var segDict = [['㐖毒',3,'n'],['㞎㞎','',''],['㧑挹','',''],['㧑损','',''],['㹴犬','',''],['㺢㹢狓','',''],['䗖蝀','',''],['䲠鱼','',''],['䴙䴘','',''],['䵹鼄','',''],['一一','',''],['一一对应','',''],['一一映射','',''],['一丁不视','',''],['一丁不识','',''],['一丁点','',''],['一丁点儿','',''],['一万','',''],['一下','',''],['一不做','',''],['一不做二不休','',''],['一专多能','',''],['一世','',''],['一世之雄','',''],['一世纪','',''],['一丘一壑','',''],['一丘之貉','',''],['一丛','',''],['一东一西','',''],['一丝','',''],['一丝一毫','',''],['一丝不挂','',''],['一丝不线','',''],['单木不林','',''],['一丝不苟','',''],['一两句话','',''],['一个','',''],['一个个','',''],['一个中国政策','',''],['一个中心','',''],['一个人','',''],['一个劲','',''],['一个劲儿','',''],['一个又一个','',''],['一个巴掌拍不响','',''],['一个心眼儿','',''],['一个接一个','',''],['一个方面','',''],['一个样','',''],['一个萝卜一个坑','',''],['一中一台','',''],['一中全会','',''],['一中原则','',''],['一串','',''],['一串红','',''],['一具','',''],['一举','',''],['一举一动','',''],['一举两便','',''],['一举两得','',''],['一举千里','',''],['一举多得','',''],['一举成功','',''],['一举成名','',''],['一举手一投足','',''],['一举手之劳','',''],['一之为甚','',''],['一之已甚','',''],['一之谓甚','',''],['一书','',''],['一了千明','',''],['一了百了','',''],['一了百当','',''],['一事','',''],['一事无成','',''],['一二九运动','',''],['一二八事变','',''],['一二十年','',''],['一五一十','',''],['一些','',''],['一人','',''],['一人之下','',''],['一人之交','',''],['一人传虚','',''],['万人传实','',''],['一人做事一人当','',''],['一人得道','',''],['鸡犬升天','',''],['鸡缸杯','',''],['一人班','',''],['一亿','',''],['一介','',''],['一介不取','',''],['一仍旧贯','',''],['一代','',''],['一代人','',''],['一代宗臣','',''],['一代新人','',''],['一代楷模','',''],['一代风流','',''],['一代鼎臣','',''],['一以当十','',''],['一以贯之','',''],['一件','',''],['一件式','',''],['一价','',''],['一任','',''],['一份','',''],['一伙','',''],['一伙人','',''],['一伙儿','',''],['一会','',''],['一会儿','',''],['一传十','',''],['一位','',''],['一体','',''],['一体两面','',''],['一体化','',''],['一佛出世','',''],['二佛升天','',''],['一例','',''],['一依旧式','',''],['一侧','',''],['一侧化','',''],['一便','',''],['一倍','',''],['一倡三叹','',''],['一倡百和','',''],['一偏','',''],['一偏之见','',''],['一停','',''],['一傅众咻','',''],['一元','',''],['一元化','',''],['一元方程','',''],['一元论','',''],['一元醇','',''],['一兆','',''],['一党','',''],['一党专制','',''],['一六○五','',''],['一共','',''],['一兵','',''],['一册','',''],['一再','',''],['一再强调','',''],['一再说明','',''],['一决胜负','',''],['一决雌雄','',''],['一冷','',''],['一击','',''],['一击入洞','',''],['一刀','',''],['一刀两断','',''],['一刀两段','',''],['一刀切','',''],['一分','',''],['一分为二','',''],['一分子','',''],['一分收获','',''],['一分耕耘','',''],['一分钟','',''],['一分钱','',''],['一分钱一分货','',''],['一分钱两分货','',''],['一切','',''],['一切从严','',''],['一切众生','',''],['一切向钱看','',''],['一切就绪','',''],['一切险','',''],['一划','',''],['一列','',''],['一则','',''],['一则以喜','',''],['一则以惧','',''],['一到','',''],['一刹那','',''],['一刻','',''],['一刻千金','',''],['一刻钟','',''],['一剂','',''],['一前一后','',''],['一副','',''],['一力','',''],['一力承当','',''],['一动','',''],['一动不动','',''],['一动不如一静','',''],['一劳久逸','',''],['一劳永逸','',''],['一勇之夫','',''],['一包','',''],['一化三改','',''],['一匙','',''],['一匡天下','',''],['一匹','',''],['一区','',''],['一千','',''],['一千万','',''],['一千个','',''],['一千年','',''],['一千零一夜','',''],['一半','',''],['一半儿','',''],['一半天','',''],['一卡通','',''],['一卷','',''],['一卷布','',''],['一厘一毫','',''],['一厢情愿','',''],['一去','',''],['一去不回','',''],['一去不复返','',''],['一去无影踪','',''],['一双','',''],['一双两好','',''],['一双鞋','',''],['一反','',''],['一反常态','',''],['一发','',''],['一发千钧','',''],['一款','',''],['一口','',''],['一口两匙','',''],['一口吸尽西江水','',''],['一口咬定','',''],['一口气','',''],['一口气儿','',''],['一口钟','',''],['一古脑儿','',''],['一句','',''],['一句话','',''],['一只','',''],['一只眼','',''],['一台','',''],['一叶','',''],['一叶知秋','',''],['一叶落知天下秋','',''],['一叶蔽目','',''],['一叶蔽目不见泰山','',''],['一叶障目','',''],['不见泰山','',''],['一叶障目不见泰山','',''],['一号','',''],['一号木杆','',''],['一号电池','',''],['一同','',''],['一名','',''],['一吐','',''],['一吐为快','',''],['一向','',''],['一吨','',''],['一听','',''],['一吸','',''],['一吹','',''],['一员','',''],['一周','',''],['一味','',''],['一呼百应','',''],['一呼百诺','',''],['一命呜呼','',''],['一咏一觞','',''],['一品','',''],['一品红','',''],['一品锅','',''],['一哄而上','',''],['一哄而散','',''],['一哄而起','',''],['一唱一和','',''],['一喷一醒','',''],['一回','',''],['一回事','',''],['一回生','',''],['一团','',''],['一团和气','',''],['一团漆黑','',''],['一团火','',''],['一团糟','',''],['一团糟摊子','',''],['一国三公','',''],['一国两制','',''],['一圈','',''],['一在','',''],['一地','',''],['一地方','',''],['一场','',''],['一场春梦','',''],['一场空','',''],['一场虚惊','',''],['一块','',''],['一块儿','',''],['一块糖','',''],['一块钱','',''],['一块面','',''],['一堂','',''],['一堆','',''],['一堆沙','',''],['一堵','',''],['一塌刮子','',''],['一塌糊涂','',''],['一墩','',''],['一壁','',''],['一壁厢','',''],['一声','',''],['一声不吭','',''],['一声不响','',''],['一声令下','',''],['一壶','',''],['一壶千金','',''],['一处','',''],['一夔已足','',''],['一多对应','',''],['一夜','',''],['一夜之间','',''],['一夜夫妻百夜恩','',''],['一夜夫妻百日恩','',''],['一夜情','',''],['一夜被蛇咬','',''],['一夜露水','',''],['一大','',''],['一大二公','',''],['一大半','',''],['一大堆','',''],['一大帮','',''],['一大批','',''],['一大早','',''],['一大早儿','',''],['一大步','',''],['一大群','',''],['一大阵','',''],['一天','',''],['一天一个样','',''],['一天到晚','',''],['一天星斗','',''],['一夫','',''],['一夫一妻','',''],['一夫一妻制','',''],['一夫制','',''],['一夫当关','',''],['万夫莫开','',''],['一夫当关万夫莫开','',''],['一失足成千古恨','',''],['一头','',''],['一头儿沉','',''],['一头栽进','',''],['一头雾水','',''],['一夺','',''],['一套','',''],['一女','',''],['一如','',''],['一如所料','',''],['一如既往','',''],['一妻','',''],['一妻制','',''],['一孔','',''],['一孔之见','',''],['一字','',''],['一字一板','',''],['一字一泪','',''],['一字一珠','',''],['一字不提','',''],['一字不苟','',''],['一字不识','',''],['一字之师','',''],['一字值千金','',''],['一字千金','',''],['一字巾','',''],['一字褒贬','',''],['一字长蛇阵','',''],['一季','',''],['一季度','',''],['一官半职','',''],['一定','',''],['一定不易','',''],['一定不移','',''],['一定之规','',''],['一定程度','',''],['一定量','',''],['一审','',''],['一客不犯二主','',''],['一家','',''],['一家一计','',''],['一家之主','',''],['一家之言','',''],['一家之论','',''],['一家之说','',''],['一家人','',''],['一家子','',''],['一家眷属','',''],['一家老小','',''],['一寒如此','',''],['一寸','',''],['一寸丹心','',''],['一寸光阴','',''],['一寸光阴一寸金','',''],['一寸赤心','',''],['一对','',''],['一对一','',''],['一对一斗牛','',''],['一对儿','',''],['一对多','',''],['一封','',''],['一封信','',''],['一将功成万骨枯','',''],['一将难求','',''],['一尊','',''],['一小儿','',''],['一小口','',''],['一小撮','',''],['一小时','',''],['一小群','',''],['一小部分','',''],['一小阵儿','',''],['一尘不染','',''],['一就','',''],['一尺','',''],['一局','',''],['一层','',''],['一届','',''],['一屋','',''],['一展','',''],['一展身手','',''],['一岁','',''],['一岁三迁','',''],['一岁九迁','',''],['一岛','',''],['一差二误','',''],['一差二错','',''],['一己','',''],['一己之私','',''],['一己之见','',''],['一巴掌','',''],['一市','',''],['一帆风顺','',''],['一带','',''],['一带而过','',''],['一席之地','',''],['一席话','',''],['一席谈','',''],['一帮','',''],['一帮人','',''],['一帽子','',''],['一幅','',''],['一幕','',''],['一幢','',''],['一干','',''],['一干一方','',''],['一干二净','',''],['一平二调','',''],['一年','',''],['一年一度','',''],['一年一次','',''],['一年两次','',''],['一年之计在于春','',''],['一年到头','',''],['一年到尾','',''],['一年半','',''],['一年半载','',''],['一年四季','',''],['一年多','',''],['一年多来','',''],['一年期','',''],['一年比一年','',''],['一年生','',''],['一朝被蛇咬','',''],['一年被蛇咬','',''],['十年怕井绳','',''],['一年被蛇咬十年怕井绳','',''],['一并','',''],['一并处理','',''],['一床两好','',''],['一床锦被遮盖','',''],['一应','',''],['一应俱全','',''],['一度','',''],['一座','',''],['一座皆惊','',''],['一廉如水','',''],['一式','',''],['一式二份','',''],['一张','',''],['一张一弛','',''],['一张一驰','',''],['一弹指倾','',''],['一弹指顷','',''],['一往','',''],['一往情深','',''],['一往无前','',''],['一径','',''],['一律','',''],['一得','',''],['一得之功','',''],['一得之愚','',''],['一得之见','',''],['一德一心','',''],['一心','',''],['一心一德','',''],['一心一意','',''],['一心一计','',''],['一心挂两头','',''],['一心无二','',''],['一忍再忍','',''],['一念','',''],['一念之差','',''],['一念之错','',''],['一忽','',''],['一忽儿','',''],['一怒之下','',''],['一怔','',''],['一总','',''],['一息奄奄','',''],['一息尚存','',''],['一悲一喜','',''],['一惊','',''],['一惊一乍','',''],['一想','',''],['一愁莫展','',''],['一意','',''],['一意孤行','',''],['一愣','',''],['一成','',''],['一成一旅','',''],['一成不变','',''],['一战','',''],['一户','',''],['一房一厅','',''],['一手','',''],['一手一足','',''],['一手交货','',''],['一手交钱','',''],['一手包办','',''],['一手包揽','',''],['一手宽','',''],['一手遮天','',''],['一打','',''],['一扔','',''],['一扫','',''],['一扫而光','',''],['一扫而空','',''],['一批','',''],['一技之长','',''],['一把','',''],['一把手','',''],['一把抓','',''],['一把死拿','',''],['一把汗','',''],['一把钥匙开一把锁','',''],['一抖','',''],['一折','',''],['一折两段','',''],['一抹','',''],['一担','',''],['一拉','',''],['一拍','',''],['一拍两散','',''],['一拍即合','',''],['一拐','',''],['一拖','',''],['一招','',''],['一拥而上','',''],['一拥而入','',''],['一拨儿','',''],['一拳','',''],['一拽','',''],['一指','',''],['一按','',''],['一挥而就','',''],['一挥而成','',''],['一捅就破','',''],['一捆','',''],['一排','',''],['一排排','',''],['一探','',''],['一推','',''],['一掬同情之泪','',''],['一掷','',''],['一掷千金','',''],['一掷百万','',''],['一提','',''],['一揽子','',''],['一搏','',''],['一搭一档','',''],['一摔','',''],['一摞','',''],['一撇','',''],['一撮','',''],['一支','',''],['一改故辙','',''],['一整套','',''],['一文','',''],['一文不值','',''],['一文不名','',''],['一文如命','',''],['一文钱难倒英雄汉','',''],['一斑','',''],['一斗','',''],['一斤','',''],['一新','',''],['一方','',''],['一方有难八方支援','',''],['一方面','',''],['一旁','',''],['一族','',''],['一无','',''],['一无可取','',''],['一无忌惮','',''],['一无所动','',''],['一无所好','',''],['一无所得','',''],['一无所成','',''],['一无所有','',''],['一无所求','',''],['一无所知','',''],['一无所能','',''],['一无所获','',''],['一无所长','',''],['一无所闻','',''],['一无是处','',''],['一无长物','',''],['一日','',''],['一日万机','',''],['一日三秋','',''],['一日三餐','',''],['一日不见','',''],['如隔三秋','',''],['一日不见如隔三秋','',''],['一日为师','',''],['一日之长','',''],['一日之雅','',''],['一日千里','',''],['一旦','',''],['一早','',''],['一时','',''],['一时一事','',''],['一时一刻','',''],['一时之秀','',''],['一时之选','',''],['一时半会','',''],['一时半会儿','',''],['一时半刻','',''],['一时半晌','',''],['一时半霎','',''],['一时间','',''],['一星儿','',''],['一星半点','',''],['一星期','',''],['一是','',''],['一昼夜','',''],['一晃','',''],['一景','',''],['一暴十寒','',''],['一曝十寒','',''],['一曲','',''],['一曲阳关','',''],['一更','',''],['一月','',''],['一月份','',''],['一服','',''],['一望','',''],['一望无垠','',''],['一望无际','',''],['一望而知','',''],['一朝','',''],['一朝一夕','',''],['一朝权在手','',''],['一期','',''],['一木难扶','',''],['一木难支','',''],['一本','',''],['一本万利','',''],['一本正经','',''],['一朵','',''],['一杆进洞','',''],['一束','',''],['一条','',''],['一条心','',''],['一条藤儿','',''],['一条街','',''],['一条鞭法','',''],['一条龙','',''],['一条龙服务','',''],['一来','',''],['一来一往','',''],['一来二去','',''],['一杯','',''],['一杯奶','',''],['一杯汤','',''],['一杯羹','',''],['一板一眼','',''],['一板三眼','',''],['一板正经','',''],['一枕黄粱','',''],['一枚','',''],['一枝独秀','',''],['一枪','',''],['一架','',''],['一柱擎天','',''],['一栏','',''],['一树百获','',''],['一栖两雄','',''],['一株','',''],['一样','',''],['一根筋','',''],['一格','',''],['一桌','',''],['一桶','',''],['一桶水','',''],['一棍打一船','',''],['一棒一条痕','',''],['一楼','',''],['一概','',''],['一概而言','',''],['一概而论','',''],['一榻糊涂','',''],['一模一样','',''],['一次','',''],['一次函数','',''],['一次又一次','',''],['一次性','',''],['一次总付','',''],['一次方程','',''],['一次方程式','',''],['一次生','',''],['一步','',''],['一步一个脚印','',''],['一步一趋','',''],['一步一鬼','',''],['一步到位','',''],['一步摄影','',''],['一步登天','',''],['一死一生','',''],['一死百了','',''],['一段','',''],['一段时间','',''],['一比','',''],['一毛不拔','',''],['一毛钱','',''],['一毫','',''],['一民同俗','',''],['一气','',''],['一气之下','',''],['一气呵成','',''],['一氧','',''],['一氧化二氮','',''],['一氧化氮','',''],['一氧化碳','',''],['一水儿','',''],['一沐三捉发','',''],['一波三折','',''],['一波又起','',''],['一波未平','',''],['一波未平一波又起','',''],['一泻千里','',''],['一派','',''],['一派谎言','',''],['一流','',''],['一浆十饼','',''],['一浪','',''],['一清二楚','',''],['一清二白','',''],['一清如水','',''],['一清早','',''],['一溜儿','',''],['一溜烟','',''],['一溜烟儿','',''],['一滑','',''],['一满匙','',''],['一满碗','',''],['一滴','',''],['一滴水','',''],['一潭死水','',''],['一灵真性','',''],['一炉','',''],['一炮','',''],['一炮打响','',''],['一点','',''],['一点一滴','',''],['一点一点','',''],['一点不','',''],['一点也不','',''],['一点儿','',''],['一点水一个泡','',''],['一点灵犀','',''],['一点点','',''],['一点邻域','',''],['一片','',''],['一片丹心','',''],['一片冰心','',''],['一片地','',''],['一片天','',''],['一片宫商','',''],['一片散沙','',''],['一片汪洋','',''],['一片至诚','',''],['一片赤心','',''],['一牛吼地','',''],['一物','',''],['一物一主','',''],['一物一制','',''],['一物不知','',''],['一物降一物','',''],['一犯再犯','',''],['一狐之腋','',''],['一环','',''],['一环扣一环','',''],['一环紧扣一环','',''],['一班','',''],['一琴一鹤','',''],['一瓶','',''],['一生','',''],['一生一世','',''],['一生中','',''],['一甲子','',''],['一番','',''],['一番话','',''],['一病不起','',''],['一瘸','',''],['一百','',''],['一百一','',''],['一百万','',''],['一百二十行','',''],['一百年','',''],['一盅','',''],['一盏','',''],['一盒','',''],['一盘','',''],['一盘散沙','',''],['一盘棋','',''],['一目了然','',''],['一目十行','',''],['一直','',''],['一直以来','',''],['一直往前','',''],['一直是','',''],['一相情愿','',''],['一看','',''],['一眨','',''],['一眨眼','',''],['一眨眼间','',''],['一眼','',''],['一眼望去','',''],['一眼看穿','',''],['一眼见得','',''],['一着','',''],['一着不慎','',''],['满盘皆输','',''],['一着不慎满盘皆输','',''],['一睹','',''],['一睹为快','',''],['一瞑不视','',''],['一瞥','',''],['一瞬','',''],['一瞬间','',''],['一矢中的','',''],['一知半解','',''],['一石二鸟','',''],['一码事','',''],['一砍二主','',''],['一砍二家','',''],['一砸','',''],['一碗','',''],['一碟','',''],['一碰','',''],['一神','',''],['一神教','',''],['一神论','',''],['一秉虔诚','',''],['一种','',''],['一秒','',''],['一秘','',''],['一程','',''],['一程子','',''],['一稿','',''],['一穷二白','',''],['一空','',''],['一窍不通','',''],['一窝','',''],['一窝蜂','',''],['一章','',''],['一端','',''],['一笑','',''],['一笑了之','',''],['一笑千金','',''],['一笑置之','',''],['一笔','',''],['一笔不苟','',''],['一笔勾销','',''],['一笔抹倒','',''],['一笔抹杀','',''],['一笔抹煞','',''],['一等','',''],['一等功','',''],['一等品','',''],['一等奖','',''],['一筹莫展','',''],['一箍节儿的零吃','',''],['一算','',''],['一箪一瓢','',''],['一箭之仇','',''],['一箭之地','',''],['一箭双雕','',''],['一箱','',''],['一篇','',''],['一篮','',''],['一簇','',''],['一簇簇','',''],['一簧两舌','',''],['一类','',''],['一类保护动物','',''],['一粒','',''],['一粒砂','',''],['一系列','',''],['一索得男','',''],['一索成男','',''],['一级','',''],['一级企业','',''],['一级士官','',''],['一级头','',''],['一级方程式','',''],['一级棒','',''],['一纸空文','',''],['一线','',''],['一线之间','',''],['一线希望','',''],['一线微光','',''],['一组','',''],['一组人','',''],['一经','',''],['一绝','',''],['一统','',''],['一维','',''],['一缕','',''],['一缕烟','',''],['一罐','',''],['一网打尽','',''],['一群','',''],['一群人','',''],['一群牛','',''],['一群羊','',''],['一翻','',''],['一翼','',''],['一者','',''],['一而','',''],['一而再','',''],['一而再再而三','',''],['一而再地','',''],['一联','',''],['一聚枯骨','',''],['一肚子气','',''],['一肥股','',''],['一股','',''],['一股劲儿','',''],['一股子','',''],['一股脑','',''],['一股脑儿','',''],['一胎','',''],['一胎制','',''],['一胎化','',''],['一脉相传','',''],['一脉相承','',''],['一脉相通','',''],['一脚','',''],['一脸','',''],['一腔热血','',''],['一臂之力','',''],['一至于此','',''],['一致','',''],['一致字','',''],['一致性','',''],['一致性效应','',''],['一致意见','',''],['一致百虑','',''],['一致认为','',''],['一致资源定址器','',''],['一致通过','',''],['一般','',''],['一般人','',''],['一般以','',''],['一般化','',''],['一般原则','',''],['一般地讲','',''],['一般地说','',''],['一般应','',''],['一般性','',''],['一般指','',''],['一般无二','',''],['一般来讲','',''],['一般来说','',''],['一般比','',''],['一般用','',''],['一般的说','',''],['一般等价物','',''],['一般而言','',''],['一般见识','',''],['一般规定','',''],['一般词汇','',''],['一般说来','',''],['一般贸易','',''],['一色','',''],['一节','',''],['一节诗','',''],['一节课','',''],['一花独放','',''],['一草一木','',''],['一花一草','',''],['一落千丈','',''],['一虎难敌众犬','',''],['一蟹不如一蟹','',''],['一行','',''],['一行人','',''],['一行作吏','',''],['一行诗','',''],['一衣带水','',''],['一表人才','',''],['一表人材','',''],['一表人物','',''],['一表非俗','',''],['一表非凡','',''],['一袋','',''],['一见','',''],['一见倾心','',''],['一见如故','',''],['一见钟情','',''],['一见高低','',''],['一视同仁','',''],['一览','',''],['一览无余','',''],['一览无遗','',''],['一览表','',''],['一觉','',''],['一觉醒来','',''],['一角','',''],['一角银币','',''],['一觞一咏','',''],['一触即发','',''],['一触即溃','',''],['一言','',''],['一言一动','',''],['一言一行','',''],['一言不发','',''],['一言两语','',''],['一言丧邦','',''],['一言中的','',''],['一言为定','',''],['一言为重','',''],['一言九鼎','',''],['一言以蔽','',''],['一言以蔽之','',''],['一言兴邦','',''],['一言千金','',''],['一言半句','',''],['一言半字','',''],['一言半语','',''],['一言堂','',''],['一言定交','',''],['一言抄百总','',''],['一言既出','',''],['驷马难追','',''],['一言既出驷马难追','',''],['一言而定','',''],['一言蔽之','',''],['一言订交','',''],['一言难尽','',''],['一言难罄','',''],['一语','',''],['一语不发','',''],['一语中人','',''],['一语中的','',''],['一语双关','',''],['一语破的','',''],['一语道破','',''],['一误再误','',''],['一说','',''],['一诺千金','',''],['一读','',''],['一课','',''],['一谦四益','',''],['一貌倾城','',''],['一貌堂堂','',''],['一败如水','',''],['一败涂地','',''],['一贫如洗','',''],['一贯','',''],['一贯性','',''],['一贯方针','',''],['一贯道','',''],['一走','',''],['一走了之','',''],['一起','',''],['一趟','',''],['一跃','',''],['一跃而起','',''],['一路','',''],['一路上','',''],['一路发','',''],['一路平安','',''],['一路来','',''],['一路福星','',''],['一路顺风','',''],['一路领先','',''],['一路风尘','',''],['一跳','',''],['一蹴即至','',''],['一蹴可几','',''],['一蹴而就','',''],['一蹴而得','',''],['一蹶不振','',''],['一身','',''],['一身两役','',''],['一身二任','',''],['一身作事一人当','',''],['一身是胆','',''],['一身汗','',''],['一车','',''],['一轨同风','',''],['一转','',''],['一转眼','',''],['一轮','',''],['一较高下','',''],['一辆','',''],['一辈','',''],['一辈子','',''],['一辞莫赞','',''],['一边','',''],['一边倒','',''],['一进','',''],['一连','',''],['一连串','',''],['一连气儿','',''],['一迭连声','',''],['一退六二五','',''],['一选','',''],['一通','',''],['一通百通','',''],['一遍','',''],['一遍又一遍','',''],['一道','',''],['一道菜','',''],['一部','',''],['一部分','',''],['一酬一酢','',''],['一醉','',''],['一针','',''],['一针见血','',''],['一钱不值','',''],['一钱不落虚空地','',''],['一钱如命','',''],['一锅','',''],['一锅粥','',''],['一错再错','',''],['一锤','',''],['一锤定音','',''],['一键','',''],['一锹','',''],['一长一短','',''],['一长制','',''],['一长半短','',''],['一门','',''],['一门心思','',''],['一闪','',''],['一闪念','',''],['一闪而过','',''],['一问','',''],['一问三不知','',''],['一间','',''],['一队','',''],['一坨','',''],['一阵','',''],['一阵子','',''],['一阵烟','',''],['一阵风','',''],['一阶半级','',''],['一阶半职','',''],['一院','',''],['一隅','',''],['一隅三反','',''],['一隅之地','',''],['一集','',''],['一零儿','',''],['一霎','',''],['一霎时','',''],['一霎眼','',''],['一霎间','',''],['一面','',''],['一面之交','',''],['一面之缘','',''],['一面之识','',''],['一面之词','',''],['一面之辞','',''],['一面之雅','',''],['一面倒','',''],['一面如旧','',''],['一音','',''],['一音节','',''],['一页','',''],['一顶','',''],['一项','',''],['一项一项地','',''],['一顺儿','',''],['一顾倾人','',''],['一顾倾城','',''],['一顿','',''],['一顿饭','',''],['一颗','',''],['一颦一笑','',''],['一风吹','',''],['一飞冲天','',''],['一餐','',''],['一饭千金','',''],['一饮','',''],['一馈十起','',''],['一首','',''],['一马一鞍','',''],['一马平川','',''],['一马当先','',''],['一骨碌','',''],['一鳞一爪','',''],['一鳞半爪','',''],['一鳞半甲','',''],['一鳞片甲','',''],['一鸣惊人','',''],['一麾出守','',''],['一鼓作气','',''],['一鼓而下','',''],['一鼻子灰','',''],['一鼻孔出气','',''],['一齐','',''],['一齐二整','',''],['一齐天下','',''],['一龙一猪','',''],['一龙一蛇','',''],['一龙九种','',''],['一试','',''],['丁一卯二','',''],['丁一确二','',''],['丁丁','',''],['丁丁炒面','',''],['丁丑','',''],['丁东','',''],['丁二烯','',''],['丁二醇','',''],['丁亥','',''],['丁人','',''],['丁克','',''],['丁内酯','',''],['丁冬','',''],['丁加奴','',''],['丁卯','',''],['丁口册','',''],['丁坝','',''],['丁型肝炎','',''],['丁基','',''],['丁基橡胶','',''],['丁夜','',''],['丁字','',''],['丁字尺','',''],['丁字梁','',''],['丁字步','',''],['丁字街','',''],['丁字裤','',''],['丁字路','',''],['丁字镐','',''],['丁宁','',''],['丁宠家庭','',''],['丁客','',''],['丁巳','',''],['丁当','',''],['丁忧','',''],['丁是丁卯是卯','',''],['丁未','',''],['丁村人','',''],['丁汝昌','',''],['丁点','',''],['丁点儿','',''],['丁烯','',''],['丁烯二酸','',''],['丁烷','',''],['丁玲','',''],['丁磊','',''],['丁种维生素','',''],['丁税','',''],['丁笨橡胶','',''],['丁糖','',''],['丁肇中','',''],['丁腈橡胶','',''],['丁艰','',''],['丁苯','',''],['丁苯橡胶','',''],['丁酉','',''],['丁酸','',''],['丁醇','',''],['丁醛','',''],['丁零','',''],['丁零当啷','',''],['丁韪良','',''],['丁香','',''],['丁香花','',''],['丁骨牛排','',''],['丁鲷','',''],['七一','',''],['七一五反革命政变','',''],['七七','',''],['七七事变','',''],['七七八八','',''],['七万','',''],['七上八下','',''],['七上八落','',''],['七个','',''],['七中全会','',''],['七事','',''],['七五','',''],['七五期间','',''],['七五计划','',''],['七人','',''],['七件','',''],['七倍','',''],['七八','',''],['七分','',''],['七分之一','',''],['七分之三','',''],['七分之二','',''],['七分之五','',''],['七分之六','',''],['七分之四','',''],['七区','',''],['七十','',''],['七十一','',''],['七十七','',''],['七十七国集团','',''],['七十三','',''],['七十个','',''],['七十九','',''],['七十二','',''],['七十二行','',''],['七十五','',''],['七十人','',''],['七十八','',''],['七十六','',''],['七十四','',''],['七十岁','',''],['七十年','',''],['七十年代','',''],['七千','',''],['七千万','',''],['七只','',''],['七台','',''],['七叶树','',''],['七号','',''],['七号电池','',''],['七君子事件','',''],['七和弦','',''],['七喜','',''],['七嘴八张','',''],['七嘴八舌','',''],['七国','',''],['七国之乱','',''],['七国集团','',''],['七堵','',''],['七堵区','',''],['七声','',''],['七声音阶','',''],['七大','',''],['七大工业国集团','',''],['七天','',''],['七头','',''],['七姊妹星团','',''],['七孔','',''],['七孔生烟','',''],['七寸','',''],['七层架构','',''],['七届','',''],['七巧板','',''],['七带石斑鱼','',''],['七年','',''],['七年战争','',''],['七度','',''],['七弦琴','',''],['七弯八曲','',''],['七彩','',''],['七律','',''],['七情','',''],['七情六欲','',''],['七手八脚','',''],['七扭八歪','',''],['七折八扣','',''],['七拉八扯','',''],['七拼八凑','',''],['七挑八选','',''],['七擒七纵','',''],['七擒八纵','',''],['七政四余','',''],['七方','',''],['七日','',''],['七日热','',''],['七时','',''],['七星','',''],['七曜','',''],['七月','',''],['七月份','',''],['七条','',''],['七楼','',''],['七横八竖','',''],['七步之才','',''],['七步成章','',''],['七步格','',''],['七武士','',''],['七死八活','',''],['七段','',''],['七河州','',''],['七点','',''],['七爷八爷','',''],['七狼八狈','',''],['七病八痛','',''],['七百','',''],['七百万','',''],['七碳糖','',''],['七窍','',''],['七窍生烟','',''],['七级浮屠','',''],['七纵七擒','',''],['七绝','',''],['七美','',''],['七美乡','',''],['七老八十','',''],['七股','',''],['七股乡','',''],['七色','',''],['七色板','',''],['七荤八素','',''],['七行','',''],['七角','',''],['七角形','',''],['七言律诗','',''],['七言诗','',''],['七路','',''],['七边形','',''],['七里河','',''],['七重奏','',''],['七长八短','',''],['七雄','',''],['七零','',''],['七零八碎','',''],['七零八落','',''],['七青八黄','',''],['七面体','',''],['七音','',''],['七项全能','',''],['七颠八倒','',''],['七高八低','',''],['七魄','',''],['七鳃鳗','',''],['七龙珠','',''],['万一','',''],['万万','',''],['万万千千','',''],['万万没有想到','',''],['万丈','',''],['万丈深渊','',''],['万丈高楼平地起','',''],['万不失一','',''],['万不得已','',''],['万世','',''],['万世一时','',''],['万世师表','',''],['万世流芳','',''],['万个','',''],['万丹','',''],['万丹乡','',''],['万事','',''],['万事万物','',''],['万事亨通','',''],['万事俱备','',''],['万事俱备只欠东风','',''],['万事具备','',''],['万事大吉','',''],['万事如意','',''],['万事开头难','',''],['万事得','',''],['万事皆备','',''],['万事达','',''],['万事通','',''],['万亩','',''],['万人','',''],['万人之上','',''],['万人之敌','',''],['万人敌','',''],['万人空巷','',''],['万亿','',''],['万代','',''],['万代一时','',''],['万代兰','',''],['万代千秋','',''],['万件','',''],['万伏','',''],['万众','',''],['万众一心','',''],['万众瞩目','',''],['万位','',''],['万余','',''],['万俟','',''],['万倍','',''],['万儿八千','',''],['万元','',''],['万元户','',''],['万全之策','',''],['万全之计','',''],['万军','',''],['万分','',''],['万分之','',''],['万分痛苦','',''],['万别千差','',''],['万剐千刀','',''],['万劫不复','',''],['万千','',''],['万华','',''],['万华区','',''],['万博省','',''],['万历','',''],['万县','',''],['万县地区','',''],['万县市','',''],['万县港','',''],['万双','',''],['万变','',''],['万变不离其宗','',''],['万古','',''],['万古千秋','',''],['万古流芳','',''],['万古长存','',''],['万古长新','',''],['万古长春','',''],['万古长青','',''],['万名','',''],['万向','',''],['万向节','',''],['万吨','',''],['万吨水压机','',''],['万国','',''],['万国博览会','',''],['万国宫','',''],['万国码','',''],['万国邮政联盟','',''],['万国邮联','',''],['万圣节前夕','',''],['万场','',''],['万块','',''],['万处','',''],['万夫','',''],['万夫不当','',''],['万夫莫当','',''],['万头','',''],['万头钻动','',''],['万字','',''],['万宝路','',''],['万家','',''],['万家乐','',''],['万家灯火','',''],['万家生佛','',''],['万寿山','',''],['万寿无疆','',''],['万山','',''],['万山镇','',''],['万岁','',''],['万岁千秋','',''],['万岸','',''],['万峦','',''],['万峦乡','',''],['万州','',''],['万年历','',''],['万年青','',''],['万幸','',''],['万应','',''],['万应灵丹','',''],['万应药','',''],['万应锭','',''],['万念俱灰','',''],['万恶','',''],['万恶之源','',''],['万恶滔天','',''],['万户','',''],['万户侯','',''],['万户千门','',''],['万斤','',''],['万方','',''],['万无','',''],['万无一失','',''],['万春','',''],['万智牌','',''],['万有','',''],['万有引力','',''],['万机','',''],['万条','',''],['万柏林','',''],['万死一生','',''],['万死不辞','',''],['万段','',''],['万民','',''],['万水千山','',''],['万泉河','',''],['万洋山','',''],['万流景仰','',''],['万灵丹','',''],['万灵节','',''],['万灵药','',''],['万物','',''],['万物有灵论','',''],['万状','',''],['万狞年交','',''],['万用','',''],['万用刀','',''],['万用电表','',''],['万用表','',''],['万盛','',''],['万目睽睽','',''],['万确','',''],['万福','',''],['万福玛丽亚','',''],['万端','',''],['万箭攒心','',''],['万箭穿心','',''],['万籁','',''],['万籁俱寂','',''],['万籁无声','',''],['万类','',''],['万紫千红','',''],['万红千紫','',''],['万绪千头','',''],['万绪千端','',''],['万维天罗地网','',''],['万维网','',''],['万维网联合体','',''],['万缕千丝','',''],['万能','',''],['万能曲尺','',''],['万能梗','',''],['万能梗犬','',''],['万能的','',''],['万能胶','',''],['万能钥匙','',''],['万般','',''],['万般无奈','',''],['万艾可','',''],['万花','',''],['万花筒','',''],['万苦千辛','',''],['万荣乡','',''],['万虑','',''],['万言','',''],['万语千言','',''],['万象','',''],['万象包罗','',''],['万象更新','',''],['万象森罗','',''],['万豪','',''],['万贯','',''],['万贯家财','',''],['万赫','',''],['万载千秋','',''],['万辆','',''],['万通','',''],['万邦','',''],['万里','',''],['万里乡','',''],['万里江山','',''],['万里石塘','',''],['万里追踪','',''],['万里长城','',''],['万里长征','',''],['万里长江','',''],['万里鹏程','',''],['万金','',''],['万金油','',''],['万隆','',''],['万隆会议','',''],['万隆会议十项原则','',''],['万难','',''],['万顷','',''],['万马千军','',''],['万马奔腾','',''],['万马皆喑','',''],['万马齐喑','',''],['万齐融','',''],['丈义','',''],['丈二','',''],['丈二金刚','',''],['丈人','',''],['丈夫','',''],['丈夫似','',''],['丈母','',''],['丈母娘','',''],['丈量','',''],['三一律','',''],['三七','',''],['三七二十一','',''],['三七仔','',''],['三七开','',''],['三七开定论','',''],['三万','',''],['三丈','',''],['三三两两','',''],['三三五五','',''],['三三制','',''],['三三制政权','',''],['三下五除二','',''],['三不','',''],['三不主义','',''],['三不知','',''],['三不管','',''],['三世','',''],['三两','',''],['三个','',''],['三个世界','',''],['三个代表','',''],['三个女人一个墟','',''],['三个女人一台戏','',''],['三个字','',''],['三个月','',''],['三个臭皮匠','',''],['三中全会','',''],['三义','',''],['三义乡','',''],['三九','',''],['三九一一','',''],['三九天','',''],['三五','',''],['三五成群','',''],['三井','',''],['三亲六故','',''],['三亲六眷','',''],['三亲四眷','',''],['三人','',''],['三人口气','',''],['三人成虎','',''],['三人行','',''],['三人行必有我师','',''],['三人间','',''],['三亿','',''],['三仇','',''],['三从四德','',''],['三代','',''],['三代同堂','',''],['三令五申','',''],['三件','',''],['三件套式西装','',''],['三价','',''],['三份','',''],['三伏','',''],['三伏天','',''],['三位','',''],['三位一体','',''],['三位博士','',''],['三位数','',''],['三体','',''],['三体问题','',''],['三侠五义','',''],['三便士','',''],['三倍','',''],['三倍性','',''],['三催四请','',''],['三元','',''],['三元运算','',''],['三元醇','',''],['三元里','',''],['三光','',''],['三光政策','',''],['三八','',''],['三八国际妇女节','',''],['三八红旗手','',''],['三八线','',''],['三六九等','',''],['三军','',''],['三农','',''],['三农问题','',''],['三出','',''],['三分','',''],['三分之一','',''],['三分之二','',''],['三分法','',''],['三分熟','',''],['三分象人七分象鬼','',''],['三分钟热度','',''],['三分鼎立','',''],['三分鼎足','',''],['三副','',''],['三包','',''],['三化螟','',''],['三北','',''],['三十','',''],['三十一','',''],['三十七','',''],['三十万','',''],['三十三','',''],['三十个','',''],['三十九','',''],['三十二','',''],['三十二位元','',''],['三十五','',''],['三十人','',''],['三十八','',''],['三十八度线','',''],['三十六','',''],['三十六字母','',''],['三十六招走为上招','',''],['三十六策走为上策','',''],['三十六计','',''],['三十四','',''],['三十年','',''],['三十年代','',''],['三十而立','',''],['三千','',''],['三千珠履','',''],['三原则','',''],['三原色','',''],['三厢','',''],['三叉','',''],['三叉戟','',''],['三叉神经','',''],['三叉路口','',''],['三反','',''],['三反五反运动','',''],['三反运动','',''],['三叠系','',''],['三叠纪','',''],['三口','',''],['三句','',''],['三句半','',''],['三句话不离本行','',''],['三只','',''],['三只手','',''],['三叶形','',''],['三叶星云','',''],['三叶草','',''],['三叶虫','',''],['三号','',''],['三号木杆','',''],['三号电池','',''],['三合一','',''],['三合一疫苗','',''],['三合会','',''],['三合土','',''],['三合房','',''],['三合星','',''],['三合板','',''],['三同','',''],['三名','',''],['三吴','',''],['三味线','',''],['三和土','',''],['三和弦','',''],['三和音','',''],['三围','',''],['三国','',''],['三国史记','',''],['三国志','',''],['三国时代','',''],['三国演义','',''],['三地','',''],['三地门','',''],['三地门乡','',''],['三复斯言','',''],['三夏','',''],['三夜','',''],['三大','',''],['三大作风','',''],['三大差别','',''],['三大法宝','',''],['三大革命运动','',''],['三天','',''],['三天不打','',''],['三天两头','',''],['三头','',''],['三头两绪','',''],['三头六臂','',''],['三头对证','',''],['三头肌','',''],['三夷教','',''],['三好','',''],['三好两歉','',''],['三好学生','',''],['三好生','',''],['三姑','',''],['三姑六婆','',''],['三孔','',''],['三字经','',''],['三季度','',''],['三季稻','',''],['三官大帝','',''],['三宝','',''],['三家','',''],['三家村','',''],['三寸','',''],['三寸不烂之舌','',''],['三寸之舌','',''],['三对三斗牛','',''],['三尖杉酯碱','',''],['三尺','',''],['三局','',''],['三局两胜','',''],['三层','',''],['三屉桌','',''],['三届','',''],['三山','',''],['三山区','',''],['三岁','',''],['三岔口','',''],['三岔路口','',''],['三岛由纪夫','',''],['三峡','',''],['三峡大坝','',''],['三峡库','',''],['三峡水库','',''],['三峡镇','',''],['三差五错','',''],['三幅','',''],['三平二满','',''],['三年','',''],['三年不窥园','',''],['三年之艾','',''],['三年五载','',''],['三年怕井绳','',''],['三废','',''],['三度','',''],['三座大山','',''],['三开','',''],['三张','',''],['三弦','',''],['三弦琴','',''],['三强','',''],['三归依','',''],['三得利','',''],['三心两意','',''],['三心二意','',''],['三态','',''],['三思','',''],['三思而后行','',''],['三思而行','',''],['三成','',''],['三户亡秦','',''],['三把火','',''],['三折之肱','',''],['三折肱为良医','',''],['三拇指','',''],['三拗汤','',''],['三振','',''],['三接头','',''],['三推六问','',''],['三教','',''],['三教九流','',''],['三文鱼','',''],['三斜','',''],['三方面','',''],['三日','',''],['三日打鱼两日晒网','',''],['三旬九食','',''],['三时','',''],['三明治','',''],['三星','',''],['三星乡','',''],['三星集团','',''],['三春','',''],['三春柳','',''],['三昧','',''],['三更','',''],['三更半夜','',''],['三曹','',''],['三月','',''],['三月份','',''],['三月街','',''],['三朋四友','',''],['三朝','',''],['三朝元老','',''],['三期','',''],['三权分立','',''],['三束','',''],['三条','',''],['三板','',''],['三极管','',''],['三查三整运动','',''],['三框栏','',''],['三棱','',''],['三棱草','',''],['三棱镜','',''],['三楼','',''],['三槐九棘','',''],['三次','',''],['三次幂','',''],['三次方','',''],['三次方程','',''],['三次曲线','',''],['三步','',''],['三段','',''],['三段式','',''],['三段论','',''],['三毛','',''],['三毛猫','',''],['三民','',''],['三民主义','',''],['三民乡','',''],['三民区','',''],['三氟化硼','',''],['三氧','',''],['三氯化磷','',''],['三氯化铁','',''],['三氯已烯','',''],['三氯已烷','',''],['三氯氧磷','',''],['三氯甲烷','',''],['三水','',''],['三水县','',''],['三求四恳','',''],['三江平原','',''],['三江并流','',''],['三江源','',''],['三江生态旅游区','',''],['三沐三熏','',''],['三河县','',''],['三法司','',''],['三洋','',''],['三流','',''],['三流九等','',''],['三浦梅园','',''],['三温暖','',''],['三湾','',''],['三湾乡','',''],['三灾八难','',''],['三点','',''],['三点会','',''],['三点水','',''],['三焦','',''],['三熏三沐','',''],['三牲','',''],['三环','',''],['三班倒','',''],['三班六房','',''],['三班制','',''],['三瓦两舍','',''],['三瓦四舍','',''],['三生有幸','',''],['三用表','',''],['三田','',''],['三男四女','',''],['三略','',''],['三番两次','',''],['三番五次','',''],['三番四复','',''],['三白草','',''],['三百','',''],['三百万','',''],['三百六十行','',''],['三百年','',''],['三皇','',''],['三皇五帝','',''],['三皇炮捶','',''],['三相','',''],['三相交流电','',''],['三硝基甲苯','',''],['三碳糖','',''],['三磷酸腺苷','',''],['三秋','',''],['三种','',''],['三窟狡兔','',''],['三竿日上','',''],['三等','',''],['三等分','',''],['三等分角','',''],['三等功','',''],['三等奖','',''],['三箱','',''],['三类','',''],['三索锦蛇','',''],['三级','',''],['三级士官','',''],['三级片','',''],['三级管','',''],['三级跳','',''],['三级跳远','',''],['三纲五常','',''],['三纸无驴','',''],['三线','',''],['三线八角','',''],['三结合','',''],['三绝韦编','',''],['三维','',''],['三维空间','',''],['三缄其口','',''],['三翼','',''],['三老四严','',''],['三者间','',''],['三联','',''],['三联书店','',''],['三联单','',''],['三联管','',''],['三聚','',''],['三聚氰胺','',''],['三股','',''],['三胚层动物','',''],['三胞胎','',''],['三脚','',''],['三脚两步','',''],['三脚架','',''],['三脚猫','',''],['三膲','',''],['三自','',''],['三自教会','',''],['三自爱国教会','',''],['三色','',''],['三色堇','',''],['三色版','',''],['三色猫','',''],['三色紫罗兰','',''],['三节','',''],['三芝','',''],['三芝乡','',''],['三花脸','',''],['三苏','',''],['三茶六饭','',''],['三菱','',''],['三藏','',''],['三藏法师','',''],['三藩之乱','',''],['三藩叛乱','',''],['三藩市','',''],['三衅三沐','',''],['三行','',''],['三角','',''],['三角债','',''],['三角关系','',''],['三角凳','',''],['三角函数','',''],['三角学','',''],['三角尺','',''],['三角巾','',''],['三角座','',''],['三角形','',''],['三角恋爱','',''],['三角恐龙','',''],['三角方程','',''],['三角旗','',''],['三角板','',''],['三角枫','',''],['三角架','',''],['三角柱体','',''],['三角法','',''],['三角洲','',''],['三角测量法','',''],['三角肌','',''],['三角腹带','',''],['三角裤','',''],['三角裤衩','',''],['三角贸易','',''],['三角钉','',''],['三角铁','',''],['三角锥','',''],['三角龙','',''],['三言两句','',''],['三言两语','',''],['三言二拍','',''],['三言五语','',''],['三豕涉河','',''],['三豕渡河','',''],['三貂角','',''],['三贞九烈','',''],['三资','',''],['三资企业','',''],['三起','',''],['三足乌','',''],['三足金乌','',''],['三足鼎立','',''],['三跪九叩','',''],['三路','',''],['三轮','',''],['三轮车','',''],['三轮车夫','',''],['三边','',''],['三边形','',''],['三连冠','',''],['三连胜','',''],['三连音','',''],['三迭纪','',''],['三通','',''],['三通一平','',''],['三通阀','',''],['三道','',''],['三部','',''],['三部分','',''],['三部曲','',''],['三都县','',''],['三酸甘油酯','',''],['三里屯','',''],['三里河','',''],['三重','',''],['三重县','',''],['三重奏','',''],['三重市','',''],['三键','',''],['三长两短','',''],['三阿姨','',''],['三陪小姐','',''],['三集','',''],['三青团','',''],['三面','',''],['三面体','',''],['三音','',''],['三音度','',''],['三音步','',''],['三音节','',''],['三顶','',''],['三项','',''],['三项全能','',''],['三项全能运动','',''],['三项式','',''],['三顾其门而不入','',''],['三顾茅庐','',''],['三餐','',''],['三马同槽','',''],['三驾马车','',''],['三魂','',''],['三魂七魄','',''],['三鲜','',''],['三鹿','',''],['三鹿集团','',''],['上一','',''],['上一个','',''],['上一劝百','',''],['上一次','',''],['上一阶段','',''],['上一页','',''],['上万','',''],['上上','',''],['上上下下','',''],['上上之策','',''],['上下','',''],['上下一心','',''],['上下一致','',''],['上下五千年','',''],['上下交困','',''],['上下其手','',''],['上下午','',''],['上下同心','',''],['上下文','',''],['上下文菜单','',''],['上下班','',''],['上下班时间','',''],['上下相安','',''],['上下级','',''],['上下级之间','',''],['上下结合','',''],['上不着天','',''],['上世','',''],['上世纪','',''],['上个','',''],['上个世纪','',''],['上个星期','',''],['上中农','',''],['上举','',''],['上乘','',''],['上书','',''],['上了','',''],['上交','',''],['上京','',''],['上人','',''],['上人儿','',''],['上代','',''],['上以','',''],['上任','',''],['上传','',''],['上传下达','',''],['上位','',''],['上位概念','',''],['上体','',''],['上作','',''],['上例','',''],['上供','',''],['上侧','',''],['上元节','',''],['上光','',''],['上党梆子','',''],['上农','',''],['上冻','',''],['上刑','',''],['上列','',''],['上前','',''],['上前线','',''],['上劲','',''],['上千','',''],['上升','',''],['上升幅度','',''],['上升空间','',''],['上升趋势','',''],['上半','',''],['上半叶','',''],['上半场','',''],['上半夜','',''],['上半天','',''],['上半年','',''],['上半时','',''],['上半晌','',''],['上半身','',''],['上半部','',''],['上半部分','',''],['上卸','',''],['上压力','',''],['上去','',''],['上叉','',''],['上口','',''],['上口字','',''],['上口齿','',''],['上古','',''],['上古汉语','',''],['上句','',''],['上台','',''],['上台阶','',''],['上司','',''],['上合','',''],['上合组织','',''],['上吊','',''],['上同调','',''],['上吐','',''],['上吐下泻','',''],['上告','',''],['上周','',''],['上呼吸道','',''],['上呼吸道感染','',''],['上品','',''],['上哪','',''],['上唇','',''],['上回','',''],['上图','',''],['上在','',''],['上场','',''],['上场门','',''],['上坐','',''],['上坟','',''],['上坡','',''],['上坡段','',''],['上坡路','',''],['上堂','',''],['上士','',''],['上声','',''],['上外','',''],['上夜','',''],['上天','',''],['上天入地','',''],['上天无路入地无门','',''],['上头','',''],['上夸克','',''],['上奏','',''],['上套','',''],['上好','',''],['上季','',''],['上学','',''],['上官','',''],['上家','',''],['上宾','',''],['上射式','',''],['上将','',''],['上将军','',''],['上尉','',''],['上尖儿','',''],['上层','',''],['上层建筑','',''],['上屈','',''],['上届','',''],['上属音','',''],['上山','',''],['上山下乡','',''],['上岁数','',''],['上岗','',''],['上岸','',''],['上峰','',''],['上工','',''],['上市','',''],['上市公司','',''],['上帐','',''],['上帝','',''],['上席','',''],['上年','',''],['上年纪','',''],['上床','',''],['上座','',''],['上座儿','',''],['上座率','',''],['上座部','',''],['上弓','',''],['上弦','',''],['上弦月','',''],['上弯形','',''],['上当','',''],['上当受骗','',''],['上心','',''],['上情下达','',''],['上戴','',''],['上房','',''],['上房揭瓦','',''],['上手','',''],['上手铐','',''],['上托','',''],['上扬','',''],['上扬趋势','',''],['上扯','',''],['上抛','',''],['上报','',''],['上拍','',''],['上操','',''],['上文','',''],['上斜','',''],['上新世','',''],['上方','',''],['上方宝剑','',''],['上无片瓦','',''],['上旬','',''],['上星期','',''],['上映','',''],['上月','',''],['上月份','',''],['上有','',''],['上有政策','',''],['上有老下有小','',''],['上朝','',''],['上期','',''],['上机','',''],['上机操作','',''],['上杆','',''],['上条','',''],['上来','',''],['上标','',''],['上标题','',''],['上树','',''],['上树拔梯','',''],['上栓','',''],['上校','',''],['上档','',''],['上梁','',''],['上梁不正下梁歪','',''],['上楼','',''],['上楼去梯','',''],['上榜','',''],['上檐','',''],['上次','',''],['上款','',''],['上段','',''],['上气不接下气','',''],['上水','',''],['上水道','',''],['上求下告','',''],['上江','',''],['上汽','',''],['上油','',''],['上流','',''],['上流社会','',''],['上流阶级','',''],['上浆','',''],['上浣','',''],['上浮','',''],['上海交大','',''],['上海交通大学','',''],['上海体育场','',''],['上海医科大学','',''],['上海商务印书馆','',''],['上海外国语大学','',''],['上海大剧院','',''],['上海大学','',''],['上海宝钢集团公司','',''],['上海工人三次武装起义','',''],['上海戏剧学院','',''],['上海振华港口机械','',''],['上海文广新闻传媒集团','',''],['上海汽车工业','',''],['上海汽车工业集团','',''],['上海环球金融中心','',''],['上海第二医科大学','',''],['上海证券交易所','',''],['上海证券交易所综合股价指','',''],['上海证卷交易所','',''],['上海话','',''],['上海财经大学','',''],['上海音乐学院','',''],['上涨','',''],['上涨幅度','',''],['上游','',''],['上溜油','',''],['上溢','',''],['上溯','',''],['上漆','',''],['上漏下湿','',''],['上演','',''],['上演税','',''],['上火','',''],['上灯','',''],['上焦','',''],['上爬','',''],['上片','',''],['上环','',''],['上班','',''],['上班族','',''],['上班时间','',''],['上甘岭','',''],['上用','',''],['上画','',''],['上界','',''],['上疏','',''],['上瘾','',''],['上皮','',''],['上皮组织','',''],['上相','',''],['上看','',''],['上眼皮','',''],['上眼睑','',''],['上着','',''],['上睑','',''],['上知天文下知地理','',''],['上确界','',''],['上移','',''],['上税','',''],['上空','',''],['上空洗车','',''],['上窜下跳','',''],['上站','',''],['上端','',''],['上第','',''],['上等','',''],['上等兵','',''],['上等品','',''],['上策','',''],['上算','',''],['上箭头','',''],['上箭头键','',''],['上篇','',''],['上类','',''],['上紧','',''],['上级','',''],['上级指示','',''],['上级领导','',''],['上线','',''],['上绷带','',''],['上缴','',''],['上网','',''],['上网本','',''],['上翻','',''],['上联','',''],['上肢','',''],['上腰','',''],['上膘','',''],['上膛','',''],['上臂','',''],['上自','',''],['上至','',''],['上船','',''],['上色','',''],['上艾瑟尔','',''],['上节','',''],['上苍','',''],['上药','',''],['上菜','',''],['上蔟','',''],['上蜡','',''],['上行','',''],['上行下效','',''],['上街','',''],['上衣','',''],['上衫','',''],['上装','',''],['上裙','',''],['上西天','',''],['上覆','',''],['上议院','',''],['上访','',''],['上证综合指数','',''],['上诉','',''],['上诉人','',''],['上诉法院','',''],['上课','',''],['上调','',''],['上谕','',''],['上路','',''],['上身','',''],['上车','',''],['上轨道','',''],['上载','',''],['上辈','',''],['上辈子','',''],['上边','',''],['上边儿','',''],['上边缘','',''],['上达','',''],['上进','',''],['上进心','',''],['上述','',''],['上部','',''],['上都','',''],['上野','',''],['上钩','',''],['上钩儿','',''],['上铺','',''],['上锁','',''],['上镜','',''],['上门','',''],['上门服务','',''],['上间','',''],['上阵','',''],['上阵杀敌','',''],['上限','',''],['上院','',''],['上集','',''],['上面','',''],['上鞋','',''],['上页','',''],['上项','',''],['上颌','',''],['上颌骨','',''],['上颔','',''],['上颔骨','',''],['上颚','',''],['上颚正门齿','',''],['上额','',''],['上风','',''],['上饶地区','',''],['上首','',''],['上香','',''],['上马','',''],['上齿','',''],['上齿龈','',''],['上龙','',''],['下一','',''],['下一个','',''],['下一代','',''],['下一位','',''],['下一次','',''],['下一步','',''],['下一站','',''],['下一阶段','',''],['下一页','',''],['下下','',''],['下不为例','',''],['下不来','',''],['下不着地','',''],['下世','',''],['下世纪初','',''],['下个','',''],['下个世纪','',''],['下个星期','',''],['下中农','',''],['下乘','',''],['下乡','',''],['下书','',''],['下了','',''],['下于','',''],['下井投石','',''],['下人','',''],['下仔','',''],['下令','',''],['下任','',''],['下传','',''],['下位','',''],['下位概念','',''],['下体','',''],['下作','',''],['下例','',''],['下侧','',''],['下修','',''],['下倾','',''],['下僚','',''],['下关','',''],['下关市','',''],['下册','',''],['下写','',''],['下决心','',''],['下冻','',''],['下凡','',''],['下划','',''],['下划线','',''],['下列','',''],['下判断','',''],['下剩','',''],['下功夫','',''],['下劲','',''],['下勺','',''],['下半','',''],['下半场','',''],['下半夜','',''],['下半天','',''],['下半年','',''],['下半旗','',''],['下半时','',''],['下半晌','',''],['下半生','',''],['下半身','',''],['下单','',''],['下厂','',''],['下压','',''],['下压力','',''],['下厨','',''],['下去','',''],['下发','',''],['下口','',''],['下台','',''],['下台阶','',''],['下同','',''],['下周','',''],['下命令','',''],['下品','',''],['下唇','',''],['下回','',''],['下土','',''],['下地','',''],['下场','',''],['下场门','',''],['下坂走丸','',''],['下坠','',''],['下坠球','',''],['下坡','',''],['下坡路','',''],['下垂','',''],['下垂症','',''],['下基层','',''],['下堂','',''],['下塌','',''],['下士','',''],['下处','',''],['下大力气','',''],['下大工夫','',''],['下大本钱','',''],['下头','',''],['下夸克','',''],['下奏','',''],['下女','',''],['下奶','',''],['下嫁','',''],['下子','',''],['下孔','',''],['下存','',''],['下季','',''],['下官','',''],['下定','',''],['下定义','',''],['下定决心','',''],['下家','',''],['下寒武','',''],['下寒武统','',''],['下层','',''],['下届','',''],['下属','',''],['下属公司','',''],['下山','',''],['下岗','',''],['下崽','',''],['下工','',''],['下工夫','',''],['下巴','',''],['下巴颏','',''],['下巴颏儿','',''],['下帖','',''],['下年','',''],['下庄','',''],['下床','',''],['下店','',''],['下延','',''],['下引','',''],['下弦','',''],['下弦月','',''],['下得','',''],['下怀','',''],['下情','',''],['下情上达','',''],['下意识','',''],['下愚不移','',''],['下房','',''],['下手','',''],['下拉','',''],['下拉菜单','',''],['下拜','',''],['下拨','',''],['下挫','',''],['下探','',''],['下接','',''],['下推','',''],['下摆','',''],['下操','',''],['下放','',''],['下文','',''],['下方','',''],['下旋','',''],['下旋削球','',''],['下无立锥之地','',''],['下旬','',''],['下星期','',''],['下晚儿','',''],['下月','',''],['下有','',''],['下有对策','',''],['下期','',''],['下本儿','',''],['下来','',''],['下架','',''],['下柬','',''],['下标','',''],['下树','',''],['下档','',''],['下梢','',''],['下棋','',''],['下楼','',''],['下楼梯','',''],['下榻','',''],['下槛','',''],['下欠','',''],['下次','',''],['下款','',''],['下步','',''],['下死劲','',''],['下毒','',''],['下毒手','',''],['下毒者','',''],['下毛','',''],['下气','',''],['下水','',''],['下水礼','',''],['下水管','',''],['下水道','',''],['下江','',''],['下江兵','',''],['下沉','',''],['下河','',''],['下油','',''],['下泄','',''],['下法','',''],['下注','',''],['下泻','',''],['下流','',''],['下流人','',''],['下流话','',''],['下浣','',''],['下浮','',''],['下海','',''],['下游','',''],['下溢','',''],['下滑','',''],['下潜','',''],['下炕','',''],['下点','',''],['下焦','',''],['下片','',''],['下牢','',''],['下狱','',''],['下班','',''],['下生','',''],['下用','',''],['下田','',''],['下画线','',''],['下界','',''],['下略','',''],['下疳','',''],['下痿','',''],['下盘','',''],['下相','',''],['下看','',''],['下眼睑','',''],['下着雨','',''],['下确界','',''],['下碇','',''],['下碗','',''],['下神','',''],['下种','',''],['下移','',''],['下穿','',''],['下站','',''],['下端','',''],['下笔','',''],['下笔千言','',''],['下笔如有神','',''],['下笔如神','',''],['下笔成章','',''],['下笔成篇','',''],['下笔有神','',''],['下第','',''],['下等','',''],['下策','',''],['下箭头','',''],['下箭头键','',''],['下箸','',''],['下篇','',''],['下级','',''],['下级单位','',''],['下级服从上级','',''],['下线','',''],['下线仪式','',''],['下网','',''],['下而上','',''],['下联','',''],['下聘','',''],['下肢','',''],['下脚','',''],['下脚料','',''],['下脚货','',''],['下腹','',''],['下腹部','',''],['下臂','',''],['下至上','',''],['下舱','',''],['下船','',''],['下花园','',''],['下药','',''],['下营','',''],['下营乡','',''],['下落','',''],['下落不明','',''],['下葬','',''],['下蛋','',''],['下行','',''],['下表','',''],['下装','',''],['下西洋','',''],['下角','',''],['下议院','',''],['下议院议员','',''],['下设','',''],['下诏','',''],['下课','',''],['下调','',''],['下象棋','',''],['下贱','',''],['下赌','',''],['下起','',''],['下跌','',''],['下跪','',''],['下身','',''],['下车','',''],['下车之始','',''],['下车伊始','',''],['下车泣罪','',''],['下载','',''],['下辈','',''],['下辈子','',''],['下辖','',''],['下边','',''],['下边儿','',''],['下达','',''],['下述','',''],['下逐客令','',''],['下道','',''],['下部','',''],['下酒','',''],['下酒菜','',''],['下里巴人','',''],['下野','',''],['下钓','',''],['下钻','',''],['下铁道','',''],['下铺','',''],['下锅','',''],['下错','',''],['下锚','',''],['下键','',''],['下门','',''],['下问','',''],['下闸','',''],['下阵雨','',''],['下阶层','',''],['下附','',''],['下陆','',''],['下降','',''],['下限','',''],['下院','',''],['下陷','',''],['下集','',''],['下雨','',''],['下雨天','',''],['下雪','',''],['下雪量','',''],['下雪雨','',''],['下雾','',''],['下霜','',''],['下面','',''],['下面请看','',''],['下页','',''],['下颌','',''],['下颌下腺','',''],['下颌动脉','',''],['下颌骨','',''],['下颏','',''],['下颔','',''],['下颔骨','',''],['下颚','',''],['下额','',''],['下风','',''],['下风方向','',''],['下飞机','',''],['下饭','',''],['下马','',''],['下马威','',''],['下马看花','',''],['下鼻甲','',''],['下齿','',''],['下龙湾','',''],['不一','',''],['不一会','',''],['不一会儿','',''],['不一定','',''],['不一律','',''],['不一样','',''],['不一而足','',''],['不一致','',''],['不一致字','',''],['不一般','',''],['不三不四','',''],['不上','',''],['不上不下','',''],['不下','',''],['不下于','',''],['不不','',''],['不专','',''],['不严','',''],['不严密','',''],['不严峻','',''],['不严谨','',''],['不严重','',''],['不中','',''],['不中意','',''],['不中用','',''],['不丰不杀','',''],['不丹亚','',''],['不丹人','',''],['不丹语','',''],['不为','',''],['不为五斗米折腰','',''],['不为人知','',''],['不为左右袒','',''],['不为己甚','',''],['不为已甚','',''],['不为所动','',''],['不为牛后','',''],['不为瓦全','',''],['不为酒困','',''],['不主故常','',''],['不久','',''],['不久以前','',''],['不久前','',''],['不义','',''],['不义之财','',''],['不乏','',''],['不乏其人','',''],['不乏其例','',''],['不乐','',''],['不习惯','',''],['不习见','',''],['不买','',''],['不买账','',''],['不乱','',''],['不了','',''],['不了了之','',''],['不了解','',''],['不予','',''],['不予承认','',''],['不予理会','',''],['不予置评','',''],['不予考虑','',''],['不予评论','',''],['不予重视','',''],['不争','',''],['不争气','',''],['不二','',''],['不二价','',''],['不二法门','',''],['不亚','',''],['不亚于','',''],['不亢','',''],['不亢不卑','',''],['不交','',''],['不交叉','',''],['不亦乐乎','',''],['不产','',''],['不亲','',''],['不亲切','',''],['不亲热','',''],['不人道','',''],['不仁','',''],['不仁慈','',''],['不仅','',''],['不仅仅','',''],['不仅如此','',''],['不今不古','',''],['不介','',''],['不介意','',''],['不付','',''],['不令人鼓舞','',''],['不以','',''],['不以为意','',''],['不以为然','',''],['不以为耻反以为荣','',''],['不以人废言','',''],['不以己悲','',''],['不以物喜','',''],['不以规矩','',''],['不以词害志','',''],['不以辞害志','',''],['不任职','',''],['不伏烧埋','',''],['不休','',''],['不休息','',''],['不优美','',''],['不优雅','',''],['不会','',''],['不会吧','',''],['不会弄错','',''],['不会有','',''],['不会老','',''],['不会错','',''],['不会飞','',''],['不传','',''],['不传导','',''],['不伤脾胃','',''],['不伦','',''],['不伦不类','',''],['不似','',''],['不但','',''],['不但如此','',''],['不低于','',''],['不住','',''],['不体谅','',''],['不体面','',''],['不作','',''],['不佞','',''],['不佳','',''],['不使','',''],['不使用武力','',''],['不依','',''],['不依不饶','',''],['不便','',''],['不俗','',''],['不保','',''],['不信','',''],['不信仰','',''],['不信任','',''],['不信任动议','',''],['不信任投票','',''],['不信任案','',''],['不信用','',''],['不信神','',''],['不信神者','',''],['不俭则匮','',''],['不修','',''],['不修不节','',''],['不修边幅','',''],['不俱','',''],['不倒','',''],['不倒翁','',''],['不借','',''],['不倦','',''],['不值','',''],['不值一哂','',''],['不值一提','',''],['不值一文','',''],['不值一钱','',''],['不值得','',''],['不值得一提','',''],['不值钱','',''],['不假','',''],['不假思索','',''],['不偏','',''],['不偏不倚','',''],['不偏不袒','',''],['不偏斜','',''],['不偏极','',''],['不做','',''],['不做事','',''],['不做亏心事','',''],['不做作','',''],['不做声','',''],['不停','',''],['不停止','',''],['不停顿','',''],['不健全','',''],['不健康','',''],['不储存','',''],['不傲慢','',''],['不傻','',''],['不像','',''],['不像是真','',''],['不像样','',''],['不像话','',''],['不允许','',''],['不充分','',''],['不充足','',''],['不光','',''],['不光彩','',''],['不光滑','',''],['不克','',''],['不免','',''],['不免一死','',''],['不入兽穴安得兽子','',''],['不入时宜','',''],['不入虎穴','',''],['不入虎穴不得虎子','',''],['不入虎穴焉得虎子','',''],['不全','',''],['不公','',''],['不公平','',''],['不公正','',''],['不共戴天','',''],['不关','',''],['不关心','',''],['不关痛痒','',''],['不关连','',''],['不兴','',''],['不具','',''],['不具名','',''],['不具备','',''],['不典型','',''],['不兼容','',''],['不兼容性','',''],['不再','',''],['不冒昧','',''],['不决','',''],['不冷','',''],['不冷不热','',''],['不冻','',''],['不冻港','',''],['不冻港口','',''],['不净','',''],['不准','',''],['不准时','',''],['不准确','',''],['不准许','',''],['不凋花','',''],['不减','',''],['不减弱','',''],['不减当年','',''],['不凑巧','',''],['不凝固','',''],['不几天','',''],['不凡','',''],['不出','',''],['不出所料','',''],['不分','',''],['不分伯仲','',''],['不分大小','',''],['不分开','',''],['不分彼此','',''],['不分情由','',''],['不分昼夜','',''],['不分清红皂白','',''],['不分畛域','',''],['不分皂白','',''],['不分离','',''],['不分胜负','',''],['不分胜败','',''],['不分轩轾','',''],['不分青红皂白','',''],['不分高下','',''],['不切合实际','',''],['不切实际','',''],['不刊之典','',''],['不刊之论','',''],['不划算','',''],['不划线','',''],['不列顿人','',''],['不列颠','',''],['不列颠・保卫战','',''],['不列颠哥伦比亚','',''],['不列颠哥伦比亚省','',''],['不列颠诸岛','',''],['不则声','',''],['不删','',''],['不利','',''],['不利于','',''],['不利作用','',''],['不利因素','',''],['不到','',''],['不到乌江不尽头','',''],['不到乌江不肯休','',''],['不到乌江心不死','',''],['不到长城非好汉','',''],['不到黄河不死心','',''],['不到黄河心不死','',''],['不前','',''],['不力','',''],['不加','',''],['不加修饰','',''],['不加分析','',''],['不加区别','',''],['不加思索','',''],['不加拘束','',''],['不加掩饰','',''],['不加水','',''],['不加渲染','',''],['不加牛奶','',''],['不加理睬','',''],['不加疑问','',''],['不加虚饰','',''],['不加评论','',''],['不加选择','',''],['不务正业','',''],['不劣方头','',''],['不动','',''],['不动产','',''],['不动声色','',''],['不动情','',''],['不动摇','',''],['不动点','',''],['不动点定理','',''],['不努力','',''],['不劳','',''],['不劳无获','',''],['不劳而获','',''],['不勉强','',''],['不包分配','',''],['不包括','',''],['不化','',''],['不匮','',''],['不匹配','',''],['不区分大小写','',''],['不协','',''],['不协同','',''],['不协调','',''],['不卑不亢','',''],['不单','',''],['不卖','',''],['不卫生','',''],['不即不离','',''],['不卷入','',''],['不厌','',''],['不厌其烦','',''],['不厌其祥','',''],['不厌其详','',''],['不厌求祥','',''],['不厚','',''],['不去','',''],['不去理','',''],['不参加','',''],['不及','',''],['不及格','',''],['不及物动词','',''],['不友善','',''],['不友好','',''],['不反射','',''],['不发','',''],['不发亮','',''],['不发火','',''],['不发达','',''],['不发达国家','',''],['不发达地区','',''],['不发音','',''],['不受','',''],['不受伤害','',''],['不受劝告','',''],['不受干扰','',''],['不受影响','',''],['不受束缚','',''],['不受欢迎','',''],['不受注意','',''],['不受理','',''],['不受管束','',''],['不受约束','',''],['不受重视','',''],['不变','',''],['不变价格','',''],['不变化','',''],['不变性','',''],['不变资本','',''],['不变量','',''],['不只','',''],['不只是','',''],['不可','',''],['不可一世','',''],['不可不','',''],['不可争议','',''],['不可以','',''],['不可企及','',''],['不可估量','',''],['不可侵犯','',''],['不可侵犯权','',''],['不可信','',''],['不可信任','',''],['不可偏废','',''],['不可再生资源','',''],['不可分','',''],['不可分割','',''],['不可分离','',''],['不可动摇','',''],['不可原谅','',''],['不可取','',''],['不可变','',''],['不可同年而语','',''],['不可同日而语','',''],['不可名状','',''],['不可向迩','',''],['不可否认','',''],['不可告人','',''],['不可多得','',''],['不可容忍','',''],['不可导','',''],['不可开交','',''],['不可忍受','',''],['不可忽视','',''],['不可思议','',''],['不可想像','',''],['不可想象','',''],['不可或缺','',''],['不可战胜','',''],['不可抗力','',''],['不可抗拒','',''],['不可挽回','',''],['不可捉摸','',''],['不可接受','',''],['不可撤销信用证','',''],['不可收拾','',''],['不可改变','',''],['不可救药','',''],['不可教','',''],['不可数','',''],['不可数名词','',''],['不可数集','',''],['不可枚举','',''],['不可测','',''],['不可爱','',''],['不可理喻','',''],['不可知','',''],['不可知论','',''],['不可磨灭','',''],['不可端倪','',''],['不可终日','',''],['不可缺','',''],['不可缺少','',''],['不可置信','',''],['不可胜数','',''],['不可胜言','',''],['不可胜计','',''],['不可能','',''],['不可能性','',''],['不可行','',''],['不可解','',''],['不可言传','',''],['不可言喻','',''],['不可言宣','',''],['不可言状','',''],['不可逆','',''],['不可逆反应','',''],['不可逆转','',''],['不可通约','',''],['不可逾越','',''],['不可遏止','',''],['不可避','',''],['不可避免','',''],['不可阻挡','',''],['不可限量','',''],['不可靠','',''],['不可预测','',''],['不可预见','',''],['不吃','',''],['不吃烟火食','',''],['不合','',''],['不合体统','',''],['不合作','',''],['不合作态度','',''],['不合作者','',''],['不合味口','',''],['不合宜','',''],['不合实际','',''],['不合情理','',''],['不合文法','',''],['不合时','',''],['不合时令','',''],['不合时宜','',''],['不合时机','',''],['不合权宜','',''],['不合格','',''],['不合法','',''],['不合理','',''],['不合理制度','',''],['不合理化','',''],['不合算','',''],['不合群','',''],['不合规格','',''],['不合语法','',''],['不合调','',''],['不合谐','',''],['不合身','',''],['不合适','',''],['不合逻辑','',''],['不合道理','',''],['不吉','',''],['不吉利','',''],['不吉祥','',''],['不同','',''],['不同于','',''],['不同凡响','',''],['不同情','',''],['不同意','',''],['不同意者','',''],['不同点','',''],['不同种类','',''],['不名一文','',''],['不名一钱','',''],['不名数','',''],['不名誉','',''],['不名誉事物','',''],['不吐气','',''],['不向','',''],['不吝','',''],['不吝惜','',''],['不吝指教','',''],['不吝珠玉','',''],['不含','',''],['不含糊','',''],['不含铁','',''],['不听命','',''],['不听话','',''],['不吭','',''],['不吸收','',''],['不告而辞','',''],['不周','',''],['不周山','',''],['不周延','',''],['不和','',''],['不和悦','',''],['不和蔼','',''],['不和谐','',''],['不咎既往','',''],['不响应','',''],['不哭','',''],['不哼不哈','',''],['不啻','',''],['不啻天渊','',''],['不善','',''],['不善交际','',''],['不喝','',''],['不回','',''],['不因不由','',''],['不因人热','',''],['不图','',''],['不圆唇元音','',''],['不圆滑','',''],['不圆通','',''],['不在','',''],['不在少数','',''],['不在话下','',''],['不堪一击','',''],['不堪入目','',''],['不堪入耳','',''],['不堪回首','',''],['不堪忍受','',''],['不堪设想','',''],['不堪造就','',''],['不堪重负','',''],['不塞不流','',''],['不止不行','',''],['不声不响','',''],['不复存在','',''],['不外乎','',''],['不外人据','',''],['不外人训','',''],['不外人道','',''],['不多','',''],['不够','',''],['不大','',''],['不失','',''],['不失众望','',''],['不失时机','',''],['不夷不惠','',''],['不夺农时','',''],['不好','',''],['不好不坏','',''],['不如','',''],['不如人意','',''],['不如归去','',''],['不如退而结网','',''],['不妙','',''],['不妥','',''],['不妨','',''],['不妨一试','',''],['不孕','',''],['不孕症','',''],['不存不济','',''],['不孝','',''],['不孝有三','',''],['不学无术','',''],['不安','',''],['不安于位','',''],['不安其室','',''],['不安好心','',''],['不完全归纳','',''],['不完全统计','',''],['不定','',''],['不定元','',''],['不定冠词','',''],['不定式','',''],['不定方程','',''],['不定期','',''],['不定根','',''],['不定积分','',''],['不定词','',''],['不宜','',''],['不实之处','',''],['不实之词','',''],['不实用','',''],['不实际','',''],['不审慎','',''],['不客气','',''],['不宣而战','',''],['不害羞','',''],['不容分说','',''],['不容分辨','',''],['不容忽视','',''],['不容置喙','',''],['不容置疑','',''],['不容置辩','',''],['不容耽搁','',''],['不容许','',''],['不容轻视','',''],['不寒而栗','',''],['不对','',''],['不对碴儿','',''],['不对称','',''],['不寻常','',''],['不小','',''],['不少','',''],['不尽人意','',''],['不尽然','',''],['不尽相同','',''],['不屈不挠','',''],['不屈曲性','',''],['不屑','',''],['不屑一顾','',''],['不履行者','',''],['不巧','',''],['不差毫厘','',''],['不差毫发','',''],['不差累黍','',''],['不已','',''],['不带偏见','',''],['不带电','',''],['不带音','',''],['不常','',''],['不常见','',''],['不干','',''],['不干不净','',''],['不干净','',''],['不干涉','',''],['不干涉政策','',''],['不干胶','',''],['不平','',''],['不平凡','',''],['不平则鸣','',''],['不平坦','',''],['不平常','',''],['不平等','',''],['不平等条约','',''],['不平而鸣','',''],['不平衡','',''],['不平静','',''],['不幸','',''],['不幸之事','',''],['不幸人','',''],['不幸受害','',''],['不幸福','',''],['不广','',''],['不庄重','',''],['不应','',''],['不应得','',''],['不应期','',''],['不应该','',''],['不开窍','',''],['不弃','',''],['不弯','',''],['不弯曲','',''],['不弱','',''],['不强','',''],['不强烈','',''],['不强调','',''],['不当','',''],['不当一回事','',''],['不当之处','',''],['不当事','',''],['不当人子','',''],['不当得利','',''],['不当真','',''],['不当紧','',''],['不当行为','',''],['不彻底','',''],['不待','',''],['不待说','',''],['不徇私情','',''],['不得','',''],['不得不','',''],['不得了','',''],['不得人心','',''],['不得体','',''],['不得其死','',''],['不得劲','',''],['不得已','',''],['不得当','',''],['不得而知','',''],['不得要领','',''],['不必','',''],['不必要','',''],['不忍','',''],['不忘','',''],['不忘沟壑','',''],['不忙','',''],['不忠','',''],['不忠实','',''],['不忠诚','',''],['不快','',''],['不快乐','',''],['不忮不得','',''],['不念','',''],['不念旧恶','',''],['不忿','',''],['不怀','',''],['不怀好意','',''],['不怀疑','',''],['不怎么','',''],['不怎么样','',''],['不怕','',''],['不怕官只怕管','',''],['不怕没柴烧','',''],['不怕虎','',''],['不怕鬼敲门','',''],['不思考','',''],['不怠','',''],['不急','',''],['不急之务','',''],['不急于','',''],['不恐惧','',''],['不恤','',''],['不恤人言','',''],['不恭','',''],['不恭敬','',''],['不息','',''],['不恰当','',''],['不悔改','',''],['不悟','',''],['不患','',''],['不悦','',''],['不悦耳','',''],['不情之情','',''],['不情之请','',''],['不情愿','',''],['不惊','',''],['不惑','',''],['不惑之年','',''],['不惜','',''],['不惜工本','',''],['不惜血本','',''],['不惟','',''],['不惧','',''],['不惮强御','',''],['不惯','',''],['不想','',''],['不惹人','',''],['不愁','',''],['不愉快','',''],['不意','',''],['不感','',''],['不感兴趣','',''],['不感谢','',''],['不愤','',''],['不愤不启','',''],['不愧','',''],['不愧下学','',''],['不愧不怍','',''],['不愧屋漏','',''],['不愿','',''],['不愿听','',''],['不愿意','',''],['不愿给','',''],['不慈悲','',''],['不慌不忙','',''],['不慌张','',''],['不慎','',''],['不慎重','',''],['不懂','',''],['不懂装懂','',''],['不懈','',''],['不懈努力','',''],['不懈怠','',''],['不懊悔','',''],['不成','',''],['不成体系','',''],['不成体统','',''],['不成功','',''],['不成器','',''],['不成型','',''],['不成形','',''],['不成文','',''],['不成文法','',''],['不成方圆','',''],['不成材','',''],['不成样子','',''],['不成比例','',''],['不成熟','',''],['不成角','',''],['不成话','',''],['不战不和','',''],['不战自败','',''],['不戴','',''],['不戴帽','',''],['不才','',''],['不打','',''],['不打不与相识','',''],['不打不成才','',''],['不打不成相识','',''],['不打不相识','',''],['不打紧','',''],['不打自招','',''],['不扣','',''],['不扩散核武器条约','',''],['不扬','',''],['不批','',''],['不承认','',''],['不承认主义','',''],['不把','',''],['不投','',''],['不抗不卑','',''],['不折不扣','',''],['不折不挠','',''],['不报','',''],['不抱','',''],['不抵抗','',''],['不抵抗主义','',''],['不抽','',''],['不拉几','',''],['不拒','',''],['不拘','',''],['不拘一格','',''],['不拘仪式','',''],['不拘小节','',''],['不拘形式','',''],['不拘束','',''],['不拘泥','',''],['不拘礼节','',''],['不拘细行','',''],['不拜','',''],['不择手段','',''],['不拿','',''],['不拿薪水','',''],['不持久','',''],['不指人','',''],['不按','',''],['不挠','',''],['不振','',''],['不换','',''],['不掉','',''],['不接','',''],['不接受','',''],['不接近','',''],['不提也罢','',''],['不插电','',''],['不揣冒昧','',''],['不搭理','',''],['不搭调','',''],['不摆','',''],['不摸头','',''],['不撞南墙不回头','',''],['不支','',''],['不支持','',''],['不收','',''],['不改','',''],['不攻','',''],['不攻自破','',''],['不放','',''],['不敌','',''],['不敏','',''],['不救','',''],['不教','',''],['不教而杀','',''],['不教而诛','',''],['不敢','',''],['不敢后人','',''],['不敢告劳','',''],['不敢当','',''],['不敢自专','',''],['不敢越雷池一步','',''],['不敢高攀','',''],['不散','',''],['不敬','',''],['不敬神','',''],['不整','',''],['不整洁','',''],['不整饰','',''],['不整齐','',''],['不敷','',''],['不敷使用','',''],['不文','',''],['不文不武','',''],['不文明','',''],['不文雅','',''],['不料','',''],['不断','',''],['不断发展','',''],['不断增加','',''],['不断增长','',''],['不断要求','',''],['不新奇','',''],['不新鲜','',''],['不方','',''],['不方便','',''],['不旋','',''],['不旋踵','',''],['不无','',''],['不无关系','',''],['不无小补','',''],['不无道理','',''],['不日','',''],['不日不月','',''],['不旧','',''],['不早','',''],['不早不晚','',''],['不时','',''],['不时之需','',''],['不时之须','',''],['不时有','',''],['不明','',''],['不明不白','',''],['不明了','',''],['不明事理','',''],['不明净','',''],['不明就里','',''],['不明显','',''],['不明智','',''],['不明朗','',''],['不明真相','',''],['不明确','',''],['不明说','',''],['不明飞行物','',''],['不易','',''],['不易之论','',''],['不易对付','',''],['不易懂','',''],['不是','',''],['不是吗','',''],['不是味儿','',''],['不是故意','',''],['不是玩儿的','',''],['不是话','',''],['不显','',''],['不显山不露水','',''],['不显眼','',''],['不显著','',''],['不景气','',''],['不智','',''],['不智之举','',''],['不暇','',''],['不曲','',''],['不曲折','',''],['不曾','',''],['不有','',''],['不服','',''],['不服从','',''],['不服气','',''],['不服水土','',''],['不服罪','',''],['不服输','',''],['不期','',''],['不期然而然','',''],['不期而会','',''],['不期而然','',''],['不期而遇','',''],['不机敏','',''],['不朽','',''],['不杀不辱','',''],['不材','',''],['不来','',''],['不来往','',''],['不来梅','',''],['不来梅港','',''],['不松懈','',''],['不枉','',''],['不果断','',''],['不标准','',''],['不栉进士','',''],['不检','',''],['不检查','',''],['不检点','',''],['不欢','',''],['不欢而散','',''],['不欲','',''],['不欺暗室','',''],['不止','',''],['不止一次','',''],['不正','',''],['不正之风','',''],['不正常','',''],['不正常状况','',''],['不正式','',''],['不正当','',''],['不正当关系','',''],['不正当竞争','',''],['不正派','',''],['不正直','',''],['不正确','',''],['不正确性','',''],['不武装','',''],['不歪','',''],['不死','',''],['不死不活','',''],['不死心','',''],['不殷勤','',''],['不比','',''],['不毛','',''],['不毛之地','',''],['不民主','',''],['不求','',''],['不求上进','',''],['不求人','',''],['不求收获','',''],['不求有功','',''],['不求甚解','',''],['不求闻达','',''],['不沉','',''],['不治','',''],['不治之症','',''],['不治而愈','',''],['不沾','',''],['不泄气','',''],['不法','',''],['不法之徒','',''],['不法分子','',''],['不法行为','',''],['不注意','',''],['不洁','',''],['不洁净','',''],['不活','',''],['不活动','',''],['不活泼','',''],['不流','',''],['不流动','',''],['不流行','',''],['不测','',''],['不测之祸','',''],['不测风云','',''],['不济','',''],['不济事','',''],['不消','',''],['不消化','',''],['不深','',''],['不混乱','',''],['不清','',''],['不清楚','',''],['不清洁','',''],['不清爽','',''],['不渗','',''],['不渝','',''],['不温不火','',''],['不温暖','',''],['不溶','',''],['不溶解','',''],['不滑','',''],['不滑稽','',''],['不满','',''],['不满意','',''],['不满意者','',''],['不满现状','',''],['不满者','',''],['不满足','',''],['不漂亮','',''],['不漂白','',''],['不漏','',''],['不漏水','',''],['不潦潦之','',''],['不潮湿','',''],['不灭','',''],['不灰心','',''],['不灰木','',''],['不灵','',''],['不灵巧','',''],['不灵敏','',''],['不烂','',''],['不烂之舌','',''],['不烦恼','',''],['不热','',''],['不热心','',''],['不热情','',''],['不然','',''],['不熟','',''],['不熟悉','',''],['不熟练','',''],['不燃','',''],['不燃性','',''],['不燃烧','',''],['不燃物','',''],['不爱','',''],['不爱交际','',''],['不爱国','',''],['不爱说话','',''],['不爽','',''],['不爽快','',''],['不牢','',''],['不特','',''],['不犯','',''],['不犹豫','',''],['不狡猾','',''],['不独','',''],['不现实','',''],['不理','',''],['不理睬','',''],['不理解','',''],['不甘','',''],['不甘于','',''],['不甘后人','',''],['不甘寂寞','',''],['不甘心','',''],['不甘愿','',''],['不甘示弱','',''],['不甘落后','',''],['不甘雌伏','',''],['不甚','',''],['不甚了了','',''],['不甚重要','',''],['不甜','',''],['不生','',''],['不生不死','',''],['不生产','',''],['不生育','',''],['不生锈','',''],['不用','',''],['不用客气','',''],['不用找','',''],['不用说','',''],['不用谢','',''],['不由','',''],['不由分说','',''],['不由得','',''],['不由自主','',''],['不畅','',''],['不畏','',''],['不畏强御','',''],['不畏强暴','',''],['不畏强权','',''],['不畏惧','',''],['不畏艰险','',''],['不留','',''],['不留心','',''],['不留神','',''],['不疑','',''],['不疲倦','',''],['不疲劳','',''],['不疾不徐','',''],['不痛','',''],['不痛不痒','',''],['不登大雅之堂','',''],['不白','',''],['不白之冤','',''],['不皱','',''],['不相','',''],['不相上下','',''],['不相为谋','',''],['不相似','',''],['不相信','',''],['不相关','',''],['不相同','',''],['不相宜','',''],['不相容','',''],['不相容原理','',''],['不相干','',''],['不相称','',''],['不相符','',''],['不相等','',''],['不相适应','',''],['不相配','',''],['不省','',''],['不省人事','',''],['不看','',''],['不看僧面看佛面','',''],['不真实','',''],['不真确','',''],['不真诚','',''],['不眠','',''],['不眠不休','',''],['不眠之夜','',''],['不着','',''],['不着边际','',''],['不着陆飞行','',''],['不睡','',''],['不睡眠','',''],['不睦','',''],['不睬','',''],['不瞅不睬','',''],['不瞒你说','',''],['不瞒您说','',''],['不矜不伐','',''],['不矜细行','',''],['不知','',''],['不知丁董','',''],['不知不觉','',''],['不知为不知','',''],['不知为什么','',''],['不知何故','',''],['不知其二','',''],['不知其所以然','',''],['不知凡几','',''],['不知出于何种原因','',''],['不知去向','',''],['不知名','',''],['不知天高地厚','',''],['不知好歹','',''],['不知就里','',''],['不知怎么','',''],['不知悔改','',''],['不知情','',''],['不知所为','',''],['不知所之','',''],['不知所云','',''],['不知所以','',''],['不知所指','',''],['不知所措','',''],['不知所终','',''],['不知旧里','',''],['不知死活','',''],['不知深浅','',''],['不知甘苦','',''],['不知疲倦','',''],['不知痛痒','',''],['不知礼','',''],['不知羞耻','',''],['不知者不罪','',''],['不知耻','',''],['不知足','',''],['不知轻重','',''],['不知进退','',''],['不知道','',''],['不知高低','',''],['不短','',''],['不破','',''],['不破不立','',''],['不确切','',''],['不确定','',''],['不确定性','',''],['不确定性原理','',''],['不确实','',''],['不碍','',''],['不碎玻璃','',''],['不磨损','',''],['不示','',''],['不礼貌','',''],['不祉','',''],['不神圣','',''],['不祥','',''],['不祥之兆','',''],['不祥之力','',''],['不祥之物','',''],['不祥预兆','',''],['不祧之祖','',''],['不禁','',''],['不离','',''],['不离儿','',''],['不科学','',''],['不积小流','',''],['不积极','',''],['不积跬步','',''],['不称','',''],['不称职','',''],['不移','',''],['不稂不莠','',''],['不稳','',''],['不稳固','',''],['不稳定','',''],['不稳定气流','',''],['不稳平衡','',''],['不稳性','',''],['不稼不穑','',''],['不穷','',''],['不空成就佛','',''],['不端','',''],['不端庄','',''],['不笑','',''],['不符','',''],['不符合','',''],['不第','',''],['不等','',''],['不等于','',''],['不等价交换','',''],['不等压','',''],['不等号','',''],['不等式','',''],['不等边','',''],['不等边三角形','',''],['不答复','',''],['不答应','',''],['不答理','',''],['不简单','',''],['不算','',''],['不管','',''],['不管三七二十一','',''],['不管不顾','',''],['不管什麽','',''],['不管如何','',''],['不管怎么说','',''],['不管怎样','',''],['不管是谁','',''],['不精','',''],['不精密','',''],['不精确','',''],['不精确性','',''],['不精通','',''],['不紧','',''],['不紧不慢','',''],['不紧要','',''],['不累','',''],['不约','',''],['不约而合','',''],['不约而同','',''],['不纯','',''],['不纯洁','',''],['不纳','',''],['不细致','',''],['不终天年','',''],['不经','',''],['不经一事','',''],['不经之谈','',''],['不经常','',''],['不经意','',''],['不经意间','',''],['不经济','',''],['不结','',''],['不结块','',''],['不结实','',''],['不结果','',''],['不结盟','',''],['不结盟会议','',''],['不结盟国家','',''],['不结盟政策','',''],['不结盟运动','',''],['不给','',''],['不给予','',''],['不给力','',''],['不绝','',''],['不绝于耳','',''],['不绝于途','',''],['不绝如线','',''],['不绝如缕','',''],['不统一','',''],['不缩','',''],['不缩不皱','',''],['不罚','',''],['不置','',''],['不置可否','',''],['不署名','',''],['不羁','',''],['不美','',''],['不美栗','',''],['不美观','',''],['不翼而飞','',''],['不老','',''],['不老实','',''],['不老练','',''],['不考虑','',''],['不而','',''],['不耐心','',''],['不耐烦','',''],['不耻','',''],['不耻下问','',''],['不肖','',''],['不肖子孙','',''],['不肥沃','',''],['不肯','',''],['不育','',''],['不育性','',''],['不育症','',''],['不育系','',''],['不胜','',''],['不胜举','',''],['不胜任','',''],['不胜其扰','',''],['不胜其烦','',''],['不胜其苦','',''],['不胜枚举','',''],['不胫而走','',''],['不能','',''],['不能不','',''],['不能分','',''],['不能动','',''],['不能同日而语','',''],['不能容忍','',''],['不能平静','',''],['不能忍受','',''],['不能成方圆','',''],['不能抵抗','',''],['不能按','',''],['不能挽回','',''],['不能接受','',''],['不能自已','',''],['不能自拔','',''],['不能读','',''],['不能飞','',''],['不脱离','',''],['不脱线','',''],['不脸红','',''],['不腐败','',''],['不自','',''],['不自主','',''],['不自在','',''],['不自然','',''],['不自由','',''],['不自私','',''],['不自觉','',''],['不自量','',''],['不自量力','',''],['不至','',''],['不至于','',''],['不致','',''],['不致于','',''],['不致命','',''],['不舆','',''],['不舍','',''],['不舍昼夜','',''],['不舒','',''],['不舒服','',''],['不舒适','',''],['不舞之鹤','',''],['不良','',''],['不良倾向','',''],['不良少年','',''],['不节俭','',''],['不节制','',''],['不苟','',''],['不苟言笑','',''],['不若','',''],['不茶不饭','',''],['不药','',''],['不药而愈','',''],['不莱梅','',''],['不菲','',''],['不落','',''],['不落俗套','',''],['不落巢臼','',''],['不落痕迹','',''],['不落窠臼','',''],['不著火','',''],['不著边际','',''],['不蔓不枝','',''],['不虔诚','',''],['不虚伪','',''],['不虚此行','',''],['不虞','',''],['不虞之誉','',''],['不融合','',''],['不蠢','',''],['不血','',''],['不行','',''],['不行了','',''],['不补','',''],['不表','',''],['不衰','',''],['不被','',''],['不装订','',''],['不褪色','',''],['不要','',''],['不要哭','',''],['不要紧','',''],['不要胡说','',''],['不要脸','',''],['不见','',''],['不见一点踪影','',''],['不见不散','',''],['不见兔子不撒鹰','',''],['不见圭角','',''],['不见天日','',''],['不见得','',''],['不见棺材不落泪','',''],['不见经传','',''],['不规则','',''],['不规则三角形','',''],['不规则四边形','',''],['不规律','',''],['不规矩','',''],['不规范','',''],['不觉','',''],['不觉察','',''],['不解','',''],['不解之缘','',''],['不解之谜','',''],['不解其意','',''],['不解风情','',''],['不触目','',''],['不言','',''],['不言下自成行','',''],['不言不语','',''],['不言而喻','',''],['不言自明','',''],['不计','',''],['不计其数','',''],['不计后果','',''],['不计报酬','',''],['不认','',''],['不认真','',''],['不认识','',''],['不认输','',''],['不让','',''],['不让须眉','',''],['不记名','',''],['不记名投票','',''],['不讲','',''],['不讲出','',''],['不讲方法','',''],['不讲条件','',''],['不讳','',''],['不许','',''],['不许可','',''],['不许百姓点灯','',''],['不论','',''],['不论什么','',''],['不论什麽','',''],['不论何时','',''],['不论何种','',''],['不论是谁','',''],['不论甚么','',''],['不论谁','',''],['不设','',''],['不设防','',''],['不设防城市','',''],['不证自明','',''],['不识','',''],['不识一丁','',''],['不识大体','',''],['不识好人心','',''],['不识好歹','',''],['不识字','',''],['不识庐山真面目','',''],['不识抬举','',''],['不识时务','',''],['不识时变','',''],['不识泰山','',''],['不识闲儿','',''],['不识高低','',''],['不诚实','',''],['不诚恳','',''],['不该','',''],['不该得','',''],['不详','',''],['不详尽','',''],['不语','',''],['不说','',''],['不说自明','',''],['不说谎','',''],['不请','',''],['不请自来','',''],['不读音','',''],['不调','',''],['不调和','',''],['不谋私利','',''],['不谋而合','',''],['不谋而同','',''],['不谐和','',''],['不谐和音','',''],['不谓','',''],['不谢','',''],['不谦虚','',''],['不谨慎','',''],['不象','',''],['不象样','',''],['不象话','',''],['不贞','',''],['不贞洁','',''],['不负','',''],['不负众望','',''],['不负责任','',''],['不败','',''],['不败之地','',''],['不质疑','',''],['不购买','',''],['不贰过','',''],['不贵','',''],['不费','',''],['不费事','',''],['不费力','',''],['不费吹灰之力','',''],['不赀','',''],['不赔','',''],['不赖','',''],['不赚','',''],['不赞一词','',''],['不赞同','',''],['不赞成','',''],['不赢','',''],['不走','',''],['不走过场','',''],['不起','',''],['不起作用','',''],['不起劲','',''],['不起眼','',''],['不超过','',''],['不越雷池','',''],['不足','',''],['不足为凭','',''],['不足为外人道','',''],['不足为奇','',''],['不足为虑','',''],['不足为训','',''],['不足为道','',''],['不足之处','',''],['不足之数','',''],['不足介意','',''],['不足以平民愤','',''],['不足取','',''],['不足够','',''],['不足挂齿','',''],['不足提','',''],['不足月','',''],['不足的地方','',''],['不足轻重','',''],['不足道','',''],['不足齿数','',''],['不跟','',''],['不轨','',''],['不轻','',''],['不轻信','',''],['不轻饶','',''],['不辍','',''],['不输','',''],['不辞','',''],['不辞劳苦','',''],['不辞而别','',''],['不辞辛劳','',''],['不辞辛苦','',''],['不辨','',''],['不辨菽麦','',''],['不达时务','',''],['不迂','',''],['不过','',''],['不过关','',''],['不过如此','',''],['不过如此而已','',''],['不过尔尔','',''],['不过意','',''],['不近','',''],['不近人情','',''],['不返','',''],['不还','',''],['不还债','',''],['不进','',''],['不进则退','',''],['不远','',''],['不远万里','',''],['不远千里','',''],['不违农时','',''],['不连接','',''],['不连续','',''],['不连续面','',''],['不连贯','',''],['不迟','',''],['不迫','',''],['不迭','',''],['不送','',''],['不送气','',''],['不适','',''],['不适中','',''],['不适任','',''],['不适合','',''],['不适宜','',''],['不适应','',''],['不适当','',''],['不适用','',''],['不适航','',''],['不逊','',''],['不透','',''],['不透光','',''],['不透明','',''],['不透明化','',''],['不透明性','',''],['不透气','',''],['不透水','',''],['不透水层','',''],['不透热','',''],['不通','',''],['不通人情','',''],['不通气','',''],['不通水火','',''],['不通融','',''],['不通风','',''],['不逞','',''],['不逞之徒','',''],['不速','',''],['不速之客','',''],['不速而至','',''],['不逮捕特权','',''],['不遂','',''],['不遑','',''],['不遑多让','',''],['不遑宁处','',''],['不道德','',''],['不遗','',''],['不遗余力','',''],['不遵守','',''],['不避','',''],['不避强御','',''],['不避斧钺','',''],['不避艰险','',''],['不那麽','',''],['不郎不秀','',''],['不配','',''],['不配合','',''],['不醉不归','',''],['不醒','',''],['不里','',''],['不重','',''],['不重要','',''],['不重视','',''],['不重读','',''],['不锈','',''],['不锈钢','',''],['不锈铁','',''],['不错','',''],['不错眼','',''],['不长','',''],['不长一智','',''],['不问','',''],['不问好歹','',''],['不问就听不到假话','',''],['不问青红皂白','',''],['不间不界','',''],['不间断','',''],['不闻不问','',''],['不防','',''],['不阴不阳','',''],['不附著','',''],['不限','',''],['不限于一','',''],['不随','',''],['不随大流','',''],['不随意','',''],['不随意肌','',''],['不难','',''],['不难想像','',''],['不难看','',''],['不难看出','',''],['不雅','',''],['不雅致','',''],['不雅观','',''],['不需','',''],['不需要','',''],['不露','',''],['不露圭角','',''],['不露声色','',''],['不露痕迹','',''],['不露面','',''],['不靠','',''],['不韪','',''],['不顺','',''],['不顺从','',''],['不顺利','',''],['不顺服','',''],['不顺遂','',''],['不须','',''],['不顾','',''],['不顾一切','',''],['不顾前后','',''],['不顾危险','',''],['不顾后果','',''],['不顾死活','',''],['不领情','',''],['不题','',''],['不食之地','',''],['不饮盗泉','',''],['不饱和','',''],['不饱和脂肪酸','',''],['不饿','',''],['不首先使用','',''],['不驯','',''],['不驯服','',''],['不骄','',''],['不骄不躁','',''],['不高','',''],['不高兴','',''],['不鲜明','',''],['不鸣则已','',''],['不齐','',''],['不齿','',''],['与世','',''],['与世俯仰','',''],['与世偃仰','',''],['与世无争','',''],['与世永别','',''],['与世沉浮','',''],['与世浮沉','',''],['与世长辞','',''],['与世隔绝','',''],['与世靡争','',''],['与之','',''],['与之无关','',''],['与人','',''],['与人为善','',''],['与人方便','',''],['与众','',''],['与众不同','',''],['与会','',''],['与会代表','',''],['与会同志','',''],['与会国','',''],['与会者','',''],['与你','',''],['与全世界为敌','',''],['与共','',''],['与其','',''],['与其说','',''],['与前同','',''],['与去年相比','',''],['与否','',''],['与国','',''],['与她','',''],['与日俱增','',''],['与日俱辉','',''],['与日俱进','',''],['与日同辉','',''],['与时俱进','',''],['与时浮沉','',''],['与时消息','',''],['与时间赛跑','',''],['与月','',''],['与格','',''],['与此','',''],['与此同时','',''],['与此无关','',''],['与此有关','',''],['与此相关','',''],['与此相反','',''],['与民','',''],['与民休息','',''],['与民偕乐','',''],['与民同乐','',''],['与民同忧','',''],['与民更始','',''],['与生','',''],['与生俱来','',''],['与虎添翼','',''],['与虎谋皮','',''],['与闻','',''],['丐帮','',''],['丑不','',''],['丑事','',''],['丑八怪','',''],['丑剧','',''],['丑化','',''],['丑名','',''],['丑声远播','',''],['丑婆子','',''],['丑小鸭','',''],['丑态','',''],['丑态百出','',''],['丑怪','',''],['丑恶','',''],['丑杂','',''],['丑牛','',''],['丑的','',''],['丑相','',''],['丑类','',''],['丑类恶物','',''],['丑老','',''],['丑行','',''],['丑行邪事','',''],['丑表功','',''],['丑角','',''],['丑诋','',''],['丑话','',''],['丑闻','',''],['丑陋','',''],['丑鬼','',''],['专一','',''],['专业','',''],['专业人员','',''],['专业人才','',''],['专业分工','',''],['专业化','',''],['专业学校','',''],['专业对口','',''],['专业性','',''],['专业户','',''],['专业教育','',''],['专业知识','',''],['专业英语','',''],['专业课','',''],['专业银行','',''],['专为','',''],['专事','',''],['专于','',''],['专人','',''],['专任','',''],['专使','',''],['专供','',''],['专修','',''],['专修科','',''],['专函','',''],['专刊','',''],['专列','',''],['专利','',''],['专利制度','',''],['专利局','',''],['专利权','',''],['专利法','',''],['专利者','',''],['专利药品','',''],['专制','',''],['专制主义','',''],['专制君主制','',''],['专力','',''],['专功','',''],['专区','',''],['专卖','',''],['专卖店','',''],['专卖者','',''],['专发','',''],['专号','',''],['专司','',''],['专名','',''],['专名词','',''],['专向','',''],['专员','',''],['专员公署','',''],['专售','',''],['专唱','',''],['专场','',''],['专家','',''],['专家学者','',''],['专家系统','',''],['专家级','',''],['专家组','',''],['专家评价','',''],['专家评论','',''],['专属','',''],['专属经济区','',''],['专差','',''],['专席','',''],['专库','',''],['专座','',''],['专征','',''],['专心','',''],['专心一志','',''],['专心一意','',''],['专心敬业','',''],['专心致志','',''],['专意','',''],['专户','',''],['专才','',''],['专拣','',''],['专指','',''],['专挑','',''],['专控','',''],['专擅','',''],['专攻','',''],['专政','',''],['专政对象','',''],['专政机关','',''],['专文','',''],['专断','',''],['专有','',''],['专有名词','',''],['专有权','',''],['专机','',''],['专权','',''],['专柜','',''],['专栏','',''],['专案','',''],['专案组','',''],['专案经理','',''],['专横','',''],['专横跋扈','',''],['专款','',''],['专款专用','',''],['专治','',''],['专注','',''],['专爱','',''],['专用','',''],['专用号','',''],['专用名词','',''],['专用章','',''],['专用线','',''],['专用网路','',''],['专用设备','',''],['专用集成电路','',''],['专电','',''],['专科','',''],['专科化','',''],['专科大学','',''],['专科学校','',''],['专科词典','',''],['专科院校','',''],['专程','',''],['专管','',''],['专线','',''],['专网','',''],['专署','',''],['专美','',''],['专美于前','',''],['专而精','',''],['专职','',''],['专职干部','',''],['专营','',''],['专营店','',''],['专著','',''],['专论','',''],['专设','',''],['专访','',''],['专诚','',''],['专责','',''],['专车','',''],['专辑','',''],['专送','',''],['专递','',''],['专长','',''],['专门','',''],['专门人员','',''],['专门人才','',''],['专门从事','',''],['专门列车','',''],['专门化','',''],['专门家','',''],['专门机构','',''],['专门调查','',''],['专集','',''],['专项','',''],['专项合同','',''],['专题','',''],['专题报告','',''],['专题片','',''],['专题研究','',''],['专题讨论','',''],['且不','',''],['且不说','',''],['且且','',''],['且休','',''],['且听','',''],['且听下回分解','',''],['且慢','',''],['且有','',''],['且末遗址','',''],['且看','',''],['且知','',''],['且经','',''],['且让','',''],['且话','',''],['且说','',''],['且过','',''],['且还','',''],['世上','',''],['世上无难事','',''],['世世','',''],['世世代代','',''],['世世生生','',''],['世事','',''],['世交','',''],['世人','',''],['世仇','',''],['世代','',''],['世代书香','',''],['世代交替','',''],['世代相传','',''],['世传','',''],['世伯','',''],['世俗','',''],['世俗化','',''],['世兄','',''],['世医','',''],['世博','',''],['世卫组织','',''],['世外','',''],['世外桃源','',''],['世外桃花源','',''],['世子','',''],['世宗','',''],['世宗大王','',''],['世家','',''],['世尊','',''],['世局','',''],['世居','',''],['世态','',''],['世态人情','',''],['世态炎凉','',''],['世情','',''],['世故','',''],['世族','',''],['世爵','',''],['世界','',''],['世界上','',''],['世界主义','',''],['世界之最','',''],['世界人权宣言','',''],['世界人民','',''],['世界先进水平','',''],['世界军事','',''],['世界冠军','',''],['世界博览','',''],['世界博览会','',''],['世界卫生大会','',''],['世界历史','',''],['世界变暖','',''],['世界各国','',''],['世界各地','',''],['世界和平','',''],['世界地图','',''],['世界地理','',''],['世界大国','',''],['世界大战','',''],['世界大赛','',''],['世界小姐选美','',''],['世界屋脊','',''],['世界市场','',''],['世界强国','',''],['世界形势','',''],['世界性','',''],['世界性古老问题','',''],['世界报','',''],['世界政治','',''],['世界文化','',''],['世界文化遗产','',''],['世界文化遗产地','',''],['世界文明','',''],['世界旅游组织','',''],['世界日报','',''],['世界时','',''],['世界末日','',''],['世界杯','',''],['世界杯赛','',''],['世界模式论','',''],['世界气象组织','',''],['世界水平','',''],['世界海关组织','',''],['世界潮流','',''],['世界的语言','',''],['世界知名','',''],['世界知识','',''],['世界知识产权组织','',''],['世界第一','',''],['世界粮食署','',''],['世界级','',''],['世界纪录','',''],['世界经济','',''],['世界经济论坛','',''],['世界维吾尔代表大会','',''],['世界自然基金会','',''],['世界范围','',''],['世界观','',''],['世界语','',''],['世界贸易','',''],['世界贸易中心','',''],['世界贸易组织','',''],['世界运动会','',''],['世界野生生物基金会','',''],['世界金融中心','',''],['世界锦标赛','',''],['世界闻名','',''],['世禄','',''],['世禄之家','',''],['世系','',''],['世纪','',''],['世纪末','',''],['世纪末年','',''],['世维会','',''],['世职','',''],['世胄','',''],['世臣','',''],['世行','',''],['世袭','',''],['世袭之争','',''],['世袭君主国','',''],['世贸','',''],['世贸中心大楼','',''],['世贸大厦','',''],['世贸组织','',''],['世运','',''],['世道','',''],['世道人情','',''],['世银','',''],['世锦赛','',''],['世间','',''],['世隔绝','',''],['世面','',''],['世风','',''],['世风日下','',''],['丘八','',''],['丘县','',''],['丘吉尔','',''],['丘墓','',''],['丘壑','',''],['丘尔金','',''],['丘成桐','',''],['丘比特','',''],['丘疹','',''],['丘脑','',''],['丘脑损伤','',''],['丘逢甲','',''],['丘阜','',''],['丘陵','',''],['丘鹬','',''],['丙丁','',''],['丙三醇','',''],['丙二醇','',''],['丙午','',''],['丙型','',''],['丙型肝炎','',''],['丙基','',''],['丙夜','',''],['丙子','',''],['丙寅','',''],['丙戌','',''],['丙方','',''],['丙氨酸','',''],['丙烯','',''],['丙烯腈','',''],['丙烯荃','',''],['丙烯酸','',''],['丙烯酸酯','',''],['丙烯醛','',''],['丙烷','',''],['丙环唑','',''],['丙申','',''],['丙种','',''],['丙种射线','',''],['丙等','',''],['丙类','',''],['丙糖','',''],['丙级','',''],['丙纶','',''],['丙辰','',''],['丙酮','',''],['丙酮酸','',''],['丙酮酸脱氢酶','',''],['丙醇','',''],['丙醚','',''],['丙醛','',''],['业业','',''],['业主','',''],['业于','',''],['业余','',''],['业余大学','',''],['业余学校','',''],['业余教育','',''],['业余时间','',''],['业余爱好','',''],['业余爱好者','',''],['业余者','',''],['业务','',''],['业务上','',''],['业务人员','',''],['业务员','',''],['业务学习','',''],['业务模式','',''],['业务水平','',''],['业务科','',''],['业务素质','',''],['业务联系','',''],['业务过失','',''],['业大','',''],['业已','',''],['业师','',''],['业后','',''],['业态','',''],['业户','',''],['业扩','',''],['业根','',''],['业海','',''],['业界','',''],['业界标准','',''],['业精于勤','',''],['业经','',''],['业绩','',''],['业者','',''],['业荒于嬉','',''],['业障','',''],['业龙','',''],['丛中','',''],['丛书','',''],['丛冢','',''],['丛刊','',''],['丛刻','',''],['丛台','',''],['丛密','',''],['丛山','',''],['丛木','',''],['丛杂','',''],['丛林','',''],['丛林战','',''],['丛树','',''],['丛毛','',''],['丛状','',''],['丛生','',''],['丛脞','',''],['丛莽','',''],['丛葬','',''],['丛谈','',''],['丛集','',''],['东一榔头西一棒子','',''],['东三省','',''],['东东','',''],['东中国海','',''],['东主','',''],['东丽','',''],['东亚','',''],['东亚运动会','',''],['东亚银行','',''],['东交民巷','',''],['东京','',''],['东京塔','',''],['东京大学','',''],['东京帝国大学','',''],['东京湾','',''],['东仓里','',''],['东佃','',''],['东侧','',''],['东侨','',''],['东侵','',''],['东倒西歪','',''],['东偷西摸','',''],['东兔西乌','',''],['东冲西突','',''],['东加王国','',''],['东劳西燕','',''],['东势','',''],['东势乡','',''],['东势镇','',''],['东北','',''],['东北三省','',''],['东北东','',''],['东北亚','',''],['东北向','',''],['东北地区','',''],['东北大学','',''],['东北大鼓','',''],['东北平原','',''],['东北抗日联军','',''],['东北方','',''],['东北虎','',''],['东北角','',''],['东北部','',''],['东北风','',''],['东升','',''],['东半球','',''],['东华三院','',''],['东华门','',''],['东协国家','',''],['东单','',''],['东南','',''],['东南东','',''],['东南之美','',''],['东南亚','',''],['东南亚半岛','',''],['东南亚国','',''],['东南亚国家联盟','',''],['东南亚联盟','',''],['东南大学','',''],['东南方','',''],['东南竹箭','',''],['东南西北','',''],['东南西北中','',''],['东南角','',''],['东南部','',''],['东南风','',''],['东印度公司','',''],['东去','',''],['东口','',''],['东向','',''],['东君','',''],['东吴','',''],['东吴大学','',''],['东周','',''],['东四','',''],['东土','',''],['东坡','',''],['东坡肉','',''],['东坡肘子','',''],['东城','',''],['东太平洋','',''],['东太平洋隆起','',''],['东头村','',''],['东夷','',''],['东奔西向','',''],['东奔西撞','',''],['东奔西走','',''],['东奔西跑','',''],['东奔西闯','',''],['东宝','',''],['东宫','',''],['东家','',''],['东家效颦','',''],['东密德兰','',''],['东寻西觅','',''],['东屯区','',''],['东山之志','',''],['东山乡','',''],['东山再起','',''],['东山复起','',''],['东山高卧','',''],['东岳','',''],['东岸','',''],['东川','',''],['东差西误','',''],['东巴文化','',''],['东市朝衣','',''],['东床','',''],['东床坦腹','',''],['东床娇婿','',''],['东床娇客','',''],['东建','',''],['东引','',''],['东引乡','',''],['东张西望','',''],['东张西觑','',''],['东归','',''],['东征','',''],['东征战役','',''],['东征西怨','',''],['东征西讨','',''],['东徙西迁','',''],['东德','',''],['东扬西荡','',''],['东扭西捏','',''],['东扯西拉','',''],['东扶西倒','',''],['东抄西袭','',''],['东拉西扯','',''],['东拼西凑','',''],['东挨西撞','',''],['东挪西借','',''],['东挪西凑','',''],['东挪西辏','',''],['东捞西摸','',''],['东掩西遮','',''],['东撙西节','',''],['东方三博士','',''],['东方人','',''],['东方千骑','',''],['东方国家','',''],['东方式','',''],['东方文明','',''],['东方日报','',''],['东方明珠塔','',''],['东方明珠电视塔','',''],['东方湾','',''],['东方狍','',''],['东方红','',''],['东方航空','',''],['东方通','',''],['东方阿閦佛','',''],['东方青龙','',''],['东方马脑炎病毒','',''],['东方黎族自治县','',''],['东施效颦','',''],['东昌','',''],['东昌府','',''],['东昌纸','',''],['东晋','',''],['东条','',''],['东条英机','',''],['东来','',''],['东来紫气','',''],['东来西去','',''],['东楼','',''],['东欧','',''],['东欧人','',''],['东欧国家','',''],['东欧平原','',''],['东正教','',''],['东歪西倒','',''],['东段','',''],['东汉','',''],['东汉末','',''],['东汉末年','',''],['东江','',''],['东沙','',''],['东沙群岛','',''],['东沟','',''],['东沟镇','',''],['东河','',''],['东河乡','',''],['东洋','',''],['东洋大海','',''],['东洋车','',''],['东洋鬼','',''],['东洋鬼子','',''],['东洲','',''],['东流','',''],['东海大学','',''],['东海大桥','',''],['东海岸','',''],['东海扬尘','',''],['东海捞针','',''],['东海舰队','',''],['东涂西摸','',''],['东渡','',''],['东港镇','',''],['东游西逛','',''],['东湖','',''],['东溟','',''],['东瀛','',''],['东王公','',''],['东现汉纪','',''],['东疆','',''],['东盟国家','',''],['东直门','',''],['东瞧西望','',''],['东石','',''],['东石乡','',''],['东碰西撞','',''],['东穿西撞','',''],['东突','',''],['东突厥斯坦','',''],['东突厥斯坦伊斯兰运动','',''],['东突厥斯坦解放组织','',''],['东突组织','',''],['东窗事发','',''],['东窗事犯','',''],['东站','',''],['东端','',''],['东线','',''],['东经','',''],['东缅高原','',''],['东罗马帝国','',''],['东翻西倒','',''],['东胜','',''],['东胡','',''],['东航','',''],['东芝','',''],['东茅草盖','',''],['东荡西除','',''],['东藏西躲','',''],['东行','',''],['东街','',''],['东补西凑','',''],['东西','',''],['东西半球','',''],['东西南北','',''],['东西南北人','',''],['东西南北客','',''],['东西周','',''],['东西宽','',''],['东西德','',''],['东西方','',''],['东西方文化','',''],['东西欧','',''],['东西湖','',''],['东观之殃','',''],['东观汉记','',''],['东观西望','',''],['东讨西伐','',''],['东讨西征','',''],['东诓西骗','',''],['东走西撞','',''],['东跑西颠','',''],['东路','',''],['东躲西藏','',''],['东躲西跑','',''],['东躲西逃','',''],['东躲西闪','',''],['东边','',''],['东边儿','',''],['东迁西徙','',''],['东逃西窜','',''],['东道','',''],['东道主','',''],['东道国','',''],['东遮西掩','',''],['东邻西舍','',''],['东郊','',''],['东部','',''],['东部时间','',''],['东郭','',''],['东郭先生','',''],['东野','',''],['东量西折','',''],['东门','',''],['东门黄犬','',''],['东闪西挪','',''],['东陵','',''],['东隅','',''],['东零西散','',''],['东零西落','',''],['东非共同体','',''],['东非大地堑','',''],['东非大裂谷','',''],['东面','',''],['东风','',''],['东风压倒西风','',''],['东风吹马耳','',''],['东风射马耳','',''],['东飘西荡','',''],['东食西宿','',''],['东马','',''],['东魏','',''],['东鳞西爪','',''],['东鳞西瓜','',''],['东鸣西应','',''],['丝一般','',''],['丝丝','',''],['丝丝入扣','',''],['丝丝小雨','',''],['丝儿','',''],['丝光','',''],['丝制品','',''],['丝包线','',''],['丝发之功','',''],['丝工','',''],['丝巾','',''],['丝布','',''],['丝带','',''],['丝弦','',''],['丝恩发怨','',''],['丝料','',''],['丝束','',''],['丝杠','',''],['丝来线去','',''],['丝板','',''],['丝柏','',''],['丝棉','',''],['丝毫','',''],['丝毫不懈','',''],['丝氨酸','',''],['丝状','',''],['丝状物','',''],['丝状虫','',''],['丝球体','',''],['丝瓜','',''],['丝盘虫','',''],['丝稠','',''],['丝竹','',''],['丝竹乐','',''],['丝竹管弦','',''],['丝米','',''],['丝糕','',''],['丝纺','',''],['丝线','',''],['丝织','',''],['丝织品','',''],['丝织物','',''],['丝绒','',''],['丝绣','',''],['丝绦','',''],['丝绳','',''],['丝绵','',''],['丝绵似','',''],['丝绸','',''],['丝绸之路','',''],['丝绸古路','',''],['丝绸织物','',''],['丝缕','',''],['丝网','',''],['丝胶','',''],['丝虫','',''],['丝虫病','',''],['丝袜','',''],['丝质','',''],['丝路','',''],['丝边','',''],['丝锥','',''],['丝雨','',''],['丞相','',''],['丢三落四','',''],['丢下','',''],['丢丑','',''],['丢乌纱帽','',''],['丢了','',''],['丢人','',''],['丢人现眼','',''],['丢光','',''],['丢出','',''],['丢到','',''],['丢到家','',''],['丢卒','',''],['丢卒保车','',''],['丢命','',''],['丢在','',''],['丢失','',''],['丢字','',''],['丢官','',''],['丢尽','',''],['丢开','',''],['丢弃','',''],['丢手','',''],['丢损','',''],['丢掉','',''],['丢掷','',''],['丢放','',''],['丢盔卸甲','',''],['丢盔弃甲','',''],['丢眉丢眼','',''],['丢眉弄色','',''],['丢眼色','',''],['丢脸','',''],['丢轮扯炮','',''],['丢面','',''],['丢面子','',''],['丢饭碗','',''],['丢魂','',''],['丢魂落魄','',''],['丢鸡蛋','',''],['两万','',''],['两三个','',''],['两下','',''],['两下子','',''],['两下里','',''],['两不','',''],['两不找','',''],['两不相欠','',''],['两不误','',''],['两世为人','',''],['两两','',''],['两两三三','',''],['两个','',''],['两个中国','',''],['两个基本点','',''],['两个建设','',''],['两个文明','',''],['两个月','',''],['两义','',''],['两亲','',''],['两人','',''],['两代','',''],['两仪','',''],['两件','',''],['两件式','',''],['两价','',''],['两份','',''],['两伊战争','',''],['两会','',''],['两位','',''],['两例','',''],['两侧','',''],['两侧对称','',''],['两便','',''],['两便士','',''],['两倍','',''],['两党','',''],['两党关系','',''],['两党制','',''],['两全','',''],['两全其美','',''],['两公婆','',''],['两军','',''],['两分','',''],['两分法','',''],['两分钟','',''],['两则','',''],['两利','',''],['两制','',''],['两匹','',''],['两千','',''],['两千年','',''],['两半','',''],['两厢','',''],['两厢情愿','',''],['两叉','',''],['两口','',''],['两口子','',''],['两句','',''],['两只','',''],['两可','',''],['两台','',''],['两叶掩目','',''],['两名','',''],['两向','',''],['两周','',''],['两唇','',''],['两唇形','',''],['两回','',''],['两回事','',''],['两国','',''],['两国之间','',''],['两国人民','',''],['两国关系','',''],['两国间','',''],['两圈','',''],['两地','',''],['两场','',''],['两块','',''],['两声','',''],['两大','',''],['两大党','',''],['两大阵营','',''],['两天','',''],['两头','',''],['两头儿','',''],['两头白面','',''],['两套','',''],['两姨','',''],['两姨亲','',''],['两字','',''],['两宋','',''],['两宋时代','',''],['两审终审制','',''],['两家','',''],['两小无猜','',''],['两层','',''],['两岁','',''],['两岸','',''],['两岸三地','',''],['两岸对话','',''],['两州','',''],['两年','',''],['两广','',''],['两广总督','',''],['两座','',''],['两张','',''],['两强相斗','',''],['两径间','',''],['两得','',''],['两德','',''],['两性','',''],['两性人','',''],['两性动物','',''],['两性化合物','',''],['两性差距','',''],['两性平等','',''],['两性异形','',''],['两性生殖','',''],['两性花','',''],['两情两愿','',''],['两手','',''],['两手空空','',''],['两抵','',''],['两指','',''],['两排','',''],['两支','',''],['两断','',''],['两方','',''],['两方面','',''],['两旁','',''],['两日','',''],['两星期','',''],['两晋','',''],['两晋时代','',''],['两曹','',''],['两月','',''],['两本','',''],['两权分离','',''],['两条','',''],['两条腿走路','',''],['两条路线','',''],['两条道路','',''],['两极','',''],['两极分化','',''],['两极性','',''],['两栖','',''],['两栖作战','',''],['两栖动物','',''],['两栖类','',''],['两栖进攻','',''],['两样','',''],['两样东西','',''],['两根','',''],['两次','',''],['两次三番','',''],['两次熟','',''],['两步','',''],['两歧','',''],['两毛','',''],['两汉','',''],['两江','',''],['两江道','',''],['两河','',''],['两河文明','',''],['两河流域','',''],['两淮','',''],['两清','',''],['两湖','',''],['两点','',''],['两点水','',''],['两点论','',''],['两班','',''],['两瓶','',''],['两生类','',''],['两用','',''],['两用人才','',''],['两用衫','',''],['两相','',''],['两相情愿','',''],['两省','',''],['两眼','',''],['两眼发黑','',''],['两着儿','',''],['两睡','',''],['两瞽相扶','',''],['两码','',''],['两码事','',''],['两种','',''],['两种制度','',''],['两秒','',''],['两税法','',''],['两立','',''],['两端','',''],['两笔','',''],['两类','',''],['两级','',''],['两线','',''],['两维','',''],['两羽状','',''],['两翼','',''],['两者','',''],['两者之间','',''],['两者都','',''],['两耳','',''],['两耳不闻窗外事','',''],['两肋','',''],['两肋插刀','',''],['两股','',''],['两脚','',''],['两脚台','',''],['两脚规','',''],['两腿','',''],['两臂','',''],['两色','',''],['两节棍','',''],['两虎共斗','',''],['两虎相争','',''],['两虎相斗','',''],['两行','',''],['两袖','',''],['两袖清风','',''],['两角','',''],['两讫','',''],['两豆塞耳','',''],['两败','',''],['两败俱伤','',''],['两起','',''],['两足','',''],['两路','',''],['两车','',''],['两轮','',''],['两辆','',''],['两边','',''],['两边倒','',''],['两迄','',''],['两造','',''],['两部','',''],['两部分','',''],['两重','',''],['两重性','',''],['两键','',''],['两间','',''],['两院','',''],['两院制','',''],['两难','',''],['两霸','',''],['两面','',''],['两面三刀','',''],['两面光','',''],['两面凸','',''],['两面凹','',''],['两面性','',''],['两面派','',''],['两项','',''],['两颊','',''],['两颊生津','',''],['两颗','',''],['两鬓','',''],['两鼠斗穴','',''],['严严实实','',''],['严了眼儿','',''],['严于','',''],['严于律己','',''],['严令','',''],['严以律己','',''],['严以责己宽以待人','',''],['严修','',''],['严冬','',''],['严刑','',''],['严刑峻法','',''],['严办','',''],['严加','',''],['严加惩处','',''],['严加申饬','',''],['严医','',''],['严厉','',''],['严厉打击','',''],['严厉批评','',''],['严命','',''],['严处','',''],['严复','',''],['严守','',''],['严守纪律','',''],['严实','',''],['严密','',''],['严寒','',''],['严寒期','',''],['严岛','',''],['严岛神社','',''],['严峻','',''],['严峻考验','',''],['严师','',''],['严惩','',''],['严惩不怠','',''],['严惩不贷','',''],['严慈','',''],['严打','',''],['严把','',''],['严拒','',''],['严整','',''],['严斥','',''],['严明','',''],['严查','',''],['严格','',''],['严格地','',''],['严格按照','',''],['严格控制','',''],['严格来讲','',''],['严格来说','',''],['严格管理','',''],['严格纪律','',''],['严格要求','',''],['严格遵守','',''],['严格隔离','',''],['严正','',''],['严治','',''],['严父','',''],['严禁','',''],['严竣','',''],['严策','',''],['严管','',''],['严紧','',''],['严罚','',''],['严而律己','',''],['严肃','',''],['严肃处理','',''],['严肃性','',''],['严肃查处','',''],['严肃认真','',''],['严苛','',''],['严词','',''],['严词拒绝','',''],['严谨','',''],['严责','',''],['严辞','',''],['严酷','',''],['严酷性','',''],['严重','',''],['严重关切','',''],['严重危害','',''],['严重后果','',''],['严重影响','',''],['严重性','',''],['严重破坏','',''],['严重问题','',''],['严防','',''],['严阵以待','',''],['严霜','',''],['严饬','',''],['丧乱','',''],['丧事','',''],['丧于非命','',''],['丧亡','',''],['丧亲','',''],['丧仪','',''],['丧假','',''],['丧偶','',''],['丧命','',''],['丧天害理','',''],['丧失','',''],['丧失了','',''],['丧失殆尽','',''],['丧失者','',''],['丧妻','',''],['丧子','',''],['丧家','',''],['丧家之犬','',''],['丧家之狗','',''],['丧尸','',''],['丧尽','',''],['丧尽天良','',''],['丧德','',''],['丧心','',''],['丧心病狂','',''],['丧志','',''],['丧明之痛','',''],['丧曲','',''],['丧服','',''],['丧期','',''],['丧权','',''],['丧权辱国','',''],['丧梆','',''],['丧棒','',''],['丧气','',''],['丧气话','',''],['丧气鬼','',''],['丧父','',''],['丧生','',''],['丧礼','',''],['丧胆','',''],['丧胆亡魂','',''],['丧胆销魂','',''],['丧荒','',''],['丧葬','',''],['丧葬费','',''],['丧身','',''],['丧钟','',''],['丧钟声','',''],['丧门星','',''],['丧门神','',''],['丧魂','',''],['丧魂失魄','',''],['丧魂落魄','',''],['个个','',''],['个中','',''],['个中人','',''],['个人','',''],['个人主义','',''],['个人伤害','',''],['个人储蓄','',''],['个人崇拜','',''],['个人意见','',''],['个人数字助理','',''],['个人电脑','',''],['个人英雄主义','',''],['个人赛','',''],['个人问题','',''],['个人防护装备','',''],['个人隐私','',''],['个位','',''],['个体','',''],['个体化','',''],['个体户','',''],['个体所有制','',''],['个体手工业','',''],['个体经济','',''],['个例','',''],['个儿','',''],['个别','',''],['个别人','',''],['个别谈话','',''],['个大','',''],['个头','',''],['个头儿','',''],['个子','',''],['个子矮','',''],['个展','',''],['个性','',''],['个性化','',''],['个把','',''],['个数','',''],['个月','',''],['个样','',''],['个案','',''],['个梦','',''],['个股','',''],['丫头','',''],['丫巴儿','',''],['丫挺','',''],['丫杈','',''],['丫环','',''],['丫髻','',''],['丫鬟','',''],['中上','',''],['中上层','',''],['中上游','',''],['中上等','',''],['中下','',''],['中下旬','',''],['中下游','',''],['中不溜儿','',''],['中专','',''],['中世纪','',''],['中东','',''],['中东战争','',''],['中东社','',''],['中东问题','',''],['中为','',''],['中举','',''],['中乐透','',''],['中了','',''],['中云','',''],['中亚','',''],['中亚国家','',''],['中亚地区','',''],['中亚细亚','',''],['中亚草原','',''],['中产','',''],['中产阶级','',''],['中人','',''],['中介','',''],['中介人','',''],['中介所','',''],['中企业','',''],['中伏','',''],['中休','',''],['中会','',''],['中伤','',''],['中伤者','',''],['中位数','',''],['中低产田','',''],['中低档','',''],['中低端','',''],['中住','',''],['中俄','',''],['中俄伊犁条约','',''],['中俄关系','',''],['中俄北京条约','',''],['中俄尼布楚条约','',''],['中俄布连斯奇界约','',''],['中俄恰克图界约','',''],['中俄改订条约','',''],['中俄瑷珲条约','',''],['中俄边界协议','',''],['中保','',''],['中值定理','',''],['中允','',''],['中元','',''],['中元普渡','',''],['中元节','',''],['中共','',''],['中共中央','',''],['中共中央宣传部','',''],['中共中央总书记','',''],['中共中央纪委监察部','',''],['中共中央纪律检查委员会','',''],['中共九大','',''],['中共党员','',''],['中兴','',''],['中兴新村','',''],['中写','',''],['中军','',''],['中农','',''],['中切','',''],['中刊','',''],['中前卫','',''],['中北大学','',''],['中北部','',''],['中区','',''],['中医','',''],['中医学','',''],['中医师','',''],['中医药','',''],['中医院','',''],['中华书局','',''],['中华儿女','',''],['中华全国体育总会','',''],['中华全国妇女联合会','',''],['中华台北','',''],['中华字海','',''],['中华学生爱国民主同盟','',''],['中华民族','',''],['中华民族解放先锋队','',''],['中华电视','',''],['中华航空公司','',''],['中华苏维埃共和国','',''],['中南','',''],['中南半岛','',''],['中南海','',''],['中南部','',''],['中印','',''],['中印半岛','',''],['中厅','',''],['中压管','',''],['中原','',''],['中原地区','',''],['中原大学','',''],['中原板荡','',''],['中原逐鹿','',''],['中去','',''],['中古','',''],['中古汉语','',''],['中台','',''],['中叶','',''],['中名','',''],['中含有','',''],['中听','',''],['中和','',''],['中和作用','',''],['中和剂','',''],['中和力','',''],['中和市','',''],['中国区','',''],['中国专利局','',''],['中国东方航空','',''],['中国中央电视台','',''],['中国中心主义','',''],['中国之最','',''],['中国书店','',''],['中国交通建设','',''],['中国交通运输协会','',''],['中国产','',''],['中国人','',''],['中国人大','',''],['中国人权民运信息中心','',''],['中国人权组织','',''],['中国人民大学','',''],['中国人民对外友好协会','',''],['中国人民志愿军','',''],['中国人民政治协商会议','',''],['中国人民武装警察部队','',''],['中国人民解放军','',''],['中国人民解放军海军','',''],['中国人民解放军空军','',''],['中国人民银行','',''],['中国伊斯兰教协会','',''],['中国传媒大学','',''],['中国作协','',''],['中国作家协会','',''],['中国保险监督管理委员会','',''],['中国光大银行','',''],['中国共产主义青年团','',''],['中国共产党','',''],['中国共产党中央委员会','',''],['中国共产党中央委员会宣传部','',''],['中国军队','',''],['中国农业银行','',''],['中国制造','',''],['中国剩余定理','',''],['中国化','',''],['中国北方工业公司','',''],['中国医学','',''],['中国历史','',''],['中国历史博物馆','',''],['中国古代四大美女','',''],['中国史','',''],['中国同盟会','',''],['中国国家博物馆','',''],['中国国家原子能机构','',''],['中国国家地震局','',''],['中国国家环保局','',''],['中国国家环境保护总局','',''],['中国国家航天局','',''],['中国国家船舶公司','',''],['中国国民党','',''],['中国国民党革命委员会','',''],['中国国防科技信息中心','',''],['中国国际信托投资公司','',''],['中国国际广播电台','',''],['中国国际航空公司','',''],['中国国际贸易促进委员会','',''],['中国地球物理学会','',''],['中国地质大学','',''],['中国地质调查局','',''],['中国地震台','',''],['中国地震局','',''],['中国城','',''],['中国大百科全书出版社','',''],['中国大蝾螈','',''],['中国天主教爱国会','',''],['中国妇女','',''],['中国字','',''],['中国学','',''],['中国对外援助八项原则','',''],['中国小说史略','',''],['中国少年先锋队','',''],['中国工农红军','',''],['中国工商银行','',''],['中国工程院','',''],['中国左翼作家联盟','',''],['中国广播公司','',''],['中国建设银行','',''],['中国式','',''],['中国战区','',''],['中国政府','',''],['中国政法大学','',''],['中国教育和科研计算机网','',''],['中国教育网','',''],['中国文化','',''],['中国文学','',''],['中国文学艺术界联合会','',''],['中国文联','',''],['中国新民党','',''],['中国新闻社','',''],['中国新闻网','',''],['中国无线电频谱管理和监测','',''],['中国日报','',''],['中国时报','',''],['中国核能总公司','',''],['中国残疾人联合会','',''],['中国残联','',''],['中国民主促进会','',''],['中国民主同盟','',''],['中国民主建国会','',''],['中国民用航空局','',''],['中国民航','',''],['中国气象局','',''],['中国法学会','',''],['中国海','',''],['中国海事局','',''],['中国海洋石油总公司','',''],['中国消费者协会','',''],['中国游艺机游乐园协会','',''],['中国热','',''],['中国特色','',''],['中国特色的','',''],['中国特色社会主义','',''],['中国电信','',''],['中国电视公司','',''],['中国画','',''],['中国石化','',''],['中国石油化工股份有限公司','',''],['中国石油和化学工业协会','',''],['中国石油天然气集团公司','',''],['中国社会科学院','',''],['中国科协','',''],['中国科学院','',''],['中国移动通信','',''],['中国精密机械进出口公司','',''],['中国红十字会','',''],['中国经营报','',''],['中国网','',''],['中国美术馆','',''],['中国联通','',''],['中国致公党','',''],['中国航天工业公司','',''],['中国航天技术进出口公司','',''],['中国航海日','',''],['中国航空工业公司','',''],['中国航空运输协会','',''],['中国船舶贸易公司','',''],['中国船舶重工集团公司','',''],['中国菜','',''],['中国西北边陲','',''],['中国证券报','',''],['中国证券监督管理委员会','',''],['中国证监会','',''],['中国话','',''],['中国边界','',''],['中国进出口银行','',''],['中国通','',''],['中国邮政','',''],['中国银联','',''],['中国银行业监督管理委员会','',''],['中国长城工业公司','',''],['中国队','',''],['中国青年','',''],['中国青年报','',''],['中国革命','',''],['中国餐馆症候群','',''],['中圈套','',''],['中土','',''],['中场','',''],['中坚','',''],['中坚力量','',''],['中坜','',''],['中坜市','',''],['中垂线','',''],['中型','',''],['中型机','',''],['中埔','',''],['中埔乡','',''],['中堂','',''],['中士','',''],['中声','',''],['中复电讯','',''],['中外','',''],['中外合资','',''],['中外合资企业','',''],['中外合资经营企业','',''],['中外比','',''],['中外观众','',''],['中外记者','',''],['中大西洋脊','',''],['中天','',''],['中央','',''],['中央专制集权','',''],['中央书记处','',''],['中央人民广播电台','',''],['中央全会','',''],['中央军','',''],['中央军事委员会','',''],['中央军委','',''],['中央凹','',''],['中央分车带','',''],['中央办公厅','',''],['中央各部委','',''],['中央处理机','',''],['中央委员','',''],['中央委员会','',''],['中央宣传部','',''],['中央广播电台','',''],['中央情报局','',''],['中央戏剧学院','',''],['中央执行委员会','',''],['中央政府','',''],['中央政治局','',''],['中央政治局委员','',''],['中央政治局常委','',''],['中央文件','',''],['中央日报','',''],['中央民族大学','',''],['中央汇金','',''],['中央海岭','',''],['中央直辖市','',''],['中央省','',''],['中央研究院','',''],['中央社','',''],['中央财经大学','',''],['中央邦','',''],['中央部','',''],['中央集权','',''],['中央音乐学院','',''],['中头','',''],['中奖','',''],['中子','',''],['中子俘获','',''],['中子射线摄影','',''],['中子弹','',''],['中子态','',''],['中子数','',''],['中子星','',''],['中子源','',''],['中学','',''],['中学教师','',''],['中学生','',''],['中宣部','',''],['中寮','',''],['中寮乡','',''],['中导','',''],['中将','',''],['中尉','',''],['中小','',''],['中小企业','',''],['中小型','',''],['中小型企业','',''],['中小城市','',''],['中小学','',''],['中小学校','',''],['中小学生','',''],['中就','',''],['中局','',''],['中层','',''],['中层楼','',''],['中山公园','',''],['中山大学','',''],['中山成彬','',''],['中山服','',''],['中山狼','',''],['中山狼传','',''],['中山舰事件','',''],['中山装','',''],['中山陵','',''],['中岛','',''],['中岳','',''],['中州','',''],['中州韵','',''],['中巴','',''],['中巴关系','',''],['中巴士','',''],['中师','',''],['中帮','',''],['中常','',''],['中幡','',''],['中干','',''],['中年','',''],['中年人','',''],['中度','',''],['中度性肺水肿','',''],['中庭','',''],['中庸','',''],['中庸之道','',''],['中式','',''],['中式盐','',''],['中式英语','',''],['中弹','',''],['中彩','',''],['中径','',''],['中微子','',''],['中德','',''],['中德诊所','',''],['中心','',''],['中心体','',''],['中心内容','',''],['中心区','',''],['中心埋置关系从句','',''],['中心对称','',''],['中心店','',''],['中心思想','',''],['中心点','',''],['中心环节','',''],['中心矩','',''],['中心粒','',''],['中心角','',''],['中心词','',''],['中心语','',''],['中性','',''],['中性盐','',''],['中性粒细胞','',''],['中情局','',''],['中意','',''],['中戏','',''],['中成药','',''],['中技','',''],['中抠','',''],['中拇指','',''],['中招','',''],['中括号','',''],['中拮','',''],['中指','',''],['中控面板','',''],['中提琴','',''],['中提琴手','',''],['中文之星','',''],['中文信息','',''],['中文分词','',''],['中文名','',''],['中文网','',''],['中文学院','',''],['中文标准交换码','',''],['中文版','',''],['中文电脑','',''],['中文窗','',''],['中文系','',''],['中语系','',''],['中断','',''],['中断器','',''],['中断站','',''],['中新世','',''],['中新社','',''],['中新网','',''],['中旅社','',''],['中日','',''],['中日关系','',''],['中日韩','',''],['中日韩统一表意文字','',''],['中日韩越','',''],['中旬','',''],['中景','',''],['中暑','',''],['中服','',''],['中朝','',''],['中期','',''],['中村','',''],['中板','',''],['中果皮','',''],['中枢','',''],['中枢神经','',''],['中枢神经系统','',''],['中枪','',''],['中标','',''],['中栏','',''],['中校','',''],['中档','',''],['中欧','',''],['中止','',''],['中正','',''],['中正区','',''],['中正纪念堂','',''],['中段','',''],['中殿','',''],['中毒','',''],['中毒性','',''],['中毒性肝炎','',''],['中毒途径','',''],['中毒酶','',''],['中气','',''],['中气层','',''],['中气层顶','',''],['中水期','',''],['中沙群岛','',''],['中油','',''],['中法','',''],['中法战争','',''],['中法新约','',''],['中波','',''],['中洋脊','',''],['中派主义','',''],['中流','',''],['中流击楫','',''],['中流砥柱','',''],['中海','',''],['中海油','',''],['中港','',''],['中港台','',''],['中游','',''],['中源地震','',''],['中澳','',''],['中灶','',''],['中点','',''],['中焦','',''],['中爪哇','',''],['中环','',''],['中班','',''],['中生代','',''],['中生界','',''],['中用','',''],['中田英寿','',''],['中甸','',''],['中甸县','',''],['中盘','',''],['中直','',''],['中直机关','',''],['中看','',''],['中看不中用','',''],['中短债','',''],['中短波','',''],['中石化','',''],['中石器时代','',''],['中石油川东钻探公司','',''],['中研院','',''],['中碳钢','',''],['中科院','',''],['中程','',''],['中程导弹','',''],['中稻','',''],['中空','',''],['中空玻璃','',''],['中立','',''],['中立不倚','',''],['中立主义','',''],['中立化','',''],['中立国','',''],['中立国家','',''],['中立性','',''],['中立政策','',''],['中立派','',''],['中站','',''],['中等','',''],['中等专业学校','',''],['中等专业教育','',''],['中等城市','',''],['中等师范学校','',''],['中等技术学校','',''],['中等教育','',''],['中等普通教育','',''],['中等水平','',''],['中筋面粉','',''],['中策','',''],['中签','',''],['中箭落马','',''],['中篇','',''],['中篇小说','',''],['中级','',''],['中级品','',''],['中级法院','',''],['中纪','',''],['中纪委','',''],['中纬度','',''],['中线','',''],['中组部','',''],['中经','',''],['中统','',''],['中继','',''],['中继器','',''],['中继站','',''],['中继线','',''],['中缀','',''],['中缝','',''],['中网','',''],['中美','',''],['中美关系','',''],['中美文化研究中心','',''],['中美洲','',''],['中老年','',''],['中老年人','',''],['中耕','',''],['中耕机','',''],['中耳','',''],['中耳炎','',''],['中联部','',''],['中肯','',''],['中胚层','',''],['中脉','',''],['中脊','',''],['中脑','',''],['中脘穴','',''],['中腹部','',''],['中苏','',''],['中苏关系','',''],['中苏解决悬案大纲协定','',''],['中英','',''],['中英对照','',''],['中英文对照','',''],['中草药','',''],['中药','',''],['中药材','',''],['中落','',''],['中行','',''],['中表','',''],['中装','',''],['中西','',''],['中西医','',''],['中西医结合','',''],['中西合并','',''],['中西合璧','',''],['中西文','',''],['中西部','',''],['中规中矩','',''],['中视','',''],['中计','',''],['中词','',''],['中财','',''],['中资','',''],['中越','',''],['中越战争','',''],['中距离','',''],['中路','',''],['中路梆子','',''],['中转','',''],['中转柜台','',''],['中转站','',''],['中轴','',''],['中轴线','',''],['中辍','',''],['中辣','',''],['中进','',''],['中远','',''],['中远太平洋','',''],['中远太平洋有限公司','',''],['中远集团','',''],['中远香港集团','',''],['中选','',''],['中途','',''],['中途岛','',''],['中途岛战役','',''],['中途搁浅','',''],['中途而废','',''],['中途退场','',''],['中道','',''],['中道而废','',''],['中邪','',''],['中部','',''],['中都','',''],['中醒','',''],['中量级','',''],['中银','',''],['中锋','',''],['中长','',''],['中长期','',''],['中长跑','',''],['中长铁路','',''],['中间','',''],['中间人','',''],['中间件','',''],['中间儿','',''],['中间名','',''],['中间商','',''],['中间圈','',''],['中间层','',''],['中间派','',''],['中间物','',''],['中间环节','',''],['中间神经元','',''],['中间纤维','',''],['中间级','',''],['中间线','',''],['中间色','',''],['中间语','',''],['中间路线','',''],['中间阶级','',''],['中队','',''],['中阮','',''],['中阶层','',''],['中院','',''],['中隔','',''],['中雨','',''],['中青','',''],['中青年','',''],['中韩','',''],['中音','',''],['中页','',''],['中项','',''],['中顾委','',''],['中频','',''],['中风','',''],['中餐','',''],['中餐馆','',''],['中饭','',''],['中饱','',''],['中饱私囊','',''],['中馈','',''],['中馈乏人','',''],['中高度防空','',''],['中高档','',''],['中高级','',''],['中高音','',''],['中魔','',''],['丰为圭臬','',''],['丰产','',''],['丰产田','',''],['丰亨豫大','',''],['丰俭由人','',''],['丰功','',''],['丰功伟业','',''],['丰功伟绩','',''],['丰功厚利','',''],['丰功懋烈','',''],['丰功盛烈','',''],['丰南','',''],['丰厚','',''],['丰取刻与','',''],['丰台','',''],['丰姿','',''],['丰姿冶丽','',''],['丰姿绰约','',''],['丰宁','',''],['丰宁县','',''],['丰容靓饰','',''],['丰富','',''],['丰富多彩','',''],['丰富多采','',''],['丰年','',''],['丰年稔岁','',''],['丰度','',''],['丰收','',''],['丰收在望','',''],['丰收年','',''],['丰标不凡','',''],['丰水','',''],['丰汇','',''],['丰沛','',''],['丰泰','',''],['丰泽','',''],['丰润','',''],['丰溪','',''],['丰溪里','',''],['丰满','',''],['丰滨','',''],['丰滨乡','',''],['丰田','',''],['丰登','',''],['丰盈','',''],['丰盛','',''],['丰硕','',''],['丰硕成果','',''],['丰碑','',''],['丰美','',''],['丰腴','',''],['丰臣秀吉','',''],['丰茂','',''],['丰衣','',''],['丰衣足食','',''],['丰裕','',''],['丰议','',''],['丰赡','',''],['丰足','',''],['丰采','',''],['丰韵','',''],['丰餐','',''],['丰饶','',''],['串串','',''],['串亲戚','',''],['串亲访友','',''],['串供','',''],['串列','',''],['串口','',''],['串号','',''],['串在','',''],['串处理','',''],['串岗','',''],['串并联','',''],['串戏','',''],['串成','',''],['串扰','',''],['串换','',''],['串气','',''],['串流','',''],['串游','',''],['串演','',''],['串烧','',''],['串珠','',''],['串用','',''],['串秧儿','',''],['串筒','',''],['串线','',''],['串联','',''],['串花','',''],['串行','',''],['串行口','',''],['串行点阵打印机','',''],['串讲','',''],['串话','',''],['串谋','',''],['串起','',''],['串连','',''],['串通','',''],['串通一气','',''],['串铃','',''],['串门','',''],['串门儿','',''],['串门子','',''],['串音','',''],['临下','',''],['临为','',''],['临了','',''],['临事而惧','',''],['临亡','',''],['临产','',''],['临写','',''],['临军对垒','',''],['临军对阵','',''],['临刑','',''],['临别','',''],['临别赠言','',''],['临到','',''],['临危','',''],['临危下石','',''],['临危不惧','',''],['临危不挠','',''],['临危不顾','',''],['临危履冰','',''],['临危授命','',''],['临危效命','',''],['临危自悔','',''],['临危自省','',''],['临危自计','',''],['临危致命','',''],['临去','',''],['临去秋波','',''],['临周','',''],['临噎掘井','',''],['临场','',''],['临场经验','',''],['临夏州','',''],['临头','',''],['临安县','',''],['临屯郡','',''],['临崖勒马','',''],['临川','',''],['临川羡鱼','',''],['临帖','',''],['临床','',''],['临床医学','',''],['临床特征','',''],['临床试验','',''],['临战','',''],['临战状态','',''],['临接','',''],['临摹','',''],['临敌卖阵','',''],['临文不讳','',''],['临时','',''],['临时代办','',''],['临时分居','',''],['临时动议','',''],['临时工','',''],['临时性','',''],['临时抱佛脚','',''],['临时政府','',''],['临时澳门市政执行委员会','',''],['临时的本地管理接口','',''],['临时贷款','',''],['临月','',''],['临月儿','',''],['临朝','',''],['临期失误','',''],['临机','',''],['临机制变','',''],['临机制胜','',''],['临机应变','',''],['临村','',''],['临检','',''],['临死','',''],['临死不怯','',''],['临死不恐','',''],['临死不惧','',''],['临死前','',''],['临水','',''],['临水登山','',''],['临池','',''],['临汾地区','',''],['临沂地区','',''],['临沧地区','',''],['临河','',''],['临河羡鱼','',''],['临海县','',''],['临海水土志','',''],['临淄','',''],['临深履冰','',''],['临深履薄','',''],['临渊结网','',''],['临渊羡鱼','',''],['临渭','',''],['临渴掘井','',''],['临渴穿井','',''],['临潼','',''],['临潼斗宝','',''],['临界','',''],['临界体积','',''],['临界值','',''],['临界压','',''],['临界温度','',''],['临界点','',''],['临界状态','',''],['临界角','',''],['临界质量','',''],['临盆','',''],['临眺','',''],['临睡','',''],['临终','',''],['临翔','',''],['临老','',''],['临蓐','',''],['临行','',''],['临街','',''],['临街房','',''],['临视','',''],['临财不苟','',''],['临财苟得','',''],['临走','',''],['临近','',''],['临门','',''],['临问','',''],['临阵','',''],['临阵磨枪','',''],['临阵脱逃','',''],['临阵退缩','',''],['临难','',''],['临难不屈','',''],['临难不恐','',''],['临难不惧','',''],['临难不慑','',''],['临难不避','',''],['临难铸兵','',''],['临风','',''],['临风对月','',''],['临食废箸','',''],['临魁','',''],['丸剂','',''],['丸子','',''],['丸药','',''],['丸药盒','',''],['丹书铁券','',''],['丹书铁契','',''],['丹佛','',''],['丹佛市','',''],['丹凤眼','',''],['丹参','',''],['丹墀','',''],['丹尼','',''],['丹尼尔','',''],['丹尼斯','',''],['丹布朗','',''],['丹徒','',''],['丹心','',''],['丹心碧血','',''],['丹方','',''],['丹桂','',''],['丹楹刻桷','',''],['丹毒','',''],['丹江','',''],['丹沙','',''],['丹瑞','',''],['丹瑞大将','',''],['丹瑞将军','',''],['丹田','',''],['丹皮','',''],['丹砂','',''],['丹衷','',''],['丹霞','',''],['丹霞地貌','',''],['丹霞山','',''],['丹青','',''],['丹顶鹤','',''],['丹魄','',''],['丹麦人','',''],['丹麦包','',''],['丹麦语','',''],['为上','',''],['为丛驱雀','',''],['为主','',''],['为之一振','',''],['为乐','',''],['为了','',''],['为人','',''],['为人为彻','',''],['为人作嫁','',''],['为人处事','',''],['为人师表','',''],['为人所知','',''],['为人正直','',''],['为人民','',''],['为人民服务','',''],['为什么','',''],['为仁不富','',''],['为从','',''],['为他','',''],['为伍','',''],['为何','',''],['为你','',''],['为佳','',''],['为使','',''],['为例','',''],['为依据','',''],['为信','',''],['为公','',''],['为典型','',''],['为准','',''],['为利','',''],['为副','',''],['为力','',''],['为区别','',''],['为受','',''],['为名','',''],['为啥','',''],['为善','',''],['为善最乐','',''],['为国','',''],['为国为民','',''],['为国为蜮','',''],['为国争光','',''],['为国出力','',''],['为国捐躯','',''],['为奴','',''],['为好成歉','',''],['为妻','',''],['为安','',''],['为官','',''],['为宜','',''],['为害','',''],['为害最烈','',''],['为富不仁','',''],['为差','',''],['为己','',''],['为师','',''],['为序','',''],['为度','',''],['为德不卒','',''],['为德不终','',''],['为怀','',''],['为恶不悛','',''],['为患','',''],['为您','',''],['为慎重起见','',''],['为成','',''],['为我','',''],['为我之物','',''],['为我所用','',''],['为所','',''],['为所欲为','',''],['为把','',''],['为政','',''],['为政清廉','',''],['为敌','',''],['为数','',''],['为数不多','',''],['为数不少','',''],['为整','',''],['为方便用户','',''],['为时','',''],['为时不晚','',''],['为时尚早','',''],['为时已晚','',''],['为时未晚','',''],['为时过早','',''],['为是','',''],['为有','',''],['为期','',''],['为期不远','',''],['为本','',''],['为止','',''],['为此','',''],['为民','',''],['为民请命','',''],['为民除害','',''],['为求','',''],['为法自弊','',''],['为渊驱鱼','',''],['为渊驱鱼为丛驱雀','',''],['为特征','',''],['为王','',''],['为甚么','',''],['为生','',''],['为由','',''],['为界','',''],['为的','',''],['为的是','',''],['为盼','',''],['为真','',''],['为真理而斗争','',''],['为着','',''],['为私','',''],['为继','',''],['为群众服务','',''],['为能','',''],['为臣死忠为子死孝','',''],['为荣','',''],['为营','',''],['为虎作伥','',''],['为虎傅翼','',''],['为虎添翼','',''],['为虺弗摧为蛇若何','',''],['为蛇添足','',''],['为蛇画足','',''],['为裘为箕','',''],['为要','',''],['为证','',''],['为辅','',''],['为避免','',''],['为重','',''],['为限','',''],['为难','',''],['为零','',''],['为非作歹','',''],['为题','',''],['为首','',''],['为高','',''],['主不先客','',''],['主业','',''],['主义','',''],['主事','',''],['主人','',''],['主人公','',''],['主人翁','',''],['主人翁精神','',''],['主仆','',''],['主从','',''],['主件','',''],['主任','',''],['主任医生','',''],['主任委员','',''],['主伐','',''],['主体','',''],['主使','',''],['主供','',''],['主修','',''],['主光轴','',''],['主公','',''],['主凶','',''],['主刑','',''],['主列','',''],['主制','',''],['主力','',''],['主力军','',''],['主力舰','',''],['主力部队','',''],['主办','',''],['主办人','',''],['主办单位','',''],['主办国','',''],['主办权','',''],['主办者','',''],['主办方','',''],['主动','',''],['主动免疫','',''],['主动性','',''],['主动权','',''],['主动精神','',''],['主动脉','',''],['主动脉弓','',''],['主动轮','',''],['主动轴','',''],['主单位','',''],['主厅','',''],['主厨','',''],['主发条','',''],['主名','',''],['主和','',''],['主和弦','',''],['主和派','',''],['主哪','',''],['主唱','',''],['主唱者','',''],['主啊','',''],['主因','',''],['主场','',''],['主妇','',''],['主妇们','',''],['主妇似','',''],['主委','',''],['主婚','',''],['主嫌','',''],['主子','',''],['主审','',''],['主客','',''],['主客观','',''],['主宰','',''],['主宰者','',''],['主宾','',''],['主宾谓','',''],['主导','',''],['主导作用','',''],['主导地位','',''],['主导性','',''],['主导权','',''],['主导者','',''],['主将','',''],['主岭','',''],['主峰','',''],['主币','',''],['主帅','',''],['主席','',''],['主席令','',''],['主席台','',''],['主席团','',''],['主席国','',''],['主干','',''],['主干形','',''],['主干线','',''],['主干网络','',''],['主干网路','',''],['主序星','',''],['主张','',''],['主心骨','',''],['主忧臣辱','',''],['主意','',''],['主战','',''],['主战派','',''],['主战论','',''],['主打品牌','',''],['主承销商','',''],['主持','',''],['主持人','',''],['主持会议','',''],['主持正义','',''],['主掌','',''],['主控','',''],['主控台','',''],['主播','',''],['主攻','',''],['主攻手','',''],['主政','',''],['主教','',''],['主教练','',''],['主敬存诚','',''],['主文','',''],['主料','',''],['主旋律','',''],['主族','',''],['主族元素','',''],['主日','',''],['主日学','',''],['主旨','',''],['主星','',''],['主显','',''],['主显节','',''],['主机','',''],['主机名','',''],['主机板','',''],['主权','',''],['主权国','',''],['主权国家','',''],['主材','',''],['主板','',''],['主枝','',''],['主根','',''],['主格','',''],['主楼','',''],['主次','',''],['主治','',''],['主治医师','',''],['主治医生','',''],['主法向量','',''],['主流','',''],['主流产品','',''],['主演','',''],['主焦点','',''],['主焦煤','',''],['主父','',''],['主牧师','',''],['主犯','',''],['主环','',''],['主球','',''],['主理','',''],['主祭','',''],['主祷文','',''],['主科','',''],['主稿','',''],['主笔','',''],['主管','',''],['主管人','',''],['主管人员','',''],['主管教区','',''],['主管机关','',''],['主管部门','',''],['主簿','',''],['主粮','',''],['主线','',''],['主组','',''],['主编','',''],['主罚','',''],['主群','',''],['主群组','',''],['主考','',''],['主考人','',''],['主考者','',''],['主脑','',''],['主航道','',''],['主菜','',''],['主街','',''],['主表','',''],['主要','',''],['主打','',''],['主要人员','',''],['主要原因','',''],['主要矛盾','',''],['主见','',''],['主观','',''],['主观主义','',''],['主观化','',''],['主观原因','',''],['主观唯心主义','',''],['主观性','',''],['主观能动性','',''],['主观论','',''],['主观辩证法','',''],['主视图','',''],['主角','',''],['主计','',''],['主计员','',''],['主计室','',''],['主讲','',''],['主诉','',''],['主词','',''],['主词表','',''],['主试','',''],['主语','',''],['主课','',''],['主调','',''],['主调音','',''],['主调音乐','',''],['主谋','',''],['主谓','',''],['主谓句','',''],['主谓宾','',''],['主谓结构','',''],['主路','',''],['主车群','',''],['主轴','',''],['主轴承','',''],['主辱臣死','',''],['主送','',''],['主道','',''],['主队','',''],['主震','',''],['主音','',''],['主页','',''],['主顾','',''],['主题','',''],['主题思想','',''],['主题标引','',''],['主题歌','',''],['主题法','',''],['主题词','',''],['主食','',''],['主麻','',''],['丽丽','',''],['丽人','',''],['丽佳娜','',''],['丽实','',''],['丽日','',''],['丽水地区','',''],['丽江古城','',''],['丽江地区','',''],['丽江纳西族自治县','',''],['丽池卡登','',''],['丽致','',''],['丽色','',''],['丽词','',''],['丽语','',''],['丽质','',''],['丽辞','',''],['丽都','',''],['丽魄','',''],['举一反三','',''],['举一废百','',''],['举不胜举','',''],['举世','',''],['举世无伦','',''],['举世无双','',''],['举世无比','',''],['举世混浊','',''],['举世瞩目','',''],['举世罕见','',''],['举世莫比','',''],['举世闻名','',''],['举个','',''],['举事','',''],['举人','',''],['举例','',''],['举例发凡','',''],['举例来说','',''],['举例说明','',''],['举借','',''],['举债','',''],['举兵','',''],['举凡','',''],['举出','',''],['举办','',''],['举办者','',''],['举动','',''],['举十知九','',''],['举反证','',''],['举发','',''],['举哀','',''],['举国','',''],['举国上下','',''],['举国欢腾','',''],['举头','',''],['举子','',''],['举家','',''],['举手','',''],['举手之劳','',''],['举手加额','',''],['举手可采','',''],['举手扣额','',''],['举手投足','',''],['举手赞成','',''],['举报','',''],['举报人','',''],['举报信','',''],['举报者','',''],['举措','',''],['举措失当','',''],['举旗','',''],['举杯','',''],['举枪','',''],['举架','',''],['举案齐眉','',''],['举棋','',''],['举棋不定','',''],['举止','',''],['举止不凡','',''],['举止大方','',''],['举止失措','',''],['举步','',''],['举步如飞','',''],['举步生风','',''],['举步维艰','',''],['举步走','',''],['举法','',''],['举火','',''],['举用','',''],['举目','',''],['举目千里','',''],['举目无亲','',''],['举直措枉','',''],['举眼无亲','',''],['举着','',''],['举荐','',''],['举行','',''],['举行仪式','',''],['举行会谈','',''],['举行婚礼','',''],['举要删芜','',''],['举要治繁','',''],['举觞称庆','',''],['举证','',''],['举贤使能','',''],['举贤良对策','',''],['举起','',''],['举足轻重','',''],['举酒','',''],['举酒作乐','',''],['举重','',''],['举重若轻','',''],['举隅法','',''],['举高','',''],['举鼎拔山','',''],['举鼎绝膑','',''],['乃堆拉','',''],['乃堆拉山口','',''],['乃尔','',''],['乃师所存者','',''],['乃心王室','',''],['乃文乃武','',''],['乃是','',''],['乃武乃文','',''],['乃至','',''],['乃见','',''],['乃论','',''],['久久','',''],['久之','',''],['久了','',''],['久仰','',''],['久仰大名','',''],['久候','',''],['久假不归','',''],['久别','',''],['久别重逢','',''],['久前','',''],['久品','',''],['久地','',''],['久坐','',''],['久存','',''],['久安长治','',''],['久已','',''],['久性','',''],['久慕','',''],['久慕盛名','',''],['久拖','',''],['久拖不办','',''],['久拨','',''],['久攻不下','',''],['久旱','',''],['久旱逢甘雨','',''],['久旷','',''],['久梦初醒','',''],['久留','',''],['久病','',''],['久病成医','',''],['久病成良医','',''],['久称','',''],['久等','',''],['久经','',''],['久经沙场','',''],['久经考验','',''],['久经锻炼','',''],['久而久之','',''],['久话','',''],['久负盛名','',''],['久辩','',''],['久远','',''],['久违','',''],['久长','',''],['久闻大名','',''],['久阔','',''],['久陪','',''],['久隔','',''],['么么','',''],['么些','',''],['么样','',''],['义上','',''],['义不取容','',''],['义不容辞','',''],['义不生财','',''],['义不辞难','',''],['义举','',''],['义之所在','',''],['义人','',''],['义仓','',''],['义作','',''],['义兵','',''],['义军','',''],['义冢','',''],['义刑义杀','',''],['义务','',''],['义务上','',''],['义务人','',''],['义务兵','',''],['义务兵役制','',''],['义务劳动','',''],['义务工作者','',''],['义务教育','',''],['义务论','',''],['义勇','',''],['义勇兵','',''],['义勇军','',''],['义勇军进行曲','',''],['义卖','',''],['义卖会','',''],['义县龙','',''],['义和乱','',''],['义和团','',''],['义和团运动','',''],['义和拳','',''],['义地','',''],['义塾','',''],['义士','',''],['义大利','',''],['义夫节妇','',''],['义女','',''],['义子','',''],['义学','',''],['义尽','',''],['义山恩海','',''],['义工','',''],['义师','',''],['义形于色','',''],['义怒','',''],['义愤','',''],['义愤填胸','',''],['义愤填膺','',''],['义战','',''],['义断恩绝','',''],['义方之训','',''],['义旗','',''],['义无反顾','',''],['义无返顾','',''],['义款','',''],['义正词严','',''],['义正辞严','',''],['义母','',''],['义气','',''],['义气相投','',''],['义演','',''],['义父','',''],['义父母','',''],['义理','',''],['义竹','',''],['义竹乡','',''],['义结金兰','',''],['义肢','',''],['义薄','',''],['义行','',''],['义警','',''],['义诊','',''],['义重恩山','',''],['义项','',''],['义齿','',''],['之一','',''],['之七','',''],['之三','',''],['之上','',''],['之下','',''],['之不','',''],['之中','',''],['之为','',''],['之主','',''],['之举','',''],['之久','',''],['之义','',''],['之乎者也','',''],['之九','',''],['之乱','',''],['之争','',''],['之事','',''],['之二','',''],['之五','',''],['之交','',''],['之人','',''],['之以','',''],['之价','',''],['之价值','',''],['之份','',''],['之众','',''],['之位','',''],['之余','',''],['之作','',''],['之侧','',''],['之便','',''],['之值','',''],['之兆','',''],['之先','',''],['之光','',''],['之八','',''],['之八九','',''],['之六','',''],['之兵','',''],['之内','',''],['之冠','',''],['之冤','',''],['之分','',''],['之列','',''],['之初','',''],['之别','',''],['之前','',''],['之功','',''],['之势','',''],['之北','',''],['之十','',''],['之半','',''],['之又','',''],['之友','',''],['之口','',''],['之名','',''],['之后','',''],['之后不久','',''],['之和','',''],['之啥','',''],['之四','',''],['之国','',''],['之在','',''],['之地','',''],['之境','',''],['之墓','',''],['之士','',''],['之声','',''],['之壳','',''],['之处','',''],['之外','',''],['之多','',''],['之夜','',''],['之大','',''],['之夫','',''],['之女','',''],['之妻','',''],['之子','',''],['之字形','',''],['之宝','',''],['之实','',''],['之客','',''],['之家','',''],['之尊','',''],['之小','',''],['之差','',''],['之差是','',''],['之年','',''],['之度','',''],['之徒','',''],['之心','',''],['之志','',''],['之态度','',''],['之恋','',''],['之恩','',''],['之患','',''],['之情','',''],['之意','',''],['之战','',''],['之所以','',''],['之才','',''],['之故','',''],['之数','',''],['之旁','',''],['之旅','',''],['之日','',''],['之日起','',''],['之时','',''],['之明','',''],['之本','',''],['之术','',''],['之极','',''],['之梦','',''],['之欢','',''],['之欲','',''],['之歌','',''],['之死','',''],['之死靡它','',''],['之母','',''],['之比','',''],['之气','',''],['之水','',''],['之河','',''],['之泰','',''],['之流','',''],['之源','',''],['之火','',''],['之灾','',''],['之父','',''],['之物','',''],['之犬','',''],['之王','',''],['之理','',''],['之用','',''],['之由','',''],['之痛','',''],['之百','',''],['之短','',''],['之神','',''],['之禄','',''],['之福','',''],['之秋','',''],['之类','',''],['之罪','',''],['之美','',''],['之而','',''],['之职','',''],['之肉','',''],['之能事','',''],['之至','',''],['之色','',''],['之行','',''],['之见','',''],['之角','',''],['之言','',''],['之计','',''],['之论','',''],['之词','',''],['之语','',''],['之谈','',''],['之谊','',''],['之貉','',''],['之财','',''],['之路','',''],['之辈','',''],['之辞','',''],['之过','',''],['之道','',''],['之都','',''],['之量','',''],['之钟','',''],['之长','',''],['之门','',''],['之间','',''],['之际','',''],['之险','',''],['之隔','',''],['之难','',''],['之音','',''],['之首','',''],['之马','',''],['之鸟','',''],['乌七八槽','',''],['乌七八糟','',''],['乌丘','',''],['乌丘乡','',''],['乌丝','',''],['乌之雌雄','',''],['乌云','',''],['乌云密布','',''],['乌亮','',''],['乌什塔拉','',''],['乌什塔拉乡','',''],['乌什塔拉回族乡','',''],['乌伊岭','',''],['乌伦古河','',''],['乌伦古湖','',''],['乌克丽丽','',''],['乌克兰人','',''],['乌兰夫','',''],['乌兰巴托','',''],['乌兰牧骑','',''],['乌兹别克','',''],['乌兹别克人','',''],['乌兹别克族','',''],['乌冬面','',''],['乌压压','',''],['乌合','',''],['乌合之众','',''],['乌合之卒','',''],['乌呼','',''],['乌塌菜','',''],['乌天黑地','',''],['乌头','',''],['乌头白马生角','',''],['乌娘','',''],['乌孙国','',''],['乌孜别克','',''],['乌孜别克语','',''],['乌审','',''],['乌尔','',''],['乌尔姆','',''],['乌尔格','',''],['乌尔禾','',''],['乌尔都语','',''],['乌干达人','',''],['乌当','',''],['乌德勒支','',''],['乌托邦','',''],['乌托邦社会主义','',''],['乌拉','',''],['乌拉圭人','',''],['乌拉尔','',''],['乌拉尔山','',''],['乌拉尔山脉','',''],['乌拉特','',''],['乌拉特草原','',''],['乌拉草','',''],['乌拜迪','',''],['乌日','',''],['乌日乡','',''],['乌普萨拉','',''],['乌有','',''],['乌有先生','',''],['乌木','',''],['乌来','',''],['乌来乡','',''],['乌枣','',''],['乌桓','',''],['乌桕','',''],['乌梁海','',''],['乌梅','',''],['乌榄','',''],['乌江','',''],['乌油油','',''],['乌泱乌泱','',''],['乌洛托品','',''],['乌涂','',''],['乌溜溜','',''],['乌滋别克','',''],['乌滋别克斯坦','',''],['乌灯黑火','',''],['乌烟瘴气','',''],['乌焉成马','',''],['乌煤','',''],['乌特列支','',''],['乌白菜','',''],['乌纱帽','',''],['乌舅金奴','',''],['乌良哈','',''],['乌节路','',''],['乌芋','',''],['乌苏里斯克','',''],['乌苏里江','',''],['乌药','',''],['乌蒙山','',''],['乌蓝','',''],['乌衣子弟','',''],['乌西亚','',''],['乌讷楚','',''],['乌语','',''],['乌贼','',''],['乌达','',''],['乌里雅苏台','',''],['乌金','',''],['乌青','',''],['乌飞兔走','',''],['乌饭果','',''],['乌饭树','',''],['乌马河','',''],['乌骨鸡','',''],['乌鱼','',''],['乌鱼蛋','',''],['乌鲁克恰提','',''],['乌鲁克恰提县','',''],['乌鲁汝','',''],['乌鲳','',''],['乌鳢','',''],['乌鸟之情','',''],['乌鸟私情','',''],['乌鸡','',''],['乌鸡白凤丸','',''],['乌鸦','',''],['乌鸦嘴','',''],['乌鸦座','',''],['乌鸫','',''],['乌鹊通巢','',''],['乌黎雅','',''],['乌黑','',''],['乌黑色','',''],['乌齐雅','',''],['乌龙','',''],['乌龙球','',''],['乌龙茶','',''],['乌龙面','',''],['乌龟','',''],['乌龟壳','',''],['乍一看','',''],['乍冷乍热','',''],['乍到','',''],['乍富','',''],['乍寒','',''],['乍得湖','',''],['乍晴','',''],['乍暖','',''],['乍暖还寒','',''],['乍浦','',''],['乍浦镇','',''],['乍热','',''],['乍然','',''],['乍猛的','',''],['乍现','',''],['乍看','',''],['乍离破碎','',''],['乍见','',''],['乎乎','',''],['乏人照顾','',''],['乏力','',''],['乏味','',''],['乏时','',''],['乏煤','',''],['乏燃料','',''],['乏燃料棒','',''],['乏货','',''],['乐不可支','',''],['乐不可极','',''],['乐不可言','',''],['乐不开支','',''],['乐不思蜀','',''],['乐东','',''],['乐东县','',''],['乐之','',''],['乐乐陶陶','',''],['乐了','',''],['乐事','',''],['乐于','',''],['乐于助人','',''],['乐交','',''],['乐亭大鼓','',''],['乐人','',''],['乐以忘忧','',''],['乐儿','',''],['乐华梅兰','',''],['乐句','',''],['乐台','',''],['乐号','',''],['乐呵呵','',''],['乐和','',''],['乐善','',''],['乐善不倦','',''],['乐善好义','',''],['乐善好施','',''],['乐器','',''],['乐团','',''],['乐园','',''],['乐土','',''],['乐圣','',''],['乐在其中','',''],['乐地','',''],['乐坛','',''],['乐声','',''],['乐天','',''],['乐天派','',''],['乐天知命','',''],['乐子','',''],['乐学者','',''],['乐山乐水','',''],['乐山地区','',''],['乐师','',''],['乐府','',''],['乐府诗集','',''],['乐开花','',''],['乐律','',''],['乐得','',''],['乐意','',''],['乐感','',''],['乐户','',''],['乐手','',''],['乐捐','',''],['乐施会','',''],['乐昌之镜','',''],['乐昌分镜','',''],['乐曲','',''],['乐极','',''],['乐极则悲','',''],['乐极悲来','',''],['乐极悲生','',''],['乐极生悲','',''],['乐果','',''],['乐歌','',''],['乐此','',''],['乐此不倦','',''],['乐此不疲','',''],['乐死','',''],['乐段','',''],['乐池','',''],['乐法','',''],['乐浪郡','',''],['乐滋滋','',''],['乐理','',''],['乐的','',''],['乐着','',''],['乐祸','',''],['乐祸幸灾','',''],['乐窝','',''],['乐章','',''],['乐经','',''],['乐羊羊','',''],['乐而不荒','',''],['乐而忘归','',''],['乐而忘返','',''],['乐腾','',''],['乐舞','',''],['乐蒂','',''],['乐见','',''],['乐观','',''],['乐观主义','',''],['乐观主义者','',''],['乐观者','',''],['乐调','',''],['乐谱','',''],['乐谱架','',''],['乐谱集','',''],['乐贫甘贱','',''],['乐购','',''],['乐趣','',''],['乐迷','',''],['乐透','',''],['乐道','',''],['乐道安贫','',''],['乐钟','',''],['乐队','',''],['乐陶陶','',''],['乐音','',''],['乐颠了馅','',''],['乐高','',''],['乐龄','',''],['乒乒','',''],['乒乓','',''],['乒乓球','',''],['乒乓球台','',''],['乒乓球拍','',''],['乒坛','',''],['乓乓','',''],['乔丹','',''],['乔其纱','',''],['乔冠华','',''],['乔巴山','',''],['乔布','',''],['乔布斯','',''],['乔戈里峰','',''],['乔木','',''],['乔松之寿','',''],['乔林','',''],['乔格里峰','',''],['乔治','',''],['乔治・华盛顿','',''],['乔治・奥威尔','',''],['乔治・索罗斯','',''],['乔治一世','',''],['乔治亚','',''],['乔治城','',''],['乔治城大学','',''],['乔治敦','',''],['乔石','',''],['乔答摩','',''],['乔红','',''],['乔纳森','',''],['乔脑','',''],['乔装','',''],['乔装打扮','',''],['乔装改扮','',''],['乔迁','',''],['乔迁之喜','',''],['乔麦','',''],['乖乖','',''],['乖僻','',''],['乖儿','',''],['乖剌','',''],['乖孩子','',''],['乖巧','',''],['乖张','',''],['乖忤','',''],['乖戾','',''],['乖涨','',''],['乖癖','',''],['乖离','',''],['乖舛','',''],['乖觉','',''],['乖谬','',''],['乖迕','',''],['乖顺','',''],['乘上','',''],['乘人不备','',''],['乘人之危','',''],['乘人之厄','',''],['乘以','',''],['乘伪行诈','',''],['乘便','',''],['乘兴','',''],['乘兴而来','',''],['乘其不意','',''],['乘凉','',''],['乘务','',''],['乘务员','',''],['乘势','',''],['乘号','',''],['乘员','',''],['乘坐','',''],['乘坚策肥','',''],['乘坚驱良','',''],['乘客','',''],['乘幂','',''],['乘座','',''],['乘快艇','',''],['乘数','',''],['乘方','',''],['乘机','',''],['乘机应变','',''],['乘槎','',''],['乘此','',''],['乘汽车','',''],['乘法','',''],['乘法器','',''],['乘法表','',''],['乘法逆','',''],['乘火打劫','',''],['乘用','',''],['乘用车','',''],['乘积','',''],['乘筏者','',''],['乘算器','',''],['乘肥衣轻','',''],['乘胜','',''],['乘胜前进','',''],['乘胜追击','',''],['乘胜逐北','',''],['乘舆播越','',''],['乘舆播迁','',''],['乘船','',''],['乘虚','',''],['乘虚而入','',''],['乘警','',''],['乘车','',''],['乘车戴笠','',''],['乘车者','',''],['乘轻驱肥','',''],['乘间投隙','',''],['乘间策肥','',''],['乘除','',''],['乘隙','',''],['乘隙而入','',''],['乘风','',''],['乘风破浪','',''],['乘飞机','',''],['乘鹤','',''],['乘龙','',''],['乘龙快婿','',''],['乙丑','',''],['乙二醇','',''],['乙亥','',''],['乙卯','',''],['乙地','',''],['乙型','',''],['乙型肝炎','',''],['乙型脑炎','',''],['乙基','',''],['乙夜','',''],['乙太','',''],['乙太网路','',''],['乙巳','',''],['乙方','',''],['乙未','',''],['乙氧基','',''],['乙氨基','',''],['乙炔','',''],['乙烯','',''],['乙烯基','',''],['乙烷','',''],['乙状结肠','',''],['乙种','',''],['乙种促效剂','',''],['乙种射线','',''],['乙种粒子','',''],['乙等','',''],['乙类','',''],['乙级','',''],['乙肝','',''],['乙胺','',''],['乙脑','',''],['乙苯','',''],['乙酉','',''],['乙酰','',''],['乙酰胆碱','',''],['乙酰胺吡咯烷酮','',''],['乙酸','',''],['乙酸基','',''],['乙酸根','',''],['乙酸盐','',''],['乙醇','',''],['乙醇酸','',''],['乙醚','',''],['乙醛','',''],['乜嘢','',''],['乜斜','',''],['九一三事件','',''],['九一八事变','',''],['九七','',''],['九万','',''],['九三','',''],['九三○事件','',''],['九三学社','',''],['九世之仇','',''],['九个','',''],['九中全会','',''],['九九','',''],['九九乘法表','',''],['九九天','',''],['九九归一','',''],['九九重阳','',''],['九书不如无书','',''],['九二○','',''],['九五','',''],['九五之位','',''],['九五之尊','',''],['九人','',''],['九亿','',''],['九份','',''],['九倍','',''],['九六','',''],['九分','',''],['九分之一','',''],['九十','',''],['九十一','',''],['九十七','',''],['九十万','',''],['九十三','',''],['九十九','',''],['九十二','',''],['九十五','',''],['九十八','',''],['九十六','',''],['九十四','',''],['九十年','',''],['九十年代','',''],['九千','',''],['九千万','',''],['九华山','',''],['九卿','',''],['九原可作','',''],['九号','',''],['九号球','',''],['九合一匡','',''],['九品','',''],['九品中正','',''],['九品中正制','',''],['九四','',''],['九声六调','',''],['九大','',''],['九天','',''],['九头鸟','',''],['九如','',''],['九如乡','',''],['九官鸟','',''],['九宫','',''],['九宫山','',''],['九宫山镇','',''],['九宫格儿','',''],['九宫格数独','',''],['九寨沟风景名胜区','',''],['九尾狐','',''],['九尾龟','',''],['九层','',''],['九层塔','',''],['九届','',''],['九岁','',''],['九嶷山','',''],['九州','',''],['九州岛','',''],['九巴','',''],['九年','',''],['九归','',''],['九成','',''],['九折','',''],['九斤黄鸡','',''],['九族','',''],['九日','',''],['九时','',''],['九曲回肠','',''],['九曲堂','',''],['九月','',''],['九月九日忆山东兄弟','',''],['九月份','',''],['九本','',''],['九条','',''],['九校联盟','',''],['九格','',''],['九楼','',''],['九次','',''],['九步','',''],['九死一生','',''],['九死不悔','',''],['九段','',''],['九江地区','',''],['九泉','',''],['九泉之下','',''],['九洲','',''],['九派','',''],['九流','',''],['九流三教','',''],['九流百家','',''],['九渊','',''],['九点','',''],['九烈三贞','',''],['九牛一毛','',''],['九牛二虎','',''],['九牛二虎之力','',''],['九百','',''],['九百万','',''],['九省','',''],['九稳','',''],['九窍','',''],['九章','',''],['九章算术','',''],['九股','',''],['九路','',''],['九边','',''],['九边形','',''],['九进法','',''],['九连环','',''],['九里','',''],['九重奏','',''],['九重霄','',''],['九零后','',''],['九霄','',''],['九霄云外','',''],['九面体','',''],['九音锣','',''],['九鼎','',''],['九鼎大吕','',''],['九齿钉耙','',''],['九龙坡','',''],['九龙城','',''],['乞丐','',''],['乞人','',''],['乞伏','',''],['乞休','',''],['乞儿','',''],['乞力马扎罗山','',''],['乞和','',''],['乞哀','',''],['乞哀告怜','',''],['乞巧','',''],['乞怜','',''],['乞怜摇尾','',''],['乞恕','',''],['乞援','',''],['乞求','',''],['乞求者','',''],['乞浆得酒','',''],['乞灵','',''],['乞纳','',''],['乞讨','',''],['乞降','',''],['乞食','',''],['也不例外','',''],['也好','',''],['也就是','',''],['也就是说','',''],['也罢','',''],['也行','',''],['也许','',''],['习与性成','',''],['习习','',''],['习以为常','',''],['习以成俗','',''],['习以成性','',''],['习以成风','',''],['习作','',''],['习俗','',''],['习俗移性','',''],['习字','',''],['习尚','',''],['习常','',''],['习得','',''],['习得性','',''],['习得性无助感','',''],['习性','',''],['习惯','',''],['习惯上','',''],['习惯了','',''],['习惯于','',''],['习惯势力','',''],['习惯性','',''],['习惯成自然','',''],['习惯法','',''],['习惯用法','',''],['习惯用语','',''],['习惯自然','',''],['习惯若自然','',''],['习染','',''],['习气','',''],['习用','',''],['习而不察','',''],['习艺','',''],['习见','',''],['习近平','',''],['习非成是','',''],['习非胜是','',''],['习题','',''],['习题集','',''],['乡下','',''],['乡下习气','',''],['乡下人','',''],['乡下佬','',''],['乡乡','',''],['乡井','',''],['乡亲','',''],['乡亲们','',''],['乡人','',''],['乡人子','',''],['乡俗','',''],['乡僻','',''],['乡办','',''],['乡勇','',''],['乡区','',''],['乡医','',''],['乡友','',''],['乡团','',''],['乡土','',''],['乡土气','',''],['乡土气息','',''],['乡土观念','',''],['乡地','',''],['乡学','',''],['乡巴佬','',''],['乡干部','',''],['乡思','',''],['乡情','',''],['乡愁','',''],['乡愿','',''],['乡戚','',''],['乡政府','',''],['乡曲','',''],['乡曲之誉','',''],['乡村','',''],['乡村医生','',''],['乡村奶酪','',''],['乡村式','',''],['乡村音乐','',''],['乡民','',''],['乡级','',''],['乡绅','',''],['乡规民约','',''],['乡试','',''],['乡谈','',''],['乡谊','',''],['乡贤','',''],['乡贯','',''],['乡邮','',''],['乡邻','',''],['乡里','',''],['乡野','',''],['乡镇','',''],['乡镇企业','',''],['乡镇企业局','',''],['乡镇经济','',''],['乡长','',''],['乡间','',''],['乡音','',''],['乡风慕义','',''],['书上','',''],['书不尽言','',''],['书中','',''],['书丹','',''],['书五','',''],['书亭','',''],['书人','',''],['书会','',''],['书体','',''],['书信','',''],['书信集','',''],['书册','',''],['书写','',''],['书写不能症','',''],['书写器','',''],['书写符号','',''],['书写者','',''],['书写语言','',''],['书函','',''],['书刊','',''],['书剑飘零','',''],['书包','',''],['书包带','',''],['书卷','',''],['书卷气','',''],['书口','',''],['书号','',''],['书名','',''],['书名号','',''],['书后','',''],['书呆子','',''],['书商','',''],['书圣','',''],['书场','',''],['书坊','',''],['书坛','',''],['书城','',''],['书堆','',''],['书声朗朗','',''],['书声琅琅','',''],['书外','',''],['书夹','',''],['书契','',''],['书套','',''],['书学','',''],['书富五车','',''],['书局','',''],['书屋','',''],['书展','',''],['书市','',''],['书库','',''],['书店','',''],['书归正传','',''],['书录','',''],['书影','',''],['书房','',''],['书扉','',''],['书报','',''],['书报费','',''],['书摊','',''],['书摘','',''],['书文','',''],['书斋','',''],['书本','',''],['书本知识','',''],['书札','',''],['书板','',''],['书架','',''],['书柜','',''],['书柬','',''],['书案','',''],['书桌','',''],['书档','',''],['书橱','',''],['书款','',''],['书法','',''],['书法家','',''],['书牍','',''],['书物','',''],['书状','',''],['书生','',''],['书生气','',''],['书用','',''],['书画','',''],['书画家','',''],['书画毡','',''],['书痴','',''],['书癖','',''],['书皮','',''],['书皮儿','',''],['书目','',''],['书目工作','',''],['书眉','',''],['书社','',''],['书稿','',''],['书立','',''],['书童','',''],['书符咒水','',''],['书签','',''],['书简','',''],['书箧','',''],['书箱','',''],['书籍','',''],['书籍商','',''],['书籍装帧','',''],['书约','',''],['书经','',''],['书缺简脱','',''],['书背','',''],['书脊','',''],['书虫','',''],['书蠹','',''],['书角','',''],['书记','',''],['书记员','',''],['书记处','',''],['书证','',''],['书评','',''],['书读五车','',''],['书迹','',''],['书通二酉','',''],['书里','',''],['书钉','',''],['书院','',''],['书面','',''],['书面发言','',''],['书面声明','',''],['书面报告','',''],['书面材料','',''],['书面许可','',''],['书面语','',''],['书面语言','',''],['书面通知','',''],['书页','',''],['书风','',''],['书馆','',''],['书馆儿','',''],['书香','',''],['书香门第','',''],['乩童','',''],['买下','',''],['买个','',''],['买主','',''],['买书','',''],['买了','',''],['买些','',''],['买价','',''],['买光','',''],['买入','',''],['买入价','',''],['买关节','',''],['买到','',''],['买办','',''],['买办资产阶级','',''],['买办资本','',''],['买单','',''],['买卖','',''],['买卖人','',''],['买卖双方','',''],['买卖婚姻','',''],['买卖方','',''],['买去','',''],['买回','',''],['买好','',''],['买它','',''],['买官','',''],['买定','',''],['买家','',''],['买帐','',''],['买张','',''],['买得','',''],['买得到','',''],['买成','',''],['买房','',''],['买断','',''],['买方','',''],['买方市场','',''],['买春','',''],['买来','',''],['买椟还珠','',''],['买点','',''],['买牛卖剑','',''],['买的','',''],['买盘','',''],['买票','',''],['买空','',''],['买空仓','',''],['买空卖空','',''],['买笑追欢','',''],['买给','',''],['买者','',''],['买臣覆水','',''],['买菜求益','',''],['买账','',''],['买货','',''],['买走','',''],['买起','',''],['买辆','',''],['买进','',''],['买通','',''],['买青苗','',''],['买面子','',''],['买餸','',''],['买马招军','',''],['乱七八糟','',''],['乱世','',''],['乱世佳人','',''],['乱世凶年','',''],['乱丢','',''],['乱串','',''],['乱乱','',''],['乱了','',''],['乱了营','',''],['乱事','',''],['乱交','',''],['乱伦','',''],['乱伦罪','',''],['乱作一团','',''],['乱作决定','',''],['乱俗伤风','',''],['乱党','',''],['乱兵','',''],['乱写','',''],['乱冲','',''],['乱凑','',''],['乱划','',''],['乱刺','',''],['乱割','',''],['乱加','',''],['乱加干涉','',''],['乱动','',''],['乱占耕地','',''],['乱反射','',''],['乱发','',''],['乱叫','',''],['乱吃','',''],['乱咕攘','',''],['乱咬','',''],['乱哄哄','',''],['乱喊','',''],['乱国','',''],['乱坟','',''],['乱坟岗','',''],['乱坠天花','',''],['乱堆','',''],['乱塞','',''],['乱头粗服','',''],['乱奏','',''],['乱套','',''],['乱子','',''],['乱射','',''],['乱开','',''],['乱弄','',''],['乱弹','',''],['乱弹琴','',''],['乱性','',''],['乱想','',''],['乱成','',''],['乱打','',''],['乱扔','',''],['乱扣','',''],['乱扣帽子','',''],['乱扯','',''],['乱抓','',''],['乱拿','',''],['乱挤','',''],['乱掉','',''],['乱推','',''],['乱提','',''],['乱搞','',''],['乱搞男女关系','',''],['乱摊派','',''],['乱摸','',''],['乱撞','',''],['乱支','',''],['乱收','',''],['乱收费','',''],['乱放','',''],['乱政','',''],['乱斗','',''],['乱杀','',''],['乱杂','',''],['乱来','',''],['乱民','',''],['乱流','',''],['乱涂','',''],['乱涂乱画','',''],['乱涨','',''],['乱涨价','',''],['乱滚','',''],['乱点鸳鸯','',''],['乱烘烘','',''],['乱物','',''],['乱用','',''],['乱画','',''],['乱真','',''],['乱石','',''],['乱石砸死','',''],['乱码','',''],['乱砍','',''],['乱砍滥伐','',''],['乱离','',''],['乱穿马路','',''],['乱窜','',''],['乱箭攒心','',''],['乱糟糟','',''],['乱纪','',''],['乱纷','',''],['乱纷纷','',''],['乱结','',''],['乱罚款','',''],['乱翻','',''],['乱腾','',''],['乱腾腾','',''],['乱臣','',''],['乱臣贼子','',''],['乱臣逆子','',''],['乱舞','',''],['乱花','',''],['乱花钱','',''],['乱葬','',''],['乱葬岗子','',''],['乱蓬','',''],['乱蓬蓬','',''],['乱要','',''],['乱视眼','',''],['乱记','',''],['乱讲','',''],['乱语','',''],['乱说','',''],['乱说乱动','',''],['乱象','',''],['乱跑','',''],['乱跳','',''],['乱蹦','',''],['乱转','',''],['乱闯','',''],['乱飞','',''],['乱首垢面','',''],['乱骂','',''],['乱麻','',''],['乱麻麻','',''],['乳交','',''],['乳体','',''],['乳儿','',''],['乳制','',''],['乳制品','',''],['乳剂','',''],['乳剂质','',''],['乳化','',''],['乳化剂','',''],['乳名','',''],['乳品','',''],['乳品店','',''],['乳头','',''],['乳头状','',''],['乳头瘤','',''],['乳量','',''],['乳娘','',''],['乳峰','',''],['乳房','',''],['乳房炎','',''],['乳房状','',''],['乳晕','',''],['乳母','',''],['乳水交融','',''],['乳汁','',''],['乳汁状','',''],['乳沟','',''],['乳油','',''],['乳浆','',''],['乳浊液','',''],['乳液','',''],['乳源','',''],['乳源县','',''],['乳牙','',''],['乳牛','',''],['乳状','',''],['乳状物','',''],['乳猪','',''],['乳痈','',''],['乳癌','',''],['乳白','',''],['乳白光','',''],['乳白天空','',''],['乳白色','',''],['乳皮','',''],['乳石','',''],['乳突','',''],['乳突炎','',''],['乳突窦','',''],['乳粉','',''],['乳糖','',''],['乳糖不耐症','',''],['乳糖酶','',''],['乳糜','',''],['乳罩','',''],['乳胶','',''],['乳胶液','',''],['乳胶漆','',''],['乳脂','',''],['乳脂状','',''],['乳腐','',''],['乳腺','',''],['乳腺炎','',''],['乳腺癌','',''],['乳臭','',''],['乳臭未干','',''],['乳色','',''],['乳部','',''],['乳酪','',''],['乳酪蛋糕','',''],['乳酸','',''],['乳酸盐','',''],['乳酸菌','',''],['乳钵','',''],['乳香','',''],['乳香树','',''],['乳香脂','',''],['乳鸽','',''],['乳齿','',''],['乳齿象','',''],['乶下','',''],['乾嘉三大家','',''],['乾坤','',''],['乾坤再造','',''],['乾旱','',''],['乾燥','',''],['乾粮','',''],['乾脆','',''],['乾陵','',''],['乾隆','',''],['了不得','',''],['了不起','',''],['了了','',''],['了了草草','',''],['了事','',''],['了债','',''],['了却','',''],['了却此生','',''],['了如指掌','',''],['了局','',''],['了帐','',''],['了当','',''],['了得','',''],['了愿','',''],['了手','',''],['了断','',''],['了望','',''],['了望台','',''],['了望塔','',''],['了案','',''],['了此','',''],['了清','',''],['了然','',''],['了结','',''],['了若指掌','',''],['了解','',''],['了解到','',''],['了解情况','',''],['了身达命','',''],['予人口实','',''],['予以','',''],['予以安排','',''],['予以照顾','',''],['予以考虑','',''],['予取予求','',''],['争个','',''],['争产','',''],['争价','',''],['争作','',''],['争做','',''],['争先','',''],['争先士卒','',''],['争先恐后','',''],['争光','',''],['争冠','',''],['争分夺妙','',''],['争分夺秒','',''],['争创','',''],['争利','',''],['争办','',''],['争功','',''],['争取','',''],['争取和平','',''],['争名','',''],['争名于朝争利于市','',''],['争名夺利','',''],['争名竞利','',''],['争名逐利','',''],['争吵','',''],['争嘴','',''],['争夺','',''],['争夺战','',''],['争奇','',''],['争奇斗异','',''],['争奇斗胜','',''],['争奇斗艳','',''],['争妍斗奇','',''],['争妍斗艳','',''],['争宠','',''],['争强','',''],['争强好胜','',''],['争强斗胜','',''],['争强显胜','',''],['争当','',''],['争得','',''],['争性','',''],['争战','',''],['争执','',''],['争执不下','',''],['争执不休','',''],['争抢','',''],['争持','',''],['争收','',''],['争斗','',''],['争斤论两','',''],['争权','',''],['争权夺利','',''],['争权攘利','',''],['争气','',''],['争球','',''],['争球线','',''],['争用','',''],['争相','',''],['争着','',''],['争竞','',''],['争端','',''],['争红斗紫','',''],['争者','',''],['争胜','',''],['争脸','',''],['争臣','',''],['争艳','',''],['争衡','',''],['争议','',''],['争议地区','',''],['争议性','',''],['争论','',''],['争论不休','',''],['争论中','',''],['争论点','',''],['争论者','',''],['争讼','',''],['争购','',''],['争起','',''],['争辨','',''],['争辩','',''],['争逐','',''],['争锋','',''],['争长争短','',''],['争长竞短','',''],['争长论短','',''],['争闹','',''],['争雄','',''],['争霸','',''],['争面子','',''],['争风吃醋','',''],['争鸣','',''],['事上','',''],['事不关己','',''],['事不关己高高挂起','',''],['事不宜迟','',''],['事与愿违','',''],['事业','',''],['事业单位','',''],['事业心','',''],['事业成功','',''],['事业有成','',''],['事业线','',''],['事业费','',''],['事为','',''],['事主','',''],['事事','',''],['事事拗违','',''],['事件','',''],['事件相关电位','',''],['事体','',''],['事例','',''],['事倍','',''],['事倍功半','',''],['事假','',''],['事儿','',''],['事先','',''],['事先通知','',''],['事关','',''],['事关全局','',''],['事关大局','',''],['事关重大','',''],['事典','',''],['事出','',''],['事出不意','',''],['事出有因','',''],['事到','',''],['事到临头','',''],['事到如今','',''],['事前','',''],['事前审计','',''],['事功','',''],['事务','',''],['事务主义','',''],['事务处理','',''],['事务律师','',''],['事务所','',''],['事务所律师','',''],['事务管理','',''],['事务繁忙','',''],['事务长','',''],['事势','',''],['事半功倍','',''],['事危累卵','',''],['事发地点','',''],['事发时','',''],['事变','',''],['事后','',''],['事后聪明','',''],['事后诸葛亮','',''],['事在人为','',''],['事在必行','',''],['事处','',''],['事外','',''],['事大主义','',''],['事奉','',''],['事宜','',''],['事实','',''],['事实上','',''],['事实婚','',''],['事实性','',''],['事实求是','',''],['事实真相','',''],['事实确凿','',''],['事实胜于雄辨','',''],['事实胜于雄辩','',''],['事实证明','',''],['事已至此','',''],['事必','',''],['事必有兆','',''],['事必躬亲','',''],['事态','',''],['事态发展','',''],['事怕行家','',''],['事情','',''],['事情要做','',''],['事成','',''],['事或物','',''],['事故','',''],['事故学','',''],['事故照射','',''],['事无大小','',''],['事无巨细','',''],['事月表','',''],['事机','',''],['事权','',''],['事求是','',''],['事物','',''],['事理','',''],['事生肘腋','',''],['事用','',''],['事由','',''],['事界','',''],['事略','',''],['事端','',''],['事证','',''],['事败垂成','',''],['事过境迁','',''],['事迹','',''],['事隔','',''],['事项','',''],['二一','',''],['二一添作五','',''],['二丁醚','',''],['二七','',''],['二万','',''],['二万五千里长征','',''],['二三','',''],['二三其德','',''],['二三其意','',''],['二不','',''],['二不休','',''],['二世','',''],['二世纪','',''],['二个','',''],['二中','',''],['二中全会','',''],['二中选一','',''],['二义性','',''],['二乎','',''],['二九','',''],['二二','',''],['二五','',''],['二五眼','',''],['二产妇','',''],['二人','',''],['二人世界','',''],['二人划','',''],['二人台','',''],['二人同心其利断金','',''],['二人转','',''],['二亿','',''],['二仑','',''],['二仑乡','',''],['二代','',''],['二价','',''],['二份','',''],['二伏','',''],['二传','',''],['二传手','',''],['二位','',''],['二侧','',''],['二倍','',''],['二倍体','',''],['二倍体植物','',''],['二傻','',''],['二元','',''],['二元性','',''],['二元方程式','',''],['二元论','',''],['二元论者','',''],['二元酸','',''],['二元醇','',''],['二八','',''],['二八佳人','',''],['二八开','',''],['二六','',''],['二几','',''],['二分','',''],['二分之','',''],['二分之一','',''],['二分明月','',''],['二分点','',''],['二分裂','',''],['二分音符','',''],['二列','',''],['二则','',''],['二副','',''],['二化螟','',''],['二十','',''],['二十一','',''],['二十一世纪','',''],['二十一条','',''],['二十一点','',''],['二十七','',''],['二十七号','',''],['二十三','',''],['二十世纪','',''],['二十个','',''],['二十九','',''],['二十二','',''],['二十二号','',''],['二十五','',''],['二十五史','',''],['二十人','',''],['二十八','',''],['二十八号','',''],['二十八宿','',''],['二十八星瓢虫','',''],['二十六','',''],['二十六号','',''],['二十六岁','',''],['二十四','',''],['二十四史','',''],['二十四号','',''],['二十四节气','',''],['二十多','',''],['二十年','',''],['二十年目睹之怪现状','',''],['二十面体','',''],['二千','',''],['二叉树','',''],['二双','',''],['二叠系','',''],['二叠纪','',''],['二号','',''],['二号人物','',''],['二号电池','',''],['二合一','',''],['二名','',''],['二名制','',''],['二名法','',''],['二哥','',''],['二四','',''],['二四滴','',''],['二回','',''],['二回熟','',''],['二地主','',''],['二地区','',''],['二声','',''],['二天','',''],['二头','',''],['二头肌','',''],['二奶','',''],['二奶专家','',''],['二妹','',''],['二姐','',''],['二姓之好','',''],['二姓子','',''],['二婚','',''],['二婚头','',''],['二字','',''],['二季度','',''],['二宝','',''],['二审','',''],['二寸','',''],['二尕子','',''],['二尖瓣','',''],['二尺','',''],['二层','',''],['二层楼','',''],['二届','',''],['二岁','',''],['二年','',''],['二年生','',''],['二年级','',''],['二年级情','',''],['二度','',''],['二开','',''],['二弦','',''],['二心','',''],['二心两意','',''],['二性','',''],['二恶英','',''],['二意','',''],['二意三心','',''],['二愣子','',''],['二战','',''],['二房','',''],['二房东','',''],['二手','',''],['二手房','',''],['二手烟','',''],['二手货','',''],['二手车','',''],['二把','',''],['二把刀','',''],['二把手','',''],['二拇指','',''],['二指','',''],['二日','',''],['二时','',''],['二更','',''],['二月','',''],['二月份','',''],['二期','',''],['二期工程','',''],['二杆子','',''],['二条','',''],['二来','',''],['二极','',''],['二极管','',''],['二林','',''],['二林镇','',''],['二桃杀三士','',''],['二楼','',''],['二次','',''],['二次世界大战','',''],['二次函数','',''],['二次型','',''],['二次多项式','',''],['二次大战','',''],['二次幂','',''],['二次开发','',''],['二次方','',''],['二次方程','',''],['二次曲','',''],['二次曲线','',''],['二次曲面','',''],['二次革命','',''],['二次元','',''],['二正丙醚','',''],['二步','',''],['二段','',''],['二比一','',''],['二毛','',''],['二氧','',''],['二氧化氮','',''],['二氧化物','',''],['二氧化硅','',''],['二氧化硫','',''],['二氧化碳','',''],['二氧化碳隔离','',''],['二氧化钛','',''],['二氧化铀','',''],['二氧化锰','',''],['二氧杂芑','',''],['二氧芑','',''],['二氯乙烷','',''],['二氯乙烷中毒','',''],['二氯异三聚氰酸钠','',''],['二氯甲烷','',''],['二氯胺','',''],['二氯苯胺苯乙酸钠','',''],['二水','',''],['二水乡','',''],['二水货','',''],['二流','',''],['二流子','',''],['二流货','',''],['二满三平','',''],['二炮','',''],['二点','',''],['二环','',''],['二甘醇','',''],['二用','',''],['二甲基砷酸','',''],['二甲基胂酸','',''],['二甲苯','',''],['二百','',''],['二百万','',''],['二百二','',''],['二百五','',''],['二百年','',''],['二皇帝','',''],['二硫化物','',''],['二硫化碳','',''],['二硫化钼','',''],['二硫基丙磺酸钠','',''],['二硫基丙醇','',''],['二硫基琥珀酸钠','',''],['二磷酸腺苷','',''],['二种','',''],['二等','',''],['二等分','',''],['二等功','',''],['二等奖','',''],['二等舱','',''],['二等车','',''],['二等边','',''],['二簧','',''],['二类','',''],['二糖','',''],['二级','',''],['二级品','',''],['二级士官','',''],['二级头','',''],['二线','',''],['二维','',''],['二缶钟惑','',''],['二老','',''],['二者','',''],['二者之一','',''],['二者之间','',''],['二者必居其一','',''],['二胎','',''],['二胡','',''],['二脚','',''],['二色','',''],['二节棍','',''],['二花脸','',''],['二苯氯胂','',''],['二茬罪','',''],['二话','',''],['二话不说','',''],['二话没说','',''],['二足','',''],['二路','',''],['二踢脚','',''],['二轮','',''],['二轮车','',''],['二轻','',''],['二轻局','',''],['二进','',''],['二进位','',''],['二进位制','',''],['二进制','',''],['二进制编码','',''],['二进宫','',''],['二进法','',''],['二连','',''],['二连巨盗龙','',''],['二连盆地','',''],['二迭纪','',''],['二遍苦','',''],['二道','',''],['二道江','',''],['二道贩子','',''],['二郎','',''],['二郎神','',''],['二郎腿','',''],['二部','',''],['二部制','',''],['二醇','',''],['二里头','',''],['二重','',''],['二重下标','',''],['二重唱','',''],['二重奏','',''],['二重性','',''],['二重根','',''],['二重母音','',''],['二量体','',''],['二锅头','',''],['二门','',''],['二阶','',''],['二阿姨','',''],['二院','',''],['二面角','',''],['二音节','',''],['二项','',''],['二项分布','',''],['二项式','',''],['二项式定理','',''],['二项式系数','',''],['二鬼子','',''],['二黄','',''],['于下','',''],['于世','',''],['于中','',''],['于丹','',''],['于事','',''],['于事无补','',''],['于人','',''],['于今','',''],['于今为烈','',''],['于外','',''],['于家为国','',''],['于己于人','',''],['于形','',''],['于心','',''],['于心不忍','',''],['于心不甘','',''],['于心何忍','',''],['于思','',''],['于思于思','',''],['于是','',''],['于是乎','',''],['于此','',''],['于民','',''],['于民润国','',''],['于洪','',''],['于焉','',''],['于那','',''],['于雾霭之中','',''],['于飞之乐','',''],['亏了','',''],['亏产','',''],['亏待','',''],['亏得','',''],['亏心','',''],['亏心事','',''],['亏心短行','',''],['亏折','',''],['亏损','',''],['亏损率','',''],['亏损面','',''],['亏损额','',''],['亏本','',''],['亏本出售','',''],['亏格','',''],['亏欠','',''],['亏理','',''],['亏盈','',''],['亏短','',''],['亏空','',''],['亏累','',''],['亏缺','',''],['亏耗','',''],['亏蚀','',''],['亏负','',''],['亏钱','',''],['云一样','',''],['云中','',''],['云云','',''],['云兴霞蔚','',''],['云冈石窟','',''],['云华','',''],['云南白药','',''],['云合雾集','',''],['云吞','',''],['云团','',''],['云图','',''],['云块','',''],['云城','',''],['云外','',''],['云天','',''],['云天高义','',''],['云头','',''],['云头儿','',''],['云室','',''],['云层','',''],['云山','',''],['云山雾罩','',''],['云岩','',''],['云崖','',''],['云开见日','',''],['云彩','',''],['云散','',''],['云散了','',''],['云散风流','',''],['云朵','',''],['云杉','',''],['云林','',''],['云梯','',''],['云母','',''],['云气','',''],['云汉','',''],['云沙','',''],['云泥异路','',''],['云海','',''],['云消雾散','',''],['云涌','',''],['云液','',''],['云淡风轻','',''],['云游','',''],['云游四方','',''],['云溪','',''],['云烟','',''],['云烟过眼','',''],['云片糕','',''],['云状','',''],['云状物','',''],['云珠','',''],['云的','',''],['云程万里','',''],['云程发轫','',''],['云窗雾槛','',''],['云端','',''],['云翳','',''],['云英','',''],['云蒸霞蔚','',''],['云行雨施','',''],['云观','',''],['云谲波诡','',''],['云豆','',''],['云豹','',''],['云贵','',''],['云贵川','',''],['云贵高原','',''],['云起龙骧','',''],['云车风马','',''],['云遮雾障','',''],['云里雾里','',''],['云量','',''],['云锣','',''],['云锦','',''],['云阶月地','',''],['云隙','',''],['云雀','',''],['云集','',''],['云雨','',''],['云雨巫山','',''],['云雨高唐','',''],['云雾','',''],['云雾径迹','',''],['云霄飞车','',''],['云霞','',''],['云霭','',''],['云高计','',''],['云鬓','',''],['云龙风虎','',''],['互不','',''],['互不侵犯','',''],['互不侵犯条约','',''],['互不干涉','',''],['互不服气','',''],['互不相欠','',''],['互不相让','',''],['互为','',''],['互为因果','',''],['互为知己','',''],['互为表里','',''],['互争','',''],['互争高下','',''],['互会','',''],['互使','',''],['互信','',''],['互关','',''],['互利','',''],['互利互惠','',''],['互利共生','',''],['互动','',''],['互动电视','',''],['互助','',''],['互助县','',''],['互助友爱','',''],['互助组','',''],['互勉','',''],['互卷','',''],['互变','',''],['互定','',''],['互市','',''],['互异','',''],['互惠','',''],['互惠关税','',''],['互惠待遇','',''],['互感','',''],['互感应','',''],['互感系数','',''],['互抵','',''],['互换','',''],['互换性','',''],['互推','',''],['互操性','',''],['互敬互爱','',''],['互文','',''],['互斥','',''],['互替','',''],['互有','',''],['互查','',''],['互殴','',''],['互派','',''],['互派大使','',''],['互济','',''],['互涉','',''],['互爱','',''],['互现','',''],['互生','',''],['互生叶','',''],['互用','',''],['互用性','',''],['互相','',''],['互相依存','',''],['互相协作','',''],['互相帮助','',''],['互相扯皮','',''],['互相推诿','',''],['互相沟通','',''],['互相爱护','',''],['互相监督','',''],['互相联系','',''],['互相连接','',''],['互祝','',''],['互素','',''],['互结','',''],['互给','',''],['互联','',''],['互联网','',''],['互联网用户','',''],['互联网站','',''],['互联网络','',''],['互补','',''],['互见','',''],['互让','',''],['互设','',''],['互访','',''],['互诉衷情','',''],['互诉衷肠','',''],['互译','',''],['互调','',''],['互谅','',''],['互谅互让','',''],['互质数','',''],['互赠','',''],['互踢','',''],['互连','',''],['互连性','',''],['互选','',''],['互通','',''],['互通性','',''],['互通有无','',''],['互锁','',''],['五一','',''],['五一劳动节','',''],['五一国际劳动节','',''],['五一节','',''],['五七','',''],['五七一代','',''],['五七干校','',''],['五七干部学校','',''],['五万','',''],['五世','',''],['五个','',''],['五中','',''],['五中全会','',''],['五五','',''],['五人','',''],['五人墓碑记','',''],['五亿','',''],['五代','',''],['五代十国','',''],['五代史','',''],['五件','',''],['五份','',''],['五伦','',''],['五位','',''],['五体投地','',''],['五保','',''],['五保户','',''],['五倍','',''],['五倍子','',''],['五倍子树','',''],['五倍子虫','',''],['五元','',''],['五光','',''],['五光十色','',''],['五内','',''],['五内如焚','',''],['五凉','',''],['五分','',''],['五分之一','',''],['五分之三','',''],['五分之二','',''],['五分之四','',''],['五分制','',''],['五分熟','',''],['五分美金','',''],['五刑','',''],['五加','',''],['五十','',''],['五十一','',''],['五十七','',''],['五十万','',''],['五十三','',''],['五十个','',''],['五十九','',''],['五十二','',''],['五十五','',''],['五十人','',''],['五十八','',''],['五十六','',''],['五十四','',''],['五十岁','',''],['五十步笑百步','',''],['五十铃','',''],['五千','',''],['五千万','',''],['五卅','',''],['五卅运动','',''],['五卷','',''],['五口通商','',''],['五台山','',''],['五台市','',''],['五号','',''],['五号电池','',''],['五名','',''],['五味','',''],['五味俱全','',''],['五味子','',''],['五味瓶','',''],['五四','',''],['五四○六菌肥','',''],['五四爱国运动','',''],['五四运动','',''],['五四青年节','',''],['五声音阶','',''],['五夜','',''],['五大','',''],['五大三粗','',''],['五大名山','',''],['五大洲','',''],['五大湖','',''],['五头','',''],['五如京兆','',''],['五子棋','',''],['五官','',''],['五官端正','',''],['五家','',''],['五小工业','',''],['五层','',''],['五届','',''],['五岭','',''],['五岳','',''],['五峰','',''],['五峰乡','',''],['五峰县','',''],['五帝','',''],['五带','',''],['五年','',''],['五年前','',''],['五年计划','',''],['五度','',''],['五弦琴','',''],['五形','',''],['五彩','',''],['五彩宾纷','',''],['五彩纷呈','',''],['五彩缤纷','',''],['五律','',''],['五忘形交','',''],['五打一','',''],['五指','',''],['五敛子','',''],['五斗','',''],['五斗柜','',''],['五斗米道','',''],['五方','',''],['五方杂厝','',''],['五方杂处','',''],['五日','',''],['五日热','',''],['五旬节','',''],['五时','',''],['五星','',''],['五星红旗','',''],['五星级','',''],['五星级酒店','',''],['五更','',''],['五月','',''],['五月份','',''],['五月节','',''],['五月花','',''],['五月天','',''],['五服','',''],['五权','',''],['五权宪法','',''],['五条','',''],['五楼','',''],['五次','',''],['五步蛇','',''],['五段','',''],['五毒','',''],['五毛','',''],['五毛党','',''],['五氧化二钒','',''],['五氯硝基苯','',''],['五洋','',''],['五洲','',''],['五洲四海','',''],['五湖','',''],['五湖四海','',''],['五灯会元','',''],['五点','',''],['五爱','',''],['五环','',''],['五环会徽','',''],['五痨七伤','',''],['五瘟','',''],['五瘟神','',''],['五百','',''],['五百万','',''],['五百年前是一家','',''],['五短身材','',''],['五碳糖','',''],['五祖拳','',''],['五福','',''],['五福临门','',''],['五禽戏','',''],['五种','',''],['五种经济成分','',''],['五笔','',''],['五笔字型','',''],['五笔字形','',''],['五笔编码','',''],['五笔输入法','',''],['五等爵位','',''],['五类分子','',''],['五粮液','',''],['五级','',''],['五级士官','',''],['五线谱','',''],['五经','',''],['五结','',''],['五结乡','',''],['五绝','',''],['五股','',''],['五股乡','',''],['五胞胎','',''],['五胡','',''],['五胡十六国','',''],['五脏','',''],['五脏俱全','',''],['五脏六腑','',''],['五色','',''],['五色无主','',''],['五色缤纷','',''],['五花','',''],['五花八门','',''],['五花大绑','',''],['五花肉','',''],['五花腌猪肉','',''],['五苓散','',''],['五荤','',''],['五营','',''],['五蕴','',''],['五虎将','',''],['五行','',''],['五行俱下','',''],['五行八作','',''],['五行并下','',''],['五角','',''],['五角场','',''],['五角大楼','',''],['五角形','',''],['五角星','',''],['五角钱','',''],['五言绝句','',''],['五言诗','',''],['五言长城','',''],['五讲','',''],['五讲四美','',''],['五谷','',''],['五谷不分','',''],['五谷丰熟','',''],['五谷丰登','',''],['五谷丰稔','',''],['五谷杂粮','',''],['五路','',''],['五载','',''],['五边','',''],['五边形','',''],['五通桥','',''],['五道','',''],['五道口','',''],['五部','',''],['五里','',''],['五里雾','',''],['五里雾中','',''],['五重奏','',''],['五金','',''],['五金店','',''],['五金店铺','',''],['五院','',''],['五陵','',''],['五陵年少','',''],['五陵豪气','',''],['五雀六燕','',''],['五霸','',''],['五面','',''],['五面体','',''],['五音','',''],['五音不全','',''],['五音度','',''],['五音节','',''],['五项','',''],['五项全能','',''],['五项全能运动','',''],['五项原则','',''],['五颜六色','',''],['五风十雨','',''],['五香','',''],['五香粉','',''],['五马分尸','',''],['五鬼','',''],['五鬼闹判','',''],['五黄六月','',''],['井下','',''],['井中求火','',''],['井中视星','',''],['井井','',''],['井井有条','',''],['井井有礼','',''],['井冈','',''],['井口','',''],['井台','',''],['井号','',''],['井喷','',''],['井场','',''],['井壁','',''],['井字','',''],['井巷','',''],['井底','',''],['井底之蛙','',''],['井底银瓶','',''],['井探','',''],['井机','',''],['井架','',''],['井栏','',''],['井水','',''],['井水不犯河水','',''],['井泵','',''],['井灌','',''],['井然','',''],['井然有序','',''],['井田','',''],['井田制','',''],['井盐','',''],['井盖','',''],['井筒','',''],['井绳','',''],['井臼亲操','',''],['井蛙之见','',''],['井蛙醯鸡','',''],['井边','',''],['井队','',''],['井陉矿','',''],['亘古','',''],['亘古不变','',''],['亘古亘今','',''],['亘古未有','',''],['亘古通今','',''],['亚丁','',''],['亚丁湾','',''],['亚临界','',''],['亚于','',''],['亚们','',''],['亚伦','',''],['亚伯','',''],['亚伯拉罕','',''],['亚克力','',''],['亚兰','',''],['亚共析钢','',''],['亚军','',''],['亚利安娜','',''],['亚利桑纳州','',''],['亚利桑那','',''],['亚利桑那州','',''],['亚力山大帝','',''],['亚努科维奇','',''],['亚单位','',''],['亚历山大・杜布切克','',''],['亚历山大大帝','',''],['亚历山大里亚','',''],['亚原子','',''],['亚变种','',''],['亚哈斯','',''],['亚喀巴','',''],['亚圣','',''],['亚太','',''],['亚太区','',''],['亚太地区','',''],['亚太经合会','',''],['亚太经济合作组织','',''],['亚寒带','',''],['亚尔发和奥米加','',''],['亚巴郎','',''],['亚平宁','',''],['亚平宁半岛','',''],['亚弗烈','',''],['亚当','',''],['亚当・斯密','',''],['亚当斯','',''],['亚当斯敦','',''],['亚得里亚海','',''],['亚所','',''],['亚拉巴马','',''],['亚拉巴马州','',''],['亚撒','',''],['亚文化','',''],['亚斯伯格','',''],['亚曼牙','',''],['亚曼牙乡','',''],['亚松森','',''],['亚格门农','',''],['亚欧','',''],['亚欧大陆','',''],['亚欧大陆桥','',''],['亚欧大陆腹地','',''],['亚比利尼','',''],['亚比玉','',''],['亚氏保加','',''],['亚洲','',''],['亚洲与太平洋','',''],['亚洲与太平洋地区','',''],['亚洲人','',''],['亚洲史','',''],['亚洲司','',''],['亚洲周刊','',''],['亚洲国家','',''],['亚洲地区','',''],['亚洲太平洋地区','',''],['亚洲开发银行','',''],['亚洲杯','',''],['亚洲纪录','',''],['亚洲足球联合会','',''],['亚热','',''],['亚热带','',''],['亚父','',''],['亚特兰大','',''],['亚琛','',''],['亚瑟','',''],['亚瑟士','',''],['亚瑟王','',''],['亚的斯亚贝巴','',''],['亚目','',''],['亚砷','',''],['亚砷酸','',''],['亚硝酸','',''],['亚硝酸异戊酯','',''],['亚硝酸盐','',''],['亚硝酸钠','',''],['亚硫酐','',''],['亚硫酸','',''],['亚硫酸盐','',''],['亚磷酸','',''],['亚种','',''],['亚科','',''],['亚穆苏克罗','',''],['亚符号模型','',''],['亚米拿达','',''],['亚类','',''],['亚纲','',''],['亚细亚','',''],['亚细亚洲','',''],['亚罗号','',''],['亚罗号事件','',''],['亚罗士打','',''],['亚美','',''],['亚美利加','',''],['亚美利加洲','',''],['亚联','',''],['亚肩迭背','',''],['亚裔','',''],['亚西尔・阿拉法特','',''],['亚词汇单元','',''],['亚词规则','',''],['亚该亚','',''],['亚赛','',''],['亚达薛西','',''],['亚运','',''],['亚运会','',''],['亚运村','',''],['亚述','',''],['亚速海','',''],['亚里士多德','',''],['亚里斯多德','',''],['亚金','',''],['亚铁','',''],['亚铁盐','',''],['亚门','',''],['亚非','',''],['亚非会议','',''],['亚非拉','',''],['亚音节单位','',''],['亚音速','',''],['亚音频','',''],['亚马孙','',''],['亚马孙河','',''],['亚马逊河','',''],['亚麻','',''],['亚麻子油','',''],['亚麻布','',''],['亚麻酸','',''],['亚齐','',''],['亚齐省','',''],['亚龙湾','',''],['些个','',''],['些子','',''],['些小','',''],['些微','',''],['些许','',''],['些须','',''],['亟亟','',''],['亟宜','',''],['亟待','',''],['亟欲','',''],['亟盼','',''],['亟需','',''],['亡人','',''],['亡佚','',''],['亡兵纪念日','',''],['亡命','',''],['亡命之徒','',''],['亡命徒','',''],['亡国','',''],['亡国之音','',''],['亡国奴','',''],['亡国灭种','',''],['亡国虏','',''],['亡失','',''],['亡戟得矛','',''],['亡故','',''],['亡母','',''],['亡灵','',''],['亡立锥之地','',''],['亡羊补牢','',''],['亡者','',''],['亡魂','',''],['亡魂丧胆','',''],['亡魂失魄','',''],['亢奋','',''],['亢旱','',''],['亢极之悔','',''],['亢直','',''],['亢进','',''],['亢进性','',''],['亢龙有悔','',''],['交上','',''],['交与','',''],['交九','',''],['交了','',''],['交互','',''],['交互式','',''],['交付','',''],['交付使用','',''],['交代','',''],['交会','',''],['交会法','',''],['交保','',''],['交保释放','',''],['交入','',''],['交公','',''],['交关','',''],['交兵','',''],['交出','',''],['交到','',''],['交割','',''],['交办','',''],['交加','',''],['交单','',''],['交卷','',''],['交卸','',''],['交叉','',''],['交叉口','',''],['交叉学科','',''],['交叉火力','',''],['交叉点','',''],['交叉着','',''],['交叉科学','',''],['交叉耐药性','',''],['交叉表','',''],['交叉路','',''],['交叉运球','',''],['交叉阴影线','',''],['交友','',''],['交变','',''],['交变流电','',''],['交变电场','',''],['交变电流','',''],['交变磁场','',''],['交叠','',''],['交口称誉','',''],['交口称赞','',''],['交合','',''],['交响','',''],['交响乐','',''],['交响乐团','',''],['交响乐队','',''],['交响曲','',''],['交响诗','',''],['交响金属','',''],['交售','',''],['交回','',''],['交困','',''],['交大','',''],['交头接耳','',''],['交契','',''],['交好','',''],['交媾','',''],['交存','',''],['交官','',''],['交寄','',''],['交尾','',''],['交工','',''],['交差','',''],['交帐','',''],['交并','',''],['交幻','',''],['交库','',''],['交底','',''],['交归','',''],['交往','',''],['交待','',''],['交心','',''],['交恶','',''],['交情','',''],['交感','',''],['交感性','',''],['交感神经','',''],['交战','',''],['交战中','',''],['交战团体','',''],['交战国','',''],['交战者','',''],['交手','',''],['交托','',''],['交拜','',''],['交换','',''],['交换代数','',''],['交换代数学','',''],['交换以太网络','',''],['交换价值','',''],['交换台','',''],['交换器','',''],['交换律','',''],['交换意见','',''],['交换技术','',''],['交换机','',''],['交换码','',''],['交换端','',''],['交换网路','',''],['交换虚电路','',''],['交接','',''],['交接仪式','',''],['交接班','',''],['交易','',''],['交易会','',''],['交易员','',''],['交易品','',''],['交易商','',''],['交易市场','',''],['交易所','',''],['交易日','',''],['交易者','',''],['交易额','',''],['交替','',''],['交朋友','',''],['交权','',''],['交来','',''],['交杯','',''],['交杯酒','',''],['交枪','',''],['交椅','',''],['交欢','',''],['交款','',''],['交款单','',''],['交汇','',''],['交汇处','',''],['交汇点','',''],['交流','',''],['交流会','',''],['交流发电机','',''],['交流声','',''],['交流电','',''],['交流电机','',''],['交浅言深','',''],['交涉','',''],['交清','',''],['交游','',''],['交火','',''],['交点','',''],['交班','',''],['交用','',''],['交由','',''],['交电','',''],['交界','',''],['交界处','',''],['交白卷','',''],['交相','',''],['交相辉映','',''],['交睫','',''],['交租','',''],['交租金','',''],['交税','',''],['交稿','',''],['交粮本','',''],['交纳','',''],['交织','',''],['交织物','',''],['交结','',''],['交结面','',''],['交给','',''],['交缠','',''],['交耦','',''],['交臂','',''],['交臂失之','',''],['交融','',''],['交角','',''],['交警','',''],['交谈','',''],['交谈式','',''],['交谊','',''],['交谊舞','',''],['交账','',''],['交货','',''],['交货期','',''],['交费','',''],['交足','',''],['交趾','',''],['交辉','',''],['交运','',''],['交还','',''],['交迫','',''],['交迭','',''],['交送','',''],['交通','',''],['交通协管员','',''],['交通卡','',''],['交通史','',''],['交通员','',''],['交通图','',''],['交通堵塞','',''],['交通壕','',''],['交通大学','',''],['交通岗','',''],['交通岛','',''],['交通工具','',''],['交通建设','',''],['交通意外','',''],['交通拥挤','',''],['交通枢纽','',''],['交通标志','',''],['交通管理局','',''],['交通线','',''],['交通肇事罪','',''],['交通规则','',''],['交通警卫','',''],['交通警察','',''],['交通费','',''],['交通车','',''],['交通部','',''],['交通量','',''],['交通阻塞','',''],['交道','',''],['交配','',''],['交钞','',''],['交钱','',''],['交锋','',''],['交错','',''],['交错法','',''],['交错觥筹','',''],['交际','',''],['交际性','',''],['交际舞','',''],['交际花','',''],['交集','',''],['交驰','',''],['交验','',''],['交齐','',''],['亥猪','',''],['亥豕鲁鱼','',''],['亦不','',''],['亦不例外','',''],['亦且','',''],['亦云','',''],['亦以','',''],['亦会','',''],['亦作','',''],['亦佳','',''],['亦即','',''],['亦可','',''],['亦同','',''],['亦喜亦忧','',''],['亦在','',''],['亦属','',''],['亦工亦农','',''],['亦庄','',''],['亦应','',''],['亦应如此','',''],['亦或','',''],['亦按','',''],['亦无','',''],['亦是','',''],['亦曾','',''],['亦有','',''],['亦步亦趋','',''],['亦然','',''],['亦称','',''],['亦要','',''],['亦趋','',''],['亦还','',''],['亦非','',''],['亦须','',''],['产下','',''],['产业','',''],['产业军','',''],['产业化','',''],['产业后备军','',''],['产业工人','',''],['产业界','',''],['产业资本','',''],['产业链','',''],['产业集群','',''],['产业革命','',''],['产中','',''],['产乳','',''],['产于','',''],['产仔','',''],['产供','',''],['产供销','',''],['产值','',''],['产假','',''],['产儿','',''],['产出','',''],['产出率','',''],['产制','',''],['产前','',''],['产前检查','',''],['产区','',''],['产卵','',''],['产卵洄游','',''],['产后','',''],['产后期','',''],['产品','',''],['产品税','',''],['产品经理','',''],['产品结构','',''],['产地','',''],['产地证','',''],['产士','',''],['产奶','',''],['产妇','',''],['产婆','',''],['产床','',''],['产房','',''],['产期','',''],['产术','',''],['产权','',''],['产检','',''],['产油','',''],['产油国','',''],['产物','',''],['产生','',''],['产生中','',''],['产生了','',''],['产科','',''],['产科医师','',''],['产科医生','',''],['产科学','',''],['产程','',''],['产籍','',''],['产粮','',''],['产粮区','',''],['产粮大省','',''],['产经新闻','',''],['产能','',''],['产自','',''],['产褥','',''],['产褥感染','',''],['产褥期','',''],['产褥热','',''],['产车','',''],['产道','',''],['产量','',''],['产量多','',''],['产金','',''],['产钳','',''],['产销','',''],['产销者','',''],['产销量','',''],['产门','',''],['产院','',''],['产额','',''],['产麦','',''],['亨利','',''],['亨利・哈德逊','',''],['亨利五世','',''],['亨德尔','',''],['亨格洛','',''],['亨特','',''],['亨特泰罗','',''],['亨祚','',''],['亨通','',''],['亩产','',''],['亩产量','',''],['亩数','',''],['享乐','',''],['享乐主义','',''],['享乐主义者','',''],['享利','',''],['享受','',''],['享名','',''],['享国','',''],['享寿','',''],['享尽','',''],['享年','',''],['享有','',''],['享有盛名','',''],['享有盛誉','',''],['享清福','',''],['享用','',''],['享福','',''],['享誉','',''],['京东大鼓','',''],['京九','',''],['京九铁路','',''],['京二胡','',''],['京京','',''],['京人','',''],['京兆','',''],['京剧','',''],['京剧团','',''],['京华','',''],['京华时报','',''],['京口','',''],['京哈','',''],['京哈铁路','',''],['京城','',''],['京师','',''],['京广','',''],['京广线','',''],['京广铁路','',''],['京戏','',''],['京报','',''],['京斯敦','',''],['京杭','',''],['京杭大运河','',''],['京杭运河','',''],['京汉','',''],['京沪','',''],['京沪高铁','',''],['京津','',''],['京派','',''],['京海','',''],['京湾','',''],['京片子','',''],['京畿','',''],['京畿道','',''],['京白','',''],['京胡','',''],['京腔','',''],['京西','',''],['京郊','',''],['京郊日报','',''],['京都','',''],['京都府','',''],['京都念慈菴枇杷膏','',''],['京韵','',''],['京韵大鼓','',''],['亭亭','',''],['亭亭玉立','',''],['亭午','',''],['亭台楼阁','',''],['亭子','',''],['亭子间','',''],['亭室','',''],['亭湖','',''],['亭里','',''],['亭阁','',''],['亮丑','',''],['亮丽','',''],['亮了','',''],['亮儿','',''],['亮光','',''],['亮光光','',''],['亮光区','',''],['亮出','',''],['亮堂','',''],['亮堂堂','',''],['亮察','',''],['亮底','',''],['亮度','',''],['亮彩','',''],['亮星','',''],['亮星云','',''],['亮晶晶','',''],['亮氨酸','',''],['亮点','',''],['亮牌','',''],['亮的','',''],['亮相','',''],['亮眼','',''],['亮眼人','',''],['亮着','',''],['亮色','',''],['亮节','',''],['亮菌','',''],['亮菌甲素','',''],['亮起','',''],['亮铮铮','',''],['亮锃锃','',''],['亮闪闪','',''],['亮饰','',''],['亲丁','',''],['亲上做亲','',''],['亲上加亲','',''],['亲上成亲','',''],['亲临','',''],['亲临其境','',''],['亲了','',''],['亲事','',''],['亲交','',''],['亲亲','',''],['亲亲热热','',''],['亲人','',''],['亲从','',''],['亲代','',''],['亲们','',''],['亲任','',''],['亲伴','',''],['亲使','',''],['亲俄','',''],['亲信','',''],['亲兄弟','',''],['亲公','',''],['亲兵','',''],['亲函','',''],['亲切','',''],['亲切友好','',''],['亲切服务','',''],['亲力亲为','',''],['亲北京','',''],['亲华','',''],['亲历','',''],['亲友','',''],['亲取','',''],['亲口','',''],['亲合力','',''],['亲启','',''],['亲吻','',''],['亲和','',''],['亲和力','',''],['亲和性','',''],['亲善','',''],['亲善大使','',''],['亲嘴','',''],['亲多','',''],['亲夫','',''],['亲如一家','',''],['亲如手足','',''],['亲如骨肉','',''],['亲妈','',''],['亲姐妹','',''],['亲娘','',''],['亲子','',''],['亲子鉴定','',''],['亲家','',''],['亲家公','',''],['亲家母','',''],['亲密','',''],['亲密无间','',''],['亲属','',''],['亲属制度','',''],['亲属称谓','',''],['亲当矢石','',''],['亲征','',''],['亲德','',''],['亲情','',''],['亲戚','',''],['亲手','',''],['亲授','',''],['亲操井臼','',''],['亲政','',''],['亲故','',''],['亲族','',''],['亲日','',''],['亲旧','',''],['亲昵','',''],['亲朋','',''],['亲朋好友','',''],['亲本','',''],['亲权','',''],['亲母','',''],['亲民','',''],['亲民党','',''],['亲水性','',''],['亲水长廊','',''],['亲洽','',''],['亲炙','',''],['亲热','',''],['亲爱','',''],['亲爱人','',''],['亲爱的','',''],['亲父','',''],['亲爸','',''],['亲爹','',''],['亲率','',''],['亲王','',''],['亲生','',''],['亲生子女','',''],['亲生父母','',''],['亲生骨肉','',''],['亲疏','',''],['亲疏贵贱','',''],['亲痛仇快','',''],['亲目','',''],['亲眷','',''],['亲眼','',''],['亲眼目睹','',''],['亲睦','',''],['亲睦邻邦','',''],['亲知','',''],['亲离','',''],['亲笔','',''],['亲笔信','',''],['亲笔写','',''],['亲缘','',''],['亲缘关系','',''],['亲美','',''],['亲者','',''],['亲耳','',''],['亲职','',''],['亲脸','',''],['亲自','',''],['亲自出马','',''],['亲自动手','',''],['亲自挂帅','',''],['亲英','',''],['亲贵','',''],['亲赴','',''],['亲身','',''],['亲迎','',''],['亲近','',''],['亲随','',''],['亲验','',''],['亲骨','',''],['亲骨肉','',''],['亵慢','',''],['亵昵','',''],['亵渎','',''],['亵渎的话','',''],['亵渎神明','',''],['亵渎者','',''],['亵玩','',''],['亵黩','',''],['亹亹','',''],['亹亹不倦','',''],['人一已百','',''],['人丁','',''],['人丁兴旺','',''],['人不为己','',''],['人不可貌相','',''],['人不犯我我不犯人','',''],['人不知鬼不觉','',''],['人不聊生','',''],['人不自安','',''],['人与人之间','',''],['人世','',''],['人世间','',''],['人丛','',''],['人中','',''],['人中之龙','',''],['人中狮子','',''],['人中穴','',''],['人中骐骥','',''],['人中龙虎','',''],['人丹','',''],['人为','',''],['人之初','',''],['人之常情','',''],['人之长情','',''],['人乳','',''],['人事','',''],['人事不知','',''],['人事代谢','',''],['人事制度','',''],['人事厅','',''],['人事变动','',''],['人事处','',''],['人事局','',''],['人事心理学','',''],['人事监察','',''],['人事科','',''],['人事管理','',''],['人事管理学','',''],['人事费','',''],['人事部门','',''],['人云','',''],['人云亦云','',''],['人五人六','',''],['人亡家破','',''],['人亡政息','',''],['人亡物在','',''],['人人','',''],['人人乐从','',''],['人人平等','',''],['人人有责','',''],['人人皆知','',''],['人人自危','',''],['人代会','',''],['人以群分','',''],['人们','',''],['人仰马翻','',''],['人份','',''],['人众胜天','',''],['人传人','',''],['人传记','',''],['人伦','',''],['人位相宜','',''],['人体','',''],['人体器官','',''],['人体学','',''],['人体工学','',''],['人体科学','',''],['人体解剖','',''],['人体解剖学','',''],['人保','',''],['人偶戏','',''],['人像','',''],['人像图','',''],['人儿','',''],['人公里','',''],['人力','',''],['人力资源','',''],['人力车','',''],['人力车夫','',''],['人势','',''],['人千人万','',''],['人去楼空','',''],['人参','',''],['人口','',''],['人口出生率','',''],['人口分布','',''],['人口分析','',''],['人口危机','',''],['人口地理','',''],['人口地理学','',''],['人口增长','',''],['人口学','',''],['人口密度','',''],['人口战略','',''],['人口政策','',''],['人口数','',''],['人口断层','',''],['人口普查','',''],['人口社会学','',''],['人口稠密','',''],['人口经济学','',''],['人口统计','',''],['人口统计学','',''],['人口老化','',''],['人口规划','',''],['人口调查','',''],['人口贩运','',''],['人口资料','',''],['人口迁移','',''],['人口预测','',''],['人各有志','',''],['人各有所好','',''],['人同此心','',''],['人名','',''],['人员','',''],['人员构成','',''],['人员测评','',''],['人命','',''],['人命关天','',''],['人命危浅','',''],['人和','',''],['人品','',''],['人品好','',''],['人喊马嘶','',''],['人困马乏','',''],['人在江湖','',''],['人地生疏','',''],['人均','',''],['人均产值','',''],['人均收入','',''],['人堆','',''],['人士','',''],['人声','',''],['人声鼎沸','',''],['人多势众','',''],['人多口杂','',''],['人多嘴杂','',''],['人多地少','',''],['人多手杂','',''],['人大','',''],['人大代表','',''],['人大常委会','',''],['人夫','',''],['人头','',''],['人头狮身','',''],['人头畜鸣','',''],['人头皮','',''],['人头税','',''],['人头蛇身','',''],['人头马','',''],['人奶','',''],['人妖','',''],['人子','',''],['人字拖','',''],['人字拖鞋','',''],['人字架','',''],['人存政举','',''],['人定','',''],['人定胜天','',''],['人客','',''],['人家','',''],['人寰','',''],['人对人','',''],['人寿','',''],['人寿保险','',''],['人寿年丰','',''],['人尖儿','',''],['人尽其才','',''],['人尽其材','',''],['人山人海','',''],['人工','',''],['人工免疫','',''],['人工化','',''],['人工受孕','',''],['人工合成','',''],['人工呼吸','',''],['人工品','',''],['人工岛','',''],['人工干预','',''],['人工技术','',''],['人工授精','',''],['人工智慧','',''],['人工智能','',''],['人工杂交','',''],['人工概念','',''],['人工气胸','',''],['人工气腹','',''],['人工河','',''],['人工流产','',''],['人工湖','',''],['人工照亮','',''],['人工电子耳','',''],['人工耳蜗','',''],['人工诱变','',''],['人工选择','',''],['人工降水','',''],['人工降雨','',''],['人师','',''],['人弃我取','',''],['人强马壮','',''],['人形','',''],['人形靶','',''],['人影','',''],['人影儿','',''],['人微权轻','',''],['人微言轻','',''],['人心','',''],['人心不古','',''],['人心不足蛇吞象','',''],['人心叵测','',''],['人心向背','',''],['人心大快','',''],['人心如面','',''],['人心惟危','',''],['人心惶恐','',''],['人心惶惶','',''],['人心所向','',''],['人心所归','',''],['人心果','',''],['人心涣散','',''],['人心涣漓','',''],['人心皇皇','',''],['人心莫测','',''],['人心隔肚皮','',''],['人心难测','',''],['人怕出名猪怕壮','',''],['人怕出名猪怕肥','',''],['人急智生','',''],['人急计生','',''],['人性','',''],['人性化','',''],['人性论','',''],['人怨神怒','',''],['人情','',''],['人情世故','',''],['人情之常','',''],['人情债','',''],['人情冷暖','',''],['人情味','',''],['人情味儿','',''],['人情汹汹','',''],['人意','',''],['人我是非','',''],['人或物','',''],['人所不为','',''],['人所不齿','',''],['人所共知','',''],['人手','',''],['人手一册','',''],['人手不足','',''],['人手动','',''],['人才','',''],['人才出众','',''],['人才培养','',''],['人才外流','',''],['人才学','',''],['人才流动','',''],['人才流失','',''],['人才济济','',''],['人才辈出','',''],['人才难得','',''],['人数','',''],['人数众多','',''],['人文','',''],['人文主义','',''],['人文地理','',''],['人文地理学','',''],['人文学','',''],['人文景观','',''],['人文社会学科','',''],['人文社科','',''],['人文科学','',''],['人族','',''],['人无外快不富','',''],['人无完人','',''],['人无远虑','',''],['必有近忧','',''],['人无远虑必有近忧','',''],['人有旦夕祸福','',''],['人本主义','',''],['人机交互','',''],['人机工程','',''],['人机界面','',''],['人权','',''],['人权保障','',''],['人权宣言','',''],['人权斗士','',''],['人权法','',''],['人权观察','',''],['人材','',''],['人来人往','',''],['人来客去','',''],['人来客往','',''],['人来疯','',''],['人杰','',''],['人杰地灵','',''],['人样','',''],['人格','',''],['人格化','',''],['人格心理学','',''],['人格操守','',''],['人格神','',''],['人格违常','',''],['人格魅力','',''],['人模狗样','',''],['人次','',''],['人欢马叫','',''],['人欲横流','',''],['人武部','',''],['人死留名','',''],['人氏','',''],['人民','',''],['人民代表','',''],['人民代表大会','',''],['人民代表大会制','',''],['人民党','',''],['人民公敌','',''],['人民公社','',''],['人民公社化','',''],['人民共和国','',''],['人民内部矛盾','',''],['人民出版社','',''],['人民利益','',''],['人民团体','',''],['人民基本权利','',''],['人民大会堂','',''],['人民币','',''],['人民币元','',''],['人民广场','',''],['人民性','',''],['人民战争','',''],['人民政府','',''],['人民日报','',''],['人民检察院','',''],['人民检查院','',''],['人民民主专政','',''],['人民民主统一战线','',''],['人民法庭','',''],['人民法院','',''],['人民网','',''],['人民群众','',''],['人民联盟党','',''],['人民英雄纪念碑','',''],['人民行动党','',''],['人民解放军','',''],['人民警察','',''],['人民起义','',''],['人民阵线','',''],['人民陪审员','',''],['人气','',''],['人治','',''],['人流','',''],['人流手术','',''],['人流行','',''],['人浮于事','',''],['人海','',''],['人海战术','',''],['人渣','',''],['人满为患','',''],['人潮','',''],['人烟','',''],['人烟凑集','',''],['人烟浩穰','',''],['人烟稀少','',''],['人烟稠密','',''],['人烟辐辏','',''],['人物','',''],['人物志','',''],['人物描写','',''],['人物画','',''],['人犯','',''],['人猿','',''],['人琴俱亡','',''],['人生','',''],['人生一世','',''],['人生价值','',''],['人生哲学','',''],['人生在世','',''],['人生地不熟','',''],['人生如朝露','',''],['人生如梦','',''],['人生朝露','',''],['人生盛衰','',''],['人生短暂','',''],['人生观','',''],['人生路不熟','',''],['人生面不熟','',''],['人畜','',''],['人畜共患症','',''],['人百其身','',''],['人皆尽知','',''],['人皆有之','',''],['人相','',''],['人相学','',''],['人神共愤','',''],['人神同愤','',''],['人种','',''],['人种差别','',''],['人种间','',''],['人称','',''],['人称代词','',''],['人稠物穰','',''],['人穷志短','',''],['人穷智短','',''],['人算不如天算','',''],['人类','',''],['人类乳突病毒','',''],['人类免疫缺陷病毒','',''],['人类化','',''],['人类基因组计划','',''],['人类学','',''],['人类学家','',''],['人类工程学','',''],['人类文化学','',''],['人类社会','',''],['人类起源','',''],['人粪尿','',''],['人精','',''],['人约黄昏','',''],['人给家足','',''],['人缘','',''],['人缘儿','',''],['人网','',''],['人群','',''],['人老珠黄','',''],['人者','',''],['人而无信不知其可','',''],['人肉','',''],['人肉搜索','',''],['人肉搜索引擎','',''],['人脉','',''],['人脉关系','',''],['人脏俱获','',''],['人脑','',''],['人臣','',''],['人自为战','',''],['人莫予毒','',''],['人莫于毒','',''],['人蛇','',''],['人蛇集团','',''],['人血','',''],['人行区','',''],['人行地下通道','',''],['人行桥','',''],['人行横道','',''],['人行横道线','',''],['人行道','',''],['人见人爱','',''],['人言凿凿','',''],['人言可畏','',''],['人言啧啧','',''],['人言籍籍','',''],['人证','',''],['人证物证','',''],['人证物证俱在','',''],['人语马嘶','',''],['人说纷纭','',''],['人谁无过','',''],['人谋','',''],['人财两失','',''],['人财两旺','',''],['人财两空','',''],['人质','',''],['人贩子','',''],['人贪智短','',''],['人贵有自知之明','',''],['人赃','',''],['人走灯灭','',''],['人身','',''],['人身事故','',''],['人身保险','',''],['人身安全','',''],['人身攻击','',''],['人身权','',''],['人身自由','',''],['人车混行','',''],['人迹','',''],['人迹稀少','',''],['人迹罕到','',''],['人迹罕至','',''],['人选','',''],['人造','',''],['人造丝','',''],['人造冰','',''],['人造卫星','',''],['人造地球卫星','',''],['人造天体','',''],['人造棉','',''],['人造橡胶','',''],['人造毛','',''],['人造皮','',''],['人造石油','',''],['人造磁铁','',''],['人造纤维','',''],['人造行星','',''],['人造语言','',''],['人造革','',''],['人逢喜事精神爽','',''],['人道','',''],['人道主义','',''],['人道救援','',''],['人间','',''],['人间佛教','',''],['人间喜剧','',''],['人间地狱','',''],['人间天上','',''],['人间天堂','',''],['人间蒸发','',''],['人际','',''],['人际关系','',''],['人际服务','',''],['人际艺术','',''],['人静','',''],['人非土木','',''],['人非生而知之者','',''],['人非草木','',''],['人面兽心','',''],['人面桃花','',''],['人首','',''],['人马','',''],['人马座','',''],['人马臂','',''],['人高马大','',''],['人鱼','',''],['人鱼小姐','',''],['人龙','',''],['亿万','',''],['亿万人民','',''],['亿万富翁','',''],['亿万富豪','',''],['亿万斯年','',''],['亿万群众','',''],['亿亩','',''],['亿元','',''],['亿兆','',''],['亿分之一','',''],['亿吨','',''],['亿斤','',''],['亿秒','',''],['什一之利','',''],['什一奉献','',''],['什么','',''],['什么事','',''],['什么人','',''],['什么地方','',''],['什么时候','',''],['什么样','',''],['什件','',''],['什件儿','',''],['什刹海','',''],['什午','',''],['什叶','',''],['什叶派','',''],['什器','',''],['什物','',''],['什菜','',''],['什袭而藏','',''],['什锦','',''],['什锦果盘','',''],['什锦菜','',''],['什麽','',''],['什麽事','',''],['什麽时候','',''],['什麽的','',''],['仁丹','',''],['仁义','',''],['仁义之师','',''],['仁义道德','',''],['仁人','',''],['仁人义士','',''],['仁人君子','',''],['仁人志士','',''],['仁兄','',''],['仁医','',''],['仁厚','',''],['仁和','',''],['仁和县','',''],['仁堂','',''],['仁学','',''],['仁川','',''],['仁川市','',''],['仁川广域市','',''],['仁弟','',''],['仁德','',''],['仁德乡','',''],['仁心','',''],['仁心仁术','',''],['仁怀县','',''],['仁惠','',''],['仁慈','',''],['仁政','',''],['仁术','',''],['仁果','',''],['仁武','',''],['仁武乡','',''],['仁民爱物','',''],['仁波切','',''],['仁爱','',''],['仁爱乡','',''],['仁爱区','',''],['仁者','',''],['仁者见仁','',''],['仁至','',''],['仁至义尽','',''],['仁言利博','',''],['仁题','',''],['仂语','',''],['仄声','',''],['仄径','',''],['仅为','',''],['仅于','',''],['仅仅','',''],['仅仅如此','',''],['仅仅是','',''],['仅以','',''],['仅以身免','',''],['仅作参考','',''],['仅供','',''],['仅供参考','',''],['仅值','',''],['仅凭','',''],['仅占','',''],['仅及','',''],['仅只','',''],['仅可','',''],['仅在','',''],['仅存','',''],['仅对','',''],['仅就','',''],['仅懂','',''],['仅把','',''],['仅指','',''],['仅据','',''],['仅是','',''],['仅有','',''],['仅次','',''],['仅次于','',''],['仅此','',''],['仅此而已','',''],['仅用','',''],['仅穿','',''],['仅能','',''],['仅见','',''],['仅限','',''],['仅靠','',''],['仆人','',''],['仆仆','',''],['仆仆风尘','',''],['仆从','',''],['仆妇','',''],['仆役','',''],['仆后','',''],['仆街','',''],['仇人','',''],['仇外','',''],['仇外心理','',''],['仇家','',''],['仇富','',''],['仇心','',''],['仇快','',''],['仇念','',''],['仇怨','',''],['仇恨','',''],['仇恨罪','',''],['仇恨罪行','',''],['仇惧','',''],['仇报','',''],['仇敌','',''],['仇杀','',''],['仇者','',''],['仇视','',''],['仇隙','',''],['仇雠','',''],['今不如昔','',''],['今世','',''],['今为','',''],['今人','',''],['今以','',''],['今儿','',''],['今儿个','',''],['今冬','',''],['今冬明春','',''],['今古传奇','',''],['今古奇闻','',''],['今古文','',''],['今后','',''],['今后任务','',''],['今夏','',''],['今夜','',''],['今事','',''],['今诗','',''],['今尹','',''],['今岁','',''],['今年底','',''],['今愁古恨','',''],['今文','',''],['今文经','',''],['今文经学','',''],['今日','',''],['今日事今日毕','',''],['今时今日','',''],['今明两天','',''],['今明两年','',''],['今昔','',''],['今昔之感','',''],['今昔对比','',''],['今春','',''],['今是','',''],['今是昨非','',''],['今晚','',''],['今晨','',''],['今月古月','',''],['今朝','',''],['今期','',''],['今村','',''],['今来古往','',''],['今次','',''],['今生','',''],['今生今世','',''],['今番','',''],['今秋','',''],['今草','',''],['今译','',''],['今起','',''],['今非昔比','',''],['今音','',''],['介之推','',''],['介乎','',''],['介于','',''],['介于两难','',''],['介体','',''],['介入','',''],['介在','',''],['介壳','',''],['介子','',''],['介子推','',''],['介怀','',''],['介意','',''],['介电常数','',''],['介系词','',''],['介绍','',''],['介绍人','',''],['介绍信','',''],['介绍性','',''],['介胄','',''],['介蒂','',''],['介词','',''],['介质','',''],['介质访问控制','',''],['介质访问控制层','',''],['介面','',''],['介音','',''],['仍不','',''],['仍以','',''],['仍会','',''],['仍停留','',''],['仍可','',''],['仍在','',''],['仍将','',''],['仍按','',''],['仍旧','',''],['仍是','',''],['仍有','',''],['仍未','',''],['仍然','',''],['仍照','',''],['仍由','',''],['仍系','',''],['仍能','',''],['仍需','',''],['仍须','',''],['从一以终','',''],['从一而终','',''],['从一般意义上','',''],['从上','',''],['从上到下','',''],['从上往下','',''],['从下','',''],['从下到上','',''],['从不','',''],['从不间断','',''],['从世','',''],['从业','',''],['从业人员','',''],['从业员','',''],['从东','',''],['从东向西','',''],['从严','',''],['从严惩处','',''],['从严治党','',''],['从中','',''],['从中作梗','',''],['从中央到地方','',''],['从事','',''],['从事于','',''],['从事研究','',''],['从于','',''],['从井救人','',''],['从仆','',''],['从今','',''],['从今之后','',''],['从今以后','',''],['从今天起','',''],['从今年起','',''],['从今往后','',''],['从从容容','',''],['从令如流','',''],['从以后','',''],['从价','',''],['从价税','',''],['从任何意义上','',''],['从优','',''],['从低','',''],['从何','',''],['从何下手','',''],['从何谈起','',''],['从俗','',''],['从俗就简','',''],['从先','',''],['从其','',''],['从内','',''],['从军','',''],['从刊','',''],['从刑','',''],['从前','',''],['从动','',''],['从北到南','',''],['从北向南','',''],['从南到北','',''],['从古到今','',''],['从古至今','',''],['从句','',''],['从右','',''],['从右到左','',''],['从各个方面','',''],['从命','',''],['从商','',''],['从善','',''],['从善如流','',''],['从善如登从恶如崩','',''],['从外到里','',''],['从外部','',''],['从大处着眼','',''],['从大局出发','',''],['从天而降','',''],['从头','',''],['从头到尾','',''],['从头到脚','',''],['从头开始','',''],['从头至尾','',''],['从始至终','',''],['从实际出发','',''],['从实际情况出发','',''],['从容','',''],['从容不迫','',''],['从容就义','',''],['从容自若','',''],['从宽','',''],['从宽发落','',''],['从宽处理','',''],['从小','',''],['从小到大','',''],['从小处着手','',''],['从尾','',''],['从属','',''],['从属于','',''],['从属国','',''],['从工作出发','',''],['从左','',''],['从左到右','',''],['从师','',''],['从开始起','',''],['从征','',''],['从心所欲','',''],['从总体上','',''],['从总的情况','',''],['从戎','',''],['从我做起','',''],['从打','',''],['从技术上','',''],['从政','',''],['从文','',''],['从新','',''],['从无到有','',''],['从早','',''],['从早到晚','',''],['从明年起','',''],['从未','',''],['从未有过','',''],['从未用过','',''],['从权','',''],['从来','',''],['从来不','',''],['从来没','',''],['从来没有','',''],['从来没有过','',''],['从某种意义上','',''],['从某种程度上','',''],['从根本上','',''],['从此','',''],['从此以后','',''],['从此往后','',''],['从母','',''],['从没','',''],['从父','',''],['从犯','',''],['从现在做起','',''],['从现在开始','',''],['从现在起','',''],['从略','',''],['从简','',''],['从紧','',''],['从缓','',''],['从群众中来','',''],['从者','',''],['从而','',''],['从良','',''],['从表面上看','',''],['从西向东','',''],['从谏如流','',''],['从轮','',''],['从轻','',''],['从辈','',''],['从这','',''],['从这一点','',''],['从这个意义上','',''],['从这个角度上','',''],['从这以后','',''],['从这时起','',''],['从速','',''],['从那','',''],['从那时','',''],['从那时起','',''],['从那里','',''],['从里','',''],['从里到外','',''],['从重','',''],['从重从快','',''],['从量','',''],['从量税','',''],['从长计议','',''],['从长远来看','',''],['从长远看','',''],['从难从严','',''],['从革命利益出发','',''],['从领导做起','',''],['从风而靡','',''],['从高','',''],['仑背','',''],['仑背乡','',''],['仓促','',''],['仓储','',''],['仓卒','',''],['仓卒防御','',''],['仓山','',''],['仓库','',''],['仓库管理','',''],['仓廪','',''],['仓惶','',''],['仓房','',''],['仓敷','',''],['仓猝','',''],['仓皇','',''],['仓皇出逃','',''],['仓皇失措','',''],['仓皇无措','',''],['仓租','',''],['仓颉','',''],['仓黄','',''],['仓鼠','',''],['仔仔细细','',''],['仔姜','',''],['仔密','',''],['仔服','',''],['仔牛','',''],['仔猪白痢','',''],['仔畜','',''],['仔细','',''],['仔肩','',''],['仕女','',''],['仕宦','',''],['仕进','',''],['仕途','',''],['他乡','',''],['他乡遇故知','',''],['他事','',''],['他人','',''],['他们','',''],['他信','',''],['他俩','',''],['他加禄语','',''],['他国','',''],['他妈','',''],['他妈的','',''],['他家','',''],['他山之攻','',''],['他山之石','',''],['他山之石可以攻玉','',''],['他州','',''],['他很','',''],['他方','',''],['他日','',''],['他本人','',''],['他杀','',''],['他死了','',''],['他活到','',''],['他物','',''],['他累了','',''],['他被','',''],['他迁','',''],['仗义','',''],['仗义执言','',''],['仗义疏财','',''],['仗势','',''],['仗势欺人','',''],['仗恃','',''],['仗火','',''],['仗腰','',''],['仗莫如信','',''],['仗马寒蝉','',''],['付与','',''],['付丙','',''],['付之一叹','',''],['付之一哂','',''],['付之一炬','',''],['付之一笑','',''],['付之丙丁','',''],['付之东流','',''],['付之度外','',''],['付了','',''],['付予','',''],['付出','',''],['付印','',''],['付品','',''],['付帐','',''],['付得','',''],['付息','',''],['付托','',''],['付排','',''],['付方','',''],['付本','',''],['付梓','',''],['付款','',''],['付款人','',''],['付款方式','',''],['付款条件','',''],['付款者','',''],['付款额','',''],['付清','',''],['付清了','',''],['付现','',''],['付税','',''],['付给','',''],['付讫','',''],['付诸','',''],['付诸东流','',''],['付诸实施','',''],['付诸实现','',''],['付诸洪乔','',''],['付账','',''],['付货','',''],['付费','',''],['付迄','',''],['付还','',''],['付邮','',''],['付酬','',''],['付金','',''],['付钱','',''],['仙丹','',''],['仙乐','',''],['仙乡','',''],['仙人','',''],['仙人掌','',''],['仙人掌果','',''],['仙人球','',''],['仙人鞭','',''],['仙似','',''],['仙去','',''],['仙台','',''],['仙后座','',''],['仙国','',''],['仙境','',''],['仙女','',''],['仙女似','',''],['仙女座','',''],['仙女座大星云','',''],['仙女座星系','',''],['仙女星座','',''],['仙女星系','',''],['仙女棒','',''],['仙姑','',''],['仙姿玉色','',''],['仙子','',''],['仙客来','',''],['仙宫','',''],['仙山','',''],['仙山琼阁','',''],['仙岛','',''],['仙方','',''],['仙方儿','',''],['仙景','',''],['仙术','',''],['仙果','',''],['仙气','',''],['仙王座','',''],['仙界','',''],['仙童','',''],['仙翁','',''],['仙花','',''],['仙草','',''],['仙药','',''],['仙踪','',''],['仙逝','',''],['仙都','',''],['仙镜','',''],['仙露明珠','',''],['仙风道骨','',''],['仙鹤','',''],['仙鹤草','',''],['仟悔','',''],['代为','',''],['代为说项','',''],['代之','',''],['代之以','',''],['代之而起','',''],['代书','',''],['代书人','',''],['代买','',''],['代乳粉','',''],['代交','',''],['代人','',''],['代人捉刀','',''],['代付','',''],['代代','',''],['代代相传','',''],['代代花','',''],['代价','',''],['代偿','',''],['代入','',''],['代写','',''],['代利斯','',''],['代办','',''],['代办处','',''],['代办所','',''],['代劳','',''],['代卖','',''],['代号','',''],['代名','',''],['代名词','',''],['代售','',''],['代回','',''],['代垫','',''],['代培','',''],['代培生','',''],['代填','',''],['代孕','',''],['代宗','',''],['代客','',''],['代客泊车','',''],['代尔','',''],['代尔夫特','',''],['代工','',''],['代币','',''],['代市长','',''],['代序','',''],['代庖','',''],['代征','',''],['代总理','',''],['代总统','',''],['代我','',''],['代扣','',''],['代拆代行','',''],['代拿买特','',''],['代换','',''],['代接','',''],['代摊','',''],['代支','',''],['代收','',''],['代收货款','',''],['代数','',''],['代数几何','',''],['代数几何学','',''],['代数函数','',''],['代数函数论','',''],['代数和','',''],['代数基本定理','',''],['代数学','',''],['代数学基本定理','',''],['代数式','',''],['代数拓扑','',''],['代数数域','',''],['代数方程','',''],['代数曲线','',''],['代数曲面','',''],['代数流行','',''],['代数簇','',''],['代数结构','',''],['代数群','',''],['代数量','',''],['代替','',''],['代替父母','',''],['代替者','',''],['代步','',''],['代沟','',''],['代派','',''],['代理','',''],['代理人','',''],['代理商','',''],['代理权','',''],['代理者','',''],['代用','',''],['代用品','',''],['代用者','',''],['代田法','',''],['代电','',''],['代省长','',''],['代码','',''],['代码段','',''],['代码页','',''],['代祷','',''],['代称','',''],['代笔','',''],['代笔人','',''],['代签','',''],['代管','',''],['代糖','',''],['代编','',''],['代罪','',''],['代罪羔羊','',''],['代考','',''],['代耕','',''],['代职','',''],['代脉','',''],['代营','',''],['代行','',''],['代表','',''],['代表人','',''],['代表人物','',''],['代表会','',''],['代表会议','',''],['代表作','',''],['代表团','',''],['代表处','',''],['代表大会','',''],['代表性','',''],['代表队','',''],['代言','',''],['代言人','',''],['代订','',''],['代议制','',''],['代记','',''],['代诉','',''],['代诉人','',''],['代词','',''],['代说','',''],['代课','',''],['代谋','',''],['代谢','',''],['代谢物','',''],['代购','',''],['代辖','',''],['代辩','',''],['代辩者','',''],['代部长','',''],['代金','',''],['代销','',''],['代销店','',''],['代问好','',''],['代顿','',''],['代领','',''],['令亲','',''],['令人','',''],['令人不安','',''],['令人不快','',''],['令人作呕','',''],['令人信服','',''],['令人兴奋','',''],['令人发指','',''],['令人叹','',''],['令人叹为观止','',''],['令人吃惊','',''],['令人喷饭','',''],['令人惊异','',''],['令人感动','',''],['令人振奋','',''],['令人捧腹','',''],['令人气结','',''],['令人注目','',''],['令人深思','',''],['令人满意','',''],['令人生畏','',''],['令人神往','',''],['令人费解','',''],['令人钦佩','',''],['令人难以置信','',''],['令人难忘','',''],['令人鼓舞','',''],['令人齿冷','',''],['令他','',''],['令兄','',''],['令其','',''],['令出','',''],['令出如山','',''],['令出惟行','',''],['令叔','',''],['令名','',''],['令堂','',''],['令她','',''],['令妹','',''],['令导人','',''],['令尊','',''],['令尊令堂','',''],['令弟','',''],['令慈','',''],['令我','',''],['令正','',''],['令爱','',''],['令牌环','',''],['令牌环网','',''],['令状','',''],['令狐','',''],['令狐德棻','',''],['令科','',''],['令箭','',''],['令箭荷花','',''],['令节','',''],['令药','',''],['令行禁止','',''],['令誉','',''],['令郎','',''],['令阃','',''],['以一击十','',''],['以一奉百','',''],['以一当十','',''],['以一持万','',''],['以一知万','',''],['以一警百','',''],['以一驭万','',''],['以上','',''],['以下','',''],['以东','',''],['以为','',''],['以事实为根据','',''],['以人为本','',''],['以人名命名','',''],['以人废言','',''],['以亿计','',''],['以便','',''],['以债养债','',''],['以假乱真','',''],['以偏概全','',''],['以儆效尤','',''],['以免','',''],['以免借口','',''],['以其人之道','',''],['以内','',''],['以军','',''],['以冰致蝇','',''],['以利于','',''],['以利亚','',''],['以利亚撒','',''],['以利亚敬','',''],['以利再战','',''],['以前','',''],['以力服人','',''],['以功补过','',''],['以功覆过','',''],['以功赎罪','',''],['以劳养武','',''],['以势压人','',''],['以北','',''],['以升量石','',''],['以华制华','',''],['以南','',''],['以卵击石','',''],['以卵投石','',''],['以及','',''],['以及人之幼','',''],['以及人之老','',''],['以叙','',''],['以古方今','',''],['以古非今','',''],['以后','',''],['以咽废飧','',''],['以售其奸','',''],['以埃','',''],['以备不测','',''],['以外','',''],['以夜继日','',''],['以太','',''],['以太网','',''],['以太网络','',''],['以太网络帧','',''],['以太网络端口','',''],['以失败而告终','',''],['以夷伐夷','',''],['以夷制夷','',''],['以夷治夷','',''],['以子之矛','',''],['以容取人','',''],['以小人之心','',''],['以小挤大','',''],['以小见大','',''],['以少胜多','',''],['以屈求申','',''],['以工代赈','',''],['以工补农','',''],['以己度人','',''],['以弗所','',''],['以弗所书','',''],['以弱制强','',''],['以弱胜强','',''],['以强凌弱','',''],['以往','',''],['以往鉴来','',''],['以律','',''],['以微知著','',''],['以德报德','',''],['以德报怨','',''],['以德抱怨','',''],['以德服人','',''],['以怨报德','',''],['以意逆志','',''],['以慎为键','',''],['以战去战','',''],['以手加额','',''],['以指挠佛','',''],['以撒','',''],['以攻为守','',''],['以文会友','',''],['以文害辞','',''],['以斯帖','',''],['以斯帖记','',''],['以斯拉记','',''],['以日为岁','',''],['以日为年','',''],['以日继夜','',''],['以旧换新','',''],['以暴制暴','',''],['以暴易暴','',''],['以期','',''],['以本人名','',''],['以杀去杀','',''],['以杀止杀','',''],['以权压法','',''],['以权谋私','',''],['以李报桃','',''],['以来','',''],['以柔克刚','',''],['以柔制刚','',''],['以次','',''],['以次充好','',''],['以此','',''],['以此为','',''],['以此为准','',''],['以此为荣','',''],['以此类推','',''],['以毒攻毒','',''],['以水救水','',''],['以水济水','',''],['以求','',''],['以求一逞','',''],['以汤止沸','',''],['以汤沃沸','',''],['以汤沃雪','',''],['以法律为准绳','',''],['以法莲','',''],['以火救火','',''],['以点带面','',''],['以然','',''],['以牙还牙','',''],['以狸致鼠','',''],['以狸饵鼠','',''],['以珠弹雀','',''],['以理服人','',''],['以白为黑','',''],['以盲辨色','',''],['以直报怨','',''],['以眦睚杀人','',''],['以眼还眼','',''],['以眼还眼以牙还牙','',''],['以石投卵','',''],['以石投水','',''],['以示警戒','',''],['以礼相待','',''],['以筌为鱼','',''],['以管窥天','',''],['以老大自居','',''],['以耳为目','',''],['以耳代目','',''],['以聋辨声','',''],['以职谋私','',''],['以至','',''],['以至于','',''],['以致','',''],['以致于','',''],['以色列亚','',''],['以色列人','',''],['以色列工党','',''],['以苦为乐','',''],['以苦为荣','',''],['以药养医','',''],['以莛叩钟','',''],['以莛撞钟','',''],['以虚带实','',''],['以蚓投鱼','',''],['以蠡测海','',''],['以血偿血','',''],['以血洗血','',''],['以血还血','',''],['以西','',''],['以西结书','',''],['以见一斑','',''],['以观后效','',''],['以言代法','',''],['以言取人','',''],['以讹传讹','',''],['以诚相待','',''],['以貌取人','',''],['以资','',''],['以资抵债','',''],['以资证明','',''],['以资鼓励','',''],['以赛亚书','',''],['以赢利为目的','',''],['以身作则','',''],['以身报国','',''],['以身抵债','',''],['以身殉国','',''],['以身殉职','',''],['以身相许','',''],['以身许国','',''],['以身试法','',''],['以近','',''],['以远','',''],['以退为进','',''],['以逸待劳','',''],['以邮戳日期为准','',''],['以邻为壑','',''],['以防万一','',''],['以防不测','',''],['以降','',''],['以飨读者','',''],['以马内利','',''],['仪上','',''],['仪仗','',''],['仪仗队','',''],['仪典','',''],['仪卫','',''],['仪器','',''],['仪器表','',''],['仪容','',''],['仪座','',''],['仪式','',''],['仪态','',''],['仪态万千','',''],['仪态万方','',''],['仪礼','',''],['仪节','',''],['仪行','',''],['仪表','',''],['仪表板','',''],['仪表盘','',''],['仫佬','',''],['仰不愧天','',''],['仰事俯畜','',''],['仰人鼻息','',''],['仰仗','',''],['仰光','',''],['仰光大金塔','',''],['仰八叉','',''],['仰冲','',''],['仰卧','',''],['仰卧起坐','',''],['仰向','',''],['仰天','',''],['仰头','',''],['仰屋','',''],['仰屋兴叹','',''],['仰屋窃叹','',''],['仰屋著书','',''],['仰度','',''],['仰后','',''],['仰慕','',''],['仰慕者','',''],['仰承','',''],['仰望','',''],['仰求','',''],['仰泳','',''],['仰给','',''],['仰者','',''],['仰脖','',''],['仰药','',''],['仰观俯察','',''],['仰视','',''],['仰角','',''],['仰赖','',''],['仰躺','',''],['仰面','',''],['仰韶','',''],['仰韶文化','',''],['仰首','',''],['仰首伸眉','',''],['仲介','',''],['仲介人','',''],['仲冬','',''],['仲夏','',''],['仲夏夜之梦','',''],['仲家','',''],['仲尼','',''],['仲春','',''],['仲秋','',''],['仲裁','',''],['仲裁人','',''],['仲裁者','',''],['仳离','',''],['仵作','',''],['仵工','',''],['件件','',''],['件数','',''],['价位','',''],['价低','',''],['价值','',''],['价值增殖','',''],['价值尺度','',''],['价值工程','',''],['价值形式','',''],['价值标准','',''],['价值观','',''],['价值规律','',''],['价值论','',''],['价值连城','',''],['价值量','',''],['价内','',''],['价原','',''],['价外','',''],['价层','',''],['价差','',''],['价廉','',''],['价廉物美','',''],['价标','',''],['价格','',''],['价格标签','',''],['价格表','',''],['价款','',''],['价率','',''],['价电子','',''],['价目','',''],['价目表','',''],['价码','',''],['价金','',''],['价钱','',''],['价键','',''],['价额','',''],['任一','',''],['任一个','',''],['任为','',''],['任之','',''],['任事','',''],['任人','',''],['任人为贤','',''],['任人唯亲','',''],['任人唯贤','',''],['任人宰割','',''],['任从','',''],['任他','',''],['任令','',''],['任何','',''],['任何一方','',''],['任何人','',''],['任何时候','',''],['任使','',''],['任侠','',''],['任便','',''],['任免','',''],['任其','',''],['任其发展','',''],['任其自流','',''],['任其自然','',''],['任内','',''],['任凭','',''],['任凭风浪起','',''],['任加','',''],['任务','',''],['任务书','',''],['任务栏','',''],['任劳','',''],['任劳任怨','',''],['任取','',''],['任听','',''],['任命','',''],['任命者','',''],['任咎','',''],['任城','',''],['任天堂','',''],['任它','',''],['任安','',''],['任心','',''],['任性','',''],['任情','',''],['任意','',''],['任意球','',''],['任所','',''],['任教','',''],['任期','',''],['任气','',''],['任满','',''],['任用','',''],['任由','',''],['任者','',''],['任职','',''],['任职期间','',''],['任至','',''],['任诞','',''],['任课','',''],['任贤使能','',''],['任贤杖能','',''],['任达华','',''],['任选','',''],['任重','',''],['任重而道远','',''],['任重致远','',''],['任重道远','',''],['任随','',''],['份上','',''],['份儿','',''],['份儿饭','',''],['份内','',''],['份内份外','',''],['份外','',''],['份子','',''],['份子钱','',''],['份数','',''],['份量','',''],['份额','',''],['份饭','',''],['仿人','',''],['仿似','',''],['仿佛','',''],['仿冒','',''],['仿冒品','',''],['仿冒者','',''],['仿制','',''],['仿制品','',''],['仿办','',''],['仿单','',''],['仿古','',''],['仿如','',''],['仿宋','',''],['仿宋体','',''],['仿射','',''],['仿射子空间','',''],['仿射空间','',''],['仿性','',''],['仿效','',''],['仿照','',''],['仿生','',''],['仿生学','',''],['仿画','',''],['仿皮','',''],['仿真','',''],['仿真器','',''],['仿真服务器','',''],['仿纸','',''],['仿羊皮纸','',''],['仿行','',''],['仿讽','',''],['仿造','',''],['仿造皮','',''],['仿造者','',''],['仿金','',''],['仿麻','',''],['企业','',''],['企业主','',''],['企业亏损','',''],['企业伦理','',''],['企业内网路','',''],['企业化','',''],['企业家','',''],['企业承包','',''],['企业改革','',''],['企业文化','',''],['企业法','',''],['企业界','',''],['企业管理','',''],['企业管理制度','',''],['企业管理硕士','',''],['企业经济','',''],['企业经营','',''],['企业联合组织','',''],['企业自主权','',''],['企业间网路','',''],['企业集团','',''],['企事业','',''],['企事业单位','',''],['企仰','',''],['企划','',''],['企划组织','',''],['企及','',''],['企口板','',''],['企图','',''],['企图心','',''],['企慕','',''],['企望','',''],['企求','',''],['企盼','',''],['企管','',''],['企管硕士','',''],['企足矫首','',''],['企足而待','',''],['企鹅','',''],['伄儅','',''],['伉俪','',''],['伉俪情深','',''],['伊丽莎白','',''],['伊于湖底','',''],['伊于胡底','',''],['伊人','',''],['伊伦','',''],['伊凡','',''],['伊利亚特','',''],['伊利埃斯库','',''],['伊利湖','',''],['伊利诺','',''],['伊利诺伊','',''],['伊利诺伊州','',''],['伊利诺州','',''],['伊塔','',''],['伊塞克湖','',''],['伊士曼柯达公司','',''],['伊妹儿','',''],['伊始','',''],['伊娃','',''],['伊娃・门德斯','',''],['伊尔','',''],['伊尔库茨克','',''],['伊尼亚斯','',''],['伊尼伊德','',''],['伊尼特','',''],['伊州','',''],['伊思迈尔','',''],['伊戈尔','',''],['伊戈尔斯','',''],['伊拉克人','',''],['伊拉克语','',''],['伊教','',''],['伊斯兰','',''],['伊斯兰会议','',''],['伊斯兰会议组织','',''],['伊斯兰党','',''],['伊斯兰圣战组织','',''],['伊斯兰堡','',''],['伊斯兰教','',''],['伊斯兰教历','',''],['伊斯坦布尔','',''],['伊斯帕尼奥拉','',''],['伊斯曼','',''],['伊斯法罕','',''],['伊斯特','',''],['伊普西隆','',''],['伊曼','',''],['伊朗人','',''],['伊朗宪监会','',''],['伊朗币','',''],['伊比利亚','',''],['伊比利亚半岛','',''],['伊波拉','',''],['伊洛瓦底','',''],['伊洛瓦底三角洲','',''],['伊洛瓦底江','',''],['伊犁','',''],['伊犁河','',''],['伊犁盆地','',''],['伊玛目','',''],['伊瑞克提翁庙','',''],['伊甸','',''],['伊甸园','',''],['伊科病毒','',''],['伊索','',''],['伊索寓言','',''],['伊莉莎白','',''],['伊莉萨白','',''],['伊莱克斯','',''],['伊萨卡','',''],['伊藤博文','',''],['伊蚊','',''],['伊通','',''],['伊通县','',''],['伊通河','',''],['伊通火山群','',''],['伊通自然保护区','',''],['伊通镇','',''],['伊里奇','',''],['伊里格瑞','',''],['伊金霍洛','',''],['伊阙石窟','',''],['伊顿公学','',''],['伊马姆','',''],['伍万','',''],['伍元','',''],['伍奢','',''],['伍子胥','',''],['伍家岗','',''],['伍廷芳','',''],['伍德豪斯','',''],['伍拾','',''],['伍的','',''],['伎俩','',''],['伏下','',''],['伏低做小','',''],['伏侍','',''],['伏兵','',''],['伏击','',''],['伏击战','',''],['伏卧','',''],['伏在','',''],['伏地','',''],['伏地挺身','',''],['伏地魔','',''],['伏处','',''],['伏天','',''],['伏安','',''],['伏安表','',''],['伏安计','',''],['伏尔加格勒','',''],['伏尔加河','',''],['伏尔泰','',''],['伏尸','',''],['伏尸流血','',''],['伏帖','',''],['伏惟','',''],['伏旱','',''],['伏明霞','',''],['伏暑','',''],['伏案','',''],['伏汛','',''],['伏法','',''],['伏流','',''],['伏牛','',''],['伏牛山','',''],['伏特','',''],['伏特加','',''],['伏特加酒','',''],['伏特数','',''],['伏特表','',''],['伏特计','',''],['伏笔','',''],['伏维尚飨','',''],['伏罗希洛夫','',''],['伏罪','',''],['伏羲','',''],['伏羲氏','',''],['伏苓','',''],['伏虎','',''],['伏虎降龙','',''],['伏诛','',''],['伏贴','',''],['伏身','',''],['伏输','',''],['伏辩','',''],['伏都教','',''],['伏龙凤雏','',''],['伐区','',''],['伐异','',''],['伐异党同','',''],['伐性之斧','',''],['伐木','',''],['伐木业','',''],['伐木人','',''],['伐木场','',''],['伐木工人','',''],['伐木者','',''],['伐柯','',''],['伐树','',''],['伐毛洗髓','',''],['休业','',''],['休书','',''],['休伊特','',''],['休会','',''],['休伦湖','',''],['休假','',''],['休克','',''],['休兵','',''],['休养','',''],['休养所','',''],['休养生息','',''],['休刊','',''],['休士顿','',''],['休妻','',''],['休学','',''],['休工','',''],['休庭','',''],['休得','',''],['休怪','',''],['休息','',''],['休息处','',''],['休息室','',''],['休息日','',''],['休惜','',''],['休想','',''],['休憩','',''],['休战','',''],['休戚','',''],['休戚与共','',''],['休戚相关','',''],['休整','',''],['休斯敦','',''],['休斯顿','',''],['休旅车','',''],['休止','',''],['休止符','',''],['休火山','',''],['休牛归马','',''],['休牛放马','',''],['休牛散马','',''],['休眠','',''],['休眠期','',''],['休眠火山','',''],['休眠芽','',''],['休管他人瓦上霜','',''],['休耕','',''],['休耕中','',''],['休要','',''],['休谟','',''],['休达','',''],['休闲','',''],['休闲学','',''],['休闲形态','',''],['休闲裤','',''],['休闲鞋','',''],['众人','',''],['众人拾柴火焰高','',''],['众人敬仰','',''],['众位','',''],['众包','',''],['众取','',''],['众叛亲离','',''],['众口','',''],['众口一词','',''],['众口交攻','',''],['众口交荐','',''],['众口同声','',''],['众口烁金','',''],['众口熏天','',''],['众口皆碑','',''],['众口纷纭','',''],['众口铄金','',''],['众口难调','',''],['众国','',''],['众多','',''],['众女','',''],['众如水火','',''],['众寡','',''],['众寡不敌','',''],['众寡势殊','',''],['众寡悬殊','',''],['众寡莫敌','',''],['众寡难敌','',''],['众少不敌','',''],['众少成多','',''],['众川赴海','',''],['众心成城','',''],['众心拱辰','',''],['众志成城','',''],['众怒','',''],['众怒难任','',''],['众怒难犯','',''],['众所','',''],['众所周知','',''],['众所曙目','',''],['众所瞩目','',''],['众所瞻望','',''],['众擎易举','',''],['众散亲离','',''],['众数','',''],['众星','',''],['众星拱北','',''],['众星拱辰','',''],['众星捧月','',''],['众望','',''],['众望所依','',''],['众望所归','',''],['众望所积','',''],['众望攸归','',''],['众望有归','',''],['众毁所归','',''],['众毛攒裘','',''],['众生','',''],['众目','',''],['众目共睹','',''],['众目共视','',''],['众目具瞻','',''],['众目所归','',''],['众目昭彰','',''],['众目睽睽','',''],['众盲摸象','',''],['众矢之的','',''],['众神','',''],['众神庙','',''],['众虎同心','',''],['众议','',''],['众议员','',''],['众议成林','',''],['众议院','',''],['众语','',''],['众说','',''],['众说纷揉','',''],['众说纷纭','',''],['众说郛','',''],['众谋','',''],['众走','',''],['众路','',''],['众院','',''],['众香子','',''],['优于','',''],['优伶','',''],['优先','',''],['优先于','',''],['优先化','',''],['优先发展','',''],['优先承购权','',''],['优先权','',''],['优先照顾','',''],['优先级','',''],['优先股','',''],['优先认股权','',''],['优劣','',''],['优势','',''],['优势互补','',''],['优化','',''],['优化组合','',''],['优厚','',''],['优哉游哉','',''],['优存劣汰','',''],['优孟衣冠','',''],['优容','',''],['优尼科','',''],['优异','',''],['优异奖','',''],['优异成绩','',''],['优弧','',''],['优待','',''],['优待券','',''],['优待票','',''],['优恤','',''],['优惠','',''],['优惠价','',''],['优惠券','',''],['优惠待遇','',''],['优惠政策','',''],['优惠贷款','',''],['优抚','',''],['优抚工作','',''],['优柔','',''],['优柔寡断','',''],['优格','',''],['优渥','',''],['优游','',''],['优游自得','',''],['优点','',''],['优生','',''],['优生优育','',''],['优生学','',''],['优生学家','',''],['优生法','',''],['优盘','',''],['优秀','',''],['优秀人才','',''],['优秀作品','',''],['优秀儿女','',''],['优秀党员','',''],['优秀分子','',''],['优秀品质','',''],['优秀奖','',''],['优秀干部','',''],['优秀成果','',''],['优秀教师','',''],['优种','',''],['优等','',''],['优缺点','',''],['优美','',''],['优者','',''],['优育','',''],['优胜','',''],['优胜劣汰','',''],['优胜旗','',''],['优胜者','',''],['优良','',''],['优良传统','',''],['优良作风','',''],['优良品种','',''],['优裕','',''],['优诺牌','',''],['优质','',''],['优质产品','',''],['优质优价','',''],['优质服务','',''],['优越','',''],['优越性','',''],['优越感','',''],['优选','',''],['优选法','',''],['优遇','',''],['优酷','',''],['优雅','',''],['伙人','',''],['伙伴','',''],['伙伴们','',''],['伙伴儿','',''],['伙儿','',''],['伙同','',''],['伙夫','',''],['伙子','',''],['伙房','',''],['伙种','',''],['伙耕','',''],['伙计','',''],['伙颐','',''],['伙食','',''],['伙食费','',''],['会上','',''],['会上会下','',''],['会下','',''],['会不会','',''],['会了','',''],['会众','',''],['会会','',''],['会儿','',''],['会元','',''],['会党','',''],['会典','',''],['会刊','',''],['会办','',''],['会务','',''],['会区','',''],['会厌','',''],['会厌软骨','',''],['会友','',''],['会受','',''],['会变','',''],['会合','',''],['会合处','',''],['会合点','',''],['会后','',''],['会否','',''],['会员','',''],['会员国','',''],['会员证','',''],['会唱','',''],['会商','',''],['会在','',''],['会场','',''],['会址','',''],['会堂','',''],['会士','',''],['会士考试','',''],['会好','',''],['会子','',''],['会安','',''],['会审','',''],['会客','',''],['会客厅','',''],['会客室','',''],['会家不忙','',''],['会对','',''],['会少离多','',''],['会展','',''],['会师','',''],['会帐','',''],['会幕','',''],['会当','',''],['会徒','',''],['会徽','',''],['会心','',''],['会心微笑','',''],['会意','',''],['会意字','',''],['会战','',''],['会所','',''],['会把','',''],['会操','',''],['会攻','',''],['会日','',''],['会晤','',''],['会有','',''],['会期','',''],['会歌','',''],['会死','',''],['会水','',''],['会法','',''],['会派','',''],['会漏','',''],['会演','',''],['会生枝节','',''],['会用','',''],['会盟','',''],['会破','',''],['会社','',''],['会稽','',''],['会籍','',''],['会老','',''],['会考','',''],['会聚','',''],['会聚透镜','',''],['会萃','',''],['会衔','',''],['会要','',''],['会见','',''],['会见者','',''],['会计','',''],['会计人员','',''],['会计准则理事会','',''],['会计制度','',''],['会计员','',''],['会计学','',''],['会计室','',''],['会计工作','',''],['会计师','',''],['会计帐','',''],['会计科','',''],['会计科目','',''],['会议','',''],['会议上','',''],['会议决定','',''],['会议厅','',''],['会议室','',''],['会议展览','',''],['会议录','',''],['会议所','',''],['会议期间','',''],['会议桌','',''],['会议纪要','',''],['会议认为','',''],['会议资料','',''],['会讲','',''],['会诊','',''],['会试','',''],['会话','',''],['会说','',''],['会谈','',''],['会谈纪要','',''],['会谈者','',''],['会象','',''],['会费','',''],['会车','',''],['会通','',''],['会逢其适','',''],['会道能说','',''],['会里县','',''],['会钞','',''],['会错','',''],['会长','',''],['会长团','',''],['会门','',''],['会阴','',''],['会集','',''],['会面','',''],['会风','',''],['会飞','',''],['会餐','',''],['会馆','',''],['会首','',''],['会齐','',''],['伛偻','',''],['伞下','',''],['伞兵','',''],['伞形','',''],['伞形科','',''],['伞形花序','',''],['伞房花序','',''],['伞状','',''],['伞菌','',''],['伞降','',''],['伞面','',''],['伞齿轮','',''],['伟业','',''],['伟丽','',''],['伟举','',''],['伟人','',''],['伟力','',''],['伟哥','',''],['伟器','',''],['伟士牌','',''],['伟大','',''],['伟大事业','',''],['伟大意义','',''],['伟岸','',''],['伟晶岩','',''],['伟绩','',''],['伟观','',''],['传三过四','',''],['传下','',''],['传不','',''],['传世','',''],['传为佳话','',''],['传为美谈','',''],['传习','',''],['传书','',''],['传书鸽','',''],['传人','',''],['传代','',''],['传令','',''],['传令兵','',''],['传令官','',''],['传位','',''],['传信','',''],['传入','',''],['传入神经','',''],['传写','',''],['传出','',''],['传出神经','',''],['传到','',''],['传动','',''],['传动器','',''],['传动带','',''],['传动机构','',''],['传动比','',''],['传动系统','',''],['传动装置','',''],['传动轴','',''],['传单','',''],['传单广','',''],['传发','',''],['传号','',''],['传名','',''],['传告','',''],['传呼','',''],['传呼电话','',''],['传唤','',''],['传唤者','',''],['传唱','',''],['传回','',''],['传声','',''],['传声器','',''],['传声筒','',''],['传奇','',''],['传奇中','',''],['传奇人物','',''],['传奇似','',''],['传奇小说','',''],['传奇式','',''],['传奇性','',''],['传奇文学','',''],['传媒','',''],['传媒界','',''],['传子','',''],['传宗接代','',''],['传家','',''],['传家宝','',''],['传寄','',''],['传导','',''],['传导力','',''],['传导性','',''],['传导率','',''],['传布','',''],['传布者','',''],['传帮','',''],['传帮带','',''],['传开','',''],['传心术','',''],['传情','',''],['传感','',''],['传感器','',''],['传感技术','',''],['传戒','',''],['传户','',''],['传打','',''],['传扬','',''],['传承','',''],['传技','',''],['传抄','',''],['传报','',''],['传换','',''],['传授','',''],['传控','',''],['传播','',''],['传播四方','',''],['传播媒体','',''],['传播学','',''],['传播者','',''],['传播途径','',''],['传教','',''],['传教团','',''],['传教士','',''],['传教师','',''],['传旨','',''],['传本','',''],['传来','',''],['传杯弄盏','',''],['传染','',''],['传染性','',''],['传染源','',''],['传染病','',''],['传染病学','',''],['传标','',''],['传檄','',''],['传檄而定','',''],['传法','',''],['传流','',''],['传灯','',''],['传热','',''],['传热学','',''],['传热性','',''],['传爆线','',''],['传球','',''],['传略','',''],['传病','',''],['传看','',''],['传真','',''],['传真发送','',''],['传真号码','',''],['传真机','',''],['传真电报','',''],['传神','',''],['传神阿堵','',''],['传票','',''],['传福音','',''],['传种','',''],['传答','',''],['传粉','',''],['传经','',''],['传经送宝','',''],['传给','',''],['传统','',''],['传统上','',''],['传统中国医药','',''],['传统主义','',''],['传统医药','',''],['传统文化','',''],['传统观','',''],['传统词类','',''],['传艺','',''],['传见','',''],['传观','',''],['传视','',''],['传言','',''],['传讯','',''],['传记','',''],['传记体','',''],['传记小说','',''],['传记性','',''],['传记文学','',''],['传讲','',''],['传译','',''],['传话','',''],['传话人','',''],['传语','',''],['传说','',''],['传说上','',''],['传说中','',''],['传说人物','',''],['传说集','',''],['传诵','',''],['传谕','',''],['传谣','',''],['传赞','',''],['传输','',''],['传输协定','',''],['传输器','',''],['传输媒体','',''],['传输媒界','',''],['传输媒质','',''],['传输层','',''],['传输技术','',''],['传输控制','',''],['传输控制协定','',''],['传输服务','',''],['传输模式','',''],['传输率','',''],['传输线','',''],['传输设备','',''],['传输距离','',''],['传输通道','',''],['传输速率','',''],['传达','',''],['传达员','',''],['传达室','',''],['传达性','',''],['传达者','',''],['传过','',''],['传述','',''],['传送','',''],['传送带','',''],['传送服务','',''],['传送者','',''],['传递','',''],['传递性','',''],['传递者','',''],['传遍','',''],['传遍全国','',''],['传遍全身','',''],['传道','',''],['传道书','',''],['传道受业','',''],['传道士','',''],['传道者','',''],['传道部','',''],['传销','',''],['传问','',''],['传闻','',''],['传闻失实','',''],['传闻证据','',''],['传阅','',''],['传颂','',''],['传题','',''],['伢子','',''],['伢崽','',''],['伤不起','',''],['伤了脚','',''],['伤亡','',''],['伤亡事故','',''],['伤亡人数','',''],['伤人','',''],['伤俘','',''],['伤兵','',''],['伤别','',''],['伤势','',''],['伤化败俗','',''],['伤及无辜','',''],['伤口','',''],['伤号','',''],['伤员','',''],['伤处','',''],['伤天','',''],['伤天害命','',''],['伤天害理','',''],['伤失','',''],['伤害','',''],['伤害罪','',''],['伤寒','',''],['伤寒沙门氏菌','',''],['伤寒症','',''],['伤弓之鸟','',''],['伤心','',''],['伤心事','',''],['伤心惨目','',''],['伤心致死','',''],['伤心落泪','',''],['伤心蒿目','',''],['伤怀','',''],['伤悲','',''],['伤悼','',''],['伤感','',''],['伤残','',''],['伤残人','',''],['伤残人员','',''],['伤毁','',''],['伤气','',''],['伤热','',''],['伤生','',''],['伤疤','',''],['伤病','',''],['伤病员','',''],['伤痕','',''],['伤痕累累','',''],['伤痛','',''],['伤着','',''],['伤神','',''],['伤筋动骨','',''],['伤筋断骨','',''],['伤者','',''],['伤耗','',''],['伤脑筋','',''],['伤药','',''],['伤财','',''],['伤身','',''],['伤逝','',''],['伤风','',''],['伤风败俗','',''],['伤食','',''],['伥鬼','',''],['伦巴','',''],['伦常','',''],['伦敦','',''],['伦敦人','',''],['伦敦国际金融期货交易所','',''],['伦敦大学亚非学院','',''],['伦敦大学学院','',''],['伦敦帝国理工学院','',''],['伦敦证券交易所','',''],['伦次','',''],['伦比','',''],['伦理','',''],['伦理学','',''],['伦理学史','',''],['伦理学家','',''],['伦理思想','',''],['伦理社会主义','',''],['伦理道德','',''],['伦琴','',''],['伦琴射线','',''],['伪书','',''],['伪代码','',''],['伪作','',''],['伪军','',''],['伪劣','',''],['伪劣商品','',''],['伪名','',''],['伪君子','',''],['伪品','',''],['伪善','',''],['伪善者','',''],['伪币','',''],['伪托','',''],['伪政权','',''],['伪朝','',''],['伪本','',''],['伪满','',''],['伪科学','',''],['伪称','',''],['伪笔','',''],['伪经','',''],['伪职','',''],['伪药','',''],['伪装','',''],['伪言','',''],['伪誓','',''],['伪誓者','',''],['伪证','',''],['伪证罪','',''],['伪证者','',''],['伪足','',''],['伪迹','',''],['伪造','',''],['伪造品','',''],['伪造物','',''],['伪造罪','',''],['伪造者','',''],['伪钞','',''],['伪顶','',''],['伪饰','',''],['伫侯','',''],['伫候','',''],['伫列','',''],['伫望','',''],['伫立','',''],['伫足','',''],['伯乐','',''],['伯乐一顾','',''],['伯仲','',''],['伯仲之间','',''],['伯仲叔季','',''],['伯伯','',''],['伯俞泣杖','',''],['伯克利','',''],['伯公','',''],['伯利恒','',''],['伯劳','',''],['伯劳飞燕','',''],['伯劳鸟','',''],['伯南克','',''],['伯叔','',''],['伯叔祖母','',''],['伯叔祖父','',''],['伯埙仲篪','',''],['伯多禄','',''],['伯婆','',''],['伯尔尼','',''],['伯尔尼国际','',''],['伯德雷恩图书馆','',''],['伯恩','',''],['伯恩斯','',''],['伯恩斯坦主义','',''],['伯恩茅斯','',''],['伯拉第斯拉瓦','',''],['伯明翰','',''],['伯杰','',''],['伯格','',''],['伯歌季舞','',''],['伯母','',''],['伯爵','',''],['伯爵夫人','',''],['伯父','',''],['伯特兰','',''],['伯特兰德','',''],['伯祖','',''],['伯祖母','',''],['伯纳斯・李','',''],['伯莎','',''],['伯赛大','',''],['伯道无儿','',''],['伯都','',''],['伯里克利','',''],['伯颜','',''],['估产','',''],['估价','',''],['估价人','',''],['估值','',''],['估列','',''],['估到','',''],['估及','',''],['估地','',''],['估堆儿','',''],['估定','',''],['估摸','',''],['估测','',''],['估税','',''],['估税员','',''],['估算','',''],['估衣','',''],['估衣店','',''],['估计','',''],['估计不足','',''],['估计员','',''],['估计者','',''],['估过','',''],['估量','',''],['估错','',''],['伴之','',''],['伴人','',''],['伴以','',''],['伴你','',''],['伴侣','',''],['伴侣号','',''],['伴儿','',''],['伴同','',''],['伴唱','',''],['伴器','',''],['伴奏','',''],['伴奏者','',''],['伴奏队员','',''],['伴娘','',''],['伴当','',''],['伴性','',''],['伴手','',''],['伴护','',''],['伴星','',''],['伴有','',''],['伴游','',''],['伴热','',''],['伴物','',''],['伴生树','',''],['伴生气','',''],['伴着','',''],['伴矩阵','',''],['伴者','',''],['伴舞','',''],['伴读','',''],['伴郎','',''],['伴随','',''],['伴随效应','',''],['伴随有','',''],['伴随物','',''],['伴音','',''],['伴食中书','',''],['伴食宰相','',''],['伶人','',''],['伶仃','',''],['伶仃孤苦','',''],['伶俐','',''],['伶俜','',''],['伶悧','',''],['伶牙','',''],['伶牙俐嘴','',''],['伶牙俐齿','',''],['伶盗龙','',''],['伶鼬','',''],['伸入','',''],['伸冤','',''],['伸出','',''],['伸到','',''],['伸化','',''],['伸及','',''],['伸向','',''],['伸域','',''],['伸展','',''],['伸展到','',''],['伸展台','',''],['伸展者','',''],['伸度','',''],['伸延','',''],['伸开','',''],['伸张','',''],['伸张正义','',''],['伸懒腰','',''],['伸手','',''],['伸手派','',''],['伸港','',''],['伸港乡','',''],['伸畅','',''],['伸直','',''],['伸眉吐气','',''],['伸缩','',''],['伸缩喇叭','',''],['伸缩器','',''],['伸缩性','',''],['伸肌','',''],['伸腰','',''],['伸腿','',''],['伸臂','',''],['伸至','',''],['伸角','',''],['伸过','',''],['伸进','',''],['伸钩索铁','',''],['伸长','',''],['伸长性','',''],['伸雪','',''],['伸颈','',''],['伺候','',''],['伺养','',''],['伺养场','',''],['伺养者','',''],['伺料','',''],['伺料槽','',''],['伺服','',''],['伺服器','',''],['伺服机构','',''],['伺服者','',''],['伺服阀','',''],['伺机','',''],['伺隙','',''],['似不','',''],['似为','',''],['似乎','',''],['似乎是','',''],['似于','',''],['似变','',''],['似可','',''],['似合理','',''],['似地','',''],['似处女','',''],['似将','',''],['似属','',''],['似应','',''],['似懂非懂','',''],['似是','',''],['似是而非','',''],['似曾相识','',''],['似有','',''],['似核','',''],['似梦','',''],['似模似样','',''],['似水如鱼','',''],['似水年华','',''],['似漆如胶','',''],['似火','',''],['似玉如花','',''],['似玻璃','',''],['似的','',''],['似真','',''],['似笑','',''],['似笑非笑','',''],['似能','',''],['似花','',''],['似虎','',''],['似蜜','',''],['似象','',''],['似醉如痴','',''],['似雪','',''],['似非而是','',''],['似马','',''],['似鬼','',''],['似鸟恐龙','',''],['伽倻','',''],['伽倻琴','',''],['伽利略','',''],['伽利略・伽利雷','',''],['伽利略探测器','',''],['伽南香','',''],['伽玛','',''],['伽罗华','',''],['伽罗华理论','',''],['伽罗瓦','',''],['伽罗瓦理论','',''],['伽蓝','',''],['伽马','',''],['伽马射线','',''],['伽马射线探测器','',''],['伽马辐射','',''],['佃农','',''],['佃契','',''],['佃客','',''],['佃户','',''],['佃权','',''],['佃租','',''],['但丁','',''],['但书','',''],['但仍用作','',''],['但以理书','',''],['但凡','',''],['但却','',''],['但可以','',''],['但如','',''],['但尼生','',''],['但愿','',''],['但愿如此','',''],['但是','',''],['但求无过','',''],['但能','',''],['但说无妨','',''],['佉卢文','',''],['位于','',''],['位于下面','',''],['位于在','',''],['位于高处','',''],['位似','',''],['位似变换','',''],['位低','',''],['位元','',''],['位元组','',''],['位列','',''],['位制','',''],['位势','',''],['位势米','',''],['位卑言高','',''],['位及','',''],['位图','',''],['位址','',''],['位子','',''],['位居','',''],['位差','',''],['位形','',''],['位形空间','',''],['位数','',''],['位极人臣','',''],['位标','',''],['位次','',''],['位移','',''],['位第','',''],['位素','',''],['位置','',''],['位置效应','',''],['位置格','',''],['位能','',''],['位高','',''],['低三下四','',''],['低下','',''],['低丘','',''],['低了','',''],['低于','',''],['低云','',''],['低产','',''],['低产田','',''],['低人','',''],['低人一等','',''],['低价','',''],['低估','',''],['低低切切','',''],['低俗','',''],['低俗之风','',''],['低俗化','',''],['低保','',''],['低倍','',''],['低值','',''],['低元音','',''],['低八度','',''],['低分','',''],['低利','',''],['低利率','',''],['低利贷款','',''],['低剂量照射','',''],['低劣','',''],['低卡','',''],['低压','',''],['低压带','',''],['低压槽','',''],['低叫','',''],['低合金钢','',''],['低吟','',''],['低周波','',''],['低唱','',''],['低喻','',''],['低回','',''],['低地','',''],['低坝','',''],['低垂','',''],['低声','',''],['低声下气','',''],['低声波','',''],['低声说','',''],['低处','',''],['低头','',''],['低头不语','',''],['低头丧气','',''],['低头认罪','',''],['低密','',''],['低尾气排放','',''],['低层','',''],['低工资','',''],['低帮','',''],['低平','',''],['低年级','',''],['低度','',''],['低廉','',''],['低得','',''],['低微','',''],['低息','',''],['低息贷款','',''],['低成本','',''],['低手','',''],['低报','',''],['低挡','',''],['低收入','',''],['低放射性废物','',''],['低效','',''],['低效率','',''],['低效益','',''],['低效能','',''],['低昂','',''],['低杠','',''],['低标号','',''],['低栏','',''],['低档','',''],['低楼','',''],['低毒','',''],['低气压','',''],['低气压区','',''],['低氧','',''],['低水平','',''],['低沉','',''],['低泣','',''],['低洼','',''],['低浓缩铀','',''],['低消耗','',''],['低温','',''],['低温泵','',''],['低温计','',''],['低潮','',''],['低点','',''],['低烧','',''],['低热','',''],['低眉顺眼','',''],['低着','',''],['低矮','',''],['低碳钢','',''],['低税','',''],['低空','',''],['低空跳伞','',''],['低空飞过','',''],['低端','',''],['低等','',''],['低等动物','',''],['低等植物','',''],['低筋面粉','',''],['低级','',''],['低级神经活动','',''],['低级语言','',''],['低级趣味','',''],['低级阶段','',''],['低纬度','',''],['低维','',''],['低缓','',''],['低耗','',''],['低胸','',''],['低能','',''],['低能儿','',''],['低能者','',''],['低脂','',''],['低腰','',''],['低落','',''],['低薪','',''],['低血压','',''],['低血糖症','',''],['低语','',''],['低语声','',''],['低调','',''],['低谷','',''],['低质量','',''],['低贱','',''],['低费用','',''],['低迷','',''],['低迷状态','',''],['低速','',''],['低速层','',''],['低速挡','',''],['低速率','',''],['低销','',''],['低阶','',''],['低阶语言','',''],['低降','',''],['低限','',''],['低陷','',''],['低音','',''],['低音喇叭','',''],['低音大号','',''],['低音大提琴','',''],['低音提琴','',''],['低音炮','',''],['低音管','',''],['低音部','',''],['低领口','',''],['低颈','',''],['低频','',''],['低额','',''],['低飞','',''],['低首','',''],['低首下心','',''],['低龋齿性','',''],['住下','',''],['住于','',''],['住入','',''],['住勤','',''],['住区','',''],['住友','',''],['住口','',''],['住员','',''],['住嘴','',''],['住在','',''],['住地','',''],['住址','',''],['住处','',''],['住宅','',''],['住宅区','',''],['住宅楼','',''],['住宅泡沫','',''],['住客','',''],['住家','',''],['住家用','',''],['住宿','',''],['住居','',''],['住屋','',''],['住店','',''],['住惯','',''],['住户','',''],['住房','',''],['住房难','',''],['住所','',''],['住手','',''],['住持','',''],['住旅馆','',''],['住校','',''],['住民','',''],['住气','',''],['住用','',''],['住的','',''],['住着','',''],['住笔','',''],['住者','',''],['住脚','',''],['住舍','',''],['住血','',''],['住行','',''],['住读','',''],['住足','',''],['住进','',''],['住院','',''],['住院治疗','',''],['佐世','',''],['佐世保','',''],['佐人','',''],['佐料','',''],['佐格比国际','',''],['佐治亚','',''],['佐治亚州','',''],['佐理','',''],['佐罗','',''],['佐药','',''],['佐证','',''],['佐贰','',''],['佐酒','',''],['佐雍得尝','',''],['佐餐','',''],['佑护','',''],['佑知','',''],['体中','',''],['体书','',''],['体会','',''],['体位','',''],['体例','',''],['体侧','',''],['体内','',''],['体刑','',''],['体制','',''],['体制改革','',''],['体力','',''],['体力不支','',''],['体力劳动','',''],['体势','',''],['体协','',''],['体味','',''],['体团','',''],['体国经野','',''],['体图','',''],['体坛','',''],['体型','',''],['体外','',''],['体外受精','',''],['体大','',''],['体大思精','',''],['体委','',''],['体察','',''],['体工队','',''],['体己','',''],['体己钱','',''],['体式','',''],['体弱','',''],['体弱多病','',''],['体形','',''],['体征','',''],['体循环','',''],['体念','',''],['体态','',''],['体性','',''],['体恤','',''],['体恤入微','',''],['体恤衫','',''],['体悟','',''],['体惜','',''],['体感','',''],['体捡','',''],['体操','',''],['体操家','',''],['体操运动员','',''],['体操队','',''],['体改','',''],['体改委','',''],['体无完肤','',''],['体校','',''],['体格','',''],['体格检查','',''],['体检','',''],['体模','',''],['体毒','',''],['体毛','',''],['体液','',''],['体温','',''],['体温检测仪','',''],['体温表','',''],['体温计','',''],['体温过低','',''],['体火','',''],['体状','',''],['体现','',''],['体癣','',''],['体积','',''],['体积单位','',''],['体积百分比','',''],['体积计','',''],['体系','',''],['体系化','',''],['体细胞','',''],['体统','',''],['体罚','',''],['体肤','',''],['体育','',''],['体育之窗','',''],['体育事业','',''],['体育人物','',''],['体育健儿','',''],['体育场','',''],['体育场馆','',''],['体育新闻','',''],['体育比赛','',''],['体育活动','',''],['体育爱好者','',''],['体育用品','',''],['体育界','',''],['体育疗法','',''],['体育竞赛','',''],['体育系','',''],['体育组','',''],['体育运动','',''],['体育道德','',''],['体育部','',''],['体育锻炼','',''],['体育项目','',''],['体育馆','',''],['体胀系数','',''],['体胖','',''],['体能','',''],['体腔','',''],['体膨胀','',''],['体臭','',''],['体节','',''],['体虫','',''],['体虱','',''],['体表','',''],['体裁','',''],['体视','',''],['体认','',''],['体词','',''],['体谅','',''],['体貌','',''],['体质','',''],['体贴','',''],['体贴入微','',''],['体重','',''],['体重器','',''],['体重计','',''],['体量','',''],['体长','',''],['体院','',''],['体面','',''],['体香剂','',''],['体验','',''],['体验生活','',''],['体高','',''],['体魄','',''],['何不','',''],['何为','',''],['何乐','',''],['何乐不为','',''],['何乐而不为','',''],['何事','',''],['何人','',''],['何以','',''],['何以成方圆','',''],['何以见得','',''],['何其','',''],['何况','',''],['何出此言','',''],['何厚铧','',''],['何去','',''],['何去何从','',''],['何啻','',''],['何在','',''],['何地','',''],['何堪','',''],['何处','',''],['何如','',''],['何妨','',''],['何尝','',''],['何干','',''],['何年','',''],['何年何月','',''],['何应钦','',''],['何廉','',''],['何必','',''],['何必当初','',''],['何忍','',''],['何患','',''],['何患无辞','',''],['何所','',''],['何故','',''],['何方','',''],['何日','',''],['何时','',''],['何时何地','',''],['何时是了','',''],['何曾','',''],['何月','',''],['何止','',''],['何殊','',''],['何济于事','',''],['何用','',''],['何种','',''],['何等','',''],['何者','',''],['何至','',''],['何苦','',''],['何苦呢','',''],['何西阿书','',''],['何许','',''],['何许人也','',''],['何谓','',''],['何足挂齿','',''],['何足道哉','',''],['何须','',''],['何首乌','',''],['何鲁晓夫','',''],['余下','',''],['余业遗烈','',''],['余值','',''],['余光','',''],['余党','',''],['余兴','',''],['余切','',''],['余利','',''],['余剩','',''],['余割','',''],['余力','',''],['余勇可贾','',''],['余可','',''],['余味','',''],['余响绕梁','',''],['余地','',''],['余外','',''],['余妙绕梁','',''],['余威','',''],['余子碌碌','',''],['余存','',''],['余孽','',''],['余年','',''],['余弦','',''],['余弧','',''],['余当','',''],['余怒','',''],['余怒未息','',''],['余性','',''],['余悸','',''],['余数','',''],['余数定理','',''],['余料','',''],['余晖','',''],['余暇','',''],['余月','',''],['余杭','',''],['余杯冷炙','',''],['余桃啖君','',''],['余款','',''],['余步','',''],['余毒','',''],['余沥','',''],['余波','',''],['余火','',''],['余烬','',''],['余烬复燃','',''],['余热','',''],['余物','',''],['余甘子','',''],['余生','',''],['余留','',''],['余留事务','',''],['余留无符号数','',''],['余皇','',''],['余码','',''],['余粮','',''],['余绪','',''],['余缺','',''],['余者','',''],['余膏剩馥','',''],['余蓄','',''],['余裕','',''],['余角','',''],['余解','',''],['余象','',''],['余车','',''],['余辉','',''],['余量','',''],['余钱','',''],['余闲','',''],['余集','',''],['余震','',''],['余霞','',''],['余霞成绮','',''],['余音','',''],['余音绕梁','',''],['余音袅袅','',''],['余韵','',''],['余韵流风','',''],['余项','',''],['余额','',''],['余风','',''],['余香','',''],['佚名','',''],['佛书','',''],['佛事','',''],['佛像','',''],['佛鬼','',''],['佛光','',''],['佛兰','',''],['佛兰德','',''],['佛兰芒语','',''],['佛典','',''],['佛协','',''],['佛历','',''],['佛口蛇心','',''],['佛号','',''],['佛吉尼亚','',''],['佛堂','',''],['佛堤树','',''],['佛塔','',''],['佛头着粪','',''],['佛学','',''],['佛家','',''],['佛寺','',''],['佛山地区','',''],['佛性','',''],['佛戾','',''],['佛手','',''],['佛手瓜','',''],['佛教','',''],['佛教史','',''],['佛教徒','',''],['佛教界','',''],['佛教语','',''],['佛晓','',''],['佛朗哥','',''],['佛朗机','',''],['佛朗机炮','',''],['佛朗机铳','',''],['佛殿','',''],['佛法','',''],['佛法僧目','',''],['佛洛伊德','',''],['佛洛斯特','',''],['佛爷','',''],['佛牙','',''],['佛眼相看','',''],['佛祖','',''],['佛经','',''],['佛罗伦萨','',''],['佛罗里达','',''],['佛罗里达州','',''],['佛舍利','',''],['佛蒙特','',''],['佛蒙特州','',''],['佛诞日','',''],['佛语','',''],['佛跳墙','',''],['佛门','',''],['佛陀','',''],['佛雷泽尔','',''],['佛青','',''],['佛香阁','',''],['佛骨','',''],['佛骨塔','',''],['佛龛','',''],['作下','',''],['作业','',''],['作业室','',''],['作业环境','',''],['作业系统','',''],['作东','',''],['作为','',''],['作主','',''],['作乐','',''],['作乱','',''],['作了','',''],['作于','',''],['作些','',''],['作交易','',''],['作人','',''],['作件','',''],['作价','',''],['作伐','',''],['作伪','',''],['作伪证','',''],['作伴','',''],['作俑','',''],['作保','',''],['作假','',''],['作先锋','',''],['作兴','',''],['作准','',''],['作准备','',''],['作出','',''],['作出了','',''],['作出决定','',''],['作出努力','',''],['作出规定','',''],['作出让步','',''],['作出评价','',''],['作别','',''],['作到','',''],['作势','',''],['作协','',''],['作古','',''],['作古人','',''],['作合','',''],['作呕','',''],['作品','',''],['作响','',''],['作哼声','',''],['作困兽斗','',''],['作图','',''],['作图解','',''],['作在','',''],['作坊','',''],['作坏事','',''],['作壁上观','',''],['作声','',''],['作大','',''],['作奸犯科','',''],['作好','',''],['作好准备','',''],['作如是观','',''],['作威','',''],['作威作福','',''],['作媒','',''],['作嫁','',''],['作孽','',''],['作官','',''],['作客','',''],['作客思想','',''],['作宣传','',''],['作家','',''],['作对','',''],['作导','',''],['作寿','',''],['作帐','',''],['作序','',''],['作序言','',''],['作废','',''],['作弄','',''],['作弄人','',''],['作弊','',''],['作得','',''],['作态','',''],['作怪','',''],['作息','',''],['作息制度','',''],['作息时间','',''],['作息时间表','',''],['作恶','',''],['作恶多端','',''],['作恶者','',''],['作愁相','',''],['作戏','',''],['作成','',''],['作战','',''],['作战失踪','',''],['作战失踪人员','',''],['作战方案','',''],['作手','',''],['作拍','',''],['作指示','',''],['作揖','',''],['作操','',''],['作数','',''],['作文','',''],['作文法','',''],['作文集','',''],['作料','',''],['作曲','',''],['作曲家','',''],['作曲者','',''],['作木工','',''],['作案','',''],['作梗','',''],['作梦','',''],['作梦者','',''],['作死','',''],['作死马医','',''],['作法','',''],['作法自毙','',''],['作派','',''],['作爱','',''],['作物','',''],['作用','',''],['作用于','',''],['作用力','',''],['作用域','',''],['作用理论','',''],['作画','',''],['作痛','',''],['作祟','',''],['作福','',''],['作福作威','',''],['作秀','',''],['作笔记','',''],['作答','',''],['作罢','',''],['作美','',''],['作者','',''],['作者不详','',''],['作者未详','',''],['作者权','',''],['作脸','',''],['作舍道边','',''],['作色','',''],['作艺','',''],['作苦工','',''],['作茧','',''],['作茧自缚','',''],['作表','',''],['作裁判','',''],['作见证','',''],['作誓','',''],['作记号','',''],['作证','',''],['作证能力','',''],['作评价','',''],['作词','',''],['作诗','',''],['作诗法','',''],['作诗者','',''],['作贱','',''],['作贼','',''],['作贼心虚','',''],['作赔','',''],['作践','',''],['作辍','',''],['作过','',''],['作陪','',''],['作难','',''],['作风','',''],['作风修养','',''],['作风正派','',''],['作马','',''],['作鬼','',''],['作鸟兽散','',''],['佝偻','',''],['佝偻病','',''],['佝瞀','',''],['佟佳江','',''],['你争我夺','',''],['你们','',''],['你好','',''],['你家','',''],['你我','',''],['你死我活','',''],['你知我知','',''],['你老','',''],['你追我赶','',''],['佣人','',''],['佣人领班','',''],['佣兵','',''],['佣妇','',''],['佣婢','',''],['佣工','',''],['佣金','',''],['佣钱','',''],['佧佤族','',''],['佩兰','',''],['佩刀','',''],['佩剑','',''],['佩地','',''],['佩带','',''],['佩思','',''],['佩戴','',''],['佩挂','',''],['佩服','',''],['佩林','',''],['佩洛西','',''],['佩玉','',''],['佩环','',''],['佩花','',''],['佩韦佩弦','',''],['佩饰','',''],['佩鲁贾','',''],['佬族','',''],['佯为','',''],['佯动','',''],['佯攻','',''],['佯死','',''],['佯狂','',''],['佯称','',''],['佯笑','',''],['佯羞','',''],['佯装','',''],['佯装不知','',''],['佯装者','',''],['佯言','',''],['佯败','',''],['佯降','',''],['佳世客','',''],['佳丽','',''],['佳人','',''],['佳人才子','',''],['佳人薄命','',''],['佳作','',''],['佳偶','',''],['佳兵不祥','',''],['佳冬','',''],['佳冬乡','',''],['佳化','',''],['佳句','',''],['佳品','',''],['佳地','',''],['佳境','',''],['佳妙','',''],['佳客','',''],['佳宾','',''],['佳得乐','',''],['佳日','',''],['佳景','',''],['佳期','',''],['佳木斯大学','',''],['佳洁士','',''],['佳篇','',''],['佳绩','',''],['佳美','',''],['佳肴','',''],['佳能','',''],['佳节','',''],['佳誉','',''],['佳评如潮','',''],['佳话','',''],['佳酿','',''],['佳里','',''],['佳里镇','',''],['佳音','',''],['佶屈聱牙','',''],['佻巧','',''],['佻薄','',''],['佼佼','',''],['佼佼者','',''],['使上','',''],['使下','',''],['使不','',''],['使不得','',''],['使与','',''],['使为','',''],['使之','',''],['使习惯','',''],['使于','',''],['使人','',''],['使人信服','',''],['使他','',''],['使以','',''],['使住','',''],['使作','',''],['使作呕','',''],['使免除','',''],['使入','',''],['使兴奋','',''],['使其','',''],['使具','',''],['使具体化','',''],['使再','',''],['使出','',''],['使到','',''],['使力','',''],['使功不如使过','',''],['使动','',''],['使劲','',''],['使劲儿','',''],['使厌烦','',''],['使受','',''],['使受伤','',''],['使君子','',''],['使命','',''],['使命感','',''],['使唤','',''],['使因','',''],['使团','',''],['使困扰','',''],['使困窘','',''],['使在','',''],['使坏','',''],['使失望','',''],['使女','',''],['使她','',''],['使如','',''],['使娱乐','',''],['使孤立','',''],['使它','',''],['使完','',''],['使容易','',''],['使对','',''],['使尽','',''],['使带','',''],['使当','',''],['使役','',''],['使徒','',''],['使徒行传','',''],['使得','',''],['使怒','',''],['使性子','',''],['使恶','',''],['使您','',''],['使惯','',''],['使愤怒','',''],['使愤慨','',''],['使成','',''],['使成一体','',''],['使我','',''],['使我们','',''],['使无','',''],['使智使勇','',''],['使更','',''],['使最','',''],['使有','',''],['使服','',''],['使气','',''],['使湿透','',''],['使满意','',''],['使热','',''],['使然','',''],['使犯','',''],['使现','',''],['使生气','',''],['使用','',''],['使用不当','',''],['使用价值','',''],['使用手册','',''],['使用报告','',''],['使用数量','',''],['使用方便','',''],['使用方法','',''],['使用期','',''],['使用权','',''],['使用条款','',''],['使用者','',''],['使用者中介','',''],['使用范围','',''],['使用说明','',''],['使用费','',''],['使用量','',''],['使由','',''],['使看','',''],['使眼色','',''],['使硬化','',''],['使羊将狼','',''],['使羞愧','',''],['使者','',''],['使而','',''],['使耳聋','',''],['使能','',''],['使膨胀','',''],['使臂使指','',''],['使臣','',''],['使至','',''],['使节','',''],['使节团','',''],['使获','',''],['使著','',''],['使蔓延','',''],['使蚊负山','',''],['使被','',''],['使该','',''],['使负','',''],['使贪使愚','',''],['使起','',''],['使转向','',''],['使达','',''],['使过','',''],['使遭','',''],['使醉','',''],['使领官员','',''],['使领馆','',''],['使馆','',''],['使骇怕','',''],['使高兴','',''],['使高贵','',''],['使魔法','',''],['使麻痹','',''],['侃价','',''],['侃侃','',''],['侃侃而谈','',''],['侃侃谔谔','',''],['侃儿','',''],['侃大山','',''],['侃山','',''],['侃星','',''],['侃爷','',''],['侄儿','',''],['侄外','',''],['侄女','',''],['侄女婿','',''],['侄妇','',''],['侄媳','',''],['侄媳妇','',''],['侄子','',''],['侄孙','',''],['侄孙儿','',''],['侄孙女','',''],['侄甥','',''],['侈奢','',''],['侈糜','',''],['侈谈','',''],['侈靡','',''],['侉子','',''],['例会','',''],['例假','',''],['例假日除外','',''],['例句','',''],['例外','',''],['例外字','',''],['例如','',''],['例子','',''],['例文','',''],['例案','',''],['例示','',''],['例程','',''],['例行','',''],['例行公事','',''],['例规','',''],['例言','',''],['例证','',''],['例语','',''],['例项','',''],['例题','',''],['侍中','',''],['侍仆','',''],['侍从','',''],['侍候','',''],['侍养','',''],['侍制','',''],['侍卫','',''],['侍卫官','',''],['侍奉','',''],['侍女','',''],['侍妾','',''],['侍婢','',''],['侍应','',''],['侍应生','',''],['侍弄','',''],['侍役','',''],['侍立','',''],['侍童','',''],['侍者','',''],['侍郎','',''],['侏儒','',''],['侏儒仓鼠','',''],['侏儒症','',''],['侏儒观戏','',''],['侏罗','',''],['侏罗系','',''],['侏罗纪','',''],['侔色揣称','',''],['侗人','',''],['侗剧','',''],['供不应求','',''],['供产销','',''],['供人','',''],['供以','',''],['供价','',''],['供住','',''],['供佛','',''],['供佛花','',''],['供作','',''],['供信','',''],['供养','',''],['供出','',''],['供品','',''],['供售','',''],['供大于求','',''],['供奉','',''],['供应','',''],['供应价格','',''],['供应体制','',''],['供应品','',''],['供应商','',''],['供应室','',''],['供应标准','',''],['供应点','',''],['供应站','',''],['供应者','',''],['供应量','',''],['供应链','',''],['供房','',''],['供方','',''],['供暖','',''],['供桌','',''],['供气','',''],['供水','',''],['供水栓','',''],['供求','',''],['供求关系','',''],['供求矛盾','',''],['供油','',''],['供油系统','',''],['供热','',''],['供燃气','',''],['供片','',''],['供物','',''],['供状','',''],['供献','',''],['供电','',''],['供电局','',''],['供电系统','',''],['供神','',''],['供称','',''],['供稿','',''],['供粮','',''],['供给','',''],['供给制','',''],['供给者','',''],['供给量','',''],['供给侧','',''],['供给方','',''],['供职','',''],['供膳','',''],['供花','',''],['供血','',''],['供血者','',''],['供认','',''],['供认不讳','',''],['供证','',''],['供词','',''],['供货','',''],['供货商','',''],['供资','',''],['供过于求','',''],['供述','',''],['供量','',''],['供销','',''],['供销合作社','',''],['供销商','',''],['供销社','',''],['供销系统','',''],['供销部门','',''],['供需','',''],['供需矛盾','',''],['供需见面','',''],['依人','',''],['依从','',''],['依仗','',''],['依体画葫芦','',''],['依余类推','',''],['依例','',''],['依依','',''],['依依不舍','',''],['依依惜别','',''],['依偎','',''],['依傍','',''],['依其','',''],['依凭','',''],['依后','',''],['依地酸二钴','',''],['依字母','',''],['依存','',''],['依属','',''],['依山傍水','',''],['依序','',''],['依律','',''],['依循','',''],['依恋','',''],['依我来看','',''],['依我看','',''],['依我看来','',''],['依托','',''],['依据','',''],['依据事实','',''],['依撒依亚','',''],['依撒意亚','',''],['依撒格','',''],['依旧','',''],['依期','',''],['依条约','',''],['依柳辛','',''],['依样','',''],['依样画葫芦','',''],['依样葫芦','',''],['依次','',''],['依次为','',''],['依此','',''],['依此类推','',''],['依法','',''],['依法办事','',''],['依法处理','',''],['依法查处','',''],['依法治国','',''],['依法治理','',''],['依洛瓦底','',''],['依流平进','',''],['依然','',''],['依然如我','',''],['依然如故','',''],['依然故我','',''],['依然是','',''],['依照','',''],['依率','',''],['依田纪基','',''],['依直','',''],['依着','',''],['依稀','',''],['依约','',''],['依草附木','',''],['依言','',''],['依计行事','',''],['依赖','',''],['依赖于','',''],['依赖心','',''],['依赖思想','',''],['依赖性','',''],['依违','',''],['依阿取容','',''],['依附','',''],['依附于','',''],['依靠','',''],['依靠人民','',''],['依靠群众','',''],['依靠集体','',''],['依顺','',''],['依顺序','',''],['侠义','',''],['侠侣','',''],['侠士','',''],['侠女','',''],['侠客','',''],['侠气','',''],['侠盗','',''],['侠盗猎车手','',''],['侠盗飞车','',''],['侠送','',''],['侠骨','',''],['侥幸','',''],['侦办','',''],['侦听','',''],['侦听器','',''],['侦察','',''],['侦察兵','',''],['侦察出','',''],['侦察卫星','',''],['侦察员','',''],['侦察性','',''],['侦察排','',''],['侦察机','',''],['侦察者','',''],['侦探','',''],['侦探小说','',''],['侦查','',''],['侦检','',''],['侦毒','',''],['侦毒器','',''],['侦毒管','',''],['侦测','',''],['侦测器','',''],['侦破','',''],['侦缉','',''],['侦讯','',''],['侦速','',''],['侧体','',''],['侧光','',''],['侧击','',''],['侧刀旁','',''],['侧卧','',''],['侧压','',''],['侧压力','',''],['侧向','',''],['侧壁','',''],['侧室','',''],['侧录','',''],['侧影','',''],['侧房','',''],['侧扁','',''],['侧投影','',''],['侧投球','',''],['侧方','',''],['侧板','',''],['侧枝','',''],['侧柏','',''],['侧标','',''],['侧根','',''],['侧棱','',''],['侧橱','',''],['侧歪','',''],['侧泳','',''],['侧滑','',''],['侧灯','',''],['侧目','',''],['侧目而视','',''],['侧睡','',''],['侧笔','',''],['侧线','',''],['侧翼','',''],['侧耳','',''],['侧耳倾听','',''],['侧耳细听','',''],['侧芽','',''],['侧蚀力','',''],['侧视','',''],['侧视图','',''],['侧记','',''],['侧身','',''],['侧身政檀','',''],['侧躺','',''],['侧边','',''],['侧边栏','',''],['侧过','',''],['侧进','',''],['侧道','',''],['侧部','',''],['侧重','',''],['侧重于','',''],['侧重点','',''],['侧链','',''],['侧锋','',''],['侧门','',''],['侧闻','',''],['侧面','',''],['侧面像','',''],['侧面图','',''],['侧页','',''],['侧风','',''],['侨乡','',''],['侨办','',''],['侨务','',''],['侨务办公室','',''],['侨务工作','',''],['侨区','',''],['侨商','',''],['侨团','',''],['侨居','',''],['侨居国','',''],['侨属','',''],['侨教','',''],['侨民','',''],['侨汇','',''],['侨生','',''],['侨界','',''],['侨眷','',''],['侨联','',''],['侨胞','',''],['侨资','',''],['侨领','',''],['侪辈','',''],['侮弄','',''],['侮慢','',''],['侮蔑','',''],['侮辱','',''],['侮辱性','',''],['侮骂','',''],['侯景之乱','',''],['侯爵','',''],['侯赛因','',''],['侯选人','',''],['侯门似海','',''],['侯鸟','',''],['侵入','',''],['侵入家宅者','',''],['侵入岩','',''],['侵入性','',''],['侵入者','',''],['侵凌','',''],['侵华','',''],['侵占','',''],['侵吞','',''],['侵夺','',''],['侵害','',''],['侵害人','',''],['侵害者','',''],['侵彻力','',''],['侵截','',''],['侵截者','',''],['侵扰','',''],['侵晨','',''],['侵权','',''],['侵权人','',''],['侵权行为','',''],['侵染','',''],['侵渔','',''],['侵犯','',''],['侵犯者','',''],['侵略','',''],['侵略军','',''],['侵略国','',''],['侵略战争','',''],['侵略扩张','',''],['侵略者','',''],['侵蚀','',''],['侵蚀作用','',''],['侵袭','',''],['侵越','',''],['侵透','',''],['便与','',''],['便中','',''],['便了','',''],['便于','',''],['便于工作','',''],['便于管理','',''],['便于解决','',''],['便人','',''],['便从','',''],['便会','',''],['便使','',''],['便便','',''],['便函','',''],['便利','',''],['便利商店','',''],['便利店','',''],['便利性','',''],['便利设施','',''],['便利贴','',''],['便卡','',''],['便可','',''],['便后','',''],['便器','',''],['便士','',''],['便壶','',''],['便嬛','',''],['便宜','',''],['便宜从事','',''],['便宜行事','',''],['便宜货','',''],['便宴','',''],['便将','',''],['便帽','',''],['便床','',''],['便当','',''],['便得','',''],['便所','',''],['便把令来行','',''],['便捷','',''],['便捷化','',''],['便携','',''],['便携式','',''],['便携机','',''],['便是','',''],['便有','',''],['便服','',''],['便条','',''],['便条纸','',''],['便桥','',''],['便桶','',''],['便步走','',''],['便毒','',''],['便民','',''],['便民利民','',''],['便民服务','',''],['便池','',''],['便溺','',''],['便状','',''],['便盆','',''],['便秘','',''],['便笺','',''],['便签','',''],['便而','',''],['便能','',''],['便菜','',''],['便血','',''],['便衣','',''],['便衣警察','',''],['便被','',''],['便装','',''],['便裤','',''],['便览','',''],['便车','',''],['便车旅行者','',''],['便道','',''],['便酌','',''],['便门','',''],['便难','',''],['便鞋','',''],['便餐','',''],['便饭','',''],['便饯','',''],['促产','',''],['促令','',''],['促使','',''],['促其','',''],['促动','',''],['促发','',''],['促声','',''],['促弦','',''],['促成','',''],['促求','',''],['促熟','',''],['促狭','',''],['促狭鬼','',''],['促生产','',''],['促织','',''],['促脉','',''],['促膝','',''],['促膝谈心','',''],['促请','',''],['促进','',''],['促进会','',''],['促进作用','',''],['促进剂','',''],['促进性','',''],['促进改革','',''],['促进派','',''],['促进生产','',''],['促进者','',''],['促退','',''],['促销','',''],['俄中','',''],['俄中朝','',''],['俄亥俄','',''],['俄亥俄州','',''],['俄克拉何马','',''],['俄克拉何马城','',''],['俄克拉何马州','',''],['俄军','',''],['俄勒冈','',''],['俄勒冈州','',''],['俄国','',''],['俄国一九○五年革命','',''],['俄国二月革命','',''],['俄国人','',''],['俄备得','',''],['俄巴底亚书','',''],['俄底浦斯','',''],['俄底浦斯情结','',''],['俄文','',''],['俄狄浦斯','',''],['俄罗斯人','',''],['俄罗斯帝国','',''],['俄罗斯方块','',''],['俄罗斯研究会','',''],['俄罗斯联邦','',''],['俄罗斯轮盘','',''],['俄而','',''],['俄联邦','',''],['俄裔','',''],['俄语','',''],['俄顷','',''],['俊俏','',''],['俊拔','',''],['俊杰','',''],['俊爽','',''],['俊秀','',''],['俊美','',''],['俊逸','',''],['俊雅','',''],['俊马','',''],['俎上肉','',''],['俏丽','',''],['俏似','',''],['俏俊','',''],['俏头','',''],['俏式','',''],['俏步','',''],['俏皮','',''],['俏皮话','',''],['俐牙俐齿','',''],['俐落','',''],['俐齿伶牙','',''],['俑坑','',''],['俗不可耐','',''],['俗不堪耐','',''],['俗世','',''],['俗世奇人','',''],['俗丽','',''],['俗义','',''],['俗事','',''],['俗人','',''],['俗体','',''],['俗体字','',''],['俗例','',''],['俗剧','',''],['俗名','',''],['俗士','',''],['俗套','',''],['俗字','',''],['俗定','',''],['俗家','',''],['俗尚','',''],['俗心','',''],['俗念','',''],['俗态','',''],['俗性','',''],['俗气','',''],['俗物','',''],['俗用','',''],['俗称','',''],['俗缘','',''],['俗艳','',''],['俗论','',''],['俗话','',''],['俗话说','',''],['俗语','',''],['俗谚','',''],['俗谚口碑','',''],['俗随时变','',''],['俘管工作','',''],['俘获','',''],['俘营','',''],['俘虏','',''],['俘虏政策','',''],['俚俗','',''],['俚言','',''],['俚语','',''],['俚谚','',''],['保不住','',''],['保不定','',''],['保不齐','',''],['保业','',''],['保丽龙','',''],['保举','',''],['保亭','',''],['保亭县','',''],['保人','',''],['保价','',''],['保价信','',''],['保价函件','',''],['保住','',''],['保佑','',''],['保修','',''],['保修期','',''],['保值','',''],['保值储蓄','',''],['保健','',''],['保健员','',''],['保健操','',''],['保健站','',''],['保健食品','',''],['保元丸','',''],['保全','',''],['保全工','',''],['保全面子','',''],['保养','',''],['保养费','',''],['保准','',''],['保利','',''],['保利科技有限公司','',''],['保力龙','',''],['保单','',''],['保卫','',''],['保卫和平','',''],['保卫工作','',''],['保卫战','',''],['保卫祖国','',''],['保卫科','',''],['保呈','',''],['保命','',''],['保和丸','',''],['保固','',''],['保国安民','',''],['保墒','',''],['保增长','',''],['保外就医','',''],['保姆','',''],['保媒','',''],['保存','',''],['保存实力','',''],['保存性','',''],['保存期','',''],['保存物','',''],['保存者','',''],['保守','',''],['保守主义','',''],['保守党','',''],['保守党人','',''],['保守性','',''],['保守机密','',''],['保守派','',''],['保守疗法','',''],['保安','',''],['保安人员','',''],['保安团','',''],['保安局局长','',''],['保安自动化','',''],['保安部队','',''],['保安队','',''],['保官','',''],['保定地区','',''],['保家卫国','',''],['保密','',''],['保密性','',''],['保尔','',''],['保尔森','',''],['保山地区','',''],['保底','',''],['保惠师','',''],['保户','',''],['保护','',''],['保护主义','',''],['保护人','',''],['保护伞','',''],['保护关税','',''],['保护剂','',''],['保护区','',''],['保护国','',''],['保护地','',''],['保护层','',''],['保护性','',''],['保护模式','',''],['保护气体','',''],['保护网','',''],['保护者','',''],['保护色','',''],['保护装置','',''],['保护视力','',''],['保护贸易','',''],['保护金','',''],['保护鸟','',''],['保持','',''],['保持一致','',''],['保持克制','',''],['保持原状','',''],['保持原貌','',''],['保持性','',''],['保持清洁','',''],['保持稳定','',''],['保持系','',''],['保持者','',''],['保持联系','',''],['保持警惕','',''],['保收','',''],['保教','',''],['保时捷','',''],['保暖','',''],['保有','',''],['保本','',''],['保残守缺','',''],['保母','',''],['保洁','',''],['保洁箱','',''],['保温','',''],['保温杯','',''],['保温瓶','',''],['保湿','',''],['保热','',''],['保状','',''],['保环主义','',''],['保用','',''],['保田','',''],['保甲','',''],['保甲制度','',''],['保留','',''],['保留剧目','',''],['保留区','',''],['保留地','',''],['保留权','',''],['保留版权','',''],['保留物','',''],['保皇','',''],['保皇党','',''],['保皇派','',''],['保真','',''],['保真度','',''],['保祐','',''],['保票','',''],['保税','',''],['保税制','',''],['保税区','',''],['保管','',''],['保管人','',''],['保管员','',''],['保管处','',''],['保结','',''],['保罗','',''],['保育','',''],['保育员','',''],['保育器','',''],['保育院','',''],['保膘','',''],['保良','',''],['保苗','',''],['保荐','',''],['保荐书','',''],['保藏','',''],['保角','',''],['保角对应','',''],['保证','',''],['保证书','',''],['保证人','',''],['保证供应','',''],['保证供给','',''],['保证破坏战略','',''],['保证质量','',''],['保证金','',''],['保证需要','',''],['保语','',''],['保质','',''],['保质保量','',''],['保质期','',''],['保费','',''],['保路运动','',''],['保身','',''],['保送','',''],['保释','',''],['保释人','',''],['保释者','',''],['保释金','',''],['保重','',''],['保重身体','',''],['保量','',''],['保镖','',''],['保镳','',''],['保长','',''],['保长对应','',''],['保险','',''],['保险业','',''],['保险业务','',''],['保险业者','',''],['保险丝','',''],['保险人','',''],['保险公司','',''],['保险刀','',''],['保险单','',''],['保险商','',''],['保险套','',''],['保险期','',''],['保险期限','',''],['保险杠','',''],['保险柜','',''],['保险灯','',''],['保险盒','',''],['保险箱','',''],['保险粉','',''],['保险装置','',''],['保险解开系统','',''],['保险费','',''],['保险金','',''],['保障','',''],['保障人','',''],['保障机制','',''],['保障监督','',''],['保驾','',''],['保鲜','',''],['保鲜剂','',''],['保鲜期','',''],['保鲜纸','',''],['保鲜膜','',''],['保龄','',''],['保龄球','',''],['保龄球馆','',''],['俞允','',''],['俞天白','',''],['俞文豹','',''],['俟候','',''],['俟机','',''],['俟河之清','',''],['信上','',''],['信不过','',''],['信中','',''],['信义','',''],['信义乡','',''],['信义区','',''],['信从','',''],['信令','',''],['信以为真','',''],['信仰','',''],['信仰主义','',''],['信仰者','',''],['信件','',''],['信任','',''],['信任感','',''],['信任投票','',''],['信任状','',''],['信任票','',''],['信众','',''],['信佛','',''],['信使','',''],['信使核糖核酸','',''],['信函','',''],['信区','',''],['信及豚鱼','',''],['信口','',''],['信口开河','',''],['信口胡说','',''],['信口雌黄','',''],['信史','',''],['信号','',''],['信号台','',''],['信号器','',''],['信号处理','',''],['信号弹','',''],['信号手','',''],['信号曲','',''],['信号机','',''],['信号枪','',''],['信号灯','',''],['信噪比','',''],['信址','',''],['信士','',''],['信外','',''],['信天游','',''],['信天翁','',''],['信奉','',''],['信女','',''],['信她','',''],['信孚中外','',''],['信守','',''],['信守合同','',''],['信实','',''],['信宿','',''],['信封','',''],['信州','',''],['信差','',''],['信徒','',''],['信得过','',''],['信徙','',''],['信德省','',''],['信心','',''],['信心倍增','',''],['信念','',''],['信息','',''],['信息与通讯技术','',''],['信息中心','',''],['信息化','',''],['信息处理','',''],['信息学','',''],['信息战','',''],['信息技术','',''],['信息时代','',''],['信息社会','',''],['信息管理','',''],['信息系统','',''],['信息素','',''],['信息论','',''],['信息资源','',''],['信息量','',''],['信息高速公路','',''],['信意','',''],['信手','',''],['信手拈来','',''],['信托','',''],['信报','',''],['信报财经新闻','',''],['信据','',''],['信政','',''],['信教','',''],['信服','',''],['信望','',''],['信札','',''],['信条','',''],['信标','',''],['信档','',''],['信步','',''],['信汇','',''],['信然','',''],['信物','',''],['信瓤儿','',''],['信用','',''],['信用卡','',''],['信用危机','',''],['信用合作社','',''],['信用度','',''],['信用状','',''],['信用等级','',''],['信用观察','',''],['信用证','',''],['信用证券','',''],['信用评等','',''],['信用评级','',''],['信用额','',''],['信用风险','',''],['信皮','',''],['信皮儿','',''],['信石','',''],['信神','',''],['信神者','',''],['信笔','',''],['信笔涂鸦','',''],['信笺','',''],['信笺簿','',''],['信筒','',''],['信管','',''],['信箱','',''],['信纸','',''],['信经','',''],['信者','',''],['信而有征','',''],['信誉','',''],['信誉第一','',''],['信誓','',''],['信誓旦旦','',''],['信访','',''],['信说','',''],['信贷','',''],['信贷危机','',''],['信贷员','',''],['信贷紧缩','',''],['信贷衍生产品','',''],['信贷资金','',''],['信贷违约掉期','',''],['信赏必罚','',''],['信赖','',''],['信赖区间','',''],['信赖者','',''],['信道','',''],['信里','',''],['信阳地区','',''],['信靠','',''],['信风','',''],['信马游缰','',''],['信鸽','',''],['俨如','',''],['俨如白昼','',''],['俨然','',''],['俩人','',''],['俩眼','',''],['俭以养廉','',''],['俭以防匮','',''],['俭则不缺','',''],['俭学','',''],['俭明','',''],['俭朴','',''],['俭用','',''],['俭省','',''],['俭素','',''],['俭约','',''],['俭腹','',''],['俭薄','',''],['修业','',''],['修习','',''],['修书','',''],['修了','',''],['修仙','',''],['修会','',''],['修修','',''],['修光','',''],['修养','',''],['修函','',''],['修到','',''],['修剪','',''],['修剪者','',''],['修图','',''],['修堤','',''],['修士','',''],['修复','',''],['修复一新','',''],['修复者','',''],['修女','',''],['修好','',''],['修定','',''],['修建','',''],['修心养性','',''],['修性','',''],['修成','',''],['修房','',''],['修护','',''],['修指','',''],['修指甲','',''],['修描','',''],['修撰','',''],['修改','',''],['修改意见','',''],['修改稿','',''],['修改草案','',''],['修改量','',''],['修整','',''],['修文偃武','',''],['修旧','',''],['修旧利废','',''],['修明','',''],['修期','',''],['修枝','',''],['修桥','',''],['修桥补路','',''],['修正','',''],['修正主义','',''],['修正案','',''],['修正稿','',''],['修正者','',''],['修水利','',''],['修治','',''],['修浚','',''],['修炼','',''],['修炼成仙','',''],['修理','',''],['修理厂','',''],['修理工','',''],['修理者','',''],['修理行业','',''],['修盖','',''],['修睦','',''],['修短','',''],['修禊','',''],['修筑','',''],['修练','',''],['修编','',''],['修缮','',''],['修缮一新','',''],['修缮者','',''],['修罗','',''],['修脚','',''],['修脸','',''],['修船','',''],['修葺','',''],['修行','',''],['修行人','',''],['修行在个人','',''],['修补','',''],['修补匠','',''],['修补者','',''],['修表','',''],['修规','',''],['修订','',''],['修订历史','',''],['修订本','',''],['修订版','',''],['修订稿','',''],['修订者','',''],['修词','',''],['修读','',''],['修起','',''],['修路','',''],['修身','',''],['修身养性','',''],['修身齐家','',''],['修车','',''],['修辞','',''],['修辞学','',''],['修辞格','',''],['修过','',''],['修造','',''],['修造厂','',''],['修道','',''],['修道会','',''],['修道士','',''],['修道张','',''],['修道院','',''],['修配','',''],['修长','',''],['修院','',''],['修面','',''],['修鞋','',''],['修鞋匠','',''],['修音','',''],['修饰','',''],['修饰话','',''],['修饰语','',''],['修饰边幅','',''],['修齐','',''],['修龄','',''],['俯下','',''],['俯仰','',''],['俯仰之间','',''],['俯仰无愧','',''],['俯仰由人','',''],['俯伏','',''],['俯冲','',''],['俯卧','',''],['俯卧撑','',''],['俯在','',''],['俯垂','',''],['俯就','',''],['俯拾即是','',''],['俯拾地芥','',''],['俯拾皆是','',''],['俯拾青紫','',''],['俯泳','',''],['俯看','',''],['俯瞰','',''],['俯瞰图','',''],['俯瞰摄影','',''],['俯街','',''],['俯视','',''],['俯视图','',''],['俯览','',''],['俯角','',''],['俯赐','',''],['俯身','',''],['俯首','',''],['俯首倾耳','',''],['俯首听命','',''],['俯首帖耳','',''],['俯首称臣','',''],['俯首贴耳','',''],['俱乐','',''],['俱乐部','',''],['俱佳','',''],['俱全','',''],['俱兴','',''],['俱利','',''],['俱到','',''],['俱在','',''],['俱备','',''],['俱收并蓄','',''],['俳优','',''],['俳句','',''],['俳谐','',''],['俸恤','',''],['俸禄','',''],['俸给','',''],['俸躬','',''],['俸钱','',''],['俸银','',''],['俺们','',''],['俾使','',''],['俾倪','',''],['俾夜作昼','',''],['俾斯麦','',''],['俾昼作夜','',''],['俾格米','',''],['俾路支','',''],['俾路支省','',''],['倍于','',''],['倍儿','',''],['倍儿棒','',''],['倍减','',''],['倍加','',''],['倍受','',''],['倍受尊敬','',''],['倍受欢迎','',''],['倍受鼓舞','',''],['倍塔','',''],['倍塔射线','',''],['倍塔粒子','',''],['倍增','',''],['倍增器','',''],['倍感','',''],['倍数','',''],['倍率','',''],['倍足类','',''],['倍足纲','',''],['倍道兼行','',''],['倍道兼进','',''],['倍频','',''],['倍频器','',''],['倏地','',''],['倏忽','',''],['倏来忽往','',''],['倏然','',''],['倒三颠四','',''],['倒下','',''],['倒不如','',''],['倒买倒卖','',''],['倒了','',''],['倒于','',''],['倒仓','',''],['倒仰儿','',''],['倒伏','',''],['倒休','',''],['倒位','',''],['倒像','',''],['倒入','',''],['倒写','',''],['倒冠落佩','',''],['倒凤颠鸾','',''],['倒出','',''],['倒刺','',''],['倒卖','',''],['倒卧','',''],['倒卵形','',''],['倒去','',''],['倒反','',''],['倒叙','',''],['倒台','',''],['倒吊蜡烛','',''],['倒嗓','',''],['倒噍','',''],['倒嚼','',''],['倒四颠三','',''],['倒回','',''],['倒在','',''],['倒地','',''],['倒坍','',''],['倒塌','',''],['倒头','',''],['倒好儿','',''],['倒屐相迎','',''],['倒屐而迎','',''],['倒屐迎宾','',''],['倒山倾海','',''],['倒帐','',''],['倒帖','',''],['倒带','',''],['倒序','',''],['倒座儿','',''],['倒开','',''],['倒弄','',''],['倒彩','',''],['倒彩声','',''],['倒影','',''],['倒忙','',''],['倒悬','',''],['倒悬之危','',''],['倒悬之急','',''],['倒悬之苦','',''],['倒戈','',''],['倒戈卸甲','',''],['倒扁','',''],['倒手','',''],['倒打','',''],['倒打一耙','',''],['倒扣','',''],['倒把','',''],['倒把投机','',''],['倒抽','',''],['倒抽一口气','',''],['倒拨','',''],['倒持泰阿','',''],['倒挂','',''],['倒挤','',''],['倒换','',''],['倒推','',''],['倒插','',''],['倒插门','',''],['倒放','',''],['倒数','',''],['倒映','',''],['倒春寒','',''],['倒是','',''],['倒替','',''],['倒有','',''],['倒板','',''],['倒枕捶床','',''],['倒果为因','',''],['倒栽','',''],['倒栽葱','',''],['倒档','',''],['倒楣','',''],['倒槽','',''],['倒毙','',''],['倒注口','',''],['倒注者','',''],['倒流','',''],['倒海','',''],['倒海反江','',''],['倒海移山','',''],['倒海翻江','',''],['倒满','',''],['倒灌','',''],['倒灶','',''],['倒爷','',''],['倒牙','',''],['倒班','',''],['倒相','',''],['倒睫','',''],['倒睫症','',''],['倒空','',''],['倒立','',''],['倒立像','',''],['倒竖','',''],['倒算','',''],['倒粪','',''],['倒绷孩儿','',''],['倒置','',''],['倒置干戈','',''],['倒翻','',''],['倒胃口','',''],['倒背如流','',''],['倒背手','',''],['倒背手儿','',''],['倒腾','',''],['倒苦水','',''],['倒茬','',''],['倒茶','',''],['倒落','',''],['倒薮','',''],['倒虹吸','',''],['倒蛋','',''],['倒行','',''],['倒行逆施','',''],['倒装','',''],['倒装句','',''],['倒裳索领','',''],['倒要','',''],['倒计时','',''],['倒读','',''],['倒象','',''],['倒败','',''],['倒账','',''],['倒贴','',''],['倒赔','',''],['倒踏门','',''],['倒车','',''],['倒车挡','',''],['倒轧','',''],['倒转','',''],['倒轮闸','',''],['倒载干戈','',''],['倒过儿','',''],['倒过来','',''],['倒运','',''],['倒退','',''],['倒逆','',''],['倒采','',''],['倒钩','',''],['倒链','',''],['倒锁','',''],['倒错','',''],['倒闭','',''],['倒阁','',''],['倒霉','',''],['倔头倔脑','',''],['倔巴','',''],['倔强','',''],['倘不','',''],['倘不如此','',''],['倘佯','',''],['倘使','',''],['倘或','',''],['倘有','',''],['倘未','',''],['倘来之物','',''],['倘然','',''],['倘能','',''],['倘能如此','',''],['倘若','',''],['候任','',''],['候光','',''],['候命','',''],['候场','',''],['候审','',''],['候教','',''],['候服玉衣','',''],['候机','',''],['候机厅','',''],['候机室','',''],['候机楼','',''],['候梯厅','',''],['候温','',''],['候爵','',''],['候粮','',''],['候缺','',''],['候船','',''],['候补','',''],['候补名单','',''],['候补委员','',''],['候诊','',''],['候诊室','',''],['候车','',''],['候车室','',''],['候选','',''],['候选人','',''],['候门如海','',''],['候领','',''],['候风地动仪','',''],['候驾','',''],['候鸟','',''],['倚仗','',''],['倚势挟权','',''],['倚墙','',''],['倚天','',''],['倚天屠龙记','',''],['倚官仗势','',''],['倚山','',''],['倚强凌弱','',''],['倚恃','',''],['倚望','',''],['倚栏望月','',''],['倚玉偎香','',''],['倚立','',''],['倚翠偎红','',''],['倚老','',''],['倚老卖老','',''],['倚草附木','',''],['倚财仗势','',''],['倚赖','',''],['倚重','',''],['倚门','',''],['倚门倚闾','',''],['倚门傍户','',''],['倚门卖俏','',''],['倚门卖笑','',''],['倚闾之望','',''],['倚靠','',''],['倚音','',''],['倚马可待','',''],['倜傥','',''],['倜傥不羁','',''],['倜傥不群','',''],['倜然','',''],['借与','',''],['借东风','',''],['借主','',''],['借书','',''],['借书单','',''],['借书证','',''],['借了','',''],['借予','',''],['借人','',''],['借代','',''],['借以','',''],['借位','',''],['借住','',''],['借余','',''],['借债','',''],['借债人','',''],['借光','',''],['借入','',''],['借入方','',''],['借减','',''],['借出','',''],['借刀杀人','',''],['借助','',''],['借助于','',''],['借势','',''],['借单','',''],['借单儿','',''],['借取','',''],['借口','',''],['借古喻今','',''],['借古讽今','',''],['借命','',''],['借喻','',''],['借垫','',''],['借增','',''],['借契','',''],['借字','',''],['借字儿','',''],['借宿','',''],['借寇兵赍盗粮','',''],['借尸还魂','',''],['借差','',''],['借帐','',''],['借得','',''],['借手除敌','',''],['借指','',''],['借据','',''],['借支','',''],['借故','',''],['借方','',''],['借方差额','',''],['借景抒情','',''],['借期','',''],['借机','',''],['借机报复','',''],['借条','',''],['借来','',''],['借款','',''],['借款人','',''],['借此','',''],['借此机会','',''],['借水行舟','',''],['借火','',''],['借用','',''],['借用人','',''],['借的','',''],['借端','',''],['借箸','',''],['借箸代筹','',''],['借给','',''],['借者','',''],['借而','',''],['借腹生子','',''],['借花','',''],['借花献佛','',''],['借记','',''],['借记卡','',''],['借词','',''],['借词推搪','',''],['借读','',''],['借调','',''],['借账','',''],['借贷','',''],['借贷资本','',''],['借资挹注','',''],['借过','',''],['借还','',''],['借道','',''],['借酒','',''],['借酒浇愁','',''],['借重','',''],['借鉴','',''],['借钱','',''],['借镜','',''],['借问','',''],['借阅','',''],['借领','',''],['借题','',''],['借题发挥','',''],['借风使船','',''],['倡仪','',''],['倡优','',''],['倡始','',''],['倡导','',''],['倡导者','',''],['倡条冶叶','',''],['倡狂','',''],['倡真','',''],['倡行','',''],['倡言','',''],['倡言者','',''],['倡议','',''],['倡议书','',''],['倡首','',''],['倥侗','',''],['倥偬','',''],['倦容','',''],['倦怠','',''],['倦意','',''],['倦感','',''],['倦游','',''],['倦鸟','',''],['倨傲','',''],['倩影','',''],['倩装','',''],['倪匡','',''],['倪嗣冲','',''],['倪柝声','',''],['倪桂珍','',''],['倭人','',''],['倭军','',''],['倭奴','',''],['倭寇','',''],['倭瓜','',''],['倭马亚王朝','',''],['倭黑猩猩','',''],['债主','',''],['债利','',''],['债券','',''],['债务','',''],['债务人','',''],['债务国','',''],['债务担保证券','',''],['债务证书','',''],['债务证券','',''],['债台','',''],['债台高筑','',''],['债息','',''],['债户','',''],['债权','',''],['债权人','',''],['债权国','',''],['债款','',''],['债物人','',''],['债额','',''],['值了','',''],['值勤','',''],['值域','',''],['值夜','',''],['值宿','',''],['值当','',''],['值得','',''],['值得一提','',''],['值得信赖','',''],['值得做','',''],['值得品味','',''],['值得敬佩','',''],['值得注意','',''],['值得注意的是','',''],['值得注视','',''],['值得称赞','',''],['值得要','',''],['值日','',''],['值日生','',''],['值星','',''],['值更','',''],['值此','',''],['值班','',''],['值班员','',''],['值班室','',''],['值表','',''],['值遇','',''],['值钱','',''],['倾佩','',''],['倾侧','',''],['倾倒','',''],['倾出','',''],['倾刻','',''],['倾刻间','',''],['倾力','',''],['倾动','',''],['倾卸','',''],['倾吐','',''],['倾吐胸臆','',''],['倾吐衷肠','',''],['倾向','',''],['倾向于','',''],['倾向性','',''],['倾听','',''],['倾听者','',''],['倾囊','',''],['倾国','',''],['倾国倾城','',''],['倾城','',''],['倾城倾国','',''],['倾家','',''],['倾家尽产','',''],['倾家竭产','',''],['倾家荡产','',''],['倾尽','',''],['倾巢','',''],['倾巢出动','',''],['倾巢来犯','',''],['倾巢而出','',''],['倾心','',''],['倾心吐胆','',''],['倾心尽力','',''],['倾慕','',''],['倾斜','',''],['倾斜仪','',''],['倾斜度','',''],['倾斜政策','',''],['倾斜着','',''],['倾斜角','',''],['倾斜面','',''],['倾服','',''],['倾桩','',''],['倾泄','',''],['倾注','',''],['倾泻','',''],['倾盆','',''],['倾盆大雨','',''],['倾盖','',''],['倾筐倒庋','',''],['倾箱倒箧','',''],['倾羡','',''],['倾耳','',''],['倾耳拭目','',''],['倾耳注目','',''],['倾耳细听','',''],['倾耳而听','',''],['倾肠倒腹','',''],['倾船','',''],['倾覆','',''],['倾角','',''],['倾诉','',''],['倾谈','',''],['倾轧','',''],['倾销','',''],['倾陷','',''],['倾颓','',''],['偃兵息甲','',''],['偃旗卧鼓','',''],['偃旗息鼓','',''],['偃武修文','',''],['偃蹇','',''],['偃鼠饮河','',''],['假中','',''],['假义','',''],['假人','',''],['假人像','',''],['假仁','',''],['假仁假义','',''],['假令','',''],['假以','',''],['假以辞色','',''],['假作','',''],['假使','',''],['假借','',''],['假借义','',''],['假借名义','',''],['假借字','',''],['假假','',''],['假假若是','',''],['假像','',''],['假充','',''],['假公','',''],['假公济私','',''],['假冒','',''],['假冒伪劣','',''],['假冒品','',''],['假冒者','',''],['假分数','',''],['假列','',''],['假力于人','',''],['假劣','',''],['假动作','',''],['假发','',''],['假名','',''],['假吏','',''],['假否定句','',''],['假品','',''],['假哭','',''],['假哭者','',''],['假唱','',''],['假善人','',''],['假嗓','',''],['假嗓子','',''],['假声','',''],['假大空','',''],['假如','',''],['假娘','',''],['假子','',''],['假定','',''],['假定者','',''],['假寐','',''],['假小子','',''],['假山','',''],['假币','',''],['假帐','',''],['假性','',''],['假性近视','',''],['假恶丑','',''],['假情假义','',''],['假情报','',''],['假想','',''],['假想敌','',''],['假惺惺','',''],['假意','',''],['假慈悲','',''],['假戏','',''],['假戏真做','',''],['假戏真唱','',''],['假手','',''],['假手于人','',''],['假托','',''],['假扣','',''],['假扮','',''],['假报告','',''],['假招子','',''],['假拱','',''],['假撇清','',''],['假支票','',''],['假日','',''],['假期','',''],['假条','',''],['假果','',''],['假根','',''],['假案','',''],['假植','',''],['假正经','',''],['假死','',''],['假泣','',''],['假漆','',''],['假牙','',''],['假珠宝','',''],['假的','',''],['假皮','',''],['假相','',''],['假眼','',''],['假睡','',''],['假票','',''],['假科学','',''],['假笑','',''],['假绅士','',''],['假而','',''],['假肢','',''],['假肯定句','',''],['假胡子','',''],['假腿','',''],['假芫茜','',''],['假若','',''],['假药','',''],['假蓝','',''],['假藉','',''],['假虎张威','',''],['假装','',''],['假言判断','',''],['假誓','',''],['假设','',''],['假设语气','',''],['假证','',''],['假证件','',''],['假词叠词','',''],['假话','',''],['假说','',''],['假象','',''],['假象牙','',''],['假货','',''],['假足','',''],['假途灭虢','',''],['假造','',''],['假道','',''],['假道伐虢','',''],['假道学','',''],['假释','',''],['假释犯','',''],['假钞','',''],['假面','',''],['假面具','',''],['假面剧','',''],['假面舞','',''],['假面舞会','',''],['假音','',''],['假高音','',''],['偌大','',''],['偎依','',''],['偎傍','',''],['偎抱','',''],['偎着','',''],['偎红依翠','',''],['偎香依玉','',''],['偏上','',''],['偏下','',''],['偏不','',''],['偏了','',''],['偏于','',''],['偏低','',''],['偏信','',''],['偏信则暗','',''],['偏倚','',''],['偏偏','',''],['偏僻','',''],['偏僻处','',''],['偏光','',''],['偏光器','',''],['偏光计','',''],['偏光镜','',''],['偏劳','',''],['偏南','',''],['偏压','',''],['偏厦','',''],['偏口鱼','',''],['偏右','',''],['偏向','',''],['偏听','',''],['偏听偏信','',''],['偏坠','',''],['偏多','',''],['偏大','',''],['偏头痛','',''],['偏好','',''],['偏安','',''],['偏宕','',''],['偏宠','',''],['偏宽','',''],['偏将','',''],['偏小','',''],['偏少','',''],['偏左','',''],['偏巧','',''],['偏差','',''],['偏差距离','',''],['偏师','',''],['偏序','',''],['偏废','',''],['偏待','',''],['偏微分','',''],['偏微分方程','',''],['偏心','',''],['偏心率','',''],['偏心眼','',''],['偏心矩','',''],['偏心轮','',''],['偏态','',''],['偏房','',''],['偏才','',''],['偏执','',''],['偏执型','',''],['偏执狂','',''],['偏护','',''],['偏振','',''],['偏振光','',''],['偏振波','',''],['偏振片','',''],['偏斜','',''],['偏方','',''],['偏旁','',''],['偏松','',''],['偏极','',''],['偏极化','',''],['偏极滤光镜','',''],['偏极镜','',''],['偏析','',''],['偏枯','',''],['偏正','',''],['偏正式合成词','',''],['偏歪','',''],['偏殿','',''],['偏注','',''],['偏流','',''],['偏滑','',''],['偏激','',''],['偏爱','',''],['偏狭','',''],['偏生','',''],['偏疼','',''],['偏瘫','',''],['偏离','',''],['偏私','',''],['偏科','',''],['偏移','',''],['偏移量','',''],['偏窄','',''],['偏紧','',''],['偏置','',''],['偏置电流','',''],['偏置电阻','',''],['偏航','',''],['偏衫','',''],['偏袒','',''],['偏西','',''],['偏要','',''],['偏见','',''],['偏角','',''],['偏距','',''],['偏转','',''],['偏转线圈','',''],['偏转角','',''],['偏轻','',''],['偏辞','',''],['偏远','',''],['偏邪不正','',''],['偏重','',''],['偏重于','',''],['偏锋','',''],['偏门','',''],['偏颇','',''],['偏题','',''],['偏食','',''],['偏高','',''],['偕同','',''],['偕老','',''],['偕行','',''],['做一天和尚','',''],['做上','',''],['做不到','',''],['做东','',''],['做为','',''],['做主','',''],['做买卖','',''],['做事','',''],['做亲','',''],['做人','',''],['做人家','',''],['做人情','',''],['做伴','',''],['做伴儿','',''],['做作','',''],['做假','',''],['做假账','',''],['做准备工作','',''],['做出','',''],['做到','',''],['做功','',''],['做功夫','',''],['做又是另外一回事','',''],['做响','',''],['做坏','',''],['做坏事','',''],['做声','',''],['做大','',''],['做女','',''],['做好','',''],['做好事','',''],['做好人','',''],['做好做歹','',''],['做媒','',''],['做媚眼','',''],['做学问','',''],['做完','',''],['做官','',''],['做客','',''],['做寿','',''],['做小','',''],['做小伏低','',''],['做工','',''],['做工作','',''],['做工夫','',''],['做市商','',''],['做广告','',''],['做广告宣传','',''],['做庄','',''],['做弄','',''],['做弊','',''],['做张做势','',''],['做张做智','',''],['做张做致','',''],['做得好','',''],['做得成','',''],['做戏','',''],['做成','',''],['做手','',''],['做手势','',''],['做手脚','',''],['做操','',''],['做文章','',''],['做早操','',''],['做样','',''],['做梦','',''],['做歉做好','',''],['做法','',''],['做活','',''],['做活儿','',''],['做派','',''],['做满月','',''],['做爱','',''],['做牌','',''],['做牛做马','',''],['做生意','',''],['做生日','',''],['做生活','',''],['做白日梦','',''],['做眉做眼','',''],['做眼','',''],['做眼色','',''],['做着','',''],['做礼拜','',''],['做祷告','',''],['做笑','',''],['做算术','',''],['做绝','',''],['做脸','',''],['做菜','',''],['做裁缝','',''],['做记号','',''],['做诗','',''],['做贼','',''],['做贼心虚','',''],['做起','',''],['做针线','',''],['做错','',''],['做题','',''],['做饭','',''],['做饭菜','',''],['做鬼','',''],['做鬼脸','',''],['做鸡','',''],['做鸭','',''],['停下','',''],['停下来','',''],['停业','',''],['停业整顿','',''],['停了','',''],['停云落月','',''],['停产','',''],['停付','',''],['停住','',''],['停俸','',''],['停刊','',''],['停办','',''],['停匀','',''],['停发','',''],['停员','',''],['停在','',''],['停妥','',''],['停学','',''],['停尸房','',''],['停工','',''],['停工待料','',''],['停建','',''],['停当','',''],['停征','',''],['停息','',''],['停战','',''],['停战日','',''],['停手','',''],['停拨','',''],['停指','',''],['停损单','',''],['停损点','',''],['停掉','',''],['停摆','',''],['停播','',''],['停放','',''],['停机','',''],['停机场','',''],['停机坪','',''],['停机库','',''],['停板制度','',''],['停柩','',''],['停歇','',''],['停止','',''],['停止工作','',''],['停止损失','',''],['停止者','',''],['停止词','',''],['停步','',''],['停水','',''],['停泊','',''],['停泊处','',''],['停泊所','',''],['停泊税','',''],['停泊费','',''],['停滞','',''],['停滞不前','',''],['停火','',''],['停火协议','',''],['停火线','',''],['停灵','',''],['停用','',''],['停电','',''],['停留','',''],['停留在','',''],['停留时间','',''],['停盘','',''],['停着','',''],['停站','',''],['停缴','',''],['停职','',''],['停职检查','',''],['停航','',''],['停著','',''],['停薪','',''],['停薪留职','',''],['停表','',''],['停话','',''],['停课','',''],['停车','',''],['停车位置','',''],['停车场','',''],['停车库','',''],['停车站','',''],['停车计时器','',''],['停转','',''],['停辛伫苦','',''],['停酒止乐','',''],['停闭','',''],['停靠','',''],['停靠港','',''],['停靠站','',''],['停顿','',''],['停飞','',''],['停食','',''],['停驶','',''],['停驻','',''],['健保','',''],['健儿','',''],['健全','',''],['健全制度','',''],['健全法制','',''],['健在','',''],['健壮','',''],['健壮性','',''],['健将','',''],['健康','',''],['健康保险','',''],['健康受损','',''],['健康检查','',''],['健康法','',''],['健康状况','',''],['健康状态','',''],['健康食品','',''],['健忘','',''],['健忘症','',''],['健忘者','',''],['健怡可乐','',''],['健旺','',''],['健步','',''],['健步如飞','',''],['健硕','',''],['健立','',''],['健美','',''],['健美操','',''],['健美运动','',''],['健胃','',''],['健胃剂','',''],['健脾','',''],['健行','',''],['健诊','',''],['健谈','',''],['健身','',''],['健身室','',''],['健身房','',''],['健身术','',''],['健身馆','',''],['偶一','',''],['偶一为之','',''],['偶人','',''],['偶像','',''],['偶像剧','',''],['偶像化','',''],['偶函数','',''],['偶发','',''],['偶发事件','',''],['偶发性','',''],['偶合','',''],['偶因论','',''],['偶尔','',''],['偶感','',''],['偶数','',''],['偶极','',''],['偶校验','',''],['偶氮基','',''],['偶然','',''],['偶然事件','',''],['偶然性','',''],['偶然论','',''],['偶犯','',''],['偶生','',''],['偶笔','',''],['偶者','',''],['偶而','',''],['偶联反应','',''],['偶见','',''],['偶语','',''],['偶语弃市','',''],['偶蹄','',''],['偶蹄目','',''],['偶蹄类','',''],['偶遇','',''],['偷东摸西','',''],['偷乘','',''],['偷了','',''],['偷人','',''],['偷做','',''],['偷偷','',''],['偷偷做','',''],['偷偷干','',''],['偷偷摸摸','',''],['偷去','',''],['偷取','',''],['偷取者','',''],['偷吃','',''],['偷合取容','',''],['偷合苟容','',''],['偷听','',''],['偷听者','',''],['偷售','',''],['偷嘴','',''],['偷天换日','',''],['偷奸取巧','',''],['偷学','',''],['偷安','',''],['偷寒送暖','',''],['偷工','',''],['偷工减料','',''],['偷巧','',''],['偷带','',''],['偷得','',''],['偷心','',''],['偷情','',''],['偷惰','',''],['偷懒','',''],['偷懒者','',''],['偷手','',''],['偷拍','',''],['偷换','',''],['偷摸','',''],['偷有','',''],['偷梁换柱','',''],['偷欢','',''],['偷渡','',''],['偷渡者','',''],['偷漏','',''],['偷漏税','',''],['偷爱','',''],['偷牌','',''],['偷猎','',''],['偷猎者','',''],['偷生','',''],['偷盗','',''],['偷看','',''],['偷眼','',''],['偷着','',''],['偷税','',''],['偷税漏税','',''],['偷空','',''],['偷窃','',''],['偷窥','',''],['偷窥狂','',''],['偷笑','',''],['偷营','',''],['偷袭','',''],['偷走','',''],['偷越','',''],['偷过','',''],['偷运','',''],['偷逃','',''],['偷采','',''],['偷钱','',''],['偷闲','',''],['偷食','',''],['偷香窃玉','',''],['偷鸡不成蚀把米','',''],['偷鸡不着蚀把米','',''],['偷鸡摸狗','',''],['偷鸡盗狗','',''],['偻㑩','',''],['偻病','',''],['偾事','',''],['偿付','',''],['偿债','',''],['偿命','',''],['偿愿','',''],['偿本','',''],['偿欠','',''],['偿清','',''],['偿还','',''],['偿金','',''],['傀儡','',''],['傀儡戏','',''],['傀儡政权','',''],['傅会','',''],['傅作义','',''],['傅科摆','',''],['傅立叶','',''],['傅立叶变换','',''],['傅粉何郎','',''],['傅粉施朱','',''],['傅说','',''],['傅里叶','',''],['傈僳','',''],['傈僳族','',''],['傍亮','',''],['傍亮儿','',''],['傍人篱壁','',''],['傍人门户','',''],['傍午','',''],['傍大款','',''],['傍家儿','',''],['傍户而立','',''],['傍晌','',''],['傍柳随花','',''],['傍水','',''],['傍花随柳','',''],['傍若无人','',''],['傍观者清','',''],['傍轨','',''],['傍边','',''],['傍边儿','',''],['傍近','',''],['傍门依户','',''],['傍靠','',''],['傍黑','',''],['傍黑儿','',''],['傢伙','',''],['傢俱','',''],['傢具','',''],['傣剧','',''],['傥来之物','',''],['傥荡','',''],['傧相','',''],['储位','',''],['储值卡','',''],['储入','',''],['储君','',''],['储处','',''],['储备','',''],['储备基金','',''],['储备物','',''],['储备粮','',''],['储备货币','',''],['储备量','',''],['储备金','',''],['储存','',''],['储存处','',''],['储币','',''],['储户','',''],['储气','',''],['储气罐','',''],['储水','',''],['储水塔','',''],['储水管','',''],['储水箱','',''],['储油','',''],['储油构造','',''],['储油罐','',''],['储油船','',''],['储物','',''],['储电量','',''],['储积','',''],['储精囊','',''],['储蓄','',''],['储蓄帐户','',''],['储蓄库','',''],['储蓄所','',''],['储蓄率','',''],['储蓄罐','',''],['储蓄金','',''],['储蓄银行','',''],['储蓄额','',''],['储藏','',''],['储藏室','',''],['储藏所','',''],['储藏箱','',''],['储运','',''],['储量','',''],['储金','',''],['储金会','',''],['傩戏','',''],['傩神','',''],['催乳','',''],['催乳激素','',''],['催交','',''],['催产','',''],['催人奋进','',''],['催人泪下','',''],['催促','',''],['催促者','',''],['催函','',''],['催办','',''],['催化','',''],['催化作用','',''],['催化剂','',''],['催化裂化','',''],['催化重整','',''],['催单','',''],['催反','',''],['催吐','',''],['催吐剂','',''],['催吐物','',''],['催告信','',''],['催命','',''],['催奶','',''],['催征','',''],['催情','',''],['催打','',''],['催折','',''],['催收','',''],['催汗','',''],['催泪','',''],['催泪剂','',''],['催泪大片','',''],['催泪弹','',''],['催泪物','',''],['催泪瓦斯','',''],['催熟','',''],['催生','',''],['催生婆','',''],['催生素','',''],['催眠','',''],['催眠剂','',''],['催眠士','',''],['催眠学','',''],['催眠曲','',''],['催眠术','',''],['催眠状态','',''],['催眠药','',''],['催租','',''],['催税','',''],['催肥','',''],['催肥剂','',''],['催芽','',''],['催讨','',''],['催证','',''],['催请','',''],['催谷','',''],['催赶','',''],['催逼','',''],['催青','',''],['傲世','',''],['傲人','',''],['傲岸','',''],['傲岸不群','',''],['傲慢','',''],['傲慢与偏见','',''],['傲斥','',''],['傲气','',''],['傲然','',''],['傲物','',''],['傲睨','',''],['傲睨一世','',''],['傲睨自若','',''],['傲立','',''],['傲自','',''],['傲视','',''],['傲贤慢士','',''],['傲雪凌霜','',''],['傲雪欺霜','',''],['傲霜','',''],['傲骨','',''],['傻不愣登','',''],['傻乎乎','',''],['傻乐','',''],['傻了','',''],['傻事','',''],['傻劲','',''],['傻劲儿','',''],['傻呀','',''],['傻呵呵','',''],['傻大','',''],['傻大个','',''],['傻大个儿','',''],['傻头傻脑','',''],['傻子','',''],['傻孩','',''],['傻屄','',''],['傻帽','',''],['傻帽儿','',''],['傻干','',''],['傻气','',''],['傻瓜','',''],['傻的','',''],['傻眼','',''],['傻笑','',''],['傻蛋','',''],['傻话','',''],['傻逼','',''],['傻里傻气','',''],['像上','',''],['像乞丐','',''],['像人','',''],['像册','',''],['像发疯','',''],['像图','',''],['像处女','',''],['像大人','',''],['像天','',''],['像女王','',''],['像奶油','',''],['像差','',''],['像底','',''],['像座','',''],['像形','',''],['像形字','',''],['像征','',''],['像征性','',''],['像戏剧','',''],['像打雷','',''],['像是','',''],['像术','',''],['像机','',''],['像样','',''],['像泥','',''],['像煞有介事','',''],['像爬虫','',''],['像片','',''],['像片簿','',''],['像狗','',''],['像王子','',''],['像用','',''],['像男人','',''],['像画','',''],['像皮','',''],['像神','',''],['像章','',''],['像素','',''],['像纸','',''],['像要','',''],['像话','',''],['像谜般','',''],['像貌','',''],['像这样','',''],['像银','',''],['僚佐','',''],['僚属','',''],['僚机','',''],['僧人','',''],['僧众','',''],['僧伽','',''],['僧侣','',''],['僧侣主义','',''],['僧俗','',''],['僧加罗语','',''],['僧多粥少','',''],['僧寺','',''],['僧尼','',''],['僧帽','',''],['僧帽猴','',''],['僧徒','',''],['僧服','',''],['僧职','',''],['僧衣','',''],['僧袍','',''],['僧院','',''],['僧面','',''],['僬侥','',''],['僬僬','',''],['僭主','',''],['僭主政治','',''],['僭越','',''],['僮仆','',''],['僮族','',''],['僳族','',''],['僵住','',''],['僵住症','',''],['僵化','',''],['僵卧','',''],['僵固性','',''],['僵尸','',''],['僵尸网络','',''],['僵局','',''],['僵持','',''],['僵持不下','',''],['僵死','',''],['僵痛','',''],['僵直','',''],['僵硬','',''],['僵蚕','',''],['僻地','',''],['僻壤','',''],['僻处','',''],['僻巷','',''],['僻径','',''],['僻远','',''],['僻道','',''],['僻陋','',''],['僻静','',''],['儆戒','',''],['儆猴','',''],['儆百','',''],['儇薄','',''],['儋县','',''],['儒勒・凡尔纳','',''],['儒医','',''],['儒墨','',''],['儒士','',''],['儒学','',''],['儒家','',''],['儒家思想','',''],['儒将','',''],['儒教','',''],['儒术','',''],['儒林','',''],['儒林外史','',''],['儒生','',''],['儒者','',''],['儒艮','',''],['儒道','',''],['儒雅','',''],['儿书','',''],['儿人','',''],['儿们','',''],['儿俩','',''],['儿化','',''],['儿化韵','',''],['儿去','',''],['儿啊','',''],['儿女','',''],['儿女之情','',''],['儿女心肠','',''],['儿女情多','',''],['儿女情长','',''],['儿女英雄传','',''],['儿媳','',''],['儿媳妇','',''],['儿媳妇儿','',''],['儿子','',''],['儿子般','',''],['儿孙','',''],['儿戏','',''],['儿手','',''],['儿时','',''],['儿曹','',''],['儿歌','',''],['儿皇帝','',''],['儿科','',''],['儿科学','',''],['儿童','',''],['儿童乐园','',''],['儿童团','',''],['儿童基金会','',''],['儿童心理学','',''],['儿童文学','',''],['儿童权利公约','',''],['儿老','',''],['儿茶','',''],['儿茶酚','',''],['儿语','',''],['儿车','',''],['儿音','',''],['儿马','',''],['兀傲','',''],['兀兀','',''],['兀凳','',''],['兀秃','',''],['兀立','',''],['兀自','',''],['兀臬','',''],['兀鹫','',''],['兀鹰','',''],['允准','',''],['允可','',''],['允宜','',''],['允当','',''],['允执其中','',''],['允执厥中','',''],['允文允武','',''],['允洽','',''],['允许','',''],['允诺','',''],['元世祖','',''],['元书纸','',''],['元代','',''],['元件','',''],['元元本本','',''],['元军','',''],['元凶','',''],['元勋','',''],['元化','',''],['元古代','',''],['元古宙','',''],['元古界','',''],['元古纪','',''],['元史','',''],['元器件','',''],['元坝','',''],['元夜','',''],['元太祖','',''],['元子','',''],['元宝','',''],['元宝山','',''],['元宝枫','',''],['元山','',''],['元山市','',''],['元帅','',''],['元年','',''],['元恶','',''],['元恶大奸','',''],['元恶大憝','',''],['元戎','',''],['元方季方','',''],['元日','',''],['元曲','',''],['元曲四大家','',''],['元月','',''],['元月份','',''],['元朗','',''],['元朗市','',''],['元朝','',''],['元末','',''],['元末明初','',''],['元桌','',''],['元气','',''],['元江县','',''],['元祖','',''],['元神','',''],['元素','',''],['元素周期表','',''],['元素符号','',''],['元老','',''],['元老院','',''],['元语言','',''],['元语言学意识','',''],['元语言能力','',''],['元谋猿人','',''],['元配','',''],['元针','',''],['元钉','',''],['元长','',''],['元长乡','',''],['元雅','',''],['元青','',''],['元音','',''],['元音和谐','',''],['元音失读','',''],['元食赘行','',''],['元首','',''],['元麦','',''],['元龙','',''],['元龙高卧','',''],['兄友弟恭','',''],['兄台','',''],['兄妹','',''],['兄嫂','',''],['兄弟','',''],['兄弟会','',''],['兄弟党','',''],['兄弟姐妹','',''],['兄弟民族','',''],['兄弟般','',''],['兄弟阋墙','',''],['兄死弟及','',''],['兄终弟及','',''],['兄肥弟瘦','',''],['兄长','',''],['充以','',''],['充任','',''],['充份','',''],['充作','',''],['充值','',''],['充值卡','',''],['充做','',''],['充公','',''],['充其量','',''],['充军','',''],['充分','',''],['充分发挥','',''],['充分就业','',''],['充分考虑','',''],['充发','',''],['充塞','',''],['充填','',''],['充填因数','',''],['充填物','',''],['充大','',''],['充好','',''],['充实','',''],['充当','',''],['充当先锋','',''],['充抵','',''],['充数','',''],['充斥','',''],['充栋汗牛','',''],['充气','',''],['充气灯泡','',''],['充气船','',''],['充气设备','',''],['充氧','',''],['充水','',''],['充沛','',''],['充溢','',''],['充满','',''],['充满信心','',''],['充满希望','',''],['充满敌意','',''],['充满活力','',''],['充满生机','',''],['充满着','',''],['充满阳光','',''],['充电','',''],['充电器','',''],['充畅','',''],['充盈','',''],['充磁','',''],['充类至尽','',''],['充耳','',''],['充耳不闻','',''],['充血','',''],['充血性','',''],['充裕','',''],['充要条件','',''],['充足','',''],['充足理由律','',''],['充车','',''],['充顶','',''],['充饥','',''],['充饥止渴','',''],['充饥画饼','',''],['兆伏','',''],['兆位','',''],['兆兆','',''],['兆周','',''],['兆多','',''],['兆头','',''],['兆字节','',''],['兆欧','',''],['兆欧表','',''],['兆瓦','',''],['兆瓦特','',''],['兆电子伏','',''],['兆赫','',''],['兆赫兹','',''],['先下手为强','',''],['先不','',''],['先不先','',''],['先世','',''],['先为','',''],['先主','',''],['先买','',''],['先买权','',''],['先于','',''],['先亡','',''],['先交','',''],['先享受后付款','',''],['先享后付','',''],['先人','',''],['先人后己','',''],['先付','',''],['先令','',''],['先以','',''],['先传','',''],['先使','',''],['先例','',''],['先倾','',''],['先兆','',''],['先入','',''],['先入为主','',''],['先入之见','',''],['先公','',''],['先公后私','',''],['先写','',''],['先决','',''],['先决条件','',''],['先决问题','',''],['先出','',''],['先别','',''],['先到','',''],['先到先得','',''],['先前','',''],['先加','',''],['先务之急','',''],['先占','',''],['先占据','',''],['先占满','',''],['先占领','',''],['先发','',''],['先发制人','',''],['先取','',''],['先吃','',''],['先同','',''],['先后','',''],['先后顺序','',''],['先向','',''],['先君','',''],['先哲','',''],['先在','',''],['先声','',''],['先声后实','',''],['先声夺人','',''],['先大母','',''],['先天','',''],['先天下之忧而忧','',''],['先天不足','',''],['先天性','',''],['先天性免疫','',''],['先天性缺陷','',''],['先天愚型','',''],['先天论','',''],['先头','',''],['先头部队','',''],['先妣','',''],['先容','',''],['先富起来','',''],['先导','',''],['先尝','',''],['先师','',''],['先帝','',''],['先帝遗诏','',''],['先征','',''],['先得','',''],['先忧后乐','',''],['先意承志','',''],['先慈','',''],['先我着鞭','',''],['先手','',''],['先抓','',''],['先按','',''],['先提','',''],['先搞','',''],['先斩后奏','',''],['先斩后闻','',''],['先明','',''],['先是','',''],['先期','',''],['先期录音','',''],['先机','',''],['先来','',''],['先来后到','',''],['先查','',''],['先死','',''],['先母','',''],['先民','',''],['先汉','',''],['先河','',''],['先烈','',''],['先父','',''],['先王','',''],['先王之乐','',''],['先王之政','',''],['先王之道','',''],['先生','',''],['先生们','',''],['先用','',''],['先由','',''],['先皇','',''],['先看','',''],['先睹为快','',''],['先知','',''],['先知先觉','',''],['先礼','',''],['先礼后兵','',''],['先祖','',''],['先秦','',''],['先秦时代','',''],['先端','',''],['先纳','',''],['先自隗始','',''],['先花后果','',''],['先行','',''],['先行后闻','',''],['先行官','',''],['先行者','',''],['先要','',''],['先见','',''],['先见之明','',''],['先见者','',''],['先觉','',''],['先觉先知','',''],['先觉者','',''],['先让','',''],['先试','',''],['先贤','',''],['先走','',''],['先躯','',''],['先躯者','',''],['先辈','',''],['先达','',''],['先过','',''],['先进','',''],['先进个人','',''],['先进事迹','',''],['先进性','',''],['先进武器','',''],['先进水平','',''],['先进集体','',''],['先述权','',''],['先遣','',''],['先遣队','',''],['先销','',''],['先锋','',''],['先锋团','',''],['先锋队','',''],['先难后获','',''],['先鞭','',''],['先驱','',''],['先驱者','',''],['先驱蝼蚁','',''],['先验','',''],['先验唯心主义','',''],['先验性','',''],['先验论','',''],['光下','',''],['光临','',''],['光临惠顾','',''],['光二极管','',''],['光亮','',''],['光亮度','',''],['光伏','',''],['光伏器件','',''],['光信号','',''],['光儿','',''],['光光','',''],['光冲量','',''],['光刻','',''],['光刻胶','',''],['光前绝后','',''],['光前耀后','',''],['光前裕后','',''],['光功率','',''],['光动嘴','',''],['光化作用','',''],['光化学','',''],['光化学烟雾','',''],['光化度','',''],['光化性','',''],['光华','',''],['光卤石','',''],['光压','',''],['光发送器','',''],['光合','',''],['光合作用','',''],['光听','',''],['光圈','',''],['光坦','',''],['光复','',''],['光复乡','',''],['光复会','',''],['光复旧京','',''],['光复旧物','',''],['光大','',''],['光天','',''],['光天之下','',''],['光天化日','',''],['光头','',''],['光子','',''],['光学','',''],['光学仪器','',''],['光学字符识别','',''],['光学家','',''],['光学录音','',''],['光学显微镜','',''],['光学玻璃','',''],['光宗耀祖','',''],['光宠','',''],['光密媒质','',''],['光导','',''],['光导管','',''],['光导纤维','',''],['光射线','',''],['光州','',''],['光州市','',''],['光州广域市','',''],['光巴','',''],['光帘','',''],['光带','',''],['光年','',''],['光度','',''],['光度计','',''],['光弹','',''],['光彩','',''],['光彩夺目','',''],['光彩照人','',''],['光影','',''],['光影效','',''],['光怪陆离','',''],['光感','',''],['光感应','',''],['光或热','',''],['光所','',''],['光拴','',''],['光接收器','',''],['光控','',''],['光敏','',''],['光敏塑料','',''],['光敏电阻','',''],['光斑','',''],['光明','',''],['光明新区','',''],['光明日报','',''],['光明星','',''],['光明正大','',''],['光明磊落','',''],['光明节','',''],['光明面','',''],['光是','',''],['光晕','',''],['光景','',''],['光机','',''],['光杆','',''],['光杆儿','',''],['光杆司令','',''],['光材料','',''],['光束','',''],['光板','',''],['光板儿','',''],['光柱','',''],['光栅','',''],['光标','',''],['光检测器','',''],['光棍','',''],['光棍儿','',''],['光棍节','',''],['光槃','',''],['光气','',''],['光波','',''],['光波长','',''],['光洁','',''],['光洁度','',''],['光洋','',''],['光测','',''],['光润','',''],['光源','',''],['光溜','',''],['光溜溜','',''],['光滑','',''],['光滑面','',''],['光漆','',''],['光火','',''],['光灵','',''],['光热','',''],['光焰','',''],['光焰万丈','',''],['光照','',''],['光爆','',''],['光片','',''],['光环','',''],['光球','',''],['光电','',''],['光电二极管','',''],['光电子','',''],['光电效应','',''],['光电显微镜','',''],['光电池','',''],['光电流','',''],['光电管','',''],['光电计数器','',''],['光疏媒质','',''],['光疗','',''],['光盘','',''],['光盘驱动器','',''],['光着','',''],['光碟','',''],['光碟机','',''],['光碟片','',''],['光磁','',''],['光磁碟','',''],['光磁碟机','',''],['光禄勋','',''],['光禄大夫','',''],['光秃','',''],['光秃秃','',''],['光笔','',''],['光纤','',''],['光纤分布式数据介面','',''],['光纤分布数据接口','',''],['光纤分散式资料介面','',''],['光纤接口','',''],['光纤电缆','',''],['光纤衰减','',''],['光纤通信','',''],['光线','',''],['光绪','',''],['光绪帝','',''],['光缆','',''],['光耀','',''],['光耀门楣','',''],['光能','',''],['光能合成','',''],['光脚','',''],['光芒','',''],['光芒万丈','',''],['光荣','',''],['光荣义务','',''],['光荣任务','',''],['光荣传统','',''],['光荣榜','',''],['光荣称号','',''],['光荣革命','',''],['光蛋','',''],['光说不做','',''],['光说不练','',''],['光谱','',''],['光谱仪','',''],['光谱分析','',''],['光谱图','',''],['光谱学','',''],['光谱线','',''],['光赤','',''],['光趟','',''],['光轴','',''],['光辉','',''],['光辉灿烂','',''],['光辐射','',''],['光通信','',''],['光通量','',''],['光速','',''],['光采','',''],['光量','',''],['光量子','',''],['光闪闪','',''],['光阳','',''],['光阴','',''],['光阴似箭','',''],['光阴如电','',''],['光阴如箭','',''],['光面','',''],['光面内质网','',''],['光顾','',''],['光风霁月','',''],['光饰','',''],['光驱','',''],['光鲜','',''],['克丝钳子','',''],['克人','',''],['克什克腾','',''],['克什米尔','',''],['克仑特罗','',''],['克俭','',''],['克俭克勤','',''],['克分子','',''],['克分子浓度','',''],['克分子量','',''],['克利夫兰','',''],['克利斯朵夫','',''],['克制','',''],['克劳','',''],['克劳修斯','',''],['克劳德','',''],['克劳斯','',''],['克劳福德','',''],['克勒','',''],['克勤克俭','',''],['克化','',''],['克原子','',''],['克基拉岛','',''],['克复','',''],['克娄巴特拉','',''],['克孜勒苏','',''],['克孜勒苏地区','',''],['克孜勒苏河','',''],['克孜尔千佛洞','',''],['克孜尔尕哈','',''],['克孜尔尕哈烽火台','',''],['克尔白','',''],['克尽厥职','',''],['克山病','',''],['克己','',''],['克己复礼','',''],['克己奉公','',''],['克当一面','',''],['克当量','',''],['克扣','',''],['克拉','',''],['克拉克','',''],['克拉夫丘克','',''],['克拉斯诺亚尔斯克','',''],['克拉斯诺达尔','',''],['克拉斯金诺','',''],['克拉科夫','',''],['克拉科夫起义','',''],['克敌','',''],['克敌制胜','',''],['克文','',''],['克星','',''],['克服','',''],['克服困难','',''],['克服缺点','',''],['克朗','',''],['克朗代克','',''],['克期','',''],['克林姆','',''],['克林姆酱','',''],['克林德','',''],['克林霉素','',''],['克架','',''],['克格勃','',''],['克汀病','',''],['克沙奇病毒','',''],['克流感','',''],['克爱克威','',''],['克绍箕裘','',''],['克罗地亚共和国','',''],['克罗地亚语','',''],['克罗埃西亚','',''],['克罗米','',''],['克罗诺斯','',''],['克耶族','',''],['克耶邦','',''],['克莉奥佩特拉','',''],['克莱','',''],['克莱因','',''],['克莱斯勒','',''],['克莱斯勒汽车公司','',''],['克莱蒙特','',''],['克莱顿','',''],['克蕾儿','',''],['克虏伯','',''],['克西','',''],['克赖斯特彻奇','',''],['克郎','',''],['克郎球','',''],['克里','',''],['克里丝蒂娃','',''],['克里奥尔语','',''],['克里姆林宫','',''],['克里斯托弗','',''],['克里斯汀・贝尔','',''],['克里斯蒂安','',''],['克里斯蒂安松','',''],['克里普斯','',''],['克里木','',''],['克里木半岛','',''],['克里木战争','',''],['克里特','',''],['克里特岛','',''],['克里米亚','',''],['克里米亚会议','',''],['克里米亚战争','',''],['克隆','',''],['克隆人','',''],['克隆技术','',''],['克隆氏病','',''],['克难','',''],['克雅氏症','',''],['克雷伯氏菌属','',''],['克霉唑','',''],['克食','',''],['免不了','',''],['免不得','',''],['免为','',''],['免予','',''],['免于','',''],['免交','',''],['免付','',''],['免俗','',''],['免冠','',''],['免刑','',''],['免去','',''],['免去职务','',''],['免受','',''],['免受伤害','',''],['免复','',''],['免局','',''],['免开尊口','',''],['免役','',''],['免役税','',''],['免征','',''],['免得','',''],['免报','',''],['免持','',''],['免掉','',''],['免提','',''],['免收','',''],['免料','',''],['免烫','',''],['免疫','',''],['免疫力','',''],['免疫反应','',''],['免疫学','',''],['免疫应答','',''],['免疫性','',''],['免疫法','',''],['免疫系统','',''],['免疫针','',''],['免礼','',''],['免票','',''],['免租金','',''],['免税','',''],['免签','',''],['免纳','',''],['免罚','',''],['免罪','',''],['免职','',''],['免试','',''],['免课','',''],['免调','',''],['免谈','',''],['免责声明','',''],['免责条款','',''],['免贴','',''],['免费','',''],['免费搭车','',''],['免费者','',''],['免费软件','',''],['免赔','',''],['免赔条款','',''],['免还','',''],['免进','',''],['免遭','',''],['免邮资','',''],['免除','',''],['免验','',''],['免黜','',''],['兑付','',''],['兑取','',''],['兑回','',''],['兑奖','',''],['兑帐','',''],['兑成','',''],['兑换','',''],['兑换业','',''],['兑换券','',''],['兑换处','',''],['兑换率','',''],['兑款','',''],['兑现','',''],['兑酒','',''],['兔丝燕麦','',''],['兔儿','',''],['兔儿爷','',''],['兔唇','',''],['兔子','',''],['兔子不吃窝边草','',''],['兔子窝','',''],['兔尽狗烹','',''],['兔崽子','',''],['兔年','',''],['兔径','',''],['兔料','',''],['兔斯基','',''],['兔死狐悲','',''],['兔死狗烹','',''],['兔毛','',''],['兔爸','',''],['兔皮','',''],['兔类','',''],['兔肉','',''],['兔脯','',''],['兔脱','',''],['兔角龟毛','',''],['兔走乌飞','',''],['兔走鸟飞','',''],['兔起凫举','',''],['兔起鹘落','',''],['兕觥','',''],['党中央','',''],['党主席','',''],['党争','',''],['党人','',''],['党代会','',''],['党代表','',''],['党代表制','',''],['党八股','',''],['党内','',''],['党内外','',''],['党制','',''],['党办','',''],['党务','',''],['党务工作','',''],['党参','',''],['党史','',''],['党同伐异','',''],['党员','',''],['党和国家','',''],['党和政府','',''],['党团','',''],['党团员','',''],['党团组','',''],['党国','',''],['党在','',''],['党外','',''],['党外人士','',''],['党委','',''],['党委书记','',''],['党委会','',''],['党委制','',''],['党小组','',''],['党建','',''],['党徒','',''],['党徽','',''],['党心','',''],['党性','',''],['党总支','',''],['党报','',''],['党支部','',''],['党支部书记','',''],['党改','',''],['党政','',''],['党政军','',''],['党政机关','',''],['党旗','',''],['党校','',''],['党棍','',''],['党歌','',''],['党民','',''],['党派','',''],['党派性','',''],['党派集会','',''],['党的','',''],['党社','',''],['党票','',''],['党禁','',''],['党章','',''],['党籍','',''],['党纪','',''],['党纪国法','',''],['党纪处分','',''],['党纲','',''],['党组','',''],['党组书记','',''],['党组织','',''],['党群','',''],['党群关系','',''],['党羽','',''],['党藉','',''],['党证','',''],['党课','',''],['党费','',''],['党部','',''],['党锢','',''],['党阀','',''],['党项','',''],['党项族','',''],['党风','',''],['党风不正','',''],['党风好转','',''],['党风建设','',''],['党魁','',''],['党龄','',''],['兜儿','',''],['兜兜','',''],['兜兜裤儿','',''],['兜卖','',''],['兜售','',''],['兜圈','',''],['兜圈子','',''],['兜头','',''],['兜子','',''],['兜帽','',''],['兜底','',''],['兜抄','',''],['兜捕','',''],['兜揽','',''],['兜翻','',''],['兜老底兜鍪','',''],['兜肚','',''],['兜著','',''],['兜著走','',''],['兜里','',''],['兜鍪','',''],['兜销','',''],['兜风','',''],['兢兢','',''],['兢兢业业','',''],['兢兢翼翼','',''],['入不支出','',''],['入不敷出','',''],['入世','',''],['入主','',''],['入主出奴','',''],['入乡随俗','',''],['入于','',''],['入伍','',''],['入伍生','',''],['入户','',''],['入伏','',''],['入伙','',''],['入会','',''],['入会者','',''],['入住','',''],['入住率','',''],['入侵','',''],['入侵者','',''],['入党','',''],['入关','',''],['入内','',''],['入册','',''],['入冬','',''],['入出境','',''],['入列','',''],['入口','',''],['入口处','',''],['入口就化','',''],['入口网','',''],['入口页','',''],['入吾彀中','',''],['入味','',''],['入团','',''],['入围','',''],['入围者','',''],['入国问俗','',''],['入土','',''],['入土为安','',''],['入圣','',''],['入圣超凡','',''],['入地','',''],['入场','',''],['入场券','',''],['入场式','',''],['入场权','',''],['入场费','',''],['入垄','',''],['入城','',''],['入境','',''],['入境签证','',''],['入境证','',''],['入境问俗','',''],['入境问禁','',''],['入境随俗','',''],['入声','',''],['入夏','',''],['入夜','',''],['入学','',''],['入学率','',''],['入定','',''],['入室升堂','',''],['入室操戈','',''],['入寇','',''],['入寝','',''],['入射','',''],['入射点','',''],['入射线','',''],['入射角','',''],['入市','',''],['入帐','',''],['入席','',''],['入幕之宾','',''],['入库','',''],['入店','',''],['入座','',''],['入彀','',''],['入微','',''],['入情入理','',''],['入手','',''],['入托','',''],['入支','',''],['入教','',''],['入时','',''],['入春','',''],['入木三分','',''],['入村','',''],['入栈','',''],['入档','',''],['入梅','',''],['入梦','',''],['入樽','',''],['入款','',''],['入殓','',''],['入水','',''],['入洞','',''],['入流','',''],['入海','',''],['入海口','',''],['入涅','',''],['入港','',''],['入港税','',''],['入犯','',''],['入狱','',''],['入画','',''],['入盟','',''],['入眠','',''],['入眼','',''],['入睡','',''],['入社','',''],['入神','',''],['入禀','',''],['入窖','',''],['入站','',''],['入籍','',''],['入绪','',''],['入网','',''],['入耳','',''],['入联','',''],['入肉','',''],['入股','',''],['入药','',''],['入营','',''],['入贡','',''],['入账','',''],['入赘','',''],['入超','',''],['入迷','',''],['入选','',''],['入选者','',''],['入道','',''],['入镜','',''],['入门','',''],['入门书','',''],['入门课程','',''],['入闱','',''],['入阁','',''],['入队','',''],['入院','',''],['入风口','',''],['入骨','',''],['入魔','',''],['全不','',''],['全被','',''],['全不知','',''],['全世界','',''],['全世界人民','',''],['全世界无产者联合起来','',''],['全世界第一','',''],['全为','',''],['全乎','',''],['全乡','',''],['全书','',''],['全买','',''],['全交','',''],['全人','',''],['全人类','',''],['全仗绿叶扶','',''],['全仗绿叶扶持','',''],['全价','',''],['全份','',''],['全休','',''],['全优','',''],['全会','',''],['全体','',''],['全体人员','',''],['全体会议','',''],['全体成员','',''],['全信','',''],['全值','',''],['全光','',''],['全党','',''],['全党全军','',''],['全党全军全国','',''],['全党全军和全国','',''],['全党全国','',''],['全军','',''],['全军覆没','',''],['全军覆灭','',''],['全冻','',''],['全凭绿叶扶持','',''],['全分','',''],['全剧','',''],['全副','',''],['全副武装','',''],['全副精力','',''],['全力','',''],['全力以赴','',''],['全功能','',''],['全劳动力','',''],['全勤','',''],['全区','',''],['全厂','',''],['全县','',''],['全反射','',''],['全同','',''],['全名','',''],['全向','',''],['全员','',''],['全员劳动合同制','',''],['全员劳动生产率','',''],['全员承包','',''],['全国','',''],['全国人大','',''],['全国人大会议','',''],['全国人大常委会','',''],['全国人民代表大会','',''],['全国人民代表大会常务委员会','',''],['全国代表大会','',''],['全国各地','',''],['全国大会党','',''],['全国性','',''],['全国民主联盟','',''],['全国运动会','',''],['全国鸟类学会','',''],['全场','',''],['全场一致','',''],['全垒打','',''],['全城','',''],['全境','',''],['全复','',''],['全天','',''],['全天候','',''],['全天候飞机','',''],['全夺','',''],['全套','',''],['全好','',''],['全始全终','',''],['全宇宙','',''],['全室','',''],['全家','',''],['全家人','',''],['全家福','',''],['全对','',''],['全对数','',''],['全尺寸','',''],['全局','',''],['全局性','',''],['全局模块','',''],['全局观念','',''],['全局语境','',''],['全屏','',''],['全屏幕','',''],['全岛','',''],['全州市','',''],['全工','',''],['全市','',''],['全带','',''],['全席','',''],['全幅','',''],['全干','',''],['全年','',''],['全度音','',''],['全开','',''],['全异','',''],['全归','',''],['全形','',''],['全影','',''],['全心','',''],['全心全意','',''],['全息','',''],['全息图','',''],['全息术','',''],['全息照相','',''],['全意','',''],['全感','',''],['全所','',''],['全才','',''],['全托','',''],['全拼','',''],['全数','',''],['全文','',''],['全文检索','',''],['全斗焕','',''],['全新','',''],['全新世','',''],['全新纪','',''],['全新统','',''],['全方','',''],['全方位','',''],['全方向','',''],['全无','',''],['全无准备','',''],['全无心肝','',''],['全无忌惮','',''],['全无是处','',''],['全日','',''],['全日制','',''],['全日制学校','',''],['全日空','',''],['全时工作','',''],['全时间','',''],['全是','',''],['全景','',''],['全月','',''],['全有','',''],['全本','',''],['全权','',''],['全权代表','',''],['全权大使','',''],['全村','',''],['全校','',''],['全检','',''],['全歼','',''],['全民','',''],['全民义务植树日','',''],['全民企业','',''],['全民公决','',''],['全民性','',''],['全民所有制','',''],['全民投票','',''],['全民教育','',''],['全民族','',''],['全民皆兵','',''],['全民英检','',''],['全活','',''],['全清','',''],['全港','',''],['全满','',''],['全然','',''],['全然不同','',''],['全然不知','',''],['全然不顾','',''],['全熟','',''],['全片','',''],['全班','',''],['全球','',''],['全球位置测定系统','',''],['全球化','',''],['全球卫星导航系统','',''],['全球发展中心','',''],['全球变暖','',''],['全球定位系统','',''],['全球性','',''],['全球暖化','',''],['全球气候','',''],['全球气候升温','',''],['全球气候变暖','',''],['全球资讯网','',''],['全球通','',''],['全生育期','',''],['全由','',''],['全留','',''],['全盘','',''],['全盘托出','',''],['全盘西化','',''],['全盛','',''],['全盛期','',''],['全省','',''],['全看','',''],['全瞎','',''],['全知','',''],['全知全能','',''],['全码','',''],['全社会','',''],['全神','',''],['全神倾注','',''],['全神灌注','',''],['全神贯注','',''],['全票','',''],['全科','',''],['全称','',''],['全程','',''],['全稿','',''],['全等','',''],['全等图形','',''],['全等形','',''],['全篇','',''],['全线','',''],['全线崩溃','',''],['全网','',''],['全罗北道','',''],['全罗南道','',''],['全罗道','',''],['全美','',''],['全美国','',''],['全美广播公司','',''],['全职','',''],['全聚德','',''],['全胜','',''],['全能','',''],['全能冠军','',''],['全能运动','',''],['全脂','',''],['全臣','',''],['全自动','',''],['全般','',''],['全色','',''],['全色片','',''],['全节流','',''],['全范围','',''],['全蚀','',''],['全行','',''],['全衡','',''],['全要','',''],['全规模','',''],['全角','',''],['全读','',''],['全谷物','',''],['全豹','',''],['全貌','',''],['全资附属公司','',''],['全赢','',''],['全跏坐','',''],['全路','',''],['全身','',''],['全身中毒性毒剂','',''],['全身心','',''],['全身远害','',''],['全身麻醉','',''],['全轮','',''],['全轮驱动','',''],['全过程','',''],['全运会','',''],['全选','',''],['全速','',''],['全部','',''],['全都','',''],['全银幕','',''],['全镇','',''],['全长','',''],['全长度','',''],['全间','',''],['全队','',''],['全院','',''],['全险','',''],['全集','',''],['全靠','',''],['全面','',''],['全面性','',''],['全面推广','',''],['全面禁止','',''],['全面禁止核试验条约','',''],['全面质量管理','',''],['全音','',''],['全音域','',''],['全音符','',''],['全音阶','',''],['全额','',''],['全食','',''],['全麦','',''],['全麻','',''],['八一','',''],['八一三事变','',''],['八一五','',''],['八一南昌起义','',''],['八一建军节','',''],['八一队','',''],['八七','',''],['八七会议','',''],['八万','',''],['八万大藏经','',''],['八下里','',''],['八两','',''],['八两半斤','',''],['八个','',''],['八中全会','',''],['八九不离十','',''],['八二三炮战','',''],['八二丹','',''],['八五','',''],['八五期间','',''],['八五规划','',''],['八人','',''],['八亿','',''],['八仙','',''],['八仙桌','',''],['八仙湖','',''],['八仙过海','',''],['八会穴','',''],['八位元','',''],['八佰伴','',''],['八倍','',''],['八倍体','',''],['八八','',''],['八八六','',''],['八公山','',''],['八冲','',''],['八分','',''],['八分之一','',''],['八分之七','',''],['八分之三','',''],['八分之二','',''],['八分之五','',''],['八分之六','',''],['八分之四','',''],['八分音符','',''],['八十','',''],['八十一','',''],['八十七','',''],['八十万','',''],['八十三','',''],['八十个','',''],['八十九','',''],['八十二','',''],['八十五','',''],['八十人','',''],['八十八','',''],['八十六','',''],['八十四','',''],['八十天环游地球','',''],['八十岁','',''],['八十年','',''],['八十年代','',''],['八千','',''],['八千万','',''],['八卦','',''],['八卦拳','',''],['八卦掌','',''],['八卦教','',''],['八卦阵','',''],['八号','',''],['八哥','',''],['八哥儿','',''],['八哥狗','',''],['八国','',''],['八国联军','',''],['八块','',''],['八块腹肌','',''],['八大处','',''],['八大工业国组织','',''],['八婆','',''],['八字','',''],['八字宪法','',''],['八字帖儿','',''],['八字形','',''],['八字打开','',''],['八字方针','',''],['八字步','',''],['八字没一撇','',''],['八字眉','',''],['八字胡','',''],['八字胡须','',''],['八字脚','',''],['八字还没一撇','',''],['八字还没一撇儿','',''],['八宝','',''],['八宝丹','',''],['八宝山','',''],['八宝山革命公墓','',''],['八宝眼药','',''],['八宝粥','',''],['八宝菜','',''],['八宝饭','',''],['八小时','',''],['八小时工作制','',''],['八层','',''],['八届','',''],['八岐大蛇','',''],['八带鱼','',''],['八年','',''],['八度','',''],['八廓','',''],['八廓街','',''],['八开','',''],['八开纸','',''],['八弦琴','',''],['八德','',''],['八德市','',''],['八怪','',''],['八成','',''],['八戒','',''],['八折','',''],['八抬大轿','',''],['八拜之交','',''],['八斗之才','',''],['八方','',''],['八方呼应','',''],['八方支援','',''],['八旗','',''],['八旗制度','',''],['八旗子弟','',''],['八日','',''],['八时','',''],['八月','',''],['八月之光','',''],['八月份','',''],['八月节','',''],['八村','',''],['八条','',''],['八极拳','',''],['八楼','',''],['八次','',''],['八正道','',''],['八步','',''],['八段','',''],['八段锦','',''],['八法','',''],['八法拳','',''],['八点','',''],['八点半','',''],['八爪鱼','',''],['八王之乱','',''],['八珍汤','',''],['八疸','',''],['八疸身面黄','',''],['八百','',''],['八百万','',''],['八的','',''],['八目鳗','',''],['八类','',''],['八级工','',''],['八级工资制','',''],['八级风','',''],['八纲','',''],['八纲辨证','',''],['八美','',''],['八美乡','',''],['八股','',''],['八股文','',''],['八般头风','',''],['八节','',''],['八苦','',''],['八荣八耻','',''],['八行书','',''],['八角','',''],['八角床','',''],['八角形','',''],['八角枫','',''],['八角茴香','',''],['八角街','',''],['八角鼓','',''],['八路','',''],['八路军','',''],['八边','',''],['八边形','',''],['八达岭','',''],['八达通','',''],['八进制','',''],['八道','',''],['八道江','',''],['八邦立国','',''],['八里','',''],['八里乡','',''],['八重奏','',''],['八门五花','',''],['八面','',''],['八面体','',''],['八面光','',''],['八面圆通','',''],['八面威风','',''],['八面威风睁','',''],['八面玲珑','',''],['八面见光','',''],['八面锋','',''],['八音','',''],['八音盒','',''],['八音节','',''],['八风','',''],['八风穴','',''],['公丈','',''],['公两','',''],['公主','',''],['公主装','',''],['公举','',''],['公义','',''],['公之于众','',''],['公买公卖','',''],['公事','',''],['公事公办','',''],['公事包','',''],['公事房','',''],['公交','',''],['公交站','',''],['公交车','',''],['公交部门','',''],['公产','',''],['公亩','',''],['公人','',''],['公仆','',''],['公仔','',''],['公仔面','',''],['公份儿','',''],['公休','',''],['公休假日','',''],['公休日','',''],['公众','',''],['公众号','',''],['公众人物','',''],['公众意见','',''],['公众电信网路','',''],['公众集会','',''],['公会','',''],['公伤','',''],['公伤事故','',''],['公余','',''],['公使','',''],['公使馆','',''],['公例','',''],['公倍','',''],['公倍式','',''],['公倍数','',''],['公候','',''],['公债','',''],['公债券','',''],['公倾','',''],['公假','',''],['公允','',''],['公元','',''],['公元前','',''],['公充价值','',''],['公克','',''],['公公','',''],['公公正正','',''],['公共','',''],['公共事业','',''],['公共交换电话网路','',''],['公共交通','',''],['公共假期','',''],['公共关系','',''],['公共卫生','',''],['公共厕所','',''],['公共团体','',''],['公共场所','',''],['公共安全罪','',''],['公共开支','',''],['公共汽车','',''],['公共汽车站','',''],['公共秩序','',''],['公共积累','',''],['公共行政','',''],['公共设施','',''],['公共财产','',''],['公共道德','',''],['公共零点','',''],['公关','',''],['公关小姐','',''],['公决','',''],['公出','',''],['公函','',''],['公分','',''],['公切线','',''],['公判','',''],['公制','',''],['公制单位','',''],['公制支数','',''],['公办','',''],['公务','',''],['公务上','',''],['公务人员','',''],['公务制度','',''],['公务员','',''],['公务舱','',''],['公募','',''],['公勺','',''],['公升','',''],['公卖','',''],['公卿','',''],['公历','',''],['公厕','',''],['公厘','',''],['公司','',''],['公司会议','',''],['公司债','',''],['公司治理','',''],['公司法','',''],['公司理财','',''],['公吨','',''],['公听会','',''],['公听并观','',''],['公告','',''],['公因子','',''],['公因式','',''],['公因数','',''],['公园','',''],['公园小径效应','',''],['公国','',''],['公地','',''],['公地悲剧','',''],['公垂线','',''],['公堂','',''],['公墓','',''],['公处','',''],['公娼','',''],['公婆','',''],['公子','',''],['公子哥儿','',''],['公子王孙','',''],['公孙','',''],['公孙树','',''],['公孙起','',''],['公孙龙','',''],['公安人员','',''],['公安厅','',''],['公安官员','',''],['公安局','',''],['公安工作','',''],['公安干警','',''],['公安战士','',''],['公安机关','',''],['公安部','',''],['公安部长','',''],['公安部队','',''],['公审','',''],['公室','',''],['公害','',''],['公家','',''],['公家机关','',''],['公寓','',''],['公寓大楼','',''],['公寓楼','',''],['公寸','',''],['公尺','',''],['公差','',''],['公布','',''],['公布于','',''],['公布于世','',''],['公布栏','',''],['公帑','',''],['公干','',''],['公干粉','',''],['公平','',''],['公平交易','',''],['公平合理','',''],['公平审判权','',''],['公平竞争','',''],['公平贸易','',''],['公府','',''],['公廨','',''],['公开','',''],['公开信','',''],['公开化','',''],['公开场合','',''],['公开审判','',''],['公开性','',''],['公开批评','',''],['公开指责','',''],['公开讨论会','',''],['公开赛','',''],['公开钥匙','',''],['公式','',''],['公式化','',''],['公式集','',''],['公引','',''],['公弛','',''],['公德','',''],['公德心','',''],['公心','',''],['公意','',''],['公愤','',''],['公房','',''],['公才公望','',''],['公投','',''],['公报','',''],['公报私仇','',''],['公担','',''],['公推','',''],['公撮','',''],['公敌','',''],['公教','',''],['公教人员','',''],['公文','',''],['公文书','',''],['公文包','',''],['公文旅行','',''],['公文袋','',''],['公斗','',''],['公斤','',''],['公断','',''],['公断人','',''],['公方','',''],['公族','',''],['公映','',''],['公有','',''],['公有制','',''],['公有化','',''],['公权','',''],['公格尔山','',''],['公案','',''],['公检','',''],['公检法','',''],['公款','',''],['公正','',''],['公正人','',''],['公母俩','',''],['公比','',''],['公民','',''],['公民义务','',''],['公民基本权利','',''],['公民投票','',''],['公民权','',''],['公民权利','',''],['公民权利和政治权利国际公约','',''],['公民自由','',''],['公民表决','',''],['公河','',''],['公法','',''],['公海','',''],['公演','',''],['公然','',''],['公然表示','',''],['公爵','',''],['公爵夫人','',''],['公爹','',''],['公牍','',''],['公牛','',''],['公物','',''],['公犬','',''],['公猪','',''],['公猫','',''],['公现','',''],['公理','',''],['公理法','',''],['公用','',''],['公用事业','',''],['公用交换电话网','',''],['公用电话','',''],['公用设施','',''],['公电','',''],['公畜','',''],['公益','',''],['公益事业','',''],['公益金','',''],['公石','',''],['公社','',''],['公社社员墙','',''],['公祭','',''],['公私','',''],['公私不分','',''],['公私两便','',''],['公私两济','',''],['公私交迫','',''],['公私兼顾','',''],['公私分明','',''],['公私合营','',''],['公秉','',''],['公积金','',''],['公称','',''],['公立','',''],['公立学校','',''],['公章','',''],['公筷','',''],['公粮','',''],['公约','',''],['公约数','',''],['公网','',''],['公署','',''],['公羊','',''],['公羊传','',''],['公羊春秋','',''],['公而忘私','',''],['公职','',''],['公职人员','',''],['公股','',''],['公营','',''],['公营企业','',''],['公营经济','',''],['公认','',''],['公议','',''],['公论','',''],['公设','',''],['公证','',''],['公证书','',''],['公证人','',''],['公证处','',''],['公证机关','',''],['公诉','',''],['公诉人','',''],['公诫','',''],['公诸','',''],['公诸于世','',''],['公诸于众','',''],['公诸同好','',''],['公费','',''],['公费医疗','',''],['公费旅游','',''],['公费生','',''],['公路','',''],['公路交通','',''],['公路网','',''],['公路自行车','',''],['公路赛','',''],['公路运输','',''],['公车','',''],['公转','',''],['公输','',''],['公道','',''],['公里','',''],['公里时','',''],['公钱','',''],['公门','',''],['公需','',''],['公顷','',''],['公馆','',''],['公馆乡','',''],['公马','',''],['公鸡','',''],['公鸭','',''],['六○六','',''],['六・二五战争','',''],['六・四','',''],['六一','',''],['六一儿童节','',''],['六一国际儿童节','',''],['六万','',''],['六三政变','',''],['六个','',''],['六个月','',''],['六个装','',''],['六中全会','',''],['六书','',''],['六二五事变','',''],['六亲','',''],['六亲不认','',''],['六亲无靠','',''],['六人','',''],['六亿','',''],['六仙桌','',''],['六价','',''],['六位','',''],['六便士','',''],['六倍','',''],['六六','',''],['六六六','',''],['六出奇计','',''],['六分','',''],['六分之一','',''],['六分之三','',''],['六分之二','',''],['六分之五','',''],['六分之四','',''],['六分仪','',''],['六分仪座','',''],['六十','',''],['六十一','',''],['六十七','',''],['六十万','',''],['六十三','',''],['六十个','',''],['六十九','',''],['六十二','',''],['六十五','',''],['六十人','',''],['六十倍','',''],['六十八','',''],['六十六','',''],['六十四','',''],['六十四万','',''],['六十四位元','',''],['六十四卦','',''],['六十岁','',''],['六十年','',''],['六十年代','',''],['六千','',''],['六卿','',''],['六号','',''],['六合','',''],['六合八法','',''],['六合彩','',''],['六味地黄丸','',''],['六四事件','',''],['六块腹肌','',''],['六大','',''],['六安地区','',''],['六官','',''],['六家','',''],['六尘','',''],['六尺之孤','',''],['六尺长','',''],['六届','',''],['六年','',''],['六库','',''],['六库镇','',''],['六开','',''],['六开本','',''],['六弦琴','',''],['六所','',''],['六折','',''],['六指','',''],['六指儿','',''],['六方','',''],['六方最密堆积','',''],['六日','',''],['六日战争','',''],['六时','',''],['六月','',''],['六月份','',''],['六月起义','',''],['六月飞霜','',''],['六朝','',''],['六朝四大家','',''],['六朝时代','',''],['六朝金粉','',''],['六条','',''],['六根','',''],['六根清净','',''],['六次','',''],['六步格','',''],['六段','',''],['六氟化硫','',''],['六氟化铀','',''],['六法全书','',''],['六淫','',''],['六点','',''],['六环路','',''],['六甲','',''],['六甲乡','',''],['六畜','',''],['六畜不安','',''],['六畜兴旺','',''],['六百','',''],['六百万','',''],['六盘山','',''],['六盘山脉','',''],['六碳糖','',''],['六神','',''],['六神不安','',''],['六神丸','',''],['六神无主','',''],['六级士官','',''],['六线形','',''],['六经','',''],['六脚','',''],['六脚乡','',''],['六腑','',''],['六色','',''],['六艺','',''],['六节诗','',''],['六行','',''],['六街三市','',''],['六角','',''],['六角形','',''],['六角括号','',''],['六角星','',''],['六角螺帽','',''],['六路','',''],['六轮','',''],['六边','',''],['六边形','',''],['六通四辟','',''],['六通四达','',''],['六道','',''],['六道轮回','',''],['六邪','',''],['六部','',''],['六重唱','',''],['六重奏','',''],['六镇起义','',''],['六问三推','',''],['六阳会首','',''],['六零','',''],['六零六','',''],['六面','',''],['六面体','',''],['六韬','',''],['六韬三略','',''],['六音','',''],['六马仰秣','',''],['六龟','',''],['六龟乡','',''],['兮兮','',''],['兰交','',''],['兰亭','',''],['兰克','',''],['兰博基尼','',''],['兰因絮果','',''],['兰坪','',''],['兰坪县','',''],['兰姆','',''],['兰姆打','',''],['兰姆达','',''],['兰姆酒','',''],['兰学','',''],['兰宝石','',''],['兰室','',''],['兰山','',''],['兰屿','',''],['兰屿乡','',''],['兰崔玉折','',''],['兰州大学','',''],['兰开夏郡','',''],['兰开斯特','',''],['兰心蕙性','',''],['兰摧玉折','',''],['兰斯','',''],['兰斯洛特','',''],['兰新','',''],['兰新铁路','',''],['兰板','',''],['兰桂齐芳','',''],['兰特','',''],['兰玉','',''],['兰科','',''],['兰章','',''],['兰舟','',''],['兰色','',''],['兰艾同焚','',''],['兰花','',''],['兰花指','',''],['兰芷之室','',''],['兰若','',''],['兰草','',''],['兰蔻','',''],['兰言','',''],['兰谱','',''],['兰迪斯','',''],['兰郑长成品油管道','',''],['兰郑长管道','',''],['兰闺','',''],['兰领','',''],['兰领工人','',''],['共为','',''],['共为唇齿','',''],['共乘','',''],['共事','',''],['共产','',''],['共产主义','',''],['共产主义人生观','',''],['共产主义者','',''],['共产主义者同盟','',''],['共产主义青年团','',''],['共产党','',''],['共产党人','',''],['共产党员','',''],['共产党和工人党情报局','',''],['共产党宣言','',''],['共产国际','',''],['共享','',''],['共享以太网络','',''],['共享函数库','',''],['共享带宽','',''],['共享库','',''],['共享程序库','',''],['共享者','',''],['共享计划','',''],['共享软体','',''],['共价','',''],['共价键','',''],['共党','',''],['共军','',''],['共创','',''],['共办','',''],['共勉','',''],['共匪','',''],['共发射极','',''],['共叙','',''],['共同','',''],['共同一致','',''],['共同体','',''],['共同利益','',''],['共同努力','',''],['共同基金','',''],['共同市场','',''],['共同性','',''],['共同海损','',''],['共同点','',''],['共同社','',''],['共同筛选','',''],['共同纲领','',''],['共同语','',''],['共同闸道介面','',''],['共和党','',''],['共和党人','',''],['共和制','',''],['共和国','',''],['共和政体','',''],['共和派','',''],['共商','',''],['共商国是','',''],['共商大计','',''],['共图大计','',''],['共在','',''],['共基极','',''],['共处','',''],['共妻','',''],['共婚','',''],['共存','',''],['共存性','',''],['共居','',''],['共工','',''],['共庆','',''],['共床人','',''],['共度','',''],['共建','',''],['共建文明','',''],['共形','',''],['共性','',''],['共总','',''],['共患难','',''],['共愤','',''],['共振','',''],['共振器','',''],['共振板','',''],['共挽鹿东','',''],['共收','',''],['共有','',''],['共有化','',''],['共析','',''],['共栖','',''],['共模','',''],['共济','',''],['共激','',''],['共焦','',''],['共犯','',''],['共生','',''],['共生矿','',''],['共用','',''],['共用权','',''],['共知','',''],['共祝','',''],['共管','',''],['共约','',''],['共职','',''],['共聚','',''],['共聚反应','',''],['共聚物','',''],['共荣','',''],['共融','',''],['共行车道','',''],['共襄','',''],['共襄善举','',''],['共襄盛举','',''],['共计','',''],['共设','',''],['共识','',''],['共话','',''],['共谋','',''],['共谋罪','',''],['共谋者','',''],['共贺','',''],['共赢','',''],['共赴','',''],['共路','',''],['共轭','',''],['共轭不尽根','',''],['共轭作用','',''],['共轭复数','',''],['共轭根式','',''],['共轭点','',''],['共轭虚数','',''],['共达','',''],['共运','',''],['共进','',''],['共进会','',''],['共进早餐','',''],['共通','',''],['共通性','',''],['共需','',''],['共青团','',''],['共青团员','',''],['共青组织','',''],['共面','',''],['共餐','',''],['共餐青年团','',''],['共饮','',''],['共鸣','',''],['共鸣器','',''],['关上','',''],['关东','',''],['关东军','',''],['关东地震','',''],['关东糖','',''],['关中','',''],['关中地区','',''],['关中平原','',''],['关之琳','',''],['关乎','',''],['关书','',''],['关了','',''],['关于','',''],['关于此','',''],['关住','',''],['关停','',''],['关停并转','',''],['关健','',''],['关入','',''],['关公','',''],['关关','',''],['关关过','',''],['关关难过','',''],['关内','',''],['关切','',''],['关卡','',''],['关厂','',''],['关厢','',''],['关口','',''],['关在','',''],['关城','',''],['关塔纳摩','',''],['关塔那摩','',''],['关塔那摩湾','',''],['关塞','',''],['关境','',''],['关外','',''],['关头','',''],['关子','',''],['关山','',''],['关山镇','',''],['关岛大学','',''],['关岭','',''],['关岭县','',''],['关帝庙','',''],['关店','',''],['关店歇业','',''],['关庙','',''],['关庙乡','',''],['关张','',''],['关征','',''],['关心','',''],['关心事','',''],['关心国家大事','',''],['关心群众','',''],['关心集体','',''],['关怀','',''],['关怀备至','',''],['关押','',''],['关掉','',''],['关文','',''],['关机','',''],['关栈','',''],['关栈费','',''],['关格','',''],['关汉卿','',''],['关注','',''],['关涉','',''],['关渡','',''],['关灯','',''],['关照','',''],['关爱','',''],['关白','',''],['关着','',''],['关碍','',''],['关税','',''],['关税与贸易总协定','',''],['关税同盟','',''],['关税国境','',''],['关税壁垒','',''],['关税率','',''],['关税自主运动','',''],['关税表','',''],['关窗','',''],['关站','',''],['关系','',''],['关系代名词','',''],['关系到','',''],['关系史','',''],['关系好','',''],['关系密切','',''],['关系式','',''],['关系户','',''],['关系正常化','',''],['关系甚钜','',''],['关系网','',''],['关系者','',''],['关系词','',''],['关紧','',''],['关羽','',''],['关联','',''],['关联公司','',''],['关节','',''],['关节囊','',''],['关节炎','',''],['关节腔','',''],['关节面','',''],['关著','',''],['关西','',''],['关西镇','',''],['关说','',''],['关贸','',''],['关贸总协定','',''],['关起','',''],['关起门来','',''],['关车','',''],['关进','',''],['关连','',''],['关金','',''],['关金圆','',''],['关键','',''],['关键字','',''],['关键性','',''],['关键时刻','',''],['关键词','',''],['关门','',''],['关门主义','',''],['关门大吉','',''],['关门弟子','',''],['关门打狗','',''],['关门捉贼','',''],['关门闭户','',''],['关闭','',''],['关闭者','',''],['关防','',''],['关隘','',''],['关颖珊','',''],['关饷','',''],['兴中会','',''],['兴之所至','',''],['兴云作雨','',''],['兴云作雾','',''],['兴云吐雾','',''],['兴云布雨','',''],['兴亡','',''],['兴亡继绝','',''],['兴产','',''],['兴会','',''],['兴会淋漓','',''],['兴修','',''],['兴修水利','',''],['兴兵','',''],['兴兵动众','',''],['兴农','',''],['兴冲冲','',''],['兴凯刺鳑鲏','',''],['兴利除害','',''],['兴利除弊','',''],['兴办','',''],['兴叹','',''],['兴味','',''],['兴复不浅','',''],['兴头','',''],['兴头儿上','',''],['兴奋','',''],['兴奋剂','',''],['兴奋性','',''],['兴奋药','',''],['兴奋高潮','',''],['兴妖作孽','',''],['兴妖作怪','',''],['兴学','',''],['兴安岭','',''],['兴安运河','',''],['兴家立业','',''],['兴宾','',''],['兴尽','',''],['兴尽悲来','',''],['兴尽意阑','',''],['兴工','',''],['兴师','',''],['兴师动众','',''],['兴师见罪','',''],['兴师问罪','',''],['兴废','',''],['兴废存亡','',''],['兴废继绝','',''],['兴建','',''],['兴微继绝','',''],['兴无灭资','',''],['兴旺','',''],['兴旺发达','',''],['兴替','',''],['兴灭举废','',''],['兴灭继绝','',''],['兴犹未尽','',''],['兴盛','',''],['兴致','',''],['兴致勃勃','',''],['兴致勃发','',''],['兴致好','',''],['兴致索然','',''],['兴荣','',''],['兴衰','',''],['兴衰成败','',''],['兴衰荣辱','',''],['兴许','',''],['兴败','',''],['兴起','',''],['兴趣','',''],['兴邦','',''],['兴都库什山','',''],['兴都库仕','',''],['兴门','',''],['兴隆台','',''],['兴革','',''],['兴风','',''],['兴风作浪','',''],['兴高','',''],['兴高彩烈','',''],['兴高采烈','',''],['兵丁','',''],['兵不厌权','',''],['兵不厌诈','',''],['兵不血刃','',''],['兵临城下','',''],['兵书','',''],['兵乱','',''],['兵出无名','',''],['兵刃','',''],['兵制','',''],['兵力','',''],['兵卒','',''],['兵变','',''],['兵员','',''],['兵器','',''],['兵器工业','',''],['兵器工业部','',''],['兵器术','',''],['兵团','',''],['兵场','',''],['兵坑','',''],['兵士','',''],['兵多将广','',''],['兵学','',''],['兵家','',''],['兵家常事','',''],['兵工','',''],['兵工厂','',''],['兵差','',''],['兵库','',''],['兵库县','',''],['兵强马壮','',''],['兵役','',''],['兵役制度','',''],['兵役法','',''],['兵役等','',''],['兵微将寡','',''],['兵志','',''],['兵戈','',''],['兵戈扰攘','',''],['兵戈相见','',''],['兵戎','',''],['兵戎相见','',''],['兵操','',''],['兵无血刃','',''],['兵权','',''],['兵来将挡','',''],['兵来将敌','',''],['兵来将敌水来土堰','',''],['兵来将迎水来土堰','',''],['兵法','',''],['兵法家','',''],['兵源','',''],['兵火','',''],['兵灾','',''],['兵甲','',''],['兵略','',''],['兵痞','',''],['兵祸','',''],['兵种','',''],['兵种战术','',''],['兵站','',''],['兵站运输线','',''],['兵符','',''],['兵籍','',''],['兵精粮足','',''],['兵经','',''],['兵舍','',''],['兵舰','',''],['兵船','',''],['兵荒马乱','',''],['兵营','',''],['兵蚁','',''],['兵要地志','',''],['兵败如山倒','',''],['兵贵神速','',''],['兵连祸结','',''],['兵部','',''],['兵队','',''],['兵饷','',''],['兵马','',''],['兵马俑','',''],['兵马未动','',''],['其一','',''],['其三','',''],['其上','',''],['其下','',''],['其中','',''],['其中之一','',''],['其为','',''],['其乐','',''],['其乐不穷','',''],['其乐无穷','',''],['其乐融融','',''],['其事','',''],['其二','',''],['其人','',''],['其人其事','',''],['其他','',''],['其他人','',''],['其余','',''],['其先','',''],['其内','',''],['其势','',''],['其势汹汹','',''],['其反','',''],['其名','',''],['其后','',''],['其味','',''],['其味无穷','',''],['其境','',''],['其处','',''],['其外','',''],['其它','',''],['其它的','',''],['其它窗口','',''],['其实','',''],['其实不然','',''],['其实难副','',''],['其害','',''],['其家','',''],['其应若响','',''],['其形','',''],['其情','',''],['其所','',''],['其数','',''],['其时','',''],['其是','',''],['其来','',''],['其次','',''],['其母','',''],['其然','',''],['其父','',''],['其生','',''],['其的','',''],['其短','',''],['其自身','',''],['其色','',''],['其解','',''],['其言','',''],['其词','',''],['其说','',''],['其谈','',''],['其貌','',''],['其貌不扬','',''],['其辞','',''],['其量','',''],['其间','',''],['其难','',''],['具交','',''],['具体','',''],['具体劳动','',''],['具体化','',''],['具体地说','',''],['具体来说','',''],['具体真理','',''],['具体而微','',''],['具体计划','',''],['具体说明','',''],['具体说来','',''],['具体问题','',''],['具保','',''],['具名','',''],['具备','',''],['具备条件','',''],['具尔','',''],['具文','',''],['具有','',''],['具有主权','',''],['具结','',''],['典书','',''],['典价','',''],['典借','',''],['典出人','',''],['典刑','',''],['典卖','',''],['典型','',''],['典型化','',''],['典型用途','',''],['典型登革热','',''],['典型的','',''],['典型示范','',''],['典型调查','',''],['典契','',''],['典式','',''],['典当','',''],['典当业','',''],['典当商','',''],['典押','',''],['典故','',''],['典狱','',''],['典狱长','',''],['典礼','',''],['典章','',''],['典章制度','',''],['典籍','',''],['典范','',''],['典藏','',''],['典装','',''],['典质','',''],['典雅','',''],['兹事体大','',''],['兹因','',''],['兹将','',''],['兹有','',''],['兹沃勒','',''],['养上','',''],['养亲','',''],['养人','',''],['养伤','',''],['养作','',''],['养儿','',''],['养儿代老积谷防饥','',''],['养儿备老','',''],['养儿待老积谷防饥','',''],['养儿防老','',''],['养儿防老积谷防饥','',''],['养兔场','',''],['养兵','',''],['养兵千日','',''],['养兵千日用兵一时','',''],['养兵千日用兵一朝','',''],['养养','',''],['养军','',''],['养军千日用兵一时','',''],['养军千日用在一时','',''],['养分','',''],['养地','',''],['养场','',''],['养大','',''],['养女','',''],['养好','',''],['养威蓄锐','',''],['养媳','',''],['养媳妇','',''],['养子','',''],['养子防老积谷防饥','',''],['养宪纳士','',''],['养家','',''],['养家活口','',''],['养家糊口','',''],['养尊处优','',''],['养小防老积谷防饥','',''],['养廉','',''],['养志','',''],['养性','',''],['养成','',''],['养护','',''],['养料','',''],['养殖','',''],['养殖业','',''],['养殖场','',''],['养殖面积','',''],['养母','',''],['养气','',''],['养汉','',''],['养法','',''],['养活','',''],['养父','',''],['养父母','',''],['养牛','',''],['养猪','',''],['养猪业','',''],['养猪人','',''],['养猪场','',''],['养生','',''],['养生法','',''],['养生送死','',''],['养生送终','',''],['养疴','',''],['养病','',''],['养痈成患','',''],['养痈自患','',''],['养痈自祸','',''],['养痈致患','',''],['养痈蓄疽','',''],['养痈贻害','',''],['养痈贻患','',''],['养痈遗患','',''],['养眼','',''],['养神','',''],['养精畜锐','',''],['养精蓄锐','',''],['养羊','',''],['养老','',''],['养老保险','',''],['养老送终','',''],['养老金','',''],['养老院','',''],['养肥','',''],['养育','',''],['养育者','',''],['养育院','',''],['养花','',''],['养虎为患','',''],['养虎伤身','',''],['养虎留患','',''],['养虎自啮','',''],['养虎贻患','',''],['养虎遗患','',''],['养虫室','',''],['养蚕','',''],['养蚕业','',''],['养蚕所','',''],['养蜂','',''],['养蜂业','',''],['养蜂人','',''],['养蜂场','',''],['养蜂家','',''],['养路','',''],['养路工','',''],['养路费','',''],['养身','',''],['养身之道','',''],['养锐蓄威','',''],['养驯','',''],['养鱼','',''],['养鱼场','',''],['养鱼塘','',''],['养鱼池','',''],['养鱼缸','',''],['养鸟','',''],['养鸡','',''],['养鸡场','',''],['养鸭','',''],['养鹰者','',''],['兼之','',''],['兼任','',''],['兼优','',''],['兼作','',''],['兼做','',''],['兼具','',''],['兼到','',''],['兼办','',''],['兼听','',''],['兼听则明','',''],['兼售','',''],['兼备','',''],['兼容','',''],['兼容并包','',''],['兼容性','',''],['兼容机','',''],['兼差','',''],['兼并','',''],['兼并与收购','',''],['兼弱攻昧','',''],['兼得','',''],['兼收','',''],['兼收并蓄','',''],['兼施','',''],['兼旬','',''],['兼有','',''],['兼权熟计','',''],['兼毫','',''],['兼演','',''],['兼爱','',''],['兼理','',''],['兼用','',''],['兼祧','',''],['兼程','',''],['兼管','',''],['兼而有之','',''],['兼职','',''],['兼职教师','',''],['兼营','',''],['兼蓄','',''],['兼课','',''],['兼顾','',''],['兽力车','',''],['兽化','',''],['兽医','',''],['兽医学','',''],['兽医院','',''],['兽奸','',''],['兽害','',''],['兽尸','',''],['兽心','',''],['兽心人面','',''],['兽性','',''],['兽性化','',''],['兽敌','',''],['兽术','',''],['兽栏','',''],['兽欲','',''],['兽王','',''],['兽环','',''],['兽病理学','',''],['兽皮','',''],['兽穴','',''],['兽窝','',''],['兽笼','',''],['兽类','',''],['兽群','',''],['兽聚鸟散','',''],['兽脚亚目','',''],['兽脚类恐龙','',''],['兽般','',''],['兽药','',''],['兽行','',''],['兽骨','',''],['冀东','',''],['冀中','',''],['冀南','',''],['冀县','',''],['冀望','',''],['冀朝铸','',''],['冀求','',''],['内中','',''],['内串','',''],['内丹','',''],['内主','',''],['内乱','',''],['内乱罪','',''],['内争','',''],['内亲','',''],['内人','',''],['内伤','',''],['内侄','',''],['内侄女','',''],['内侍','',''],['内侧','',''],['内债','',''],['内倾','',''],['内兄','',''],['内克','',''],['内八字脚','',''],['内公切线','',''],['内凹','',''],['内出','',''],['内出血','',''],['内击战','',''],['内函','',''],['内分','',''],['内分泌','',''],['内分泌腺','',''],['内切','',''],['内切圆','',''],['内切球','',''],['内则','',''],['内制','',''],['内力','',''],['内立面','',''],['内功','',''],['内务','',''],['内务条令','',''],['内务部','',''],['内动','',''],['内助','',''],['内勤','',''],['内包','',''],['内化','',''],['内华达','',''],['内华达州','',''],['内卡河','',''],['内卷','',''],['内参','',''],['内变','',''],['内史','',''],['内向','',''],['内向型','',''],['内向性','',''],['内向者','',''],['内含','',''],['内含体','',''],['内吸剂','',''],['内哄','',''],['内啡素','',''],['内啡肽','',''],['内因','',''],['内圈','',''],['内圣外王','',''],['内在','',''],['内在几何','',''],['内在几何学','',''],['内在化','',''],['内在坐标','',''],['内在性','',''],['内在的','',''],['内在联系','',''],['内在论','',''],['内在超越','',''],['内地','',''],['内地人','',''],['内场','',''],['内城','',''],['内埔','',''],['内埔乡','',''],['内堂','',''],['内塔尼亚胡','',''],['内墙','',''],['内壁','',''],['内壕','',''],['内外','',''],['内外交困','',''],['内外勾结','',''],['内外夹攻','',''],['内外有别','',''],['内奸','',''],['内子','',''],['内存','',''],['内宅','',''],['内定','',''],['内室','',''],['内容','',''],['内容提要','',''],['内容管理系统','',''],['内宾','',''],['内寄生','',''],['内层','',''],['内嵌','',''],['内布拉斯加','',''],['内布拉斯加州','',''],['内幕','',''],['内幕交易','',''],['内应','',''],['内应力','',''],['内底','',''],['内府','',''],['内座层','',''],['内廷','',''],['内建','',''],['内弟','',''],['内弧面','',''],['内弯','',''],['内弯足','',''],['内径','',''],['内心','',''],['内心世界','',''],['内心深处','',''],['内心里','',''],['内忧','',''],['内忧外困','',''],['内忧外患','',''],['内急','',''],['内患','',''],['内情','',''],['内战','',''],['内戮','',''],['内拉','',''],['内掌柜','',''],['内掌柜的','',''],['内接多边形','',''],['内插','',''],['内摩擦','',''],['内收','',''],['内攻','',''],['内放','',''],['内政','',''],['内政部','',''],['内政部警政署','',''],['内政部长','',''],['内斗','',''],['内斜视','',''],['内景','',''],['内有','',''],['内服','',''],['内服药','',''],['内果','',''],['内果皮','',''],['内柔外刚','',''],['内查外调','',''],['内核','',''],['内殿','',''],['内毒','',''],['内比都','',''],['内汇','',''],['内江地区','',''],['内河','',''],['内河航行权','',''],['内河运输','',''],['内沿','',''],['内流','',''],['内流河','',''],['内海','',''],['内涝','',''],['内涵','',''],['内涵意义','',''],['内港','',''],['内湖','',''],['内湖区','',''],['内源','',''],['内热','',''],['内焰','',''],['内熵','',''],['内燃','',''],['内燃机','',''],['内燃机车','',''],['内爆','',''],['内爆法原子弹','',''],['内爱','',''],['内物','',''],['内生','',''],['内生的','',''],['内电战','',''],['内电路','',''],['内电阻','',''],['内疚','',''],['内痔','',''],['内皮','',''],['内盛','',''],['内省','',''],['内省性','',''],['内眷','',''],['内眼角','',''],['内码','',''],['内破裂','',''],['内秀','',''],['内科','',''],['内科医生','',''],['内科学','',''],['内积','',''],['内稃','',''],['内空','',''],['内管','',''],['内紧外松','',''],['内线','',''],['内线交易','',''],['内线消息','',''],['内细胞团','',''],['内经','',''],['内罗毕','',''],['内置','',''],['内翻','',''],['内耗','',''],['内耳','',''],['内耳眩晕症','',''],['内耳道','',''],['内联','',''],['内联外引','',''],['内联网','',''],['内聚力','',''],['内聚性','',''],['内肿','',''],['内胎','',''],['内胚','',''],['内胚层','',''],['内能','',''],['内脏','',''],['内腺','',''],['内膜','',''],['内膝','',''],['内臣','',''],['内营力','',''],['内蒙','',''],['内蒙古大学','',''],['内蒙古高原','',''],['内蕴','',''],['内行','',''],['内行星','',''],['内行看门道','',''],['内衣','',''],['内衣裤','',''],['内衬','',''],['内袋','',''],['内袖','',''],['内装','',''],['内裙','',''],['内裤','',''],['内视反听','',''],['内角','',''],['内讧','',''],['内设','',''],['内诊镜','',''],['内详','',''],['内质网','',''],['内贾德','',''],['内资','',''],['内踝','',''],['内转','',''],['内部','',''],['内部事务','',''],['内部人','',''],['内部刊物','',''],['内部斗争','',''],['内部矛盾','',''],['内部结构','',''],['内部缺陷','',''],['内部网','',''],['内酯','',''],['内酰胺','',''],['内酰胺酶','',''],['内里','',''],['内销','',''],['内错','',''],['内错角','',''],['内门','',''],['内门乡','',''],['内阁','',''],['内阁制','',''],['内阁总理大臣','',''],['内阻','',''],['内陆','',''],['内陆国','',''],['内陆河','',''],['内陆湖','',''],['内院','',''],['内陷','',''],['内障','',''],['内难','',''],['内需','',''],['内面','',''],['内项','',''],['内顾','',''],['内顾之忧','',''],['内饰','',''],['内驻','',''],['内骨','',''],['内骨骼','',''],['内鬼','',''],['冈上肌','',''],['冈下肌','',''],['冈仁波齐','',''],['冈仁波齐峰','',''],['冈山','',''],['冈山县','',''],['冈山镇','',''],['冈峦','',''],['冈底斯山','',''],['冈底斯山脉','',''],['冈本','',''],['冈陵','',''],['冉冉','',''],['冉冉上升','',''],['冉冉升起','',''],['冉魏','',''],['册书','',''],['册卷','',''],['册历','',''],['册子','',''],['册封','',''],['册府元龟','',''],['册立','',''],['册簿','',''],['册页','',''],['再一','',''],['再一次','',''],['再三','',''],['再三再四','',''],['再上','',''],['再上演','',''],['再不','',''],['再不是','',''],['再不然','',''],['再与','',''],['再且','',''],['再严','',''],['再临','',''],['再为','',''],['再主张','',''],['再之','',''],['再也','',''],['再也不','',''],['再买','',''],['再予','',''],['再交','',''],['再交换','',''],['再任命','',''],['再会','',''],['再传','',''],['再作','',''],['再作冯妇','',''],['再使用','',''],['再供','',''],['再保证','',''],['再保险','',''],['再借','',''],['再假定','',''],['再做','',''],['再充填','',''],['再入','',''],['再写','',''],['再凭','',''],['再出','',''],['再出口','',''],['再出现','',''],['再分','',''],['再分析','',''],['再则','',''],['再创','',''],['再创造','',''],['再利用','',''],['再到','',''],['再制','',''],['再制用','',''],['再制盐','',''],['再制纸','',''],['再加','',''],['再加倍','',''],['再加入','',''],['再区分','',''],['再去','',''],['再参加','',''],['再发','',''],['再发作','',''],['再发展','',''],['再发布','',''],['再发现','',''],['再发生','',''],['再发行','',''],['再发见','',''],['再取','',''],['再取得','',''],['再同','',''],['再向','',''],['再听','',''],['再启动','',''],['再吸收','',''],['再唱','',''],['再四','',''],['再回','',''],['再填满','',''],['再处理','',''],['再复苏','',''],['再多','',''],['再好','',''],['再好不过','',''],['再好没有','',''],['再如','',''],['再婚','',''],['再嫁','',''],['再嫁娶','',''],['再安顿','',''],['再定购','',''],['再实施','',''],['再审','',''],['再导入','',''],['再将','',''],['再就是','',''],['再屠现金','',''],['再布置','',''],['再带','',''],['再度','',''],['再建','',''],['再开','',''],['再开始','',''],['再录音','',''],['再往前','',''],['再循环','',''],['再想','',''],['再打','',''],['再扩散','',''],['再扫描','',''],['再找','',''],['再把','',''],['再投资','',''],['再折扣','',''],['再拉','',''],['再拜','',''],['再拿','',''],['再指名','',''],['再按','',''],['再振作','',''],['再捕获','',''],['再接再励','',''],['再接再厉','',''],['再接再砺','',''],['再接合','',''],['再提','',''],['再提供','',''],['再提名','',''],['再改','',''],['再放','',''],['再放射','',''],['再放映','',''],['再教育','',''],['再断言','',''],['再无','',''],['再有','',''],['再来','',''],['再检查','',''],['再植','',''],['再植入','',''],['再次','',''],['再武装','',''],['再注满','',''],['再洗礼','',''],['再活化假说','',''],['再涂上','',''],['再混','',''],['再混合','',''],['再演','',''],['再点燃','',''],['再热','',''],['再燃','',''],['再燃烧','',''],['再燃起','',''],['再版','',''],['再犯','',''],['再现','',''],['再现部','',''],['再生','',''],['再生不良性贫血','',''],['再生产','',''],['再生制动','',''],['再生器','',''],['再生燃料','',''],['再生父母','',''],['再生能源','',''],['再生草','',''],['再生资源','',''],['再用','',''],['再由','',''],['再登','',''],['再登上','',''],['再直接','',''],['再看','',''],['再确认','',''],['再租赁','',''],['再穿上','',''],['再穿著','',''],['再立新功','',''],['再等','',''],['再经','',''],['再经历','',''],['再结合','',''],['再给','',''],['再统一','',''],['再继续','',''],['再考虑','',''],['再者','',''],['再聚集','',''],['再肯定','',''],['再育','',''],['再膨胀','',''],['再致词','',''],['再苦再累','',''],['再获','',''],['再萌发','',''],['再融资','',''],['再行','',''],['再补','',''],['再表明','',''],['再衰三竭','',''],['再被','',''],['再装入','',''],['再装填','',''],['再装满','',''],['再装运','',''],['再装配','',''],['再要','',''],['再见','',''],['再认','',''],['再让','',''],['再议','',''],['再讲','',''],['再论','',''],['再访','',''],['再评价','',''],['再试','',''],['再试验','',''],['再说','',''],['再读','',''],['再调整','',''],['再谈','',''],['再贴现','',''],['再赋予','',''],['再赛','',''],['再走','',''],['再起','',''],['再踏上','',''],['再转复','',''],['再输入','',''],['再输出','',''],['再迁','',''],['再过','',''],['再运行','',''],['再进','',''],['再进入','',''],['再远','',''],['再迟','',''],['再选','',''],['再通过','',''],['再造','',''],['再造业','',''],['再造丸','',''],['再造之恩','',''],['再造手术','',''],['再醮','',''],['再问','',''],['再防雨','',''],['再陷','',''],['再障','',''],['再集合','',''],['冏卿','',''],['冏寺','',''],['冏彻','',''],['冏牧','',''],['冒了','',''],['冒充','',''],['冒充者','',''],['冒充货','',''],['冒冒','',''],['冒冒失失','',''],['冒出','',''],['冒号','',''],['冒名','',''],['冒名顶替','',''],['冒名顶替者','',''],['冒大不韪','',''],['冒天下之大不韪','',''],['冒失','',''],['冒失鬼','',''],['冒头','',''],['冒尖','',''],['冒昧','',''],['冒暑','',''],['冒死','',''],['冒气','',''],['冒汗','',''],['冒泡','',''],['冒泡排序','',''],['冒火','',''],['冒烟','',''],['冒然','',''],['冒牌','',''],['冒牌者','',''],['冒牌货','',''],['冒犯','',''],['冒犯者','',''],['冒生命危险','',''],['冒用','',''],['冒着','',''],['冒着烟','',''],['冒着生命危险','',''],['冒称','',''],['冒纳罗亚','',''],['冒认','',''],['冒起','',''],['冒进','',''],['冒险','',''],['冒险主义','',''],['冒险家','',''],['冒险干','',''],['冒险性','',''],['冒险者','',''],['冒险跳','',''],['冒雨','',''],['冒顶','',''],['冒领','',''],['冒题','',''],['冒风险','',''],['冒风雨','',''],['冕旒','',''],['冕礼','',''],['冗位','',''],['冗余','',''],['冗余度','',''],['冗余量','',''],['冗兵','',''],['冗冗','',''],['冗务','',''],['冗员','',''],['冗官','',''],['冗散','',''],['冗数','',''],['冗杂','',''],['冗条子','',''],['冗笔','',''],['冗繁','',''],['冗职','',''],['冗言','',''],['冗词','',''],['冗词赘句','',''],['冗语','',''],['冗费','',''],['冗赘','',''],['冗赘词','',''],['冗辞','',''],['冗长','',''],['冗长度','',''],['冗食','',''],['写上','',''],['写下','',''],['写了','',''],['写事','',''],['写人','',''],['写他','',''],['写作','',''],['写作学','',''],['写作家','',''],['写作文','',''],['写作方法','',''],['写作知识','',''],['写信','',''],['写信给','',''],['写入','',''],['写全','',''],['写写','',''],['写出','',''],['写到','',''],['写回','',''],['写在','',''],['写大字','',''],['写大纲','',''],['写好','',''],['写字','',''],['写字台','',''],['写字楼','',''],['写字间','',''],['写完','',''],['写实','',''],['写实主义','',''],['写实性','',''],['写寄','',''],['写屏','',''],['写序言','',''],['写得','',''],['写意','',''],['写意画','',''],['写成','',''],['写手','',''],['写报道','',''],['写文','',''],['写明','',''],['写景','',''],['写景图','',''],['写有','',''],['写本','',''],['写来','',''],['写法','',''],['写清','',''],['写满','',''],['写照','',''],['写生','',''],['写生簿','',''],['写画','',''],['写的','',''],['写真','',''],['写真集','',''],['写着','',''],['写稿','',''],['写给','',''],['写词','',''],['写诗','',''],['写读','',''],['写进','',''],['写道','',''],['写错','',''],['军不血刃','',''],['军中','',''],['军临城下','',''],['军乐','',''],['军乐队','',''],['军事','',''],['军事上','',''],['军事体育','',''],['军事力量','',''],['军事化','',''],['军事区','',''],['军事地形学','',''],['军事基地','',''],['军事委员会','',''],['军事威胁','',''],['军事学','',''],['军事实力','',''],['军事家','',''],['军事情报','',''],['军事援助','',''],['军事政变','',''],['军事机构','',''],['军事核大国','',''],['军事法庭','',''],['军事演习','',''],['军事科学','',''],['军事管制','',''],['军事职业专业','',''],['军事行动','',''],['军事训练','',''],['军事设施','',''],['军事部门','',''],['军人','',''],['军人优抚','',''],['军人伦理','',''],['军人修养','',''],['军人地位','',''],['军人道德','',''],['军代表','',''],['军令','',''],['军令如山','',''],['军令状','',''],['军体','',''],['军兵种','',''],['军刀','',''],['军分区','',''],['军制','',''],['军制史','',''],['军力','',''],['军办','',''],['军功','',''],['军务','',''],['军务工作','',''],['军势','',''],['军区','',''],['军医','',''],['军医大学','',''],['军医学院','',''],['军医院','',''],['军史','',''],['军史知识','',''],['军号','',''],['军品','',''],['军品出口领导小组','',''],['军品采购','',''],['军售','',''],['军团','',''],['军团杆菌','',''],['军团菌','',''],['军团菌病','',''],['军国','',''],['军国主义','',''],['军国主义者','',''],['军国化','',''],['军地','',''],['军垦','',''],['军士','',''],['军士制度','',''],['军备','',''],['军备控制','',''],['军备竞赛','',''],['军多将广','',''],['军委','',''],['军委会','',''],['军委各总部','',''],['军姿','',''],['军威','',''],['军官','',''],['军官室','',''],['军容','',''],['军容风纪','',''],['军属','',''],['军屯','',''],['军工','',''],['军工产品','',''],['军工企业','',''],['军工生产','',''],['军师','',''],['军帽','',''],['军徽','',''],['军心','',''],['军总','',''],['军情','',''],['军情五处','',''],['军情六处','',''],['军援','',''],['军操','',''],['军政','',''],['军政大学','',''],['军政府','',''],['军方','',''],['军旅','',''],['军旗','',''],['军曹鱼','',''],['军服','',''],['军机','',''],['军机处','',''],['军权','',''],['军校','',''],['军械','',''],['军械库','',''],['军棋','',''],['军歌','',''],['军毯','',''],['军民','',''],['军民一致','',''],['军民团结','',''],['军法','',''],['军法从事','',''],['军港','',''],['军演','',''],['军火','',''],['军火交易','',''],['军火公司','',''],['军火商','',''],['军火库','',''],['军火贸易','',''],['军烈属','',''],['军犬','',''],['军用','',''],['军界','',''],['军略','',''],['军眷','',''],['军礼','',''],['军种','',''],['军种体制','',''],['军管','',''],['军管会','',''],['军籍','',''],['军粮','',''],['军纪','',''],['军统','',''],['军统局','',''],['军绿','',''],['军群','',''],['军职','',''],['军舰','',''],['军营','',''],['军衔','',''],['军衔制','',''],['军衣','',''],['军装','',''],['军规','',''],['军警','',''],['军训','',''],['军语','',''],['军语词典','',''],['军调部','',''],['军费','',''],['军费开支','',''],['军费预算','',''],['军车','',''],['军转民','',''],['军邮','',''],['军部','',''],['军长','',''],['军门','',''],['军阀','',''],['军阀主义','',''],['军阀混战','',''],['军队','',''],['军队化','',''],['军队式','',''],['军阵','',''],['军阶','',''],['军需','',''],['军需品','',''],['军需官','',''],['军需部','',''],['军靴','',''],['军鞋','',''],['军风','',''],['军风纪','',''],['军饷','',''],['军马','',''],['军鼓','',''],['军龄','',''],['农业','',''],['农业人口','',''],['农业八字宪法','',''],['农业再上新台阶','',''],['农业化学','',''],['农业区','',''],['农业区划','',''],['农业合作化','',''],['农业国','',''],['农业地理','',''],['农业大学','',''],['农业家','',''],['农业工人','',''],['农业总产值','',''],['农业技术','',''],['农业投入','',''],['农业改革','',''],['农业政策','',''],['农业机械','',''],['农业机械化','',''],['农业现代化','',''],['农业生产','',''],['农业生产合作社','',''],['农业生产责任制','',''],['农业生产资料','',''],['农业生技','',''],['农业用地','',''],['农业社','',''],['农业社会主义','',''],['农业社会主义改造','',''],['农业科技','',''],['农业税','',''],['农业经济','',''],['农业贷款','',''],['农业资本家','',''],['农业部门','',''],['农业院校','',''],['农业集体化','',''],['农业革命','',''],['农中','',''],['农事','',''],['农事活动','',''],['农产','',''],['农产品','',''],['农产量','',''],['农人','',''],['农会','',''],['农作','',''],['农作物','',''],['农作物品种','',''],['农具','',''],['农副','',''],['农副业','',''],['农副产品','',''],['农区','',''],['农协','',''],['农历','',''],['农历新年','',''],['农友','',''],['农口','',''],['农园','',''],['农地','',''],['农场','',''],['农场主','',''],['农场管理','',''],['农垦','',''],['农垦工作','',''],['农垦经济','',''],['农大','',''],['农夫','',''],['农夫们','',''],['农奴','',''],['农奴主','',''],['农奴制','',''],['农奴解放日','',''],['农妇','',''],['农委','',''],['农学','',''],['农学家','',''],['农学院','',''],['农宅','',''],['农家','',''],['农家庭院','',''],['农家肥料','',''],['农工','',''],['农工党','',''],['农工商','',''],['农工牧副渔业','',''],['农庄','',''],['农德孟','',''],['农忙','',''],['农户','',''],['农房','',''],['农技','',''],['农政全书','',''],['农救会','',''],['农时','',''],['农机','',''],['农机具','',''],['农机厂','',''],['农村','',''],['农村公社','',''],['农村合作化','',''],['农村家庭联产承包责任制','',''],['农村干部','',''],['农村政策','',''],['农村无产阶级','',''],['农村经济','',''],['农村调查','',''],['农村资产阶级','',''],['农林','',''],['农林水产省','',''],['农林牧副','',''],['农林牧副渔','',''],['农校','',''],['农桑','',''],['农械','',''],['农民','',''],['农民企业家','',''],['农民党','',''],['农民协会','',''],['农民工','',''],['农民战争','',''],['农民技术员','',''],['农民日报','',''],['农民起义','',''],['农民运动会','',''],['农民阶级','',''],['农活','',''],['农牧','',''],['农牧业','',''],['农牧区','',''],['农牧场','',''],['农牧民','',''],['农牧渔','',''],['农牧渔业','',''],['农用','',''],['农用物资','',''],['农田','',''],['农田基本建设','',''],['农田水利','',''],['农田灌溉','',''],['农电','',''],['农畜','',''],['农畜产品','',''],['农科院','',''],['农耕','',''],['农膜','',''],['农舍','',''],['农艺','',''],['农艺学','',''],['农艺师','',''],['农药','',''],['农行','',''],['农谚','',''],['农贷','',''],['农贸','',''],['农贸市场','',''],['农资','',''],['农车','',''],['农转非','',''],['农运','',''],['农运会','',''],['农闲','',''],['农院','',''],['农隙','',''],['冠亚军','',''],['冠以','',''],['冠冕','',''],['冠冕堂煌','',''],['冠冕堂皇','',''],['冠军','',''],['冠军杯','',''],['冠军赛','',''],['冠冢','',''],['冠子','',''],['冠履倒易','',''],['冠履倒置','',''],['冠带','',''],['冠形词','',''],['冠心病','',''],['冠状','',''],['冠状动脉','',''],['冠状动脉旁路移植手术','',''],['冠状动脉旁通手术','',''],['冠盖如云','',''],['冠盖相属','',''],['冠盖相望','',''],['冠目','',''],['冠脉','',''],['冠脉循环','',''],['冠词','',''],['冢中枯骨','',''],['冤业','',''],['冤仇','',''],['冤假错案','',''],['冤冤相报','',''],['冤冤相报何时了','',''],['冤各有头债各有主','',''],['冤呀','',''],['冤大头','',''],['冤天屈地','',''],['冤头','',''],['冤孽','',''],['冤家','',''],['冤家宜解不宜结','',''],['冤家对头','',''],['冤家路狭','',''],['冤家路窄','',''],['冤屈','',''],['冤情','',''],['冤抑','',''],['冤有头债有主','',''],['冤枉','',''],['冤枉路','',''],['冤枉钱','',''],['冤案','',''],['冤死','',''],['冤气','',''],['冤狱','',''],['冤苦','',''],['冤诬','',''],['冤钱','',''],['冤鬼','',''],['冤魂','',''],['冥冥','',''],['冥合','',''],['冥器','',''],['冥婚','',''],['冥府','',''],['冥思','',''],['冥思苦想','',''],['冥思苦索','',''],['冥想','',''],['冥想者','',''],['冥王','',''],['冥王星','',''],['冥界','',''],['冥福','',''],['冥纸','',''],['冥衣','',''],['冥道','',''],['冥钞','',''],['冥钱','',''],['冥顽','',''],['冥顽不灵','',''],['冬不拉','',''],['冬令','',''],['冬令营','',''],['冬候鸟','',''],['冬冬响','',''],['冬响','',''],['冬夏','',''],['冬天','',''],['冬奥会','',''],['冬子月','',''],['冬字头','',''],['冬季','',''],['冬季奥运会','',''],['冬季运动','',''],['冬季运动会','',''],['冬学','',''],['冬宫','',''],['冬小麦','',''],['冬山','',''],['冬山乡','',''],['冬扇夏炉','',''],['冬日','',''],['冬日可爱','',''],['冬月','',''],['冬汛','',''],['冬泳','',''],['冬温','',''],['冬温夏清','',''],['冬灌','',''],['冬烘','',''],['冬瓜','',''],['冬瘟','',''],['冬眠','',''],['冬笋','',''],['冬耕','',''],['冬至点','',''],['冬至线','',''],['冬节','',''],['冬菇','',''],['冬菜','',''],['冬藏','',''],['冬虫夏草','',''],['冬蛰','',''],['冬衣','',''],['冬装','',''],['冬训','',''],['冬运会','',''],['冬闲','',''],['冬防','',''],['冬青','',''],['冬青树','',''],['冬麦','',''],['冯内果','',''],['冯德英','',''],['冯梦龙','',''],['冯武','',''],['冯玉祥','',''],['冯窦伯','',''],['冯骥才','',''],['冰上','',''],['冰上运动','',''],['冰人','',''],['冰似','',''],['冰冷','',''],['冰冷如石','',''],['冰冻','',''],['冰冻三尺','',''],['冰冻期','',''],['冰冻食品','',''],['冰凉','',''],['冰凌','',''],['冰凝器','',''],['冰刀','',''],['冰品','',''],['冰场','',''],['冰块','',''],['冰块盒','',''],['冰坝','',''],['冰坨子','',''],['冰堆','',''],['冰堆丘','',''],['冰塔','',''],['冰塔林','',''],['冰塞','',''],['冰壑','',''],['冰壶','',''],['冰壶玉尺','',''],['冰壶秋月','',''],['冰天','',''],['冰天雪地','',''],['冰天雪窖','',''],['冰室','',''],['冰封','',''],['冰封雪冻','',''],['冰层','',''],['冰山','',''],['冰山一角','',''],['冰岛人','',''],['冰峰','',''],['冰崩','',''],['冰川','',''],['冰川带','',''],['冰川期','',''],['冰川湖','',''],['冰帽','',''],['冰床','',''],['冰库','',''],['冰心','',''],['冰排','',''],['冰散瓦解','',''],['冰晶','',''],['冰晶石','',''],['冰期','',''],['冰染染料','',''],['冰柜','',''],['冰柱','',''],['冰桥','',''],['冰桶','',''],['冰棍','',''],['冰棍儿','',''],['冰棒','',''],['冰橇','',''],['冰毒','',''],['冰水','',''],['冰沙','',''],['冰沟','',''],['冰河','',''],['冰河学','',''],['冰河时代','',''],['冰河时期','',''],['冰河期','',''],['冰洋','',''],['冰洞','',''],['冰洲石','',''],['冰消冻解','',''],['冰消冻释','',''],['冰消瓦解','',''],['冰淇淋','',''],['冰清玉洁','',''],['冰清玉润','',''],['冰激凌','',''],['冰火','',''],['冰火不容','',''],['冰灯','',''],['冰炭','',''],['冰炭不相容','',''],['冰炭不言','',''],['冰炭同炉','',''],['冰点','',''],['冰片','',''],['冰球','',''],['冰球场','',''],['冰瓶','',''],['冰皮','',''],['冰皮月饼','',''],['冰盖','',''],['冰砖','',''],['冰硬','',''],['冰硼散','',''],['冰碛','',''],['冰碴','',''],['冰积物','',''],['冰窖','',''],['冰箱','',''],['冰糕','',''],['冰糖','',''],['冰糖葫芦','',''],['冰肌玉骨','',''],['冰舌','',''],['冰船','',''],['冰花','',''],['冰蚀','',''],['冰蛋','',''],['冰袋','',''],['冰解冻释','',''],['冰车','',''],['冰轮','',''],['冰酒','',''],['冰醋酸','',''],['冰释','',''],['冰锋','',''],['冰锥','',''],['冰镇','',''],['冰镩','',''],['冰隙','',''],['冰雕','',''],['冰雪','',''],['冰雪消融','',''],['冰雪皇后','',''],['冰雪聪明','',''],['冰雹','',''],['冰霜','',''],['冰鞋','',''],['冰风暴','',''],['冰魂雪魄','',''],['冲上','',''],['冲下','',''],['冲件','',''],['冲倒','',''],['冲兑','',''],['冲入','',''],['冲冠怒发','',''],['冲冲','',''],['冲决','',''],['冲凉','',''],['冲减','',''],['冲出','',''],['冲击','',''],['冲击力','',''],['冲击声','',''],['冲击波','',''],['冲到','',''],['冲刷','',''],['冲刺','',''],['冲剂','',''],['冲力','',''],['冲动','',''],['冲劲','',''],['冲压','',''],['冲压机','',''],['冲去','',''],['冲口而出','',''],['冲口而发','',''],['冲向','',''],['冲喜','',''],['冲坏','',''],['冲坚陷阵','',''],['冲垮','',''],['冲塌','',''],['冲天','',''],['冲天炉','',''],['冲失','',''],['冲头','',''],['冲子','',''],['冲孔','',''],['冲州撞府','',''],['冲帐','',''],['冲床','',''],['冲开','',''],['冲打','',''],['冲抵','',''],['冲挡','',''],['冲挹','',''],['冲掉','',''],['冲撞','',''],['冲散','',''],['冲断','',''],['冲断层','',''],['冲昏','',''],['冲昏头脑','',''],['冲晒','',''],['冲服','',''],['冲服剂','',''],['冲杀','',''],['冲模','',''],['冲毁','',''],['冲水','',''],['冲沟','',''],['冲洗','',''],['冲流','',''],['冲浪','',''],['冲浪板','',''],['冲浪者','',''],['冲淋浴','',''],['冲淡','',''],['冲澡','',''],['冲牙器','',''],['冲犯','',''],['冲电器','',''],['冲盹儿','',''],['冲着','',''],['冲破','',''],['冲积','',''],['冲积层','',''],['冲积平原','',''],['冲积扇','',''],['冲积物','',''],['冲程','',''],['冲突','',''],['冲突地区','',''],['冲绳','',''],['冲绳县','',''],['冲绳岛','',''],['冲绳群岛','',''],['冲茶','',''],['冲要','',''],['冲调','',''],['冲账','',''],['冲走','',''],['冲越','',''],['冲转','',''],['冲过','',''],['冲进','',''],['冲退','',''],['冲量','',''],['冲销','',''],['冲锋','',''],['冲锋不止','',''],['冲锋枪','',''],['冲锋陷阵','',''],['冲龄','',''],['决一死战','',''],['决一胜负','',''],['决一雌雄','',''],['决不','',''],['决不会','',''],['决不再','',''],['决不可','',''],['决不是','',''],['决不罢休','',''],['决不能','',''],['决不食言','',''],['决于','',''],['决出','',''],['决出名次','',''],['决分','',''],['决口','',''],['决堤','',''],['决定','',''],['决定了','',''],['决定作用','',''],['决定因素','',''],['决定性','',''],['决定权','',''],['决定簇','',''],['决定论','',''],['决心','',''],['决心书','',''],['决心很大','',''],['决心要','',''],['决志','',''],['决意','',''],['决战','',''],['决撒','',''],['决斗','',''],['决斗者','',''],['决断','',''],['决断如流','',''],['决无','',''],['决明','',''],['决明子','',''],['决死','',''],['决然','',''],['决狱断刑','',''],['决疑','',''],['决疑论','',''],['决痈溃疽','',''],['决窍','',''],['决策','',''],['决策人','',''],['决策千里','',''],['决策学','',''],['决策树','',''],['决策者','',''],['决策论','',''],['决算','',''],['决绝','',''],['决而不行','',''],['决胜','',''],['决胜千里','',''],['决胜千里之外','',''],['决胜负','',''],['决裂','',''],['决要','',''],['决计','',''],['决议','',''],['决议案','',''],['决赛','',''],['决赛权','',''],['决选','',''],['决选名单','',''],['决雌雄','',''],['决非','',''],['况且','',''],['况味','',''],['冶叶倡条','',''],['冶天','',''],['冶容','',''],['冶容诲淫','',''],['冶性','',''],['冶游','',''],['冶炼','',''],['冶炼厂','',''],['冶炼炉','',''],['冶练','',''],['冶艳','',''],['冶荡','',''],['冶金','',''],['冶金学','',''],['冶金学家','',''],['冶金家','',''],['冶金工业','',''],['冶金工业部','',''],['冶金术','',''],['冶金部','',''],['冶铁','',''],['冶铸','',''],['冷丁','',''],['冷下来','',''],['冷不丁','',''],['冷不丁地','',''],['冷不防','',''],['冷丝丝','',''],['冷作','',''],['冷僻','',''],['冷光','',''],['冷兵器','',''],['冷冰','',''],['冷冰冰','',''],['冷冷','',''],['冷冷清清','',''],['冷冻','',''],['冷冻剂','',''],['冷冻库','',''],['冷冻机','',''],['冷凝','',''],['冷凝器','',''],['冷凝物','',''],['冷加工','',''],['冷却','',''],['冷却剂','',''],['冷却器','',''],['冷却塔','',''],['冷却水','',''],['冷嘲','',''],['冷嘲热讽','',''],['冷场','',''],['冷塔','',''],['冷处理','',''],['冷天','',''],['冷媒','',''],['冷子','',''],['冷子管','',''],['冷字','',''],['冷孤丁','',''],['冷官','',''],['冷宫','',''],['冷害','',''],['冷寂','',''],['冷峭','',''],['冷峻','',''],['冷布','',''],['冷床','',''],['冷库','',''],['冷待','',''],['冷得','',''],['冷感','',''],['冷战','',''],['冷战以后','',''],['冷房','',''],['冷敷','',''],['冷暖','',''],['冷暖房','',''],['冷暖自知','',''],['冷杉','',''],['冷板凳','',''],['冷枪','',''],['冷森森','',''],['冷气','',''],['冷气团','',''],['冷气机','',''],['冷气衫','',''],['冷水','',''],['冷水机组','',''],['冷水滩','',''],['冷汗','',''],['冷流','',''],['冷浸','',''],['冷浸田','',''],['冷涩','',''],['冷淡','',''],['冷淡关系','',''],['冷清','',''],['冷清清','',''],['冷湖','',''],['冷湖行政区','',''],['冷湖行政委员会','',''],['冷湿','',''],['冷漠','',''],['冷漠对待','',''],['冷灰爆豆','',''],['冷烫','',''],['冷热','',''],['冷热度数','',''],['冷热病','',''],['冷热自明','',''],['冷焊','',''],['冷然','',''],['冷煖自知','',''],['冷疗','',''],['冷的','',''],['冷盆','',''],['冷盘','',''],['冷眉冷眼','',''],['冷眼','',''],['冷眼旁观','',''],['冷眼相看','',''],['冷碟儿','',''],['冷空气','',''],['冷笑','',''],['冷箭','',''],['冷缩','',''],['冷脆','',''],['冷脸子','',''],['冷色','',''],['冷艳','',''],['冷若冰霜','',''],['冷荤','',''],['冷菜','',''],['冷落','',''],['冷藏','',''],['冷藏器','',''],['冷藏箱','',''],['冷藏车','',''],['冷藏间','',''],['冷血','',''],['冷血动物','',''],['冷觉','',''],['冷言','',''],['冷言冷语','',''],['冷言热语','',''],['冷讥热嘲','',''],['冷讽','',''],['冷话','',''],['冷语','',''],['冷语冰人','',''],['冷货','',''],['冷轧','',''],['冷透','',''],['冷遇','',''],['冷酷','',''],['冷酷无情','',''],['冷铆','',''],['冷铸','',''],['冷锋','',''],['冷门','',''],['冷霜','',''],['冷静','',''],['冷面','',''],['冷颤','',''],['冷风','',''],['冷飕飕','',''],['冷食','',''],['冷餐','',''],['冷饮','',''],['冻了','',''],['冻伤','',''],['冻住','',''],['冻僵','',''],['冻冰','',''],['冻剂','',''],['冻土','',''],['冻土层','',''],['冻坏','',''],['冻奶','',''],['冻害','',''],['冻容','',''],['冻干','',''],['冻库','',''],['冻得','',''],['冻手','',''],['冻手冻脚','',''],['冻机','',''],['冻死','',''],['冻状','',''],['冻疮','',''],['冻瘃','',''],['冻着','',''],['冻硬','',''],['冻穿','',''],['冻糕','',''],['冻结','',''],['冻肉','',''],['冻胶','',''],['冻裂','',''],['冻解冰释','',''],['冻豆腐','',''],['冻过','',''],['冻雨','',''],['冻霜','',''],['冻露','',''],['冻饿','',''],['冻馁','',''],['冻鸡','',''],['冼手','',''],['冼星海','',''],['净余','',''],['净值','',''],['净光','',''],['净利','',''],['净利润','',''],['净剩','',''],['净办','',''],['净化','',''],['净化器','',''],['净含量','',''],['净土','',''],['净土宗','',''],['净地','',''],['净增','',''],['净室','',''],['净尽','',''],['净差','',''],['净得','',''],['净心修身','',''],['净手','',''],['净损','',''],['净支','',''],['净收入','',''],['净数','',''],['净是','',''],['净本','',''],['净桶','',''],['净水','',''],['净水器','',''],['净现值','',''],['净盘将军','',''],['净空','',''],['净角','',''],['净赚','',''],['净身','',''],['净重','',''],['净量','',''],['净销','',''],['净额','',''],['净高','',''],['凄冷','',''],['凄凄','',''],['凄凉','',''],['凄切','',''],['凄厉','',''],['凄呖','',''],['凄咽','',''],['凄哀','',''],['凄婉','',''],['凄寒','',''],['凄怆','',''],['凄恻','',''],['凄惋','',''],['凄惨','',''],['凄惶','',''],['凄暗','',''],['凄梗','',''],['凄楚','',''],['凄沧','',''],['凄清','',''],['凄然','',''],['凄美','',''],['凄苍','',''],['凄苦','',''],['凄迷','',''],['凄风冷雨','',''],['凄风苦雨','',''],['凄黯','',''],['准之','',''],['准予','',''],['准件','',''],['准会','',''],['准位','',''],['准保','',''],['准假','',''],['准儿','',''],['准入','',''],['准其','',''],['准军事','',''],['准决赛','',''],['准准','',''],['准则','',''],['准噶尔','',''],['准噶尔盆地','',''],['准噶尔翼龙','',''],['准备','',''],['准备好','',''],['准备好了','',''],['准备就绪','',''],['准备工作','',''],['准备金','',''],['准头','',''],['准宝石','',''],['准将','',''],['准尉','',''],['准尺','',''],['准差','',''],['准平原','',''],['准心','',''],['准接','',''],['准收','',''],['准时','',''],['准星','',''],['准是','',''],['准有','',''],['准格尔','',''],['准格尔盆地','',''],['准没','',''],['准点','',''],['准男爵','',''],['准的','',''],['准确','',''],['准确度','',''],['准确性','',''],['准确无误','',''],['准确率','',''],['准稳旋涡结构','',''],['准线','',''],['准绳','',''],['准葛尔盆地','',''],['准规','',''],['准许','',''],['准证','',''],['准谱儿','',''],['准距','',''],['准轨','',''],['准运证','',''],['准郊外','',''],['凉了','',''],['凉亭','',''],['凉伞','',''],['凉台','',''],['凉处','',''],['凉山','',''],['凉州','',''],['凉席','',''],['凉廊','',''],['凉快','',''],['凉意','',''],['凉拌','',''],['凉拌炒鸡蛋','',''],['凉拌生菜','',''],['凉棚','',''],['凉气','',''],['凉水','',''],['凉爽','',''],['凉瓶','',''],['凉皮','',''],['凉碟','',''],['凉粉','',''],['凉茶','',''],['凉药','',''],['凉菜','',''],['凉薯','',''],['凉面','',''],['凉鞋','',''],['凉风','',''],['凉飕飕','',''],['凋敝','',''],['凋敞','',''],['凋残','',''],['凋花','',''],['凋萎','',''],['凋落','',''],['凋谢','',''],['凋零','',''],['凌乱','',''],['凌乱不堪','',''],['凌厉','',''],['凌夷','',''],['凌志','',''],['凌志美','',''],['凌杂','',''],['凌杂米盐','',''],['凌汛','',''],['凌河','',''],['凌空','',''],['凌蒙初','',''],['凌虐','',''],['凌轹','',''],['凌辱','',''],['凌迟','',''],['凌锥','',''],['凌霄花','',''],['凌驾','',''],['减为','',''],['减亏','',''],['减产','',''],['减人','',''],['减价','',''],['减份','',''],['减低','',''],['减低速度','',''],['减俸','',''],['减借','',''],['减债','',''],['减值','',''],['减免','',''],['减免税','',''],['减减','',''],['减刑','',''],['减到','',''],['减削','',''],['减劲','',''],['减半','',''],['减压','',''],['减压器','',''],['减压时间表','',''],['减压病','',''],['减压症','',''],['减压程序','',''],['减压表','',''],['减压阀','',''],['减去','',''],['减号','',''],['减员','',''],['减噪','',''],['减小','',''],['减少','',''],['减少量','',''],['减尽','',''],['减幅','',''],['减并','',''],['减弱','',''],['减息','',''],['减慢','',''],['减拨','',''],['减按','',''],['减振','',''],['减振器','',''],['减损','',''],['减掉','',''],['减排','',''],['减摩合金','',''],['减支','',''],['减收','',''],['减数','',''],['减数分裂','',''],['减料','',''],['减方','',''],['减杀','',''],['减核','',''],['减毒活疫苗','',''],['减河','',''],['减法','',''],['减灾','',''],['减盈','',''],['减省','',''],['减碳','',''],['减租','',''],['减租减息','',''],['减税','',''],['减紧','',''],['减纳','',''],['减缓','',''],['减缩','',''],['减肥','',''],['减肥法','',''],['减胖','',''],['减至','',''],['减色','',''],['减薪','',''],['减计','',''],['减负','',''],['减轻','',''],['减轻负担','',''],['减退','',''],['减速','',''],['减速伞','',''],['减速剂','',''],['减速器','',''],['减速运动','',''],['减量','',''],['减除','',''],['减震','',''],['减震器','',''],['减额','',''],['减食','',''],['凑了','',''],['凑份子','',''],['凑兴','',''],['凑出','',''],['凑到','',''],['凑合','',''],['凑巧','',''],['凑成','',''],['凑手','',''],['凑拢','',''],['凑搭','',''],['凑效','',''],['凑数','',''],['凑热','',''],['凑热闹','',''],['凑热闹儿','',''],['凑胆子','',''],['凑趣','',''],['凑趣儿','',''],['凑足','',''],['凑近','',''],['凑钱','',''],['凑集','',''],['凑齐','',''],['凛冽','',''],['凛凛','',''],['凛然','',''],['凛遵','',''],['凝为','',''],['凝乳','',''],['凝冰','',''],['凝冻','',''],['凝华','',''],['凝固','',''],['凝固剂','',''],['凝固汽油弹','',''],['凝固点','',''],['凝块','',''],['凝思','',''],['凝想','',''],['凝成','',''],['凝成块','',''],['凝望','',''],['凝汞温度','',''],['凝液','',''],['凝滞','',''],['凝灰岩','',''],['凝眸','',''],['凝神','',''],['凝练','',''],['凝结','',''],['凝结剂','',''],['凝结器','',''],['凝结水','',''],['凝结物','',''],['凝缩','',''],['凝缩器','',''],['凝聚','',''],['凝聚剂','',''],['凝聚力','',''],['凝聚层','',''],['凝聚态','',''],['凝胶','',''],['凝胶体','',''],['凝胶化','',''],['凝胶物','',''],['凝胶状','',''],['凝脂','',''],['凝花菜','',''],['凝血','',''],['凝血素','',''],['凝血脢','',''],['凝血脢原','',''],['凝血酶','',''],['凝视','',''],['凝视时间','',''],['凝视者','',''],['凝重','',''],['凝集','',''],['凝集的','',''],['凝集素','',''],['几丁','',''],['几丁质','',''],['几万','',''],['几下','',''],['几个','',''],['几个月','',''],['几乎','',''],['几乎不','',''],['几乎完全','',''],['几乎没有','',''],['几亿','',''],['几代','',''],['几代人','',''],['几件','',''],['几位','',''],['几何','',''],['几何体','',''],['几何光学','',''],['几何原本','',''],['几何图形','',''],['几何学','',''],['几何平均数','',''],['几何拓扑','',''],['几何拓扑学','',''],['几何级数','',''],['几何线','',''],['几何量','',''],['几倍','',''],['几儿','',''],['几内','',''],['几内亚人','',''],['几内亚湾','',''],['几分','',''],['几列','',''],['几十','',''],['几十亿','',''],['几十年','',''],['几十年如一日','',''],['几十年来','',''],['几千','',''],['几千年','',''],['几口','',''],['几句','',''],['几句话','',''],['几只','',''],['几可乱真','',''],['几号','',''],['几名','',''],['几周','',''],['几多','',''],['几天','',''],['几天几夜','',''],['几天来','',''],['几套','',''],['几家','',''],['几层','',''],['几岁','',''],['几希','',''],['几年','',''],['几年如一日','',''],['几年来','',''],['几度','',''],['几张','',''],['几微','',''],['几所','',''],['几支','',''],['几方面','',''],['几日','',''],['几时','',''],['几朵','',''],['几条','',''],['几架','',''],['几样','',''],['几案','',''],['几次','',''],['几次三番','',''],['几欲','',''],['几步','',''],['几滴','',''],['几点','',''],['几点了','',''],['几点钟了','',''],['几率','',''],['几番','',''],['几百','',''],['几百年','',''],['几票','',''],['几种','',''],['几笔','',''],['几米','',''],['几类','',''],['几粒','',''],['几组','',''],['几经','',''],['几经反复','',''],['几经周折','',''],['几经考虑','',''],['几维鸟','',''],['几群','',''],['几至','',''],['几许','',''],['几谏','',''],['几起','',''],['几近','',''],['几遍','',''],['几部','',''],['几部分','',''],['几间','',''],['几集','',''],['几项','',''],['凡与','',''],['凡世通','',''],['凡为','',''],['凡事','',''],['凡事总有一个开头','',''],['凡事总有开头','',''],['凡人','',''],['凡以','',''],['凡例','',''],['凡俗','',''],['凡可','',''],['凡响','',''],['凡在','',''],['凡士林','',''],['凡夫','',''],['凡夫俗子','',''],['凡将','',''],['凡尔','',''],['凡尔丁','',''],['凡尔登战役','',''],['凡尔赛','',''],['凡尔赛和约','',''],['凡尘','',''],['凡属','',''],['凡庸','',''],['凡心','',''],['凡是','',''],['凡有','',''],['凡未','',''],['凡此','',''],['凡此种种','',''],['凡用','',''],['凡百','',''],['凡立丁','',''],['凡立水','',''],['凡经','',''],['凡胎俗骨','',''],['凡胎浊骨','',''],['凡能','',''],['凡近','',''],['凡间','',''],['凡需','',''],['凡高','',''],['凤仙花','',''],['凤冠','',''],['凤凰于蜚','',''],['凤凰于飞','',''],['凤凰古城','',''],['凤凰号','',''],['凤凰城','',''],['凤凰座','',''],['凤凰木','',''],['凤凰来仪','',''],['凤友鸾交','',''],['凤头鹦鹉','',''],['凤头麦鸡','',''],['凤害','',''],['凤尾竹','',''],['凤尾鱼','',''],['凤林','',''],['凤林镇','',''],['凤梨','',''],['凤梨园','',''],['凤毛济美','',''],['凤毛麟角','',''],['凤泉','',''],['凤泊鸾飘','',''],['凤爪','',''],['凤皇','',''],['凤眼','',''],['凤眼兰','',''],['凤眼莲','',''],['凤舞龙飞','',''],['凤蝶','',''],['凤蝶科','',''],['凤雏麟子','',''],['凤髓龙肝','',''],['凤鸣朝阳','',''],['凫水','',''],['凫翁','',''],['凫茈','',''],['凫趋雀跃','',''],['凭之','',''],['凭什么','',''],['凭仗','',''],['凭以','',''],['凭依','',''],['凭信','',''],['凭倚','',''],['凭借','',''],['凭准','',''],['凭券','',''],['凭单','',''],['凭原','',''],['凭吊','',''],['凭恃','',''],['凭手画','',''],['凭据','',''],['凭条','',''],['凭柬','',''],['凭栏','',''],['凭此','',''],['凭河暴虎','',''],['凭照','',''],['凭白','',''],['凭白无故','',''],['凭眺','',''],['凭着','',''],['凭票','',''],['凭票供应','',''],['凭票入场','',''],['凭空','',''],['凭空捏造','',''],['凭经验','',''],['凭著','',''],['凭藉','',''],['凭记忆','',''],['凭证','',''],['凭轼结辙','',''],['凭险','',''],['凭陵','',''],['凭靠','',''],['凯利','',''],['凯因斯','',''],['凯尔特人','',''],['凯尼恩','',''],['凯彻','',''],['凯恩斯','',''],['凯恩斯主义','',''],['凯悦','',''],['凯撒','',''],['凯撒肋雅','',''],['凯撒酱','',''],['凯文','',''],['凯旋','',''],['凯旋式','',''],['凯旋归来','',''],['凯旋而归','',''],['凯旋门','',''],['凯林赛','',''],['凯歌','',''],['凯法劳尼亚','',''],['凯特','',''],['凯瑟琳','',''],['凯茜・弗里曼','',''],['凯达格兰','',''],['凯达格兰族','',''],['凯迪拉克','',''],['凳上','',''],['凳子','',''],['凶事','',''],['凶信','',''],['凶兆','',''],['凶光','',''],['凶党','',''],['凶化','',''],['凶器','',''],['凶多吉少','',''],['凶宅','',''],['凶岁','',''],['凶巴巴','',''],['凶年','',''],['凶年饥岁','',''],['凶徒','',''],['凶恶','',''],['凶悍','',''],['凶戾','',''],['凶手','',''],['凶暴','',''],['凶服','',''],['凶杀','',''],['凶杀案','',''],['凶极','',''],['凶横','',''],['凶死','',''],['凶残','',''],['凶殴','',''],['凶气','',''],['凶灾','',''],['凶焰','',''],['凶煞','',''],['凶犯','',''],['凶狂','',''],['凶狠','',''],['凶猛','',''],['凶相','',''],['凶相毕露','',''],['凶神','',''],['凶神恶煞','',''],['凶终隙末','',''],['凶荒','',''],['凶虐','',''],['凶讯','',''],['凶身','',''],['凶险','',''],['凶顽','',''],['凸凸','',''],['凸凹','',''],['凸出','',''],['凸出部','',''],['凸多胞形','',''],['凸多边形','',''],['凸多面体','',''],['凸嵌线','',''],['凸性','',''],['凸折线','',''],['凸显','',''],['凸版','',''],['凸版印刷','',''],['凸现','',''],['凸用','',''],['凸纹','',''],['凸线','',''],['凸缘','',''],['凸耳','',''],['凸胸','',''],['凸花','',''],['凸起','',''],['凸轮','',''],['凸轮轴','',''],['凸边','',''],['凸边角','',''],['凸透','',''],['凸透镜','',''],['凸镜','',''],['凸雕','',''],['凸面','',''],['凸面体','',''],['凸面部分','',''],['凸面镜','',''],['凹下','',''],['凹了','',''],['凹入','',''],['凹凸','',''],['凹凸不平','',''],['凹凸印刷','',''],['凹凸形','',''],['凹凸轧花','',''],['凹凸透镜','',''],['凹口','',''],['凹坑','',''],['凹处','',''],['凹岸','',''],['凹底','',''],['凹度','',''],['凹形','',''],['凹曲','',''],['凹曲面','',''],['凹朴皮','',''],['凹板','',''],['凹槽','',''],['凹洞','',''],['凹洼','',''],['凹版','',''],['凹版印刷','',''],['凹状','',''],['凹痕','',''],['凹的','',''],['凹纹','',''],['凹线','',''],['凹角','',''],['凹进','',''],['凹透','',''],['凹透镜','',''],['凹镜','',''],['凹陷','',''],['凹雕','',''],['凹面','',''],['凹面镜','',''],['出丑','',''],['出世','',''],['出世作','',''],['出丧','',''],['出主意','',''],['出乎','',''],['出乎意外','',''],['出乎意料','',''],['出乎预料','',''],['出乖弄丑','',''],['出乖露丑','',''],['出乘','',''],['出书','',''],['出买','',''],['出乱子','',''],['出了事','',''],['出事','',''],['出事地点','',''],['出于','',''],['出于公心','',''],['出于好意','',''],['出于意料','',''],['出亡','',''],['出产','',''],['出人命','',''],['出人头地','',''],['出人意外','',''],['出人意料','',''],['出人意表','',''],['出仕','',''],['出价','',''],['出价人','',''],['出任','',''],['出份子','',''],['出伏','',''],['出众','',''],['出位','',''],['出使','',''],['出倒','',''],['出借','',''],['出入','',''],['出入口','',''],['出入境','',''],['出入头地','',''],['出入将相','',''],['出入平安','',''],['出入证','',''],['出入门','',''],['出关','',''],['出兵','',''],['出其不意','',''],['出其不意攻其不备','',''],['出具','',''],['出典','',''],['出出','',''],['出击','',''],['出列','',''],['出力','',''],['出力不讨好','',''],['出动','',''],['出勤','',''],['出勤率','',''],['出包','',''],['出卖','',''],['出卖灵魂','',''],['出厂','',''],['出厂价','',''],['出厂价格','',''],['出去','',''],['出去走走','',''],['出发','',''],['出发点','',''],['出口','',''],['出口产品','',''],['出口入耳','',''],['出口创汇','',''],['出口创汇率','',''],['出口品','',''],['出口商','',''],['出口商品','',''],['出口国','',''],['出口处','',''],['出口成章','',''],['出口政策','',''],['出口气','',''],['出口调查','',''],['出口货','',''],['出口贸易','',''],['出口转内销','',''],['出口量','',''],['出口额','',''],['出台','',''],['出号','',''],['出名','',''],['出品','',''],['出品人','',''],['出售','',''],['出喽子','',''],['出国','',''],['出国深造','',''],['出国热','',''],['出国考察','',''],['出国访问','',''],['出圈','',''],['出圈儿','',''],['出土','',''],['出土文书','',''],['出土文物','',''],['出在','',''],['出地','',''],['出场','',''],['出埃及记','',''],['出城','',''],['出塞','',''],['出境','',''],['出境检查','',''],['出境证','',''],['出声','',''],['出处','',''],['出外','',''],['出外谋生','',''],['出大差','',''],['出头','',''],['出头露面','',''],['出头鸟','',''],['出奇','',''],['出奇制胜','',''],['出奔','',''],['出娄子','',''],['出嫁','',''],['出官','',''],['出家','',''],['出家人','',''],['出将入相','',''],['出尔反尔','',''],['出尖','',''],['出尖儿','',''],['出局','',''],['出山','',''],['出岔','',''],['出岔子','',''],['出巡','',''],['出工','',''],['出差','',''],['出师','',''],['出帐','',''],['出席','',''],['出席人','',''],['出席会议','',''],['出席者','',''],['出席表决比例','',''],['出库','',''],['出店','',''],['出庭','',''],['出征','',''],['出恭','',''],['出息','',''],['出戏','',''],['出战','',''],['出手','',''],['出手得卢','',''],['出招','',''],['出挑','',''],['出据','',''],['出操','',''],['出数儿','',''],['出料','',''],['出新','',''],['出月','',''],['出月子','',''],['出期','',''],['出来','',''],['出来了','',''],['出柜','',''],['出格','',''],['出楼子','',''],['出榜','',''],['出殡','',''],['出毛病','',''],['出气','',''],['出气口','',''],['出气筒','',''],['出水','',''],['出水口','',''],['出水芙蓉','',''],['出汗','',''],['出没','',''],['出没无常','',''],['出油','',''],['出法','',''],['出洋','',''],['出洋相','',''],['出洞','',''],['出活','',''],['出海','',''],['出清','',''],['出港','',''],['出港大厅','',''],['出游','',''],['出溜','',''],['出漏子','',''],['出炉','',''],['出点子','',''],['出片','',''],['出版','',''],['出版业','',''],['出版事业','',''],['出版单位','',''],['出版发行','',''],['出版品','',''],['出版商','',''],['出版学','',''],['出版工作','',''],['出版物','',''],['出版界','',''],['出版社','',''],['出版者','',''],['出版自由','',''],['出版说明','',''],['出牌','',''],['出牙期','',''],['出狱','',''],['出猎','',''],['出现','',''],['出现意外','',''],['出生','',''],['出生于','',''],['出生入死','',''],['出生前','',''],['出生后','',''],['出生地','',''],['出生地点','',''],['出生年月','',''],['出生日期','',''],['出生率','',''],['出生缺陷','',''],['出生证','',''],['出生证明','',''],['出生证明书','',''],['出界','',''],['出疹','',''],['出盘','',''],['出破','',''],['出示','',''],['出神','',''],['出神入化','',''],['出科','',''],['出租','',''],['出租人','',''],['出租司机','',''],['出租汽车','',''],['出租给','',''],['出租者','',''],['出租车','',''],['出空','',''],['出窑','',''],['出站','',''],['出端','',''],['出笼','',''],['出类拔群','',''],['出类拔萃','',''],['出类超群','',''],['出纳','',''],['出纳业务','',''],['出纳员','',''],['出线','',''],['出线权','',''],['出继','',''],['出缺','',''],['出群拔萃','',''],['出老千','',''],['出脱','',''],['出自','',''],['出自于','',''],['出自内心','',''],['出自肺腑','',''],['出臭子儿','',''],['出航','',''],['出舱','',''],['出船坞','',''],['出色','',''],['出色完成','',''],['出芽','',''],['出芽生殖','',''],['出苗','',''],['出落','',''],['出蛰','',''],['出血','',''],['出血性','',''],['出血性登革热','',''],['出血热','',''],['出血病','',''],['出行','',''],['出行者','',''],['出言','',''],['出言不逊','',''],['出言成章','',''],['出言无状','',''],['出让','',''],['出访','',''],['出诊','',''],['出谋划策','',''],['出谋献策','',''],['出谷迁乔','',''],['出货','',''],['出资','',''],['出赛','',''],['出走','',''],['出超','',''],['出路','',''],['出身','',''],['出身名门','',''],['出身好','',''],['出身微贱','',''],['出车','',''],['出轨','',''],['出辑','',''],['出迎','',''],['出逃','',''],['出道','',''],['出钱','',''],['出错','',''],['出错信息','',''],['出镜','',''],['出门','',''],['出门子','',''],['出问题','',''],['出阁','',''],['出阵','',''],['出院','',''],['出险','',''],['出难题','',''],['出露','',''],['出面','',''],['出面交涉','',''],['出鞘','',''],['出顶','',''],['出项','',''],['出题','',''],['出风口','',''],['出风头','',''],['出饭','',''],['出首','',''],['出马','',''],['出高价','',''],['出齐','',''],['击中','',''],['击中要害','',''],['击乐器','',''],['击伤','',''],['击倒','',''],['击入','',''],['击刺','',''],['击剑','',''],['击剑者','',''],['击发','',''],['击向','',''],['击坠','',''],['击垮','',''],['击壤鼓腹','',''],['击声','',''],['击弦类','',''],['击弦类乐器','',''],['击弦贝斯','',''],['击打','',''],['击掌','',''],['击撞','',''],['击昏','',''],['击楫中流','',''],['击毁','',''],['击毙','',''],['击水','',''],['击沉','',''],['击溃','',''],['击玉敲金','',''],['击球','',''],['击球员','',''],['击破','',''],['击碎','',''],['击碎唾壶','',''],['击穿','',''],['击缶','',''],['击节','',''],['击节叹赏','',''],['击节称赏','',''],['击落','',''],['击败','',''],['击赏','',''],['击退','',''],['击钟','',''],['击钟陈鼎','',''],['击钟鼎食','',''],['击键','',''],['击鼓','',''],['击鼓鸣金','',''],['凼子','',''],['凼肥','',''],['函丈','',''],['函人','',''],['函令','',''],['函件','',''],['函作','',''],['函内','',''],['函办','',''],['函发','',''],['函告','',''],['函商','',''],['函大','',''],['函子','',''],['函式库','',''],['函授','',''],['函授大学','',''],['函授学校','',''],['函授教育','',''],['函授生','',''],['函授课程','',''],['函授部','',''],['函数','',''],['函数值','',''],['函电','',''],['函盖','',''],['函索','',''],['函询','',''],['函请','',''],['函调','',''],['函谷关','',''],['函购','',''],['函送法办','',''],['函馆','',''],['凿井','',''],['凿凿','',''],['凿凿可据','',''],['凿凿有据','',''],['凿刻','',''],['凿圆枘方','',''],['凿壁偷光','',''],['凿壁悬梁','',''],['凿子','',''],['凿孔','',''],['凿山','',''],['凿岩','',''],['凿岩机','',''],['凿开','',''],['凿成','',''],['凿枘','',''],['凿沟','',''],['凿洞','',''],['凿石','',''],['凿石场','',''],['凿空','',''],['凿空指鹿','',''],['凿穿','',''],['凿船虫','',''],['凿通','',''],['凿隧道','',''],['刀伤','',''],['刀俎','',''],['刀儿','',''],['刀光','',''],['刀光剑影','',''],['刀光血影','',''],['刀兵','',''],['刀具','',''],['刀刃','',''],['刀刺','',''],['刀刺性痛','',''],['刀削面','',''],['刀剑','',''],['刀割','',''],['刀匠','',''],['刀叉','',''],['刀口','',''],['刀叶','',''],['刀子','',''],['刀子嘴','',''],['刀子嘴巴','',''],['刀尖','',''],['刀山','',''],['刀山剑树','',''],['刀山火海','',''],['刀差','',''],['刀币','',''],['刀把','',''],['刀把儿','',''],['刀斧手','',''],['刀杆','',''],['刀枪','',''],['刀枪不入','',''],['刀枪入库','',''],['刀架','',''],['刀柄','',''],['刀械','',''],['刀法','',''],['刀片','',''],['刀疤','',''],['刀痕','',''],['刀笔','',''],['刀类','',''],['刀耕火种','',''],['刀耕火耨','',''],['刀背','',''],['刀螂','',''],['刀豆','',''],['刀身','',''],['刀郎','',''],['刀郎舞','',''],['刀锋','',''],['刀锯','',''],['刀锯斧钺','',''],['刀锯鼎镬','',''],['刀闸','',''],['刀面','',''],['刀鞘','',''],['刀马旦','',''],['刀鱼','',''],['刁圆','',''],['刁妇','',''],['刁悍','',''],['刁斗','',''],['刁民','',''],['刁滑','',''],['刁藩都','',''],['刁藩都方程','',''],['刁蛮','',''],['刁钻','',''],['刁钻古怪','',''],['刁难','',''],['刁顽','',''],['刃人','',''],['刃具','',''],['刃口','',''],['刃角','',''],['分不开','',''],['分不清','',''],['分业','',''],['分为','',''],['分之','',''],['分之一','',''],['分争','',''],['分享','',''],['分付','',''],['分会','',''],['分会场','',''],['分体','',''],['分作','',''],['分值','',''],['分做','',''],['分光','',''],['分光仪','',''],['分光计','',''],['分光谱','',''],['分光镜','',''],['分克','',''],['分公司','',''],['分兵把口','',''],['分兵把守','',''],['分内','',''],['分册','',''],['分出','',''],['分出来','',''],['分分','',''],['分分秒秒','',''],['分划','',''],['分列','',''],['分列式','',''],['分则','',''],['分别','',''],['分别为','',''],['分到','',''],['分割','',''],['分割区','',''],['分割高原','',''],['分力','',''],['分办','',''],['分包','',''],['分化','',''],['分化瓦解','',''],['分区','',''],['分区制','',''],['分升','',''],['分厂','',''],['分压','',''],['分压器','',''],['分厘卡','',''],['分叉','',''],['分叉处','',''],['分发','',''],['分发者','',''],['分取','',''],['分句','',''],['分号','',''],['分各部','',''],['分合','',''],['分在','',''],['分地','',''],['分场','',''],['分块','',''],['分外','',''],['分多','',''],['分头','',''],['分娩','',''],['分子','',''],['分子力','',''],['分子化合物','',''],['分子医学','',''],['分子式','',''],['分子杂交','',''],['分子溶液','',''],['分子物理学','',''],['分子状','',''],['分子生物学','',''],['分子电流','',''],['分子病','',''],['分子筛','',''],['分子结构','',''],['分子论','',''],['分子遗传学','',''],['分子量','',''],['分字法','',''],['分家','',''],['分寄','',''],['分寸','',''],['分封','',''],['分封制','',''],['分尸','',''],['分局','',''],['分层','',''],['分居','',''],['分屏','',''],['分属','',''],['分岔','',''],['分崩','',''],['分崩离析','',''],['分巡兵备道','',''],['分工','',''],['分布','',''],['分布区','',''],['分布图','',''],['分布学','',''],['分布广','',''],['分布式','',''],['分布式发展模型','',''],['分布式拒绝服务','',''],['分布式环境','',''],['分布式结构','',''],['分布式网络','',''],['分布控制','',''],['分布电容','',''],['分布连结网络','',''],['分帐','',''],['分带','',''],['分库','',''],['分店','',''],['分度','',''],['分度器','',''],['分度规','',''],['分庭伉礼','',''],['分庭抗礼','',''],['分开','',''],['分开了','',''],['分异','',''],['分式','',''],['分式方程','',''],['分张','',''],['分当','',''],['分录','',''],['分形','',''],['分形几何','',''],['分形几何学','',''],['分得','',''],['分得开','',''],['分得清','',''],['分心','',''],['分忧','',''],['分忧解愁','',''],['分成','',''],['分我杯羹','',''],['分户','',''],['分房','',''],['分所','',''],['分手','',''],['分手代理','',''],['分批','',''],['分担','',''],['分担者','',''],['分拆','',''],['分拣','',''],['分拨','',''],['分指数','',''],['分掉','',''],['分搁','',''],['分摊','',''],['分支','',''],['分散','',''],['分散主义','',''],['分散介质','',''],['分散剂','',''],['分散器','',''],['分散度','',''],['分散式','',''],['分散染料','',''],['分散注意','',''],['分散的策略','',''],['分散相','',''],['分数','',''],['分数挂帅','',''],['分文','',''],['分文不取','',''],['分斤掰两','',''],['分斤较两','',''],['分旬','',''],['分时','',''],['分时多工','',''],['分明','',''],['分星掰两','',''],['分星擘两','',''],['分晓','',''],['分月','',''],['分期','',''],['分期付款','',''],['分期分批','',''],['分机','',''],['分权','',''],['分权制衡','',''],['分析','',''],['分析人士','',''],['分析化学','',''],['分析员','',''],['分析器','',''],['分析处理','',''],['分析学','',''],['分析家','',''],['分析师','',''],['分析心理学','',''],['分析法','',''],['分析研究','',''],['分析者','',''],['分析语','',''],['分枝','',''],['分栏','',''],['分校','',''],['分桃','',''],['分档','',''],['分步骤','',''],['分歧','',''],['分歧点','',''],['分段','',''],['分段落','',''],['分母','',''],['分比','',''],['分毫','',''],['分毫不爽','',''],['分毫之差','',''],['分水岭','',''],['分水线','',''],['分治','',''],['分泌','',''],['分泌汗','',''],['分泌液','',''],['分泌物','',''],['分泌素','',''],['分泌颗粒','',''],['分法','',''],['分波多工','',''],['分洪','',''],['分派','',''],['分流','',''],['分流电路','',''],['分浅缘悭','',''],['分浅缘薄','',''],['分润','',''],['分清','',''],['分清敌我','',''],['分清是非','',''],['分灶','',''],['分点','',''],['分爨','',''],['分片','',''],['分片包干','',''],['分班','',''],['分理','',''],['分理处','',''],['分甘共苦','',''],['分生孢子','',''],['分生组织','',''],['分界','',''],['分界符','',''],['分界线','',''],['分相','',''],['分省','',''],['分社','',''],['分神','',''],['分离','',''],['分离主义','',''],['分离出','',''],['分离分子','',''],['分离器','',''],['分离性','',''],['分科','',''],['分秒','',''],['分秒必争','',''],['分租','',''],['分税','',''],['分税制','',''],['分立','',''],['分站','',''],['分等','',''],['分等级','',''],['分算','',''],['分管','',''],['分米','',''],['分米波','',''],['分类上','',''],['分类器','',''],['分类学','',''],['分类帐','',''],['分类汇总','',''],['分类法','',''],['分类理论','',''],['分类者','',''],['分类账','',''],['分粒器','',''],['分系统','',''],['分红','',''],['分级','',''],['分级分类','',''],['分线','',''],['分线规','',''],['分组','',''],['分组交换','',''],['分组会','',''],['分组循环','',''],['分组循环赛','',''],['分组赛','',''],['分给','',''],['分群','',''],['分而治之','',''],['分肥','',''],['分脏','',''],['分至点','',''],['分色','',''],['分色镜','',''],['分色镜头','',''],['分节','',''],['分节音','',''],['分节驳船队','',''],['分茅列土','',''],['分茅胙土','',''],['分获','',''],['分葱','',''],['分薄缘悭','',''],['分蘖','',''],['分蘖期','',''],['分蜜','',''],['分行','',''],['分表','',''],['分袂','',''],['分裂','',''],['分裂主义','',''],['分裂生殖','',''],['分裂组织','',''],['分装','',''],['分装机','',''],['分规','',''],['分角器','',''],['分解','',''],['分解代谢','',''],['分解作用','',''],['分解力','',''],['分解者','',''],['分论','',''],['分设','',''],['分词','',''],['#分词器','',''],['分说','',''],['分谴','',''],['分贝','',''],['分账','',''],['分赃','',''],['分赴','',''],['分路','',''],['分路扬镳','',''],['分身','',''],['分身术','',''],['分轨','',''],['分辨','',''],['分辨不清','',''],['分辨出','',''],['分辨率','',''],['分辩','',''],['分辩率','',''],['分进合击','',''],['分述','',''],['分送','',''],['分选','',''],['分途','',''],['分道','',''],['分道扬镳','',''],['分遣','',''],['分遣队','',''],['分部','',''],['分配','',''],['分配人','',''],['分配器','',''],['分配律','',''],['分配权','',''],['分配者','',''],['分配阀','',''],['分野','',''],['分量','',''],['分针','',''],['分钗断带','',''],['分钟','',''],['分钱','',''],['分销','',''],['分销店','',''],['分销网络','',''],['分门','',''],['分门别户','',''],['分门别类','',''],['分队','',''],['分阴','',''],['分阶','',''],['分阶段','',''],['分际','',''],['分院','',''],['分隔','',''],['分隔栏','',''],['分隔符','',''],['分音','',''],['分音符','',''],['分页','',''],['分项','',''],['分频','',''],['分餐','',''],['分馏','',''],['分馏塔','',''],['分馏法','',''],['分香卖履','',''],['切下','',''],['切不','',''],['切不可','',''],['切中','',''],['切中时弊','',''],['切中时病','',''],['切中要害','',''],['切入','',''],['切分','',''],['切分信息','',''],['切分法','',''],['切分音','',''],['切切','',''],['切切实实','',''],['切切私语','',''],['切削','',''],['切削面','',''],['切割','',''],['切割机','',''],['切割物','',''],['切力','',''],['切勿','',''],['切去','',''],['切变','',''],['切变线','',''],['切口','',''],['切合','',''],['切合实际','',''],['切向','',''],['切向力','',''],['切向速度','',''],['切向量','',''],['切嘱','',''],['切圆','',''],['切块','',''],['切实','',''],['切实可行','',''],['切尔西','',''],['切尔诺贝利','',''],['切尼','',''],['切屑','',''],['切平面','',''],['切开','',''],['切当','',''],['切忌','',''],['切成','',''],['切成丝','',''],['切成块','',''],['切换','',''],['切掉','',''],['切断','',''],['切断者','',''],['切望','',''],['切末','',''],['切杆','',''],['切根虫','',''],['切激','',''],['切点','',''],['切片','',''],['切片机','',''],['切片检查','',''],['切牙','',''],['切特豪斯学校','',''],['切痛','',''],['切盼','',''],['切石术','',''],['切碎','',''],['切碎器','',''],['切磋','',''],['切磋琢磨','',''],['切空间','',''],['切纸','',''],['切线','',''],['切细','',''],['切结书','',''],['切肉','',''],['切肉刀','',''],['切肤','',''],['切肤之痛','',''],['切脉','',''],['切腹','',''],['切草','',''],['切莫','',''],['切菜','',''],['切菜刀','',''],['切要','',''],['切角','',''],['切角面','',''],['切触','',''],['切记','',''],['切诊','',''],['切责','',''],['切起','',''],['切距','',''],['切身','',''],['切身利益','',''],['切达','',''],['切近','',''],['切迫','',''],['切送','',''],['切除','',''],['切除术','',''],['切面','',''],['切音','',''],['切题','',''],['切骨之仇','',''],['切齿','',''],['切齿咬牙','',''],['切齿拊心','',''],['切齿痛恨','',''],['切齿腐心','',''],['刈包','',''],['刈羽','',''],['刊入','',''],['刊出','',''],['刊刻','',''],['刊印','',''],['刊发','',''],['刊号','',''],['刊后语','',''],['刊在','',''],['刊大','',''],['刊头','',''],['刊布','',''],['刊授','',''],['刊本','',''],['刊正','',''],['刊物','',''],['刊登','',''],['刊落','',''],['刊行','',''],['刊词','',''],['刊误','',''],['刊误表','',''],['刊载','',''],['刊首语','',''],['刍秣','',''],['刍粮','',''],['刍荛','',''],['刍议','',''],['刍豢','',''],['刎颈','',''],['刎颈之交','',''],['刎颈至交','',''],['刑书','',''],['刑事','',''],['刑事上','',''],['刑事侦察','',''],['刑事处分','',''],['刑事审判庭','',''],['刑事局','',''],['刑事拘留','',''],['刑事法','',''],['刑事法庭','',''],['刑事法院','',''],['刑事犯','',''],['刑事犯罪','',''],['刑事犯罪分子','',''],['刑事警察局','',''],['刑事诉讼法','',''],['刑事责任','',''],['刑人','',''],['刑令','',''],['刑侦','',''],['刑具','',''],['刑典','',''],['刑名','',''],['刑名之学','',''],['刑吏','',''],['刑场','',''],['刑堂','',''],['刑天','',''],['刑学','',''],['刑庭','',''],['刑律','',''],['刑戮','',''],['刑房','',''],['刑措不用','',''],['刑期','',''],['刑案','',''],['刑求','',''],['刑法','',''],['刑法学','',''],['刑满','',''],['刑网','',''],['刑罚','',''],['刑罚学','',''],['刑舂','',''],['刑警','',''],['刑警队','',''],['刑讯','',''],['刑诉法','',''],['刑辱','',''],['刑部','',''],['划一','',''],['划一不二','',''],['划上','',''],['划不来','',''],['划为','',''],['划价','',''],['划伤','',''],['划入','',''],['划出','',''],['划出划入','',''],['划分','',''],['划划','',''],['划动','',''],['划去','',''],['划回','',''],['划圆防守','',''],['划地为牢','',''],['划子','',''],['划定','',''],['划帐','',''],['划底线','',''],['划开','',''],['划归','',''],['划得','',''],['划得来','',''],['划成','',''],['划手','',''],['划抵','',''],['划拉','',''],['划拨','',''],['划拳','',''],['划掉','',''],['划时代','',''],['划板','',''],['划格线','',''],['划框框','',''],['划桨','',''],['划横线','',''],['划款','',''],['划水','',''],['划法','',''],['划浆','',''],['划清','',''],['划清界限','',''],['划渡','',''],['划点','',''],['划燃','',''],['划片','',''],['划独','',''],['划界','',''],['划界限','',''],['划痕','',''],['划着','',''],['划破','',''],['划等号','',''],['划策','',''],['划算','',''],['划粉','',''],['划线','',''],['划线人','',''],['划线板','',''],['划给','',''],['划船','',''],['划艇','',''],['划花','',''],['划行','',''],['划解','',''],['划记号','',''],['划转','',''],['划过','',''],['划进','',''],['划选','',''],['划销','',''],['列中','',''],['列为','',''],['列举','',''],['列于','',''],['列传','',''],['列位','',''],['列克星顿','',''],['列入','',''],['列兵','',''],['列出','',''],['列列','',''],['列别杰夫','',''],['列前','',''],['列印','',''],['列名','',''],['列国','',''],['列土分茅','',''],['列土封疆','',''],['列块','',''],['列夫・托尔斯泰','',''],['列女','',''],['列子','',''],['列宁','',''],['列宁主义','',''],['列宁格勒','',''],['列宗','',''],['列宽','',''],['列岛','',''],['列帐','',''],['列席','',''],['列席代表','',''],['列席会议','',''],['列式','',''],['列强','',''],['列当','',''],['列成','',''],['列成表','',''],['列报','',''],['列拱','',''],['列支','',''],['列数','',''],['列明','',''],['列星','',''],['列有','',''],['列柜','',''],['列橱','',''],['列次','',''],['列氏温度计','',''],['列氏温标','',''],['列治文','',''],['列法','',''],['列王纪上','',''],['列王纪下','',''],['列王记上','',''],['列王记下','',''],['列示','',''],['列祖','',''],['列线','',''],['列缺','',''],['列缺霹雳','',''],['列表','',''],['列计','',''],['列记','',''],['列车','',''],['列车员','',''],['列车长','',''],['列队','',''],['列阵','',''],['列项','',''],['列鼎而食','',''],['刘云山','',''],['刘伯温','',''],['刘光第','',''],['刘公岛','',''],['刘剑峰','',''],['刘厚总','',''],['刘基','',''],['刘备','',''],['刘天华','',''],['刘奭','',''],['刘姥姥进大观园','',''],['刘安','',''],['刘宋','',''],['刘宋时代','',''],['刘宠刘宸起义','',''],['刘家夼','',''],['刘家夼镇','',''],['刘家村','',''],['刘家辉','',''],['刘宾雁','',''],['刘少奇','',''],['刘德华','',''],['刘心武','',''],['刘恒','',''],['刘昫','',''],['刘晓波','',''],['刘毅','',''],['刘洋','',''],['刘海','',''],['刘海儿','',''],['刘涓子','',''],['刘涓子鬼遗方','',''],['刘渊','',''],['刘熙','',''],['刘禅','',''],['刘禹锡','',''],['刘翔','',''],['刘表','',''],['刘裕','',''],['刘贵今','',''],['刘邦','',''],['刘金宝','',''],['刘青云','',''],['刘鹗','',''],['则个','',''],['则为','',''],['则从','',''],['则以','',''],['则否','',''],['则在','',''],['则声','',''],['则安之','',''],['则应','',''],['则废','',''],['则必有我师','',''],['则怎','',''],['则指','',''],['则是','',''],['则有','',''],['则步隆','',''],['则甚','',''],['则用','',''],['则由','',''],['则要','',''],['则辣黑','',''],['则需','',''],['刚一','',''],['刚从','',''],['刚体','',''],['刚体转动','',''],['刚健','',''],['刚入','',''],['刚出巢','',''],['刚出炉','',''],['刚出现','',''],['刚出生','',''],['刚刚','',''],['刚到','',''],['刚劲','',''],['刚勇','',''],['刚好','',''],['刚巧','',''],['刚度','',''],['刚开始','',''],['刚强','',''],['刚性','',''],['刚愎','',''],['刚愎自用','',''],['刚戾自用','',''],['刚才','',''],['刚来','',''],['刚果','',''],['刚果人','',''],['刚果河','',''],['刚果红','',''],['刚架','',''],['刚柔','',''],['刚柔并济','',''],['刚柔相济','',''],['刚正','',''],['刚正不阿','',''],['刚毅','',''],['刚毅木讷','',''],['刚毛','',''],['刚烈','',''],['刚玉','',''],['刚生下','',''],['刚直','',''],['刚直不阿','',''],['刚石','',''],['刚砂','',''],['刚硬','',''],['刚离','',''],['刚褊自用','',''],['刚要','',''],['刚过','',''],['刚过去','',''],['刚钻','',''],['刚键','',''],['创一流','',''],['创下','',''],['创下高票房','',''],['创世','',''],['创世纪','',''],['创世记','',''],['创世论','',''],['创业','',''],['创业史','',''],['创业垂统','',''],['创业投资','',''],['创业板上市','',''],['创业精神','',''],['创业者','',''],['创举','',''],['创价学会','',''],['创优','',''],['创伤','',''],['创伤后','',''],['创伤后压力','',''],['创伤后压力紊乱','',''],['创作','',''],['创作部','',''],['创作室','',''],['创作人','',''],['创作员','',''],['创作力','',''],['创作思想','',''],['创作方法','',''],['创作经验','',''],['创作者','',''],['创作自由','',''],['创刊','',''],['创刊号','',''],['创利','',''],['创利税','',''],['创制','',''],['创制者','',''],['创办','',''],['创办人','',''],['创办者','',''],['创历','',''],['创历史最高水平','',''],['创历史最高纪录','',''],['创口','',''],['创可贴','',''],['创域','',''],['创始','',''],['创始人','',''],['创始者','',''],['创巨痛深','',''],['创建','',''],['创建组','',''],['创建者','',''],['创性','',''],['创意','',''],['创投基金','',''],['创收','',''],['创效','',''],['创新','',''],['创新精神','',''],['创新纪录','',''],['创新者','',''],['创汇','',''],['创汇额','',''],['创牌子','',''],['创痕','',''],['创痛','',''],['创立','',''],['创立人','',''],['创立者','',''],['创纪录','',''],['创获','',''],['创见','',''],['创见性','',''],['创议','',''],['创记录','',''],['创设','',''],['创造','',''],['创造力','',''],['创造学','',''],['创造性','',''],['创造条件','',''],['创造物','',''],['创造社','',''],['创造者','',''],['创造论','',''],['创面','',''],['初上','',''],['初丧','',''],['初中','',''],['初中生','',''],['初为','',''],['初亏','',''],['初交','',''],['初产','',''],['初伏','',''],['初估','',''],['初值','',''],['初具','',''],['初具规模','',''],['初写黄庭','',''],['初冬','',''],['初出','',''],['初出茅庐','',''],['初创','',''],['初创公司','',''],['初刻拍案惊奇','',''],['初加工','',''],['初升','',''],['初叶','',''],['初唐','',''],['初声','',''],['初夏','',''],['初头','',''],['初始','',''],['初始化','',''],['初婚','',''],['初学','',''],['初学者','',''],['初审','',''],['初小','',''],['初年','',''],['初度','',''],['初建','',''],['初开','',''],['初态','',''],['初恋','',''],['初恋感觉','',''],['初愿','',''],['初战','',''],['初战告捷','',''],['初探','',''],['初旬','',''],['初时','',''],['初映','',''],['初春','',''],['初更','',''],['初期','',''],['初来乍到','',''],['初查','',''],['初校','',''],['初次','',''],['初次用','',''],['初步','',''],['初步设想','',''],['初民','',''],['初演','',''],['初潮','',''],['初版','',''],['初犯','',''],['初现','',''],['初生','',''],['初生之犊','',''],['初生之犊不怕虎','',''],['初生之犊不畏虎','',''],['初生态','',''],['初生牛犊不怕虎','',''],['初看','',''],['初秋','',''],['初稿','',''],['初等','',''],['初等代数','',''],['初等教育','',''],['初等数学','',''],['初算','',''],['初级','',''],['初级中学','',''],['初级产品','',''],['初级小学','',''],['初级班','',''],['初级社','',''],['初级线圈','',''],['初级职称','',''],['初级读本','',''],['初级阶段','',''],['初纺','',''],['初衷','',''],['初见','',''],['初见成效','',''],['初设','',''],['初访','',''],['初评','',''],['初诊','',''],['初试','',''],['初试身手','',''],['初读','',''],['初赛','',''],['初进','',''],['初选','',''],['初速','',''],['初雪','',''],['初露','',''],['初露头角','',''],['初露才华','',''],['初露锋芒','',''],['删减','',''],['删削','',''],['删剪','',''],['删去','',''],['删掉','',''],['删改','',''],['删汰','',''],['删略','',''],['删简压缩','',''],['删繁就简','',''],['删节','',''],['删节号','',''],['删节本','',''],['删芜就简','',''],['删除','',''],['判上','',''],['判令','',''],['判优器','',''],['判例','',''],['判决','',''],['判决书','',''],['判决日','',''],['判刑','',''],['判别','',''],['判别式','',''],['判处','',''],['判官','',''],['判定','',''],['判据','',''],['判断','',''],['判断力','',''],['判断句','',''],['判断能力','',''],['判明','',''],['判明是非','',''],['判案','',''],['判然','',''],['判给','',''],['判罪','',''],['判若','',''],['判若两人','',''],['判若云泥','',''],['判若天渊','',''],['判若水火','',''],['判若鸿沟','',''],['判若黑白','',''],['判袂','',''],['判词','',''],['判读','',''],['判赔','',''],['判输','',''],['刨冰','',''],['刨刀','',''],['刨圆','',''],['刨子','',''],['刨工','',''],['刨平','',''],['刨床','',''],['刨根','',''],['刨根儿','',''],['刨根问底','',''],['刨根问底儿','',''],['刨片','',''],['刨程','',''],['刨花','',''],['刨花板','',''],['刨齿','',''],['利乐包','',''],['利事','',''],['利于','',''],['利人','',''],['利什曼原虫','',''],['利他','',''],['利他主义','',''],['利他林','',''],['利他灵','',''],['利他能','',''],['利他行为','',''],['利令智昏','',''],['利伯曼','',''],['利伯维尔','',''],['利兹','',''],['利刃','',''],['利剑','',''],['利勒哈默尔','',''],['利口捷给','',''],['利口酒','',''],['利古里亚','',''],['利嗦','',''],['利嘴','',''],['利器','',''],['利国','',''],['利国利民','',''],['利基','',''],['利多','',''],['利多弊少','',''],['利好','',''],['利害','',''],['利害关系','',''],['利害关系人','',''],['利害关系方','',''],['利害冲突','',''],['利害攸关','',''],['利宾纳','',''],['利导','',''],['利尔','',''],['利尿','',''],['利尿剂','',''],['利差','',''],['利己','',''],['利己主义','',''],['利己癖','',''],['利市','',''],['利市三倍','',''],['利弊','',''],['利得','',''],['利得税','',''],['利息','',''],['利息率','',''],['利手','',''],['利改税','',''],['利时','',''],['利是','',''],['利未记','',''],['利权','',''],['利析秋毫','',''],['利欲','',''],['利欲心','',''],['利欲熏心','',''],['利比利亚','',''],['利民','',''],['利派','',''],['利润','',''],['利润率','',''],['利润留成','',''],['利爪','',''],['利物浦','',''],['利率','',''],['利玛窦','',''],['利用','',''],['利用人工吹气','',''],['利用率','',''],['利用系数','',''],['利益','',''],['利益集团','',''],['利眠','',''],['利眠宁','',''],['利眼','',''],['利禄','',''],['利禄薰心','',''],['利税','',''],['利税分流','',''],['利空','',''],['利索','',''],['利纳克斯','',''],['利缰名锁','',''],['利者','',''],['利落','',''],['利语','',''],['利诱','',''],['利贴','',''],['利钱','',''],['利锁名牵','',''],['利锁名缰','',''],['利隆圭','',''],['利雅得','',''],['利马','',''],['利马窦','',''],['利马索尔','',''],['利默里克','',''],['利齿','',''],['利齿伶牙','',''],['利齿能牙','',''],['别个','',''],['别了','',''],['别人','',''],['别传','',''],['别住','',''],['别做','',''],['别傻了','',''],['别克','',''],['别具一格','',''],['别具匠心','',''],['别具只眼','',''],['别具炉锤','',''],['别具特色','',''],['别再','',''],['别出心裁','',''],['别出机杼','',''],['别别扭扭','',''],['别动','',''],['别动队','',''],['别去','',''],['别史','',''],['别号','',''],['别名','',''],['别后','',''],['别吵','',''],['别哭','',''],['别喊','',''],['别嘴','',''],['别国','',''],['别在','',''],['别地','',''],['别墅','',''],['别处','',''],['别太客气','',''],['别子','',''],['别字','',''],['别客气','',''],['别开','',''],['别开生面','',''],['别式','',''],['别心','',''],['别急','',''],['别恋','',''],['别愁离恨','',''],['别意','',''],['别打扰我','',''],['别扣','',''],['别扭','',''],['别扯','',''],['别把','',''],['别择','',''],['别提','',''],['别提了','',''],['别无','',''],['别无二致','',''],['别无他法','',''],['别无他物','',''],['别无他用','',''],['别无出路','',''],['别无所求','',''],['别无选择','',''],['别无长物','',''],['别是','',''],['别有','',''],['别有天地','',''],['别有洞天','',''],['别有用心','',''],['别有肺肠','',''],['别有韵味','',''],['别有风味','',''],['别来无恙','',''],['别树一帜','',''],['别树一旗','',''],['别样','',''],['别法','',''],['别犯傻','',''],['别理','',''],['别用','',''],['别的','',''],['别看','',''],['别着急','',''],['别离','',''],['别称','',''],['别筵','',''],['别管','',''],['别类','',''],['别紧','',''],['别紧张','',''],['别绪','',''],['别耽搁','',''],['别胡说了','',''],['别胡闹','',''],['别脸','',''],['别致','',''],['别论','',''],['别词','',''],['别说','',''],['别赫捷列夫','',''],['别走','',''],['别辞','',''],['别针','',''],['别集','',''],['别风淮雨','',''],['别骂','',''],['别鹤孤鸾','',''],['别鹤离鸾','',''],['刮伤','',''],['刮光','',''],['刮出','',''],['刮刀','',''],['刮刮','',''],['刮刮卡','',''],['刮刮叫','',''],['刮削','',''],['刮勺','',''],['刮匙','',''],['刮去','',''],['刮在','',''],['刮地皮','',''],['刮垢磨光','',''],['刮大风','',''],['刮宫','',''],['刮平','',''],['刮弧','',''],['刮得','',''],['刮打扁儿','',''],['刮掉','',''],['刮毛','',''],['刮痧','',''],['刮皮','',''],['刮皮刀','',''],['刮目','',''],['刮目相待','',''],['刮目相看','',''],['刮目相视','',''],['刮破','',''],['刮肠洗胃','',''],['刮胡刀','',''],['刮胡子','',''],['刮脸','',''],['刮脸皮','',''],['刮舌','',''],['刮舌子','',''],['刮起','',''],['刮过','',''],['刮钱','',''],['刮铲','',''],['刮除','',''],['刮风','',''],['刮风下雨','',''],['刮骨','',''],['刮骨刀','',''],['刮鼻子','',''],['到一起','',''],['到上面','',''],['到下','',''],['到不行','',''],['到中途','',''],['到之','',''],['到了','',''],['到了儿','',''],['到人','',''],['到今','',''],['到今天为止','',''],['到任','',''],['到会','',''],['到位','',''],['到国外','',''],['到场','',''],['到处','',''],['到处可见','',''],['到头','',''],['到头来','',''],['到家','',''],['到尾','',''],['到岸','',''],['到岸价','',''],['到差','',''],['到底','',''],['到庭','',''],['到户','',''],['到手','',''],['到手软','',''],['到数','',''],['到旁边','',''],['到时','',''],['到时候','',''],['到时候再说','',''],['到有','',''],['到期','',''],['到期收益率','',''],['到期日','',''],['到本世纪末','',''],['到来','',''],['到某处','',''],['到校','',''],['到案','',''],['到此','',''],['到此为止','',''],['到此处','',''],['到港','',''],['到点','',''],['到现在','',''],['到现在为止','',''],['到目前','',''],['到目前为止','',''],['到站','',''],['到群众中去','',''],['到者','',''],['到职','',''],['到自','',''],['到访','',''],['到货','',''],['到达','',''],['到达大厅','',''],['到达站','',''],['到达者','',''],['到过','',''],['到这','',''],['到那','',''],['到那个时候','',''],['到那里','',''],['到顶','',''],['到齐','',''],['制件','',''],['制伏','',''],['制住','',''],['制作','',''],['制作人','',''],['制作商','',''],['制作所','',''],['制作者','',''],['制假','',''],['制做','',''],['制冰','',''],['制冷','',''],['制冷剂','',''],['制冷器','',''],['制冷机','',''],['制剂','',''],['制动','',''],['制动器','',''],['制动机','',''],['制动踏板','',''],['制动闸','',''],['制单','',''],['制取','',''],['制品','',''],['制售','',''],['制图','',''],['制图人','',''],['制图员','',''],['制图学','',''],['制图法','',''],['制备','',''],['制定','',''],['制宪','',''],['制宪会议','',''],['制导','',''],['制导技术','',''],['制导武器','',''],['制币','',''],['制度','',''],['制度上','',''],['制度化','',''],['制式','',''],['制式化','',''],['制式教练','',''],['制得','',''],['制成','',''],['制成品','',''],['制成皮','',''],['制敌','',''],['制景','',''],['制服','',''],['制服呢','',''],['制板机','',''],['制止','',''],['制止动乱','',''],['制止物','',''],['制止者','',''],['制气','',''],['制法','',''],['制海权','',''],['制热','',''],['制片','',''],['制片人','',''],['制片厂','',''],['制版','',''],['制盐','',''],['制程','',''],['制空','',''],['制空权','',''],['制糖','',''],['制糖厂','',''],['制约','',''],['制约力','',''],['制胜','',''],['制胜因素','',''],['制艺','',''],['制药','',''],['制药业','',''],['制药企业','',''],['制药厂','',''],['制药者','',''],['制衡','',''],['制霸','',''],['制衣','',''],['制表','',''],['制表业','',''],['制表符','',''],['制表键','',''],['制裁','',''],['制订','',''],['制造','',''],['制造业','',''],['制造业者','',''],['制造厂','',''],['制造品','',''],['制造商','',''],['制造学','',''],['制造所','',''],['制造者','',''],['制钉者','',''],['制钱','',''],['制门器','',''],['制陶','',''],['制陶工人','',''],['制革','',''],['制革厂','',''],['制鞋','',''],['制鞋匠','',''],['制鞋工人','',''],['制高点','',''],['制黄','',''],['制黄贩黄','',''],['刷上','',''],['刷写','',''],['刷卡','',''],['刷卡机','',''],['刷去','',''],['刷子','',''],['刷拉','',''],['刷新','',''],['刷新纪录','',''],['刷机','',''],['刷洗','',''],['刷漆','',''],['刷爆','',''],['刷牙','',''],['刷白','',''],['刷磅','',''],['刷色','',''],['券别','',''],['券商','',''],['券种','',''],['券面','',''],['刹不住','',''],['刹住','',''],['刹把','',''],['刹时','',''],['刹车','',''],['刹车灯','',''],['刹那','',''],['刹那间','',''],['刺丛','',''],['刺丝囊','',''],['刺丝胞','',''],['刺丝胞动物','',''],['刺中','',''],['刺五加','',''],['刺人','',''],['刺伤','',''],['刺住','',''],['刺儿','',''],['刺儿头','',''],['刺儿李','',''],['刺儿菜','',''],['刺儿话','',''],['刺入','',''],['刺出','',''],['刺刀','',''],['刺刑','',''],['刺刺','',''],['刺刺不休','',''],['刺参','',''],['刺取','',''],['刺史','',''],['刺孔','',''],['刺字','',''],['刺客','',''],['刺开','',''],['刺戟','',''],['刺戳','',''],['刺挠','',''],['刺捕','',''],['刺探','',''],['刺探者','',''],['刺杀','',''],['刺柏','',''],['刺桐','',''],['刺棱','',''],['刺槐','',''],['刺死','',''],['刺毛辊','',''],['刺溜','',''],['刺激','',''],['刺激剂','',''],['刺激启动不同步','',''],['刺激性','',''],['刺激性毒剂','',''],['刺激物','',''],['刺激素','',''],['刺激者','',''],['刺猬','',''],['刺画','',''],['刺痒','',''],['刺痕','',''],['刺痛','',''],['刺目','',''],['刺眼','',''],['刺破','',''],['刺穿','',''],['刺绣','',''],['刺绣品','',''],['刺网','',''],['刺耳','',''],['刺股','',''],['刺股悬梁','',''],['刺胞','',''],['刺胞动物','',''],['刺芹菇','',''],['刺苋','',''],['刺身','',''],['刺进','',''],['刺透','',''],['刺配','',''],['刺针','',''],['刺钢丝','',''],['刺青','',''],['刺骨','',''],['刺骨悬梁','',''],['刺鼻','',''],['刻上','',''],['刻下','',''],['刻不容缓','',''],['刻丝','',''],['刻为','',''],['刻了','',''],['刻于','',''],['刻其','',''],['刻写','',''],['刻出','',''],['刻刀','',''],['刻划','',''],['刻制','',''],['刻印','',''],['刻在','',''],['刻字','',''],['刻度','',''],['刻度尺','',''],['刻度盘','',''],['刻录','',''],['刻录机','',''],['刻意','',''],['刻意为之','',''],['刻意求工','',''],['刻成','',''],['刻有','',''],['刻木为吏','',''],['刻本','',''],['刻板','',''],['刻板印象','',''],['刻毒','',''],['刻版','',''],['刻版印刷','',''],['刻物','',''],['刻画','',''],['刻画无盐','',''],['刻痕','',''],['刻纹','',''],['刻线','',''],['刻细','',''],['刻肌刻骨','',''],['刻舟','',''],['刻舟求剑','',''],['刻苦','',''],['刻苦努力','',''],['刻苦学习','',''],['刻苦耐劳','',''],['刻苦自励','',''],['刻苦钻研','',''],['刻薄','',''],['刻薄话','',''],['刻蚀','',''],['刻记','',''],['刻足适屦','',''],['刻钟','',''],['刻骨','',''],['刻骨相思','',''],['刻骨铭心','',''],['刻骨镂心','',''],['刻鹄类鹜','',''],['刽子手','',''],['剀切','',''],['剁斧石','',''],['剁碎','',''],['剁者','',''],['剂型','',''],['剂子','',''],['剂量','',''],['剂量学','',''],['剂量当量','',''],['剂量效应','',''],['剂量监控','',''],['剂量监督','',''],['剃光','',''],['剃光头','',''],['剃刀','',''],['剃刀鲸','',''],['剃发','',''],['剃发令','',''],['剃发留辫','',''],['剃头','',''],['剃度','',''],['剃掉','',''],['剃枝虫','',''],['剃着','',''],['剃胡刀','',''],['剃须','',''],['剃须刀','',''],['剃须膏','',''],['削下','',''],['削价','',''],['削减','',''],['削击','',''],['削刮','',''],['削去','',''],['削发','',''],['削壁','',''],['削尖','',''],['削平','',''],['削弱','',''],['削成','',''],['削打','',''],['削掉','',''],['削整','',''],['削方为圆','',''],['削木为吏','',''],['削水','',''],['削球','',''],['削皮','',''],['削皮器','',''],['削磨','',''],['削籍','',''],['削职','',''],['削职为民','',''],['削薄','',''],['削薄片','',''],['削角','',''],['削觚为圆','',''],['削足适履','',''],['削趾适屦','',''],['削铁如泥','',''],['削铅笔机','',''],['削除','',''],['削除者','',''],['削面','',''],['剌柏','',''],['剌破','',''],['剌细胞','',''],['剌谬','',''],['前一','',''],['前一刻','',''],['前一向','',''],['前一天','',''],['前一年','',''],['前一段','',''],['前一段时间','',''],['前三名','',''],['前不久','',''],['前不见古人','',''],['前世','',''],['前世姻缘','',''],['前事','',''],['前事不忘','',''],['前事不忘后事之师','',''],['前些','',''],['前些天','',''],['前些年','',''],['前些时候','',''],['前人','',''],['前人栽树','',''],['前人栽树后任乘凉','',''],['前仆后继','',''],['前仆后起','',''],['前仇','',''],['前代','',''],['前仰后合','',''],['前件','',''],['前任','',''],['前任者','',''],['前传','',''],['前体','',''],['前作','',''],['前例','',''],['前信号灯','',''],['前俯后仰','',''],['前倒','',''],['前倨后卑','',''],['前倨后恭','',''],['前倾','',''],['前儿','',''],['前元音','',''],['前兆','',''],['前冠','',''],['前凉','',''],['前几天','',''],['前几年','',''],['前列','',''],['前列腺','',''],['前列腺炎','',''],['前列腺素','',''],['前前后后','',''],['前功','',''],['前功尽弃','',''],['前功尽灭','',''],['前半场','',''],['前半夜','',''],['前半天','',''],['前半天儿','',''],['前半晌','',''],['前半晌儿','',''],['前半部','',''],['前卫','',''],['前卫战','',''],['前厅','',''],['前去','',''],['前台','',''],['前史','',''],['前同','',''],['前后','',''],['前后左右','',''],['前后文','',''],['前后矛盾','',''],['前向拥塞通知','',''],['前呼','',''],['前呼后仰','',''],['前呼后偃','',''],['前呼后拥','',''],['前咽','',''],['前哨','',''],['前哨战','',''],['前哨阵地','',''],['前因','',''],['前因后果','',''],['前场','',''],['前坡','',''],['前堂','',''],['前处','',''],['前夕','',''],['前夜','',''],['前大灯','',''],['前夫','',''],['前头','',''],['前奏','',''],['前奏曲','',''],['前妻','',''],['前委','',''],['前嫌','',''],['前寒','',''],['前寒武纪','',''],['前导','',''],['前尘','',''],['前尘影事','',''],['前层','',''],['前屈','',''],['前岸','',''],['前度刘郎','',''],['前庭','',''],['前庭窗','',''],['前廊','',''],['前往','',''],['前怕狼','',''],['前怕狼后怕虎','',''],['前思后想','',''],['前总理','',''],['前总统','',''],['前情','',''],['前愆','',''],['前意识','',''],['前戏','',''],['前房','',''],['前房角','',''],['前所','',''],['前所未有','',''],['前所未有的','',''],['前所未见','',''],['前所未闻','',''],['前排','',''],['前掠翼','',''],['前推','',''],['前提','',''],['前提下','',''],['前提条件','',''],['前揭','',''],['前摆','',''],['前政府','',''],['前敌','',''],['前文','',''],['前方','',''],['前旋肌','',''],['前无','',''],['前无古人','',''],['前无古人后无来者','',''],['前日','',''],['前晌','',''],['前晚','',''],['前景','',''],['前景可期','',''],['前月','',''],['前有','',''],['前朝','',''],['前期','',''],['前条','',''],['前来','',''],['前松后紧','',''],['前柱式','',''],['前桅','',''],['前桥','',''],['前次','',''],['前款','',''],['前歌后舞','',''],['前此','',''],['前殉后继','',''],['前段','',''],['前段时间','',''],['前汉','',''],['前汉书','',''],['前沿','',''],['前清后欠','',''],['前滚翻','',''],['前滩','',''],['前灯','',''],['前燕','',''],['前片','',''],['前生','',''],['前生冤孽','',''],['前生召唤','',''],['前甲板','',''],['前看','',''],['前瞻','',''],['前瞻性','',''],['前磨齿','',''],['前科','',''],['前科犯','',''],['前秦','',''],['前程','',''],['前程万里','',''],['前程远大','',''],['前空翻','',''],['前站','',''],['前端','',''],['前紧后松','',''],['前线','',''],['前缀','',''],['前缘未了','',''],['前置','',''],['前置词','',''],['前翅','',''],['前者','',''],['前肢','',''],['前胸','',''],['前脑','',''],['前脚','',''],['前腿','',''],['前臂','',''],['前臼齿','',''],['前舞台','',''],['前舱','',''],['前苏联','',''],['前茅','',''],['前行','',''],['前襟','',''],['前言','',''],['前言不搭后语','',''],['前词典语音加工','',''],['前词汇加工','',''],['前词汇语音加工','',''],['前词汇阶段','',''],['前贤','',''],['前走','',''],['前赴后继','',''],['前赵','',''],['前足','',''],['前跑','',''],['前蹄','',''],['前身','',''],['前车','',''],['前车主','',''],['前车之覆','',''],['前车之鉴','',''],['前车可鉴','',''],['前转','',''],['前轮','',''],['前轴','',''],['前辈','',''],['前辍','',''],['前边','',''],['前边儿','',''],['前进','',''],['前述','',''],['前途','',''],['前途广阔','',''],['前途无量','',''],['前途未卜','',''],['前途渺茫','',''],['前遮后拥','',''],['前部','',''],['前部皮层下损伤','',''],['前郭县','',''],['前郭镇','',''],['前金','',''],['前金区','',''],['前锋','',''],['前锯肌','',''],['前镇','',''],['前镇区','',''],['前门','',''],['前门打虎','',''],['前门拒虎','',''],['前门拒虎后门进狼','',''],['前院','',''],['前震','',''],['前面','',''],['前项','',''],['前题','',''],['前额','',''],['前首相','',''],['前驱','',''],['前驱性','',''],['前鼻音','',''],['前齿','',''],['前齿龈','',''],['剑侠','',''],['剑光','',''],['剑兰','',''],['剑客','',''],['剑尖','',''],['剑形','',''],['剑影逃形','',''],['剑怨求媚','',''],['剑手','',''],['剑手待毙','',''],['剑拔弩张','',''],['剑拔驽张','',''],['剑术','',''],['剑术师','',''],['剑柄','',''],['剑树刀山','',''],['剑桥','',''],['剑桥大学','',''],['剑桥郡','',''],['剑气','',''],['剑法','',''],['剑状','',''],['剑眉','',''],['剑胆琴心','',''],['剑走偏锋','',''],['剑走蜻蛉','',''],['剑身','',''],['剑道','',''],['剑鞘','',''],['剑鱼座','',''],['剑麻','',''],['剑齿虎','',''],['剑齿象','',''],['剑龙','',''],['剔出','',''],['剔去','',''],['剔庄货','',''],['剔牙','',''],['剔红','',''],['剔蝎撩蜂','',''],['剔透','',''],['剔除','',''],['剔骨','',''],['剖决如流','',''],['剖宫产','',''],['剖宫产手术','',''],['剖开','',''],['剖心析肝','',''],['剖心沥肝','',''],['剖明','',''],['剖析','',''],['剖析器','',''],['剖比','',''],['剖白','',''],['剖肝沥胆','',''],['剖腹','',''],['剖腹产','',''],['剖腹产手术','',''],['剖腹术','',''],['剖腹自杀','',''],['剖腹藏珠','',''],['剖视','',''],['剖视图','',''],['剖解','',''],['剖辩','',''],['剖释','',''],['剖面','',''],['剖面图','',''],['剜肉补疮','',''],['剞劂','',''],['剥下','',''],['剥光','',''],['剥出','',''],['剥削','',''],['剥削制度','',''],['剥削者','',''],['剥削阶级','',''],['剥剥','',''],['剥去','',''],['剥啄','',''],['剥壳','',''],['剥夺','',''],['剥夺人权','',''],['剥夺政治权利终身','',''],['剥开','',''],['剥掉','',''],['剥皮','',''],['剥皮器','',''],['剥离','',''],['剥肤椎髓','',''],['剥脱','',''],['剥脱性皮炎','',''],['剥落','',''],['剥蚀','',''],['剥采比','',''],['剥除','',''],['剧中','',''],['剧中人','',''],['剧体','',''],['剧作','',''],['剧作家','',''],['剧减','',''],['剧务','',''],['剧协','',''],['剧变','',''],['剧团','',''],['剧场','',''],['剧坛','',''],['剧增','',''],['剧情','',''],['剧挫','',''],['剧曲','',''],['剧本','',''],['剧本稿','',''],['剧校','',''],['剧毒','',''],['剧烈','',''],['剧照','',''],['剧痛','',''],['剧的','',''],['剧目','',''],['剧社','',''],['剧种','',''],['剧组','',''],['剧终','',''],['剧评','',''],['剧跌','',''],['剧跳','',''],['剧透','',''],['剧里','',''],['剧院','',''],['剩下','',''],['剩余','',''],['剩余产品','',''],['剩余价值','',''],['剩余价值率','',''],['剩余价值规律','',''],['剩余劳力','',''],['剩余劳动','',''],['剩余劳动力','',''],['剩余定理','',''],['剩余放射性','',''],['剩余物','',''],['剩余辐射','',''],['剩女','',''],['剩料','',''],['剩水残山','',''],['剩物','',''],['剩磁','',''],['剩菜','',''],['剩词','',''],['剩货','',''],['剩遗','',''],['剩钱','',''],['剩饭','',''],['剪䌽','',''],['剪下','',''],['剪修','',''],['剪出','',''],['剪刀','',''],['剪刀差','',''],['剪切','',''],['剪切力','',''],['剪切块','',''],['剪切形变','',''],['剪切板','',''],['剪力','',''],['剪去','',''],['剪发','',''],['剪取','',''],['剪头发','',''],['剪子','',''],['剪字','',''],['剪床','',''],['剪应力','',''],['剪开','',''],['剪彩','',''],['剪影','',''],['剪径','',''],['剪恶除奸','',''],['剪成','',''],['剪报','',''],['剪掉','',''],['剪接','',''],['剪断','',''],['剪枝','',''],['剪枝竭流','',''],['剪毛','',''],['剪毛机','',''],['剪烛西窗','',''],['剪画','',''],['剪着','',''],['剪短','',''],['剪砍','',''],['剪票','',''],['剪秋萝','',''],['剪纸','',''],['剪纸片','',''],['剪纸片儿','',''],['剪羊','',''],['剪羊毛','',''],['剪草','',''],['剪草机','',''],['剪草除根','',''],['剪裁','',''],['剪贴','',''],['剪贴板','',''],['剪贴簿','',''],['剪辑','',''],['剪过','',''],['剪除','',''],['剪须和药','',''],['剪齐','',''],['副业','',''],['副主任','',''],['副主席','',''],['副主教','',''],['副主祭','',''],['副主管','',''],['副主编','',''],['副书记','',''],['副井','',''],['副交感神经','',''],['副产','',''],['副产品','',''],['副产物','',''],['副代表','',''],['副件','',''],['副伤寒','',''],['副作用','',''],['副修','',''],['副关节','',''],['副净','',''],['副刊','',''],['副医师','',''],['副印','',''],['副厅长','',''],['副县长','',''],['副参谋长','',''],['副反应','',''],['副司令','',''],['副司令员','',''],['副司长','',''],['副品','',''],['副团长','',''],['副国务卿','',''],['副地级市','',''],['副堂','',''],['副处长','',''],['副外长','',''],['副委员','',''],['副委员长','',''],['副官','',''],['副官职','',''],['副审','',''],['副将','',''],['副局长','',''],['副州长','',''],['副市长','',''],['副性征','',''],['副总','',''],['副总参谋长','',''],['副总工程师','',''],['副总理','',''],['副总督','',''],['副总经理','',''],['副总统','',''],['副总编','',''],['副总编辑','',''],['副总裁','',''],['副手','',''],['副执事','',''],['副教授','',''],['副族元素','',''],['副本','',''],['副标','',''],['副标题','',''],['副校长','',''],['副歌','',''],['副法向量','',''],['副热带','',''],['副热带高压','',''],['副理事长','',''],['副甲','',''],['副监督','',''],['副相','',''],['副省级','',''],['副省级城市','',''],['副省长','',''],['副研','',''],['副研究员','',''],['副社长','',''],['副神经','',''],['副科长','',''],['副秘书长','',''],['副站长','',''],['副线','',''],['副线圈','',''],['副组长','',''],['副经理','',''],['副编审','',''],['副署','',''],['副翼','',''],['副职','',''],['副联','',''],['副肾','',''],['副药','',''],['副虹','',''],['副议长','',''],['副证','',''],['副词','',''],['副译审','',''],['副郡长','',''],['副部长','',''],['副院长','',''],['副领事','',''],['副题','',''],['副食','',''],['副食品','',''],['副馆长','',''],['副驾驶','',''],['副驾驶员','',''],['副黏液病毒','',''],['割下','',''],['割伤','',''],['割切','',''],['割包皮','',''],['割去','',''],['割取','',''],['割地','',''],['割席','',''],['割席分坐','',''],['割开','',''],['割息','',''],['割据','',''],['割掉','',''],['割接','',''],['割接法','',''],['割断','',''],['割法','',''],['割爱','',''],['割痕','',''],['割破','',''],['割碎','',''],['割礼','',''],['割离','',''],['割稻','',''],['割线','',''],['割绒','',''],['割肚牵肠','',''],['割股','',''],['割胶','',''],['割腱术','',''],['割臂盟公','',''],['割舍','',''],['割草','',''],['割草机','',''],['割蜜','',''],['割袍断义','',''],['割裂','',''],['割让','',''],['割除','',''],['割颈','',''],['割鸡焉用牛刀','',''],['割麦','',''],['剽原','',''],['剽取','',''],['剽悍','',''],['剽窃','',''],['剽窃者','',''],['剿共','',''],['剿匪','',''],['剿灭','',''],['剿袭','',''],['剿说','',''],['剿除','',''],['劈刀','',''],['劈刺','',''],['劈叉','',''],['劈啪','',''],['劈天盖地','',''],['劈头','',''],['劈头盖脸','',''],['劈山','',''],['劈开','',''],['劈得开','',''],['劈情操','',''],['劈手','',''],['劈拍','',''],['劈拍声','',''],['劈挂拳','',''],['劈柴','',''],['劈死','',''],['劈波斩浪','',''],['劈痕','',''],['劈砍','',''],['劈离','',''],['劈空扳害','',''],['劈胸','',''],['劈脸','',''],['劈腿','',''],['劈裂','',''],['劈里啪啦','',''],['劈面','',''],['劈风斩浪','',''],['劓刑','',''],['力不从心','',''],['力不从愿','',''],['力不副心','',''],['力不同科','',''],['力不自胜','',''],['力不足','',''],['力主','',''],['力争','',''],['力争上游','',''],['力传递','',''],['力作','',''],['力促','',''],['力保','',''],['力倍功半','',''],['力做','',''],['力偶','',''],['力克','',''],['力分势弱','',''],['力创','',''],['力劝','',''],['力及','',''],['力困筋乏','',''],['力图','',''],['力场','',''],['力均势敌','',''],['力士','',''],['力大无比','',''],['力大无穷','',''],['力学','',''],['力学传递','',''],['力学波','',''],['力学笃行','',''],['力宝','',''],['力尽','',''],['力尽神危','',''],['力尽筋疲','',''],['力屈势穷','',''],['力屈计穷','',''],['力屈道穷','',''],['力差','',''],['力巴','',''],['力度','',''],['力弱','',''],['力强','',''],['力征','',''],['力微','',''],['力微任重','',''],['力心','',''],['力感','',''],['力戒','',''],['力战','',''],['力所能及','',''],['力拓','',''],['力持','',''],['力挫','',''],['力挫群雄','',''],['力挺','',''],['力挽狂澜','',''],['力捧','',''],['力排','',''],['力排众议','',''],['力攻','',''],['力敌万夫','',''],['力敌势均','',''],['力殚财竭','',''],['力气','',''],['力气活','',''],['力求','',''],['力波','',''],['力派','',''],['力济九区','',''],['力点','',''],['力畜','',''],['力矩','',''],['力竭','',''],['力竭声嘶','',''],['力系','',''],['力臂','',''],['力荐','',''],['力薄才疏','',''],['力行','',''],['力行近乎仁','',''],['力衰','',''],['力解','',''],['力谋','',''],['力足以做','',''],['力距','',''],['力蹙势穷','',''],['力透纸背','',''],['力道','',''],['力避','',''],['力量','',''],['力量均衡','',''],['力量大','',''],['力量对比','',''],['力钱','',''],['力阻','',''],['力陈','',''],['劝业场','',''],['劝人','',''],['劝住','',''],['劝农','',''],['劝农使','',''],['劝动','',''],['劝勉','',''],['劝募','',''],['劝化','',''],['劝告','',''],['劝告者','',''],['劝和','',''],['劝善','',''],['劝善惩恶','',''],['劝善戒恶','',''],['劝善黜恶','',''],['劝学','',''],['劝导','',''],['劝得','',''],['劝慰','',''],['劝戒','',''],['劝教','',''],['劝服','',''],['劝架','',''],['劝止','',''],['劝百讽一','',''],['劝解','',''],['劝解者','',''],['劝诫','',''],['劝诱','',''],['劝说','',''],['劝说者','',''],['劝课','',''],['劝谏','',''],['劝进','',''],['劝退','',''],['劝酒','',''],['劝阻','',''],['劝降','',''],['劝驾','',''],['办不到','',''],['办不成','',''],['办事','',''],['办事员','',''],['办事处','',''],['办事效率','',''],['办事机构','',''],['办公','',''],['办公会议','',''],['办公厅','',''],['办公地址','',''],['办公处','',''],['办公大楼','',''],['办公室','',''],['办公时间','',''],['办公桌','',''],['办公桌轮用','',''],['办公楼','',''],['办公用品','',''],['办公自动化','',''],['办公设备','',''],['办公费','',''],['办几件实事','',''],['办到','',''],['办厂','',''],['办好','',''],['办妥','',''],['办学','',''],['办学条件','',''],['办完','',''],['办实事','',''],['办差','',''],['办得到','',''],['办得成','',''],['办成','',''],['办报','',''],['办文','',''],['办案','',''],['办法','',''],['办班','',''],['办理','',''],['办矿','',''],['办税','',''],['办稿','',''],['办罪','',''],['办证','',''],['办货','',''],['办起','',''],['办错','',''],['办错事','',''],['功不可没','',''],['功业','',''],['功于','',''],['功亏一篑','',''],['功亏一蒉','',''],['功令','',''],['功利','',''],['功利主义','',''],['功到自然成','',''],['功力','',''],['功力深湛','',''],['功劳','',''],['功勋','',''],['功同赏异','',''],['功名','',''],['功名利禄','',''],['功均天地','',''],['功堕垂成','',''],['功大于过','',''],['功夫','',''],['功夫球','',''],['功夫茶','',''],['功完行满','',''],['功就名成','',''],['功底','',''],['功德','',''],['功德圆满','',''],['功德无量','',''],['功成不居','',''],['功成名就','',''],['功成名立','',''],['功成名遂','',''],['功成行满','',''],['功成身退','',''],['功放','',''],['功效','',''],['功烈','',''],['功狗功人','',''],['功率','',''],['功率因数','',''],['功率恶化','',''],['功率输出','',''],['功用','',''],['功绩','',''],['功罪','',''],['功耗','',''],['功能','',''],['功能上','',''],['功能团','',''],['功能性','',''],['功能模块','',''],['功能磁共振成像术','',''],['功能群','',''],['功能表','',''],['功能词','',''],['功能键','',''],['功能集','',''],['功臣','',''],['功课','',''],['功败垂成','',''],['功过','',''],['功遂身退','',''],['功高不赏','',''],['功高望重','',''],['功高绩著','',''],['加上','',''],['加下','',''],['加下标','',''],['加之','',''],['加了','',''],['加于','',''],['加些','',''],['加亮','',''],['加人一等','',''],['加仑','',''],['加仑量','',''],['加付','',''],['加以','',''],['加以分析','',''],['加以改进','',''],['加以解决','',''],['加价','',''],['加俸','',''],['加倍','',''],['加倍大','',''],['加值','',''],['加值型网路','',''],['加入','',''],['加入者','',''],['加兹尼','',''],['加兹尼省','',''],['加冕','',''],['加农','',''],['加农榴弹炮','',''],['加农炮','',''],['加冠','',''],['加冰','',''],['加冰块','',''],['加减','',''],['加减乘除','',''],['加减号','',''],['加减法','',''],['加刑','',''],['加删','',''],['加利利','',''],['加利福尼亚','',''],['加利福尼亚大学','',''],['加利福尼亚大学洛杉矶分校','',''],['加利福尼亚州','',''],['加利福尼亚理工学院','',''],['加利肋亚','',''],['加利西亚','',''],['加到','',''],['加前缀','',''],['加剧','',''],['加力','',''],['加加','',''],['加加林','',''],['加劲','',''],['加劲儿','',''],['加勒比','',''],['加勒比人','',''],['加勒比国家联盟','',''],['加勒比海','',''],['加印','',''],['加压','',''],['加压釜','',''],['加厚','',''],['加号','',''],['加号码','',''],['加吉鱼','',''],['加固','',''],['加国','',''],['加在','',''],['加在一起','',''],['加塞','',''],['加塞儿','',''],['加增','',''],['加外框','',''],['加多','',''],['加大','',''],['加大力度','',''],['加大努力','',''],['加大油门','',''],['加央','',''],['加套','',''],['加委','',''],['加官','',''],['加官晋爵','',''],['加官晋级','',''],['加官进位','',''],['加官进爵','',''],['加官进禄','',''],['加害','',''],['加害于','',''],['加宽','',''],['加密','',''],['加密后的','',''],['加密套接字协议层','',''],['加封','',''],['加封官阶','',''],['加尔各答','',''],['加尔文','',''],['加尾词','',''],['加州','',''],['加州大学','',''],['加州技术学院','',''],['加州理工学院','',''],['加工','',''],['加工业','',''],['加工厂','',''],['加工工业','',''],['加工成本','',''],['加工效率','',''],['加工时序','',''],['加工贸易','',''],['加座','',''],['加引号','',''],['加强','',''],['加强团结','',''],['加强管制','',''],['加强管理','',''],['加征','',''],['加德士','',''],['加德满都','',''],['加德纳','',''],['加德西','',''],['加快','',''],['加急','',''],['加急电报','',''],['加总','',''],['加息','',''],['加意','',''],['加成','',''],['加成反应','',''],['加护','',''],['加拉加斯','',''],['加拉太书','',''],['加拉巴哥斯','',''],['加拉巴哥斯群岛','',''],['加拉帕戈斯群岛','',''],['加拉罕','',''],['加括号','',''],['加拿大人','',''],['加拿大太平洋铁路','',''],['加拿大皇家','',''],['加拿大皇家海军','',''],['加收','',''],['加数','',''],['加料','',''],['加时','',''],['加星号','',''],['加有','',''],['加权','',''],['加权平均','',''],['加来','',''],['加来海峡','',''],['加枝添叶','',''],['加标签','',''],['加标记','',''],['加格达奇','',''],['加格达奇区','',''],['加框','',''],['加气','',''],['加气水泥','',''],['加氢','',''],['加氢油','',''],['加水','',''],['加沙','',''],['加沙地带','',''],['加油','',''],['加油器','',''],['加油工','',''],['加油添醋','',''],['加油站','',''],['加法','',''],['加法器','',''],['加注','',''],['加泰罗尼亚','',''],['加洗','',''],['加派','',''],['加润','',''],['加深','',''],['加深印象','',''],['加深理解','',''],['加添','',''],['加温','',''],['加湿器','',''],['加满','',''],['加演','',''],['加点','',''],['加热','',''],['加热器','',''],['加热炉','',''],['加煤','',''],['加物','',''],['加特林','',''],['加特林机枪','',''],['加班','',''],['加班加点','',''],['加班费','',''],['加甜','',''],['加百列','',''],['加的夫','',''],['加的斯','',''],['加盐','',''],['加盖','',''],['加盖于','',''],['加盟','',''],['加盟共和国','',''],['加盟者','',''],['加码','',''],['加税','',''],['加答儿','',''],['加粗','',''],['加糖','',''],['加紧','',''],['加级鱼','',''],['加纳人','',''],['加练','',''],['加给','',''],['加罗林群岛','',''],['加罚','',''],['加罪','',''],['加聚反应','',''],['加膝坠渊','',''],['加航','',''],['加色','',''],['加药物','',''],['加菜','',''],['加菲猫','',''],['加蓬人','',''],['加薪','',''],['加藤','',''],['加衬垫','',''],['加装','',''],['加西亚','',''],['加记','',''],['加试','',''],['加课','',''],['加赛','',''],['加足','',''],['加足马力','',''],['加车','',''],['加载','',''],['加载项','',''],['加达里','',''],['加进','',''],['加速','',''],['加速仪','',''],['加速剂','',''],['加速器','',''],['加速度','',''],['加速档','',''],['加速者','',''],['加速踏板','',''],['加速运动','',''],['加酒','',''],['加醋','',''],['加里','',''],['加里宁格勒','',''],['加里宁格勒州','',''],['加里曼丹','',''],['加里曼丹岛','',''],['加里波第','',''],['加里肋亚','',''],['加里肋亚海','',''],['加重','',''],['加重语气','',''],['加锁','',''],['加锁链','',''],['加长','',''],['加长型','',''],['加鞭','',''],['加餐','',''],['加高','',''],['务使','',''],['务公','',''],['务农','',''],['务商','',''],['务实','',''],['务实去华','',''],['务尽','',''],['务川','',''],['务川县','',''],['务川自治县','',''],['务工','',''],['务当','',''],['务必','',''],['务时','',''],['务期','',''],['务本','',''],['务本力穑','',''],['务本抑末','',''],['务正','',''],['务求','',''],['务派','',''],['务生','',''],['务虚','',''],['务请','',''],['务须','',''],['劣作','',''],['劣势','',''],['劣品','',''],['劣地','',''],['劣学生','',''],['劣币驱逐良币','',''],['劣弧','',''],['劣株','',''],['劣根性','',''],['劣汰','',''],['劣画','',''],['劣种','',''],['劣等','',''],['劣等纸','',''],['劣绅','',''],['劣者','',''],['劣行','',''],['劣诗','',''],['劣货','',''],['劣质','',''],['劣质品','',''],['劣迹','',''],['劣迹斑斑','',''],['劣迹昭著','',''],['劣酒','',''],['劣马','',''],['动不动','',''],['动之以情','',''],['动乱','',''],['动了','',''],['动产','',''],['动人','',''],['动人心弦','',''],['动人心魄','',''],['动众','',''],['动作','',''],['动作学','',''],['动作片','',''],['动兵','',''],['动刑','',''],['动力','',''],['动力化','',''],['动力反应堆','',''],['动力学','',''],['动力室','',''],['动力机','',''],['动力系统','',''],['动力计','',''],['动动','',''],['动劲儿','',''],['动势','',''],['动口','',''],['动名词','',''],['动向','',''],['动听','',''],['动员','',''],['动员令','',''],['动员会','',''],['动员大会','',''],['动员群众','',''],['动嘴','',''],['动嘴皮','',''],['动嘴皮儿','',''],['动嘴皮子','',''],['动因','',''],['动土','',''],['动地惊天','',''],['动如参商','',''],['动如脱兔','',''],['动容','',''],['动宾','',''],['动宾式','',''],['动工','',''],['动平衡','',''],['动弹','',''],['动弹不得','',''],['动心','',''],['动心娱目','',''],['动心忍性','',''],['动心怵目','',''],['动心骇目','',''],['动念','',''],['动态','',''],['动态助词','',''],['动态图形','',''],['动态存储器','',''],['动态平衡','',''],['动态影像','',''],['动态更新','',''],['动态网页','',''],['动态规划','',''],['动态链接库','',''],['动怒','',''],['动悟','',''],['动情','',''],['动情期','',''],['动情激素','',''],['动情素','',''],['动感','',''],['动手','',''],['动手动脚','',''],['动手术','',''],['动手脚','',''],['动换','',''],['动摇','',''],['动支','',''],['动机','',''],['动植物','',''],['动植物分类','',''],['动武','',''],['动气','',''],['动滑轮','',''],['动漫','',''],['动火','',''],['动点','',''],['动物','',''],['动物似','',''],['动物农场','',''],['动物分类','',''],['动物化','',''],['动物园','',''],['动物学','',''],['动物庄园','',''],['动物志','',''],['动物性','',''],['动物性名词','',''],['动物性饲料','',''],['动物所','',''],['动物极','',''],['动物毒素','',''],['动物油','',''],['动物淀粉','',''],['动物界','',''],['动物病','',''],['动物纤维','',''],['动物脂肪','',''],['动用','',''],['动电学','',''],['动画','',''],['动画影片','',''],['动画片','',''],['动画片儿','',''],['动眼神经','',''],['动着','',''],['动笔','',''],['动粗','',''],['动肝火','',''],['动能','',''],['动能车','',''],['动脉','',''],['动脉弓','',''],['动脉炎','',''],['动脉状','',''],['动脉瘤','',''],['动脉硬化','',''],['动脉粥样硬化','',''],['动脉血','',''],['动脉输血','',''],['动脑','',''],['动脑筋','',''],['动荡','',''],['动荡不安','',''],['动见观瞻','',''],['动觉','',''],['动议','',''],['动词','',''],['动词化','',''],['动词结构','',''],['动词重叠','',''],['动身','',''],['动车','',''],['动转','',''],['动轮','',''],['动辄','',''],['动辄得咎','',''],['动量','',''],['动量守恒定律','',''],['动量矩','',''],['动量词','',''],['动问','',''],['动静','',''],['动魄','',''],['动魄惊心','',''],['助于','',''],['助产','',''],['助产士','',''],['助产术','',''],['助人','',''],['助人为乐','',''],['助人为快乐之本','',''],['助作','',''],['助兴','',''],['助剂','',''],['助力','',''],['助动词','',''],['助动车','',''],['助听','',''],['助听器','',''],['助员','',''],['助咳','',''],['助威','',''],['助学','',''],['助学贷款','',''],['助学金','',''],['助工','',''],['助帆','',''],['助您','',''],['助成','',''],['助我','',''],['助我张目','',''],['助战','',''],['助手','',''],['助手席','',''],['助推器','',''],['助攻','',''],['助教','',''],['助桀为虐','',''],['助残','',''],['助消化','',''],['助熔剂','',''],['助燃','',''],['助理','',''],['助理员','',''],['助理工程师','',''],['助益','',''],['助研','',''],['助纣为虐','',''],['助编','',''],['助航','',''],['助记方法','',''],['助记符','',''],['助词','',''],['助跑','',''],['助选','',''],['助选活动','',''],['助长','',''],['助阵','',''],['助飞','',''],['助飞器','',''],['助餐','',''],['努出','',''],['努力','',''],['努力以赴','',''],['努努嘴','',''],['努劲儿','',''],['努嘴','',''],['努嘴儿','',''],['努尔哈赤','',''],['努比亚','',''],['努牙突嘴','',''],['努瓦克肖特','',''],['努纳武特','',''],['努责','',''],['劫九回断','',''],['劫九回肠','',''],['劫余','',''],['劫出','',''],['劫匪','',''],['劫去','',''],['劫取','',''],['劫后','',''],['劫后余生','',''],['劫后重逢','',''],['劫囚','',''],['劫夺','',''],['劫富','',''],['劫富济贫','',''],['劫寨','',''],['劫持','',''],['劫持犯','',''],['劫持者','',''],['劫掠','',''],['劫数','',''],['劫数难逃','',''],['劫机','',''],['劫机者','',''],['劫杀','',''],['劫案','',''],['劫波','',''],['劫洗','',''],['劫狱','',''],['劫盗','',''],['劫者','',''],['劫船','',''],['劫获','',''],['劫营','',''],['劫走','',''],['劫车','',''],['劫道','',''],['劫难','',''],['劬劳','',''],['励志','',''],['励志哥','',''],['励磁','',''],['励精图治','',''],['励精求治','',''],['励行','',''],['劲儿','',''],['劲力','',''],['劲卒','',''],['劲吹','',''],['劲地','',''],['劲头','',''],['劲射','',''],['劲峭','',''],['劲度系数','',''],['劲急','',''],['劲打','',''],['劲拉','',''],['劲拔','',''],['劲挺','',''],['劲敌','',''],['劲旅','',''],['劲松','',''],['劲烈','',''],['劲直','',''],['劲草','',''],['劲风','',''],['劲骨丰肌','',''],['劳乏','',''],['劳什子','',''],['劳伤','',''],['劳伦斯','',''],['劳作','',''],['劳保','',''],['劳保用品','',''],['劳做','',''],['劳军','',''],['劳力','',''],['劳力士','',''],['劳务','',''],['劳务市场','',''],['劳务费','',''],['劳动','',''],['劳动二重性','',''],['劳动人民','',''],['劳动价值论','',''],['劳动保护','',''],['劳动保险','',''],['劳动党','',''],['劳动制','',''],['劳动力','',''],['劳动力价值','',''],['劳动力商品','',''],['劳动号','',''],['劳动合同','',''],['劳动定额','',''],['劳动对象','',''],['劳动局','',''],['劳动强度','',''],['劳动手段','',''],['劳动报','',''],['劳动改造','',''],['劳动教养','',''],['劳动新闻','',''],['劳动日','',''],['劳动权','',''],['劳动模范','',''],['劳动法','',''],['劳动生产力','',''],['劳动生产率','',''],['劳动纪律','',''],['劳动者','',''],['劳动能力','',''],['劳动致富','',''],['劳动营','',''],['劳动解放社','',''],['劳动资料','',''],['劳动部','',''],['劳动量','',''],['劳劳碌碌','',''],['劳埃德','',''],['劳多得','',''],['劳委会','',''],['劳工','',''],['劳工党','',''],['劳工法','',''],['劳师','',''],['劳师动众','',''],['劳师袭远','',''],['劳役','',''],['劳役地租','',''],['劳心','',''],['劳心劳力','',''],['劳心焦思','',''],['劳心苦思','',''],['劳拉西泮','',''],['劳支','',''],['劳改','',''],['劳改营','',''],['劳教','',''],['劳教所','',''],['劳斯莱斯','',''],['劳方','',''],['劳模','',''],['劳步','',''],['劳民','',''],['劳民伤财','',''],['劳烦','',''],['劳燕分飞','',''],['劳瘁','',''],['劳碌','',''],['劳神','',''],['劳累','',''],['劳累过度','',''],['劳绩','',''],['劳而无功','',''],['劳而无获','',''],['劳苦','',''],['劳苦功高','',''],['劳苦大众','',''],['劳资','',''],['劳资关系','',''],['劳资双方','',''],['劳资科','',''],['劳资纠纷','',''],['劳身焦思','',''],['劳逊','',''],['劳逸','',''],['劳逸结合','',''],['劳金','',''],['劳雇','',''],['劳雇关系','',''],['劳顿','',''],['劳驾','',''],['势不两存','',''],['势不两立','',''],['势不力敌','',''],['势不可当','',''],['势不可挡','',''],['势众','',''],['势倾朝野','',''],['势划','',''],['势利','',''],['势利小人','',''],['势利眼','',''],['势利言行','',''],['势利鬼','',''],['势力','',''],['势力范围','',''],['势合形离','',''],['势图','',''],['势在','',''],['势在必得','',''],['势在必行','',''],['势均','',''],['势均力敌','',''],['势头','',''],['势如破竹','',''],['势子','',''],['势将','',''],['势必','',''],['势态','',''],['势成骑虎','',''],['势所必然','',''],['势族','',''],['势无反顾','',''],['势殊事异','',''],['势治','',''],['势派','',''],['势焰','',''],['势穷力极','',''],['势穷力竭','',''],['势能','',''],['势要','',''],['势阱','',''],['势降','',''],['势难两全','',''],['势面','',''],['势高益危','',''],['勃兰登堡','',''],['勃兴','',''],['勃列日涅夫','',''],['勃勃','',''],['勃勃生机','',''],['勃发','',''],['勃固','',''],['勃固山脉','',''],['勃固河','',''],['勃拉姆斯','',''],['勃朗宁','',''],['勃海','',''],['勃然','',''],['勃然变色','',''],['勃然大怒','',''],['勃艮第','',''],['勃起','',''],['勃郎宁','',''],['勇为','',''],['勇于','',''],['勇冠三军','',''],['勇冲','',''],['勇决','',''],['勇力','',''],['勇动多怨','',''],['勇士','',''],['勇夫悍卒','',''],['勇夺','',''],['勇往','',''],['勇往直前','',''],['勇悍','',''],['勇挑','',''],['勇挑重担','',''],['勇攀高峰','',''],['勇救','',''],['勇敢','',''],['勇斗歹徒','',''],['勇武','',''],['勇气','',''],['勇猛','',''],['勇猛果敢','',''],['勇猛直前','',''],['勇猛精进','',''],['勇男蠢妇','',''],['勇略','',''],['勇者','',''],['勇而无谋','',''],['勇退','',''],['勇退激流','',''],['勉为其难','',''],['勉从','',''],['勉力','',''],['勉力而为','',''],['勉励','',''],['勉勉强强','',''],['勉强','',''],['勉强能','',''],['勋业','',''],['勋位','',''],['勋劳','',''],['勋爵','',''],['勋章','',''],['勋绩','',''],['勋绶','',''],['勒人','',''],['勒令','',''],['勒住','',''],['勒勒车','',''],['勒压','',''],['勒哈费尔','',''],['勒威耶','',''],['勒庞','',''],['勒戒','',''],['勒抑','',''],['勒支','',''],['勒斯波斯','',''],['勒斯波斯岛','',''],['勒杀','',''],['勒死','',''],['勒毙','',''],['勒派','',''],['勒索','',''],['勒索罪','',''],['勒索者','',''],['勒紧','',''],['勒紧裤带','',''],['勒维夫','',''],['勒维纳斯','',''],['勒脖子','',''],['勒逼','',''],['勒颈','',''],['勒马','',''],['勒马悬崖','',''],['勖勉','',''],['勘乱','',''],['勘定','',''],['勘察','',''],['勘察加','',''],['勘察加半岛','',''],['勘探','',''],['勘探者','',''],['勘探队','',''],['勘查','',''],['勘正','',''],['勘测','',''],['勘漏','',''],['勘灾','',''],['勘界','',''],['勘破','',''],['勘误','',''],['勘误表','',''],['勘谬','',''],['勘验','',''],['募倚','',''],['募兵','',''],['募兵制','',''],['募化','',''],['募得','',''],['募捐','',''],['募捐者','',''],['募款','',''],['募缘','',''],['募集','',''],['募集者','',''],['勤于','',''],['勤于思考','',''],['勤俭','',''],['勤俭为服务之本','',''],['勤俭办企业','',''],['勤俭办学','',''],['勤俭办社','',''],['勤俭务实','',''],['勤俭建国','',''],['勤俭持家','',''],['勤俭朴实','',''],['勤俭朴素','',''],['勤俭耐劳','',''],['勤俭节约','',''],['勤俭起家','',''],['勤则不匮','',''],['勤前教育','',''],['勤力','',''],['勤加练习','',''],['勤务','',''],['勤务兵','',''],['勤务员','',''],['勤务训练','',''],['勤劳','',''],['勤劳不虞匮乏','',''],['勤劳者','',''],['勤劳致富','',''],['勤勉','',''],['勤勤','',''],['勤勤恳恳','',''],['勤奋','',''],['勤奋刻苦','',''],['勤学','',''],['勤学苦练','',''],['勤密','',''],['勤工俭学','',''],['勤工助学','',''],['勤快','',''],['勤恳','',''],['勤恳恳','',''],['勤政','',''],['勤政廉政','',''],['勤朴','',''],['勤杂','',''],['勤杂人员','',''],['勤杂工','',''],['勤王','',''],['勤练','',''],['勤耕','',''],['勤能补拙','',''],['勤苦','',''],['勤谨','',''],['勺子','',''],['勺状软骨','',''],['勾三搭四','',''],['勾肩','',''],['勾肩搭背','',''],['勾乙','',''],['勾人','',''],['勾住','',''],['勾兑','',''],['勾出','',''],['勾划','',''],['勾勒','',''],['勾勾','',''],['勾勾搭搭','',''],['勾去','',''],['勾取','',''],['勾号','',''],['勾引','',''],['勾当','',''],['勾心','',''],['勾心斗角','',''],['勾手','',''],['勾拳','',''],['勾掉','',''],['勾搭','',''],['勾栏','',''],['勾消','',''],['勾玉','',''],['勾画','',''],['勾留','',''],['勾结','',''],['勾缝','',''],['勾股','',''],['勾股定理','',''],['勾股形','',''],['勾脸','',''],['勾芡','',''],['勾藤','',''],['勾起','',''],['勾践','',''],['勾通','',''],['勾针','',''],['勾销','',''],['勾阑','',''],['勾除','',''],['勾魂','',''],['勿似','',''],['勿动','',''],['勿失','',''],['勿失良机','',''],['勿宁说','',''],['勿带','',''],['勿庸置疑','',''],['勿忘国耻','',''],['勿忘我','',''],['勿忘草','',''],['勿施于人','',''],['勿替敬典','',''],['勿有','',''],['勿求人','',''],['勿玩','',''],['勿药有喜','',''],['勿谓言之不预','',''],['匀停','',''],['匀兑','',''],['匀净','',''],['匀和','',''],['匀实','',''],['匀整','',''],['匀溜','',''],['匀称','',''],['匀脸','',''],['匀速','',''],['匀速圆周运动','',''],['匀速直线运动','',''],['匀速运动','',''],['包上','',''],['包举','',''],['包乘','',''],['包乘制','',''],['包乘组','',''],['包书皮','',''],['包二奶','',''],['包产','',''],['包产到户','',''],['包产到户制','',''],['包人','',''],['包以','',''],['包件','',''],['包价旅游','',''],['包伙','',''],['包住','',''],['包修','',''],['包公','',''],['包兰铁路','',''],['包养','',''],['包内','',''],['包剿','',''],['包办','',''],['包办代替','',''],['包办婚姻','',''],['包包','',''],['包医','',''],['包厢','',''],['包含','',''],['包含在内','',''],['包囊','',''],['包园儿','',''],['包围','',''],['包围圈','',''],['包围着','',''],['包圆儿','',''],['包在','',''],['包在我身上','',''],['包场','',''],['包头地区','',''],['包子','',''],['包孕','',''],['包容','',''],['包封','',''],['包尔','',''],['包层','',''],['包工','',''],['包工包料','',''],['包工头','',''],['包工队','',''],['包巾','',''],['包布','',''],['包干','',''],['包干儿','',''],['包干到户','',''],['包干制','',''],['包庇','',''],['包底','',''],['包店','',''],['包待制','',''],['包心菜','',''],['包成','',''],['包房','',''],['包扎','',''],['包打听','',''],['包打天下','',''],['包承制','',''],['包承组','',''],['包抄','',''],['包括','',''],['包括了','',''],['包括内置配重','',''],['包拯','',''],['包换','',''],['包探','',''],['包揽','',''],['包揽词讼','',''],['包收','',''],['包教','',''],['包月','',''],['包机','',''],['包柔氏螺旋体','',''],['包死','',''],['包氏螺旋体','',''],['包河','',''],['包治百病','',''],['包法利','',''],['包活','',''],['包涵','',''],['包片','',''],['包牙','',''],['包皮','',''],['包皮环切','',''],['包皮环切术','',''],['包着','',''],['包票','',''],['包租','',''],['包税','',''],['包管','',''],['包箱','',''],['包米','',''],['包粟','',''],['包紧','',''],['包纸','',''],['包给','',''],['包缠','',''],['包罗','',''],['包罗万象','',''],['包罗广泛','',''],['包羞忍耻','',''],['包羞忍辱','',''],['包背装','',''],['包船','',''],['包茅','',''],['包草','',''],['包荒','',''],['包著','',''],['包藏','',''],['包藏祸心','',''],['包虫','',''],['包衣','',''],['包衣种子','',''],['包袋','',''],['包被','',''],['包袱','',''],['包袱底儿','',''],['包装','',''],['包装工人','',''],['包装材料','',''],['包装物','',''],['包装箱','',''],['包装纸','',''],['包装费','',''],['包裹','',''],['包谷','',''],['包豪斯','',''],['包赔','',''],['包起','',''],['包起来','',''],['包身','',''],['包身工','',''],['包车','',''],['包进','',''],['包退','',''],['包邮','',''],['包里','',''],['包里斯','',''],['包金','',''],['包钢','',''],['包银','',''],['包销','',''],['包间','',''],['包青天','',''],['包饭','',''],['包饺子','',''],['包龙图','',''],['匆促','',''],['匆匆','',''],['匆匆一看','',''],['匆匆忙忙','',''],['匆卒','',''],['匆忙','',''],['匆忙而行','',''],['匆猝','',''],['匆穿','',''],['匆遽','',''],['匈奴','',''],['匈奴王','',''],['匈牙利一九一九年革命','',''],['匈牙利人','',''],['匈牙利语','',''],['匈语','',''],['匍伏','',''],['匍匐','',''],['匍匐之救','',''],['匍匐前进','',''],['匍匐茎','',''],['匏瓜','',''],['匏瓜空悬','',''],['匐匍','',''],['匐枝','',''],['匐行','',''],['匕首','',''],['匕鬯不惊','',''],['化上','',''],['化为','',''],['化为乌有','',''],['化为己有','',''],['化为泡影','',''],['化为灰烬','',''],['化作','',''],['化作灰烬','',''],['化公为私','',''],['化冻','',''],['化出化入','',''],['化分','',''],['化剂','',''],['化募','',''],['化合','',''],['化合价','',''],['化合物','',''],['化名','',''],['化境','',''],['化外','',''],['化妆','',''],['化妆台','',''],['化妆品','',''],['化妆室','',''],['化妆师','',''],['化妆水','',''],['化妆舞会','',''],['化子','',''],['化学','',''],['化学信息素','',''],['化学元素','',''],['化学分析','',''],['化学剂量计','',''],['化学化','',''],['化学反应','',''],['化学反应式','',''],['化学变化','',''],['化学合成','',''],['化学品','',''],['化学家','',''],['化学工业','',''],['化学工业部','',''],['化学工程','',''],['化学师','',''],['化学平衡','',''],['化学式','',''],['化学弹药','',''],['化学当量','',''],['化学性','',''],['化学性质','',''],['化学成分','',''],['化学战','',''],['化学战剂','',''],['化学战剂检毒箱','',''],['化学战斗部','',''],['化学方程式','',''],['化学武器','',''],['化学武器储备','',''],['化学武器防护','',''],['化学比色法','',''],['化学治疗','',''],['化学激光器','',''],['化学物','',''],['化学稳定性','',''],['化学符号','',''],['化学系','',''],['化学纤维','',''],['化学肥料','',''],['化学能','',''],['化学航弹','',''],['化学键','',''],['化学镀','',''],['化学防护','',''],['化学需氧量','',''],['化工','',''],['化工厂','',''],['化工局','',''],['化工部','',''],['化干戈为玉帛','',''],['化开','',''],['化形','',''],['化成','',''],['化掉','',''],['化敌','',''],['化敌为友','',''],['化整','',''],['化整为零','',''],['化斋','',''],['化日','',''],['化日光天','',''],['化武','',''],['化毒散','',''],['化氮','',''],['化油器','',''],['化生','',''],['化疗','',''],['化痰','',''],['化石','',''],['化石燃料','',''],['化石群','',''],['化简','',''],['化粪','',''],['化粪池','',''],['化纤','',''],['化纤工业','',''],['化缘','',''],['化肥','',''],['化脓','',''],['化脓性','',''],['化腐朽为神奇','',''],['化蛹','',''],['化装','',''],['化装服','',''],['化解','',''],['化费','',''],['化身','',''],['化过','',''],['化铁炉','',''],['化除','',''],['化险','',''],['化险为夷','',''],['化隆','',''],['化隆县','',''],['化零为整','',''],['化革','',''],['化验','',''],['化验员','',''],['化验室','',''],['北上','',''],['北二外','',''],['北亚','',''],['北京中医药大学','',''],['北京产权交易所','',''],['北京人民大会堂','',''],['北京军区','',''],['北京动物园','',''],['北京周报','',''],['北京商务中心区','',''],['北京国家体育场','',''],['北京国家游泳中心','',''],['北京图书馆','',''],['北京地区','',''],['北京外国语大学','',''],['北京大学','',''],['北京工业大学','',''],['北京工人体育场','',''],['北京师范大学','',''],['北京广播学院','',''],['北京教育学院','',''],['北京日报','',''],['北京时间','',''],['北京晚报','',''],['北京晨报','',''],['北京条约','',''],['北京林业大学','',''],['北京核武器研究所','',''],['北京汽车制造厂有限公司','',''],['北京烤鸭','',''],['北京物资学院','',''],['北京猿人','',''],['北京环球金融中心','',''],['北京理工大学','',''],['北京电影学院','',''],['北京科技大学','',''],['北京站','',''],['北京第二外国语学院','',''],['北京舞蹈学院','',''],['北京航空学院','',''],['北京航空航天大学','',''],['北京艺术学院','',''],['北京话','',''],['北京语言大学','',''],['北京语言学院','',''],['北京青年报','',''],['北京音','',''],['北京鸭','',''],['北仑','',''],['北仓区','',''],['北伐','',''],['北伐军','',''],['北伐战争','',''],['北佬','',''],['北侧','',''],['北关','',''],['北冕座','',''],['北冬','',''],['北冰洋','',''],['北凉','',''],['北半球','',''],['北卡罗来纳','',''],['北卡罗来纳州','',''],['北印度语','',''],['北县','',''],['北叟失马','',''],['北史','',''],['北周','',''],['北回归线','',''],['北国','',''],['北国风光','',''],['北坡','',''],['北埔','',''],['北埔乡','',''],['北塔','',''],['北塘','',''],['北外','',''],['北大','',''],['北大荒','',''],['北大西洋','',''],['北大西洋公约组织','',''],['北头','',''],['北威州','',''],['北安普敦','',''],['北宋','',''],['北宋四大部书','',''],['北寒带','',''],['北展','',''],['北屯','',''],['北屯区','',''],['北屯市','',''],['北屯镇','',''],['北山','',''],['北山羊','',''],['北岛','',''],['北岳','',''],['北岸','',''],['北川','',''],['北川县','',''],['北工大','',''],['北师','',''],['北平','',''],['北往','',''],['北征','',''],['北戴河','',''],['北房','',''],['北投','',''],['北投区','',''],['北斗','',''],['北斗七星','',''],['北斗卫星导航系统','',''],['北斗星','',''],['北斗镇','',''],['北方','',''],['北方人','',''],['北方佬','',''],['北方地区','',''],['北方工业','',''],['北方工业公司','',''],['北方民族大学','',''],['北方话','',''],['北方邦','',''],['北方领土','',''],['北曲','',''],['北朝','',''],['北朝鲜','',''],['北极','',''],['北极光','',''],['北极圈','',''],['北极星','',''],['北极熊','',''],['北极狐','',''],['北林','',''],['北柴胡','',''],['北楼','',''],['北欧','',''],['北欧人','',''],['北欧航空公司','',''],['北段','',''],['北汉','',''],['北江','',''],['北汽','',''],['北洋','',''],['北洋军','',''],['北洋军阀','',''],['北洋政府','',''],['北洋水师','',''],['北洋系','',''],['北洋陆军','',''],['北派螳螂拳','',''],['北海舰队','',''],['北海道','',''],['北温带','',''],['北港','',''],['北港镇','',''],['北濒','',''],['北煤南运','',''],['北燕','',''],['北爱','',''],['北爱尔兰','',''],['北狄','',''],['北瓜','',''],['北疆','',''],['北碚','',''],['北端','',''],['北竿','',''],['北竿乡','',''],['北约组织','',''],['北纬','',''],['北美','',''],['北美产','',''],['北美洲','',''],['北航','',''],['北苑','',''],['北荷兰','',''],['北莱茵・威斯特法伦州','',''],['北行','',''],['北街','',''],['北角','',''],['北越','',''],['北路','',''],['北路梆子','',''],['北辕适楚','',''],['北辙南辕','',''],['北辰','',''],['北边','',''],['北边儿','',''],['北达科他','',''],['北达科他州','',''],['北进','',''],['北进政策','',''],['北道主人','',''],['北邙','',''],['北郊','',''],['北部','',''],['北部地区','',''],['北部拉班特','',''],['北部湾','',''],['北镇','',''],['北镇市','',''],['北镇满族自治县','',''],['北门','',''],['北门乡','',''],['北门锁钥','',''],['北非','',''],['北非洲','',''],['北面','',''],['北面称臣','',''],['北韩','',''],['北领地','',''],['北风','',''],['北魏','',''],['北麓','',''],['北齐','',''],['北齐书','',''],['匙儿','',''],['匙子','',''],['匝加利亚','',''],['匝地','',''],['匝数','',''],['匝月','',''],['匝道','',''],['匝道口','',''],['匠人','',''],['匠心','',''],['匠气','',''],['匠心独具','',''],['匠心独运','',''],['匠石运斤','',''],['匠遇作家','',''],['匡俗济时','',''],['匡心如水','',''],['匡扶','',''],['匡扶社稷','',''],['匡救','',''],['匡时济俗','',''],['匡正','',''],['匡济','',''],['匡算','',''],['匡门如市','',''],['匣剑帷灯','',''],['匣子','',''],['匣里龙吟','',''],['匪党','',''],['匪兵','',''],['匪军','',''],['匪夷所思','',''],['匪巢','',''],['匪帮','',''],['匪徒','',''],['匪徒集团','',''],['匪患','',''],['匪朝伊夕','',''],['匪片','',''],['匪盗','',''],['匪石之心','',''],['匪祸','',''],['匪穴','',''],['匪警','',''],['匪躬之操','',''],['匪邦','',''],['匪首','',''],['匮乏','',''],['匮竭','',''],['匮缺','',''],['匹亚','',''],['匹偶','',''],['匹兹堡','',''],['匹夫','',''],['匹夫之勇','',''],['匹夫匹妇','',''],['匹夫无罪怀璧其罪','',''],['匹夫有责','',''],['匹头','',''],['匹拉米洞','',''],['匹敌','',''],['匹耦','',''],['匹配','',''],['匹马力','',''],['匹马单枪','',''],['区上','',''],['区位','',''],['区位码','',''],['区公所','',''],['区内','',''],['区分','',''],['区分大小写','',''],['区分开','',''],['区分线','',''],['区划','',''],['区别','',''],['区别不同情况','',''],['区别于','',''],['区别对待','',''],['区别轻重缓急','',''],['区区','',''],['区区小事','',''],['区县','',''],['区号','',''],['区名','',''],['区块','',''],['区块链','',''],['区域','',''],['区域合作','',''],['区域性','',''],['区域经济','',''],['区域经济学','',''],['区域网络','',''],['区域网路','',''],['区域网路技术','',''],['区域自治','',''],['区处','',''],['区外','',''],['区委','',''],['区字框','',''],['区宇一清','',''],['区局','',''],['区属','',''],['区政','',''],['区政府','',''],['区旗','',''],['区标','',''],['区段','',''],['区画','',''],['区界','',''],['区码','',''],['区级','',''],['区议会','',''],['区里','',''],['区长','',''],['区间','',''],['区间车','',''],['区院','',''],['区隔','',''],['医不好','',''],['医专','',''],['医书','',''],['医伤用','',''],['医务','',''],['医务人员','',''],['医务室','',''],['医务工作者','',''],['医务所','',''],['医医','',''],['医卜','',''],['医嘱','',''],['医士','',''],['医大','',''],['医好','',''],['医学','',''],['医学上','',''],['医学专家','',''],['医学中心','',''],['医学博士','',''],['医学士','',''],['医学家','',''],['医学心理学','',''],['医学检验','',''],['医学检验师','',''],['医学系','',''],['医学院','',''],['医官','',''],['医家','',''],['医密','',''],['医师','',''],['医德','',''],['医托','',''],['医护','',''],['医护人员','',''],['医改','',''],['医方','',''],['医时救弊','',''],['医术','',''],['医案','',''],['医治','',''],['医治无效','',''],['医治者','',''],['医理','',''],['医生','',''],['医用','',''],['医疗','',''],['医疗事故','',''],['医疗体操','',''],['医疗体育','',''],['医疗保健','',''],['医疗保险','',''],['医疗卫生','',''],['医疗器械','',''],['医疗护理','',''],['医疗疏失','',''],['医疗经验','',''],['医疗费','',''],['医疗队','',''],['医病','',''],['医神','',''],['医科','',''],['医科大学','',''],['医科学校','',''],['医者','',''],['医药','',''],['医药分离','',''],['医药卫生','',''],['医药商店','',''],['医药学','',''],['医药费','',''],['医道','',''],['医院','',''],['匾的','',''],['匾额','',''],['匿伏','',''],['匿名','',''],['匿名信','',''],['匿处','',''],['匿影藏形','',''],['匿报','',''],['匿於','',''],['匿藏','',''],['匿迹','',''],['匿迹潜形','',''],['匿迹销声','',''],['匿迹隐形','',''],['十一','',''],['十一个','',''],['十一人','',''],['十一倍','',''],['十一大','',''],['十一届三中全会','',''],['十一时','',''],['十一月','',''],['十一月份','',''],['十一路','',''],['十余','',''],['十七','',''],['十七世纪','',''],['十七个','',''],['十七人','',''],['十七勇士','',''],['十七史','',''],['十七大','',''],['十七孔桥','',''],['十万','',''],['十万位','',''],['十万八千里','',''],['十万火急','',''],['十万火速','',''],['十万个为什么','',''],['十三','',''],['十三个','',''],['十三人','',''],['十三大','',''],['十三日','',''],['十三时','',''],['十三点','',''],['十三经','',''],['十三辙','',''],['十三陵','',''],['十不闲儿','',''],['十个','',''],['十中全会','',''],['十之八九','',''],['十九','',''],['十九世纪','',''],['十九个','',''],['十九人','',''],['十九大','',''],['十九时','',''],['十二','',''],['十二个','',''],['十二个月','',''],['十二人','',''],['十二倍','',''],['十二分','',''],['十二地支','',''],['十二大','',''],['十二宫','',''],['十二平均律','',''],['十二开','',''],['十二指肠','',''],['十二指肠溃疡','',''],['十二支','',''],['十二时','',''],['十二时辰','',''],['十二星座','',''],['十二月','',''],['十二月份','',''],['十二用','',''],['十二码','',''],['十二经','',''],['十二经脉','',''],['十二角形','',''],['十二边形','',''],['十二金牌','',''],['十二面体','',''],['十二音','',''],['十五','',''],['十五世纪','',''],['十五个','',''],['十五个吊桶打水','',''],['十五人','',''],['十五大','',''],['十五年','',''],['十五日','',''],['十亲九故','',''],['十人','',''],['十亿','',''],['十亿位元','',''],['十亿位元以太网络','',''],['十亿位元以太网络联盟','',''],['十件','',''],['十传百','',''],['十位','',''],['十佳','',''],['十便士','',''],['十倍','',''],['十元','',''],['十元整','',''],['十克','',''],['十全','',''],['十全十美','',''],['十八','',''],['十八世纪','',''],['十八个','',''],['十八人','',''],['十八大','',''],['十八岁','',''],['十八开','',''],['十八时','',''],['十八罗汉','',''],['十八般武艺','',''],['十六','',''],['十六世纪','',''],['十六个','',''],['十六人','',''],['十六位元','',''],['十六分音符','',''],['十六国','',''],['十六国春秋','',''],['十六大','',''],['十六字诀','',''],['十六岁','',''],['十六开本','',''],['十六时','',''],['十六烷值','',''],['十六进位','',''],['十六进制','',''],['十冬腊月','',''],['十几','',''],['十几个月','',''],['十几岁','',''],['十几年来','',''],['十分','',''],['十分之一','',''],['十分之七','',''],['十分之三','',''],['十分之九','',''],['十分之二','',''],['十分之五','',''],['十分之八','',''],['十分之六','',''],['十分之十','',''],['十分之四','',''],['十分关心','',''],['十分困难','',''],['十分复杂','',''],['十分多谢','',''],['十分宝贵','',''],['十分必要','',''],['十分明确','',''],['十分注意','',''],['十分满意','',''],['十分相似','',''],['十分艰巨','',''],['十分迅速','',''],['十分重要','',''],['十分重视','',''],['十分高兴','',''],['十十五五','',''],['十号','',''],['十吨','',''],['十味','',''],['十四','',''],['十四个','',''],['十四人','',''],['十四大','',''],['十四时','',''],['十四行诗','',''],['十围五攻','',''],['十国春秋','',''],['十多亿','',''],['十大','',''],['十大神兽','',''],['十天','',''],['十天干','',''],['十字','',''],['十字军','',''],['十字军东征','',''],['十字军远征','',''],['十字头','',''],['十字头螺刀','',''],['十字形','',''],['十字架','',''],['十字架刑','',''],['十字标','',''],['十字绣','',''],['十字花科','',''],['十字街头','',''],['十字路','',''],['十字路口','',''],['十字路头','',''],['十字镜','',''],['十室九空','',''],['十家','',''],['十尺','',''],['十届','',''],['十岁','',''],['十常侍','',''],['十干','',''],['十年','',''],['十年九不遇','',''],['十年内乱','',''],['十年动乱','',''],['十年如一日','',''],['十年寒窗','',''],['十年怕井索','',''],['十年期','',''],['十年树木','',''],['十年树木百年树人','',''],['十年规划','',''],['十年间','',''],['十开','',''],['十张','',''],['十恶不赦','',''],['十成','',''],['十成九稳','',''],['十戒','',''],['十户','',''],['十拿九稳','',''],['十拿十稳','',''],['十指有长短','',''],['十指连心','',''],['十捉九着','',''],['十数','',''],['十方','',''],['十日','',''],['十日一水五日一石','',''],['十日怕麻绳','',''],['十日谈','',''],['十时','',''],['十月','',''],['十月份','',''],['十月革命','',''],['十有八九','',''],['十期','',''],['十本','',''],['十条','',''],['十样锦','',''],['十楼','',''],['十步芳草','',''],['十死一生','',''],['十死九生','',''],['十段','',''],['十滴水','',''],['十点','',''],['十生九死','',''],['十番乐','',''],['十病九痛','',''],['十目所视十手所指','',''],['十米','',''],['十类','',''],['十级','',''],['十羊九牧','',''],['十荡十决','',''],['十行俱下','',''],['十角形','',''],['十诫','',''],['十足','',''],['十足类','',''],['十路','',''],['十边形','',''],['十进','',''],['十进位','',''],['十进位制','',''],['十进位法','',''],['十进制','',''],['十进对数','',''],['十进小数','',''],['十进算术','',''],['十进管','',''],['十通','',''],['十里','',''],['十里洋场','',''],['十锦','',''],['十面','',''],['十面体','',''],['十面埋伏','',''],['十音节','',''],['十项','',''],['十项全能','',''],['十项全能运动','',''],['十风五雨','',''],['十鼠争穴','',''],['十鼠同穴','',''],['千万','',''],['千万个','',''],['千万买邻','',''],['千丈','',''],['千丝万缕','',''],['千乘万骑','',''],['千了百当','',''],['千亩','',''],['千人','',''],['千人所指','',''],['千亿','',''],['千仇万恨','',''],['千仓万箱','',''],['千伏','',''],['千伏特','',''],['千伶百俐','',''],['千位','',''],['千位元','',''],['千余','',''],['千佛洞','',''],['千依万顺','',''],['千依百顺','',''],['千倍','',''],['千儿八百','',''],['千元','',''],['千兆','',''],['千克','',''],['千克米','',''],['千公斤','',''],['千兵万马','',''],['千军','',''],['千军万马','',''],['千军易得','',''],['千军易得一将难求','',''],['千刀万剁','',''],['千刀万剐','',''],['千分','',''],['千分之','',''],['千分之一','',''],['千分位','',''],['千分尺','',''],['千分率','',''],['千分表','',''],['千千万万','',''],['千升','',''],['千卡','',''],['千变万化','',''],['千变万轸','',''],['千古','',''],['千古独步','',''],['千古罪人','',''],['千古遗恨','',''],['千叮万嘱','',''],['千叶','',''],['千叶县','',''],['千叶市','',''],['千吨','',''],['千吨级核武器','',''],['千周','',''],['千周率','',''],['千呼万唤','',''],['千唤万唤','',''],['千回','',''],['千回百转','',''],['千夫','',''],['千夫所指','',''],['千头万绪','',''],['千奇百怪','',''],['千妥万妥','',''],['千妥万当','',''],['千姿百态','',''],['千娇百媚','',''],['千娇百态','',''],['千孔百疮','',''],['千字','',''],['千字文','',''],['千字节','',''],['千家万户','',''],['千尺','',''],['千层','',''],['千层底','',''],['千层面','',''],['千居里','',''],['千山','',''],['千山万壑','',''],['千山万水','',''],['千岁','',''],['千岁一时','',''],['千岛','',''],['千岛列岛','',''],['千岛湖','',''],['千岛群岛','',''],['千岛酱','',''],['千岩万壑','',''],['千岩万谷','',''],['千差万别','',''],['千帕','',''],['千年','',''],['千年万载','',''],['千度','',''],['千张','',''],['千态万状','',''],['千思万想','',''],['千恩万谢','',''],['千户','',''],['千推万阻','',''],['千斤','',''],['千斤顶','',''],['千方万计','',''],['千方百计','',''],['千日','',''],['千日红','',''],['千村万落','',''],['千条万端','',''],['千欢万喜','',''],['千状万态','',''],['千状万端','',''],['千瓦','',''],['千瓦时','',''],['千瓦时表','',''],['千疮百孔','',''],['千百','',''],['千百万','',''],['千百年来','',''],['千盏菊','',''],['千真万真','',''],['千真万确','',''],['千碱基对','',''],['千禧年','',''],['千秋','',''],['千秋万世','',''],['千秋万代','',''],['千秋万古','',''],['千秋万岁','',''],['千秋大业','',''],['千穗谷','',''],['千端万绪','',''],['千篇一律','',''],['千米','',''],['千粒重','',''],['千红万紫','',''],['千纤','',''],['千经万卷','',''],['千绪万端','',''],['千编一律','',''],['千虑','',''],['千虑一失','',''],['千虑一得','',''],['千言万语','',''],['千赫','',''],['千赫兹','',''],['千足虫','',''],['千载一会','',''],['千载一合','',''],['千载一时','',''],['千载一逢','',''],['千载一遇','',''],['千载独步','',''],['千载难逢','',''],['千辛万苦','',''],['千辛百苦','',''],['千部一腔千人一面','',''],['千里','',''],['千里一曲','',''],['千里之堤','',''],['千里之堤溃于蚁穴','',''],['千里之外','',''],['千里之行','',''],['千里光','',''],['千里命驾','',''],['千里姻缘一线牵','',''],['千里寄鹅毛','',''],['千里搭长棚','',''],['千里犹面','',''],['千里眼','',''],['千里莼羹','',''],['千里达','',''],['千里达和多巴哥','',''],['千里迢迢','',''],['千里迢遥','',''],['千里送鹅毛','',''],['千里马','',''],['千里驹','',''],['千里鹅毛','',''],['千金','',''],['千金一刻','',''],['千金一掷','',''],['千金一笑','',''],['千金一诺','',''],['千金之子','',''],['千金之家','',''],['千金买笑','',''],['千金小姐','',''],['千金市骨','',''],['千金弊帚','',''],['千金方','',''],['千金要方','',''],['千金难买','',''],['千钧','',''],['千钧一发','',''],['千钧棒','',''],['千钧重负','',''],['千锤','',''],['千锤百炼','',''],['千锤百鍊','',''],['千镒之裘','',''],['千门万户','',''],['千闻不如一见','',''],['千难万险','',''],['千难万难','',''],['千页','',''],['千鸟渊国家公墓','',''],['升上','',''],['升为','',''],['升了','',''],['升于','',''],['升任','',''],['升值','',''],['升到','',''],['升力','',''],['升势','',''],['升华','',''],['升压','',''],['升压机','',''],['升堂','',''],['升堂入室','',''],['升堂拜母','',''],['升天','',''],['升天节','',''],['升学','',''],['升学率','',''],['升官','',''],['升官发财','',''],['升市','',''],['升帐','',''],['升幂','',''],['升幅','',''],['升平','',''],['升序','',''],['升息','',''],['升斗','',''],['升斗小民','',''],['升旗','',''],['升旗仪式','',''],['升格','',''],['升档','',''],['升水','',''],['升汞','',''],['升涨','',''],['升温','',''],['升班','',''],['升空','',''],['升级','',''],['升级版','',''],['升结肠','',''],['升职','',''],['升腾','',''],['升至','',''],['升调','',''],['升起','',''],['升迁','',''],['升遐','',''],['升降','',''],['升降机','',''],['升降索','',''],['升降舵','',''],['升限','',''],['升高','',''],['升高自下','',''],['午休','',''],['午前','',''],['午场','',''],['午夜','',''],['午安','',''],['午宴','',''],['午市','',''],['午时茶','',''],['午曲','',''],['午狮','',''],['午睡','',''],['午膳','',''],['午觉','',''],['午课','',''],['午门','',''],['午间','',''],['午餐','',''],['午餐会','',''],['午饭','',''],['午马','',''],['半不','',''],['半世','',''],['半个','',''],['半个世纪','',''],['半个多世纪','',''],['半个月','',''],['半中腰','',''],['半乳糖','',''],['半乳糖血症','',''],['半人马','',''],['半人马座','',''],['半以上','',''],['半价','',''],['半份','',''],['半低元音','',''],['半保留复制','',''],['半信半疑','',''],['半元音','',''],['半公开','',''],['半决赛','',''],['半决赛权','',''],['半分','',''],['半制品','',''],['半刻','',''],['半劳动力','',''],['半半','',''],['半半拉拉','',''],['半发达','',''],['半句','',''],['半吊子','',''],['半吞半吐','',''],['半吨','',''],['半咸水湖','',''],['半响','',''],['半圆','',''],['半圆仪','',''],['半圆形','',''],['半场','',''],['半场球赛','',''],['半坡','',''],['半坡村','',''],['半坡遗址','',''],['半壁','',''],['半壁江山','',''],['半复赛','',''],['半夏','',''],['半夜三更','',''],['半夜敲门不吃惊','',''],['半夜敲门心不惊','',''],['半大','',''],['半天','',''],['半失业','',''],['半子','',''],['半学年','',''],['半官方','',''],['半导体','',''],['半导体探测器','',''],['半导体收音机','',''],['半导体超点阵','',''],['半导瓷','',''],['半封建','',''],['半封建半殖民地','',''],['半小时','',''],['半履带','',''],['半山','',''],['半山区','',''],['半山坡','',''],['半山腰','',''],['半岛','',''],['半岛和东方航海','',''],['半岛国际学校','',''],['半岛电视台','',''],['半工半读','',''],['半干','',''],['半年','',''],['半底','',''],['半开','',''],['半开化','',''],['半开半关','',''],['半开门','',''],['半开门儿','',''],['半彪子','',''],['半影','',''],['半径','',''],['半成品','',''],['半截','',''],['半截入土','',''],['半截衫','',''],['半打','',''],['半托','',''],['半拉','',''],['半拉子','',''],['半拍','',''],['半拱','',''],['半排出期','',''],['半推半就','',''],['半支莲','',''],['半数','',''],['半数以上','',''],['半文盲','',''],['半斤','',''],['半斤八两','',''],['半新','',''],['半新不旧','',''],['半新半旧','',''],['半方','',''],['半旗','',''],['半无产阶级','',''],['半无限','',''],['半日','',''],['半日制','',''],['半日制学校','',''],['半日工作','',''],['半时','',''],['半明不灭','',''],['半明半暗','',''],['半晌','',''],['半暗','',''],['半月','',''],['半月刊','',''],['半月形','',''],['半月板','',''],['半期','',''],['半机械化','',''],['半条命','',''],['半步','',''],['半死','',''],['半死不活','',''],['半死半活','',''],['半殖民地','',''],['半治天下','',''],['半流体','',''],['半涂而废','',''],['半涂而罢','',''],['半点','',''],['半熟','',''],['半熟练','',''],['半球','',''],['半瓶','',''],['半瓶水响叮当','',''],['半瓶醋','',''],['半生','',''],['半生不熟','',''],['半白','',''],['半百','',''],['半盲','',''],['半真半假','',''],['半瞎','',''],['半神半人','',''],['半票','',''],['半空','',''],['半空中','',''],['半筹不纳','',''],['半筹莫展','',''],['半糖夫妻','',''],['半翅目','',''],['半老','',''],['半老徐娘','',''],['半职','',''],['半职业性','',''],['半胱氨酸','',''],['半脱产','',''],['半腰','',''],['半腱肌','',''],['半膜肌','',''],['半自动','',''],['半自动化','',''],['半自耕农','',''],['半苦半甜','',''],['半英寸','',''],['半薪','',''],['半融','',''],['半衰期','',''],['半裸','',''],['半裸体','',''],['半规则','',''],['半规管','',''],['半视野','',''],['半角','',''],['半跏坐','',''],['半路','',''],['半路修行','',''],['半路出家','',''],['半路埋伏','',''],['半身','',''],['半身不遂','',''],['半身像','',''],['半车','',''],['半轴','',''],['半载','',''],['半辈','',''],['半辈子','',''],['半边','',''],['半边人','',''],['半边天','',''],['半边莲','',''],['半透','',''],['半透明','',''],['半透膜','',''],['半途','',''],['半途而废','',''],['半通不通','',''],['半道','',''],['半道儿','',''],['半道打字','',''],['半部','',''],['半部论语','',''],['半长轴','',''],['半间不界','',''],['半青半黄','',''],['半面','',''],['半面之交','',''],['半音','',''],['半音程','',''],['半饱','',''],['半高','',''],['半高元音','',''],['华东','',''],['华东军区','',''],['华东地区','',''],['华东师大','',''],['华东师范大学','',''],['华东理工大学','',''],['华丝葛','',''],['华严宗','',''],['华严经','',''],['华中','',''],['华中地区','',''],['华为','',''],['华丽','',''],['华人','',''],['华佗','',''],['华侨','',''],['华侨中学','',''],['华侨大学','',''],['华侨委员会','',''],['华侨报','',''],['华侨状况','',''],['华兴会','',''],['华北','',''],['华北事变','',''],['华北地区','',''],['华北平原','',''],['华北龙','',''],['华南','',''],['华南地区','',''],['华南理工大学','',''],['华南虎','',''],['华厦','',''],['华发','',''],['华商','',''],['华商报','',''],['华商晨报','',''],['华国锋','',''],['华埠','',''],['华夏','',''],['华威','',''],['华威大学','',''],['华容道','',''],['华封三祝','',''],['华尔兹','',''],['华尔兹舞','',''],['华尔滋','',''],['华尔街','',''],['华尔街日报','',''],['华屋','',''],['华屋丘墟','',''],['华工','',''],['华府','',''],['华彩','',''],['华拳','',''],['华教','',''],['华文','',''],['华族','',''],['华林','',''],['华林部','',''],['华校','',''],['华毂','',''],['华氏','',''],['华氏度','',''],['华氏温度表','',''],['华氏温度计','',''],['华沙','',''],['华法林','',''],['华海','',''],['华润万家','',''],['华灯','',''],['华灯初上','',''],['华特','',''],['华盖','',''],['华盛顿','',''],['华盛顿会议','',''],['华盛顿州','',''],['华盛顿时报','',''],['华盛顿特区','',''],['华盛顿邮报','',''],['华硕','',''],['华社','',''],['华章','',''],['华约','',''],['华纳兄弟','',''],['华纳音乐集团','',''],['华罗庚','',''],['华美','',''],['华而不实','',''],['华胄','',''],['华航','',''],['华表','',''],['华裔','',''],['华西','',''],['华视','',''],['华诞','',''],['华语','',''],['华豪鹤唳','',''],['华贵','',''],['华辞','',''],['华达呢','',''],['华里','',''],['华陀','',''],['华靡','',''],['华龙','',''],['协人','',''],['协从','',''],['协会','',''],['协作','',''],['协作关系','',''],['协作单位','',''],['协作者','',''],['协力','',''],['协力同心','',''],['协办','',''],['协助','',''],['协助者','',''],['协同','',''],['协同作战','',''],['协同作用','',''],['协同学','',''],['协同通信','',''],['协和','',''],['协和式客机','',''],['协和飞机','',''],['协商','',''],['协商一致','',''],['协商会议','',''],['协商者','',''],['协处','',''],['协奏','',''],['协奏曲','',''],['协定','',''],['协心同力','',''],['协性','',''],['协方差','',''],['协查','',''],['协洽','',''],['协理','',''],['协理员','',''],['协税','',''],['协管','',''],['协管员','',''],['协约','',''],['协约国','',''],['协统','',''],['协议','',''],['协议书','',''],['协调','',''],['协调世界时','',''],['协调人','',''],['协调会','',''],['协调发展','',''],['协调员','',''],['协调委员会','',''],['协调官','',''],['协调者','',''],['协调论','',''],['协谈','',''],['协迫','',''],['协韵','',''],['卑下','',''],['卑不足道','',''],['卑之','',''],['卑之无甚高论','',''],['卑以自牧','',''],['卑俗','',''],['卑劣','',''],['卑劣下流','',''],['卑卑不足道','',''],['卑南','',''],['卑南乡','',''],['卑南族','',''],['卑宫菲食','',''],['卑尔根','',''],['卑屈','',''],['卑己自牧','',''],['卑微','',''],['卑怯','',''],['卑恭','',''],['卑恭屈节','',''],['卑污','',''],['卑礼厚币','',''],['卑职','',''],['卑视','',''],['卑谦','',''],['卑贱','',''],['卑躬屈膝','',''],['卑躬屈节','',''],['卑辞','',''],['卑辞厚币','',''],['卑辞厚礼','',''],['卑逊','',''],['卑鄙','',''],['卑鄙无耻','',''],['卑鄙的人','',''],['卑鄙龌龊','',''],['卑陋','',''],['卑陋龌龊','',''],['卒业','',''],['卒中','',''],['卒于','',''],['卒子','',''],['卒岁','',''],['卓乎不群','',''],['卓兰','',''],['卓兰镇','',''],['卓尔不群','',''],['卓尔出群','',''],['卓异','',''],['卓有','',''],['卓有成效','',''],['卓溪','',''],['卓溪乡','',''],['卓然','',''],['卓然不群','',''],['卓约','',''],['卓绝','',''],['卓荤不羁','',''],['卓荦','',''],['卓著','',''],['卓见','',''],['卓识','',''],['卓越','',''],['卓越网','',''],['单一','',''],['单一制','',''],['单一化','',''],['单一合体字','',''],['单一性','',''],['单一码','',''],['单一货币','',''],['单丁','',''],['单丝','',''],['单丝不线','',''],['单个','',''],['单个儿','',''],['单义','',''],['单于','',''],['单交','',''],['单交种','',''],['单产','',''],['单亲','',''],['单亲家庭','',''],['单人','',''],['单人床','',''],['单人座','',''],['单人独马','',''],['单人间','',''],['单件','',''],['单价','',''],['单传','',''],['单位','',''],['单位信托','',''],['单位元','',''],['单位切向量','',''],['单位制','',''],['单位向量','',''],['单位根','',''],['单位负责人','',''],['单位量','',''],['单位面积产量','',''],['单位预算','',''],['单体','',''],['单作','',''],['单作用','',''],['单侧','',''],['单倍体','',''],['单倍体植物','',''],['单倍体育种','',''],['单元','',''],['单元格','',''],['单元论','',''],['单元频率','',''],['单克隆','',''],['单克隆抗体','',''],['单兵教练','',''],['单养','',''],['单内','',''],['单凭','',''],['单击','',''],['单刀','',''],['单刀直入','',''],['单刃剑','',''],['单分','',''],['单列','',''],['单利','',''],['单动式','',''],['单单','',''],['单卵性','',''],['单原子','',''],['单去','',''],['单发','',''],['单口相声','',''],['单句','',''],['单只','',''],['单叶','',''],['单叶双曲面','',''],['单号','',''],['单名数','',''],['单向','',''],['单向电流','',''],['单向阀','',''],['单味药','',''],['单块','',''],['单夫只妇','',''],['单套','',''],['单子','',''],['单子叶','',''],['单子叶植物','',''],['单孔','',''],['单孔目','',''],['单字','',''],['单字集','',''],['单季稻','',''],['单宁','',''],['单宁酸','',''],['单寒','',''],['单射','',''],['单就','',''],['单层','',''],['单层塔','',''],['单峰','',''],['单峰驼','',''],['单帮','',''],['单幅','',''],['单幢','',''],['单干','',''],['单干户','',''],['单座','',''],['单座式','',''],['单式教学','',''],['单式编制','',''],['单引擎','',''],['单张','',''],['单弦','',''],['单弦儿','',''],['单弦琴','',''],['单弱','',''],['单循环赛','',''],['单性','',''],['单性生殖','',''],['单性花','',''],['单恋','',''],['单意','',''],['单房差','',''],['单手','',''],['单打','',''],['单打一','',''],['单打独斗','',''],['单报','',''],['单指','',''],['单挑','',''],['单据','',''],['单排','',''],['单摆','',''],['单放机','',''],['单数','',''],['单料','',''],['单斜层','',''],['单方','',''],['单方决定','',''],['单方制剂','',''],['单方向','',''],['单方宣告','',''],['单方恐吓','',''],['单方过失碰撞','',''],['单方面','',''],['单日','',''],['单是','',''],['单显','',''],['单晶','',''],['单晶体','',''],['单晶硅','',''],['单晶硅棒','',''],['单曲','',''],['单月','',''],['单本','',''],['单机','',''],['单杠','',''],['单条','',''],['单板机','',''],['单板滑雪','',''],['单极','',''],['单枞','',''],['单枪','',''],['单枪匹马','',''],['单株','',''],['单核细胞','',''],['单核细胞增多症','',''],['单根独苗','',''],['单模','',''],['单模光纤','',''],['单次','',''],['单步','',''],['单比','',''],['单比例','',''],['单源多倍体','',''],['单源论','',''],['单点','',''],['单点系泊','',''],['单片','',''],['单片机','',''],['单独','',''],['单环','',''],['单班课','',''],['单瓣','',''],['单生花','',''],['单用','',''],['单瘫','',''],['单皮','',''],['单盲','',''],['单相','',''],['单相串激电动机','',''],['单相交流电','',''],['单相思','',''],['单眼','',''],['单眼皮','',''],['单眼镜','',''],['单科','',''],['单程','',''],['单程票','',''],['单立','',''],['单端孢霉烯类毒素','',''],['单端孢霉烯类毒素中毒症','',''],['单簧管','',''],['单糖','',''],['单纤维','',''],['单纯','',''],['单纯疱疹','',''],['单纯疱疹病毒','',''],['单纯词','',''],['单线','',''],['单线联系','',''],['单细胞','',''],['单细胞生物','',''],['单缸','',''],['单翼','',''],['单翼飞机','',''],['单耳','',''],['单联','',''],['单肩包','',''],['单胞藻','',''],['单脉冲','',''],['单脚跳','',''],['单腿','',''],['单色','',''],['单色光','',''],['单色照片','',''],['单色版','',''],['单色画','',''],['单薄','',''],['单行','',''],['单行本','',''],['单行线','',''],['单行道','',''],['单衣','',''],['单裤','',''],['单褂','',''],['单设','',''],['单证','',''],['单词','',''],['单词产生器模型','',''],['单说','',''],['单调','',''],['单调乏味','',''],['单质','',''],['单趟','',''],['单足','',''],['单跌','',''],['单身','',''],['单身汉','',''],['单身贵族','',''],['单车','',''],['单轨','',''],['单轨制','',''],['单轨铁路','',''],['单轮','',''],['单轮车','',''],['单边','',''],['单边主义','',''],['单连接站','',''],['单选','',''],['单铬','',''],['单链','',''],['单键','',''],['单镜反光相机','',''],['单间','',''],['单间儿','',''],['单院','',''],['单靠','',''],['单面','',''],['单鞋','',''],['单音','',''],['单音节','',''],['单音词','',''],['单韵母','',''],['单页','',''],['单项','',''],['单项奖','',''],['单项式','',''],['单额','',''],['单飞','',''],['单骑','',''],['单鹄寡凫','',''],['卖不掉','',''],['卖主','',''],['卖主求荣','',''],['卖乖','',''],['卖书','',''],['卖买','',''],['卖了','',''],['卖人','',''],['卖人情','',''],['卖价','',''],['卖俏','',''],['卖俏营奸','',''],['卖俏行奸','',''],['卖俏迎奸','',''],['卖傻','',''],['卖儿鬻女','',''],['卖光','',''],['卖光了','',''],['卖公营私','',''],['卖关子','',''],['卖关节','',''],['卖冰者','',''],['卖出','',''],['卖出价','',''],['卖刀买犊','',''],['卖到','',''],['卖剑买牛','',''],['卖力','',''],['卖力气','',''],['卖功','',''],['卖劲','',''],['卖卜','',''],['卖友','',''],['卖呆','',''],['卖命','',''],['卖品','',''],['卖唱','',''],['卖嘴','',''],['卖国','',''],['卖国主义','',''],['卖国求利','',''],['卖国求荣','',''],['卖国贼','',''],['卖大号','',''],['卖头卖脚','',''],['卖契','',''],['卖好','',''],['卖妻鬻子','',''],['卖完','',''],['卖官鬻爵','',''],['卖官鬻狱','',''],['卖局','',''],['卖工夫','',''],['卖底','',''],['卖座','',''],['卖弄','',''],['卖弄玄虚','',''],['卖弄风情','',''],['卖弄风骚','',''],['卖得','',''],['卖房','',''],['卖报','',''],['卖掉','',''],['卖文','',''],['卖断','',''],['卖方','',''],['卖方市场','',''],['卖春','',''],['卖本事','',''],['卖淫','',''],['卖淫嫖娼','',''],['卖清','',''],['卖炭翁','',''],['卖点','',''],['卖爵赘子','',''],['卖爵鬻子','',''],['卖狗悬羊','',''],['卖狗皮膏药','',''],['卖狗肉','',''],['卖的','',''],['卖盘','',''],['卖相','',''],['卖破绽','',''],['卖票','',''],['卖空','',''],['卖笑','',''],['卖给','',''],['卖老','',''],['卖者','',''],['卖肉','',''],['卖肉者','',''],['卖艺','',''],['卖花','',''],['卖苦力','',''],['卖茶','',''],['卖萌','',''],['卖货','',''],['卖超过','',''],['卖身','',''],['卖身契','',''],['卖身投靠','',''],['卖钱','',''],['卖面子','',''],['卖风流','',''],['卖鱼妇','',''],['南丁格尔','',''],['南三角座','',''],['南下','',''],['南乔治亚岛和南桑威奇','',''],['南乳','',''],['南亚','',''],['南亚区域合作联盟','',''],['南京农业大学','',''],['南京大学','',''],['南京大屠杀','',''],['南京大屠杀事件','',''],['南京条约','',''],['南京理工大学','',''],['南京路','',''],['南京邮电大学','',''],['南京长江大桥','',''],['南人','',''],['南侧','',''],['南充地区','',''],['南关','',''],['南冕座','',''],['南军','',''],['南冰洋','',''],['南凉','',''],['南化','',''],['南化乡','',''],['南北','',''],['南北战争','',''],['南北方','',''],['南北朝','',''],['南北极','',''],['南北美','',''],['南北议和','',''],['南北长','',''],['南北韩','',''],['南十字座','',''],['南半球','',''],['南华早报','',''],['南华经','',''],['南南合作','',''],['南卡罗来纳','',''],['南卡罗来纳州','',''],['南史','',''],['南向','',''],['南味','',''],['南唐','',''],['南回归线','',''],['南回线','',''],['南园','',''],['南国','',''],['南国风光','',''],['南坡','',''],['南坪','',''],['南大','',''],['南天竹','',''],['南天门','',''],['南太平洋','',''],['南奥塞梯','',''],['南宁地区','',''],['南安普敦','',''],['南宋','',''],['南定','',''],['南寒带','',''],['南屯区','',''],['南山','',''],['南山可移','',''],['南山矿区','',''],['南山隐约','',''],['南岔','',''],['南岗','',''],['南岛','',''],['南岛民族','',''],['南岭','',''],['南岳','',''],['南岸','',''],['南川区','',''],['南州','',''],['南州乡','',''],['南州冠冕','',''],['南巡','',''],['南市','',''],['南希','',''],['南平地区','',''],['南庄','',''],['南庄乡','',''],['南开','',''],['南开大学','',''],['南式','',''],['南征','',''],['南征北伐','',''],['南征北战','',''],['南征北讨','',''],['南戏','',''],['南拳','',''],['南拳妈妈','',''],['南斗','',''],['南斯拉夫','',''],['南方','',''],['南方人','',''],['南方周末','',''],['南方澳渔港','',''],['南无','',''],['南昌起义','',''],['南明','',''],['南普陀寺','',''],['南曲','',''],['南朝','',''],['南朝宋','',''],['南朝梁','',''],['南朝陈','',''],['南朝鲜','',''],['南朝齐','',''],['南来','',''],['南极','',''],['南极区','',''],['南极圈','',''],['南极座','',''],['南极洲','',''],['南极洲半岛','',''],['南枣','',''],['南柯一梦','',''],['南桐矿区','',''],['南梆子','',''],['南楼','',''],['南橘北枳','',''],['南欧','',''],['南欧人','',''],['南段','',''],['南汇','',''],['南汉','',''],['南沙','',''],['南沙区','',''],['南泥湾','',''],['南洋','',''],['南洋商报','',''],['南洋杉','',''],['南洋理工大学','',''],['南洋群岛','',''],['南派螳螂','',''],['南浔','',''],['南浦','',''],['南浦市','',''],['南海','',''],['南海子','',''],['南海舰队','',''],['南海诸岛','',''],['南温带','',''],['南港','',''],['南港区','',''],['南湖','',''],['南湖区','',''],['南澳乡','',''],['南澳大利亚州','',''],['南澳岛','',''],['南燕','',''],['南特','',''],['南瓜','',''],['南瓜子','',''],['南瓜灯','',''],['南疆','',''],['南盟','',''],['南票','',''],['南端','',''],['南竹','',''],['南竿','',''],['南竿乡','',''],['南箕北斗','',''],['南纬','',''],['南线','',''],['南美','',''],['南美梨','',''],['南美洲','',''],['南美鹰','',''],['南胡','',''],['南胶河','',''],['南腔北调','',''],['南至','',''],['南航','',''],['南芬','',''],['南苑','',''],['南荷兰','',''],['南蛮','',''],['南行','',''],['南街','',''],['南西诸岛','',''],['南诏','',''],['南诏国','',''],['南谯','',''],['南货','',''],['南赡部洲','',''],['南越','',''],['南路','',''],['南辕北辙','',''],['南边','',''],['南边儿','',''],['南达科他','',''],['南达科他州','',''],['南进','',''],['南进政策','',''],['南迦巴瓦峰','',''],['南通地区','',''],['南郊','',''],['南部人','',''],['南部非洲','',''],['南郭','',''],['南针','',''],['南长','',''],['南门','',''],['南门二','',''],['南阮北阮','',''],['南阳县','',''],['南阳地区','',''],['南非洲','',''],['南非语','',''],['南面','',''],['南面百城','',''],['南韩','',''],['南风','',''],['南风不竞','',''],['南飞过冬','',''],['南鱼座','',''],['南鹞北鹰','',''],['南麓','',''],['南齐','',''],['南齐书','',''],['博个知今','',''],['博伊西','',''],['博动','',''],['博友','',''],['博取','',''],['博古','',''],['博古通今','',''],['博士','',''],['博士买驴','',''],['博士后','',''],['博士头衔','',''],['博士学位','',''],['博士山','',''],['博士生','',''],['博大','',''],['博大精深','',''],['博奕','',''],['博如大海','',''],['博学','',''],['博学多才','',''],['博学多闻','',''],['博学洽闻','',''],['博客','',''],['博客写手','',''],['博客圈','',''],['博客话剧','',''],['博尔塔拉','',''],['博尔德','',''],['博尔赫斯','',''],['博尔顿','',''],['博山','',''],['博帕尔','',''],['博弈','',''],['博弈者','',''],['博弈论','',''],['博引','',''],['博彩','',''],['博得','',''],['博德','',''],['博文','',''],['博文约礼','',''],['博斗','',''],['博斯普鲁斯海峡','',''],['博斯沃思','',''],['博斯腾湖','',''],['博施济众','',''],['博格','',''],['博格多','',''],['博格多汗宫','',''],['博格达山脉','',''],['博格达峰','',''],['博洛尼亚','',''],['博爱者','',''],['博物','',''],['博物多闻','',''],['博物学家','',''],['博物洽闻','',''],['博物院','',''],['博物馆','',''],['博物馆学','',''],['博登湖','',''],['博福斯','',''],['博美犬','',''],['博而不精','',''],['博茨瓦那','',''],['博蒂','',''],['博蒙特','',''],['博览','',''],['博览会','',''],['博讯','',''],['博识','',''],['博识多通','',''],['博识洽闻','',''],['博采','',''],['博采众家之长','',''],['博采众长','',''],['博采各家之长','',''],['博闻','',''],['博闻多识','',''],['博闻强志','',''],['博闻强记','',''],['博闻强识','',''],['博雅','',''],['博鳌','',''],['博鳌亚洲论坛','',''],['博鳌镇','',''],['卜卜米','',''],['卜占','',''],['卜占官','',''],['卜卦','',''],['卜夜卜昼','',''],['卜宅','',''],['卜居','',''],['卜征','',''],['卜昼卜夜','',''],['卜术','',''],['卜甲','',''],['卜筮','',''],['卜算','',''],['卜课','',''],['卜辞','',''],['卜问','',''],['卜骨','',''],['卟吩','',''],['卟啉','',''],['卟通','',''],['占上风','',''],['占下风','',''],['占为己有','',''],['占主导地位','',''],['占了','',''],['占人口总数','',''],['占优','',''],['占优势','',''],['占位','',''],['占位符','',''],['占位置','',''],['占住','',''],['占便宜','',''],['占兆','',''],['占先','',''],['占公家便宜','',''],['占到','',''],['占卜','',''],['占卜者','',''],['占卦','',''],['占压','',''],['占去','',''],['占地','',''],['占地位','',''],['占地儿','',''],['占地方','',''],['占地面积','',''],['占城','',''],['占婆','',''],['占尽','',''],['占据','',''],['占据者','',''],['占族','',''],['占星','',''],['占星学','',''],['占星家','',''],['占星师','',''],['占星术','',''],['占有','',''],['占有一席之地','',''],['占有人','',''],['占有物','',''],['占有率','',''],['占有者','',''],['占有量','',''],['占板','',''],['占梦','',''],['占满','',''],['占用','',''],['占着','',''],['占线','',''],['占著','',''],['占课','',''],['占领','',''],['占领军','',''],['占领区','',''],['占领市场','',''],['占领者','',''],['卡丁车','',''],['卡上','',''],['卡乐星','',''],['卡人','',''],['卡介苗','',''],['卡仙尼','',''],['卡位','',''],['卡住','',''],['卡其','',''],['卡其布','',''],['卡其色','',''],['卡具','',''],['卡内基','',''],['卡内基梅隆大学','',''],['卡农','',''],['卡利亚里','',''],['卡利卡特','',''],['卡利多尼亚','',''],['卡利科','',''],['卡匣','',''],['卡哇伊','',''],['卡嗒声','',''],['卡嚓','',''],['卡圈','',''],['卡在','',''],['卡塔尔人','',''],['卡塔尼亚','',''],['卡塔赫纳','',''],['卡壳','',''],['卡夫','',''],['卡夫卡','',''],['卡奴','',''],['卡子','',''],['卡宾枪','',''],['卡尔','',''],['卡尔・马克思','',''],['卡尔加里','',''],['卡尔巴拉','',''],['卡尔德龙','',''],['卡尔扎伊','',''],['卡尔文','',''],['卡尔文克莱因','',''],['卡尔斯鲁厄','',''],['卡尔顿','',''],['卡尺','',''],['卡尼丁','',''],['卡巴','',''],['卡巴斯基','',''],['卡巴胂','',''],['卡巴莱','',''],['卡布其诺','',''],['卡布其诺咖啡','',''],['卡布奇诺','',''],['卡帕','',''],['卡带','',''],['卡式','',''],['卡弹','',''],['卡恩','',''],['卡扎菲','',''],['卡拉什尼科夫','',''],['卡拉奇','',''],['卡拉奇那','',''],['卡拉姆昌德','',''],['卡拉季奇','',''],['卡拉布里亚','',''],['卡拉比拉','',''],['卡拉胶','',''],['卡拉马佐夫兄弟','',''],['卡擦','',''],['卡文迪什','',''],['卡斯特利翁','',''],['卡斯特罗','',''],['卡斯翠','',''],['卡斯蒂利亚','',''],['卡斯蒂利亚・莱昂','',''],['卡方','',''],['卡昂','',''],['卡桑德拉','',''],['卡梅伦','',''],['卡死','',''],['卡油','',''],['卡波耶拉','',''],['卡波西氏肉瘤','',''],['卡洛娜','',''],['卡洛斯','',''],['卡片','',''],['卡片盒','',''],['卡特','',''],['卡特尔','',''],['卡特彼勒公司','',''],['卡瓦格博峰','',''],['卡盘','',''],['卡答声','',''],['卡索','',''],['卡紧','',''],['卡纳塔克邦','',''],['卡纳维尔角','',''],['卡纳维拉尔角','',''],['卡纸','',''],['卡罗利纳','',''],['卡美拉','',''],['卡美洛','',''],['卡脖子','',''],['卡脖旱','',''],['卡萨布兰卡','',''],['卡西尼','',''],['卡西欧','',''],['卡西米尔效应','',''],['卡西莫夫','',''],['卡规','',''],['卡路里','',''],['卡车','',''],['卡达','',''],['卡通','',''],['卡钳','',''],['卡门','',''],['卡门柏乳酪','',''],['卡门贝','',''],['卢克索','',''],['卢卡','',''],['卢卡斯','',''],['卢卡申科','',''],['卢因','',''],['卢塞恩','',''],['卢安达','',''],['卢布','',''],['卢布尔雅那','',''],['卢循起义','',''],['卢梭','',''],['卢森堡人','',''],['卢森堡市','',''],['卢武铉','',''],['卢比','',''],['卢比安纳','',''],['卢沟桥','',''],['卢沟桥事变','',''],['卢泰愚','',''],['卢浮宫','',''],['卢湾','',''],['卢照邻','',''],['卢瑟','',''],['卢瑟福','',''],['卢瓦尔河','',''],['卢萨卡','',''],['卤代烃','',''],['卤化','',''],['卤化物','',''],['卤化银','',''],['卤味','',''],['卤壶','',''],['卤属','',''],['卤族','',''],['卤水','',''],['卤汁','',''],['卤法','',''],['卤田','',''],['卤素','',''],['卤肉','',''],['卤莽','',''],['卤莽灭裂','',''],['卤菜','',''],['卤虾','',''],['卤虾油','',''],['卤蛋','',''],['卤质','',''],['卤过鱼','',''],['卤钨灯','',''],['卤面','',''],['卤鸡','',''],['卦义','',''],['卦算','',''],['卦辞','',''],['卧下','',''],['卧不安','',''],['卧不安席','',''],['卧不安枕','',''],['卧位','',''],['卧佛','',''],['卧倒','',''],['卧具','',''],['卧内','',''],['卧地','',''],['卧姿','',''],['卧室','',''],['卧床','',''],['卧床不起','',''],['卧底','',''],['卧式','',''],['卧房','',''],['卧推','',''],['卧旗息鼓','',''],['卧果儿','',''],['卧椅','',''],['卧榻','',''],['卧榻之侧','',''],['卧游','',''],['卧狼当道','',''],['卧病','',''],['卧病在床','',''],['卧舱','',''],['卧薪尝胆','',''],['卧虎','',''],['卧虎藏龙','',''],['卧谈','',''],['卧车','',''],['卧车铺','',''],['卧轨','',''],['卧铺','',''],['卧雪眠霜','',''],['卧鼓偃旗','',''],['卧龙','',''],['卧龙大熊猫保护区','',''],['卧龙自然保护区','',''],['卫东','',''],['卫兵','',''],['卫冕','',''],['卫冕者','',''],['卫国','',''],['卫城','',''],['卫士','',''],['卫奕信','',''],['卫尉','',''],['卫戍','',''],['卫戍区','',''],['卫戍部队','',''],['卫护','',''],['卫报','',''],['卫拉特','',''],['卫星','',''],['卫星云图','',''],['卫星侦察','',''],['卫星国','',''],['卫星图','',''],['卫星图像','',''],['卫星地面站','',''],['卫星城','',''],['卫星定位系统','',''],['卫星导航','',''],['卫星导航系统','',''],['卫星电视','',''],['卫星通信','',''],['卫校','',''],['卫氏朝鲜','',''],['卫浴','',''],['卫满朝鲜','',''],['卫滨','',''],['卫理公会','',''],['卫生','',''],['卫生保健','',''],['卫生动员','',''],['卫生勤务','',''],['卫生厅','',''],['卫生员','',''],['卫生学','',''],['卫生官员','',''],['卫生局','',''],['卫生巾','',''],['卫生带','',''],['卫生所','',''],['卫生条件','',''],['卫生棉','',''],['卫生棉条','',''],['卫生球','',''],['卫生用纸','',''],['卫生纸','',''],['卫生组织','',''],['卫生署','',''],['卫生衣','',''],['卫生裤','',''],['卫生设备','',''],['卫生部','',''],['卫生间','',''],['卫生防疫','',''],['卫生院','',''],['卫生陶瓷','',''],['卫留成','',''],['卫矛','',''],['卫舰','',''],['卫视','',''],['卫道','',''],['卫道士','',''],['卫队','',''],['卯兔','',''],['卯榫','',''],['卯眼','',''],['印上','',''],['印中','',''],['印之','',''],['印书','',''],['印于','',''],['印件','',''],['印信','',''],['印像','',''],['印像派','',''],['印出','',''],['印制','',''],['印制电路','',''],['印制电路板','',''],['印刷','',''],['印刷业','',''],['印刷体','',''],['印刷厂','',''],['印刷品','',''],['印刷学','',''],['印刷工','',''],['印刷店','',''],['印刷所','',''],['印刷术','',''],['印刷机','',''],['印刷版','',''],['印刷物','',''],['印刷电路','',''],['印刷电路板','',''],['印刷者','',''],['印加','',''],['印加人','',''],['印发','',''],['印古什','',''],['印台','',''],['印地安纳','',''],['印地安纳州','',''],['印地语','',''],['印堂','',''],['印妥','',''],['印子','',''],['印子钱','',''],['印字','',''],['印字机','',''],['印尼','',''],['印尼币','',''],['印尼盾','',''],['印巴','',''],['印度人','',''],['印度人民党','',''],['印度兵','',''],['印度半岛','',''],['印度国大党','',''],['印度尼西亚语','',''],['印度巴基斯坦战争','',''],['印度支那','',''],['印度支那半岛','',''],['印度教','',''],['印度教徒','',''],['印度斯坦','',''],['印度时报','',''],['印度橡胶树','',''],['印度民族大起义','',''],['印度河','',''],['印度洋','',''],['印度眼镜蛇','',''],['印度航空公司','',''],['印度袄','',''],['印度音乐','',''],['印度鬼椒','',''],['印张','',''],['印成','',''],['印戒','',''],['印戳','',''],['印把子','',''],['印支','',''],['印支半岛','',''],['印支期','',''],['印数','',''],['印有','',''],['印本','',''],['印染','',''],['印次','',''],['印欧人','',''],['印欧文','',''],['印欧语','',''],['印欧语系','',''],['印欧语言','',''],['印江','',''],['印江县','',''],['印油','',''],['印泥','',''],['印片','',''],['印版','',''],['印玺','',''],['印画','',''],['印痕','',''],['印盒','',''],['印相','',''],['印相纸','',''],['印章','',''],['印第安','',''],['印第安人','',''],['印第安座','',''],['印第安纳','',''],['印第安纳州','',''],['印第安纳波利斯','',''],['印第安语','',''],['印累绶若','',''],['印纸','',''],['印纽','',''],['印绶','',''],['印航','',''],['印色','',''],['印花','',''],['印花厂','',''],['印花布','',''],['印花税','',''],['印行','',''],['印表','',''],['印表机','',''],['印记','',''],['印证','',''],['印谱','',''],['印象','',''],['印象主义','',''],['印象派','',''],['印象深刻','',''],['印迹','',''],['印鉴','',''],['印钞票','',''],['印钮','',''],['印错','',''],['印页','',''],['印鼠客蚤','',''],['印鼻','',''],['危于累卵','',''],['危亡','',''],['危及','',''],['危困','',''],['危在旦夕','',''],['危地','',''],['危地马拉人','',''],['危城','',''],['危境','',''],['危如朝露','',''],['危如累卵','',''],['危害','',''],['危害性','',''],['危害评价','',''],['危局','',''],['危岩','',''],['危径','',''],['危急','',''],['危性','',''],['危惧','',''],['危房','',''],['危房改造','',''],['危改','',''],['危旧房','',''],['危旧房屋','',''],['危机','',''],['危机四伏','',''],['危机感','',''],['危楼','',''],['危殆','',''],['危浅','',''],['危笃','',''],['危而不持','',''],['危若朝露','',''],['危言','',''],['危言危行','',''],['危言正色','',''],['危言耸听','',''],['危言谠论','',''],['危语','',''],['危辞耸听','',''],['危迫','',''],['危途','',''],['危重','',''],['危重病人','',''],['危险','',''],['危险区','',''],['危险品','',''],['危险性','',''],['危险期','',''],['危险物','',''],['危险物品','',''],['危险警告灯','',''],['危难','',''],['即丢','',''],['即为','',''],['即从','',''],['即付','',''],['即付即打','',''],['即令','',''],['即以其人之道','',''],['即位','',''],['即使','',''],['即使是','',''],['即便','',''],['即兴','',''],['即兴之作','',''],['即兴发挥','',''],['即兴而作','',''],['即刻','',''],['即化','',''],['即发','',''],['即可','',''],['即告','',''],['即回','',''],['即在','',''],['即地','',''],['即如','',''],['即对','',''],['即将','',''],['即将来临','',''],['即属','',''],['即已','',''],['即席','',''],['即弃','',''],['即得','',''],['即或','',''],['即扔','',''],['即把','',''],['即指','',''],['即按','',''],['即插即用','',''],['即日','',''],['即早','',''],['即时','',''],['即时即地','',''],['即时通讯','',''],['即是','',''],['即景','',''],['即景生情','',''],['即有','',''],['即期','',''],['即止','',''],['即溶咖啡','',''],['即用','',''],['即由','',''],['即纳','',''],['即若','',''],['即表示','',''],['即被','',''],['即要','',''],['即论','',''],['即逝','',''],['即那','',''],['即食','',''],['即鹿无虞','',''],['却不','',''],['却为','',''],['却之不恭','',''],['却也','',''],['却倒','',''],['却其','',''],['却可','',''],['却向','',''],['却因','',''],['却在','',''],['却已','',''],['却才','',''],['却把','',''],['却是','',''],['却有','',''],['却步','',''],['却病','',''],['却病延年','',''],['却给','',''],['却能','',''],['却被','',''],['却要','',''],['却见','',''],['却说','',''],['却象','',''],['卵与石斗','',''],['卵圆','',''],['卵圆形','',''],['卵圆窗','',''],['卵块','',''],['卵壳','',''],['卵子','',''],['卵巢','',''],['卵巢炎','',''],['卵巢窝','',''],['卵形','',''],['卵形物','',''],['卵模','',''],['卵母细胞','',''],['卵泡','',''],['卵生','',''],['卵用鸡','',''],['卵白','',''],['卵石','',''],['卵磷脂','',''],['卵精巢','',''],['卵细胞','',''],['卵翼','',''],['卵胎生','',''],['卵膜','',''],['卵裂','',''],['卵黄','',''],['卵黄囊','',''],['卵黄管','',''],['卵黄腺','',''],['卷上','',''],['卷云','',''],['卷儿','',''],['卷入','',''],['卷册','',''],['卷刃','',''],['卷动','',''],['卷发','',''],['卷发器','',''],['卷发纸','',''],['卷叶蛾','',''],['卷吸作用','',''],['卷回','',''],['卷土重来','',''],['卷地皮','',''],['卷头','',''],['卷子','',''],['卷宗','',''],['卷尺','',''],['卷层云','',''],['卷巴','',''],['卷布','',''],['卷帆索','',''],['卷帘门','',''],['卷帙','',''],['卷帙浩繁','',''],['卷带','',''],['卷开','',''],['卷心','',''],['卷心菜','',''],['卷成','',''],['卷扬','',''],['卷扬机','',''],['卷收','',''],['卷旗息鼓','',''],['卷曲','',''],['卷有','',''],['卷标','',''],['卷毛','',''],['卷浪','',''],['卷烟','',''],['卷烟厂','',''],['卷片','',''],['卷着','',''],['卷积云','',''],['卷笔刀','',''],['卷筒','',''],['卷紧','',''],['卷纸','',''],['卷纸烟','',''],['卷线器','',''],['卷绕','',''],['卷缩','',''],['卷缩了','',''],['卷缩成','',''],['卷缩状','',''],['卷缩者','',''],['卷舌','',''],['卷舌元音','',''],['卷舌音','',''],['卷装','',''],['卷裹','',''],['卷走','',''],['卷起','',''],['卷起来','',''],['卷轴','',''],['卷轴装','',''],['卷边','',''],['卷过','',''],['卷进','',''],['卷逃','',''],['卷铺盖','',''],['卷铺盖走人','',''],['卷须','',''],['卷饼','',''],['卷首','',''],['卸上','',''],['卸下','',''],['卸下船','',''],['卸任','',''],['卸去','',''],['卸套','',''],['卸妆','',''],['卸掉','',''],['卸桥','',''],['卸煤机','',''],['卸磨杀驴','',''],['卸职','',''],['卸肩','',''],['卸肩儿','',''],['卸脱','',''],['卸装','',''],['卸责','',''],['卸货','',''],['卸货人','',''],['卸车','',''],['卸载','',''],['卸除','',''],['卸鞍','',''],['卺饮','',''],['卿卿','',''],['卿卿我我','',''],['卿士','',''],['卿大夫','',''],['卿相','',''],['卿鱼','',''],['厂丝','',''],['厂主','',''],['厂休','',''],['厂内','',''],['厂办','',''],['厂区','',''],['厂史','',''],['厂名','',''],['厂商','',''],['厂地','',''],['厂址','',''],['厂外','',''],['厂子','',''],['厂字旁','',''],['厂家','',''],['厂工','',''],['厂房','',''],['厂方','',''],['厂校挂钩','',''],['厂棚','',''],['厂牌','',''],['厂矿','',''],['厂矿企业','',''],['厂礼拜','',''],['厂级','',''],['厂装','',''],['厂规','',''],['厂部','',''],['厂里','',''],['厂长','',''],['厂长负责制','',''],['厄什塔','',''],['厄勒海峡','',''],['厄尔','',''],['厄尔尼诺','',''],['厄尔尼诺现象','',''],['厄尔布鲁士','',''],['厄洛斯','',''],['厄运','',''],['厄难','',''],['厅事','',''],['厅堂','',''],['厅局','',''],['厅局级','',''],['厅局长','',''],['厅房','',''],['厅里','',''],['厅长','',''],['历下','',''],['历久','',''],['历久弥坚','',''],['历书','',''],['历代','',''],['历代志上','',''],['历代志下','',''],['历任','',''],['历历','',''],['历历可数','',''],['历历可见','',''],['历历可辨','',''],['历历在目','',''],['历历如绘','',''],['历历落落','',''],['历史','',''],['历史上','',''],['历史主义','',''],['历史久远','',''],['历史事件','',''],['历史人物','',''],['历史剧','',''],['历史博物馆','',''],['历史唯心主义','',''],['历史唯物主义','',''],['历史学','',''],['历史学家','',''],['历史家','',''],['历史循环论','',''],['历史性','',''],['历史总在重演','',''],['历史悠久','',''],['历史意义','',''],['历史成本','',''],['历史新高','',''],['历史时期','',''],['历史条件下','',''],['历史沿革','',''],['历史版本','',''],['历史画','',''],['历史背景','',''],['历史观','',''],['历史观点','',''],['历史遗产','',''],['历史遗迹','',''],['历城','',''],['历尽','',''],['历尽沧桑','',''],['历届','',''],['历年','',''],['历数','',''],['历日旷久','',''],['历时','',''],['历朝','',''],['历朝通俗演义','',''],['历本','',''],['历来','',''],['历来最低点','',''],['历次','',''],['历法','',''],['历程','',''],['历练','',''],['历练老成','',''],['历经','',''],['历经沧桑','',''],['历经磨难','',''],['历象','',''],['历险','',''],['厉兵秣马','',''],['厉兵粟马','',''],['厉声','',''],['厉害','',''],['厉目而视','',''],['厉精图治','',''],['厉精更始','',''],['厉精求治','',''],['厉色','',''],['厉行','',''],['厉行节约','',''],['厉鬼','',''],['压上','',''],['压下','',''],['压不碎','',''],['压仰','',''],['压价','',''],['压低','',''],['压住','',''],['压倒','',''],['压倒一切','',''],['压倒元白','',''],['压倒多数','',''],['压倒性','',''],['压光','',''],['压光机','',''],['压克力','',''],['压出','',''],['压制','',''],['压制性','',''],['压力','',''],['压力容器','',''],['压力强度','',''],['压力机','',''],['压力表','',''],['压力计','',''],['压力锅','',''],['压印','',''],['压卷','',''],['压压','',''],['压压脚','',''],['压压脚儿','',''],['压台戏','',''],['压圈','',''],['压在','',''],['压在心底','',''],['压坏','',''],['压垮','',''],['压埋','',''],['压境','',''],['压宝','',''],['压寨','',''],['压岁','',''],['压岁钱','',''],['压差','',''],['压帐','',''],['压平','',''],['压延','',''],['压弯','',''],['压强','',''],['压后','',''],['压惊','',''],['压成','',''],['压扁','',''],['压抑','',''],['压抑感','',''],['压担子','',''],['压挤','',''],['压敏电阻器','',''],['压服','',''],['压机','',''],['压条','',''],['压板','',''],['压枝','',''],['压根','',''],['压根儿','',''],['压榨','',''],['压榨器','',''],['压榨机','',''],['压气','',''],['压气机','',''],['压烂','',''],['压电','',''],['压电体','',''],['压电效应','',''],['压电现象','',''],['压痕','',''],['压痛','',''],['压皱','',''],['压着','',''],['压破','',''],['压碎','',''],['压秤','',''],['压紧','',''],['压纹','',''],['压线','',''],['压缩','',''],['压缩器','',''],['压缩机','',''],['压缩比','',''],['压缩疗法','',''],['压缩空气','',''],['压而不服','',''],['压脚','',''],['压舌板','',''],['压花','',''],['压蒜器','',''],['压蔓','',''],['压路','',''],['压路机','',''],['压车','',''],['压轴好戏','',''],['压轴子','',''],['压轴戏','',''],['压迫','',''],['压迫者','',''],['压逼','',''],['压铸','',''],['压队','',''],['压阵','',''],['压青','',''],['压韵','',''],['压顶','',''],['压顶石','',''],['厌世','',''],['厌世观','',''],['厌倦','',''],['厌学','',''],['厌弃','',''],['厌恨','',''],['厌恶','',''],['厌恶人类者','',''],['厌战','',''],['厌新','',''],['厌旧','',''],['厌气','',''],['厌氧','',''],['厌氧性','',''],['厌氧菌','',''],['厌烦','',''],['厌腻','',''],['厌薄','',''],['厌酷球孢子菌','',''],['厌难折冲','',''],['厌食','',''],['厕具','',''],['厕坑','',''],['厕所','',''],['厕纸','',''],['厕身','',''],['厗奚','',''],['厘克','',''],['厘升','',''],['厘卡','',''],['厘定','',''],['厘正','',''],['厘清','',''],['厘米','',''],['厘米波','',''],['厘金','',''],['厚了','',''],['厚今薄古','',''],['厚养薄葬','',''],['厚利','',''],['厚厚','',''],['厚古薄今','',''],['厚味','',''],['厚味腊毒','',''],['厚墩墩','',''],['厚外套','',''],['厚实','',''],['厚底','',''],['厚度','',''],['厚待','',''],['厚德载物','',''],['厚德载福','',''],['厚德重义','',''],['厚恩','',''],['厚意','',''],['厚报','',''],['厚敛','',''],['厚望','',''],['厚朴','',''],['厚板','',''],['厚此','',''],['厚此薄彼','',''],['厚死薄生','',''],['厚漆','',''],['厚爱','',''],['厚片','',''],['厚生劳动省','',''],['厚生相','',''],['厚生省','',''],['厚的','',''],['厚皮','',''],['厚皮菜','',''],['厚着','',''],['厚着脸皮','',''],['厚礼','',''],['厚禄','',''],['厚禄高官','',''],['厚积薄发','',''],['厚纸','',''],['厚绒布','',''],['厚脸','',''],['厚脸皮','',''],['厚膜电路','',''],['厚舌','',''],['厚葬','',''],['厚薄','',''],['厚薄规','',''],['厚角','',''],['厚谊','',''],['厚貌深情','',''],['厚赐','',''],['厚边','',''],['厚达','',''],['厚运','',''],['厚道','',''],['厚重','',''],['厚颜','',''],['厚颜无耻','',''],['厝火积薪','',''],['厝薪于火','',''],['原为','',''],['原主','',''],['原义','',''],['原义是','',''],['原产','',''],['原产国','',''],['原产地','',''],['原人','',''],['原以','',''],['原以为','',''],['原件','',''],['原价','',''],['原任','',''],['原位','',''],['原住','',''],['原住民','',''],['原住民族','',''],['原体','',''],['原作','',''],['原作者','',''],['原值','',''],['原先','',''],['原函数','',''],['原则','',''],['原则上','',''],['原则性','',''],['原则立场','',''],['原则通过','',''],['原则问题','',''],['原创','',''],['原创性','',''],['原判','',''],['原动','',''],['原动力','',''],['原单位','',''],['原南斯拉夫','',''],['原原本本','',''],['原发性进行性失语','',''],['原名','',''],['原告','',''],['原味','',''],['原因','',''],['原因论','',''],['原图','',''],['原地','',''],['原地区','',''],['原地踏步','',''],['原场','',''],['原址','',''],['原型','',''],['原声','',''],['原处','',''],['原始','',''],['原始公社','',''],['原始公社所有制','',''],['原始反终','',''],['原始林','',''],['原始森林','',''],['原始热带雨林','',''],['原始状','',''],['原始社会','',''],['原始积累','',''],['原始群','',''],['原始要终','',''],['原始见终','',''],['原委','',''],['原子','',''],['原子操作','',''],['原子价','',''],['原子半径','',''],['原子反应堆','',''],['原子团','',''],['原子堆','',''],['原子学','',''],['原子尘','',''],['原子序数','',''],['原子弹','',''],['原子数','',''],['原子时','',''],['原子核','',''],['原子核物理学','',''],['原子武器','',''],['原子炉','',''],['原子炸弹','',''],['原子爆弹','',''],['原子爆破弹药','',''],['原子物理学','',''],['原子科学家','',''],['原子科学家通报','',''],['原子秒','',''],['原子笔','',''],['原子能','',''],['原子能化学','',''],['原子能发电','',''],['原子能发电站','',''],['原子论','',''],['原子说','',''],['原子质量','',''],['原子量','',''],['原子钟','',''],['原定','',''],['原审','',''],['原宥','',''],['原封','',''],['原封不动','',''],['原就','',''],['原居','',''],['原属','',''],['原州','',''],['原形','',''],['原形毕露','',''],['原性','',''],['原意','',''],['原成','',''],['原户籍','',''],['原指','',''],['原故','',''],['原文','',''],['原料','',''],['原料价格','',''],['原旧','',''],['原是','',''],['原有','',''],['原木','',''],['原本','',''],['原材料','',''],['原来','',''],['原极','',''],['原样','',''],['原核','',''],['原核生物','',''],['原核生物界','',''],['原核细胞','',''],['原核细胞型微生物','',''],['原核质','',''],['原案','',''],['原棉','',''],['原款','',''],['原殖民','',''],['原汁','',''],['原汁原味','',''],['原油','',''],['原点','',''],['原点矩','',''],['原煤','',''],['原爆','',''],['原爆点','',''],['原版','',''],['原物','',''],['原物料','',''],['原状','',''],['原班','',''],['原班人马','',''],['原理','',''],['原生','',''],['原生代','',''],['原生体','',''],['原生动物','',''],['原生生物','',''],['原生矿物','',''],['原生质','',''],['原田','',''],['原由','',''],['原电池','',''],['原盐','',''],['原石器','',''],['原矿','',''],['原码','',''],['原种','',''],['原税','',''],['原稿','',''],['原稿纸','',''],['原籍','',''],['原粮','',''],['原糖','',''],['原索动物','',''],['原纤维','',''],['原级','',''],['原线圈','',''],['原罪','',''],['原职','',''],['原色','',''],['原苏联','',''],['原著','',''],['原虫','',''],['原被告','',''],['原装','',''],['原计划','',''],['原订','',''],['原设','',''],['原证','',''],['原诉','',''],['原诗','',''],['原话','',''],['原谅','',''],['原貌','',''],['原质','',''],['原路','',''],['原载','',''],['原速','',''],['原道','',''],['原配','',''],['原酶','',''],['原野','',''],['原鸽','',''],['厢式车','',''],['厢房','',''],['厦门大学','',''],['厨余','',''],['厨具','',''],['厨卫','',''],['厨司','',''],['厨娘','',''],['厨子','',''],['厨师','',''],['厨师长','',''],['厨房','',''],['厨手','',''],['厨柜','',''],['厨灶','',''],['厩肥','',''],['厮守','',''],['厮打','',''],['厮搏','',''],['厮敬厮爱','',''],['厮杀','',''],['厮混','',''],['厮熟','',''],['厮缠','',''],['厮锣','',''],['去上学','',''],['去世','',''],['去乡村','',''],['去了','',''],['去伪存真','',''],['去作','',''],['去你的','',''],['去使','',''],['去做','',''],['去光水','',''],['去其糟粕','',''],['去函','',''],['去划船','',''],['去办','',''],['去劣','',''],['去势','',''],['去危就安','',''],['去去','',''],['去取','',''],['去取之间','',''],['去台','',''],['去台人员','',''],['去向','',''],['去向不明','',''],['去吧','',''],['去国外','',''],['去垢','',''],['去垢剂','',''],['去声','',''],['去壳','',''],['去处','',''],['去天尺五','',''],['去头','',''],['去官','',''],['去就','',''],['去就之分','',''],['去岁','',''],['去年底','',''],['去得','',''],['去得快','',''],['去恶','',''],['去找','',''],['去抓','',''],['去拿','',''],['去拿来','',''],['去掉','',''],['去接','',''],['去无踪','',''],['去旧','',''],['去暑','',''],['去末归本','',''],['去杀胜残','',''],['去来','',''],['去核','',''],['去根','',''],['去死','',''],['去毛','',''],['去氧','',''],['去氧核糖核酸','',''],['去氧麻黄碱','',''],['去污','',''],['去污剂','',''],['去污粉','',''],['去法','',''],['去泰去甚','',''],['去湿','',''],['去火','',''],['去甚去泰','',''],['去留','',''],['去病','',''],['去皮','',''],['去看','',''],['去看戏','',''],['去硫','',''],['去磁','',''],['去磁场','',''],['去程','',''],['去粗取精','',''],['去绉','',''],['去职','',''],['去芜存菁','',''],['去角','',''],['去调节','',''],['去路','',''],['去过','',''],['去逝','',''],['去邪','',''],['去邪归正','',''],['去野餐','',''],['去除','',''],['去雄','',''],['去鳞','',''],['县上','',''],['县丞','',''],['县乡','',''],['县令','',''],['县份','',''],['县内','',''],['县办','',''],['县区','',''],['县吊','',''],['县名','',''],['县团级','',''],['县地','',''],['县城','',''],['县外','',''],['县委','',''],['县委书记','',''],['县委会','',''],['县官','',''],['县局','',''],['县属','',''],['县市','',''],['县府','',''],['县志','',''],['县政府','',''],['县河','',''],['县治','',''],['县界','',''],['县直','',''],['县直机关','',''],['县立','',''],['县级','',''],['县级市','',''],['县行','',''],['县试','',''],['县里','',''],['县镇','',''],['县长','',''],['参与','',''],['参与制','',''],['参与者','',''],['参两院','',''],['参事','',''],['参军','',''],['参军入伍','',''],['参办','',''],['参加','',''],['参加着','',''],['参加者','',''],['参加革命','',''],['参劾','',''],['参半','',''],['参参伍伍','',''],['参变','',''],['参变量','',''],['参合','',''],['参启','',''],['参商','',''],['参天','',''],['参天两地','',''],['参天贰地','',''],['参奏','',''],['参孙','',''],['参审制度','',''],['参宿','',''],['参宿七','',''],['参将','',''],['参展','',''],['参差','',''],['参差不齐','',''],['参差错落','',''],['参悟','',''],['参战','',''],['参拜','',''],['参政','',''],['参政权','',''],['参政议政','',''],['参数','',''],['参杂','',''],['参校','',''],['参演','',''],['参照','',''],['参照实行','',''],['参照物','',''],['参照系','',''],['参疑','',''],['参看','',''],['参禅','',''],['参考','',''],['参考书','',''],['参考书目','',''],['参考咨询','',''],['参考文','',''],['参考文献','',''],['参考材料','',''],['参考消息','',''],['参考系','',''],['参考资料','',''],['参股','',''],['参茸','',''],['参薯','',''],['参见','',''],['参观','',''],['参观团','',''],['参观指导','',''],['参观者','',''],['参议','',''],['参议会','',''],['参议员','',''],['参议院','',''],['参访团','',''],['参谋','',''],['参谋总长','',''],['参谋部','',''],['参谋长','',''],['参谒','',''],['参赛','',''],['参赛者','',''],['参赞','',''],['参辰卯酉','',''],['参辰日月','',''],['参选','',''],['参选人','',''],['参透','',''],['参酌','',''],['参量','',''],['参量空间','',''],['参错','',''],['参阅','',''],['参院','',''],['参预','',''],['参验','',''],['叆叆','',''],['叆叇','',''],['又一','',''],['又一个','',''],['又一次','',''],['又上','',''],['又不能','',''],['又与','',''],['又为','',''],['又从','',''],['又以','',''],['又会','',''],['又像','',''],['又到','',''],['又去','',''],['又及','',''],['又叫','',''],['又可','',''],['又名','',''],['又名为','',''],['又吵又闹','',''],['又吹','',''],['又和','',''],['又哭又闹','',''],['又因','',''],['又在','',''],['又多','',''],['又大','',''],['又好','',''],['又如','',''],['又对','',''],['又带','',''],['又弱一个','',''],['又打','',''],['又把','',''],['又拉','',''],['又搞','',''],['又放','',''],['又是','',''],['又有','',''],['又来','',''],['又来了','',''],['又比','',''],['又没','',''],['又热','',''],['又瘦','',''],['又称','',''],['又端','',''],['又红又专','',''],['又红又肿','',''],['又经','',''],['又给','',''],['又能','',''],['又被','',''],['又要','',''],['又讯','',''],['又说','',''],['又起','',''],['又都','',''],['又非','',''],['又靠','',''],['叉上','',''],['叉口','',''],['叉头','',''],['叉子','',''],['叉开','',''],['叉形','',''],['叉手','',''],['叉掉','',''],['叉架','',''],['叉烧','',''],['叉烧包','',''],['叉状','',''],['叉着','',''],['叉积','',''],['叉簧','',''],['叉腰','',''],['叉腿','',''],['叉起','',''],['叉路','',''],['叉车','',''],['叉配','',''],['及之','',''],['及其','',''],['及其他','',''],['及到','',''],['及早','',''],['及时','',''],['及时处理','',''],['及时性','',''],['及时行乐','',''],['及时雨','',''],['及格','',''],['及格线','',''],['及物','',''],['及物动词','',''],['及笄','',''],['及第','',''],['及膝','',''],['及至','',''],['及锋一试','',''],['及锋而试','',''],['及门','',''],['及龄','',''],['友人','',''],['友伴','',''],['友军','',''],['友协','',''],['友善','',''],['友好','',''],['友好人士','',''],['友好代表团','',''],['友好使者','',''],['友好关系','',''],['友好合作','',''],['友好周','',''],['友好国家','',''],['友好城市','',''],['友好往来','',''],['友好月','',''],['友好条约','',''],['友好相处','',''],['友好襄助','',''],['友好访问','',''],['友悌','',''],['友情','',''],['友派','',''],['友爱','',''],['友谊万岁','',''],['友谊地久天长','',''],['友谊天长地久','',''],['友谊峰','',''],['友谊比赛','',''],['友谊赛','',''],['友邦','',''],['友邦保险公司','',''],['友邻','',''],['友风子雨','',''],['双一','',''],['双丰收','',''],['双义','',''],['双乳','',''],['双亡','',''],['双亲','',''],['双人','',''],['双人包夹','',''],['双人床','',''],['双人房','',''],['双人滑','',''],['双人用','',''],['双人间','',''],['双份','',''],['双休','',''],['双休日','',''],['双侧','',''],['双倍','',''],['双倍体','',''],['双元音','',''],['双光气','',''],['双全','',''],['双关','',''],['双关语','',''],['双凸面','',''],['双击','',''],['双刃','',''],['双刃剑','',''],['双十','',''],['双十二事变','',''],['双十节','',''],['双双','',''],['双叙法','',''],['双台子','',''],['双号','',''],['双名','',''],['双名法','',''],['双后前兵开局','',''],['双向','',''],['双向交流','',''],['双向选择','',''],['双周','',''],['双周刊','',''],['双周期性','',''],['双响','',''],['双唇','',''],['双唇音','',''],['双唑泰栓','',''],['双喜','',''],['双喜临门','',''],['双城子','',''],['双塔','',''],['双增双节','',''],['双声','',''],['双壳类','',''],['双复磷','',''],['双头肌','',''],['双套','',''],['双子','',''],['双子叶','',''],['双子叶植物','',''],['双子座','',''],['双字','',''],['双季稻','',''],['双学位','',''],['双安','',''],['双宾语','',''],['双宿双飞','',''],['双射','',''],['双层','',''],['双层公共汽车','',''],['双层巴士','',''],['双峰驼','',''],['双工','',''],['双工器','',''],['双开','',''],['双态','',''],['双性恋','',''],['双截棍','',''],['双手','',''],['双手拉','',''],['双打','',''],['双折射','',''],['双抢','',''],['双抽','',''],['双拐','',''],['双拥','',''],['双拼','',''],['双挡','',''],['双排','',''],['双摆','',''],['双数','',''],['双料','',''],['双方','',''],['双方同意','',''],['双方面','',''],['双日','',''],['双星','',''],['双曲','',''],['双曲余割','',''],['双曲余弦','',''],['双曲抛物面','',''],['双曲拱桥','',''],['双曲正弦','',''],['双曲线','',''],['双曲线正弦','',''],['双曲面','',''],['双月','',''],['双月刊','',''],['双杠','',''],['双极','',''],['双柑斗酒','',''],['双栅极','',''],['双栖','',''],['双栖双宿','',''],['双核','',''],['双桅船','',''],['双桥','',''],['双桨','',''],['双氟','',''],['双氧','',''],['双氧水','',''],['双氯灭痛','',''],['双氯芬酸钠','',''],['双氯醇胺','',''],['双水内冷发电机','',''],['双江县','',''],['双清','',''],['双湖','',''],['双湖特别区','',''],['双溪','',''],['双溪乡','',''],['双滦','',''],['双焦点','',''],['双独','',''],['双独夫妇','',''],['双球菌','',''],['双生','',''],['双生兄弟','',''],['双百方针','',''],['双目','',''],['双目失明','',''],['双盲','',''],['双眸','',''],['双眼','',''],['双眼皮','',''],['双眼视觉','',''],['双瞳剪水','',''],['双程票','',''],['双稳态','',''],['双立人','',''],['双端','',''],['双筒','',''],['双筒望远镜','',''],['双管','',''],['双管齐下','',''],['双簧','',''],['双簧管','',''],['双糖','',''],['双线','',''],['双线性','',''],['双绞线','',''],['双缸','',''],['双翅目','',''],['双翅类','',''],['双翼','',''],['双翼飞机','',''],['双耳','',''],['双职','',''],['双职工','',''],['双股','',''],['双肩','',''],['双胎','',''],['双胞','',''],['双胞胎','',''],['双脚','',''],['双腿','',''],['双膝','',''],['双臂','',''],['双色','',''],['双节棍','',''],['双节棍道','',''],['双蕊兰','',''],['双行','',''],['双行线','',''],['双行道','',''],['双规','',''],['双角','',''],['双角犀','',''],['双解','',''],['双语','',''],['双误','',''],['双调和','',''],['双赢','',''],['双足','',''],['双身子','',''],['双轨','',''],['双轨制','',''],['双边','',''],['双边会谈','',''],['双边关系','',''],['双边合作','',''],['双边条约','',''],['双边贸易','',''],['双进双出','',''],['双连接站','',''],['双速','',''],['双重','',''],['双重人格','',''],['双重国籍','',''],['双重性','',''],['双重标准','',''],['双重目','',''],['双重身份','',''],['双重身分','',''],['双重领导','',''],['双金属','',''],['双钩','',''],['双铺','',''],['双链','',''],['双链核酸','',''],['双键','',''],['双阳','',''],['双阳极','',''],['双陆棋','',''],['双面','',''],['双音','',''],['双音节','',''],['双音频','',''],['双颊','',''],['双飞','',''],['双鬓','',''],['双鱼','',''],['双鱼座','',''],['双鸟在林一鸟在手','',''],['双龙大裂谷','',''],['双龙镇','',''],['反三角函数','',''],['反中','',''],['反中子','',''],['反串','',''],['反义','',''],['反义字','',''],['反义词','',''],['反之','',''],['反之亦然','',''],['反互换','',''],['反人类','',''],['反人类罪','',''],['反人道罪','',''],['反人道罪行','',''],['反传算法','',''],['反作用','',''],['反作用力','',''],['反例','',''],['反侦察','',''],['反侧','',''],['反侵略','',''],['反侵略战争','',''],['反修','',''],['反倒','',''],['反倾销','',''],['反光','',''],['反光镜','',''],['反光面','',''],['反党','',''],['反党集团','',''],['反共','',''],['反共主义','',''],['反共宣传','',''],['反共宣传罪','',''],['反兴奋剂','',''],['反其','',''],['反其道而行之','',''],['反冲','',''],['反冲击','',''],['反冲力','',''],['反击','',''],['反函数','',''],['反分裂法','',''],['反切','',''],['反刍','',''],['反刍动物','',''],['反刍类','',''],['反到','',''],['反剪','',''],['反力','',''],['反动','',''],['反动分子','',''],['反动势力','',''],['反动派','',''],['反华','',''],['反卫星','',''],['反卷','',''],['反压力','',''],['反去','',''],['反及','',''],['反反复复','',''],['反叛','',''],['反叛分子','',''],['反口','',''],['反右','',''],['反右派斗争','',''],['反右运动','',''],['反合围','',''],['反向','',''],['反听内视','',''],['反告','',''],['反咬','',''],['反咬一口','',''],['反响','',''],['反哺','',''],['反唇相稽','',''],['反唇相讥','',''],['反嘴','',''],['反噬','',''],['反围剿','',''],['反圣婴','',''],['反地道','',''],['反坐','',''],['反坦克','',''],['反坦克导弹','',''],['反坦克炮','',''],['反坫','',''],['反垄断','',''],['反垄断法','',''],['反基督','',''],['反复','',''],['反复不常','',''],['反复强调','',''],['反复性','',''],['反复无常','',''],['反复研究','',''],['反复证明','',''],['反季','',''],['反客为主','',''],['反密码子','',''],['反对','',''],['反对党','',''],['反对党人','',''],['反对极','',''],['反对派','',''],['反对物','',''],['反对票','',''],['反对称','',''],['反对者','',''],['反导','',''],['反导导弹','',''],['反导弹','',''],['反导系统','',''],['反封锁','',''],['反射','',''],['反射体','',''],['反射作用','',''],['反射光','',''],['反射动作','',''],['反射区治疗','',''],['反射器','',''],['反射层','',''],['反射弧','',''],['反射性','',''],['反射星云','',''],['反射比','',''],['反射波','',''],['反射炉','',''],['反射率','',''],['反射疗法','',''],['反射线','',''],['反射角','',''],['反射镜','',''],['反射面','',''],['反左','',''],['反差','',''],['反差强','',''],['反帝','',''],['反帝反封建','',''],['反常','',''],['反干扰','',''],['反序','',''],['反应','',''],['反应器','',''],['反应堆','',''],['反应堆燃料元件','',''],['反应堆芯','',''],['反应式','',''],['反应方程','',''],['反应时','',''],['反应时间','',''],['反应炉','',''],['反应热','',''],['反应物','',''],['反应者','',''],['反应迟钝','',''],['反应速度','',''],['反应锅','',''],['反建议','',''],['反式','',''],['反式脂肪','',''],['反弹','',''],['反弹导弹','',''],['反弹道','',''],['反录病毒','',''],['反影镜','',''],['反心','',''],['反思','',''],['反恐','',''],['反恐怖','',''],['反恐战争','',''],['反悔','',''],['反情报','',''],['反意','',''],['反意字','',''],['反感','',''],['反戈','',''],['反戈一击','',''],['反战','',''],['反战抗议','',''],['反战运动','',''],['反手','',''],['反手拍','',''],['反扑','',''],['反打','',''],['反托','',''],['反托拉斯','',''],['反扫荡','',''],['反批评','',''],['反抗','',''],['反抗者','',''],['反折','',''],['反折射','',''],['反掌','',''],['反接','',''],['反控','',''],['反推','',''],['反推力','',''],['反搞','',''],['反撞','',''],['反攻','',''],['反攻倒算','',''],['反攻战役','',''],['反攻日','',''],['反政变','',''],['反政府','',''],['反散射','',''],['反文旁','',''],['反斜杠','',''],['反斜线','',''],['反日','',''],['反时势','',''],['反时针','',''],['反映','',''],['反映情况','',''],['反映论','',''],['反是','',''],['反显','',''],['反本还原','',''],['反机动','',''],['反杜林论','',''],['反核','',''],['反正','',''],['反正一样','',''],['反步兵','',''],['反武装','',''],['反殖','',''],['反殖民','',''],['反毒品','',''],['反比','',''],['反比例','',''],['反气旋','',''],['反水','',''],['反水不收','',''],['反求诸己','',''],['反法西斯','',''],['反法西斯战争','',''],['反派','',''],['反清','',''],['反演','',''],['反潜','',''],['反潜机','',''],['反潜艇','',''],['反潮','',''],['反潮流','',''],['反激因','',''],['反火力','',''],['反照','',''],['反照率','',''],['反物质','',''],['反特','',''],['反犹太主义','',''],['反生物战','',''],['反用','',''],['反用换流器','',''],['反用法','',''],['反电动势','',''],['反电子','',''],['反白','',''],['反目','',''],['反目为仇','',''],['反目成仇','',''],['反相','',''],['反省','',''],['反眼不识','',''],['反知识','',''],['反码','',''],['反硝化作用','',''],['反磁性','',''],['反社会','',''],['反社会行为','',''],['反科学','',''],['反空袭','',''],['反空降','',''],['反突击','',''],['反突破','',''],['反粒子','',''],['反经合义','',''],['反经行权','',''],['反美','',''],['反而','',''],['反而是','',''],['反聘','',''],['反胃','',''],['反脚','',''],['反脸无情','',''],['反腐','',''],['反腐倡廉','',''],['反腐败','',''],['反舰导弹','',''],['反舰艇','',''],['反舰艇巡航导弹','',''],['反色','',''],['反艺术','',''],['反英','',''],['反英雄','',''],['反蚕食','',''],['反衬','',''],['反袁','',''],['反袁斗争','',''],['反袁运动','',''],['反装甲','',''],['反裘负刍','',''],['反裘负薪','',''],['反西方','',''],['反覆','',''],['反覆说','',''],['反观','',''],['反角','',''],['反言','',''],['反计','',''],['反讲','',''],['反论','',''],['反讽','',''],['反证','',''],['反证法','',''],['反诉','',''],['反诉状','',''],['反诗','',''],['反诘','',''],['反诘问','',''],['反话','',''],['反诬','',''],['反语','',''],['反语法','',''],['反调制','',''],['反调幅','',''],['反败为胜','',''],['反质子','',''],['反贪','',''],['反贪污','',''],['反贪腐','',''],['反赤道流','',''],['反走私','',''],['反跃','',''],['反跳','',''],['反身','',''],['反身代词','',''],['反躬自省','',''],['反躬自责','',''],['反躬自问','',''],['反转','',''],['反转录','',''],['反转录病毒','',''],['反转来','',''],['反转片','',''],['反转选择','',''],['反过来','',''],['反过来说','',''],['反逆','',''],['反遭','',''],['反酷刑折磨公约','',''],['反醒','',''],['反重合','',''],['反铲','',''],['反锁','',''],['反问','',''],['反问句','',''],['反问语气','',''],['反间','',''],['反间计','',''],['反间谍','',''],['反霸','',''],['反霸斗争','',''],['反面','',''],['反面人物','',''],['反面儿','',''],['反面教员','',''],['反面无情','',''],['反革命','',''],['反革命分子','',''],['反革命宣传','',''],['反革命宣传煽动罪','',''],['反革命战争','',''],['反革命政变','',''],['反革命案件','',''],['反顾','',''],['反馈','',''],['反驳','',''],['反驳者','',''],['反驳道','',''],['反骄破满','',''],['反高潮','',''],['反黄','',''],['发丝','',''],['发丧','',''],['发之','',''],['发乳','',''],['发事','',''],['发交','',''],['发亮','',''],['发人深思','',''],['发人深省','',''],['发人深醒','',''],['发付','',''],['发令','',''],['发令枪','',''],['发件人','',''],['发伪誓','',''],['发低','',''],['发作','',''],['发作性','',''],['发信','',''],['发信人','',''],['发信号','',''],['发光','',''],['发光二极体','',''],['发光二极管','',''],['发光体','',''],['发光度','',''],['发光强度','',''],['发光性','',''],['发光物','',''],['发兵','',''],['发冷','',''],['发冷光','',''],['发凡','',''],['发凡举例','',''],['发出','',''],['发出指示','',''],['发出通知','',''],['发函','',''],['发刊','',''],['发刊词','',''],['发力','',''],['发动','',''],['发动力','',''],['发动攻势','',''],['发动机','',''],['发动群众','',''],['发包','',''],['发单','',''],['发卡','',''],['发卷','',''],['发号出令','',''],['发号布令','',''],['发号施令','',''],['发否','',''],['发呆','',''],['发呕','',''],['发售','',''],['发喊连天','',''],['发喘','',''],['发嘎嘎声','',''],['发嘘','',''],['发嘘声','',''],['发嘶','',''],['发噱','',''],['发回','',''],['发型','',''],['发型师','',''],['发声','',''],['发声器','',''],['发声器官','',''],['发声法','',''],['发夹','',''],['发奋','',''],['发奋图强','',''],['发奋忘食','',''],['发奋有为','',''],['发奖','',''],['发奖仪式','',''],['发套','',''],['发奸摘隐','',''],['发妻','',''],['发威','',''],['发家','',''],['发家致富','',''],['发射','',''],['发射中','',''],['发射井','',''],['发射体','',''],['发射光谱','',''],['发射出','',''],['发射台','',''],['发射器','',''],['发射场','',''],['发射学','',''],['发射成功','',''],['发射星云','',''],['发射机','',''],['发射机应答器','',''],['发射极','',''],['发射点','',''],['发射物','',''],['发射站','',''],['发射者','',''],['发尖','',''],['发屋','',''],['发屋求狸','',''],['发展','',''],['发展中','',''],['发展中国家','',''],['发展史','',''],['发展商','',''],['发展好','',''],['发展核武器','',''],['发展的国家','',''],['发展研究中心','',''],['发展观','',''],['发展趋势','',''],['发工资','',''],['发工资日','',''],['发市','',''],['发布','',''],['发布会','',''],['发布者','',''],['发帖','',''],['发带','',''],['发干','',''],['发廊','',''],['发式','',''],['发引','',''],['发形','',''],['发往','',''],['发怒','',''],['发怔','',''],['发急','',''],['发怵','',''],['发恶臭','',''],['发恼','',''],['发悸','',''],['发情','',''],['发情期','',''],['发愁','',''],['发愣','',''],['发愤','',''],['发愤图强','',''],['发愿','',''],['发慌','',''],['发憷','',''],['发懵','',''],['发成','',''],['发扬','',''],['发扬光大','',''],['发扬成绩','',''],['发扬民主','',''],['发扬踔厉','',''],['发扬蹈厉','',''],['发抒','',''],['发抖','',''],['发报','',''],['发报人','',''],['发报机','',''],['发指','',''],['发指眦裂','',''],['发挥','',''],['发掉','',''],['发排','',''],['发掘','',''],['发放','',''],['发放贷款','',''],['发政施仁','',''],['发散','',''],['发散出','',''],['发散透镜','',''],['发文','',''],['发料','',''],['发明','',''],['发明人','',''],['发明创造','',''],['发明家','',''],['发明权','',''],['发明物','',''],['发明者','',''],['发昏','',''],['发昏章十一','',''],['发春','',''],['发晕','',''],['发暗','',''],['发条','',''],['发来','',''],['发枪','',''],['发柔','',''],['发标','',''],['发根','',''],['发案','',''],['发案率','',''],['发棵','',''],['发楞','',''],['发榜','',''],['发横财','',''],['发款员','',''],['发毛','',''],['发气','',''],['发水','',''],['发汗','',''],['发汗室','',''],['发油','',''],['发泄','',''],['发泄对象','',''],['发泡','',''],['发泡剂','',''],['发泡胶','',''],['发浊音','',''],['发源','',''],['发源地','',''],['发火','',''],['发火点','',''],['发炎','',''],['发炮','',''],['发烟','',''],['发烧','',''],['发烧友','',''],['发烫','',''],['发热','',''],['发热伴血小板减少综合征','',''],['发热器','',''],['发热量','',''],['发牌','',''],['发牌者','',''],['发牢骚','',''],['发物','',''],['发狂','',''],['发狂言','',''],['发狠','',''],['发现','',''],['发现号','',''],['发现物','',''],['发现者','',''],['发现问题','',''],['发球','',''],['发球区','',''],['发球者','',''],['发生','',''],['发生中','',''],['发生了','',''],['发生于','',''],['发生去','',''],['发生器','',''],['发生地','',''],['发生率','',''],['发电','',''],['发电厂','',''],['发电室','',''],['发电容量','',''],['发电技术','',''],['发电报','',''],['发电机','',''],['发电站','',''],['发电能力','',''],['发电量','',''],['发疯','',''],['发病','',''],['发病率','',''],['发痒','',''],['发痛','',''],['发痧','',''],['发痴','',''],['发癣','',''],['发白','',''],['发直','',''],['发短信','',''],['发短心长','',''],['发硎新试','',''],['发硬','',''],['发磷光','',''],['发神经','',''],['发祥','',''],['发祥地','',''],['发票','',''],['发福','',''],['发积','',''],['发稿','',''],['发稿时','',''],['发窘','',''],['发端','',''],['发笑','',''],['发策决科','',''],['发簪','',''],['发粉','',''],['发粘','',''],['发糕','',''],['发紫','',''],['发红','',''],['发纵指示','',''],['发绀','',''],['发结','',''],['发给','',''],['发绺','',''],['发网','',''],['发罩','',''],['发聋振聩','',''],['发育','',''],['发育不良','',''],['发育期','',''],['发育生物学','',''],['发胀','',''],['发胖','',''],['发胶','',''],['发脆','',''],['发脚','',''],['发脱口齿','',''],['发脾气','',''],['发腻','',''],['发自','',''],['发自内心','',''],['发臭','',''],['发至','',''],['发芽','',''],['发芽势','',''],['发芽率','',''],['发菜','',''],['发落','',''],['发蒙','',''],['发蒙振聩','',''],['发蒙振落','',''],['发蓝','',''],['发蔫','',''],['发薪','',''],['发薪日','',''],['发薪水','',''],['发虚','',''],['发蜡','',''],['发行','',''],['发行人','',''],['发行基金','',''],['发行备忘录','',''],['发行工作','',''],['发行红利股','',''],['发行者','',''],['发行部','',''],['发行量','',''],['发行额','',''],['发表','',''],['发表声明','',''],['发表意见','',''],['发表文章','',''],['发表演讲','',''],['发表谈话','',''],['发见','',''],['发觉','',''],['发解','',''],['发言','',''],['发言中肯','',''],['发言人','',''],['发言权','',''],['发言稿','',''],['发言者','',''],['发誓','',''],['发警报','',''],['发证','',''],['发话','',''],['发话器','',''],['发话筒','',''],['发语词','',''],['发语辞','',''],['发财','',''],['发财了','',''],['发财致富','',''],['发货','',''],['发货人','',''],['发贴','',''],['发起','',''],['发起书','',''],['发起人','',''],['发踊冲冠','',''],['发踪指示','',''],['发身','',''],['发车','',''],['发轫','',''],['发软','',''],['发辫','',''],['发达','',''],['发达国','',''],['发达国家','',''],['发达地区','',''],['发过誓','',''],['发运','',''],['发还','',''],['发迹','',''],['发送','',''],['发送功率','',''],['发送器','',''],['发送机','',''],['发送者','',''],['发配','',''],['发酒疯','',''],['发酵','',''],['发酵了','',''],['发酵剂','',''],['发酵学','',''],['发酵性','',''],['发酵法','',''],['发酵物','',''],['发酵粉','',''],['发酵饲料','',''],['发酸','',''],['发野','',''],['发钗','',''],['发问','',''],['发问者','',''],['发闷','',''],['发隐摘伏','',''],['发难','',''],['发霉','',''],['发露','',''],['发青','',''],['发面','',''],['发音','',''],['发音体','',''],['发音器官','',''],['发音法','',''],['发颤','',''],['发飘','',''],['发飙','',''],['发饰品','',''],['发饷','',''],['发香','',''],['发髻','',''],['发麻','',''],['发黄','',''],['发黑','',''],['叔丈人','',''],['叔丈母','',''],['叔伯','',''],['叔侄','',''],['叔公','',''],['叔叔','',''],['叔婆','',''],['叔婶','',''],['叔嫂','',''],['叔子','',''],['叔岳','',''],['叔本华','',''],['叔母','',''],['叔父','',''],['叔祖','',''],['叔祖母','',''],['叔舅','',''],['取下','',''],['取之','',''],['取之不保','',''],['取之不尽','',''],['取之不尽用之不竭','',''],['取之于','',''],['取乐','',''],['取书','',''],['取代','',''],['取保','',''],['取保候审','',''],['取保释放','',''],['取信','',''],['取信于民','',''],['取值','',''],['取偿','',''],['取其','',''],['取其精华','',''],['取决','',''],['取决于','',''],['取出','',''],['取刀','',''],['取去','',''],['取名','',''],['取名为','',''],['取向','',''],['取回','',''],['取尽','',''],['取巧','',''],['取得','',''],['取得一致','',''],['取得实效','',''],['取得胜利','',''],['取悦','',''],['取悦于','',''],['取才','',''],['取掉','',''],['取教','',''],['取整','',''],['取景','',''],['取景器','',''],['取暖','',''],['取材','',''],['取来','',''],['取样','',''],['取样数量','',''],['取款','',''],['取款机','',''],['取水','',''],['取法','',''],['取消','',''],['取消后','',''],['取消禁令','',''],['取消组','',''],['取火','',''],['取灯儿','',''],['取物','',''],['取用','',''],['取的','',''],['取笑','',''],['取精','',''],['取精用弘','',''],['取经','',''],['取给','',''],['取绰号','',''],['取缔','',''],['取而','',''],['取而代之','',''],['取胜','',''],['取自','',''],['取舍','',''],['取舍权','',''],['取证','',''],['取货','',''],['取费','',''],['取走','',''],['取送','',''],['取道','',''],['取钱','',''],['取银','',''],['取长补短','',''],['取闹','',''],['取阅','',''],['取青配白','',''],['取静','',''],['取齐','',''],['受不了','',''],['受业','',''],['受主','',''],['受之','',''],['受之有愧','',''],['受了','',''],['受事','',''],['受享','',''],['受人','',''],['受任','',''],['受众','',''],['受伤','',''],['受伤处','',''],['受伤害','',''],['受伤者','',''],['受住','',''],['受体','',''],['受作','',''],['受俘','',''],['受保人','',''],['受保障监督的设施','',''],['受信','',''],['受信人','',''],['受俸','',''],['受俸者','',''],['受冻','',''],['受凉','',''],['受击','',''],['受刑','',''],['受刑人','',''],['受创伤','',''],['受到','',''],['受到了','',''],['受到冲击','',''],['受到好评','',''],['受到影响','',''],['受到破坏','',''],['受到重视','',''],['受到限制','',''],['受制','',''],['受刺激','',''],['受力','',''],['受勋','',''],['受取','',''],['受后付款','',''],['受听','',''],['受命','',''],['受命于天','',''],['受困','',''],['受困惑','',''],['受够','',''],['受奉','',''],['受奖','',''],['受好评','',''],['受孕','',''],['受宠','',''],['受宠若惊','',''],['受审','',''],['受害','',''],['受害人','',''],['受害者','',''],['受寒','',''],['受封','',''],['受尊敬','',''],['受尽','',''],['受德','',''],['受性','',''],['受恐怖','',''],['受恐慌','',''],['受惊','',''],['受惊吓','',''],['受惠','',''],['受惠者','',''],['受惩罚','',''],['受戒','',''],['受打','',''],['受托','',''],['受托人','',''],['受托者','',''],['受持','',''],['受挫','',''],['受挫折','',''],['受损','',''],['受损失','',''],['受损害','',''],['受控','',''],['受控制','',''],['受援','',''],['受操纵','',''],['受支配','',''],['受敌','',''],['受救','',''],['受教','',''],['受暑','',''],['受有','',''],['受权','',''],['受格','',''],['受欢迎','',''],['受款人','',''],['受气','',''],['受气包','',''],['受治于','',''],['受治疗','',''],['受法律保护权','',''],['受洗','',''],['受洗命名','',''],['受涝','',''],['受潮','',''],['受灾','',''],['受灾地区','',''],['受灾面积','',''],['受热','',''],['受理','',''],['受用','',''],['受电弓','',''],['受病','',''],['受瘪','',''],['受益','',''],['受益不浅','',''],['受益人','',''],['受益匪浅','',''],['受益者','',''],['受看','',''],['受知','',''],['受礼','',''],['受禄','',''],['受禅','',''],['受穷','',''],['受窘','',''],['受粉','',''],['受精','',''],['受精卵','',''],['受精囊','',''],['受累','',''],['受约人','',''],['受约束','',''],['受纳','',''],['受罚','',''],['受罪','',''],['受聘','',''],['受聘于','',''],['受胎','',''],['受苦','',''],['受苦受难','',''],['受苦者','',''],['受著','',''],['受虐','',''],['受虐待','',''],['受虐狂','',''],['受血者','',''],['受让','',''],['受让人','',''],['受训','',''],['受访','',''],['受访者','',''],['受诅咒','',''],['受词','',''],['受试','',''],['受试者','',''],['受话器','',''],['受贿','',''],['受贿案','',''],['受贿罪','',''],['受贿者','',''],['受赏','',''],['受赠','',''],['受赠者','',''],['受辱','',''],['受过','',''],['受遗','',''],['受邀','',''],['受重视','',''],['受阻','',''],['受降','',''],['受降仪式','',''],['受限','',''],['受限制','',''],['受难','',''],['受难日','',''],['受难纪念','',''],['受难者','',''],['受雇','',''],['受雇用','',''],['受雇者','',''],['受霜害','',''],['受非难','',''],['受颁','',''],['受领','',''],['受领者','',''],['受骗','',''],['受骗上当','',''],['变丑','',''],['变为','',''],['变乱','',''],['变乾','',''],['变了','',''],['变了色','',''],['变产','',''],['变亮','',''],['变价','',''],['变优美','',''],['变位','',''],['变低','',''],['变体','',''],['变作','',''],['变修','',''],['变倍','',''],['变值','',''],['变做','',''],['变其','',''],['变冷','',''],['变出','',''],['变分','',''],['变分原理','',''],['变分学','',''],['变分法','',''],['变动','',''],['变化','',''],['变化万端','',''],['变化不测','',''],['变化多端','',''],['变化性','',''],['变化无常','',''],['变化无方','',''],['变化无穷','',''],['变化莫测','',''],['变卖','',''],['变卦','',''],['变危为安','',''],['变压','',''],['变压器','',''],['变厚','',''],['变去','',''],['变参','',''],['变古乱常','',''],['变名易姓','',''],['变味','',''],['变咸','',''],['变址','',''],['变址数','',''],['变坏','',''],['变坏事为好事','',''],['变声','',''],['变大','',''],['变天','',''],['变天帐','',''],['变奏','',''],['变奏曲','',''],['变好','',''],['变子','',''],['变容','',''],['变宽','',''],['变小','',''],['变少','',''],['变局','',''],['变工','',''],['变工队','',''],['变差','',''],['变干','',''],['变平','',''],['变幻','',''],['变幻不测','',''],['变幻无常','',''],['变幻莫测','',''],['变幻风云','',''],['变废为宝','',''],['变度','',''],['变异','',''],['变异型克雅氏症','',''],['变异性','',''],['变异株','',''],['变弄','',''],['变弱','',''],['变强','',''],['变形','',''],['变形虫','',''],['变形虫痢疾','',''],['变形金刚','',''],['变得','',''],['变得不同','',''],['变得复杂','',''],['变得微弱','',''],['变徵之声','',''],['变心','',''],['变态','',''],['变态反应','',''],['变态心理学','',''],['变态性','',''],['变性','',''],['变性酒精','',''],['变感器','',''],['变慢','',''],['变戏法','',''],['变成','',''],['变把戏','',''],['变换','',''],['变换器','',''],['变换式','',''],['变换群','',''],['变换设备','',''],['变故','',''],['变故易常','',''],['变数','',''],['变文','',''],['变新','',''],['变旧','',''],['变易','',''],['变星','',''],['变暖','',''],['变暗','',''],['变更','',''],['变更部署','',''],['变本','',''],['变本加厉','',''],['变来','',''],['变来变去','',''],['变松','',''],['变样','',''],['变样儿','',''],['变格','',''],['变法','',''],['变法儿','',''],['变活','',''],['变流器','',''],['变浅','',''],['变浓','',''],['变淡','',''],['变深','',''],['变清','',''],['变温','',''],['变温动物','',''],['变温层','',''],['变湿','',''],['变灰','',''],['变热','',''],['变焦','',''],['变焦距','',''],['变焦距镜头','',''],['变焦镜头','',''],['变狭','',''],['变现','',''],['变甜','',''],['变生肘腋','',''],['变电','',''],['变电所','',''],['变电站','',''],['变瘦','',''],['变白','',''],['变直','',''],['变相','',''],['变相剥削','',''],['变相涨价','',''],['变瞎','',''],['变短','',''],['变矮','',''],['变硬','',''],['变硬了','',''],['变种','',''],['变空','',''],['变窄','',''],['变粗','',''],['变紧','',''],['变红','',''],['变细','',''],['变美','',''],['变老','',''],['变者','',''],['变脆','',''],['变脏','',''],['变脸','',''],['变色','',''],['变色易容','',''],['变色蜥','',''],['变色镜','',''],['变色龙','',''],['变节','',''],['变节者','',''],['变苦','',''],['变蓝','',''],['变薄','',''],['变蛋','',''],['变被动为主动','',''],['变装皇后','',''],['变说','',''],['变调','',''],['变质','',''],['变质作用','',''],['变质岩','',''],['变起萧墙','',''],['变身','',''],['变软','',''],['变轻','',''],['变迁','',''],['变迁兴衰','',''],['变迹埋名','',''],['变通','',''],['变速','',''],['变速传动','',''],['变速器','',''],['变速杆','',''],['变速箱','',''],['变速运动','',''],['变造','',''],['变造币','',''],['变酸','',''],['变量','',''],['变长','',''],['变阻','',''],['变阻器','',''],['变革','',''],['变革时代','',''],['变音','',''],['变频','',''],['变频管','',''],['变颜色','',''],['变风改俗','',''],['变风易俗','',''],['变黄','',''],['变黑','',''],['叙事','',''],['叙事曲','',''],['叙事诗','',''],['叙利亚人','',''],['叙利亚文','',''],['叙别','',''],['叙功','',''],['叙功行赏','',''],['叙及','',''],['叙唱','',''],['叙情','',''],['叙拉古','',''],['叙文','',''],['叙旧','',''],['叙明','',''],['叙法','',''],['叙用','',''],['叙者','',''],['叙言','',''],['叙说','',''],['叙谈','',''],['叙述','',''],['叙述性','',''],['叙述文','',''],['叙述法','',''],['叙述者','',''],['叛乱','',''],['叛乱罪','',''],['叛乱者','',''],['叛党','',''],['叛党者','',''],['叛军','',''],['叛匪','',''],['叛卖','',''],['叛变','',''],['叛变的省份','',''],['叛国','',''],['叛国罪','',''],['叛将','',''],['叛徒','',''],['叛意','',''],['叛教','',''],['叛教者','',''],['叛民','',''],['叛离','',''],['叛者','',''],['叛贼','',''],['叛逃','',''],['叛逆','',''],['叛逆罪','',''],['叛逆者','',''],['叠加','',''],['叠印','',''],['叠句','',''],['叠合','',''],['叠好','',''],['叠字','',''],['叠层','',''],['叠层岩','',''],['叠层石','',''],['叠嶂','',''],['叠平','',''],['叠床架屋','',''],['叠式','',''],['叠彩','',''],['叠接','',''],['叠盖','',''],['叠矩重规','',''],['叠纸','',''],['叠罗汉','',''],['叠词','',''],['叠起','',''],['叠韵','',''],['口不二价','',''],['口不应心','',''],['口中','',''],['口中蚤虱','',''],['口中雌黄','',''],['口交','',''],['口令','',''],['口传','',''],['口似悬河','',''],['口供','',''],['口供人','',''],['口侧','',''],['口信','',''],['口儿','',''],['口内','',''],['口出','',''],['口出狂言','',''],['口北','',''],['口口','',''],['口口声声','',''],['口口相传','',''],['口号','',''],['口吃','',''],['口吃人','',''],['口吃者','',''],['口吐毒焰','',''],['口吐珠玑','',''],['口含天宪','',''],['口吸盘','',''],['口吻','',''],['口吻生花','',''],['口味','',''],['口哨','',''],['口哨儿','',''],['口器','',''],['口型','',''],['口壁','',''],['口外','',''],['口头','',''],['口头上','',''],['口头文学','',''],['口头禅','',''],['口头语','',''],['口如悬河','',''],['口子','',''],['口实','',''],['口密腹剑','',''],['口射','',''],['口小','',''],['口尚乳臭','',''],['口岸','',''],['口干','',''],['口干舌燥','',''],['口弦','',''],['口形','',''],['口彩','',''],['口径','',''],['口德','',''],['口快','',''],['口快心直','',''],['口惠','',''],['口惠而实不至','',''],['口感','',''],['口才','',''],['口技','',''],['口技表演者','',''],['口拙','',''],['口授','',''],['口无择言','',''],['口无遮拦','',''],['口是心非','',''],['口服','',''],['口服心服','',''],['口服液','',''],['口术','',''],['口条','',''],['口气','',''],['口水','',''],['口水仗','',''],['口沉','',''],['口沫','',''],['口沸目赤','',''],['口活','',''],['口涎','',''],['口淫','',''],['口渴','',''],['口湖','',''],['口湖乡','',''],['口炎','',''],['口燥唇干','',''],['口状','',''],['口琴','',''],['口疮','',''],['口白','',''],['口盖','',''],['口碑','',''],['口碑流传','',''],['口碑载道','',''],['口碱','',''],['口福','',''],['口称','',''],['口算','',''],['口簧','',''],['口簧琴','',''],['口粮','',''],['口紧','',''],['口红','',''],['口络','',''],['口罩','',''],['口耳之学','',''],['口腔','',''],['口腔炎','',''],['口腕','',''],['口腹','',''],['口腹之欲','',''],['口腹蜜剑','',''],['口臭','',''],['口舌','',''],['口若','',''],['口若悬河','',''],['口蘑','',''],['口蜜腹剑','',''],['口血未干','',''],['口袋','',''],['口袋妖怪','',''],['口角','',''],['口角战','',''],['口角春风','',''],['口角炎','',''],['口诀','',''],['口译','',''],['口译员','',''],['口试','',''],['口诛','',''],['口诛笔伐','',''],['口语','',''],['口语字词识别','',''],['口语沟通','',''],['口说无凭','',''],['口诵心惟','',''],['口谈','',''],['口蹄疫','',''],['口轻','',''],['口述','',''],['口述者','',''],['口部','',''],['口重','',''],['口锋','',''],['口音','',''],['口风','',''],['口香片','',''],['口香糖','',''],['口马','',''],['口鼻','',''],['口鼻部','',''],['口齿','',''],['口齿不清','',''],['口齿伶俐','',''],['口齿清楚','',''],['口齿生香','',''],['古为今用','',''],['古义','',''],['古书','',''],['古事','',''],['古井无波','',''],['古人','',''],['古人类','',''],['古今','',''],['古今中外','',''],['古今图书集成','',''],['古今字','',''],['古今小说','',''],['古今有之','',''],['古代','',''],['古代史','',''],['古代船','',''],['古代辩证法','',''],['古体','',''],['古体诗','',''],['古兰经','',''],['古典','',''],['古典主义','',''],['古典之作','',''],['古典乐','',''],['古典作品','',''],['古典政治经济学','',''],['古典文学','',''],['古典派','',''],['古典语言','',''],['古典音乐','',''],['古冶','',''],['古刹','',''],['古北口','',''],['古北界','',''],['古印','',''],['古史','',''],['古吉拉特','',''],['古吉拉特邦','',''],['古名','',''],['古国','',''],['古地磁','',''],['古坑','',''],['古坑乡','',''],['古城','',''],['古城堡','',''],['古堡','',''],['古塔','',''],['古墓','',''],['古墓丽影','',''],['古墓葬','',''],['古墓葬群','',''],['古奥','',''],['古妆','',''],['古字','',''],['古宅','',''],['古尔班通古特沙漠','',''],['古尔邦节','',''],['古已有之','',''],['古巴人','',''],['古巴共产党','',''],['古巴比伦','',''],['古币','',''],['古希腊','',''],['古希腊语','',''],['古建','',''],['古式','',''],['古往今来','',''],['古怪','',''],['古怪人','',''],['古惑仔','',''],['古战场','',''],['古拉格','',''],['古拙','',''],['古文','',''],['古文书','',''],['古文体','',''],['古文化','',''],['古文字','',''],['古文字学','',''],['古文明','',''],['古文观止','',''],['古文运动','',''],['古斯塔夫・多雷','',''],['古斯塔夫・施特雷泽曼','',''],['古新世','',''],['古新统','',''],['古方','',''],['古旧','',''],['古早','',''],['古时','',''],['古时人','',''],['古时候','',''],['古昔','',''],['古晋','',''],['古曲','',''],['古朴','',''],['古来','',''],['古来有之','',''],['古杰拉尔','',''],['古杰拉特邦','',''],['古板','',''],['古柯','',''],['古柯树','',''],['古柯碱','',''],['古树名木','',''],['古根海姆','',''],['古根罕','',''],['古根罕喷气推进研究中心','',''],['古气候学','',''],['古汉语','',''],['古波','',''],['古灵精怪','',''],['古烽燧','',''],['古版书','',''],['古物','',''],['古猿','',''],['古玩','',''],['古玩店','',''],['古琴','',''],['古生代','',''],['古生物','',''],['古生物学','',''],['古生物学家','',''],['古生界','',''],['古用法','',''],['古田会议','',''],['古登堡','',''],['古盗鸟','',''],['古砚','',''],['古神','',''],['古稀','',''],['古稀之年','',''],['古筝','',''],['古籍','',''],['古纪','',''],['古经','',''],['古罗马','',''],['古老','',''],['古脊椎动物学','',''],['古脑','',''],['古腾堡计划','',''],['古色','',''],['古色古香','',''],['古董','',''],['古董滩','',''],['古装','',''],['古装剧','',''],['古观','',''],['古训','',''],['古论','',''],['古词','',''],['古诗','',''],['古话','',''],['古语','',''],['古诺','',''],['古调不弹','',''],['古调独弹','',''],['古谚','',''],['古谱','',''],['古貌古心','',''],['古迹','',''],['古道','',''],['古道热肠','',''],['古都','',''],['古里古怪','',''],['古钱','',''],['古铜','',''],['古铜色','',''],['古雅','',''],['古雅典','',''],['古音','',''],['古风','',''],['古龙','',''],['句句实话','',''],['句号','',''],['句型','',''],['句子','',''],['句子成分','',''],['句字','',''],['句式','',''],['句数','',''],['句柄','',''],['句段','',''],['句法','',''],['句法分析','',''],['句法意识','',''],['句点','',''],['句群','',''],['句话','',''],['句读','',''],['句逗','',''],['句首','',''],['句骊河','',''],['另一','',''],['另一个','',''],['另一半','',''],['另一方','',''],['另一方面','',''],['另一番','',''],['另一种','',''],['另一面','',''],['另事','',''],['另付','',''],['另件','',''],['另作','',''],['另册','',''],['另加','',''],['另告','',''],['另外','',''],['另娶','',''],['另存','',''],['另存为','',''],['另定','',''],['另寄','',''],['另将','',''],['另屈','',''],['另建','',''],['另开','',''],['另开生面','',''],['另当','',''],['另征','',''],['另报','',''],['另按','',''],['另换','',''],['另据','',''],['另据报道','',''],['另收','',''],['另日','',''],['另有','',''],['另有企图','',''],['另案','',''],['另版','',''],['另用','',''],['另眼','',''],['另眼相待','',''],['另眼相看','',''],['另眼看待','',''],['另立','',''],['另签','',''],['另类','',''],['另类医疗','',''],['另纳','',''],['另给','',''],['另缴','',''],['另置','',''],['另行','',''],['另行安排','',''],['另行规定','',''],['另行通知','',''],['另见','',''],['另觅新欢','',''],['另议','',''],['另设','',''],['另请','',''],['另请高明','',''],['另谋','',''],['另谋高就','',''],['另起','',''],['另起炉灶','',''],['另辟蹊径','',''],['另选','',''],['另配','',''],['另附','',''],['叨光','',''],['叨叨','',''],['叨咕','',''],['叨唠','',''],['叨念','',''],['叨扰','',''],['叨教','',''],['叨登','',''],['叩关','',''],['叩出','',''],['叩击者','',''],['叩头','',''],['叩头虫','',''],['叩应','',''],['叩打','',''],['叩拜','',''],['叩球','',''],['叩见','',''],['叩诊','',''],['叩谒','',''],['叩谢','',''],['叩门','',''],['叩问','',''],['叩阍','',''],['叩首','',''],['只一次','',''],['只不过','',''],['只不过是','',''],['只为','',''],['只争','',''],['只争旦夕','',''],['只争朝夕','',''],['只于','',''],['只产','',''],['只从','',''],['只会','',''],['只作','',''],['只做','',''],['只准','',''],['只凭','',''],['只剩','',''],['只占','',''],['只只','',''],['只可','',''],['只可意会','',''],['只可意会不可言传','',''],['只因','',''],['只在','',''],['只好','',''],['只字','',''],['只字不提','',''],['只字片言','',''],['只对','',''],['只差','',''],['只当','',''],['只影单形','',''],['只影孤形','',''],['只征','',''],['只得','',''],['只怕','',''],['只怕有心人','',''],['只想','',''],['只手','',''],['只手单拳','',''],['只手擎天','',''],['只手空拳','',''],['只把','',''],['只投','',''],['只按','',''],['只是','',''],['只有','',''],['只欠东风','',''],['只此','',''],['只此一家别无分店','',''],['只求','',''],['只消','',''],['只热','',''],['只玩','',''],['只用','',''],['只用于','',''],['只留','',''],['只看','',''],['只知其一','',''],['只知其一不知其二','',''],['只知其一未知其二','',''],['只管','',''],['只缺','',''],['只羊','',''],['只能','',''],['只要','',''],['只要功夫深','',''],['只见','',''],['只见树木不见森林','',''],['只言','',''],['只言片语','',''],['只许','',''],['只许州官放火','',''],['只说','',''],['只读','',''],['只身','',''],['只身孤影','',''],['只轮不返','',''],['只重衣衫不重人','',''],['只限','',''],['只限于','',''],['只需','',''],['只须','',''],['只顾','',''],['只鸡斗酒','',''],['只鸡絮酒','',''],['叫个','',''],['叫人','',''],['叫价','',''],['叫住','',''],['叫作','',''],['叫做','',''],['叫出','',''],['叫到','',''],['叫化','',''],['叫化子','',''],['叫卖','',''],['叫卖声','',''],['叫卖贩','',''],['叫号','',''],['叫吃','',''],['叫名','',''],['叫响','',''],['叫哥哥','',''],['叫唤','',''],['叫啥','',''],['叫喊','',''],['叫喊声','',''],['叫喊者','',''],['叫嚣','',''],['叫嚷','',''],['叫声','',''],['叫头','',''],['叫好','',''],['叫子','',''],['叫客','',''],['叫屈','',''],['叫床','',''],['叫床声','',''],['叫座','',''],['叫开','',''],['叫得','',''],['叫我','',''],['叫春','',''],['叫来','',''],['叫板','',''],['叫牌','',''],['叫着','',''],['叫绝','',''],['叫花','',''],['叫花子','',''],['叫苦','',''],['叫苦不迭','',''],['叫苦连天','',''],['叫走','',''],['叫起','',''],['叫过','',''],['叫道','',''],['叫醒','',''],['叫醒服务','',''],['叫错','',''],['叫门','',''],['叫阵','',''],['叫驴','',''],['叫骂','',''],['叫鸡','',''],['召之即来','',''],['召募','',''],['召唤','',''],['召唤者','',''],['召回','',''],['召回率','',''],['召开','',''],['召开会议','',''],['召来','',''],['召父杜母','',''],['召祸','',''],['召者','',''],['召见','',''],['召请','',''],['召陵','',''],['召集','',''],['召集人','',''],['召集者','',''],['叭叭','',''],['叭啦狗','',''],['叭嗒','',''],['叭声','',''],['叭达','',''],['叮伤','',''],['叮叮','',''],['叮叮当当','',''],['叮叮猫','',''],['叮呤','',''],['叮咚','',''],['叮咛','',''],['叮咬','',''],['叮响','',''],['叮嘱','',''],['叮噹声','',''],['叮当','',''],['叮当响','',''],['叮当声','',''],['叮玲','',''],['叮玲响','',''],['叮铃','',''],['叮问','',''],['可上演','',''],['可不','',''],['可不可以','',''],['可不可能','',''],['可不是','',''],['可与','',''],['可专用','',''],['可为','',''],['可主张','',''],['可乐','',''],['可乘','',''],['可乘之机','',''],['可乘之隙','',''],['可买','',''],['可买卖','',''],['可了解','',''],['可予','',''],['可争','',''],['可争议','',''],['可争论','',''],['可争辩','',''],['可于','',''],['可互换','',''],['可交换','',''],['可交谈','',''],['可享','',''],['可享乐','',''],['可亲','',''],['可亲可敬','',''],['可人','',''],['可从','',''],['可付','',''],['可付还','',''],['可代替','',''],['可以','',''],['可以买','',''],['可以休矣','',''],['可以分','',''],['可以吃','',''],['可以向','',''],['可以喝','',''],['可以忽视','',''],['可以意会','',''],['可以燎原','',''],['可以解','',''],['可以说','',''],['可以请','',''],['可以选','',''],['可以避免','',''],['可以骑','',''],['可会见','',''],['可传导','',''],['可传性','',''],['可传播','',''],['可传染','',''],['可传达','',''],['可传递','',''],['可估价','',''],['可估计','',''],['可伸出','',''],['可伸缩','',''],['可伸长','',''],['可住','',''],['可体','',''],['可作','',''],['可佩','',''],['可使','',''],['可使用','',''],['可供','',''],['可供军用','',''],['可依','',''],['可保存','',''],['可保证','',''],['可保释','',''],['可保险','',''],['可信','',''],['可信任','',''],['可信度','',''],['可信性','',''],['可信用','',''],['可信赖','',''],['可修复','',''],['可修好','',''],['可修正','',''],['可修理','',''],['可修缮','',''],['可修订','',''],['可倒','',''],['可借','',''],['可假定','',''],['可做','',''],['可偿','',''],['可偿还','',''],['可储存','',''],['可兑换','',''],['可兰经','',''],['可共存','',''],['可共患难','',''],['可兼容','',''],['可再','',''],['可再制','',''],['可再生','',''],['可再生原','',''],['可决','',''],['可决定','',''],['可决率','',''],['可决票','',''],['可凌驾','',''],['可减去','',''],['可减少','',''],['可减轻','',''],['可凭','',''],['可出租','',''],['可击','',''],['可分','',''],['可分别','',''],['可分割','',''],['可分子','',''],['可分开','',''],['可分析','',''],['可分离','',''],['可分类','',''],['可分解','',''],['可分配','',''],['可切除','',''],['可列举','',''],['可利用','',''],['可别','',''],['可到','',''],['可到达','',''],['可剥夺','',''],['可劝','',''],['可劝告','',''],['可加','',''],['可加工','',''],['可动','',''],['可动性','',''],['可动摇','',''],['可区分','',''],['可医','',''],['可医好','',''],['可医治','',''],['可升级','',''],['可卑','',''],['可卖','',''],['可占','',''],['可卡因','',''],['可印刷','',''],['可压','',''],['可压榨','',''],['可压缩','',''],['可原谅','',''],['可及','',''],['可反对','',''],['可反转','',''],['可发','',''],['可发明','',''],['可发行','',''],['可发表','',''],['可发觉','',''],['可发音','',''],['可取','',''],['可取代','',''],['可取回','',''],['可取得','',''],['可取性','',''],['可取消','',''],['可受','',''],['可变','',''],['可变化','',''],['可变化合价','',''],['可变形','',''],['可变性','',''],['可变渗透性模型','',''],['可变电容器','',''],['可变硬','',''],['可变资本','',''],['可口','',''],['可口可乐公司','',''],['可召唤','',''],['可召集','',''],['可可','',''],['可可儿的','',''],['可可托海','',''],['可可托海镇','',''],['可可米','',''],['可可西里','',''],['可可豆','',''],['可叹','',''],['可吃','',''],['可合并','',''],['可同','',''],['可同化','',''],['可向','',''],['可吟诵','',''],['可否','',''],['可否认','',''],['可听','',''],['可听度','',''],['可听见','',''],['可吸收','',''],['可和','',''],['可和解','',''],['可哀','',''],['可品尝','',''],['可善','',''],['可喜','',''],['可嘉','',''],['可回','',''],['可回复','',''],['可回忆','',''],['可回收','',''],['可围绕','',''],['可在','',''],['可塑','',''],['可塑性','',''],['可塑造','',''],['可塞','',''],['可增加','',''],['可处理','',''],['可复苏','',''],['可大','',''],['可好','',''],['可子','',''],['可存取','',''],['可完','',''],['可定义','',''],['可定名','',''],['可定址','',''],['可实施','',''],['可实现','',''],['可实行','',''],['可容','',''],['可容忍','',''],['可容纳','',''],['可容许','',''],['可宽恕','',''],['可察觉','',''],['可寻址','',''],['可导','',''],['可将','',''],['可尊敬','',''],['可尊重','',''],['可尝','',''],['可居','',''],['可居住','',''],['可展开','',''],['可展性','',''],['可展曲面','',''],['可崇敬','',''],['可巧','',''],['可带走','',''],['可应用','',''],['可废止','',''],['可废除','',''],['可延','',''],['可延期','',''],['可延续性','',''],['可延长','',''],['可开动','',''],['可引','',''],['可引出','',''],['可引导','',''],['可引渡','',''],['可引用','',''],['可强迫','',''],['可归','',''],['可归于','',''],['可归因','',''],['可归属','',''],['可归罪','',''],['可归还','',''],['可当','',''],['可录音','',''],['可征收','',''],['可征服','',''],['可征税','',''],['可待','',''],['可待因','',''],['可得','',''],['可得到','',''],['可微','',''],['可心','',''],['可心如意','',''],['可忍受','',''],['可忍耐','',''],['可忽略','',''],['可怕','',''],['可怖','',''],['可怜','',''],['可怜人','',''],['可怜兮兮','',''],['可怜虫','',''],['可怜见','',''],['可怪','',''],['可恃','',''],['可恕','',''],['可恢复','',''],['可恨','',''],['可恶','',''],['可恼','',''],['可悬吊','',''],['可悬挂','',''],['可悲','',''],['可惊','',''],['可惊异','',''],['可惜','',''],['可想','',''],['可想像','',''],['可想到','',''],['可想而知','',''],['可意','',''],['可感知','',''],['可感觉','',''],['可憎','',''],['可懂度','',''],['可成形','',''],['可战胜','',''],['可执行','',''],['可扩展','',''],['可扩展标记语言','',''],['可扩张','',''],['可承认','',''],['可把','',''],['可抑制','',''],['可抑压','',''],['可折叠','',''],['可折式衣架','',''],['可抚慰','',''],['可抢救','',''],['可护','',''],['可报导','',''],['可抵抗','',''],['可抹掉','',''],['可抽出','',''],['可抽吸','',''],['可抽税','',''],['可拆卸','',''],['可拉长','',''],['可拒绝','',''],['可持续','',''],['可持续发展','',''],['可指','',''],['可指明','',''],['可按','',''],['可挖苦','',''],['可挥发','',''],['可振动','',''],['可挽回','',''],['可捉捕','',''],['可排','',''],['可排除','',''],['可接','',''],['可接受','',''],['可接受性','',''],['可接近','',''],['可控','',''],['可控性','',''],['可控告','',''],['可控硅','',''],['可推广','',''],['可推断','',''],['可推测','',''],['可推知','',''],['可推荐','',''],['可推论','',''],['可掬','',''],['可提议','',''],['可援用','',''],['可搬运','',''],['可携','',''],['可携带','',''],['可撤回','',''],['可撤销','',''],['可操作','',''],['可操作性','',''],['可操作的艺术','',''],['可操左券','',''],['可操纵','',''],['可擦写','',''],['可擦写可编程只读存储器','',''],['可擦掉','',''],['可攀登','',''],['可支付性','',''],['可支持','',''],['可支配','',''],['可收','',''],['可收买','',''],['可收到','',''],['可收回','',''],['可收集','',''],['可改','',''],['可改变','',''],['可改善','',''],['可改正','',''],['可改编','',''],['可改良','',''],['可改革','',''],['可攻克','',''],['可放','',''],['可救','',''],['可救出','',''],['可救助','',''],['可教','',''],['可教化','',''],['可教性','',''],['可教育','',''],['可敬','',''],['可敬畏','',''],['可数','',''],['可数名词','',''],['可数集','',''],['可断','',''],['可断定','',''],['可断言','',''],['可无','',''],['可是','',''],['可视化','',''],['可更改','',''],['可更新','',''],['可替换','',''],['可有可无','',''],['可望','',''],['可望取胜者','',''],['可望有成','',''],['可望而不可即','',''],['可望而不可及','',''],['可查','',''],['可树','',''],['可核准','',''],['可根除','',''],['可模仿','',''],['可欺','',''],['可歌可泣','',''],['可比','',''],['可比价格','',''],['可比较','',''],['可气','',''],['可气化','',''],['可氧化','',''],['可汀','',''],['可求','',''],['可汗','',''],['可汽化','',''],['可沐浴','',''],['可没','',''],['可没收','',''],['可治','',''],['可治愈','',''],['可治疗','',''],['可洗','',''],['可洗涤','',''],['可洞察','',''],['可流通','',''],['可测','',''],['可测性','',''],['可测量','',''],['可浸透','',''],['可消化','',''],['可消耗','',''],['可消费','',''],['可消除','',''],['可液化','',''],['可混','',''],['可渗入','',''],['可渗透','',''],['可湿性','',''],['可溶','',''],['可溶性','',''],['可溶解','',''],['可满','',''],['可满足','',''],['可滤','',''],['可漂浮','',''],['可灌溉','',''],['可熄灭','',''],['可熔','',''],['可燃','',''],['可燃冰','',''],['可燃性','',''],['可爱','',''],['可牺牲','',''],['可犯','',''],['可理解','',''],['可生','',''],['可生产','',''],['可用','',''],['可用性','',''],['可由','',''],['可畏','',''],['可畏惧','',''],['可疑','',''],['可疑分子','',''],['可疑性','',''],['可登记','',''],['可直接','',''],['可省略','',''],['可看','',''],['可看破','',''],['可着','',''],['可知','',''],['可知性','',''],['可知觉','',''],['可知论','',''],['可研','',''],['可破坏','',''],['可确定','',''],['可磁化体','',''],['可磋商','',''],['可种植','',''],['可秤','',''],['可称','',''],['可移','',''],['可移动','',''],['可移植','',''],['可移植性','',''],['可移转','',''],['可穿','',''],['可穿著','',''],['可穿透','',''],['可笑','',''],['可答复','',''],['可答辩','',''],['可简化','',''],['可算','',''],['可类比','',''],['可纠正','',''],['可组合','',''],['可组织','',''],['可结合性','',''],['可统一','',''],['可统治','',''],['可继承','',''],['可维护性','',''],['可维持','',''],['可缓和','',''],['可编','',''],['可编程','',''],['可缩','',''],['可羡慕','',''],['可翻译','',''],['可者','',''],['可耕','',''],['可耕地','',''],['可耻','',''],['可耻下场','',''],['可联','',''],['可联想','',''],['可能','',''],['可能发生','',''],['可能性','',''],['可能有','',''],['可能派','',''],['可膨胀','',''],['可自','',''],['可自乘','',''],['可航行','',''],['可苏醒','',''],['可获','',''],['可获利','',''],['可获得','',''],['可行','',''],['可行性','',''],['可行性研究','',''],['可补救','',''],['可表明','',''],['可表现','',''],['可表示','',''],['可被','',''],['可裁决','',''],['可裂变','',''],['可裂变材料','',''],['可要','',''],['可要求','',''],['可见','',''],['可见一斑','',''],['可见光','',''],['可见度','',''],['可观','',''],['可视性','',''],['可视电话','',''],['可觉察','',''],['可解','',''],['可解决','',''],['可解说','',''],['可解读','',''],['可解释','',''],['可解雇','',''],['可触','',''],['可触知','',''],['可言','',''],['可计数','',''],['可计算','',''],['可认识','',''],['可让','',''],['可让与','',''],['可议论','',''],['可记得','',''],['可记述','',''],['可讲','',''],['可论证','',''],['可设','',''],['可证','',''],['可证实','',''],['可证明','',''],['可评价','',''],['可诉讼','',''],['可试验','',''],['可诱惑','',''],['可说','',''],['可说明','',''],['可说服','',''],['可读','',''],['可读性','',''],['可读音性','',''],['可课税','',''],['可调','',''],['可调停','',''],['可调和','',''],['可调整','',''],['可谓','',''],['可象','',''],['可责','',''],['可责备','',''],['可责难','',''],['可贴现','',''],['可贵','',''],['可贺','',''],['可资','',''],['可赎','',''],['可赎回','',''],['可赞叹','',''],['可赞赏','',''],['可走','',''],['可走动','',''],['可起诉','',''],['可超越','',''],['可身','',''],['可转','',''],['可转换同位素','',''],['可转移','',''],['可转让','',''],['可转让证券','',''],['可轻视','',''],['可输入','',''],['可输出','',''],['可辨别','',''],['可辨认','',''],['可辩','',''],['可辩别','',''],['可辩护','',''],['可辩解','',''],['可辩论','',''],['可达','',''],['可达到','',''],['可过','',''],['可这','',''],['可进入','',''],['可进口','',''],['可连接','',''],['可述说','',''],['可追求','',''],['可追踪','',''],['可退回','',''],['可适用','',''],['可逆','',''],['可逆反应','',''],['可逆性','',''],['可选','',''],['可选择','',''],['可选择丢弃','',''],['可选项','',''],['可透入','',''],['可透性','',''],['可通','',''],['可通约','',''],['可通航','',''],['可通融','',''],['可通行','',''],['可遗传','',''],['可遵守','',''],['可避免','',''],['可邮寄','',''],['可鄙','',''],['可采','',''],['可采用','',''],['可采纳','',''],['可重写','',''],['可重获','',''],['可量','',''],['可钦佩','',''],['可销','',''],['可销售','',''],['可锻铸铁','',''],['可闻','',''],['可防','',''],['可防卫','',''],['可防守','',''],['可防御','',''],['可防止','',''],['可降','',''],['可降低','',''],['可限制','',''],['可除尽','',''],['可雇用','',''],['可非难','',''],['可靠','',''],['可靠人士','',''],['可靠保证','',''],['可靠性','',''],['可靠性理论','',''],['可靠消息','',''],['可预付','',''],['可预期','',''],['可预知','',''],['可预言','',''],['可食','',''],['可食用','',''],['可饮用','',''],['可饱和','',''],['可驯养','',''],['可驯服','',''],['可驳倒','',''],['可驳斥','',''],['可驾驶','',''],['可验','',''],['可验证','',''],['可骗','',''],['台上','',''],['台上一分钟','',''],['台上台下','',''],['台下','',''],['台下十年功','',''],['台伯河','',''],['台位','',''],['台儿庄','',''],['台北反美事件','',''],['台北捷运','',''],['台南府','',''],['台南府市','',''],['台历','',''],['台启','',''],['台员','',''],['台商','',''],['台地','',''],['台基','',''],['台大','',''],['台妹','',''],['台媒','',''],['台子','',''],['台客','',''],['台属','',''],['台州地区','',''],['台巴子','',''],['台币','',''],['台布','',''],['台帐','',''],['台度','',''],['台座','',''],['台式','',''],['台式电脑','',''],['台数','',''],['台本','',''],['台板','',''],['台架','',''],['台柱','',''],['台柱子','',''],['台步','',''],['台海','',''],['台港','',''],['台港澳','',''],['台湾关系法','',''],['台湾叶鼻蝠','',''],['台湾同胞','',''],['台湾土狗','',''],['台湾大学','',''],['台湾山脉','',''],['台湾岛','',''],['台湾当局','',''],['台湾民主自治同盟','',''],['台湾海峡','',''],['台湾猴','',''],['台灯','',''],['台独','',''],['台球','',''],['台球场','',''],['台球桌','',''],['台甫','',''],['台盆','',''],['台盟','',''],['台磅','',''],['台秤','',''],['台称','',''],['台端','',''],['台联','',''],['台股','',''],['台胞','',''],['台西','',''],['台西乡','',''],['台视','',''],['台词','',''],['台谍','',''],['台资','',''],['台车','',''],['台鉴','',''],['台钟','',''],['台钳','',''],['台钻','',''],['台镜','',''],['台阁生风','',''],['台阶','',''],['台面','',''],['台面呢','',''],['台风','',''],['台风儿','',''],['叱吒','',''],['叱吒风云','',''],['叱呵','',''],['叱咄','',''],['叱咤','',''],['叱咤风云','',''],['叱喝','',''],['叱嗟风云','',''],['叱责','',''],['叱问','',''],['叱骂','',''],['史上','',''],['史不绝书','',''],['史丹佛','',''],['史丹福大学','',''],['史丹顿岛','',''],['史乘','',''],['史书','',''],['史传','',''],['史传小说','',''],['史册','',''],['史前','',''],['史前人','',''],['史前古器物','',''],['史前史','',''],['史前石桌','',''],['史剧','',''],['史卓','',''],['史威士','',''],['史学','',''],['史学家','',''],['史学方法','',''],['史官','',''],['史实','',''],['史实性','',''],['史家','',''],['史密斯','',''],['史密特','',''],['史志','',''],['史思明','',''],['史抄','',''],['史提夫・贾伯斯','',''],['史料','',''],['史料选编','',''],['史无前例','',''],['史景迁','',''],['史沫特莱','',''],['史瓦济兰','',''],['史瓦辛格','',''],['史略','',''],['史称','',''],['史稿','',''],['史籀篇','',''],['史籍','',''],['史纲','',''],['史臣','',''],['史蒂夫','',''],['史蒂夫・乔布斯','',''],['史蒂文','',''],['史蒂文斯','',''],['史蒂芬・哈珀','',''],['史观','',''],['史记','',''],['史论','',''],['史评','',''],['史诗','',''],['史诗性','',''],['史诗般','',''],['史话','',''],['史语','',''],['史载','',''],['史迪威','',''],['史迹','',''],['史部','',''],['史馆','',''],['史黛西','',''],['右上','',''],['右上方','',''],['右下','',''],['右下方','',''],['右侧','',''],['右倾','',''],['右倾机会主义','',''],['右分枝关系从句','',''],['右列','',''],['右前卫','',''],['右弯','',''],['右房','',''],['右手','',''],['右手定则','',''],['右抱','',''],['右方','',''],['右旋','',''],['右旋性','',''],['右江','',''],['右派','',''],['右派分子','',''],['右眼','',''],['右移','',''],['右端','',''],['右箭头','',''],['右箭头键','',''],['右翼','',''],['右耳','',''],['右脚','',''],['右腿','',''],['右臂','',''],['右舵','',''],['右舷','',''],['右行','',''],['右袒','',''],['右角','',''],['右转','',''],['右边','',''],['右边儿','',''],['右键','',''],['右面','',''],['右页','',''],['右顾','',''],['右首','',''],['叵测','',''],['叵耐','',''],['叶丛','',''],['叶伟文','',''],['叶伟民','',''],['叶儿','',''],['叶公','',''],['叶公好龙','',''],['叶兰','',''],['叶利钦','',''],['叶卡捷琳堡','',''],['叶卡捷琳娜','',''],['叶卡特琳娜堡','',''],['叶口蝠科','',''],['叶圣陶','',''],['叶块繁殖','',''],['叶子','',''],['叶子列','',''],['叶子板','',''],['叶子烟','',''],['叶尔羌河','',''],['叶序','',''],['叶形','',''],['叶挺','',''],['叶斑病','',''],['叶枕','',''],['叶枝','',''],['叶柄','',''],['叶永烈','',''],['叶江川','',''],['叶片','',''],['叶片状','',''],['叶状','',''],['叶状体','',''],['叶猴','',''],['叶瑟','',''],['叶甜菜','',''],['叶礼庭','',''],['叶窗','',''],['叶红素','',''],['叶绿','',''],['叶绿体','',''],['叶绿粒','',''],['叶绿素','',''],['叶肉','',''],['叶脉','',''],['叶脉序','',''],['叶腑','',''],['叶芽','',''],['叶苔','',''],['叶茂','',''],['叶茂盛','',''],['叶茎','',''],['叶草','',''],['叶菊','',''],['叶落归根','',''],['叶落归秋','',''],['叶落知秋','',''],['叶虫','',''],['叶蜂','',''],['叶蝉','',''],['叶轮','',''],['叶轮机械','',''],['叶选平','',''],['叶酸','',''],['叶锈病','',''],['叶门','',''],['叶问','',''],['叶面','',''],['叶面施肥','',''],['叶鞘','',''],['叶韵','',''],['叶鼻蝠','',''],['号丧','',''],['号为','',''],['号令','',''],['号令如山','',''],['号儿','',''],['号兵','',''],['号叫','',''],['号召','',''],['号召力','',''],['号哭','',''],['号啕','',''],['号坎儿','',''],['号声','',''],['号外','',''],['号天叩地','',''],['号头','',''],['号子','',''],['号寒啼饥','',''],['号志灯','',''],['号房','',''],['号手','',''],['号数','',''],['号旗','',''],['号曰','',''],['号楼','',''],['号炮','',''],['号牌','',''],['号码','',''],['号码机','',''],['号码牌','',''],['号码盘','',''],['号礮','',''],['号称','',''],['号筒','',''],['号脉','',''],['号衣','',''],['号角','',''],['号音','',''],['司书','',''],['司事','',''],['司令','',''],['司令员','',''],['司令官','',''],['司令杖','',''],['司令部','',''],['司仪','',''],['司务','',''],['司务长','',''],['司南','',''],['司厨','',''],['司号员','',''],['司各特','',''],['司售','',''],['司售人员','',''],['司天台','',''],['司寇','',''],['司局','',''],['司局级','',''],['司库','',''],['司徒','',''],['司晨','',''],['司机','',''],['司汤达','',''],['司法','',''],['司法上','',''],['司法人员','',''],['司法制度','',''],['司法官','',''],['司法机关','',''],['司法权','',''],['司法独立','',''],['司法部','',''],['司法部门','',''],['司法院','',''],['司法厅','',''],['司炉','',''],['司祭','',''],['司空','',''],['司空眼惯','',''],['司空见惯','',''],['司线员','',''],['司职','',''],['司铎','',''],['司长','',''],['司马','',''],['司马光','',''],['司马懿','',''],['司马承帧','',''],['司马昭之心','',''],['司马昭之心路人所知','',''],['司马法','',''],['司马炎','',''],['司马穰苴','',''],['司马谈','',''],['司马辽太郎','',''],['司马迁','',''],['司马青衫','',''],['叹为','',''],['叹为观止','',''],['叹了一口气','',''],['叹号','',''],['叹喟','',''],['叹声','',''],['叹息','',''],['叹惋','',''],['叹惋观止','',''],['叹惜','',''],['叹服','',''],['叹气','',''],['叹羡','',''],['叹老嗟卑','',''],['叹者','',''],['叹词','',''],['叹语','',''],['叹赏','',''],['叼了','',''],['叽叽','',''],['叽叽喳喳','',''],['叽叽嘎嘎','',''],['叽咕','',''],['叽哩咕噜','',''],['叽喳','',''],['叽嘎声','',''],['叽里呱啦','',''],['叽里咕噜','',''],['叽里旮旯儿','',''],['吁吁','',''],['吁请','',''],['吃一堑','',''],['吃一堑长一智','',''],['吃一惊','',''],['吃上','',''],['吃下','',''],['吃不上','',''],['吃不下','',''],['吃不了兜着走','',''],['吃不住','',''],['吃不到葡萄说葡萄酸','',''],['吃不开','',''],['吃不服','',''],['吃不来','',''],['吃不消','',''],['吃东西','',''],['吃了一惊','',''],['吃了定心丸','',''],['吃亏','',''],['吃亏上当','',''],['吃人','',''],['吃人不吐骨头','',''],['吃光','',''],['吃入','',''],['吃刀','',''],['吃到','',''],['吃力','',''],['吃力不讨好','',''],['吃劲','',''],['吃午饭','',''],['吃去','',''],['吃口','',''],['吃吃','',''],['吃吃喝喝','',''],['吃吃地笑','',''],['吃吧','',''],['吃喝','',''],['吃喝儿','',''],['吃喝嫖赌','',''],['吃喝玩乐','',''],['吃喝风','',''],['吃嘴','',''],['吃坏','',''],['吃大亏','',''],['吃大户','',''],['吃大锅饭','',''],['吃奶','',''],['吃奶之力','',''],['吃奶的力气','',''],['吃奶的气力','',''],['吃完','',''],['吃官司','',''],['吃客','',''],['吃尽苦头','',''],['吃布','',''],['吃得','',''],['吃得住','',''],['吃得开','',''],['吃得来','',''],['吃得消','',''],['吃得苦中苦','',''],['吃得过多','',''],['吃心','',''],['吃快餐','',''],['吃惊','',''],['吃掉','',''],['吃教','',''],['吃斋','',''],['吃早餐','',''],['吃早饭','',''],['吃水','',''],['吃法','',''],['吃点','',''],['吃熊心豹子胆','',''],['吃牢饭','',''],['吃独食','',''],['吃现成饭','',''],['吃瓦片儿','',''],['吃白食','',''],['吃皇粮','',''],['吃着碗里','',''],['吃穷','',''],['吃空额','',''],['吃空饷','',''],['吃穿','',''],['吃笑','',''],['吃粮','',''],['吃粮不管事','',''],['吃素','',''],['吃紧','',''],['吃羹','',''],['吃老本','',''],['吃者','',''],['吃肉','',''],['吃腻','',''],['吃苦','',''],['吃苦头','',''],['吃苦耐劳','',''],['吃茶','',''],['吃草','',''],['吃荤','',''],['吃药','',''],['吃药人','',''],['吃著不尽','',''],['吃角子老虎','',''],['吃请','',''],['吃请风','',''],['吃豆人','',''],['吃豆腐','',''],['吃豆豆','',''],['吃败仗','',''],['吃起来','',''],['吃软不吃硬','',''],['吃软饭','',''],['吃过','',''],['吃过量','',''],['吃进','',''],['吃透','',''],['吃通','',''],['吃醋','',''],['吃醋争风','',''],['吃醋拈酸','',''],['吃里爬外','',''],['吃重','',''],['吃错药','',''],['吃闲饭','',''],['吃零嘴','',''],['吃霸王餐','',''],['吃食','',''],['吃饭','',''],['吃饱','',''],['吃饱了饭撑的','',''],['吃饱喝足','',''],['吃饱撑着','',''],['吃饱穿暖','',''],['吃香','',''],['吃鱼','',''],['各不相同','',''],['各不相让','',''],['各不相谋','',''],['各业','',''],['各个','',''],['各个击破','',''],['各人','',''],['各人民团体','',''],['各人自扫门前雪','',''],['各付','',''],['各代','',''],['各企业','',''],['各位','',''],['各位听众','',''],['各位观众','',''],['各具','',''],['各具特色','',''],['各军兵种','',''],['各军区','',''],['各别','',''],['各区','',''],['各半','',''],['各单位','',''],['各占','',''],['各厂','',''],['各厂矿','',''],['各县','',''],['各取所需','',''],['各口','',''],['各司其职','',''],['各向','',''],['各向同性','',''],['各向异性','',''],['各国','',''],['各国人民','',''],['各国共产党和工人党会议','',''],['各地','',''],['各地区','',''],['各地方','',''],['各处','',''],['各大军区','',''],['各奔东西','',''],['各奔前程','',''],['各好','',''],['各季','',''],['各家','',''],['各家各户','',''],['各就','',''],['各尽其能','',''],['各尽所能','',''],['按劳分配','',''],['按需分配','',''],['各局','',''],['各层','',''],['各岛','',''],['各州','',''],['各市','',''],['各年','',''],['各异','',''],['各式','',''],['各式各样','',''],['各形','',''],['各得其宜','',''],['各得其所','',''],['各怀','',''],['各户','',''],['各所','',''],['各打','',''],['各执一词','',''],['各执己见','',''],['各执所见','',''],['各批','',''],['各抒己见','',''],['各拉丹冬山','',''],['各拉丹冬峰','',''],['各持己见','',''],['各摊','',''],['各方','',''],['各方面','',''],['各族','',''],['各族人民','',''],['各族群众','',''],['各显所长','',''],['各显神通','',''],['各月','',''],['各有','',''],['各有不同','',''],['各有千秋','',''],['各有所好','',''],['各有所得','',''],['各有所长','',''],['各期','',''],['各村','',''],['各条','',''],['各条战线','',''],['各栏','',''],['各校','',''],['各样','',''],['各次','',''],['各款','',''],['各款产品','',''],['各民主党派','',''],['各民族','',''],['各派','',''],['各点','',''],['各界','',''],['各界人士','',''],['各省','',''],['各省市','',''],['各省市自治区','',''],['各种','',''],['各种各样','',''],['各种颜色','',''],['各答','',''],['各类','',''],['各级','',''],['各级党委','',''],['各级领导','',''],['各组','',''],['各联','',''],['各自','',''],['各自为战','',''],['各自为政','',''],['各般','',''],['各色','',''],['各色各样','',''],['各行','',''],['各行业','',''],['各行其事','',''],['各行其志','',''],['各行其是','',''],['各行各业','',''],['各表','',''],['各说','',''],['各路','',''],['各达','',''],['各部','',''],['各部委','',''],['各部门','',''],['各长','',''],['各门','',''],['各队','',''],['各院校','',''],['各页','',''],['各项','',''],['各顾各','',''],['吆五喝六','',''],['吆呼','',''],['吆喊','',''],['吆喝','',''],['合一','',''],['合上','',''],['合不拢嘴','',''],['合不来','',''],['合不着','',''],['合为','',''],['合乎','',''],['合乎逻辑','',''],['合二为一','',''],['合于','',''],['合于时宜','',''],['合亟','',''],['合众','',''],['合众为一','',''],['合众国','',''],['合众国际社','',''],['合众社','',''],['合众银行','',''],['合伙','',''],['合伙人','',''],['合伙企业','',''],['合会','',''],['合住','',''],['合体字','',''],['合作','',''],['合作主义','',''],['合作伙伴','',''],['合作关系','',''],['合作农场','',''],['合作制','',''],['合作化','',''],['合作医疗','',''],['合作商店','',''],['合作社','',''],['合作社经济','',''],['合作经济','',''],['合作者','',''],['合作运动','',''],['合作项目','',''],['合共','',''],['合击','',''],['合刊','',''],['合则两利','',''],['合剂','',''],['合力','',''],['合办','',''],['合化','',''],['合十','',''],['合卺','',''],['合取','',''],['合口','',''],['合口呼','',''],['合叶','',''],['合吃族','',''],['合同','',''],['合同书','',''],['合同作战','',''],['合同制','',''],['合同各方','',''],['合同工','',''],['合同异','',''],['合同法','',''],['合同货币','',''],['合唱','',''],['合唱会','',''],['合唱团','',''],['合唱曲','',''],['合四乙尺工','',''],['合围','',''],['合在','',''],['合块','',''],['合声','',''],['合处','',''],['合夥','',''],['合夥人','',''],['合奏','',''],['合婚','',''],['合子','',''],['合宜','',''],['合宪性','',''],['合家','',''],['合家欢','',''],['合属','',''],['合川区','',''],['合干者','',''],['合并','',''],['合并症','',''],['合并者','',''],['合度','',''],['合建','',''],['合式','',''],['合影','',''],['合影留念','',''],['合得来','',''],['合得着','',''],['合心','',''],['合情','',''],['合情合理','',''],['合意','',''],['合成','',''],['合成一个诸葛亮','',''],['合成代谢','',''],['合成器','',''],['合成天然橡胶','',''],['合成数','',''],['合成机','',''],['合成染料','',''],['合成树脂','',''],['合成橡胶','',''],['合成氨','',''],['合成氨法','',''],['合成法','',''],['合成洗涤剂','',''],['合成物','',''],['合成石油','',''],['合成矿物','',''],['合成类固醇','',''],['合成纤维','',''],['合成者','',''],['合成药物','',''],['合成词','',''],['合成语境','',''],['合成语音','',''],['合成酶','',''],['合成革','',''],['合扇','',''],['合手','',''],['合护','',''],['合抱','',''],['合拍','',''],['合拢','',''],['合掌','',''],['合掌瓜','',''],['合教','',''],['合数','',''],['合时','',''],['合时宜','',''],['合格','',''],['合格品','',''],['合格率','',''],['合格者','',''],['合格证','',''],['合格证书','',''],['合欢','',''],['合气道','',''],['合法','',''],['合法利益','',''],['合法化','',''],['合法席位','',''],['合法性','',''],['合法收入','',''],['合法政府','',''],['合法斗争','',''],['合法权利','',''],['合法权益','',''],['合法马克思主义','',''],['合流','',''],['合浦珠还','',''],['合浦还珠','',''],['合演','',''],['合照','',''],['合片','',''],['合物','',''],['合理','',''],['合理化','',''],['合理化建议','',''],['合理性','',''],['合理流动','',''],['合理负担','',''],['合璧','',''],['合瓣花冠','',''],['合用','',''],['合眼','',''],['合眼摸象','',''],['合租','',''],['合称','',''],['合算','',''],['合约','',''],['合纵','',''],['合纵连横','',''],['合线','',''],['合组','',''],['合编','',''],['合缝','',''],['合缝处','',''],['合群','',''],['合而为一','',''],['合股','',''],['合股线','',''],['合肥工业大学','',''],['合脚','',''],['合花','',''],['合营','',''],['合营企业','',''],['合著','',''],['合著者','',''],['合葬','',''],['合规','',''],['合解','',''],['合计','',''],['合订','',''],['合订本','',''],['合议','',''],['合议制','',''],['合议庭','',''],['合论','',''],['合该','',''],['合谋','',''],['合谷穴','',''],['合资','',''],['合资企业','',''],['合资经营','',''],['合身','',''],['合辑','',''],['合辙','',''],['合辙儿','',''],['合进','',''],['合适','',''],['合金','',''],['合金钢','',''],['合闸','',''],['合集','',''],['合面','',''],['合音','',''],['合页','',''],['合骑','',''],['合龙','',''],['吉之岛','',''],['吉事果','',''],['吉亚卡摩','',''],['吉人','',''],['吉人天相','',''],['吉人自有天相','',''],['吉他','',''],['吉他手','',''],['吉他谱','',''],['吉伯特氏症候群','',''],['吉兆','',''],['吉光片羽','',''],['吉兰丹','',''],['吉兰丹州','',''],['吉兰丹河','',''],['吉凶','',''],['吉列','',''],['吉利','',''],['吉剧','',''],['吉勒','',''],['吉卜力工作室','',''],['吉卜赛','',''],['吉卜赛人','',''],['吉合','',''],['吉士粉','',''],['吉大港','',''],['吉娃娃','',''],['吉字节','',''],['吉它','',''],['吉安乡','',''],['吉安地区','',''],['吉尔伯特','',''],['吉尔伯特群岛','',''],['吉尔吉斯','',''],['吉尔吉斯人','',''],['吉尔吉斯坦','',''],['吉尔吉斯族','',''],['吉尔达','',''],['吉尼斯','',''],['吉尼系数','',''],['吉州','',''],['吉州郡','',''],['吉庆','',''],['吉强镇','',''],['吉恩','',''],['吉打','',''],['吉拉尼','',''],['吉拉德','',''],['吉文','',''],['吉日','',''],['吉日良辰','',''],['吉普','',''],['吉普塞人','',''],['吉普斯夸','',''],['吉普赛','',''],['吉普赛人','',''],['吉普车','',''],['吉期','',''],['吉本斯','',''],['吉林大学','',''],['吉电子伏','',''],['吉百利','',''],['吉祥','',''],['吉祥如意','',''],['吉祥止止','',''],['吉祥物','',''],['吉米','',''],['吉贝','',''],['吉达','',''],['吉迪恩','',''],['吉通','',''],['吉野','',''],['吉野家','',''],['吉金','',''],['吉隆坡','',''],['吉隆波','',''],['吊丧','',''],['吊住','',''],['吊儿郎当','',''],['吊兰','',''],['吊具','',''],['吊刑','',''],['吊卷','',''],['吊古','',''],['吊古寻幽','',''],['吊台','',''],['吊味口','',''],['吊唁','',''],['吊嗓','',''],['吊嗓子','',''],['吊在','',''],['吊坠','',''],['吊塔','',''],['吊孝','',''],['吊审','',''],['吊客','',''],['吊带','',''],['吊带衫','',''],['吊床','',''],['吊引','',''],['吊慰','',''],['吊扇','',''],['吊打','',''],['吊扣','',''],['吊挂','',''],['吊文','',''],['吊斗','',''],['吊杆','',''],['吊杠','',''],['吊架','',''],['吊柜','',''],['吊档裤','',''],['吊桥','',''],['吊桶','',''],['吊梯','',''],['吊椅','',''],['吊楼','',''],['吊死','',''],['吊死问疾','',''],['吊死鬼','',''],['吊民伐罪','',''],['吊灯','',''],['吊环','',''],['吊球','',''],['吊瓶','',''],['吊瓶族','',''],['吊盘','',''],['吊着','',''],['吊祭','',''],['吊窗','',''],['吊篮','',''],['吊索','',''],['吊线','',''],['吊绳','',''],['吊胃口','',''],['吊膀','',''],['吊膀子','',''],['吊舱','',''],['吊艇','',''],['吊袜带','',''],['吊装','',''],['吊裤','',''],['吊裤带','',''],['吊誉沽名','',''],['吊诡','',''],['吊诡矜奇','',''],['吊起','',''],['吊车','',''],['吊运','',''],['吊针','',''],['吊钟','',''],['吊钟花','',''],['吊钩','',''],['吊铺','',''],['吊链','',''],['吊销','',''],['吊锚索','',''],['吊门','',''],['吊闸','',''],['吊顶','',''],['吊颈','',''],['吊鼻子','',''],['同一','',''],['同比','',''],['同一个','',''],['同一个世界','',''],['同一个梦想','',''],['同一律','',''],['同一性','',''],['同一时间','',''],['同上','',''],['同世','',''],['同业','',''],['同业公会','',''],['同业工会','',''],['同业拆借','',''],['同中心','',''],['同为','',''],['同义','',''],['同义反复','',''],['同义字','',''],['同义词','',''],['同义语','',''],['同乐','',''],['同乡','',''],['同乡亲故','',''],['同事','',''],['同于','',''],['同享','',''],['同人','',''],['同仁医院','',''],['同仁堂','',''],['同仇','',''],['同仇敌忾','',''],['同付','',''],['同代人','',''],['同价','',''],['同伙','',''],['同传耳麦','',''],['同伴','',''],['同位','',''],['同位格','',''],['同位素','',''],['同位素分离','',''],['同位角','',''],['同住','',''],['同住者','',''],['同体','',''],['同余','',''],['同余式','',''],['同余类','',''],['同作','',''],['同侪','',''],['同侪压力','',''],['同侪团体','',''],['同侪审查','',''],['同侪扶持','',''],['同侪检视','',''],['同侪谘商','',''],['同僚','',''],['同党','',''],['同减','',''],['同出一辙','',''],['同分异构','',''],['同分异构体','',''],['同前','',''],['同功一体','',''],['同化','',''],['同化作用','',''],['同化政策','',''],['同卵','',''],['同卵双胞胎','',''],['同原语','',''],['同去','',''],['同台','',''],['同吃','',''],['同名','',''],['同名同姓','',''],['同告','',''],['同命运','',''],['同唱','',''],['同喜','',''],['同回','',''],['同国人','',''],['同在','',''],['同地','',''],['同地方','',''],['同型','',''],['同型性','',''],['同型配子','',''],['同城','',''],['同堂','',''],['同增','',''],['同声','',''],['同声一哭','',''],['同声之应','',''],['同声传译','',''],['同声相应','',''],['同声翻译','',''],['同声附和','',''],['同处','',''],['同大','',''],['同好','',''],['同姓','',''],['同字框','',''],['同学','',''],['同学们','',''],['同安','',''],['同安县','',''],['同宗','',''],['同室','',''],['同室操戈','',''],['同室者','',''],['同宿','',''],['同宿舍','',''],['同居','',''],['同居人','',''],['同居者','',''],['同屋','',''],['同属','',''],['同岁','',''],['同工','',''],['同工不同酬','',''],['同工同酬','',''],['同工异曲','',''],['同席','',''],['同年','',''],['同年代','',''],['同年而语','',''],['同床','',''],['同床共枕','',''],['同床各梦','',''],['同床异梦','',''],['同庚','',''],['同座','',''],['同异','',''],['同归','',''],['同归于尽','',''],['同归殊涂','',''],['同归殊途','',''],['同形','',''],['同往','',''],['同往常一样','',''],['同德同心','',''],['同心协力','',''],['同心合力','',''],['同心同德','',''],['同心圆','',''],['同心并力','',''],['同心断金','',''],['同心鹿力','',''],['同志','',''],['同志们','',''],['同志合道','',''],['同态','',''],['同性','',''],['同性恋','',''],['同性恋恐惧症','',''],['同性恋爱','',''],['同性恋者','',''],['同性爱','',''],['同性相斥','',''],['同性质','',''],['同恶相助','',''],['同恶相救','',''],['同恶相求','',''],['同恶相济','',''],['同情','',''],['同情心','',''],['同情者','',''],['同意','',''],['同感','',''],['同房','',''],['同房间','',''],['同播','',''],['同收','',''],['同文馆','',''],['同於','',''],['同旁内角','',''],['同旁外角','',''],['同族','',''],['同族体','',''],['同日','',''],['同日而言','',''],['同日而语','',''],['同时','',''],['同时代','',''],['同时并举','',''],['同时性','',''],['同时期','',''],['同时间','',''],['同是','',''],['同月','',''],['同有','',''],['同期','',''],['同机','',''],['同村','',''],['同条','',''],['同条共贯','',''],['同构','',''],['同校','',''],['同样','',''],['同样地','',''],['同样是','',''],['同案','',''],['同案犯','',''],['同桌','',''],['同档','',''],['同次','',''],['同欢','',''],['同此','',''],['同步','',''],['同步加速器','',''],['同步化','',''],['同步卫星','',''],['同步发电机','',''],['同步增长','',''],['同步性','',''],['同步数位阶层','',''],['同步机','',''],['同步电动机','',''],['同母','',''],['同母异父','',''],['同气相求','',''],['同气连枝','',''],['同治','',''],['同流合污','',''],['同济','',''],['同济医科大学','',''],['同济大学','',''],['同温层','',''],['同源','',''],['同源词','',''],['同点','',''],['同父','',''],['同父异母','',''],['同父母','',''],['同犯','',''],['同狱','',''],['同班','',''],['同班同学','',''],['同理','',''],['同理心','',''],['同甘共苦','',''],['同甘同苦','',''],['同甘苦','',''],['同生共死','',''],['同用','',''],['同病','',''],['同病相怜','',''],['同盟','',''],['同盟会','',''],['同盟军','',''],['同盟国','',''],['同盟罢工','',''],['同盟者','',''],['同着','',''],['同知','',''],['同砚','',''],['同种','',''],['同科','',''],['同窗','',''],['同符合契','',''],['同等','',''],['同等学力','',''],['同等学历','',''],['同等对待','',''],['同等条件','',''],['同等条件下','',''],['同类','',''],['同类产品','',''],['同类型','',''],['同类相吸','',''],['同类相求','',''],['同类相食','',''],['同类项','',''],['同系','',''],['同系物','',''],['同素','',''],['同素体','',''],['同素异形体','',''],['同级','',''],['同级评审','',''],['同线','',''],['同组','',''],['同翅目','',''],['同翅类','',''],['同胞','',''],['同胞兄妹','',''],['同舟共济','',''],['同舟而济','',''],['同船','',''],['同色','',''],['同花顺','',''],['同蒙其利','',''],['同蒲铁路','',''],['同血族','',''],['同行','',''],['同行业','',''],['同袍','',''],['同袍同泽','',''],['同语','',''],['同调','',''],['同谋','',''],['同谋者','',''],['同质','',''],['同质性','',''],['同贺','',''],['同路','',''],['同路人','',''],['同跳','',''],['同轴','',''],['同轴圆弧','',''],['同轴电缆','',''],['同辈','',''],['同途殊归','',''],['同道','',''],['同道中人','',''],['同道者','',''],['同配生殖','',''],['同酬','',''],['同量','',''],['同量异位素','',''],['同门','',''],['同门异户','',''],['同队','',''],['同音','',''],['同音字','',''],['同音词','',''],['同韵词','',''],['同额','',''],['同餐','',''],['同龄','',''],['同龄人','',''],['名下','',''],['名下无虚','',''],['名不副实','',''],['名不正言不顺','',''],['名不符实','',''],['名不虚传','',''],['名不虚行','',''],['名不见经传','',''],['名为','',''],['名义','',''],['名义上','',''],['名义价值','',''],['名义工资','',''],['名义账户','',''],['名产','',''],['名人','',''],['名人录','',''],['名从主人','',''],['名份','',''],['名优','',''],['名优产品','',''],['名优新','',''],['名优新产品','',''],['名优特新产品','',''],['名位','',''],['名作','',''],['名儒','',''],['名儿','',''],['名册','',''],['名分','',''],['名列','',''],['名列前茅','',''],['名列榜首','',''],['名列第一','',''],['名列首位','',''],['名利','',''],['名利双收','',''],['名利场','',''],['名制','',''],['名刺','',''],['名副其实','',''],['名匠','',''],['名医','',''],['名单','',''],['名厨','',''],['名古屋','',''],['名句','',''],['名叫','',''],['名史','',''],['名号','',''],['名后','',''],['名唤','',''],['名嘴','',''],['名噪一时','',''],['名地','',''],['名址','',''],['名垂','',''],['名垂史册','',''],['名垂青史','',''],['名城','',''],['名堂','',''],['名士','',''],['名士派','',''],['名士风流','',''],['名声','',''],['名声在外','',''],['名声大噪','',''],['名声大振','',''],['名声好','',''],['名声狼藉','',''],['名妓','',''],['名媒正配','',''],['名媛','',''],['名子','',''],['名字','',''],['名存实亡','',''],['名学','',''],['名实','',''],['名实不符','',''],['名实相副','',''],['名实相称','',''],['名实相符','',''],['名家','',''],['名将','',''],['名山事业','',''],['名山大川','',''],['名师','',''],['名师出高徒','',''],['名帖','',''],['名录','',''],['名录服务','',''],['名手','',''],['名扬中外','',''],['名扬四方','',''],['名扬四海','',''],['名教','',''],['名数','',''],['名星','',''],['名曲','',''],['名望','',''],['名标青史','',''],['名校','',''],['名模','',''],['名次','',''],['名正言顺','',''],['名气','',''],['名流','',''],['名源','',''],['名满天下','',''],['名演','',''],['名演员','',''],['名烟','',''],['名爵','',''],['名片','',''],['名片盒','',''],['名牌','',''],['名牌产品','',''],['名牌货','',''],['名物','',''],['名特产','',''],['名状','',''],['名画','',''],['名画家','',''],['名目','',''],['名目繁多','',''],['名相','',''],['名称','',''],['名称权','',''],['名称标签','',''],['名符其实','',''],['名签','',''],['名篇','',''],['名簿','',''],['名缰利索','',''],['名缰利锁','',''],['名胜','',''],['名胜古迹','',''],['名臣','',''],['名节','',''],['名茶','',''],['名菜','',''],['名落孙山','',''],['名著','',''],['名衔','',''],['名表','',''],['名裂','',''],['名角','',''],['名角儿','',''],['名言','',''],['名言集','',''],['名誉','',''],['名誉博士','',''],['名誉博士学位','',''],['名誉坏','',''],['名誉好','',''],['名誉学位','',''],['名誉扫地','',''],['名誉权','',''],['名讳','',''],['名论','',''],['名词','',''],['名诗','',''],['名贵','',''],['名贵药材','',''],['名过其实','',''],['名酒','',''],['名重识暗','',''],['名量词','',''],['名门','',''],['名门世族','',''],['名门望族','',''],['名间','',''],['名间乡','',''],['名闻','',''],['名震中外','',''],['名额','',''],['名额有限','',''],['名驰遐迩','',''],['名高天下','',''],['名高难副','',''],['后一段','',''],['后不为例','',''],['后不见来者','',''],['后世','',''],['后两者','',''],['后为','',''],['后主','',''],['后之','',''],['后事','',''],['后事之师','',''],['后人','',''],['后人乘凉','',''],['后仍','',''],['后付','',''],['后代','',''],['后以','',''],['后仰','',''],['后仰前合','',''],['后任','',''],['后会可期','',''],['后会无期','',''],['后会有期','',''],['后会难期','',''],['后信号灯','',''],['后倾','',''],['后儿','',''],['后元音','',''],['后入','',''],['后冬','',''],['后冲','',''],['后凉','',''],['后列','',''],['后加','',''],['后劲','',''],['后势看俏','',''],['后勤','',''],['后勤体制','',''],['后勤保障','',''],['后勤史','',''],['后勤学','',''],['后勤工作','',''],['后勤建设','',''],['后勤思想','',''],['后勤技术','',''],['后勤法规','',''],['后勤理论','',''],['后勤管理','',''],['后勤装备','',''],['后勤部','',''],['后勾拳','',''],['后半','',''],['后半叶','',''],['后半场','',''],['后半夜','',''],['后半天','',''],['后半晌','',''],['后半期','',''],['后半生','',''],['后半部','',''],['后卫','',''],['后卫线','',''],['后即','',''],['后厅','',''],['后厦','',''],['后又','',''],['后发制人','',''],['后发座','',''],['后变','',''],['后召','',''],['后台','',''],['后台老板','',''],['后叶','',''],['后合前仰','',''],['后周','',''],['后味','',''],['后唐','',''],['后嗣','',''],['后圈','',''],['后坐','',''],['后坐力','',''],['后壁','',''],['后壁乡','',''],['后备','',''],['后备军','',''],['后备干部','',''],['后备箱','',''],['后天下之乐而乐','',''],['后天性','',''],['后头','',''],['后奏曲','',''],['后妃','',''],['后妈','',''],['后娘','',''],['后婚','',''],['后婚儿','',''],['后学','',''],['后实先声','',''],['后宫','',''],['后尘','',''],['后尾儿','',''],['后屈','',''],['后屋','',''],['后山','',''],['后已','',''],['后巷','',''],['后巷前街','',''],['后帐','',''],['后序','',''],['后座','',''],['后庭','',''],['后延','',''],['后影','',''],['后心','',''],['后怕','',''],['后恭前倨','',''],['后悔','',''],['后悔不及','',''],['后悔不该','',''],['后悔不迭','',''],['后悔何及','',''],['后悔无及','',''],['后悔药','',''],['后悔莫及','',''],['后患','',''],['后患无穷','',''],['后想','',''],['后感','',''],['后感觉','',''],['后成','',''],['后房','',''],['后手','',''],['后手不接','',''],['后才','',''],['后拥','',''],['后拥前呼','',''],['后拥前遮','',''],['后拥前驱','',''],['后挡板','',''],['后排','',''],['后掠角','',''],['后接','',''],['后推','',''],['后掩蔽','',''],['后援','',''],['后摆','',''],['后撤','',''],['后效','',''],['后文','',''],['后方','',''],['后方补给','',''],['后方防卫','',''],['后日','',''],['后明','',''],['后晋','',''],['后晌','',''],['后景','',''],['后期','',''],['后来','',''],['后来之秀','',''],['后来居上','',''],['后来者居上','',''],['后果','',''],['后果前因','',''],['后果自负','',''],['后查','',''],['后桥','',''],['后梁','',''],['后步','',''],['后段','',''],['后殿','',''],['后母','',''],['后汉','',''],['后汉书','',''],['后没','',''],['后浪','',''],['后浪崔前浪','',''],['后浪推前浪','',''],['后港','',''],['后溪穴','',''],['后滞','',''],['后灯','',''],['后燕','',''],['后父','',''],['后爹','',''],['后现代主义','',''],['后生','',''],['后生动物','',''],['后生可畏','',''],['后生小子','',''],['后生晚学','',''],['后用','',''],['后甲板','',''],['后盖','',''],['后盾','',''],['后福','',''],['后秦','',''],['后空翻','',''],['后窗','',''],['后端','',''],['后类','',''],['后继','',''],['后继乏人','',''],['后继无人','',''],['后继有人','',''],['后继者','',''],['后续','',''],['后续的解释过程','',''],['后缀','',''],['后缘','',''],['后罩房','',''],['后置','',''],['后置词','',''],['后羿','',''],['后翅','',''],['后翻筋斗','',''],['后者','',''],['后肢','',''],['后背','',''],['后胸','',''],['后能','',''],['后脑','',''],['后脑勺','',''],['后脑勺子','',''],['后脑海','',''],['后脚','',''],['后脸儿','',''],['后腰','',''],['后腿','',''],['后膛','',''],['后舱','',''],['后蜀','',''],['后行','',''],['后街','',''],['后补','',''],['后补者','',''],['后被','',''],['后裔','',''],['后襟','',''],['后西游记','',''],['后见之明','',''],['后视','',''],['后视图','',''],['后视镜','',''],['后记','',''],['后设','',''],['后诊','',''],['后词汇加工','',''],['后话','',''],['后语','',''],['后账','',''],['后赵','',''],['后起','',''],['后起之秀','',''],['后跟','',''],['后路','',''],['后身','',''],['后车之戒','',''],['后车之鉴','',''],['后车轴','',''],['后转','',''],['后轮','',''],['后轴','',''],['后辈','',''],['后辍','',''],['后边','',''],['后边儿','',''],['后进','',''],['后进先出','',''],['后进变先进','',''],['后述','',''],['后退','',''],['后送','',''],['后送医院','',''],['后逃','',''],['后选','',''],['后遗','',''],['后遗症','',''],['后部','',''],['后里','',''],['后里乡','',''],['后金','',''],['后钩','',''],['后钩儿','',''],['后门','',''],['后门打狼','',''],['后门进狼','',''],['后防线','',''],['后附','',''],['后院','',''],['后院起火','',''],['后面','',''],['后项','',''],['后顾','',''],['后顾之忧','',''],['后顾之患','',''],['后顾之虑','',''],['后顾之虞','',''],['后颈','',''],['后首','',''],['后魏','',''],['后鼻音','',''],['后龙','',''],['后龙镇','',''],['吏治','',''],['吏胥','',''],['吏部','',''],['吐槽','',''],['吐丝','',''],['吐丝自缚','',''],['吐了','',''],['吐出','',''],['吐出物','',''],['吐刚茹柔','',''],['吐口','',''],['吐口水','',''],['吐司','',''],['吐哺握发','',''],['吐唾沫','',''],['吐奶','',''],['吐字','',''],['吐属','',''],['吐弃','',''],['吐故纳新','',''],['吐根','',''],['吐气','',''],['吐气扬眉','',''],['吐沫','',''],['吐泡','',''],['吐泻','',''],['吐火','',''],['吐火罗人','',''],['吐瓦鲁','',''],['吐痰','',''],['吐穗','',''],['吐絮','',''],['吐纳','',''],['吐绶鸡','',''],['吐胆倾心','',''],['吐艳','',''],['吐苦水','',''],['吐蕃','',''],['吐蕃王朝','',''],['吐藩','',''],['吐血','',''],['吐诉','',''],['吐谷浑','',''],['吐雾','',''],['吐露','',''],['吐露真情','',''],['吐鲁番盆地','',''],['向一边','',''],['向上','',''],['向上举','',''],['向上扔','',''],['向上抛','',''],['向上游','',''],['向上爬','',''],['向上看','',''],['向下','',''],['向下坡','',''],['向下看','',''],['向下风','',''],['向东','',''],['向东北','',''],['向东南','',''],['向东方','',''],['向东行','',''],['向于','',''],['向人民负责','',''],['向何处','',''],['向使','',''],['向例','',''],['向侧边','',''],['向侧面','',''],['向傍侧','',''],['向光','',''],['向内','',''],['向内卷','',''],['向到','',''],['向前','',''],['向前冲','',''],['向前看','',''],['向前翻腾','',''],['向前进','',''],['向北','',''],['向北地','',''],['向北方','',''],['向南','',''],['向南方','',''],['向右','',''],['向右拐','',''],['向右转','',''],['向后','',''],['向后翻腾','',''],['向后转','',''],['向后面','',''],['向哪','',''],['向地性','',''],['向壁虚构','',''],['向壁虚造','',''],['向外','',''],['向外面','',''],['向太空','',''],['向她','',''],['向学','',''],['向导','',''],['向岸上','',''],['向左','',''],['向左拐','',''],['向左转','',''],['向巴平措','',''],['向平之愿','',''],['向往','',''],['向心','',''],['向心力','',''],['向性','',''],['向慕','',''],['向我','',''],['向搂上','',''],['向斜','',''],['向斜层','',''],['向无此例','',''],['向日','',''],['向日性','',''],['向日葵','',''],['向暮','',''],['向来','',''],['向标','',''],['向正','',''],['向此','',''],['向海','',''],['向海外','',''],['向海岸','',''],['向海面','',''],['向火','',''],['向火乞儿','',''],['向盘','',''],['向着','',''],['向社会开放','',''],['向纵深发展','',''],['向背','',''],['向舷外','',''],['向著','',''],['向西','',''],['向西南','',''],['向这','',''],['向这边','',''],['向这里','',''],['向迩','',''],['向那','',''],['向里','',''],['向里头','',''],['向野外','',''],['向量','',''],['向量代数','',''],['向量图形','',''],['向阳','',''],['向阳花','',''],['向隅','',''],['向隅独泣','',''],['向隅而泣','',''],['向风','',''],['吓一跳','',''],['吓不倒','',''],['吓了','',''],['吓人','',''],['吓住','',''],['吓倒','',''],['吓傻','',''],['吓呆','',''],['吓唬','',''],['吓嘘','',''],['吓坏','',''],['吓声','',''],['吓得','',''],['吓得发抖','',''],['吓昏','',''],['吓死','',''],['吓疯','',''],['吓着','',''],['吓破胆','',''],['吓走','',''],['吓跑','',''],['吓阻','',''],['吕不韦','',''],['吕剧','',''],['吕塞尔斯海姆','',''],['吕安题凤','',''],['吕宋','',''],['吕宋岛','',''],['吕宋烟','',''],['吕岩','',''],['吕布','',''],['吕布戟','',''],['吕望','',''],['吕氏春秋','',''],['吕蒙','',''],['吕览','',''],['吕贝克','',''],['吖啶','',''],['吖嗪','',''],['吗哪','',''],['吗啡','',''],['吗啡精','',''],['君临','',''],['君主','',''],['君主专制','',''],['君主专制制','',''],['君主制','',''],['君主国','',''],['君主政体','',''],['君主政治','',''],['君主权','',''],['君主立宪','',''],['君主立宪制','',''],['君位','',''],['君士坦丁堡','',''],['君子','',''],['君子一言','',''],['君子一言快马一鞭','',''],['君子不计小人过','',''],['君子之交','',''],['君子之交淡如水','',''],['君子兰','',''],['君子动口不动手','',''],['君子协定','',''],['君子国','',''],['君子坦荡荡','',''],['君山','',''],['君悦','',''],['君权','',''],['君王','',''],['君臣','',''],['吝于','',''],['吝啬','',''],['吝啬者','',''],['吝啬鬼','',''],['吝惜','',''],['吝舍','',''],['吞下','',''],['吞云吐雾','',''],['吞剥','',''],['吞吃','',''],['吞吐','',''],['吞吐能力','',''],['吞吐量','',''],['吞吞吐吐','',''],['吞咽','',''],['吞噬','',''],['吞噬作用','',''],['吞噬细胞','',''],['吞声','',''],['吞声忍气','',''],['吞声饮气','',''],['吞并','',''],['吞恨','',''],['吞拿','',''],['吞拿鱼','',''],['吞掉','',''],['吞服','',''],['吞没','',''],['吞灭','',''],['吞炭漆身','',''],['吞物','',''],['吞米桑布札','',''],['吞精','',''],['吞舟之鱼','',''],['吞金','',''],['吞食','',''],['吟味','',''],['吟咏','',''],['吟哦','',''],['吟唱','',''],['吟唱者','',''],['吟子打死','',''],['吟游','',''],['吟篇','',''],['吟诗','',''],['吟诵','',''],['吟颂','',''],['吟风咏月','',''],['吟风弄月','',''],['吠叫','',''],['吠吠','',''],['吠声','',''],['吠形吠声','',''],['吠影吠声','',''],['吠月','',''],['吠舍','',''],['吠陀','',''],['吠非其主','',''],['吡叻','',''],['吡咯','',''],['吡啶','',''],['吡拉西坦','',''],['否决','',''],['否决权','',''],['否决票','',''],['否决者','',''],['否则','',''],['否去泰来','',''],['否定','',''],['否定之否定','',''],['否定句','',''],['否定性','',''],['否定论','',''],['否有效','',''],['否极泰来','',''],['否极泰至','',''],['否极生泰','',''],['否终则泰','',''],['否终而泰','',''],['否认','',''],['否认者','',''],['吧台','',''],['吧唧','',''],['吧唧吧唧','',''],['吧嗒','',''],['吧女','',''],['吧托','',''],['吧托女','',''],['吧间','',''],['吨位','',''],['吨公里','',''],['吨数','',''],['吨海里','',''],['吨级','',''],['吩咐','',''],['含义','',''],['含于','',''],['含冤','',''],['含冤负屈','',''],['含吞','',''],['含含糊糊','',''],['含味隽永','',''],['含哺鼓腹','',''],['含商咀征','',''],['含在','',''],['含垢忍耻','',''],['含垢忍辱','',''],['含垢纳污','',''],['含垢藏疾','',''],['含多','',''],['含宫咀征','',''],['含忍耻辱','',''],['含怒','',''],['含恨','',''],['含情脉脉','',''],['含意','',''],['含括','',''],['含无','',''],['含有','',''],['含有量','',''],['含毒','',''],['含气','',''],['含氧','',''],['含氧酸','',''],['含水','',''],['含水层','',''],['含水量','',''],['含沙','',''],['含沙射影','',''],['含沙量','',''],['含油','',''],['含油岩','',''],['含泪','',''],['含混','',''],['含混不清','',''],['含湿气','',''],['含漱剂','',''],['含燐','',''],['含片','',''],['含病毒','',''],['含盐量','',''],['含着','',''],['含石油','',''],['含碱','',''],['含碳','',''],['含磷','',''],['含税','',''],['含笑','',''],['含笑九泉','',''],['含笑入地','',''],['含米特人','',''],['含糊','',''],['含糊不清','',''],['含糊其辞','',''],['含糖','',''],['含纤维','',''],['含羞','',''],['含羞草','',''],['含而不露','',''],['含胡','',''],['含苞','',''],['含苞待放','',''],['含苞欲放','',''],['含英咀华','',''],['含蓄','',''],['含蓼问疾','',''],['含蕴','',''],['含血喷人','',''],['含辛茹苦','',''],['含酒精','',''],['含酸','',''],['含量','',''],['含金','',''],['含金量','',''],['含钙','',''],['含铁','',''],['含铁质','',''],['含雪','',''],['含饴弄孙','',''],['含鸦片','',''],['含齿戴发','',''],['听不','',''],['听不到','',''],['听不懂','',''],['听不见','',''],['听不进','',''],['听不进去','',''],['听之','',''],['听之任之','',''],['听书','',''],['听了','',''],['听事','',''],['听人','',''],['听人摆布','',''],['听人穿鼻','',''],['听从','',''],['听他','',''],['听任','',''],['听众','',''],['听众席','',''],['听会','',''],['听使','',''],['听便','',''],['听信','',''],['听信谣言','',''],['听候','',''],['听候处理','',''],['听做','',''],['听其自然','',''],['听其言而观其行','',''],['听其言观其行','',''],['听写','',''],['听凭','',''],['听出','',''],['听到','',''],['听力','',''],['听力理解','',''],['听力表','',''],['听力计','',''],['听厌','',''],['听取','',''],['听取意见','',''],['听取批评','',''],['听取汇报','',''],['听后','',''],['听君一席话','',''],['听听','',''],['听命','',''],['听墙根','',''],['听墙根儿','',''],['听墙面','',''],['听天任命','',''],['听天安命','',''],['听天由命','',''],['听头','',''],['听子','',''],['听完','',''],['听审','',''],['听审会','',''],['听小骨','',''],['听岔','',''],['听差','',''],['听度计','',''],['听得','',''],['听得懂','',''],['听得见','',''],['听惯','',''],['听想','',''],['听懂','',''],['听戏','',''],['听我','',''],['听房','',''],['听政','',''],['听断','',''],['听来','',''],['听清','',''],['听着','',''],['听神经','',''],['听窗','',''],['听筒','',''],['听者','',''],['听者有心','',''],['听而不闻','',''],['听而无闻视而不见','',''],['听腻','',''],['听腻了','',''],['听著','',''],['听装','',''],['听见','',''],['听见风就是雨','',''],['听观','',''],['听觉','',''],['听觉型','',''],['听觉学','',''],['听讲','',''],['听讼','',''],['听证','',''],['听证会','',''],['听诊','',''],['听诊器','',''],['听话','',''],['听话儿','',''],['听话听声','',''],['听说','',''],['听说读写','',''],['听课','',''],['听起','',''],['听起来','',''],['听过','',''],['听错','',''],['听闻','',''],['听阈','',''],['听随','',''],['听风','',''],['听风听水','',''],['听风就是雨','',''],['听风是雨','',''],['听骨','',''],['听骨链','',''],['吭吭','',''],['吭哧','',''],['吭声','',''],['吭气','',''],['吮乳','',''],['吮吸','',''],['吮干','',''],['吮痈舐痔','',''],['启事','',''],['启人疑窦','',''],['启动','',''],['启动作业','',''],['启动区','',''],['启动子','',''],['启动市场','',''],['启动技术','',''],['启发','',''],['启发式','',''],['启发式教学','',''],['启发性','',''],['启发法','',''],['启发者','',''],['启口','',''],['启奏','',''],['启封','',''],['启应祈祷','',''],['启开','',''],['启德机场','',''],['启明','',''],['启明星','',''],['启用','',''],['启碇','',''],['启示','',''],['启示录','',''],['启示性','',''],['启示者','',''],['启禀','',''],['启程','',''],['启航','',''],['启蒙','',''],['启蒙专制君主','',''],['启蒙主义','',''],['启蒙运动','',''],['启蛰','',''],['启衅','',''],['启运','',''],['启迪','',''],['启闭','',''],['启齿','',''],['吱叫','',''],['吱吱','',''],['吱吱叫','',''],['吱吱响','',''],['吱吱嘎嘎','',''],['吱吱声','',''],['吱吾','',''],['吱响','',''],['吱唔','',''],['吱喳','',''],['吱嘎','',''],['吱声','',''],['吲哚','',''],['吴孟达','',''],['吴下阿蒙','',''],['吴中','',''],['吴仪','',''],['吴任臣','',''],['吴作栋','',''],['吴侬娇语','',''],['吴侬软语','',''],['吴兴','',''],['吴县','',''],['吴哥','',''],['吴哥城','',''],['吴哥窟','',''],['吴嘉经','',''],['吴国','',''],['吴天明','',''],['吴头楚尾','',''],['吴子','',''],['吴孟超','',''],['吴官正','',''],['吴尊','',''],['吴市吹箫','',''],['吴建豪','',''],['吴承恩','',''],['吴敬梓','',''],['吴晗','',''],['吴楚','',''],['吴永刚','',''],['吴淞','',''],['吴清源','',''],['吴牛喘月','',''],['吴牛见月','',''],['吴玉章','',''],['吴王阖庐','',''],['吴王阖闾','',''],['吴用','',''],['吴自牧','',''],['吴茱萸','',''],['吴语','',''],['吴起','',''],['吴起县','',''],['吴越','',''],['吴越同舟','',''],['吴越春秋','',''],['吴越曲','',''],['吴趼人','',''],['吴邦国','',''],['吴镇宇','',''],['吵吵','',''],['吵吵嚷嚷','',''],['吵吵闹闹','',''],['吵嘴','',''],['吵嚷','',''],['吵子','',''],['吵得','',''],['吵杂','',''],['吵架','',''],['吵着','',''],['吵翻','',''],['吵者','',''],['吵过','',''],['吵醒','',''],['吵闹','',''],['吵闹声','',''],['吸上','',''],['吸了','',''],['吸住','',''],['吸允','',''],['吸入','',''],['吸入剂','',''],['吸入器','',''],['吸入者','',''],['吸入量','',''],['吸入阀','',''],['吸出','',''],['吸出器','',''],['吸到','',''],['吸力','',''],['吸取','',''],['吸取教训','',''],['吸口','',''],['吸吮','',''],['吸墨纸','',''],['吸声','',''],['吸奶','',''],['吸孔','',''],['吸小','',''],['吸尘','',''],['吸尘器','',''],['吸尘机','',''],['吸尽','',''],['吸干','',''],['吸引','',''],['吸引人','',''],['吸引力','',''],['吸引外资','',''],['吸引子','',''],['吸引子网络','',''],['吸引物','',''],['吸引著','',''],['吸收','',''],['吸收体','',''],['吸收光谱','',''],['吸收剂','',''],['吸收剂量','',''],['吸收器','',''],['吸收外资','',''],['吸收度','',''],['吸收性','',''],['吸收比','',''],['吸收率','',''],['吸毒','',''],['吸毒成瘾','',''],['吸毒者','',''],['吸气','',''],['吸气器','',''],['吸氧','',''],['吸水','',''],['吸水力','',''],['吸法','',''],['吸浆虫','',''],['吸湿','',''],['吸湿性','',''],['吸烟','',''],['吸烟区','',''],['吸烟室','',''],['吸烟者','',''],['吸热','',''],['吸热性','',''],['吸留','',''],['吸盘','',''],['吸着','',''],['吸着剂','',''],['吸着物','',''],['吸睛','',''],['吸碳','',''],['吸碳存','',''],['吸积','',''],['吸管','',''],['吸纳','',''],['吸芽','',''],['吸虫','',''],['吸虫纲','',''],['吸血','',''],['吸血者','',''],['吸血鬼','',''],['吸起','',''],['吸进','',''],['吸金','',''],['吸铁石','',''],['吸门','',''],['吸附','',''],['吸附剂','',''],['吸附性','',''],['吸附洗消剂','',''],['吸音','',''],['吸顶灯','',''],['吸食','',''],['吸饱','',''],['吹了','',''],['吹倒','',''],['吹光','',''],['吹入','',''],['吹冷风','',''],['吹出','',''],['吹动','',''],['吹去','',''],['吹口哨','',''],['吹叶机','',''],['吹号','',''],['吹向','',''],['吹吹','',''],['吹吹打打','',''],['吹吹拍拍','',''],['吹响','',''],['吹哨','',''],['吹喇叭','',''],['吹嘘','',''],['吹大气','',''],['吹大法螺','',''],['吹奏','',''],['吹孔','',''],['吹干','',''],['吹开','',''],['吹影镂尘','',''],['吹成','',''],['吹打','',''],['吹打乐','',''],['吹扫','',''],['吹拂','',''],['吹捧','',''],['吹掉','',''],['吹擂','',''],['吹散','',''],['吹棉介壳虫','',''],['吹毛求瑕','',''],['吹毛求疵','',''],['吹毛索疵','',''],['吹气','',''],['吹气胜兰','',''],['吹求','',''],['吹法','',''],['吹泡','',''],['吹消','',''],['吹火','',''],['吹灭','',''],['吹灰','',''],['吹灰之力','',''],['吹点','',''],['吹炼','',''],['吹熄','',''],['吹牛','',''],['吹牛专家','',''],['吹牛拍马','',''],['吹牛皮','',''],['吹皱一池春水','',''],['吹竽手','',''],['吹笛','',''],['吹笛子','',''],['吹笛者','',''],['吹管','',''],['吹管乐','',''],['吹箫','',''],['吹箫乞食','',''],['吹糠见米','',''],['吹胀','',''],['吹胡子瞪眼','',''],['吹腔','',''],['吹袭','',''],['吹走','',''],['吹起','',''],['吹进','',''],['吹遍','',''],['吹雾','',''],['吹风','',''],['吹风机','',''],['吹鼓手','',''],['吻别','',''],['吻合','',''],['吻手','',''],['吻技','',''],['吻痕','',''],['吼出','',''],['吼叫','',''],['吼声','',''],['吼道','',''],['吽牙','',''],['吾人','',''],['吾令','',''],['吾侪','',''],['吾兄','',''],['吾地','',''],['吾家','',''],['吾尔','',''],['吾尔开希','',''],['吾生也有涯','',''],['吾等','',''],['吾辈','',''],['吾道东矣','',''],['呀呀','',''],['呀诺达','',''],['呃逆','',''],['呆会儿','',''],['呆住','',''],['呆傻','',''],['呆呆','',''],['呆呆地','',''],['呆在','',''],['呆在家','',''],['呆头','',''],['呆头呆脑','',''],['呆子','',''],['呆小症','',''],['呆帐','',''],['呆得','',''],['呆想','',''],['呆板','',''],['呆根','',''],['呆滞','',''],['呆瓜','',''],['呆看','',''],['呆立','',''],['呆笨','',''],['呆若木鸡','',''],['呆视','',''],['呆话','',''],['呆账','',''],['呈上','',''],['呈上升趋势','',''],['呈交','',''],['呈准','',''],['呈出','',''],['呈函','',''],['呈子','',''],['呈应','',''],['呈报','',''],['呈文','',''],['呈正','',''],['呈献','',''],['呈现','',''],['呈现出','',''],['呈祥','',''],['呈给','',''],['呈脉','',''],['呈请','',''],['呈送','',''],['呈递','',''],['呈阅','',''],['呈阳性','',''],['呈露','',''],['呈项','',''],['呈验','',''],['告一段落','',''],['告之','',''],['告人','',''],['告便','',''],['告假','',''],['告别','',''],['告别仪式','',''],['告别宴会','',''],['告别式','',''],['告别词','',''],['告别话','',''],['告别辞','',''],['告劳','',''],['告发','',''],['告吹','',''],['告密','',''],['告密者','',''],['告急','',''],['告慰','',''],['告成','',''],['告戒','',''],['告捷','',''],['告朔饩羊','',''],['告栏','',''],['告求','',''],['告牌','',''],['告状','',''],['告病','',''],['告白','',''],['告知','',''],['告示','',''],['告示牌','',''],['告竣','',''],['告终','',''],['告绝','',''],['告罄','',''],['告罪','',''],['告老','',''],['告老还乡','',''],['告者','',''],['告解','',''],['告警','',''],['告诉','',''],['告诫','',''],['告语','',''],['告诵','',''],['告谢','',''],['告贷','',''],['告辞','',''],['告退','',''],['告送','',''],['告饶','',''],['呋喃','',''],['呋喃西林','',''],['呐喊','',''],['呒啥','',''],['呒虾米','',''],['呒虾米输入法','',''],['呓语','',''],['呕出物','',''],['呕吐','',''],['呕吐物','',''],['呕吐者','',''],['呕心','',''],['呕心吐胆','',''],['呕心沥血','',''],['呕气','',''],['呕血','',''],['呖呖','',''],['员外','',''],['员外郎','',''],['员山','',''],['员山乡','',''],['员工','',''],['员林','',''],['员林镇','',''],['员警','',''],['员额','',''],['呛人','',''],['呛到','',''],['呛咕','',''],['呛鼻','',''],['呜乎哀哉','',''],['呜冤叫屈','',''],['呜呜','',''],['呜呼','',''],['呜呼哀哉','',''],['呜咽','',''],['呜声','',''],['呜辞','',''],['呢呢','',''],['呢呢痴痴','',''],['呢喃','',''],['呢喃细语','',''],['呢子','',''],['呢帽','',''],['呢称','',''],['呢绒','',''],['呢绒商','',''],['呤呤','',''],['呤唱','',''],['呦呦','',''],['周一岳','',''],['周三径一','',''],['周书','',''],['周代','',''],['周会','',''],['周传瑛','',''],['周作人','',''],['周全','',''],['周公吐哺','',''],['周刊','',''],['周到','',''],['周勃','',''],['周口地区','',''],['周口店','',''],['周围','',''],['周围性眩晕','',''],['周围环境','',''],['周围神经','',''],['周地','',''],['周处','',''],['周宣王','',''],['周家','',''],['周密','',''],['周小川','',''],['周岁','',''],['周年','',''],['周庄','',''],['周庄镇','',''],['周延','',''],['周径','',''],['周急继乏','',''],['周总理','',''],['周恤','',''],['周恩来','',''],['周扒皮','',''],['周折','',''],['周报','',''],['周敦颐','',''],['周文王','',''],['周旋','',''],['周易','',''],['周星驰','',''],['周晬','',''],['周朝','',''],['周期','',''],['周期函数','',''],['周期律','',''],['周期性','',''],['周期数','',''],['周期系','',''],['周期表','',''],['周期解','',''],['周未','',''],['周末','',''],['周末愉快','',''],['周村','',''],['周杰伦','',''],['周树人','',''],['周梁淑怡','',''],['周正','',''],['周武王','',''],['周武王姬发','',''],['周永康','',''],['周波','',''],['周济','',''],['周润发','',''],['周渝民','',''],['周游','',''],['周游世界','',''],['周游列国','',''],['周狗','',''],['周率','',''],['周王朝','',''],['周瑜','',''],['周瑜打黄盖','',''],['周璇','',''],['周界','',''],['周瘦鹃','',''],['周相','',''],['周知','',''],['周礼','',''],['周穆王','',''],['周立波','',''],['周章','',''],['周线','',''],['周缘','',''],['周而不比','',''],['周而复始','',''],['周薪','',''],['周角','',''],['周详','',''],['周身','',''],['周转','',''],['周转期','',''],['周转率','',''],['周转资金','',''],['周转量','',''],['周转金','',''],['周边','',''],['周边设备','',''],['周速','',''],['周遍','',''],['周遭','',''],['周郎顾曲','',''],['周长','',''],['周几','',''],['呫吨','',''],['呫吨酮','',''],['呫呫','',''],['呫哔','',''],['呫嗫','',''],['呫嚅','',''],['呫毕','',''],['呱呱','',''],['呱呱叫','',''],['呱哒','',''],['呱唧','',''],['呱嗒','',''],['呱嗒板儿','',''],['呲牙','',''],['呲牙咧嘴','',''],['味儿','',''],['味同嚼腊','',''],['味同嚼蜡','',''],['味噌汤','',''],['味好','',''],['味如嚼蜡','',''],['味如鸡肋','',''],['味差','',''],['味数','',''],['味料','',''],['味汁','',''],['味浓','',''],['味淡','',''],['味甘美','',''],['味精','',''],['味素','',''],['味美','',''],['味美思酒','',''],['味著','',''],['味蕾','',''],['味觉','',''],['味觉迟钝','',''],['味道','',''],['味道好','',''],['味道差','',''],['呵佛骂祖','',''],['呵叱','',''],['呵呵','',''],['呵喝','',''],['呵壁问天','',''],['呵成','',''],['呵护','',''],['呵斥','',''],['呵欠','',''],['呵欠虫','',''],['呵气','',''],['呵痒','',''],['呵禁','',''],['呵责','',''],['呶呶','',''],['呶呶不休','',''],['呷呷','',''],['呷茶','',''],['呸声','',''],['呻吟','',''],['呻吟声','',''],['呼中','',''],['呼中区','',''],['呼么喝六','',''],['呼之即来','',''],['呼之即来挥之即去','',''],['呼之欲出','',''],['呼伦湖','',''],['呼伦贝尔盟','',''],['呼伦贝尔草原','',''],['呼入','',''],['呼兰','',''],['呼出','',''],['呼卢喝雉','',''],['呼叫','',''],['呼叫中心','',''],['呼叫器','',''],['呼叫声','',''],['呼叫者','',''],['呼召','',''],['呼号','',''],['呼吁','',''],['呼吁书','',''],['呼吸','',''],['呼吸作用','',''],['呼吸器','',''],['呼吸气','',''],['呼吸相通','',''],['呼吸管','',''],['呼吸系统','',''],['呼吸者','',''],['呼吸调节器','',''],['呼吸道','',''],['呼呼','',''],['呼呼哱','',''],['呼呼声','',''],['呼呼大睡','',''],['呼咻','',''],['呼响','',''],['呼哧','',''],['呼哧呼哧','',''],['呼哨','',''],['呼唤','',''],['呼啦','',''],['呼啦啦','',''],['呼啦圈','',''],['呼啸','',''],['呼啸声','',''],['呼啸山庄','',''],['呼喇','',''],['呼喊','',''],['呼喊者','',''],['呼喝','',''],['呼嗤','',''],['呼噜','',''],['呼噜噜','',''],['呼噪','',''],['呼嚎','',''],['呼图克图','',''],['呼地','',''],['呼声','',''],['呼声最高','',''],['呼天抢地','',''],['呼孔','',''],['呼市','',''],['呼应','',''],['呼庚呼癸','',''],['呼延','',''],['呼扇','',''],['呼拉圈','',''],['呼救','',''],['呼救声','',''],['呼朋引伴','',''],['呼朋引类','',''],['呼机','',''],['呼来喝去','',''],['呼毕勒罕','',''],['呼气','',''],['呼牛作马','',''],['呼牛呼马','',''],['呼蚩','',''],['呼风唤雨','',''],['呼鼓而攻之','',''],['命不久已','',''],['命世之才','',''],['命中','',''],['命中注定','',''],['命中率','',''],['命人','',''],['命令','',''],['命令主义','',''],['命令书','',''],['命令句','',''],['命令式','',''],['命令行','',''],['命俦啸侣','',''],['命危','',''],['命名','',''],['命名为','',''],['命名人','',''],['命名作业','',''],['命名大会','',''],['命名法','',''],['命名系统','',''],['命名者','',''],['命在旦夕','',''],['命定','',''],['命意','',''],['命数','',''],['命根','',''],['命根子','',''],['命案','',''],['命理学','',''],['命盘','',''],['命相','',''],['命笔','',''],['命脉','',''],['命苦','',''],['命薄','',''],['命该','',''],['命赴黄泉','',''],['命蹇时乖','',''],['命运','',''],['命运攸关','',''],['命运注定','',''],['命途','',''],['命途坎坷','',''],['命题','',''],['命题逻辑','',''],['命驾','',''],['咀嚼','',''],['咂嘴','',''],['咂嘴弄舌','',''],['咂摸','',''],['咄咄','',''],['咄咄怪事','',''],['咄咄称奇','',''],['咄咄逼人','',''],['咄嗟','',''],['咄嗟便办','',''],['咆哮','',''],['咆哮声','',''],['咆哮如雷','',''],['咆哮者','',''],['咆啸','',''],['咋办','',''],['咋呼','',''],['咋回事','',''],['咋舌','',''],['和乐','',''],['和乐蟹','',''],['和事佬','',''],['和事老','',''],['和亲','',''],['和亲政策','',''],['和会','',''],['和光同尘','',''],['和和气气','',''],['和善','',''],['和声','',''],['和声学','',''],['和头','',''],['和好','',''],['和好如初','',''],['和婉','',''],['和容悦气','',''],['和尚','',''],['和尚打伞','',''],['和局','',''],['和布克赛尔县','',''],['和平主义','',''],['和平乡','',''],['和平会谈','',''],['和平共处','',''],['和平共处五项原则','',''],['和平利用','',''],['和平力量','',''],['和平协议','',''],['和平友好','',''],['和平建议','',''],['和平条约','',''],['和平演变','',''],['和平特使','',''],['和平竞赛','',''],['和平统一','',''],['和平统一祖国','',''],['和平解决','',''],['和平谈判','',''],['和平过渡','',''],['和平运动','',''],['和平部队','',''],['和平里','',''],['和平队','',''],['和平鸽','',''],['和弄','',''],['和弦','',''],['和得来','',''],['和悦','',''],['和散那','',''],['和数','',''],['和文','',''],['和易','',''],['和暖','',''],['和有','',''],['和服','',''],['和棋','',''],['和歌','',''],['和歌山','',''],['和歌山县','',''],['和氏璧','',''],['和气','',''],['和气生财','',''],['和气致祥','',''],['和洽','',''],['和煦','',''],['和牌','',''],['和珅','',''],['和璧隋珠','',''],['和田河','',''],['和田玉','',''],['和畅','',''],['和盘托出','',''],['和睦','',''],['和睦相处','',''],['和稀泥','',''],['和约','',''],['和经','',''],['和缓','',''],['和美','',''],['和美镇','',''],['和羹','',''],['和而不同','',''],['和胃力气','',''],['和蔼','',''],['和蔼可亲','',''],['和衷共济','',''],['和解','',''],['和解人','',''],['和解性','',''],['和解稅','',''],['和解者','',''],['和解费','',''],['和议','',''],['和记黄埔','',''],['和诗','',''],['和谈','',''],['和谐','',''],['和谐一致','',''],['和谐性','',''],['和达・清夫','',''],['和面','',''],['和音','',''],['和颜悦色','',''],['和风','',''],['和风丽日','',''],['和风细雨','',''],['和食','',''],['咎于','',''],['咎有应得','',''],['咎由自取','',''],['咏叙唱','',''],['咏叹','',''],['咏叹调','',''],['咏唱','',''],['咏唱调','',''],['咏怀','',''],['咏春','',''],['咏春拳','',''],['咏歌','',''],['咏诗','',''],['咏赞','',''],['咏雪之慧','',''],['咒文','',''],['咒符','',''],['咒诅','',''],['咒语','',''],['咒逐','',''],['咒骂','',''],['咔叽','',''],['咔哒','',''],['咔哒声','',''],['咔唑','',''],['咔嗒','',''],['咔嚓','',''],['咔白','',''],['咕叫','',''],['咕叽','',''],['咕咕','',''],['咕咕叫','',''],['咕咚','',''],['咕咾肉','',''],['咕哝','',''],['咕唧','',''],['咕嘟','',''],['咕噜','',''],['咕噜肉','',''],['咕容','',''],['咕攘','',''],['咕隆','',''],['咖哩','',''],['咖哩汁','',''],['咖哩粉','',''],['咖啡','',''],['咖啡厅','',''],['咖啡因','',''],['咖啡室','',''],['咖啡屋','',''],['咖啡店','',''],['咖啡机','',''],['咖啡碱','',''],['咖啡粉','',''],['咖啡色','',''],['咖啡茶','',''],['咖啡豆','',''],['咖啡馆','',''],['咖啡馆儿','',''],['咖喱','',''],['咖喱粉','',''],['咖逼','',''],['咚咚','',''],['咝咝','',''],['咝咝声','',''],['咝声','',''],['咣咣','',''],['咣当','',''],['咧咧','',''],['咧嘴','',''],['咧开','',''],['咧开嘴笑','',''],['咧着','',''],['咨客','',''],['咨文','',''],['咨询','',''],['咨询中心','',''],['咨询委员会','',''],['咨询服务','',''],['咨询机构','',''],['咩咩','',''],['咪叫','',''],['咪咪','',''],['咫尺','',''],['咫尺万里','',''],['咫尺千里','',''],['咫尺天涯','',''],['咫角骖驹','',''],['咬一口','',''],['咬下','',''],['咬了','',''],['咬人','',''],['咬人狗儿不露齿','',''],['咬伤','',''],['咬住','',''],['咬合','',''],['咬咬牙','',''],['咬啮','',''],['咬嚼','',''],['咬字','',''],['咬字儿','',''],['咬字眼儿','',''],['咬定','',''],['咬得菜根','',''],['咬掉','',''],['咬文','',''],['咬文嚼字','',''],['咬断','',''],['咬牙','',''],['咬牙切齿','',''],['咬痕','',''],['咬着','',''],['咬碎','',''],['咬紧','',''],['咬紧牙关','',''],['咬群','',''],['咬耳朵','',''],['咬舌儿','',''],['咬舌自尽','',''],['咬钉嚼铁','',''],['咬钩','',''],['咭咭呱呱','',''],['咯儿','',''],['咯叫','',''],['咯吱','',''],['咯吱声','',''],['咯咯','',''],['咯咯声','',''],['咯咯笑','',''],['咯哒','',''],['咯嗒','',''],['咯噔','',''],['咯嚓','',''],['咯声','',''],['咯笑','',''],['咯肢','',''],['咯血','',''],['咱们','',''],['咱俩','',''],['咱娃','',''],['咱家','',''],['咱得','',''],['咱村','',''],['咱爷','',''],['咱这','',''],['咳出','',''],['咳出物','',''],['咳呛','',''],['咳唾成珠','',''],['咳嗽','',''],['咳声','',''],['咳得','',''],['咳痰','',''],['咳药','',''],['咳血','',''],['咴儿咴儿','',''],['咴唿','',''],['咸丝丝','',''],['咸丝丝儿','',''],['咸兴','',''],['咸兴市','',''],['咸味','',''],['咸宁地区','',''],['咸宜','',''],['咸榆公路','',''],['咸水','',''],['咸水妹','',''],['咸水湖','',''],['咸津津','',''],['咸津津儿','',''],['咸海','',''],['咸涩','',''],['咸淡','',''],['咸湖','',''],['咸猪手','',''],['咸的','',''],['咸盐','',''],['咸肉','',''],['咸菜','',''],['咸蛋','',''],['咸镜','',''],['咸镜北道','',''],['咸镜南道','',''],['咸镜道','',''],['咸阳地区','',''],['咸阳桥','',''],['咸鱼','',''],['咸鱼翻身','',''],['咸鸭蛋','',''],['咻咻','',''],['咻声','',''],['咽下','',''],['咽了','',''],['咽住','',''],['咽喉','',''],['咽喉炎','',''],['咽头','',''],['咽头炎','',''],['咽峡','',''],['咽峡炎','',''],['咽气','',''],['咽炎','',''],['咽肿','',''],['咽鼓管','',''],['咿呀','',''],['咿咿','',''],['咿唔','',''],['哀丝豪竹','',''],['哀乐','',''],['哀伤','',''],['哀伤地','',''],['哀兵必胜','',''],['哀劝','',''],['哀叫','',''],['哀号','',''],['哀叹','',''],['哀吊','',''],['哀启','',''],['哀告','',''],['哀告宾服','',''],['哀呼','',''],['哀哀','',''],['哀哉','',''],['哀哭','',''],['哀哭切齿','',''],['哀唤','',''],['哀啼','',''],['哀嚎','',''],['哀声','',''],['哀失','',''],['哀婉','',''],['哀子','',''],['哀家','',''],['哀怜','',''],['哀思','',''],['哀怨','',''],['哀恳','',''],['哀恸','',''],['哀悯','',''],['哀悼','',''],['哀惜','',''],['哀愁','',''],['哀感顽艳','',''],['哀戚','',''],['哀梨蒸食','',''],['哀歌','',''],['哀毁骨立','',''],['哀求','',''],['哀江南赋','',''],['哀泣','',''],['哀痛','',''],['哀的美敦书','',''],['哀矜','',''],['哀祭','',''],['哀而不伤','',''],['哀艳','',''],['哀苦','',''],['哀荣','',''],['哀莫大于心死','',''],['哀诉','',''],['哀词','',''],['哀诗','',''],['哀辞','',''],['哀鸣','',''],['哀鸿遍地','',''],['哀鸿遍野','',''],['品位','',''],['品名','',''],['品味','',''],['品味生活','',''],['品头论足','',''],['品头题足','',''],['品学','',''],['品学兼优','',''],['品学兼忧','',''],['品定','',''],['品客','',''],['品家','',''],['品尝','',''],['品川','',''],['品川区','',''],['品德','',''],['品德教育','',''],['品德高尚','',''],['品性','',''],['品族','',''],['品晤','',''],['品月','',''],['品服','',''],['品格','',''],['品梦','',''],['品检','',''],['品牌','',''],['品目','',''],['品种','',''],['品竹弹丝','',''],['品竹调丝','',''],['品竹调弦','',''],['品第','',''],['品等','',''],['品管','',''],['品类','',''],['品粮','',''],['品系','',''],['品红','',''],['品红色','',''],['品级','',''],['品绿','',''],['品脱','',''],['品色','',''],['品节','',''],['品花','',''],['品茗','',''],['品茶','',''],['品蓝','',''],['品藻','',''],['品行','',''],['品议','',''],['品评','',''],['品貌','',''],['品质','',''],['品质管制','',''],['品质超群','',''],['品达','',''],['品酒','',''],['品鉴','',''],['品题','',''],['哂纳','',''],['哄人','',''],['哄传','',''],['哄劝','',''],['哄动','',''],['哄动一时','',''],['哄哄','',''],['哄堂','',''],['哄堂大笑','',''],['哄弄','',''],['哄抢','',''],['哄抬','',''],['哄抬物价','',''],['哄然','',''],['哄然大笑','',''],['哄瞒','',''],['哄笑','',''],['哄诱','',''],['哄骗','',''],['哆哆嗦嗦','',''],['哆啰美远','',''],['哆啰美远族','',''],['哆嗦','',''],['哇叫','',''],['哇哇','',''],['哇哇叫','',''],['哇哇哭','',''],['哇啦','',''],['哇喇','',''],['哇噻','',''],['哇塞','',''],['哇声','',''],['哇沙比','',''],['哇语','',''],['哇靠','',''],['哈丰角','',''],['哈什蚂','',''],['哈伯','',''],['哈伯太空望远镜','',''],['哈伯玛斯','',''],['哈佛','',''],['哈佛大学','',''],['哈克贝利・芬历险记','',''],['哈利','',''],['哈利・波特','',''],['哈利伯顿','',''],['哈利法克斯','',''],['哈利路亚','',''],['哈利迪亚','',''],['哈努卡','',''],['哈努卡节','',''],['哈勃','',''],['哈博罗内','',''],['哈吉','',''],['哈吧狗','',''],['哈哈','',''],['哈哈儿','',''],['哈哈大笑','',''],['哈哈笑','',''],['哈哈镜','',''],['哈啰','',''],['哈啾','',''],['哈喇','',''],['哈喇子','',''],['哈喽','',''],['哈士奇','',''],['哈奴曼','',''],['哈姆雷特','',''],['哈季奇','',''],['哈密瓜','',''],['哈尔斯塔','',''],['哈尔滨工业大学','',''],['哈尔登','',''],['哈巴','',''],['哈巴狗','',''],['哈巴罗夫斯克','',''],['哈巴谷书','',''],['哈巴雪山','',''],['哈布斯堡','',''],['哈希','',''],['哈德逊河','',''],['哈恩','',''],['哈拉子','',''],['哈拉尔五世','',''],['哈拉雷','',''],['哈摩辣','',''],['哈日','',''],['哈日族','',''],['哈普西科德','',''],['哈根达斯','',''],['哈桑','',''],['哈梅内伊','',''],['哈欠','',''],['哈比人','',''],['哈气','',''],['哈灵根','',''],['哈特福德','',''],['哈珀','',''],['哈瓦那','',''],['哈米吉多顿','',''],['哈米尔卡','',''],['哈罗','',''],['哈罗德','',''],['哈腰','',''],['哈苏','',''],['哈莉・贝瑞','',''],['哈莱姆','',''],['哈萨克','',''],['哈萨克人','',''],['哈萨克文','',''],['哈萨克语','',''],['哈蜜瓜','',''],['哈西纳','',''],['哈该书','',''],['哈贝尔','',''],['哈达','',''],['哈迪','',''],['哈迷','',''],['哈里','',''],['哈里发','',''],['哈里发塔','',''],['哈里发帝国','',''],['哈里斯堡','',''],['哈里森・施密特','',''],['哈雷彗星','',''],['哈马尔','',''],['哌嗪','',''],['哌替啶','',''],['响个','',''],['响个不停','',''],['响了','',''],['响亮','',''],['响儿','',''],['响动','',''],['响叮当','',''],['响器','',''],['响地','',''],['响声','',''],['响头','',''],['响尾蛇','',''],['响岩','',''],['响应','',''],['响应时间','',''],['响当当','',''],['响彻','',''],['响彻云际','',''],['响彻云霄','',''],['响晴','',''],['响杨','',''],['响板','',''],['响的','',''],['响着','',''],['响石','',''],['响笛','',''],['响答影随','',''],['响箭','',''],['响葫芦','',''],['响起','',''],['响遍','',''],['响遏行云','',''],['响铃','',''],['响雷','',''],['响鞭','',''],['响音','',''],['响马','',''],['响鸣','',''],['响鼻','',''],['哎呀','',''],['哎呦','',''],['哎哟','',''],['哎唷','',''],['哐哐啷啷','',''],['哐啷','',''],['哑人','',''],['哑剧','',''],['哑剧中','',''],['哑口','',''],['哑口无言','',''],['哑叫','',''],['哑哑','',''],['哑场','',''],['哑声','',''],['哑子','',''],['哑子得梦','',''],['哑巴','',''],['哑巴亏','',''],['哑巴吃黄莲','',''],['哑巴吃黄连','',''],['哑弹','',''],['哑炮','',''],['哑点','',''],['哑然','',''],['哑然失笑','',''],['哑然无生','',''],['哑终端','',''],['哑补','',''],['哑语','',''],['哑谜','',''],['哑铃','',''],['哑门穴','',''],['哑默悄声','',''],['哑鼓','',''],['哒哒','',''],['哒嗪','',''],['哓哓','',''],['哔叽','',''],['哔哔','',''],['哔哔啪啪','',''],['哔声','',''],['哕哕','',''],['哗世取宠','',''],['哗众取宠','',''],['哗变','',''],['哗哗','',''],['哗啦','',''],['哗啦一声','',''],['哗啦啦','',''],['哗地','',''],['哗拉','',''],['哗然','',''],['哗笑','',''],['哜哜嘈嘈','',''],['哝哝','',''],['哥们','',''],['哥们儿','',''],['哥伦布','',''],['哥伦布纪','',''],['哥伦比亚大学','',''],['哥伦比亚广播公司','',''],['哥伦比亚特区','',''],['哥儿','',''],['哥儿们','',''],['哥儿们义气','',''],['哥利亚','',''],['哥吉拉','',''],['哥哥','',''],['哥大','',''],['哥嫂','',''],['哥尼斯堡','',''],['哥德堡','',''],['哥德巴赫猜想','',''],['哥打巴鲁','',''],['哥斯大黎加','',''],['哥斯拉','',''],['哥本哈根','',''],['哥林多','',''],['哥林多前书','',''],['哥林多后书','',''],['哥特人','',''],['哥特式','',''],['哥白尼','',''],['哥罗仿','',''],['哥罗芳','',''],['哥老会','',''],['哥萨克','',''],['哥萨克人','',''],['哦呵','',''],['哦哟','',''],['哧溜','',''],['哨位','',''],['哨兵','',''],['哨卡','',''],['哨声','',''],['哨子','',''],['哨子声','',''],['哨房','',''],['哨所','',''],['哨棒','',''],['哨笛','',''],['哨艇','',''],['哨音','',''],['哩哩啦啦','',''],['哩哩啰啰','',''],['哩哩罗罗','',''],['哩溜歪斜','',''],['哪一个','',''],['哪一种','',''],['哪个','',''],['哪为','',''],['哪些','',''],['哪份','',''],['哪会','',''],['哪会儿','',''],['哪位','',''],['哪像','',''],['哪儿','',''],['哪区','',''],['哪吒','',''],['哪壶不开提哪壶','',''],['哪天','',''],['哪家','',''],['哪年哪月','',''],['哪怕','',''],['哪找','',''],['哪是','',''],['哪有','',''],['哪样','',''],['哪次','',''],['哪点','',''],['哪由','',''],['哪知','',''],['哪种','',''],['哪科','',''],['哪能','',''],['哪要','',''],['哪许','',''],['哪边','',''],['哪里','',''],['哪里哪里','',''],['哪门','',''],['哪门子','',''],['哪项','',''],['哭丧','',''],['哭丧棒','',''],['哭丧着脸','',''],['哭丧脸','',''],['哭了','',''],['哭似','',''],['哭出','',''],['哭叫','',''],['哭号','',''],['哭吧','',''],['哭哭','',''],['哭哭啼啼','',''],['哭啼','',''],['哭啼啼','',''],['哭喊','',''],['哭墙','',''],['哭声','',''],['哭声震天','',''],['哭天','',''],['哭天抹泪','',''],['哭得','',''],['哭泣','',''],['哭泣者','',''],['哭灵','',''],['哭的','',''],['哭着','',''],['哭秋风','',''],['哭穷','',''],['哭笑','',''],['哭笑不得','',''],['哭脸','',''],['哭腔','',''],['哭著','',''],['哭诉','',''],['哭过','',''],['哭闹','',''],['哭骂','',''],['哭鼻','',''],['哭鼻子','',''],['哮喘','',''],['哮喘病','',''],['哮鸣','',''],['哲人','',''],['哲人其萎','',''],['哲人石','',''],['哲学','',''],['哲学上','',''],['哲学体系','',''],['哲学博士学位','',''],['哲学史','',''],['哲学学派','',''],['哲学家','',''],['哲学思想','',''],['哲学思潮','',''],['哲学流派','',''],['哲学理论','',''],['哲学笔记','',''],['哲学著作','',''],['哲学评论','',''],['哲理','',''],['哲蚌寺','',''],['哺乳','',''],['哺乳动物','',''],['哺乳室','',''],['哺乳期','',''],['哺乳类','',''],['哺乳类动物','',''],['哺乳纲','',''],['哺养','',''],['哺子','',''],['哺期','',''],['哺母乳','',''],['哺育','',''],['哼了','',''],['哼催','',''],['哼儿哈儿','',''],['哼哈','',''],['哼哈二将','',''],['哼哧','',''],['哼哼','',''],['哼哼唧唧','',''],['哼唧','',''],['哼唱','',''],['哼唷','',''],['哼声','',''],['哼歌','',''],['哼着','',''],['哼着唱','',''],['哼者','',''],['哼著','',''],['哽住','',''],['哽咽','',''],['哽噎','',''],['哽塞','',''],['唁信','',''],['唁函','',''],['唁劳','',''],['唁电','',''],['唆使','',''],['唆唆','',''],['唆者','',''],['唇下','',''],['唇亡齿寒','',''],['唇印','',''],['唇吻','',''],['唇声','',''],['唇形','',''],['唇形科','',''],['唇彩','',''],['唇枪舌剑','',''],['唇枪舌战','',''],['唇焦舌敝','',''],['唇状','',''],['唇瓣','',''],['唇红齿白','',''],['唇膏','',''],['唇舌','',''],['唇裂','',''],['唇角','',''],['唇语','',''],['唇部','',''],['唇音','',''],['唇音化','',''],['唇颚裂','',''],['唇饰','',''],['唇齿','',''],['唇齿相依','',''],['唇齿音','',''],['唉叹','',''],['唉呀','',''],['唉哟','',''],['唉唉','',''],['唉声叹气','',''],['唉姐','',''],['唏哩哗啦','',''],['唏嘘','',''],['唐三藏','',''],['唐中宗','',''],['唐临晋帖','',''],['唐书','',''],['唐人','',''],['唐人街','',''],['唐代','',''],['唐代宗','',''],['唐伯虎','',''],['唐僖宗','',''],['唐僧','',''],['唐初四大家','',''],['唐卡','',''],['唐古拉','',''],['唐古拉山','',''],['唐古拉山脉','',''],['唐古拉峰','',''],['唐哀帝','',''],['唐哉皇哉','',''],['唐太宗','',''],['唐太宗李卫公问对','',''],['唐宁街','',''],['唐宋','',''],['唐宋八大家','',''],['唐宣宗','',''],['唐宪宗','',''],['唐家山','',''],['唐家璇','',''],['唐寅','',''],['唐尧','',''],['唐山地区','',''],['唐山大地震','',''],['唐德宗','',''],['唐恩都乐','',''],['唐懿宗','',''],['唐招提寺','',''],['唐敬宗','',''],['唐文宗','',''],['唐明皇','',''],['唐昭宗','',''],['唐朝','',''],['唐末','',''],['唐李问对','',''],['唐棣','',''],['唐楼','',''],['唐武宗','',''],['唐殇帝','',''],['唐氏儿','',''],['唐氏症','',''],['唐狗','',''],['唐玄宗','',''],['唐王','',''],['唐璜','',''],['唐睿宗','',''],['唐穆宗','',''],['唐突','',''],['唐突西施','',''],['唐纳','',''],['唐纳德','',''],['唐纳德・川普','',''],['唐绍仪','',''],['唐老鸭','',''],['唐肃宗','',''],['唐花','',''],['唐菖蒲','',''],['唐装','',''],['唐诗','',''],['唐诗三百首','',''],['唐顺宗','',''],['唐高宗','',''],['唐高祖','',''],['唐高祖李渊','',''],['唔好睇','',''],['唠叨','',''],['唠叨不已','',''],['唠叼','',''],['唠唠','',''],['唠唠叨叨','',''],['唠嗑','',''],['唠扯','',''],['唠这扯那','',''],['唢呐','',''],['唤人','',''],['唤作','',''],['唤做','',''],['唤出','',''],['唤回','',''],['唤头','',''],['唤定','',''],['唤狗','',''],['唤起','',''],['唤起者','',''],['唤醒','',''],['唤雨呼风','',''],['唧叫','',''],['唧咕','',''],['唧哝','',''],['唧唧','',''],['唧唧叫','',''],['唧唧喳喳','',''],['唧唧嘎嘎','',''],['唧啾','',''],['唧喳声','',''],['唧声','',''],['唧筒','',''],['唧筒座','',''],['唪经','',''],['唬人','',''],['唬住','',''],['唬唬','',''],['唬地','',''],['唬神瞒鬼','',''],['售与','',''],['售书员','',''],['售价','',''],['售值','',''],['售出','',''],['售卖','',''],['售后','',''],['售后服务','',''],['售完','',''],['售完即止','',''],['售得','',''],['售性','',''],['售房','',''],['售摊','',''],['售楼','',''],['售物','',''],['售票','',''],['售票口','',''],['售票员','',''],['售票处','',''],['售票大厅','',''],['售给','',''],['售缺','',''],['售罄','',''],['售让','',''],['售货','',''],['售货台','',''],['售货员','',''],['唯一','',''],['唯一性','',''],['唯亲','',''],['唯信','',''],['唯其','',''],['唯利是从','',''],['唯利是图','',''],['唯利是求','',''],['唯名论','',''],['唯吾独尊','',''],['唯命是从','',''],['唯命是听','',''],['唯命论','',''],['唯唯','',''],['唯唯否否','',''],['唯唯诺诺','',''],['唯妙','',''],['唯妙唯肖','',''],['唯实','',''],['唯心','',''],['唯心主义','',''],['唯心主义者','',''],['唯心史观','',''],['唯心论','',''],['唯心辩证法','',''],['唯恐','',''],['唯恐天下不乱','',''],['唯意志论','',''],['唯我','',''],['唯我主义','',''],['唯我独尊','',''],['唯我论','',''],['唯才是举','',''],['唯有','',''],['唯灵论','',''],['唯物','',''],['唯物主义','',''],['唯物主义者','',''],['唯物史观','',''],['唯物论','',''],['唯物辩证法','',''],['唯独','',''],['唯理论','',''],['唯美','',''],['唯美主义','',''],['唯肖','',''],['唯能论','',''],['唯若','',''],['唯读','',''],['唯贤','',''],['唯钱是图','',''],['唱下','',''],['唱主角','',''],['唱了','',''],['唱作','',''],['唱出','',''],['唱功','',''],['唱双簧','',''],['唱反调','',''],['唱名','',''],['唱吧','',''],['唱和','',''],['唱喏','',''],['唱头','',''],['唱家','',''],['唱对台戏','',''],['唱工','',''],['唱得','',''],['唱念','',''],['唱戏','',''],['唱曲','',''],['唱本','',''],['唱机','',''],['唱歌','',''],['唱歌者','',''],['唱段','',''],['唱法','',''],['唱片','',''],['唱片儿','',''],['唱独角戏','',''],['唱班','',''],['唱白脸','',''],['唱盘','',''],['唱着','',''],['唱碟','',''],['唱票','',''],['唱筹量沙','',''],['唱者','',''],['唱腔','',''],['唱臂','',''],['唱词','',''],['唱诗','',''],['唱诗班','',''],['唱起','',''],['唱过','',''],['唱酬','',''],['唱针','',''],['唱高调','',''],['唱高调儿','',''],['唵嘛呢叭咪哞','',''],['唵嘛咪叭呢哞','',''],['唸唸有词','',''],['唼喋','',''],['唾余','',''],['唾吐','',''],['唾弃','',''],['唾手','',''],['唾手可取','',''],['唾手可得','',''],['唾沫','',''],['唾沫星子','',''],['唾液','',''],['唾液素','',''],['唾液腺','',''],['唾腺','',''],['唾面自们','',''],['唾面自干','',''],['唾骂','',''],['唿哨','',''],['唿喇','',''],['唿喇喇','',''],['啁哳','',''],['啁啾','',''],['啁啾叫','',''],['啃书','',''],['啃去','',''],['啃掉','',''],['啃着','',''],['啃老','',''],['啃青','',''],['啄啄','',''],['啄木鸟','',''],['啄痕','',''],['啄破','',''],['啄羊鹦鹉','',''],['啄食','',''],['商丘地区','',''],['商业','',''],['商业中心','',''],['商业企业','',''],['商业化','',''],['商业区','',''],['商业发票','',''],['商业局','',''],['商业应用','',''],['商业性','',''],['商业机构','',''],['商业模式','',''],['商业版本','',''],['商业界','',''],['商业管理','',''],['商业系统','',''],['商业经济','',''],['商业网','',''],['商业职工','',''],['商业行为','',''],['商业计划','',''],['商业资本','',''],['商业部','',''],['商业部门','',''],['商业银行','',''],['商事','',''],['商亭','',''],['商人','',''],['商人们','',''],['商人银行','',''],['商代','',''],['商会','',''],['商住楼','',''],['商兑','',''],['商办','',''],['商务','',''],['商务中心区','',''],['商务办事处','',''],['商务印书馆','',''],['商务汉语考试','',''],['商务部','',''],['商号','',''],['商君书','',''],['商品','',''],['商品二重性','',''],['商品交换','',''],['商品交易会','',''],['商品价值','',''],['商品化','',''],['商品形象','',''],['商品性','',''],['商品房','',''],['商品拜物教','',''],['商品检验','',''],['商品流通','',''],['商品牌价','',''],['商品率','',''],['商品生产','',''],['商品粮','',''],['商品经济','',''],['商品肥料','',''],['商品质量','',''],['商品输出','',''],['商品销售','',''],['商商','',''],['商团','',''],['商场','',''],['商域','',''],['商埠','',''],['商女','',''],['商妥','',''],['商学','',''],['商学院','',''],['商定','',''],['商家','',''],['商局','',''],['商展','',''],['商州','',''],['商店','',''],['商得','',''],['商情','',''],['商战','',''],['商户','',''],['商报','',''],['商拟','',''],['商数','',''],['商旅','',''],['商朝','',''],['商机','',''],['商权','',''],['商标','',''],['商标名','',''],['商标法','',''],['商栈','',''],['商检','',''],['商检局','',''],['商榷','',''],['商民','',''],['商汤','',''],['商法','',''],['商洽','',''],['商港','',''],['商用','',''],['商界','',''],['商社','',''],['商祺','',''],['商科','',''],['商科院校','',''],['商科集团','',''],['商税','',''],['商籁体','',''],['商纣王','',''],['商约','',''],['商羊','',''],['商而优则仕','',''],['商联','',''],['商船','',''],['商行','',''],['商誉','',''],['商计','',''],['商订','',''],['商讨','',''],['商议','',''],['商议会','',''],['商议好','',''],['商议者','',''],['商调','',''],['商谈','',''],['商贩','',''],['商贸','',''],['商贾','',''],['商路','',''],['商酌','',''],['商量','',''],['商铺','',''],['商队','',''],['商鞅','',''],['商鞅变法','',''],['商飙徐起','',''],['啊呀','',''],['啊呸','',''],['啊哈','',''],['啊哟','',''],['啊唷','',''],['啊嚏','',''],['啐了','',''],['啐声','',''],['啜泣','',''],['啜菽饮水','',''],['啜食','',''],['啜饮','',''],['啡厅','',''],['啤洒','',''],['啤酒','',''],['啤酒厂','',''],['啤酒杯','',''],['啤酒节','',''],['啤酒花','',''],['啥受','',''],['啥子','',''],['啥病','',''],['啦啦','',''],['啦啦队','',''],['啦啦队长','',''],['啦行','',''],['啧啧','',''],['啧有烦言','',''],['啪响','',''],['啪哒','',''],['啪啦','',''],['啪啪','',''],['啪嗒','',''],['啪嚓','',''],['啪声','',''],['啪达','',''],['啫哩','',''],['啫喱','',''],['啬刻','',''],['啮合','',''],['啮雪吞毡','',''],['啮雪餐毡','',''],['啮齿','',''],['啮齿动物','',''],['啮齿目','',''],['啮齿类','',''],['啰唆','',''],['啰嗦','',''],['啰苏','',''],['啰里啰嗦','',''],['啲咑','',''],['啴啴','',''],['啴缓','',''],['啵啵','',''],['啷当','',''],['啸傲','',''],['啸剧','',''],['啸啸','',''],['啸啸声','',''],['啸声','',''],['啸聚','',''],['啸鸣','',''],['啼叫','',''],['啼叫声','',''],['啼哭','',''],['啼声','',''],['啼天哭地','',''],['啼笑皆非','',''],['啼饥号寒','',''],['啾叫','',''],['啾啾','',''],['喀什噶尔','',''],['喀什米尔','',''],['喀吧','',''],['喀哒','',''],['喀哒声','',''],['喀啦喀啦','',''],['喀喇昆仑公路','',''],['喀喇昆仑山','',''],['喀喇昆仑山脉','',''],['喀喇沁','',''],['喀嚓','',''],['喀土穆','',''],['喀奴特','',''],['喀山','',''],['喀布尔','',''],['喀拉喀托火山','',''],['喀拉拉邦','',''],['喀拉昆仑山','',''],['喀拉汗国','',''],['喀拉汗王朝','',''],['喀斯特','',''],['喀斯特地貌','',''],['喀秋莎','',''],['喀纳斯湖','',''],['喁喁','',''],['喂以','',''],['喂养','',''],['喂喂','',''],['喂奶','',''],['喂母乳','',''],['喂猪','',''],['喂给','',''],['喂药','',''],['喂食','',''],['喂饱','',''],['喃喃','',''],['喃喃细语','',''],['喃喃而语','',''],['喃喃自语','',''],['喃字','',''],['善与人交','',''],['善举','',''],['善书','',''],['善事','',''],['善于','',''],['善人','',''],['善任','',''],['善体','',''],['善体人意','',''],['善写','',''],['善刀而藏','',''],['善化','',''],['善化镇','',''],['善变','',''],['善变人','',''],['善后','',''],['善后借款','',''],['善后处理','',''],['善后工作','',''],['善哉','',''],['善善从长','',''],['善善恶恶','',''],['善善者不来','',''],['善处','',''],['善始令终','',''],['善始善终','',''],['善存','',''],['善待','',''],['善心','',''],['善忘','',''],['善思','',''],['善性','',''],['善恶','',''],['善恶不辨','',''],['善意','',''],['善意的谎言','',''],['善感','',''],['善战','',''],['善才','',''],['善报','',''],['善文','',''],['善有善报','',''],['善本','',''],['善款','',''],['善气迎人','',''],['善理','',''],['善用','',''],['善男信女','',''],['善策','',''],['善类','',''],['善终','',''],['善缘','',''],['善罢','',''],['善罢甘休','',''],['善美','',''],['善者','',''],['善者不来','',''],['善者不辩','',''],['善能','',''],['善自为谋','',''],['善自珍摄','',''],['善良','',''],['善莫大焉','',''],['善行','',''],['善解','',''],['善解人意','',''],['善言','',''],['善言辞','',''],['善论','',''],['善诱','',''],['善说','',''],['善谈','',''],['善财','',''],['善财难舍','',''],['善贾而沽','',''],['善辩','',''],['善辩家','',''],['善辩者','',''],['善道','',''],['善邻','',''],['善长','',''],['善门难开','',''],['善颂善祷','',''],['善风','',''],['喇叭','',''],['喇叭口','',''],['喇叭声','',''],['喇叭形','',''],['喇叭手','',''],['喇叭枪','',''],['喇叭水仙','',''],['喇叭状','',''],['喇叭筒','',''],['喇叭管','',''],['喇叭花','',''],['喇叭裙','',''],['喇叭裤','',''],['喇合','',''],['喇嘛','',''],['喇嘛庙','',''],['喇嘛教','',''],['喈喈','',''],['喉咙','',''],['喉咙痛','',''],['喉咽','',''],['喉塞','',''],['喉塞音','',''],['喉头','',''],['喉头炎','',''],['喉头镜','',''],['喉学','',''],['喉急','',''],['喉擦音','',''],['喉炎','',''],['喉痛','',''],['喉痧','',''],['喉癌','',''],['喉科','',''],['喉科学','',''],['喉管','',''],['喉结','',''],['喉舌','',''],['喉轮','',''],['喉部','',''],['喉镜','',''],['喉音','',''],['喉风','',''],['喉鸣','',''],['喊了','',''],['喊人','',''],['喊价','',''],['喊住','',''],['喊冤','',''],['喊冤叫屈','',''],['喊冤者','',''],['喊出','',''],['喊到','',''],['喊叫','',''],['喊叫声','',''],['喊叫者','',''],['喊嗓','',''],['喊嗓子','',''],['喊嚷','',''],['喊声','',''],['喊好','',''],['喊它','',''],['喊开','',''],['喊打','',''],['喊着','',''],['喊穷','',''],['喊话','',''],['喊道','',''],['喊醒','',''],['喋喋','',''],['喋喋不休','',''],['喋喋而言','',''],['喋血','',''],['喑呜叱吒','',''],['喑哑','',''],['喔呀','',''],['喔唷','',''],['喔喔','',''],['喘不','',''],['喘不过','',''],['喘不过气','',''],['喘不过气来','',''],['喘吁吁','',''],['喘喘','',''],['喘嘘嘘','',''],['喘声','',''],['喘息','',''],['喘振','',''],['喘气','',''],['喘气者','',''],['喘状','',''],['喘着','',''],['喘着气','',''],['喘粗气','',''],['喙长三尺','',''],['喜上心头','',''],['喜不自禁','',''],['喜不自胜','',''],['喜乐','',''],['喜乱','',''],['喜事','',''],['喜人','',''],['喜从天降','',''],['喜修','',''],['喜光植物','',''],['喜兴','',''],['喜冒险','',''],['喜冲冲','',''],['喜出望外','',''],['喜则气缓','',''],['喜剧','',''],['喜力','',''],['喜功','',''],['喜吟吟','',''],['喜喜欢欢','',''],['喜嘉','',''],['喜地欢天','',''],['喜好','',''],['喜娘','',''],['喜子','',''],['喜孜孜','',''],['喜宴','',''],['喜对','',''],['喜寿','',''],['喜封','',''],['喜帕','',''],['喜帖','',''],['喜幛','',''],['喜幸','',''],['喜庆','',''],['喜形','',''],['喜形于色','',''],['喜忧参半','',''],['喜怒','',''],['喜怒哀乐','',''],['喜怒无常','',''],['喜恶','',''],['喜悦','',''],['喜战','',''],['喜报','',''],['喜新','',''],['喜新厌旧','',''],['喜来登','',''],['喜极而泣','',''],['喜果','',''],['喜欢','',''],['喜欢吵架','',''],['喜歌剧院','',''],['喜气','',''],['喜气洋洋','',''],['喜气盈门','',''],['喜洋洋','',''],['喜滋滋','',''],['喜炼','',''],['喜爱','',''],['喜玛拉雅','',''],['喜癖','',''],['喜盈盈','',''],['喜眉笑眼','',''],['喜看','',''],['喜知','',''],['喜神','',''],['喜笑','',''],['喜笑颜开','',''],['喜筵','',''],['喜糖','',''],['喜群飞','',''],['喜联','',''],['喜色','',''],['喜获','',''],['喜获丰收','',''],['喜蛋','',''],['喜讯','',''],['喜谈','',''],['喜跃','',''],['喜车','',''],['喜迁新居','',''],['喜迎','',''],['喜酒','',''],['喜钱','',''],['喜闻','',''],['喜闻乐见','',''],['喜阳','',''],['喜雀','',''],['喜雨','',''],['喜音','',''],['喜颜','',''],['喜饼','',''],['喜香怜玉','',''],['喜马拉雅','',''],['喜马拉雅山','',''],['喜马拉雅山脉','',''],['喜鹊','',''],['喝上','',''],['喝下','',''],['喝了','',''],['喝令','',''],['喝住','',''],['喝倒彩','',''],['喝光','',''],['喝六呼么','',''],['喝口','',''],['喝叱','',''],['喝声','',''],['喝够','',''],['喝完','',''],['喝干','',''],['喝彩','',''],['喝彩声','',''],['喝成','',''],['喝掉','',''],['喝斥','',''],['喝止','',''],['喝水','',''],['喝点','',''],['喝着','',''],['喝茶','',''],['喝西北风','',''],['喝过','',''],['喝道','',''],['喝酒','',''],['喝醉','',''],['喝醉了','',''],['喝采','',''],['喝问','',''],['喟叹','',''],['喟然','',''],['喧吵','',''],['喧呼','',''],['喧哗','',''],['喧哗与骚动','',''],['喧嚣','',''],['喧嚷','',''],['喧天','',''],['喧宾夺主','',''],['喧扰','',''],['喧腾','',''],['喧腾不息','',''],['喧闹','',''],['喧闹声','',''],['喧阗','',''],['喧骚','',''],['喳喳','',''],['喳声','',''],['喷丝头','',''],['喷云吐雾','',''],['喷出','',''],['喷出岩','',''],['喷出物','',''],['喷发','',''],['喷口','',''],['喷吐','',''],['喷喷香','',''],['喷嘴','',''],['喷嘴儿','',''],['喷嚏','',''],['喷嚏剂','',''],['喷墨','',''],['喷壶','',''],['喷头','',''],['喷子','',''],['喷射','',''],['喷射器','',''],['喷射客机','',''],['喷射机','',''],['喷射混凝土','',''],['喷成','',''],['喷打','',''],['喷撒','',''],['喷枪','',''],['喷桶','',''],['喷气','',''],['喷气发动机','',''],['喷气口','',''],['喷气式','',''],['喷气式飞机','',''],['喷气推进实验室','',''],['喷气机','',''],['喷气织机','',''],['喷水','',''],['喷水壶','',''],['喷水孔','',''],['喷水池','',''],['喷水织机','',''],['喷池','',''],['喷油井','',''],['喷泉','',''],['喷注','',''],['喷洒','',''],['喷洒器','',''],['喷洒车','',''],['喷浇','',''],['喷涂','',''],['喷涌','',''],['喷淋','',''],['喷淋浴','',''],['喷湿','',''],['喷溅','',''],['喷溅出','',''],['喷漆','',''],['喷漆推进','',''],['喷灌','',''],['喷火','',''],['喷火分队','',''],['喷火器','',''],['喷火坦克','',''],['喷灯','',''],['喷烟','',''],['喷焊','',''],['喷着','',''],['喷管','',''],['喷薄','',''],['喷薄欲出','',''],['喷镀','',''],['喷雾','',''],['喷雾器','',''],['喷饭','',''],['喷香','',''],['喷鼻息','',''],['喹啉','',''],['喹诺酮','',''],['喻为','',''],['喻性','',''],['喼汁','',''],['喽啰','',''],['喽子','',''],['喽罗','',''],['嗄吱','',''],['嗅中毒','',''],['嗅出','',''],['嗅到','',''],['嗅探','',''],['嗅探者','',''],['嗅着','',''],['嗅神经','',''],['嗅觉','',''],['嗅银矿','',''],['嗅闻','',''],['嗉囊','',''],['嗉子','',''],['嗌嗌','',''],['嗑牙','',''],['嗑药','',''],['嗒声','',''],['嗒然','',''],['嗓子','',''],['嗓子眼','',''],['嗓门','',''],['嗓门儿','',''],['嗓音','',''],['嗔喝','',''],['嗔怒','',''],['嗔怪','',''],['嗔斥','',''],['嗔狂','',''],['嗔目','',''],['嗔着','',''],['嗔睨','',''],['嗔色','',''],['嗔视','',''],['嗔诟','',''],['嗖嗖','',''],['嗖地','',''],['嗖声','',''],['嗜好','',''],['嗜好成癖','',''],['嗜杀','',''],['嗜杀成性','',''],['嗜欲','',''],['嗜毒','',''],['嗜爱','',''],['嗜痂之癖','',''],['嗜痂成癖','',''],['嗜眠','',''],['嗜睡症','',''],['嗜碱性球','',''],['嗜碱性粒细胞','',''],['嗜血','',''],['嗜血杆菌','',''],['嗜贝','',''],['嗜酒','',''],['嗜酒如命','',''],['嗜酸乳干菌','',''],['嗜酸性球','',''],['嗜酸性粒细胞','',''],['嗜食','',''],['嗝儿','',''],['嗟悔','',''],['嗟悔无及','',''],['嗟来之食','',''],['嗡叫','',''],['嗡嗡','',''],['嗡嗡叫','',''],['嗡嗡响','',''],['嗡嗡声','',''],['嗡嗡弹','',''],['嗡嗡祖拉','',''],['嗡声','',''],['嗡子','',''],['嗣业','',''],['嗣位','',''],['嗣后','',''],['嗣响','',''],['嗣国','',''],['嗣子','',''],['嗣岁','',''],['嗣徽','',''],['嗤之','',''],['嗤之以鼻','',''],['嗤嗤','',''],['嗤噗','',''],['嗤笑','',''],['嗥叫','',''],['嗦嗦','',''],['嗨哟','',''],['嗫呫','',''],['嗫嗫','',''],['嗫嚅','',''],['嗯哼','',''],['嗳气','',''],['嗳气吞酸','',''],['嗳气呕逆','',''],['嗳气腐臭','',''],['嗳气酸腐','',''],['嗳腐','',''],['嗳腐吞酸','',''],['嗳酸','',''],['嗵嗵鼓','',''],['嗷吠','',''],['嗷嗷','',''],['嗷嗷待哺','',''],['嗽口','',''],['嗽叭','',''],['嗽嗽声','',''],['嗾使','',''],['嘀咕','',''],['嘀嗒','',''],['嘀嘀','',''],['嘀嘀咕咕','',''],['嘀嘀声','',''],['嘀里嘟噜','',''],['嘁哩喀喳','',''],['嘁嘁喳喳','',''],['嘈嚷','',''],['嘈杂','',''],['嘈杂一群','',''],['嘈杂声','',''],['嘉仁','',''],['嘉会','',''],['嘉兴地区','',''],['嘉剧','',''],['嘉勉','',''],['嘉士伯','',''],['嘉奖','',''],['嘉定','',''],['嘉宾','',''],['嘉山','',''],['嘉山县','',''],['嘉峪关城','',''],['嘉年华','',''],['嘉年华会','',''],['嘉庆','',''],['嘉应大学','',''],['嘉柏隆里','',''],['嘉礼','',''],['嘉肴','',''],['嘉言善行','',''],['嘉言懿行','',''],['嘉许','',''],['嘉谋善功','',''],['嘉酿','',''],['嘉陵','',''],['嘉陵江','',''],['嘌呤','',''],['嘎吱','',''],['嘎啦','',''],['嘎嗒','',''],['嘎嘎','',''],['嘎嘎响','',''],['嘎嘎小姐','',''],['嘎声','',''],['嘎子','',''],['嘎巴','',''],['嘎巴儿','',''],['嘎扎','',''],['嘎拉哈','',''],['嘎渣儿','',''],['嘎然','',''],['嘎登','',''],['嘘唏','',''],['嘘嘘','',''],['嘘声','',''],['嘘寒问暖','',''],['嘘枯吹生','',''],['嘘气','',''],['嘚啵','',''],['嘟哝','',''],['嘟哝不平','',''],['嘟嘟','',''],['嘟嘟响','',''],['嘟嘟哝哝','',''],['嘟嘟囔囔','',''],['嘟嘟车','',''],['嘟噜','',''],['嘟囔','',''],['嘟声','',''],['嘟着嘴','',''],['嘤嘤','',''],['嘤鸣求友','',''],['嘧啶','',''],['嘱人','',''],['嘱咐','',''],['嘱托','',''],['嘱目','',''],['嘲哳','',''],['嘲弄','',''],['嘲弄者','',''],['嘲热','',''],['嘲笑','',''],['嘲笑者','',''],['嘲笑著','',''],['嘲讽','',''],['嘲谑','',''],['嘲风咏月','',''],['嘲风弄月','',''],['嘲骂','',''],['嘴上','',''],['嘴严','',''],['嘴中','',''],['嘴乖','',''],['嘴儿','',''],['嘴唇','',''],['嘴头','',''],['嘴子','',''],['嘴对嘴','',''],['嘴尖','',''],['嘴巴','',''],['嘴巴子','',''],['嘴快','',''],['嘴快心直','',''],['嘴损','',''],['嘴松','',''],['嘴琴','',''],['嘴甜','',''],['嘴甜心苦','',''],['嘴皮','',''],['嘴皮子','',''],['嘴直','',''],['嘴硬','',''],['嘴稳','',''],['嘴笨','',''],['嘴紧','',''],['嘴脸','',''],['嘴角','',''],['嘴软','',''],['嘴边','',''],['嘴里','',''],['嘴钝','',''],['嘴馋','',''],['嘶叫','',''],['嘶吼','',''],['嘶哑','',''],['嘶哑声','',''],['嘶喊','',''],['嘶嘶','',''],['嘶嘶声','',''],['嘶声','',''],['嘶鸣','',''],['嘹亮','',''],['嘹望员','',''],['嘻哈','',''],['嘻嗝','',''],['嘻嘻','',''],['嘻嘻哈哈','',''],['嘻戏','',''],['嘻皮','',''],['嘻皮笑脸','',''],['嘻笑','',''],['嘿咻','',''],['嘿嘿','',''],['噍类','',''],['噍类无遗','',''],['噎住','',''],['噎嗝','',''],['噎噎','',''],['噔噔','',''],['噗哧','',''],['噗噜噜','',''],['噗浪','',''],['噗跳','',''],['噗通','',''],['噘嘴','',''],['噜嗦','',''],['噜声','',''],['噜苏','',''],['噢运会','',''],['噤口痢','',''],['噤声令','',''],['噤若寒蝉','',''],['器乐','',''],['器件','',''],['器具','',''],['器宇','',''],['器宇轩昂','',''],['器官','',''],['器官捐献者','',''],['器官移殖','',''],['器小易盈','',''],['器材','',''],['器械','',''],['器械体操','',''],['器物','',''],['器皿','',''],['器识','',''],['器质性','',''],['器重','',''],['器量','',''],['器量小','',''],['器鼠难投','',''],['噩噩','',''],['噩梦','',''],['噩耗','',''],['噩运','',''],['噪声','',''],['噪声污染','',''],['噪杂','',''],['噪音','',''],['噪音盒','',''],['噫嘻','',''],['噬咬','',''],['噬细胞','',''],['噬脐何及','',''],['噬脐无及','',''],['噬脐莫及','',''],['噬菌','',''],['噬菌体','',''],['噬食','',''],['噱头','',''],['噶举派','',''],['噶伦','',''],['噶厦','',''],['噶哈巫族','',''],['噶啷啷','',''],['噶喇','',''],['噶嗒','',''],['噶嘣','',''],['噶噶','',''],['噶布伦','',''],['噶当派','',''],['噶拉','',''],['噶拉・多杰・仁波切','',''],['噶玛兰','',''],['噶玛兰族','',''],['噶隆','',''],['噶霏','',''],['噻吩','',''],['噻唑','',''],['噼啪','',''],['噼噼啪啪','',''],['嚆矢','',''],['嚎叫','',''],['嚎哭','',''],['嚎啕','',''],['嚎啕大哭','',''],['嚎着','',''],['嚏喷','',''],['嚏声','',''],['嚓嚓','',''],['嚣叫','',''],['嚣张','',''],['嚣张一时','',''],['嚣张气焰','',''],['嚣浮','',''],['嚷劈','',''],['嚷叫','',''],['嚷嚷','',''],['嚷声','',''],['嚷着','',''],['嚷闹','',''],['嚼墨喷纸','',''],['嚼子','',''],['嚼字','',''],['嚼烂','',''],['嚼碎','',''],['嚼舌','',''],['嚼舌头','',''],['嚼舌根','',''],['嚼蜡','',''],['嚼裹儿','',''],['囊中','',''],['囊中取物','',''],['囊中物','',''],['囊中羞涩','',''],['囊内','',''],['囊层','',''],['囊括','',''],['囊揣','',''],['囊泡','',''],['囊炎','',''],['囊状','',''],['囊生','',''],['囊空如洗','',''],['囊肿','',''],['囊胚','',''],['囊膪','',''],['囊萤积雪','',''],['囊虫','',''],['囒吨','',''],['囒哰','',''],['囔囔','',''],['囔着','',''],['囗渴','',''],['囚人','',''],['囚室','',''],['囚居','',''],['囚徒','',''],['囚房','',''],['囚牢','',''],['囚犯','',''],['囚禁','',''],['囚笼','',''],['囚衣','',''],['囚车','',''],['囚首垢面','',''],['四一二','',''],['四一二事变','',''],['四一二反革命政变','',''],['四一二惨案','',''],['四万','',''],['四下','',''],['四下里','',''],['四不像','',''],['四不拗六','',''],['四不象','',''],['四世','',''],['四世同堂','',''],['四个','',''],['四个人','',''],['四个坚持','',''],['四个现代化','',''],['四中','',''],['四中全会','',''],['四乙基铅中毒','',''],['四乡','',''],['四书','',''],['四书集注','',''],['四五','',''],['四五万','',''],['四五十','',''],['四五千','',''],['四五百','',''],['四亭八当','',''],['四人','',''],['四人帮','',''],['四亿','',''],['四仙桌','',''],['四代','',''],['四仰八叉','',''],['四件','',''],['四价','',''],['四份','',''],['四伏','',''],['四位','',''],['四体','',''],['四体不勤','',''],['四体不勤无谷不分','',''],['四倍','',''],['四元数','',''],['四八','',''],['四六体','',''],['四六文','',''],['四六风','',''],['四分','',''],['四分之一','',''],['四分之三','',''],['四分之二','',''],['四分五裂','',''],['四分仪','',''],['四分卫','',''],['四分法','',''],['四分音符','',''],['四则','',''],['四则运算','',''],['四化','',''],['四化大业','',''],['四化建设','',''],['四十','',''],['四十一','',''],['四十七','',''],['四十万','',''],['四十三','',''],['四十个','',''],['四十九','',''],['四十二','',''],['四十二章经','',''],['四十五','',''],['四十人','',''],['四十倍','',''],['四十八','',''],['四十六','',''],['四十四','',''],['四十岁','',''],['四千','',''],['四千万','',''],['四叠体','',''],['四叶草','',''],['四号','',''],['四号电池','',''],['四合房','',''],['四合院','',''],['四名','',''],['四周','',''],['四周围','',''],['四周年','',''],['四呼','',''],['四回','',''],['四围','',''],['四国','',''],['四国岛','',''],['四国犬','',''],['四圣谛','',''],['四块','',''],['四境','',''],['四壁','',''],['四壁萧然','',''],['四声','',''],['四处','',''],['四处奔波','',''],['四处活动','',''],['四外','',''],['四大','',''],['四大佛教名山','',''],['四大发明','',''],['四大名著','',''],['四大天王','',''],['四大皆空','',''],['四大盆地','',''],['四大石窟','',''],['四大美女','',''],['四大须生','',''],['四天','',''],['四头','',''],['四头肌','',''],['四套','',''],['四好运动','',''],['四子王','',''],['四孔','',''],['四季','',''],['四季如春','',''],['四季度','',''],['四季海棠','',''],['四季豆','',''],['四季豆腐','',''],['四害','',''],['四家','',''],['四射','',''],['四小龙','',''],['四层','',''],['四届','',''],['四川外国语大学','',''],['四川大地震','',''],['四川大学','',''],['四川日报','',''],['四川盆地','',''],['四幕','',''],['四平八稳','',''],['四平地区','',''],['四年','',''],['四库','',''],['四库全书','',''],['四开','',''],['四强','',''],['四德','',''],['四德三从','',''],['四成','',''],['四战之国','',''],['四战之地','',''],['四手类','',''],['四拇指','',''],['四散','',''],['四散奔逃','',''],['四方','',''],['四四方方','',''],['四方八面','',''],['四方台','',''],['四方响应','',''],['四方步','',''],['四方脸','',''],['四旁','',''],['四日','',''],['四日市','',''],['四日市市','',''],['四旧','',''],['四旬','',''],['四旬斋','',''],['四旬节','',''],['四时','',''],['四时八节','',''],['四时气备','',''],['四星','',''],['四更','',''],['四月','',''],['四月份','',''],['四有','',''],['四条','',''],['四极管','',''],['四楼','',''],['四次','',''],['四次幂','',''],['四段','',''],['四氟化硅','',''],['四氟化铀','',''],['四氢大麻酚','',''],['四氧','',''],['四氯乙烯','',''],['四氯化碳','',''],['四海','',''],['四海为家','',''],['四海之内皆兄弟','',''],['四海升平','',''],['四海承风','',''],['四海生平','',''],['四海皆准','',''],['四海飘零','',''],['四海鼎沸','',''],['四清','',''],['四清六活','',''],['四清运动','',''],['四湖','',''],['四湖乡','',''],['四溅','',''],['四灵','',''],['四点','',''],['四物汤','',''],['四环','',''],['四环素','',''],['四百','',''],['四百万','',''],['四百年','',''],['四碳糖','',''],['四神丸','',''],['四种','',''],['四类分子','',''],['四级','',''],['四级士官','',''],['四组','',''],['四维','',''],['四维时空','',''],['四维空间','',''],['四联','',''],['四联单','',''],['四肢','',''],['四胡','',''],['四脚','',''],['四脚兽','',''],['四脚朝天','',''],['四脚蛇','',''],['四至','',''],['四舍五入','',''],['四行','',''],['四行诗','',''],['四角','',''],['四角号码','',''],['四角帽','',''],['四角形','',''],['四角柱体','',''],['四角裤','',''],['四言诗','',''],['四诊','',''],['四谛','',''],['四象','',''],['四起','',''],['四足','',''],['四路','',''],['四轮','',''],['四轮马车','',''],['四轮驱动','',''],['四边','',''],['四边形','',''],['四近','',''],['四通','',''],['四通五达','',''],['四通八达','',''],['四邻','',''],['四邻八舍','',''],['四郊','',''],['四郊多垒','',''],['四部','',''],['四部曲','',''],['四重唱','',''],['四重奏','',''],['四野','',''],['四门轿车','',''],['四队','',''],['四面','',''],['四面体','',''],['四面八方','',''],['四面楚歌','',''],['四音','',''],['四音节','',''],['四页','',''],['四项','',''],['四项基本原则','',''],['四顾','',''],['四马攒蹄','',''],['回不来','',''],['回丝','',''],['回主页','',''],['回乡','',''],['回乡务农','',''],['回了','',''],['回事','',''],['回交','',''],['回京','',''],['回佣','',''],['回信','',''],['回信地址','',''],['回修','',''],['回充','',''],['回光','',''],['回光反照','',''],['回光返照','',''],['回光镜','',''],['回内地','',''],['回冲','',''],['回击','',''],['回击者','',''],['回函','',''],['回到','',''],['回动','',''],['回升','',''],['回单','',''],['回单儿','',''],['回历','',''],['回原','',''],['回去','',''],['回口','',''],['回合','',''],['回吼','',''],['回味','',''],['回味无穷','',''],['回咬','',''],['回响','',''],['回嗔作喜','',''],['回嘴','',''],['回回','',''],['回回青','',''],['回国','',''],['回城','',''],['回填','',''],['回墨印','',''],['回声','',''],['回声定位','',''],['回复','',''],['回天','',''],['回天之力','',''],['回天乏术','',''],['回头','',''],['回头人','',''],['回头是岸','',''],['回头见','',''],['回头路','',''],['回奉','',''],['回娘家','',''],['回家','',''],['回山倒海','',''],['回师','',''],['回帐','',''],['回帖','',''],['回应','',''],['回廊','',''],['回弹','',''],['回归','',''],['回归带','',''],['回归年','',''],['回归热','',''],['回归祖国','',''],['回归线','',''],['回形针','',''],['回心转意','',''],['回忆','',''],['回忆录','',''],['回忆起','',''],['回想','',''],['回戏','',''],['回手','',''],['回扣','',''],['回执','',''],['回扫','',''],['回折','',''],['回折格子','',''],['回护','',''],['回报','',''],['回拜','',''],['回拨','',''],['回挪','',''],['回描','',''],['回援','',''],['回收','',''],['回收价值','',''],['回收率','',''],['回收站','',''],['回放','',''],['回教','',''],['回教徒','',''],['回敬','',''],['回文','',''],['回文织锦','',''],['回旋','',''],['回旋余地','',''],['回旋加速器','',''],['回旋曲','',''],['回旋状','',''],['回春','',''],['回暖','',''],['回条','',''],['回来','',''],['回柱','',''],['回棋','',''],['回民','',''],['回水','',''],['回波','',''],['回流','',''],['回游','',''],['回溯','',''],['回潮','',''],['回潮率','',''],['回火','',''],['回炉','',''],['回煞','',''],['回环','',''],['回球','',''],['回生','',''],['回生起死','',''],['回电','',''],['回目','',''],['回眸','',''],['回瞅','',''],['回礼','',''],['回禀','',''],['回禄','',''],['回禄之灾','',''],['回程','',''],['回稳','',''],['回空','',''],['回笼','',''],['回答','',''],['回答者','',''],['回答说','',''],['回纥','',''],['回纹针','',''],['回绕','',''],['回绝','',''],['回翔','',''],['回老家','',''],['回耗','',''],['回肠','',''],['回肠九转','',''],['回肠伤气','',''],['回肠寸断','',''],['回肠荡气','',''],['回航','',''],['回良玉','',''],['回茬','',''],['回荡','',''],['回落','',''],['回覆','',''],['回见','',''],['回视','',''],['回访','',''],['回话','',''],['回请','',''],['回赎','',''],['回跌','',''],['回跑','',''],['回路','',''],['回跳','',''],['回身','',''],['回车','',''],['回车键','',''],['回转','',''],['回转仪','',''],['回转半径','',''],['回转寿司','',''],['回转窑','',''],['回转轴','',''],['回过','',''],['回过头来','',''],['回返','',''],['回还','',''],['回退','',''],['回送','',''],['回避','',''],['回邮','',''],['回邮信封','',''],['回采','',''],['回銮','',''],['回销','',''],['回锅','',''],['回锅油','',''],['回锅肉','',''],['回门','',''],['回青','',''],['回音','',''],['回页首','',''],['回顾','',''],['回顾历史','',''],['回顾展','',''],['回风','',''],['回飞','',''],['回馈','',''],['回首','',''],['回首往事','',''],['回首页','',''],['回马枪','',''],['回驳','',''],['回骂','',''],['回鹘','',''],['回黄转绿','',''],['囟脑门','',''],['囟门','',''],['因为','',''],['因为种种原因','',''],['因之','',''],['因事','',''],['因事制宜','',''],['因于','',''],['因人','',''],['因人制宜','',''],['因人成事','',''],['因人而异','',''],['因何','',''],['因使','',''],['因公','',''],['因公假私','',''],['因公殉职','',''],['因公行私','',''],['因其','',''],['因利乘便','',''],['因势利导','',''],['因厄','',''],['因受','',''],['因变数','',''],['因变量','',''],['因名额有限','',''],['因噎废食','',''],['因在','',''],['因地制宜','',''],['因如此','',''],['因子','',''],['因子型','',''],['因孕而婚','',''],['因小失大','',''],['因小而失大','',''],['因小见大','',''],['因应','',''],['因式','',''],['因式分解','',''],['因循','',''],['因循坐误','',''],['因循守旧','',''],['因恐','',''],['因情形','',''],['因我','',''],['因所','',''],['因故','',''],['因敌取资','',''],['因数','',''],['因斯布鲁克','',''],['因时','',''],['因时制宜','',''],['因明','',''],['因材施教','',''],['因条件限制','',''],['因果','',''],['因果关系','',''],['因果律','',''],['因果报应','',''],['因果联系','',''],['因树为屋','',''],['因次','',''],['因此','',''],['因此当','',''],['因爱成恨','',''],['因父之名','',''],['因特网','',''],['因特网提供商','',''],['因特网联通','',''],['因由','',''],['因病','',''],['因祸为福','',''],['因祸得福','',''],['因素','',''],['因纽特','',''],['因纽特人','',''],['因缘','',''],['因而','',''],['因被','',''],['因袭','',''],['因购买','',''],['因陀罗','',''],['因陋就简','',''],['因难见巧','',''],['因风吹火','',''],['囡囡','',''],['团中央','',''],['团代会','',''],['团伙','',''],['团似','',''],['团体','',''],['团体冠军','',''],['团体操','',''],['团体行','',''],['团体赛','',''],['团务工作','',''],['团员','',''],['团团','',''],['团团围住','',''],['团团转','',''],['团圆','',''],['团圆节','',''],['团块','',''],['团头鲂','',''],['团契','',''],['团委','',''],['团子','',''],['团市委','',''],['团年','',''],['团弄','',''],['团徽','',''],['团扇','',''],['团拜','',''],['团支部','',''],['团旗','',''],['团日','',''],['团服','',''],['团校','',''],['团省委','',''],['团矿','',''],['团章','',''],['团籍','',''],['团粉','',''],['团粒','',''],['团级','',''],['团练','',''],['团组织','',''],['团结','',''],['团结一致','',''],['团结互助','',''],['团结合作','',''],['团结就是力量','',''],['团结工会','',''],['团职','',''],['团聚','',''],['团脐','',''],['团藻','',''],['团评','',''],['团课','',''],['团购','',''],['团费','',''],['团部','',''],['团长','',''],['团队','',''],['团队精神','',''],['团音','',''],['团鱼','',''],['囤积','',''],['囤积居奇','',''],['囤积者','',''],['囤聚','',''],['囫囵','',''],['囫囵吞下','',''],['囫囵吞枣','',''],['园丁','',''],['园主','',''],['园内','',''],['园凳','',''],['园区','',''],['园口','',''],['园囿','',''],['园圃','',''],['园圈','',''],['园地','',''],['园外','',''],['园子','',''],['园寂','',''],['园弧','',''],['园形','',''],['园数','',''],['园木','',''],['园林','',''],['园桌','',''],['园桶','',''],['园田','',''],['园笼','',''],['园艺','',''],['园艺学','',''],['园艺家','',''],['园规','',''],['园钢','',''],['园长','',''],['困乏','',''],['困于','',''],['困人','',''],['困住','',''],['困倦','',''],['困兽','',''],['困兽犹斗','',''],['困厄','',''],['困境','',''],['困处','',''],['困守','',''],['困局','',''],['困心衡虑','',''],['困恼','',''],['困惑','',''],['困惑不解','',''],['困惫','',''],['困扰','',''],['困时','',''],['困死','',''],['困知勉行','',''],['困窘','',''],['困绕','',''],['困苦','',''],['困迫','',''],['困镜','',''],['困难','',''],['困难在于','',''],['困难户','',''],['困难重重','',''],['困顿','',''],['囱门','',''],['围了','',''],['围产','',''],['围以','',''],['围住','',''],['围作','',''],['围兜','',''],['围内','',''],['围击','',''],['围剿','',''],['围嘴','',''],['围嘴儿','',''],['围困','',''],['围圈','',''],['围在','',''],['围地','',''],['围场','',''],['围场县','',''],['围坐','',''],['围垦','',''],['围城','',''],['围城打援','',''],['围堰','',''],['围堵','',''],['围墙','',''],['围子','',''],['围屏','',''],['围岩','',''],['围巾','',''],['围心腔','',''],['围成','',''],['围护','',''],['围拢','',''],['围挡','',''],['围捕','',''],['围擒','',''],['围攻','',''],['围攻者','',''],['围栏','',''],['围桌','',''],['围棋','',''],['围歼','',''],['围炉','',''],['围点打援','',''],['围猎','',''],['围盘','',''],['围着','',''],['围笼','',''],['围篱','',''],['围绕','',''],['围绕物','',''],['围网','',''],['围脖','',''],['围脖儿','',''],['围腰布','',''],['围腰带','',''],['围膝毯','',''],['围著','',''],['围补','',''],['围裙','',''],['围裹','',''],['围观','',''],['围起','',''],['围魏救赵','',''],['囹圄','',''],['囹圉','',''],['固件','',''],['固体','',''],['固体力学','',''],['固体性','',''],['固体溶体','',''],['固体热容激光器','',''],['固体燃料','',''],['固体物','',''],['固体物理','',''],['固体物理学','',''],['固体物质','',''],['固体电路','',''],['固化','',''],['固化剂','',''],['固原地区','',''],['固堤','',''],['固守','',''],['固定','',''],['固定器','',''],['固定收入','',''],['固定汇率','',''],['固定点','',''],['固定物','',''],['固定电话','',''],['固定虚拟连接','',''],['固定词组','',''],['固定资产','',''],['固定资本','',''],['固定资金','',''],['固形物','',''],['固态','',''],['固执','',''],['固执己见','',''],['固执者','',''],['固持','',''],['固持己见','',''],['固有','',''],['固有名词','',''],['固有性','',''],['固有振荡','',''],['固有词','',''],['固有频率','',''],['固本','',''],['固步自封','',''],['固氮','',''],['固氮菌','',''],['固沙','',''],['固沙林','',''],['固溶体','',''],['固然','',''],['固用','',''],['固着','',''],['固结','',''],['固网电信','',''],['固置','',''],['固色剂','',''],['固若金汤','',''],['固醇','',''],['固醇类','',''],['固陋','',''],['国与国','',''],['国专','',''],['国丧','',''],['国中','',''],['国中之国','',''],['国乐','',''],['国书','',''],['国事','',''],['国事访问','',''],['国交','',''],['国产','',''],['国产化','',''],['国产机','',''],['国人','',''],['国企','',''],['国优','',''],['国会','',''],['国会制','',''],['国会大厦','',''],['国会山','',''],['国会议员','',''],['国会议长','',''],['国体','',''],['国侦局','',''],['国债','',''],['国光','',''],['国公','',''],['国共','',''],['国共两党','',''],['国共关系','',''],['国共内战','',''],['国共合作','',''],['国共和谈','',''],['国内','',''],['国内先进水平','',''],['国内外','',''],['国内市场','',''],['国内形势','',''],['国内战争','',''],['国内政策','',''],['国内法','',''],['国内生产总值','',''],['国内线','',''],['国内航线','',''],['国内贸易','',''],['国内革命战争','',''],['国军','',''],['国别','',''],['国别史','',''],['国力','',''],['国办','',''],['国务','',''],['国务会议','',''],['国务卿','',''],['国务委员','',''],['国务总理','',''],['国务次卿','',''],['国务部长','',''],['国务长官','',''],['国务院','',''],['国务院办公厅','',''],['国务院台湾事务办公室','',''],['国务院国有资产监督管理委员会','',''],['国务院新闻办公室','',''],['国务院法制局','',''],['国务院港澳事务办公室','',''],['国势','',''],['国势日衰','',''],['国医','',''],['国历','',''],['国发','',''],['国台办','',''],['国史','',''],['国号','',''],['国名','',''],['国君','',''],['国国','',''],['国土','',''],['国土安全','',''],['国土安全局','',''],['国土安全部','',''],['国境','',''],['国境管理','',''],['国境线','',''],['国士无双','',''],['国外','',''],['国外内','',''],['国外市场','',''],['国外经验','',''],['国大','',''],['国大代表','',''],['国大党','',''],['国奥会','',''],['国姓','',''],['国姓乡','',''],['国威','',''],['国子监','',''],['国字','',''],['国字脸','',''],['国学','',''],['国安局','',''],['国安部','',''],['国宝','',''],['国宴','',''],['国家','',''],['国家一级保护','',''],['国家主义','',''],['国家代码','',''],['国家体委','',''],['国家元首','',''],['国家公园','',''],['国家兴亡','',''],['国家军品贸易局','',''],['国家军品贸易管理委员会','',''],['国家利益','',''],['国家制度','',''],['国家副主席','',''],['国家化','',''],['国家发展和改革委员会','',''],['国家发展改革委','',''],['国家发展计划委员会','',''],['国家图书馆','',''],['国家地震局','',''],['国家垄断资本主义','',''],['国家外汇管理局','',''],['国家宇航和太空署','',''],['国家安全','',''],['国家安全局','',''],['国家安全部','',''],['国家政策','',''],['国家文物委员会','',''],['国家文物局','',''],['国家文物鉴定委员会','',''],['国家旅游度假区','',''],['国家机关','',''],['国家机器','',''],['国家机构','',''],['国家标准中文交换码','',''],['国家标准化管理委员会','',''],['国家标准码','',''],['国家汉办','',''],['国家法','',''],['国家海洋局','',''],['国家火山公园','',''],['国家环保总局','',''],['国家电力监管委员会','',''],['国家电网公司','',''],['国家留学基金管理委员会','',''],['国家社会主义','',''],['国家管理基金','',''],['国家级','',''],['国家经济贸易委员会','',''],['国家结构','',''],['国家统计局','',''],['国家航天局','',''],['国家航空公司','',''],['国家裁判','',''],['国家计划委员会','',''],['国家计委','',''],['国家质量监督检验检疫总局','',''],['国家资本主义','',''],['国家重点学科','',''],['国家重点实验室','',''],['国家队','',''],['国家食品药品监督管理局','',''],['国宾','',''],['国宾馆','',''],['国富','',''],['国富兵强','',''],['国富民安','',''],['国富论','',''],['国将不国','',''],['国小','',''],['国尔忘家','',''],['国币','',''],['国师','',''],['国帑','',''],['国庆日','',''],['国库','',''],['国库券','',''],['国府','',''],['国度','',''],['国式','',''],['国弱民穷','',''],['国后','',''],['国徽','',''],['国情','',''],['国情咨文','',''],['国戚','',''],['国手','',''],['国技','',''],['国政','',''],['国故','',''],['国教','',''],['国文','',''],['国新办','',''],['国旅','',''],['国旗','',''],['国是','',''],['国有','',''],['国有企业','',''],['国有公司','',''],['国有化','',''],['国有资产监督管理委员会','',''],['国本','',''],['国术','',''],['国柄','',''],['国标','',''],['国标码','',''],['国标舞','',''],['国格','',''],['国棋','',''],['国槐','',''],['国槐树','',''],['国歌','',''],['国步艰难','',''],['国殇','',''],['国民','',''],['国民中学','',''],['国民党','',''],['国民党军队','',''],['国民军','',''],['国民大会','',''],['国民小学','',''],['国民性','',''],['国民总产值','',''],['国民总收入','',''],['国民收入','',''],['国民政府','',''],['国民教育','',''],['国民生产总值','',''],['国民经济','',''],['国民经济计划','',''],['国民警卫队','',''],['国民议会','',''],['国民革命军','',''],['国法','',''],['国泰','',''],['国泰民安','',''],['国泰航空','',''],['国父','',''],['国王','',''],['国玺','',''],['国用','',''],['国画','',''],['国界','',''],['国界法','',''],['国界线','',''],['国破家亡','',''],['国祭','',''],['国税','',''],['国立','',''],['国立台北科技大学','',''],['国立台湾技术大学','',''],['国立显忠院','',''],['国立首尔大学','',''],['国策','',''],['国策顾问','',''],['国籍','',''],['国粹','',''],['国统区','',''],['国美','',''],['国美电器','',''],['国老','',''],['国耻','',''],['国联','',''],['国脚','',''],['国舅','',''],['国航','',''],['国色','',''],['国色天姿','',''],['国色天香','',''],['国花','',''],['国药','',''],['国菜','',''],['国营','',''],['国营企业','',''],['国营农场','',''],['国营经济','',''],['国葬','',''],['国蠹','',''],['国计','',''],['国计民生','',''],['国语注音符号第一式','',''],['国语罗马字','',''],['国货','',''],['国贸','',''],['国贼','',''],['国资委','',''],['国运','',''],['国道','',''],['国都','',''],['国门','',''],['国队','',''],['国防','',''],['国防军','',''],['国防利益','',''],['国防工业','',''],['国防现代化','',''],['国防科工委','',''],['国防科技工业委员会','',''],['国防语言学院','',''],['国防费','',''],['国防部长','',''],['国防预算','',''],['国际','',''],['国际上','',''],['国际主义','',''],['国际互联网络','',''],['国际互连网','',''],['国际人权标准','',''],['国际仲裁','',''],['国际体操联合会','',''],['国际先驱论坛报','',''],['国际公制','',''],['国际公法','',''],['国际公认','',''],['国际共产主义运动','',''],['国际共管','',''],['国际关系','',''],['国际关系学院','',''],['国际刑事警察组织','',''],['国际刑警组织','',''],['国际劳工组织','',''],['国际化','',''],['国际医疗中心','',''],['国际协会','',''],['国际单位','',''],['国际单位制','',''],['国际原子能机构','',''],['国际原子能结构','',''],['国际和平基金会','',''],['国际商业机器','',''],['国际商会','',''],['国际垄断同盟','',''],['国际外交','',''],['国际大赦','',''],['国际太空站','',''],['国际奥委会','',''],['国际奥林匹克委员会','',''],['国际媒体','',''],['国际工人协会','',''],['国际性','',''],['国际惯例','',''],['国际战争罪法庭','',''],['国际收支','',''],['国际数学联盟','',''],['国际文传通讯社','',''],['国际新闻','',''],['国际日期变更线','',''],['国际机场','',''],['国际标准','',''],['国际标准化组织','',''],['国际棋联','',''],['国际歌','',''],['国际民航组织','',''],['国际民间组织','',''],['国际法','',''],['国际法庭','',''],['国际法院','',''],['国际海事组织','',''],['国际清算银行','',''],['国际特赦','',''],['国际特赦组织','',''],['国际电信联盟','',''],['国际电报电话咨询委员会','',''],['国际电话','',''],['国际电话电报谘询委员会','',''],['国际社会','',''],['国际私法','',''],['国际笔会','',''],['国际米兰','',''],['国际米兰足球俱乐部','',''],['国际米兰队','',''],['国际红十字大会','',''],['国际级','',''],['国际纵队','',''],['国际组织','',''],['国际网络','',''],['国际网络公司','',''],['国际网络门户','',''],['国际羽毛球联合会','',''],['国际联盟','',''],['国际舞台','',''],['国际航空联合会','',''],['国际航空运输协会','',''],['国际裁判','',''],['国际见闻','',''],['国际象棋','',''],['国际货币基金','',''],['国际货币基金组织','',''],['国际货运代理','',''],['国际贸易','',''],['国际足球联合会','',''],['国际足联','',''],['国际跳棋','',''],['国际金融公司','',''],['国际间','',''],['国际音标','',''],['国际驾照','',''],['国难','',''],['国音','',''],['国风','',''],['国魂','',''],['国鸟','',''],['图三','',''],['图上','',''],['图上作业','',''],['图中','',''],['图为','',''],['图为不轨','',''],['图书','',''],['图书事业','',''],['图书典藏','',''],['图书分类','',''],['图书分类法','',''],['图书发行','',''],['图书学','',''],['图书室','',''],['图书工作','',''],['图书目录','',''],['图书管理','',''],['图书管理员','',''],['图书编目','',''],['图书装修','',''],['图书评介','',''],['图书资料','',''],['图书资料馆','',''],['图书采购','',''],['图书鉴定','',''],['图书馆','',''],['图书馆员','',''],['图书馆学','',''],['图书馆管理','',''],['图二','',''],['图们江','',''],['图例','',''],['图像','',''],['图像互换格式','',''],['图像处理','',''],['图像用户介面','',''],['图元','',''],['图克','',''],['图册','',''],['图列','',''],['图利','',''],['图制','',''],['图卢兹','',''],['图卢斯','',''],['图块','',''],['图坦卡门','',''],['图存','',''],['图学','',''],['图尔','',''],['图尔库','',''],['图库','',''],['图式','',''],['图录','',''],['图形','',''],['图形卡','',''],['图形用户界面','',''],['图形界面','',''],['图快','',''],['图恩','',''],['图报','',''],['图文','',''],['图文并茂','',''],['图文框','',''],['图文集','',''],['图景','',''],['图板','',''],['图林根','',''],['图标','',''],['图样','',''],['图案','',''],['图档','',''],['图法','',''],['图波列夫','',''],['图灵','',''],['图灵奖','',''],['图灵测试','',''],['图片','',''],['图片展览','',''],['图片报','',''],['图版','',''],['图画','',''],['图画书','',''],['图画文字','',''],['图画钉','',''],['图示','',''],['图穷匕见','',''],['图穷匕首见','',''],['图章','',''],['图符','',''],['图签','',''],['图籍','',''],['图纸','',''],['图腾','',''],['图腾崇拜','',''],['图表','',''],['图西族','',''],['图解','',''],['图解者','',''],['图解说明','',''],['图记','',''],['图论','',''],['图说','',''],['图谋','',''],['图谋不轨','',''],['图谱','',''],['图谶','',''],['图象','',''],['图财害命','',''],['图财致命','',''],['图辑','',''],['图鉴','',''],['图钉','',''],['图门江','',''],['图阿雷格','',''],['图集','',''],['图面','',''],['图饰','',''],['囿于','',''],['囿于成见','',''],['圆丘般','',''],['圆光','',''],['圆全','',''],['圆函数','',''],['圆凿方枘','',''],['圆口纲脊椎动物','',''],['圆台','',''],['圆号','',''],['圆周','',''],['圆周率','',''],['圆周角','',''],['圆唇元音','',''],['圆圆','',''],['圆圈','',''],['圆场','',''],['圆型','',''],['圆堡','',''],['圆头棒','',''],['圆子','',''],['圆孔','',''],['圆寂','',''],['圆屋顶','',''],['圆度','',''],['圆弧','',''],['圆弧规','',''],['圆形','',''],['圆形动物','',''],['圆形木材','',''],['圆形物','',''],['圆形罩','',''],['圆形面包','',''],['圆径','',''],['圆心','',''],['圆心角','',''],['圆成','',''],['圆房','',''],['圆括号','',''],['圆括弧','',''],['圆拱','',''],['圆明园','',''],['圆月','',''],['圆木','',''],['圆木材','',''],['圆材','',''],['圆柏','',''],['圆柱','',''],['圆柱体','',''],['圆柱形','',''],['圆柱状','',''],['圆柱面','',''],['圆桌','',''],['圆桌会议','',''],['圆桌面','',''],['圆桶','',''],['圆梦','',''],['圆浑','',''],['圆润','',''],['圆溜溜','',''],['圆滑','',''],['圆滚滚','',''],['圆满','',''],['圆满完成','',''],['圆满完成任务','',''],['圆满成功','',''],['圆满解决','',''],['圆点','',''],['圆烛台','',''],['圆熟','',''],['圆片','',''],['圆状','',''],['圆环','',''],['圆环图','',''],['圆环面','',''],['圆珠','',''],['圆珠形离子交换剂','',''],['圆珠笔','',''],['圆球','',''],['圆瑛','',''],['圆白菜','',''],['圆的','',''],['圆盖','',''],['圆盘','',''],['圆盘耙','',''],['圆盾形','',''],['圆睁','',''],['圆石头','',''],['圆石子','',''],['圆窗','',''],['圆笼','',''],['圆筒','',''],['圆筒形','',''],['圆胖','',''],['圆脸','',''],['圆腹鲱','',''],['圆舞','',''],['圆舞曲','',''],['圆规','',''],['圆规座','',''],['圆角','',''],['圆谎','',''],['圆起','',''],['圆轨道','',''],['圆通','',''],['圆钢','',''],['圆锥','',''],['圆锥体','',''],['圆锥台','',''],['圆锥形','',''],['圆锥曲线','',''],['圆锥状','',''],['圆锥花序','',''],['圆锯','',''],['圆雕','',''],['圆面饼','',''],['圆顶','',''],['圆顶阁','',''],['圆颅方趾','',''],['圆领','',''],['圆领衫','',''],['圆饼','',''],['圆首方足','',''],['圆鼓鼓','',''],['圈上','',''],['圈之','',''],['圈住','',''],['圈儿','',''],['圈内','',''],['圈占','',''],['圈圈','',''],['圈圈点点','',''],['圈地','',''],['圈地运动','',''],['圈外','',''],['圈夺','',''],['圈套','',''],['圈子','',''],['圈拢','',''],['圈数','',''],['圈椅','',''],['圈点','',''],['圈状物','',''],['圈环','',''],['圈结','',''],['圈肥','',''],['圈起','',''],['圈进','',''],['圈阅','',''],['圈饼','',''],['圉人','',''],['圉限','',''],['圊肥','',''],['土专家','',''],['土丘','',''],['土中','',''],['土产','',''],['土人','',''],['土仪','',''],['土伦','',''],['土偶','',''],['土到不行','',''],['土制','',''],['土办法','',''],['土包子','',''],['土匪','',''],['土卫二','',''],['土卫六','',''],['土司','',''],['土司制度','',''],['土味','',''],['土围子','',''],['土地','',''],['土地公','',''],['土地利用规划','',''],['土地庙','',''],['土地改革','',''],['土地法','',''],['土地税','',''],['土地证','',''],['土地资源','',''],['土地革命','',''],['土地革命战争','',''],['土坎','',''],['土坎儿','',''],['土坑','',''],['土块','',''],['土坝','',''],['土坡','',''],['土坯','',''],['土埂','',''],['土城','',''],['土城市','',''],['土堆','',''],['土墙','',''],['土墩','',''],['土壤','',''],['土壤型','',''],['土壤学','',''],['土壤细流','',''],['土头土脑','',''],['土家','',''],['土尔其斯坦','',''],['土层','',''],['土山','',''],['土岗','',''],['土崩瓦解','',''],['土崩鱼烂','',''],['土布','',''],['土库','',''],['土库曼','',''],['土库曼人','',''],['土库镇','',''],['土建','',''],['土性','',''],['土戏','',''],['土拉弗氏菌','',''],['土拨鼠','',''],['土改','',''],['土政策','',''],['土方','',''],['土星','',''],['土曜日','',''],['土木','',''],['土木工程','',''],['土木建筑','',''],['土木形骸','',''],['土木身','',''],['土木香','',''],['土桑','',''],['土棍','',''],['土楼','',''],['土模','',''],['土气','',''],['土沥青','',''],['土法','',''],['土法上马','',''],['土洋并举','',''],['土洋结合','',''],['土温','',''],['土灰色','',''],['土炕','',''],['土牛','',''],['土牛木马','',''],['土牢','',''],['土物','',''],['土特','',''],['土特产','',''],['土特品','',''],['土狗','',''],['土狗子','',''],['土狼','',''],['土猪','',''],['土生','',''],['土生土长','',''],['土皇帝','',''],['土石','',''],['土石方','',''],['土石流','',''],['土矿','',''],['土神','',''],['土窑','',''],['土窖','',''],['土管','',''],['土籍','',''],['土粉子','',''],['土粪','',''],['土纸','',''],['土耳其人','',''],['土耳其旋转烤肉','',''],['土耳其语','',''],['土腔','',''],['土腥','',''],['土色','',''],['土茴香','',''],['土药','',''],['土著','',''],['土著人','',''],['土著居民','',''],['土葬','',''],['土蚕','',''],['土蜂','',''],['土蝗','',''],['土话','',''],['土语','',''],['土谷祠','',''],['土豆','',''],['土豆丝','',''],['土豆泥','',''],['土豆网','',''],['土豚','',''],['土豪','',''],['土豪劣绅','',''],['土财主','',''],['土货','',''],['土质','',''],['土邦','',''],['土里土气','',''],['土门','',''],['土阶茅屋','',''],['土阶茅茨','',''],['土陶','',''],['土霉素','',''],['土霸','',''],['土音','',''],['土风舞','',''],['土香','',''],['土魠鱼','',''],['土鲮鱼','',''],['土鳖','',''],['土鸡瓦犬','',''],['土黄','',''],['土黄色','',''],['土龙刍狗','',''],['圣上','',''],['圣主','',''],['圣乐','',''],['圣乔治','',''],['圣事','',''],['圣人','',''],['圣代','',''],['圣休圣绪','',''],['圣传','',''],['圣伯多禄大殿','',''],['圣但尼','',''],['圣体','',''],['圣体节','',''],['圣体血','',''],['圣保罗','',''],['圣俸','',''],['圣像','',''],['圣僧','',''],['圣克鲁斯','',''],['圣克鲁斯岛','',''],['圣典','',''],['圣凯瑟琳','',''],['圣劳伦斯河','',''],['圣化','',''],['圣卢西亚岛','',''],['圣君','',''],['圣哈辛托','',''],['圣哉经','',''],['圣哲','',''],['圣器室','',''],['圣地','',''],['圣地亚哥','',''],['圣地牙哥','',''],['圣坛','',''],['圣坛所','',''],['圣城','',''],['圣堂','',''],['圣塔伦','',''],['圣墓','',''],['圣多明各','',''],['圣多明哥','',''],['圣多美','',''],['圣大非','',''],['圣奥古斯丁','',''],['圣女','',''],['圣女果','',''],['圣女贞德','',''],['圣婴','',''],['圣子','',''],['圣安地列斯断层','',''],['圣安多尼堂区','',''],['圣安德列斯断层','',''],['圣安德鲁','',''],['圣帕特里克','',''],['圣庙','',''],['圣役','',''],['圣彼得','',''],['圣彼得堡','',''],['圣徒','',''],['圣徒传','',''],['圣徒般','',''],['圣德克旭贝里','',''],['圣德太子','',''],['圣心','',''],['圣心节','',''],['圣恩','',''],['圣战','',''],['圣手','',''],['圣教','',''],['圣文森和格林纳丁','',''],['圣旨','',''],['圣明','',''],['圣曲','',''],['圣朝','',''],['圣本','',''],['圣杯','',''],['圣歌','',''],['圣殿','',''],['圣母','',''],['圣母升天节','',''],['圣母峰','',''],['圣母教堂','',''],['圣母玛利亚','',''],['圣水','',''],['圣水盆','',''],['圣洁','',''],['圣洗','',''],['圣潘克勒斯站','',''],['圣火','',''],['圣灰瞻礼日','',''],['圣灰节','',''],['圣灵','',''],['圣灵降临','',''],['圣烛节','',''],['圣父','',''],['圣物','',''],['圣王','',''],['圣皮埃尔和密克隆','',''],['圣盘','',''],['圣礼','',''],['圣祖','',''],['圣神','',''],['圣神降临','',''],['圣神降临周','',''],['圣索非亚','',''],['圣索非亚大教堂','',''],['圣约','',''],['圣约瑟夫','',''],['圣约翰','',''],['圣约翰斯','',''],['圣纳帕','',''],['圣经','',''],['圣经典故','',''],['圣经卦','',''],['圣经外传','',''],['圣经段落','',''],['圣经神学','',''],['圣经贤传','',''],['圣经贤转','',''],['圣者','',''],['圣职','',''],['圣职者','',''],['圣胎','',''],['圣药','',''],['圣荷西','',''],['圣菲','',''],['圣萨尔瓦多','',''],['圣衣','',''],['圣训','',''],['圣诗','',''],['圣诞','',''],['圣诞前夕','',''],['圣诞卡','',''],['圣诞岛','',''],['圣诞快乐','',''],['圣诞树','',''],['圣诞红','',''],['圣诞老人','',''],['圣诞花','',''],['圣诞颂','',''],['圣谕','',''],['圣贤','',''],['圣贤书','',''],['圣赫勒拿岛','',''],['圣路易斯','',''],['圣躬','',''],['圣迹','',''],['圣雄','',''],['圣餐','',''],['圣餐台','',''],['圣马利亚','',''],['圣马利诺','',''],['圣马洛','',''],['圣骨','',''],['圣骨匣','',''],['圣骨箱','',''],['在一般情况下','',''],['在一起','',''],['在一边','',''],['在上','',''],['在上文','',''],['在上游','',''],['在上面','',''],['在下','',''],['在下列','',''],['在下文','',''],['在下方','',''],['在下边','',''],['在下面','',''],['在不久的将来','',''],['在与','',''],['在世','',''],['在世界上','',''],['在世界范围内','',''],['在业','',''],['在东方','',''],['在中心','',''],['在中间','',''],['在乎','',''],['在于','',''],['在京','',''],['在人矮檐下','',''],['在什么','',''],['在他','',''],['在他处','',''],['在任','',''],['在任何情况下','',''],['在会谈中','',''],['在传','',''],['在位','',''],['在位时代','',''],['在何处','',''],['在作','',''],['在使','',''],['在做','',''],['在先','',''],['在先前','',''],['在全国范围内','',''],['在其中','',''],['在内','',''],['在册','',''],['在初期','',''],['在别处','',''],['在到','',''],['在制','',''],['在制品','',''],['在前','',''],['在前于','',''],['在前头','',''],['在前方','',''],['在前部','',''],['在前面','',''],['在劫难逃','',''],['在半途','',''],['在华','',''],['在印刷','',''],['在即','',''],['在各方面','',''],['在同等条件下','',''],['在后','',''],['在后面','',''],['在周围','',''],['在周末','',''],['在哪','',''],['在国内外','',''],['在国外','',''],['在国际上','',''],['在在','',''],['在地上','',''],['在地下','',''],['在地愿做连理枝','',''],['在场','',''],['在城郊','',''],['在外','',''],['在外国','',''],['在外面','',''],['在大多数情况下','',''],['在天之灵','',''],['在天愿做比翼鸟','',''],['在头上','',''],['在她','',''],['在学','',''],['在官言官','',''],['在室内','',''],['在宫中','',''],['在家','',''],['在家出家','',''],['在密切注意','',''],['在将来','',''],['在屋里','',''],['在山麓','',''],['在岗','',''],['在工作上','',''],['在工作中','',''],['在左舷','',''],['在帮','',''],['在平日','',''],['在床','',''],['在床上','',''],['在底下','',''],['在座','',''],['在建','',''],['在建设中','',''],['在彼方','',''],['在很大程度上','',''],['在很短的时间内','',''],['在心','',''],['在必','',''],['在意','',''],['在我心中','',''],['在我看','',''],['在我看来','',''],['在户内','',''],['在户外','',''],['在所不惜','',''],['在所不计','',''],['在所不辞','',''],['在所难免','',''],['在手边','',''],['在打','',''],['在技术上','',''],['在押','',''],['在押犯','',''],['在挤','',''],['在握','',''],['在改革中','',''],['在教','',''],['在新形势下','',''],['在新的一年里','',''],['在旁','',''],['在日常工作中','',''],['在日常生活中','',''],['在时','',''],['在春季','',''],['在晚上','',''],['在暗中','',''],['在最','',''],['在望','',''],['在朝','',''],['在本世纪内','',''],['在本国','',''],['在校','',''],['在校学生','',''],['在校生','',''],['在案','',''],['在次页','',''],['在此','',''],['在此中','',''],['在此之前','',''],['在此之后','',''],['在此之际','',''],['在此后','',''],['在此基础上','',''],['在此存照','',''],['在此期间','',''],['在水上','',''],['在水下','',''],['在沉','',''],['在海上','',''],['在涨','',''],['在深处','',''],['在深夜','',''],['在演','',''],['在特定情况下','',''],['在特殊情况下','',''],['在理','',''],['在理会','',''],['在生活上','',''],['在生活中','',''],['在用','',''],['在百忙之中','',''],['在的','',''],['在真空中','',''],['在眼前','',''],['在短期内','',''],['在短短的几年之内','',''],['在窗','',''],['在第十','',''],['在等','',''],['在线','',''],['在线造词','',''],['在组织上','',''],['在经济上','',''],['在给','',''],['在编','',''],['在编人员','',''],['在群众中','',''],['在职','',''],['在职人员','',''],['在职干部','',''],['在职者','',''],['在职训练','',''],['在舷侧','',''],['在船上','',''],['在船尾','',''],['在行','',''],['在被','',''],['在西南','',''],['在要','',''],['在讲话中','',''],['在诉讼期间','',''],['在说','',''],['在读','',''],['在调','',''],['在谈','',''],['在身','',''],['在身边','',''],['在过','',''],['在近旁','',''],['在这之前','',''],['在这期间','',''],['在逃','',''],['在逃犯','',''],['在途','',''],['在逗','',''],['在通常情况下','',''],['在那','',''],['在那儿','',''],['在野','',''],['在野党','',''],['在野外','',''],['在附近','',''],['在陈之厄','',''],['在飞','',''],['在高处','',''],['圩地','',''],['圩场','',''],['圩垸','',''],['圩子','',''],['圩田','',''],['圪垯','',''],['圪节','',''],['圪蹴','',''],['圪针','',''],['圬工','',''],['圭臬','',''],['圭表','',''],['地丁','',''],['地三鲜','',''],['地上','',''],['地上河','',''],['地上茎','',''],['地下','',''],['地下修文','',''],['地下党','',''],['地下室','',''],['地下工程施工','',''],['地下斗争','',''],['地下核爆炸','',''],['地下核试验','',''],['地下水','',''],['地下海','',''],['地下组织','',''],['地下茎','',''],['地下通信','',''],['地下通道','',''],['地下道','',''],['地下铁路','',''],['地下铁道','',''],['地丑德齐','',''],['地中','',''],['地中海','',''],['地中海地区','',''],['地中海形贫血','',''],['地中海气候','',''],['地中海贫血','',''],['地主','',''],['地主之谊','',''],['地主家庭','',''],['地主阶级','',''],['地久天长','',''],['地产','',''],['地产大亨','',''],['地亩','',''],['地价','',''],['地位','',''],['地侧','',''],['地保','',''],['地做','',''],['地儿','',''],['地光','',''],['地利','',''],['地利人和','',''],['地力','',''],['地动','',''],['地动仪','',''],['地动山摇','',''],['地势','',''],['地勤','',''],['地勤人员','',''],['地区','',''],['地区冲突','',''],['地区差价','',''],['地区开发','',''],['地区性','',''],['地区法院','',''],['地区经济','',''],['地区霸权主义','',''],['地压','',''],['地台','',''],['地史','',''],['地名','',''],['地名学','',''],['地名录','',''],['地响','',''],['地图','',''],['地图册','',''],['地图制图学','',''],['地图学','',''],['地图投影','',''],['地图管理','',''],['地图集','',''],['地地道道','',''],['地址','',''],['地址的转换','',''],['地址解析协议','',''],['地块','',''],['地坛','',''],['地垄','',''],['地域','',''],['地域性','',''],['地基','',''],['地堑','',''],['地堡','',''],['地塄','',''],['地塞米松','',''],['地声','',''],['地壳','',''],['地壳运动','',''],['地处','',''],['地大物博','',''],['地头','',''],['地头蛇','',''],['地契','',''],['地委','',''],['地委书记','',''],['地学','',''],['地安门','',''],['地宫','',''],['地富反坏','',''],['地富反坏右','',''],['地对空','',''],['地对空导弹','',''],['地层','',''],['地层学','',''],['地岬','',''],['地峡','',''],['地崩山摧','',''],['地市','',''],['地帛','',''],['地带','',''],['地幔','',''],['地平','',''],['地平天成','',''],['地平线','',''],['地平线上','',''],['地广人稀','',''],['地底','',''],['地府','',''],['地形','',''],['地形图','',''],['地形学','',''],['地役权','',''],['地心','',''],['地心吸力','',''],['地心引力','',''],['地心纬度','',''],['地心说','',''],['地志','',''],['地拉那','',''],['地摊','',''],['地支','',''],['地政','',''],['地政学','',''],['地文学','',''],['地方','',''],['地方主义','',''],['地方停车','',''],['地方党委','',''],['地方军','',''],['地方化','',''],['地方官','',''],['地方官职位','',''],['地方志','',''],['地方性','',''],['地方性斑疹伤寒','',''],['地方性植物','',''],['地方戏','',''],['地方时','',''],['地方武装','',''],['地方民族主义','',''],['地方法院','',''],['地方病','',''],['地方税','',''],['地方自治','',''],['地方部队','',''],['地景','',''],['地权','',''],['地板','',''],['地极','',''],['地标','',''],['地栗','',''],['地核','',''],['地梨','',''],['地检署','',''],['地榜','',''],['地槽','',''],['地步','',''],['地段','',''],['地毡','',''],['地毯','',''],['地毯拖鞋','',''],['地水','',''],['地沟','',''],['地沟油','',''],['地波','',''],['地洞','',''],['地浅','',''],['地温','',''],['地温表','',''],['地滑','',''],['地滚球','',''],['地漏','',''],['地灵','',''],['地灵人杰','',''],['地炉','',''],['地点','',''],['地热','',''],['地热发电','',''],['地热发电厂','',''],['地热学','',''],['地热电站','',''],['地热能','',''],['地热资源','',''],['地牢','',''],['地物','',''],['地状','',''],['地狱','',''],['地狱般','',''],['地球','',''],['地球上','',''],['地球仪','',''],['地球体','',''],['地球化学','',''],['地球化学勘探','',''],['地球外','',''],['地球大气','',''],['地球物理','',''],['地球物理勘探','',''],['地球物理学','',''],['地球物理观测卫星','',''],['地球磁场','',''],['地球科学','',''],['地球资源勘测卫星','',''],['地球轨道','',''],['地理','',''],['地理书','',''],['地理位置','',''],['地理坐标','',''],['地理学','',''],['地理学家','',''],['地理志','',''],['地理极','',''],['地理民情','',''],['地理环境决定论','',''],['地瓜','',''],['地瓜面','',''],['地界','',''],['地界标','',''],['地痞','',''],['地痞流氓','',''],['地瘩','',''],['地瘪','',''],['地皮','',''],['地盖','',''],['地盘','',''],['地矿','',''],['地矿局','',''],['地矿部','',''],['地磁','',''],['地磁仪','',''],['地磁场','',''],['地磁极','',''],['地磁气','',''],['地祇','',''],['地租','',''],['地租收入','',''],['地秤','',''],['地积','',''],['地积单','',''],['地税','',''],['地穴','',''],['地窖','',''],['地窟','',''],['地窨','',''],['地窨子','',''],['地籍','',''],['地籍图','',''],['地精似','',''],['地级','',''],['地级市','',''],['地线','',''],['地绸','',''],['地缘','',''],['地缘战略','',''],['地缘政治','',''],['地缘政治学','',''],['地网天罗','',''],['地羊','',''],['地老天荒','',''],['地老虎','',''],['地肤','',''],['地肤子','',''],['地能','',''],['地脉','',''],['地脚','',''],['地膜','',''],['地膜覆盖','',''],['地藏','',''],['地藏王菩萨','',''],['地藏菩萨','',''],['地蚕','',''],['地蜡','',''],['地衣','',''],['地表','',''],['地表水','',''],['地西泮','',''],['地覆天翻','',''],['地角','',''],['地角天涯','',''],['地话','',''],['地貌','',''],['地貌变迁','',''],['地貌学','',''],['地财','',''],['地质','',''],['地质作用','',''],['地质力学','',''],['地质勘探','',''],['地质图','',''],['地质学','',''],['地质学家','',''],['地质局','',''],['地质年代','',''],['地质年代表','',''],['地质年表','',''],['地质普查','',''],['地质构造','',''],['地质矿产部','',''],['地质队','',''],['地走','',''],['地躺拳','',''],['地轴','',''],['地速','',''],['地道','',''],['地道战','',''],['地邻','',''],['地里','',''],['地钱','',''],['地铁','',''],['地铁站','',''],['地铺','',''],['地锦草','',''],['地间','',''],['地陷','',''],['地雷','',''],['地雷区','',''],['地雷场','',''],['地雷战','',''],['地震','',''],['地震中','',''],['地震仪','',''],['地震区','',''],['地震学','',''],['地震学家','',''],['地震局','',''],['地震带','',''],['地震序列','',''],['地震波','',''],['地震活动带','',''],['地震烈度','',''],['地震计','',''],['地震震级','',''],['地震预报','',''],['地面','',''],['地面卫星接收站','',''],['地面层','',''],['地面控制','',''],['地面核爆炸','',''],['地面气压','',''],['地面水','',''],['地面沉降','',''],['地面温度表','',''],['地面灌溉','',''],['地面站','',''],['地面部队','',''],['地面零点','',''],['地鳖','',''],['地黄','',''],['地黄牛','',''],['地龙','',''],['场上','',''],['场主','',''],['场儿','',''],['场内','',''],['场券','',''],['场区','',''],['场区应急','',''],['场合','',''],['场地','',''],['场地自行车','',''],['场场','',''],['场址','',''],['场外','',''],['场外应急','',''],['场子','',''],['场屋','',''],['场强','',''],['场戏','',''],['场所','',''],['场景','',''],['场次','',''],['场界','',''],['场白','',''],['场租','',''],['场站','',''],['场记','',''],['场记板','',''],['场论','',''],['场费','',''],['场部','',''],['场长','',''],['场院','',''],['场面','',''],['场频','',''],['场馆','',''],['均一','',''],['均不','',''],['均不能','',''],['均与','',''],['均为','',''],['均享','',''],['均以','',''],['均依','',''],['均值','',''],['均分','',''],['均列','',''],['均势','',''],['均匀','',''],['均匀性','',''],['均占','',''],['均受','',''],['均变论','',''],['均可','',''],['均富','',''],['均居','',''],['均属','',''],['均差','',''],['均已','',''],['均应','',''],['均指','',''],['均按','',''],['均据','',''],['均摊','',''],['均收','',''],['均数','',''],['均方','',''],['均无','',''],['均日照','',''],['均有','',''],['均未','',''],['均权','',''],['均权制度','',''],['均沾','',''],['均湿','',''],['均热','',''],['均用','',''],['均田','',''],['均田制','',''],['均由','',''],['均相','',''],['均称','',''],['均等','',''],['均等化','',''],['均等性','',''],['均线','',''],['均线指标','',''],['均能','',''],['均衡','',''],['均衡器','',''],['均衡性','',''],['均衡生产','',''],['均衡论','',''],['均衡说','',''],['均被','',''],['均要','',''],['均设','',''],['均质','',''],['均贫','',''],['均达','',''],['均遭','',''],['均重','',''],['均需','',''],['均须','',''],['坊子','',''],['坊本','',''],['坊间','',''],['坋粒','',''],['坌鸟先飞','',''],['坍台','',''],['坍塌','',''],['坍恶不赦','',''],['坍方','',''],['坍缩星','',''],['坎井之蛙','',''],['坎儿','',''],['坎儿井','',''],['坎土曼','',''],['坎坎','',''],['坎坷','',''],['坎坷不平','',''],['坎坷多舛','',''],['坎坎坷坷','',''],['坎培拉','',''],['坎塔布连','',''],['坎塔布连山脉','',''],['坎塔布连海','',''],['坎塔布里亚','',''],['坎壈','',''],['坎大哈','',''],['坎大哈省','',''],['坎子','',''],['坎帕拉','',''],['坎德拉','',''],['坎昆','',''],['坎洼','',''],['坎特伯雷','',''],['坎特伯雷大主教','',''],['坎肩','',''],['坎肩儿','',''],['坎贝尔','',''],['坎贝尔侏儒仓鼠','',''],['坏东西','',''],['坏书','',''],['坏了','',''],['坏事','',''],['坏事变好事','',''],['坏人','',''],['坏人坏事','',''],['坏分子','',''],['坏包儿','',''],['坏名声','',''],['坏君','',''],['坏啦','',''],['坏坏','',''],['坏处','',''],['坏家伙','',''],['坏帐','',''],['坏心','',''],['坏心眼','',''],['坏心肠','',''],['坏性','',''],['坏掉','',''],['坏死','',''],['坏水','',''],['坏疽','',''],['坏的','',''],['坏种','',''],['坏脾气','',''],['坏蛋','',''],['坏血','',''],['坏血病','',''],['坏话','',''],['坏账','',''],['坏运','',''],['坏运气','',''],['坏透','',''],['坏透了','',''],['坏透坏绝','',''],['坏鸟','',''],['坐上','',''],['坐下','',''],['坐不垂堂','',''],['坐不安席','',''],['坐不改名','',''],['坐不改姓','',''],['坐不窥堂','',''],['坐了','',''],['坐井','',''],['坐井观天','',''],['坐享其成','',''],['坐以待旦','',''],['坐以待毙','',''],['坐会','',''],['坐位','',''],['坐便器','',''],['坐倒','',''],['坐像','',''],['坐具','',''],['坐冷板凳','',''],['坐到','',''],['坐力','',''],['坐功','',''],['坐化','',''],['坐卧','',''],['坐卧不宁','',''],['坐卧不安','',''],['坐厕','',''],['坐厕垫','',''],['坐取','',''],['坐台','',''],['坐台小姐','',''],['坐吃享福','',''],['坐吃山崩','',''],['坐吃山空','',''],['坐向','',''],['坐吧','',''],['坐呀','',''],['坐商','',''],['坐困','',''],['坐在','',''],['坐地分赃','',''],['坐坡','',''],['坐垫','',''],['坐墩','',''],['坐大','',''],['坐失','',''],['坐失机宜','',''],['坐失良机','',''],['坐好','',''],['坐姿','',''],['坐守','',''],['坐定','',''],['坐山','',''],['坐山看虎斗','',''],['坐山观虎斗','',''],['坐山雕','',''],['坐席','',''],['坐庄','',''],['坐往','',''],['坐待','',''],['坐得','',''],['坐怀不乱','',''],['坐惯','',''],['坐探','',''],['坐支','',''],['坐收','',''],['坐收渔利','',''],['坐无车公','',''],['坐月','',''],['坐月子','',''],['坐木筏','',''],['坐果','',''],['坐标','',''],['坐标法','',''],['坐标空间','',''],['坐标系','',''],['坐标轴','',''],['坐椅','',''],['坐此','',''],['坐浴','',''],['坐满','',''],['坐牢','',''],['坐班','',''],['坐班房','',''],['坐的人','',''],['坐着','',''],['坐票','',''],['坐禁闭','',''],['坐禅','',''],['坐科','',''],['坐立','',''],['坐立不安','',''],['坐立难安','',''],['坐等','',''],['坐筹帷幄','',''],['坐者','',''],['坐而待旦','',''],['坐而待毙','',''],['坐而论道','',''],['坐背','',''],['坐脏','',''],['坐舱','',''],['坐船','',''],['坐药','',''],['坐落','',''],['坐坐','',''],['坐蓐','',''],['坐蔸','',''],['坐薪尝胆','',''],['坐薪悬胆','',''],['坐蜡','',''],['坐观','',''],['坐观成败','',''],['坐视','',''],['坐视不救','',''],['坐视不理','',''],['坐视成败','',''],['坐视无睹','',''],['坐言起行','',''],['坐误','',''],['坐起','',''],['坐车','',''],['坐镇','',''],['坐飞机','',''],['坐骑','',''],['坐骨','',''],['坐骨神经','',''],['坐骨神经痛','',''],['坑井','',''],['坑人','',''],['坑儒','',''],['坑内','',''],['坑口','',''],['坑坎','',''],['坑坑洼洼','',''],['坑子','',''],['坑害','',''],['坑木','',''],['坑杀','',''],['坑洞','',''],['坑洼','',''],['坑爹','',''],['坑穴','',''],['坑蒙拐骗','',''],['坑道','',''],['坑里','',''],['坑骗','',''],['块体','',''],['块儿','',''],['块儿八毛','',''],['块冰','',''],['块块','',''],['块垒','',''],['块头','',''],['块根','',''],['块煤','',''],['块状','',''],['块状物','',''],['块结','',''],['块茎','',''],['块茎状','',''],['块菌','',''],['块规','',''],['块间','',''],['坚不可摧','',''],['坚信','',''],['坚信不移','',''],['坚信礼','',''],['坚决','',''],['坚决否认','',''],['坚固','',''],['坚固性','',''],['坚固耐用','',''],['坚城深池','',''],['坚壁','',''],['坚壁清野','',''],['坚如','',''],['坚如磐石','',''],['坚如钢','',''],['坚守','',''],['坚守岗位','',''],['坚定','',''],['坚定不移','',''],['坚定性','',''],['坚实','',''],['坚尼系数','',''],['坚度','',''],['坚强','',''],['坚强不屈','',''],['坚强意志','',''],['坚忍','',''],['坚忍不拔','',''],['坚戈','',''],['坚执','',''],['坚拒','',''],['坚持','',''],['坚持下去','',''],['坚持不懈','',''],['坚持不渝','',''],['坚持原则','',''],['坚持四项基本原则','',''],['坚持真理','',''],['坚振','',''],['坚振礼','',''],['坚挺','',''],['坚明','',''],['坚果','',''],['坚果仁','',''],['坚果壳','',''],['坚毅','',''],['坚牢','',''],['坚牢度','',''],['坚甲利兵','',''],['坚石','',''],['坚硬','',''],['坚称','',''],['坚致','',''],['坚苦','',''],['坚苦卓绝','',''],['坚贞','',''],['坚贞不屈','',''],['坚贞不渝','',''],['坚韧','',''],['坚韧不拔','',''],['坛坛罐罐','',''],['坛子','',''],['坛木','',''],['坛而不化','',''],['坝址','',''],['坝基','',''],['坝埽','',''],['坝子','',''],['坝身','',''],['坟丘','',''],['坟地','',''],['坟场','',''],['坟墓','',''],['坟头','',''],['坟山','',''],['坟茔','',''],['坠下','',''],['坠体','',''],['坠入','',''],['坠地','',''],['坠子','',''],['坠机','',''],['坠楼','',''],['坠毁','',''],['坠海','',''],['坠茵落溷','',''],['坠落','',''],['坠饰','',''],['坠马','',''],['坡地','',''],['坡垒','',''],['坡头','',''],['坡度','',''],['坡状','',''],['坡田','',''],['坡路','',''],['坡道','',''],['坡鹿','',''],['坤甸','',''],['坤角儿','',''],['坦佩雷','',''],['坦克','',''],['坦克兵','',''],['坦克车','',''],['坦克部队','',''],['坦博拉','',''],['坦噶','',''],['坦噶尼喀','',''],['坦噶尼喀湖','',''],['坦坦','',''],['坦平','',''],['坦怀','',''],['坦承','',''],['坦然','',''],['坦然无惧','',''],['坦然自若','',''],['坦率','',''],['坦白','',''],['坦白从宽','',''],['坦直','',''],['坦缓','',''],['坦胸','',''],['坦腹','',''],['坦腹东床','',''],['坦荡','',''],['坦言','',''],['坦诚','',''],['坦诚相待','',''],['坦诚相见','',''],['坦说','',''],['坦途','',''],['坦陈','',''],['坦陈衷曲','',''],['坦露','',''],['坨儿','',''],['坨子','',''],['坩埚','',''],['坩子土','',''],['坩锅','',''],['坪坝','',''],['坪林','',''],['坪林乡','',''],['坯件','',''],['坯子','',''],['坯布','',''],['坯料','',''],['坯模','',''],['坯砌','',''],['坳堂','',''],['坳陷','',''],['坷垃','',''],['坷拉','',''],['坼裂','',''],['垂下','',''],['垂体','',''],['垂危','',''],['垂垂','',''],['垂头丧气','',''],['垂头弯腰','',''],['垂头缩肩','',''],['垂就','',''],['垂布','',''],['垂帘','',''],['垂帘听政','',''],['垂幕','',''],['垂度','',''],['垂心','',''],['垂悬分词','',''],['垂感','',''],['垂手','',''],['垂手而得','',''],['垂拱而治','',''],['垂挂','',''],['垂暮','',''],['垂暮之年','',''],['垂曲线','',''],['垂杨柳','',''],['垂柳','',''],['垂死','',''],['垂死挣扎','',''],['垂泣','',''],['垂泪','',''],['垂涎','',''],['垂涎三尺','',''],['垂涎欲摘','',''],['垂涎欲滴','',''],['垂片','',''],['垂白','',''],['垂直','',''],['垂直和短距起落飞机','',''],['垂直平分线','',''],['垂直性','',''],['垂直搜索','',''],['垂直线','',''],['垂直起落飞机','',''],['垂直面','',''],['垂线','',''],['垂线足','',''],['垂老','',''],['垂耳','',''],['垂肉','',''],['垂肌','',''],['垂花门','',''],['垂裕后昆','',''],['垂询','',''],['垂足','',''],['垂部','',''],['垂钓','',''],['垂青','',''],['垂顾','',''],['垂髫','',''],['垃圾','',''],['垃圾场','',''],['垃圾堆','',''],['垃圾处理','',''],['垃圾工','',''],['垃圾桶','',''],['垃圾电邮','',''],['垃圾筒','',''],['垃圾箱','',''],['垃圾虫','',''],['垃圾袋','',''],['垃圾车','',''],['垃圾邮件','',''],['垄作','',''],['垄断','',''],['垄断价格','',''],['垄断利润','',''],['垄断组织','',''],['垄断者','',''],['垄断贩卖','',''],['垄断资产阶级','',''],['垄断资本','',''],['垄断资本主义','',''],['垄沟','',''],['垄统','',''],['垆坶','',''],['垆埴','',''],['垆邸','',''],['型号','',''],['型式','',''],['型心','',''],['型快闪记忆体','',''],['型材','',''],['型板','',''],['型款','',''],['型状','',''],['型男','',''],['型砂','',''],['型车','',''],['型钢','',''],['垒固','',''],['垒球','',''],['垒砌','',''],['垒障','',''],['垓下','',''],['垓心','',''],['垛上','',''],['垛口','',''],['垛子','',''],['垝垣','',''],['垡子','',''],['垢污','',''],['垢物','',''],['垢阂','',''],['垢面','',''],['垣衣','',''],['垦丁','',''],['垦丁国家公园','',''],['垦丁市','',''],['垦区','',''],['垦复','',''],['垦拓','',''],['垦殖','',''],['垦荒','',''],['垩版','',''],['垩纪','',''],['垫上','',''],['垫上运动','',''],['垫付','',''],['垫借','',''],['垫充','',''],['垫圈','',''],['垫子','',''],['垫层','',''],['垫布','',''],['垫平','',''],['垫底','',''],['垫底儿','',''],['垫座','',''],['垫支','',''],['垫料','',''],['垫木','',''],['垫板','',''],['垫架','',''],['垫款','',''],['垫片','',''],['垫物','',''],['垫用','',''],['垫盘','',''],['垫着','',''],['垫肩','',''],['垫背','',''],['垫脚','',''],['垫脚石','',''],['垫补','',''],['垫衬','',''],['垫被','',''],['垫褥','',''],['垫起','',''],['垫钱','',''],['垫高','',''],['垭口','',''],['垮了','',''],['垮台','',''],['垮塌','',''],['垮掉','',''],['垸子','',''],['埂子','',''],['埃克托','',''],['埃克托・柏辽兹','',''],['埃利斯岛','',''],['埃加迪群岛','',''],['埃博拉病毒','',''],['埃及七月革命','',''],['埃及人','',''],['埃及古物学','',''],['埃及古物学者','',''],['埃及语','',''],['埃及豆','',''],['埃叙','',''],['埃因霍温','',''],['埃塔','',''],['埃塞俄比亚语','',''],['埃夫伯里','',''],['埃奥罗斯','',''],['埃尔南德斯','',''],['埃尔多安','',''],['埃尔帕索','',''],['埃尔朗根','',''],['埃尔朗根纲领','',''],['埃尔福特','',''],['埃尔维斯・普雷斯利','',''],['埃尔金','',''],['埃尔金大理石','',''],['埃居','',''],['埃布罗','',''],['埃布罗河','',''],['埃弗顿','',''],['埃德','',''],['埃德・米利班德','',''],['埃德加','',''],['埃德加・斯诺','',''],['埃德加・爱伦・坡','',''],['埃德蒙・伯克','',''],['埃德蒙顿','',''],['埃拉托塞尼斯','',''],['埃拉特','',''],['埃文','',''],['埃文斯','',''],['埃文河畔斯特拉特福','',''],['埃文茅斯','',''],['埃斯库多','',''],['埃斯库罗斯','',''],['埃斯特哈齐','',''],['埃斯特朗','',''],['埃格尔松','',''],['埃森','',''],['埃森哲','',''],['埃森纳赫','',''],['埃涅阿斯','',''],['埃涅阿斯纪','',''],['埃特纳火山','',''],['埃琳娜','',''],['埃米尔','',''],['埃菲尔铁塔','',''],['埃蕾','',''],['埃迪卡拉','',''],['埃迪卡拉纪','',''],['埃里温','',''],['埇桥','',''],['埋下','',''],['埋伏','',''],['埋入','',''],['埋冤','',''],['埋单','',''],['埋名','',''],['埋在','',''],['埋天怨地','',''],['埋头','',''],['埋头工作','',''],['埋头苦干','',''],['埋怨','',''],['埋汰','',''],['埋没','',''],['埋着','',''],['埋线','',''],['埋线疗法','',''],['埋置','',''],['埋葬','',''],['埋葬者','',''],['埋藏','',''],['埋设','',''],['埋首','',''],['埋首于','',''],['城下','',''],['城下之盟','',''],['城中','',''],['城中村','',''],['城主','',''],['城乡','',''],['城体','',''],['城关','',''],['城关镇','',''],['城内','',''],['城北徐公','',''],['城南','',''],['城厢','',''],['城垒','',''],['城垣','',''],['城域网','',''],['城堞','',''],['城堡','',''],['城墙','',''],['城墙外','',''],['城壁','',''],['城壕','',''],['城外','',''],['城头','',''],['城子河','',''],['城市','',''],['城市人','',''],['城市依赖症','',''],['城市化','',''],['城市区域','',''],['城市学','',''],['城市居民','',''],['城市热岛','',''],['城市管理行政执法局','',''],['城市规划','',''],['城市贫民','',''],['城市运动会','',''],['城市间','',''],['城府','',''],['城廓','',''],['城建','',''],['城建局','',''],['城弧','',''],['城形','',''],['城根','',''],['城楼','',''],['城步','',''],['城步县','',''],['城池','',''],['城河','',''],['城濮之战','',''],['城狐社鼠','',''],['城管','',''],['城西','',''],['城运会','',''],['城邦','',''],['城郊','',''],['城郭','',''],['城里','',''],['城里人','',''],['城铁','',''],['城镇','',''],['城镇化','',''],['城镇化水平','',''],['城门','',''],['城门失火','',''],['城门失火殃及池鱼','',''],['城阙','',''],['城防','',''],['城阳','',''],['城隍','',''],['埏埴','',''],['埔心','',''],['埔心乡','',''],['埔盐','',''],['埔盐乡','',''],['埔里','',''],['埔里镇','',''],['域名','',''],['域名抢注','',''],['域名服务器','',''],['域名注册','',''],['域外','',''],['域多利皇后','',''],['域网','',''],['埠头','',''],['埤头','',''],['埤头乡','',''],['埴土','',''],['培修','',''],['培养','',''],['培养人才','',''],['培养基','',''],['培养教育','',''],['培养液','',''],['培养皿','',''],['培养目标','',''],['培养者','',''],['培勒兹','',''],['培土','',''],['培基','',''],['培根','',''],['培植','',''],['培育','',''],['培训','',''],['培训中心','',''],['培训基地','',''],['培训教材','',''],['培训班','',''],['培里克利斯','',''],['基业','',''],['基于','',''],['基件','',''],['基价','',''],['基体','',''],['基值','',''],['基准','',''],['基准面','',''],['基加利','',''],['基友','',''],['基因','',''],['基因修改','',''],['基因变异','',''],['基因图谱','',''],['基因型','',''],['基因学','',''],['基因工程','',''],['基因库','',''],['基因扩大','',''],['基因技术','',''],['基因改造','',''],['基因染色体异常','',''],['基因治疗','',''],['基因码','',''],['基因突变','',''],['基因组','',''],['基团','',''],['基地','',''],['基地址','',''],['基地恐怖组织','',''],['基地组织','',''],['基地防御','',''],['基址','',''],['基坑','',''],['基多','',''],['基尔','',''],['基尔特','',''],['基尼系数','',''],['基层','',''],['基层社','',''],['基岩','',''],['基布兹','',''],['基希讷乌','',''],['基干','',''],['基年','',''],['基床','',''],['基底','',''],['基底动脉','',''],['基底神经节孙损伤','',''],['基底细胞癌','',''],['基度山','',''],['基座','',''],['基建','',''],['基态','',''],['基拉韦厄','',''],['基数','',''],['基数词','',''],['基时','',''],['基木','',''],['基本','',''],['基本上','',''],['基本利率','',''],['基本功','',''],['基本单位','',''],['基本原则','',''],['基本原理','',''],['基本国策','',''],['基本多文种平面','',''],['基本完成','',''],['基本定理','',''],['基本工资','',''],['基本建设','',''],['基本性','',''],['基本方针','',''],['基本概念','',''],['基本法','',''],['基本点','',''],['基本理论','',''],['基本电荷','',''],['基本矛盾','',''],['基本粒子','',''],['基本经济规律','',''],['基本词汇','',''],['基本路线','',''],['基本金','',''],['基本需要','',''],['基板','',''],['基极','',''],['基桑加尼','',''],['基桩','',''],['基民党','',''],['基波','',''],['基测','',''],['基点','',''],['基甸','',''],['基督','',''],['基督圣体节','',''],['基督城','',''],['基督徒','',''],['基督教','',''],['基督教徒','',''],['基督教民主联盟','',''],['基督教派','',''],['基督教科学派','',''],['基督新教','',''],['基石','',''],['基础','',''],['基础上','',''],['基础代谢','',''],['基础医学','',''],['基础工业','',''],['基础性','',''],['基础教育','',''],['基础理论','',''],['基础科学','',''],['基础结构','',''],['基础设施','',''],['基础课','',''],['基础速率','',''],['基础问题','',''],['基站','',''],['基线','',''],['基网','',''],['基肥','',''],['基脚','',''],['基色','',''],['基调','',''],['基谐波','',''],['基质','',''],['基质膜','',''],['基辅','',''],['基辅罗斯','',''],['基辛格','',''],['基达','',''],['基部','',''],['基里巴斯共和国','',''],['基金','',''],['基金会','',''],['基金组织','',''],['基面','',''],['基音','',''],['基频','',''],['堂・吉河德','',''],['堂上','',''],['堂会','',''],['堂侄','',''],['堂倌','',''],['堂兄','',''],['堂兄弟','',''],['堂叔','',''],['堂吉诃德','',''],['堂哥','',''],['堂坳','',''],['堂堂','',''],['堂堂正正','',''],['堂堂皇皇','',''],['堂外','',''],['堂奥','',''],['堂妹','',''],['堂姊妹','',''],['堂姐','',''],['堂子','',''],['堂客','',''],['堂屋','',''],['堂庑','',''],['堂弟','',''],['堂房','',''],['堂煌','',''],['堂皇','',''],['堂皇富丽','',''],['堂皇正大','',''],['堂而皇之','',''],['堂课','',''],['堂风','',''],['堂高廉远','',''],['堂鼓','',''],['堆丘','',''],['堆于','',''],['堆仓','',''],['堆入','',''],['堆叠','',''],['堆土机','',''],['堆垒','',''],['堆垒数论','',''],['堆垛','',''],['堆存处','',''],['堆成','',''],['堆房','',''],['堆搓','',''],['堆放','',''],['堆木场','',''],['堆栈','',''],['堆案盈几','',''],['堆满','',''],['堆焊','',''],['堆石','',''],['堆砌','',''],['堆积','',''],['堆积如山','',''],['堆积木','',''],['堆积物','',''],['堆笑','',''],['堆肥','',''],['堆芯','',''],['堆装物','',''],['堆起','',''],['堆迭','',''],['堆里','',''],['堆金积玉','',''],['堆集','',''],['堆高机','',''],['堇色','',''],['堇菜','',''],['堑壕','',''],['堕云雾中','',''],['堕入','',''],['堕楼','',''],['堕甑不顾','',''],['堕着','',''],['堕胎','',''],['堕胎药','',''],['堕落','',''],['堕马','',''],['堡中','',''],['堡主','',''],['堡垒','',''],['堡垒户','',''],['堡子','',''],['堡寨','',''],['堡礁','',''],['堤围','',''],['堤坝','',''],['堤堰','',''],['堤岸','',''],['堤拉米苏','',''],['堤溃','',''],['堤溃蚁孔','',''],['堤道','',''],['堤防','',''],['堤顶大路','',''],['堪培拉','',''],['堪察加','',''],['堪察加半岛','',''],['堪布','',''],['堪忧','',''],['堪称','',''],['堪称一绝','',''],['堪舆','',''],['堪萨斯','',''],['堪萨斯州','',''],['堪虞','',''],['堪达罕','',''],['堰内','',''],['堰塞湖','',''],['堰蜓座','',''],['堵了','',''],['堵住','',''],['堵击','',''],['堵剿匪徒','',''],['堵嘴','',''],['堵在','',''],['堵塞','',''],['堵塞费','',''],['堵墙','',''],['堵截','',''],['堵挡','',''],['堵死','',''],['堵气','',''],['堵水','',''],['堵漏','',''],['堵着','',''],['堵车','',''],['堵门','',''],['塄坎','',''],['塌下','',''],['塌了','',''],['塌倒','',''],['塌台','',''],['塌实','',''],['塌心','',''],['塌方','',''],['塌架','',''],['塌桥','',''],['塌棵菜','',''],['塌楼','',''],['塌车','',''],['塌陷','',''],['塌鼻','',''],['塌鼻子','',''],['塑像','',''],['塑化','',''],['塑化剂','',''],['塑型','',''],['塑封','',''],['塑性','',''],['塑性力学','',''],['塑成','',''],['塑料','',''],['塑料制品','',''],['塑料厂','',''],['塑料工业','',''],['塑料布','',''],['塑料片','',''],['塑料版','',''],['塑料瓶','',''],['塑料皮','',''],['塑料盒','',''],['塑料盘','',''],['塑料纸','',''],['塑料薄膜','',''],['塑料袋','',''],['塑料贴面板','',''],['塑木','',''],['塑条','',''],['塑胶','',''],['塑胶爆炸','',''],['塑胶跑道','',''],['塑膜','',''],['塑褂','',''],['塑身','',''],['塑造','',''],['塑造成','',''],['塑钢','',''],['塔什干','',''],['塔什库尔干','',''],['塔什库尔干乡','',''],['塔什库尔干自治县','',''],['塔克拉玛干','',''],['塔克拉玛干沙漠','',''],['塔克拉马干','',''],['塔公','',''],['塔公寺','',''],['塔列朗','',''],['塔利班','',''],['塔刹','',''],['塔加路族语','',''],['塔台','',''],['塔吉克','',''],['塔吉克人','',''],['塔吉克语','',''],['塔吊','',''],['塔塔儿','',''],['塔塔儿人','',''],['塔塔尔','',''],['塔夫绸','',''],['塔尔寺','',''],['塔尖','',''],['塔崩','',''],['塔崩水解酶','',''],['塔底','',''],['塔式','',''],['塔式起重机','',''],['塔形','',''],['塔扎','',''],['塔拉','',''],['塔拉瓦','',''],['塔斯曼','',''],['塔斯曼尼亚','',''],['塔斯曼尼亚岛','',''],['塔斯社','',''],['塔斯科拉','',''],['塔斯马尼亚洲','',''],['塔木德经','',''],['塔林','',''],['塔楼','',''],['塔灰','',''],['塔状','',''],['塔玛尔','',''],['塔瓦斯科','',''],['塔罗','',''],['塔罗卡','',''],['塔身','',''],['塔轮','',''],['塔迪奇','',''],['塔那那利佛','',''],['塔里木','',''],['塔里木河','',''],['塔里木盆地','',''],['塔门','',''],['塔顶','',''],['塔高','',''],['塕埲','',''],['塘坝','',''],['塘堰','',''],['塘沽','',''],['塘沽协定','',''],['塘泥','',''],['塘肥','',''],['塘虱','',''],['塘鹅','',''],['塞万提斯','',''],['塞上','',''],['塞住','',''],['塞入','',''],['塞具','',''],['塞北','',''],['塞哥维亚','',''],['塞在','',''],['塞外','',''],['塞子','',''],['塞孔','',''],['塞尔南','',''],['塞尔特','',''],['塞尔特语','',''],['塞尔维亚克罗地亚语','',''],['塞尔维亚和黑山','',''],['塞尔维亚民主党','',''],['塞尔维亚语','',''],['塞尺','',''],['塞巴斯蒂安','',''],['塞得','',''],['塞擦音','',''],['塞族','',''],['塞有','',''],['塞渊','',''],['塞满','',''],['塞满了','',''],['塞瓦斯托波尔','',''],['塞着','',''],['塞紧','',''],['塞纳河','',''],['塞给','',''],['塞维利亚','',''],['塞缪尔','',''],['塞缪尔・约翰逊','',''],['塞翁失马','',''],['塞翁失马安知非福','',''],['塞翁失马焉知非福','',''],['塞耳','',''],['塞耳盗铃','',''],['塞舌尔群岛','',''],['塞著','',''],['塞规','',''],['塞语','',''],['塞责','',''],['塞车','',''],['塞进','',''],['塞韦里诺','',''],['塞音','',''],['塞饱','',''],['填上','',''],['填交','',''],['填仓','',''],['填充','',''],['填充剂','',''],['填入','',''],['填具','',''],['填写','',''],['填列','',''],['填制','',''],['填发','',''],['填土','',''],['填地','',''],['填垫','',''],['填堵','',''],['填塞','',''],['填塞器','',''],['填塞料','',''],['填塞物','',''],['填填','',''],['填好','',''],['填字','',''],['填密','',''],['填平','',''],['填平补齐','',''],['填息','',''],['填成','',''],['填成平','',''],['填房','',''],['填报','',''],['填料','',''],['填方','',''],['填海','',''],['填满','',''],['填物','',''],['填用','',''],['填空','',''],['填空补缺','',''],['填絮','',''],['填补','',''],['填补国内空白','',''],['填补空白','',''],['填表','',''],['填记','',''],['填词','',''],['填送','',''],['填错','',''],['填饱','',''],['填高','',''],['填鸭','',''],['填鸭式','',''],['塬地','',''],['境内','',''],['境内外','',''],['境况','',''],['境地','',''],['境域','',''],['境外','',''],['境界','',''],['境遇','',''],['墉垣','',''],['墒土','',''],['墒情','',''],['墓中','',''],['墓主','',''],['墓人','',''],['墓园','',''],['墓地','',''],['墓场','',''],['墓址','',''],['墓坑','',''],['墓坑夯土层','',''],['墓塔','',''],['墓室','',''],['墓志','',''],['墓志文','',''],['墓志铭','',''],['墓石','',''],['墓碑','',''],['墓穴','',''],['墓窖','',''],['墓葬','',''],['墓葬区','',''],['墓道','',''],['墓门','',''],['墙上','',''],['墙上泥皮','',''],['墙下','',''],['墙体','',''],['墙倒众人推','',''],['墙内','',''],['墙前','',''],['墙垣','',''],['墙基','',''],['墙壁','',''],['墙外','',''],['墙头','',''],['墙头草','',''],['墙头诗','',''],['墙头马上','',''],['墙报','',''],['墙旮旯','',''],['墙有缝壁有耳','',''],['墙板','',''],['墙根','',''],['墙泥','',''],['墙洞','',''],['墙篱','',''],['墙纸','',''],['墙脚','',''],['墙花','',''],['墙花路柳','',''],['墙花路草','',''],['墙裙','',''],['墙角','',''],['墙跟','',''],['墙里墙外','',''],['墙里开花墙外香','',''],['墙面','',''],['墙面而立','',''],['墙风毕耳','',''],['墙高基下','',''],['增三和弦','',''],['增为','',''],['增亏','',''],['增产','',''],['增产增收','',''],['增产节约','',''],['增人','',''],['增借','',''],['增值','',''],['增值税','',''],['增光','',''],['增光添色','',''],['增兵','',''],['增减','',''],['增刊','',''],['增列','',''],['增删','',''],['增利','',''],['增加','',''],['增加值','',''],['增加收入','',''],['增加数','',''],['增加物','',''],['增印','',''],['增压','',''],['增压器','',''],['增发','',''],['增员','',''],['增塑剂','',''],['增多','',''],['增大','',''],['增大器','',''],['增幅','',''],['增幅器','',''],['增年','',''],['增广','',''],['增建','',''],['增强','',''],['增强党性','',''],['增强团结','',''],['增强塑料','',''],['增强活力','',''],['增征','',''],['增拨','',''],['增损','',''],['增援','',''],['增收','',''],['增收节支','',''],['增效','',''],['增有','',''],['增殖','',''],['增殖反应堆','',''],['增殖者','',''],['增殖腺','',''],['增派','',''],['增添','',''],['增添物','',''],['增温','',''],['增温层','',''],['增湿器','',''],['增生','',''],['增白','',''],['增白剂','',''],['增盈','',''],['增益','',''],['增税','',''],['增稠','',''],['增稠剂','',''],['增纳','',''],['增缴','',''],['增聘','',''],['增肥','',''],['增至','',''],['增色','',''],['增薪','',''],['增补','',''],['增订','',''],['增订本','',''],['增记','',''],['增设','',''],['增调','',''],['增贷','',''],['增资','',''],['增辉','',''],['增进','',''],['增进友谊','',''],['增选','',''],['增速','',''],['增配','',''],['增量','',''],['增量参数','',''],['增长','',''],['增长天','',''],['增长幅度','',''],['增长率','',''],['增长速度','',''],['增防','',''],['增高','',''],['墟里','',''],['墨丘利','',''],['墨具','',''],['墨刑','',''],['墨匣','',''],['墨台','',''],['墨吏','',''],['墨囊','',''],['墨子','',''],['墨守','',''],['墨守成规','',''],['墨守陈规','',''],['墨宝','',''],['墨客','',''],['墨家','',''],['墨尔本','',''],['墨尔钵','',''],['墨斗','',''],['墨斗鱼','',''],['墨晶','',''],['墨水','',''],['墨水儿','',''],['墨水台','',''],['墨水壶','',''],['墨水池','',''],['墨水瓶','',''],['墨水瓶架','',''],['墨汁','',''],['墨汁未干','',''],['墨江县','',''],['墨海','',''],['墨渍','',''],['墨湾','',''],['墨画','',''],['墨盒','',''],['墨石','',''],['墨砚','',''],['墨笔','',''],['墨粉','',''],['墨索里尼','',''],['墨累','',''],['墨累达令流域','',''],['墨纸','',''],['墨线','',''],['墨绿','',''],['墨绿色','',''],['墨者','',''],['墨色','',''],['墨菊','',''],['墨西哥人','',''],['墨西哥城','',''],['墨西哥湾','',''],['墨西哥独立战争','',''],['墨西拿','',''],['墨西拿海峡','',''],['墨迹','',''],['墨迹未干','',''],['墨镜','',''],['墨鱼','',''],['墨鸦','',''],['墨黑','',''],['墩墩','',''],['墩子','',''],['墩布','',''],['壁上','',''],['壁上观','',''],['壁助','',''],['壁厢','',''],['壁垒','',''],['壁垒一新','',''],['壁垒森严','',''],['壁扇','',''],['壁报','',''],['壁挂','',''],['壁效应','',''],['壁板','',''],['壁架','',''],['壁柜','',''],['壁柱','',''],['壁橱','',''],['壁毯','',''],['壁灯','',''],['壁炉','',''],['壁球','',''],['壁画','',''],['壁砖','',''],['壁立','',''],['壁立千仞','',''],['壁纸','',''],['壁虎','',''],['壁虱','',''],['壁钱','',''],['壁龛','',''],['壅土','',''],['壅塞','',''],['壅穆不争','',''],['壑沟','',''],['壑谷','',''],['壕沟','',''],['壤土','',''],['士丹利','',''],['士为知己者死','',''],['士人','',''],['士兵','',''],['士力架','',''],['士卒','',''],['士可杀不可辱','',''],['士大夫','',''],['士女','',''],['士子','',''],['士学位','',''],['士官','',''],['士师记','',''],['士敏土','',''],['士族','',''],['士林','',''],['士林区','',''],['士死知己','',''],['士民','',''],['士气','',''],['士绅','',''],['士饱马腾','',''],['壬午','',''],['壬子','',''],['壬寅','',''],['壬戌','',''],['壬申','',''],['壬辰','',''],['壬辰倭乱','',''],['壮丁','',''],['壮丽','',''],['壮丽堂皇','',''],['壮举','',''],['壮健','',''],['壮围','',''],['壮围乡','',''],['壮士','',''],['壮士断腕','',''],['壮士解腕','',''],['壮大','',''],['壮实','',''],['壮工','',''],['壮年','',''],['壮心','',''],['壮心不已','',''],['壮志','',''],['壮志凌云','',''],['壮志未酬','',''],['壮戏','',''],['壮气吞牛','',''],['壮烈','',''],['壮的','',''],['壮硕','',''],['壮美','',''],['壮胆','',''],['壮苗','',''],['壮行','',''],['壮观','',''],['壮语','',''],['壮起胆子','',''],['壮锦','',''],['壮阔','',''],['壮阳剂','',''],['声东击西','',''],['声乐','',''],['声乐家','',''],['声价','',''],['声价十倍','',''],['声光','',''],['声势','',''],['声势汹汹','',''],['声势浩大','',''],['声区','',''],['声卡','',''],['声压','',''],['声叫','',''],['声名','',''],['声名大振','',''],['声名大震','',''],['声名狼籍','',''],['声名狼藉','',''],['声名鹊起','',''],['声吞气忍','',''],['声呐','',''],['声响','',''],['声嘶力竭','',''],['声囊','',''],['声声','',''],['声威','',''],['声威大震','',''],['声学','',''],['声学家','',''],['声带','',''],['声应气求','',''],['声张','',''],['声形','',''],['声律','',''],['声急','',''],['声息','',''],['声情并茂','',''],['声扬','',''],['声押','',''],['声振林大','',''],['声控','',''],['声援','',''],['声效','',''],['声旁','',''],['声旁字','',''],['声旁错误','',''],['声明','',''],['声明书','',''],['声明者','',''],['声望','',''],['声母','',''],['声气','',''],['声气相投','',''],['声气相求','',''],['声求气应','',''],['声波','',''],['声波定位','',''],['声波纹','',''],['声泪俱下','',''],['声浪','',''],['声源','',''],['声电','',''],['声磬同音','',''],['声称','',''],['声类系统','',''],['声级','',''],['声纳','',''],['声能','',''],['声能学','',''],['声腔','',''],['声色','',''],['声色俱厉','',''],['声色场所','',''],['声色犬马','',''],['声色狗马','',''],['声觉','',''],['声言','',''],['声誉','',''],['声誉坏','',''],['声誉好','',''],['声讨','',''],['声语','',''],['声说','',''],['声请','',''],['声调','',''],['声调的调值','',''],['声调语言','',''],['声调轮廓','',''],['声谱','',''],['声象','',''],['声辩','',''],['声迹','',''],['声速','',''],['声道','',''],['声部','',''],['声量','',''],['声门','',''],['声闻','',''],['声闻过情','',''],['声闻远播','',''],['声霸卡','',''],['声音','',''],['声音大','',''],['声音笑貌','',''],['声韵','',''],['声韵学','',''],['声频','',''],['壳儿','',''],['壳子','',''],['壳幔','',''],['壳斗','',''],['壳牌','',''],['壳牌公司','',''],['壳状','',''],['壳菜','',''],['壳虫','',''],['壳贝','',''],['壳质','',''],['壳郎猪','',''],['壶中','',''],['壶中日月','',''],['壶嘴','',''],['壶浆塞道','',''],['壶里乾坤','',''],['壶铃','',''],['壹套','',''],['壹败涂地','',''],['处世','',''],['处世之道','',''],['处世原则','',''],['处世哲学','',''],['处世态度','',''],['处之','',''],['处之泰然','',''],['处事','',''],['处事原则','',''],['处于','',''],['处于优势','',''],['处于领先地位','',''],['处以','',''],['处决','',''],['处分','',''],['处刑','',''],['处去','',''],['处在','',''],['处堂燕雀','',''],['处境','',''],['处士','',''],['处处','',''],['处女','',''],['处女似','',''],['处女作','',''],['处女地','',''],['处女座','',''],['处女膜','',''],['处女航','',''],['处子','',''],['处子秀','',''],['处安思危','',''],['处室','',''],['处心积虑','',''],['处所','',''],['处斩','',''],['处方','',''],['处死','',''],['处死刑','',''],['处治','',''],['处理','',''],['处理不当','',''],['处理品','',''],['处理器','',''],['处理意见','',''],['处理机','',''],['处理系统','',''],['处理者','',''],['处理能力','',''],['处理问题','',''],['处男','',''],['处私刑','',''],['处级','',''],['处绞刑','',''],['处罚','',''],['处罚者','',''],['处罚金','',''],['处置','',''],['处身','',''],['处长','',''],['处高鹜远','',''],['备下','',''],['备不住','',''],['备中','',''],['备件','',''],['备份','',''],['备位充数','',''],['备军','',''],['备办','',''],['备取','',''],['备受','',''],['备员','',''],['备品','',''],['备好','',''],['备妥','',''],['备存','',''],['备尝艰苦','',''],['备尝辛苦','',''],['备忘','',''],['备忘录','',''],['备悉','',''],['备战','',''],['备抵','',''],['备换服装','',''],['备换鞋','',''],['备料','',''],['备有','',''],['备查','',''],['备案','',''],['备注','',''],['备用','',''],['备用二级头呼吸器','',''],['备用品','',''],['备用环','',''],['备用轮胎','',''],['备用金','',''],['备置','',''],['备考','',''],['备而不用','',''],['备耕','',''],['备胎','',''],['备至','',''],['备荒','',''],['备课','',''],['备货','',''],['备足','',''],['备选','',''],['备餐','',''],['备饭','',''],['备马','',''],['备齐','',''],['复习','',''],['复习资料','',''],['复交','',''],['复仇','',''],['复仇主义','',''],['复仇者','',''],['复仇雪耻','',''],['复任','',''],['复会','',''],['复位','',''],['复信','',''],['复修','',''],['复健','',''],['复元','',''],['复元音','',''],['复共轭','',''],['复关','',''],['复兴','',''],['复兴乡','',''],['复兴党','',''],['复兴时代','',''],['复兴者','',''],['复兴门','',''],['复写','',''],['复写簿','',''],['复写纸','',''],['复出','',''],['复击','',''],['复函','',''],['复分解反应','',''],['复刊','',''],['复利','',''],['复制','',''],['复制品','',''],['复制器','',''],['复制本','',''],['复加','',''],['复印','',''],['复印件','',''],['复印机','',''],['复印纸','',''],['复原','',''],['复发','',''],['复变','',''],['复变函数','',''],['复变函数论','',''],['复古','',''],['复古会','',''],['复句','',''],['复叶','',''],['复合','',''],['复合体','',''],['复合元音','',''],['复合函数','',''],['复合判断','',''],['复合字','',''],['复合弓','',''],['复合材料','',''],['复合母音','',''],['复合纤维','',''],['复合肥料','',''],['复合词','',''],['复合词素词','',''],['复合量词','',''],['复名数','',''],['复听','',''],['复吸','',''],['复员','',''],['复员军人','',''],['复员证','',''],['复命','',''],['复唱句','',''],['复圆','',''],['复地','',''],['复壮','',''],['复大','',''],['复姓','',''],['复婚','',''],['复子明辟','',''],['复学','',''],['复审','',''],['复工','',''],['复平面','',''],['复建','',''],['复式','',''],['复式教学','',''],['复式犁','',''],['复式编制','',''],['复归','',''],['复得','',''],['复折','',''],['复指','',''],['复指成分','',''],['复摆','',''],['复数','',''],['复数域','',''],['复数平面','',''],['复数形式','',''],['复方','',''],['复旦','',''],['复旦大学','',''],['复旧','',''],['复明','',''],['复本','',''],['复本位制','',''],['复杂','',''],['复杂劳动','',''],['复杂化','',''],['复杂多变','',''],['复杂度','',''],['复杂度理论','',''],['复杂性','',''],['复杂系统','',''],['复查','',''],['复核','',''],['复根','',''],['复殖吸虫','',''],['复殖目','',''],['复比','',''],['复活','',''],['复活的军团','',''],['复活节岛','',''],['复活赛','',''],['复燃','',''],['复现','',''],['复生','',''],['复电','',''],['复白','',''],['复盐','',''],['复盖','',''],['复眼','',''],['复礼克己','',''],['复社','',''],['复种','',''],['复种指数','',''],['复种面积','',''],['复算','',''],['复籍','',''],['复线','',''],['复耕','',''],['复职','',''],['复色光','',''],['复苏','',''],['复萌','',''],['复视','',''],['复议','',''],['复讼','',''],['复评','',''],['复诊','',''],['复试','',''],['复读','',''],['复读生','',''],['复课','',''],['复调音乐','',''],['复赛','',''],['复蹈其辙','',''],['复蹈前辙','',''],['复转','',''],['复辅音','',''],['复辟','',''],['复返','',''],['复迭','',''],['复述','',''],['复选','',''],['复选框','',''],['复醒','',''],['复阅','',''],['复音','',''],['复音形','',''],['复音词','',''],['复韵母','',''],['复驳','',''],['夏五郭公','',''],['夏代','',''],['夏令','',''],['夏令时','',''],['夏令营','',''],['夏侯','',''],['夏候鸟','',''],['夏初','',''],['夏利','',''],['夏历','',''],['夏商周','',''],['夏士莲','',''],['夏天','',''],['夏威夷','',''],['夏威夷岛','',''],['夏威夷州','',''],['夏威夷火山国家公园','',''],['夏娃','',''],['夏季','',''],['夏尔巴人','',''],['夏州','',''],['夏布','',''],['夏收','',''],['夏收夏种','',''],['夏敬渠','',''],['夏文化','',''],['夏日','',''],['夏日可畏','',''],['夏时制','',''],['夏朝','',''],['夏枯草','',''],['夏正民','',''],['夏洛克','',''],['夏洛特','',''],['夏洛特・勃良特','',''],['夏洛特敦','',''],['夏洛特阿马利亚','',''],['夏炉冬扇','',''],['夏熟','',''],['夏熟作物','',''],['夏王朝','',''],['夏目漱石','',''],['夏眠','',''],['夏禹','',''],['夏种','',''],['夏管','',''],['夏粮','',''],['夏耘','',''],['夏至点','',''],['夏至线','',''],['夏至草','',''],['夏草','',''],['夏虫不可以语冰','',''],['夏虫不可语冰','',''],['夏虫朝菌','',''],['夏虫疑冰','',''],['夏衍','',''],['夏衣','',''],['夏装','',''],['夏锄','',''],['夏长','',''],['夏雨雨人','',''],['夏黄公','',''],['夔夔','',''],['夔州','',''],['夔纹','',''],['夔龙礼乐','',''],['夕幕','',''],['夕惕若厉','',''],['夕拾','',''],['夕烟','',''],['夕照','',''],['夕阳','',''],['夕阳产业','',''],['夕阳工业','',''],['夕阳西下','',''],['外丹','',''],['外乡','',''],['外乡人','',''],['外事','',''],['外事处','',''],['外事活动','',''],['外事知识','',''],['外交','',''],['外交上','',''],['外交事务','',''],['外交代表','',''],['外交关系','',''],['外交关系理事会','',''],['外交史','',''],['外交团','',''],['外交大臣','',''],['外交学院','',''],['外交官','',''],['外交家','',''],['外交庇护','',''],['外交手腕','',''],['外交政策','',''],['外交机构','',''],['外交活动','',''],['外交特权','',''],['外交界','',''],['外交谋略','',''],['外交辞令','',''],['外交风波','',''],['外亲内疏','',''],['外人','',''],['外企','',''],['外传','',''],['外伤','',''],['外伤学','',''],['外伸','',''],['外侧','',''],['外侧沟','',''],['外侧裂','',''],['外侧裂周区','',''],['外侧裂周围','',''],['外侨','',''],['外侮','',''],['外借','',''],['外债','',''],['外倾','',''],['外八字脚','',''],['外八字腿','',''],['外公','',''],['外公切线','',''],['外典写作','',''],['外军','',''],['外出','',''],['外出用','',''],['外出血','',''],['外出访问','',''],['外分泌','',''],['外分泌腺','',''],['外切多边形','',''],['外刚内柔','',''],['外力','',''],['外立面','',''],['外办','',''],['外功','',''],['外加','',''],['外加剂','',''],['外加附件','',''],['外务','',''],['外务员','',''],['外务省','',''],['外务部','',''],['外劳','',''],['外勤','',''],['外包','',''],['外包装','',''],['外化','',''],['外区','',''],['外协','',''],['外单位','',''],['外卖','',''],['外厂','',''],['外厕','',''],['外县','',''],['外史','',''],['外号','',''],['外合里应','',''],['外向','',''],['外向型','',''],['外向型经济','',''],['外听道','',''],['外商','',''],['外商投资企业','',''],['外商独资企业','',''],['外商直接投资','',''],['外因','',''],['外因论','',''],['外围','',''],['外国','',''],['外国专家','',''],['外国产','',''],['外国人','',''],['外国人居住证明','',''],['外国公司','',''],['外国化','',''],['外国商人','',''],['外国媒体','',''],['外国投资','',''],['外国投资者','',''],['外国旅游者','',''],['外国电影','',''],['外国血统','',''],['外国评论','',''],['外国话','',''],['外国语','',''],['外国货','',''],['外国资本','',''],['外圆内方','',''],['外圈','',''],['外在','',''],['外在超越','',''],['外地','',''],['外地人','',''],['外场','',''],['外型','',''],['外城','',''],['外埔','',''],['外埔乡','',''],['外域','',''],['外埠','',''],['外墙','',''],['外壁','',''],['外壳','',''],['外太空','',''],['外头','',''],['外夺','',''],['外套','',''],['外姓','',''],['外婆','',''],['外媒','',''],['外子','',''],['外存','',''],['外孙','',''],['外孙女','',''],['外孙女儿','',''],['外孙子','',''],['外客','',''],['外室','',''],['外家','',''],['外宽内忌','',''],['外宽内深','',''],['外宾','',''],['外宿','',''],['外寄生','',''],['外寇','',''],['外小腿','',''],['外层','',''],['外层空间','',''],['外屋','',''],['外展','',''],['外展神经','',''],['外岛','',''],['外岸','',''],['外巧内嫉','',''],['外差','',''],['外差式','',''],['外币','',''],['外币流通','',''],['外市','',''],['外带','',''],['外延','',''],['外开','',''],['外引内联','',''],['外弛','',''],['外弦','',''],['外强中干','',''],['外形','',''],['外形上','',''],['外征','',''],['外径','',''],['外御其侮','',''],['外心','',''],['外快','',''],['外患','',''],['外愚内智','',''],['外感','',''],['外戚','',''],['外手','',''],['外扬','',''],['外挂程式','',''],['外接','',''],['外接圆','',''],['外推','',''],['外推法','',''],['外插法','',''],['外援','',''],['外搭程式','',''],['外敌','',''],['外教','',''],['外敷','',''],['外文','',''],['外文版','',''],['外文系','',''],['外斜肌','',''],['外方','',''],['外族','',''],['外星','',''],['外星人','',''],['外显','',''],['外景','',''],['外来','',''],['外来人','',''],['外来干涉','',''],['外来成语','',''],['外来投资','',''],['外来物','',''],['外来物种','',''],['外来者','',''],['外来词','',''],['外来语','',''],['外来货','',''],['外果皮','',''],['外柔内刚','',''],['外查','',''],['外校','',''],['外框','',''],['外欠','',''],['外比','',''],['外气层','',''],['外水','',''],['外汇','',''],['外汇储备','',''],['外汇券','',''],['外汇市场','',''],['外汇资金','',''],['外沿','',''],['外泄','',''],['外洋','',''],['外活','',''],['外流','',''],['外海','',''],['外渗','',''],['外港','',''],['外源','',''],['外溢','',''],['外滩','',''],['外激素','',''],['外焰','',''],['外照射','',''],['外环线','',''],['外生','',''],['外甥','',''],['外甥女','',''],['外甥女婿','',''],['外甥媳妇','',''],['外用','',''],['外电','',''],['外电路','',''],['外界','',''],['外界人士','',''],['外痔','',''],['外皮','',''],['外盖','',''],['外相','',''],['外省','',''],['外看','',''],['外眼角','',''],['外码','',''],['外祖','',''],['外祖母','',''],['外祖父','',''],['外祸','',''],['外科','',''],['外科医生','',''],['外科学','',''],['外科手术','',''],['外积','',''],['外稃','',''],['外空','',''],['外籍','',''],['外籍劳工','',''],['外籍华人','',''],['外线','',''],['外经','',''],['外经部','',''],['外罩','',''],['外翻','',''],['外耳','',''],['外耳道','',''],['外耳门','',''],['外肾','',''],['外胎','',''],['外胚叶','',''],['外胚层','',''],['外舅','',''],['外蒙','',''],['外蒙古','',''],['外行','',''],['外行人','',''],['外行星','',''],['外行看热闹','',''],['外衣','',''],['外表','',''],['外表上','',''],['外袍','',''],['外观','',''],['外观上','',''],['外观设计','',''],['外角','',''],['外设','',''],['外话','',''],['外语','',''],['外调','',''],['外貌','',''],['外财','',''],['外货','',''],['外质膜','',''],['外购','',''],['外贸','',''],['外贸体制','',''],['外贸出口','',''],['外贸逆差','',''],['外贸部','',''],['外贸顺差','',''],['外贾','',''],['外资','',''],['外资企业','',''],['外路','',''],['外踝','',''],['外转','',''],['外轮','',''],['外边','',''],['外边儿','',''],['外迁','',''],['外运','',''],['外送','',''],['外逃','',''],['外遇','',''],['外道','',''],['外邦人','',''],['外部','',''],['外部环境','',''],['外部联系','',''],['外部设备','',''],['外部连接','',''],['外部链接','',''],['外郭城','',''],['外钞','',''],['外销','',''],['外销量','',''],['外错角','',''],['外长','',''],['外间','',''],['外阴','',''],['外阴部','',''],['外院','',''],['外露','',''],['外面','',''],['外物','',''],['外面儿光','',''],['外面性','',''],['外项','',''],['外首','',''],['外骛','',''],['外骨骼','',''],['外高加索','',''],['外高桥','',''],['外鹜','',''],['夙世冤家','',''],['夙仇','',''],['夙兴夜寐','',''],['夙夜','',''],['夙夜不懈','',''],['夙夜为媒','',''],['夙夜匪懈','',''],['夙夜在公','',''],['夙嫌','',''],['夙心往志','',''],['夙志','',''],['夙愿','',''],['夙愿以偿','',''],['夙愿得偿','',''],['夙敌','',''],['夙日','',''],['夙昔','',''],['夙诺','',''],['多一事不如少一事','',''],['多一事不如省一事','',''],['多一倍','',''],['多一半','',''],['多万','',''],['多上','',''],['多个','',''],['多中心','',''],['多为','',''],['多久','',''],['多么','',''],['多义','',''],['多义关系','',''],['多义字','',''],['多义性','',''],['多义词','',''],['多了','',''],['多事','',''],['多事之秋','',''],['多于','',''],['多亏','',''],['多云','',''],['多云转阴','',''],['多交','',''],['多产','',''],['多产性','',''],['多人','',''],['多人会谈室','',''],['多人对策','',''],['多付','',''],['多以','',''],['多价','',''],['多任务','',''],['多伊尔','',''],['多会儿','',''],['多伦多','',''],['多位','',''],['多位数','',''],['多余','',''],['多佛','',''],['多佛尔','',''],['多例','',''],['多侧面','',''],['多俊','',''],['多倍体','',''],['多倍体植物','',''],['多值','',''],['多值函数','',''],['多做','',''],['多做实事','',''],['多元','',''],['多元不饱和脂肪酸','',''],['多元化','',''],['多元宇宙','',''],['多元性','',''],['多元文化主义','',''],['多元论','',''],['多元酯','',''],['多党','',''],['多党制','',''],['多党合作制','',''],['多党选举','',''],['多凶少吉','',''],['多分','',''],['多列','',''],['多则','',''],['多利','',''],['多力多滋','',''],['多办','',''],['多办一些实事','',''],['多办实事','',''],['多功','',''],['多功能','',''],['多功能表','',''],['多加','',''],['多加小心','',''],['多动','',''],['多动症','',''],['多助','',''],['多劳','',''],['多劳多得','',''],['多半','',''],['多占','',''],['多即','',''],['多卷','',''],['多历年所','',''],['多发','',''],['多发性硬化症','',''],['多发病','',''],['多变','',''],['多变化','',''],['多口','',''],['多口相声','',''],['多口词','',''],['多可','',''],['多台','',''],['多叶','',''],['多吃多占','',''],['多名','',''],['多向','',''],['多含','',''],['多听','',''],['多咱','',''],['多哈','',''],['多哈回合','',''],['多嘴','',''],['多嘴多舌','',''],['多嘴饶舌','',''],['多国','',''],['多国公司','',''],['多国籍','',''],['多址','',''],['多块','',''],['多塞','',''],['多士','',''],['多处','',''],['多多','',''],['多多保重','',''],['多多少少','',''],['多多益办','',''],['多多益善','',''],['多多马','',''],['多大','',''],['多大点事','',''],['多天','',''],['多头','',''],['多好','',''],['多如牛毛','',''],['多妻','',''],['多妻制','',''],['多姿','',''],['多姿多彩','',''],['多娇','',''],['多媒体','',''],['多媒体资讯','',''],['多嫌','',''],['多子','',''],['多子多福','',''],['多孔','',''],['多孔动物','',''],['多孔性','',''],['多孔材料','',''],['多孔蕈','',''],['多字节','',''],['多学科','',''],['多宝鱼','',''],['多家','',''],['多宽','',''],['多寡','',''],['多对','',''],['多对一','',''],['多少','',''],['多少年','',''],['多少年如一日','',''],['多少年来','',''],['多少有些','',''],['多尔','',''],['多尔衮','',''],['多层','',''],['多层复','',''],['多层复迭','',''],['多层大厦','',''],['多层彩色感光材料','',''],['多层材','',''],['多层次','',''],['多层次分析模型','',''],['多层面','',''],['多山','',''],['多山地区','',''],['多岁','',''],['多峰','',''],['多工','',''],['多工作业','',''],['多工化','',''],['多工器','',''],['多工运作','',''],['多巧','',''],['多巴胺','',''],['多幕剧','',''],['多平台','',''],['多年','',''],['多年来','',''],['多年生','',''],['多广','',''],['多弹头','',''],['多形','',''],['多形式','',''],['多形核白细胞','',''],['多彩','',''],['多彩多姿','',''],['多得','',''],['多得多','',''],['多得是','',''],['多心','',''],['多快','',''],['多快好省','',''],['多思','',''],['多情','',''],['多愁','',''],['多愁善感','',''],['多愁多病','',''],['多感','',''],['多手多脚','',''],['多才','',''],['多才多艺','',''],['多报','',''],['多拿','',''],['多指','',''],['多收','',''],['多放','',''],['多数','',''],['多数人','',''],['多数党','',''],['多数决','',''],['多文为富','',''],['多方','',''],['多方位','',''],['多方面','',''],['多旋律','',''],['多日','',''],['多日赛','',''],['多早晚','',''],['多时','',''],['多明尼加','',''],['多明尼加共和国','',''],['多星','',''],['多普勒','',''],['多普勒效应','',''],['多普达','',''],['多晶体','',''],['多晶硅','',''],['多月','',''],['多材多艺','',''],['多束','',''],['多条','',''],['多极','',''],['多极化','',''],['多果实','',''],['多树木','',''],['多样','',''],['多样化','',''],['多样性','',''],['多根','',''],['多栽花少栽刺','',''],['多档','',''],['多模','',''],['多模光纤','',''],['多模块','',''],['多次','',''],['多此一举','',''],['多毛','',''],['多民族','',''],['多民族国家','',''],['多氯联苯','',''],['多水','',''],['多水分','',''],['多汁','',''],['多汁液','',''],['多沼地','',''],['多沼泽','',''],['多波段','',''],['多洞','',''],['多派','',''],['多渠道','',''],['多源','',''],['多灯','',''],['多灾多难','',''],['多点','',''],['多烦','',''],['多特蒙德','',''],['多瑙','',''],['多瑙河','',''],['多瓣蒜','',''],['多瓦','',''],['多生','',''],['多用','',''],['多用户','',''],['多用途','',''],['多留','',''],['多疑','',''],['多病','',''],['多的','',''],['多目的','',''],['多相','',''],['多看','',''],['多石','',''],['多礼','',''],['多神','',''],['多神教','',''],['多神论','',''],['多神论者','',''],['多福','',''],['多种','',''],['多种多样','',''],['多种子','',''],['多种形式','',''],['多种经营','',''],['多种语言','',''],['多种语言支持','',''],['多站','',''],['多站地址','',''],['多端','',''],['多端中继器','',''],['多端寡要','',''],['多算','',''],['多管','',''],['多管闲事','',''],['多篇','',''],['多米','',''],['多米尼加','',''],['多米尼加联邦','',''],['多米诺','',''],['多米诺骨牌','',''],['多类','',''],['多粒','',''],['多粒子','',''],['多粒子系统','',''],['多糖','',''],['多糖症','',''],['多糖类','',''],['多累','',''],['多级','',''],['多级火箭','',''],['多线程','',''],['多细','',''],['多细胞','',''],['多细胞生物','',''],['多给','',''],['多维','',''],['多美','',''],['多者','',''],['多而','',''],['多聚糖','',''],['多育','',''],['多肽','',''],['多肽连','',''],['多胎','',''],['多胎妊娠','',''],['多胚生殖','',''],['多胞形','',''],['多脂','',''],['多脂肪','',''],['多腺染色体','',''],['多臂机','',''],['多至','',''],['多舛','',''],['多色','',''],['多艺','',''],['多节','',''],['多花','',''],['多菲什','',''],['多蒸气','',''],['多蒸汽','',''],['多藏厚亡','',''],['多虫','',''],['多血性','',''],['多行不义必自毙','',''],['多见','',''],['多见于','',''],['多角','',''],['多角体','',''],['多角形','',''],['多解','',''],['多言','',''],['多言或中','',''],['多言数穷','',''],['多言繁称','',''],['多计','',''],['多许少与','',''],['多词','',''],['多话','',''],['多语','',''],['多语言','',''],['多调性','',''],['多谋善断','',''],['多谢','',''],['多谢光临','',''],['多财善贾','',''],['多贱寡贵','',''],['多费','',''],['多赚','',''],['多趣','',''],['多足','',''],['多足动物','',''],['多足类','',''],['多路','',''],['多路径','',''],['多路通信','',''],['多轨','',''],['多轮','',''],['多边','',''],['多边协定','',''],['多边合作','',''],['多边形','',''],['多边条约','',''],['多边贸易','',''],['多边贸易谈判','',''],['多达','',''],['多远','',''],['多退','',''],['多道','',''],['多那太罗','',''],['多部','',''],['多酸','',''],['多醣','',''],['多采','',''],['多重','',''],['多重国籍','',''],['多重性','',''],['多量','',''],['多金属','',''],['多针刺','',''],['多钩','',''],['多钱善贾','',''],['多铧犁','',''],['多销','',''],['多长','',''],['多闻天','',''],['多闻强记','',''],['多闻而志之','',''],['多闻阙疑','',''],['多难','',''],['多难兴邦','',''],['多雨','',''],['多雪','',''],['多雾','',''],['多面','',''],['多面体','',''],['多面手','',''],['多面角','',''],['多音','',''],['多音多义字','',''],['多音字','',''],['多音节','',''],['多音节词','',''],['多页','',''],['多项','',''],['多项式','',''],['多项式方程','',''],['多项式方程组','',''],['多顾虑','',''],['多领','',''],['多频','',''],['多风','',''],['多食症','',''],['多香果','',''],['多高','',''],['多齿','',''],['夜不归宿','',''],['夜不成眠','',''],['夜不能寐','',''],['夜不闭户','',''],['夜以接日','',''],['夜以继日','',''],['夜以继昼','',''],['夜作','',''],['夜儿个','',''],['夜光','',''],['夜光云','',''],['夜光虫','',''],['夜光表','',''],['夜分','',''],['夜勤','',''],['夜半','',''],['夜半三更','',''],['夜叉','',''],['夜场','',''],['夜壶','',''],['夜夜','',''],['夜大','',''],['夜大学','',''],['夜宵','',''],['夜宵儿','',''],['夜尿症','',''],['夜工','',''],['夜市','',''],['夜幕','',''],['夜幕降临','',''],['夜店','',''],['夜总会','',''],['夜战','',''],['夜招待酒会','',''],['夜明珠','',''],['夜晚','',''],['夜景','',''],['夜曲','',''],['夜月花朝','',''],['夜来','',''],['夜来香','',''],['夜枭','',''],['夜校','',''],['夜消','',''],['夜深','',''],['夜深人静','',''],['夜游','',''],['夜游神','',''],['夜猫','',''],['夜猫子','',''],['夜班','',''],['夜生活','',''],['夜的','',''],['夜盗','',''],['夜盲','',''],['夜盲症','',''],['夜短','',''],['夜礼服','',''],['夜神仙','',''],['夜祷','',''],['夜空','',''],['夜航','',''],['夜色','',''],['夜色苍茫','',''],['夜莺','',''],['夜蛾','',''],['夜行','',''],['夜行军','',''],['夜行性','',''],['夜行昼伏','',''],['夜行被绣','',''],['夜袭','',''],['夜视','',''],['夜视仪','',''],['夜视器材','',''],['夜视技术','',''],['夜视镜','',''],['夜警','',''],['夜话','',''],['夜读','',''],['夜读拾零','',''],['夜课','',''],['夜谈','',''],['夜贼','',''],['夜车','',''],['夜郎','',''],['夜郎自大','',''],['夜里','',''],['夜长','',''],['夜长梦多','',''],['夜闭','',''],['夜间部','',''],['夜阑','',''],['夜阑人静','',''],['夜阑珊','',''],['夜雨对床','',''],['夜雾','',''],['夜静更深','',''],['夜静更长','',''],['夜静更阑','',''],['夜餐','',''],['夜饭','',''],['夜香木','',''],['夜鸟','',''],['夜鹭','',''],['夜鹰','',''],['够不着','',''],['够了','',''],['够交情','',''],['够做','',''],['够到','',''],['够刺激','',''],['够劲儿','',''],['够受','',''],['够受的','',''],['够呛','',''],['够味','',''],['够味儿','',''],['够啦','',''],['够多','',''],['够大','',''],['够得着','',''],['够忍','',''],['够意思','',''],['够戗','',''],['够数','',''],['够时','',''],['够朋友','',''],['够本','',''],['够标准','',''],['够格','',''],['够用','',''],['够瞧','',''],['够瞧的','',''],['够量','',''],['夤夜','',''],['夤缘','',''],['夤缘攀附','',''],['夥伴','',''],['夥计','',''],['夥颐','',''],['大一','',''],['大一些','',''],['大一统','',''],['大一统志','',''],['大丁草','',''],['大丈夫','',''],['大丈夫能屈能伸','',''],['大三','',''],['大三元','',''],['大三和弦','',''],['大三度','',''],['大不一样','',''],['大不列蹀','',''],['大不列颠','',''],['大不列颠岛','',''],['大不如前','',''],['大不相同','',''],['大不里士','',''],['大不韪','',''],['大专','',''],['大专生','',''],['大专院校','',''],['大业','',''],['大丛林','',''],['大东','',''],['大东亚共荣圈','',''],['大个','',''],['大个儿','',''],['大个子','',''],['大中企业','',''],['大中华区','',''],['大中型','',''],['大中型项目','',''],['大中城市','',''],['大中学校','',''],['大中学生','',''],['大丸药','',''],['大为','',''],['大为不满','',''],['大为吃惊','',''],['大为惊异','',''],['大为改观','',''],['大为激动','',''],['大主教','',''],['大丽花','',''],['大举','',''],['大久保','',''],['大久保利通','',''],['大义','',''],['大义凛然','',''],['大义灭亲','',''],['大乌苏里岛','',''],['大乌鸦','',''],['大乘','',''],['大书','',''],['大书特书','',''],['大事','',''],['大事不糊涂','',''],['大事化小','',''],['大事去矣','',''],['大事年表','',''],['大事纪','',''],['大事记','',''],['大二','',''],['大于','',''],['大五码','',''],['大五趾跳鼠','',''],['大五金','',''],['大亚湾','',''],['大亨','',''],['大人','',''],['大人不记小人过','',''],['大人先生','',''],['大人国','',''],['大人物','',''],['大人虎变','',''],['大仁大义','',''],['大仙','',''],['大仲马','',''],['大件','',''],['大众','',''],['大众传播','',''],['大众化','',''],['大众媒介','',''],['大众捷运','',''],['大众文化','',''],['大众文学','',''],['大众汽车','',''],['大伙','',''],['大伙儿','',''],['大会','',''],['大会堂','',''],['大会报告起草人','',''],['大伟','',''],['大伤元气','',''],['大伤脑筋','',''],['大伦敦地区','',''],['大伯','',''],['大伯子','',''],['大佐','',''],['大体','',''],['大体上','',''],['大体相当','',''],['大体而言','',''],['大体说来','',''],['大佛','',''],['大作','',''],['大佬','',''],['大使','',''],['大使级','',''],['大使馆','',''],['大侃','',''],['大侠','',''],['大便','',''],['大便干燥','',''],['大便秘结','',''],['大俄罗斯主义','',''],['大修','',''],['大修道院','',''],['大修道院长','',''],['大做','',''],['大做文章','',''],['大傻瓜','',''],['大儒','',''],['大元大一统志','',''],['大元帅','',''],['大先知书','',''],['大全','',''],['大公','',''],['大公司','',''],['大公国','',''],['大公国际','',''],['大公报','',''],['大公无私','',''],['大关节目','',''],['大兴','',''],['大兴土木','',''],['大兴安岭','',''],['大兴安岭山脉','',''],['大兴问罪之师','',''],['大兵','',''],['大兵团','',''],['大典','',''],['大内','',''],['大内乡','',''],['大写','',''],['大写字母','',''],['大写锁定','',''],['大军','',''],['大军区','',''],['大农园','',''],['大农场','',''],['大冲','',''],['大凡','',''],['大凡粗知','',''],['大出','',''],['大出其汗','',''],['大出血','',''],['大出风头','',''],['大刀','',''],['大刀会','',''],['大刀阔斧','',''],['大分县','',''],['大分子','',''],['大分界岭','',''],['大刑','',''],['大利','',''],['大利拉','',''],['大别山','',''],['大别山脉','',''],['大剌剌','',''],['大前提','',''],['大前题','',''],['大剪刀','',''],['大副','',''],['大力','',''],['大力加强','',''],['大力发展','',''],['大力士','',''],['大力开展','',''],['大力推广','',''],['大力提高','',''],['大力支持','',''],['大力水手','',''],['大力神','',''],['大劝脉','',''],['大办','',''],['大功','',''],['大功告成','',''],['大功毕成','',''],['大功率','',''],['大加','',''],['大加那利岛','',''],['大动','',''],['大动干戈','',''],['大动肝火','',''],['大动脉','',''],['大势','',''],['大势已去','',''],['大势所趋','',''],['大势至菩萨','',''],['大勇若怯','',''],['大包','',''],['大包大揽','',''],['大包干','',''],['大化','',''],['大化县','',''],['大匠不斫','',''],['大区','',''],['大千','',''],['大千世界','',''],['大半','',''],['大半截','',''],['大半辈子','',''],['大协作','',''],['大卖场','',''],['大卡','',''],['大卫','',''],['大卫・米利班德','',''],['大卫・艾登堡','',''],['大卫营和约','',''],['大印','',''],['大厂','',''],['大厂县','',''],['大厅','',''],['大厦','',''],['大厦将倾','',''],['大厦栋梁','',''],['大厨','',''],['大发','',''],['大发宏论','',''],['大发慈悲','',''],['大发雷霆','',''],['大叔','',''],['大受','',''],['大受欢迎','',''],['大变','',''],['大变动','',''],['大变革','',''],['大口','',''],['大口井','',''],['大口径','',''],['大口瓶','',''],['大只','',''],['大叫','',''],['大可不必','',''],['大叶性肺炎','',''],['大叶杨','',''],['大叶桉','',''],['大号','',''],['大司农','',''],['大司马','',''],['大吃','',''],['大吃一惊','',''],['大吃二喝','',''],['大吃大喝','',''],['大吃苦头','',''],['大合唱','',''],['大吉','',''],['大吉大利','',''],['大同乡','',''],['大同书','',''],['大同地区','',''],['大同小异','',''],['大同思想','',''],['大名鼎鼎','',''],['大后方','',''],['大吏','',''],['大君主','',''],['大吞噬细胞','',''],['大含细入','',''],['大吵大闹','',''],['大吹','',''],['大吹大擂','',''],['大吹法螺','',''],['大员','',''],['大呼小叫','',''],['大呼拉尔','',''],['大和','',''],['大哗','',''],['大哥','',''],['大哥大','',''],['大哭','',''],['大唐','',''],['大唐狄公案','',''],['大唐芙蓉园','',''],['大唐西域记','',''],['大喊','',''],['大喊大叫','',''],['大喜','',''],['大喜过望','',''],['大喝','',''],['大喝一声','',''],['大嗓','',''],['大嘴','',''],['大器','',''],['大器晚成','',''],['大噪','',''],['大嚷','',''],['大嚼','',''],['大四','',''],['大团圆','',''],['大团结','',''],['大园','',''],['大园乡','',''],['大国','',''],['大国主义','',''],['大国家党','',''],['大国沙文主义','',''],['大圆','',''],['大圆圈','',''],['大圣','',''],['大地','',''],['大地主','',''],['大地为席','',''],['大地之歌','',''],['大地回春','',''],['大地图','',''],['大地洞','',''],['大地测量','',''],['大地测量学','',''],['大地线','',''],['大地震','',''],['大场鸫','',''],['大坂','',''],['大坏蛋','',''],['大坑','',''],['大块','',''],['大块头','',''],['大块文章','',''],['大块朵颐','',''],['大坝','',''],['大型','',''],['大型企业','',''],['大型强子对撞机','',''],['大型机','',''],['大型项目','',''],['大城乡','',''],['大城市','',''],['大埔乡','',''],['大埤','',''],['大埤乡','',''],['大堂','',''],['大堆','',''],['大堆栈','',''],['大堡礁','',''],['大堤','',''],['大增','',''],['大壑','',''],['大声','',''],['大声一点','',''],['大声叫','',''],['大声喊叫','',''],['大声嚷','',''],['大声点','',''],['大声疾呼','',''],['大声笑','',''],['大声说','',''],['大声说话','',''],['大壶','',''],['大处','',''],['大处着眼','',''],['大处落墨','',''],['大夏','',''],['大外','',''],['大多','',''],['大多功能','',''],['大多数','',''],['大多数人','',''],['大多数情况下','',''],['大夥','',''],['大大','',''],['大大咧咧','',''],['大大小小','',''],['大大方方','',''],['大大落落','',''],['大大高于','',''],['大天使','',''],['大天幕','',''],['大夫','',''],['大失','',''],['大失人望','',''],['大失所望','',''],['大失败','',''],['大头','',''],['大头在后头','',''],['大头瘟','',''],['大头目','',''],['大头菜','',''],['大头贴','',''],['大头针','',''],['大头钉','',''],['大头鱼','',''],['大夼','',''],['大夼镇','',''],['大奖','',''],['大奖牌','',''],['大奖章','',''],['大奖赛','',''],['大套','',''],['大奸似忠','',''],['大好','',''],['大好事','',''],['大好形势','',''],['大好时光','',''],['大妈','',''],['大姐','',''],['大姑','',''],['大姑娘','',''],['大姑子','',''],['大姓','',''],['大姨','',''],['大姨妈','',''],['大姨子','',''],['大娘','',''],['大婶','',''],['大婶儿','',''],['大媒','',''],['大嫂','',''],['大字','',''],['大字报','',''],['大孝','',''],['大学','',''],['大学城','',''],['大学士','',''],['大学学科能力测验','',''],['大学本科','',''],['大学生','',''],['大学间','',''],['大学预科','',''],['大宅邸','',''],['大宇','',''],['大宇宙','',''],['大安乡','',''],['大安的列斯','',''],['大安的列斯群岛','',''],['大宗','',''],['大官','',''],['大宛','',''],['大宝','',''],['大客车','',''],['大宪章','',''],['大宴会','',''],['大家','',''],['大家伙儿','',''],['大家庭','',''],['大家闺秀','',''],['大家风范','',''],['大家鼠','',''],['大容量','',''],['大富大贵','',''],['大富翁','',''],['大富豪','',''],['大寨','',''],['大寮','',''],['大寮乡','',''],['大寺院','',''],['大将','',''],['大将军','',''],['大尉','',''],['大小','',''],['大小三度','',''],['大小不一','',''],['大小不等','',''],['大小便','',''],['大小写','',''],['大小姐','',''],['大小年','',''],['大小相当','',''],['大少爷','',''],['大尽','',''],['大局','',''],['大屏幕','',''],['大展','',''],['大展宏图','',''],['大屠杀','',''],['大屠杀事件','',''],['大屯火山','',''],['大山','',''],['大山小山','',''],['大山洞','',''],['大山猫','',''],['大山谷州立大学','',''],['大屿山','',''],['大岛','',''],['大峡谷','',''],['大川','',''],['大巢菜','',''],['大巧若拙','',''],['大已','',''],['大巴','',''],['大布','',''],['大帅','',''],['大帆船','',''],['大师','',''],['大师傅','',''],['大帐幕','',''],['大帐篷','',''],['大幅','',''],['大幅度','',''],['大干','',''],['大干物议','',''],['大年','',''],['大年夜','',''],['大庄园','',''],['大庄稼','',''],['大店','',''],['大度','',''],['大度包容','',''],['大度汪洋','',''],['大度豁达','',''],['大庭广众','',''],['大庸','',''],['大庾岭','',''],['大建','',''],['大开','',''],['大开斋','',''],['大开方便之门','',''],['大开眼界','',''],['大开绿灯','',''],['大弓','',''],['大弟','',''],['大张声势','',''],['大张挞伐','',''],['大张旗鼓','',''],['大形','',''],['大彻大悟','',''],['大得','',''],['大得以','',''],['大循环','',''],['大德','',''],['大忌','',''],['大志','',''],['大志若愚','',''],['大忙','',''],['大忙人','',''],['大快人心','',''],['大快朵颐','',''],['大怒','',''],['大总统','',''],['大恩','',''],['大恩大德','',''],['大恭','',''],['大患','',''],['大悦','',''],['大悬','',''],['大悲','',''],['大悲咒','',''],['大惊','',''],['大惊失色','',''],['大惊小怪','',''],['大惑','',''],['大惑不解','',''],['大意','',''],['大愚','',''],['大愚不灵','',''],['大愿地藏菩萨','',''],['大慈大悲','',''],['大慈恩寺','',''],['大憝','',''],['大戏','',''],['大成','',''],['大成功','',''],['大我','',''],['大战','',''],['大战略','',''],['大戟科','',''],['大户','',''],['大房','',''],['大手','',''],['大手大脚','',''],['大手笔','',''],['大才小用','',''],['大打出手','',''],['大扫除','',''],['大批','',''],['大批量','',''],['大把','',''],['大抓','',''],['大投资家','',''],['大抵','',''],['大拇哥','',''],['大拇指','',''],['大括号','',''],['大括弧','',''],['大拿','',''],['大指','',''],['大挫折','',''],['大捆','',''],['大捕头','',''],['大捷','',''],['大排档','',''],['大提','',''],['大提倡','',''],['大提琴','',''],['大提琴家','',''],['大提琴手','',''],['大搞','',''],['大搞特搞','',''],['大摆','',''],['大摇大摆','',''],['大操大办','',''],['大放光明','',''],['大放厥词','',''],['大放厥辞','',''],['大放异彩','',''],['大放悲声','',''],['大政','',''],['大政方针','',''],['大政翼賛会','',''],['大故','',''],['大敌','',''],['大敌当前','',''],['大教堂','',''],['大数','',''],['大数学家','',''],['大文蛤','',''],['大斋','',''],['大斋期','',''],['大斋节','',''],['大料','',''],['大斧','',''],['大方之家','',''],['大方向','',''],['大方广佛华严经','',''],['大方脉科','',''],['大旋涡','',''],['大族','',''],['大旗','',''],['大无畏','',''],['大日如来','',''],['大旨','',''],['大旱','',''],['大旱云霓','',''],['大旱望云霓','',''],['大明历','',''],['大星芹','',''],['大春','',''],['大昭寺','',''],['大是大非','',''],['大显威风','',''],['大显神通','',''],['大显身手','',''],['大智','',''],['大智如愚','',''],['大智慧','',''],['大智若愚','',''],['大曲','',''],['大曲酒','',''],['大月','',''],['大月支','',''],['大月氏','',''],['大有','',''],['大有人在','',''],['大有作为','',''],['大有可为','',''],['大有可观','',''],['大有好转','',''],['大有希望','',''],['大有径庭','',''],['大有文章','',''],['大有益处','',''],['大有裨益','',''],['大木片','',''],['大未必佳','',''],['大本','',''],['大本大宗','',''],['大本涅盘经','',''],['大本营','',''],['大札','',''],['大杀风景','',''],['大杂烩','',''],['大杂院','',''],['大杂院儿','',''],['大权','',''],['大权在握','',''],['大权旁落','',''],['大权独揽','',''],['大材小用','',''],['大村','',''],['大村乡','',''],['大杖则走小杖则受','',''],['大条','',''],['大杯','',''],['大板车','',''],['大林','',''],['大林镇','',''],['大枣','',''],['大枪','',''],['大柴旦','',''],['大柴旦行政区','',''],['大柴旦行政委员会','',''],['大柴旦镇','',''],['大树','',''],['大树乡','',''],['大树将军','',''],['大树菠萝','',''],['大校','',''],['大样','',''],['大根兰','',''],['大桅帆','',''],['大案','',''],['大案要案','',''],['大桥','',''],['大桶','',''],['大梁','',''],['大梦初醒','',''],['大检查','',''],['大棒','',''],['大棒政策','',''],['大椎穴','',''],['大楷','',''],['大楼','',''],['大概','',''],['大概其','',''],['大概是','',''],['大槌','',''],['大模型','',''],['大模大样','',''],['大款','',''],['大正','',''],['大步','',''],['大步流星','',''],['大步走','',''],['大武','',''],['大武乡','',''],['大武口','',''],['大殓','',''],['大段','',''],['大殿','',''],['大比','',''],['大比目鱼','',''],['大毛','',''],['大氅','',''],['大民主','',''],['大民族主义','',''],['大气','',''],['大气候','',''],['大气儿','',''],['大气光','',''],['大气压','',''],['大气压力','',''],['大气压强','',''],['大气圈','',''],['大气学','',''],['大气层','',''],['大气层核试验','',''],['大气暖化','',''],['大气污染','',''],['大气环流','',''],['大气监测','',''],['大气磅礴','',''],['大气科学','',''],['大氧吧','',''],['大水','',''],['大汉','',''],['大汉族主义','',''],['大汗','',''],['大汗淋漓','',''],['大江','',''],['大江健三郎','',''],['大江南北','',''],['大沙河','',''],['大沙漠','',''],['大河','',''],['大油','',''],['大治','',''],['大沽口炮台','',''],['大沽炮台','',''],['大沿','',''],['大沿帽','',''],['大法','',''],['大法官','',''],['大法小廉','',''],['大泽乡起义','',''],['大洋','',''],['大洋中脊','',''],['大洋型地壳','',''],['大洋彼岸','',''],['大洋洲','',''],['大洋洲人','',''],['大洋间','',''],['大洞','',''],['大洞受苦','',''],['大洞吃苦','',''],['大洞穴','',''],['大洞难补','',''],['大洪水','',''],['大洲','',''],['大流星','',''],['大浦洞','',''],['大浦洞二','',''],['大浦洞二号','',''],['大浪','',''],['大海','',''],['大海捞针','',''],['大海沟','',''],['大海龟','',''],['大润发','',''],['大混乱','',''],['大清','',''],['大清帝国','',''],['大清早','',''],['大渡口','',''],['大渡河','',''],['大港','',''],['大湄公河次区域','',''],['大湄公河次区域合作','',''],['大湖','',''],['大湖乡','',''],['大湖区','',''],['大溜','',''],['大溪','',''],['大溪豆干','',''],['大溪镇','',''],['大满贯','',''],['大漆','',''],['大演说','',''],['大漠','',''],['大漩涡','',''],['大潮','',''],['大澈大悟','',''],['大瀑布','',''],['大火','',''],['大火灾','',''],['大灭绝','',''],['大灯','',''],['大灶','',''],['大灾','',''],['大灾之年','',''],['大灾难','',''],['大炮','',''],['大炮打蚊子','',''],['大烟','',''],['大烟囱','',''],['大热','',''],['大烹五鼎','',''],['大煞风景','',''],['大熊座','',''],['大熊猫','',''],['大熔炉','',''],['大爆炸','',''],['大爆破','',''],['大爱','',''],['大父','',''],['大爷','',''],['大片','',''],['大牌','',''],['大牙','',''],['大牢','',''],['大牲畜','',''],['大特','',''],['大犬座','',''],['大狒狒','',''],['大狱','',''],['大猩猩','',''],['大猫熊','',''],['大猾','',''],['大率','',''],['大王','',''],['大玩','',''],['大环','',''],['大班','',''],['大球','',''],['大理岩','',''],['大理州','',''],['大理石','',''],['大理院','',''],['大生产运动','',''],['大用','',''],['大田作物','',''],['大田市','',''],['大田广域市','',''],['大甲','',''],['大甲镇','',''],['大男大女','',''],['大男子主义','',''],['大男子主义者','',''],['大男小女','',''],['大略','',''],['大疮','',''],['大病','',''],['大瘟热','',''],['大白','',''],['大白于天下','',''],['大白天','',''],['大白熊犬','',''],['大白菜','',''],['大白话','',''],['大白鲨','',''],['大白鼠','',''],['大百科全书','',''],['大的','',''],['大盆','',''],['大盐','',''],['大盖帽','',''],['大盘子','',''],['大直若屈','',''],['大相径庭','',''],['大眼','',''],['大眼睛','',''],['大眼角','',''],['大眼贼','',''],['大眼镜蛇','',''],['大石块','',''],['大砍刀','',''],['大砟','',''],['大破','',''],['大破坏','',''],['大破迷关','',''],['大碗','',''],['大礼','',''],['大礼堂','',''],['大礼拜','',''],['大礼服','',''],['大社','',''],['大社乡','',''],['大祥','',''],['大祭司','',''],['大祸','',''],['大祸临头','',''],['大福不再','',''],['大禹','',''],['大秋','',''],['大秋作物','',''],['大秦','',''],['大端','',''],['大笑','',''],['大笑声','',''],['大笑话','',''],['大笔','',''],['大笔一挥','',''],['大笔如椽','',''],['大笔钱','',''],['大笨象','',''],['大等高线','',''],['大箐山','',''],['大管','',''],['大箱','',''],['大篆','',''],['大篷车','',''],['大米','',''],['大类','',''],['大粒','',''],['大粪','',''],['大系','',''],['大系统','',''],['大紫荆勋章','',''],['大纛高牙','',''],['大红','',''],['大红大紫','',''],['大红鼻子','',''],['大约','',''],['大约摸','',''],['大纪元','',''],['大纪元时报','',''],['大纲','',''],['大绝灭','',''],['大统','',''],['大罢工','',''],['大群','',''],['大老','',''],['大老婆','',''],['大老板','',''],['大老粗','',''],['大老远','',''],['大考','',''],['大而','',''],['大而化之','',''],['大而无当','',''],['大而言之','',''],['大耳','',''],['大联盟','',''],['大聚会','',''],['大肆','',''],['大肆攻击','',''],['大肆鼓','',''],['大肆鼓噪','',''],['大肚','',''],['大肚乡','',''],['大肚子','',''],['大肚子痞','',''],['大肚子经济','',''],['大肠','',''],['大肠杆菌','',''],['大肠炎','',''],['大肠癌','',''],['大肠菌','',''],['大股东','',''],['大胆','',''],['大胆妄为','',''],['大胜','',''],['大胡','',''],['大胡蜂','',''],['大能','',''],['大脑','',''],['大脑死亡','',''],['大脑比喻','',''],['大脑炎','',''],['大脑皮层','',''],['大脑脚','',''],['大脖子病','',''],['大脚','',''],['大腕','',''],['大腹便便','',''],['大腹子','',''],['大腹贾','',''],['大腿','',''],['大腿骨','',''],['大臣','',''],['大自然','',''],['大致','',''],['大致说来','',''],['大舅','',''],['大舅子','',''],['大舌头','',''],['大般涅盘经','',''],['大舵手','',''],['大船','',''],['大节','',''],['大花瓶','',''],['大花脸','',''],['大苏打','',''],['大英博物馆','',''],['大英帝国','',''],['大英联合王国','',''],['大范围','',''],['大茴香','',''],['大茴香子','',''],['大草原','',''],['大荒','',''],['大获','',''],['大获全胜','',''],['大菜','',''],['大菱鲆','',''],['大萧条','',''],['大葱','',''],['大蒜','',''],['大蒜似','',''],['大蓟','',''],['大藏经','',''],['大虫','',''],['大虾','',''],['大蛇丸','',''],['大蜀','',''],['大蝾螈','',''],['大融炉','',''],['大螟','',''],['大行其道','',''],['大行政区','',''],['大行星','',''],['大街','',''],['大街小巷','',''],['大衣','',''],['大衣箱','',''],['大袋','',''],['大袋子','',''],['大袋鼠','',''],['大裂谷','',''],['大褂','',''],['大襟','',''],['大西','',''],['大西北','',''],['大西国','',''],['大西庇阿','',''],['大西洋','',''],['大西洋中脊','',''],['大西洋国','',''],['大西洋地区','',''],['大西洋宪章','',''],['大西洋洋中脊','',''],['大西洋联盟','',''],['大要','',''],['大观','',''],['大观园','',''],['大规模','',''],['大规模杀伤性武器','',''],['大解','',''],['大言','',''],['大言不惭','',''],['大言相骇','',''],['大计','',''],['大讲','',''],['大论','',''],['大词','',''],['大话','',''],['大话骰','',''],['大课','',''],['大调','',''],['大调动','',''],['大谈','',''],['大谈特谈','',''],['大谎','',''],['大谬','',''],['大谬不然','',''],['大谱儿','',''],['大豆','',''],['大豆胶','',''],['大豆蚜虫','',''],['大象','',''],['大财主','',''],['大贤','',''],['大贤虎变','',''],['大败','',''],['大货车','',''],['大贱卖','',''],['大费周章','',''],['大资产阶级','',''],['大赚','',''],['大赛','',''],['大赦','',''],['大赦国际','',''],['大起大落','',''],['大趋势','',''],['大跃进','',''],['大跌','',''],['大跌市','',''],['大路','',''],['大路活','',''],['大路货','',''],['大踏步','',''],['大车','',''],['大车以载','',''],['大转变','',''],['大轰','',''],['大轰大嗡','',''],['大轴','',''],['大轴子','',''],['大轴戏','',''],['大辂椎轮','',''],['大辟','',''],['大辩不言','',''],['大辩若讷','',''],['大辱','',''],['大过','',''],['大运','',''],['大运河','',''],['大进化','',''],['大进大出','',''],['大连外国语大学','',''],['大连理工大学','',''],['大逆','',''],['大逆不道','',''],['大逆无道','',''],['大选','',''],['大通','',''],['大通县','',''],['大逛','',''],['大道','',''],['大道理','',''],['大邱','',''],['大邱市','',''],['大邱广域市','',''],['大部','',''],['大部份','',''],['大部分','',''],['大部分地区','',''],['大部地区','',''],['大部头','',''],['大都','',''],['大都会','',''],['大都市','',''],['大都市地区','',''],['大都有','',''],['大酒宴','',''],['大酒杯','',''],['大酒瓶','',''],['大醇小疵','',''],['大醉','',''],['大里','',''],['大里市','',''],['大量','',''],['大量杀伤武器','',''],['大量生产','',''],['大釜','',''],['大钞','',''],['大钟','',''],['大钢琴','',''],['大钱','',''],['大锅','',''],['大锅菜','',''],['大锅饭','',''],['大错','',''],['大错特错','',''],['大错误','',''],['大锤','',''],['大键琴','',''],['大镕炉','',''],['大镰刀','',''],['大长今','',''],['大门','',''],['大门口','',''],['大门柱','',''],['大问题','',''],['大闹','',''],['大闹天宫','',''],['大队','',''],['大阪','',''],['大阪府','',''],['大阮','',''],['大阿姨','',''],['大陆','',''],['大陆会议','',''],['大陆同胞','',''],['大陆地区','',''],['大陆块','',''],['大陆坡','',''],['大陆封锁政策','',''],['大陆性','',''],['大陆性气候','',''],['大陆政策','',''],['大陆架','',''],['大陆漂移','',''],['大陆话','',''],['大陆间','',''],['大限','',''],['大限临头','',''],['大限到来','',''],['大院','',''],['大陪审团','',''],['大隐朝市','',''],['大难','',''],['大难不死','',''],['大难临头','',''],['大雁','',''],['大雁塔','',''],['大雄','',''],['大雄宝殿','',''],['大雅','',''],['大雅乡','',''],['大雅君子','',''],['大雨','',''],['大雨倾盆','',''],['大雨如注','',''],['大雷雨','',''],['大雾','',''],['大震荡','',''],['大霉','',''],['大青山','',''],['大静脉','',''],['大面','',''],['大面儿','',''],['大面积','',''],['大面纱','',''],['大革命','',''],['大韩帝国','',''],['大韩民国','',''],['大韩航空','',''],['大音阶','',''],['大项','',''],['大顺','',''],['大题小作','',''],['大颚','',''],['大额','',''],['大风','',''],['大风大浪','',''],['大风子','',''],['大风暴','',''],['大飞跃','',''],['大食','',''],['大餐','',''],['大饥','',''],['大饱口福','',''],['大饱眼福','',''],['大饼','',''],['大马','',''],['大马哈鱼','',''],['大马士革','',''],['大马士革李','',''],['大马金刀','',''],['大驾','',''],['大骂','',''],['大骚乱','',''],['大骨节病','',''],['大鱼','',''],['大鱼大肉','',''],['大鲵','',''],['大鲽鱼','',''],['大鳄','',''],['大鳞大马哈鱼','',''],['大鳞大麻哈鱼','',''],['大鸟','',''],['大鸣大放','',''],['大鸨','',''],['大鸿胪','',''],['大鹏','',''],['大鹏鸟','',''],['大鹿','',''],['大麦','',''],['大麦克','',''],['大麦克指数','',''],['大麦地','',''],['大麻','',''],['大麻哈鱼','',''],['大麻子','',''],['大麻里','',''],['大麻里乡','',''],['大麻风','',''],['大黄','',''],['大黄蜂','',''],['大黄鱼','',''],['大鼓','',''],['大鼓凉伞','',''],['大鼠','',''],['大鼻子','',''],['大齐','',''],['大龄','',''],['大龄青年','',''],['天上','',''],['天上人间','',''],['天上石麟','',''],['天上麒麟','',''],['天下','',''],['天下一家','',''],['天下为一','',''],['天下为公','',''],['天下为家','',''],['天下乌鸦一般黑','',''],['天下事','',''],['天下兴亡','',''],['天下大乱','',''],['天下大事','',''],['天下太平','',''],['天下归心','',''],['天下文宗','',''],['天下无敌','',''],['天下无难事','',''],['天下本无事','',''],['天下汹汹','',''],['天下没有不散的宴席','',''],['天下没有不散的筵席','',''],['天下第一','',''],['天下鼎沸','',''],['天不作美','',''],['天不怕地不怕','',''],['天不绝人','',''],['天与人归','',''],['天主','',''],['天主教','',''],['天主教会','',''],['天主教堂','',''],['天主教徒','',''],['天主的羔羊','',''],['天之骄子','',''],['天书','',''],['天云','',''],['天井','',''],['天京','',''],['天亮','',''],['天人','',''],['天人之际','',''],['天人关系','',''],['天人合一','',''],['天人感应','',''],['天人路隔','',''],['天从人愿','',''],['天付良缘','',''],['天仙','',''],['天价','',''],['天份','',''],['天伦','',''],['天伦之乐','',''],['天低吴楚','',''],['天佑吾人基业','',''],['天体','',''],['天体主义','',''],['天体仪','',''],['天体力学','',''],['天体图','',''],['天体学','',''],['天体演化学','',''],['天体物理','',''],['天体物理学','',''],['天体物理学家','',''],['天作之合','',''],['天使','',''],['天使学','',''],['天使报喜节','',''],['天使般','',''],['天似穹庐','',''],['天保九如','',''],['天候','',''],['天假因缘','',''],['天假良缘','',''],['天儿','',''],['天光','',''],['天兔座','',''],['天公','',''],['天公不作美','',''],['天公作美','',''],['天公地道','',''],['天兰','',''],['天兵','',''],['天兵天将','',''],['天冠地屦','',''],['天冬氨酸','',''],['天冬苯丙二肽酯','',''],['天冬酰胺','',''],['天冷','',''],['天分','',''],['天前配','',''],['天动','',''],['天南地北','',''],['天南星','',''],['天南海北','',''],['天却','',''],['天台乌药','',''],['天台宗','',''],['天台山','',''],['天各一方','',''],['天后','',''],['天后站','',''],['天呀','',''],['天命','',''],['天命有归','',''],['天和','',''],['天哪','',''],['天啊','',''],['天国','',''],['天地','',''],['天地会','',''],['天地头','',''],['天地悬隔','',''],['天地玄黄','',''],['天地良心','',''],['天坛','',''],['天坛座','',''],['天城文','',''],['天堂','',''],['天堑','',''],['天塌地陷','',''],['天塔','',''],['天壤','',''],['天壤之判','',''],['天壤之别','',''],['天壤王郎','',''],['天外','',''],['天外来客','',''],['天大','',''],['天大地大','',''],['天女','',''],['天天','',''],['天天向上','',''],['天头','',''],['天夺之魄','',''],['天夺其魄','',''],['天女散花','',''],['天妇罗','',''],['天妒英才','',''],['天姿','',''],['天姿国色','',''],['天子','',''],['天子无戏言','',''],['天子门生','',''],['天字第一号','',''],['天孙娘娘','',''],['天宁','',''],['天宇','',''],['天安','',''],['天安门','',''],['天安门事件','',''],['天安门城楼','',''],['天安门广场','',''],['天完','',''],['天官','',''],['天宝','',''],['天宫','',''],['天宫图','',''],['天寒','',''],['天寒地冻','',''],['天尊','',''],['天山','',''],['天山山脉','',''],['天崩地坼','',''],['天崩地裂','',''],['天工','',''],['天差地远','',''],['天师','',''],['天帝','',''],['天幕','',''],['天干','',''],['天平','',''],['天年','',''],['天年不遂','',''],['天幸','',''],['天底','',''],['天底下','',''],['天府','',''],['天府之国','',''],['天庭','',''],['天弓','',''],['天心','',''],['天快','',''],['天怒','',''],['天怒人怨','',''],['天性','',''],['天恩','',''],['天悬地隔','',''],['天悯','',''],['天惊','',''],['天惊石破','',''],['天愁地惨','',''],['天意','',''],['天成','',''],['天才','',''],['天才出自勤奋','',''],['天才论','',''],['天打','',''],['天择','',''],['天授','',''],['天授地设','',''],['天摇地转','',''],['天摧地塌','',''],['天敌','',''],['天数','',''],['天文','',''],['天文单位','',''],['天文台','',''],['天文坐标','',''],['天文学','',''],['天文学大成','',''],['天文学家','',''],['天文导航','',''],['天文数字','',''],['天文望远镜','',''],['天文钟','',''],['天文馆','',''],['天方','',''],['天方夜谭','',''],['天旋','',''],['天旋地转','',''],['天无二日','',''],['天无绝人之路','',''],['天日','',''],['天旱','',''],['天时','',''],['天时地利','',''],['天时地利人和','',''],['天明','',''],['天昏','',''],['天昏地惨','',''],['天昏地暗','',''],['天昏地黑','',''],['天星码头','',''],['天晓得','',''],['天晴','',''],['天暗','',''],['天有不测风云','',''],['天朝','',''],['天朝田亩制度','',''],['天末凉风','',''],['天机','',''],['天机不可泄漏','',''],['天机不可泄露','',''],['天机云锦','',''],['天权','',''],['天条','',''],['天枢','',''],['天枢星','',''],['天枰座','',''],['天桥','',''],['天桥立','',''],['天梯','',''],['天棚','',''],['天楼','',''],['天气','',''],['天气图','',''],['天气形势','',''],['天气情况','',''],['天气状况','',''],['天气现象','',''],['天气真好','',''],['天气预报','',''],['天水地区','',''],['天汉','',''],['天池','',''],['天沟','',''],['天河','',''],['天波','',''],['天津会议专条','',''],['天津外国语大学','',''],['天津大学','',''],['天津条约','',''],['天津环球金融中心','',''],['天涯','',''],['天涯咫尺','',''],['天涯地角','',''],['天涯比邻','',''],['天涯海角','',''],['天涯若比邻','',''],['天清日晏','',''],['天清气朗','',''],['天渊','',''],['天渊之别','',''],['天演','',''],['天演论','',''],['天潢贵胄','',''],['天火','',''],['天灵盖','',''],['天灵盖儿','',''],['天灾','',''],['天灾人祸','',''],['天灾地变','',''],['天灾地孽','',''],['天灾物怪','',''],['天炉座','',''],['天然','',''],['天然丝','',''],['天然免疫','',''],['天然堤','',''],['天然本地','',''],['天然杂交','',''],['天然林','',''],['天然树脂','',''],['天然桥','',''],['天然橡胶','',''],['天然毒素','',''],['天然气','',''],['天然气井','',''],['天然港','',''],['天然漆','',''],['天然照亮','',''],['天然磁铁','',''],['天然纤维','',''],['天然药物','',''],['天然铀','',''],['天燕座','',''],['天父','',''],['天爷','',''],['天牛','',''],['天狗','',''],['天狗螺','',''],['天狼座','',''],['天狼星','',''],['天猫座','',''],['天王','',''],['天王星','',''],['天玑','',''],['天球','',''],['天球仪','',''],['天理','',''],['天理不容','',''],['天理教','',''],['天理教起义','',''],['天理昭彰','',''],['天理昭昭','',''],['天理昭然','',''],['天理良心','',''],['天理难容','',''],['天琴座','',''],['天琴星座','',''],['天璇','',''],['天生','',''],['天生天杀','',''],['天生尤物','',''],['天生的一对','',''],['天电','',''],['天界','',''],['天疱疮','',''],['天皇','',''],['天盖','',''],['天相吉人','',''],['天真','',''],['天真无邪','',''],['天真活泼','',''],['天真烂漫','',''],['天知地知','',''],['天祝','',''],['天祝县','',''],['天神','',''],['天禀','',''],['天禄','',''],['天秤','',''],['天秤座','',''],['天穹','',''],['天空','',''],['天空辐射表','',''],['天穿日','',''],['天窗','',''],['天竹','',''],['天竺','',''],['天竺牡丹','',''],['天竺葵','',''],['天竺鼠','',''],['天箭座','',''],['天篷','',''],['天籁','',''],['天级','',''],['天线','',''],['天线宝宝','',''],['天经地义','',''],['天缘凑合','',''],['天缘奇遇','',''],['天网恢恢','',''],['天网灰灰','',''],['天罗','',''],['天罗地网','',''],['天罡','',''],['天罡星','',''],['天翻','',''],['天翻地覆','',''],['天老儿','',''],['天职','',''],['天舟座','',''],['天良','',''],['天色','',''],['天芥菜','',''],['天花','',''],['天花乱坠','',''],['天花板','',''],['天花病毒','',''],['天花粉','',''],['天荒','',''],['天荒地老','',''],['天葬','',''],['天蓝','',''],['天蓝色','',''],['天蚕','',''],['天蚕蛾','',''],['天蛾','',''],['天蝎','',''],['天蝎座','',''],['天蝼','',''],['天蟹座','',''],['天行赤眼','',''],['天衣','',''],['天衣无缝','',''],['天要落雨','',''],['天覆地载','',''],['天诛','',''],['天诛地灭','',''],['天诱其衷','',''],['天说','',''],['天谴','',''],['天象','',''],['天象仪','',''],['天资','',''],['天赋','',''],['天赐','',''],['天赐良机','',''],['天趣','',''],['天足','',''],['天路历程','',''],['天车','',''],['天轴','',''],['天边','',''],['天造地设','',''],['天道','',''],['天道人事','',''],['天道好还','',''],['天道恢恢','',''],['天道无亲','',''],['天道无私','',''],['天道酬勤','',''],['天那水','',''],['天郎气清','',''],['天长地久','',''],['天长地老','',''],['天长地远','',''],['天长日久','',''],['天门冬','',''],['天门冬科','',''],['天阉','',''],['天阴','',''],['天际','',''],['天降','',''],['天险','',''],['天随人愿','',''],['天雨路滑','',''],['天雨顺延','',''],['天青','',''],['天青石','',''],['天青色','',''],['天顶','',''],['天顺','',''],['天香国色','',''],['天马行空','',''],['天骄','',''],['天高','',''],['天高地卑','',''],['天高地厚','',''],['天高地远','',''],['天高地迥','',''],['天高日远','',''],['天高气清','',''],['天高气爽','',''],['天高皇帝远','',''],['天魔','',''],['天鸽座','',''],['天鹅','',''],['天鹅座','',''],['天鹅湖','',''],['天鹅绒','',''],['天鹤座','',''],['天鹰座','',''],['天麻','',''],['天黑','',''],['天龙','',''],['天龙八部','',''],['天龙座','',''],['太上','',''],['太上忘情','',''],['太上皇','',''],['太上老君','',''],['太不像话','',''],['太不自量','',''],['太丘道广','',''],['太久','',''],['太仆','',''],['太仆寺','',''],['太仆寺卿','',''],['太仓一粟','',''],['太低','',''],['太俗','',''],['太傅','',''],['太充足','',''],['太公','',''],['太公兵法','',''],['太公望','',''],['太公钓鱼','',''],['太公钓鱼愿者上钩','',''],['太冷','',''],['太凶了','',''],['太初','',''],['太医','',''],['太半','',''],['太古','',''],['太古代','',''],['太古宙','',''],['太古洋行','',''],['太古界','',''],['太古菜','',''],['太史','',''],['太史令','',''],['太史公','',''],['太后','',''],['太君','',''],['太和殿','',''],['太坏','',''],['太多','',''],['太大','',''],['太太','',''],['太太们','',''],['太奇','',''],['太好了','',''],['太妃','',''],['太妃糖','',''],['太妹','',''],['太婆','',''],['太子','',''],['太子丹','',''],['太子党','',''],['太子十三峰','',''],['太子太保','',''],['太子港','',''],['太学','',''],['太守','',''],['太宗','',''],['太宽','',''],['太尉','',''],['太小','',''],['太少','',''],['太岁','',''],['太岁头上动土','',''],['太差','',''],['太师','',''],['太师椅','',''],['太常','',''],['太平','',''],['太平公主','',''],['太平天国','',''],['太平市','',''],['太平广记','',''],['太平御览','',''],['太平无象','',''],['太平梯','',''],['太平水缸','',''],['太平洋','',''],['太平洋区域','',''],['太平洋周边','',''],['太平洋宪章','',''],['太平洋战争','',''],['太平洋联合铁路','',''],['太平盛世','',''],['太平绅士','',''],['太平花','',''],['太平道','',''],['太平门','',''],['太平间','',''],['太平鼓','',''],['太平龙头','',''],['太庙','',''],['太弱','',''],['太强','',''],['太忙','',''],['太快','',''],['太息','',''],['太慢','',''],['太早','',''],['太晚','',''],['太极','',''],['太极剑','',''],['太极图','',''],['太极图说','',''],['太极拳','',''],['太棒','',''],['太死','',''],['太液池','',''],['太深','',''],['太湖石','',''],['太热','',''],['太熟','',''],['太爷','',''],['太猛','',''],['太甚','',''],['太白山','',''],['太白星','',''],['太白粉','',''],['太的','',''],['太监','',''],['太短','',''],['太石村','',''],['太祖','',''],['太穷','',''],['太空','',''],['太空人','',''],['太空学','',''],['太空战略','',''],['太空探索','',''],['太空服','',''],['太空梭','',''],['太空步','',''],['太空游','',''],['太空漫步','',''],['太空站','',''],['太空舞步','',''],['太空舱','',''],['太空船','',''],['太空行走','',''],['太空飞船','',''],['太空飞行','',''],['太简','',''],['太粗','',''],['太紧','',''],['太虚','',''],['太行','',''],['太行山','',''],['太行山脉','',''],['太贵','',''],['太软','',''],['太轻','',''],['太过','',''],['太近','',''],['太远','',''],['太重','',''],['太长','',''],['太阳','',''],['太阳仪','',''],['太阳光','',''],['太阳光柱','',''],['太阳公司','',''],['太阳历','',''],['太阳地儿','',''],['太阳帽','',''],['太阳年','',''],['太阳微系统公司','',''],['太阳报','',''],['太阳日','',''],['太阳时','',''],['太阳永不落','',''],['太阳活动','',''],['太阳灯','',''],['太阳灶','',''],['太阳炉','',''],['太阳照在桑干河上','',''],['太阳电池','',''],['太阳电池板','',''],['太阳眼镜','',''],['太阳社','',''],['太阳神','',''],['太阳神经丛','',''],['太阳神计划','',''],['太阳穴','',''],['太阳窗','',''],['太阳窝','',''],['太阳系','',''],['太阳翼','',''],['太阳能','',''],['太阳能板','',''],['太阳能电池','',''],['太阳轮','',''],['太阳辐射','',''],['太阳钟','',''],['太阳镜','',''],['太阳风','',''],['太阳鸟','',''],['太阳黑子','',''],['太阳黑子周','',''],['太阴','',''],['太阴历','',''],['太阿之柄','',''],['太阿倒持','',''],['太阿在握','',''],['太难','',''],['太高','',''],['太鲁阁','',''],['太鲁阁族','',''],['太麻里','',''],['太麻里乡','',''],['夫人','',''],['夫人裙带','',''],['夫余','',''],['夫君','',''],['夫唱妇随','',''],['夫妇','',''],['夫妇间','',''],['夫妻','',''],['夫妻反目','',''],['夫妻店','',''],['夫妻肺片','',''],['夫婿','',''],['夫子','',''],['夫子庙','',''],['夫子自道','',''],['夫座','',''],['夫权','',''],['夫琅和费','',''],['夫荣妻显','',''],['夫荣妻贵','',''],['夫贵妻荣','',''],['夭亡','',''],['夭夭','',''],['夭折','',''],['夭桃浓李','',''],['夭矫','',''],['央中','',''],['央元音','',''],['央及','',''],['央告','',''],['央托','',''],['央求','',''],['央行','',''],['央视国际','',''],['央财','',''],['夯具','',''],['夯土','',''],['夯土机','',''],['夯实','',''],['夯歌','',''],['夯汉','',''],['夯砣','',''],['夯雀先飞','',''],['失业','',''],['失业人数','',''],['失业率','',''],['失业者','',''],['失为','',''],['失主','',''],['失之','',''],['失之东隅','',''],['失之东隅收之桑榆','',''],['失之交臂','',''],['失之千里','',''],['失之毫厘','',''],['失事','',''],['失于','',''],['失仪','',''],['失传','',''],['失体统','',''],['失体面','',''],['失信','',''],['失修','',''],['失光泽','',''],['失利','',''],['失势','',''],['失单','',''],['失却','',''],['失去','',''],['失去意识','',''],['失口','',''],['失和','',''],['失土','',''],['失地','',''],['失坠','',''],['失声','',''],['失声症','',''],['失声痛哭','',''],['失失慌慌','',''],['失学','',''],['失守','',''],['失宜','',''],['失实','',''],['失宠','',''],['失密','',''],['失察','',''],['失常','',''],['失度','',''],['失张失志','',''],['失张失智','',''],['失当','',''],['失忆症','',''],['失态','',''],['失怙','',''],['失恃','',''],['失恋','',''],['失悔','',''],['失惊打怪','',''],['失意','',''],['失慎','',''],['失所','',''],['失手','',''],['失掉','',''],['失控','',''],['失措','',''],['失效','',''],['失效日期','',''],['失散','',''],['失敬','',''],['失时','',''],['失明','',''],['失望','',''],['失期','',''],['失机','',''],['失枕','',''],['失果','',''],['失查','',''],['失格','',''],['失检','',''],['失欢','',''],['失款','',''],['失步','',''],['失水','',''],['失火','',''],['失灵','',''],['失物','',''],['失物招领','',''],['失物认领','',''],['失盗','',''],['失真','',''],['失眠','',''],['失眠症','',''],['失着','',''],['失瞻','',''],['失礼','',''],['失神','',''],['失神落魄','',''],['失禁','',''],['失窃','',''],['失笑','',''],['失策','',''],['失算','',''],['失约','',''],['失纵','',''],['失而复得','',''],['失职','',''],['失聪','',''],['失能性毒剂','',''],['失脚','',''],['失色','',''],['失节','',''],['失范','',''],['失落','',''],['失落感','',''],['失血','',''],['失血性贫血','',''],['失衡','',''],['失言','',''],['失计','',''],['失认','',''],['失记','',''],['失语','',''],['失语症','',''],['失误','',''],['失诸交臂','',''],['失读症','',''],['失调','',''],['失责','',''],['失败','',''],['失败为成功之母','',''],['失败主义','',''],['失败乃成功之母','',''],['失败是成功之母','',''],['失败者','',''],['失足','',''],['失足青年','',''],['失踪','',''],['失踪者','',''],['失身','',''],['失身分','',''],['失迎','',''],['失迷','',''],['失速','',''],['失道','',''],['失道寡助','',''],['失配','',''],['失重','',''],['失错','',''],['失闪','',''],['失陪','',''],['失陷','',''],['失面子','',''],['失音','',''],['失风','',''],['失马亡羊','',''],['失魂','',''],['失魂丧魄','',''],['失魂落魄','',''],['头一','',''],['头一回','',''],['头一年','',''],['头一次','',''],['头上','',''],['头上安头','',''],['头中','',''],['头人','',''],['头份','',''],['头份镇','',''],['头伏','',''],['头伙','',''],['头会箕敛','',''],['头会箕赋','',''],['头信息','',''],['头像','',''],['头儿','',''],['头儿脑儿','',''],['头兜','',''],['头冠','',''],['头刷','',''],['头功','',''],['头功起衅','',''],['头半天','',''],['头半天儿','',''],['头发','',''],['头发油','',''],['头发胡子一把抓','',''],['头口','',''],['头号','',''],['头号字','',''],['头名','',''],['头向前','',''],['头回','',''],['头囟儿','',''],['头城','',''],['头城镇','',''],['头大','',''],['头天','',''],['头头','',''],['头头儿','',''],['头头是道','',''],['头奖','',''],['头套','',''],['头子','',''],['头字语','',''],['头孢拉定','',''],['头孢菌','',''],['头孢菌素','',''],['头家','',''],['头寸','',''],['头小','',''],['头尾','',''],['头屋','',''],['头屋乡','',''],['头屑','',''],['头屯河','',''],['头巾','',''],['头带','',''],['头年','',''],['头座','',''],['头异','',''],['头彩','',''],['头悬梁','',''],['头戴','',''],['头手枷','',''],['头挡','',''],['头数','',''],['头文字','',''],['头昏','',''],['头昏目晕','',''],['头昏目眩','',''],['头昏眼晕','',''],['头昏眼暗','',''],['头昏眼花','',''],['头昏脑涨','',''],['头昏脑眩','',''],['头昏脑胀','',''],['头昏脑闷','',''],['头晌','',''],['头晕','',''],['头晕目眩','',''],['头晕眼昏','',''],['头晕眼花','',''],['头晕脑涨','',''],['头晕脑胀','',''],['头朝下','',''],['头期款','',''],['头条','',''],['头条新闻','',''],['头梢自领','',''],['头款','',''],['头水','',''],['头油','',''],['头版','',''],['头版头条','',''],['头牌','',''],['头状','',''],['头状花序','',''],['头生','',''],['头疼','',''],['头疼脑热','',''],['头痒搔跟','',''],['头痛','',''],['头痛医头','',''],['头痛治头足痛治足','',''],['头痛灸头脚痛医脚','',''],['头癣','',''],['头皮','',''],['头皮屑','',''],['头盔','',''],['头盖','',''],['头盖帽','',''],['头盖骨','',''],['头目','',''],['头眩眼花','',''],['头短','',''],['头破血出','',''],['头破血流','',''],['头票','',''],['头童齿豁','',''],['头端','',''],['头等','',''],['头等大事','',''],['头等舱','',''],['头筹','',''],['头箍','',''],['头箍儿','',''],['头索类','',''],['头纱','',''],['头绪','',''],['头绳','',''],['头罩','',''],['头羊','',''],['头胀','',''],['头胎','',''],['头胸部','',''],['头脑','',''],['头脑发热','',''],['头脑发胀','',''],['头脑好','',''],['头脑清楚','',''],['头脑清醒','',''],['头脑简单四肢发达','',''],['头脸','',''],['头脸儿','',''],['头舱','',''],['头茬','',''],['头菜','',''],['头虱','',''],['头衔','',''],['头角','',''],['头角峥嵘','',''],['头角崭然','',''],['头足异处','',''],['头足异所','',''],['头足纲','',''],['头路','',''],['头道','',''],['头部','',''],['头里','',''],['头重','',''],['头重脚轻','',''],['头重足轻','',''],['头针疗法','',''],['头钱','',''],['头阵','',''],['头陀','',''],['头难','',''],['头雁','',''],['头面','',''],['头面人物','',''],['头韵','',''],['头顶','',''],['头颅','',''],['头领','',''],['头颈','',''],['头额','',''],['头风','',''],['头饰','',''],['头马','',''],['头骨','',''],['头骨学','',''],['夷为平地','',''],['夷人','',''],['夷平','',''],['夷戮','',''],['夷旷','',''],['夷洲','',''],['夷灭','',''],['夷然','',''],['夷犹','',''],['夷狄','',''],['夷门','',''],['夷险一节','',''],['夷陵','',''],['夸克','',''],['夸口','',''],['夸嘴','',''],['夸多斗靡','',''],['夸大','',''],['夸大之词','',''],['夸大其词','',''],['夸大狂','',''],['夸夸','',''],['夸夸其谈','',''],['夸夸而谈','',''],['夸奖','',''],['夸她','',''],['夸张','',''],['夸张者','',''],['夸强说会','',''],['夸强道会','',''],['夸海口','',''],['夸父追日','',''],['夸父逐日','',''],['夸特','',''],['夸示','',''],['夸称','',''],['夸耀','',''],['夸能斗志','',''],['夸脱','',''],['夸诞','',''],['夸赞','',''],['夸饰','',''],['夹七夹八','',''],['夹上','',''],['夹丝玻璃','',''],['夹了','',''],['夹住','',''],['夹克','',''],['夹入','',''],['夹具','',''],['夹击','',''],['夹剪','',''],['夹叙','',''],['夹塞儿','',''],['夹套','',''],['夹子','',''],['夹尾巴','',''],['夹层','',''],['夹层玻璃','',''],['夹山国家森林公园','',''],['夹山寺','',''],['夹带','',''],['夹当','',''],['夹当儿','',''],['夹心','',''],['夹批','',''],['夹持','',''],['夹指','',''],['夹攻','',''],['夹断','',''],['夹杂','',''],['夹板','',''],['夹板气','',''],['夹棉衣','',''],['夹棍','',''],['夹注','',''],['夹牢','',''],['夹生','',''],['夹生饭','',''],['夹痛','',''],['夹盘','',''],['夹着','',''],['夹石','',''],['夹竹桃','',''],['夹紧','',''],['夹缝','',''],['夹肝','',''],['夹肢窝','',''],['夹背','',''],['夹菜','',''],['夹衣','',''],['夹袄','',''],['夹袋中人物','',''],['夹袍','',''],['夹被','',''],['夹角','',''],['夹起','',''],['夹起尾巴','',''],['夹道','',''],['夹道欢迎','',''],['夹针','',''],['夹钳','',''],['夹馅','',''],['夺了','',''],['夺人','',''],['夺佃','',''],['夺偶','',''],['夺冠','',''],['夺占','',''],['夺去','',''],['夺取','',''],['夺命','',''],['夺回','',''],['夺在','',''],['夺席谈经','',''],['夺得','',''],['夺掉','',''],['夺权','',''],['夺标','',''],['夺爱','',''],['夺目','',''],['夺眶而出','',''],['夺美','',''],['夺胎换骨','',''],['夺走','',''],['夺过','',''],['夺金','',''],['夺门而出','',''],['夺魁','',''],['夺魂','',''],['奄列','',''],['奄奄','',''],['奄奄一息','',''],['奄忽','',''],['奄然而逝','',''],['奇丑','',''],['奇丑无比','',''],['奇丽','',''],['奇事','',''],['奇人','',''],['奇伎淫巧','',''],['奇伟','',''],['奇偶','',''],['奇偶性','',''],['奇兵','',''],['奇函数','',''],['奇剧','',''],['奇功','',''],['奇努克','',''],['奇勋','',''],['奇南香','',''],['奇境','',''],['奇墙外汉','',''],['奇士','',''],['奇奇怪怪','',''],['奇妙','',''],['奇寒','',''],['奇山异水','',''],['奇峰','',''],['奇崛','',''],['奇巧','',''],['奇幻','',''],['奇庞福艾','',''],['奇异','',''],['奇异夸克','',''],['奇异幻想','',''],['奇异果','',''],['奇异笔','',''],['奇形怪状','',''],['奇彩','',''],['奇心','',''],['奇志','',''],['奇思','',''],['奇怪','',''],['奇都','',''],['奇情','',''],['奇想','',''],['奇想家','',''],['奇才','',''],['奇技','',''],['奇技淫巧','',''],['奇招','',''],['奇效','',''],['奇数','',''],['奇文','',''],['奇文共赏','',''],['奇文瑰句','',''],['奇昆古尼亚热','',''],['奇昆古尼亚病毒','',''],['奇景','',''],['奇术','',''],['奇校验','',''],['奇热','',''],['奇特','',''],['奇特性','',''],['奇珍','',''],['奇珍异宝','',''],['奇瑞','',''],['奇瓦瓦','',''],['奇痒','',''],['奇祸','',''],['奇绝','',''],['奇缘','',''],['奇缺','',''],['奇羡','',''],['奇耻大辱','',''],['奇能','',''],['奇能异士','',''],['奇花异卉','',''],['奇花异草','',''],['奇葩','',''],['奇葩异卉','',''],['奇袭','',''],['奇袭者','',''],['奇装异服','',''],['奇观','',''],['奇览','',''],['奇解','',''],['奇言','',''],['奇诗','',''],['奇语','',''],['奇谈','',''],['奇谈怪论','',''],['奇谋','',''],['奇谲','',''],['奇貌','',''],['奇货','',''],['奇货可居','',''],['奇趣','',''],['奇蹄目','',''],['奇蹄类','',''],['奇迹','',''],['奇迹般地','',''],['奇遇','',''],['奇门遁甲','',''],['奇闻','',''],['奇闻怪事','',''],['奇零','',''],['奈何','',''],['奈何以死惧之','',''],['奈曼','',''],['奈特','',''],['奈秒','',''],['奈米','',''],['奈良','',''],['奈良县','',''],['奈良市','',''],['奈良时代','',''],['奉上','',''],['奉上一函','',''],['奉为','',''],['奉为楷模','',''],['奉为神','',''],['奉令','',''],['奉令承教','',''],['奉公','',''],['奉公不阿','',''],['奉公克己','',''],['奉公守法','',''],['奉公执法','',''],['奉养','',''],['奉劝','',''],['奉召','',''],['奉告','',''],['奉命','',''],['奉命唯谨','',''],['奉天','',''],['奉天承运','',''],['奉头鼠窜','',''],['奉如神明','',''],['奉悉','',''],['奉扬仁风','',''],['奉承','',''],['奉承者','',''],['奉承讨好','',''],['奉旨','',''],['奉此','',''],['奉献','',''],['奉献物','',''],['奉献礼','',''],['奉献精神','',''],['奉献者','',''],['奉现','',''],['奉申贺敬','',''],['奉祀','',''],['奉系','',''],['奉系军阀','',''],['奉约','',''],['奉职','',''],['奉若神明','',''],['奉行','',''],['奉行故事','',''],['奉行者','',''],['奉诏','',''],['奉贤','',''],['奉赠','',''],['奉辛比克党','',''],['奉辞伐罪','',''],['奉迎','',''],['奉还','',''],['奉送','',''],['奉道斋僧','',''],['奉陪','',''],['奉陪到底','',''],['奋不顾生','',''],['奋不顾身','',''],['奋力','',''],['奋力冲刺','',''],['奋力拼搏','',''],['奋勇','',''],['奋勇当先','',''],['奋勉','',''],['奋发','',''],['奋发向上','',''],['奋发图强','',''],['奋发有为','',''],['奋发蹈厉','',''],['奋战','',''],['奋斗','',''],['奋斗不息','',''],['奋斗到底','',''],['奋斗目标','',''],['奋斗者','',''],['奋武扬威','',''],['奋笔','',''],['奋笔疾书','',''],['奋袂','',''],['奋袂攘襟','',''],['奋袂而起','',''],['奋起','',''],['奋起反抗','',''],['奋起抗争','',''],['奋起湖','',''],['奋起直追','',''],['奋起自卫','',''],['奋身','',''],['奋身独步','',''],['奋迅','',''],['奋进','',''],['奋进号','',''],['奋飞','',''],['奎宁','',''],['奎宁水','',''],['奎托','',''],['奎文','',''],['奎星','',''],['奏乐','',''],['奏书','',''],['奏凯','',''],['奏出','',''],['奏功','',''],['奏响','',''],['奏帖','',''],['奏折','',''],['奏捷','',''],['奏效','',''],['奏明','',''],['奏曲','',''],['奏本','',''],['奏疏','',''],['奏章','',''],['奏者','',''],['奏腔','',''],['奏表','',''],['奏议','',''],['奏鸣','',''],['奏鸣曲','',''],['奏鸣曲式','',''],['契东','',''],['契丹','',''],['契人','',''],['契友','',''],['契合','',''],['契合金兰','',''],['契据','',''],['契文','',''],['契机','',''],['契沙比克湾','',''],['契税','',''],['契箭','',''],['契约','',''],['契约桥牌','',''],['契约者','',''],['契约货币','',''],['契纸','',''],['契若金兰','',''],['契证','',''],['契诃夫','',''],['奔丧','',''],['奔去','',''],['奔向','',''],['奔命','',''],['奔头','',''],['奔头儿','',''],['奔奔族','',''],['奔忙','',''],['奔放','',''],['奔月','',''],['奔波','',''],['奔泻','',''],['奔流','',''],['奔涌','',''],['奔突','',''],['奔窜','',''],['奔腾','',''],['奔袭','',''],['奔走','',''],['奔走之友','',''],['奔走呼号','',''],['奔走如市','',''],['奔走相告','',''],['奔赴','',''],['奔跑','',''],['奔跑戏耍','',''],['奔跳','',''],['奔车朽索','',''],['奔逃','',''],['奔逸绝尘','',''],['奔马','',''],['奔驰','',''],['奔驶','',''],['奕䜣','',''],['奕奕','',''],['奕詝','',''],['奖优罚劣','',''],['奖券','',''],['奖励','',''],['奖励制度','',''],['奖励品','',''],['奖励旅行','',''],['奖励金','',''],['奖勉','',''],['奖勤','',''],['奖勤罚懒','',''],['奖品','',''],['奖售','',''],['奖学金','',''],['奖得主','',''],['奖惩','',''],['奖惩制度','',''],['奖拔公心','',''],['奖挹','',''],['奖掖','',''],['奖旗','',''],['奖杯','',''],['奖牌','',''],['奖牌榜','',''],['奖状','',''],['奖的','',''],['奖章','',''],['奖给','',''],['奖罚','',''],['奖赏','',''],['奖酬','',''],['奖金','',''],['奖金税','',''],['奖限','',''],['奖项','',''],['套上','',''],['套中人','',''],['套交情','',''],['套住','',''],['套作','',''],['套儿','',''],['套入','',''],['套写','',''],['套利','',''],['套利者','',''],['套包','',''],['套印','',''],['套取','',''],['套叠','',''],['套口','',''],['套口供','',''],['套圈','',''],['套在','',''],['套头','',''],['套套','',''],['套子','',''],['套房','',''],['套挂','',''],['套换','',''],['套数','',''],['套料','',''],['套曲','',''],['套服','',''],['套期保值','',''],['套杉','',''],['套汇','',''],['套版','',''],['套牢','',''],['套犁','',''],['套环','',''],['套用','',''],['套种','',''],['套筒','',''],['套算','',''],['套管','',''],['套管针','',''],['套系','',''],['套索','',''],['套红','',''],['套结','',''],['套绳','',''],['套耕','',''],['套耧','',''],['套色','',''],['套色版','',''],['套衣','',''],['套衫','',''],['套衫儿','',''],['套袖','',''],['套裁','',''],['套装','',''],['套裙','',''],['套裤','',''],['套话','',''],['套语','',''],['套购','',''],['套路','',''],['套车','',''],['套近乎','',''],['套进','',''],['套钟','',''],['套问','',''],['套间','',''],['套靴','',''],['套鞋','',''],['套领','',''],['套餐','',''],['套马','',''],['套马杆','',''],['奚啸伯','',''],['奚奴','',''],['奚幸','',''],['奚落','',''],['奠仪','',''],['奠基','',''],['奠基人','',''],['奠基仪式','',''],['奠基典礼','',''],['奠基石','',''],['奠基者','',''],['奠定','',''],['奠济宫','',''],['奠祭','',''],['奠立','',''],['奠边府战役','',''],['奠都','',''],['奠酒','',''],['奢丽','',''],['奢侈','',''],['奢侈品','',''],['奢侈逸乐','',''],['奢入俭难','',''],['奢华','',''],['奢想','',''],['奢易俭难','',''],['奢望','',''],['奢求','',''],['奢泰','',''],['奢淫','',''],['奢盼','',''],['奢谈','',''],['奢靡','',''],['奢香','',''],['奥丁','',''],['奥丁谐振器','',''],['奥什','',''],['奥克兰','',''],['奥克拉荷马州','',''],['奥克斯纳德','',''],['奥克苏斯河','',''],['奥兰多','',''],['奥切诺斯','',''],['奥利安','',''],['奥勒冈州','',''],['奥匈帝国','',''],['奥区','',''],['奥博','',''],['奥卢','',''],['奥古斯都','',''],['奥国','',''],['奥地利人','',''],['奥塞梯','',''],['奥塞罗','',''],['奥妙','',''],['奥姆真理教','',''],['奥委会','',''],['奥威尔','',''],['奥密克戎','',''],['奥尔巴尼','',''],['奥尔布赖特','',''],['奥尔德尼岛','',''],['奥尔良','',''],['奥巴马','',''],['奥布里','',''],['奥康内尔','',''],['奥康纳','',''],['奥德修斯','',''],['奥德赛','',''],['奥托','',''],['奥援','',''],['奥数','',''],['奥斯丁','',''],['奥斯卡','',''],['奥斯卡金像奖','',''],['奥斯威辛','',''],['奥斯威辛集中营','',''],['奥斯忒','',''],['奥斯曼','',''],['奥斯曼帝国','',''],['奥斯汀','',''],['奥斯瓦尔德','',''],['奥斯陆','',''],['奥朗德','',''],['奥林匹亚','',''],['奥林匹克','',''],['奥林匹克体育场','',''],['奥林匹克精神','',''],['奥林匹克运动会','',''],['奥林匹克运动会组织委员会','',''],['奥涅金','',''],['奥特曼','',''],['奥特朗托','',''],['奥特朗托海峡','',''],['奥特莱斯','',''],['奥秒','',''],['奥秘','',''],['奥米伽','',''],['奥米可戎','',''],['奥组委','',''],['奥维耶多','',''],['奥草','',''],['奥西娜斯','',''],['奥赖恩','',''],['奥赛罗','',''],['奥运','',''],['奥运会','',''],['奥运城市','',''],['奥运村','',''],['奥运赛','',''],['奥迪','',''],['奥迪修斯','',''],['奥迹','',''],['奥里萨邦','',''],['奥里里亚','',''],['奥陶系','',''],['奥陶纪','',''],['奥马哈','',''],['奥马尔','',''],['奥黛丽','',''],['奥黛莉','',''],['女业主','',''],['女中','',''],['女中丈夫','',''],['女中尧舜','',''],['女中豪杰','',''],['女为悦己者容','',''],['女主','',''],['女主人','',''],['女主人公','',''],['女主席','',''],['女主角','',''],['女乘务员','',''],['女书','',''],['女亲属','',''],['女人','',''],['女人不爱','',''],['女人家','',''],['女人气','',''],['女仆','',''],['女优','',''],['女伯爵','',''],['女伴','',''],['女低音','',''],['女佣','',''],['女佣人','',''],['女侍','',''],['女侯爵','',''],['女便袍','',''],['女修道','',''],['女修道张','',''],['女修道院','',''],['女傧相','',''],['女像柱','',''],['女儿','',''],['女儿墙','',''],['女儿红','',''],['女公子','',''],['女公爵','',''],['女兵','',''],['女凶手','',''],['女功','',''],['女医生','',''],['女单','',''],['女厕','',''],['女厕所','',''],['女友','',''],['女发','',''],['女史','',''],['女司机','',''],['女同','',''],['女同志','',''],['女同胞','',''],['女名','',''],['女向导','',''],['女售','',''],['女城主','',''],['女墙','',''],['女士','',''],['女士们','',''],['女士优先','',''],['女声','',''],['女外套','',''],['女大不中留','',''],['女大使','',''],['女大十八变','',''],['女大难留','',''],['女大须嫁','',''],['女奴','',''],['女奴隶','',''],['女妖','',''],['女妖魔','',''],['女娃','',''],['女娲','',''],['女娲氏','',''],['女婴','',''],['女婿','',''],['女子','',''],['女子单打','',''],['女子参政权','',''],['女子无才便是德','',''],['女学士','',''],['女学生','',''],['女学者','',''],['女孩','',''],['女孩儿','',''],['女孩子','',''],['女孩子家','',''],['女官','',''],['女家','',''],['女家长','',''],['女导演','',''],['女将','',''],['女工','',''],['女工头','',''],['女巨人','',''],['女巫','',''],['女市长','',''],['女师','',''],['女帝','',''],['女帽','',''],['女帽类','',''],['女干部','',''],['女店员','',''],['女座','',''],['女庵','',''],['女强人','',''],['女待','',''],['女徒','',''],['女怕嫁错郎','',''],['女性','',''],['女性主义','',''],['女性化','',''],['女性厌恶','',''],['女性名','',''],['女性贬抑','',''],['女性间','',''],['女怪','',''],['女总督','',''],['女房东','',''],['女扮男装','',''],['女招待','',''],['女捕手','',''],['女排','',''],['女探','',''],['女教师','',''],['女方','',''],['女星','',''],['女朋友','',''],['女服','',''],['女服务员','',''],['女权','',''],['女权主义','',''],['女杰','',''],['女校','',''],['女校长','',''],['女样','',''],['女歌','',''],['女歌唱家','',''],['女歌手','',''],['女武神','',''],['女沙皇','',''],['女流','',''],['女海神','',''],['女演员','',''],['女牧师','',''],['女犯','',''],['女猎人','',''],['女猎师','',''],['女王','',''],['女王国','',''],['女王般','',''],['女生','',''],['女生外向','',''],['女用','',''],['女画家','',''],['女的','',''],['女皇','',''],['女皇大学','',''],['女皇帝','',''],['女监工','',''],['女看守','',''],['女真','',''],['女眷','',''],['女祖先','',''],['女神','',''],['女神蛤','',''],['女童','',''],['女管家','',''],['女篮','',''],['女红','',''],['女织男耕','',''],['女经理','',''],['女继承人','',''],['女编辑','',''],['女者','',''],['女舍','',''],['女舍监','',''],['女色','',''],['女英雄','',''],['女英雌','',''],['女萝','',''],['女衫','',''],['女衬衣','',''],['女衬衫','',''],['女袍','',''],['女装','',''],['女装裁缝师','',''],['女裙','',''],['女裙钗','',''],['女裤','',''],['女警','',''],['女警们','',''],['女警员','',''],['女警察','',''],['女议长','',''],['女诗人','',''],['女诱','',''],['女调','',''],['女貌','',''],['女貌郎才','',''],['女贞','',''],['女超人','',''],['女车','',''],['女运','',''],['女郎','',''],['女长须嫁','',''],['女门徒','',''],['女门房','',''],['女队','',''],['女阴','',''],['女院','',''],['女雕','',''],['女青年','',''],['女鞋','',''],['女领','',''],['女骑师','',''],['女骑手','',''],['女骗徒','',''],['女高音','',''],['女魔','',''],['女黑人','',''],['奴仆','',''],['奴佛卡因','',''],['奴使','',''],['奴儿干','',''],['奴儿干都司','',''],['奴化','',''],['奴女','',''],['奴婢','',''],['奴家','',''],['奴工','',''],['奴役','',''],['奴态','',''],['奴性','',''],['奴才','',''],['奴隶','',''],['奴隶主','',''],['奴隶主所有制','',''],['奴隶制','',''],['奴隶制度','',''],['奴隶性','',''],['奴隶社会','',''],['奴颜','',''],['奴颜婢睐','',''],['奴颜婢膝','',''],['奴颜婢色','',''],['奴颜媚骨','',''],['奶农','',''],['奶冻','',''],['奶制品','',''],['奶刷','',''],['奶厂','',''],['奶名','',''],['奶咀','',''],['奶品','',''],['奶品店','',''],['奶嘴','',''],['奶嘴儿','',''],['奶场','',''],['奶头','',''],['奶奶','',''],['奶妈','',''],['奶娘','',''],['奶子','',''],['奶孩','',''],['奶房','',''],['奶昔','',''],['奶杯','',''],['奶毛','',''],['奶水','',''],['奶汤','',''],['奶油','',''],['奶油菜花','',''],['奶油鸡蛋','',''],['奶液','',''],['奶牙','',''],['奶牛','',''],['奶牛场','',''],['奶瓶','',''],['奶疮','',''],['奶皮','',''],['奶积','',''],['奶站','',''],['奶类','',''],['奶粉','',''],['奶糕','',''],['奶糖','',''],['奶罩','',''],['奶羊','',''],['奶豆','',''],['奶酒','',''],['奶酥','',''],['奶酪','',''],['奶酪火锅','',''],['奶锅','',''],['奶黄包','',''],['奸人','',''],['奸人之雄','',''],['奸佞','',''],['奸党','',''],['奸匪','',''],['奸商','',''],['奸夫','',''],['奸夫淫妇','',''],['奸妇','',''],['奸宄','',''],['奸官','',''],['奸官污吏','',''],['奸尸','',''],['奸徒','',''],['奸恶','',''],['奸恶之徒','',''],['奸情','',''],['奸杀','',''],['奸民','',''],['奸污','',''],['奸淫','',''],['奸滑','',''],['奸犯','',''],['奸猾','',''],['奸笑','',''],['奸细','',''],['奸者','',''],['奸臣','',''],['奸计','',''],['奸诈','',''],['奸谋','',''],['奸贼','',''],['奸邪','',''],['奸险','',''],['奸雄','',''],['她们','',''],['她们的','',''],['她俩','',''],['她的','',''],['她经济','',''],['她自己','',''],['好一个','',''],['好不','',''],['好不好','',''],['好不容易','',''],['好东西','',''],['好中','',''],['好丹非素','',''],['好为人师','',''],['好主意','',''],['好久','',''],['好久不见','',''],['好书','',''],['好乱','',''],['好了','',''],['好争吵','',''],['好争论','',''],['好事','',''],['好事不出门','',''],['好事之徒','',''],['好事多磨','',''],['好事天悭','',''],['好事者','',''],['好些','',''],['好人','',''],['好人好事','',''],['好人榜','',''],['好似','',''],['好位','',''],['好使','',''],['好做','',''],['好像','',''],['好兵帅克','',''],['好冒险','',''],['好写','',''],['好几','',''],['好几个','',''],['好几年','',''],['好几次','',''],['好几天','',''],['好几里','',''],['好分数','',''],['好剑','',''],['好力宝','',''],['好办','',''],['好动','',''],['好半天','',''],['好去','',''],['好友','',''],['好发','',''],['好受','',''],['好吃','',''],['好吃懒做','',''],['好名声','',''],['好吗','',''],['好吧','',''],['好听','',''],['好吵架','',''],['好呀','',''],['好命','',''],['好哇','',''],['好哭','',''],['好啊','',''],['好啦','',''],['好善嫉恶','',''],['好善恶恶','',''],['好喝','',''],['好嗨','',''],['好嘛','',''],['好在','',''],['好坏','',''],['好坏不分','',''],['好声好气','',''],['好处','',''],['好处费','',''],['好多','',''],['好多个','',''],['好大喜功','',''],['好天','',''],['好天儿','',''],['好天气','',''],['好头','',''],['好奇','',''],['好奇会吃苦头的','',''],['好奇尚异','',''],['好奇心','',''],['好好','',''],['好好儿','',''],['好好先生','',''],['好好学习','',''],['好姑娘','',''],['好字','',''],['好孤立','',''],['好学','',''],['好学不倦','',''],['好学深思','',''],['好学生','',''],['好学近乎知','',''],['好孩子','',''],['好客','',''],['好家伙','',''],['好容易','',''],['好寒性','',''],['好寻','',''],['好尚','',''],['好市多','',''],['好帮手','',''],['好干','',''],['好干燥','',''],['好康','',''],['好开','',''],['好弄','',''],['好强','',''],['好得多','',''],['好得很','',''],['好心','',''],['好心人','',''],['好心倒做了驴肝肺','',''],['好心好意','',''],['好心肠','',''],['好怕的','',''],['好性儿','',''],['好恶','',''],['好恶心','',''],['好惹','',''],['好意','',''],['好意思','',''],['好感','',''],['好戏','',''],['好戏连台','',''],['好战','',''],['好手','',''],['好打','',''],['好打听','',''],['好批评','',''],['好找','',''],['好报','',''],['好抱怨','',''],['好搞','',''],['好收成','',''],['好故事百听不厌','',''],['好散','',''],['好整以暇','',''],['好斗','',''],['好新闻','',''],['好施','',''],['好施乐善','',''],['好施小惠','',''],['好日子','',''],['好时','',''],['好时机','',''],['好景','',''],['好景不长','',''],['好朋友','',''],['好望角','',''],['好本事','',''],['好来','',''],['好来坞','',''],['好来坞式','',''],['好极','',''],['好极了','',''],['好样','',''],['好样儿的','',''],['好样的','',''],['好梦想','',''],['好梦难圆','',''],['好梦难成','',''],['好棒','',''],['好植','',''],['好模仿','',''],['好歹','',''],['好死','',''],['好死不如赖活着','',''],['好比','',''],['好气','',''],['好气万千','',''],['好气儿','',''],['好气微生物','',''],['好氧','',''],['好汉','',''],['好汉做事','',''],['好汉当','',''],['好消息','',''],['好物','',''],['好玩','',''],['好玩儿','',''],['好球','',''],['好生','',''],['好生之德','',''],['好生恶杀','',''],['好用','',''],['好痛','',''],['好的','',''],['好的多','',''],['好看','',''],['好睇','',''],['好睡','',''],['好立克','',''],['好端端','',''],['好笑','',''],['好管','',''],['好紧','',''],['好聚好散','',''],['好胜','',''],['好胜心','',''],['好脾气','',''],['好自为之','',''],['好自矜夸','',''],['好色','',''],['好色之徒','',''],['好色者','',''],['好茶','',''],['好莱坞','',''],['好行小慧','',''],['好要','',''],['好言','',''],['好言好语','',''],['好让','',''],['好议论','',''],['好记','',''],['好讽刺','',''],['好评','',''],['好词','',''],['好话','',''],['好语似珠','',''],['好说','',''],['好说歹说','',''],['好说话儿','',''],['好说谎','',''],['好谀恶直','',''],['好谋善断','',''],['好谋而成','',''],['好象','',''],['好货','',''],['好赖','',''],['好走','',''],['好起来','',''],['好躺','',''],['好转','',''],['好辩','',''],['好过','',''],['好运','',''],['好运气','',''],['好运符','',''],['好还','',''],['好逸恶劳','',''],['好道','',''],['好酒','',''],['好酒贪杯','',''],['好问','',''],['好问则裕','',''],['好闲','',''],['好闻','',''],['好险','',''],['好难过','',''],['好饭不怕晚','',''],['好香','',''],['好马','',''],['好马不吃回头草','',''],['好高务远','',''],['好高骛远','',''],['好高鹜远','',''],['好鸟','',''],['好黑','',''],['如一','',''],['如上','',''],['如上所述','',''],['如下','',''],['如不','',''],['如不胜衣','',''],['如与','',''],['如丘而止','',''],['如丧考妣','',''],['如临大敌','',''],['如临深渊','',''],['如临深谷','',''],['如临渊谷','',''],['如之','',''],['如云','',''],['如人饮水','',''],['如今','',''],['如从','',''],['如以','',''],['如何','',''],['如何是好','',''],['如你','',''],['如假包换','',''],['如兄','',''],['如兄如弟','',''],['如入','',''],['如入无人之境','',''],['如其','',''],['如其所好','',''],['如冬','',''],['如冰','',''],['如出','',''],['如出一口','',''],['如出一辙','',''],['如切如磋','',''],['如初','',''],['如前','',''],['如厕','',''],['如同','',''],['如后','',''],['如君王','',''],['如图','',''],['如在','',''],['如坐云雾','',''],['如坐针毡','',''],['如坠烟海','',''],['如坠烟雾','',''],['如堕五里雾中','',''],['如堕烟雾','',''],['如字','',''],['如实','',''],['如对','',''],['如属','',''],['如履如临','',''],['如履平地','',''],['如履薄冰','',''],['如左右手','',''],['如常','',''],['如弃敝屣','',''],['如弓','',''],['如弟','',''],['如归','',''],['如影随形','',''],['如恶魔','',''],['如意','',''],['如意算盘','',''],['如意郎君','',''],['如愿','',''],['如愿以偿','',''],['如拾地芥','',''],['如持左券','',''],['如指诸掌','',''],['如按','',''],['如故','',''],['如数','',''],['如数家珍','',''],['如斯','',''],['如无','',''],['如无其事','',''],['如日中天','',''],['如日方中','',''],['如日方升','',''],['如旧','',''],['如昔','',''],['如春','',''],['如是','',''],['如是我闻','',''],['如是说','',''],['如月','',''],['如有','',''],['如有所失','',''],['如期','',''],['如来','',''],['如来佛','',''],['如果','',''],['如果不','',''],['如梦','',''],['如梦初觉','',''],['如梦初醒','',''],['如梦如醉','',''],['如梦方醒','',''],['如次','',''],['如歌','',''],['如此','',''],['如此之','',''],['如此来说','',''],['如此等等','',''],['如此而已','',''],['如此说来','',''],['如此这般','',''],['如死','',''],['如水','',''],['如汤沃雪','',''],['如汤泼雪','',''],['如汤浇雪','',''],['如汤灌雪','',''],['如法','',''],['如法泡制','',''],['如法炮制','',''],['如泣如诉','',''],['如洗','',''],['如渴','',''],['如火','',''],['如火如茶','',''],['如火如荼','',''],['如火晚霞','',''],['如烹小鲜','',''],['如焚','',''],['如牛负重','',''],['如狼似虎','',''],['如狼牧羊','',''],['如玉','',''],['如用','',''],['如电','',''],['如画','',''],['如痴似醉','',''],['如痴如梦','',''],['如痴如狂','',''],['如痴如醉','',''],['如真如幻','',''],['如神','',''],['如箭在弦','',''],['如簧之舌','',''],['如约','',''],['如胶似漆','',''],['如胶如漆','',''],['如胶投漆','',''],['如能','',''],['如臂使指','',''],['如芒刺背','',''],['如芒在背','',''],['如花','',''],['如花似月','',''],['如花似玉','',''],['如花似锦','',''],['如花如玉','',''],['如若','',''],['如茵','',''],['如草','',''],['如荼如火','',''],['如获至宝','',''],['如获至珍','',''],['如虎傅翼','',''],['如虎得翼','',''],['如虎添翼','',''],['如虎生翼','',''],['如蚁附膻','',''],['如蝇逐臭','',''],['如蝇附膻','',''],['如表','',''],['如被','',''],['如解倒悬','',''],['如许','',''],['如诉如泣','',''],['如诗如画','',''],['如说','',''],['如象','',''],['如蹈水火','',''],['如蹈汤火','',''],['如运诸掌','',''],['如这般','',''],['如遇','',''],['如醉初醒','',''],['如醉如梦','',''],['如醉如狂','',''],['如醉如痴','',''],['如醉方醒','',''],['如释重负','',''],['如金似玉','',''],['如针刺','',''],['如闻其声如见其人','',''],['如雨','',''],['如雷','',''],['如雷灌耳','',''],['如雷贯耳','',''],['如需','',''],['如面','',''],['如题','',''],['如风过耳','',''],['如飞','',''],['如饥','',''],['如饥似渴','',''],['如香油','',''],['如鱼似水','',''],['如鱼得水','',''],['如鸟兽散','',''],['如麻','',''],['妃嫔','',''],['妃子','',''],['妃子笑','',''],['妃色','',''],['妄下雌黄','',''],['妄为','',''],['妄人','',''],['妄作','',''],['妄加','',''],['妄加指责','',''],['妄加评论','',''],['妄动','',''],['妄取','',''],['妄图','',''],['妄念','',''],['妄想','',''],['妄想狂','',''],['妄断','',''],['妄求','',''],['妄求者','',''],['妄生穿凿','',''],['妄用','',''],['妄称','',''],['妄羡','',''],['妄自','',''],['妄自尊大','',''],['妄自菲薄','',''],['妄言','',''],['妄言妄听','',''],['妄评','',''],['妄语','',''],['妄说','',''],['妄谈祸福','',''],['妆奁','',''],['妆扮','',''],['妆新','',''],['妆点','',''],['妆饰','',''],['妇产','',''],['妇产医院','',''],['妇产科','',''],['妇人','',''],['妇人之仁','',''],['妇人帽','',''],['妇代会','',''],['妇儒','',''],['妇女','',''],['妇女会','',''],['妇女用','',''],['妇女病','',''],['妇女能顶半边天','',''],['妇女运动','',''],['妇姑勃溪','',''],['妇婴','',''],['妇孺','',''],['妇孺皆知','',''],['妇幼','',''],['妇幼保健','',''],['妇幼保健站','',''],['妇救会','',''],['妇权','',''],['妇短','',''],['妇科','',''],['妇职','',''],['妇联','',''],['妇道','',''],['妇道人家','',''],['妈咪','',''],['妈妈','',''],['妈子','',''],['妈的','',''],['妈眯','',''],['妈祖','',''],['妊妇','',''],['妊娠','',''],['妊娠前','',''],['妊娠试验','',''],['妍丽','',''],['妍皮痴骨','',''],['妒嫉','',''],['妒忌','',''],['妒恨','',''],['妒意','',''],['妒火中烧','',''],['妒能害贤','',''],['妒贤嫉能','',''],['妒贤忌能','',''],['妒贤疾能','',''],['妓女','',''],['妓院','',''],['妓馆','',''],['妖人','',''],['妖似','',''],['妖冶','',''],['妖女','',''],['妖妇','',''],['妖娆','',''],['妖媚','',''],['妖孽','',''],['妖形怪状','',''],['妖怪','',''],['妖教','',''],['妖术','',''],['妖气','',''],['妖法','',''],['妖物','',''],['妖由人兴','',''],['妖精','',''],['妖艳','',''],['妖言','',''],['妖言惑众','',''],['妖道','',''],['妖邪','',''],['妖里妖气','',''],['妖镜','',''],['妖雾','',''],['妖风','',''],['妖魔','',''],['妖魔鬼怪','',''],['妗子','',''],['妗母','',''],['妙不','',''],['妙不可言','',''],['妙事','',''],['妙人','',''],['妙句','',''],['妙品','',''],['妙哉','',''],['妙喻取譬','',''],['妙在不言中','',''],['妙境','',''],['妙处','',''],['妙处不传','',''],['妙妙熊历险记','',''],['妙思','',''],['妙想','',''],['妙手','',''],['妙手丹青','',''],['妙手回春','',''],['妙手空空','',''],['妙探寻凶','',''],['妙方','',''],['妙智慧','',''],['妙极','',''],['妙极了','',''],['妙棋','',''],['妙法','',''],['妙法莲华经','',''],['妙理','',''],['妙用','',''],['妙笔','',''],['妙笔生花','',''],['妙策','',''],['妙算','',''],['妙绝','',''],['妙绝一时','',''],['妙绝时人','',''],['妙舞清歌','',''],['妙药','',''],['妙言要道','',''],['妙计','',''],['妙论','',''],['妙诀','',''],['妙语','',''],['妙语如珠','',''],['妙语横生','',''],['妙语解颐','',''],['妙语连珠','',''],['妙趣','',''],['妙趣横溢','',''],['妙趣横生','',''],['妙辞','',''],['妙龄','',''],['妞妞','',''],['妥为','',''],['妥协','',''],['妥否','',''],['妥善','',''],['妥善处理','',''],['妥善安置','',''],['妥善解决','',''],['妥坝','',''],['妥坝县','',''],['妥妥','',''],['妥妥贴贴','',''],['妥实','',''],['妥帖','',''],['妥当','',''],['妥当性','',''],['妥瑞症','',''],['妥用','',''],['妥贴','',''],['妥靠','',''],['妨功害能','',''],['妨害','',''],['妨害者','',''],['妨碍','',''],['妨碍球','',''],['妨碍者','',''],['妨诉','',''],['妩媚','',''],['妮可・基德曼','',''],['妮子','',''],['妮维娅','',''],['妮维雅','',''],['妯娌','',''],['妲己','',''],['妹夫','',''],['妹妹','',''],['妹婿','',''],['妹子','',''],['妻儿','',''],['妻儿老小','',''],['妻女','',''],['妻妾','',''],['妻子','',''],['妻子管得严','',''],['妻孥','',''],['妻室','',''],['妻小','',''],['妻离子散','',''],['妻管严','',''],['妻舅','',''],['妾侍','',''],['妾妇','',''],['妾身','',''],['姆佬','',''],['姆佬族','',''],['姆妈','',''],['姆巴巴纳','',''],['姆拉迪奇','',''],['姆指','',''],['姊丈','',''],['姊夫','',''],['姊妹','',''],['姊姊','',''],['姊归县','',''],['始业','',''],['始乱终弃','',''],['始于','',''],['始于足下','',''],['始作俑者','',''],['始动','',''],['始发','',''],['始发站','',''],['始定','',''],['始建','',''],['始建于','',''],['始料','',''],['始料所及','',''],['始料未及','',''],['始新世','',''],['始新纪','',''],['始新统','',''],['始末','',''],['始点','',''],['始生代','',''],['始皇','',''],['始祖','',''],['始祖马','',''],['始祖鸟','',''],['始终','',''],['始终一贯','',''],['始终不懈','',''],['始终不渝','',''],['始终保持','',''],['始终如一','',''],['始能','',''],['始自','',''],['始行','',''],['姐丈','',''],['姐们儿','',''],['姐儿','',''],['姐儿们','',''],['姐夫','',''],['姐妹','',''],['姐妹班','',''],['姐姐','',''],['姐弟','',''],['姑丈','',''],['姑且','',''],['姑夫','',''],['姑奶','',''],['姑奶奶','',''],['姑妄','',''],['姑妄听之','',''],['姑妄言之','',''],['姑妄试之','',''],['姑妈','',''],['姑姑','',''],['姑姥姥','',''],['姑娘','',''],['姑娘儿','',''],['姑娘家','',''],['姑婆','',''],['姑嫂','',''],['姑子','',''],['姑宽','',''],['姑射神人','',''],['姑息','',''],['姑息养奸','',''],['姑息疗法','',''],['姑息者','',''],['姑息迁就','',''],['姑息遗患','',''],['姑母','',''],['姑父','',''],['姑爷','',''],['姑爹','',''],['姑置勿论','',''],['姑老爷','',''],['姑舅','',''],['姑表','',''],['姒文命','',''],['姓名','',''],['姓名权','',''],['姓氏','',''],['委为','',''],['委付','',''],['委以','',''],['委任','',''],['委任状','',''],['委任统治','',''],['委任者','',''],['委佗','',''],['委内瑞拉独立战争','',''],['委内瑞拉马脑炎病毒','',''],['委制','',''],['委办','',''],['委员','',''],['委员会','',''],['委员会会议','',''],['委员长','',''],['委外','',''],['委委屈屈','',''],['委婉','',''],['委婉词','',''],['委婉语','',''],['委宛','',''],['委实','',''],['委屈','',''],['委屈周全','',''],['委屈成全','',''],['委常之惧','',''],['委托','',''],['委托书','',''],['委托人','',''],['委托物','',''],['委托者','',''],['委曲','',''],['委曲求全','',''],['委派','',''],['委用','',''],['委罪','',''],['委聘','',''],['委肉虎蹊','',''],['委蛇','',''],['委身','',''],['委过','',''],['委部','',''],['委重投艰','',''],['委靡','',''],['委靡不振','',''],['委顿','',''],['姗姗','',''],['姗姗来迟','',''],['姘夫','',''],['姘头','',''],['姘妇','',''],['姘居','',''],['姘识','',''],['姚思廉','',''],['姚文元','',''],['姚明','',''],['姚滨','',''],['姚雪垠','',''],['姚黄魏紫','',''],['姜丝','',''],['姜味','',''],['姜太公','',''],['姜太公钓鱼','',''],['姜子牙','',''],['姜文','',''],['姜末','',''],['姜汁','',''],['姜汤','',''],['姜片','',''],['姜片虫','',''],['姜石年','',''],['姜粉','',''],['姜糖','',''],['姜芋','',''],['姜还是老的辣','',''],['姜饼','',''],['姜黄','',''],['姜黄色','',''],['姣好','',''],['姣生贯养','',''],['姣美','',''],['姥姥','',''],['姥娘','',''],['姥爷','',''],['姥鲨','',''],['姨丈','',''],['姨儿','',''],['姨太','',''],['姨太太','',''],['姨夫','',''],['姨奶奶','',''],['姨妈','',''],['姨妹','',''],['姨姐','',''],['姨姥姥','',''],['姨娘','',''],['姨婆','',''],['姨子','',''],['姨母','',''],['姨父','',''],['姨甥男女','',''],['姨表','',''],['姫路市','',''],['姬妾','',''],['姬松茸','',''],['姬路城','',''],['姬鼠','',''],['姮娥','',''],['姹女','',''],['姹紫嫣红','',''],['姻亚','',''],['姻亲','',''],['姻娅','',''],['姻缘','',''],['姿势','',''],['姿容','',''],['姿态','',''],['姿态婀娜','',''],['姿色','',''],['威严','',''],['威仪','',''],['威仪孔时','',''],['威信扫地','',''],['威凤一羽','',''],['威利','',''],['威利斯','',''],['威利诱','',''],['威力','',''],['威势','',''],['威化','',''],['威化饼干','',''],['威厉','',''],['威压','',''],['威名','',''],['威吓','',''],['威吓性','',''],['威吓者','',''],['威呵','',''],['威基基','',''],['威士','',''],['威士忌','',''],['威士忌酒','',''],['威奇托','',''],['威妥玛','',''],['威妥玛拼法','',''],['威妥玛拼音','',''],['威宁县','',''],['威客','',''],['威容','',''],['威尊命贱','',''],['威尔士语','',''],['威尔特郡','',''],['威尔逊','',''],['威尼斯','',''],['威尼斯商人','',''],['威州镇','',''],['威廉','',''],['威廉・福克纳','',''],['威廉・莎士比亚','',''],['威廉斯堡','',''],['威德','',''],['威慑','',''],['威慑力量','',''],['威慑理论','',''],['威振天下','',''],['威斯康星','',''],['威斯康星州','',''],['威斯康辛','',''],['威斯敏斯特教堂','',''],['威显','',''],['威服','',''],['威望','',''],['威权','',''],['威棱','',''],['威武','',''],['威武不屈','',''],['威氏注音法','',''],['威法','',''],['威海卫','',''],['威灵','',''],['威灵顿','',''],['威烈','',''],['威猛','',''],['威玛','',''],['威玛共和国','',''],['威玛拼法','',''],['威玛拼音','',''],['威福由己','',''],['威福自己','',''],['威而不猛','',''],['威而钢','',''],['威胁','',''],['威胁利诱','',''],['威胁性','',''],['威胁要','',''],['威虎','',''],['威视','',''],['威赫','',''],['威迫','',''],['威迫利诱','',''],['威逼','',''],['威逼利诱','',''],['威重','',''],['威震','',''],['威震天下','',''],['威风','',''],['威风一羽','',''],['威风凛凛','',''],['威风扫地','',''],['威风祥麟','',''],['威骇','',''],['娃儿','',''],['娃娃','',''],['娃娃亲','',''],['娃娃兵','',''],['娃娃生','',''],['娃娃脸','',''],['娃娃装','',''],['娃娃车','',''],['娃娃鱼','',''],['娃子','',''],['娃脸','',''],['娄子','',''],['娄宿','',''],['娄底地区','',''],['娄族','',''],['娄星','',''],['娇儿','',''],['娇养','',''],['娇嗔','',''],['娇妻','',''],['娇娃','',''],['娇娆','',''],['娇媚','',''],['娇嫩','',''],['娇宠','',''],['娇客','',''],['娇小','',''],['娇小玲珑','',''],['娇弱','',''],['娇态','',''],['娇惯','',''],['娇惰','',''],['娇憨','',''],['娇柔','',''],['娇气','',''],['娇气十足','',''],['娇滴滴','',''],['娇生惯养','',''],['娇痴','',''],['娇红','',''],['娇纵','',''],['娇美','',''],['娇羞','',''],['娇翠','',''],['娇艳','',''],['娇贵','',''],['娇黄','',''],['娈俦凤侣','',''],['娈童','',''],['娈童者','',''],['娉婷','',''],['娑罗双树','',''],['娑罗树','',''],['娓娓','',''],['娓娓不倦','',''],['娓娓动听','',''],['娓娓可听','',''],['娓娓而谈','',''],['娓娓道来','',''],['娘亲','',''],['娘儿','',''],['娘儿们','',''],['娘姨','',''],['娘娘','',''],['娘娘庙','',''],['娘娘腔','',''],['娘子','',''],['娘子军','',''],['娘家','',''],['娘家姓','',''],['娘惹','',''],['娘树','',''],['娘炮','',''],['娘胎','',''],['娘腔','',''],['娘舅','',''],['娘要嫁人','',''],['娜塔莉','',''],['娜娜','',''],['娟娟','',''],['娟秀','',''],['娣姒','',''],['娥眉','',''],['娩出','',''],['娭姐','',''],['娱乐','',''],['娱乐中心','',''],['娱乐区','',''],['娱乐场','',''],['娱乐场所','',''],['娱乐室','',''],['娱乐性','',''],['娱乐活动','',''],['娱乐圈','',''],['娱乐界','',''],['娱人','',''],['娱遣','',''],['娴淑','',''],['娴熟','',''],['娴雅','',''],['娴静','',''],['娶亲','',''],['娶你','',''],['娶到','',''],['娶妻','',''],['娶媳','',''],['娶媳妇','',''],['娼女','',''],['娼妇','',''],['娼妓','',''],['娼家','',''],['娼寮','',''],['婀娜','',''],['婆姨','',''],['婆娑','',''],['婆娘','',''],['婆婆','',''],['婆婆妈妈','',''],['婆婆家','',''],['婆媳','',''],['婆子','',''],['婆家','',''],['婆心','',''],['婆母','',''],['婆罗','',''],['婆罗洲','',''],['婆罗浮屠','',''],['婆罗门','',''],['婆罗门教','',''],['婉商','',''],['婉如','',''],['婉妙','',''],['婉娩','',''],['婉婉','',''],['婉拒','',''],['婉称','',''],['婉约','',''],['婉言','',''],['婉言谢绝','',''],['婉词','',''],['婉语','',''],['婉谢','',''],['婉转','',''],['婉辞','',''],['婉顺','',''],['婊子','',''],['婕妤','',''],['婚丧','',''],['婚丧嫁娶','',''],['婚书','',''],['婚事','',''],['婚事半成全','',''],['婚事新办','',''],['婚假','',''],['婚典','',''],['婚前','',''],['婚前性行为','',''],['婚前财产公证','',''],['婚友','',''],['婚后','',''],['婚否','',''],['婚外','',''],['婚外恋','',''],['婚外情','',''],['婚姻','',''],['婚姻介绍所','',''],['婚姻关系','',''],['婚姻制度','',''],['婚姻大事','',''],['婚姻法','',''],['婚姻登记','',''],['婚姻自主','',''],['婚姻自由','',''],['婚姻调解','',''],['婚嫁','',''],['婚宴','',''],['婚庆','',''],['婚式','',''],['婚恋','',''],['婚期','',''],['婚生子女','',''],['婚礼','',''],['婚神星','',''],['婚筵','',''],['婚约','',''],['婚纱','',''],['婚纱摄影','',''],['婚者','',''],['婚诗','',''],['婚配','',''],['婚龄','',''],['婢仆','',''],['婢作夫人','',''],['婢女','',''],['婢奴','',''],['婢学夫人','',''],['婴儿','',''],['婴儿手推车','',''],['婴儿期','',''],['婴儿潮','',''],['婴儿猝死综合症','',''],['婴儿车','',''],['婴儿鞋','',''],['婴孩','',''],['婴幼儿','',''],['婵娟','',''],['婵媛','',''],['婶儿','',''],['婶娘','',''],['婶婆','',''],['婶婶','',''],['婶子','',''],['婶母','',''],['婷婷','',''],['婹嫋','',''],['婹袅','',''],['婹褭','',''],['婺剧','',''],['婺城','',''],['婺女','',''],['媒人','',''],['媒介','',''],['媒介物','',''],['媒介者','',''],['媒体','',''],['媒体报导','',''],['媒体接口连接器','',''],['媒体自由','',''],['媒体访问控制','',''],['媒儿','',''],['媒妁','',''],['媒婆','',''],['媒怨','',''],['媒染','',''],['媒染剂','',''],['媒界','',''],['媒质','',''],['媒鸟','',''],['媚人','',''],['媚俗','',''],['媚外','',''],['媚娃','',''],['媚态','',''],['媚惑','',''],['媚眼','',''],['媚笑','',''],['媚词','',''],['媚骨','',''],['媲美','',''],['媳妇','',''],['媳妇儿','',''],['媵侍','',''],['媾和','',''],['媾疫','',''],['嫁人','',''],['嫁出','',''],['嫁女','',''],['嫁妆','',''],['嫁妆箱','',''],['嫁娶','',''],['嫁接','',''],['嫁狗随狗','',''],['嫁祸','',''],['嫁祸于','',''],['嫁祸于人','',''],['嫁给','',''],['嫁资','',''],['嫁鸡逐鸡','',''],['嫁鸡随鸡','',''],['嫂夫人','',''],['嫂嫂','',''],['嫂子','',''],['嫉妒','',''],['嫉妒者','',''],['嫉恨','',''],['嫉恶好善','',''],['嫉恶如仇','',''],['嫉贤妒能','',''],['嫌厌','',''],['嫌弃','',''],['嫌忌','',''],['嫌怨','',''],['嫌恨','',''],['嫌恶','',''],['嫌憎','',''],['嫌气微生物','',''],['嫌犯','',''],['嫌猜','',''],['嫌疑','',''],['嫌疑人','',''],['嫌疑犯','',''],['嫌肥挑瘦','',''],['嫌贫爱富','',''],['嫌隙','',''],['嫏嬛','',''],['嫔妃','',''],['嫔相','',''],['嫖妓','',''],['嫖娼','',''],['嫖客','',''],['嫖宿','',''],['嫖资','',''],['嫠不恤纬','',''],['嫠妇','',''],['嫠纬之忧','',''],['嫠节','',''],['嫡亲','',''],['嫡传','',''],['嫡堂','',''],['嫡子','',''],['嫡母','',''],['嫡派','',''],['嫡系','',''],['嫡裔','',''],['嫣然','',''],['嫣然一笑','',''],['嫣红','',''],['嫦娥','',''],['嫩叶','',''],['嫩枝','',''],['嫩江地区','',''],['嫩煮','',''],['嫩白','',''],['嫩的','',''],['嫩皮','',''],['嫩绿','',''],['嫩肉','',''],['嫩芽','',''],['嫩苗','',''],['嫩苗龟','',''],['嫩黄','',''],['嫪毐','',''],['嬉乐','',''],['嬉嬉','',''],['嬉弄','',''],['嬉戏','',''],['嬉戏著','',''],['嬉水','',''],['嬉游','',''],['嬉皮','',''],['嬉皮士','',''],['嬉皮笑脸','',''],['嬉笑','',''],['嬉笑怒骂','',''],['嬉耍','',''],['嬉装','',''],['嬉闹','',''],['嬗变','',''],['嬴政','',''],['嬷嬷','',''],['孀妇','',''],['孀婺','',''],['孀居','',''],['孀闺','',''],['子不语怪','',''],['子丑','',''],['子丑寅卯','',''],['子串','',''],['子为父隐','',''],['子书','',''],['子产','',''],['子京','',''],['子代','',''],['子儿','',''],['子公司','',''],['子函数','',''],['子午','',''],['子午卯酉','',''],['子午圈','',''],['子午线','',''],['子午莲','',''],['子午道','',''],['子口','',''],['子句','',''],['子叶','',''],['子嗣','',''],['子囊','',''],['子囊菌','',''],['子城','',''],['子埝','',''],['子域','',''],['子堤','',''],['子多','',''],['子夜歌','',''],['子女','',''],['子女教育','',''],['子女玉帛','',''],['子妇','',''],['子婿','',''],['子子孙孙','',''],['子孙','',''],['子孙后代','',''],['子孙娘娘','',''],['子孝父慈','',''],['子实','',''],['子宫','',''],['子宫体癌','',''],['子宫内','',''],['子宫内避孕器','',''],['子宫壁','',''],['子宫外','',''],['子宫学','',''],['子宫炎','',''],['子宫环','',''],['子宫病','',''],['子宫肌瘤','',''],['子宫脱垂','',''],['子宫颈','',''],['子宫颈癌','',''],['子层','',''],['子弟','',''],['子弟书','',''],['子弟兵','',''],['子弦','',''],['子弹','',''],['子弹夹','',''],['子弹带','',''],['子弹火车','',''],['子息','',''],['子房','',''],['子曰','',''],['子曰诗云','',''],['子棉','',''],['子模型','',''],['子母弹','',''],['子母扣儿','',''],['子母炮弹','',''],['子母炸弹','',''],['子母船运输','',''],['子母钟','',''],['子民','',''],['子爵','',''],['子畜','',''],['子痫','',''],['子癫前症','',''],['子目','',''],['子目录','',''],['子程序','',''],['子空间','',''],['子类','',''],['子粒','',''],['子精','',''],['子系统','',''],['子细胞','',''],['子网','',''],['子网屏蔽码','',''],['子群','',''],['子虚','',''],['子虚乌有','',''],['子蜂','',''],['子规','',''],['子设备','',''],['子贡','',''],['子路','',''],['子部','',''],['子金','',''],['子集','',''],['子集合','',''],['子音','',''],['子项','',''],['子鸡','',''],['子鼠','',''],['孑孑','',''],['孑孑为义','',''],['孑孓','',''],['孑影孤单','',''],['孑然','',''],['孑然一身','',''],['孑然无依','',''],['孑立','',''],['孑立无依','',''],['孑身','',''],['孑遗','',''],['孔丘','',''],['孔丛子','',''],['孔东','',''],['孔乙己','',''],['孔口','',''],['孔圣人','',''],['孔型','',''],['孔夫子','',''],['孔子','',''],['孔子学院','',''],['孔子家语','',''],['孔孟','',''],['孔孟之道','',''],['孔学','',''],['孔席墨突','',''],['孔庙','',''],['孔府','',''],['孔径','',''],['孔戏','',''],['孔教','',''],['孔数','',''],['孔斯贝格','',''],['孔方兄','',''],['孔明','',''],['孔明灯','',''],['孔林','',''],['孔武有力','',''],['孔洞','',''],['孔眼','',''],['孔穴','',''],['孔类','',''],['孔线','',''],['孔融','',''],['孔道','',''],['孔门','',''],['孔隙','',''],['孔隙比','',''],['孔雀','',''],['孔雀座','',''],['孔雀开屏','',''],['孔雀河','',''],['孔雀王朝','',''],['孔雀石','',''],['孔雀绿','',''],['孔雀草','',''],['孕产','',''],['孕前','',''],['孕吐','',''],['孕妇','',''],['孕妇装','',''],['孕期','',''],['孕激素','',''],['孕畜','',''],['孕穗','',''],['孕育','',''],['孕育处','',''],['字串','',''],['字义','',''],['字义上','',''],['字书','',''],['字体','',''],['字体盒','',''],['字儿','',''],['字元','',''],['字元集','',''],['字典','',''],['字前','',''],['字区','',''],['字句','',''],['字号','',''],['字后','',''],['字图','',''],['字型','',''],['字处理','',''],['字头','',''],['字字','',''],['字字珠玉','',''],['字尾','',''],['字帖','',''],['字帖儿','',''],['字幕','',''],['字库','',''],['字形','',''],['字形学','',''],['字形档','',''],['字据','',''],['字数','',''],['字斟句酌','',''],['字条','',''],['字样','',''],['字根','',''],['字根合体字','',''],['字根表','',''],['字根通用码','',''],['字框','',''],['字模','',''],['字正腔圆','',''],['字段','',''],['字母','',''],['字母表','',''],['字母顺序','',''],['字母顺序概率','',''],['字汇','',''],['字汇判断任务','',''],['字源','',''],['字状','',''],['字画','',''],['字盘','',''],['字眼','',''],['字码','',''],['字码儿','',''],['字稿','',''],['字符','',''],['字符串','',''],['字符集','',''],['字素','',''],['字纸','',''],['字纸篓','',''],['字纸篓子','',''],['字组','',''],['字脚','',''],['字节','',''],['字节数','',''],['字表','',''],['字词','',''],['字译','',''],['字语','',''],['字调','',''],['字谜','',''],['字贴','',''],['字距','',''],['字迹','',''],['字里','',''],['字里行间','',''],['字长','',''],['字间','',''],['字集','',''],['字面','',''],['字面上','',''],['字音','',''],['字频','',''],['字首','',''],['存下','',''],['存为','',''],['存于','',''],['存亡','',''],['存亡攸关','',''],['存亡断绝','',''],['存亡未卜','',''],['存亡绝续','',''],['存体','',''],['存储','',''],['存储卡','',''],['存储器','',''],['存储处','',''],['存储容量','',''],['存储栈','',''],['存入','',''],['存区','',''],['存十一于一百','',''],['存单','',''],['存卷','',''],['存取','',''],['存取时间','',''],['存在','',''],['存在主义','',''],['存在论','',''],['存处','',''],['存完','',''],['存小异','',''],['存底','',''],['存异','',''],['存心','',''],['存户','',''],['存托凭证','',''],['存执','',''],['存折','',''],['存抚','',''],['存据','',''],['存摺','',''],['存放','',''],['存放处','',''],['存有','',''],['存有偏见','',''],['存期','',''],['存查','',''],['存栏','',''],['存栏数','',''],['存样','',''],['存根','',''],['存案','',''],['存档','',''],['存款','',''],['存款人','',''],['存款准备金','',''],['存款准备金率','',''],['存款单','',''],['存款簿','',''],['存款者','',''],['存款证','',''],['存款额','',''],['存活','',''],['存活率','',''],['存照','',''],['存物','',''],['存留','',''],['存疑','',''],['存盘','',''],['存积','',''],['存立','',''],['存管','',''],['存簿','',''],['存粮','',''],['存续','',''],['存而不论','',''],['存记','',''],['存证','',''],['存词','',''],['存货','',''],['存贮','',''],['存贮器','',''],['存贷','',''],['存贷款','',''],['存身','',''],['存车','',''],['存车场','',''],['存车处','',''],['存量','',''],['存钱','',''],['存钱罐','',''],['存项','',''],['存食','',''],['孙中山','',''],['孙传芳','',''],['孙儿','',''],['孙坚','',''],['孙大圣','',''],['孙女','',''],['孙女儿','',''],['孙女婿','',''],['孙婿','',''],['孙媳','',''],['孙媳夫','',''],['孙媳妇','',''],['孙子','',''],['孙子兵法','',''],['孙子定理','',''],['孙思邈','',''],['孙恩起义','',''],['孙悟空','',''],['孙悦','',''],['孙文主义学会','',''],['孙权','',''],['孙武','',''],['孙武子','',''],['孙毓棠','',''],['孙燕姿','',''],['孙犁','',''],['孙策','',''],['孙继海','',''],['孙膑','',''],['孙膑兵法','',''],['孙行者','',''],['孙诛','',''],['孙逸仙','',''],['孛星','',''],['孜孜','',''],['孜孜不倦','',''],['孜孜不怠','',''],['孜孜以求','',''],['孜孜矻矻','',''],['孜然','',''],['孜然芹','',''],['孝南','',''],['孝女','',''],['孝子','',''],['孝子慈孙','',''],['孝子贤孙','',''],['孝子顺孙','',''],['孝幔','',''],['孝廉','',''],['孝心','',''],['孝思不匮','',''],['孝悌','',''],['孝悌忠信','',''],['孝感地区','',''],['孝成王','',''],['孝敬','',''],['孝服','',''],['孝男','',''],['孝祥','',''],['孝经','',''],['孝经起序','',''],['孝老','',''],['孝肃','',''],['孝行','',''],['孝衣','',''],['孝道','',''],['孝顺','',''],['孟买','',''],['孟买市','',''],['孟什维主义','',''],['孟什维克','',''],['孟加','',''],['孟加拉','',''],['孟加拉人民共和国','',''],['孟加拉共和国','',''],['孟加拉湾','',''],['孟加拉语','',''],['孟县','',''],['孟姜女','',''],['孟子','',''],['孟尝君','',''],['孟德尔主义','',''],['孟德斯鸠','',''],['孟思诚','',''],['孟村','',''],['孟村县','',''],['孟浩然','',''],['孟浪','',''],['孟禄主义','',''],['孟良崮','',''],['孟良崮战役','',''],['孟菲斯','',''],['孟诗韩笔','',''],['孟轲','',''],['孟连县','',''],['孟郊','',''],['孢囊','',''],['孢子','',''],['孢子囊','',''],['孢子植物','',''],['季世','',''],['季会','',''],['季候','',''],['季候风','',''],['季军','',''],['季冬','',''],['季刊','',''],['季初','',''],['季后赛','',''],['季夏','',''],['季子','',''],['季孙之忧','',''],['季布一诺','',''],['季常之惧','',''],['季度','',''],['季报','',''],['季春','',''],['季末','',''],['季父','',''],['季相','',''],['季票','',''],['季稻','',''],['季经','',''],['季羡林','',''],['季肋','',''],['季节','',''],['季节差价','',''],['季节性','',''],['季节洄游','',''],['季节风','',''],['季花','',''],['季莫申科','',''],['季诺','',''],['季路','',''],['季雨林','',''],['季风','',''],['季风气候','',''],['孤云野鹤','',''],['孤傲','',''],['孤僻','',''],['孤儿','',''],['孤儿寡妇','',''],['孤儿寡母','',''],['孤儿药','',''],['孤儿院','',''],['孤军','',''],['孤军作战','',''],['孤军奋战','',''],['孤军深入','',''],['孤单','',''],['孤哀子','',''],['孤女','',''],['孤孀','',''],['孤子','',''],['孤孑','',''],['孤孑特立','',''],['孤孤单单','',''],['孤家寡人','',''],['孤寂','',''],['孤寒','',''],['孤寡','',''],['孤寡老人','',''],['孤山','',''],['孤岛','',''],['孤峰','',''],['孤形单影','',''],['孤形只影','',''],['孤形吊影','',''],['孤征','',''],['孤拐','',''],['孤拔','',''],['孤掌难鸣','',''],['孤本','',''],['孤注一掷','',''],['孤点','',''],['孤犊触乳','',''],['孤独','',''],['孤独于世','',''],['孤独心理学','',''],['孤独感','',''],['孤独无援','',''],['孤独症','',''],['孤立','',''],['孤立主义','',''],['孤立子','',''],['孤立子波','',''],['孤立无助','',''],['孤立无援','',''],['孤立木','',''],['孤立波','',''],['孤立点','',''],['孤老','',''],['孤胆','',''],['孤胆英雄','',''],['孤臣孽子','',''],['孤芳自赏','',''],['孤苦','',''],['孤苦伶仃','',''],['孤苦零丁','',''],['孤行','',''],['孤行己意','',''],['孤行己见','',''],['孤证不立','',''],['孤负','',''],['孤贫','',''],['孤身','',''],['孤身一人','',''],['孤身只影','',''],['孤闻','',''],['孤陋','',''],['孤陋寡闻','',''],['孤雌生殖','',''],['孤雏腐鼠','',''],['孤零','',''],['孤零零','',''],['孤高','',''],['孤高自许','',''],['孤魂','',''],['孤鸟','',''],['孤鸾寡鹤','',''],['孤鸾年','',''],['学业','',''],['学业有成','',''],['学乖','',''],['学习','',''],['学习体会','',''],['学习刻苦','',''],['学习方法','',''],['学习材料','',''],['学习班','',''],['学习者','',''],['学习计划','',''],['学了','',''],['学人','',''],['学以致用','',''],['学优才赡','',''],['学优而仕','',''],['学会','',''],['学会院士','',''],['学位','',''],['学位论文','',''],['学位证书','',''],['学作','',''],['学修','',''],['学先进','',''],['学养','',''],['学军','',''],['学分','',''],['学分制','',''],['学分小时','',''],['学到','',''],['学到老','',''],['学制','',''],['学前','',''],['学前教育','',''],['学前期','',''],['学力','',''],['学区','',''],['学历','',''],['学友','',''],['学史','',''],['学号','',''],['学名','',''],['学呀','',''],['学员','',''],['学园','',''],['学坏','',''],['学堂','',''],['学塾','',''],['学士','',''],['学士学位','',''],['学好','',''],['学如逆水行舟','',''],['学妹','',''],['学姐','',''],['学子','',''],['学学','',''],['学家','',''],['学富五车','',''],['学工','',''],['学年','',''],['学府','',''],['学弟','',''],['学徒','',''],['学徒工','',''],['学得','',''],['学成','',''],['学成回国','',''],['学成归国','',''],['学所','',''],['学报','',''],['学摸','',''],['学政','',''],['学无常师','',''],['学无止境','',''],['学时','',''],['学有','',''],['学有所成','',''],['学有所用','',''],['学有所长','',''],['学期','',''],['学术','',''],['学术上','',''],['学术交流','',''],['学术会议','',''],['学术团体','',''],['学术年会','',''],['学术思想','',''],['学术性','',''],['学术报告','',''],['学术无涯','',''],['学术水平','',''],['学术界','',''],['学术研究','',''],['学术研讨会','',''],['学术自由','',''],['学术观点','',''],['学术讨论会','',''],['学术论文','',''],['学杂','',''],['学杂费','',''],['学来','',''],['学校','',''],['学校教育','',''],['学校行政','',''],['学校里','',''],['学校间','',''],['学样','',''],['学棍','',''],['学步','',''],['学步邯郸','',''],['学气','',''],['学法','',''],['学派','',''],['学浅才疏','',''],['学测','',''],['学海','',''],['学海无涯','',''],['学海泛舟','',''],['学潮','',''],['学然后知不足','',''],['学理','',''],['学理上','',''],['学生','',''],['学生会','',''],['学生族','',''],['学生界','',''],['学生组织','',''],['学生装','',''],['学生证','',''],['学生运动','',''],['学用','',''],['学用一致','',''],['学田','',''],['学甲','',''],['学甲镇','',''],['学界','',''],['学疏才浅','',''],['学监','',''],['学社','',''],['学科','',''],['学科分类','',''],['学科知识','',''],['学究','',''],['学究天人','',''],['学究式','',''],['学究气','',''],['学童','',''],['学籍','',''],['学级','',''],['学者','',''],['学而','',''],['学而不厌','',''],['学而不思则罔','',''],['学而优则仕','',''],['学联','',''],['学自','',''],['学舌','',''],['学舍','',''],['学艺','',''],['学苑','',''],['学藉','',''],['学衔','',''],['学识','',''],['学识上','',''],['学话','',''],['学语','',''],['学说','',''],['学贯天人','',''],['学费','',''],['学走','',''],['学起','',''],['学车','',''],['学过','',''],['学运','',''],['学部','',''],['学部委员','',''],['学长','',''],['学问','',''],['学阀','',''],['学际天人','',''],['学院','',''],['学院派','',''],['学院间','',''],['学雷锋','',''],['学非所用','',''],['学风','',''],['学龄','',''],['学龄儿童','',''],['学龄前','',''],['学龄前儿童','',''],['孩似','',''],['孩儿','',''],['孩子','',''],['孩子们','',''],['孩子似','',''],['孩子头','',''],['孩子气','',''],['孩提','',''],['孩童','',''],['孩童们','',''],['孪生','',''],['孪生兄弟','',''],['孪生姐妹','',''],['孬种','',''],['孰真孰假','',''],['孰知','',''],['孰能生巧','',''],['孰若','',''],['孱头','',''],['孱弱','',''],['孳乳','',''],['孳孳','',''],['孳生','',''],['孵出','',''],['孵化','',''],['孵化器','',''],['孵化场','',''],['孵化期','',''],['孵卵','',''],['孵卵器','',''],['孵小鸡','',''],['孵成','',''],['孵育','',''],['孵蛋','',''],['孺人','',''],['孺子','',''],['孺子可教','',''],['孺子牛','',''],['孽子','',''],['孽报','',''],['孽海花','',''],['孽畜','',''],['孽种','',''],['孽缘','',''],['孽障','',''],['宁为','',''],['宁为玉碎','',''],['宁为玉碎不为瓦全','',''],['宁为鸡口不为牛后','',''],['宁冈','',''],['宁冈县','',''],['宁可','',''],['宁夏','',''],['宁夏省','',''],['宁夏自治区','',''],['宁宗','',''],['宁定淡泊','',''],['宁左勿右','',''],['宁帖','',''],['宁德地区','',''],['宁愿','',''],['宁日','',''],['宁有','',''],['宁死','',''],['宁死不屈','',''],['宁江','',''],['宁波地区','',''],['宁洱','',''],['宁洱县','',''],['宁洱哈尼族彝族自治县','',''],['宁滥毋缺','',''],['宁神剂','',''],['宁缺','',''],['宁缺勿滥','',''],['宁缺毋滥','',''],['宁肯','',''],['宁蒗','',''],['宁蒗县','',''],['宁要','',''],['宁谧','',''],['宁边','',''],['宁都起义','',''],['宁酸','',''],['宁靖','',''],['宁静','',''],['宁静致远','',''],['宁馨儿','',''],['它们','',''],['它山之石','',''],['它本身','',''],['它被','',''],['宅区','',''],['宅地','',''],['宅基','',''],['宅基地','',''],['宅女','',''],['宅子','',''],['宅度假','',''],['宅心忠厚','',''],['宅男','',''],['宅第','',''],['宅经','',''],['宅舍','',''],['宅邸','',''],['宅配','',''],['宅门','',''],['宅院','',''],['宇宙','',''],['宇宙号','',''],['宇宙学','',''],['宇宙学家','',''],['宇宙射线','',''],['宇宙尘','',''],['宇宙性','',''],['宇宙火箭','',''],['宇宙生成论','',''],['宇宙空间','',''],['宇宙线','',''],['宇宙线物理学','',''],['宇宙线高能物理','',''],['宇宙观','',''],['宇宙论','',''],['宇宙速度','',''],['宇宙飞船','',''],['宇文','',''],['宇普西龙','',''],['宇航','',''],['宇航员','',''],['宇航学','',''],['宇航局','',''],['宇航服','',''],['宇航站','',''],['守业','',''],['守丧','',''],['守份','',''],['守住','',''],['守住阵','',''],['守侯','',''],['守信','',''],['守信用','',''],['守候','',''],['守候室','',''],['守兵','',''],['守军','',''],['守分','',''],['守则','',''],['守制','',''],['守势','',''],['守卫','',''],['守卫者','',''],['守原则','',''],['守口如瓶','',''],['守土','',''],['守土有责','',''],['守地','',''],['守城','',''],['守备','',''],['守备部队','',''],['守备队','',''],['守夜','',''],['守夜者','',''],['守孝','',''],['守宫','',''],['守寡','',''],['守将','',''],['守岁','',''],['守己','',''],['守御','',''],['守恒','',''],['守恒定律','',''],['守成','',''],['守托者','',''],['守护','',''],['守护神','',''],['守拙','',''],['守敌','',''],['守斋','',''],['守方','',''],['守旧','',''],['守旧派','',''],['守旧者','',''],['守时','',''],['守更','',''],['守服','',''],['守望','',''],['守望犬','',''],['守望相助','',''],['守株待兔','',''],['守株缘木','',''],['守正不回','',''],['守正不挠','',''],['守正不移','',''],['守正不阿','',''],['守死善道','',''],['守法','',''],['守法者','',''],['守活寡','',''],['守灵','',''],['守猎','',''],['守球门','',''],['守着','',''],['守空房','',''],['守约','',''],['守约施博','',''],['守纪','',''],['守纪律','',''],['守经达权','',''],['守缺','',''],['守职','',''],['守节','',''],['守节不回','',''],['守节不移','',''],['守规矩','',''],['守誓','',''],['守贞','',''],['守财奴','',''],['守身','',''],['守身如玉','',''],['守身若玉','',''],['守车','',''],['守道安贫','',''],['守门','',''],['守门人','',''],['守门员','',''],['守静','',''],['安・海瑟薇','',''],['安上','',''],['安下','',''],['安下心来','',''],['安不忘危','',''],['安东尼','',''],['安东尼与克莉奥佩特拉','',''],['安乃近','',''],['安之','',''],['安之若命','',''],['安之若素','',''],['安乐','',''],['安乐区','',''],['安乐死','',''],['安乐窝','',''],['安于','',''],['安于一隅','',''],['安于现状','',''],['安享','',''],['安人','',''],['安代舞','',''],['安份','',''],['安份守己','',''],['安保','',''],['安倍','',''],['安倍・晋三','',''],['安克拉治','',''],['安克雷奇','',''],['安全','',''],['安全与交换委员会','',''],['安全保密','',''],['安全别针','',''],['安全区','',''],['安全员','',''],['安全壳','',''],['安全套','',''],['安全局','',''],['安全岛','',''],['安全带','',''],['安全帽','',''],['安全年','',''],['安全性','',''],['安全感','',''],['安全掣','',''],['安全措施','',''],['安全无事','',''],['安全无恙','',''],['安全无虞','',''],['安全期','',''],['安全检查','',''],['安全气囊','',''],['安全灯','',''],['安全玻璃','',''],['安全生产','',''],['安全电压','',''],['安全眼罩','',''],['安全科','',''],['安全第一','',''],['安全系数','',''],['安全网','',''],['安全考虑','',''],['安全装置','',''],['安全部','',''],['安全问题','',''],['安全阀','',''],['安养','',''],['安养院','',''],['安分','',''],['安分守己','',''],['安利','',''],['安华','',''],['安南','',''],['安南区','',''],['安南子','',''],['安南山脉','',''],['安卡拉','',''],['安卧','',''],['安危','',''],['安危冷暖','',''],['安厝','',''],['安可','',''],['安史之乱','',''],['安吉尔','',''],['安哥拉兔','',''],['安土乐业','',''],['安土重迁','',''],['安地斯','',''],['安坐','',''],['安坐待毙','',''],['安培','',''],['安培小时','',''],['安培表','',''],['安培计','',''],['安堵','',''],['安堵乐业','',''],['安堵如故','',''],['安多芬','',''],['安大略','',''],['安大略湖','',''],['安大略省','',''],['安好','',''],['安如泰山','',''],['安如磐石','',''],['安妥','',''],['安妮・夏菲维','',''],['安妮・海瑟薇','',''],['安娜','',''],['安娜・卡列尼娜','',''],['安宁片','',''],['安宅正路','',''],['安安定定','',''],['安安心心','',''],['安安稳稳','',''],['安安静静','',''],['安定','',''],['安定乡','',''],['安定化','',''],['安定团结','',''],['安定门','',''],['安家','',''],['安家乐业','',''],['安家立业','',''],['安家落户','',''],['安家费','',''],['安富尊荣','',''],['安富恤穷','',''],['安富恤贫','',''],['安居','',''],['安居乐业','',''],['安居工程','',''],['安山岩','',''],['安常处顺','',''],['安常履顺','',''],['安平区','',''],['安庆地区','',''],['安度','',''],['安度晚年','',''],['安康地区','',''],['安徒生','',''],['安得拉邦','',''],['安德海','',''],['安德烈','',''],['安德肋','',''],['安德鲁','',''],['安徽中医学院','',''],['安徽大学','',''],['安徽工程科技学院','',''],['安徽建筑工业学院','',''],['安心','',''],['安心工作','',''],['安息','',''],['安息国','',''],['安息日','',''],['安息茴香','',''],['安息香','',''],['安息香属','',''],['安息香科','',''],['安息香脂','',''],['安慰','',''],['安慰剂','',''],['安慰奖','',''],['安慰性','',''],['安慰赛','',''],['安打','',''],['安抚','',''],['安抵','',''],['安拉','',''],['安排','',''],['安排时间','',''],['安提瓜岛','',''],['安插','',''],['安放','',''],['安曼','',''],['安替比林','',''],['安枕','',''],['安枕而卧','',''],['安格尔','',''],['安检','',''],['安次','',''],['安歇','',''],['安步','',''],['安步当车','',''],['安民','',''],['安民告示','',''],['安泰','',''],['安源','',''],['安澜','',''],['安灵','',''],['安然','',''],['安然无事','',''],['安然无恙','',''],['安特卫普','',''],['安琪儿','',''],['安瓦尔','',''],['安瓿','',''],['安瓿瓶','',''],['安生','',''],['安眠','',''],['安眠药','',''],['安眠酮','',''],['安睡','',''],['安石榴','',''],['安祖花','',''],['安神','',''],['安祥','',''],['安禄山','',''],['安稳','',''],['安第斯','',''],['安第斯山','',''],['安第斯山脉','',''],['安纳托利亚','',''],['安纳波利斯','',''],['安置','',''],['安老怀少','',''],['安能','',''],['安若泰山','',''],['安营','',''],['安营下寨','',''],['安营扎寨','',''],['安葬','',''],['安装','',''],['安装工程','',''],['安设','',''],['安详','',''],['安谧','',''],['安贞','',''],['安贫乐苦','',''],['安贫乐贱','',''],['安贫乐道','',''],['安贫守道','',''],['安身','',''],['安身之地','',''],['安身立命','',''],['安达曼岛','',''],['安达曼海','',''],['安达曼群岛','',''],['安适','',''],['安适如常','',''],['安逸','',''],['安道尔','',''],['安道尔城','',''],['安那其主义','',''],['安邦','',''],['安邦定国','',''],['安邦治国','',''],['安重根','',''],['安闲','',''],['安闲自在','',''],['安闲自得','',''],['安闲舒适','',''],['安闲随意','',''],['安阳地区','',''],['安静','',''],['安非他命','',''],['安非他明','',''],['安顺地区','',''],['安顿','',''],['安魂','',''],['安魂弥撒','',''],['安卓','',''],['宋书','',''],['宋代','',''],['宋体','',''],['宋体字','',''],['宋元','',''],['宋史','',''],['宋四大书','',''],['宋四家','',''],['宋太祖','',''],['宋学','',''],['宋庆龄','',''],['宋徽宗','',''],['宋慈','',''],['宋教仁','',''],['宋斤鲁削','',''],['宋明','',''],['宋朝','',''],['宋楚瑜','',''],['宋武帝','',''],['宋武帝刘裕','',''],['宋江','',''],['宋江起义','',''],['宋濂','',''],['宋画吴冶','',''],['宋白','',''],['宋祁','',''],['宋美龄','',''],['宋襄公','',''],['宋词','',''],['宋诗','',''],['完了','',''],['完事','',''],['完事大吉','',''],['完人','',''],['完值','',''],['完全','',''],['完全兼容','',''],['完全可以','',''],['完全可能','',''],['完全叶','',''],['完全同意','',''],['完全小学','',''],['完全归纳推理','',''],['完全必要','',''],['完全性','',''],['完全愈复','',''],['完全懂得','',''],['完全正确','',''],['完全符合','',''],['完全肥料','',''],['完全避免','',''],['完具','',''],['完县','',''],['完善','',''],['完场','',''],['完壁','',''],['完备','',''],['完备性','',''],['完好','',''],['完好如初','',''],['完好无损','',''],['完好无缺','',''],['完好率','',''],['完婚','',''],['完完全全','',''],['完小','',''],['完工','',''],['完形','',''],['完形心理学','',''],['完形心理治疗','',''],['完形测验','',''],['完成','',''],['完成任务','',''],['完成式','',''],['完成时','',''],['完整','',''],['完整性','',''],['完整无损','',''],['完整无缺','',''],['完毕','',''],['完满','',''],['完璧','',''],['完璧归赵','',''],['完税','',''],['完稿','',''],['完竣','',''],['完粮','',''],['完结','',''],['完美','',''],['完美主义者','',''],['完美无瑕','',''],['完美无缺','',''],['完聚','',''],['完肤','',''],['完蛋','',''],['宏业','',''],['宏丽','',''],['宏亮','',''],['宏代码','',''],['宏伟','',''],['宏伟目标','',''],['宏儒','',''],['宏光','',''],['宏功能','',''],['宏名','',''],['宏命令','',''],['宏图','',''],['宏图大略','',''],['宏壮','',''],['宏大','',''],['宏录','',''],['宏恩','',''],['宏愿','',''],['宏扬','',''],['宏指令','',''],['宏效','',''],['宏旨','',''],['宏汇','',''],['宏汇编','',''],['宏病毒','',''],['宏碁','',''],['宏碁集团','',''],['宏程序','',''],['宏观','',''],['宏观世界','',''],['宏观图','',''],['宏观控制','',''],['宏观管理','',''],['宏观经济','',''],['宏观经济学','',''],['宏观能力','',''],['宏观调控','',''],['宏观调节','',''],['宏论','',''],['宏达','',''],['宏都拉斯','',''],['宓妃','',''],['宕机','',''],['宗主','',''],['宗主国','',''],['宗主权','',''],['宗亲','',''],['宗仰','',''],['宗兄','',''],['宗匠','',''],['宗史','',''],['宗喀巴','',''],['宗圣侯','',''],['宗圣公','',''],['宗姓','',''],['宗室','',''],['宗师','',''],['宗庙','',''],['宗庙丘墟','',''],['宗教','',''],['宗教上','',''],['宗教仪式','',''],['宗教信仰','',''],['宗教团','',''],['宗教团体','',''],['宗教学','',''],['宗教徒','',''],['宗教改革','',''],['宗教政策','',''],['宗教法庭','',''],['宗教画','',''],['宗教界','',''],['宗族','',''],['宗旨','',''],['宗权','',''],['宗正','',''],['宗法','',''],['宗法制','',''],['宗法制度','',''],['宗法观念','',''],['宗派','',''],['宗派主义','',''],['宗祠','',''],['宗祧','',''],['宗筋','',''],['宗谱','',''],['官书','',''],['官二代','',''],['官人','',''],['官令','',''],['官价','',''],['官位','',''],['官佐','',''],['官使','',''],['官俸','',''],['官倒','',''],['官僚','',''],['官僚主义','',''],['官僚习气','',''],['官僚资产阶级','',''],['官僚资本','',''],['官僚资本主义','',''],['官儿','',''],['官兵','',''],['官兵一致','',''],['官兵关系','',''],['官册','',''],['官军','',''],['官制','',''],['官办','',''],['官印','',''],['官厅','',''],['官厅水库','',''],['官司','',''],['官名','',''],['官吏','',''],['官吏们','',''],['官员','',''],['官商','',''],['官商合资','',''],['官地','',''],['官场','',''],['官场如戏','',''],['官场现形记','',''],['官复原职','',''],['官子','',''],['官学','',''],['官官','',''],['官官相为','',''],['官官相护','',''],['官客','',''],['官宦','',''],['官宦人家','',''],['官家','',''],['官属','',''],['官差','',''],['官府','',''],['官式','',''],['官式访问','',''],['官情纸薄','',''],['官房长官','',''],['官报','',''],['官报私仇','',''],['官方','',''],['官方化','',''],['官方语言','',''],['官服','',''],['官架','',''],['官架子','',''],['官样','',''],['官样文章','',''],['官桂','',''],['官止神行','',''],['官气','',''],['官法如炉','',''],['官渡','',''],['官渡之战','',''],['官爵','',''],['官田','',''],['官田乡','',''],['官瘾','',''],['官癖','',''],['官禄','',''],['官私合营','',''],['官称','',''],['官窑','',''],['官级','',''],['官绅','',''],['官署','',''],['官老爷','',''],['官职','',''],['官能','',''],['官能团','',''],['官能基','',''],['官腔','',''],['官舱','',''],['官营','',''],['官虔吏狠','',''],['官衔','',''],['官衙','',''],['官词','',''],['官话','',''],['官费','',''],['官轿','',''],['官运','',''],['官运亨通','',''],['官逼','',''],['官逼民反','',''],['官道','',''],['官邸','',''],['官长','',''],['官阶','',''],['官非','',''],['官饷','',''],['宙斯','',''],['宙斯盾','',''],['定上','',''],['定下','',''],['定不','',''],['定为','',''],['定义','',''],['定义域','',''],['定了','',''],['定于','',''],['定于一尊','',''],['定产','',''],['定亲','',''],['定人','',''],['定价','',''],['定会','',''],['定位','',''],['定位器','',''],['定作','',''],['定使','',''],['定例','',''],['定做','',''],['定军山','',''],['定冠词','',''],['定准','',''],['定出','',''],['定分','',''],['定则','',''],['定制','',''],['定力','',''],['定势','',''],['定单','',''],['定名','',''],['定名为','',''],['定名称','',''],['定向','',''],['定向培育','',''],['定向天线','',''],['定向爆破','',''],['定向越野','',''],['定员','',''],['定喘丸','',''],['定场白','',''],['定场诗','',''],['定址','',''],['定型','',''],['定型水','',''],['定夺','',''],['定好','',''],['定婚','',''],['定子','',''],['定存','',''],['定宽','',''],['定局','',''],['定居','',''],['定居点','',''],['定居者','',''],['定岗','',''],['定常态','',''],['定幅','',''],['定序','',''],['定座','',''],['定座率','',''],['定式','',''],['定弦','',''],['定当','',''],['定形','',''],['定影','',''],['定影剂','',''],['定律','',''],['定心','',''],['定心丸','',''],['定性','',''],['定性分析','',''],['定性处理','',''],['定性理论','',''],['定息','',''],['定情','',''],['定数','',''],['定数额','',''],['定时','',''],['定时信管','',''],['定时器','',''],['定时摄影','',''],['定时炸弹','',''],['定时钟','',''],['定时间','',''],['定更','',''],['定有','',''],['定期','',''],['定期储蓄','',''],['定期存款','',''],['定期性','',''],['定来','',''],['定标','',''],['定标器','',''],['定样','',''],['定格','',''],['定案','',''],['定植','',''],['定洋','',''],['定海','',''],['定滑轮','',''],['定点','',''],['定点企业','',''],['定点厂','',''],['定然','',''],['定版','',''],['定物','',''],['定理','',''],['定界','',''],['定界符','',''],['定界线','',''],['定界限','',''],['定盘星','',''],['定直线','',''],['定睛','',''],['定礼','',''],['定神','',''],['定票','',''],['定税','',''],['定税额','',''],['定稿','',''],['定约','',''],['定级','',''],['定编','',''],['定罪','',''],['定置','',''],['定职','',''],['定职位','',''],['定能','',''],['定舱','',''],['定色','',''],['定苗','',''],['定西地区','',''],['定见','',''],['定规','',''],['定角色','',''],['定言','',''],['定计','',''],['定计划','',''],['定论','',''],['定语','',''],['定调','',''],['定调子','',''],['定谳','',''],['定货','',''],['定购','',''],['定距','',''],['定远营','',''],['定都','',''],['定量','',''],['定量分块','',''],['定量分析','',''],['定量配','',''],['定金','',''],['定钱','',''],['定银','',''],['定阅','',''],['定限','',''],['定陪','',''],['定陵','',''],['定音','',''],['定音鼓','',''],['定项','',''],['定顺序','',''],['定额','',''],['定额工资制','',''],['定额税','',''],['定额管理','',''],['定额组','',''],['定风针','',''],['定鼎','',''],['宛城','',''],['宛如','',''],['宛延','',''],['宛然','',''],['宛然在目','',''],['宛若','',''],['宛蜒','',''],['宛转','',''],['宜于','',''],['宜人','',''],['宜喜宜嗔','',''],['宜嗔宜喜','',''],['宜在','',''],['宜室宜家','',''],['宜家','',''],['宜宾地区','',''],['宜将','',''],['宜居','',''],['宜山','',''],['宜山县','',''],['宜山镇','',''],['宜敲勿捧','',''],['宜昌县','',''],['宜昌地区','',''],['宜春地区','',''],['宜秀','',''],['宜秀区','',''],['宝中之宝','',''],['宝丽金','',''],['宝书','',''],['宝位','',''],['宝典','',''],['宝刀','',''],['宝刀不老','',''],['宝刀未老','',''],['宝刹','',''],['宝剑','',''],['宝卷','',''],['宝号','',''],['宝器','',''],['宝地','',''],['宝坻','',''],['宝塔','',''],['宝塔菜','',''],['宝安','',''],['宝宝','',''],['宝山','',''],['宝山乡','',''],['宝山空回','',''],['宝岛','',''],['宝库','',''],['宝座','',''],['宝成铁路','',''],['宝林','',''],['宝殿','',''],['宝洁','',''],['宝洁公司','',''],['宝物','',''],['宝特瓶','',''],['宝玉','',''],['宝珠','',''],['宝瓶','',''],['宝瓶座','',''],['宝生佛','',''],['宝盆','',''],['宝盒','',''],['宝盖','',''],['宝石','',''],['宝石匠','',''],['宝石商','',''],['宝石蓝','',''],['宝箱','',''],['宝莱坞','',''],['宝葫芦','',''],['宝葫芦的秘密','',''],['宝蓝','',''],['宝藏','',''],['宝贝','',''],['宝贝儿','',''],['宝贝疙瘩','',''],['宝货','',''],['宝贵','',''],['宝贵意见','',''],['宝贵财富','',''],['宝重','',''],['宝鉴','',''],['宝钢','',''],['宝钢集团','',''],['宝马','',''],['宝马车','',''],['宝马香车','',''],['实与有力','',''],['实业','',''],['实业家','',''],['实业界','',''],['实为','',''],['实习','',''],['实习期','',''],['实习生','',''],['实事','',''],['实事求是','',''],['实交','',''],['实付','',''],['实价','',''],['实体','',''],['实体化','',''],['实体图','',''],['实体层','',''],['实体店','',''],['实例','',''],['实值','',''],['实像','',''],['实况','',''],['实况录像','',''],['实况录音','',''],['实况转播','',''],['实出无耐','',''],['实分析','',''],['实则','',''],['实利','',''],['实利主义','',''],['实力','',''],['实力政策','',''],['实力派','',''],['实力统计','',''],['实力雄厚','',''],['实务','',''],['实发','',''],['实受资本','',''],['实变','',''],['实变函数','',''],['实变函数论','',''],['实可','',''],['实名','',''],['实名制','',''],['实在','',''],['实在性','',''],['实在物','',''],['实在论','',''],['实地','',''],['实地考察','',''],['实地访视','',''],['实型','',''],['实境','',''],['实处','',''],['实女','',''],['实字','',''],['实存','',''],['实学','',''],['实实','',''],['实实在在','',''],['实层','',''],['实属','',''],['实属不易','',''],['实岁','',''],['实干','',''],['实干家','',''],['实弹','',''],['实录','',''],['实得','',''],['实心','',''],['实心球','',''],['实心皮球','',''],['实性','',''],['实情','',''],['实惠','',''],['实意','',''],['实感','',''],['实战','',''],['实才','',''],['实打实','',''],['实报实销','',''],['实拍','',''],['实据','',''],['实收','',''],['实效','',''],['实数','',''],['实数值','',''],['实数集','',''],['实施','',''],['实施办法','',''],['实施细则','',''],['实施者','',''],['实无','',''],['实时','',''],['实时加工','',''],['实时技术','',''],['实时操作环境','',''],['实是','',''],['实景','',''],['实有','',''],['实权','',''],['实根','',''],['实派','',''],['实测','',''],['实物','',''],['实物地租','',''],['实物教学','',''],['实现','',''],['实现好','',''],['实用','',''],['实用主义','',''],['实用价值','',''],['实用型','',''],['实用性','',''],['实用技术','',''],['实用文','',''],['实用阶段','',''],['实症','',''],['实益','',''],['实相','',''],['实繁有徒','',''],['实纳','',''],['实线','',''],['实绩','',''],['实缺','',''],['实耗','',''],['实职','',''],['实肘','',''],['实股','',''],['实至名归','',''],['实蕃有徒','',''],['实行','',''],['实行家','',''],['实行改革','',''],['实行者','',''],['实观','',''],['实觉','',''],['实言相告','',''],['实证','',''],['实证主义','',''],['实证论','',''],['实词','',''],['实话','',''],['实话实说','',''],['实说','',''],['实质','',''],['实质上','',''],['实质性','',''],['实质问题','',''],['实购','',''],['实足','',''],['实践','',''],['实践中','',''],['实践是检验真理的唯一标准','',''],['实践经验','',''],['实践论','',''],['实践证明','',''],['实销','',''],['实际','',''],['实际上','',''],['实际困难','',''],['实际增长','',''],['实际工作','',''],['实际工资','',''],['实际应用','',''],['实际性','',''],['实际情况','',''],['实际意义','',''],['实际收入','',''],['实际水平','',''],['实际生活','',''],['实际行动','',''],['实际问题','',''],['实际需要','',''],['实难','',''],['实验','',''],['实验上','',''],['实验主义','',''],['实验员','',''],['实验室','',''],['实验室感染','',''],['实验心理学','',''],['实验性','',''],['实验所','',''],['实验者','',''],['宠信','',''],['宠儿','',''],['宠坏','',''],['宠幸','',''],['宠恩','',''],['宠擅专房','',''],['宠爱','',''],['宠物','',''],['宠臣','',''],['宠辱不惊','',''],['宠辱无惊','',''],['宠辱若惊','',''],['审判','',''],['审判上','',''],['审判前','',''],['审判员','',''],['审判学','',''],['审判席','',''],['审判庭','',''],['审判权','',''],['审判栏','',''],['审判程序','',''],['审判者','',''],['审判长','',''],['审前','',''],['审处','',''],['审官','',''],['审定','',''],['审察','',''],['审察人','',''],['审己度人','',''],['审干','',''],['审度','',''],['审度时势','',''],['审慎','',''],['审慎行事','',''],['审批','',''],['审改','',''],['审断','',''],['审时定势','',''],['审时度势','',''],['审曲面势','',''],['审查','',''],['审查员','',''],['审查委员会','',''],['审查核准','',''],['审查者','',''],['审校','',''],['审核','',''],['审案','',''],['审理','',''],['审稿','',''],['审稿人','',''],['审级','',''],['审级制度','',''],['审结','',''],['审美','',''],['审美快感','',''],['审美感受','',''],['审美活动','',''],['审美眼光','',''],['审美者','',''],['审美观','',''],['审美观点','',''],['审美评价','',''],['审视','',''],['审计','',''],['审计员','',''],['审计学','',''],['审计局','',''],['审计工作','',''],['审计署','',''],['审计长','',''],['审订','',''],['审议','',''],['审讯','',''],['审读','',''],['审谛','',''],['审酌','',''],['审问','',''],['审问者','',''],['审阅','',''],['审验','',''],['客上','',''],['客串','',''],['客人','',''],['客位','',''],['客体','',''],['客卿','',''],['客厅','',''],['客员','',''],['客商','',''],['客囊羞涩','',''],['客土','',''],['客地','',''],['客场','',''],['客堂','',''],['客套','',''],['客套话','',''],['客姓','',''],['客官','',''],['客客气气','',''],['客室','',''],['客家','',''],['客家人','',''],['客家语','',''],['客居','',''],['客岁','',''],['客帮','',''],['客店','',''],['客座','',''],['客座教授','',''],['客性','',''],['客户','',''],['客户应用','',''],['客户服务','',''],['客户服务中心','',''],['客户服务器结构','',''],['客户服务部','',''],['客户机','',''],['客户机服务器环境','',''],['客户机软件','',''],['客户端','',''],['客房','',''],['客星','',''],['客服','',''],['客机','',''],['客来','',''],['客栈','',''],['客梯','',''],['客死','',''],['客气','',''],['客气话','',''],['客流','',''],['客流量','',''],['客满','',''],['客物','',''],['客票','',''],['客站','',''],['客籍','',''],['客舍','',''],['客舱','',''],['客船','',''],['客蚤','',''],['客蚤属','',''],['客西马尼园','',''],['客西马尼花园','',''],['客观','',''],['客观世界','',''],['客观主义','',''],['客观事实','',''],['客观化','',''],['客观原因','',''],['客观唯心主义','',''],['客观存在','',''],['客观实在','',''],['客观实际','',''],['客观性','',''],['客观情况','',''],['客观条件','',''],['客观真理','',''],['客观规律','',''],['客观辩证法','',''],['客语','',''],['客货','',''],['客车','',''],['客车厢','',''],['客轮','',''],['客运','',''],['客运码头','',''],['客运量','',''],['客队','',''],['客饭','',''],['客驳','',''],['宣传','',''],['宣传文案','',''],['宣传册','',''],['宣传员','',''],['宣传周','',''],['宣传品','',''],['宣传工作','',''],['宣传弹','',''],['宣传性','',''],['宣传报道','',''],['宣传提纲','',''],['宣传攻势','',''],['宣传教育','',''],['宣传月','',''],['宣传画','',''],['宣传科','',''],['宣传者','',''],['宣传部','',''],['宣传部长','',''],['宣传队','',''],['宣判','',''],['宣叙调','',''],['宣召','',''],['宣告','',''],['宣告者','',''],['宣州','',''],['宣布','',''],['宣布破产','',''],['宣德','',''],['宣战','',''],['宣扬','',''],['宣扬者','',''],['宣教','',''],['宣明','',''],['宣武','',''],['宣武门','',''],['宣泄','',''],['宣示','',''],['宣称','',''],['宣纸','',''],['宣统','',''],['宣腿','',''],['宣言','',''],['宣言者','',''],['宣誓','',''],['宣誓书','',''],['宣誓供词证明','',''],['宣誓就职','',''],['宣誓证言','',''],['宣认','',''],['宣讲','',''],['宣读','',''],['宣道','',''],['室中','',''],['室乐','',''],['室内','',''],['室内乐','',''],['室内装潢','',''],['室内设计','',''],['室前','',''],['室厅','',''],['室友','',''],['室名','',''],['室员','',''],['室外','',''],['室女','',''],['室女座','',''],['室如悬磐','',''],['室如悬罄','',''],['室怒市色','',''],['室息性毒剂','',''],['室温','',''],['室町','',''],['室町幕府','',''],['室迩人远','',''],['室迩人遐','',''],['室里','',''],['宦乡','',''],['宦官','',''],['宦海','',''],['宦海风波','',''],['宦游','',''],['宦途','',''],['宦门','',''],['宦骑','',''],['宪兵','',''],['宪兵队','',''],['宪制','',''],['宪政','',''],['宪法','',''],['宪法学','',''],['宪法法院','',''],['宪法监护委员会','',''],['宪法规定','',''],['宪章','',''],['宪章派','',''],['宪章运动','',''],['宪纲','',''],['宫主','',''],['宫人','',''],['宫体','',''],['宫保','',''],['宫保鸡丁','',''],['宫内','',''],['宫内节育器','',''],['宫刑','',''],['宫商角徵羽','',''],['宫城','',''],['宫城县','',''],['宫墙','',''],['宫外','',''],['宫女','',''],['宫娥','',''],['宫室','',''],['宫崎','',''],['宫崎县','',''],['宫崎吾朗','',''],['宫崎骏','',''],['宫廷','',''],['宫廷政变','',''],['宫廷舞蹈','',''],['宫掖','',''],['宫殿','',''],['宫殿似','',''],['宫泽喜一','',''],['宫灯','',''],['宫爆肉丁','',''],['宫爆鸡丁','',''],['宫画','',''],['宫缩','',''],['宫观','',''],['宫调','',''],['宫里','',''],['宫镜','',''],['宫门','',''],['宫闱','',''],['宫阙','',''],['宫颈','',''],['宫颈抹片','',''],['宰予','',''],['宰予昼寝','',''],['宰人','',''],['宰制','',''],['宰割','',''],['宰客','',''],['宰杀','',''],['宰牲节','',''],['宰相','',''],['宰羊','',''],['宰食','',''],['害了','',''],['害于','',''],['害人','',''],['害人不浅','',''],['害人精','',''],['害人虫','',''],['害兽','',''],['害口','',''],['害命','',''],['害喜','',''],['害处','',''],['害己','',''],['害得','',''],['害怕','',''],['害性','',''],['害我','',''],['害月子','',''],['害死','',''],['害病','',''],['害相思病','',''],['害眼','',''],['害羞','',''],['害群之马','',''],['害臊','',''],['害自','',''],['害虫','',''],['害马','',''],['害鸟','',''],['宴乐','',''],['宴会','',''],['宴会厅','',''],['宴安鸩毒','',''],['宴客','',''],['宴席','',''],['宴请','',''],['宴飨','',''],['宴饮','',''],['宵分','',''],['宵夜','',''],['宵小','',''],['宵征','',''],['宵旰','',''],['宵旰图治','',''],['宵旰忧劳','',''],['宵旰忧勤','',''],['宵旰焦劳','',''],['宵禁','',''],['宵衣旰食','',''],['宵遁','',''],['家丁','',''],['家上','',''],['家丑','',''],['家丑不可外传','',''],['家丑不可外扬','',''],['家世','',''],['家世寒微','',''],['家业','',''],['家严','',''],['家中','',''],['家乐福','',''],['家乡','',''],['家乡人','',''],['家乡菜','',''],['家乡话','',''],['家乡鸡','',''],['家书','',''],['家事','',''],['家产','',''],['家场','',''],['家亲','',''],['家人','',''],['家人一等','',''],['家什','',''],['家仆','',''],['家伙','',''],['家传','',''],['家佣','',''],['家信','',''],['家俱','',''],['家僮','',''],['家儿','',''],['家兄','',''],['家兔','',''],['家公','',''],['家具','',''],['家具商','',''],['家养','',''],['家务','',''],['家务事','',''],['家务劳动','',''],['家务活','',''],['家区','',''],['家叔','',''],['家口','',''],['家史','',''],['家名','',''],['家和万事兴','',''],['家喻户晓','',''],['家园','',''],['家坝水电站','',''],['家培','',''],['家塾','',''],['家境','',''],['家天下','',''],['家奴','',''],['家妇','',''],['家姊','',''],['家姐','',''],['家姑','',''],['家姓','',''],['家姬','',''],['家娘','',''],['家婆','',''],['家嫂','',''],['家子','',''],['家学','',''],['家学渊源','',''],['家宅','',''],['家室','',''],['家宴','',''],['家家','',''],['家家户户','',''],['家家有本难念的经','',''],['家小','',''],['家居','',''],['家属','',''],['家属区','',''],['家属宿舍','',''],['家常','',''],['家常便饭','',''],['家常服','',''],['家常茶饭','',''],['家常菜','',''],['家常豆腐','',''],['家底','',''],['家庭','',''],['家庭中','',''],['家庭主夫','',''],['家庭主妇','',''],['家庭似','',''],['家庭作业','',''],['家庭出身','',''],['家庭制','',''],['家庭副业','',''],['家庭地址','',''],['家庭妇女','',''],['家庭式','',''],['家庭成员','',''],['家庭手工业','',''],['家庭教师','',''],['家庭暴力','',''],['家庭消费者','',''],['家庭煮夫','',''],['家弟','',''],['家弦户诵','',''],['家当','',''],['家徒四壁','',''],['家徒壁立','',''],['家慈','',''],['家政','',''],['家政员','',''],['家政学','',''],['家教','',''],['家数','',''],['家族','',''],['家族制度','',''],['家族树','',''],['家无儋石','',''],['家无担石','',''],['家景','',''],['家暴','',''],['家有','',''],['家有敝帚享之千金','',''],['家母','',''],['家法','',''],['家灶','',''],['家燕','',''],['家父','',''],['家爷','',''],['家犬','',''],['家狗','',''],['家猫','',''],['家珍','',''],['家用','',''],['家用电器','',''],['家用电脑','',''],['家电','',''],['家畜','',''],['家的','',''],['家眷','',''],['家破人亡','',''],['家破身亡','',''],['家祖','',''],['家祠','',''],['家禽','',''],['家禽肉','',''],['家私','',''],['家种','',''],['家童','',''],['家累','',''],['家累千金','',''],['家给人足','',''],['家给民足','',''],['家翻宅乱','',''],['家老','',''],['家臣','',''],['家至人说','',''],['家至户晓','',''],['家舅','',''],['家蚊','',''],['家蚕','',''],['家蝇','',''],['家规','',''],['家计','',''],['家训','',''],['家访','',''],['家谱','',''],['家财','',''],['家败人亡','',''],['家贫如洗','',''],['家贼难防','',''],['家赀万贯','',''],['家资','',''],['家轿','',''],['家道','',''],['家道从容','',''],['家道消乏','',''],['家里','',''],['家钵','',''],['家长','',''],['家长会','',''],['家长制','',''],['家长式','',''],['家长里短','',''],['家门','',''],['家雀儿','',''],['家风','',''],['家鸡','',''],['家鸡野雉','',''],['家鸡野鹜','',''],['家鸭','',''],['家鸭绿头鸭','',''],['家鸽','',''],['家鼠','',''],['容下','',''],['容不得','',''],['容人','',''],['容光','',''],['容光焕发','',''],['容克','',''],['容克地主','',''],['容华绝代','',''],['容受','',''],['容器','',''],['容头过身','',''],['容幸','',''],['容度','',''],['容得','',''],['容忍','',''],['容忍度','',''],['容情','',''],['容或','',''],['容抗','',''],['容易','',''],['容易发','',''],['容易哭','',''],['容易教','',''],['容易错','',''],['容止','',''],['容电器','',''],['容留','',''],['容祖儿','',''],['容积','',''],['容积效率','',''],['容积计','',''],['容纳','',''],['容纳物','',''],['容缓','',''],['容让','',''],['容许','',''],['容许有','',''],['容貌','',''],['容身','',''],['容量','',''],['容量分析','',''],['容量大','',''],['容量瓶','',''],['容错','',''],['容颜','',''],['容颜失色','',''],['宽于','',''],['宽亮','',''],['宽以待人','',''],['宽余','',''],['宽假','',''],['宽免','',''],['宽减','',''],['宽厚','',''],['宽口','',''],['宽吻海豚','',''],['宽城','',''],['宽城县','',''],['宽大','',''],['宽大为怀','',''],['宽大仁爱','',''],['宽大处理','',''],['宽大政策','',''],['宽宏','',''],['宽宏大度','',''],['宽宏大量','',''],['宽宥','',''],['宽容','',''],['宽屏','',''],['宽展','',''],['宽带','',''],['宽幅','',''],['宽广','',''],['宽广度','',''],['宽度','',''],['宽延','',''],['宽弘','',''],['宽影片','',''],['宽待','',''],['宽心','',''],['宽心丸','',''],['宽心丸儿','',''],['宽恕','',''],['宽慰','',''],['宽打','',''],['宽打窄用','',''],['宽敞','',''],['宽斧','',''],['宽旷','',''],['宽松','',''],['宽松环境','',''],['宽泛','',''],['宽洪','',''],['宽洪大度','',''],['宽洪大量','',''],['宽洪海量','',''],['宽爱','',''],['宽爽','',''],['宽狭','',''],['宽猛相济','',''],['宽甸','',''],['宽甸县','',''],['宽畅','',''],['宽窄','',''],['宽紧','',''],['宽纵','',''],['宽线','',''],['宽绰','',''],['宽缓','',''],['宽胶带','',''],['宽腰','',''],['宽舒','',''],['宽行','',''],['宽衣','',''],['宽袖','',''],['宽裕','',''],['宽规','',''],['宽角度','',''],['宽解','',''],['宽让','',''],['宽贷','',''],['宽赦','',''],['宽路','',''],['宽轨','',''],['宽边','',''],['宽边帽','',''],['宽银幕','',''],['宽银幕影片','',''],['宽银幕电影','',''],['宽阔','',''],['宽限','',''],['宽限期','',''],['宽领','',''],['宽频','',''],['宽饶','',''],['宾东','',''],['宾主','',''],['宾主双方','',''],['宾利','',''],['宾夕法尼亚','',''],['宾夕法尼亚大学','',''],['宾夕法尼亚州','',''],['宾客','',''],['宾客如云','',''],['宾客盈门','',''],['宾室','',''],['宾州','',''],['宾得','',''],['宾朋','',''],['宾朋满座','',''],['宾朋盈门','',''],['宾服','',''],['宾果','',''],['宾格','',''],['宾治','',''],['宾白','',''],['宾礼','',''],['宾至','',''],['宾至如归','',''],['宾西法尼亚','',''],['宾词','',''],['宾语','',''],['宾语关系从句','',''],['宾馆','',''],['宿世冤家','',''],['宿主','',''],['宿于','',''],['宿仇','',''],['宿债','',''],['宿儒','',''],['宿分','',''],['宿务','',''],['宿卫','',''],['宿县','',''],['宿县地区','',''],['宿命','',''],['宿命论','',''],['宿城','',''],['宿处','',''],['宿夜','',''],['宿娼','',''],['宿学旧儒','',''],['宿将','',''],['宿将旧卒','',''],['宿弊','',''],['宿怨','',''],['宿恨','',''],['宿愿','',''],['宿敌','',''],['宿昔','',''],['宿星','',''],['宿根','',''],['宿疾','',''],['宿缘','',''],['宿舍','',''],['宿舍楼','',''],['宿草','',''],['宿营','',''],['宿营地','',''],['宿见','',''],['宿诺','',''],['宿豫','',''],['宿费','',''],['宿逋','',''],['宿酒','',''],['宿醉','',''],['宿雾','',''],['宿题','',''],['寂寂','',''],['寂寞','',''],['寂寥','',''],['寂灭','',''],['寂然','',''],['寂若无人','',''],['寂若死灰','',''],['寂静','',''],['寄上','',''],['寄主','',''],['寄予','',''],['寄予厚望','',''],['寄交','',''],['寄人篱下','',''],['寄件人','',''],['寄件者','',''],['寄住','',''],['寄信','',''],['寄信人','',''],['寄养','',''],['寄出','',''],['寄到','',''],['寄卖','',''],['寄去','',''],['寄发','',''],['寄名','',''],['寄售','',''],['寄售品','',''],['寄回','',''],['寄女','',''],['寄子','',''],['寄存','',''],['寄存器','',''],['寄存处','',''],['寄宿','',''],['寄宿人','',''],['寄宿学校','',''],['寄宿生','',''],['寄宿舍','',''],['寄寓','',''],['寄居','',''],['寄居蟹','',''],['寄希望于','',''],['寄往','',''],['寄怀','',''],['寄情','',''],['寄托','',''],['寄托人','',''],['寄放','',''],['寄望','',''],['寄来','',''],['寄母','',''],['寄父','',''],['寄生','',''],['寄生物','',''],['寄生生活','',''],['寄生者','',''],['寄生虫','',''],['寄生蜂','',''],['寄的','',''],['寄籍','',''],['寄给','',''],['寄自','',''],['寄至','',''],['寄语','',''],['寄费','',''],['寄赠','',''],['寄赠本','',''],['寄身','',''],['寄辞','',''],['寄达','',''],['寄迹','',''],['寄送','',''],['寄递','',''],['寄钱','',''],['寄销','',''],['寄顿','',''],['寅吃卯粮','',''],['寅忧夕惕','',''],['寅支卯粮','',''],['寅虎','',''],['密不可分','',''],['密不透风','',''],['密事','',''],['密云不雨','',''],['密令','',''],['密件','',''],['密会','',''],['密位','',''],['密使','',''],['密信','',''],['密函','',''],['密切','',''],['密切关系','',''],['密切协作','',''],['密切合作','',''],['密切接触','',''],['密切注意','',''],['密切注视','',''],['密切相关','',''],['密切相连','',''],['密切联系群众','',''],['密切配合','',''],['密匝匝','',''],['密县','',''],['密友','',''],['密司脱','',''],['密合','',''],['密告','',''],['密告者','',''],['密商','',''],['密宗','',''],['密定','',''],['密实','',''],['密室','',''],['密密','',''],['密密丛丛','',''],['密密匝匝','',''],['密密实实','',''],['密密层层','',''],['密密扎扎','',''],['密密麻麻','',''],['密封','',''],['密封剂','',''],['密封器','',''],['密封圈','',''],['密封胶','',''],['密封舱','',''],['密封辐射源','',''],['密尔沃基','',''],['密布','',''],['密帐','',''],['密度','',''],['密度波','',''],['密度计','',''],['密技','',''],['密报','',''],['密排','',''],['密探','',''],['密接','',''],['密教','',''],['密文','',''],['密斯','',''],['密旨','',''],['密林','',''],['密植','',''],['密檐塔','',''],['密歇根','',''],['密歇根大学','',''],['密歇根州','',''],['密歇根湖','',''],['密气','',''],['密法','',''],['密特朗','',''],['密电','',''],['密电码','',''],['密码','',''],['密码保护','',''],['密码子','',''],['密码学','',''],['密码术','',''],['密码机','',''],['密码法','',''],['密码电报','',''],['密码锁','',''],['密穴','',''],['密约','',''],['密级','',''],['密纹唱片','',''],['密织','',''],['密缝','',''],['密而不宣','',''],['密致','',''],['密苏里','',''],['密苏里州','',''],['密苏里洲','',''],['密茂','',''],['密藏','',''],['密西根','',''],['密西西比','',''],['密西西比州','',''],['密西西比河','',''],['密议','',''],['密访','',''],['密诀','',''],['密诏','',''],['密语','',''],['密谈','',''],['密谋','',''],['密谋者','',''],['密送','',''],['密钥','',''],['密锣紧鼓','',''],['密闭','',''],['密闭式循环再呼吸水肺系统','',''],['密闭舱','',''],['密闭货舱','',''],['密闭门','',''],['密陀僧','',''],['密集','',''],['密集井群','',''],['密集体','',''],['密集型','',''],['密集物','',''],['密麻麻','',''],['寇仇','',''],['寇准','',''],['寇攘','',''],['富丽','',''],['富丽堂皇','',''],['富二代','',''],['富于','',''],['富于想像','',''],['富人','',''],['富佃','',''],['富余','',''],['富兰克林','',''],['富农','',''],['富农分子','',''],['富可敌国','',''],['富同','',''],['富含','',''],['富商','',''],['富国','',''],['富国安民','',''],['富国强兵','',''],['富埒天子','',''],['富士','',''],['富士山','',''],['富士康','',''],['富士康科技集团','',''],['富士通','',''],['富婆','',''],['富孀','',''],['富家','',''],['富富有余','',''],['富尔不骄','',''],['富川县','',''],['富布赖特','',''],['富庶','',''],['富强','',''],['富强纤维','',''],['富得流油','',''],['富态','',''],['富想','',''],['富户','',''],['富拉尔基','',''],['富於','',''],['富时','',''],['富春江','',''],['富有','',''],['富有成效','',''],['富比王侯','',''],['富民政策','',''],['富矿','',''],['富纳富提','',''],['富翁','',''],['富而好礼','',''],['富良野','',''],['富色彩','',''],['富裕中农','',''],['富裕户','',''],['富豪','',''],['富贵','',''],['富贵不淫','',''],['富贵不能淫','',''],['富贵利达','',''],['富贵寿考','',''],['富贵无常','',''],['富贵浮云','',''],['富贵病','',''],['富贵荣华','',''],['富贵角','',''],['富贵逼人','',''],['富贵骄人','',''],['富足','',''],['富邦','',''],['富里','',''],['富里乡','',''],['富饶','',''],['寐神','',''],['寐龙','',''],['寒亭','',''],['寒伧','',''],['寒假','',''],['寒光','',''],['寒光闪闪','',''],['寒冬','',''],['寒冬腊月','',''],['寒冷','',''],['寒号虫','',''],['寒喧','',''],['寒喧语','',''],['寒噤','',''],['寒士','',''],['寒夜','',''],['寒天','',''],['寒峭','',''],['寒带','',''],['寒微','',''],['寒心','',''],['寒心酸鼻','',''],['寒性','',''],['寒意','',''],['寒战','',''],['寒暄','',''],['寒暑','',''],['寒暑假','',''],['寒暑表','',''],['寒木春花','',''],['寒来暑往','',''],['寒梅','',''],['寒武','',''],['寒武爆发','',''],['寒武系','',''],['寒武纪','',''],['寒武纪大爆发','',''],['寒武纪生命大爆发','',''],['寒毛','',''],['寒气','',''],['寒气逼人','',''],['寒泉之思','',''],['寒流','',''],['寒潮','',''],['寒热','',''],['寒疟','',''],['寒症','',''],['寒痹','',''],['寒碜','',''],['寒秋','',''],['寒窗','',''],['寒耕热耘','',''],['寒腿','',''],['寒舍','',''],['寒色','',''],['寒花晚节','',''],['寒苦','',''],['寒蝉','',''],['寒蝉仗马','',''],['寒衣','',''],['寒酸','',''],['寒门','',''],['寒霜','',''],['寒颤','',''],['寒风','',''],['寒风刺骨','',''],['寒食','',''],['寒鸦','',''],['寓书','',''],['寓于','',''],['寓公','',''],['寓居','',''],['寓意','',''],['寓意深远','',''],['寓意深长','',''],['寓所','',''],['寓教','',''],['寓目','',''],['寓管理于服务之中','',''],['寓言','',''],['寓言中','',''],['寓言诗','',''],['寝不安席','',''],['寝不遑安','',''],['寝具','',''],['寝室','',''],['寝宫','',''],['寝皮食肉','',''],['寝苫枕块','',''],['寝车','',''],['寝陵','',''],['寝食','',''],['寝食不安','',''],['寝食俱废','',''],['寝食难安','',''],['寞然','',''],['察三访四','',''],['察合台','',''],['察察','',''],['察察为明','',''],['察察而明','',''],['察尔汗盐湖','',''],['察布查尔','',''],['察布查尔县','',''],['察微知著','',''],['察看','',''],['察纳','',''],['察见渊鱼','',''],['察觉','',''],['察觉到','',''],['察言观色','',''],['察访','',''],['察验','',''],['寡不敌众','',''],['寡二少双','',''],['寡人','',''],['寡众','',''],['寡助','',''],['寡味','',''],['寡头','',''],['寡头垄断','',''],['寡头政治','',''],['寡女','',''],['寡妇','',''],['寡居','',''],['寡居期','',''],['寡廉','',''],['寡廉鲜耻','',''],['寡恩少义','',''],['寡情','',''],['寡情少义','',''],['寡敌','',''],['寡断','',''],['寡欢','',''],['寡母','',''],['寡见','',''],['寡见鲜见','',''],['寡见鲜闻','',''],['寡言','',''],['寡闻','',''],['寡闻少见','',''],['寡陋','',''],['寤寐','',''],['寥寥','',''],['寥寥可数','',''],['寥寥数语','',''],['寥寥无几','',''],['寥廓','',''],['寥若晨星','',''],['寥落','',''],['寨主','',''],['寨外','',''],['寨子','',''],['寮共','',''],['寮国','',''],['寮屋','',''],['寰宇','',''],['寰球','',''],['寰螽','',''],['寸丝不挂','',''],['寸兵尺铁','',''],['寸函','',''],['寸口','',''],['寸口脉','',''],['寸善片长','',''],['寸土','',''],['寸土不让','',''],['寸土尺地','',''],['寸土必争','',''],['寸地尺天','',''],['寸头','',''],['寸心','',''],['寸揩','',''],['寸断','',''],['寸晷','',''],['寸有所长','',''],['寸木岑楼','',''],['寸楷','',''],['寸步','',''],['寸步不离','',''],['寸步不让','',''],['寸步难移','',''],['寸步难行','',''],['寸男尺女','',''],['寸白虫','',''],['寸积铢累','',''],['寸脉','',''],['寸草','',''],['寸草不生','',''],['寸草不留','',''],['寸草春晖','',''],['寸金难买寸光阴','',''],['寸铁','',''],['寸长尺短','',''],['寸阳尺璧','',''],['寸阳若岁','',''],['寸阴','',''],['对上','',''],['对不上','',''],['对不住','',''],['对不对','',''],['对不起','',''],['对乙酰氨基酚','',''],['对了','',''],['对于','',''],['对亲','',''],['对仗','',''],['对付','',''],['对价','',''],['对位','',''],['对位法','',''],['对保','',''],['对偶','',''],['对偶多面体','',''],['对偶婚','',''],['对偶性','',''],['对像','',''],['对光','',''],['对内','',''],['对内搞活','',''],['对冲','',''],['对冲基金','',''],['对决','',''],['对准','',''],['对刺','',''],['对劲','',''],['对劲儿','',''],['对半','',''],['对华','',''],['对口','',''],['对口型','',''],['对口径','',''],['对口快板儿','',''],['对口疮','',''],['对口相声','',''],['对口词','',''],['对句','',''],['对台关系','',''],['对台戏','',''],['对台贸易','',''],['对号','',''],['对号入座','',''],['对味儿','',''],['对唱','',''],['对嘴','',''],['对地','',''],['对垒','',''],['对外','',''],['对外关系','',''],['对外开放','',''],['对外政策','',''],['对外经济贸易大学','',''],['对外联络部','',''],['对外贸易','',''],['对外贸易仲裁','',''],['对外贸易经济合作部','',''],['对大家来说','',''],['对头','',''],['对子','',''],['对家','',''],['对对子','',''],['对对碰','',''],['对局','',''],['对岸','',''],['对峙','',''],['对工','',''],['对工儿','',''],['对帐','',''],['对幺','',''],['对床夜雨','',''],['对床风雨','',''],['对应','',''],['对开','',''],['对弈','',''],['对待','',''],['对得起','',''],['对心','',''],['对心儿','',''],['对恃','',''],['对我来说','',''],['对手','',''],['对打','',''],['对抗','',''],['对抗性','',''],['对抗性矛盾','',''],['对抗煸动','',''],['对抗者','',''],['对抗赛','',''],['对折','',''],['对持','',''],['对换','',''],['对接','',''],['对撞','',''],['对撞机','',''],['对攻','',''],['对敌','',''],['对敌者','',''],['对数','',''],['对数函数','',''],['对数方程','',''],['对方','',''],['对方付款电话','',''],['对方付费电话','',''],['对日','',''],['对映','',''],['对映体','',''],['对映异构','',''],['对映异构体','',''],['对景伤情','',''],['对望','',''],['对本','',''],['对杯','',''],['对案','',''],['对歌','',''],['对比','',''],['对比度','',''],['对比法','',''],['对比温度','',''],['对比研究','',''],['对比联想','',''],['对比色','',''],['对氨基苯丙酮','',''],['对流','',''],['对流层','',''],['对流层顶','',''],['对流热','',''],['对流雨','',''],['对消','',''],['对火','',''],['对焦','',''],['对照','',''],['对照一下','',''],['对照法','',''],['对照者','',''],['对照表','',''],['对牛弹琴','',''],['对现','',''],['对症下药','',''],['对症发药','',''],['对白','',''],['对着干','',''],['对硫磷','',''],['对称','',''],['对称中心','',''],['对称性','',''],['对称点','',''],['对称破缺','',''],['对称空间','',''],['对称美','',''],['对称轴','',''],['对空射击','',''],['对空火器','',''],['对空观察哨','',''],['对立','',''],['对立统一','',''],['对立统一规律','',''],['对立面','',''],['对等','',''],['对答','',''],['对答如流','',''],['对策','',''],['对簿','',''],['对簿公堂','',''],['对美','',''],['对联','',''],['对胃口','',''],['对苯二甲酸','',''],['对苯二酚','',''],['对苯醌','',''],['对茬儿','',''],['对虾','',''],['对虾科','',''],['对表','',''],['对衬','',''],['对襟','',''],['对视','',''],['对角','',''],['对角线','',''],['对讲','',''],['对讲机','',''],['对讲电话','',''],['对证','',''],['对证命名','',''],['对词','',''],['对话','',''],['对话体','',''],['对话框','',''],['对话者','',''],['对话课','',''],['对课','',''],['对调','',''],['对谈','',''],['对象','',''],['对象性','',''],['对账','',''],['对质','',''],['对路','',''],['对边','',''],['对过','',''],['对酌','',''],['对酒当歌','',''],['对错','',''],['对门','',''],['对阵','',''],['对面','',''],['对顶角','',''],['对题','',''],['对马','',''],['对马岛','',''],['对马海峡','',''],['对齐','',''],['寺内','',''],['寺塔','',''],['寺庙','',''],['寺院','',''],['寺院中','',''],['寻乐','',''],['寻事','',''],['寻事生非','',''],['寻亲','',''],['寻人','',''],['寻人启事','',''],['寻仇','',''],['寻出','',''],['寻到','',''],['寻味','',''],['寻呼','',''],['寻回','',''],['寻回犬','',''],['寻址','',''],['寻宝','',''],['寻山问水','',''],['寻常','',''],['寻幽访胜','',''],['寻底','',''],['寻开心','',''],['寻思','',''],['寻找','',''],['寻摸','',''],['寻机','',''],['寻来范畴','',''],['寻根','',''],['寻根溯源','',''],['寻根究底','',''],['寻根问底','',''],['寻梦','',''],['寻欢','',''],['寻欢作乐','',''],['寻死','',''],['寻死觅活','',''],['寻求','',''],['寻甸县','',''],['寻的','',''],['寻短见','',''],['寻租','',''],['寻究','',''],['寻章摘句','',''],['寻花','',''],['寻花问柳','',''],['寻衅','',''],['寻行数墨','',''],['寻觅','',''],['寻访','',''],['寻踪','',''],['寻踪觅迹','',''],['寻迹','',''],['寻道','',''],['寻问','',''],['寻问者','',''],['导体','',''],['导入','',''],['导入期','',''],['导出','',''],['导出值','',''],['导函数','',''],['导医','',''],['导向','',''],['导坑','',''],['导尿','',''],['导尿管','',''],['导师','',''],['导引','',''],['导弹','',''],['导弹快艇','',''],['导弹战','',''],['导弹旅','',''],['导弹核潜艇','',''],['导弹武器技术控制制度','',''],['导弹潜艇','',''],['导弹艇','',''],['导德齐礼','',''],['导扬','',''],['导报','',''],['导播','',''],['导数','',''],['导板','',''],['导标','',''],['导水管','',''],['导沟','',''],['导油','',''],['导流','',''],['导流板','',''],['导液管','',''],['导游','',''],['导源','',''],['导演','',''],['导火','',''],['导火索','',''],['导火线','',''],['导热','',''],['导热性','',''],['导电','',''],['导电性','',''],['导盲犬','',''],['导磁','',''],['导磁率','',''],['导管','',''],['导管素','',''],['导管组织','',''],['导纳','',''],['导线','',''],['导致','',''],['导致死亡','',''],['导航','',''],['导航员','',''],['导航雷达','',''],['导言','',''],['导论','',''],['导语','',''],['导读','',''],['导购','',''],['导赤丸','',''],['导轨','',''],['导轮','',''],['导通','',''],['寿宴','',''],['寿丰','',''],['寿丰乡','',''],['寿保险公司','',''],['寿光鸡','',''],['寿司','',''],['寿命','',''],['寿堂','',''],['寿山福海','',''],['寿数','',''],['寿数已尽','',''],['寿斑','',''],['寿星','',''],['寿木','',''],['寿材','',''],['寿桃','',''],['寿桃包','',''],['寿比南山','',''],['寿满天年','',''],['寿王坟','',''],['寿王坟镇','',''],['寿礼','',''],['寿穴','',''],['寿筵','',''],['寿终','',''],['寿终正寝','',''],['寿考','',''],['寿联','',''],['寿衣','',''],['寿衾','',''],['寿诞','',''],['寿辰','',''],['寿限','',''],['寿险','',''],['寿陵匍匐','',''],['寿陵失步','',''],['寿面','',''],['封一','',''],['封三','',''],['封上','',''],['封为','',''],['封二','',''],['封住','',''],['封侯','',''],['封信','',''],['封候','',''],['封入','',''],['封冻','',''],['封函','',''],['封刀','',''],['封包','',''],['封印','',''],['封口','',''],['封口蜡','',''],['封号','',''],['封喉','',''],['封土','',''],['封地','',''],['封夺','',''],['封套','',''],['封妻荫子','',''],['封妻阴子','',''],['封存','',''],['封官','',''],['封官许愿','',''],['封封','',''],['封山','',''],['封山育林','',''],['封帐','',''],['封底','',''],['封建','',''],['封建主','',''],['封建主义','',''],['封建制度','',''],['封建割据','',''],['封建土地所有制','',''],['封建思想','',''],['封建性','',''],['封建把头','',''],['封建时代','',''],['封建社会','',''],['封建社会主义','',''],['封斋','',''],['封斋节','',''],['封杀','',''],['封条','',''],['封檐板','',''],['封死','',''],['封沙育林','',''],['封河','',''],['封河期','',''],['封泥','',''],['封港','',''],['封火','',''],['封爵','',''],['封牢','',''],['封疆','',''],['封皮','',''],['封盖','',''],['封神','',''],['封神榜','',''],['封神演义','',''],['封禁','',''],['封禅','',''],['封签','',''],['封缄','',''],['封网','',''],['封胡羯末','',''],['封胡遏末','',''],['封臣','',''],['封舱','',''],['封蜡','',''],['封袋','',''],['封装','',''],['封装块','',''],['封裹','',''],['封豕长蛇','',''],['封赏','',''],['封赠','',''],['封邑','',''],['封里','',''],['封锁','',''],['封锁线','',''],['封门','',''],['封掉','',''],['封闭','',''],['封闭器','',''],['封闭型','',''],['封闭式','',''],['封闭性','',''],['封闭性开局','',''],['封闭疗法','',''],['封面','',''],['封顶','',''],['封顶仪式','',''],['射中','',''],['射倒','',''],['射入','',''],['射出','',''],['射击','',''],['射击场','',''],['射击学','',''],['射击比赛','',''],['射击理论','',''],['射击训练','',''],['射击运动','',''],['射到','',''],['射向','',''],['射孔','',''],['射完','',''],['射层','',''],['射干','',''],['射弹','',''],['射影','',''],['射影几何','',''],['射影几何学','',''],['射影变换','',''],['射手','',''],['射手座','',''],['射杀','',''],['射极','',''],['射流','',''],['射流技术','',''],['射灯','',''],['射猎','',''],['射电','',''],['射电天文学','',''],['射电望远镜','',''],['射界','',''],['射石饮羽','',''],['射程','',''],['射箭','',''],['射精','',''],['射精管','',''],['射线','',''],['射能','',''],['射角','',''],['射速','',''],['射钉','',''],['射钉枪','',''],['射门','',''],['射雕英雄传','',''],['射频','',''],['射频噪声','',''],['射频干扰','',''],['射频武器','',''],['射频识别','',''],['射频调谐器','',''],['将上','',''],['将不','',''],['将且','',''],['将临','',''],['将为','',''],['将于','',''],['将今论古','',''],['将从','',''],['将他','',''],['将令','',''],['将以','',''],['将会','',''],['将伯','',''],['将伯之助','',''],['将使','',''],['将信将疑','',''],['将其','',''],['将养','',''],['将军','',''],['将军乡','',''],['将军肚子','',''],['将到','',''],['将功折罪','',''],['将功折过','',''],['将功补过','',''],['将功赎罪','',''],['将勤补拙','',''],['将勤补绌','',''],['将去','',''],['将同','',''],['将向','',''],['将增','',''],['将士','',''],['将她','',''],['将如','',''],['将它','',''],['将官','',''],['将对','',''],['将就','',''],['将帅','',''],['将心比心','',''],['将息','',''],['将成','',''],['将或','',''],['将才','',''],['将打开','',''],['将把','',''],['将指','',''],['将是','',''],['将有','',''],['将朝','',''],['将本图利','',''],['将机就机','',''],['将机就计','',''],['将来','',''],['将来临','',''],['将校','',''],['将棋','',''],['将次','',''],['将此','',''],['将死','',''],['将比','',''],['将牌','',''],['将由','',''],['将略','',''],['将相','',''],['将给','',''],['将至','',''],['将虾钓鳖','',''],['将被','',''],['将要','',''],['将要来','',''],['将计就计','',''],['将近','',''],['将遇良才','',''],['将那','',''],['将错就错','',''],['将门','',''],['将门出将','',''],['将门有将','',''],['将领','',''],['尉官','',''],['尉缭','',''],['尉缭子','',''],['尉迟','',''],['尉迟恭','',''],['尊严','',''],['尊为','',''],['尊亲','',''],['尊从','',''],['尊公','',''],['尊卑','',''],['尊口','',''],['尊古卑今','',''],['尊号','',''],['尊君','',''],['尊命','',''],['尊堂','',''],['尊奉','',''],['尊姓','',''],['尊姓大名','',''],['尊官厚禄','',''],['尊容','',''],['尊尚','',''],['尊崇','',''],['尊己卑人','',''],['尊师','',''],['尊师爱徒','',''],['尊师贵道','',''],['尊师重教','',''],['尊师重道','',''],['尊年尚齿','',''],['尊府','',''],['尊心','',''],['尊意','',''],['尊敬','',''],['尊称','',''],['尊翁','',''],['尊老','',''],['尊老爱幼','',''],['尊者','',''],['尊荣','',''],['尊贤使能','',''],['尊贤爱物','',''],['尊贵','',''],['尊酒论文','',''],['尊重','',''],['尊重事实','',''],['尊重人才','',''],['尊重客观事实','',''],['尊重知识','',''],['尊长','',''],['尊颜','',''],['尊驾','',''],['尊鱼','',''],['小三','',''],['小三和弦','',''],['小三度','',''],['小不忍则乱大谋','',''],['小不点','',''],['小不点儿','',''],['小丑','',''],['小丑跳梁','',''],['小丑鱼','',''],['小丘','',''],['小业主','',''],['小东西','',''],['小两','',''],['小两口','',''],['小两口儿','',''],['小个','',''],['小丸','',''],['小丸药','',''],['小义大利','',''],['小乖','',''],['小乘','',''],['小九九','',''],['小书','',''],['小了','',''],['小争吵','',''],['小争执','',''],['小争论','',''],['小事','',''],['小事一桩','',''],['小事件','',''],['小事化了','',''],['小二','',''],['小于','',''],['小亏','',''],['小五金','',''],['小亚细亚','',''],['小些','',''],['小产','',''],['小亭','',''],['小人','',''],['小人书','',''],['小人儿','',''],['小人儿书','',''],['小人国','',''],['小人得志','',''],['小人物','',''],['小人长戚戚','',''],['小令','',''],['小份','',''],['小企业','',''],['小众','',''],['小伙','',''],['小伙儿','',''],['小伙子','',''],['小传','',''],['小佃农','',''],['小住','',''],['小住所','',''],['小编','',''],['小便','',''],['小便器','',''],['小便宜','',''],['小便所','',''],['小便斗','',''],['小保姆','',''],['小俩口','',''],['小修','',''],['小偷','',''],['小偷儿','',''],['小偷小摸','',''],['小儿','',''],['小儿痲痹','',''],['小儿科','',''],['小儿经','',''],['小儿脐风散','',''],['小儿语','',''],['小儿软骨病','',''],['小儿麻痹','',''],['小儿麻痹病毒','',''],['小儿麻痹症','',''],['小兄弟','',''],['小先生','',''],['小兔','',''],['小公主','',''],['小公共','',''],['小兴安岭','',''],['小兵','',''],['小册','',''],['小册子','',''],['小写','',''],['小写体','',''],['小写字','',''],['小写字母','',''],['小农','',''],['小农场','',''],['小农经济','',''],['小冲突','',''],['小刀','',''],['小刀会','',''],['小刀会起义','',''],['小分枝','',''],['小分队','',''],['小则','',''],['小别','',''],['小到','',''],['小前提','',''],['小动作','',''],['小勺','',''],['小包','',''],['小区','',''],['小区域','',''],['小半','',''],['小半活','',''],['小协约国','',''],['小卒','',''],['小卖','',''],['小卖部','',''],['小卧室','',''],['小厂','',''],['小厨房','',''],['小厮','',''],['小反对','',''],['小发明','',''],['小叔','',''],['小叔子','',''],['小受大走','',''],['小变','',''],['小口','',''],['小叫','',''],['小可','',''],['小叶','',''],['小叶杨','',''],['小号','',''],['小吃','',''],['小吃店','',''],['小合唱','',''],['小同乡','',''],['小名','',''],['小吞噬细胞','',''],['小和尚','',''],['小咬','',''],['小品','',''],['小品文','',''],['小哥','',''],['小商','',''],['小商人','',''],['小商品','',''],['小商品经济','',''],['小商小贩','',''],['小商贩','',''],['小喇叭','',''],['小喜','',''],['小喜剧','',''],['小嗓','',''],['小嘴','',''],['小器','',''],['小器作','',''],['小器易盈','',''],['小团','',''],['小团体主义','',''],['小国','',''],['小国寡民','',''],['小国王','',''],['小圈','',''],['小圈子','',''],['小圈环','',''],['小场','',''],['小坏蛋','',''],['小坑','',''],['小块','',''],['小块土','',''],['小坚果','',''],['小型','',''],['小型企业','',''],['小型化','',''],['小型巴士','',''],['小型报','',''],['小型机','',''],['小型柜橱','',''],['小型核武器','',''],['小型汽车','',''],['小型货车','',''],['小型车','',''],['小城','',''],['小城市','',''],['小堆','',''],['小堡垒','',''],['小声','',''],['小处着手','',''],['小夜曲','',''],['小夥子','',''],['小天使','',''],['小天地','',''],['小天平','',''],['小天鹅','',''],['小太太','',''],['小头','',''],['小奏','',''],['小奖章','',''],['小套房','',''],['小女','',''],['小女子','',''],['小女孩','',''],['小如','',''],['小妖','',''],['小妖精','',''],['小妞','',''],['小妹','',''],['小姐','',''],['小姑','',''],['小姑娘','',''],['小姑子','',''],['小姨','',''],['小姨子','',''],['小娃','',''],['小娃娃','',''],['小娘','',''],['小娘子','',''],['小婿','',''],['小媳妇儿','',''],['小子','',''],['小孔','',''],['小字','',''],['小字辈','',''],['小学','',''],['小学教师','',''],['小学校','',''],['小学生','',''],['小孩','',''],['小孩似','',''],['小孩儿','',''],['小孩子','',''],['小宇宙','',''],['小宗','',''],['小官','',''],['小官僚','',''],['小宝','',''],['小客店','',''],['小家伙','',''],['小家子气','',''],['小家庭','',''],['小家碧玉','',''],['小家鼠','',''],['小容器','',''],['小寝室','',''],['小寨','',''],['小将','',''],['小小','',''],['小小不言','',''],['小小子','',''],['小小说','',''],['小尖塔','',''],['小尽','',''],['小屁孩','',''],['小屁孩日记','',''],['小屈大伸','',''],['小屋','',''],['小屋子','',''],['小山','',''],['小山丘','',''],['小山包包','',''],['小山羊','',''],['小岛','',''],['小岩洞','',''],['小峡谷','',''],['小川','',''],['小工','',''],['小工厂','',''],['小巧','',''],['小巧玲珑','',''],['小巫见大巫','',''],['小差','',''],['小巴','',''],['小巷','',''],['小市','',''],['小市民','',''],['小布','',''],['小布袋','',''],['小帐','',''],['小帽','',''],['小干','',''],['小平房','',''],['小年人','',''],['小广播','',''],['小床','',''],['小店','',''],['小康','',''],['小康水平','',''],['小康生活','',''],['小康社会','',''],['小廉大法','',''],['小廉曲谨','',''],['小建','',''],['小引','',''],['小弟','',''],['小弟弟','',''],['小张','',''],['小弹','',''],['小弹丸','',''],['小强','',''],['小影','',''],['小往大来','',''],['小径','',''],['小循环','',''],['小心','',''],['小心点','',''],['小心眼','',''],['小心眼儿','',''],['小心翼翼','',''],['小心谨慎','',''],['小忠小信','',''],['小性儿','',''],['小恩','',''],['小恭','',''],['小惠','',''],['小惩大诫','',''],['小意思','',''],['小憩','',''],['小戏','',''],['小成','',''],['小我','',''],['小户','',''],['小房','',''],['小房子','',''],['小房屋','',''],['小房间','',''],['小扁豆','',''],['小手','',''],['小手小脚','',''],['小手工业者','',''],['小手鼓','',''],['小打小闹','',''],['小批','',''],['小技','',''],['小抄','',''],['小抄儿','',''],['小把','',''],['小报','',''],['小拇哥儿','',''],['小拇指','',''],['小括号','',''],['小指','',''],['小捆','',''],['小提','',''],['小提琴','',''],['小提琴手','',''],['小提箱','',''],['小插曲','',''],['小摆设','',''],['小摊','',''],['小摊儿','',''],['小撮','',''],['小数','',''],['小数点','',''],['小斑点','',''],['小斗篷','',''],['小旅馆','',''],['小旗','',''],['小日子','',''],['小时','',''],['小时制','',''],['小时候','',''],['小时候儿','',''],['小时工','',''],['小昊','',''],['小明星','',''],['小春','',''],['小春作物','',''],['小昭寺','',''],['小晌午','',''],['小曲','',''],['小曲儿','',''],['小月','',''],['小有','',''],['小朋友','',''],['小木材','',''],['小木槌','',''],['小本','',''],['小本生意','',''],['小本经营','',''],['小机枪','',''],['小村','',''],['小杖则受大杖则走','',''],['小束','',''],['小束状','',''],['小杯','',''],['小松糕','',''],['小枉大直','',''],['小林','',''],['小枝','',''],['小枪眼','',''],['小柱','',''],['小标题','',''],['小树','',''],['小树林','',''],['小树枝','',''],['小样','',''],['小桌','',''],['小桥','',''],['小桶','',''],['小楷','',''],['小楼','',''],['小槌','',''],['小歌剧','',''],['小步','',''],['小步舞曲','',''],['小段子','',''],['小母鸡','',''],['小毛','',''],['小毛病','',''],['小毛虫','',''],['小民','',''],['小气','',''],['小气候','',''],['小气腔','',''],['小气鬼','',''],['小水','',''],['小池','',''],['小池・百合子','',''],['小汤山','',''],['小汽车','',''],['小沙丘','',''],['小沟','',''],['小河','',''],['小泉','',''],['小泉・纯一郎','',''],['小泡','',''],['小波','',''],['小波动','',''],['小注','',''],['小洋','',''],['小洋葱','',''],['小洞','',''],['小洞不堵','',''],['小洞不堵沉大船','',''],['小洞不补大洞吃苦','',''],['小流氓','',''],['小浪','',''],['小海湾','',''],['小海雀','',''],['小淘气','',''],['小渊恵三','',''],['小港','',''],['小港区','',''],['小游','',''],['小湖','',''],['小溪','',''],['小溪流','',''],['小滴','',''],['小潮','',''],['小瀑布','',''],['小灌木','',''],['小火','',''],['小火花','',''],['小灵通','',''],['小灵通机站','',''],['小灶','',''],['小灾难','',''],['小炉儿匠','',''],['小点','',''],['小点心','',''],['小照','',''],['小熊','',''],['小熊座','',''],['小熊猫','',''],['小熊维尼','',''],['小片','',''],['小牛','',''],['小牛肉','',''],['小牝牛','',''],['小物件','',''],['小物体','',''],['小犬','',''],['小犬座','',''],['小狗','',''],['小狮子','',''],['小狮座','',''],['小猪','',''],['小猫','',''],['小猫似','',''],['小猫熊','',''],['小王子','',''],['小玩','',''],['小玩意','',''],['小环','',''],['小珠','',''],['小班','',''],['小球','',''],['小球体','',''],['小球性','',''],['小球藻','',''],['小瓶','',''],['小甜点','',''],['小生','',''],['小生产','',''],['小生产者','',''],['小生意','',''],['小男','',''],['小男孩','',''],['小畑健','',''],['小病','',''],['小白兔','',''],['小白脸','',''],['小白脸儿','',''],['小白菜','',''],['小白鼠','',''],['小百科全书','',''],['小百货','',''],['小的','',''],['小皇帝','',''],['小皮包','',''],['小盆','',''],['小盐','',''],['小盒','',''],['小盒子','',''],['小盘','',''],['小看','',''],['小真豫','',''],['小眼薄皮','',''],['小眼角','',''],['小睡','',''],['小瞧','',''],['小石','',''],['小石子','',''],['小砖','',''],['小碟','',''],['小碟子','',''],['小礼','',''],['小礼帽','',''],['小礼拜','',''],['小祖宗','',''],['小神仙','',''],['小票','',''],['小私有制','',''],['小秋收','',''],['小种','',''],['小税','',''],['小穴','',''],['小窗','',''],['小窝','',''],['小站','',''],['小站练兵','',''],['小童','',''],['小笔','',''],['小笔电','',''],['小笼包','',''],['小算盘','',''],['小箱','',''],['小篆','',''],['小米','',''],['小米面','',''],['小粉','',''],['小粒','',''],['小精灵','',''],['小红帽','',''],['小红莓','',''],['小红萝卜','',''],['小纺','',''],['小线儿','',''],['小组','',''],['小组会','',''],['小组委员会','',''],['小组第一','',''],['小组长','',''],['小细胞','',''],['小结','',''],['小绳索','',''],['小绺','',''],['小绿人','',''],['小缸缸儿','',''],['小羊','',''],['小羊儿','',''],['小羊皮','',''],['小羊肉','',''],['小羚羊','',''],['小群','',''],['小老婆','',''],['小考','',''],['小者','',''],['小而','',''],['小而全','',''],['小聪明','',''],['小肚子','',''],['小肚鸡肠','',''],['小肠','',''],['小肠串气','',''],['小胡桃','',''],['小脏鬼','',''],['小脑','',''],['小脚','',''],['小脸','',''],['小腊烛','',''],['小腹','',''],['小腿','',''],['小腿侧','',''],['小膜','',''],['小舅','',''],['小舅子','',''],['小舌','',''],['小舍','',''],['小舟','',''],['小舰艇','',''],['小舰队','',''],['小船','',''],['小船室','',''],['小艇','',''],['小节','',''],['小节线','',''],['小花','',''],['小花棘豆','',''],['小花脸','',''],['小花远志','',''],['小花饰','',''],['小苏打','',''],['小苏打粉','',''],['小范围','',''],['小茅屋','',''],['小茴香','',''],['小茶杯','',''],['小草','',''],['小菜','',''],['小菜一碟','',''],['小菜儿','',''],['小菜碟儿','',''],['小萝卜','',''],['小营盘镇','',''],['小葱','',''],['小蓟','',''],['小薰','',''],['小虫','',''],['小虾','',''],['小虾米','',''],['小蛇','',''],['小蜜','',''],['小蠹','',''],['小行星','',''],['小行星带','',''],['小街','',''],['小街突','',''],['小衣','',''],['小衣裳','',''],['小补','',''],['小袋','',''],['小袋鼠','',''],['小褂','',''],['小襟','',''],['小规模','',''],['小视','',''],['小觑','',''],['小解','',''],['小触角','',''],['小计','',''],['小词','',''],['小试','',''],['小试锋芒','',''],['小话','',''],['小说','',''],['小说家','',''],['小调','',''],['小谎','',''],['小豆','',''],['小豆子','',''],['小豆蔻','',''],['小贝','',''],['小账','',''],['小货车','',''],['小贩','',''],['小费','',''],['小资','',''],['小资产阶级','',''],['小资产阶级社会主义','',''],['小赤壁','',''],['小起重机','',''],['小趾','',''],['小跑','',''],['小跑步','',''],['小路','',''],['小车','',''],['小车站','',''],['小轮车','',''],['小轿车','',''],['小辈','',''],['小辫','',''],['小辫儿','',''],['小辫子','',''],['小过','',''],['小造桥虫','',''],['小道','',''],['小道儿消息','',''],['小道具','',''],['小道新闻','',''],['小道消息','',''],['小部分','',''],['小都市','',''],['小酌','',''],['小酒','',''],['小酒馆','',''],['小里小气','',''],['小野不由美','',''],['小量','',''],['小金库','',''],['小钞','',''],['小钢炮','',''],['小钢球','',''],['小钩','',''],['小钩子','',''],['小钱','',''],['小铃当','',''],['小铲子','',''],['小锅','',''],['小错','',''],['小锣','',''],['小键盘','',''],['小镇','',''],['小门','',''],['小队','',''],['小队长','',''],['小阳春','',''],['小阿姨','',''],['小院','',''],['小除夕','',''],['小隔间','',''],['小隙沉舟','',''],['小雁塔','',''],['小雅','',''],['小集团','',''],['小雕像','',''],['小雨','',''],['小青年','',''],['小青瓦','',''],['小静脉','',''],['小面包','',''],['小鞋','',''],['小项','',''],['小项目','',''],['小颗','',''],['小题大作','',''],['小题大做','',''],['小颚','',''],['小额','',''],['小额融资','',''],['小风琴','',''],['小食中心','',''],['小饭店','',''],['小饭馆','',''],['小饮','',''],['小饼乾','',''],['小首饰','',''],['小香袋','',''],['小马','',''],['小马座','',''],['小驻','',''],['小鬼','',''],['小鱼','',''],['小鲵','',''],['小鸟','',''],['小兽','',''],['小鸟依人','',''],['小鸡','',''],['小鸡鸡','',''],['小鸭','',''],['小鹅','',''],['小鹰','',''],['小鹰号','',''],['小鹿','',''],['小鹿乱撞','',''],['小麦','',''],['小麦线虫','',''],['小麦线虫病','',''],['小麦胚芽','',''],['小黄瓜','',''],['小黄鱼','',''],['小黠大痴','',''],['小鼓','',''],['小鼠','',''],['小齿轮','',''],['小龙','',''],['小龙汤包','',''],['小龙虾','',''],['少一半','',''],['少不','',''],['少不了','',''],['少不得','',''],['少不更事','',''],['少不经事','',''],['少东','',''],['少之','',''],['少之又少','',''],['少于','',''],['少交','',''],['少产','',''],['少付','',''],['少佐','',''],['少儿','',''],['少儿不宜','',''],['少先队','',''],['少先队员','',''],['少列','',''],['少则','',''],['少刻','',''],['少印','',''],['少发','',''],['少吃','',''],['少地','',''],['少壮','',''],['少壮不努力','',''],['少壮派','',''],['少女','',''],['少女似','',''],['少女嫩妇','',''],['少女峰','',''],['少女露笑脸','',''],['少奶奶','',''],['少妇','',''],['少安勿躁','',''],['少安无躁','',''],['少安毋躁','',''],['少将','',''],['少尉','',''],['少小','',''],['少少','',''],['少年','',''],['少年之家','',''],['少年人','',''],['少年儿童','',''],['少年先锋队','',''],['少年宫','',''],['少年期','',''],['少年犯','',''],['少年老成','',''],['少府','',''],['少开','',''],['少征','',''],['少待','',''],['少得','',''],['少成','',''],['少成多','',''],['少成若性','',''],['少扣','',''],['少找','',''],['少报','',''],['少提','',''],['少搞','',''],['少收','',''],['少放','',''],['少数','',''],['少数人','',''],['少数党','',''],['少数服从多数','',''],['少数民族','',''],['少数民族乡','',''],['少数民族地区','',''],['少数派','',''],['少时','',''],['少有','',''],['少条失教','',''],['少林','',''],['少林寺','',''],['少林拳','',''],['少林武功','',''],['少校','',''],['少爷','',''],['少生优生','',''],['少用','',''],['少男','',''],['少男少女','',''],['少白头','',''],['少的','',''],['少相','',''],['少礼','',''],['少私寡欲','',''],['少突胶质','',''],['少等','',''],['少算','',''],['少管','',''],['少管闲事','',''],['少纳','',''],['少给','',''],['少而精','',''],['少艾','',''],['少花钱多办事','',''],['少装','',''],['少见','',''],['少见多怪','',''],['少解','',''],['少计','',''],['少记','',''],['少讲','',''],['少讲空话','',''],['少许','',''],['少说','',''],['少说为佳','',''],['少说多做','',''],['少贴','',''],['少走弯路','',''],['少转','',''],['少运','',''],['少退','',''],['少配','',''],['少量','',''],['少钱','',''],['少销','',''],['少间','',''],['少阳病','',''],['少阳经','',''],['少陪','',''],['少顷','',''],['少额','',''],['尔人','',''],['尔后','',''],['尔尔','',''],['尔式','',''],['尔德','',''],['尔族','',''],['尔曹','',''],['尔来','',''],['尔格','',''],['尔歌','',''],['尔汝','',''],['尔汝之交','',''],['尔省','',''],['尔等','',''],['尔自','',''],['尔虞我诈','',''],['尔诈我虞','',''],['尔语','',''],['尔雅','',''],['尔雅温文','',''],['尔非','',''],['尖兵','',''],['尖刀','',''],['尖利','',''],['尖刺','',''],['尖刻','',''],['尖劈','',''],['尖叫','',''],['尖叫声','',''],['尖啸','',''],['尖喊','',''],['尖嗓','',''],['尖嘴','',''],['尖嘴猴腮','',''],['尖嘴薄舌','',''],['尖嘴鱼','',''],['尖团音','',''],['尖塔','',''],['尖塔状','',''],['尖声','',''],['尖声啼哭','',''],['尖头','',''],['尖头蝗','',''],['尖子','',''],['尖尖','',''],['尖尖的','',''],['尖山','',''],['尖峰','',''],['尖形','',''],['尖括号','',''],['尖拱','',''],['尖新','',''],['尖桩','',''],['尖梢','',''],['尖椒','',''],['尖沙咀','',''],['尖溜溜','',''],['尖牙','',''],['尖瓣','',''],['尖石','',''],['尖石乡','',''],['尖窄','',''],['尖端','',''],['尖端放电','',''],['尖端细','',''],['尖笔','',''],['尖管面','',''],['尖细','',''],['尖脐','',''],['尖草坪','',''],['尖角','',''],['尖酸','',''],['尖酸刻薄','',''],['尖钉','',''],['尖锐','',''],['尖锐化','',''],['尖锐声','',''],['尖锐批评','',''],['尖阁列岛','',''],['尖音','',''],['尖顶','',''],['尖顶窗','',''],['尖鼻子','',''],['尖齿','',''],['尘世','',''],['尘事','',''],['尘云','',''],['尘俗','',''],['尘凡','',''],['尘嚣','',''],['尘土','',''],['尘土飞扬','',''],['尘垢','',''],['尘垢秕糠','',''],['尘埃','',''],['尘埃传染','',''],['尘埃落定','',''],['尘寰','',''],['尘封','',''],['尘暴','',''],['尘粒','',''],['尘缘','',''],['尘肺','',''],['尘芥','',''],['尘菌','',''],['尘螨','',''],['尘雾','',''],['尘饭涂羹','',''],['尚不','',''],['尚不安','',''],['尚且','',''],['尚书','',''],['尚书经','',''],['尚书郎','',''],['尚佳','',''],['尚可','',''],['尚在','',''],['尚好','',''],['尚属','',''],['尚应','',''],['尚待','',''],['尚感','',''],['尚慕杰','',''],['尚方剑','',''],['尚方宝剑','',''],['尚无','',''],['尚是','',''],['尚有','',''],['尚未','',''],['尚未解决','',''],['尚武','',''],['尚看','',''],['尚缺','',''],['尚能','',''],['尚难','',''],['尚需','',''],['尚须','',''],['尚飨','',''],['尜儿','',''],['尜尜','',''],['尝了','',''],['尝出','',''],['尝到','',''],['尝受','',''],['尝味','',''],['尝尝','',''],['尝尽','',''],['尝尽心酸','',''],['尝新','',''],['尝胆','',''],['尝胆卧薪','',''],['尝试','',''],['尝试性','',''],['尝过','',''],['尝鲜','',''],['尝鼎一脔','',''],['尤为','',''],['尤以','',''],['尤佳','',''],['尤克里里琴','',''],['尤其','',''],['尤其是','',''],['尤其要','',''],['尤利娅・季莫申科','',''],['尤利西斯','',''],['尤加','',''],['尤加利','',''],['尤卡坦','',''],['尤卡坦半岛','',''],['尤坎','',''],['尤如','',''],['尤尔钦科','',''],['尤异','',''],['尤德','',''],['尤指','',''],['尤文图斯','',''],['尤有','',''],['尤有甚者','',''],['尤物','',''],['尤甚','',''],['尤诟','',''],['尤里斯・伊文思','',''],['尤金塞尔南','',''],['尤须','',''],['尥蹶子','',''],['尧天舜日','',''],['尧舜','',''],['尧都','',''],['就会','',''],['就在','',''],['就业','',''],['就业人数','',''],['就业培训','',''],['就业安定费','',''],['就业机会','',''],['就业率','',''],['就业问题','',''],['就义','',''],['就事论事','',''],['就任者','',''],['就便器材','',''],['就医','',''],['就地取材','',''],['就地正法','',''],['就坡下驴','',''],['就好','',''],['就是','',''],['就像','',''],['就寝','',''],['就寝时间','',''],['就席','',''],['就教于','',''],['就日瞻云','',''],['就棍打腿','',''],['就此罢休','',''],['就算','',''],['就绪','',''],['就职','',''],['就职典礼','',''],['就职演讲','',''],['就职演说','',''],['就范','',''],['就虚避实','',''],['就诊','',''],['就读','',''],['就象','',''],['就近','',''],['就餐','',''],['尴尬','',''],['尸位','',''],['尸位素餐','',''],['尸体','',''],['尸体剖检','',''],['尸体袋','',''],['尸体解剖','',''],['尸僵','',''],['尸布','',''],['尸斑','',''],['尸检','',''],['尸横遍野','',''],['尸禄','',''],['尸蜡','',''],['尸衣','',''],['尸身','',''],['尸首','',''],['尸骨','',''],['尸骨未寒','',''],['尸骸','',''],['尸魂','',''],['尹潽善','',''],['尺中','',''],['尺二冤家','',''],['尺二秀才','',''],['尺动脉','',''],['尺头儿','',''],['尺子','',''],['尺寸','',''],['尺寸之功','',''],['尺寸千里','',''],['尺寸过大','',''],['尺山寸水','',''],['尺布斗粟','',''],['尺布绳趋','',''],['尺幅千里','',''],['尺度','',''],['尺数','',''],['尺有所短','',''],['尺板斗食','',''],['尺波电谢','',''],['尺牍','',''],['尺短寸长','',''],['尺码','',''],['尺蠖','',''],['尺蠖蛾','',''],['尺规','',''],['尺规作图','',''],['尺骨','',''],['尻舆神马','',''],['尻轮神马','',''],['尻门子','',''],['尻骨','',''],['尼亚','',''],['尼亚加拉瀑布','',''],['尼亚美','',''],['尼克','',''],['尼克松','',''],['尼克松主义','',''],['尼克森','',''],['尼厄丽德','',''],['尼古丁','',''],['尼哥底母','',''],['尼姆','',''],['尼姑','',''],['尼安德塔','',''],['尼安德塔人','',''],['尼安德鲁人','',''],['尼尔逊','',''],['尼峰','',''],['尼布楚条约','',''],['尼布甲尼撒','',''],['尼希米记','',''],['尼庵','',''],['尼康','',''],['尼德兰','',''],['尼德兰资产阶级革命','',''],['尼斯','',''],['尼斯湖水怪','',''],['尼日尔河','',''],['尼格罗','',''],['尼桑','',''],['尼泊尔人','',''],['尼泊尔共产党','',''],['尼泊尔国王','',''],['尼泊尔语','',''],['尼科西亚','',''],['尼米兹','',''],['尼米兹号','',''],['尼罗','',''],['尼罗河','',''],['尼赫','',''],['尼赫鲁','',''],['尼采','',''],['尼雅','',''],['尼雅河','',''],['尼龙','',''],['尼龙丝','',''],['尼龙搭扣','',''],['尽上','',''],['尽义务','',''],['尽人皆知','',''],['尽伏东流','',''],['尽先','',''],['尽入彀中','',''],['尽全','',''],['尽全力','',''],['尽兴','',''],['尽兴而归','',''],['尽其','',''],['尽其在我','',''],['尽其所有','',''],['尽到','',''],['尽到责任','',''],['尽力','',''],['尽力尽责','',''],['尽力而为','',''],['尽可','',''],['尽可能','',''],['尽善尽美','',''],['尽在','',''],['尽在其中','',''],['尽地主之谊','',''],['尽够','',''],['尽失','',''],['尽头','',''],['尽如','',''],['尽如人意','',''],['尽孝','',''],['尽弃','',''],['尽心','',''],['尽心图极','',''],['尽心尽力','',''],['尽心尽意','',''],['尽心尽职','',''],['尽心竭力','',''],['尽心竭诚','',''],['尽忠','',''],['尽忠尽职','',''],['尽忠报国','',''],['尽忠竭力','',''],['尽快','',''],['尽态极妍','',''],['尽性','',''],['尽情','',''],['尽情尽理','',''],['尽意','',''],['尽收','',''],['尽收眼底','',''],['尽数','',''],['尽日穷夜','',''],['尽早','',''],['尽期','',''],['尽欢','',''],['尽欢而散','',''],['尽然','',''],['尽瘁','',''],['尽瘁事国','',''],['尽瘁鞠躬','',''],['尽皆','',''],['尽盘将军','',''],['尽知','',''],['尽管','',''],['尽管如此','',''],['尽美尽善','',''],['尽职','',''],['尽职尽责','',''],['尽自','',''],['尽致','',''],['尽节竭诚','',''],['尽言','',''],['尽让','',''],['尽诚竭节','',''],['尽责','',''],['尽责尽力','',''],['尽速','',''],['尽释前嫌','',''],['尽量','',''],['尽饱','',''],['尾击','',''],['尾声','',''],['尾大不掉','',''],['尾大难掉','',''],['尾子','',''],['尾字','',''],['尾巴','',''],['尾巴主义','',''],['尾座','',''],['尾张国','',''],['尾数','',''],['尾期','',''],['尾板','',''],['尾梢','',''],['尾欠','',''],['尾款','',''],['尾气','',''],['尾水','',''],['尾水渠道','',''],['尾注','',''],['尾流','',''],['尾灯','',''],['尾牙','',''],['尾状物','',''],['尾生','',''],['尾矿','',''],['尾矿库','',''],['尾端','',''],['尾缀','',''],['尾羽','',''],['尾羽龙','',''],['尾翼','',''],['尾花','',''],['尾苗','',''],['尾蚴','',''],['尾语','',''],['尾追','',''],['尾部','',''],['尾酒','',''],['尾闾','',''],['尾闾骨','',''],['尾随','',''],['尾音','',''],['尾韵','',''],['尾页','',''],['尾骨','',''],['尾鳍','',''],['尿不湿','',''],['尿嘧啶','',''],['尿壶','',''],['尿尿','',''],['尿崩症','',''],['尿布','',''],['尿布垫','',''],['尿床','',''],['尿样','',''],['尿毒','',''],['尿毒症','',''],['尿泡','',''],['尿流屁滚','',''],['尿液','',''],['尿潴留','',''],['尿炕','',''],['尿生殖管道','',''],['尿盆','',''],['尿管','',''],['尿素','',''],['尿肥','',''],['尿脬','',''],['尿臊味','',''],['尿花','',''],['尿道','',''],['尿道炎','',''],['尿酸','',''],['尿闭','',''],['尿频','',''],['局中人','',''],['局促','',''],['局促一隅','',''],['局促不安','',''],['局内','',''],['局势','',''],['局势稳定','',''],['局地','',''],['局域','',''],['局域网','',''],['局外','',''],['局外中立','',''],['局外人','',''],['局委','',''],['局子','',''],['局级','',''],['局部','',''],['局部利益','',''],['局部化','',''],['局部地区','',''],['局部性','',''],['局部战争','',''],['局部语境','',''],['局部连结网络','',''],['局部连贯性','',''],['局部麻醉','',''],['局部麻醉剂','',''],['局长','',''],['局限','',''],['局限于','',''],['局限性','',''],['局面','',''],['局饕','',''],['局骗','',''],['局麻药','',''],['屁事','',''],['屁屁','',''],['屁滚尿流','',''],['屁用','',''],['屁眼','',''],['屁眼儿','',''],['屁精','',''],['屁股','',''],['屁股蹲儿','',''],['屁话','',''],['屁颠屁颠','',''],['层云','',''],['层内','',''],['层出不穷','',''],['层出叠见','',''],['层卷云','',''],['层压','',''],['层压式推销','',''],['层压板','',''],['层叠','',''],['层外','',''],['层子','',''],['层子模型','',''],['层层','',''],['层层加码','',''],['层层落实','',''],['层层迭迭','',''],['层岩','',''],['层峦','',''],['层峦叠嶂','',''],['层峦迭嶂','',''],['层带','',''],['层报','',''],['层数','',''],['层板','',''],['层林','',''],['层楼','',''],['层次','',''],['层次分明','',''],['层流','',''],['层状','',''],['层理','',''],['层积云','',''],['层级','',''],['层见叠出','',''],['层见迭出','',''],['层间','',''],['层面','',''],['层高','',''],['居上','',''],['居下讪上','',''],['居不重席','',''],['居不重茵','',''],['居丧','',''],['居中','',''],['居中调停','',''],['居之不疑','',''],['居于','',''],['居人','',''],['居仁由义','',''],['居位','',''],['居住','',''],['居住于','',''],['居住区','',''],['居住地','',''],['居住者','',''],['居住证','',''],['居住面积','',''],['居停','',''],['居先','',''],['居全国之首','',''],['居全国首位','',''],['居前','',''],['居功','',''],['居功不傲','',''],['居功厥伟','',''],['居功自傲','',''],['居功自恃','',''],['居区','',''],['居后','',''],['居士','',''],['居处','',''],['居多','',''],['居大不易','',''],['居奇','',''],['居委会','',''],['居孀','',''],['居宅','',''],['居安思危','',''],['居安虑危','',''],['居官','',''],['居官守法','',''],['居室','',''],['居家','',''],['居巢','',''],['居庸关','',''],['居心','',''],['居心不良','',''],['居心叵测','',''],['居心险恶','',''],['居所','',''],['居无定所','',''],['居无求安','',''],['居次','',''],['居正','',''],['居民','',''],['居民区','',''],['居民委员会','',''],['居民消费价格指数','',''],['居民点','',''],['居民点儿','',''],['居民购买力','',''],['居民身份证','',''],['居点','',''],['居然','',''],['居留','',''],['居留权','',''],['居留证','',''],['居礼','',''],['居礼夫人','',''],['居积','',''],['居第','',''],['居经','',''],['居者','',''],['居里','',''],['居里夫人','',''],['居间','',''],['居领先地位','',''],['居首','',''],['居首位','',''],['居首功','',''],['居高不下','',''],['居高临下','',''],['屈一伸万','',''],['屈下身','',''],['屈从','',''],['屈伸','',''],['屈体','',''],['屈光','',''],['屈光度','',''],['屈原','',''],['屈原祠','',''],['屈原纪念馆','',''],['屈尊','',''],['屈尊俯就','',''],['屈就','',''],['屈居','',''],['屈心','',''],['屈戌','',''],['屈戌儿','',''],['屈才','',''],['屈打成招','',''],['屈折语','',''],['屈指','',''],['屈指一算','',''],['屈指可数','',''],['屈挠','',''],['屈曲','',''],['屈服','',''],['屈服于','',''],['屈枉','',''],['屈死','',''],['屈水性','',''],['屈流性','',''],['屈膝','',''],['屈膝礼','',''],['屈艳班香','',''],['屈节','',''],['屈身','',''],['屈辱','',''],['屈驾','',''],['屉儿','',''],['屉子','',''],['届临','',''],['届时','',''],['届期','',''],['届满','',''],['屋上建瓴','',''],['屋下架屋','',''],['屋下盖屋','',''],['屋主','',''],['屋乌推爱','',''],['屋企','',''],['屋内','',''],['屋前','',''],['屋后','',''],['屋基','',''],['屋外','',''],['屋头','',''],['屋子','',''],['屋宇','',''],['屋架','',''],['屋梁','',''],['屋檐','',''],['屋町','',''],['屋脊','',''],['屋舍','',''],['屋角','',''],['屋里','',''],['屋里人','',''],['屋门','',''],['屋面','',''],['屋面瓦','',''],['屋顶','',''],['屋顶室','',''],['屋顶板','',''],['屋顶花园','',''],['屌丝','',''],['屎壳郎','',''],['屎尿','',''],['屎蚵螂','',''],['屏住','',''],['屏幕','',''],['屏幕保护程序','',''],['屏幕提示','',''],['屏弃','',''],['屏息','',''],['屏条','',''],['屏极','',''],['屏气','',''],['屏绝','',''],['屏营','',''],['屏蔽','',''],['屏蔽罐','',''],['屏藩','',''],['屏边','',''],['屏退','',''],['屏门','',''],['屏除','',''],['屏隔','',''],['屏障','',''],['屏风','',''],['屐履造门','',''],['屑于','',''],['展为','',''],['展位','',''],['展出','',''],['展列','',''],['展到','',''],['展卖','',''],['展厅','',''],['展台','',''],['展品','',''],['展团','',''],['展室','',''],['展宽','',''],['展布','',''],['展帆','',''],['展平','',''],['展延','',''],['展开','',''],['展开图','',''],['展开式','',''],['展性','',''],['展播','',''],['展望','',''],['展望镜','',''],['展期','',''],['展板','',''],['展牌','',''],['展玩','',''],['展现','',''],['展眉','',''],['展眼舒眉','',''],['展示','',''],['展示会','',''],['展示场','',''],['展示者','',''],['展缓','',''],['展翅','',''],['展翅高飞','',''],['展观','',''],['展览','',''],['展览会','',''],['展览品','',''],['展览者','',''],['展览馆','',''],['展评','',''],['展转','',''],['展转反侧','',''],['展转腾挪','',''],['展销','',''],['展销会','',''],['展销品','',''],['展限','',''],['展露','',''],['展颜','',''],['展颜微笑','',''],['展馆','',''],['屙尿','',''],['屙屎','',''],['属下','',''],['属世','',''],['属之','',''],['属于','',''],['属于她','',''],['属于我','',''],['属名','',''],['属吏','',''],['属员','',''],['属国','',''],['属地','',''],['属垣有耳','',''],['属实','',''],['属性','',''],['属意','',''],['属文','',''],['属有','',''],['属望','',''],['属格','',''],['属概念','',''],['属次比事','',''],['属毛离里','',''],['属灵','',''],['属相','',''],['属象','',''],['属马','',''],['屠伯','',''],['屠刀','',''],['屠场','',''],['屠城','',''],['屠夫','',''],['屠妖节','',''],['屠宰','',''],['屠宰场','',''],['屠戮','',''],['屠户','',''],['屠杀','',''],['屠杀场','',''],['屠杀者','',''],['屠格涅夫','',''],['屠毒','',''],['屠毒笔墨','',''],['屠苏酒','',''],['屠门大嚼','',''],['屠龙','',''],['屠龙之伎','',''],['屠龙之技','',''],['屡催','',''],['屡出狂言','',''],['屡劝不改','',''],['屡加','',''],['屡受','',''],['屡增','',''],['屡屡','',''],['屡屡得手','',''],['屡建奇功','',''],['屡战','',''],['屡战屡北','',''],['屡战屡胜','',''],['屡教','',''],['屡教不改','',''],['屡有','',''],['屡次','',''],['屡次三番','',''],['屡禁','',''],['屡禁不止','',''],['屡禁不绝','',''],['屡见','',''],['屡见不鲜','',''],['屡试','',''],['屡试不爽','',''],['屡败','',''],['屡遭','',''],['屡遭不测','',''],['履仁道义','',''],['履任','',''],['履冰','',''],['履历','',''],['履历片','',''],['履历表','',''],['履带','',''],['履带式拖拉机','',''],['履带机','',''],['履带车','',''],['履新','',''],['履汤蹈火','',''],['履约','',''],['履约保证金','',''],['履舄交错','',''],['履薄临沈','',''],['履行','',''],['履行义务','',''],['履行合同','',''],['履行诺言','',''],['履践','',''],['履险如夷','',''],['履霜坚冰','',''],['履霜知冰','',''],['屦及剑及','',''],['屦贱踊贵','',''],['屯兵','',''],['屯垦','',''],['屯垦园区','',''],['屯子','',''],['屯戍','',''],['屯扎','',''],['屯溪','',''],['屯特','',''],['屯特大学','',''],['屯田','',''],['屯田制','',''],['屯积','',''],['屯粮','',''],['屯粮积草','',''],['屯聚','',''],['屯落','',''],['屯街塞巷','',''],['屯门','',''],['屯驻','',''],['山上','',''],['山上乡','',''],['山下','',''],['山不转水转','',''],['山不转路转','',''],['山丘','',''],['山东半岛','',''],['山东大学','',''],['山东大鼓','',''],['山东快书','',''],['山东梆子','',''],['山东科技大学','',''],['山中','',''],['山中圣训','',''],['山乡','',''],['山亭','',''],['山人','',''],['山体','',''],['山侧','',''],['山冈','',''],['山凹','',''],['山前','',''],['山势','',''],['山包','',''],['山区','',''],['山南','',''],['山南海北','',''],['山口','',''],['山口县','',''],['山口洋','',''],['山后','',''],['山向','',''],['山呼海啸','',''],['山和尚','',''],['山响','',''],['山嘴','',''],['山国','',''],['山地','',''],['山地人','',''],['山地同胞','',''],['山地自行车','',''],['山坞','',''],['山坡','',''],['山坳','',''],['山埃','',''],['山城','',''],['山墙','',''],['山壑','',''],['山夜','',''],['山头','',''],['山头主义','',''],['山奈','',''],['山奈钾','',''],['山姆','',''],['山子','',''],['山寨','',''],['山寨王','',''],['山寨机','',''],['山寨货','',''],['山居','',''],['山山水水','',''],['山岗','',''],['山岗子','',''],['山岚','',''],['山岩','',''],['山岭','',''],['山岳','',''],['山峡','',''],['山峦','',''],['山峦重叠','',''],['山峰','',''],['山崎','',''],['山崖','',''],['山崩','',''],['山崩地坼','',''],['山崩地裂','',''],['山崩地陷','',''],['山崩钟应','',''],['山嵛菜','',''],['山巅','',''],['山川','',''],['山带','',''],['山庄','',''],['山形','',''],['山形县','',''],['山形墙','',''],['山径','',''],['山摇地动','',''],['山斗','',''],['山旮旯','',''],['山旮旯儿','',''],['山明水秀','',''],['山晕','',''],['山木','',''],['山本','',''],['山本五十六','',''],['山村','',''],['山杨','',''],['山林','',''],['山果','',''],['山查','',''],['山栖谷饮','',''],['山核桃','',''],['山根','',''],['山桃','',''],['山案座','',''],['山桐子','',''],['山梁','',''],['山梨','',''],['山梨县','',''],['山梨酸钾','',''],['山梨醇','',''],['山椒鱼','',''],['山楂','',''],['山榄科','',''],['山樱桃','',''],['山歌','',''],['山毛榉','',''],['山民','',''],['山水','',''],['山水画','',''],['山水诗','',''],['山沟','',''],['山河','',''],['山河易改本性难移','',''],['山河镇','',''],['山泉','',''],['山泥倾泻','',''],['山洞','',''],['山洪','',''],['山洪暴发','',''],['山洼','',''],['山海关','',''],['山海经','',''],['山涧','',''],['山清水秀','',''],['山火','',''],['山炮','',''],['山狮','',''],['山猪','',''],['山猫','',''],['山珍','',''],['山珍海味','',''],['山珍海错','',''],['山瑞','',''],['山瑞鳖','',''],['山田','',''],['山盟海誓','',''],['山石','',''],['山神','',''],['山积','',''],['山穷水尽','',''],['山窝','',''],['山窝窝','',''],['山竹','',''],['山系','',''],['山羊','',''],['山羊似','',''],['山羊座','',''],['山羊皮','',''],['山羊绒','',''],['山羌','',''],['山群','',''],['山肴野蔌','',''],['山胡桃','',''],['山胡桃木','',''],['山脉','',''],['山脉间','',''],['山脊','',''],['山脚','',''],['山腰','',''],['山腹','',''],['山色','',''],['山芋','',''],['山花','',''],['山苍子','',''],['山茱萸','',''],['山茶','',''],['山茶花','',''],['山草','',''],['山药','',''],['山药蛋','',''],['山莓','',''],['山葡萄','',''],['山葵','',''],['山行','',''],['山西兽','',''],['山西大学','',''],['山西梆子','',''],['山谷','',''],['山豆根','',''],['山货','',''],['山贼','',''],['山路','',''],['山轿','',''],['山达基','',''],['山道','',''],['山道年','',''],['山遥水远','',''],['山那边','',''],['山里','',''],['山里红','',''],['山野','',''],['山镇','',''],['山长水远','',''],['山门','',''],['山间','',''],['山险','',''],['山陵','',''],['山雀','',''],['山雀类','',''],['山雕','',''],['山雨欲来风满楼','',''],['山靛','',''],['山顶','',''],['山顶洞人','',''],['山颓木坏','',''],['山颠','',''],['山风','',''],['山高','',''],['山高水低','',''],['山高水长','',''],['山高水险','',''],['山高海深','',''],['山魈','',''],['山鸟类','',''],['山鸡','',''],['山鸡椒','',''],['山鸡舞镜','',''],['山麓','',''],['山鼠类','',''],['屹然','',''],['屹立','',''],['岁不我与','',''],['岁丰年稔','',''],['岁了','',''],['岁以上','',''],['岁修','',''],['岁俸','',''],['岁入','',''],['岁出','',''],['岁在龙蛇','',''],['岁寒三友','',''],['岁寒松柏','',''],['岁岁','',''],['岁岁平安','',''],['岁差','',''],['岁序','',''],['岁数','',''],['岁时','',''],['岁时伏腊','',''],['岁星','',''],['岁晚','',''],['岁暮','',''],['岁月','',''],['岁月不居','',''],['岁月如流','',''],['岁月峥嵘','',''],['岁月待人','',''],['岁月流逝','',''],['岁月蹉跎','',''],['岁末','',''],['岁末年初','',''],['岁杪','',''],['岁比不登','',''],['岁秒','',''],['岁稔年丰','',''],['岁绪','',''],['岁计余绌','',''],['岁间','',''],['岁阑','',''],['岁除','',''],['岁首','',''],['岂不','',''],['岂不怪哉','',''],['岂不是','',''],['岂但','',''],['岂只','',''],['岂可','',''],['岂容他人鼾睡','',''],['岂弟君子','',''],['岂敢','',''],['岂是','',''],['岂有他哉','',''],['岂有此理','',''],['岂止','',''],['岂知','',''],['岂能','',''],['岂非','',''],['岌岌','',''],['岌岌可危','',''],['岐点','',''],['岐视','',''],['岐路灯','',''],['岐阜县','',''],['岑寂','',''],['岑岑','',''],['岑彭','',''],['岔口','',''],['岔子','',''],['岔尾','',''],['岔开','',''],['岔换','',''],['岔曲儿','',''],['岔气','',''],['岔河','',''],['岔流','',''],['岔眼','',''],['岔调','',''],['岔路','',''],['岔路口','',''],['岔道','',''],['岔道儿','',''],['岗亭','',''],['岗仁波齐','',''],['岗位','',''],['岗位责任制','',''],['岗哨','',''],['岗地','',''],['岗子','',''],['岗峦','',''],['岗楼','',''],['岗石','',''],['岗警','',''],['岘港','',''],['岘首山','',''],['岚山','',''],['岛上','',''],['岛产','',''],['岛人','',''],['岛名','',''],['岛国','',''],['岛屿','',''],['岛弧','',''],['岛民','',''],['岛状物','',''],['岛瘦郊寒','',''],['岛盖部','',''],['岩仓','',''],['岩仓使节团','',''],['岩土体','',''],['岩壁','',''],['岩壑','',''],['岩层','',''],['岩居穴处','',''],['岩居谷饮','',''],['岩屑','',''],['岩岸','',''],['岩床','',''],['岩径','',''],['岩心','',''],['岩手','',''],['岩手县','',''],['岩棉','',''],['岩沙海葵毒素','',''],['岩洞','',''],['岩流','',''],['岩流圈','',''],['岩浆','',''],['岩浆岩','',''],['岩浆流','',''],['岩渣','',''],['岩溶','',''],['岩溶地貌','',''],['岩状','',''],['岩画','',''],['岩盐','',''],['岩石','',''],['岩石圈','',''],['岩石学','',''],['岩石层','',''],['岩礁','',''],['岩穴','',''],['岩穴之士','',''],['岩类','',''],['岩羊','',''],['岩脉','',''],['岩茶','',''],['岩葬','',''],['岩质','',''],['岫岩县','',''],['岬角','',''],['岭东','',''],['岭南','',''],['岭巆','',''],['岭拨','',''],['岭石','',''],['岭高','',''],['岱宗','',''],['岱庙','',''],['岳丈','',''],['岳塘','',''],['岳家','',''],['岳得尔歌','',''],['岳母','',''],['岳父','',''],['岳父母','',''],['岳阳地区','',''],['岳阳楼','',''],['岳阳楼记','',''],['岳飞','',''],['岳麓','',''],['岳麓书院','',''],['岳麓山','',''],['岷山','',''],['岷江','',''],['岸上','',''],['岸壁','',''],['岸头','',''],['岸标','',''],['岸然','',''],['岸然道貌','',''],['岸边','',''],['岿然','',''],['岿然不动','',''],['岿然独存','',''],['峄城','',''],['峇峇娘惹','',''],['峒人','',''],['峒剧','',''],['峒室','',''],['峙立','',''],['峡口','',''],['峡湾','',''],['峡谷','',''],['峥嵘','',''],['峥嵘岁月','',''],['峥巆','',''],['峨冠博带','',''],['峨山县','',''],['峨嵋','',''],['峨嵋山','',''],['峨嵋山市','',''],['峨嵋拳','',''],['峨眉','',''],['峨眉乡','',''],['峨边县','',''],['峪口','',''],['峭壁','',''],['峭拔','',''],['峭直','',''],['峭立','',''],['峰丘','',''],['峰会','',''],['峰值','',''],['峰值输出功能','',''],['峰回路转','',''],['峰峦','',''],['峰峰矿','',''],['峰巅','',''],['峰期','',''],['峰火台','',''],['峰线','',''],['峰顶','',''],['峻厉','',''],['峻地','',''],['峻岭','',''],['峻岭崇山','',''],['峻峭','',''],['峻急','',''],['峻法','',''],['峻笔','',''],['峻阪盐车','',''],['崁顶','',''],['崁顶乡','',''],['崂山','',''],['崆峒','',''],['崇善','',''],['崇外','',''],['崇奉','',''],['崇安','',''],['崇尚','',''],['崇山','',''],['崇山峻岭','',''],['崇川','',''],['崇庆','',''],['崇拜','',''],['崇拜仪式','',''],['崇拜者','',''],['崇敬','',''],['崇文','',''],['崇文门','',''],['崇明岛','',''],['崇本抑末','',''],['崇洋','',''],['崇洋媚外','',''],['崇祯','',''],['崇论宏议','',''],['崇论闳议','',''],['崇高','',''],['崇高品质','',''],['崇高理想','',''],['崎岖','',''],['崎岖险阻','',''],['崔健','',''],['崔圭夏','',''],['崔嵬','',''],['崔巍','',''],['崔明慧','',''],['崔永元','',''],['崔萤','',''],['崔述','',''],['崔颢','',''],['崔鸿','',''],['崖刻','',''],['崖壁','',''],['崖壑','',''],['崖山之战','',''],['崖岸','',''],['崖州','',''],['崖略','',''],['崖谷','',''],['崖限','',''],['崛地而起','',''],['崛立','',''],['崛起','',''],['崦嵫','',''],['崧生岳降','',''],['崩倒','',''],['崩决','',''],['崩坍','',''],['崩坏','',''],['崩坏作用','',''],['崩塌','',''],['崩摧','',''],['崩殂','',''],['崩毁','',''],['崩溃','',''],['崩漏','',''],['崩症','',''],['崩盘','',''],['崩落','',''],['崩裂','',''],['崩解','',''],['崩陷','',''],['崩龙','',''],['崩龙族','',''],['崭亮','',''],['崭劲','',''],['崭新','',''],['崭晴','',''],['崭然','',''],['崭露头角','',''],['崭齐','',''],['崴子','',''],['崴泥','',''],['崽子','',''],['嵊县','',''],['嵊泗列岛','',''],['嵌于','',''],['嵌入','',''],['嵌合','',''],['嵌合体','',''],['嵌在','',''],['嵌块','',''],['嵌套','',''],['嵌接','',''],['嵌有','',''],['嵌木','',''],['嵌片','',''],['嵌物','',''],['嵌环','',''],['嵌进','',''],['嵌金','',''],['嵞山','',''],['嵩山','',''],['嵬然不动','',''],['嵯峨','',''],['嶙峋','',''],['嶙嶙','',''],['巅峰','',''],['巍山','',''],['巍山县','',''],['巍峨','',''],['巍巍','',''],['巍然','',''],['巍然屹立','',''],['川党','',''],['川党参','',''],['川军','',''],['川剧','',''],['川外','',''],['川崎','',''],['川汇','',''],['川江','',''],['川沙','',''],['川流','',''],['川流不息','',''],['川滇藏','',''],['川畸','',''],['川端康成','',''],['川红','',''],['川芎','',''],['川菜','',''],['川菜厅','',''],['川藏','',''],['川藏公路','',''],['川西','',''],['川谷','',''],['川贝','',''],['川资','',''],['川震','',''],['川马','',''],['川黔铁路','',''],['州内','',''],['州县','',''],['州名','',''],['州官','',''],['州官放火','',''],['州市','',''],['州界','',''],['州立','',''],['州立大学','',''],['州议会','',''],['州辖','',''],['州郡','',''],['州里','',''],['州长','',''],['州际','',''],['巡于','',''],['巡哨','',''],['巡回','',''],['巡回分析端口','',''],['巡回医疗','',''],['巡回展览','',''],['巡回法庭','',''],['巡回演出','',''],['巡夜','',''],['巡天','',''],['巡守','',''],['巡察','',''],['巡展','',''],['巡幸','',''],['巡弋','',''],['巡抚','',''],['巡捕','',''],['巡捕房','',''],['巡查','',''],['巡检','',''],['巡洋','',''],['巡洋舰','',''],['巡测仪','',''],['巡游','',''],['巡演','',''],['巡礼','',''],['巡票','',''],['巡航','',''],['巡航导弹','',''],['巡行','',''],['巡视','',''],['巡视员','',''],['巡视者','',''],['巡警','',''],['巡诊','',''],['巡逻','',''],['巡逻者','',''],['巡逻船','',''],['巡逻艇','',''],['巡逻车','',''],['巡逻队','',''],['巡道','',''],['巡邋','',''],['巡防','',''],['巡风','',''],['巢中','',''],['巢倾卵覆','',''],['巢县','',''],['巢居','',''],['巢居穴处','',''],['巢房','',''],['巢毁卵破','',''],['巢湖地区','',''],['巢状','',''],['巢础','',''],['巢穴','',''],['巢窝','',''],['巢窟','',''],['巢脾','',''],['巢菜','',''],['巢鼠','',''],['工业','',''],['工业七国集团','',''],['工业体系','',''],['工业化','',''],['工业化国家','',''],['工业区','',''],['工业厅','',''],['工业品','',''],['工业园区','',''],['工业国','',''],['工业大学','',''],['工业学校','',''],['工业局','',''],['工业气压','',''],['工业现代化','',''],['工业用','',''],['工业界','',''],['工业病','',''],['工业设计','',''],['工业部','',''],['工业除尘','',''],['工业革命','',''],['工事','',''],['工于心计','',''],['工交','',''],['工人','',''],['工人们','',''],['工人党','',''],['工人文化宫','',''],['工人日报','',''],['工人纠察队','',''],['工人贵族','',''],['工人运动','',''],['工人阶级','',''],['工人阶级解放斗争协会','',''],['工件','',''],['工价','',''],['工休','',''],['工休日','',''],['工会','',''],['工会工作','',''],['工会干部','',''],['工会组织','',''],['工伤','',''],['工伤事故','',''],['工伤假','',''],['工体','',''],['工余','',''],['工作','',''],['工作上','',''],['工作中','',''],['工作人员','',''],['工作件','',''],['工作区','',''],['工作单位','',''],['工作台','',''],['工作周','',''],['工作地','',''],['工作场','',''],['工作委员会','',''],['工作学','',''],['工作室','',''],['工作房','',''],['工作报告','',''],['工作日','',''],['工作时间','',''],['工作服','',''],['工作母机','',''],['工作流','',''],['工作流程','',''],['工作狂','',''],['工作站','',''],['工作等','',''],['工作簿','',''],['工作组','',''],['工作者','',''],['工作表','',''],['工作袋','',''],['工作记忆','',''],['工作证','',''],['工作过度','',''],['工作量','',''],['工作队','',''],['工作面','',''],['工作鞋','',''],['工信部','',''],['工信处','',''],['工值','',''],['工党','',''],['工兵','',''],['工具','',''],['工具主义','',''],['工具书','',''],['工具包','',''],['工具机','',''],['工具条','',''],['工具架','',''],['工具栏','',''],['工具箱','',''],['工具钢','',''],['工农','',''],['工农业','',''],['工农兵','',''],['工农差别','',''],['工农群众','',''],['工农联盟','',''],['工况','',''],['工分','',''],['工分值','',''],['工制','',''],['工力','',''],['工力悉敌','',''],['工匠','',''],['工区','',''],['工厂','',''],['工厂主','',''],['工友','',''],['工号','',''],['工商','',''],['工商业','',''],['工商人员','',''],['工商企业','',''],['工商会','',''],['工商局','',''],['工商户','',''],['工商界','',''],['工商界人士','',''],['工商管理','',''],['工商管理硕士','',''],['工商联','',''],['工商行政','',''],['工商行政管理局','',''],['工团','',''],['工团主义','',''],['工地','',''],['工场','',''],['工场手工业','',''],['工场间','',''],['工夫','',''],['工夫不负有心人','',''],['工夫茶','',''],['工头','',''],['工套','',''],['工女','',''],['工委','',''],['工娱疗法','',''],['工字钢','',''],['工学','',''],['工学院','',''],['工宣队','',''],['工尺','',''],['工尺谱','',''],['工工整整','',''],['工巧','',''],['工序','',''],['工役','',''],['工房','',''],['工所','',''],['工效','',''],['工救会','',''],['工数','',''],['工整','',''],['工料','',''],['工日','',''],['工时','',''],['工期','',''],['工本','',''],['工本费','',''],['工架','',''],['工校','',''],['工棚','',''],['工楷','',''],['工欲善其事','',''],['工段','',''],['工活','',''],['工潮','',''],['工矿','',''],['工矿企业','',''],['工矿用地','',''],['工种','',''],['工科','',''],['工程','',''],['工程保障','',''],['工程兵','',''],['工程图','',''],['工程图学','',''],['工程塑料','',''],['工程处','',''],['工程学','',''],['工程师','',''],['工程设计','',''],['工程部','',''],['工稳','',''],['工笔','',''],['工笔画','',''],['工细','',''],['工缴','',''],['工缴费','',''],['工联','',''],['工联主义','',''],['工致','',''],['工艺','',''],['工艺品','',''],['工艺学','',''],['工艺流程','',''],['工艺美术','',''],['工薪','',''],['工薪阶层','',''],['工蜂','',''],['工行','',''],['工装','',''],['工装裤','',''],['工读','',''],['工读学校','',''],['工读生','',''],['工质','',''],['工贸','',''],['工贸结合','',''],['工贼','',''],['工资','',''],['工资分','',''],['工资单','',''],['工资基金','',''],['工资级别','',''],['工资高','',''],['工车','',''],['工运','',''],['工部','',''],['工钱','',''],['工长','',''],['工间','',''],['工间操','',''],['工队','',''],['工龄','',''],['左上','',''],['左上方','',''],['左下','',''],['左不过','',''],['左丘明','',''],['左传','',''],['左侧','',''],['左倾','',''],['左倾机会主义','',''],['左倾者','',''],['左列','',''],['左券','',''],['左券在握','',''],['左前卫','',''],['左卷','',''],['左右','',''],['左右两难','',''],['左右为难','',''],['左右共利','',''],['左右勾拳','',''],['左右开弓','',''],['左右手','',''],['左右袒','',''],['左右逢原','',''],['左右逢源','',''],['左向','',''],['左嗓子','',''],['左图右史','',''],['左字头','',''],['左宜右有','',''],['左岸','',''],['左归右归','',''],['左思','',''],['左思右想','',''],['左手','',''],['左拉','',''],['左拥','',''],['左挈右提','',''],['左掌','',''],['左提右挈','',''],['左撇','',''],['左撇子','',''],['左支右绌','',''],['左方','',''],['左旋','',''],['左氏春秋','',''],['左派','',''],['左盼','',''],['左眼','',''],['左移','',''],['左端','',''],['左箭头','',''],['左箭头键','',''],['左翼','',''],['左耳','',''],['左联','',''],['左脚','',''],['左腿','',''],['左腿瘸','',''],['左膀右臂','',''],['左臂','',''],['左至右','',''],['左舵','',''],['左舷','',''],['左营','',''],['左营区','',''],['左萦右拂','',''],['左行','',''],['左袒','',''],['左角','',''],['左证','',''],['左躲','',''],['左转','',''],['左轮','',''],['左轮手枪','',''],['左轮枪','',''],['左辅右弼','',''],['左边','',''],['左边儿','',''],['左迁','',''],['左近','',''],['左道','',''],['左道惑众','',''],['左道旁门','',''],['左邻','',''],['左邻右舍','',''],['左邻右里','',''],['左键','',''],['左镇','',''],['左镇乡','',''],['左面','',''],['左页','',''],['左顾','',''],['左顾右盼','',''],['左顾右眄','',''],['左首','',''],['巧不','',''],['巧不可阶','',''],['巧事','',''],['巧于','',''],['巧伪不如拙诚','',''],['巧做','',''],['巧偷豪夺','',''],['巧克','',''],['巧克力','',''],['巧克力脆片','',''],['巧劲','',''],['巧劲儿','',''],['巧匠','',''],['巧发奇中','',''],['巧取','',''],['巧取豪夺','',''],['巧合','',''],['巧夺','',''],['巧夺天工','',''],['巧妇','',''],['巧妇难为无米之炊','',''],['巧妙','',''],['巧干','',''],['巧思','',''],['巧手','',''],['巧捷','',''],['巧用','',''],['巧立','',''],['巧立名目','',''],['巧舌','',''],['巧舌如簧','',''],['巧言','',''],['巧言令色','',''],['巧言利口','',''],['巧言如簧','',''],['巧计','',''],['巧诈不如拙诚','',''],['巧语','',''],['巧语花言','',''],['巧辞','',''],['巧辩','',''],['巧遇','',''],['巧验','',''],['巨万','',''],['巨亨','',''],['巨人','',''],['巨人症','',''],['巨人般','',''],['巨债','',''],['巨像','',''],['巨兽','',''],['巨匠','',''],['巨变','',''],['巨响','',''],['巨商','',''],['巨噬细胞','',''],['巨型','',''],['巨型机','',''],['巨大','',''],['巨大影响','',''],['巨大症','',''],['巨头','',''],['巨奸','',''],['巨妖','',''],['巨宅','',''],['巨富','',''],['巨峰','',''],['巨幅','',''],['巨擘','',''],['巨无霸','',''],['巨无霸汉堡包指数','',''],['巨星','',''],['巨树','',''],['巨案','',''],['巨款','',''],['巨流','',''],['巨浪','',''],['巨滑','',''],['巨照','',''],['巨爵座','',''],['巨牙鲨','',''],['巨物','',''],['巨石','',''],['巨石柱群','',''],['巨石阵','',''],['巨碑','',''],['巨祸','',''],['巨穴','',''],['巨笔','',''],['巨细','',''],['巨细胞病毒','',''],['巨细胞病毒视网膜炎','',''],['巨著','',''],['巨蛇尾','',''],['巨蛇座','',''],['巨蛋','',''],['巨蜥','',''],['巨蟒','',''],['巨蟹','',''],['巨蟹座','',''],['巨蠹','',''],['巨贾','',''],['巨资','',''],['巨轮','',''],['巨量','',''],['巨集','',''],['巨额','',''],['巨鸟','',''],['巨鹿之战','',''],['巨齿鲨','',''],['巨龙','',''],['巩俐','',''],['巩县','',''],['巩固','',''],['巩膜','',''],['巫医','',''],['巫婆','',''],['巫山云雨','',''],['巫山山脉','',''],['巫山洛水','',''],['巫山落浦','',''],['巫峡','',''],['巫师','',''],['巫术','',''],['巫神','',''],['巫蛊','',''],['巫蛊之祸','',''],['巫觋','',''],['差一点','',''],['差一点儿','',''],['差三错四','',''],['差不多','',''],['差不离','',''],['差不离儿','',''],['差之千里','',''],['差之毫厘','',''],['差之毫厘失之千里','',''],['差之毫厘缪以千里','',''],['差事','',''],['差些','',''],['差人','',''],['差以千里','',''],['差以毫厘谬以千里','',''],['差价','',''],['差价款','',''],['差使','',''],['差值','',''],['差分','',''],['差分方程','',''],['差别','',''],['差办','',''],['差动','',''],['差动齿轮','',''],['差劲','',''],['差商','',''],['差失','',''],['差异','',''],['差异性','',''],['差强人意','',''],['差役','',''],['差得','',''],['差得多','',''],['差数','',''],['差旅','',''],['差旅费','',''],['差池','',''],['差派','',''],['差点','',''],['差点儿','',''],['差率','',''],['差生','',''],['差等','',''],['差者','',''],['差讹','',''],['差评','',''],['差误','',''],['差谬','',''],['差距','',''],['差远','',''],['差速器','',''],['差遣','',''],['差错','',''],['差额','',''],['差额选举','',''],['己丑','',''],['己亥','',''],['己人','',''],['己任','',''],['己卯','',''],['己型肝炎','',''],['己巳','',''],['己所不欲','',''],['己所不欲勿施于人','',''],['己方','',''],['己有','',''],['己未','',''],['己欲毋人','',''],['己欲毋施','',''],['己物','',''],['己癖','',''],['己糖','',''],['己见','',''],['己身','',''],['己酉','',''],['己饥己溺','',''],['已为','',''],['已久','',''],['已于','',''],['已作出保','',''],['已作故人','',''],['已决犯','',''],['已冷','',''],['已婚','',''],['已定','',''],['已往','',''],['已成形','',''],['已故','',''],['已晚','',''],['已灭','',''],['已然','',''],['已知','',''],['已知数','',''],['已经','',''],['已而','',''],['已见分晓','',''],['巳蛇','',''],['巴三览四','',''],['巴不得','',''],['巴不能够','',''],['巴中地区','',''],['巴乔','',''],['巴人','',''],['巴人下里','',''],['巴以','',''],['巴伊兰大学','',''],['巴伐利亚','',''],['巴伦支海','',''],['巴伦西亚','',''],['巴儿狗','',''],['巴克夏猪','',''],['巴克科思','',''],['巴克莱','',''],['巴克莱银行','',''],['巴利','',''],['巴利文','',''],['巴别塔','',''],['巴前算后','',''],['巴力','',''],['巴勒斯坦民族权力机构','',''],['巴勒斯坦解放组织','',''],['巴勒莫','',''],['巴南','',''],['巴厘','',''],['巴厘岛','',''],['巴县','',''],['巴哈伊','',''],['巴唧','',''],['巴唧巴唧','',''],['巴坦群岛','',''],['巴塞尔','',''],['巴塞尔宣言','',''],['巴塞罗那','',''],['巴塞隆纳','',''],['巴塞隆那','',''],['巴士','',''],['巴士公司','',''],['巴士底','',''],['巴士拉','',''],['巴士海峡','',''],['巴士站','',''],['巴头探脑','',''],['巴宰族','',''],['巴尔','',''],['巴尔克嫩德','',''],['巴尔喀什湖','',''],['巴尔多禄茂','',''],['巴尔干','',''],['巴尔干半岛','',''],['巴尔干战争','',''],['巴尔扎克','',''],['巴尔的摩','',''],['巴尔舍夫斯基','',''],['巴尼亚卢卡','',''],['巴山','',''],['巴山夜雨','',''],['巴山蜀水','',''],['巴山越岭','',''],['巴州','',''],['巴巴','',''],['巴巴儿地','',''],['巴巴劫劫','',''],['巴巴结结','',''],['巴布・狄伦','',''],['巴布亚纽几内亚','',''],['巴布尔','',''],['巴布延群岛','',''],['巴布拉族','',''],['巴希尔','',''],['巴库','',''],['巴录','',''],['巴彦浩特','',''],['巴彦浩特市','',''],['巴彦浩特镇','',''],['巴德尔','',''],['巴戟','',''],['巴拉克','',''],['巴拉基列夫','',''],['巴拉巴斯','',''],['巴拉迪','',''],['巴拿芬','',''],['巴拿马城','',''],['巴拿马运河','',''],['巴掌','',''],['巴掌大','',''],['巴控克什米尔','',''],['巴斗','',''],['巴斯','',''],['巴斯克','',''],['巴斯克语','',''],['巴斯卡尔','',''],['巴斯德','',''],['巴斯特尔','',''],['巴斯蒂亚','',''],['巴新','',''],['巴旦杏','',''],['巴望','',''],['巴松管','',''],['巴林右','',''],['巴林左','',''],['巴枯宁主义','',''],['巴格兰','',''],['巴格兰省','',''],['巴格达','',''],['巴比','',''],['巴比妥','',''],['巴比特合金','',''],['巴氏','',''],['巴氏杀菌法','',''],['巴特','',''],['巴特瓦族','',''],['巴特纳','',''],['巴生','',''],['巴甫洛夫','',''],['巴登','',''],['巴登・符腾堡州','',''],['巴纽','',''],['巴结','',''],['巴罗佐','',''],['巴罗克','',''],['巴耶利巴','',''],['巴莫','',''],['巴蜀','',''],['巴西人','',''],['巴西会议','',''],['巴西利亚','',''],['巴西战舞','',''],['巴解','',''],['巴解组织','',''],['巴豆','',''],['巴豆壳','',''],['巴豆属','',''],['巴豆树','',''],['巴贝西亚原虫病','',''],['巴赫','',''],['巴里','',''],['巴里坤','',''],['巴里坤县','',''],['巴里坤草原','',''],['巴里岛','',''],['巴金','',''],['巴金森氏症','',''],['巴闭','',''],['巴阿','',''],['巴音布克草原','',''],['巴音满都呼','',''],['巴音郭愣州','',''],['巴音郭愣蒙古自治州','',''],['巴颂管','',''],['巴颜喀拉','',''],['巴颜喀拉山','',''],['巴颜喀拉山脉','',''],['巴马县','',''],['巴马干酪','',''],['巴马科','',''],['巴高望上','',''],['巴黎','',''],['巴黎人','',''],['巴黎公社','',''],['巴黎和会','',''],['巴黎大学','',''],['巴黎绿','',''],['巷口','',''],['巷子','',''],['巷尾','',''],['巷尾街头','',''],['巷弄','',''],['巷战','',''],['巷议','',''],['巷议街谈','',''],['巷道','',''],['巷里','',''],['巾在江湖心存魏阙','',''],['巾帼','',''],['巾帼不让须眉','',''],['巾帼英雄','',''],['巾帼须眉','',''],['巾状','',''],['币值','',''],['币别','',''],['币制','',''],['币名','',''],['币种','',''],['币重言甘','',''],['币铢','',''],['市丈','',''],['市上','',''],['市下','',''],['市不二价','',''],['市两','',''],['市中心','',''],['市井','',''],['市井之徒','',''],['市井之臣','',''],['市井小人','',''],['市亩','',''],['市价','',''],['市侩','',''],['市内','',''],['市内电话','',''],['市况','',''],['市分','',''],['市制','',''],['市区','',''],['市升','',''],['市占率','',''],['市厘','',''],['市县','',''],['市合','',''],['市名','',''],['市售','',''],['市场','',''],['市场价','',''],['市场价格','',''],['市场份额','',''],['市场体系','',''],['市场供应','',''],['市场信息','',''],['市场准入','',''],['市场分析','',''],['市场动态','',''],['市场化','',''],['市场占有率','',''],['市场学','',''],['市场定位','',''],['市场推广','',''],['市场环境','',''],['市场疲软','',''],['市场竞争','',''],['市场管理','',''],['市场繁荣','',''],['市场经济','',''],['市场萎缩','',''],['市场营销','',''],['市场调查','',''],['市场调节','',''],['市场趋势','',''],['市场部','',''],['市场需求','',''],['市场需求分析','',''],['市场预测','',''],['市外','',''],['市委','',''],['市委书记','',''],['市容','',''],['市寸','',''],['市尺','',''],['市局','',''],['市属','',''],['市布','',''],['市府','',''],['市廛','',''],['市引','',''],['市情','',''],['市惠','',''],['市房','',''],['市担','',''],['市招','',''],['市政','',''],['市政厅','',''],['市政员','',''],['市政工程','',''],['市政府','',''],['市政建设','',''],['市政税','',''],['市数','',''],['市斗','',''],['市斤','',''],['市无二价','',''],['市曹','',''],['市毫','',''],['市民','',''],['市民权','',''],['市民社会','',''],['市用制','',''],['市电','',''],['市盈率','',''],['市直','',''],['市直机关','',''],['市石','',''],['市称','',''],['市立','',''],['市管县','',''],['市级','',''],['市绅','',''],['市西','',''],['市议会','',''],['市议员','',''],['市郊','',''],['市里','',''],['市钱','',''],['市镇','',''],['市长','',''],['市间','',''],['市际','',''],['市集','',''],['市面','',''],['市顷','',''],['市风','',''],['布丁','',''],['布下','',''],['布什尔','',''],['布伍','',''],['布伞','',''],['布伦尼','',''],['布佳迪','',''],['布依','',''],['布兰妮・斯皮尔斯','',''],['布兰森','',''],['布农族','',''],['布列塔尼','',''],['布列斯特和约','',''],['布加勒斯特','',''],['布劳恩','',''],['布包','',''],['布匹','',''],['布匿战争','',''],['布吉河','',''],['布告','',''],['布告栏','',''],['布告牌','',''],['布哈拉','',''],['布哈林','',''],['布商','',''],['布囊','',''],['布囊其口','',''],['布坎南','',''],['布垫','',''],['布城','',''],['布头','',''],['布娃娃','',''],['布宜诺斯艾利斯','',''],['布尔','',''],['布尔乔亚','',''],['布尔什维主义','',''],['布尔什维克','',''],['布尔代数','',''],['布尼亚病毒','',''],['布局','',''],['布市','',''],['布帆无恙','',''],['布希威克','',''],['布帘','',''],['布帛','',''],['布帛菽粟','',''],['布带','',''],['布幕','',''],['布干维尔','',''],['布干维尔岛','',''],['布床','',''],['布店','',''],['布建','',''],['布托','',''],['布拉','',''],['布拉吉','',''],['布拉德・彼特','',''],['布拉柴维尔','',''],['布拉格','',''],['布拉索夫','',''],['布拉迪斯拉发','',''],['布政使','',''],['布斐','',''],['布料','',''],['布料商','',''],['布施','',''],['布景','',''],['布朗','',''],['布朗克士','',''],['布朗克斯','',''],['布朗士','',''],['布朗大学','',''],['布朗运动','',''],['布条','',''],['布林迪西','',''],['布氏杆菌病','',''],['布氏菌苗','',''],['布氏非鲫','',''],['布法罗','',''],['布洒器','',''],['布洛芬','',''],['布满','',''],['布点','',''],['布热津斯基','',''],['布熊','',''],['布片','',''],['布琼布拉','',''],['布痕瓦尔德','',''],['布票','',''],['布篷','',''],['布类','',''],['布纹','',''],['布纹纸','',''],['布线','',''],['布置','',''],['布署','',''],['布莱克史密斯','',''],['布莱克本','',''],['布莱尼','',''],['布莱德湖','',''],['布莱恩','',''],['布莱特妮・墨菲','',''],['布菜','',''],['布衣','',''],['布衣之交','',''],['布衣料','',''],['布衣粝食','',''],['布衣蔬食','',''],['布衣韦带','',''],['布衣黔首','',''],['布衫','',''],['布袋','',''],['布袋戏','',''],['布袋镇','',''],['布袜青鞋','',''],['布装','',''],['布裙','',''],['布裙荆钗','',''],['布谷','',''],['布谷鸟','',''],['布达佩斯','',''],['布达拉宫','',''],['布达拉山','',''],['布迪亚','',''],['布道','',''],['布里坦尼','',''],['布里奇顿','',''],['布里斯托','',''],['布里斯托尔','',''],['布里斯托尔海峡','',''],['布里斯班','',''],['布防','',''],['布防迎战','',''],['布阵','',''],['布隆伯格','',''],['布隆方丹','',''],['布雷','',''],['布雷舰','',''],['布雷顿森林','',''],['布面','',''],['布鞋','',''],['布须曼人','',''],['布鲁克','',''],['布鲁克林','',''],['布鲁克林大桥','',''],['布鲁克海文国家实验室','',''],['布鲁克海文实验室','',''],['布鲁塞尔','',''],['布鲁姆斯伯里','',''],['布鲁斯','',''],['布鲁日','',''],['布鲁氏菌','',''],['布鲁氏菌病','',''],['布鼓雷门','',''],['帅印','',''],['帅呆了','',''],['帅哥','',''],['帅才','',''],['帅权','',''],['帅气','',''],['帆伞','',''],['帆布','',''],['帆布床','',''],['帆布鞋','',''],['帆张风满','',''],['帆板','',''],['帆船','',''],['师专','',''],['师严道尊','',''],['师之所存','',''],['师事','',''],['师传','',''],['师傅','',''],['师兄','',''],['师兄弟','',''],['师公','',''],['师出无名','',''],['师出有名','',''],['师友','',''],['师古','',''],['师哥','',''],['师团','',''],['师大','',''],['师妹','',''],['师姐','',''],['师娘','',''],['师尊','',''],['师弟','',''],['师徒','',''],['师心自是','',''],['师心自用','',''],['师恩','',''],['师承','',''],['师母','',''],['师法','',''],['师父','',''],['师父领进门','',''],['师爷','',''],['师生','',''],['师直为壮','',''],['师级','',''],['师老兵疲','',''],['师范','',''],['师范大学','',''],['师范学校','',''],['师范学院','',''],['师范教育','',''],['师范院校','',''],['师表','',''],['师资','',''],['师道','',''],['师道尊严','',''],['师长','',''],['师门','',''],['师院','',''],['希世之珍','',''],['希仁','',''],['希伯来','',''],['希伯来书','',''],['希伯来人','',''],['希伯来语','',''],['希伯莱','',''],['希伯莱大学','',''],['希伯莱文','',''],['希伯莱语','',''],['希冀','',''],['希图','',''],['希夏邦马峰','',''],['希奇','',''],['希奇古怪','',''],['希尔','',''],['希尔伯特','',''],['希尔内科斯','',''],['希尔弗瑟姆','',''],['希尔排序','',''],['希尔顿','',''],['希律王','',''],['希思罗','',''],['希拉克','',''],['希拉蕊','',''],['希拉里','',''],['希拉里・克林顿','',''],['希斯','',''],['希斯・莱杰','',''],['希斯仑','',''],['希斯罗机场','',''],['希有','',''],['希望','',''],['希望有','',''],['希望落空','',''],['希格斯','',''],['希格斯机制','',''],['希格斯玻色子','',''],['希格斯粒子','',''],['希求','',''],['希沃特','',''],['希波克拉底','',''],['希波战争','',''],['希洪','',''],['希特勒','',''],['希神','',''],['希罕','',''],['希罗底','',''],['希耳伯特','',''],['希腊人','',''],['希腊字母','',''],['希腊文','',''],['希腊文化','',''],['希腊王','',''],['希腊神话','',''],['希腊罗马神话','',''],['希腊语','',''],['希蒙・佩雷斯','',''],['希西家','',''],['希里哗啦','',''],['帏幕','',''],['帐上','',''],['帐主子','',''],['帐内','',''],['帐册','',''],['帐务','',''],['帐单','',''],['帐卡','',''],['帐号','',''],['帐外','',''],['帐夹','',''],['帐子','',''],['帐家','',''],['帐帘','',''],['帐幔','',''],['帐幕','',''],['帐户','',''],['帐房','',''],['帐据','',''],['帐本','',''],['帐棚','',''],['帐款','',''],['帐目','',''],['帐篷','',''],['帐簿','',''],['帐表','',''],['帐证','',''],['帐钉','',''],['帐钩','',''],['帐面','',''],['帐页','',''],['帑藏','',''],['帕丽斯・希尔顿','',''],['帕兰卡','',''],['帕内尔','',''],['帕台农','',''],['帕台农神庙','',''],['帕塔亚','',''],['帕子','',''],['帕尔瓦蒂','',''],['帕尼巴特','',''],['帕拉塞尔士','',''],['帕拉马里博','',''],['帕提亚人','',''],['帕提侬神庙','',''],['帕斯','',''],['帕斯卡','',''],['帕斯卡三角形','',''],['帕斯卡六边形','',''],['帕斯卡尔','',''],['帕特丽夏','',''],['帕特里克','',''],['帕特里夏','',''],['帕瓦蒂','',''],['帕福斯','',''],['帕米尔','',''],['帕米尔山脉','',''],['帕米尔高原','',''],['帕累托','',''],['帕累托最优','',''],['帕累托法则','',''],['帕萨特','',''],['帕蒂尔','',''],['帕西','',''],['帕金森','',''],['帕金森病','',''],['帕金森症','',''],['帕马森','',''],['帖子','',''],['帖撒罗尼迦','',''],['帖撒罗尼迦前书','',''],['帖撒罗尼迦后书','',''],['帖服','',''],['帖木儿','',''],['帖木儿大汗','',''],['帘子','',''],['帘子布','',''],['帘子线','',''],['帘布','',''],['帘帐','',''],['帘带','',''],['帘幕','',''],['帛书','',''],['帛品','',''],['帛琉','',''],['帛画','',''],['帛金','',''],['帝业','',''],['帝乡','',''],['帝京','',''],['帝位','',''],['帝俄','',''],['帝俊','',''],['帝制','',''],['帝力','',''],['帝名','',''],['帝后','',''],['帝君','',''],['帝喾','',''],['帝国','',''],['帝国主义','',''],['帝国主义者','',''],['帝国理工学院','',''],['帝子','',''],['帝庙','',''],['帝政','',''],['帝权','',''],['帝汶岛','',''],['帝汶海','',''],['帝王','',''],['帝王企鹅','',''],['帝王切开','',''],['帝王将相','',''],['帝王般','',''],['帝王谱','',''],['帝皇','',''],['帝辛','',''],['帝都','',''],['带上','',''],['带下','',''],['带丑闻','',''],['带信','',''],['带儿','',''],['带入','',''],['带兵','',''],['带兵艺术','',''],['带冷笑','',''],['带出','',''],['带分数','',''],['带到','',''],['带刺','',''],['带动','',''],['带劲','',''],['带原者','',''],['带去','',''],['带呼','',''],['带响','',''],['带回','',''],['带回家','',''],['带坏','',''],['带声','',''],['带头','',''],['带头人','',''],['带头作用','',''],['带头巾','',''],['带子','',''],['带孝','',''],['带宽','',''],['带岭','',''],['带徒弟','',''],['带手儿','',''],['带扣','',''],['带挈','',''],['带斑点','',''],['带月披星','',''],['带有','',''],['带材','',''],['带来','',''],['带枪','',''],['带柄','',''],['带标识','',''],['带步人','',''],['带气','',''],['带水拖泥','',''],['带河厉山','',''],['带牛佩犊','',''],['带状','',''],['带状条','',''],['带状疱疹','',''],['带电','',''],['带电作业','',''],['带电粒子','',''],['带病','',''],['带眼镜','',''],['带着','',''],['带着希望去旅行','',''],['带砺山河','',''],['带砺河山','',''],['带紫色','',''],['带累','',''],['带红色','',''],['带给','',''],['带罪立功','',''],['带菌者','',''],['带薪','',''],['带薪休假','',''],['带装','',''],['带褐色','',''],['带调','',''],['带走','',''],['带路','',''],['带路人','',''],['带过','',''],['带进','',''],['带送','',''],['带酸味','',''],['带金佩紫','',''],['带钢','',''],['带错','',''],['带锯','',''],['带队','',''],['带霉','',''],['带露','',''],['带青色','',''],['带音','',''],['带领','',''],['带饰','',''],['带鱼','',''],['带黄色','',''],['帧中继','',''],['帧太长','',''],['帧格式','',''],['帧检验序列','',''],['帧频','',''],['帧首定界符','',''],['席上','',''],['席上之珍','',''],['席下','',''],['席不暇暖','',''],['席丰履厚','',''],['席位','',''],['席凡宁根','',''],['席勒','',''],['席卷','',''],['席卷一空','',''],['席卷亚洲','',''],['席卷而来','',''],['席地','',''],['席地幕天','',''],['席地而坐','',''],['席垫','',''],['席子','',''],['席德尼','',''],['席梦思','',''],['席次','',''],['席珍待聘','',''],['席箔','',''],['席篾','',''],['席草','',''],['席间','',''],['席面','',''],['帮人','',''],['帮他','',''],['帮伙','',''],['帮会','',''],['帮你','',''],['帮倒忙','',''],['帮内','',''],['帮冬','',''],['帮凶','',''],['帮办','',''],['帮助','',''],['帮助某人','',''],['帮助索引','',''],['帮厨','',''],['帮口','',''],['帮同','',''],['帮员','',''],['帮套','',''],['帮子','',''],['帮宝适','',''],['帮工','',''],['帮带','',''],['帮帮','',''],['帮忙','',''],['帮我','',''],['帮手','',''],['帮扶','',''],['帮教','',''],['帮派','',''],['帮派体系','',''],['帮浦','',''],['帮着','',''],['帮腔','',''],['帮补','',''],['帮衬','',''],['帮诉','',''],['帮闲','',''],['帮闲钻懒','',''],['帷子','',''],['帷帐','',''],['帷幄','',''],['帷幔','',''],['帷幕','',''],['帷幕凿井','',''],['帷薄不修','',''],['常与','',''],['常为','',''],['常乐','',''],['常事','',''],['常于','',''],['常人','',''],['常以','',''],['常任','',''],['常任理事国','',''],['常会','',''],['常住','',''],['常住论','',''],['常作','',''],['常使','',''],['常例','',''],['常俸','',''],['常到','',''],['常务','',''],['常务主席','',''],['常务会议','',''],['常务委员会','',''],['常务理事','',''],['常压','',''],['常去','',''],['常喝','',''],['常在','',''],['常坐','',''],['常坐汽车者','',''],['常备','',''],['常备不懈','',''],['常备兵','',''],['常备军','',''],['常备药','',''],['常委','',''],['常委会','',''],['常客','',''],['常川','',''],['常常','',''],['常平','',''],['常年','',''],['常年不懈','',''],['常年不断','',''],['常异交作物','',''],['常往','',''],['常微分方程','',''],['常德地区','',''],['常态','',''],['常态分布','',''],['常态化','',''],['常怪','',''],['常情','',''],['常把','',''],['常抓','',''],['常抓不懈','',''],['常指','',''],['常数','',''],['常时','',''],['常春','',''],['常春藤','',''],['常有','',''],['常服','',''],['常来常往','',''],['常染色体','',''],['常比','',''],['常温','',''],['常温动物','',''],['常温层','',''],['常犯','',''],['常理','',''],['常用','',''],['常用品','',''],['常用字','',''],['常用对数','',''],['常相知','',''],['常磁性','',''],['常礼','',''],['常绕','',''],['常绿','',''],['常绿树','',''],['常绿植物','',''],['常绿阔叶林','',''],['常胜','',''],['常胜军','',''],['常胜将军','',''],['常蚊','',''],['常衡','',''],['常衡制','',''],['常被','',''],['常见','',''],['常见病','',''],['常见的','',''],['常见问题','',''],['常规','',''],['常规战','',''],['常规战争','',''],['常规武器','',''],['常规铜电话线','',''],['常言','',''],['常言说','',''],['常言说得好','',''],['常言道','',''],['常设','',''],['常设机构','',''],['常访','',''],['常识','',''],['常说','',''],['常谈','',''],['常赴','',''],['常轨','',''],['常道','',''],['常量','',''],['常锡文戏','',''],['常问','',''],['常问问题','',''],['常青','',''],['常青藤','',''],['常青藤八校','',''],['常项','',''],['常食','',''],['常饮酒','',''],['常驻','',''],['常驻机构','',''],['帹暆','',''],['帽上','',''],['帽匠','',''],['帽天山','',''],['帽头','',''],['帽子','',''],['帽子戏法','',''],['帽徽','',''],['帽扣','',''],['帽架','',''],['帽檐','',''],['帽沿','',''],['帽盔','',''],['帽盔儿','',''],['帽章','',''],['帽箍儿','',''],['帽耳','',''],['帽舌','',''],['帽花','',''],['帽边','',''],['幂值','',''],['幂级数','',''],['幅员','',''],['幅员辽阔','',''],['幅宽','',''],['幅射','',''],['幅射线','',''],['幅度','',''],['幅面','',''],['幌子','',''],['幔子','',''],['幔帐','',''],['幕上','',''],['幕僚','',''],['幕前','',''],['幕剧','',''],['幕友','',''],['幕后','',''],['幕后操纵','',''],['幕后花絮','',''],['幕天','',''],['幕天席地','',''],['幕宾','',''],['幕布','',''],['幕帷','',''],['幕幕','',''],['幕府','',''],['幕灯','',''],['幕燕鼎鱼','',''],['幕间','',''],['幕降','',''],['幛子','',''],['幞头','',''],['幡然','',''],['幡然悔悟','',''],['幡然改图','',''],['幢幢','',''],['干一番事业','',''],['干下','',''],['干与','',''],['干么','',''],['干了','',''],['干事','',''],['干事长','',''],['干云蔽日','',''],['干产','',''],['干亲','',''],['干什么','',''],['干仗','',''],['干休','',''],['干休所','',''],['干俸','',''],['干儿','',''],['干儿子','',''],['干兄弟','',''],['干冰','',''],['干冷','',''],['干净','',''],['干净俐落','',''],['干净利落','',''],['干制','',''],['干劲','',''],['干劲冲天','',''],['干劲十足','',''],['干卿何事','',''],['干号','',''],['干名采誉','',''],['干吗','',''],['干咳','',''],['干哕','',''],['干啥','',''],['干啼湿哭','',''],['干嘛','',''],['干嚎','',''],['干城','',''],['干好','',''],['干妈','',''],['干姜','',''],['干娘','',''],['干完','',''],['干将','',''],['干尸','',''],['干尽','',''],['干巴','',''],['干巴巴','',''],['干干净净','',''],['干得','',''],['干得出','',''],['干得好','',''],['干急','',''],['干性油','',''],['干戈','',''],['干戈载戢','',''],['干扁豆角','',''],['干才','',''],['干打垒','',''],['干扰','',''],['干扰声','',''],['干扰机','',''],['干扰素','',''],['干扰者','',''],['干挠','',''],['干掉','',''],['干支','',''],['干料','',''],['干旱','',''],['干旱地区','',''],['干旱风','',''],['干时','',''],['干晒','',''],['干材','',''],['干杯','',''],['干果','',''],['干枯','',''],['干柴','',''],['干校','',''],['干梅子','',''],['干死','',''],['干洗','',''],['干活','',''],['干活儿','',''],['干流','',''],['干涉','',''],['干涉仪','',''],['干涉内政','',''],['干涉现象','',''],['干涉者','',''],['干涉计','',''],['干涩','',''],['干涸','',''],['干渠','',''],['干渴','',''],['干湿','',''],['干湿球温度表','',''],['干潮','',''],['干煸土豆丝','',''],['干燥','',''],['干燥剂','',''],['干燥器','',''],['干燥机','',''],['干燥窑','',''],['干燥箱','',''],['干爹','',''],['干爽','',''],['干犯','',''],['干球','',''],['干球温度','',''],['干电池','',''],['干瘦','',''],['干瘪','',''],['干癣','',''],['干眼症','',''],['干着','',''],['干着急','',''],['干瞪眼','',''],['干硬','',''],['干碍','',''],['干禄','',''],['干笑','',''],['干等','',''],['干粉','',''],['干粮','',''],['干粮袋','',''],['干系','',''],['干线','',''],['干练','',''],['干细胞','',''],['干结','',''],['干群','',''],['干群关系','',''],['干肉','',''],['干肉片','',''],['干肉饼','',''],['干股','',''],['干肥','',''],['干脆','',''],['干脆利落','',''],['干腊肠','',''],['干草','',''],['干草堆','',''],['干草机','',''],['干草架','',''],['干草粉','',''],['干菜','',''],['干薪','',''],['干蠢事','',''],['干血浆','',''],['干血痨','',''],['干衣','',''],['干裂','',''],['干警','',''],['干证','',''],['干谒','',''],['干豆','',''],['干贝','',''],['干货','',''],['干贮','',''],['干起','',''],['干起来','',''],['干路','',''],['干躁','',''],['干过','',''],['干连','',''],['干透','',''],['干道','',''],['干邑','',''],['干部','',''],['干酪','',''],['干酪素','',''],['干酵母','',''],['干预','',''],['干饭','',''],['干馏','',''],['干鲜果','',''],['平一','',''],['平乱','',''],['平交道','',''],['平产','',''],['平人','',''],['平仄','',''],['平仓','',''],['平仰','',''],['平价','',''],['平伏','',''],['平伸','',''],['平作','',''],['平信','',''],['平假名','',''],['平允','',''],['平光','',''],['平凉地区','',''],['平减','',''],['平凡','',''],['平分','',''],['平分点','',''],['平分秋色','',''],['平分线','',''],['平分面','',''],['平列','',''],['平刨','',''],['平剧','',''],['平加','',''],['平动','',''],['平卧','',''],['平原十日饮','',''],['平原战场','',''],['平反','',''],['平叛','',''],['平口钳','',''],['平台','',''],['平台型','',''],['平台式','',''],['平地','',''],['平地木','',''],['平地机','',''],['平地起家','',''],['平地青云','',''],['平地风波','',''],['平均','',''],['平均为','',''],['平均主义','',''],['平均价格','',''],['平均值','',''],['平均值定理','',''],['平均共产主义','',''],['平均利润','',''],['平均剂量','',''],['平均发展水平','',''],['平均增长速度','',''],['平均寿命','',''],['平均工资','',''],['平均年龄','',''],['平均律','',''],['平均指数','',''],['平均指标','',''],['平均收入','',''],['平均数','',''],['平均日产量','',''],['平均每年下降','',''],['平均每年增长','',''],['平均气温','',''],['平均水平','',''],['平均海水面','',''],['平均达','',''],['平均速度','',''],['平坐','',''],['平坦','',''],['平型关','',''],['平型关大捷','',''],['平城','',''],['平埔族','',''],['平壤','',''],['平壤市','',''],['平声','',''],['平复','',''],['平头','',''],['平头数','',''],['平头正脸','',''],['平头百姓','',''],['平头钉','',''],['平妥','',''],['平安北道','',''],['平安南道','',''],['平安无事','',''],['平安时代','',''],['平安神宫','',''],['平安道','',''],['平安里','',''],['平宝盖','',''],['平实','',''],['平射炮','',''],['平尺','',''],['平局','',''],['平屋顶','',''],['平展','',''],['平川','',''],['平巷','',''],['平布','',''],['平常','',''],['平常日','',''],['平平','',''],['平平安安','',''],['平平常常','',''],['平平当当','',''],['平平淡淡','',''],['平平稳稳','',''],['平平静静','',''],['平年','',''],['平底','',''],['平底船','',''],['平底锅','',''],['平庸','',''],['平庸之辈','',''],['平庸无奇','',''],['平心','',''],['平心而论','',''],['平心静气','',''],['平快车','',''],['平息','',''],['平成','',''],['平战结合','',''],['平房','',''],['平房式','',''],['平手','',''],['平抑','',''],['平抚','',''],['平摊','',''],['平放','',''],['平整','',''],['平整土地','',''],['平方','',''],['平方公里','',''],['平方千米','',''],['平方厘米','',''],['平方反比定律','',''],['平方反比律','',''],['平方成反比','',''],['平方根','',''],['平方米','',''],['平方英尺','',''],['平日','',''],['平时','',''],['平时不烧香','',''],['平明','',''],['平易','',''],['平易近人','',''],['平易近民','',''],['平昔','',''],['平曝一声雷','',''],['平月','',''],['平服','',''],['平权','',''],['平板','',''],['平板仪','',''],['平板状','',''],['平板电脑','',''],['平板车','',''],['平架','',''],['平桥','',''],['平槽','',''],['平正','',''],['平步青云','',''],['平毁','',''],['平民','',''],['平民百姓','',''],['平水期','',''],['平江起义','',''],['平津战役','',''],['平流层','',''],['平流缓进','',''],['平浅','',''],['平淡','',''],['平淡无奇','',''],['平添','',''],['平溪','',''],['平溪乡','',''],['平滑','',''],['平滑字','',''],['平滑流畅','',''],['平滑肌','',''],['平炉','',''],['平版','',''],['平生','',''],['平生不做亏心事','',''],['平畴','',''],['平白','',''],['平白无故','',''],['平盘','',''],['平直','',''],['平看','',''],['平移','',''],['平稳','',''],['平空','',''],['平等','',''],['平等主义','',''],['平等互利','',''],['平等互惠','',''],['平等利','',''],['平等待人','',''],['平等权利','',''],['平等的法律地位','',''],['平等竞争','',''],['平米','',''],['平籴','',''],['平素','',''],['平级','',''],['平纹','',''],['平绒','',''],['平缓','',''],['平肩','',''],['平胸','',''],['平舌音','',''],['平芜','',''],['平英团','',''],['平菇','',''],['平行','',''],['平行作业','',''],['平行公设','',''],['平行四边形','',''],['平行线','',''],['平衍','',''],['平衡','',''],['平衡力','',''],['平衡态','',''],['平衡木','',''],['平衡物','',''],['平衡环','',''],['平衡者','',''],['平衡觉','',''],['平装','',''],['平装书','',''],['平装本','',''],['平西','',''],['平视','',''],['平视显示器','',''],['平角','',''],['平话','',''],['平调','',''],['平谷','',''],['平谷县','',''],['平走漫步','',''],['平起','',''],['平起平坐','',''],['平足','',''],['平路机','',''],['平身','',''],['平躺','',''],['平车','',''],['平辈','',''],['平道','',''],['平野','',''],['平金','',''],['平铺','',''],['平铺直叙','',''],['平锅','',''],['平锅柄','',''],['平镇','',''],['平镇市','',''],['平降','',''],['平靖','',''],['平静','',''],['平面','',''],['平面几何','',''],['平面化','',''],['平面图','',''],['平面曲线','',''],['平面波','',''],['平面角','',''],['平面镜','',''],['平音','',''],['平顶','',''],['平鱼','',''],['平鲁','',''],['年三十','',''],['年下','',''],['年中','',''],['年久失修','',''],['年之久','',''],['年事','',''],['年事已高','',''],['年产','',''],['年产值','',''],['年产能力','',''],['年产量','',''],['年仅','',''],['年代','',''],['年代初','',''],['年代学','',''],['年以下','',''],['年以来','',''],['年份','',''],['年休','',''],['年会','',''],['年俸','',''],['年值','',''],['年假','',''],['年兄','',''],['年光','',''],['年关','',''],['年内','',''],['年刊','',''],['年初','',''],['年利','',''],['年利润','',''],['年前','',''],['年力','',''],['年功加俸','',''],['年华','',''],['年历','',''],['年友','',''],['年史','',''],['年号','',''],['年后','',''],['年唔','',''],['年均','',''],['年均增长率','',''],['年均日照','',''],['年增长率','',''],['年复一年','',''],['年夜','',''],['年夜饭','',''],['年头','',''],['年头儿','',''],['年审','',''],['年宵','',''],['年富力强','',''],['年寿','',''],['年尊','',''],['年少','',''],['年少无知','',''],['年少气盛','',''],['年尾','',''],['年岁','',''],['年岁大','',''],['年已蹉跎','',''],['年市','',''],['年平均','',''],['年平均增长率','',''],['年年','',''],['年年如此','',''],['年年有余','',''],['年年有馀','',''],['年幼','',''],['年幼者','',''],['年底','',''],['年庚','',''],['年度','',''],['年度大会','',''],['年度报告','',''],['年度股东大会','',''],['年度计划','',''],['年度预算','',''],['年总产','',''],['年息','',''],['年成','',''],['年报','',''],['年收入','',''],['年数','',''],['年时','',''],['年景','',''],['年月','',''],['年末','',''],['年来','',''],['年根','',''],['年楚河','',''],['年次','',''],['年浅','',''],['年深日久','',''],['年深月久','',''],['年满','',''],['年率','',''],['年生','',''],['年生产能力','',''],['年画','',''],['年画儿','',''],['年礼','',''],['年神兽散','',''],['年祭','',''],['年秋天','',''],['年税','',''],['年糕','',''],['年级','',''],['年级间','',''],['年纪','',''],['年终','',''],['年终分配','',''],['年终奖','',''],['年终总结','',''],['年终评比','',''],['年缴','',''],['年老','',''],['年老体弱','',''],['年老力衰','',''],['年老多病','',''],['年节','',''],['年菜','',''],['年薪','',''],['年表','',''],['年衰','',''],['年谊','',''],['年谱','',''],['年貌','',''],['年货','',''],['年资','',''],['年轮','',''],['年轻','',''],['年轻一代','',''],['年轻人','',''],['年轻力壮','',''],['年轻化','',''],['年轻干部','',''],['年轻有为','',''],['年轻气盛','',''],['年载','',''],['年辈','',''],['年过半百','',''],['年过古稀','',''],['年过花甲','',''],['年迈','',''],['年迈体弱','',''],['年近半百','',''],['年近古稀','',''],['年近花甲','',''],['年逾','',''],['年逾古稀','',''],['年金','',''],['年鉴','',''],['年长','',''],['年间','',''],['年限','',''],['年集','',''],['年青','',''],['年青人','',''],['年饭','',''],['年馑','',''],['年首','',''],['年高','',''],['年高德劭','',''],['年高德邵','',''],['年齿','',''],['年龄','',''],['年龄特征','',''],['年龄组','',''],['并不','',''],['并不以此为满足','',''],['并不在乎','',''],['并不是','',''],['并不矛盾','',''],['并不等于','',''],['并不能','',''],['并且','',''],['并为','',''],['并举','',''],['并作','',''],['并使','',''],['并例','',''],['并修','',''],['并入','',''],['并列','',''],['并力','',''],['并卷机','',''],['并发','',''],['并发症','',''],['并口','',''],['并可','',''],['并合','',''],['并同','',''],['并向','',''],['并吞','',''],['并坐','',''],['并对于','',''],['并已','',''],['并当','',''],['并把','',''],['并报','',''],['并拢','',''],['并按','',''],['并排','',''],['并施','',''],['并无','',''],['并日而食','',''],['并有','',''],['并未','',''],['并条','',''],['并案办理','',''],['并没有','',''],['并激','',''],['并用','',''],['并由','',''],['并称','',''],['并立','',''],['并端','',''],['并纱','',''],['并经','',''],['并给','',''],['并网','',''],['并网发电','',''],['并置','',''],['并者','',''],['并联','',''],['并肩','',''],['并肩而行','',''],['并肩作战','',''],['并肩战斗','',''],['并能','',''],['并臻','',''],['并蒂莲','',''],['并行','',''],['并行不悖','',''],['并行口','',''],['并行程序','',''],['并行计算','',''],['并被','',''],['并要','',''],['并解','',''],['并论','',''],['并请','',''],['并购','',''],['并轨','',''],['并转','',''],['并进','',''],['并重','',''],['并附','',''],['并非','',''],['并非如此','',''],['并非易事','',''],['并驾齐驱','',''],['幸中','',''],['幸事','',''],['幸亏','',''],['幸会','',''],['幸免','',''],['幸免于死','',''],['幸勿','',''],['幸喜','',''],['幸好','',''],['幸存','',''],['幸存者','',''],['幸得','',''],['幸未','',''],['幸灾乐祸','',''],['幸甚','',''],['幸福','',''],['幸福学','',''],['幸而','',''],['幸臣','',''],['幸运','',''],['幸运儿','',''],['幸运抽奖','',''],['幸进','',''],['幺么小丑','',''],['幺二','',''],['幺喝','',''],['幺并矢','',''],['幺点','',''],['幺麽','',''],['幺麽小丑','',''],['幻像','',''],['幻化','',''],['幻听','',''],['幻境','',''],['幻形','',''],['幻影','',''],['幻影似','',''],['幻念','',''],['幻忽然间','',''],['幻想','',''],['幻想力','',''],['幻想家','',''],['幻想曲','',''],['幻日','',''],['幻景','',''],['幻术','',''],['幻灭','',''],['幻灭感','',''],['幻灯','',''],['幻灯机','',''],['幻灯片','',''],['幻片','',''],['幻画','',''],['幻视','',''],['幻觉','',''],['幻觉剂','',''],['幻象','',''],['幼体','',''],['幼儿','',''],['幼儿园','',''],['幼儿教育','',''],['幼儿用','',''],['幼兽','',''],['幼功','',''],['幼发拉底','',''],['幼发拉底河','',''],['幼发拉底河谷','',''],['幼君','',''],['幼吾幼','',''],['幼女','',''],['幼妹','',''],['幼子','',''],['幼学壮行','',''],['幼小','',''],['幼少','',''],['幼师','',''],['幼年','',''],['幼年期','',''],['幼弟','',''],['幼态','',''],['幼托','',''],['幼教','',''],['幼时','',''],['幼有所托','',''],['幼林','',''],['幼树','',''],['幼株','',''],['幼畜','',''],['幼禽','',''],['幼稚','',''],['幼稚园','',''],['幼稚期','',''],['幼稚病','',''],['幼稚症','',''],['幼童','',''],['幼者','',''],['幼芽','',''],['幼苗','',''],['幼虫','',''],['幼雏','',''],['幼马','',''],['幼龄','',''],['幽会','',''],['幽僻','',''],['幽兰','',''],['幽冥','',''],['幽咽','',''],['幽囚','',''],['幽囚受辱','',''],['幽囹','',''],['幽女','',''],['幽婉','',''],['幽室','',''],['幽寂','',''],['幽居','',''],['幽州','',''],['幽幽','',''],['幽径','',''],['幽微','',''],['幽忧','',''],['幽思','',''],['幽怨','',''],['幽情','',''],['幽愤','',''],['幽明','',''],['幽明异路','',''],['幽暗','',''],['幽期','',''],['幽期密约','',''],['幽浮','',''],['幽深','',''],['幽灵','',''],['幽灵似','',''],['幽眇','',''],['幽禁','',''],['幽绿','',''],['幽美','',''],['幽谷','',''],['幽趣','',''],['幽邃','',''],['幽门','',''],['幽闭','',''],['幽闭恐惧','',''],['幽闭恐惧症','',''],['幽闲','',''],['幽雅','',''],['幽静','',''],['幽香','',''],['幽魂','',''],['幽默','',''],['幽默家','',''],['幽默感','',''],['幽默滑稽','',''],['幽默画','',''],['幽默话','',''],['广东医学院','',''],['广东外语外贸大学','',''],['广东天地会起义','',''],['广东戏','',''],['广东海洋大学','',''],['广东科学技术职业学院','',''],['广东药学院','',''],['广东话','',''],['广东音乐','',''],['广为','',''],['广义','',''],['广义地说','',''],['广义性','',''],['广义相对论','',''],['广九','',''],['广九铁路','',''],['广交','',''],['广交会','',''],['广交朋友','',''],['广众','',''],['广众大庭','',''],['广传','',''],['广体','',''],['广加','',''],['广博','',''],['广厦','',''],['广告','',''],['广告商','',''],['广告文印','',''],['广告条幅','',''],['广告片','',''],['广告牌','',''],['广告栏','',''],['广告衫','',''],['广告设计师','',''],['广土众民','',''],['广地','',''],['广场','',''],['广场舞','',''],['广场恐怖症','',''],['广场恐惧','',''],['广场恐惧症','',''],['广域市','',''],['广域网','',''],['广域网路','',''],['广夏细旃','',''],['广外','',''],['广大','',''],['广大人民','',''],['广大党员','',''],['广大干部','',''],['广大群众','',''],['广大读者','',''],['广大青年','',''],['广安地区','',''],['广安门','',''],['广寒仙子','',''],['广寒宫','',''],['广岛','',''],['广岛县','',''],['广岛市','',''],['广州中医药大学','',''],['广州日报','',''],['广州美术学院','',''],['广州起义','',''],['广布','',''],['广度','',''],['广庭大众','',''],['广开','',''],['广开学路','',''],['广开才路','',''],['广开言路','',''],['广开门路','',''],['广播','',''],['广播体操','',''],['广播剧','',''],['广播员','',''],['广播和未知服务器','',''],['广播地址','',''],['广播室','',''],['广播工作','',''],['广播操','',''],['广播段','',''],['广播电台','',''],['广播电影电视总局','',''],['广播电影电视部','',''],['广播电视','',''],['广播电视部','',''],['广播稿','',''],['广播网','',''],['广播网路','',''],['广播节目','',''],['广播讲座','',''],['广播讲话','',''],['广敞','',''],['广柑','',''],['广泛','',''],['广泛开展','',''],['广泛影响','',''],['广泛性','',''],['广游','',''],['广漠','',''],['广电','',''],['广电总局','',''],['广益','',''],['广目天','',''],['广砚','',''],['广种薄收','',''],['广积','',''],['广结','',''],['广结良缘','',''],['广而告之广告公司','',''],['广而言之','',''],['广袖高髻','',''],['广袤','',''],['广袤无垠','',''],['广西','',''],['广西军区','',''],['广西省','',''],['广西自治区','',''],['广角','',''],['广角镜','',''],['广角镜头','',''],['广设','',''],['广识','',''],['广谱','',''],['广货','',''],['广阔','',''],['广阔天地','',''],['广阔性','',''],['广阳','',''],['广陵','',''],['广雅','',''],['广韵','',''],['庄严','',''],['庄主','',''],['庄员','',''],['庄周','',''],['庄周梦蝶','',''],['庄园','',''],['庄园主','',''],['庄子','',''],['庄客','',''],['庄家','',''],['庄户','',''],['庄稼','',''],['庄稼人','',''],['庄稼地','',''],['庄稼户','',''],['庄稼户儿','',''],['庄稼汉','',''],['庄稼活儿','',''],['庄稼院','',''],['庄老','',''],['庄重','',''],['庆事','',''],['庆典','',''],['庆功','',''],['庆功会','',''],['庆华','',''],['庆历','',''],['庆历新政','',''],['庆大霉素','',''],['庆宴','',''],['庆寿','',''],['庆尙北道','',''],['庆尙南道','',''],['庆尚北道','',''],['庆尚南道','',''],['庆尚道','',''],['庆州','',''],['庆幸','',''],['庆父不死','',''],['庆父不死鲁难未已','',''],['庆生','',''],['庆祝','',''],['庆祝会','',''],['庆贺','',''],['庆阳地区','',''],['庇佑','',''],['庇护','',''],['庇护所','',''],['庇祐','',''],['庇荫','',''],['庇西特拉图','',''],['床上','',''],['床上安床','',''],['床上施床','',''],['床上用品','',''],['床下','',''],['床下安床','',''],['床位','',''],['床侧','',''],['床单','',''],['床号','',''],['床垫','',''],['床头','',''],['床头板','',''],['床头柜','',''],['床头金尽','',''],['床子','',''],['床旅','',''],['床板','',''],['床架','',''],['床柱','',''],['床榻','',''],['床沿','',''],['床笠','',''],['床第之私','',''],['床罩','',''],['床脚','',''],['床虱','',''],['床被','',''],['床褥','',''],['床身','',''],['床边','',''],['床铺','',''],['序乐','',''],['序位','',''],['序列','',''],['序列号','',''],['序号','',''],['序名','',''],['序幕','',''],['序战','',''],['序数','',''],['序文','',''],['序时','',''],['序时帐','',''],['序曲','',''],['序渐','',''],['序目','',''],['序言','',''],['序论','',''],['序诗','',''],['序跋','',''],['序齿','',''],['庐剧','',''],['庐山','',''],['庐山真面目','',''],['庐山面目','',''],['庐州','',''],['庐舍','',''],['庐阳','',''],['库仑','',''],['库仑定律','',''],['库仑计','',''],['库仓定律','',''],['库伦','',''],['库伦镇','',''],['库克','',''],['库克山','',''],['库克船长','',''],['库券','',''],['库单','',''],['库姆','',''],['库姆塔格沙漠','',''],['库存','',''],['库存内','',''],['库存品','',''],['库存现金','',''],['库存量','',''],['库容','',''],['库尔','',''],['库尔尼科娃','',''],['库尔德','',''],['库尔德人','',''],['库尔德工人党','',''],['库尔德斯坦','',''],['库尔斯克','',''],['库尔特・瓦尔德海姆','',''],['库工党','',''],['库布里克','',''],['库房','',''],['库木吐拉千佛洞','',''],['库模块','',''],['库款','',''],['库特','',''],['库珀带','',''],['库纳南','',''],['库缎','',''],['库藏','',''],['库蚊','',''],['库里','',''],['库里提巴','',''],['库锦','',''],['库页岛','',''],['应为','',''],['应举','',''],['应予','',''],['应予以','',''],['应于','',''],['应交','',''],['应仁之乱','',''],['应从','',''],['应付','',''],['应付帐款','',''],['应付款','',''],['应付自如','',''],['应付裕如','',''],['应以','',''],['应作','',''],['应做','',''],['应允','',''],['应充','',''],['应免','',''],['应兑','',''],['应具','',''],['应典','',''],['应分','',''],['应列','',''],['应到','',''],['应到达','',''],['应制','',''],['应力','',''],['应力场','',''],['应办','',''],['应加','',''],['应募','',''],['应卯','',''],['应即','',''],['应县木塔','',''],['应发','',''],['应取','',''],['应受','',''],['应变','',''],['应变力','',''],['应变无方','',''],['应变能力','',''],['应变计','',''],['应变随机','',''],['应召','',''],['应召入伍','',''],['应召女郎','',''],['应名儿','',''],['应向','',''],['应否','',''],['应和','',''],['应在','',''],['应城区','',''],['应增','',''],['应声','',''],['应声虫','',''],['应天从人','',''],['应天从民','',''],['应天从物','',''],['应天受命','',''],['应天承运','',''],['应天授命','',''],['应天顺人','',''],['应天顺时','',''],['应天顺民','',''],['应对','',''],['应对不穷','',''],['应对如流','',''],['应将','',''],['应尊敬','',''],['应尽','',''],['应届','',''],['应届毕业生','',''],['应属','',''],['应市','',''],['应当','',''],['应征','',''],['应征收','',''],['应征税','',''],['应得','',''],['应急','',''],['应急出口','',''],['应急待命','',''],['应急措施','',''],['应急照射','',''],['应急状态','',''],['应惩罚','',''],['应战','',''],['应手','',''],['应扣','',''],['应承','',''],['应把','',''],['应报','',''],['应报备','',''],['应拨','',''],['应按','',''],['应按照','',''],['应接','',''],['应接不暇','',''],['应接如响','',''],['应提','',''],['应援','',''],['应摊','',''],['应支','',''],['应收','',''],['应收帐款','',''],['应敌','',''],['应斥责','',''],['应时','',''],['应时而生','',''],['应是','',''],['应景','',''],['应景儿','',''],['应有','',''],['应有尽有','',''],['应机权变','',''],['应机立断','',''],['应权通变','',''],['应根据','',''],['应注意','',''],['应激性','',''],['应点','',''],['应生','',''],['应用','',''],['应用于','',''],['应用层','',''],['应用平台','',''],['应用心理学','',''],['应用技术','',''],['应用数学','',''],['应用文','',''],['应用物理','',''],['应用科学','',''],['应用程式','',''],['应用程式介面','',''],['应用软件','',''],['应用软体','',''],['应用逻辑','',''],['应用题','',''],['应由','',''],['应电流','',''],['应留','',''],['应穿','',''],['应立即','',''],['应答','',''],['应答如响','',''],['应约','',''],['应纳','',''],['应纳税','',''],['应罚款','',''],['应考','',''],['应聘','',''],['应聘者','',''],['应能','',''],['应补','',''],['应被','',''],['应规蹈矩','',''],['应计','',''],['应计基础','',''],['应记','',''],['应许','',''],['应设','',''],['应诉','',''],['应诊','',''],['应诏','',''],['应试','',''],['应试教育','',''],['应试者','',''],['应该','',''],['应该说','',''],['应说','',''],['应诺','',''],['应课税','',''],['应负','',''],['应负责','',''],['应责备','',''],['应贷','',''],['应起诉','',''],['应转','',''],['应运','',''],['应运而生','',''],['应运而起','',''],['应还','',''],['应退','',''],['应适当','',''],['应选','',''],['应邀','',''],['应邀出席','',''],['应邀前来','',''],['应邀而来','',''],['应酬','',''],['应酬话','',''],['应采儿','',''],['应销','',''],['应门','',''],['应际而生','',''],['应领','',''],['应验','',''],['底上','',''],['底下','',''],['底下人','',''],['底事','',''],['底价','',''],['底使','',''],['底儿','',''],['底册','',''],['底分','',''],['底土','',''],['底垫','',''],['底墒','',''],['底夸克','',''],['底子','',''],['底孔','',''],['底宽','',''],['底层','',''],['底工','',''],['底帐','',''],['底座','',''],['底抽','',''],['底数','',''],['底朝天','',''],['底本','',''],['底板','',''],['底架','',''],['底栖有孔虫','',''],['底栖生物','',''],['底样','',''],['底格里斯','',''],['底格里斯河','',''],['底框','',''],['底梁','',''],['底止','',''],['底比斯','',''],['底气','',''],['底汁','',''],['底洞','',''],['底漆','',''],['底火','',''],['底片','',''],['底版','',''],['底牌','',''],['底特律','',''],['底狱','',''],['底界','',''],['底盘','',''],['底码','',''],['底稿','',''],['底端','',''],['底粪','',''],['底纹','',''],['底线','',''],['底细','',''],['底肥','',''],['底船','',''],['底色','',''],['底蕴','',''],['底薪','',''],['底行','',''],['底裤','',''],['底襟','',''],['底角','',''],['底货','',''],['底边','',''],['底部','',''],['底里','',''],['底阀','',''],['底限','',''],['底面','',''],['庖丁','',''],['庖丁解牛','',''],['庖厨','',''],['庖牺氏','',''],['庖疹','',''],['店东','',''],['店主','',''],['店伙','',''],['店伙计','',''],['店内','',''],['店名','',''],['店员','',''],['店堂','',''],['店外','',''],['店头','',''],['店家','',''],['店小二','',''],['店类','',''],['店舍','',''],['店里','',''],['店钱','',''],['店铃','',''],['店铺','',''],['店面','',''],['店面广告','',''],['店风','',''],['庙中','',''],['庙主','',''],['庙会','',''],['庙口','',''],['庙号','',''],['庙堂','',''],['庙塔','',''],['庙宇','',''],['庙寺','',''],['庙祝','',''],['庙里','',''],['庚午','',''],['庚子','',''],['庚子国变','',''],['庚寅','',''],['庚帖','',''],['庚戌','',''],['庚日','',''],['庚申','',''],['庚癸之呼','',''],['庚糖','',''],['庚辰','',''],['府上','',''],['府中','',''],['府兵制','',''],['府君','',''],['府城','',''],['府外','',''],['府尹','',''],['府幕','',''],['府库','',''],['府志','',''],['府治','',''],['府第','',''],['府绸','',''],['府试','',''],['府邸','',''],['庞克','',''],['庞兹','',''],['庞加莱','',''],['庞培','',''],['庞大','',''],['庞家堡区','',''],['庞德','',''],['庞德街','',''],['庞杂','',''],['庞氏','',''],['庞氏骗局','',''],['庞涓','',''],['庞然','',''],['庞然大物','',''],['庞眉白发','',''],['庞眉皓首','',''],['废书而叹','',''],['废人','',''],['废位','',''],['废品','',''],['废品收购','',''],['废品率','',''],['废址','',''],['废墟','',''],['废嫡','',''],['废寝忘食','',''],['废寝忘餐','',''],['废寝食','',''],['废弃','',''],['废弃物','',''],['废弛','',''],['废掉','',''],['废料','',''],['废旧','',''],['废旧物资','',''],['废时','',''],['废林','',''],['废柴','',''],['废止','',''],['废止者','',''],['废气','',''],['废水','',''],['废油','',''],['废液','',''],['废渣','',''],['废热利用','',''],['废然','',''],['废然而反','',''],['废物','',''],['废物利用','',''],['废物箱','',''],['废矿','',''],['废票','',''],['废站','',''],['废纸','',''],['废纸篓','',''],['废统','',''],['废置','',''],['废置不用','',''],['废胶','',''],['废船','',''],['废藩置县','',''],['废话','',''],['废语','',''],['废钢','',''],['废铁','',''],['废铜','',''],['废铜烂铁','',''],['废除','',''],['废除军备','',''],['废页','',''],['废食忘寝','',''],['废黜','',''],['庠序','',''],['度假','',''],['度假区','',''],['度假者','',''],['度君子之腹','',''],['度命','',''],['度夏','',''],['度外','',''],['度娘','',''],['度尺','',''],['度德量力','',''],['度支','',''],['度数','',''],['度日','',''],['度日如岁','',''],['度日如年','',''],['度曲','',''],['度牒','',''],['度蜜月','',''],['度表','',''],['度过','',''],['度过难关','',''],['度量','',''],['度量大','',''],['度量衡','',''],['座上','',''],['座上客','',''],['座上宾','',''],['座中','',''],['座位','',''],['座像','',''],['座儿','',''],['座前','',''],['座力','',''],['座右铭','',''],['座号','',''],['座员','',''],['座垫','',''],['座头市','',''],['座头鲸','',''],['座套','',''],['座子','',''],['座层','',''],['座师','',''],['座席','',''],['座无空席','',''],['座无虚席','',''],['座机','',''],['座标','',''],['座标轴','',''],['座椅','',''],['座椅套子','',''],['座次','',''],['座生水母','',''],['座者','',''],['座舱','',''],['座落','',''],['座谈','',''],['座谈会','',''],['座车','',''],['座钟','',''],['座骨','',''],['庭上','',''],['庭令','',''],['庭园','',''],['庭园里','',''],['庭堂','',''],['庭外','',''],['庭审','',''],['庭期','',''],['庭训','',''],['庭议','',''],['庭长','',''],['庭院','',''],['庭院经济','',''],['庭除','',''],['庵堂','',''],['庵摩勒','',''],['庵摩落迦果','',''],['庶乎','',''],['庶人','',''],['庶几','',''],['庶几乎','',''],['庶务','',''],['庶吉士','',''],['庶子','',''],['庶室','',''],['庶母','',''],['庶民','',''],['庶生','',''],['康乃馨','',''],['康乐球','',''],['康乾宗迦峰','',''],['康乾盛世','',''],['康佳','',''],['康健','',''],['康区','',''],['康哉之歌','',''],['康复','',''],['康多莉扎・赖斯','',''],['康奈尔','',''],['康奈尔大学','',''],['康宁','',''],['康巴','',''],['康巴地区','',''],['康巴藏区','',''],['康广仁','',''],['康庄','',''],['康庄大道','',''],['康强','',''],['康德','',''],['康思维恩格','',''],['康托尔','',''],['康拜因','',''],['康斯坦察','',''],['康斯坦茨','',''],['康有为','',''],['康桥','',''],['康泰','',''],['康涅狄格','',''],['康涅狄格州','',''],['康熙','',''],['康熙字典','',''],['康生','',''],['康白度','',''],['康科德','',''],['康衢','',''],['康采恩','',''],['康铜','',''],['庸中佼佼','',''],['庸中皎皎','',''],['庸人','',''],['庸人庸福','',''],['庸人自扰','',''],['庸人自扰之','',''],['庸俗','',''],['庸俗低级','',''],['庸俗作品','',''],['庸俗化','',''],['庸俗唯物主义','',''],['庸俗政治经济学','',''],['庸俗者','',''],['庸医','',''],['庸医杀人','',''],['庸品','',''],['庸国','',''],['庸庸碌碌','',''],['庸才','',''],['庸碌','',''],['庸碌无能','',''],['庸谷进化论','',''],['庾信','',''],['廉价','',''],['廉价物','',''],['廉俸','',''],['廉售','',''],['廉宜','',''],['廉政','',''],['廉政公署','',''],['廉政建设','',''],['廉明','',''],['廉正','',''],['廉泉让水','',''],['廉洁','',''],['廉洁公道','',''],['廉洁奉公','',''],['廉洁自律','',''],['廉烂羊头','',''],['廉直','',''],['廉署','',''],['廉耻','',''],['廉远堂高','',''],['廉顽立懦','',''],['廉颇','',''],['廊下','',''],['廊桥','',''],['廊坊地区','',''],['廊子','',''],['廊庑','',''],['廊庙','',''],['廊檐','',''],['廊道','',''],['廓张','',''],['廓清','',''],['廓落','',''],['廖沫沙','',''],['廥仓','',''],['延于','',''],['延会','',''],['延伸','',''],['延发','',''],['延发性','',''],['延后','',''],['延坪岛','',''],['延安地区','',''],['延安整风运动','',''],['延安精神','',''],['延宕','',''],['延展','',''],['延展性','',''],['延平','',''],['延平乡','',''],['延年','',''],['延年益寿','',''],['延性','',''],['延报','',''],['延拓','',''],['延接','',''],['延揽','',''],['延搁','',''],['延时','',''],['延时器','',''],['延时摄影','',''],['延期','',''],['延期付款','',''],['延滞','',''],['延烧','',''],['延用','',''],['延续','',''],['延绵','',''],['延缓','',''],['延聘','',''],['延聘招揽','',''],['延至','',''],['延见','',''],['延误','',''],['延误费','',''],['延请','',''],['延边','',''],['延边地区','',''],['延边大学','',''],['延边州','',''],['延迟','',''],['延长线','',''],['延颈举踵','',''],['延颈企踵','',''],['延髓','',''],['廷争面折','',''],['廷尉','',''],['廷巴克图','',''],['廷布','',''],['廷杖','',''],['廷试','',''],['建三江','',''],['建下','',''],['建业','',''],['建中','',''],['建于','',''],['建交','',''],['建党','',''],['建党思想','',''],['建党节','',''],['建兰','',''],['建兵','',''],['建军','',''],['建初','',''],['建制','',''],['建功','',''],['建功立业','',''],['建功立事','',''],['建华','',''],['建厂','',''],['建同一气','',''],['建同作弊','',''],['建国','',''],['建国以来','',''],['建国方针','',''],['建基','',''],['建塘镇','',''],['建好','',''],['建委','',''],['建安','',''],['建屋互助会','',''],['建工','',''],['建帐','',''],['建康','',''],['建成','',''],['建成区','',''],['建成投产','',''],['建户','',''],['建房','',''],['建所','',''],['建政','',''],['建文','',''],['建文帝','',''],['建有','',''],['建材','',''],['建材工业','',''],['建构','',''],['建构正义理论','',''],['建树','',''],['建校','',''],['建档','',''],['建桥','',''],['建模','',''],['建漆','',''],['建瓴高屋','',''],['建白','',''],['建省','',''],['建立','',''],['建立健全','',''],['建立正式外交关系','',''],['建立者','',''],['建站','',''],['建筑','',''],['建筑上','',''],['建筑业','',''],['建筑学','',''],['建筑工人','',''],['建筑师','',''],['建筑术','',''],['建筑材料','',''],['建筑物','',''],['建筑群','',''],['建筑者','',''],['建筑艺术','',''],['建筑设计','',''],['建筑队','',''],['建筑面积','',''],['建置','',''],['建行','',''],['建言','',''],['建议','',''],['建议书','',''],['建议者','',''],['建设','',''],['建设中','',''],['建设公债','',''],['建设厅','',''],['建设性','',''],['建设性的批评','',''],['建设者','',''],['建设部','',''],['建起','',''],['建造','',''],['建造者','',''],['建邺','',''],['建都','',''],['建院','',''],['建馆','',''],['廿八躔','',''],['廿四史','',''],['开三次方','',''],['开上','',''],['开上开下船','',''],['开业','',''],['开业典礼','',''],['开业大吉','',''],['开业者','',''],['开个','',''],['开了','',''],['开二次','',''],['开于','',''],['开云见日','',''],['开交','',''],['开亮了','',''],['开仓济贫','',''],['开仗','',''],['开价','',''],['开伐','',''],['开伙','',''],['开会','',''],['开会祈祷','',''],['开会讨论','',''],['开伞','',''],['开伯尔','',''],['开伯尔山口','',''],['开例','',''],['开信','',''],['开倒车','',''],['开元','',''],['开元之治','',''],['开元盛世','',''],['开先','',''],['开光','',''],['开入','',''],['开关','',''],['开出','',''],['开凿','',''],['开凿者','',''],['开刀','',''],['开刃','',''],['开刃儿','',''],['开列','',''],['开创','',''],['开创局面','',''],['开创性','',''],['开创新局面','',''],['开创者','',''],['开初','',''],['开到','',''],['开办','',''],['开动','',''],['开区','',''],['开区间','',''],['开单','',''],['开印','',''],['开卷','',''],['开卷有得','',''],['开卷有益','',''],['开卷考试','',''],['开原县','',''],['开去','',''],['开发','',''],['开发中心','',''],['开发人员','',''],['开发公司','',''],['开发利用','',''],['开发区','',''],['开发周期','',''],['开发商','',''],['开发环境','',''],['开发者','',''],['开发费','',''],['开发资源','',''],['开发过程','',''],['开发部','',''],['开发银行','',''],['开口','',''],['开口呼','',''],['开口子','',''],['开口跳','',''],['开口销','',''],['开台','',''],['开台锣鼓','',''],['开司米','',''],['开合桥','',''],['开合锣鼓','',''],['开吊','',''],['开后门','',''],['开向','',''],['开启','',''],['开味','',''],['开国','',''],['开国元勋','',''],['开国功臣','',''],['开国大典','',''],['开地','',''],['开场','',''],['开场白','',''],['开场锣鼓','',''],['开坯','',''],['开垦','',''],['开城','',''],['开城市','',''],['开埠','',''],['开堂','',''],['开墒','',''],['开士米','',''],['开壶','',''],['开处','',''],['开处方','',''],['开外','',''],['开夜车','',''],['开大','',''],['开大油门','',''],['开天窗','',''],['开天辟地','',''],['开天避地','',''],['开头','',''],['开奖','',''],['开始','',''],['开始以前','',''],['开始实行','',''],['开始时','',''],['开始比赛','',''],['开始营业','',''],['开孔','',''],['开学','',''],['开宗明义','',''],['开导','',''],['开封地区','',''],['开封府','',''],['开小','',''],['开小会','',''],['开小差','',''],['开小灶','',''],['开尔文','',''],['开局','',''],['开屏','',''],['开展','',''],['开山','',''],['开山祖师','',''],['开山老祖','',''],['开山鼻祖','',''],['开岁','',''],['开工','',''],['开工典礼','',''],['开工率','',''],['开市','',''],['开帐','',''],['开席','',''],['开幕','',''],['开幕典礼','',''],['开幕式','',''],['开幕词','',''],['开年','',''],['开年以来','',''],['开店','',''],['开庭','',''],['开开','',''],['开开心心','',''],['开弓','',''],['开张','',''],['开往','',''],['开征','',''],['开心','',''],['开心丸儿','',''],['开心形','',''],['开心果','',''],['开心见诚','',''],['开心颜','',''],['开快','',''],['开快车','',''],['开怀','',''],['开怀儿','',''],['开怀大笑','',''],['开怀畅饮','',''],['开恩','',''],['开慢','',''],['开戏','',''],['开戒','',''],['开战','',''],['开户','',''],['开户行','',''],['开户银行','',''],['开房','',''],['开房间','',''],['开打','',''],['开扩','',''],['开拍','',''],['开拓','',''],['开拓创新','',''],['开拓型','',''],['开拓性','',''],['开拓精神','',''],['开拓者','',''],['开拔','',''],['开挖','',''],['开掘','',''],['开播','',''],['开支','',''],['开放','',''],['开放地区','',''],['开放地带','',''],['开放城市','',''],['开放市场','',''],['开放式系统','',''],['开放式网络','',''],['开放性','',''],['开放源代码','',''],['开放源码','',''],['开放源码软件','',''],['开放电路','',''],['开放系统','',''],['开放系统互连','',''],['开敞','',''],['开斋','',''],['开斋节','',''],['开方','',''],['开旷','',''],['开明','',''],['开明专制','',''],['开明人士','',''],['开明君主','',''],['开映','',''],['开春','',''],['开普勒','',''],['开普勒定律','',''],['开普敦','',''],['开晴','',''],['开朗','',''],['开本','',''],['开机','',''],['开杆','',''],['开来','',''],['开枪','',''],['开架','',''],['开架式','',''],['开标','',''],['开槽','',''],['开步','',''],['开水','',''],['开汽车','',''],['开沟','',''],['开河','',''],['开河期','',''],['开洋','',''],['开洋荤','',''],['开洞','',''],['开涮','',''],['开渠','',''],['开源','',''],['开源节流','',''],['开溜','',''],['开满','',''],['开演','',''],['开漳圣王','',''],['开火','',''],['开灯','',''],['开炉','',''],['开炮','',''],['开物成务','',''],['开犁','',''],['开玩笑','',''],['开班','',''],['开球','',''],['开瓶费','',''],['开电','',''],['开畅','',''],['开疆','',''],['开白条','',''],['开皌','',''],['开盖','',''],['开盘','',''],['开盘汇率','',''],['开眼','',''],['开眼界','',''],['开着','',''],['开矿','',''],['开票','',''],['开票人','',''],['开禁','',''],['开福','',''],['开秤','',''],['开窍','',''],['开窗','',''],['开窗口','',''],['开窗法','',''],['开立','',''],['开站','',''],['开端','',''],['开端者','',''],['开笔','',''],['开筵','',''],['开篇','',''],['开篇伊始','',''],['开线','',''],['开给','',''],['开绽','',''],['开绿灯','',''],['开缝','',''],['开缺','',''],['开罐','',''],['开罐器','',''],['开罗','',''],['开罗会议','',''],['开罗大学','',''],['开罗宣言','',''],['开罚单','',''],['开罪','',''],['开耧','',''],['开胃','',''],['开胃菜','',''],['开胃酒','',''],['开胶','',''],['开脚','',''],['开脱','',''],['开脱罪责','',''],['开脸','',''],['开腔','',''],['开膛','',''],['开膛手杰克','',''],['开航','',''],['开船','',''],['开花','',''],['开花儿','',''],['开花期','',''],['开花结实','',''],['开花结果','',''],['开花衣','',''],['开苞','',''],['开荒','',''],['开荤','',''],['开药','',''],['开著','',''],['开蒙','',''],['开行','',''],['开衩','',''],['开裂','',''],['开裆裤','',''],['开襟','',''],['开解','',''],['开言','',''],['开讲','',''],['开设','',''],['开证','',''],['开诚','',''],['开诚布公','',''],['开诚相见','',''],['开课','',''],['开豁','',''],['开败','',''],['开账','',''],['开赛','',''],['开走','',''],['开赴','',''],['开起','',''],['开足','',''],['开足马力','',''],['开路','',''],['开路人','',''],['开路先锋','',''],['开路机','',''],['开车','',''],['开车人','',''],['开辟','',''],['开辟者','',''],['开辟通路','',''],['开边','',''],['开过','',''],['开运河','',''],['开进','',''],['开通','',''],['开遍','',''],['开道','',''],['开都河','',''],['开酒费','',''],['开采','',''],['开采权','',''],['开释','',''],['开金','',''],['开金矿','',''],['开钻','',''],['开销','',''],['开锁','',''],['开锄','',''],['开锅','',''],['开锣','',''],['开锣喝道','',''],['开镰','',''],['开门','',''],['开门办学','',''],['开门揖盗','',''],['开门炮','',''],['开门红','',''],['开门见喜','',''],['开门见山','',''],['开闭','',''],['开闭幕式','',''],['开间','',''],['开闸','',''],['开闸放水','',''],['开阔','',''],['开阔地','',''],['开阔眼界','',''],['开除','',''],['开除党籍','',''],['开除学籍','',''],['开集','',''],['开霁','',''],['开革','',''],['开颜','',''],['开饭','',''],['开馆','',''],['开首','',''],['开高叉','',''],['开黑店','',''],['弁言','',''],['异丁烷','',''],['异丁苯丙酸','',''],['异丙醇','',''],['异义','',''],['异乎','',''],['异乎寻常','',''],['异乡','',''],['异乡人','',''],['异事','',''],['异于','',''],['异交作物','',''],['异亮氨酸','',''],['异人','',''],['异位','',''],['异体','',''],['异体字','',''],['异俗','',''],['异像','',''],['异元','',''],['异军','',''],['异军特起','',''],['异军突起','',''],['异动','',''],['异化','',''],['异化作用','',''],['异卉奇花','',''],['异卵','',''],['异卵双胞胎','',''],['异口同声','',''],['异口同辞','',''],['异口同音','',''],['异口同韵','',''],['异同','',''],['异名','',''],['异味','',''],['异咯嗪','',''],['异国','',''],['异国他乡','',''],['异国情趣','',''],['异国风光','',''],['异地','',''],['异地恋','',''],['异地相逢','',''],['异型','',''],['异域','',''],['异声','',''],['异处','',''],['异外','',''],['异宝奇珍','',''],['异己','',''],['异己分子','',''],['异常','',''],['异形','',''],['异形词','',''],['异彩','',''],['异心','',''],['异态','',''],['异性','',''],['异性体','',''],['异性性接触','',''],['异性恋','',''],['异性恋主义','',''],['异性相吸','',''],['异想','',''],['异想天开','',''],['异意','',''],['异戊二烯','',''],['异戊橡胶','',''],['异或','',''],['异才','',''],['异政殊俗','',''],['异教','',''],['异教徒','',''],['异教者','',''],['异数','',''],['异文','',''],['异文鄙事','',''],['异族','',''],['异日','',''],['异时','',''],['异曲','',''],['异曲同工','',''],['异服','',''],['异木奇花','',''],['异构','',''],['异构体','',''],['异构酶','',''],['异样','',''],['异步','',''],['异步传输模式','',''],['异步电动机','',''],['异母','',''],['异派同源','',''],['异源多倍体','',''],['异点','',''],['异烟肼','',''],['异焉','',''],['异父','',''],['异物','',''],['异特龙','',''],['异状','',''],['异相','',''],['异种','',''],['异端','',''],['异端者','',''],['异端邪说','',''],['异类','',''],['异胎同岑','',''],['异能','',''],['异腈','',''],['异色','',''],['异花','',''],['异花传粉','',''],['异装癖','',''],['异见','',''],['异见者','',''],['异言','',''],['异议','',''],['异议人士','',''],['异议分子','',''],['异议者','',''],['异词','',''],['异语','',''],['异说','',''],['异读','',''],['异读词','',''],['异质','',''],['异质体','',''],['异质化','',''],['异质网路','',''],['异趣','',''],['异路同归','',''],['异途','',''],['异途同归','',''],['异邦','',''],['异重流','',''],['异闻传说','',''],['异音','',''],['异项','',''],['异频雷达收发机','',''],['异食','',''],['异香','',''],['异香异气','',''],['异香扑鼻','',''],['异龙','',''],['弃世','',''],['弃义','',''],['弃之','',''],['弃之可惜','',''],['弃保潜逃','',''],['弃儿','',''],['弃养','',''],['弃农经商','',''],['弃取','',''],['弃如弁髦','',''],['弃妇','',''],['弃婴','',''],['弃学','',''],['弃守','',''],['弃官','',''],['弃市','',''],['弃恶从善','',''],['弃文就武','',''],['弃旧','',''],['弃旧图新','',''],['弃旧怜新','',''],['弃暗投明','',''],['弃本逐末','',''],['弃权','',''],['弃权票','',''],['弃核','',''],['弃樱','',''],['弃武修文','',''],['弃物','',''],['弃瑕取用','',''],['弃瑕录用','',''],['弃用','',''],['弃甲','',''],['弃甲曳兵','',''],['弃短取长','',''],['弃约背盟','',''],['弃绝','',''],['弃置','',''],['弃职','',''],['弃船','',''],['弃若敝屣','',''],['弃过图新','',''],['弃邪从正','',''],['弃邪归正','',''],['弄上','',''],['弄不好','',''],['弄不清','',''],['弄丢','',''],['弄乱','',''],['弄人','',''],['弄伤','',''],['弄倒','',''],['弄假','',''],['弄假成真','',''],['弄僵','',''],['弄兵','',''],['弄兵潢池','',''],['弄凌乱','',''],['弄出','',''],['弄到','',''],['弄到手','',''],['弄口鸣舌','',''],['弄喧捣鬼','',''],['弄嘴弄舌','',''],['弄圆','',''],['弄坏','',''],['弄坏了','',''],['弄坏事','',''],['弄垮','',''],['弄堂','',''],['弄好','',''],['弄姿','',''],['弄宽','',''],['弄小','',''],['弄巧','',''],['弄巧成拙','',''],['弄干','',''],['弄干净','',''],['弄平','',''],['弄开','',''],['弄弄','',''],['弄弯','',''],['弄弯曲','',''],['弄得','',''],['弄得清','',''],['弄性尚气','',''],['弄懂','',''],['弄懂弄通','',''],['弄成','',''],['弄成一团','',''],['弄整洁','',''],['弄斜','',''],['弄斧班门','',''],['弄断','',''],['弄明白','',''],['弄昏','',''],['弄暗','',''],['弄月嘲风','',''],['弄月抟风','',''],['弄权','',''],['弄枪','',''],['弄歪','',''],['弄死','',''],['弄水','',''],['弄污','',''],['弄法','',''],['弄法舞文','',''],['弄淡','',''],['弄混','',''],['弄清','',''],['弄清楚','',''],['弄湿','',''],['弄潮','',''],['弄热','',''],['弄熄','',''],['弄玉偷香','',''],['弄璋','',''],['弄璋之喜','',''],['弄璋之庆','',''],['弄瓦','',''],['弄瓦之喜','',''],['弄甜','',''],['弄痛','',''],['弄白','',''],['弄皱','',''],['弄盏传杯','',''],['弄直','',''],['弄着','',''],['弄短','',''],['弄破','',''],['弄确实','',''],['弄碎','',''],['弄穷','',''],['弄笔','',''],['弄粉调朱','',''],['弄粗','',''],['弄糊涂','',''],['弄糟','',''],['弄细','',''],['弄绉','',''],['弄翻','',''],['弄脏','',''],['弄脏了','',''],['弄臣','',''],['弄苦','',''],['弄虚','',''],['弄虚作假','',''],['弄蛇','',''],['弄蛇者','',''],['弄走','',''],['弄通','',''],['弄醉','',''],['弄醒','',''],['弄钝','',''],['弄钱','',''],['弄错','',''],['弄饭','',''],['弄鬼','',''],['弄鬼妆幺','',''],['弄鬼掉猴','',''],['弄黑','',''],['弊习','',''],['弊多利少','',''],['弊害','',''],['弊恶','',''],['弊政','',''],['弊病','',''],['弊端','',''],['弊绝风清','',''],['弊衣疏食','',''],['弊衣箪食','',''],['弊车羸马','',''],['弊车驽马','',''],['弋不射宿','',''],['弋横起义','',''],['弋江','',''],['弋江区','',''],['弋者何慕','',''],['弋者何篡','',''],['弋阳腔','',''],['式子','',''],['式微','',''],['式样','',''],['弑君','',''],['弑母','',''],['弑父','',''],['弑父母','',''],['弓匠','',''],['弓子','',''],['弓射手','',''],['弓弦','',''],['弓弦儿','',''],['弓弩','',''],['弓弩手','',''],['弓形','',''],['弓状','',''],['弓箭','',''],['弓箭手','',''],['弓箭步','',''],['弓背','',''],['弓腰','',''],['弓起','',''],['弓身','',''],['弓长岭','',''],['引为','',''],['引产','',''],['引人','',''],['引人入胜','',''],['引人注意','',''],['引人注目','',''],['引人瞩目','',''],['引介','',''],['引以','',''],['引以为傲','',''],['引以为憾','',''],['引以为戒','',''],['引以为耻','',''],['引以为荣','',''],['引伸','',''],['引体','',''],['引体向上','',''],['引使','',''],['引信','',''],['引信系统','',''],['引儿','',''],['引入','',''],['引入口','',''],['引入迷途','',''],['引决','',''],['引出','',''],['引别','',''],['引力','',''],['引力场','',''],['引力波','',''],['引动','',''],['引发','',''],['引叙','',''],['引号','',''],['引向','',''],['引向器','',''],['引吭高歌','',''],['引咎','',''],['引咎自责','',''],['引咎责躬','',''],['引咎辞职','',''],['引商刻羽','',''],['引喻','',''],['引嫌','',''],['引子','',''],['引导','',''],['引导员','',''],['引导扇区','',''],['引座员','',''],['引开','',''],['引征','',''],['引得','',''],['引得出','',''],['引据','',''],['引接','',''],['引擎','',''],['引文','',''],['引来','',''],['引柴','',''],['引桥','',''],['引水','',''],['引水上山','',''],['引水入墙','',''],['引水员','',''],['引水工程','',''],['引河','',''],['引流','',''],['引渡','',''],['引港','',''],['引火','',''],['引火柴','',''],['引火烧身','',''],['引火物','',''],['引火线','',''],['引炸','',''],['引燃','',''],['引爆','',''],['引爆器','',''],['引爆点','',''],['引爆装置','',''],['引物','',''],['引狗入寨','',''],['引狼入室','',''],['引玉','',''],['引玉之砖','',''],['引理','',''],['引用','',''],['引用句','',''],['引用文','',''],['引申','',''],['引申义','',''],['引申语','',''],['引着','',''],['引示','',''],['引种','',''],['引类呼朋','',''],['引线','',''],['引线穿针','',''],['引经据典','',''],['引经据古','',''],['引绳批根','',''],['引绳排根','',''],['引而不发','',''],['引自','',''],['引致','',''],['引航','',''],['引航权','',''],['引荐','',''],['引虎自卫','',''],['引蛇出洞','',''],['引行','',''],['引见','',''],['引言','',''],['引论','',''],['引证','',''],['引证者','',''],['引语','',''],['引诱','',''],['引诱物','',''],['引起','',''],['引起争议','',''],['引起轰动','',''],['引足救经','',''],['引路','',''],['引车','',''],['引进','',''],['引进人才','',''],['引进外资','',''],['引进技术','',''],['引进设备','',''],['引述','',''],['引退','',''],['引逗','',''],['引道','',''],['引酵','',''],['引锥刺骨','',''],['引领','',''],['引领企踵','',''],['引颈','',''],['引颈受戮','',''],['引颈就戮','',''],['引风吹火','',''],['引鬼上门','',''],['弗兰克','',''],['弗兰兹','',''],['弗兰西斯','',''],['弗兰西斯・培根','',''],['弗吉尼亚','',''],['弗吉尼亚州','',''],['弗塞奇','',''],['弗如','',''],['弗拉基米尔','',''],['弗拉芒','',''],['弗朗索瓦・霍兰德','',''],['弗格森','',''],['弗洛伊德','',''],['弗洛伦蒂诺・佩雷斯','',''],['弗洛勒斯岛','',''],['弗洛姆','',''],['弗洛里斯岛','',''],['弗爱','',''],['弗罗茨瓦夫','',''],['弗罗里达','',''],['弗罗里达州','',''],['弗莱威厄斯','',''],['弗莱福兰','',''],['弗落伊德','',''],['弗迪南','',''],['弗里得里希','',''],['弗里德里希','',''],['弗里德里希・席勒','',''],['弗里敦','',''],['弗里斯兰','',''],['弗里曼','',''],['弗雷','',''],['弗雷德里克','',''],['弗雷德里克顿','',''],['弘图','',''],['弘愿','',''],['弘扬','',''],['弘治','',''],['弘法','',''],['弘论','',''],['弘道','',''],['弛张','',''],['弛张性','',''],['弛张热','',''],['弛懈','',''],['弛禁','',''],['弛缓','',''],['弟亲','',''],['弟兄','',''],['弟兄们','',''],['弟妇','',''],['弟妹','',''],['弟媳','',''],['弟媳妇','',''],['弟子','',''],['弟子规','',''],['弟弟','',''],['张臂','',''],['张丹','',''],['张之洞','',''],['张二鸿','',''],['张仪','',''],['张伯伦','',''],['张作霖','',''],['张僧繇','',''],['张公吃酒李公醉','',''],['张冠李戴','',''],['张力','',''],['张力计','',''],['张华','',''],['张口','',''],['张口结舌','',''],['张嘴','',''],['张国焘','',''],['张国荣','',''],['张大','',''],['张大千','',''],['张天翼','',''],['张太雷','',''],['张学友','',''],['张学良','',''],['张宁','',''],['张宝','',''],['张家口地区','',''],['张家长','',''],['张居正','',''],['张岱','',''],['张帖','',''],['张店','',''],['张廷玉','',''],['张开','',''],['张弛','',''],['张张','',''],['张心','',''],['张志新','',''],['张怡','',''],['张怡宁','',''],['张惠妹','',''],['张戎','',''],['张扬','',''],['张择端','',''],['张挂','',''],['张掖地区','',''],['张揖','',''],['张敞','',''],['张敞画眉','',''],['张数','',''],['张斌','',''],['张旭','',''],['张易之','',''],['张春帆','',''],['张春桥','',''],['张曼玉','',''],['张望','',''],['张本','',''],['张柏芝','',''],['张楚','',''],['张榜','',''],['张榜公布','',''],['张治中','',''],['张湾','',''],['张溥','',''],['张灯挂彩','',''],['张灯结彩','',''],['张爱玲','',''],['张牙舞爪','',''],['张牙舞瓜','',''],['张狂','',''],['张献忠','',''],['张王李赵','',''],['张皇','',''],['张皇失措','',''],['张皇失错','',''],['张目','',''],['张眉努眼','',''],['张秋','',''],['张籍','',''],['张纯如','',''],['张网','',''],['张罗','',''],['张自忠','',''],['张艺谋','',''],['张若虚','',''],['张衡','',''],['张角','',''],['张诚泽','',''],['张贴','',''],['张量','',''],['张闻天','',''],['张震','',''],['张静初','',''],['张韶涵','',''],['张飞','',''],['张飞打岳飞','',''],['张骞','',''],['弥久','',''],['弥深','',''],['弥勒佛','',''],['弥勒菩萨','',''],['弥合','',''],['弥天','',''],['弥天大罪','',''],['弥天大谎','',''],['弥天盖地','',''],['弥封','',''],['弥山遍野','',''],['弥彰','',''],['弥撒','',''],['弥散','',''],['弥月','',''],['弥望','',''],['弥满','',''],['弥漫','',''],['弥漫星云','',''],['弥甥','',''],['弥留','',''],['弥缝','',''],['弥蒙','',''],['弥补','',''],['弥赛亚','',''],['弥足珍贵','',''],['弥迦书','',''],['弥陀','',''],['弥陀乡','',''],['弦乐','',''],['弦乐器','',''],['弦乐队','',''],['弦切角','',''],['弦器','',''],['弦声','',''],['弦外之响','',''],['弦外之意','',''],['弦外之音','',''],['弦子','',''],['弦子舞','',''],['弦数','',''],['弦月','',''],['弦月窗','',''],['弦歌','',''],['弦比','',''],['弦理论','',''],['弦琴','',''],['弦线','',''],['弦而鼓之','',''],['弦规','',''],['弦论','',''],['弦诵不缀','',''],['弦诵不辍','',''],['弦贝斯','',''],['弦音','',''],['弦音器','',''],['弦鸣乐器','',''],['弧光','',''],['弧光灯','',''],['弧度','',''],['弧形','',''],['弧线','',''],['弧线长','',''],['弧菌','',''],['弧长','',''],['弧长参数','',''],['弧面','',''],['弩兵','',''],['弩弓','',''],['弩手','',''],['弩炮','',''],['弩钝','',''],['弪度','',''],['弭兵','',''],['弭患','',''],['弭撒','',''],['弭谤','',''],['弯下','',''],['弯了','',''],['弯作','',''],['弯儿','',''],['弯刀','',''],['弯回','',''],['弯头','',''],['弯如弓','',''],['弯子','',''],['弯度','',''],['弯弓','',''],['弯弯','',''],['弯弯曲曲','',''],['弯成','',''],['弯扭','',''],['弯折','',''],['弯曲','',''],['弯曲处','',''],['弯曲度','',''],['弯曲形变','',''],['弯曲空间','',''],['弯月','',''],['弯月形透镜','',''],['弯液面','',''],['弯着','',''],['弯矩','',''],['弯管面','',''],['弯腰','',''],['弯腰驼背','',''],['弯腿','',''],['弯膝礼','',''],['弯角','',''],['弯路','',''],['弯身','',''],['弯进','',''],['弯道','',''],['弱不好弄','',''],['弱不禁风','',''],['弱不胜衣','',''],['弱作用','',''],['弱作用力','',''],['弱侧','',''],['弱冠','',''],['弱势','',''],['弱势群体','',''],['弱化','',''],['弱受','',''],['弱国','',''],['弱型','',''],['弱小','',''],['弱性','',''],['弱拍','',''],['弱敌','',''],['弱智','',''],['弱智儿童','',''],['弱点','',''],['弱电','',''],['弱电统一','',''],['弱相互作用','',''],['弱碱','',''],['弱碱性','',''],['弱者','',''],['弱肉强食','',''],['弱脉','',''],['弱视','',''],['弱败','',''],['弱酸','',''],['弱队','',''],['弱音','',''],['弱音踏板','',''],['弱项','',''],['弹丝品竹','',''],['弹丸','',''],['弹丸之地','',''],['弹体','',''],['弹冠相庆','',''],['弹出','',''],['弹出式','',''],['弹力','',''],['弹力呢','',''],['弹力素','',''],['弹力袜','',''],['弹劾','',''],['弹匣','',''],['弹压','',''],['弹去','',''],['弹吉他','',''],['弹唱','',''],['弹回','',''],['弹坑','',''],['弹壳','',''],['弹头','',''],['弹夹','',''],['弹奏','',''],['弹子','',''],['弹子锁','',''],['弹孔','',''],['弹射','',''],['弹射出','',''],['弹射器','',''],['弹射座椅','',''],['弹射座舱','',''],['弹尽援绝','',''],['弹尽粮绝','',''],['弹开','',''],['弹弓','',''],['弹性','',''],['弹性体','',''],['弹性力学','',''],['弹性化','',''],['弹性形变','',''],['弹性模量','',''],['弹拨','',''],['弹拨乐','',''],['弹拨乐器','',''],['弹指','',''],['弹指一挥间','',''],['弹指之间','',''],['弹指如飞','',''],['弹料','',''],['弹斤估两','',''],['弹斥','',''],['弹无虚发','',''],['弹涂鱼','',''],['弹片','',''],['弹牙','',''],['弹珠','',''],['弹球','',''],['弹球盘','',''],['弹琴','',''],['弹痕','',''],['弹痕累累','',''],['弹盒','',''],['弹着点','',''],['弹空说嘴','',''],['弹竖琴','',''],['弹筒','',''],['弹簧','',''],['弹簧刀','',''],['弹簧秤','',''],['弹簧钢','',''],['弹簧锁','',''],['弹簧门','',''],['弹纠','',''],['弹花','',''],['弹药','',''],['弹药学','',''],['弹药库','',''],['弹药消耗','',''],['弹药筒','',''],['弹药箱','',''],['弹药补给站','',''],['弹词','',''],['弹起','',''],['弹跳','',''],['弹跳板','',''],['弹道','',''],['弹道学','',''],['弹道导弹','',''],['弹道式导弹','',''],['弹量','',''],['弹铗无鱼','',''],['弹雨','',''],['强不知以为知','',''],['强中更有强中手','',''],['强中自有强中手','',''],['强买','',''],['强买强卖','',''],['强人','',''],['强人所难','',''],['强令','',''],['强似','',''],['强作','',''],['强作用','',''],['强作用力','',''],['强作笑颜','',''],['强使','',''],['强借','',''],['强健','',''],['强光','',''],['强兵','',''],['强击机','',''],['强制','',''],['强制性','',''],['强制执行法','',''],['强制措施','',''],['强力','',''],['强力胶','',''],['强加','',''],['强加于','',''],['强加于人','',''],['强劲','',''],['强势','',''],['强化','',''],['强化物','',''],['强化训练','',''],['强占','',''],['强压','',''],['强压怒火','',''],['强取','',''],['强取豪夺','',''],['强台风','',''],['强告化','',''],['强嘴','',''],['强固','',''],['强国','',''],['强国之路','',''],['强国富民','',''],['强壮','',''],['强壮人','',''],['强壮剂','',''],['强大','',''],['强夺','',''],['强奸','',''],['强奸民意','',''],['强奸犯','',''],['强奸罪','',''],['强奸者','',''],['强子','',''],['强射','',''],['强将之下无弱兵','',''],['强将手下无弱兵','',''],['强干','',''],['强干弱枝','',''],['强度','',''],['强开','',''],['强弩之末','',''],['强弱','',''],['强征','',''],['强心剂','',''],['强心针','',''],['强忍','',''],['强忍悲痛','',''],['强悍','',''],['强悍人','',''],['强手','',''],['强手如云','',''],['强手如林','',''],['强打','',''],['强打手','',''],['强扯','',''],['强抢','',''],['强拉','',''],['强拉硬扯','',''],['强拍','',''],['强推','',''],['强攻','',''],['强敌','',''],['强暴','',''],['强曳','',''],['强有力','',''],['强有力地','',''],['强本弱知','',''],['强本节用','',''],['强权','',''],['强权政治','',''],['强档','',''],['强梁','',''],['强横','',''],['强死强活','',''],['强求','',''],['强派','',''],['强流','',''],['强渡','',''],['强渡江河','',''],['强烈','',''],['强烈反对','',''],['强烈愿望','',''],['强烈抗议','',''],['强生','',''],['强生公司','',''],['强电','',''],['强留','',''],['强的','',''],['强盗','',''],['强盗罪','',''],['强盛','',''],['强直','',''],['强相互作用','',''],['强硬','',''],['强硬态度','',''],['强硬派','',''],['强硬立场','',''],['强碱','',''],['强磁','',''],['强磁性','',''],['强者','',''],['强聒不舍','',''],['强行','',''],['强行军','',''],['强行摊派','',''],['强袭','',''],['强要','',''],['强记','',''],['强记博闻','',''],['强记洽闻','',''],['强词夺理','',''],['强调','',''],['强身','',''],['强身健体','',''],['强辐射区','',''],['强辩','',''],['强过','',''],['强迫','',''],['强迫人','',''],['强迫劳动','',''],['强迫性','',''],['强迫性储物症','',''],['强迫性性行为','',''],['强迫症','',''],['强迫观念','',''],['强逼','',''],['强酸','',''],['强队','',''],['强震','',''],['强韧','',''],['强音','',''],['强音踏板','',''],['强音部','',''],['强项','',''],['强颜','',''],['强风','',''],['强食','',''],['强马饮水难','',''],['强龙不压地头蛇','',''],['彀中','',''],['归一','',''],['归为','',''],['归于','',''],['归仁','',''],['归仁乡','',''],['归位','',''],['归依','',''],['归侨','',''],['归入','',''],['归全反真','',''],['归公','',''],['归到','',''],['归功','',''],['归功于','',''],['归化','',''],['归去','',''],['归去来兮','',''],['归口','',''],['归向','',''],['归咎','',''],['归咎于','',''],['归因','',''],['归因于','',''],['归国','',''],['归国者','',''],['归垫','',''],['归天','',''],['归奇顾怪','',''],['归宁','',''],['归家','',''],['归宿','',''],['归属','',''],['归属感','',''],['归属权','',''],['归巢','',''],['归己','',''],['归并','',''],['归并排序','',''],['归心','',''],['归心似箭','',''],['归心如箭','',''],['归心者','',''],['归总','',''],['归拢','',''],['归教育','',''],['归期','',''],['归来','',''],['归根','',''],['归根到底','',''],['归根结底','',''],['归根结蒂','',''],['归案','',''],['归档','',''],['归正反当','',''],['归正反本','',''],['归正首丘','',''],['归田','',''],['归由','',''],['归省','',''],['归真','',''],['归真反璞','',''],['归真返璞','',''],['归着','',''],['归程','',''],['归类','',''],['归类于','',''],['归纳','',''],['归纳推理','',''],['归纳法','',''],['归纳逻辑','',''],['归结','',''],['归结于','',''],['归绥','',''],['归罪','',''],['归罪于','',''],['归置','',''],['归老菟裘','',''],['归航','',''],['归西','',''],['归谁','',''],['归谬法','',''],['归赵','',''],['归路','',''],['归返','',''],['归还','',''],['归途','',''],['归邪反正','',''],['归邪转曜','',''],['归队','',''],['归附','',''],['归降','',''],['归除','',''],['归隐','',''],['归集','',''],['归零地','',''],['归顺','',''],['归马放牛','',''],['归齐','',''],['当上','',''],['当下','',''],['当且仅当','',''],['当世','',''],['当世之冠','',''],['当世冠','',''],['当世才度','',''],['当世无双','',''],['当个','',''],['当中','',''],['当中间儿','',''],['当之','',''],['当之无愧','',''],['当之有愧','',''],['当事','',''],['当事人','',''],['当事国','',''],['当事者','',''],['当事者迷','',''],['当仁不让','',''],['当今','',''],['当今世界','',''],['当今无辈','',''],['当今社会','',''],['当代','',''],['当代史','',''],['当代新儒家','',''],['当令','',''],['当众','',''],['当众出丑','',''],['当众受辱','',''],['当作','',''],['当值','',''],['当做','',''],['当儿','',''],['当先','',''],['当兵','',''],['当初','',''],['当前','',''],['当前任务','',''],['当前工作','',''],['当前状况','',''],['当务','',''],['当务之急','',''],['当十','',''],['当即','',''],['当口','',''],['当口儿','',''],['当哭','',''],['当啷','',''],['当回事','',''],['当回事儿','',''],['当国','',''],['当地','',''],['当地人','',''],['当地居民','',''],['当地时间','',''],['当场','',''],['当场出丑','',''],['当场现丑','',''],['当声','',''],['当夜','',''],['当天','',''],['当天事当天毕','',''],['当央','',''],['当头','',''],['当头一棒','',''],['当头棒喝','',''],['当头炮','',''],['当夺','',''],['当好','',''],['当子','',''],['当季','',''],['当学徒','',''],['当官','',''],['当家','',''],['当家人','',''],['当家作主','',''],['当家子','',''],['当家理财','',''],['当家的','',''],['当局','',''],['当局者','',''],['当局者迷','',''],['当差','',''],['当年','',''],['当归','',''],['当当','',''],['当当车','',''],['当心','',''],['当成','',''],['当掉','',''],['当政','',''],['当政者','',''],['当断不断','',''],['当断则断','',''],['当断即断','',''],['当日','',''],['当时','',''],['当时的','',''],['当晚','',''],['当月','',''],['当机','',''],['当机立断','',''],['当权','',''],['当权派','',''],['当权者','',''],['当板','',''],['当查','',''],['当演员','',''],['当然','',''],['当然可以','',''],['当牛作马','',''],['当班','',''],['当真','',''],['当着','',''],['当票','',''],['当空','',''],['当紧','',''],['当红','',''],['当耳边风','',''],['当腰','',''],['当获','',''],['当著','',''],['当行出色','',''],['当街','',''],['当证明','',''],['当起了','',''],['当轴','',''],['当轴处中','',''],['当过','',''],['当选','',''],['当道','',''],['当量','',''],['当量剂量','',''],['当量浓度','',''],['当铺','',''],['当门对户','',''],['当间儿','',''],['当院儿','',''],['当面','',''],['当面鼓对面锣','',''],['当风秉烛','',''],['当驾','',''],['录下','',''],['录事','',''],['录作','',''],['录供','',''],['录像','',''],['录像带','',''],['录像机','',''],['录像片','',''],['录像盘','',''],['录像碟','',''],['录入','',''],['录共','',''],['录制','',''],['录取','',''],['录取线','',''],['录取通知书','',''],['录好','',''],['录影','',''],['录影唱片','',''],['录影带','',''],['录影机','',''],['录影碟','',''],['录打','',''],['录放','',''],['录用','',''],['录相','',''],['录相机','',''],['录象','',''],['录象带','',''],['录象机','',''],['录音','',''],['录音员','',''],['录音带','',''],['录音机','',''],['录音磁带','',''],['彖辞','',''],['彗星','',''],['彗汜画涂','',''],['彝伦','',''],['彝剧','',''],['彝器','',''],['彝宪','',''],['彝训','',''],['彝陵之战','',''],['形上','',''],['形丑心善','',''],['形义','',''],['形于色','',''],['形似','',''],['形体','',''],['形体化','',''],['形像','',''],['形像化','',''],['形制','',''],['形势','',''],['形势严峻','',''],['形势发展','',''],['形势教育','',''],['形势逼人','',''],['形单','',''],['形单影只','',''],['形变','',''],['形只影单','',''],['形同','',''],['形同虚设','',''],['形同陌路','',''],['形图','',''],['形墙','',''],['形声','',''],['形声字','',''],['形好','',''],['形如','',''],['形容','',''],['形容词','',''],['形容辞','',''],['形式','',''],['形式上','',''],['形式主义','',''],['形式化','',''],['形式多样','',''],['形式逻辑','',''],['形形色色','',''],['形影','',''],['形影不离','',''],['形影相依','',''],['形影相吊','',''],['形影相追','',''],['形影相随','',''],['形影相顾','',''],['形态','',''],['形态上','',''],['形态发生素','',''],['形态学','',''],['形态美','',''],['形态论','',''],['形意拳','',''],['形成','',''],['形成层','',''],['形成核','',''],['形旁','',''],['形核','',''],['形格势禁','',''],['形物','',''],['形状','',''],['形状好','',''],['形的','',''],['形相','',''],['形石','',''],['形码','',''],['形神','',''],['形秽','',''],['形而','',''],['形而上学','',''],['形而上学唯物主义','',''],['形胜','',''],['形虫','',''],['形象','',''],['形象化','',''],['形象大使','',''],['形象思维','',''],['形象清新','',''],['形貌','',''],['形质','',''],['形迹','',''],['形迹可疑','',''],['形销骨立','',''],['形音','',''],['形骸','',''],['彤云','',''],['彤彤','',''],['彤管贻','',''],['彩云','',''],['彩云易散','',''],['彩信','',''],['彩像','',''],['彩凤随鸦','',''],['彩券','',''],['彩印','',''],['彩卷','',''],['彩号','',''],['彩喷','',''],['彩塑','',''],['彩头','',''],['彩层','',''],['彩巾','',''],['彩带','',''],['彩弹','',''],['彩扩','',''],['彩排','',''],['彩旗','',''],['彩旦','',''],['彩显','',''],['彩条','',''],['彩棚','',''],['彩灯','',''],['彩照','',''],['彩珠','',''],['彩球','',''],['彩瓷','',''],['彩电','',''],['彩电视','',''],['彩画','',''],['彩礼','',''],['彩票','',''],['彩笔','',''],['彩管','',''],['彩纸','',''],['彩练','',''],['彩绘','',''],['彩绸','',''],['彩胜','',''],['彩色','',''],['彩色化','',''],['彩色影片','',''],['彩色照片','',''],['彩色片','',''],['彩色片儿','',''],['彩色电影','',''],['彩色电视','',''],['彩色电视机','',''],['彩色画','',''],['彩色监视器','',''],['彩色胶卷','',''],['彩虹','',''],['彩蚌','',''],['彩蛋','',''],['彩衣','',''],['彩袋','',''],['彩调','',''],['彩超','',''],['彩车','',''],['彩轿','',''],['彩釉','',''],['彩金','',''],['彩铃','',''],['彩陶','',''],['彩陶文化','',''],['彩霞','',''],['彪个子','',''],['彪休','',''],['彪壮','',''],['彪子','',''],['彪形','',''],['彪形大汉','',''],['彪悍','',''],['彪柄','',''],['彪炳','',''],['彪炳千古','',''],['彪焕','',''],['彪蒙','',''],['彪马','',''],['彬彬','',''],['彬彬君子','',''],['彬彬文质','',''],['彬彬有礼','',''],['彬蔚','',''],['彬马那','',''],['彭亨','',''],['彭佳屿','',''],['彭养鸥','',''],['彭勃','',''],['彭博通讯社','',''],['彭县','',''],['彭定康','',''],['彭德怀','',''],['彭水县','',''],['彭湖','',''],['彭湖岛','',''],['彭真','',''],['彭祖','',''],['彰善瘅恶','',''],['彰彰','',''],['彰往察来','',''],['彰往考来','',''],['彰明','',''],['彰明较著','',''],['彰显','',''],['影业','',''],['影人','',''],['影像','',''],['影像会议','',''],['影像处理','',''],['影像档','',''],['影儿','',''],['影剂','',''],['影剧','',''],['影剧院','',''],['影印','',''],['影印件','',''],['影印本','',''],['影印机','',''],['影响','',''],['影响力','',''],['影响很大','',''],['影圈','',''],['影坛','',''],['影城','',''],['影壁','',''],['影子','',''],['影子内阁','',''],['影射','',''],['影射小说','',''],['影展','',''],['影影绰绰','',''],['影戏','',''],['影星','',''],['影格儿','',''],['影液','',''],['影片','',''],['影片儿','',''],['影碟','',''],['影碟机','',''],['影线','',''],['影视','',''],['影视圈','',''],['影评','',''],['影调','',''],['影调剧','',''],['影象','',''],['影踪','',''],['影迷','',''],['影院','',''],['影集','',''],['影音','',''],['彳亍','',''],['彷似','',''],['彷佛','',''],['彷徉','',''],['彷徨','',''],['役使','',''],['役使动物','',''],['役制','',''],['役卒','',''],['役法','',''],['役畜','',''],['役长','',''],['役龄','',''],['彻上彻下','',''],['彻夜','',''],['彻夜不眠','',''],['彻夜未眠','',''],['彻头彻尾','',''],['彻尾','',''],['彻底','',''],['彻底失败','',''],['彻底改变','',''],['彻底清除','',''],['彻底澄清','',''],['彻底粉碎','',''],['彻底解决','',''],['彻悟','',''],['彻查','',''],['彻西','',''],['彻首彻尾','',''],['彻骨','',''],['彼一时此一时','',''],['彼人','',''],['彼伏','',''],['彼众我寡','',''],['彼侧','',''],['彼倡此和','',''],['彼唱此和','',''],['彼处','',''],['彼尔姆','',''],['彼岸','',''],['彼岸性','',''],['彼弃我取','',''],['彼得','',''],['彼得前书','',''],['彼得后书','',''],['彼得堡','',''],['彼得格勒','',''],['彼得罗维奇','',''],['彼得里皿','',''],['彼拉多','',''],['彼时','',''],['彼此','',''],['彼此之间','',''],['彼此协作','',''],['彼此彼此','',''],['彼特','',''],['彼竭无盈','',''],['彼等','',''],['彼辈','',''],['往上','',''],['往上爬','',''],['往上调','',''],['往下','',''],['往下看','',''],['往不','',''],['往世','',''],['往东','',''],['往东南','',''],['往之','',''],['往事','',''],['往事如风','',''],['往例','',''],['往其所以','',''],['往内','',''],['往前','',''],['往北','',''],['往南','',''],['往古','',''],['往右','',''],['往后','',''],['往后面','',''],['往回','',''],['往复','',''],['往复运动','',''],['往外','',''],['往外看','',''],['往家','',''],['往届','',''],['往岁','',''],['往左','',''],['往常','',''],['往年','',''],['往往','',''],['往往有之','',''],['往情','',''],['往日','',''],['往时','',''],['往昔','',''],['往来','',''],['往来帐户','',''],['往楼上','',''],['往泥里踩','',''],['往生','',''],['往直','',''],['往程','',''],['往脸上抹黑','',''],['往西','',''],['往西南','',''],['往访','',''],['往返','',''],['往返运输','',''],['往还','',''],['往迹','',''],['往那','',''],['往那里','',''],['往里','',''],['往里走','',''],['征人','',''],['征伐','',''],['征传','',''],['征信社','',''],['征候','',''],['征候学','',''],['征借','',''],['征兆','',''],['征免','',''],['征兵','',''],['征兵制','',''],['征到','',''],['征剿','',''],['征募','',''],['征友','',''],['征发','',''],['征召','',''],['征召令','',''],['征召员','',''],['征名责实','',''],['征地','',''],['征士','',''],['征夫','',''],['征婚','',''],['征实','',''],['征尘','',''],['征帆','',''],['征引','',''],['征彸','',''],['征得','',''],['征戍','',''],['征战','',''],['征收','',''],['征敛','',''],['征敛无度','',''],['征文','',''],['征旆','',''],['征服','',''],['征服者','',''],['征期','',''],['征求','',''],['征求意见','',''],['征派','',''],['征状','',''],['征用','',''],['征程','',''],['征税','',''],['征稿','',''],['征粮','',''],['征纳','',''],['征缴','',''],['征聘','',''],['征自','',''],['征衣','',''],['征衫','',''],['征解','',''],['征订','',''],['征讨','',''],['征询','',''],['征调','',''],['征象','',''],['征购','',''],['征购粮','',''],['征足','',''],['征逐','',''],['征途','',''],['征集','',''],['征风召雨','',''],['征马','',''],['征驾','',''],['径向','',''],['径庭','',''],['径情直遂','',''],['径流','',''],['径直','',''],['径自','',''],['径赛','',''],['径路','',''],['径迹','',''],['径道','',''],['径间','',''],['待业','',''],['待业保险','',''],['待业青年','',''],['待之如友','',''],['待产','',''],['待人','',''],['待人刻薄','',''],['待人处事','',''],['待人接物','',''],['待价而沽','',''],['待价藏珠','',''],['待优','',''],['待会','',''],['待会儿','',''],['待修','',''],['待冲','',''],['待决','',''],['待到','',''],['待制','',''],['待办','',''],['待印','',''],['待发','',''],['待发箱','',''],['待员','',''],['待命','',''],['待命状态','',''],['待哺','',''],['待售','',''],['待在','',''],['待复','',''],['待字','',''],['待定','',''],['待审','',''],['待客','',''],['待宵草','',''],['待工','',''],['待己','',''],['待征','',''],['待扣','',''],['待批','',''],['待承','',''],['待挑','',''],['待摊','',''],['待收','',''],['待放','',''],['待时守分','',''],['待时而举','',''],['待时而动','',''],['待月西厢','',''],['待机','',''],['待机而动','',''],['待查','',''],['待毙','',''],['待物','',''],['待用','',''],['待续','',''],['待缴','',''],['待考','',''],['待聘','',''],['待补','',''],['待要','',''],['待解','',''],['待证','',''],['待说','',''],['待退','',''],['待送','',''],['待遇','',''],['待遇好','',''],['待销','',''],['待雇','',''],['待领','',''],['徇公忘己','',''],['徇公灭私','',''],['徇国亡家','',''],['徇国忘身','',''],['徇情','',''],['徇情枉法','',''],['徇私','',''],['徇私作弊','',''],['徇私废公','',''],['徇私枉法','',''],['徇私舞弊','',''],['很上','',''],['很下','',''],['很严','',''],['很为','',''],['很久','',''],['很会','',''],['很低','',''],['很值得','',''],['很像','',''],['很内向','',''],['很冷','',''],['很凉','',''],['很卫生','',''],['很厚','',''],['很受','',''],['很可','',''],['很可怕','',''],['很可能','',''],['很响','',''],['很坏','',''],['很复杂','',''],['很外向','',''],['很多','',''],['很多人','',''],['很多时','',''],['很大','',''],['很好','',''],['很容易','',''],['很对','',''],['很小','',''],['很少','',''],['很少数','',''],['很差','',''],['很帅','',''],['很广','',''],['很强','',''],['很忙','',''],['很快','',''],['很想','',''],['很感','',''],['很感兴趣','',''],['很慢','',''],['很懊悔','',''],['很挑剔','',''],['很早','',''],['很是','',''],['很晚','',''],['很暗','',''],['很有','',''],['很有可能','',''],['很有希望','',''],['很有必要','',''],['很有成效','',''],['很有见地','',''],['很横','',''],['很沉','',''],['很浅','',''],['很深','',''],['很滑','',''],['很热','',''],['很甜','',''],['很痛快','',''],['很短','',''],['很破','',''],['很穷','',''],['很窄','',''],['很糟','',''],['很紧','',''],['很累','',''],['很美','',''],['很老','',''],['很能','',''],['很脆','',''],['很脏','',''],['很苦','',''],['很薄','',''],['很规矩','',''],['很轻','',''],['很近','',''],['很远','',''],['很迟','',''],['很重','',''],['很重要','',''],['很野','',''],['很长','',''],['很闷','',''],['很难','',''],['很难说','',''],['很静','',''],['很非常','',''],['很顺从','',''],['很饱','',''],['很香','',''],['很高','',''],['很高兴','',''],['徉言','',''],['律令','',''],['律动','',''],['律吕','',''],['律己','',''],['律师','',''],['律师事务所','',''],['律师制度','',''],['律性','',''],['律政司','',''],['律条','',''],['律法','',''],['律的','',''],['律论','',''],['律诗','',''],['徐世昌','',''],['徐俊','',''],['徐光启','',''],['徐克','',''],['徐匡迪','',''],['徐图','',''],['徐娘半老','',''],['徐家汇','',''],['徐州地区','',''],['徐徐','',''],['徐志摩','',''],['徐悲鸿','',''],['徐星','',''],['徐步','',''],['徐汇','',''],['徐渭','',''],['徐熙媛','',''],['徐祯卿','',''],['徐福','',''],['徐继畲','',''],['徐缓','',''],['徐行','',''],['徐铉','',''],['徐风','',''],['徒书','',''],['徒乱人意','',''],['徒传','',''],['徒作','',''],['徒具','',''],['徒刑','',''],['徒劳','',''],['徒劳无功','',''],['徒劳无益','',''],['徒呼负负','',''],['徒增','',''],['徒子徒孙','',''],['徒孙','',''],['徒宅忘妻','',''],['徒工','',''],['徒废唇舌','',''],['徒弟','',''],['徒录','',''],['徒手','',''],['徒手搏击','',''],['徒手格斗','',''],['徒手画','',''],['徒手空拳','',''],['徒托空言','',''],['徒拥虚名','',''],['徒有','',''],['徒有其名','',''],['徒有虚名','',''],['徒步','',''],['徒步旅行','',''],['徒步浮桥','',''],['徒然','',''],['徒生','',''],['徒耗','',''],['徒自惊扰','',''],['徒裼','',''],['徒费唇舌','',''],['徒费无益','',''],['徒长','',''],['徒陈空文','',''],['得一忘十','',''],['得上','',''],['得不','',''],['得不偿失','',''],['得不到','',''],['得不补失','',''],['得不赏失','',''],['得不酬失','',''],['得中','',''],['得主','',''],['得人儿','',''],['得人心','',''],['得人死力','',''],['得人者昌','',''],['得人者昌失人者亡','',''],['得体','',''],['得克萨斯','',''],['得克萨斯州','',''],['得其三昧','',''],['得其所哉','',''],['得准','',''],['得出','',''],['得分','',''],['得利','',''],['得到','',''],['得力','',''],['得劲','',''],['得势','',''],['得去','',''],['得及','',''],['得名','',''],['得啦','',''],['得大于失','',''],['得天独厚','',''],['得失','',''],['得失在人','',''],['得失成败','',''],['得失相半','',''],['得失荣枯','',''],['得奖','',''],['得奖人','',''],['得奖者','',''],['得宜','',''],['得宠','',''],['得寸入尺','',''],['得寸思尺','',''],['得寸进尺','',''],['得对','',''],['得尔塔','',''],['得尺得寸','',''],['得当','',''],['得心应手','',''],['得志','',''],['得意','',''],['得意之极','',''],['得意忘形','',''],['得意忘言','',''],['得意忘象','',''],['得意扬扬','',''],['得意洋洋','',''],['得意门生','',''],['得意非凡','',''],['得手','',''],['得手应心','',''],['得救','',''],['得文','',''],['得新忘旧','',''],['得时','',''],['得未尝有','',''],['得未曾有','',''],['得来','',''],['得来全不费工夫','',''],['得步进步','',''],['得济','',''],['得理让人','',''],['得用','',''],['得病','',''],['得益','',''],['得着','',''],['得知','',''],['得票','',''],['得票率','',''],['得罪','',''],['得罪人','',''],['得而复失','',''],['得聋望蜀','',''],['得胜','',''],['得胜回朝','',''],['得胜头回','',''],['得说','',''],['得起','',''],['得过且过','',''],['得逞','',''],['得道','',''],['得道多助','',''],['得陇望蜀','',''],['得饶人处且饶人','',''],['得鱼忘筌','',''],['徘徊','',''],['徙倚','',''],['徙居','',''],['徙步','',''],['徜徉','',''],['御下蔽上','',''],['御书','',''],['御侮','',''],['御冬','',''],['御制','',''],['御前','',''],['御医','',''],['御史','',''],['御史大夫','',''],['御地','',''],['御夫座','',''],['御宅族','',''],['御寒','',''],['御座','',''],['御弟','',''],['御性','',''],['御戎','',''],['御手','',''],['御敌','',''],['御旨','',''],['御林','',''],['御林军','',''],['御沟流叶','',''],['御沟红叶','',''],['御用','',''],['御用大律师','',''],['御膳','',''],['御膳房','',''],['御花园','',''],['御诏','',''],['御赐','',''],['御轿','',''],['御酒','',''],['御风','',''],['御驾','',''],['御驾亲征','',''],['徨徨','',''],['循例','',''],['循化','',''],['循化县','',''],['循名校实','',''],['循名督实','',''],['循名考实','',''],['循名课实','',''],['循名责实','',''],['循声附会','',''],['循常席故','',''],['循序','',''],['循序渐进','',''],['循序见进','',''],['循循','',''],['循循善诱','',''],['循循诱人','',''],['循次而进','',''],['循沿','',''],['循环','',''],['循环使用','',''],['循环制','',''],['循环反复','',''],['循环器','',''],['循环小数','',''],['循环往复','',''],['循环性','',''],['循环系统','',''],['循环节','',''],['循环论','',''],['循环论证','',''],['循环赛','',''],['循球赛','',''],['循着','',''],['循规矩蹈','',''],['循规蹈矩','',''],['循路','',''],['徭役','',''],['徭役地租','',''],['微不足录','',''],['微不足道','',''],['微丝','',''],['微丝血管','',''],['微中子','',''],['微乎其微','',''],['微亨利','',''],['微伏','',''],['微光','',''],['微光夜视仪','',''],['微光技术','',''],['微光电视','',''],['微光瞄准具','',''],['微光观察仪','',''],['微克','',''],['微冷','',''],['微减','',''],['微凹','',''],['微分','',''],['微分几何','',''],['微分几何学','',''],['微分学','',''],['微分方程','',''],['微分电路','',''],['微创手术','',''],['微利','',''],['微动','',''],['微动脉','',''],['微化石','',''],['微升','',''],['微博客','',''],['微压','',''],['微压计','',''],['微商','',''],['微囊','',''],['微型','',''],['微型化','',''],['微型封装块','',''],['微型机','',''],['微型电脑','',''],['微型计算机','',''],['微处','',''],['微处理器','',''],['微处理机','',''],['微妙','',''],['微子','',''],['微孔','',''],['微孔膜','',''],['微安','',''],['微安培','',''],['微宏','',''],['微导管','',''],['微小','',''],['微小病毒科','',''],['微少','',''],['微尘','',''],['微尘学','',''],['微居里','',''],['微差','',''],['微带','',''],['微开','',''],['微弱','',''],['微径','',''],['微循环','',''],['微微','',''],['微微米','',''],['微怒','',''],['微扰','',''],['微扰展开','',''],['微扰论','',''],['微控','',''],['微故细过','',''],['微文深诋','',''],['微旨','',''],['微明','',''],['微星','',''],['微晶','',''],['微晶片','',''],['微晶质','',''],['微暗','',''],['微服','',''],['微服私行','',''],['微服私访','',''],['微末','',''],['微机','',''],['微机化','',''],['微气','',''],['微气象','',''],['微法拉','',''],['微泡胶片','',''],['微波','',''],['微波天线','',''],['微波技术','',''],['微波炉','',''],['微波电子管','',''],['微温','',''],['微溶','',''],['微漠','',''],['微火','',''],['微热','',''],['微现','',''],['微生','',''],['微生物','',''],['微生物学','',''],['微生物学家','',''],['微电子','',''],['微电子学','',''],['微电子技术','',''],['微电机','',''],['微电脑','',''],['微白','',''],['微秒','',''],['微积','',''],['微积分','',''],['微积分基本定理','',''],['微积分学','',''],['微程序','',''],['微笑','',''],['微笑服务','',''],['微管','',''],['微管蛋白','',''],['微米','',''],['微粉化','',''],['微粒','',''],['微粒体','',''],['微粒子','',''],['微红','',''],['微细','',''],['微细丝','',''],['微细加工','',''],['微结构','',''],['微缩','',''],['微缩卡','',''],['微缩点','',''],['微缩胶卷','',''],['微聚焦','',''],['微胶囊技术','',''],['微臣','',''],['微茫','',''],['微菌','',''],['微薄','',''],['微血管','',''],['微行','',''],['微观','',''],['微观世界','',''],['微观粒子','',''],['微观经济','',''],['微言','',''],['微言大义','',''],['微言大指','',''],['微言精义','',''],['微计','',''],['微词','',''],['微调','',''],['微贱','',''],['微软件','',''],['微软公司','',''],['微辞','',''],['微辣','',''],['微进','',''],['微进化','',''],['微速摄影','',''],['微醉','',''],['微醺','',''],['微量','',''],['微量元素','',''],['微量白蛋白','',''],['微雕','',''],['微雨','',''],['微震','',''],['微震计','',''],['微静脉','',''],['微音','',''],['微音器','',''],['微风','',''],['微黄','',''],['微黄色','',''],['微黑','',''],['徯径','',''],['徵兵','',''],['徵召','',''],['徵名责实','',''],['徵收','',''],['德乌帕','',''],['德人','',''],['德仁','',''],['德以报怨','',''],['德伦特','',''],['德克萨斯','',''],['德克萨斯州','',''],['德军','',''],['德勒兹','',''],['德勒巴克','',''],['德厚流光','',''],['德古拉','',''],['德国一九一八年革命','',''],['德国一八四八年革命','',''],['德国之声','',''],['德国人','',''],['德国农民战争','',''],['德国化','',''],['德国古典哲学','',''],['德国学术交流总署','',''],['德国战车','',''],['德国汉莎航空公司','',''],['德国统一社会党','',''],['德国酸菜','',''],['德国马克','',''],['德国麻疹','',''],['德城','',''],['德奥同盟','',''],['德宏','',''],['德宏州','',''],['德容兼备','',''],['德尊望重','',''],['德川','',''],['德州仪器','',''],['德州地区','',''],['德州战役','',''],['德布勒森','',''],['德干','',''],['德式','',''],['德彪西','',''],['德律风','',''],['德性','',''],['德惠地区','',''],['德意志学术交流中心','',''],['德意志民主共和国','',''],['德意志联邦共和国','',''],['德意志银行','',''],['德才','',''],['德才兼备','',''],['德拉克罗瓦','',''],['德拉门','',''],['德政','',''],['德政碑','',''],['德文','',''],['德新社','',''],['德昂','',''],['德智体','',''],['德智体美','',''],['德望','',''],['德沃夏克','',''],['德治','',''],['德法年鉴','',''],['德派','',''],['德浅行薄','',''],['德班','',''],['德累斯顿','',''],['德维尔潘','',''],['德育','',''],['德胜门','',''],['德航','',''],['德薄才疏','',''],['德薄能鲜','',''],['德行','',''],['德言功貌','',''],['德言容功','',''],['德语','',''],['德贵丽类','',''],['德都','',''],['德都县','',''],['德里','',''],['德里达','',''],['德隆望尊','',''],['德隆望重','',''],['德雷尔','',''],['德雷斯顿','',''],['德雷福斯','',''],['德雷福斯案件','',''],['德音莫违','',''],['德高望重','',''],['德黑兰','',''],['德黑兰会议','',''],['徼幸','',''],['徽剧','',''],['徽号','',''],['徽墨','',''],['徽州','',''],['徽帜','',''],['徽标','',''],['徽牌','',''],['徽章','',''],['徽菜','',''],['徽记','',''],['徽语','',''],['徽调','',''],['心上','',''],['心上人','',''],['心下','',''],['心不','',''],['心不在焉','',''],['心不应口','',''],['心中','',''],['心中无数','',''],['心中有数','',''],['心中有鬼','',''],['心乡往之','',''],['心书','',''],['心乱','',''],['心乱如麻','',''],['心事','',''],['心些','',''],['心仪','',''],['心传','',''],['心似','',''],['心低','',''],['心余力绌','',''],['心儿','',''],['心内','',''],['心内膜','',''],['心凉','',''],['心切','',''],['心到','',''],['心力','',''],['心力交瘁','',''],['心力衰竭','',''],['心动','',''],['心动图','',''],['心动神驰','',''],['心劲','',''],['心劳意攘','',''],['心劳意穰','',''],['心劳日拙','',''],['心包','',''],['心包炎','',''],['心口','',''],['心口不一','',''],['心口如一','',''],['心同','',''],['心向','',''],['心和气平','',''],['心喜','',''],['心回意转','',''],['心土','',''],['心在魏阙','',''],['心地','',''],['心地善良','',''],['心坎','',''],['心坚石穿','',''],['心境','',''],['心声','',''],['心外膜','',''],['心头','',''],['心头病','',''],['心头肉','',''],['心契','',''],['心如刀割','',''],['心如刀搅','',''],['心如刀锉','',''],['心如刀锯','',''],['心如古井','',''],['心如坚石','',''],['心如寒灰','',''],['心如木石','',''],['心如止水','',''],['心如死灰','',''],['心如金石','',''],['心如铁石','',''],['心子','',''],['心孔','',''],['心存不满','',''],['心存怀疑','',''],['心学','',''],['心安','',''],['心安理得','',''],['心安神泰','',''],['心安神闲','',''],['心实','',''],['心室','',''],['心宽','',''],['心宽体肥','',''],['心宽体胖','',''],['心宿二','',''],['心寒','',''],['心寒胆战','',''],['心寒胆碎','',''],['心寒胆落','',''],['心尖','',''],['心平气和','',''],['心平气定','',''],['心广体胖','',''],['心底','',''],['心开目明','',''],['心弦','',''],['心形','',''],['心形线','',''],['心影儿','',''],['心往神驰','',''],['心律','',''],['心得','',''],['心得体会','',''],['心得安','',''],['心心','',''],['心心念念','',''],['心心相印','',''],['心志','',''],['心忙意急','',''],['心怀','',''],['心怀不轨','',''],['心怀叵测','',''],['心怀鬼胎','',''],['心态','',''],['心思','',''],['心怡神旷','',''],['心急','',''],['心急吃不了热豆腐','',''],['心急如火','',''],['心急如焚','',''],['心急火燎','',''],['心怦怦跳','',''],['心性','',''],['心悦神怡','',''],['心悦诚服','',''],['心悸','',''],['心情','',''],['心情坏','',''],['心情愉快','',''],['心情舒畅','',''],['心惊','',''],['心惊肉战','',''],['心惊肉跳','',''],['心惊胆寒','',''],['心惊胆怕','',''],['心惊胆慑','',''],['心惊胆战','',''],['心惊胆落','',''],['心惊胆跳','',''],['心惊胆颤','',''],['心想','',''],['心想事成','',''],['心意','',''],['心愿','',''],['心愿单','',''],['心慈','',''],['心慈手软','',''],['心慈面软','',''],['心慌','',''],['心慌意乱','',''],['心慕手追','',''],['心慕笔追','',''],['心慵意懒','',''],['心战','',''],['心房','',''],['心房颤动','',''],['心扉','',''],['心手相应','',''],['心折','',''],['心折首肯','',''],['心拙口夯','',''],['心拙口笨','',''],['心掏','',''],['心搏','',''],['心数','',''],['心旌摇曳','',''],['心无二想','',''],['心无二用','',''],['心旷神怡','',''],['心旷神愉','',''],['心明眼亮','',''],['心智','',''],['心曲','',''],['心有','',''],['心有余','',''],['心有余悸','',''],['心有余而力不足','',''],['心有灵犀一点通','',''],['心服','',''],['心服口服','',''],['心服情愿','',''],['心术','',''],['心术不正','',''],['心机','',''],['心材','',''],['心来','',''],['心梗','',''],['心正','',''],['心殒胆破','',''],['心殒胆落','',''],['心毒','',''],['心毒手辣','',''],['心气','',''],['心活','',''],['心浮','',''],['心满','',''],['心满意足','',''],['心满愿足','',''],['心潮','',''],['心潮澎湃','',''],['心潮起伏','',''],['心火','',''],['心灰','',''],['心灰意冷','',''],['心灰意懒','',''],['心灰意败','',''],['心灵','',''],['心灵上','',''],['心灵感应','',''],['心灵手巧','',''],['心灵深处','',''],['心烦','',''],['心烦意乱','',''],['心烦意冗','',''],['心烦虑乱','',''],['心焉如割','',''],['心焦','',''],['心焦如火','',''],['心焦如焚','',''],['心照','',''],['心照不宣','',''],['心照神交','',''],['心爱','',''],['心狠','',''],['心狠手辣','',''],['心猿意马','',''],['心率','',''],['心理','',''],['心理上','',''],['心理作用','',''],['心理剧','',''],['心理学','',''],['心理学家','',''],['心理战','',''],['心理疗法','',''],['心理素质','',''],['心理诊所','',''],['心理词典','',''],['心理防线','',''],['心甘','',''],['心甘情愿','',''],['心田','',''],['心电图','',''],['心疑','',''],['心疼','',''],['心病','',''],['心痒','',''],['心痒难挠','',''],['心痒难揉','',''],['心痛','',''],['心皮','',''],['心盛','',''],['心目','',''],['心目中','',''],['心直','',''],['心直口快','',''],['心直嘴快','',''],['心眼','',''],['心眼儿','',''],['心眼坏','',''],['心眼多','',''],['心眼大','',''],['心眼好','',''],['心眼小','',''],['心瞻魏阙','',''],['心知','',''],['心知肚明','',''],['心砰砰跳','',''],['心硬','',''],['心碎','',''],['心神','',''],['心神不宁','',''],['心神不安','',''],['心神不定','',''],['心神恍惚','',''],['心秀','',''],['心窄','',''],['心窍','',''],['心窗','',''],['心窝','',''],['心窝儿','',''],['心算','',''],['心粗气浮','',''],['心粗胆壮','',''],['心粗胆大','',''],['心细','',''],['心细如发','',''],['心经','',''],['心结','',''],['心绞痛','',''],['心绪','',''],['心绪不宁','',''],['心绪如麻','',''],['心绪恍惚','',''],['心羡','',''],['心肌','',''],['心肌梗塞','',''],['心肌梗死','',''],['心肌炎','',''],['心肝','',''],['心肠','',''],['心肠好','',''],['心肠硬','',''],['心肠软','',''],['心肠黑','',''],['心肺复苏术','',''],['心胆','',''],['心胆俱碎','',''],['心胆俱裂','',''],['心胸','',''],['心胸开阔','',''],['心胸狭窄','',''],['心胸狭隘','',''],['心脏','',''],['心脏学','',''],['心脏形','',''],['心脏搭桥手术','',''],['心脏收缩压','',''],['心脏疾患','',''],['心脏病','',''],['心脏移殖','',''],['心脏舒张压','',''],['心腹','',''],['心腹之交','',''],['心腹之忧','',''],['心腹之患','',''],['心腹之疾','',''],['心腹大患','',''],['心腹话','',''],['心腹重患','',''],['心膂爪牙','',''],['心膂股肱','',''],['心花','',''],['心花怒发','',''],['心花怒开','',''],['心花怒放','',''],['心若死灰','',''],['心荡神怡','',''],['心荡神摇','',''],['心荡神迷','',''],['心荡神驰','',''],['心虔志诚','',''],['心虚','',''],['心融神会','',''],['心血','',''],['心血来潮','',''],['心血管','',''],['心血管疾病','',''],['心裁','',''],['心计','',''],['心许','',''],['心诚','',''],['心话','',''],['心谤腹非','',''],['心贯白日','',''],['心贴心','',''],['心路','',''],['心跳','',''],['心身','',''],['心轮','',''],['心软','',''],['心轴','',''],['心连心','',''],['心迹','',''],['心途','',''],['心都','',''],['心酸','',''],['心醉','',''],['心醉神迷','',''],['心里','',''],['心里有数','',''],['心里有谱','',''],['心里痒痒','',''],['心里美萝卜','',''],['心里话','',''],['心重','',''],['心长发短','',''],['心闲手敏','',''],['心间','',''],['心静','',''],['心静自然凉','',''],['心面','',''],['心音','',''],['心领','',''],['心领神会','',''],['心领神悟','',''],['心驰神往','',''],['心驰魏阙','',''],['心高气傲','',''],['心高气硬','',''],['心魄','',''],['心黑','',''],['必不','',''],['必不可免','',''],['必不可少','',''],['必不可少组成','',''],['必不可缺','',''],['必不得已','',''],['必也正名','',''],['必争','',''],['必争之地','',''],['必会','',''],['必保','',''],['必修','',''],['必修课','',''],['必先利其器','',''],['必到','',''],['必和必拓','',''],['必备','',''],['必失','',''],['必学','',''],['必定','',''],['必将','',''],['必应','',''],['必得','',''],['必恭必敬','',''],['必改','',''],['必是','',''],['必有','',''],['必有一伤','',''],['必有一失','',''],['必有其徒','',''],['必有我师','',''],['必死','',''],['必死之症','',''],['必然','',''],['必然之事','',''],['必然会','',''],['必然伴有','',''],['必然判断','',''],['必然性','',''],['必然王国','',''],['必然结果','',''],['必然规律','',''],['必然论','',''],['必然趋势','',''],['必由','',''],['必由之路','',''],['必究','',''],['必经','',''],['必经之地','',''],['必经之路','',''],['必经阶段','',''],['必罚','',''],['必胜','',''],['必胜客','',''],['必能','',''],['必行','',''],['必衰','',''],['必被','',''],['必要','',''],['必要产品','',''],['必要劳动','',''],['必要性','',''],['必要措施','',''],['必要条件','',''],['必败','',''],['必需','',''],['必需品','',''],['必须','',''],['必须做','',''],['必须品','',''],['必须的','',''],['必做','',''],['必封','',''],['必挂','',''],['必杀','',''],['忆及','',''],['忆旧','',''],['忆法','',''],['忆苦思甜','',''],['忆苦饭','',''],['忆起','',''],['忆述','',''],['忉怛','',''],['忌克','',''],['忌刻','',''],['忌医','',''],['忌口','',''],['忌嘴','',''],['忌妒','',''],['忌恨','',''],['忌惮','',''],['忌日','',''],['忌讳','',''],['忌语','',''],['忌辰','',''],['忌酒','',''],['忌食','',''],['忍下','',''],['忍不住','',''],['忍从','',''],['忍住','',''],['忍俊','',''],['忍俊不禁','',''],['忍冬','',''],['忍受','',''],['忍垢偷生','',''],['忍得住','',''],['忍心','',''],['忍心害理','',''],['忍性','',''],['忍无可忍','',''],['忍气','',''],['忍气吞声','',''],['忍痛','',''],['忍痛割爱','',''],['忍着','',''],['忍笑','',''],['忍者','',''],['忍耐','',''],['忍耐力','',''],['忍耻','',''],['忍耻偷生','',''],['忍耻含垢','',''],['忍耻含羞','',''],['忍让','',''],['忍辱','',''],['忍辱偷生','',''],['忍辱含垢','',''],['忍辱含羞','',''],['忍辱求全','',''],['忍辱负重','',''],['忍饥受渴','',''],['忍饥受饿','',''],['忍饥挨饿','',''],['忏悔','',''],['忏悔式','',''],['忐忑','',''],['忐忑不安','',''],['忐忑不定','',''],['忒儿','',''],['忖度','',''],['忖思','',''],['忖量','',''],['志不在此','',''],['志于','',''],['志冲斗牛','',''],['志同道合','',''],['志向','',''],['志哀','',''],['志喜','',''],['志在','',''],['志在千里','',''],['志在四方','',''],['志在沛公','',''],['志坚胆壮','',''],['志士','',''],['志士仁人','',''],['志大才疏','',''],['志大才短','',''],['志工','',''],['志广才疏','',''],['志得意满','',''],['志愿','',''],['志愿书','',''],['志愿人员','',''],['志愿兵','',''],['志愿兵制','',''],['志愿军','',''],['志愿活动','',''],['志愿者','',''],['志气','',''],['志气凌云','',''],['志满气得','',''],['志留系','',''],['志留纪','',''],['志薄','',''],['志诚君子','',''],['志趣','',''],['志足意满','',''],['志骄意满','',''],['志高气扬','',''],['忘不','',''],['忘不了','',''],['忘乎所以','',''],['忘了','',''],['忘事','',''],['忘八旦','',''],['忘八蛋','',''],['忘其所以','',''],['忘却','',''],['忘啦','',''],['忘寝废食','',''],['忘带','',''],['忘年','',''],['忘年之交','',''],['忘年之契','',''],['忘年之好','',''],['忘年交','',''],['忘形','',''],['忘形之交','',''],['忘形之契','',''],['忘忧','',''],['忘忧草','',''],['忘怀','',''],['忘性','',''],['忘恩','',''],['忘恩失义','',''],['忘恩背义','',''],['忘恩负义','',''],['忘情','',''],['忘我','',''],['忘我劳动','',''],['忘我工作','',''],['忘我精神','',''],['忘战必危','',''],['忘战者危','',''],['忘掉','',''],['忘旧','',''],['忘本','',''],['忘生舍死','',''],['忘神','',''],['忘私','',''],['忘记','',''],['忘记了','',''],['忘记密码','',''],['忘象得意','',''],['忘返','',''],['忘餐','',''],['忘餐失寝','',''],['忘餐废寝','',''],['忙不过来','',''],['忙不迭','',''],['忙个不停','',''],['忙中','',''],['忙中有失','',''],['忙中有错','',''],['忙中添乱','',''],['忙乎','',''],['忙乱','',''],['忙于','',''],['忙人','',''],['忙动','',''],['忙将','',''],['忙得','',''],['忙得不亦乐乎','',''],['忙得不可开交','',''],['忙忙','',''],['忙忙碌碌','',''],['忙於','',''],['忙活','',''],['忙的','',''],['忙着','',''],['忙碌','',''],['忙碌著','',''],['忙者','',''],['忙著','',''],['忙说','',''],['忙进忙出','',''],['忙里偷闲','',''],['忙问','',''],['忠义','',''],['忠于','',''],['忠于祖国','',''],['忠于职守','',''],['忠仆','',''],['忠信','',''],['忠勇','',''],['忠南大学校','',''],['忠厚','',''],['忠君报国','',''],['忠君爱国','',''],['忠告','',''],['忠告者','',''],['忠孝','',''],['忠孝两全','',''],['忠孝节义','',''],['忠孝节烈','',''],['忠实','',''],['忠实于','',''],['忠心','',''],['忠心耿耿','',''],['忠心贯日','',''],['忠心赤胆','',''],['忠清','',''],['忠清北道','',''],['忠清南道','',''],['忠清道','',''],['忠烈','',''],['忠肝义胆','',''],['忠臣','',''],['忠臣不事二主','',''],['忠臣双全','',''],['忠臣烈士','',''],['忠良','',''],['忠言','',''],['忠言嘉谟','',''],['忠言奇谋','',''],['忠言谠论','',''],['忠言逆耳','',''],['忠诚','',''],['忠诚人','',''],['忠诚老实','',''],['忠贞','',''],['忠贞不渝','',''],['忠贯白日','',''],['忠顺','',''],['忡忡','',''],['忤逆','',''],['忤逆不孝','',''],['忧伤','',''],['忧公如家','',''],['忧公忘私','',''],['忧公无私','',''],['忧国','',''],['忧国哀民','',''],['忧国如家','',''],['忧国忘家','',''],['忧国忘私','',''],['忧国忘身','',''],['忧国忧民','',''],['忧国恤民','',''],['忧国爱民','',''],['忧形于色','',''],['忧心','',''],['忧心如捣','',''],['忧心如焚','',''],['忧心如酲','',''],['忧心如醉','',''],['忧心忡忡','',''],['忧心悄悄','',''],['忧心若醉','',''],['忧思','',''],['忧悒','',''],['忧患','',''],['忧惧','',''],['忧愁','',''],['忧愤','',''],['忧戚','',''],['忧抑','',''],['忧民','',''],['忧民忧国','',''],['忧沉','',''],['忧深思远','',''],['忧灼','',''],['忧烦','',''],['忧能伤人','',''],['忧色','',''],['忧苦','',''],['忧苦以终','',''],['忧虑','',''],['忧郁','',''],['忧郁不乐','',''],['忧郁症','',''],['忧闷','',''],['快中子','',''],['快乐','',''],['快乐岛','',''],['快乐幸福','',''],['快乐论','',''],['快书','',''],['快了','',''],['快事','',''],['快于','',''],['快些','',''],['快人','',''],['快人快事','',''],['快人快语','',''],['快件','',''],['快信','',''],['快刀','',''],['快刀斩乱麻','',''],['快刀断乱麻','',''],['快别','',''],['快到','',''],['快取','',''],['快叫','',''],['快可立','',''],['快吃','',''],['快嘴','',''],['快好','',''],['快婿','',''],['快干','',''],['快当','',''],['快得多','',''],['快快','',''],['快快乐乐','',''],['快意','',''],['快感','',''],['快感中心','',''],['快慢','',''],['快慰','',''],['快手','',''],['快把','',''],['快报','',''],['快拍','',''],['快捷','',''],['快捷方式','',''],['快捷键','',''],['快攻','',''],['快来','',''],['快板','',''],['快板儿','',''],['快枪','',''],['快档','',''],['快步','',''],['快步流星','',''],['快步走','',''],['快步跑','',''],['快死','',''],['快活','',''],['快活人','',''],['快溺死','',''],['快滑','',''],['快点','',''],['快点儿','',''],['快照','',''],['快班','',''],['快球','',''],['快的','',''],['快看','',''],['快种','',''],['快而','',''],['快舌','',''],['快船','',''],['快艇','',''],['快行道','',''],['快要','',''],['快讯','',''],['快说','',''],['快走','',''],['快跑','',''],['快车','',''],['快车道','',''],['快转','',''],['快进','',''],['快追','',''],['快退','',''],['快递','',''],['快速','',''],['快速以太网络','',''],['快速动眼期','',''],['快速反应','',''],['快速排序','',''],['快速记忆法','',''],['快邮','',''],['快门','',''],['快门儿','',''],['快餐','',''],['快餐交友','',''],['快餐店','',''],['快餐部','',''],['快马','',''],['快马加鞭','',''],['快鱼','',''],['念上','',''],['念之','',''],['念书','',''],['念以','',''],['念佛','',''],['念兹在兹','',''],['念册','',''],['念及','',''],['念叨','',''],['念咒','',''],['念头','',''],['念学位','',''],['念心','',''],['念心儿','',''],['念念','',''],['念念不忘','',''],['念念有词','',''],['念日','',''],['念旧','',''],['念本','',''],['念珠','',''],['念白','',''],['念着','',''],['念经','',''],['念诗','',''],['念诵','',''],['念起','',''],['念过','',''],['念道','',''],['念错','',''],['忸忸怩怩','',''],['忸怩','',''],['忸怩作态','',''],['忸昵','',''],['忻府','',''],['忻忻得意','',''],['忽上忽下','',''],['忽儿','',''],['忽冷','',''],['忽减','',''],['忽发','',''],['忽听','',''],['忽哨','',''],['忽地','',''],['忽左忽右','',''],['忽布','',''],['忽微','',''],['忽必烈','',''],['忽忽','',''],['忽忽不乐','',''],['忽忽悠悠','',''],['忽悠','',''],['忽明','',''],['忽有','',''],['忽灭','',''],['忽热','',''],['忽然','',''],['忽然间','',''],['忽现','',''],['忽略','',''],['忽米','',''],['忽而','',''],['忽落','',''],['忽视','',''],['忽起','',''],['忽身','',''],['忽闪','',''],['忽闻','',''],['忽隐忽现','',''],['忽飞','',''],['忽高忽低','',''],['忽鲁谟斯','',''],['忿不顾身','',''],['忿忿','',''],['忿忿不平','',''],['忿怒','',''],['忿恨','',''],['忿懑','',''],['忿然作色','',''],['忿詈','',''],['怀中','',''],['怀乡','',''],['怀仁堂','',''],['怀俄明','',''],['怀俄明州','',''],['怀偏见','',''],['怀冤抱屈','',''],['怀刺漫灭','',''],['怀化县','',''],['怀古','',''],['怀妊','',''],['怀孕','',''],['怀孕中','',''],['怀宝迷邦','',''],['怀宝遁世','',''],['怀德畏威','',''],['怀念','',''],['怀恋','',''],['怀恨','',''],['怀恨在心','',''],['怀恨者','',''],['怀恶','',''],['怀恶不悛','',''],['怀恶意','',''],['怀想','',''],['怀才不遇','',''],['怀才抱德','',''],['怀抱','',''],['怀抱不平','',''],['怀敌意','',''],['怀旧','',''],['怀旧感','',''],['怀春','',''],['怀有','',''],['怀材抱德','',''],['怀柔','',''],['怀柔县','',''],['怀特','',''],['怀珠抱玉','',''],['怀瑾握瑜','',''],['怀璧其罪','',''],['怀疑','',''],['怀疑一切','',''],['怀疑性','',''],['怀疑派','',''],['怀疑者','',''],['怀疑论','',''],['怀真抱素','',''],['怀着','',''],['怀禄','',''],['怀绪','',''],['怀胎','',''],['怀表','',''],['怀质抱真','',''],['怀道迷邦','',''],['怀里','',''],['怀金垂紫','',''],['怀金拖紫','',''],['怀铅提椠','',''],['怀铅握椠','',''],['怀铅握素','',''],['怀鬼胎','',''],['怀黄佩紫','',''],['态势','',''],['态叠加','',''],['态子','',''],['态射','',''],['态度','',''],['态度生硬','',''],['态度端正','',''],['态样','',''],['怂恿','',''],['怃然','',''],['怄气','',''],['怅怅','',''],['怅恨','',''],['怅惘','',''],['怅望','',''],['怅然','',''],['怅然自失','',''],['怅然若失','',''],['怆地呼天','',''],['怆天呼地','',''],['怆然','',''],['怊怅','',''],['怊怅若失','',''],['怎不','',''],['怎个','',''],['怎么','',''],['怎么了','',''],['怎么办','',''],['怎么回事','',''],['怎么得了','',''],['怎么搞的','',''],['怎么样','',''],['怎么着','',''],['怎了','',''],['怎会','',''],['怎办','',''],['怎啦','',''],['怎地','',''],['怎奈','',''],['怎好意思','',''],['怎就','',''],['怎敢','',''],['怎敢不低头','',''],['怎样','',''],['怎生','',''],['怎的','',''],['怎知','',''],['怎肯','',''],['怎能','',''],['怎说','',''],['怎麽','',''],['怏怏','',''],['怏怏不乐','',''],['怏怏不平','',''],['怏怏不悦','',''],['怏然','',''],['怒不可遏','',''],['怒冲冲','',''],['怒发','',''],['怒发冲冠','',''],['怒号','',''],['怒吓','',''],['怒吠','',''],['怒吼','',''],['怒喊','',''],['怒喝','',''],['怒容','',''],['怒容满面','',''],['怒形','',''],['怒形于色','',''],['怒恨','',''],['怒意','',''],['怒放','',''],['怒斥','',''],['怒殴','',''],['怒殴者','',''],['怒气','',''],['怒气冲冲','',''],['怒气冲天','',''],['怒气冲霄','',''],['怒江','',''],['怒江傈僳族自治区','',''],['怒江大峡谷','',''],['怒江州','',''],['怒涛','',''],['怒潮','',''],['怒火','',''],['怒火中烧','',''],['怒火冲天','',''],['怒目','',''],['怒目切齿','',''],['怒目横眉','',''],['怒目相向','',''],['怒目而视','',''],['怒臂当车','',''],['怒臂当辙','',''],['怒色','',''],['怒视','',''],['怒颜相报','',''],['怒骂','',''],['怔地','',''],['怔忡','',''],['怔忪','',''],['怔怔','',''],['怔神儿','',''],['怔营','',''],['怕三怕四','',''],['怕丢面子','',''],['怕事','',''],['怕人','',''],['怕冷','',''],['怕只怕','',''],['怕怕','',''],['怕是','',''],['怕死','',''],['怕死贪生','',''],['怕死鬼','',''],['怕水','',''],['怕火','',''],['怕热','',''],['怕生','',''],['怕疼','',''],['怕痒','',''],['怕硬欺软','',''],['怕累','',''],['怕羞','',''],['怕老婆','',''],['怕苦','',''],['怕苦怕累','',''],['怕难为情','',''],['怙恃','',''],['怙恶不悛','',''],['怙恶不改','',''],['怛然失色','',''],['怜之','',''],['怜孤惜寡','',''],['怜恤','',''],['怜悯','',''],['怜惜','',''],['怜才','',''],['怜新弃旧','',''],['怜爱','',''],['怜贫惜老','',''],['怜贫敬老','',''],['怜香惜玉','',''],['思不出位','',''],['思义','',''],['思之心痛','',''],['思乐冰','',''],['思乡','',''],['思乡病','',''],['思乱','',''],['思亲','',''],['思冥','',''],['思凡','',''],['思前','',''],['思前想后','',''],['思前算后','',''],['思变','',''],['思古','',''],['思嘉丽','',''],['思如泉涌','',''],['思如涌泉','',''],['思孟学派','',''],['思归','',''],['思录','',''],['思忖','',''],['思念','',''],['思恋','',''],['思情','',''],['思惟','',''],['思惟经济原则','',''],['思想','',''],['思想上','',''],['思想交流','',''],['思想体系','',''],['思想包袱','',''],['思想史','',''],['思想家','',''],['思想库','',''],['思想性','',''],['思想意识','',''],['思想斗争','',''],['思想方法','',''],['思想素质','',''],['思想顽钝','',''],['思愁','',''],['思慕','',''],['思战','',''],['思时','',''],['思明','',''],['思春','',''],['思春期','',''],['思是','',''],['思源','',''],['思潮','',''],['思潮起伏','',''],['思熟','',''],['思甜','',''],['思科','',''],['思索','',''],['思索性','',''],['思索者','',''],['思绪','',''],['思绪万千','',''],['思维','',''],['思维敏捷','',''],['思维方式','',''],['思维科学','',''],['思维能力','',''],['思考','',''],['思考者','',''],['思考题','',''],['思而不学则殆','',''],['思而后行','',''],['思若泉涌','',''],['思若涌泉','',''],['思茅区','',''],['思茅地区','',''],['思虑','',''],['思议','',''],['思谋','',''],['思贤如渴','',''],['思路','',''],['思路敏捷','',''],['思辨哲学','',''],['思辩','',''],['思迁','',''],['思过','',''],['思过半矣','',''],['思量','',''],['怠堕','',''],['怠工','',''],['怠忽','',''],['怠惰','',''],['怠慢','',''],['怡人','',''],['怡保','',''],['怡保市','',''],['怡和','',''],['怡悦','',''],['怡情悦性','',''],['怡然','',''],['怡然自乐','',''],['怡然自娱','',''],['怡然自得','',''],['怡然自足','',''],['怡目','',''],['急下降','',''],['急不可待','',''],['急不可耐','',''],['急不择言','',''],['急中','',''],['急中生智','',''],['急了','',''],['急事','',''],['急于','',''],['急于想','',''],['急于星火','',''],['急于求成','',''],['急人','',''],['急人之困','',''],['急人之难','',''],['急人所急','',''],['急件','',''],['急促','',''],['急促声','',''],['急修','',''],['急先锋','',''],['急公好义','',''],['急冲','',''],['急切','',''],['急刹车','',''],['急剧','',''],['急剧下降','',''],['急功近利','',''],['急功近名','',''],['急务','',''],['急匆匆','',''],['急升','',''],['急发','',''],['急变','',''],['急口令','',''],['急吼吼','',''],['急呀','',''],['急嘴急舌','',''],['急噪','',''],['急坏','',''],['急奔','',''],['急如星火','',''],['急如风火','',''],['急射','',''],['急就章','',''],['急巴巴','',''],['急座','',''],['急弯','',''],['急征重敛','',''],['急待','',''],['急得','',''],['急忙','',''],['急急如律令','',''],['急急巴巴','',''],['急急忙忙','',''],['急性','',''],['急性人','',''],['急性传染病','',''],['急性子','',''],['急性氰化物中毒','',''],['急性照射','',''],['急性病','',''],['急性肠炎','',''],['急性胃肠炎','',''],['急性阑尾炎','',''],['急惊风','',''],['急扯','',''],['急抓','',''],['急报','',''],['急抽','',''],['急拉','',''],['急拍','',''],['急拍拍','',''],['急救','',''],['急救中心','',''],['急救包','',''],['急救员','',''],['急救站','',''],['急景凋年','',''],['急景流年','',''],['急智','',''],['急来抱佛脚','',''],['急步','',''],['急死','',''],['急派','',''],['急流','',''],['急流勇进','',''],['急流勇退','',''],['急流险滩','',''],['急湍','',''],['急火','',''],['急煞','',''],['急用','',''],['急电','',''],['急病','',''],['急症','',''],['急的','',''],['急眼','',''],['急着','',''],['急竹繁丝','',''],['急管繁弦','',''],['急聘','',''],['急聚','',''],['急脉缓受','',''],['急腹症','',''],['急茬','',''],['急茬儿','',''],['急行','',''],['急行军','',''],['急袭','',''],['急要','',''],['急让','',''],['急诊','',''],['急诊室','',''],['急语','',''],['急赤白脸','',''],['急走','',''],['急赶','',''],['急起直追','',''],['急跑','',''],['急躁','',''],['急转','',''],['急转弯','',''],['急转直下','',''],['急进','',''],['急迫','',''],['急退','',''],['急送','',''],['急速','',''],['急造','',''],['急遽','',''],['急降','',''],['急难','',''],['急需','',''],['急需品','',''],['急需处理','',''],['急需解决','',''],['急风','',''],['急风暴雨','',''],['急飞','',''],['急驰','',''],['急骤','',''],['怦怦','',''],['怦然','',''],['怦然心动','',''],['性乐','',''],['性事','',''],['性交','',''],['性交易','',''],['性交高潮','',''],['性产业','',''],['性价比','',''],['性伙伴','',''],['性传播','',''],['性伴','',''],['性伴侣','',''],['性侵','',''],['性侵害','',''],['性侵犯','',''],['性倒','',''],['性倒错','',''],['性偏好','',''],['性健康','',''],['性关系','',''],['性兴奋','',''],['性冲动','',''],['性冷感','',''],['性冷淡','',''],['性别','',''],['性别歧视','',''],['性别比','',''],['性别角色','',''],['性历','',''],['性取向','',''],['性变态','',''],['性同','',''],['性同一性障碍','',''],['性向','',''],['性命','',''],['性命交关','',''],['性命攸关','',''],['性善','',''],['性善论','',''],['性器','',''],['性器官','',''],['性地','',''],['性好','',''],['性如','',''],['性媾','',''],['性子','',''],['性学','',''],['性工作','',''],['性弱','',''],['性强','',''],['性形','',''],['性征','',''],['性徵','',''],['性快感','',''],['性态','',''],['性急','',''],['性急人','',''],['性恶','',''],['性恶论','',''],['性情','',''],['性情好','',''],['性感','',''],['性成熟','',''],['性技','',''],['性指向','',''],['性接触','',''],['性教育','',''],['性服务','',''],['性服务产业','',''],['性本善','',''],['性本能','',''],['性格','',''],['性格不合','',''],['性格好','',''],['性模','',''],['性欲','',''],['性欲高潮','',''],['性气','',''],['性满足','',''],['性激素','',''],['性灵','',''],['性爱','',''],['性物恋','',''],['性状','',''],['性生活','',''],['性疾病','',''],['性病','',''],['性瘾','',''],['性短讯','',''],['性禁忌','',''],['性科','',''],['性科学','',''],['性稳','',''],['性细胞','',''],['性能','',''],['性能超群','',''],['性腺','',''],['性药','',''],['性虐','',''],['性虐待','',''],['性行','',''],['性行为','',''],['性衰','',''],['性质','',''],['性质上','',''],['性质命题','',''],['性野','',''],['性骚扰','',''],['性高潮','',''],['怨不得','',''],['怨偶','',''],['怨入骨髓','',''],['怨叹','',''],['怨命','',''],['怨声','',''],['怨声满道','',''],['怨声盈路','',''],['怨声载路','',''],['怨声载道','',''],['怨天尤人','',''],['怨天怨地','',''],['怨天载道','',''],['怨女','',''],['怨女旷夫','',''],['怨尤','',''],['怨府','',''],['怨怼','',''],['怨恨','',''],['怨愤','',''],['怨我','',''],['怨报','',''],['怨望','',''],['怨毒','',''],['怨气','',''],['怨气冲天','',''],['怨耦','',''],['怨艾','',''],['怨言','',''],['怨载','',''],['怨鬼','',''],['怪不','',''],['怪不得','',''],['怪事','',''],['怪人','',''],['怪人奥尔・扬科维奇','',''],['怪僻','',''],['怪兽','',''],['怪到','',''],['怪力乱神','',''],['怪叔叔','',''],['怪叫','',''],['怪味','',''],['怪哉','',''],['怪圈','',''],['怪声','',''],['怪声怪气','',''],['怪客','',''],['怪异','',''],['怪异事','',''],['怪影','',''],['怪念','',''],['怪念头','',''],['怪怨','',''],['怪怪','',''],['怪怪的','',''],['怪想','',''],['怪手','',''],['怪杰','',''],['怪样','',''],['怪样子','',''],['怪模','',''],['怪模怪样','',''],['怪气','',''],['怪物','',''],['怪物似','',''],['怪病','',''],['怪癖','',''],['怪相','',''],['怪石','',''],['怪秘','',''],['怪笑','',''],['怪给','',''],['怪罪','',''],['怪胎','',''],['怪脸','',''],['怪蜀黍','',''],['怪行','',''],['怪讶','',''],['怪论','',''],['怪话','',''],['怪诞','',''],['怪诞不经','',''],['怪谈','',''],['怪谬','',''],['怪谲','',''],['怪象','',''],['怪道','',''],['怪里怪气','',''],['怫然','',''],['怯场','',''],['怯声怯气','',''],['怯头怯脑','',''],['怯子','',''],['怯弱','',''],['怯怯','',''],['怯意','',''],['怯懦','',''],['怯生','',''],['怯生生','',''],['怯疑','',''],['怯相','',''],['怯羞','',''],['怯阵','',''],['怵惕','',''],['怵惧','',''],['怵然','',''],['怵目惊心','',''],['总不','',''],['总主教','',''],['总之','',''],['总书记','',''],['总产','',''],['总产值','',''],['总产量','',''],['总人口','',''],['总人数','',''],['总令','',''],['总价','',''],['总价值','',''],['总任务','',''],['总会','',''],['总会三明治','',''],['总会会长','',''],['总会计师','',''],['总体','',''],['总体上','',''],['总体上说','',''],['总体布局','',''],['总体方案','',''],['总体水平','',''],['总体目标','',''],['总体经济学','',''],['总体规划','',''],['总供给','',''],['总值','',''],['总储量','',''],['总公司','',''],['总共','',''],['总兵','',''],['总册','',''],['总分','',''],['总则','',''],['总办','',''],['总加','',''],['总务','',''],['总动员','',''],['总医院','',''],['总协定','',''],['总卵黄管','',''],['总厂','',''],['总参','',''],['总参谋部','',''],['总参谋长','',''],['总可','',''],['总台','',''],['总司令','',''],['总司令部','',''],['总合','',''],['总后','',''],['总后勤部','',''],['总后方','',''],['总吨','',''],['总吨位','',''],['总吨数','',''],['总和','',''],['总回报','',''],['总图','',''],['总备','',''],['总将','',''],['总局','',''],['总崩溃','',''],['总工','',''],['总工会','',''],['总工程师','',''],['总帐','',''],['总干事','',''],['总平面图','',''],['总库','',''],['总店','',''],['总开关','',''],['总开销','',''],['总归','',''],['总得','',''],['总怪','',''],['总总','',''],['总想','',''],['总成','',''],['总成本','',''],['总成绩','',''],['总括','',''],['总指挥','',''],['总指挥部','',''],['总按','',''],['总控','',''],['总揽','',''],['总揽全局','',''],['总支','',''],['总支出','',''],['总收入','',''],['总收益','',''],['总攻','',''],['总攻击','',''],['总政','',''],['总政治部','',''],['总政策','',''],['总教堂','',''],['总教练','',''],['总数','',''],['总数达','',''],['总方针','',''],['总星系','',''],['总是','',''],['总有','',''],['总机','',''],['总机构','',''],['总杆赛','',''],['总次数','',''],['总汇','',''],['总流量','',''],['总热值','',''],['总爱','',''],['总状花序','',''],['总理','',''],['总理衙门','',''],['总的','',''],['总的形势','',''],['总的来看','',''],['总的来说','',''],['总的说来','',''],['总监','',''],['总目','',''],['总目录','',''],['总目标','',''],['总督','',''],['总社','',''],['总称','',''],['总站','',''],['总章','',''],['总算','',''],['总管','',''],['总管子','',''],['总管理处','',''],['总管道','',''],['总纂','',''],['总纲','',''],['总线','',''],['总经','',''],['总经济师','',''],['总经理','',''],['总结','',''],['总结会','',''],['总结工作','',''],['总结性','',''],['总结报告','',''],['总结经验','',''],['总统','',''],['总统任期','',''],['总统制','',''],['总统大选','',''],['总统府','',''],['总统选举','',''],['总编','',''],['总编辑','',''],['总罚','',''],['总罢工','',''],['总署','',''],['总而言之','',''],['总耗','',''],['总能','',''],['总营业额','',''],['总行','',''],['总表','',''],['总裁','',''],['总装','',''],['总要','',''],['总规模','',''],['总览','',''],['总角','',''],['总角之交','',''],['总角之好','',''],['总计','',''],['总论','',''],['总评','',''],['总说','',''],['总谱','',''],['总账','',''],['总起来说','',''],['总趋势','',''],['总路线','',''],['总辖','',''],['总运单','',''],['总还','',''],['总部','',''],['总重','',''],['总重量','',''],['总量','',''],['总钥匙','',''],['总长','',''],['总阀','',''],['总队','',''],['总院','',''],['总集','',''],['总需求','',''],['总面积','',''],['总预算','',''],['总领事','',''],['总领事馆','',''],['总领馆','',''],['总额','',''],['总风险','',''],['总馆','',''],['总鳍鱼','',''],['恁么','',''],['恁地','',''],['恁般','',''],['恂恂','',''],['恂恂善诱','',''],['恃势','',''],['恃强凌弱','',''],['恃强欺弱','',''],['恃才','',''],['恃才傲物','',''],['恃才扬己','',''],['恃才敖物','',''],['恃才矜己','',''],['恋人','',''],['恋女','',''],['恋家','',''],['恋恋','',''],['恋恋不舍','',''],['恋恋难舍','',''],['恋情','',''],['恋慕','',''],['恋新忘旧','',''],['恋旧','',''],['恋旧情结','',''],['恋曲','',''],['恋栈','',''],['恋歌','',''],['恋母','',''],['恋母情结','',''],['恋爱','',''],['恋父','',''],['恋物','',''],['恋物狂','',''],['恋物癖','',''],['恋狂','',''],['恋生恶死','',''],['恋癖','',''],['恋着','',''],['恋童癖','',''],['恋脚癖','',''],['恋脚癖者','',''],['恋诗','',''],['恋贫恤老','',''],['恋贫恤苦','',''],['恋酒贪杯','',''],['恋酒贪色','',''],['恋酒贪花','',''],['恋酒迷花','',''],['恍如','',''],['恍如隔世','',''],['恍忽','',''],['恍恍忽忽','',''],['恍恍惚惚','',''],['恍惚','',''],['恍惚迷离','',''],['恍然','',''],['恍然大悟','',''],['恍然醒悟','',''],['恍神','',''],['恍若','',''],['恍若隔世','',''],['恐不','',''],['恐俄症','',''],['恐兽','',''],['恐同','',''],['恐同症','',''],['恐后争先','',''],['恐吓','',''],['恐味','',''],['恐外','',''],['恐怕','',''],['恐怖','',''],['恐怖主义','',''],['恐怖主义者','',''],['恐怖事件','',''],['恐怖份子','',''],['恐怖分子','',''],['恐怖感','',''],['恐怖活动','',''],['恐怖片','',''],['恐怖片儿','',''],['恐怖电影','',''],['恐怖症','',''],['恐怖组织','',''],['恐怖行动','',''],['恐怖袭击','',''],['恐怖集团','',''],['恐惧','',''],['恐惧心理','',''],['恐惧感','',''],['恐惧症','',''],['恐慌','',''],['恐慌万状','',''],['恐旷症','',''],['恐水','',''],['恐水病','',''],['恐水症','',''],['恐法症','',''],['恐荒','',''],['恐韩症','',''],['恐高','',''],['恐高症','',''],['恐鸟','',''],['恐龙','',''],['恐龙妹','',''],['恐龙总目','',''],['恐龙类','',''],['恒久','',''],['恒产','',''],['恒力','',''],['恒加速度','',''],['恒压','',''],['恒压器','',''],['恒定','',''],['恒定性','',''],['恒山','',''],['恒常','',''],['恒心','',''],['恒星','',''],['恒星年','',''],['恒星日','',''],['恒星月','',''],['恒星系','',''],['恒星际','',''],['恒春','',''],['恒春半岛','',''],['恒春镇','',''],['恒河','',''],['恒河沙数','',''],['恒河猴','',''],['恒温','',''],['恒温器','',''],['恒湿','',''],['恒湿器','',''],['恒牙','',''],['恒生','',''],['恒生中资企业指数','',''],['恒生指数','',''],['恒生银行','',''],['恒等','',''],['恒等式','',''],['恒速率','',''],['恒量','',''],['恒齿','',''],['恓惶','',''],['恕不','',''],['恕不从命','',''],['恕不奉陪','',''],['恕不接待','',''],['恕免','',''],['恕己及人','',''],['恕己及物','',''],['恕性','',''],['恕我','',''],['恕我直言','',''],['恕罪','',''],['恕赎','',''],['恕邀','',''],['恕难从命','',''],['恙虫','',''],['恙虫病','',''],['恝置','',''],['恢复','',''],['恢复原状','',''],['恢复名誉','',''],['恢复常态','',''],['恢复期','',''],['恢复生产','',''],['恢复系','',''],['恢宏','',''],['恢宏大度','',''],['恢廓','',''],['恢廓大度','',''],['恢弘','',''],['恢恢','',''],['恢恢有余','',''],['恢谐','',''],['恣心所欲','',''],['恣情','',''],['恣情纵欲','',''],['恣意','',''],['恣意妄为','',''],['恣意妄行','',''],['恣意行乐','',''],['恣横','',''],['恣欲','',''],['恣睢无忌','',''],['恣肆','',''],['恣肆无忌','',''],['恣行无忌','',''],['恤匮','',''],['恤嫠','',''],['恤孤念寡','',''],['恤孤念苦','',''],['恤老怜贫','',''],['恤衫','',''],['恤金','',''],['恨不','',''],['恨不得','',''],['恨不能','',''],['恨之','',''],['恨之入骨','',''],['恨事','',''],['恨人','',''],['恨入心髓','',''],['恨入骨髓','',''],['恨恨','',''],['恨恶','',''],['恨意','',''],['恨死','',''],['恨海难填','',''],['恨相知晚','',''],['恨相见晚','',''],['恨透','',''],['恨铁不成钢','',''],['恩主','',''],['恩人','',''],['恩仇','',''],['恩俸','',''],['恩公','',''],['恩典','',''],['恩准','',''],['恩同再造','',''],['恩同父母','',''],['恩培多克勒','',''],['恩威兼施','',''],['恩威并施','',''],['恩威并用','',''],['恩威并著','',''],['恩威并行','',''],['恩宠','',''],['恩将仇报','',''],['恩山义海','',''],['恩师','',''],['恩德','',''],['恩怨','',''],['恩情','',''],['恩惠','',''],['恩慈','',''],['恩戴','',''],['恩断义绝','',''],['恩断意绝','',''],['恩斯赫德','',''],['恩施县','',''],['恩施地区','',''],['恩格尔','',''],['恩格斯','',''],['恩比天大','',''],['恩泽','',''],['恩深义重','',''],['恩爱','',''],['恩眄','',''],['恩膏','',''],['恩贾梅纳','',''],['恩赐','',''],['恩赐观点','',''],['恩里科・费米','',''],['恩重丘山','',''],['恩重如山','',''],['恪守','',''],['恪守成式','',''],['恪守成规','',''],['恪尽职守','',''],['恪慎','',''],['恪遵','',''],['恫吓','',''],['恫疑虚喝','',''],['恫言','',''],['恬不为怪','',''],['恬不为意','',''],['恬不知怪','',''],['恬不知耻','',''],['恬和','',''],['恬噪','',''],['恬愉','',''],['恬愉之安','',''],['恬波','',''],['恬淡','',''],['恬淡卦欲','',''],['恬淡无为','',''],['恬淡无欲','',''],['恬漠','',''],['恬澹','',''],['恬然','',''],['恬畅','',''],['恬美','',''],['恬谧','',''],['恬退','',''],['恬适','',''],['恬逸','',''],['恬雅','',''],['恬静','',''],['恭亲王','',''],['恭亲王奕䜣','',''],['恭从','',''],['恭候','',''],['恭听','',''],['恭喜','',''],['恭喜发财','',''],['恭城','',''],['恭城县','',''],['恭子','',''],['恭恭','',''],['恭恭敬敬','',''],['恭惟','',''],['恭敬','',''],['恭敬不如从命','',''],['恭敬桑梓','',''],['恭服','',''],['恭桶','',''],['恭祝','',''],['恭维','',''],['恭维话','',''],['恭行天罚','',''],['恭请','',''],['恭谒','',''],['恭谦','',''],['恭谨','',''],['恭贺','',''],['恭贺佳节','',''],['恭贺新禧','',''],['恭迎','',''],['恭逢其盛','',''],['恭顺','',''],['息事','',''],['息事宁人','',''],['息兵','',''],['息声','',''],['息峰县','',''],['息影','',''],['息怒','',''],['息息','',''],['息息相关','',''],['息息相通','',''],['息憩','',''],['息战','',''],['息技','',''],['息率','',''],['息票','',''],['息肉','',''],['息肩','',''],['息黥补劓','',''],['息鼓','',''],['恰似','',''],['恰值','',''],['恰切','',''],['恰到','',''],['恰到好处','',''],['恰在此时','',''],['恰好','',''],['恰好相反','',''],['恰如','',''],['恰如其份','',''],['恰如其分','',''],['恰巧','',''],['恰帕斯州','',''],['恰当','',''],['恰恰','',''],['恰恰相反','',''],['恰恰舞','',''],['恰逢','',''],['恳亲会','',''],['恳切','',''],['恳挚','',''],['恳求','',''],['恳求似','',''],['恳求者','',''],['恳请','',''],['恳请似','',''],['恳谈','',''],['恳谈会','',''],['恳辞','',''],['恶习','',''],['恶事','',''],['恶事传千里','',''],['恶事行千里','',''],['恶人','',''],['恶人先告状','',''],['恶仗','',''],['恶作剧','',''],['恶作剧者','',''],['恶例','',''],['恶俗','',''],['恶兆','',''],['恶凶凶','',''],['恶创','',''],['恶劣','',''],['恶劣影响','',''],['恶劳好逸','',''],['恶势力','',''],['恶化','',''],['恶叉白赖','',''],['恶口','',''],['恶名','',''],['恶名儿','',''],['恶名昭彰','',''],['恶名昭著','',''],['恶唑啉','',''],['恶唑啉酮','',''],['恶嗪','',''],['恶声','',''],['恶妇','',''],['恶婆','',''],['恶寒','',''],['恶少','',''],['恶岁','',''],['恶徒','',''],['恶德','',''],['恶心','',''],['恶念','',''],['恶性','',''],['恶性循环','',''],['恶性疟原虫','',''],['恶性瘤','',''],['恶性肿瘤','',''],['恶性通货膨胀','',''],['恶恨','',''],['恶恶实实','',''],['恶意','',''],['恶意中伤','',''],['恶意代码','',''],['恶感','',''],['恶战','',''],['恶报','',''],['恶损','',''],['恶搞','',''],['恶搞文化','',''],['恶政','',''],['恶斗','',''],['恶有恶报','',''],['恶果','',''],['恶梦','',''],['恶梦似','',''],['恶棍','',''],['恶棍似','',''],['恶毒','',''],['恶气','',''],['恶水','',''],['恶汉','',''],['恶浊','',''],['恶浪','',''],['恶煞','',''],['恶犬','',''],['恶狗','',''],['恶狠','',''],['恶狠狠','',''],['恶疾','',''],['恶病','',''],['恶病质','',''],['恶癖','',''],['恶直丑正','',''],['恶相','',''],['恶神','',''],['恶积祸盈','',''],['恶稔祸盈','',''],['恶稔罪盈','',''],['恶稔贯盈','',''],['恶紫夺朱','',''],['恶者','',''],['恶臭','',''],['恶臭扑鼻','',''],['恶臭物','',''],['恶臭脓','',''],['恶舌','',''],['恶苗病','',''],['恶虎饥鹰','',''],['恶行','',''],['恶衣恶食','',''],['恶衣粗食','',''],['恶衣粝食','',''],['恶衣菲食','',''],['恶衣蔬食','',''],['恶补','',''],['恶言','',''],['恶言伤人','',''],['恶言漫骂','',''],['恶言詈辞','',''],['恶誓','',''],['恶论','',''],['恶评','',''],['恶评昭著','',''],['恶语','',''],['恶语中伤','',''],['恶语伤人','',''],['恶贯满盈','',''],['恶贯祸盈','',''],['恶辣','',''],['恶运','',''],['恶迹','',''],['恶霸','',''],['恶骂','',''],['恶鬼','',''],['恶魔','',''],['恶魔似','',''],['恶魔般','',''],['恸哭','',''],['恹恹','',''],['恺弟','',''],['恺彻','',''],['恺悌','',''],['恺悌君子','',''],['恺撒','',''],['恻怛之心','',''],['恻然','',''],['恻隐','',''],['恻隐之心','',''],['恼乱','',''],['恼人','',''],['恼怒','',''],['恼恨','',''],['恼火','',''],['恼羞','',''],['恼羞变怒','',''],['恼羞成怒','',''],['悄声','',''],['悄悄','',''],['悄悄儿','',''],['悄悄话','',''],['悄无声息','',''],['悄没声儿','',''],['悄然','',''],['悄然无声','',''],['悉交绝游','',''],['悉听尊便','',''],['悉尼','',''],['悉德尼','',''],['悉心','',''],['悉心戮力','',''],['悉心毕力','',''],['悉心竭力','',''],['悉数','',''],['悉由','',''],['悉索敝赋','',''],['悉索薄赋','',''],['悌友','',''],['悌睦','',''],['悍勇','',''],['悍匪','',''],['悍妇','',''],['悍妻','',''],['悍将','',''],['悍接','',''],['悍然','',''],['悍然不顾','',''],['悒悒','',''],['悒悒不乐','',''],['悒悒不欢','',''],['悔不','',''],['悔不当初','',''],['悔不该','',''],['悔之','',''],['悔之不及','',''],['悔之亡及','',''],['悔之何及','',''],['悔之已晚','',''],['悔之无及','',''],['悔之晚矣','',''],['悔之莫及','',''],['悔婚','',''],['悔帮','',''],['悔恨','',''],['悔恨交加','',''],['悔悟','',''],['悔意','',''],['悔改','',''],['悔棋','',''],['悔气','',''],['悔罪','',''],['悔罪者','',''],['悔罪自新','',''],['悔过','',''],['悔过书','',''],['悔过自忏','',''],['悔过自新','',''],['悔过自责','',''],['悖入悖出','',''],['悖文','',''],['悖晦','',''],['悖理','',''],['悖礼','',''],['悖缪','',''],['悖论','',''],['悖谬','',''],['悖逆','',''],['悚然','',''],['悟入','',''],['悟净','',''],['悟出','',''],['悟力','',''],['悟学','',''],['悟性','',''],['悟空','',''],['悟能','',''],['悟道','',''],['悠久','',''],['悠哉','',''],['悠哉悠哉','',''],['悠哉游哉','',''],['悠忽','',''],['悠悠','',''],['悠悠忽忽','',''],['悠悠荡荡','',''],['悠扬','',''],['悠然','',''],['悠然神往','',''],['悠然自得','',''],['悠然自适','',''],['悠着','',''],['悠着点','',''],['悠缪','',''],['悠荡','',''],['悠谬','',''],['悠远','',''],['悠长','',''],['悠闲','',''],['悠闲自在','',''],['患上','',''],['患了','',''],['患儿','',''],['患处','',''],['患得患失','',''],['患晚期','',''],['患有','',''],['患病','',''],['患病者','',''],['患癌','',''],['患者','',''],['患难','',''],['患难与共','',''],['患难之交','',''],['患难之交才是真正的朋友','',''],['患难相恤','',''],['患难相扶','',''],['患难相死','',''],['患难见弃','',''],['患难见真情','',''],['悦人','',''],['悦心娱目','',''],['悦服','',''],['悦目','',''],['悦目娱心','',''],['悦纳','',''],['悦耳','',''],['悦耳动听','',''],['悦色','',''],['悦近来远','',''],['您不','',''],['您也','',''],['您了','',''],['您们','',''],['您先','',''],['您再','',''],['您别','',''],['您去','',''],['您可','',''],['您在','',''],['您坐','',''],['您大','',''],['您好','',''],['您对','',''],['您将','',''],['您就','',''],['您得','',''],['您快','',''],['您想','',''],['您慢','',''],['您提','',''],['您是','',''],['您有','',''],['您来','',''],['您猜','',''],['您的','',''],['您瞧','',''],['您能','',''],['您让','',''],['您说','',''],['您还','',''],['您这','',''],['悬乎','',''],['悬于','',''],['悬停','',''],['悬剑','',''],['悬吊','',''],['悬在','',''],['悬垂','',''],['悬垂物','',''],['悬垂肌','',''],['悬壶','',''],['悬壶济世','',''],['悬头刺骨','',''],['悬岩','',''],['悬崖','',''],['悬崖勒马','',''],['悬崖峭壁','',''],['悬崖绝壁','',''],['悬弧之庆','',''],['悬心吊胆','',''],['悬念','',''],['悬悬而望','',''],['悬想','',''],['悬拟','',''],['悬挂','',''],['悬挂式','',''],['悬挂式滑翔','',''],['悬挂式滑翔机','',''],['悬挂物','',''],['悬揣','',''],['悬旗','',''],['悬望','',''],['悬木','',''],['悬案','',''],['悬梁','',''],['悬梁刺股','',''],['悬梁刺骨','',''],['悬梁自尽','',''],['悬梯','',''],['悬殊','',''],['悬河','',''],['悬河注水','',''],['悬河注火','',''],['悬河泻水','',''],['悬浊液','',''],['悬浮','',''],['悬浮体染色','',''],['悬浮微粒','',''],['悬浮液','',''],['悬浮物','',''],['悬瀑','',''],['悬灯结彩','',''],['悬疑','',''],['悬着','',''],['悬空','',''],['悬空寺','',''],['悬索桥','',''],['悬绝','',''],['悬罄','',''],['悬置','',''],['悬羊头卖狗肉','',''],['悬而未决','',''],['悬肠挂肚','',''],['悬腕','',''],['悬臂','',''],['悬若日月','',''],['悬荡','',''],['悬虑','',''],['悬赏','',''],['悬赏令','',''],['悬起','',''],['悬车之年','',''],['悬车告老','',''],['悬车致仕','',''],['悬钩子','',''],['悬铃木','',''],['悬隔','',''],['悬雍垂','',''],['悬鹑百结','',''],['悭俭','',''],['悭吝','',''],['悯惜','',''],['悱恻','',''],['悲不自胜','',''],['悲伤','',''],['悲凄','',''],['悲凉','',''],['悲切','',''],['悲剧','',''],['悲剧性','',''],['悲剧演员','',''],['悲剧缺陷','',''],['悲号','',''],['悲叹','',''],['悲咽','',''],['悲哀','',''],['悲哉','',''],['悲哭','',''],['悲啼','',''],['悲喜','',''],['悲喜交切','',''],['悲喜交并','',''],['悲喜交至','',''],['悲喜交集','',''],['悲喜兼集','',''],['悲喜剧','',''],['悲喜剧性','',''],['悲壮','',''],['悲声载道','',''],['悲天悯人','',''],['悲心','',''],['悲怀','',''],['悲怅','',''],['悲怆','',''],['悲怨','',''],['悲恨','',''],['悲恸','',''],['悲恻','',''],['悲悯','',''],['悲悼','',''],['悲情','',''],['悲惨','',''],['悲惨世界','',''],['悲惨境遇','',''],['悲惨结局','',''],['悲愁','',''],['悲感','',''],['悲愤','',''],['悲愤填膺','',''],['悲戚','',''],['悲摧','',''],['悲欢','',''],['悲欢合散','',''],['悲欢离合','',''],['悲歌','',''],['悲歌当哭','',''],['悲歌慷慨','',''],['悲泣','',''],['悲痛','',''],['悲痛欲绝','',''],['悲秋','',''],['悲苦','',''],['悲衷','',''],['悲观','',''],['悲观主义','',''],['悲观厌世','',''],['悲观失望','',''],['悲观论者','',''],['悲观论调','',''],['悲诉','',''],['悲辛','',''],['悲郁','',''],['悲酸','',''],['悲鸣','',''],['悴奴','',''],['悸动','',''],['悸愣','',''],['悸栗','',''],['悻悻','',''],['悻然','',''],['悼亡','',''],['悼唁','',''],['悼心失图','',''],['悼念','',''],['悼惜','',''],['悼文','',''],['悼歌','',''],['悼者','',''],['悼襄王','',''],['悼词','',''],['悼诗','',''],['悼辞','',''],['情不可却','',''],['情不自堪','',''],['情不自禁','',''],['情不自胜','',''],['情丝','',''],['情义','',''],['情之所钟','',''],['情书','',''],['情事','',''],['情人','',''],['情人眼里出西施','',''],['情人眼里有西施','',''],['情份','',''],['情何以堪','',''],['情侣','',''],['情侣鹦鹉','',''],['情儿','',''],['情关','',''],['情况','',''],['情况下','',''],['情况汇报','',''],['情分','',''],['情势','',''],['情史','',''],['情同一家','',''],['情同手足','',''],['情同骨肉','',''],['情同鱼水','',''],['情味','',''],['情商','',''],['情场','',''],['情境','',''],['情境模型','',''],['情夫','',''],['情妇','',''],['情孚意合','',''],['情形','',''],['情怀','',''],['情态','',''],['情思','',''],['情急','',''],['情急之下','',''],['情急了','',''],['情急智生','',''],['情意','',''],['情感','',''],['情愫','',''],['情愿','',''],['情投','',''],['情投意合','',''],['情投意洽','',''],['情报','',''],['情报体制','',''],['情报员','',''],['情报处','',''],['情报学','',''],['情报官员','',''],['情报局','',''],['情报工作','',''],['情报战','',''],['情报所','',''],['情报服务','',''],['情报机构','',''],['情报检索','',''],['情报活动','',''],['情报源','',''],['情报界','',''],['情报组织','',''],['情报统计','',''],['情报网','',''],['情报资料','',''],['情报部','',''],['情报部门','',''],['情操','',''],['情敌','',''],['情文','',''],['情文并茂','',''],['情景','',''],['情景交融','',''],['情暖','',''],['情曲','',''],['情有可原','',''],['情有独钟','',''],['情有西施','',''],['情杀','',''],['情欲','',''],['情歌','',''],['情比金坚','',''],['情海','',''],['情深','',''],['情深似海','',''],['情深友于','',''],['情深如海','',''],['情深意浓','',''],['情深骨肉','',''],['情火','',''],['情爱','',''],['情状','',''],['情狂','',''],['情理','',''],['情理难容','',''],['情由','',''],['情痴','',''],['情真','',''],['情真意切','',''],['情真意挚','',''],['情知','',''],['情种','',''],['情窦','',''],['情窦初开','',''],['情结','',''],['情绪','',''],['情绪化','',''],['情绪商数','',''],['情绪状态','',''],['情绪高涨','',''],['情缘','',''],['情网','',''],['情至','',''],['情至意尽','',''],['情致','',''],['情色','',''],['情节','',''],['情节严重','',''],['情节剧','',''],['情若手足','',''],['情蒐','',''],['情见乎言','',''],['情见乎词','',''],['情见乎辞','',''],['情见力屈','',''],['情见势屈','',''],['情见势竭','',''],['情诗','',''],['情话','',''],['情调','',''],['情谊','',''],['情资','',''],['情趣','',''],['情趣商店','',''],['情趣用品','',''],['情迷','',''],['情逾骨肉','',''],['情郎','',''],['情随事迁','',''],['情面','',''],['惆怅','',''],['惆怅若失','',''],['惆然','',''],['惊世骇俗','',''],['惊为','',''],['惊人','',''],['惊人之举','',''],['惊倒','',''],['惊动','',''],['惊动人','',''],['惊厥','',''],['惊叫','',''],['惊叹','',''],['惊叹不已','',''],['惊叹号','',''],['惊吓','',''],['惊呆','',''],['惊呼','',''],['惊喜','',''],['惊喜若狂','',''],['惊堂木','',''],['惊天','',''],['惊天动地','',''],['惊奇','',''],['惊师动众','',''],['惊异','',''],['惊弓之鸟','',''],['惊弦之鸟','',''],['惊得','',''],['惊心','',''],['惊心动魄','',''],['惊心胆颤','',''],['惊怕','',''],['惊怖','',''],['惊急','',''],['惊怪','',''],['惊怯','',''],['惊恐','',''],['惊恐万状','',''],['惊恐翼龙','',''],['惊悉','',''],['惊悚','',''],['惊悟','',''],['惊悸','',''],['惊惧','',''],['惊惶','',''],['惊惶失措','',''],['惊惶失色','',''],['惊惶无措','',''],['惊愕','',''],['惊慌','',''],['惊慌失措','',''],['惊慌失色','',''],['惊才绝艳','',''],['惊扰','',''],['惊服','',''],['惊栗','',''],['惊梦','',''],['惊涛','',''],['惊涛骇浪','',''],['惊现','',''],['惊疑','',''],['惊痫','',''],['惊羡','',''],['惊群动众','',''],['惊艳','',''],['惊蛇入草','',''],['惊蜇','',''],['惊视','',''],['惊觉','',''],['惊讶','',''],['惊诧','',''],['惊谔','',''],['惊赏','',''],['惊走','',''],['惊起','',''],['惊跑','',''],['惊跳','',''],['惊车','',''],['惊退','',''],['惊逃','',''],['惊遽','',''],['惊避','',''],['惊醒','',''],['惊采绝艳','',''],['惊错','',''],['惊险','',''],['惊雷','',''],['惊颤','',''],['惊风','',''],['惊风骇浪','',''],['惊飞','',''],['惊马','',''],['惊骇','',''],['惊魂','',''],['惊魂未定','',''],['惊魂甫定','',''],['惊鸟','',''],['惊鸿','',''],['惋惜','',''],['惑世盗名','',''],['惑乱','',''],['惑众','',''],['惑星','',''],['惑者','',''],['惕励','',''],['惕厉','',''],['惕然','',''],['惕而不漏','',''],['惘然','',''],['惘然如失','',''],['惘然若失','',''],['惘若有失','',''],['惛耄','',''],['惜别','',''],['惜力','',''],['惜售','',''],['惜墨如金','',''],['惜孤念寡','',''],['惜寸阴','',''],['惜指失掌','',''],['惜时如命','',''],['惜物','',''],['惜玉怜香','',''],['惜福','',''],['惜老怜贫','',''],['惜阴','',''],['惝恍','',''],['惟一','',''],['惟其','',''],['惟利是图','',''],['惟利是营','',''],['惟利是视','',''],['惟利是逐','',''],['惟命是从','',''],['惟命是听','',''],['惟妙惟肖','',''],['惟恐','',''],['惟恐天下不乱','',''],['惟我独尊','',''],['惟有','',''],['惟有读书高','',''],['惟独','',''],['惟精惟一','',''],['惟肖','',''],['惠临','',''],['惠予','',''],['惠农','',''],['惠及','',''],['惠城','',''],['惠子','',''],['惠存','',''],['惠山','',''],['惠斯勒','',''],['惠斯特','',''],['惠施','',''],['惠普','',''],['惠普公司','',''],['惠更斯','',''],['惠河','',''],['惠济','',''],['惠灵顿','',''],['惠然肯来','',''],['惠特妮・休斯顿','',''],['惠而不费','',''],['惠誉','',''],['惠赐','',''],['惠远寺','',''],['惠鉴','',''],['惠阳','',''],['惠阳地区','',''],['惠顾','',''],['惦念','',''],['惦挂','',''],['惦着','',''],['惦记','',''],['惦量','',''],['惧内','',''],['惧外','',''],['惧怕','',''],['惧色','',''],['惧高症','',''],['惧意','',''],['惧感','',''],['惨不忍睹','',''],['惨不忍闻','',''],['惨事','',''],['惨像','',''],['惨兮兮','',''],['惨况','',''],['惨剧','',''],['惨厉','',''],['惨变','',''],['惨叫','',''],['惨境','',''],['惨怛','',''],['惨惨','',''],['惨无人道','',''],['惨景','',''],['惨杀','',''],['惨案','',''],['惨死','',''],['惨毒','',''],['惨淡','',''],['惨淡经营','',''],['惨烈','',''],['惨然','',''],['惨然不乐','',''],['惨状','',''],['惨痛','',''],['惨白','',''],['惨相','',''],['惨祸','',''],['惨笑','',''],['惨绝人寰','',''],['惨绿少年','',''],['惨绿愁红','',''],['惨苦','',''],['惨败','',''],['惨遭','',''],['惨遭不幸','',''],['惨遭毒手','',''],['惨重','',''],['惩一儆众','',''],['惩一儆百','',''],['惩一戒百','',''],['惩一警百','',''],['惩前毖后','',''],['惩办','',''],['惩办主义','',''],['惩处','',''],['惩奖','',''],['惩忿窒欲','',''],['惩恶','',''],['惩恶劝善','',''],['惩戒','',''],['惩敛','',''],['惩治','',''],['惩治腐败','',''],['惩罚','',''],['惩罚性','',''],['惩诫','',''],['惫倦','',''],['惫懒','',''],['惫赖','',''],['惬当','',''],['惬心','',''],['惬怀','',''],['惬意','',''],['惭愧','',''],['惭色','',''],['惯了','',''],['惯于','',''],['惯例','',''],['惯偷','',''],['惯养','',''],['惯匪','',''],['惯升','',''],['惯坏','',''],['惯家','',''],['惯常','',''],['惯常于','',''],['惯性','',''],['惯性力','',''],['惯性定律','',''],['惯性系','',''],['惯手','',''],['惯技','',''],['惯挺','',''],['惯法','',''],['惯深','',''],['惯犯','',''],['惯用','',''],['惯用手','',''],['惯用法','',''],['惯用语','',''],['惯盗','',''],['惯窃','',''],['惯贼','',''],['惯量','',''],['惰性','',''],['惰性气体','',''],['想上','',''],['想不到','',''],['想不开','',''],['想不起','',''],['想不通','',''],['想买','',''],['想了','',''],['想从','',''],['想他','',''],['想以','',''],['想倒美','',''],['想做','',''],['想像','',''],['想像上','',''],['想像力','',''],['想儿','',''],['想入非非','',''],['想出','',''],['想到','',''],['想到此','',''],['想前顾后','',''],['想办法','',''],['想去','',''],['想吃','',''],['想吃天鹅肉','',''],['想吐','',''],['想听','',''],['想头','',''],['想好','',''],['想定','',''],['想家','',''],['想尽','',''],['想开','',''],['想当初','',''],['想当年','',''],['想当然','',''],['想得','',''],['想得到','',''],['想得开','',''],['想得美','',''],['想必','',''],['想念','',''],['想想','',''],['想想看','',''],['想我','',''],['想把','',''],['想方设法','',''],['想方设计','',''],['想望','',''],['想望风采','',''],['想来','',''],['想来想去','',''],['想法','',''],['想法子','',''],['想用','',''],['想着','',''],['想睡','',''],['想知','',''],['想知道','',''],['想等','',''],['想而','',''],['想要','',''],['想见','',''],['想说','',''],['想象','',''],['想象力','',''],['想象画','',''],['想起','',''],['想起来','',''],['想过','',''],['想通','',''],['想错','',''],['想问','',''],['惴惴','',''],['惴惴不安','',''],['惴栗','',''],['惶恐','',''],['惶恐不安','',''],['惶悚不安','',''],['惶惑','',''],['惶惶','',''],['惶惶不可终日','',''],['惶遽','',''],['惹下','',''],['惹不起','',''],['惹乱子','',''],['惹事','',''],['惹事招非','',''],['惹事生非','',''],['惹人','',''],['惹人厌','',''],['惹人心烦','',''],['惹人注意','',''],['惹人注目','',''],['惹出','',''],['惹喽子','',''],['惹娄子','',''],['惹得','',''],['惹怒','',''],['惹恼','',''],['惹是招非','',''],['惹是生非','',''],['惹是非','',''],['惹来','',''],['惹楼子','',''],['惹毛','',''],['惹气','',''],['惹火','',''],['惹火烧身','',''],['惹灾招祸','',''],['惹眼','',''],['惹祸','',''],['惹祸招愆','',''],['惹祸招殃','',''],['惹祸招灾','',''],['惹罪招愆','',''],['惹草拈花','',''],['惹草沾花','',''],['惹草沾风','',''],['惹草粘花','',''],['惹说','',''],['惹起','',''],['惹麻烦','',''],['惺忪','',''],['惺惺','',''],['惺惺作态','',''],['惺惺惜惺惺','',''],['惺惺相惜','',''],['惺松','',''],['愀然','',''],['愁云','',''],['愁云惭雾','',''],['愁容','',''],['愁容满面','',''],['愁山闷海','',''],['愁帽','',''],['愁思','',''],['愁眉','',''],['愁眉不展','',''],['愁眉泪眼','',''],['愁眉苦目','',''],['愁眉苦眼','',''],['愁眉苦脸','',''],['愁眉锁眼','',''],['愁红惨绿','',''],['愁绪','',''],['愁绪如麻','',''],['愁肠','',''],['愁肠九转','',''],['愁肠寸断','',''],['愁肠百结','',''],['愁苦','',''],['愁闷','',''],['愁雾','',''],['愁颜','',''],['愁颜不展','',''],['愆尤','',''],['愆期','',''],['愈加','',''],['愈发','',''],['愈合','',''],['愈复','',''],['愈大','',''],['愈好','',''],['愈小','',''],['愈差','',''],['愈描愈黑','',''],['愈易','',''],['愈是','',''],['愈显','',''],['愈来','',''],['愈来愈','',''],['愈来愈多','',''],['愈来愈少','',''],['愈来愈热','',''],['愈演愈烈','',''],['愈甚','',''],['愈益','',''],['愈能','',''],['愈长','',''],['愉快','',''],['愉悦','',''],['意上','',''],['意下','',''],['意下如何','',''],['意中','',''],['意中事','',''],['意中人','',''],['意为','',''],['意义','',''],['意义上','',''],['意义变化','',''],['意义深长','',''],['意乐','',''],['意乱','',''],['意乱心慌','',''],['意于','',''],['意亦为','',''],['意会','',''],['意做','',''],['意像','',''],['意兴','',''],['意兴索然','',''],['意兴阑珊','',''],['意切言尽','',''],['意切辞尽','',''],['意到','',''],['意匠','',''],['意即','',''],['意合情投','',''],['意向','',''],['意向书','',''],['意向性','',''],['意味','',''],['意味深长','',''],['意味着','',''],['意味著','',''],['意图','',''],['意在','',''],['意在沛公','',''],['意在笔先','',''],['意在言外','',''],['意境','',''],['意外','',''],['意外事','',''],['意外事故','',''],['意外险','',''],['意大利人','',''],['意大利式','',''],['意大利直面','',''],['意大利语','',''],['意大利青瓜','',''],['意大利面','',''],['意存笔先','',''],['意广才疏','',''],['意式浓缩咖啡','',''],['意往神驰','',''],['意得志满','',''],['意志','',''],['意志力','',''],['意志薄弱','',''],['意念','',''],['意态','',''],['意思','',''],['意思为','',''],['意思是','',''],['意急心忙','',''],['意想','',''],['意想不到','',''],['意惹情牵','',''],['意愿','',''],['意慵心懒','',''],['意懒心恢','',''],['意懒心慵','',''],['意扰心烦','',''],['意指','',''],['意攘心劳','',''],['意文','',''],['意料','',''],['意料之中','',''],['意料之外','',''],['意断恩绝','',''],['意旨','',''],['意欲','',''],['意气','',''],['意气扬扬','',''],['意气洋洋','',''],['意气用事','',''],['意气相倾','',''],['意气相合','',''],['意气相投','',''],['意气自得','',''],['意气自若','',''],['意气轩昂','',''],['意气风发','',''],['意涵','',''],['意淫','',''],['意满志得','',''],['意犹未尽','',''],['意符','',''],['意第绪语','',''],['意简','',''],['意绪','',''],['意者','',''],['意蕴','',''],['意表','',''],['意见','',''],['意见不合','',''],['意见书','',''],['意见沟通','',''],['意见箱','',''],['意见簿','',''],['意识','',''],['意识到','',''],['意识形态','',''],['意识形态领域','',''],['意识流','',''],['意译','',''],['意语','',''],['意说','',''],['意谓','',''],['意象','',''],['意趣','',''],['意转心回','',''],['意面','',''],['意马心猿','',''],['意马心辕','',''],['愕然','',''],['愚不可及','',''],['愚事','',''],['愚人','',''],['愚人节快乐','',''],['愚兄','',''],['愚公','',''],['愚公移山','',''],['愚公精神','',''],['愚勇','',''],['愚化','',''],['愚妄','',''],['愚孝','',''],['愚弄','',''],['愚弄者','',''],['愚弟','',''],['愚意','',''],['愚懦','',''],['愚拙','',''],['愚昧','',''],['愚昧无知','',''],['愚昧落后','',''],['愚民','',''],['愚民政策','',''],['愚氓','',''],['愚眉肉眼','',''],['愚笨','',''],['愚策','',''],['愚者','',''],['愚者千虑亦有一得','',''],['愚者千虑必有一得','',''],['愚者千虑或有一得','',''],['愚蒙','',''],['愚蠢','',''],['愚行','',''],['愚见','',''],['愚言','',''],['愚钝','',''],['愚附愚妇','',''],['愚陋','',''],['愚顽','',''],['愚騃','',''],['愚鲁','',''],['感人','',''],['感人心脾','',''],['感人肺肝','',''],['感人肺腑','',''],['感今怀昔','',''],['感伤','',''],['感佩','',''],['感光','',''],['感光剂','',''],['感光度','',''],['感光性','',''],['感光材料','',''],['感光片','',''],['感光纸','',''],['感光计','',''],['感兴趣','',''],['感冒','',''],['感冒药','',''],['感冒退热冲剂','',''],['感到','',''],['感到遗憾','',''],['感动','',''],['感动性','',''],['感化','',''],['感化所','',''],['感化院','',''],['感发','',''],['感受','',''],['感受力','',''],['感受器','',''],['感受性','',''],['感召','',''],['感召力','',''],['感叹','',''],['感叹句','',''],['感叹号','',''],['感叹词','',''],['感叹语','',''],['感同身受','',''],['感喟','',''],['感天动地','',''],['感奋','',''],['感官','',''],['感应','',''],['感应器','',''],['感应电动势','',''],['感应电动机','',''],['感应电流','',''],['感应线圈','',''],['感念','',''],['感怀','',''],['感性','',''],['感性认识','',''],['感恩','',''],['感恩图报','',''],['感恩戴义','',''],['感恩戴德','',''],['感恩荷德','',''],['感悟','',''],['感情','',''],['感情上','',''],['感情甚笃','',''],['感情用事','',''],['感情脆弱','',''],['感想','',''],['感愤','',''],['感愧','',''],['感慨','',''],['感慨万千','',''],['感慨万端','',''],['感慨系之','',''],['感戴','',''],['感抗','',''],['感染','',''],['感染人数','',''],['感染力','',''],['感染性','',''],['感染性腹泻','',''],['感染率','',''],['感染者','',''],['感泣','',''],['感激','',''],['感激不尽','',''],['感激流涕','',''],['感激涕泗','',''],['感激涕零','',''],['感生','',''],['感生电流','',''],['感电','',''],['感知','',''],['感知力','',''],['感知觉','',''],['感纫','',''],['感觉','',''],['感觉上','',''],['感觉到','',''],['感觉力','',''],['感觉器','',''],['感觉器官','',''],['感觉性','',''],['感觉毛','',''],['感觉神经','',''],['感觉论','',''],['感触','',''],['感言','',''],['感谢','',''],['感谢信','',''],['感谢状','',''],['感遇','',''],['感遇诗','',''],['愠容','',''],['愠怒','',''],['愠色','',''],['愣了','',''],['愣住','',''],['愣劲儿','',''],['愣地','',''],['愣头儿青','',''],['愣头愣脑','',''],['愣干','',''],['愣愣','',''],['愣着','',''],['愣神','',''],['愣神儿','',''],['愣说','',''],['愤不顾身','',''],['愤世嫉俗','',''],['愤世嫉邪','',''],['愤发','',''],['愤富','',''],['愤怒','',''],['愤恨','',''],['愤愤','',''],['愤愤不平','',''],['愤慨','',''],['愤懑','',''],['愤气填膺','',''],['愤激','',''],['愤然','',''],['愤然而起','',''],['愤青','',''],['愧不敢当','',''],['愧作','',''],['愧咎','',''],['愧对','',''],['愧怍','',''],['愧恨','',''],['愧悔无地','',''],['愧歉','',''],['愧汗','',''],['愧疚','',''],['愧痛','',''],['愧色','',''],['愧赧','',''],['愧难见人','',''],['愿为','',''],['愿人','',''],['愿付','',''],['愿去','',''],['愿受','',''],['愿听','',''],['愿心','',''],['愿意','',''],['愿意不愿意','',''],['愿景','',''],['愿服从','',''],['愿望','',''],['愿留','',''],['愿给','',''],['愿者','',''],['愿者上钩','',''],['愿能','',''],['愿赌服输','',''],['愿闻','',''],['慈乌反哺','',''],['慈乌返哺','',''],['慈和','',''],['慈善','',''],['慈善事业','',''],['慈善家','',''],['慈善抽奖','',''],['慈善机构','',''],['慈善组织','',''],['慈姑','',''],['慈孙孝子','',''],['慈心','',''],['慈悲','',''],['慈悲为本','',''],['慈母','',''],['慈母心','',''],['慈江道','',''],['慈济','',''],['慈照寺','',''],['慈爱','',''],['慈父','',''],['慈眉善目','',''],['慈眉善眼','',''],['慈石','',''],['慈祥','',''],['慈福行动','',''],['慈禧','',''],['慈禧太后','',''],['慈竹','',''],['慈霭','',''],['慈颜','',''],['慌不择路','',''],['慌乱','',''],['慌了','',''],['慌作一团','',''],['慌如隔世','',''],['慌张','',''],['慌张张','',''],['慌得','',''],['慌忙','',''],['慌恐','',''],['慌慌','',''],['慌慌不安','',''],['慌慌张张','',''],['慌手忙脚','',''],['慌手慌脚','',''],['慌淫无度','',''],['慌淫无耻','',''],['慌淫无道','',''],['慌渺不惊','',''],['慌神','',''],['慌神儿','',''],['慌谬绝伦','',''],['慌里慌张','',''],['慎之又慎','',''],['慎于','',''],['慎入','',''],['慎密','',''],['慎小谨微','',''],['慎微','',''],['慎思','',''],['慎思熟虑','',''],['慎独','',''],['慎用','',''],['慎终如始','',''],['慎终思远','',''],['慎终若始','',''],['慎终追远','',''],['慎行','',''],['慎言','',''],['慎谋','',''],['慎选','',''],['慎重','',''],['慎重从事','',''],['慎重考虑','',''],['慎防杜渐','',''],['慑服','',''],['慑物','',''],['慕光性','',''],['慕名','',''],['慕名而来','',''],['慕容','',''],['慕尼黑','',''],['慕道友','',''],['慢一点','',''],['慢下来','',''],['慢中子','',''],['慢么','',''],['慢了','',''],['慢件','',''],['慢动作','',''],['慢化剂','',''],['慢吃','',''],['慢吞吞','',''],['慢地','',''],['慢坡','',''],['慢城市','',''],['慢工出巧匠','',''],['慢工出细货','',''],['慢待','',''],['慢性','',''],['慢性子','',''],['慢性疼痛','',''],['慢性疾病','',''],['慢性病','',''],['慢悠悠','',''],['慢惊风','',''],['慢慢','',''],['慢慢儿','',''],['慢慢吃','',''],['慢慢吞吞','',''],['慢慢地','',''],['慢慢悠悠','',''],['慢慢来','',''],['慢慢的','',''],['慢慢腾腾','',''],['慢手','',''],['慢曲','',''],['慢条丝礼','',''],['慢条厮礼','',''],['慢条斯理','',''],['慢条斯礼','',''],['慢板','',''],['慢档','',''],['慢步','',''],['慢火','',''],['慢热型','',''],['慢煮','',''],['慢班','',''],['慢着','',''],['慢累积','',''],['慢脚','',''],['慢腾腾','',''],['慢藏诲盗','',''],['慢行','',''],['慢行道','',''],['慢词','',''],['慢说','',''],['慢走','',''],['慢跑','',''],['慢跑者','',''],['慢车','',''],['慢速','',''],['慢速摄影','',''],['慢镜头','',''],['慢长','',''],['慧心','',''],['慧心巧思','',''],['慧星','',''],['慧根','',''],['慧眼','',''],['慧黠','',''],['慨叹','',''],['慨然','',''],['慨然允诺','',''],['慨然应允','',''],['慨然领诺','',''],['慨解义囊','',''],['慰使','',''],['慰劳','',''],['慰勉','',''],['慰唁','',''],['慰安妇','',''],['慰抚','',''],['慰抚者','',''],['慰籍','',''],['慰藉','',''],['慰藉物','',''],['慰解','',''],['慰言','',''],['慰问','',''],['慰问信','',''],['慰问品','',''],['慰问团','',''],['慰问电','',''],['慰问袋','',''],['慰鸡之力','',''],['慵懒','',''],['慷他人之慨','',''],['慷慨','',''],['慷慨就义','',''],['慷慨悲歌','',''],['慷慨捐生','',''],['慷慨激扬','',''],['慷慨激昂','',''],['慷慨激烈','',''],['慷慨解囊','',''],['慷慨赴义','',''],['慷慨输将','',''],['慷慨陈词','',''],['憋不住','',''],['憋了','',''],['憋气','',''],['憋着','',''],['憋脚','',''],['憋闷','',''],['憎厌','',''],['憎恨','',''],['憎恶','',''],['憎称','',''],['憔悴','',''],['憧憧','',''],['憧憬','',''],['憨厚','',''],['憨头','',''],['憨子','',''],['憨实','',''],['憨态','',''],['憨态可掬','',''],['憨直','',''],['憨笑','',''],['憨脑','',''],['憨豆先生','',''],['憩儿','',''],['憩场','',''],['憩室','',''],['憩室炎','',''],['憩息','',''],['憩息处','',''],['憬悟','',''],['憬然','',''],['憷场','',''],['憷头','',''],['憾事','',''],['憾恨','',''],['懂事','',''],['懂局','',''],['懂得','',''],['懂的','',''],['懂行','',''],['懂门儿','',''],['懈弛','',''],['懈怠','',''],['懈惰','',''],['懈气','',''],['懊丧','',''],['懊恨','',''],['懊恼','',''],['懊悔','',''],['懊憹','',''],['懑然','',''],['懒于','',''],['懒人','',''],['懒作','',''],['懒做','',''],['懒办法','',''],['懒妇','',''],['懒得','',''],['懒得搭理','',''],['懒怠','',''],['懒惰','',''],['懒惰成性','',''],['懒惰者','',''],['懒惰虫','',''],['懒散','',''],['懒汉','',''],['懒洋洋','',''],['懒猫','',''],['懒腰','',''],['懒虫','',''],['懒觉','',''],['懒驴上磨屎尿多','',''],['懒骨头','',''],['懒鬼','',''],['懦夫','',''],['懦弱','',''],['懦怯','',''],['懮虑','',''],['懵懂','',''],['懵懵','',''],['懵懵懂懂','',''],['懵然','',''],['懿亲','',''],['懿旨','',''],['戆头戆脑','',''],['戆直','',''],['戆督','',''],['戈兰高地','',''],['戈壁','',''],['戈壁沙漠','',''],['戈壁滩','',''],['戈壁荒滩','',''],['戈尔','',''],['戈尔巴乔夫','',''],['戈德斯通','',''],['戈斯拉尔','',''],['戈林','',''],['戈比','',''],['戈矛','',''],['戊五醇','',''],['戊午','',''],['戊唑醇','',''],['戊型肝炎','',''],['戊夜','',''],['戊子','',''],['戊寅','',''],['戊巴比妥钠','',''],['戊戌','',''],['戊戌六君子','',''],['戊戌变法','',''],['戊戌政变','',''],['戊戌维新','',''],['戊烷','',''],['戊申','',''],['戊等','',''],['戊糖','',''],['戊级','',''],['戊辰','',''],['戊醇','',''],['戋戋','',''],['戌狗','',''],['戍卒','',''],['戍守','',''],['戍角','',''],['戍边','',''],['戎事','',''],['戎事倥偬','',''],['戎机','',''],['戎甲','',''],['戎行','',''],['戎衣','',''],['戎装','',''],['戎车','',''],['戎首','',''],['戎马','',''],['戎马一生','',''],['戎马倥偬','',''],['戎马生涯','',''],['戎马生郊','',''],['戏中','',''],['戏仿','',''],['戏侮','',''],['戏出儿','',''],['戏剧','',''],['戏剧化','',''],['戏剧家','',''],['戏剧性','',''],['戏剧等','',''],['戏剧般','',''],['戏单','',''],['戏台','',''],['戏嘻','',''],['戏团','',''],['戏园','',''],['戏园子','',''],['戏场','',''],['戏子','',''],['戏弄','',''],['戏弄者','',''],['戏报子','',''],['戏据性','',''],['戏文','',''],['戏是','',''],['戏曲','',''],['戏本','',''],['戏校','',''],['戏水','',''],['戏水者','',''],['戏法','',''],['戏照','',''],['戏班','',''],['戏的','',''],['戏目','',''],['戏码','',''],['戏票','',''],['戏种','',''],['戏耍','',''],['戏衣','',''],['戏装','',''],['戏言','',''],['戏评','',''],['戏词','',''],['戏说','',''],['戏说剧','',''],['戏谈','',''],['戏谑','',''],['戏路','',''],['戏迷','',''],['戏闹','',''],['戏院','',''],['戏馆子','',''],['成一家言','',''],['成丁','',''],['成个儿','',''],['成串','',''],['成为','',''],['成为必要','',''],['成也萧何','',''],['成也萧何败也萧何','',''],['成书','',''],['成了','',''],['成事','',''],['成事不说','',''],['成事不足','',''],['成事不足败事有余','',''],['成事在天','',''],['成交','',''],['成交价','',''],['成交量','',''],['成交额','',''],['成亲','',''],['成人','',''],['成人不自在','',''],['成人之美','',''],['成人教育','',''],['成人期','',''],['成仁','',''],['成仁取义','',''],['成仙','',''],['成份','',''],['成份股','',''],['成体','',''],['成何体统','',''],['成佛','',''],['成例','',''],['成俗','',''],['成倍','',''],['成倍增长','',''],['成像','',''],['成全','',''],['成军','',''],['成凤','',''],['成分','',''],['成列','',''],['成则为王败则为寇','',''],['成则为王败则为虏','',''],['成则为王败则为贼','',''],['成功','',''],['成功之路','',''],['成功之道','',''],['成功感','',''],['成功率','',''],['成功者','',''],['成功镇','',''],['成包','',''],['成化','',''],['成匹','',''],['成千','',''],['成千上万','',''],['成千成万','',''],['成千累万','',''],['成千论万','',''],['成华','',''],['成单','',''],['成单数','',''],['成卷','',''],['成双','',''],['成双作对','',''],['成双成对','',''],['成反比','',''],['成吉思汗','',''],['成名','',''],['成名作','',''],['成名成家','',''],['成员','',''],['成员国','',''],['成命','',''],['成品','',''],['成品机','',''],['成品油','',''],['成品率','',''],['成器','',''],['成因','',''],['成国渠','',''],['成圈','',''],['成均馆','',''],['成块','',''],['成型','',''],['成堆','',''],['成天','',''],['成套','',''],['成套设备','',''],['成妖作怪','',''],['成婚','',''],['成家','',''],['成家立业','',''],['成家立计','',''],['成对','',''],['成就','',''],['成就感','',''],['成层','',''],['成山','',''],['成年','',''],['成年人','',''],['成年累月','',''],['成年组','',''],['成年者','',''],['成形','',''],['成心','',''],['成性','',''],['成总儿','',''],['成才','',''],['成才之路','',''],['成打','',''],['成批','',''],['成批生产','',''],['成报','',''],['成排','',''],['成效','',''],['成效显著','',''],['成数','',''],['成文','',''],['成文法','',''],['成文造句','',''],['成方','',''],['成方儿','',''],['成日','',''],['成昆铁路','',''],['成服','',''],['成本','',''],['成本上升','',''],['成本会计','',''],['成本核算','',''],['成本计算','',''],['成材','',''],['成材林','',''],['成林','',''],['成果','',''],['成果奖','',''],['成果鉴定','',''],['成样','',''],['成样子','',''],['成核','',''],['成正比','',''],['成殓','',''],['成段','',''],['成比例','',''],['成气侯','',''],['成气候','',''],['成汉','',''],['成活','',''],['成活率','',''],['成渝','',''],['成渝铁路','',''],['成灾','',''],['成熟','',''],['成熟分裂','',''],['成熟期','',''],['成田','',''],['成田机场','',''],['成瘾','',''],['成癖','',''],['成百上千','',''],['成皋之战','',''],['成真','',''],['成眠','',''],['成矿','',''],['成矿作用','',''],['成礼','',''],['成穗率','',''],['成立','',''],['成章','',''],['成竹在胸','',''],['成精作怪','',''],['成约','',''],['成组','',''],['成组运输','',''],['成绩','',''],['成绩册','',''],['成绩卓然','',''],['成绩单','',''],['成绩斐然','',''],['成群','',''],['成群作队','',''],['成群结伙','',''],['成群结党','',''],['成群结队','',''],['成考移民','',''],['成舟','',''],['成色','',''],['成荫','',''],['成药','',''],['成虫','',''],['成蛹','',''],['成行','',''],['成衣','',''],['成表','',''],['成见','',''],['成规','',''],['成议','',''],['成话','',''],['成语','',''],['成语典故','',''],['成语接龙','',''],['成说','',''],['成象','',''],['成败','',''],['成败兴废','',''],['成败利钝','',''],['成败在此一举','',''],['成败得失','',''],['成败论人','',''],['成都体育大学','',''],['成长','',''],['成长中','',''],['成长率','',''],['成问题','',''],['成风','',''],['成骨','',''],['成骨不全症','',''],['成龙','',''],['成龙配套','',''],['我人','',''],['我以为','',''],['我们','',''],['我俩','',''],['我党','',''],['我哥','',''],['我国','',''],['我国人民','',''],['我国各族人民','',''],['我妈','',''],['我姐','',''],['我娃','',''],['我家','',''],['我怕','',''],['我总','',''],['我教','',''],['我方','',''],['我校','',''],['我爸','',''],['我的','',''],['我等','',''],['我能','',''],['我自己','',''],['我行我素','',''],['我见犹怜','',''],['我走','',''],['我辈','',''],['我过我的独木桥','',''],['我醉欲眠','',''],['我队','',''],['我靠','',''],['戒严','',''],['戒严令','',''],['戒严区','',''],['戒严部队','',''],['戒书','',''],['戒刀','',''],['戒勉','',''],['戒去','',''],['戒命','',''],['戒坛','',''],['戒备','',''],['戒备森严','',''],['戒备状态','',''],['戒奢崇俭','',''],['戒子','',''],['戒尺','',''],['戒弃','',''],['戒律','',''],['戒心','',''],['戒忌','',''],['戒性','',''],['戒惧','',''],['戒慎','',''],['戒指','',''],['戒掉','',''],['戒条','',''],['戒毒','',''],['戒毒所','',''],['戒烟','',''],['戒牒','',''],['戒禁','',''],['戒绝','',''],['戒者','',''],['戒色','',''],['戒行','',''],['戒规','',''],['戒赌','',''],['戒酒','',''],['戒除','',''],['戒骄','',''],['戒骄戒躁','',''],['戕害','',''],['戕害不辜','',''],['戕贼','',''],['或不','',''],['或为','',''],['或之后','',''],['或以','',''],['或使','',''],['或则','',''],['或到','',''],['或去','',''],['或变','',''],['或否','',''],['或因','',''],['或在','',''],['或多或少','',''],['或大','',''],['或如','',''],['或将','',''],['或少','',''],['或当','',''],['或意','',''],['或早','',''],['或时','',''],['或明或暗','',''],['或是','',''],['或晚','',''],['或有','',''],['或有意','',''],['或然','',''],['或然性','',''],['或然率','',''],['或用','',''],['或由','',''],['或称','',''],['或者','',''],['或者是','',''],['或者说','',''],['或能','',''],['或许','',''],['或非','',''],['戗风','',''],['战不旋踵','',''],['战书','',''],['战乱','',''],['战争','',''],['战争与和平','',''],['战争初期','',''],['战争年代','',''],['战争状态','',''],['战争罪','',''],['战争罪犯','',''],['战争贩子','',''],['战争赔偿','',''],['战争边缘政策','',''],['战争追赔','',''],['战事','',''],['战云','',''],['战例','',''],['战俘','',''],['战兢','',''],['战兢兢','',''],['战具','',''],['战况','',''],['战刀','',''],['战列舰','',''],['战利品','',''],['战前','',''],['战力','',''],['战功','',''],['战勤','',''],['战区','',''],['战友','',''],['战台','',''],['战史','',''],['战后','',''],['战团','',''],['战国','',''],['战国七雄','',''],['战国时代','',''],['战国末','',''],['战国末年','',''],['战国策','',''],['战地','',''],['战场','',''],['战场形势','',''],['战场练兵','',''],['战壕','',''],['战壕热','',''],['战士','',''],['战备','',''],['战备值班','',''],['战备动员','',''],['战备等级','',''],['战备训练','',''],['战天斗地','',''],['战将','',''],['战局','',''],['战幕','',''],['战役','',''],['战战兢兢','',''],['战战栗栗','',''],['战抖','',''],['战报','',''],['战斗','',''],['战斗不止','',''],['战斗任务','',''],['战斗侦察','',''],['战斗保障','',''],['战斗准备','',''],['战斗出动','',''],['战斗分队','',''],['战斗力','',''],['战斗化','',''],['战斗原则','',''],['战斗员','',''],['战斗序列','',''],['战斗性','',''],['战斗性能','',''],['战斗指挥','',''],['战斗支援','',''],['战斗教令','',''],['战斗机','',''],['战斗条令','',''],['战斗概则','',''],['战斗活动','',''],['战斗群','',''],['战斗者','',''],['战斗舰','',''],['战斗舰艇','',''],['战斗英雄','',''],['战斗详报','',''],['战斗运用','',''],['战斗部','',''],['战斗部队','',''],['战斗队形','',''],['战斧','',''],['战旗','',''],['战无不克','',''],['战无不胜','',''],['战时','',''],['战时共产主义','',''],['战时内阁','',''],['战术','',''],['战术上','',''],['战术家','',''],['战术导弹','',''],['战术核武器','',''],['战机','',''],['战果','',''],['战栗','',''],['战歌','',''],['战死','',''],['战法','',''],['战火','',''],['战火纷飞','',''],['战犯','',''],['战略','',''],['战略上','',''],['战略伙伴','',''],['战略储备','',''],['战略决策','',''],['战略后方','',''],['战略地位','',''],['战略夥伴','',''],['战略家','',''],['战略导弹','',''],['战略性','',''],['战略战术','',''],['战略方针','',''],['战略核力量','',''],['战略核武器','',''],['战略武器','',''],['战略物资','',''],['战略目标','',''],['战略要地','',''],['战略要点','',''],['战略转移','',''],['战略轰炸机','',''],['战略部署','',''],['战略重点','',''],['战略防御倡议','',''],['战神','',''],['战祸','',''],['战线','',''],['战绩','',''],['战者','',''],['战胜','',''],['战胜者','',''],['战舰','',''],['战船','',''],['战表','',''],['战袍','',''],['战讯','',''],['战评','',''],['战败','',''],['战车','',''],['战门性','',''],['战门机','',''],['战马','',''],['战鼓','',''],['戚凭','',''],['戚友','',''],['戚墅堰','',''],['戚属','',''],['戚戚','',''],['戚族','',''],['戚继光','',''],['戚谊','',''],['戛戛','',''],['戛戛独造','',''],['戛然','',''],['戛然而止','',''],['戛玉敲冰','',''],['戛玉敲金','',''],['戛玉锵金','',''],['戛玉鸣金','',''],['戛纳','',''],['戟指怒目','',''],['戡乱','',''],['戡乱平反','',''],['戡定','',''],['戢鳞潜翼','',''],['戥子','',''],['截住','',''],['截出','',''],['截击','',''],['截击机','',''],['截去','',''],['截发留宾','',''],['截取','',''],['截口','',''],['截听','',''],['截图','',''],['截塔','',''],['截头','',''],['截夺','',''],['截尾','',''],['截屏','',''],['截开','',''],['截成','',''],['截拦','',''],['截拳道','',''],['截掉','',''],['截收','',''],['截断','',''],['截断器','',''],['截止','',''],['截流','',''],['截然','',''],['截然不同','',''],['截煤机','',''],['截留','',''],['截瘫','',''],['截盘','',''],['截短','',''],['截程序','',''],['截稿','',''],['截线','',''],['截肢','',''],['截肢术','',''],['截至','',''],['截获','',''],['截趾适履','',''],['截距','',''],['截镫留鞭','',''],['截长补短','',''],['截门','',''],['截限','',''],['截面','',''],['戮伤','',''],['戮刺','',''],['戮力','',''],['戮力一心','',''],['戮力同心','',''],['戮力齐心','',''],['戮破','',''],['戮穿','',''],['戮记','',''],['戳不住','',''],['戳个儿','',''],['戳份儿','',''],['戳伤','',''],['戳儿','',''],['戳刺感','',''],['戳力','',''],['戳印','',''],['戳咕','',''],['戳壁脚','',''],['戳子','',''],['戳得住','',''],['戳心灌髓','',''],['戳搭','',''],['戳破','',''],['戳祸','',''],['戳穿','',''],['戳穿试验','',''],['戳脊梁','',''],['戳脊梁骨','',''],['戳记','',''],['戳进','',''],['戴上','',''],['戴了','',''],['戴以','',''],['戴假发','',''],['戴冠','',''],['戴发含齿','',''],['戴名世','',''],['戴圆履方','',''],['戴在','',''],['戴天','',''],['戴天履地','',''],['戴头','',''],['戴头巾','',''],['戴头识脸','',''],['戴套','',''],['戴奥辛','',''],['戴好','',''],['戴孝','',''],['戴安娜','',''],['戴安娜王妃','',''],['戴尔','',''],['戴帽','',''],['戴帽子','',''],['戴手镯','',''],['戴月','',''],['戴月披星','',''],['戴有色眼镜','',''],['戴桂冠','',''],['戴牢','',''],['戴白','',''],['戴盆望天','',''],['戴眼','',''],['戴眼镜','',''],['戴着','',''],['戴秉国','',''],['戴紧','',''],['戴维斯','',''],['戴维斯杯','',''],['戴维营','',''],['戴绿头巾','',''],['戴绿帽','',''],['戴绿帽子','',''],['戴罪图功','',''],['戴罪立功','',''],['戴胜','',''],['戴菊','',''],['戴菊鸟','',''],['戴表','',''],['戴面具','',''],['戴高乐','',''],['戴高帽儿','',''],['戴高帽子','',''],['戴鸡配豚','',''],['户下','',''],['户主','',''],['户内','',''],['户列簪缨','',''],['户别','',''],['户口','',''],['户口制','',''],['户口制度','',''],['户口簿','',''],['户名','',''],['户告人晓','',''],['户均','',''],['户外','',''],['户外活动','',''],['户头','',''],['户家','',''],['户对门当','',''],['户户','',''],['户政机关','',''],['户数','',''],['户枢','',''],['户枢不蠢','',''],['户枢不蠹','',''],['户牌','',''],['户牖','',''],['户籍','',''],['户给人足','',''],['户藉','',''],['户部','',''],['户部尚书','',''],['户长','',''],['户限','',''],['户限为穿','',''],['戽斗','',''],['戽水','',''],['戾气','',''],['戾龙','',''],['房下','',''],['房东','',''],['房主','',''],['房事','',''],['房产','',''],['房产中介','',''],['房产主','',''],['房产证','',''],['房价','',''],['房卡','',''],['房后','',''],['房地','',''],['房地产','',''],['房地美','',''],['房基','',''],['房契','',''],['房奴','',''],['房子','',''],['房子租','',''],['房客','',''],['房室','',''],['房屋','',''],['房屋中介','',''],['房山','',''],['房帖','',''],['房店','',''],['房捐','',''],['房改','',''],['房柁','',''],['房梁','',''],['房檐','',''],['房源','',''],['房牙','',''],['房牙子','',''],['房玄龄','',''],['房租','',''],['房租费','',''],['房管','',''],['房管局','',''],['房脊','',''],['房舍','',''],['房舱','',''],['房谋杜断','',''],['房贷','',''],['房贷银行','',''],['房费','',''],['房车','',''],['房钱','',''],['房门','',''],['房间','',''],['房顶','',''],['房魔','',''],['所不','',''],['所为','',''],['所乘','',''],['所云','',''],['所交','',''],['所付','',''],['所以','',''],['所以然','',''],['所伤','',''],['所住','',''],['所作','',''],['所作所为','',''],['所倡','',''],['所做','',''],['所写','',''],['所出','',''],['所列','',''],['所到之处','',''],['所剩','',''],['所剩无几','',''],['所办','',''],['所加','',''],['所占','',''],['所及','',''],['所发','',''],['所发现','',''],['所取','',''],['所受','',''],['所变','',''],['所向','',''],['所向披靡','',''],['所向无前','',''],['所向无敌','',''],['所向风靡','',''],['所含','',''],['所周知','',''],['所唱','',''],['所喜','',''],['所困','',''],['所图不轨','',''],['所在','',''],['所在之处','',''],['所在单位','',''],['所在地','',''],['所处','',''],['所外','',''],['所多','',''],['所多玛','',''],['所多玛与蛾摩拉','',''],['所失','',''],['所好','',''],['所存','',''],['所学','',''],['所定','',''],['所居','',''],['所属','',''],['所属单位','',''],['所希望','',''],['所带','',''],['所干','',''],['所幸','',''],['所建','',''],['所当','',''],['所征','',''],['所得','',''],['所得税','',''],['所思','',''],['所想','',''],['所感','',''],['所愿','',''],['所成','',''],['所托','',''],['所扣','',''],['所持','',''],['所指','',''],['所提','',''],['所提出','',''],['所携','',''],['所料','',''],['所有','',''],['所有主','',''],['所有人','',''],['所有制','',''],['所有权','',''],['所有格','',''],['所有物','',''],['所有者','',''],['所有这些','',''],['所未','',''],['所梦','',''],['所欠','',''],['所欲','',''],['所求','',''],['所派','',''],['所爱','',''],['所犯','',''],['所生','',''],['所用','',''],['所画','',''],['所知','',''],['所研','',''],['所示','',''],['所称','',''],['所穿','',''],['所立','',''],['所签','',''],['所经','',''],['所编','',''],['所罗巴伯','',''],['所罗门','',''],['所能','',''],['所至','',''],['所致','',''],['所获','',''],['所著','',''],['所要','',''],['所覆','',''],['所见','',''],['所见即所得','',''],['所见所闻','',''],['所言','',''],['所讲','',''],['所设','',''],['所说','',''],['所请','',''],['所谓','',''],['所购','',''],['所费','',''],['所费不资','',''],['所赚','',''],['所趋','',''],['所踏','',''],['所辖','',''],['所运','',''],['所迫','',''],['所述','',''],['所选','',''],['所造','',''],['所部','',''],['所里','',''],['所长','',''],['所长所至','',''],['所问','',''],['所闻','',''],['所附','',''],['所限','',''],['所难','',''],['所需','',''],['扁了','',''],['扁卷螺','',''],['扁圆','',''],['扁圆形','',''],['扁坯','',''],['扁头','',''],['扁平','',''],['扁平足','',''],['扁形','',''],['扁形动物','',''],['扁形动物门','',''],['扁形虫','',''],['扁扁','',''],['扁担','',''],['扁柏','',''],['扁桃','',''],['扁桃体','',''],['扁桃体炎','',''],['扁桃腺','',''],['扁桃腺炎','',''],['扁率','',''],['扁穴','',''],['扁舟','',''],['扁虫','',''],['扁虱','',''],['扁豆','',''],['扁钢','',''],['扁锉','',''],['扁锹形虫','',''],['扁长','',''],['扁额','',''],['扁食','',''],['扁骨','',''],['扁鹊','',''],['扂楔','',''],['扇人','',''],['扇具','',''],['扇动','',''],['扇区','',''],['扇子','',''],['扇形','',''],['扇枕温被','',''],['扇火止沸','',''],['扇状','',''],['扇状尾','',''],['扇贝','',''],['扇车','',''],['扇面','',''],['扇面儿','',''],['扇面琴','',''],['扇风','',''],['扇风点火','',''],['扇骨子','',''],['扈从','',''],['扉画','',''],['扉页','',''],['手上','',''],['手下','',''],['手下留情','',''],['手不停挥','',''],['手不稳','',''],['手不辍卷','',''],['手不释卷','',''],['手中','',''],['手中无权','',''],['手中有权','',''],['手举','',''],['手书','',''],['手交','',''],['手仗','',''],['手令','',''],['手儿','',''],['手册','',''],['手写','',''],['手写体','',''],['手写识别','',''],['手写辩识','',''],['手刃','',''],['手到','',''],['手到拈来','',''],['手到拿来','',''],['手到擒来','',''],['手到病除','',''],['手制','',''],['手制动','',''],['手刹车','',''],['手力','',''],['手动','',''],['手动变速器','',''],['手动挡','',''],['手劲','',''],['手势','',''],['手勤','',''],['手包','',''],['手印','',''],['手卷','',''],['手头','',''],['手头上','',''],['手头不便','',''],['手头字','',''],['手头现金','',''],['手夺','',''],['手套','',''],['手套箱','',''],['手嶌葵','',''],['手工','',''],['手工业','',''],['手工业品','',''],['手工业生产合作社','',''],['手工业社会主义改造','',''],['手工业者','',''],['手工业资本家','',''],['手工制','',''],['手工劳动','',''],['手工匠','',''],['手工台','',''],['手工工人','',''],['手工操作','',''],['手工艺','',''],['手工艺品','',''],['手工课','',''],['手巧','',''],['手巾','',''],['手帕','',''],['手底下','',''],['手式','',''],['手弹','',''],['手影','',''],['手心','',''],['手忙','',''],['手忙脚乱','',''],['手快','',''],['手急眼快','',''],['手性','',''],['手感','',''],['手慌脚乱','',''],['手戳','',''],['手打','',''],['手打字机','',''],['手扳葫芦','',''],['手扶','',''],['手扶拖拉机','',''],['手技','',''],['手抄','',''],['手抄本','',''],['手把','',''],['手把手','',''],['手抓羊肉','',''],['手拉手','',''],['手拉葫芦','',''],['手拉车','',''],['手拔','',''],['手拜','',''],['手拷','',''],['手拿','',''],['手拿包','',''],['手持','',''],['手指','',''],['手指印','',''],['手指头','',''],['手指头肚儿','',''],['手指字母','',''],['手挑选','',''],['手挥目送','',''],['手挽手','',''],['手掌','',''],['手掌状','',''],['手掣','',''],['手控','',''],['手推','',''],['手推磨','',''],['手推车','',''],['手提','',''],['手提包','',''],['手提式','',''],['手提电脑','',''],['手提箱','',''],['手搭凉棚','',''],['手携手','',''],['手摇','',''],['手摇车','',''],['手摇钻','',''],['手摇铃','',''],['手摇风琴','',''],['手旁','',''],['手无寸铁','',''],['手无缚鸡之力','',''],['手本','',''],['手札','',''],['手术','',''],['手术前','',''],['手术台','',''],['手术后','',''],['手机','',''],['手杖','',''],['手板','',''],['手板儿','',''],['手板葫芦','',''],['手枪','',''],['手柄','',''],['手植','',''],['手榴弹','',''],['手榴弹掷远','',''],['手模','',''],['手段','',''],['手民','',''],['手气','',''],['手法','',''],['手泽','',''],['手淫','',''],['手滑心慈','',''],['手炉','',''],['手爪','',''],['手版','',''],['手牵手','',''],['手环','',''],['手球','',''],['手生','',''],['手用','',''],['手电','',''],['手电筒','',''],['手画线','',''],['手疾眼快','',''],['手痒','',''],['手癣','',''],['手相','',''],['手相家','',''],['手相术','',''],['手眼','',''],['手稿','',''],['手笔','',''],['手紧','',''],['手纸','',''],['手纹','',''],['手织','',''],['手绢','',''],['手续','',''],['手续费','',''],['手编','',''],['手缝','',''],['手肘','',''],['手背','',''],['手胼足胝','',''],['手脖子','',''],['手脚','',''],['手脚无措','',''],['手腕','',''],['手腕子','',''],['手腕式','',''],['手腕式指北针','',''],['手臂','',''],['手舞足蹈','',''],['手艺','',''],['手艺人','',''],['手表','',''],['手表商','',''],['手袋','',''],['手订','',''],['手记','',''],['手语','',''],['手谈','',''],['手谕','',''],['手起刀落','',''],['手足','',''],['手足之情','',''],['手足亲情','',''],['手足口病','',''],['手足口症','',''],['手足失措','',''],['手足异处','',''],['手足无措','',''],['手足胼胝','',''],['手车','',''],['手轮','',''],['手软','',''],['手轻','',''],['手边','',''],['手迹','',''],['手部','',''],['手里','',''],['手重','',''],['手钏','',''],['手钻','',''],['手铐','',''],['手链','',''],['手锣','',''],['手锤','',''],['手锯','',''],['手镯','',''],['手长','',''],['手间','',''],['手闸','',''],['手雷','',''],['手面','',''],['手风琴','',''],['手饰','',''],['手鼓','',''],['才不','',''],['才人','',''],['才会','',''],['才使','',''],['才俊','',''],['才具','',''],['才兼文武','',''],['才分','',''],['才力','',''],['才华','',''],['才华出众','',''],['才华奔放','',''],['才华横溢','',''],['才华盖世','',''],['才可','',''],['才外流','',''],['才大难用','',''],['才女','',''],['才子','',''],['才子佳人','',''],['才学','',''],['才学兼优','',''],['才对','',''],['才将','',''],['才尽','',''],['才尽其用','',''],['才干','',''],['才广妨身','',''],['才德','',''],['才德兼备','',''],['才思','',''],['才怪','',''],['才情','',''],['才是','',''],['才智','',''],['才有','',''],['才望','',''],['才来','',''],['才气','',''],['才气无双','',''],['才气过人','',''],['才然','',''],['才略','',''],['才疏学浅','',''],['才疏德薄','',''],['才疏志大','',''],['才疏意广','',''],['才疏计拙','',''],['才知自','',''],['才短气粗','',''],['才秀人微','',''],['才算','',''],['才者','',''],['才能','',''],['才艺','',''],['才艺技能','',''],['才艺秀','',''],['才蔽识浅','',''],['才行','',''],['才识','',''],['才识过人','',''],['才貌','',''],['才貌双全','',''],['才贯二酉','',''],['才轻德厚','',''],['才过屈宋','',''],['才高八斗','',''],['才高意广','',''],['才高行厚','',''],['才高行洁','',''],['扎以尔','',''],['扎伊尔','',''],['扎伊尔人','',''],['扎伊尔河','',''],['扎伤','',''],['扎住','',''],['扎克雷起义','',''],['扎入','',''],['扎啤','',''],['扎堆','',''],['扎实','',''],['扎实推进','',''],['扎寨','',''],['扎小辫','',''],['扎尔达里','',''],['扎工','',''],['扎布机','',''],['扎幌市','',''],['扎手','',''],['扎手舞脚','',''],['扎扎','',''],['扎扎实实','',''],['扎挣','',''],['扎捆','',''],['扎根','',''],['扎格罗斯','',''],['扎格罗斯山脉','',''],['扎欧扎翁','',''],['扎款','',''],['扎牢','',''],['扎猛子','',''],['扎痛','',''],['扎眼','',''],['扎稳打','',''],['扎穿','',''],['扎紧','',''],['扎纸','',''],['扎线带','',''],['扎耳朵','',''],['扎花','',''],['扎营','',''],['扎襄','',''],['扎赉特','',''],['扎辫子','',''],['扎进','',''],['扎针','',''],['扎钢','',''],['扎马剌丁','',''],['扎马鲁丁','',''],['扎鲁特','',''],['扑住','',''],['扑作教刑','',''],['扑倒','',''],['扑克','',''],['扑克牌','',''],['扑克脸','',''],['扑出','',''],['扑到','',''],['扑动','',''],['扑去','',''],['扑向','',''],['扑哧','',''],['扑在','',''],['扑地','',''],['扑扇','',''],['扑打','',''],['扑救','',''],['扑朔','',''],['扑朔迷离','',''],['扑杀','',''],['扑杀此獠','',''],['扑棱','',''],['扑楞','',''],['扑满','',''],['扑火','',''],['扑灭','',''],['扑灭者','',''],['扑灯蛾子','',''],['扑空','',''],['扑簌','',''],['扑簌簌','',''],['扑粉','',''],['扑翼','',''],['扑脸儿','',''],['扑腾','',''],['扑虎','',''],['扑虎儿','',''],['扑跌','',''],['扑通','',''],['扑闪','',''],['扑面','',''],['扑面而来','',''],['扑鼻','',''],['扑鼻而来','',''],['扒出','',''],['扒地','',''],['扒头儿','',''],['扒寻','',''],['扒开','',''],['扒手','',''],['扒拉','',''],['扒搂','',''],['扒灰','',''],['扒犁','',''],['扒皮','',''],['扒窃','',''],['扒粪','',''],['扒糕','',''],['扒起','',''],['扒车','',''],['扒钉','',''],['扒高踩低','',''],['扒鸡','',''],['扒鸭','',''],['打上','',''],['打下','',''],['打下手','',''],['打不','',''],['打不动','',''],['打不垮','',''],['打不着','',''],['打不起精神','',''],['打不过','',''],['打不通','',''],['打个','',''],['打个照面','',''],['打中','',''],['打主意','',''],['打乱','',''],['打了','',''],['打井','',''],['打交','',''],['打交道','',''],['打人','',''],['打人骂狗','',''],['打从','',''],['打仗','',''],['打以','',''],['打价','',''],['打伙儿','',''],['打伞','',''],['打伤','',''],['打住','',''],['打作','',''],['打佯儿','',''],['打保票','',''],['打信号','',''],['打倒','',''],['打假','',''],['打先锋','',''],['打光','',''],['打光棍','',''],['打兑','',''],['打兔子','',''],['打入','',''],['打入冷宫','',''],['打冲锋','',''],['打冷战','',''],['打冷枪','',''],['打冷颤','',''],['打凤捞龙','',''],['打凤牢龙','',''],['打出','',''],['打出吊入','',''],['打出手','',''],['打击','',''],['打击乐器','',''],['打击军事力量','',''],['打击报复','',''],['打击社会财富','',''],['打分','',''],['打到','',''],['打制','',''],['打制石器','',''],['打前失','',''],['打前站','',''],['打动','',''],['打劫','',''],['打勤献趣','',''],['打勾','',''],['打勾勾','',''],['打包','',''],['打包机','',''],['打千','',''],['打卡','',''],['打卦','',''],['打印','',''],['打印台','',''],['打印头','',''],['打印服务器','',''],['打印机','',''],['打印纸','',''],['打去','',''],['打发','',''],['打发时间','',''],['打叠','',''],['打口','',''],['打听','',''],['打听好','',''],['打吵子','',''],['打呵欠','',''],['打呼','',''],['打呼噜','',''],['打哄','',''],['打哆嗦','',''],['打哈','',''],['打哈哈','',''],['打哈哈儿','',''],['打哈欠','',''],['打响','',''],['打响名号','',''],['打哑语','',''],['打啵','',''],['打喳喳','',''],['打喷','',''],['打喷嚏','',''],['打嗝','',''],['打嗝儿','',''],['打嘴','',''],['打嘴巴','',''],['打噎','',''],['打嚏喷','',''],['打围','',''],['打圆场','',''],['打圈子','',''],['打在','',''],['打地铺','',''],['打场','',''],['打坏','',''],['打坐','',''],['打垮','',''],['打埋伏','',''],['打基础','',''],['打声','',''],['打天下','',''],['打夯','',''],['打头','',''],['打头阵','',''],['打头风','',''],['打奔儿','',''],['打奶','',''],['打好','',''],['打孔','',''],['打孔器','',''],['打孔机','',''],['打孔钻','',''],['打字','',''],['打字员','',''],['打字本','',''],['打字机','',''],['打官司','',''],['打官腔','',''],['打官话','',''],['打定','',''],['打定主意','',''],['打家劫盗','',''],['打家劫舍','',''],['打家截道','',''],['打富济贫','',''],['打对仗','',''],['打对台','',''],['打小报告','',''],['打小算盘','',''],['打小鼓儿的','',''],['打尖','',''],['打屁','',''],['打屁投','',''],['打屁股','',''],['打层次','',''],['打岔','',''],['打工','',''],['打工仔','',''],['打工妹','',''],['打平','',''],['打底','',''],['打底子','',''],['打开','',''],['打开天窗说亮话','',''],['打弹子','',''],['打得','',''],['打得火热','',''],['打心眼里','',''],['打总儿','',''],['打情骂俏','',''],['打愣儿','',''],['打成','',''],['打成一片','',''],['打成平手','',''],['打我','',''],['打战','',''],['打扇','',''],['打手','',''],['打手势','',''],['打手枪','',''],['打手语','',''],['打扑','',''],['打扑克','',''],['打扫','',''],['打扫卫生','',''],['打扫工','',''],['打扫战场','',''],['打扮','',''],['打扰','',''],['打把势','',''],['打把式','',''],['打抖','',''],['打折','',''],['打折扣','',''],['打抱不平','',''],['打抽丰','',''],['打拍','',''],['打拍子','',''],['打招','',''],['打招呼','',''],['打拱','',''],['打拱作揖','',''],['打拳','',''],['打拼','',''],['打挺儿','',''],['打捞','',''],['打捞船','',''],['打掉','',''],['打探','',''],['打掩护','',''],['打援','',''],['打搅','',''],['打摆子','',''],['打擂台','',''],['打散','',''],['打整','',''],['打斋','',''],['打斗','',''],['打斜','',''],['打断','',''],['打旋','',''],['打旋儿','',''],['打旋磨儿','',''],['打旗号','',''],['打昏','',''],['打春','',''],['打晃','',''],['打晃儿','',''],['打晕','',''],['打更','',''],['打杀','',''],['打杂','',''],['打杂儿','',''],['打杈','',''],['打来','',''],['打来回','',''],['打枪','',''],['打架','',''],['打架斗殴','',''],['打柴','',''],['打校样','',''],['打样','',''],['打格子','',''],['打桩','',''],['打桩机','',''],['打棉机','',''],['打棍','',''],['打棍子','',''],['打棚','',''],['打榧子','',''],['打横','',''],['打横炮','',''],['打歪','',''],['打死','',''],['打死打伤','',''],['打死老虎','',''],['打歼灭战','',''],['打比','',''],['打气','',''],['打气筒','',''],['打水','',''],['打水漂','',''],['打油','',''],['打油诗','',''],['打法','',''],['打泡','',''],['打洞','',''],['打流','',''],['打浆','',''],['打浆机','',''],['打浑','',''],['打消','',''],['打消心意','',''],['打混','',''],['打游击','',''],['打滑','',''],['打滚','',''],['打滚撒泼','',''],['打火','',''],['打火机','',''],['打火石','',''],['打灰','',''],['打炮','',''],['打点','',''],['打点子','',''],['打点行装','',''],['打烂','',''],['打烊','',''],['打爆','',''],['打牌','',''],['打牙撂嘴','',''],['打牙犯嘴','',''],['打牙祭','',''],['打狗','',''],['打狗欺主','',''],['打猎','',''],['打球','',''],['打理','',''],['打瓜','',''],['打电报','',''],['打电话','',''],['打痛','',''],['打白条','',''],['打的','',''],['打皱','',''],['打盹','',''],['打盹儿','',''],['打眼','',''],['打眼放炮','',''],['打着','',''],['打瞌睡','',''],['打短儿','',''],['打短工','',''],['打破','',''],['打破常规','',''],['打破沙锅问到底','',''],['打破碗花花','',''],['打破纪录','',''],['打破记录','',''],['打砸抢','',''],['打碎','',''],['打磕睡','',''],['打磨','',''],['打票','',''],['打禅','',''],['打秋风','',''],['打稻机','',''],['打稿','',''],['打稿子','',''],['打箍','',''],['打算','',''],['打算盘','',''],['打簧表','',''],['打紧','',''],['打结','',''],['打绳节','',''],['打网','',''],['打群架','',''],['打翻','',''],['打翻身仗','',''],['打耳光','',''],['打肿','',''],['打肿脸充胖子','',''],['打背躬','',''],['打胎','',''],['打胜','',''],['打胜仗','',''],['打脚','',''],['打苞','',''],['打草','',''],['打草惊蛇','',''],['打药','',''],['打落','',''],['打落水狗','',''],['打著','',''],['打虫','',''],['打虫药','',''],['打蛇不死','',''],['打蛇打七寸','',''],['打蛋','',''],['打蜡','',''],['打街骂巷','',''],['打表','',''],['打褶','',''],['打诨','',''],['打诨插科','',''],['打谎','',''],['打谱','',''],['打谷','',''],['打谷场','',''],['打谷机','',''],['打败','',''],['打赌','',''],['打赖','',''],['打赢','',''],['打赤脚','',''],['打起','',''],['打起精神','',''],['打趣','',''],['打趣话','',''],['打趸儿','',''],['打跑','',''],['打跟头','',''],['打蹦儿','',''],['打躬','',''],['打躬作揖','',''],['打车','',''],['打转','',''],['打边炉','',''],['打边鼓','',''],['打过','',''],['打进','',''],['打连厢','',''],['打退','',''],['打退堂鼓','',''],['打通','',''],['打通关','',''],['打通宵','',''],['打造','',''],['打道','',''],['打道回府','',''],['打酒','',''],['打酱油','',''],['打醮','',''],['打野外','',''],['打野战','',''],['打野炮','',''],['打量','',''],['打针','',''],['打钩','',''],['打钱','',''],['打铁','',''],['打错','',''],['打锣','',''],['打长工','',''],['打长途','',''],['打门','',''],['打问','',''],['打问讯','',''],['打闷雷','',''],['打闹','',''],['打雪仗','',''],['打零','',''],['打雷','',''],['打靶','',''],['打靶场','',''],['打顶','',''],['打顿','',''],['打顿儿','',''],['打颤','',''],['打飞机','',''],['打食','',''],['打饥荒','',''],['打马虎眼','',''],['打骂','',''],['打高','',''],['打高尔夫','',''],['打高尔夫球','',''],['打鬼','',''],['打鱼','',''],['打鸟','',''],['打鸡血','',''],['打鸣儿','',''],['打黑','',''],['打鼓','',''],['打鼓儿的','',''],['打鼾','',''],['打鼾者','',''],['扔下','',''],['扔了','',''],['扔出','',''],['扔到','',''],['扔向','',''],['扔回','',''],['扔在','',''],['扔弃','',''],['扔掉','',''],['扔球','',''],['扔给','',''],['扔进','',''],['托交','',''],['托人','',''],['托人情','',''],['托付','',''],['托偶','',''],['托儿','',''],['托儿所','',''],['托出','',''],['托利党人','',''],['托办','',''],['托勒密','',''],['托勒密王','',''],['托勒玫','',''],['托叶','',''],['托名','',''],['托塔天王','',''],['托媒','',''],['托子','',''],['托孤','',''],['托孤寄命','',''],['托尔斯泰','',''],['托尔金','',''],['托幼','',''],['托庇','',''],['托情','',''],['托拉博拉','',''],['托拉尔','',''],['托拉斯','',''],['托收','',''],['托收承付','',''],['托故','',''],['托期','',''],['托木尔','',''],['托木尔峰','',''],['托板','',''],['托枪','',''],['托架','',''],['托梁','',''],['托梦','',''],['托洛茨基','',''],['托洛茨基主义','',''],['托派','',''],['托熟','',''],['托物','',''],['托物寓兴','',''],['托特','',''],['托生','',''],['托病','',''],['托盘','',''],['托着','',''],['托福','',''],['托称','',''],['托管','',''],['托管制度','',''],['托管地','',''],['托给','',''],['托罗斯山','',''],['托老所','',''],['托腮','',''],['托莱多','',''],['托词','',''],['托说','',''],['托足无门','',''],['托辞','',''],['托运','',''],['托运行李','',''],['托里拆利','',''],['托钵','',''],['托钵修会','',''],['托钵僧','',''],['托销','',''],['托陈取消派','',''],['托鞋','',''],['托马斯','',''],['托马斯・哈代','',''],['托马斯・斯特恩斯・艾略特','',''],['托马斯・阿奎纳','',''],['托马斯主义','',''],['扛大个儿','',''],['扛扛','',''],['扛活','',''],['扛着','',''],['扛起','',''],['扛长工','',''],['扛鼎拔山','',''],['扣上','',''],['扣下','',''],['扣交','',''],['扣人','',''],['扣人心弦','',''],['扣件','',''],['扣住','',''],['扣作','',''],['扣儿','',''],['扣关','',''],['扣减','',''],['扣出','',''],['扣击','',''],['扣分','',''],['扣到','',''],['扣动','',''],['扣压','',''],['扣去','',''],['扣发','',''],['扣在','',''],['扣头','',''],['扣女','',''],['扣好','',''],['扣子','',''],['扣屎盔子','',''],['扣帽子','',''],['扣应','',''],['扣式电池','',''],['扣得','',''],['扣心泣血','',''],['扣手','',''],['扣扣','',''],['扣押','',''],['扣押人','',''],['扣押者','',''],['扣掉','',''],['扣杀','',''],['扣查','',''],['扣款','',''],['扣牢','',''],['扣环','',''],['扣球','',''],['扣留','',''],['扣眼','',''],['扣眼儿','',''],['扣着','',''],['扣税','',''],['扣篮','',''],['扣紧','',''],['扣紧物','',''],['扣缴','',''],['扣肉','',''],['扣襻','',''],['扣货','',''],['扣针','',''],['扣链','',''],['扣锁','',''],['扣除','',''],['扣除额','',''],['扣鞋','',''],['扣题','',''],['扦子','',''],['扦手','',''],['扦插','',''],['执业','',''],['执两用中','',''],['执事','',''],['执勤','',''],['执友','',''],['执委会','',''],['执导','',''],['执念','',''],['执意','',''],['执拗','',''],['执拾','',''],['执掌','',''],['执政','',''],['执政党','',''],['执政官','',''],['执政方式','',''],['执政者','',''],['执政能力','',''],['执教','',''],['执柯作伐','',''],['执法','',''],['执法不严','',''],['执法如山','',''],['执法必严','',''],['执法犯法','',''],['执泥','',''],['执照','',''],['执照税','',''],['执牛耳','',''],['执白','',''],['执着','',''],['执笔','',''],['执笔人','',''],['执绋','',''],['执而不化','',''],['执著','',''],['执行','',''],['执行主席','',''],['执行人','',''],['执行任务','',''],['执行委员会','',''],['执行官','',''],['执行情况','',''],['执行指挥官','',''],['执行者','',''],['执行长','',''],['执言','',''],['执达员','',''],['执迷','',''],['执迷不悟','',''],['执鞭','',''],['执鞭坠镫','',''],['执鞭随镫','',''],['执黑','',''],['扩为','',''],['扩充','',''],['扩军','',''],['扩军备战','',''],['扩军计划','',''],['扩印','',''],['扩及','',''],['扩增','',''],['扩增实境','',''],['扩大','',''],['扩大会','',''],['扩大会议','',''],['扩大其词','',''],['扩大再生产','',''],['扩大出口','',''],['扩大化','',''],['扩大器','',''],['扩大机','',''],['扩大生产','',''],['扩孔','',''],['扩容','',''],['扩展','',''],['扩展到','',''],['扩展名','',''],['扩展性','',''],['扩延','',''],['扩建','',''],['扩建工程','',''],['扩张','',''],['扩张主义','',''],['扩张主义者','',''],['扩张政策','',''],['扩征','',''],['扩散','',''],['扩散泵','',''],['扩版','',''],['扩用','',''],['扩界','',''],['扩编','',''],['扩股','',''],['扩胸器','',''],['扩音','',''],['扩音器','',''],['扩音机','',''],['扩频','',''],['扩频通信','',''],['扪参历井','',''],['扪心','',''],['扪心无愧','',''],['扪心自问','',''],['扪虱而言','',''],['扪隙发罅','',''],['扫倒','',''],['扫光','',''],['扫兴','',''],['扫出','',''],['扫刮','',''],['扫到','',''],['扫去','',''],['扫听','',''],['扫地','',''],['扫地以尽','',''],['扫地俱尽','',''],['扫地出门','',''],['扫地无余','',''],['扫墓','',''],['扫射','',''],['扫尾','',''],['扫帚','',''],['扫帚星','',''],['扫帚菜','',''],['扫平','',''],['扫房','',''],['扫把','',''],['扫把星','',''],['扫掠','',''],['扫描','',''],['扫描仪','',''],['扫描器','',''],['扫数','',''],['扫榻','',''],['扫榻以待','',''],['扫毒','',''],['扫清','',''],['扫灭','',''],['扫田刮地','',''],['扫盲','',''],['扫眉才子','',''],['扫瞄','',''],['扫穴犁庭','',''],['扫罗','',''],['扫荡','',''],['扫荡腿','',''],['扫街','',''],['扫视','',''],['扫边','',''],['扫过','',''],['扫除','',''],['扫除天下','',''],['扫除机','',''],['扫雪','',''],['扫雪车','',''],['扫雷','',''],['扫雷坦克','',''],['扫雷战','',''],['扫雷舰','',''],['扫雷艇','',''],['扫黄','',''],['扫黄打非','',''],['扫黄运动','',''],['扬上','',''],['扬剧','',''],['扬厉','',''],['扬名','',''],['扬名后世','',''],['扬名四海','',''],['扬名显亲','',''],['扬名显姓','',''],['扬善','',''],['扬善抑恶','',''],['扬嘴','',''],['扬场','',''],['扬场机','',''],['扬声','',''],['扬声器','',''],['扬威','',''],['扬威耀武','',''],['扬子','',''],['扬子江','',''],['扬子鳄','',''],['扬己露才','',''],['扬帆','',''],['扬幡招魂','',''],['扬幡擂鼓','',''],['扬弃','',''],['扬手','',''],['扬扬','',''],['扬扬得意','',''],['扬扬自得','',''],['扬抑格','',''],['扬旗','',''],['扬榷','',''],['扬水','',''],['扬水站','',''],['扬汤止沸','',''],['扬清抑浊','',''],['扬清激浊','',''],['扬琴','',''],['扬眉','',''],['扬眉吐气','',''],['扬眉奋髯','',''],['扬眉抵掌','',''],['扬砂走石','',''],['扬科维奇','',''],['扬程','',''],['扬花','',''],['扬菜','',''],['扬葩振藻','',''],['扬言','',''],['扬谷','',''],['扬起','',''],['扬铃打鼓','',''],['扬锣捣鼓','',''],['扬镳','',''],['扬镳分路','',''],['扬长','',''],['扬长而去','',''],['扬长补短','',''],['扬长避短','',''],['扬雄','',''],['扬鞭','',''],['扭下','',''],['扭了','',''],['扭亏','',''],['扭亏为盈','',''],['扭亏为赢','',''],['扭亏增盈','',''],['扭伤','',''],['扭住','',''],['扭倒','',''],['扭出','',''],['扭力','',''],['扭力天平','',''],['扭动','',''],['扭卷','',''],['扭去','',''],['扭回','',''],['扭头','',''],['扭头别项','',''],['扭开','',''],['扭弯','',''],['扭得','',''],['扭成','',''],['扭手扭脚','',''],['扭打','',''],['扭扭','',''],['扭扭乐','',''],['扭扭捏捏','',''],['扭捏','',''],['扭搭','',''],['扭摆','',''],['扭斗','',''],['扭断','',''],['扭是为非','',''],['扭曲','',''],['扭曲作直','',''],['扭歪','',''],['扭痛','',''],['扭着','',''],['扭矩','',''],['扭秤','',''],['扭秧歌','',''],['扭紧','',''],['扭结','',''],['扭绞','',''],['扭绞者','',''],['扭股','',''],['扭股儿糖','',''],['扭脸','',''],['扭腰','',''],['扭角羚','',''],['扭身','',''],['扭转','',''],['扭转乾坤','',''],['扭转局面','',''],['扭转形变','',''],['扭送','',''],['扮个','',''],['扮作','',''],['扮做','',''],['扮像','',''],['扮得','',''],['扮戏','',''],['扮成','',''],['扮演','',''],['扮演者','',''],['扮男','',''],['扮白','',''],['扮相','',''],['扮装','',''],['扮装皇后','',''],['扮鬼','',''],['扯上','',''],['扯下','',''],['扯了','',''],['扯住','',''],['扯倒','',''],['扯到','',''],['扯去','',''],['扯后腿','',''],['扯嗓子','',''],['扯家常','',''],['扯平','',''],['扯开','',''],['扯后','',''],['扯成','',''],['扯手','',''],['扯拉','',''],['扯掉','',''],['扯断','',''],['扯旗','',''],['扯淡','',''],['扯白','',''],['扯皮','',''],['扯直','',''],['扯着','',''],['扯破','',''],['扯碎','',''],['扯离','',''],['扯空砑光','',''],['扯篷拉纤','',''],['扯裂','',''],['扯谈','',''],['扯谎','',''],['扯起','',''],['扯起来','',''],['扯进','',''],['扯远','',''],['扯铃','',''],['扯闲','',''],['扯鼓夺旗','',''],['扰乱','',''],['扰乱性','',''],['扰动','',''],['扰嚷','',''],['扰扰','',''],['扰攘','',''],['扰民','',''],['扰流板','',''],['扰频','',''],['扳不倒儿','',''],['扳价','',''],['扳动','',''],['扳回','',''],['扳头','',''],['扳子','',''],['扳平','',''],['扳开','',''],['扳手','',''],['扳指儿','',''],['扳本','',''],['扳本儿','',''],['扳机','',''],['扳紧','',''],['扳罾','',''],['扳道','',''],['扳道员','',''],['扳道岔','',''],['扳钳','',''],['扳闸','',''],['扳龙附凤','',''],['扶乩','',''],['扶他林','',''],['扶住','',''],['扶倾济弱','',''],['扶养','',''],['扶养者','',''],['扶养费','',''],['扶助','',''],['扶危','',''],['扶危定乱','',''],['扶危定倾','',''],['扶危拯溺','',''],['扶危救困','',''],['扶危济困','',''],['扶危翼倾','',''],['扶善惩恶','',''],['扶墙','',''],['扶墙摸壁','',''],['扶壁','',''],['扶她','',''],['扶弱助残','',''],['扶弱抑强','',''],['扶恤金','',''],['扶手','',''],['扶手椅','',''],['扶持','',''],['扶掖','',''],['扶揄','',''],['扶摇','',''],['扶摇直上','',''],['扶栏','',''],['扶桑','',''],['扶梯','',''],['扶椅','',''],['扶植','',''],['扶正','',''],['扶正压邪','',''],['扶正祛邪','',''],['扶正黜邪','',''],['扶清灭洋','',''],['扶灵','',''],['扶犁','',''],['扶疏','',''],['扶病','',''],['扶直','',''],['扶着','',''],['扶箕','',''],['扶织','',''],['扶老携幼','',''],['扶苗','',''],['扶贫','',''],['扶贫济困','',''],['扶起','',''],['扶轮社','',''],['扶鞍上马','',''],['扶颠持危','',''],['扶馀','',''],['扶鸾','',''],['批亢捣虚','',''],['批件','',''],['批价','',''],['批假','',''],['批八字','',''],['批准','',''],['批准书','',''],['批准者','',''],['批判','',''],['批判地','',''],['批判实在论','',''],['批判现实主义','',''],['批判者','',''],['批办','',''],['批发','',''],['批发业','',''],['批发价','',''],['批发价格','',''],['批发商','',''],['批发市场','',''],['批发部','',''],['批号','',''],['批命','',''],['批哩啪啦','',''],['批回','',''],['批处理','',''],['批复','',''],['批审','',''],['批改','',''],['批文','',''],['批斗','',''],['批条','',''],['批条子','',''],['批次','',''],['批死','',''],['批毛求疵','',''],['批汇','',''],['批注','',''],['批流年','',''],['批点','',''],['批示','',''],['批红判白','',''],['批给','',''],['批荡','',''],['批萨','',''],['批覆','',''],['批评','',''],['批评与自我批评','',''],['批评家','',''],['批评性','',''],['批评指正','',''],['批评者','',''],['批语','',''],['批货','',''],['批购','',''],['批转','',''],['批郤导窾','',''],['批量','',''],['批量生产','',''],['批量购买','',''],['批阅','',''],['批颊','',''],['批风抹月','',''],['批驳','',''],['批验','',''],['扼住','',''],['扼制','',''],['扼吭拊背','',''],['扼喉抚背','',''],['扼守','',''],['扼杀','',''],['扼杀者','',''],['扼死','',''],['扼流圈','',''],['扼腕','',''],['扼臂','',''],['扼襟控咽','',''],['扼要','',''],['扼颈','',''],['找上门','',''],['找上门来','',''],['找不到','',''],['找不着','',''],['找不着北','',''],['找不自在','',''],['找个','',''],['找了','',''],['找事','',''],['找些','',''],['找人','',''],['找他','',''],['找借口','',''],['找准','',''],['找出','',''],['找到','',''],['找到了','',''],['找刺儿','',''],['找台阶儿','',''],['找回','',''],['找头','',''],['找对象','',''],['找寻','',''],['找岔子','',''],['找工作','',''],['找平','',''],['找得着','',''],['找我','',''],['找找','',''],['找时','',''],['找机会','',''],['找来','',''],['找死','',''],['找点事干','',''],['找点活干','',''],['找病','',''],['找着','',''],['找碴','',''],['找碴儿','',''],['找空','',''],['找窍门','',''],['找缝子','',''],['找茬','',''],['找茬儿','',''],['找补','',''],['找话','',''],['找谁','',''],['找辙','',''],['找还','',''],['找遍','',''],['找那','',''],['找钱','',''],['找错','',''],['找饭碗','',''],['找麻烦','',''],['找齐','',''],['承上启下','',''],['承上起下','',''],['承乏','',''],['承付','',''],['承佃','',''],['承保人','',''],['承做','',''],['承先启后','',''],['承兑','',''],['承兑人','',''],['承兑汇票','',''],['承典','',''],['承典人','',''],['承制','',''],['承前启后','',''],['承办','',''],['承办人','',''],['承办商','',''],['承办者','',''],['承包','',''],['承包人','',''],['承包制','',''],['承包商','',''],['承包工程','',''],['承包经营','',''],['承包经营责任制','',''],['承包者','',''],['承包责任制','',''],['承包费','',''],['承印','',''],['承发包','',''],['承受','',''],['承受不住','',''],['承受人','',''],['承受力','',''],['承受能力','',''],['承台','',''],['承头','',''],['承审员','',''],['承审法官','',''],['承尘','',''],['承平','',''],['承应','',''],['承建','',''],['承当','',''],['承德地区','',''],['承心','',''],['承情','',''],['承扶','',''],['承担','',''],['承担义务','',''],['承担人','',''],['承担者','',''],['承担责任','',''],['承接','',''],['承揽','',''],['承望','',''],['承欢','',''],['承欢献媚','',''],['承欢膝下','',''],['承溜','',''],['承租','',''],['承租人','',''],['承租方','',''],['承籍','',''],['承继','',''],['承蒙','',''],['承蒙关照','',''],['承袭','',''],['承认','',''],['承认书','',''],['承认控罪','',''],['承认者','',''],['承认错误','',''],['承让','',''],['承让人','',''],['承诺','',''],['承诺人','',''],['承购','',''],['承转','',''],['承载','',''],['承载力','',''],['承运','',''],['承运人','',''],['承造','',''],['承重','',''],['承重孙','',''],['承销','',''],['承销人','',''],['承销价差','',''],['承销利差','',''],['承销品','',''],['承销商','',''],['承销团','',''],['承销店','',''],['承销货物','',''],['承面','',''],['承顺','',''],['承题','',''],['承颜候色','',''],['承风希旨','',''],['技俩','',''],['技击','',''],['技压群芳','',''],['技压群雄','',''],['技嘉','',''],['技士','',''],['技工','',''],['技工学校','',''],['技工贸','',''],['技巧','',''],['技巧运动','',''],['技师','',''],['技措','',''],['技改','',''],['技术','',''],['技术上','',''],['技术交流','',''],['技术人员','',''],['技术作物','',''],['技术发展','',''],['技术员','',''],['技术咨询','',''],['技术学校','',''],['技术室','',''],['技术家','',''],['技术开发部','',''],['技术性','',''],['技术情报','',''],['技术所限','',''],['技术指导','',''],['技术援助','',''],['技术故障','',''],['技术标准','',''],['技术潜水','',''],['技术知识','',''],['技术科','',''],['技术装备','',''],['技术规范','',''],['技术革命','',''],['技术革新','',''],['技校','',''],['技法','',''],['技痒','',''],['技穷','',''],['技能','',''],['技能上','',''],['技能检定','',''],['技艺','',''],['技艺家','',''],['技贸','',''],['技高一筹','',''],['抃悦','',''],['抃掌','',''],['抄书','',''],['抄件','',''],['抄公','',''],['抄写','',''],['抄写员','',''],['抄写者','',''],['抄列','',''],['抄发','',''],['抄后路','',''],['抄回','',''],['抄在','',''],['抄家','',''],['抄录','',''],['抄手','',''],['抄抄','',''],['抄报','',''],['抄收','',''],['抄斩','',''],['抄本','',''],['抄查','',''],['抄用','',''],['抄纸','',''],['抄网','',''],['抄获','',''],['抄袭','',''],['抄走','',''],['抄身','',''],['抄近','',''],['抄近儿','',''],['抄近路','',''],['抄送','',''],['抄送单位','',''],['抄造','',''],['抄道','',''],['抄集','',''],['抉择','',''],['抉搞','',''],['抉摘','',''],['抉瑕掩瑜','',''],['把你','',''],['把儿','',''],['把兄弟','',''],['把关','',''],['把势','',''],['把头','',''],['把好','',''],['把妹','',''],['把子','',''],['把守','',''],['把家','',''],['把尿','',''],['把弄','',''],['把式','',''],['把总','',''],['把戏','',''],['把手','',''],['把持','',''],['把持不定','',''],['把持住','',''],['把捉','',''],['把握','',''],['把揽','',''],['把斋','',''],['把柄','',''],['把牢','',''],['把玩','',''],['把玩无厌','',''],['把盏','',''],['把稳','',''],['把素持斋','',''],['把脉','',''],['把臂入林','',''],['把舵','',''],['把袂','',''],['把酒','',''],['把门','',''],['把风','',''],['把饭叫饥','',''],['抑且','',''],['抑低','',''],['抑制','',''],['抑制作用','',''],['抑制剂','',''],['抑制器','',''],['抑制物','',''],['抑制者','',''],['抑制酶','',''],['抑压','',''],['抑压器','',''],['抑压者','',''],['抑塞磊落','',''],['抑强扶弱','',''],['抑恶扬善','',''],['抑或','',''],['抑扬','',''],['抑扬升降性','',''],['抑扬格','',''],['抑扬顿挫','',''],['抑抑','',''],['抑是','',''],['抑格','',''],['抑止','',''],['抑素','',''],['抑菌','',''],['抑菌作用','',''],['抑贬','',''],['抑郁','',''],['抑郁不乐','',''],['抑郁不平','',''],['抑郁寡欢','',''],['抑郁症','',''],['抑音','',''],['抒写','',''],['抒发','',''],['抒怀','',''],['抒情','',''],['抒情诗','',''],['抒意','',''],['抒解','',''],['抓举','',''],['抓了','',''],['抓人','',''],['抓伤','',''],['抓住','',''],['抓出','',''],['抓到','',''],['抓力','',''],['抓功夫','',''],['抓包','',''],['抓去','',''],['抓取','',''],['抓取程序','',''],['抓哏','',''],['抓地','',''],['抓地力','',''],['抓头挖耳','',''],['抓好','',''],['抓子儿','',''],['抓尖要强','',''],['抓工夫','',''],['抓差','',''],['抓得','',''],['抓手','',''],['抓拍','',''],['抓挠','',''],['抓捕','',''],['抓掀','',''],['抓握','',''],['抓斗','',''],['抓点','',''],['抓牢','',''],['抓狂','',''],['抓痒','',''],['抓痕','',''],['抓着','',''],['抓瞎','',''],['抓破','',''],['抓破脸','',''],['抓空子','',''],['抓紧','',''],['抓紧学习','',''],['抓紧抓好','',''],['抓紧时间','',''],['抓纲','',''],['抓耳挠腮','',''],['抓耳搔腮','',''],['抓背用','',''],['抓膘','',''],['抓苗头','',''],['抓茬儿','',''],['抓药','',''],['抓获','',''],['抓词','',''],['抓贼','',''],['抓赌','',''],['抓走','',''],['抓起','',''],['抓辫子','',''],['抓过','',''],['抓钩','',''],['抓阄','',''],['抓阄儿','',''],['抓饭','',''],['抓髻','',''],['投下','',''],['投中','',''],['投书','',''],['投于','',''],['投井','',''],['投井下石','',''],['投产','',''],['投亲','',''],['投亲靠友','',''],['投以','',''],['投保','',''],['投保人','',''],['投保方','',''],['投信','',''],['投光灯','',''],['投入','',''],['投入产出','',''],['投入市场','',''],['投入生产','',''],['投其所好','',''],['投军','',''],['投出','',''],['投击','',''],['投函','',''],['投到','',''],['投去','',''],['投合','',''],['投向','',''],['投回','',''],['投壶','',''],['投契','',''],['投奔','',''],['投宿','',''],['投宿者','',''],['投寄','',''],['投射','',''],['投射物','',''],['投山窜海','',''],['投币','',''],['投币口','',''],['投币孔','',''],['投师','',''],['投店','',''],['投弃','',''],['投弹','',''],['投弹员','',''],['投弹手','',''],['投影','',''],['投影中心','',''],['投影仪','',''],['投影几何','',''],['投影几何学','',''],['投影图','',''],['投影机','',''],['投影线','',''],['投影面','',''],['投怀送抱','',''],['投戈讲艺','',''],['投手','',''],['投报','',''],['投掷','',''],['投掷者','',''],['投放','',''],['投放市场','',''],['投效','',''],['投敌','',''],['投料','',''],['投明','',''],['投木报琼','',''],['投机','',''],['投机买卖','',''],['投机倒把','',''],['投机取巧','',''],['投机商','',''],['投机者','',''],['投杀','',''],['投杼之感','',''],['投杼之疑','',''],['投杼市虎','',''],['投枪','',''],['投标','',''],['投标人','',''],['投标者','',''],['投栏','',''],['投桃之报','',''],['投桃报李','',''],['投案','',''],['投案自首','',''],['投梭','',''],['投梭折齿','',''],['投水','',''],['投河','',''],['投河奔井','',''],['投河觅井','',''],['投注','',''],['投海','',''],['投环','',''],['投球','',''],['投生','',''],['投畀豺虎','',''],['投看','',''],['投石','',''],['投石下井','',''],['投石問路','',''],['投石器','',''],['投石者','',''],['投石问路','',''],['投硬币','',''],['投票','',''],['投票人','',''],['投票匦','',''],['投票地点','',''],['投票所','',''],['投票数','',''],['投票机器','',''],['投票权','',''],['投票率','',''],['投票站','',''],['投票箱','',''],['投票者','',''],['投稿','',''],['投稿者','',''],['投笔','',''],['投笔从戎','',''],['投笔肤谈','',''],['投篮','',''],['投篮机','',''],['投簧','',''],['投缘','',''],['投缳','',''],['投缳自缢','',''],['投考','',''],['投考者','',''],['投股','',''],['投胎','',''],['投膏止火','',''],['投药','',''],['投袂援戈','',''],['投袂而起','',''],['投袂荷戈','',''],['投诉','',''],['投诉信','',''],['投诉者','',''],['投诚','',''],['投资','',''],['投资客','',''],['投资人','',''],['投资回报率','',''],['投资家','',''],['投资总额','',''],['投资报酬率','',''],['投资数','',''],['投资气氛','',''],['投资环境','',''],['投资者','',''],['投资规模','',''],['投资选择','',''],['投资银行','',''],['投资额','',''],['投资风险','',''],['投身','',''],['投身于','',''],['投进','',''],['投送','',''],['投递','',''],['投递员','',''],['投递送','',''],['投钱戏','',''],['投闲置散','',''],['投阱下石','',''],['投降','',''],['投降主义','',''],['投降书','',''],['投靠','',''],['投鞭断流','',''],['投鼠之忌','',''],['投鼠忌器','',''],['抖乱','',''],['抖出','',''],['抖动','',''],['抖去','',''],['抖开','',''],['抖搂','',''],['抖擞','',''],['抖擞精神','',''],['抖松','',''],['抖瑟','',''],['抖索','',''],['抖缩','',''],['抖翻','',''],['抖落','',''],['抖著','',''],['抗丁','',''],['抗争','',''],['抗体','',''],['抗倒伏','',''],['抗倭斗争','',''],['抗倾覆','',''],['抗凝','',''],['抗凝固','',''],['抗凝血剂','',''],['抗击','',''],['抗力','',''],['抗压','',''],['抗压强度','',''],['抗原','',''],['抗原决定簇','',''],['抗反射','',''],['抗命','',''],['抗坏血酸','',''],['抗大','',''],['抗寒','',''],['抗尘走俗','',''],['抗属','',''],['抗干扰','',''],['抗御','',''],['抗忧郁药','',''],['抗性','',''],['抗感染','',''],['抗战','',''],['抗抗生素','',''],['抗拉强度','',''],['抗拒','',''],['抗拒从严','',''],['抗捐','',''],['抗敌','',''],['抗日','',''],['抗日军政大学','',''],['抗日战争','',''],['抗日救亡团体','',''],['抗日救亡运动','',''],['抗日救国','',''],['抗日民族统一战线','',''],['抗旱','',''],['抗暴','',''],['抗核加固','',''],['抗毒','',''],['抗毒性','',''],['抗毒素','',''],['抗毒血清','',''],['抗氧','',''],['抗氧剂','',''],['抗氧化','',''],['抗氧化剂','',''],['抗水','',''],['抗洪','',''],['抗洪抢险','',''],['抗洪救灾','',''],['抗活','',''],['抗涝','',''],['抗溶','',''],['抗溶剂','',''],['抗火','',''],['抗灾','',''],['抗炎性','',''],['抗热','',''],['抗热合金','',''],['抗生','',''],['抗生素','',''],['抗生菌','',''],['抗用','',''],['抗病','',''],['抗病毒','',''],['抗病毒药','',''],['抗癌','',''],['抗直','',''],['抗真菌','',''],['抗着','',''],['抗碱','',''],['抗磁','',''],['抗礼','',''],['抗税','',''],['抗粮','',''],['抗精神病','',''],['抗组织胺','',''],['抗组胺','',''],['抗组胺剂','',''],['抗组胺药','',''],['抗缴','',''],['抗美','',''],['抗美援朝','',''],['抗美援朝运动','',''],['抗耐甲氧西林金葡菌','',''],['抗药','',''],['抗药性','',''],['抗药能力','',''],['抗菌','',''],['抗菌剂','',''],['抗菌增效剂','',''],['抗菌法','',''],['抗菌甲硝唑','',''],['抗菌素','',''],['抗菌药','',''],['抗菌血清','',''],['抗虫','',''],['抗血清','',''],['抗衡','',''],['抗议','',''],['抗议者','',''],['抗诉','',''],['抗辩','',''],['抗辩人','',''],['抗辩者','',''],['抗过','',''],['抗逆性','',''],['抗酸','',''],['抗震','',''],['抗震剂','',''],['抗震性','',''],['抗震救灾','',''],['抗震救灾指挥部','',''],['抗震结构','',''],['抗静电','',''],['抗风','',''],['抗风火柴','',''],['折中','',''],['折中主义','',''],['折价','',''],['折伞','',''],['折信','',''],['折倒','',''],['折光','',''],['折兑','',''],['折冲','',''],['折冲厌难','',''],['折冲尊俎','',''],['折冲御侮','',''],['折冲樽俎','',''],['折凳','',''],['折刀','',''],['折刀儿','',''],['折半','',''],['折反','',''],['折受','',''],['折变','',''],['折叠','',''],['折叠式','',''],['折叠椅','',''],['折号','',''],['折合','',''],['折向','',''],['折回','',''],['折头','',''],['折奏','',''],['折子','',''],['折子戏','',''],['折实','',''],['折寿','',''],['折射','',''],['折射器','',''],['折射性','',''],['折射率','',''],['折射线','',''],['折射计','',''],['折小','',''],['折尺','',''],['折帐','',''],['折干','',''],['折床','',''],['折弯','',''],['折成','',''],['折戟','',''],['折戟沉沙','',''],['折扇','',''],['折扣','',''],['折抵','',''],['折挫','',''],['折损','',''],['折断','',''],['折断撉','',''],['折旧','',''],['折旧率','',''],['折旧费','',''],['折曲','',''],['折服','',''],['折本','',''],['折杀','',''],['折枝','',''],['折柳攀花','',''],['折桂','',''],['折桂攀蟾','',''],['折椅','',''],['折款','',''],['折煞','',''],['折物','',''],['折现','',''],['折现率','',''],['折痕','',''],['折皱','',''],['折磨','',''],['折福','',''],['折秤','',''],['折笔','',''],['折算','',''],['折箩','',''],['折箭','',''],['折纸','',''],['折线','',''],['折缝','',''],['折罪','',''],['折耗','',''],['折股','',''],['折腰','',''],['折腰五斗','',''],['折腰升斗','',''],['折腾','',''],['折节','',''],['折节下士','',''],['折节待士','',''],['折节礼士','',''],['折节读书','',''],['折行','',''],['折衷','',''],['折衷主义','',''],['折衷派','',''],['折衷鹦鹉','',''],['折裙','',''],['折角','',''],['折让','',''],['折起','',''],['折跟头','',''],['折转','',''],['折辱','',''],['折边','',''],['折过儿','',''],['折返','',''],['折迭','',''],['折钱','',''],['折长补短','',''],['折页','',''],['抚人','',''],['抚今','',''],['抚今思昔','',''],['抚今追昔','',''],['抚使','',''],['抚养','',''],['抚养成人','',''],['抚养权','',''],['抚养费','',''],['抚军','',''],['抚古思今','',''],['抚孤恤寡','',''],['抚平','',''],['抚弄','',''],['抚循','',''],['抚心自问','',''],['抚恤','',''],['抚恤金','',''],['抚慰','',''],['抚慰性','',''],['抚慰者','',''],['抚慰金','',''],['抚抱','',''],['抚拍','',''],['抚掌','',''],['抚掌大笑','',''],['抚摩','',''],['抚摸','',''],['抚梁易柱','',''],['抚爱','',''],['抚琴','',''],['抚绥','',''],['抚育','',''],['抚背扼喉','',''],['抚躬自问','',''],['抚远三角洲','',''],['抛下','',''],['抛下锚','',''],['抛光','',''],['抛光机','',''],['抛出','',''],['抛却','',''],['抛向','',''],['抛售','',''],['抛头露面','',''],['抛媚眼','',''],['抛射','',''],['抛射体','',''],['抛射物','',''],['抛开','',''],['抛弃','',''],['抛戈卸甲','',''],['抛戈弃甲','',''],['抛手','',''],['抛投','',''],['抛掉','',''],['抛掷','',''],['抛撒','',''],['抛散','',''],['抛洒','',''],['抛物','',''],['抛物线','',''],['抛物面','',''],['抛球','',''],['抛生耦','',''],['抛砖','',''],['抛砖引玉','',''],['抛离','',''],['抛空','',''],['抛绣球','',''],['抛脸','',''],['抛荒','',''],['抛补','',''],['抛补套利','',''],['抛费','',''],['抛起','',''],['抛进','',''],['抛金弃鼓','',''],['抛锚','',''],['抛鸾拆凤','',''],['抟沙','',''],['抟沙作饭','',''],['抟沙嚼蜡','',''],['抟砂弄汞','',''],['抟风','',''],['抟饭','',''],['抟香弄粉','',''],['抠出','',''],['抠字眼','',''],['抠字眼儿','',''],['抠心挖肚','',''],['抠心挖胆','',''],['抠破','',''],['抠门','',''],['抠门儿','',''],['抡刀','',''],['抡拳','',''],['抡棍','',''],['抡眉竖目','',''],['抢亲','',''],['抢人','',''],['抢修','',''],['抢先','',''],['抢先一步','',''],['抢光','',''],['抢到','',''],['抢劫','',''],['抢劫案','',''],['抢劫犯','',''],['抢劫罪','',''],['抢占','',''],['抢去','',''],['抢嘴','',''],['抢在','',''],['抢地呼天','',''],['抢墒','',''],['抢夺','',''],['抢婚','',''],['抢完','',''],['抢得','',''],['抢戏','',''],['抢手','',''],['抢手货','',''],['抢掠','',''],['抢收','',''],['抢救','',''],['抢救无效','',''],['抢时间','',''],['抢案','',''],['抢渡','',''],['抢滩','',''],['抢生意','',''],['抢白','',''],['抢眼','',''],['抢着','',''],['抢种','',''],['抢购','',''],['抢购一空','',''],['抢购风','',''],['抢走','',''],['抢跑','',''],['抢过','',''],['抢运','',''],['抢通','',''],['抢镜头','',''],['抢险','',''],['抢险救灾','',''],['抢风','',''],['抢风头','',''],['抢风航行','',''],['护佑','',''],['护兵','',''],['护养','',''],['护卫','',''],['护卫舰','',''],['护卫艇','',''],['护卫队','',''],['护发','',''],['护发乳','',''],['护发素','',''],['护国','',''],['护国佑民','',''],['护国军','',''],['护国战','',''],['护国战争','',''],['护国运动','',''],['护坡','',''],['护城','',''],['护城河','',''],['护堤','',''],['护墙','',''],['护墙板','',''],['护壁','',''],['护壁板','',''],['护士','',''],['护士长','',''],['护套','',''],['护封','',''],['护层','',''],['护岸','',''],['护岸林','',''],['护带','',''],['护手盘','',''],['护手霜','',''],['护持','',''],['护旗','',''],['护板','',''],['护林','',''],['护林员','',''],['护林防火','',''],['护柩者','',''],['护栏','',''],['护校','',''],['护民','',''],['护民官','',''],['护法','',''],['护法战争','',''],['护法神','',''],['护法运动','',''],['护海商法','',''],['护照','',''],['护理','',''],['护理学','',''],['护田林','',''],['护甲','',''],['护盖物','',''],['护目镜','',''],['护着','',''],['护短','',''],['护神','',''],['护税','',''],['护符','',''],['护老者','',''],['护耳','',''],['护肘','',''],['护肤','',''],['护肤品','',''],['护肤膏','',''],['护肩','',''],['护胫','',''],['护胸','',''],['护腿','',''],['护膝','',''],['护航','',''],['护航舰','',''],['护花','',''],['护贝机','',''],['护路','',''],['护路林','',''],['护身','',''],['护身法','',''],['护身符','',''],['护身符子','',''],['护过饰非','',''],['护运','',''],['护送','',''],['护送者','',''],['护驾','',''],['护鼻','',''],['报上','',''],['报业','',''],['报丧','',''],['报亭','',''],['报人','',''],['报仇','',''],['报仇雪恨','',''],['报仇雪耻','',''],['报以','',''],['报价','',''],['报价人','',''],['报价单','',''],['报作','',''],['报信','',''],['报偿','',''],['报关','',''],['报冤','',''],['报出','',''],['报分','',''],['报刊','',''],['报刊发行','',''],['报刊摊','',''],['报刊杂志','',''],['报到','',''],['报功','',''],['报务','',''],['报务员','',''],['报单','',''],['报名','',''],['报名表','',''],['报名费','',''],['报告','',''],['报告书','',''],['报告人','',''],['报告会','',''],['报告员','',''],['报告团','',''],['报告文学','',''],['报喜','',''],['报喜不报忧','',''],['报喜也报忧','',''],['报国','',''],['报复','',''],['报复主义','',''],['报复心理','',''],['报复性','',''],['报失','',''],['报头','',''],['报夹','',''],['报子','',''],['报官','',''],['报审','',''],['报导','',''],['报导文学','',''],['报帐','',''],['报帖','',''],['报幕','',''],['报应','',''],['报应不爽','',''],['报废','',''],['报录','',''],['报录人','',''],['报德','',''],['报忧','',''],['报怨','',''],['报恩','',''],['报户口','',''],['报批','',''],['报损','',''],['报捷','',''],['报摊','',''],['报摘','',''],['报效','',''],['报效祖国','',''],['报数','',''],['报文','',''],['报时','',''],['报春','',''],['报春花','',''],['报晓','',''],['报本反始','',''],['报条','',''],['报查','',''],['报栏','',''],['报案','',''],['报检','',''],['报界','',''],['报盘','',''],['报知','',''],['报社','',''],['报禁','',''],['报称','',''],['报税','',''],['报税单','',''],['报税表','',''],['报穷','',''],['报窝','',''],['报章','',''],['报童','',''],['报端','',''],['报答','',''],['报系','',''],['报纸','',''],['报纸报导','',''],['报纸杂志','',''],['报经','',''],['报缴','',''],['报考','',''],['报聘','',''],['报表','',''],['报装','',''],['报警','',''],['报警器','',''],['报话机','',''],['报说','',''],['报请','',''],['报谦','',''],['报账','',''],['报贩亭','',''],['报费','',''],['报转','',''],['报载','',''],['报送','',''],['报道','',''],['报道失实','',''],['报道说','',''],['报酬','',''],['报销','',''],['报错','',''],['报领','',''],['报馆','',''],['报验','',''],['报讯','',''],['抨击','',''],['抨弹','',''],['披上','',''],['披发缨冠','',''],['披古通今','',''],['披在','',''],['披垂','',''],['披头','',''],['披头四乐团','',''],['披头散发','',''],['披巾','',''],['披庥带孝','',''],['披心沥血','',''],['披拂','',''],['披挂','',''],['披挂上阵','',''],['披散','',''],['披星带月','',''],['披星戴月','',''],['披枷带锁','',''],['披榛采兰','',''],['披毛戴角','',''],['披毛求疵','',''],['披毛犀','',''],['披沙剖璞','',''],['披沙拣金','',''],['披沙简金','',''],['披沥','',''],['披沥肝胆','',''],['披甲','',''],['披盖','',''],['披着','',''],['披索','',''],['披红','',''],['披红挂彩','',''],['披缁削发','',''],['披肝挂胆','',''],['披肝沥胆','',''],['披肝沥血','',''],['披肝露胆','',''],['披肩','',''],['披荆斩棘','',''],['披萨','',''],['披著','',''],['披袍擐甲','',''],['披览','',''],['披针形','',''],['披阅','',''],['披露','',''],['披露肝胆','',''],['披靡','',''],['披风','',''],['披麻','',''],['披麻带孝','',''],['披麻带索','',''],['披麻戴孝','',''],['披麻救火','',''],['抬不','',''],['抬不起头来','',''],['抬举','',''],['抬价','',''],['抬出','',''],['抬升','',''],['抬头','',''],['抬头纹','',''],['抬抬','',''],['抬捧','',''],['抬杠','',''],['抬枪','',''],['抬棺者','',''],['抬的','',''],['抬着','',''],['抬秤','',''],['抬筐','',''],['抬肩','',''],['抬脸','',''],['抬裉','',''],['抬走','',''],['抬起','',''],['抬起头来','',''],['抬轿','',''],['抬轿子','',''],['抬阁','',''],['抬高','',''],['抱不','',''],['抱不平','',''],['抱了','',''],['抱令守律','',''],['抱以','',''],['抱住','',''],['抱佛脚','',''],['抱偏见','',''],['抱关击柝','',''],['抱养','',''],['抱厦','',''],['抱在','',''],['抱境息民','',''],['抱头','',''],['抱头大哭','',''],['抱头痛哭','',''],['抱头缩项','',''],['抱头鼠窜','',''],['抱头鼠蹿','',''],['抱委屈','',''],['抱子弄孙','',''],['抱子甘蓝','',''],['抱存','',''],['抱定','',''],['抱宝怀珍','',''],['抱屈','',''],['抱布贸丝','',''],['抱怨','',''],['抱恙','',''],['抱恨','',''],['抱恨终天','',''],['抱恨终身','',''],['抱愧','',''],['抱憾','',''],['抱成一团','',''],['抱抱','',''],['抱抱团','',''],['抱抱装','',''],['抱拳','',''],['抱持','',''],['抱摔','',''],['抱有','',''],['抱有偏见','',''],['抱有成见','',''],['抱枕','',''],['抱椠怀铅','',''],['抱歉','',''],['抱残','',''],['抱残守缺','',''],['抱残守阙','',''],['抱犊崮','',''],['抱病','',''],['抱着','',''],['抱窝','',''],['抱粗腿','',''],['抱素怀朴','',''],['抱紧','',''],['抱者','',''],['抱腰','',''],['抱草','',''],['抱草瘟','',''],['抱著','',''],['抱蔓摘瓜','',''],['抱薪救火','',''],['抱薪救焚','',''],['抱蛋','',''],['抱诚守真','',''],['抱负','',''],['抱负不凡','',''],['抱起','',''],['抱进','',''],['抵事','',''],['抵交','',''],['抵付','',''],['抵住','',''],['抵作','',''],['抵借','',''],['抵债','',''],['抵偿','',''],['抵充','',''],['抵免','',''],['抵冲','',''],['抵减','',''],['抵制','',''],['抵华','',''],['抵命','',''],['抵岸','',''],['抵帐','',''],['抵得住','',''],['抵御','',''],['抵悟','',''],['抵扣','',''],['抵扳','',''],['抵抗','',''],['抵抗力','',''],['抵抗性','',''],['抵抗者','',''],['抵押','',''],['抵押品','',''],['抵押权','',''],['抵押者','',''],['抵押贷款','',''],['抵押贷款危机','',''],['抵拒','',''],['抵拨','',''],['抵挡','',''],['抵换','',''],['抵掌','',''],['抵掌而谈','',''],['抵排','',''],['抵撞','',''],['抵敌','',''],['抵死瞒生','',''],['抵死谩生','',''],['抵毁','',''],['抵消','',''],['抵牾','',''],['抵瑕蹈隙','',''],['抵用','',''],['抵用券','',''],['抵留','',''],['抵税','',''],['抵罪','',''],['抵补','',''],['抵触','',''],['抵触情绪','',''],['抵账','',''],['抵赖','',''],['抵足而卧','',''],['抵足而眠','',''],['抵足谈心','',''],['抵达','',''],['抵过','',''],['抵还','',''],['抵销','',''],['抵顶','',''],['抹一鼻子灰','',''],['抹上','',''],['抹不下脸','',''],['抹不掉','',''],['抹了','',''],['抹刀','',''],['抹去','',''],['抹嘴','',''],['抹子','',''],['抹布','',''],['抹抹','',''],['抹掉','',''],['抹搭','',''],['抹月批风','',''],['抹杀','',''],['抹油','',''],['抹泪揉眵','',''],['抹消','',''],['抹灰','',''],['抹煞','',''],['抹片','',''],['抹磁','',''],['抹稀泥','',''],['抹粉','',''],['抹粉施脂','',''],['抹胸','',''],['抹脖','',''],['抹脖子','',''],['抹脸','',''],['抹茶','',''],['抹角','',''],['抹角转弯','',''],['抹零','',''],['抹面','',''],['抹香','',''],['抹香粉','',''],['抹香鲸','',''],['抹黑','',''],['抹黑了','',''],['抻面','',''],['押上','',''],['押人','',''],['押住','',''],['押出','',''],['押后','',''],['押头','',''],['押宝','',''],['押尾','',''],['押帐','',''],['押平声韵','',''],['押当','',''],['押往','',''],['押抵','',''],['押柜','',''],['押款','',''],['押汇','',''],['押沙龙','',''],['押注','',''],['押物','',''],['押着','',''],['押租','',''],['押给','',''],['押解','',''],['押账','',''],['押车','',''],['押运','',''],['押运员','',''],['押送','',''],['押金','',''],['押阵','',''],['押韵','',''],['抽丁','',''],['抽丝','',''],['抽丝剥茧','',''],['抽中','',''],['抽像','',''],['抽像性','',''],['抽冷子','',''],['抽凤','',''],['抽出','',''],['抽出物','',''],['抽到','',''],['抽动','',''],['抽印','',''],['抽去','',''],['抽取','',''],['抽吸','',''],['抽咽','',''],['抽嘴巴','',''],['抽噎','',''],['抽回','',''],['抽地','',''],['抽壮丁','',''],['抽头','',''],['抽奖','',''],['抽完','',''],['抽审','',''],['抽尽','',''],['抽屉','',''],['抽工夫','',''],['抽干','',''],['抽得出','',''],['抽成','',''],['抽打','',''],['抽抽噎噎','',''],['抽拨','',''],['抽换','',''],['抽掉','',''],['抽提','',''],['抽插','',''],['抽搐','',''],['抽搦','',''],['抽搭','',''],['抽支烟','',''],['抽斗','',''],['抽时间','',''],['抽暇','',''],['抽机','',''],['抽杀','',''],['抽查','',''],['抽样','',''],['抽样检查','',''],['抽样调查','',''],['抽检','',''],['抽气','',''],['抽气机','',''],['抽水','',''],['抽水机','',''],['抽水泵','',''],['抽水站','',''],['抽水马桶','',''],['抽油烟机','',''],['抽泣','',''],['抽泵','',''],['抽点','',''],['抽烟','',''],['抽烟斗','',''],['抽烟者','',''],['抽痛','',''],['抽着','',''],['抽税','',''],['抽穗','',''],['抽穗期','',''],['抽空','',''],['抽筋','',''],['抽筋剥皮','',''],['抽签','',''],['抽简禄马','',''],['抽紧','',''],['抽纱','',''],['抽线','',''],['抽绎','',''],['抽缩','',''],['抽考','',''],['抽胎换骨','',''],['抽脂','',''],['抽芽','',''],['抽菸','',''],['抽薪止沸','',''],['抽薹','',''],['抽血','',''],['抽调','',''],['抽象','',''],['抽象代数','',''],['抽象劳动','',''],['抽象化','',''],['抽象域','',''],['抽象思维','',''],['抽象性','',''],['抽象概念','',''],['抽象派','',''],['抽象词','',''],['抽资','',''],['抽走','',''],['抽身','',''],['抽钉拔楔','',''],['抽阅','',''],['抽青配白','',''],['抽风','',''],['抽验','',''],['抽黄对白','',''],['抿住','',''],['抿嘴','',''],['抿子','',''],['抿没','',''],['抿著','',''],['拂到','',''],['拂动','',''],['拂去','',''],['拂尘','',''],['拂扫','',''],['拂拂','',''],['拂拭','',''],['拂晓','',''],['拂煦','',''],['拂衣而去','',''],['拂袖','',''],['拂袖而去','',''],['拂袖而归','',''],['拂袖而起','',''],['拂面','',''],['拄著','',''],['担不是','',''],['担任','',''],['担保','',''],['担保人','',''],['担名','',''],['担子','',''],['担当','',''],['担当者','',''],['担待','',''],['担心','',''],['担忧','',''],['担惊','',''],['担惊受怕','',''],['担惊受恐','',''],['担懮','',''],['担承','',''],['担担面','',''],['担架','',''],['担架兵','',''],['担架床','',''],['担架式','',''],['担架抬','',''],['担水','',''],['担着','',''],['担着心','',''],['担荷','',''],['担误','',''],['担负','',''],['担责任','',''],['担运','',''],['担雪塞井','',''],['担雪填井','',''],['担雪填河','',''],['担风险','',''],['拆下','',''],['拆东墙补西墙','',''],['拆东补西','',''],['拆了','',''],['拆伙','',''],['拆借','',''],['拆兑','',''],['拆分','',''],['拆卖','',''],['拆卸','',''],['拆去','',''],['拆台','',''],['拆墙脚','',''],['拆字','',''],['拆封','',''],['拆屋','',''],['拆帐','',''],['拆开','',''],['拆息','',''],['拆成','',''],['拆掉','',''],['拆接','',''],['拆放款','',''],['拆散','',''],['拆旧','',''],['拆机','',''],['拆桥','',''],['拆毁','',''],['拆洗','',''],['拆烂污','',''],['拆用','',''],['拆白','',''],['拆白道字','',''],['拆碑道字','',''],['拆穿','',''],['拆线','',''],['拆股','',''],['拆装','',''],['拆西补东','',''],['拆角','',''],['拆解','',''],['拆解开','',''],['拆账','',''],['拆迁','',''],['拆除','',''],['拇战','',''],['拇指','',''],['拇指甲','',''],['拇指痕','',''],['拇趾','',''],['拈弄','',''],['拈指','',''],['拈斤播两','',''],['拈来','',''],['拈花','',''],['拈花弄月','',''],['拈花微笑','',''],['拈花惹草','',''],['拈花摘叶','',''],['拈花摘草','',''],['拈轻','',''],['拈轻怕重','',''],['拈酸吃醋','',''],['拈量','',''],['拈阄儿','',''],['拈香','',''],['拉丁','',''],['拉丁人','',''],['拉丁化','',''],['拉丁字母','',''],['拉丁文','',''],['拉丁文字','',''],['拉丁方块','',''],['拉丁美洲','',''],['拉丁舞','',''],['拉三扯四','',''],['拉上','',''],['拉下','',''],['拉下脸','',''],['拉丝','',''],['拉丝模','',''],['拉个手','',''],['拉买卖','',''],['拉了','',''],['拉亏空','',''],['拉交情','',''],['拉亮','',''],['拉人','',''],['拉什卡尔加','',''],['拉什莫尔山','',''],['拉伤','',''],['拉伸','',''],['拉伸强度','',''],['拉伸形变','',''],['拉住','',''],['拉倒','',''],['拉克替醇','',''],['拉入','',''],['拉关系','',''],['拉兹莫夫斯基','',''],['拉冈','',''],['拉出','',''],['拉到','',''],['拉制','',''],['拉力','',''],['拉力器','',''],['拉力赛','',''],['拉动','',''],['拉勾','',''],['拉勾儿','',''],['拉包尔','',''],['拉匝禄','',''],['拉卜楞寺','',''],['拉去','',''],['拉各斯','',''],['拉合尔','',''],['拉后腿','',''],['拉呱儿','',''],['拉回','',''],['拉升','',''],['拉在','',''],['拉场子','',''],['拉圾','',''],['拉坏','',''],['拉大','',''],['拉大便','',''],['拉大旗作虎皮','',''],['拉大条','',''],['拉大片','',''],['拉夫','',''],['拉夫堡','',''],['拉夫堡大学','',''],['拉夫桑贾尼','',''],['拉夫罗夫','',''],['拉奎拉','',''],['拉套','',''],['拉姆安拉','',''],['拉姆斯菲尔德','',''],['拉客','',''],['拉家带口','',''],['拉家常','',''],['拉小','',''],['拉尔维克','',''],['拉尼娅','',''],['拉尼娜','',''],['拉屎','',''],['拉巴','',''],['拉巴斯','',''],['拉巴特','',''],['拉布拉多','',''],['拉帐','',''],['拉帕斯','',''],['拉帮结伙','',''],['拉帮结派','',''],['拉平','',''],['拉床','',''],['拉延','',''],['拉开','',''],['拉开帷幕','',''],['拉开序幕','',''],['拉开战幕','',''],['拉开架势','',''],['拉开档次','',''],['拉开距离','',''],['拉弓','',''],['拉得','',''],['拉德','',''],['拉成','',''],['拉手','',''],['拉扯','',''],['拉拉','',''],['拉拉扯扯','',''],['拉拉杂杂','',''],['拉拉队','',''],['拉拔','',''],['拉拢','',''],['拉拽','',''],['拉掉','',''],['拉撒路','',''],['拉文克劳','',''],['拉文纳','',''],['拉斐尔','',''],['拉斐特','',''],['拉断','',''],['拉斯帕尔马斯','',''],['拉斯穆森','',''],['拉斯维加斯','',''],['拉普兰','',''],['拉普拉斯','',''],['拉曳','',''],['拉朽摧枯','',''],['拉杂','',''],['拉杆','',''],['拉杆机','',''],['拉条','',''],['拉松','',''],['拉架','',''],['拉格朗日','',''],['拉格比','',''],['拉模','',''],['拉比','',''],['拉沙病毒','',''],['拉法兰','',''],['拉法格','',''],['拉法赫','',''],['拉洋片','',''],['拉特格斯大学','',''],['拉狄克','',''],['拉环','',''],['拉琴','',''],['拉瓦尔','',''],['拉瓦锡','',''],['拉生意','',''],['拉登','',''],['拉皮','',''],['拉皮条','',''],['拉盖尔','',''],['拉直','',''],['拉着','',''],['拉票','',''],['拉科鲁尼亚','',''],['拉秧','',''],['拉稀','',''],['拉窗','',''],['拉筋','',''],['拉管','',''],['拉簧','',''],['拉米夫定','',''],['拉紧','',''],['拉纤','',''],['拉纳卡','',''],['拉线','',''],['拉练','',''],['拉细','',''],['拉网','',''],['拉美','',''],['拉美国家','',''],['拉美西斯','',''],['拉肚子','',''],['拉脚','',''],['拉茶','',''],['拉莫斯','',''],['拉菲草','',''],['拉萨条约','',''],['拉裂','',''],['拉话','',''],['拉货','',''],['拉贾斯坦邦','',''],['拉赫曼尼诺夫','',''],['拉走','',''],['拉起','',''],['拉车','',''],['拉辛','',''],['拉达克','',''],['拉过','',''],['拉近','',''],['拉近乎','',''],['拉选票','',''],['拉那烈','',''],['拉里','',''],['拉钩','',''],['拉链','',''],['拉锁','',''],['拉锯','',''],['拉锯战','',''],['拉长','',''],['拉长脸','',''],['拉门','',''],['拉青格','',''],['拉面','',''],['拉顿','',''],['拉饥荒','',''],['拉马特甘','',''],['拉高','',''],['拉魂腔','',''],['拉鲁','',''],['拉鲁湿地国家自然保护区','',''],['拉齐奥','',''],['拊掌','',''],['拊髀','',''],['拌住','',''],['拌入','',''],['拌勺','',''],['拌匀','',''],['拌和','',''],['拌嘴','',''],['拌嘴斗舌','',''],['拌用','',''],['拌种','',''],['拌菜','',''],['拌蒜','',''],['拌面','',''],['拌饭','',''],['拍人','',''],['拍出','',''],['拍击','',''],['拍动','',''],['拍卖','',''],['拍卖人','',''],['拍卖会','',''],['拍卖商','',''],['拍卖场','',''],['拍去','',''],['拍发','',''],['拍号','',''],['拍声','',''],['拍婆子','',''],['拍子','',''],['拍客','',''],['拍岸','',''],['拍巴掌','',''],['拍快照','',''],['拍戏','',''],['拍成','',''],['拍手','',''],['拍手叫好','',''],['拍手声','',''],['拍手拍脚','',''],['拍手称快','',''],['拍手者','',''],['拍打','',''],['拍打物','',''],['拍拖','',''],['拍掉','',''],['拍掌','',''],['拍摄','',''],['拍板','',''],['拍板定案','',''],['拍板成交','',''],['拍案','',''],['拍案叫绝','',''],['拍案惊奇','',''],['拍案称奇','',''],['拍案而起','',''],['拍档','',''],['拍照','',''],['拍片','',''],['拍球','',''],['拍电','',''],['拍电影','',''],['拍着','',''],['拍砖','',''],['拍纸簿','',''],['拍背','',''],['拍胸脯','',''],['拍马','',''],['拍马屁','',''],['拍马者','',''],['拎包','',''],['拎起','',''],['拐入','',''],['拐卖','',''],['拐去','',''],['拐品','',''],['拐子','',''],['拐带','',''],['拐弯','',''],['拐弯儿','',''],['拐弯处','',''],['拐弯抹角','',''],['拐杖','',''],['拐棍','',''],['拐点','',''],['拐肘','',''],['拐脖','',''],['拐脖儿','',''],['拐角','',''],['拐角处','',''],['拐诱','',''],['拐走','',''],['拐过','',''],['拐骗','',''],['拒不','',''],['拒不悔改','',''],['拒不执行','',''],['拒不接受','',''],['拒不认付','',''],['拒之','',''],['拒之门外','',''],['拒交','',''],['拒人千里之外','',''],['拒付','',''],['拒受','',''],['拒开','',''],['拒捕','',''],['拒收','',''],['拒敌','',''],['拒斥','',''],['拒服','',''],['拒留','',''],['拒礼','',''],['拒签','',''],['拒给','',''],['拒绝','',''],['拒绝执行','',''],['拒绝者','',''],['拒缴','',''],['拒腐防变','',''],['拒虎进狼','',''],['拒谏','',''],['拒谏饰非','',''],['拒贿','',''],['拒赔','',''],['拒载','',''],['拓印','',''],['拓土开疆','',''],['拓宽','',''],['拓展','',''],['拓广','',''],['拓开','',''],['拓扑','',''],['拓扑学','',''],['拓扑空间','',''],['拓扑结构','',''],['拓拔','',''],['拓本','',''],['拓朴','',''],['拓殖','',''],['拓片','',''],['拓草','',''],['拓荒','',''],['拓荒者','',''],['拓落不羁','',''],['拓补','',''],['拓跋','',''],['拓跋魏','',''],['拓边','',''],['拔万论千','',''],['拔万轮千','',''],['拔下','',''],['拔丝','',''],['拔了','',''],['拔出','',''],['拔刀抽楔','',''],['拔刀相助','',''],['拔刀相济','',''],['拔剑','',''],['拔动','',''],['拔十失五','',''],['拔十得五','',''],['拔去','',''],['拔取','',''],['拔地','',''],['拔地倚天','',''],['拔地参天','',''],['拔地摇山','',''],['拔地而起','',''],['拔宅上升','',''],['拔宅飞升','',''],['拔尖','',''],['拔尖儿','',''],['拔山举鼎','',''],['拔山扛鼎','',''],['拔山超海','',''],['拔开','',''],['拔掉','',''],['拔擢','',''],['拔新领异','',''],['拔本塞源','',''],['拔来报往','',''],['拔染','',''],['拔树寻根','',''],['拔树撼山','',''],['拔根','',''],['拔步','',''],['拔毒','',''],['拔毛','',''],['拔毛连茹','',''],['拔河','',''],['拔海','',''],['拔涉','',''],['拔火','',''],['拔火罐','',''],['拔火罐儿','',''],['拔牙','',''],['拔犀擢象','',''],['拔白','',''],['拔秧','',''],['拔类超群','',''],['拔缝','',''],['拔罐','',''],['拔罐子','',''],['拔罐法','',''],['拔群出类','',''],['拔脚','',''],['拔腿','',''],['拔节','',''],['拔节期','',''],['拔苗','',''],['拔苗助长','',''],['拔茅茹','',''],['拔茅连茹','',''],['拔草','',''],['拔萃','',''],['拔萃出类','',''],['拔萃出群','',''],['拔营','',''],['拔葵去织','',''],['拔葵断枣','',''],['拔起','',''],['拔身','',''],['拔还','',''],['拔钉锤','',''],['拔锚','',''],['拔除','',''],['拔顶','',''],['拔高','',''],['拖下','',''],['拖下水','',''],['拖人下水','',''],['拖住','',''],['拖债','',''],['拖儿带女','',''],['拖入','',''],['拖出','',''],['拖到','',''],['拖力','',''],['拖动','',''],['拖动力','',''],['拖吊车','',''],['拖后腿','',''],['拖地','',''],['拖地板','',''],['拖垮','',''],['拖堂','',''],['拖天扫地','',''],['拖宕','',''],['拖家带口','',''],['拖尾巴','',''],['拖布','',''],['拖带','',''],['拖延','',''],['拖延战术','',''],['拖延时间','',''],['拖延者','',''],['拖后','',''],['拖慢','',''],['拖把','',''],['拖拉','',''],['拖拉机','',''],['拖拉机厂','',''],['拖拉机手','',''],['拖拖拉拉','',''],['拖拖沓沓','',''],['拖挂','',''],['拖捞','',''],['拖捞船','',''],['拖放','',''],['拖斗','',''],['拖曳','',''],['拖曳机','',''],['拖曳物','',''],['拖曳缆','',''],['拖来','',''],['拖来拖去','',''],['拖板','',''],['拖柴垂青','',''],['拖欠','',''],['拖沓','',''],['拖油瓶','',''],['拖泥','',''],['拖泥带水','',''],['拖洗','',''],['拖湍','',''],['拖牵索道','',''],['拖男带女','',''],['拖男挟女','',''],['拖着','',''],['拖磨','',''],['拖粪','',''],['拖累','',''],['拖绳','',''],['拖网','',''],['拖脏','',''],['拖至','',''],['拖航','',''],['拖船','',''],['拖著','',''],['拖行','',''],['拖走','',''],['拖足','',''],['拖车','',''],['拖车头','',''],['拖轮','',''],['拖运','',''],['拖进','',''],['拖链','',''],['拖长','',''],['拖青纡紫','',''],['拖鞋','',''],['拖驳','',''],['拖麻拽布','',''],['拗不过','',''],['拗口','',''],['拗口令','',''],['拗性','',''],['拗断','',''],['拗曲作直','',''],['拗陷','',''],['拘于','',''],['拘传','',''],['拘俗守常','',''],['拘囚','',''],['拘囿','',''],['拘守','',''],['拘役','',''],['拘忌','',''],['拘执','',''],['拘押','',''],['拘押营','',''],['拘拿','',''],['拘挛','',''],['拘挛儿','',''],['拘挛补衲','',''],['拘捕','',''],['拘文牵义','',''],['拘文牵俗','',''],['拘束','',''],['拘束不安','',''],['拘板','',''],['拘检','',''],['拘泥','',''],['拘泥小节','',''],['拘牵','',''],['拘留','',''],['拘留所','',''],['拘留犯','',''],['拘礼','',''],['拘票','',''],['拘禁','',''],['拘管','',''],['拘系','',''],['拘虚','',''],['拘谨','',''],['拘迂','',''],['拙于言词','',''],['拙作','',''],['拙劣','',''],['拙口钝腮','',''],['拙口钝辞','',''],['拙嘴','',''],['拙嘴笨舌','',''],['拙政园','',''],['拙朴','',''],['拙涩','',''],['拙直','',''],['拙稿','',''],['拙笔','',''],['拙笨','',''],['拙荆','',''],['拙著','',''],['拙行','',''],['拙见','',''],['拙集','',''],['拚写','',''],['拚到','',''],['拚去','',''],['拚命','',''],['拚弃','',''],['拚搏','',''],['拚死','',''],['拚法','',''],['拚财','',''],['拚贴','',''],['拚除','',''],['招事','',''],['招亡纳叛','',''],['招亲','',''],['招人','',''],['招人喜欢','',''],['招供','',''],['招兵','',''],['招兵买马','',''],['招军买马','',''],['招到','',''],['招募','',''],['招呼','',''],['招呼站','',''],['招商','',''],['招商局','',''],['招商引店','',''],['招商引资','',''],['招女婿','',''],['招子','',''],['招安','',''],['招展','',''],['招工','',''],['招干','',''],['招式','',''],['招引','',''],['招待','',''],['招待人','',''],['招待会','',''],['招待员','',''],['招待所','',''],['招待费','',''],['招徕','',''],['招怨','',''],['招惹','',''],['招手','',''],['招投标','',''],['招抚','',''],['招揽','',''],['招揽生意','',''],['招摇','',''],['招摇撞骗','',''],['招摇过市','',''],['招收','',''],['招数','',''],['招是惹非','',''],['招是揽非','',''],['招权纳贿','',''],['招权纳赂','',''],['招权纳赇','',''],['招来','',''],['招架','',''],['招架不住','',''],['招标','',''],['招法','',''],['招潮蟹','',''],['招灾','',''],['招灾惹祸','',''],['招灾揽祸','',''],['招牌','',''],['招牌动作','',''],['招牌纸','',''],['招牌菜','',''],['招生','',''],['招生工作','',''],['招盘','',''],['招眼','',''],['招祸','',''],['招租','',''],['招笑儿','',''],['招考','',''],['招聘','',''],['招聘会','',''],['招聘制','',''],['招聘协调人','',''],['招聘机构','',''],['招聘者','',''],['招股','',''],['招股书','',''],['招股说明书','',''],['招致','',''],['招花惹草','',''],['招蜂','',''],['招认','',''],['招议','',''],['招诱','',''],['招请','',''],['招财','',''],['招财猫','',''],['招财进宝','',''],['招贤','',''],['招贤下士','',''],['招贤纳士','',''],['招贴','',''],['招贴画','',''],['招赘','',''],['招起','',''],['招门纳婿','',''],['招降','',''],['招降纳叛','',''],['招集','',''],['招领','',''],['招风','',''],['招风惹草','',''],['招风惹雨','',''],['招风揽火','',''],['招鬼','',''],['招魂','',''],['拜上帝会','',''],['拜人','',''],['拜人为师','',''],['拜会','',''],['拜伦','',''],['拜佛','',''],['拜倒','',''],['拜倒辕门','',''],['拜别','',''],['拜到','',''],['拜匣','',''],['拜占庭','',''],['拜受','',''],['拜台','',''],['拜堂','',''],['拜墓','',''],['拜天地','',''],['拜官','',''],['拜客','',''],['拜寿','',''],['信拜寿','',''],['拜将封候','',''],['拜师','',''],['拜年','',''],['拜忏','',''],['拜托','',''],['拜扫','',''],['拜把','',''],['拜把子','',''],['拜拜','',''],['拜揖','',''],['拜明','',''],['拜服','',''],['拜望','',''],['拜火教','',''],['拜物','',''],['拜物教','',''],['拜登','',''],['拜相封候','',''],['拜神','',''],['拜祭','',''],['拜科努尔','',''],['拜科努尔航天发射基地','',''],['拜节','',''],['拜见','',''],['拜访','',''],['拜读','',''],['拜谒','',''],['拜谢','',''],['拜贺','',''],['拜跪','',''],['拜辞','',''],['拜金','',''],['拜金主义','',''],['拜鬼','',''],['拜鬼求神','',''],['拟上','',''],['拟于','',''],['拟于不伦','',''],['拟人','',''],['拟人法','',''],['拟人观','',''],['拟价','',''],['拟任','',''],['拟作','',''],['拟像','',''],['拟写','',''],['拟出','',''],['拟制','',''],['拟办','',''],['拟卤素','',''],['拟古','',''],['拟古之作','',''],['拟古体','',''],['拟合','',''],['拟向','',''],['拟圆','',''],['拟声','',''],['拟声唱法','',''],['拟声词','',''],['拟妥','',''],['拟娩','',''],['拟定','',''],['拟就','',''],['拟态','',''],['拟文','',''],['拟有','',''],['拟球','',''],['拟稿','',''],['拟订','',''],['拟议','',''],['拟议调停','',''],['拟请','',''],['拟请照准','',''],['拟调','',''],['拟阿拖品药物','',''],['拟音','',''],['拢共','',''],['拢在','',''],['拢子','',''],['拢岸','',''],['拢总','',''],['拢攥','',''],['拣佛烧香','',''],['拣信室','',''],['拣出','',''],['拣去','',''],['拣精拣肥','',''],['拣起','',''],['拣软的欺','',''],['拣选','',''],['拣选出','',''],['拥入','',''],['拥兵','',''],['拥兵玩寇','',''],['拥兵自固','',''],['拥军','',''],['拥军优属','',''],['拥军爱民','',''],['拥吻','',''],['拥堵','',''],['拥塞','',''],['拥彗先驱','',''],['拥彗清道','',''],['拥彗迎门','',''],['拥戴','',''],['拥护','',''],['拥护者','',''],['拥抱','',''],['拥抱者','',''],['拥挤','',''],['拥挤不堪','',''],['拥政爱民','',''],['拥政爱民运动','',''],['拥有','',''],['拥有权','',''],['拥王','',''],['拥登','',''],['拥着','',''],['拥立','',''],['拥趸','',''],['拥雾翻波','',''],['拦住','',''],['拦击','',''],['拦劫','',''],['拦截','',''],['拦截机','',''],['拦截者','',''],['拦挡','',''],['拦柜','',''],['拦水','',''],['拦水堰','',''],['拦河','',''],['拦河坝','',''],['拦洪','',''],['拦洪坝','',''],['拦网','',''],['拦腰','',''],['拦蓄','',''],['拦路','',''],['拦路抢劫','',''],['拦路虎','',''],['拦路贼','',''],['拦车','',''],['拦道木','',''],['拦阻','',''],['拧干','',''],['拧开','',''],['拧态病','',''],['拧成','',''],['拧成一股绳','',''],['拧断','',''],['拧条','',''],['拧松','',''],['拧紧','',''],['拧转','',''],['拨万轮千','',''],['拨下','',''],['拨乱之才','',''],['拨乱兴治','',''],['拨乱反正','',''],['拨乱反治','',''],['拨乱济危','',''],['拨乱济时','',''],['拨乱诛暴','',''],['拨云撩雨','',''],['拨云睹日','',''],['拨云见日','',''],['拨交','',''],['拨付','',''],['拨作','',''],['拨冗','',''],['拨准','',''],['拨出','',''],['拨刺','',''],['拨剌','',''],['拨动','',''],['拨叫式','',''],['拨号','',''],['拨号盘','',''],['拨号网络','',''],['拨号连接','',''],['拨号音','',''],['拨奏','',''],['拨子','',''],['拨子弹','',''],['拨工','',''],['拨开','',''],['拨弄','',''],['拨弦乐器','',''],['拨快','',''],['拨慢','',''],['拨打','',''],['拨拉','',''],['拨拨','',''],['拨款','',''],['拨正','',''],['拨浪鼓','',''],['拨火','',''],['拨火棍','',''],['拨火罐儿','',''],['拨用','',''],['拨电','',''],['拨秧机','',''],['拨给','',''],['拨缴','',''],['拨草寻蛇','',''],['拨补','',''],['拨通','',''],['拨雨撩云','',''],['拨高','',''],['择一','',''],['择不开','',''],['择主而事','',''],['择交','',''],['择交而友','',''],['择人而事','',''],['择优','',''],['择优上岗','',''],['择优录取','',''],['择优录用','',''],['择优选用','',''],['择偶','',''],['择刺','',''],['择友','',''],['择吉','',''],['择向','',''],['择善','',''],['择善固执','',''],['择善而从','',''],['择善而行','',''],['择地而蹈','',''],['择定','',''],['择席','',''],['择度','',''],['择引','',''],['择性','',''],['择日','',''],['择日子','',''],['择木而处','',''],['择物','',''],['择福宜重','',''],['择肥而噬','',''],['择菜','',''],['择要','',''],['择言','',''],['择译','',''],['括入','',''],['括号','',''],['括囊守禄','',''],['括囊拱手','',''],['括在','',''],['括弧','',''],['括毒','',''],['括约肌','',''],['括线','',''],['拭了','',''],['拭去','',''],['拭子','',''],['拭抹','',''],['拭擦','',''],['拭泪','',''],['拭目','',''],['拭目以俟','',''],['拭目以待','',''],['拭目以观','',''],['拭目倾耳','',''],['拭目而待','',''],['拭除','',''],['拮据','',''],['拯危扶溺','',''],['拯救','',''],['拯溺扶危','',''],['拯溺救焚','',''],['拱了','',''],['拱出','',''],['拱券','',''],['拱北','',''],['拱卫','',''],['拱圈','',''],['拱坝','',''],['拱墅','',''],['拱墩','',''],['拱壁','',''],['拱壮','',''],['拱度','',''],['拱廊','',''],['拱廊似','',''],['拱形','',''],['拱心石','',''],['拱手','',''],['拱手听命','',''],['拱手垂裳','',''],['拱手投降','',''],['拱手旁观','',''],['拱手相让','',''],['拱手而降','',''],['拱抱','',''],['拱曲','',''],['拱月','',''],['拱木','',''],['拱柱','',''],['拱桥','',''],['拱洞','',''],['拱状','',''],['拱璧','',''],['拱立','',''],['拱翻','',''],['拱肩','',''],['拱肩缩背','',''],['拱背','',''],['拱腰','',''],['拱起','',''],['拱道','',''],['拱门','',''],['拱面','',''],['拱顶','',''],['拱顶石','',''],['拳击','',''],['拳击台','',''],['拳击家','',''],['拳击手','',''],['拳击比赛','',''],['拳击选手','',''],['拳坛','',''],['拳头','',''],['拳头产品','',''],['拳师','',''],['拳手','',''],['拳打','',''],['拳打脚踢','',''],['拳拳','',''],['拳拳服膺','',''],['拳斗','',''],['拳曲','',''],['拳术','',''],['拳棒','',''],['拳法','',''],['拳王','',''],['拳脚','',''],['拳脚交加','',''],['拳脚相向','',''],['拳赛','',''],['拳道','',''],['拳皇','',''],['拴上','',''],['拴住','',''],['拴在','',''],['拴牢','',''],['拴着','',''],['拴紧','',''],['拴绳','',''],['拴锁','',''],['拶刑','',''],['拶子','',''],['拶指','',''],['拷打','',''],['拷掠','',''],['拷火','',''],['拷盘','',''],['拷纱','',''],['拷绸','',''],['拷花','',''],['拷贝','',''],['拷边','',''],['拷边工','',''],['拷问','',''],['拷问台','',''],['拼上','',''],['拼了','',''],['拼争','',''],['拼做','',''],['拼写','',''],['拼写错误','',''],['拼凑','',''],['拼出','',''],['拼到底','',''],['拼刺','',''],['拼刺刀','',''],['拼力','',''],['拼双','',''],['拼合','',''],['拼命','',''],['拼命三郎','',''],['拼命吃','',''],['拼命讨好','',''],['拼图','',''],['拼图玩具','',''],['拼字','',''],['拼字法','',''],['拼成','',''],['拼抢','',''],['拼拢','',''],['拼接','',''],['拼搏','',''],['拼搏精神','',''],['拼攒','',''],['拼斗','',''],['拼杀','',''],['拼板','',''],['拼板游戏','',''],['拼板玩具','',''],['拼板胶','',''],['拼桌','',''],['拼死','',''],['拼死拼活','',''],['拼法','',''],['拼火','',''],['拼版','',''],['拼盘','',''],['拼缀','',''],['拼花地板','',''],['拼装','',''],['拼读','',''],['拼贴','',''],['拼起来','',''],['拼车','',''],['拼错','',''],['拼错字','',''],['拼音','',''],['拼音字母','',''],['拼音文字','',''],['拼音阶段','',''],['拽了','',''],['拽住','',''],['拽布披麻','',''],['拽拳丢跌','',''],['拽步','',''],['拽着','',''],['拽耙扶犁','',''],['拽象拖犀','',''],['拾人余唾','',''],['拾人唾余','',''],['拾人唾涕','',''],['拾人涕唾','',''],['拾人牙慧','',''],['拾元','',''],['拾到','',''],['拾去','',''],['拾取','',''],['拾取者','',''],['拾得','',''],['拾得品','',''],['拾掇','',''],['拾物','',''],['拾级','',''],['拾级而上','',''],['拾者','',''],['拾芥','',''],['拾荒','',''],['拾起','',''],['拾趣','',''],['拾遗','',''],['拾遗补缺','',''],['拾遗补阙','',''],['拾金不昧','',''],['拾零','',''],['拾音器','',''],['拿上','',''],['拿下','',''],['拿不','',''],['拿不准','',''],['拿不出手','',''],['拿不动','',''],['拿不定主意','',''],['拿主意','',''],['拿乔','',''],['拿事','',''],['拿云捉月','',''],['拿云握雾','',''],['拿人','',''],['拿住','',''],['拿俄米','',''],['拿出','',''],['拿出手','',''],['拿出来','',''],['拿到','',''],['拿办','',''],['拿印把儿','',''],['拿去','',''],['拿回','',''],['拿大','',''],['拿大头','',''],['拿大顶','',''],['拿好','',''],['拿定','',''],['拿开','',''],['拿得','',''],['拿得起放得下','',''],['拿手','',''],['拿手好戏','',''],['拿手菜','',''],['拿捏','',''],['拿捕','',''],['拿掉','',''],['拿撒勒','',''],['拿权','',''],['拿来','',''],['拿枪','',''],['拿架子','',''],['拿班作势','',''],['拿用','',''],['拿着','',''],['拿着鸡毛当令箭','',''],['拿督','',''],['拿破仑','',''],['拿破仑・波拿巴','',''],['拿稳','',''],['拿粗挟细','',''],['拿糖','',''],['拿糖作醋','',''],['拿给','',''],['拿腔作势','',''],['拿腔拿调','',''],['拿获','',''],['拿著','',''],['拿薪水','',''],['拿贼拿赃','',''],['拿贼要赃拿奸要双','',''],['拿贼见赃','',''],['拿走','',''],['拿起','',''],['拿近点','',''],['拿钱','',''],['拿铁','',''],['拿铁咖啡','',''],['拿顶','',''],['拿顺','',''],['拿骚','',''],['持不','',''],['持不同政见','',''],['持不同政见者','',''],['持不同看法','',''],['持久','',''],['持久之计','',''],['持久力','',''],['持久和平','',''],['持久性','',''],['持久性毒剂','',''],['持久战','',''],['持久稳固','',''],['持之','',''],['持之以恒','',''],['持之有故','',''],['持乐观态度','',''],['持人','',''],['持人长短','',''],['持兵','',''],['持刀','',''],['持刀动仗','',''],['持刀弄棒','',''],['持力','',''],['持卡人','',''],['持危扶颠','',''],['持反对态度','',''],['持否定态度','',''],['持国天','',''],['持守','',''],['持宠生骄','',''],['持家','',''],['持带','',''],['持平','',''],['持平之论','',''],['持异议','',''],['持怀疑态度','',''],['持批评态度','',''],['持斋','',''],['持斋把素','',''],['持有','',''],['持有人','',''],['持有异议','',''],['持枪','',''],['持枪抢劫','',''],['持械','',''],['持橐簪笔','',''],['持正不挠','',''],['持正不阿','',''],['持满戒盈','',''],['持火','',''],['持物','',''],['持球','',''],['持留','',''],['持疑不决','',''],['持疑不定','',''],['持盈保泰','',''],['持矛','',''],['持禄保位','',''],['持禄养交','',''],['持禄养身','',''],['持禄取容','',''],['持禄固宠','',''],['持筹握算','',''],['持续','',''],['持续不断','',''],['持续力','',''],['持续增长','',''],['持续很久','',''],['持续性','',''],['持续性植物人状态','',''],['持续性植物状态','',''],['持续时间','',''],['持续稳定地增长','',''],['持者','',''],['持股','',''],['持股公司','',''],['持肯定态度','',''],['持蠡测海','',''],['持论','',''],['持谨慎态度','',''],['持身','',''],['持重','',''],['挂一漏万','',''],['挂上','',''],['挂不住','',''],['挂人','',''],['挂住','',''],['挂入','',''],['挂兰','',''],['挂冠','',''],['挂出','',''],['挂包','',''],['挂单','',''],['挂印悬牌','',''],['挂历','',''],['挂去','',''],['挂号','',''],['挂号信','',''],['挂号室','',''],['挂号证','',''],['挂名','',''],['挂图','',''],['挂在','',''],['挂在嘴上','',''],['挂在嘴边','',''],['挂坠盒','',''],['挂失','',''],['挂好','',''],['挂孝','',''],['挂屏','',''],['挂布','',''],['挂帅','',''],['挂帅的社会','',''],['挂帐','',''],['挂幌子','',''],['挂弦','',''],['挂彩','',''],['挂心','',''],['挂念','',''],['挂怀','',''],['挂成','',''],['挂挡','',''],['挂掉','',''],['挂接','',''],['挂斗','',''],['挂断','',''],['挂旗','',''],['挂晃','',''],['挂机','',''],['挂果','',''],['挂架','',''],['挂欠','',''],['挂毡','',''],['挂毯','',''],['挂气','',''],['挂满','',''],['挂漏','',''],['挂火','',''],['挂灯结彩','',''],['挂牌','',''],['挂物架','',''],['挂牵','',''],['挂着','',''],['挂碍','',''],['挂累','',''],['挂红','',''],['挂级','',''],['挂线','',''],['挂线疗法','',''],['挂羊头','',''],['挂羊头卖狗肉','',''],['挂职','',''],['挂肚牵心','',''],['挂肠悬胆','',''],['挂花','',''],['挂虑','',''],['挂衣','',''],['挂表','',''],['挂起','',''],['挂车','',''],['挂轴','',''],['挂运','',''],['挂钟','',''],['挂钩','',''],['挂钩儿','',''],['挂锁','',''],['挂锄','',''],['挂镰','',''],['挂零','',''],['挂靠','',''],['挂面','',''],['挂马','',''],['挂齿','',''],['指一说十','',''],['指不胜屈','',''],['指东打西','',''],['指东画西','',''],['指东话西','',''],['指东说西','',''],['指为','',''],['指事','',''],['指事字','',''],['指亲托故','',''],['指人','',''],['指代','',''],['指令','',''],['指令名字','',''],['指令性','',''],['指令性计划','',''],['指令系统','',''],['指令表','',''],['指使','',''],['指做','',''],['指关节','',''],['指出','',''],['指到','',''],['指北针','',''],['指南','',''],['指南宫','',''],['指南打北','',''],['指南车','',''],['指南针','',''],['指印','',''],['指压','',''],['指古摘今','',''],['指名','',''],['指名道姓','',''],['指向','',''],['指向装置','',''],['指在','',''],['指天为誓','',''],['指天画地','',''],['指天誓心','',''],['指天誓日','',''],['指天说地','',''],['指头','',''],['指头儿肚','',''],['指定','',''],['指定者','',''],['指导','',''],['指导下','',''],['指导作用','',''],['指导员','',''],['指导工作','',''],['指导思想','',''],['指导性计划','',''],['指导意义','',''],['指导教授','',''],['指导方针','',''],['指导生','',''],['指导者','',''],['指导课','',''],['指尖','',''],['指山卖磨','',''],['指山说磨','',''],['指引','',''],['指弹','',''],['指征','',''],['指战员','',''],['指戳','',''],['指手','',''],['指手划脚','',''],['指手点脚','',''],['指手画脚','',''],['指手顿脚','',''],['指指','',''],['指指戳戳','',''],['指指点点','',''],['指挥','',''],['指挥中心','',''],['指挥仪','',''],['指挥刀','',''],['指挥员','',''],['指挥塔','',''],['指挥学院','',''],['指挥官','',''],['指挥家','',''],['指挥所','',''],['指挥控制系统','',''],['指挥有方','',''],['指挥机关','',''],['指挥机构','',''],['指挥棒','',''],['指挥系统','',''],['指挥者','',''],['指挥艺术','',''],['指挥若定','',''],['指挥部','',''],['指授','',''],['指掌可取','',''],['指控','',''],['指摘','',''],['指摹','',''],['指教','',''],['指教员','',''],['指数','',''],['指数函数','',''],['指数基金','',''],['指数套利','',''],['指数期权','',''],['指斥','',''],['指日','',''],['指日可待','',''],['指日成功','',''],['指日而待','',''],['指时针','',''],['指明','',''],['指是','',''],['指望','',''],['指标','',''],['指桑','',''],['指桑说槐','',''],['指桑骂槐','',''],['指模','',''],['指正','',''],['指水盟松','',''],['指法','',''],['指洞','',''],['指派','',''],['指点','',''],['指点江山','',''],['指点迷津','',''],['指状物','',''],['指猪骂狗','',''],['指猴','',''],['指环','',''],['指瑕造隙','',''],['指用','',''],['指甲','',''],['指甲刀','',''],['指甲剪','',''],['指甲心儿','',''],['指甲油','',''],['指甲盖','',''],['指甲盖儿','',''],['指甲花','',''],['指画','',''],['指疔','',''],['指痕','',''],['指皂为白','',''],['指的','',''],['指眼睛','',''],['指着','',''],['指破迷团','',''],['指示','',''],['指示代词','',''],['指示剂','',''],['指示器','',''],['指示字','',''],['指示植物','',''],['指示灯','',''],['指示牌','',''],['指示物','',''],['指示符','',''],['指示精神','',''],['指示者','',''],['指称','',''],['指空话空','',''],['指端','',''],['指纹','',''],['指纹学','',''],['指给','',''],['指缝','',''],['指肠','',''],['指腹为亲','',''],['指腹为婚','',''],['指腹割衿','',''],['指腹成亲','',''],['指腹裁襟','',''],['指著','',''],['指认','',''],['指证','',''],['指责','',''],['指责者','',''],['指距','',''],['指路','',''],['指路明灯','',''],['指针','',''],['指针式','',''],['指错','',''],['指雁为羹','',''],['指靠','',''],['指顾之间','',''],['指顾之际','',''],['指骨','',''],['指鸡骂狗','',''],['指鹿为马','',''],['指鹿作马','',''],['指麾','',''],['挈带','',''],['挈挈','',''],['挈瓶之知','',''],['挈瓶小智','',''],['按上级规定','',''],['按下','',''],['按下葫芦浮起瓢','',''],['按两次','',''],['按了','',''],['按人','',''],['按人均计算','',''],['按件','',''],['按价','',''],['按住','',''],['按使','',''],['按例','',''],['按倒','',''],['按兵','',''],['按兵不举','',''],['按兵不动','',''],['按其','',''],['按办','',''],['按动','',''],['按劳付酬','',''],['按劳取酬','',''],['按压','',''],['按原样','',''],['按原计划','',''],['按名责实','',''],['按吨','',''],['按喇叭','',''],['按国家有关规定','',''],['按图索骏','',''],['按图索骥','',''],['按在','',''],['按址','',''],['按堵如故','',''],['按天','',''],['按季','',''],['按察','',''],['按察使','',''],['按年','',''],['按序','',''],['按惯例','',''],['按户','',''],['按手','',''],['按手礼','',''],['按打','',''],['按扣','',''],['按指','',''],['按捺','',''],['按捺不住','',''],['按揭','',''],['按摩','',''],['按摩师','',''],['按摩棒','',''],['按日','',''],['按旬','',''],['按时','',''],['按时完成','',''],['按时间先后','',''],['按月','',''],['按期','',''],['按期归还','',''],['按次','',''],['按此','',''],['按步就班','',''],['按比例','',''],['按照','',''],['按照字面','',''],['按照法律','',''],['按照计划','',''],['按理','',''],['按理说','',''],['按甲休兵','',''],['按甲寝兵','',''],['按着','',''],['按码','',''],['按立','',''],['按立宪治国','',''],['按类','',''],['按级','',''],['按纽','',''],['按脉','',''],['按蚊','',''],['按规定','',''],['按触','',''],['按计划','',''],['按诊','',''],['按语','',''],['按说','',''],['按质','',''],['按质定价','',''],['按质论价','',''],['按蹻','',''],['按部','',''],['按部就班','',''],['按酒','',''],['按量','',''],['按钮','',''],['按铃','',''],['按键','',''],['按键音','',''],['按需','',''],['按需出版','',''],['挎兜','',''],['挎兜儿','',''],['挎包','',''],['挎斗','',''],['挎著','',''],['挑一','',''],['挑三拣四','',''],['挑三窝四','',''],['挑三豁四','',''],['挑了','',''],['挑使','',''],['挑出','',''],['挑刺','',''],['挑刺儿','',''],['挑剔','',''],['挑动','',''],['挑取','',''],['挑口板','',''],['挑唆','',''],['挑唇料嘴','',''],['挑嘴','',''],['挑大梁','',''],['挑夫','',''],['挑头','',''],['挑头儿','',''],['挑子','',''],['挑字眼儿','',''],['挑山工','',''],['挑幺挑六','',''],['挑开','',''],['挑弄','',''],['挑战','',''],['挑战书','',''],['挑战者','',''],['挑战者号','',''],['挑担','',''],['挑拔','',''],['挑拣','',''],['挑拨','',''],['挑拨是非','',''],['挑拨离间','',''],['挑挑','',''],['挑挑拣拣','',''],['挑明','',''],['挑染','',''],['挑檐','',''],['挑毛剔刺','',''],['挑毛剔刺儿','',''],['挑毛病','',''],['挑水','',''],['挑激','',''],['挑灯','',''],['挑灯夜战','',''],['挑灯拨火','',''],['挑牙料唇','',''],['挑眼','',''],['挑着','',''],['挑肥嫌瘦','',''],['挑肥拣瘦','',''],['挑脚','',''],['挑花','',''],['挑花眼','',''],['挑衅','',''],['挑衅性','',''],['挑起','',''],['挑运','',''],['挑选','',''],['挑逗','',''],['挑逗性','',''],['挑重担','',''],['挑针','',''],['挑食','',''],['挖井','',''],['挖出','',''],['挖剪','',''],['挖去','',''],['挖取','',''],['挖土','',''],['挖土机','',''],['挖地','',''],['挖地道','',''],['挖坑道','',''],['挖墓','',''],['挖墓者','',''],['挖墙脚','',''],['挖墙角','',''],['挖壕','',''],['挖壕机','',''],['挖开','',''],['挖成','',''],['挖挖','',''],['挖掉','',''],['挖掘','',''],['挖掘器','',''],['挖掘机','',''],['挖掘机械','',''],['挖掘潜力','',''],['挖掘者','',''],['挖方','',''],['挖槽','',''],['挖沙','',''],['挖沟','',''],['挖沟人','',''],['挖沟机','',''],['挖泥','',''],['挖泥船','',''],['挖洞','',''],['挖浚','',''],['挖渠','',''],['挖潜','',''],['挖煤','',''],['挖穴','',''],['挖空','',''],['挖空心思','',''],['挖耳当挡','',''],['挖肉补疮','',''],['挖苦','',''],['挖苦话','',''],['挖补','',''],['挖角','',''],['挖走','',''],['挖除','',''],['挖鼻子','',''],['挚切','',''],['挚友','',''],['挚友良朋','',''],['挚情','',''],['挚敬','',''],['挚爱','',''],['挚诚','',''],['挛缩','',''],['挞伐','',''],['挟主行令','',''],['挟人捉将','',''],['挟冰求温','',''],['挟制','',''],['挟势弄权','',''],['挟取','',''],['挟天子以令天下','',''],['挟天子以令诸侯','',''],['挟嫌','',''],['挟山超海','',''],['挟带','',''],['挟怨','',''],['挟恨','',''],['挟持','',''],['挟持雇主','',''],['挟朋树党','',''],['挟权倚势','',''],['挟细拿粗','',''],['挟贵倚势','',''],['挟贵自重','',''],['挠头','',''],['挠度','',''],['挠曲','',''],['挠率','',''],['挠痒','',''],['挠直为曲','',''],['挠秧','',''],['挠裂','',''],['挠败','',''],['挠钩','',''],['挡位','',''],['挡住','',''],['挡在','',''],['挡墙','',''],['挡子','',''],['挡层','',''],['挡开','',''],['挡拆','',''],['挡挡','',''],['挡板','',''],['挡案库','',''],['挡横儿','',''],['挡水','',''],['挡泥','',''],['挡泥板','',''],['挡眼','',''],['挡箭牌','',''],['挡路','',''],['挡车','',''],['挡道','',''],['挡钱','',''],['挡雨','',''],['挡风','',''],['挡风墙','',''],['挡风板','',''],['挡风玻璃','',''],['挡驾','',''],['挣个','',''],['挣到','',''],['挣命','',''],['挣开','',''],['挣得','',''],['挣扎','',''],['挣揣','',''],['挣断','',''],['挣来','',''],['挣点','',''],['挣着','',''],['挣脱','',''],['挣起','',''],['挣钱','',''],['挣饭','',''],['挤上','',''],['挤上去','',''],['挤乳','',''],['挤人','',''],['挤作','',''],['挤兑','',''],['挤入','',''],['挤出','',''],['挤到','',''],['挤占','',''],['挤压','',''],['挤压出','',''],['挤去','',''],['挤向','',''],['挤咕','',''],['挤在','',''],['挤垮','',''],['挤奶','',''],['挤奶人','',''],['挤奶员','',''],['挤奶机','',''],['挤对','',''],['挤干','',''],['挤得','',''],['挤成','',''],['挤挤','',''],['挤挤插插','',''],['挤掉','',''],['挤提','',''],['挤撞','',''],['挤时间','',''],['挤来','',''],['挤来挤去','',''],['挤榨','',''],['挤满','',''],['挤牙膏','',''],['挤牛奶','',''],['挤眉弄眼','',''],['挤眉溜眼','',''],['挤眼','',''],['挤着','',''],['挤紧','',''],['挤花','',''],['挤花袋','',''],['挤落','',''],['挤走','',''],['挤踏','',''],['挤车','',''],['挤轧','',''],['挤过','',''],['挤进','',''],['挤进去','',''],['挤迫','',''],['挤逼','',''],['挥之','',''],['挥之不去','',''],['挥之即去','',''],['挥兵','',''],['挥军','',''],['挥出','',''],['挥击','',''],['挥刀','',''],['挥别','',''],['挥剑','',''],['挥剑成河','',''],['挥动','',''],['挥动者','',''],['挥发','',''],['挥发性','',''],['挥发性存储器','',''],['挥发油','',''],['挥发物','',''],['挥师','',''],['挥戈','',''],['挥戈反日','',''],['挥戈回日','',''],['挥手','',''],['挥拳','',''],['挥挥手','',''],['挥斥','',''],['挥斥方遒','',''],['挥旗','',''],['挥杆','',''],['挥毫','',''],['挥毫洒墨','',''],['挥汗','',''],['挥汗如雨','',''],['挥汗成雨','',''],['挥泪','',''],['挥洒','',''],['挥洒自如','',''],['挥翰','',''],['挥翰临池','',''],['挥翰成风','',''],['挥臂','',''],['挥舞','',''],['挥金','',''],['挥金如土','',''],['挥霍','',''],['挥霍一空','',''],['挥霍无度','',''],['挥霍浪费','',''],['挥霍者','',''],['挥鞭','',''],['挥麈','',''],['挨上','',''],['挨不上','',''],['挨个','',''],['挨个儿','',''],['挨克','',''],['挨冻','',''],['挨刀','',''],['挨到','',''],['挨受','',''],['挨呲儿','',''],['挨头子','',''],['挨宰','',''],['挨家','',''],['挨家挨户','',''],['挨山塞海','',''],['挨延','',''],['挨得','',''],['挨户','',''],['挨户团','',''],['挨打','',''],['挨打受气','',''],['挨打受骂','',''],['挨批','',''],['挨挤','',''],['挨揍','',''],['挨擦','',''],['挨整','',''],['挨斗','',''],['挨时间','',''],['挨板子','',''],['挨次','',''],['挨着','',''],['挨肩','',''],['挨肩儿','',''],['挨肩搭背','',''],['挨肩擦背','',''],['挨肩擦脸','',''],['挨肩擦膀','',''],['挨肩迭背','',''],['挨著','',''],['挨训','',''],['挨踢','',''],['挨边','',''],['挨边儿','',''],['挨过','',''],['挨近','',''],['挨门','',''],['挨门逐户','',''],['挨靠','',''],['挨风缉缝','',''],['挨饥抵饿','',''],['挨饿','',''],['挨骂','',''],['挨黑','',''],['挪亚','',''],['挪作他用','',''],['挪借','',''],['挪出','',''],['挪动','',''],['挪占','',''],['挪威人','',''],['挪威币','',''],['挪威语','',''],['挪开','',''],['挪款','',''],['挪步','',''],['挪用','',''],['挪移','',''],['挪窝','',''],['挪窝儿','',''],['挪言','',''],['挪走','',''],['挫伤','',''],['挫折','',''],['挫折感','',''],['挫敌','',''],['挫败','',''],['挫骨扬灰','',''],['振作','',''],['振作有为','',''],['振作精神','',''],['振兴','',''],['振兴中华','',''],['振刷','',''],['振动','',''],['振动器','',''],['振动子','',''],['振动筛','',''],['振动者','',''],['振动计','',''],['振响','',''],['振奋','',''],['振奋人心','',''],['振奋精神','',''],['振安','',''],['振幅','',''],['振拔','',''],['振振有词','',''],['振振有辞','',''],['振旅','',''],['振民育德','',''],['振片','',''],['振穷恤寡','',''],['振穷恤贫','',''],['振笔','',''],['振笔疾书','',''],['振翅','',''],['振翼','',''],['振耳','',''],['振聋发聩','',''],['振臂','',''],['振臂一呼','',''],['振臂高呼','',''],['振荡','',''],['振荡器','',''],['振衣提领','',''],['振衣濯足','',''],['振裘持领','',''],['振贫济乏','',''],['振起','',''],['振领提纲','',''],['振频','',''],['挹取','',''],['挹彼注兹','',''],['挹彼注此','',''],['挹掬','',''],['挹注','',''],['挹泪揉眵','',''],['挹酌','',''],['挺举','',''],['挺伸','',''],['挺住','',''],['挺凶','',''],['挺出','',''],['挺到','',''],['挺坚','',''],['挺好','',''],['挺拔','',''],['挺括','',''],['挺挺','',''],['挺杆','',''],['挺棒','',''],['挺爱','',''],['挺直','',''],['挺着','',''],['挺硬','',''],['挺秀','',''],['挺立','',''],['挺而走险','',''],['挺胸','',''],['挺胸凸肚','',''],['挺胸迭肚','',''],['挺脱','',''],['挺著','',''],['挺起','',''],['挺身','',''],['挺身而出','',''],['挺过','',''],['挺进','',''],['挺香','',''],['挽住','',''],['挽具','',''],['挽力','',''],['挽唱','',''],['挽回','',''],['挽回经济损失','',''],['挽幛','',''],['挽弩自射','',''],['挽手','',''],['挽救','',''],['挽救儿童','',''],['挽歌','',''],['挽留','',''],['挽留者','',''],['挽着','',''],['挽联','',''],['挽臂','',''],['挽衣女','',''],['挽袖','',''],['挽词','',''],['挽诗','',''],['挽起','',''],['挽辞','',''],['挽近','',''],['挽额','',''],['捂住','',''],['捂住脸','',''],['捂到','',''],['捂捂盖盖','',''],['捂盖子','',''],['捂着','',''],['捂雾拿云','',''],['捅了','',''],['捅咕','',''],['捅喽子','',''],['捅娄子','',''],['捅楼子','',''],['捅破','',''],['捅穿','',''],['捅马蜂窝','',''],['捆上','',''],['捆住','',''],['捆包','',''],['捆包绳','',''],['捆在','',''],['捆好','',''],['捆干','',''],['捆成','',''],['捆扎','',''],['捆稻草','',''],['捆紧','',''],['捆绑','',''],['捆缚','',''],['捆缚术','',''],['捆装','',''],['捆起','',''],['捉住','',''],['捉刀','',''],['捉到','',''],['捉取','',''],['捉奸','',''],['捉奸捉双','',''],['捉奸见床','',''],['捉将官里去','',''],['捉将挟人','',''],['捉弄','',''],['捉影','',''],['捉影捕风','',''],['捉影追风','',''],['捉拿','',''],['捉拿归案','',''],['捉捕器','',''],['捉摸','',''],['捉摸不定','',''],['捉班做势','',''],['捉生替死','',''],['捉笔','',''],['捉获','',''],['捉虎擒蛟','',''],['捉衿见肘','',''],['捉襟肘见','',''],['捉襟见肘','',''],['捉贼见赃捉奸见双','',''],['捉迷藏','',''],['捉鸡骂狗','',''],['捉鼠拿猫','',''],['捋胳膊','',''],['捋臂揎拳','',''],['捋虎须','',''],['捋袖','',''],['捋袖子','',''],['捋袖揎拳','',''],['捍卫','',''],['捍卫者','',''],['捎信','',''],['捎关打节','',''],['捎带','',''],['捎带脚儿','',''],['捎来','',''],['捎脚','',''],['捎色','',''],['捎马子','',''],['捏一把汗','',''],['捏估','',''],['捏住','',''],['捏制','',''],['捏合','',''],['捏告','',''],['捏咕','',''],['捏弄','',''],['捏成','',''],['捏手捏脚','',''],['捏报','',''],['捏捏','',''],['捏捏扭扭','',''],['捏着','',''],['捏碎','',''],['捏积','',''],['捏称','',''],['捏脊治疗','',''],['捏脊疗法','',''],['捏脚捏手','',''],['捏腔拿调','',''],['捏著','',''],['捏词','',''],['捏造','',''],['捏造者','',''],['捐出','',''],['捐助','',''],['捐助人','',''],['捐募','',''],['捐华务实','',''],['捐命','',''],['捐弃','',''],['捐弃前嫌','',''],['捐忿弃瑕','',''],['捐款','',''],['捐款人','',''],['捐款额','',''],['捐款者','',''],['捐残去杀','',''],['捐物','',''],['捐献','',''],['捐献者','',''],['捐班','',''],['捐生','',''],['捐生殉国','',''],['捐益表','',''],['捐税','',''],['捐给','',''],['捐背','',''],['捐血','',''],['捐血者','',''],['捐赀','',''],['捐资','',''],['捐赠','',''],['捐赠盈余','',''],['捐赠者','',''],['捐躯','',''],['捐躯报国','',''],['捐躯殒首','',''],['捐躯济难','',''],['捐躯赴难','',''],['捐输','',''],['捐选','',''],['捐金抵璧','',''],['捐钱','',''],['捕俘','',''],['捕处','',''],['捕头','',''],['捕尽','',''],['捕影拿风','',''],['捕影系风','',''],['捕快','',''],['捕房','',''],['捕手','',''],['捕拿','',''],['捕捉','',''],['捕捞','',''],['捕收','',''],['捕杀','',''],['捕猎','',''],['捕禽人','',''],['捕获','',''],['捕获量','',''],['捕虏岩','',''],['捕虫叶','',''],['捕虾','',''],['捕蝇器','',''],['捕蝇纸','',''],['捕蟹','',''],['捕风弄月','',''],['捕风捉影','',''],['捕风系影','',''],['捕食','',''],['捕食性','',''],['捕鱼','',''],['捕鱼人','',''],['捕鱼用','',''],['捕鲸','',''],['捕鲸船','',''],['捕鸟','',''],['捕鸟蛛','',''],['捕鼠','',''],['捕鼠器','',''],['捕鼠机','',''],['捞一把','',''],['捞什子','',''],['捞出','',''],['捞住','',''],['捞到','',''],['捞取','',''],['捞捕','',''],['捞摸','',''],['捞月','',''],['捞本','',''],['捞着','',''],['捞稻草','',''],['捞网','',''],['捞著','',''],['捞起','',''],['捞钱','',''],['损上益下','',''],['损人','',''],['损人不利己','',''],['损人利己','',''],['损人安己','',''],['损人害己','',''],['损人益己','',''],['损人肥己','',''],['损伤','',''],['损公肥私','',''],['损兵折将','',''],['损军折将','',''],['损友','',''],['损坏','',''],['损失','',''],['损害','',''],['损己利物','',''],['损本逐末','',''],['损毁','',''],['损益','',''],['损益表','',''],['损税','',''],['损耗','',''],['损耗品','',''],['损耗量','',''],['损赠','',''],['损量','',''],['捡了','',''],['捡到','',''],['捡开','',''],['捡拾','',''],['捡来','',''],['捡漏','',''],['捡漏儿','',''],['捡的','',''],['捡着','',''],['捡破烂','',''],['捡破烂儿','',''],['捡起','',''],['换上','',''],['换个','',''],['换个儿','',''],['换乘','',''],['换了','',''],['换亲','',''],['换人','',''],['换代','',''],['换代产品','',''],['换位','',''],['换入','',''],['换出','',''],['换单','',''],['换取','',''],['换句话说','',''],['换向','',''],['换回','',''],['换契','',''],['换妻','',''],['换季','',''],['换届','',''],['换岗','',''],['换工','',''],['换帖','',''],['换幕','',''],['换开','',''],['换式','',''],['换性者','',''],['换成','',''],['换房','',''],['换房旅游','',''],['换挡','',''],['换挡杆','',''],['换换','',''],['换掉','',''],['换文','',''],['换新','',''],['换日偷天','',''],['换来换','',''],['换样','',''],['换档','',''],['换档杆','',''],['换毛','',''],['换气','',''],['换水','',''],['换汇','',''],['换汤','',''],['换汤不换药','',''],['换洗','',''],['换热器','',''],['换版','',''],['换牌','',''],['换牙','',''],['换班','',''],['换用','',''],['换票','',''],['换称','',''],['换笔','',''],['换算','',''],['换线','',''],['换置','',''],['换羽','',''],['换能器','',''],['换船','',''],['换茬','',''],['换药','',''],['换行','',''],['换行符','',''],['换装','',''],['换言之','',''],['换证','',''],['换货','',''],['换车','',''],['换进','',''],['换钱','',''],['换防','',''],['换面','',''],['换鞋底','',''],['换页','',''],['换领','',''],['换骨夺胎','',''],['换骨脱胎','',''],['捣乱','',''],['捣乱者','',''],['捣卖','',''],['捣坏','',''],['捣实','',''],['捣弄','',''],['捣枕捶床','',''],['捣毁','',''],['捣烂','',''],['捣碎','',''],['捣腾','',''],['捣蒜','',''],['捣虚批吭','',''],['捣蛋','',''],['捣蛋鬼','',''],['捣衣','',''],['捣鬼','',''],['捣麻烦','',''],['捣鼓','',''],['捧上天','',''],['捧人','',''],['捧住','',''],['捧到天上','',''],['捧哏','',''],['捧场','',''],['捧头鼠窜','',''],['捧心西子','',''],['捧托','',''],['捧持','',''],['捧杀','',''],['捧杯','',''],['捧毂推轮','',''],['捧着','',''],['捧腹','',''],['捧腹大笑','',''],['捧腹绝倒','',''],['捧腹轩渠','',''],['捧花','',''],['捧著','',''],['捧角','',''],['捧角儿','',''],['捧读','',''],['捧走','',''],['捧起','',''],['捭阖','',''],['捭阖纵横','',''],['据不完全统计','',''],['据为','',''],['据为己有','',''],['据义履方','',''],['据了解','',''],['据介绍','',''],['据从','',''],['据以','',''],['据传','',''],['据传闻','',''],['据估','',''],['据估计','',''],['据信','',''],['据典','',''],['据分析','',''],['据初步统计','',''],['据外电报道','',''],['据守','',''],['据守天险','',''],['据实','',''],['据宣布','',''],['据悉','',''],['据情办理','',''],['据我','',''],['据我所知','',''],['据我看','',''],['据报','',''],['据报导','',''],['据报道','',''],['据料','',''],['据有','',''],['据有关人士透露','',''],['据有关部门统计','',''],['据查','',''],['据此','',''],['据测','',''],['据测定','',''],['据点','',''],['据理','',''],['据理力争','',''],['据知','',''],['据称','',''],['据统计','',''],['据说','',''],['据调查','',''],['据载','',''],['据道','',''],['据闻','',''],['据险','',''],['据预测','',''],['捱三顶五','',''],['捱三顶四','',''],['捱过','',''],['捱风缉缝','',''],['捶击','',''],['捶子','',''],['捶平','',''],['捶床拍枕','',''],['捶床捣枕','',''],['捶打','',''],['捶背','',''],['捶胸','',''],['捶胸跌足','',''],['捶胸迭脚','',''],['捶胸顿脚','',''],['捶胸顿足','',''],['捷克人','',''],['捷克共和国','',''],['捷克和斯洛伐克','',''],['捷克币','',''],['捷克斯拉夫共和国','',''],['捷克斯洛伐克','',''],['捷克语','',''],['捷安特','',''],['捷尔任斯克','',''],['捷尔梅兹','',''],['捷径','',''],['捷报','',''],['捷报频传','',''],['捷给','',''],['捷者','',''],['捷语','',''],['捷豹','',''],['捷足','',''],['捷足先得','',''],['捷足先登','',''],['捷达','',''],['捷达航空货运','',''],['捷运','',''],['捺印','',''],['捻军','',''],['捻军起义','',''],['捻子','',''],['捻度','',''],['捻捻','',''],['捻捻转儿','',''],['捻搓机','',''],['捻着鼻子','',''],['捻神捻鬼','',''],['捻脚捻手','',''],['捻角','',''],['掀到','',''],['掀动','',''],['掀天揭地','',''],['掀天斡地','',''],['掀开','',''],['掀掉','',''],['掀涌','',''],['掀背式','',''],['掀腾','',''],['掀起','',''],['掀雷决电','',''],['掀风鼓浪','',''],['掂对','',''],['掂掂','',''],['掂掇','',''],['掂斤估两','',''],['掂斤抹两','',''],['掂斤播两','',''],['掂量','',''],['掇乖弄俏','',''],['掇刀','',''],['掇弄','',''],['掇拾','',''],['掇臀捧屁','',''],['掇青拾紫','',''],['授与','',''],['授与封','',''],['授业','',''],['授业解惑','',''],['授乳','',''],['授乳期','',''],['授予','',''],['授予者','',''],['授于','',''],['授人','',''],['授人以柄','',''],['授人以鱼不如授人以渔','',''],['授人口实','',''],['授以','',''],['授任','',''],['授信','',''],['授冠者','',''],['授动','',''],['授勋','',''],['授受','',''],['授受不亲','',''],['授命','',''],['授奖','',''],['授奶','',''],['授意','',''],['授手援溺','',''],['授旗','',''],['授时','',''],['授权','',''],['授权与','',''],['授权令','',''],['授权范围','',''],['授枪','',''],['授法','',''],['授爵位','',''],['授称号','',''],['授粉','',''],['授粉树','',''],['授精','',''],['授给','',''],['授职','',''],['授职惟贤','',''],['授职者','',''],['授衔','',''],['授计','',''],['授课','',''],['授首','',''],['掉下','',''],['掉书袋','',''],['掉了','',''],['掉以轻心','',''],['掉价','',''],['掉价儿','',''],['掉入','',''],['掉出','',''],['掉到','',''],['掉包','',''],['掉向','',''],['掉嘴弄舌','',''],['掉在','',''],['掉头','',''],['掉头就走','',''],['掉头鼠窜','',''],['掉换','',''],['掉期','',''],['掉枪花','',''],['掉泪','',''],['掉点儿','',''],['掉球','',''],['掉秤','',''],['掉线','',''],['掉膘','',''],['掉臂不顾','',''],['掉舌','',''],['掉舌鼓唇','',''],['掉色','',''],['掉落','',''],['掉转','',''],['掉过','',''],['掉过儿','',''],['掉进','',''],['掉队','',''],['掊击','',''],['掌上','',''],['掌上型','',''],['掌上明珠','',''],['掌上电脑','',''],['掌上观纹','',''],['掌中','',''],['掌中戏','',''],['掌击','',''],['掌力','',''],['掌勺','',''],['掌勺儿','',''],['掌印','',''],['掌厨','',''],['掌嘴','',''],['掌声','',''],['掌声雷动','',''],['掌子','',''],['掌子面','',''],['掌心','',''],['掌承','',''],['掌控','',''],['掌掴声','',''],['掌握','',''],['掌握分寸','',''],['掌握电脑','',''],['掌故','',''],['掌权','',''],['掌柜','',''],['掌柜的','',''],['掌案儿的','',''],['掌灯','',''],['掌灶','',''],['掌玺大臣','',''],['掌玺官','',''],['掌班','',''],['掌相','',''],['掌管','',''],['掌舵','',''],['掌舵人','',''],['掌财','',''],['掌铺','',''],['掌鞭','',''],['掌骨','',''],['掎裳连袂','',''],['掏出','',''],['掏到','',''],['掏包','',''],['掏取','',''],['掏尽','',''],['掏心掏肺','',''],['掏空','',''],['掏窟窿','',''],['掏粪','',''],['掏给','',''],['掏腰包','',''],['掏钱','',''],['掐住','',''],['掐头去尾','',''],['掐子','',''],['掐尖落钞','',''],['掐巴','',''],['掐指','',''],['掐掉','',''],['掐断','',''],['掐死','',''],['掐灭','',''],['掐算','',''],['掐紧','',''],['掐诀','',''],['排上','',''],['排中律','',''],['排人','',''],['排他','',''],['排他性','',''],['排便','',''],['排偶','',''],['排入','',''],['排兵布阵','',''],['排出','',''],['排击','',''],['排列','',''],['排列名次','',''],['排列次序','',''],['排到','',''],['排华','',''],['排华法案','',''],['排印','',''],['排卵','',''],['排卵期','',''],['排去','',''],['排号','',''],['排名','',''],['排名榜','',''],['排名表','',''],['排在','',''],['排场','',''],['排坛','',''],['排外','',''],['排头','',''],['排头兵','',''],['排好','',''],['排子车','',''],['排字','',''],['排它性','',''],['排定','',''],['排客','',''],['排射','',''],['排尾','',''],['排尿','',''],['排屋','',''],['排山倒峡','',''],['排山倒海','',''],['排山压卵','',''],['排干','',''],['排序','',''],['排序算法','',''],['排序问题','',''],['排开','',''],['排律','',''],['排忧解难','',''],['排患解纷','',''],['排愁破涕','',''],['排戏','',''],['排成','',''],['排挡','',''],['排挡速率','',''],['排挤','',''],['排挤掉','',''],['排揎','',''],['排摈','',''],['排放','',''],['排放器','',''],['排整齐','',''],['排斥','',''],['排斥异己','',''],['排枪','',''],['排架','',''],['排查','',''],['排查故障','',''],['排档','',''],['排档速率','',''],['排检','',''],['排毒','',''],['排比','',''],['排气','',''],['排气口','',''],['排气孔','',''],['排气管','',''],['排水','',''],['排水口','',''],['排水槽','',''],['排水沟','',''],['排水渠','',''],['排水管','',''],['排水系统','',''],['排水量','',''],['排汗','',''],['排污','',''],['排污地下主管网','',''],['排污管','',''],['排泄','',''],['排泄物','',''],['排泄系统','',''],['排泄腔','',''],['排法','',''],['排泻','',''],['排泻口','',''],['排泻物','',''],['排洪','',''],['排涝','',''],['排湾族','',''],['排演','',''],['排灌','',''],['排炮','',''],['排版','',''],['排犹','',''],['排犹主义','',''],['排班','',''],['排球','',''],['排空','',''],['排笔','',''],['排笙','',''],['排筏','',''],['排箫','',''],['排粪','',''],['排练','',''],['排翅','',''],['排脓','',''],['排舞','',''],['排萧','',''],['排行','',''],['排行榜','',''],['排解','',''],['排课','',''],['排调','',''],['排起长队','',''],['排遣','',''],['排量','',''],['排钮','',''],['排错','',''],['排长','',''],['排长队','',''],['排队','',''],['排阵','',''],['排除','',''],['排除万难','',''],['排除异己','',''],['排障','',''],['排难','',''],['排难解纷','',''],['排雷','',''],['排风','',''],['排风口','',''],['排骨','',''],['排齐','',''],['掖咕','',''],['掖垣','',''],['掖庭','',''],['掖掖盖盖','',''],['掖门','',''],['掘于','',''],['掘井','',''],['掘以','',''],['掘出','',''],['掘凿器','',''],['掘到','',''],['掘取','',''],['掘土','',''],['掘土机','',''],['掘地','',''],['掘坑','',''],['掘墓','',''],['掘墓人','',''],['掘墓工人','',''],['掘墓鞭尸','',''],['掘壕','',''],['掘客','',''],['掘室求鼠','',''],['掘沟','',''],['掘洞','',''],['掘洞穴','',''],['掘翻','',''],['掘起','',''],['掘进','',''],['掘进率','',''],['掘通','',''],['掠人之美','',''],['掠卖','',''],['掠卖华工','',''],['掠取','',''],['掠取物','',''],['掠地','',''],['掠地攻城','',''],['掠夺','',''],['掠夺兵','',''],['掠夺品','',''],['掠夺性','',''],['掠夺者','',''],['掠影','',''],['掠是搬非','',''],['掠杀','',''],['掠美','',''],['掠脂斡肉','',''],['掠角','',''],['掠走','',''],['掠过','',''],['掠食','',''],['掠食性','',''],['掠食者','',''],['探井','',''],['探亲','',''],['探亲假','',''],['探亲访友','',''],['探伤','',''],['探伤器','',''],['探信','',''],['探出','',''],['探勘','',''],['探勘员','',''],['探勘者','',''],['探友','',''],['探取','',''],['探口气','',''],['探口风','',''],['探听','',''],['探听者','',''],['探听虚实','',''],['探启','',''],['探员','',''],['探囊取物','',''],['探头','',''],['探头探脑','',''],['探头探脑儿','',''],['探奇','',''],['探奇穷异','',''],['探奇访胜','',''],['探奥索隐','',''],['探子','',''],['探家','',''],['探察','',''],['探寻','',''],['探寻者','',''],['探尺','',''],['探幽发微','',''],['探幽穷赜','',''],['探幽索隐','',''],['探异玩奇','',''],['探息','',''],['探悉','',''],['探戈','',''],['探戈舞','',''],['探掘','',''],['探摸','',''],['探明','',''],['探春','',''],['探月','',''],['探望','',''],['探本溯源','',''],['探本穷源','',''],['探查','',''],['探案','',''],['探求','',''],['探求者','',''],['探测','',''],['探测仪','',''],['探测器','',''],['探测字','',''],['探渊索珠','',''],['探源','',''],['探溯','',''],['探照灯','',''],['探犬','',''],['探玩','',''],['探病','',''],['探监','',''],['探看','',''],['探知','',''],['探矿','',''],['探矿者','',''],['探秘','',''],['探究','',''],['探究反射','',''],['探究式','',''],['探究性','',''],['探空','',''],['探空仪','',''],['探索','',''],['探索性','',''],['探索者','',''],['探船','',''],['探花','',''],['探视','',''],['探视权','',''],['探讨','',''],['探讨问题','',''],['探访','',''],['探询','',''],['探谎器','',''],['探象','',''],['探赜索隐','',''],['探路','',''],['探路者','',''],['探身','',''],['探身子','',''],['探过','',''],['探针','',''],['探钳','',''],['探长','',''],['探问','',''],['探问者','',''],['探险','',''],['探险家','',''],['探险者','',''],['探雷','',''],['探雷人员','',''],['探雷器','',''],['探风','',''],['探马','',''],['探骊得珠','',''],['掣电','',''],['掣肘','',''],['掣襟肘见','',''],['掣襟露肘','',''],['接三换九','',''],['接上','',''],['接下','',''],['接下来','',''],['接不','',''],['接事','',''],['接二连三','',''],['接交','',''],['接人','',''],['接任','',''],['接任者','',''],['接住','',''],['接到','',''],['接力','',''],['接力棒','',''],['接力赛','',''],['接力赛跑','',''],['接办','',''],['接单','',''],['接受','',''],['接受体','',''],['接受审问','',''],['接受者','',''],['接口','',''],['接口模块','',''],['接合','',''],['接合体','',''],['接合处','',''],['接合点','',''],['接合物','',''],['接合线','',''],['接合菌纲','',''],['接合部','',''],['接听','',''],['接吻','',''],['接和','',''],['接在','',''],['接地','',''],['接境','',''],['接墒','',''],['接壤','',''],['接头','',''],['接头儿','',''],['接头辞','',''],['接客','',''],['接应','',''],['接应不暇','',''],['接待','',''],['接待员','',''],['接待室','',''],['接待生','',''],['接待站','',''],['接待者','',''],['接戏','',''],['接手','',''],['接排','',''],['接接','',''],['接援','',''],['接收','',''],['接收器','',''],['接收器灵敏度','',''],['接收天线','',''],['接收机','',''],['接收站','',''],['接收者','',''],['接替','',''],['接替者','',''],['接木','',''],['接机','',''],['接来','',''],['接来送往','',''],['接枝','',''],['接棒','',''],['接气','',''],['接水','',''],['接泊车','',''],['接活','',''],['接洽','',''],['接济','',''],['接火','',''],['接点','',''],['接牢','',''],['接物','',''],['接物镜','',''],['接环','',''],['接班','',''],['接班人','',''],['接球','',''],['接生','',''],['接生婆','',''],['接电器','',''],['接盘人','',''],['接目镜','',''],['接眼','',''],['接着','',''],['接碴','',''],['接种','',''],['接穗','',''],['接站','',''],['接管','',''],['接纳','',''],['接线','',''],['接线员','',''],['接线柱','',''],['接线生','',''],['接线盒','',''],['接绍香烟','',''],['接续','',''],['接续而来','',''],['接续香烟','',''],['接缝','',''],['接羔','',''],['接耳','',''],['接耳交头','',''],['接茬','',''],['接茬儿','',''],['接获','',''],['接著','',''],['接著来','',''],['接衫','',''],['接袂成帷','',''],['接见','',''],['接触','',''],['接触不良','',''],['接触器','',''],['接触性皮炎','',''],['接触焊','',''],['接触眼镜','',''],['接词','',''],['接谈','',''],['接货','',''],['接贵攀高','',''],['接走','',''],['接踵','',''],['接踵比肩','',''],['接踵而来','',''],['接踵而至','',''],['接轨','',''],['接辞','',''],['接过','',''],['接近','',''],['接进','',''],['接连','',''],['接连不断','',''],['接送','',''],['接通','',''],['接通费','',''],['接长','',''],['接防','',''],['接风','',''],['接驳','',''],['接驳车','',''],['接驾','',''],['接骨','',''],['接骨师','',''],['接骨木','',''],['接龙','',''],['控件','',''],['控作','',''],['控制','',''],['控制下','',''],['控制人口','',''],['控制区','',''],['控制台','',''],['控制器','',''],['控制室','',''],['控制数字','',''],['控制权','',''],['控制杆','',''],['控制棒','',''],['控制系统','',''],['控制者','',''],['控制论','',''],['控制面板','',''],['控制项','',''],['控办','',''],['控名责实','',''],['控告','',''],['控告者','',''],['控拆','',''],['控方','',''],['控矽','',''],['控管','',''],['控罪','',''],['控股','',''],['控股公司','',''],['控规','',''],['控诉','',''],['控诉人','',''],['控诉道','',''],['控词','',''],['控购','',''],['控辩','',''],['控辩交易','',''],['控辩协议','',''],['控驭','',''],['推三宕四','',''],['推三挨四','',''],['推三阻四','',''],['推上','',''],['推东主西','',''],['推为','',''],['推举','',''],['推了','',''],['推事','',''],['推事席','',''],['推亡固存','',''],['推介','',''],['推介会','',''],['推估','',''],['推倒','',''],['推倒重来','',''],['推入','',''],['推出','',''],['推刨','',''],['推到','',''],['推力','',''],['推动','',''],['推动力','',''],['推动器','',''],['推动者','',''],['推却','',''],['推卸','',''],['推卸责任','',''],['推去','',''],['推及','',''],['推后','',''],['推向','',''],['推土','',''],['推土机','',''],['推天抢地','',''],['推头','',''],['推委','',''],['推子','',''],['推宕','',''],['推宗明本','',''],['推官','',''],['推定','',''],['推寻','',''],['推导','',''],['推尊','',''],['推展','',''],['推崇','',''],['推崇备至','',''],['推己及人','',''],['推广','',''],['推广应用','',''],['推度','',''],['推延','',''],['推开','',''],['推心','',''],['推心置腹','',''],['推恩','',''],['推情准理','',''],['推想','',''],['推戴','',''],['推手','',''],['推托','',''],['推拉门','',''],['推拿','',''],['推挤','',''],['推挽','',''],['推挽式','',''],['推换','',''],['推掉','',''],['推推','',''],['推搡','',''],['推搪','',''],['推撞','',''],['推故','',''],['推敲','',''],['推斥','',''],['推斥力','',''],['推断','',''],['推断出','',''],['推服','',''],['推本溯源','',''],['推杆','',''],['推来','',''],['推来推去','',''],['推检人员','',''],['推毂荐士','',''],['推求','',''],['推法','',''],['推波助澜','',''],['推测','',''],['推测上','',''],['推测学','',''],['推涛作浪','',''],['推溯','',''],['推演','',''],['推燥居湿','',''],['推特','',''],['推理','',''],['推理者','',''],['推病','',''],['推着','',''],['推知','',''],['推磨','',''],['推移','',''],['推究','',''],['推算','',''],['推索','',''],['推给','',''],['推群独步','',''],['推翻','',''],['推而广之','',''],['推聋做哑','',''],['推聋妆哑','',''],['推脱','',''],['推舟','',''],['推舟于陆','',''],['推荐','',''],['推荐书','',''],['推荐信','',''],['推荐者','',''],['推行','',''],['推衍','',''],['推襟送抱','',''],['推见','',''],['推计','',''],['推让','',''],['推许','',''],['推论','',''],['推论性','',''],['推诚','',''],['推诚布信','',''],['推诚布公','',''],['推诚待物','',''],['推诚接物','',''],['推诚相见','',''],['推诚置腹','',''],['推详','',''],['推说','',''],['推诿','',''],['推谢','',''],['推贤下士','',''],['推贤举善','',''],['推贤乐善','',''],['推贤任人','',''],['推贤让能','',''],['推贤进善','',''],['推贤进士','',''],['推贤逊能','',''],['推走','',''],['推起','',''],['推车','',''],['推车者','',''],['推轮捧毂','',''],['推辞','',''],['推运','',''],['推进','',''],['推进剂','',''],['推进力','',''],['推进器','',''],['推进改革','',''],['推进机','',''],['推进物','',''],['推进者','',''],['推进舱','',''],['推迟','',''],['推送','',''],['推选','',''],['推重','',''],['推铅球','',''],['推销','',''],['推销员','',''],['推销术','',''],['推门','',''],['推门入桕','',''],['推门而入','',''],['推问','',''],['推阐','',''],['推陈','',''],['推陈出新','',''],['推陈布新','',''],['推陈致新','',''],['推食解衣','',''],['掩上','',''],['掩人','',''],['掩人耳目','',''],['掩住','',''],['掩体','',''],['掩其不备','',''],['掩其无备','',''],['掩卷','',''],['掩口','',''],['掩口胡卢','',''],['掩埋','',''],['掩恶扬善','',''],['掩恶溢美','',''],['掩护','',''],['掩护物','',''],['掩掩','',''],['掩旗息鼓','',''],['掩映','',''],['掩映生姿','',''],['掩杀','',''],['掩样法','',''],['掩没','',''],['掩瑕藏疾','',''],['掩盖','',''],['掩目捕雀','',''],['掩眼法','',''],['掩着','',''],['掩罪饰非','',''],['掩美绝俗','',''],['掩耳','',''],['掩耳偷铃','',''],['掩耳盗钟','',''],['掩耳盗铃','',''],['掩耳而走','',''],['掩蔽','',''],['掩蔽处','',''],['掩蔽部','',''],['掩藏','',''],['掩贤妒善','',''],['掩面','',''],['掩面失色','',''],['掩面而泣','',''],['掩饰','',''],['掩饰物','',''],['掩鼻','',''],['掩鼻偷香','',''],['掩鼻而过','',''],['措举','',''],['措办','',''],['措口','',''],['措大','',''],['措失','',''],['措意','',''],['措手','',''],['措手不及','',''],['措手不迭','',''],['措施','',''],['措施不力','',''],['措款','',''],['措置','',''],['措置有方','',''],['措置裕如','',''],['措词','',''],['措词不当','',''],['措词巧妙','',''],['措辞','',''],['措辞上','',''],['措辞不当','',''],['措辞强硬','',''],['措颜乖方','',''],['措颜天地','',''],['掬水','',''],['掬诚','',''],['掬起','',''],['掬饮','',''],['掮客','',''],['掰开','',''],['掰开揉碎','',''],['掰扯','',''],['掰掰','',''],['掳人','',''],['掳人勒赎','',''],['掳夺','',''],['掳掠','',''],['掳获','',''],['掳袖揎拳','',''],['掷下','',''],['掷出','',''],['掷回','',''],['掷地之材','',''],['掷地作金玉声','',''],['掷地有声','',''],['掷弹筒','',''],['掷抛','',''],['掷果盈车','',''],['掷棒','',''],['掷环','',''],['掷石地雷','',''],['掷至','',''],['掷色','',''],['掷还','',''],['掷骰子','',''],['掷鼠忌器','',''],['掸去','',''],['掸子','',''],['掸帚','',''],['掸灰','',''],['掸邦','',''],['掸邦高原','',''],['掺假','',''],['掺兑','',''],['掺入','',''],['掺制','',''],['掺合','',''],['掺和','',''],['掺有','',''],['掺杂','',''],['掺水','',''],['掺沙子','',''],['掺混','',''],['掺进','',''],['掼交','',''],['掼纱帽','',''],['揄扬','',''],['揄袂','',''],['揆度','',''],['揉制','',''],['揉匀','',''],['揉合','',''],['揉和','',''],['揉成','',''],['揉捻','',''],['揉搓','',''],['揉摩','',''],['揉皱','',''],['揉眵抹泪','',''],['揉眼','',''],['揉碎','',''],['揉磨','',''],['揉背','',''],['揉面','',''],['揉面槽','',''],['揍死','',''],['揎拳捋袖','',''],['描上','',''],['描写','',''],['描出','',''],['描图','',''],['描字','',''],['描成','',''],['描描','',''],['描摩者','',''],['描摹','',''],['描法','',''],['描淡写','',''],['描画','',''],['描眉画眼','',''],['描红','',''],['描绘','',''],['描述','',''],['描金','',''],['描鸾刺凤','',''],['提不','',''],['提不起来','',''],['提举','',''],['提了','',''],['提交','',''],['提亲','',''],['提亲事','',''],['提价','',''],['提任','',''],['提供','',''],['提供优质服务','',''],['提供商','',''],['提供方便','',''],['提供有','',''],['提供者','',''],['提倡','',''],['提倡者','',''],['提克里特','',''],['提出','',''],['提出建议','',''],['提出异议','',''],['提出批评','',''],['提出抗议','',''],['提出抗辩','',''],['提出申请','',''],['提出者','',''],['提列','',''],['提到','',''],['提制','',''],['提前','',''],['提前完成','',''],['提前投票','',''],['提前起爆','',''],['提剑汗马','',''],['提包','',''],['提升','',''],['提升间','',''],['提单','',''],['提去','',''],['提及','',''],['提取','',''],['提取物','',''],['提名','',''],['提名权','',''],['提名者','',''],['提告','',''],['提告人','',''],['提味','',''],['提喻法','',''],['提壶','',''],['提壶芦','',''],['提多','',''],['提多书','',''],['提头儿','',''],['提姆・罗宾斯','',''],['提婚','',''],['提子','',''],['提存','',''],['提学御史','',''],['提审','',''],['提尔','',''],['提尔市','',''],['提干','',''],['提异议','',''],['提心','',''],['提心吊胆','',''],['提心在口','',''],['提意见','',''],['提成','',''],['提手','',''],['提拉米苏','',''],['提拔','',''],['提拨','',''],['提挈','',''],['提掖','',''],['提提','',''],['提携','',''],['提摩太','',''],['提摩太前书','',''],['提摩太后书','',''],['提早','',''],['提案','',''],['提案人','',''],['提桶','',''],['提梁','',''],['提款','',''],['提款卡','',''],['提款机','',''],['提水工程','',''],['提法','',''],['提溜','',''],['提灌','',''],['提灯','',''],['提炼','',''],['提炼厂','',''],['提牌执戟','',''],['提现','',''],['提琴','',''],['提留','',''],['提盒','',''],['提着','',''],['提督','',''],['提示','',''],['提示区','',''],['提示符','',''],['提示音','',''],['提神','',''],['提神剂','',''],['提神药','',''],['提神醒脑','',''],['提笔','',''],['提笔忘字','',''],['提箱','',''],['提篮','',''],['提篮儿','',''],['提级','',''],['提级提价','',''],['提纯','',''],['提纯复壮','',''],['提纲','',''],['提纲挈领','',''],['提线木偶','',''],['提给','',''],['提职','',''],['提职提薪','',''],['提花','',''],['提葫芦','',''],['提薪','',''],['提行','',''],['提补','',''],['提要','',''],['提议','',''],['提议者','',''],['提讯','',''],['提词','',''],['提请','',''],['提调','',''],['提谈','',''],['提货','',''],['提货单','',''],['提资','',''],['提赔','',''],['提起','',''],['提起公诉','',''],['提起精神','',''],['提足','',''],['提述','',''],['提退','',''],['提选','',''],['提速','',''],['提醒','',''],['提醒物','',''],['提醒者','',''],['提链','',''],['提问','',''],['提防','',''],['提领','',''],['提高','',''],['提高产量','',''],['提高劳动效率','',''],['提高工作效率','',''],['提高技术','',''],['提高效率','',''],['提高效益','',''],['提高生产率','',''],['提高生活水平','',''],['提高觉悟','',''],['提高警惕','',''],['提高认识','',''],['提高质量','',''],['插上','',''],['插不上手','',''],['插于','',''],['插件','',''],['插住','',''],['插值','',''],['插入','',''],['插入句','',''],['插入因子','',''],['插入排序','',''],['插入杂交','',''],['插入物','',''],['插入语','',''],['插入键','',''],['插关儿','',''],['插写','',''],['插到','',''],['插叙','',''],['插口','',''],['插句','',''],['插嘴','',''],['插图','',''],['插在','',''],['插头','',''],['插孔','',''],['插定','',''],['插屏','',''],['插座','',''],['插戴','',''],['插手','',''],['插插花花','',''],['插旗','',''],['插曲','',''],['插条','',''],['插板','',''],['插枝','',''],['插架万轴','',''],['插栓','',''],['插槽','',''],['插法','',''],['插犋','',''],['插班','',''],['插班生','',''],['插画','',''],['插科打浑','',''],['插科打诨','',''],['插秧','',''],['插秧机','',''],['插管','',''],['插线','',''],['插线板','',''],['插翅','',''],['插翅难逃','',''],['插翅难飞','',''],['插脚','',''],['插腰','',''],['插花','',''],['插花地','',''],['插补','',''],['插袋','',''],['插言','',''],['插话','',''],['插话式','',''],['插足','',''],['插身','',''],['插车','',''],['插进','',''],['插销','',''],['插锁','',''],['插队','',''],['插队落户','',''],['插页','',''],['揖拜','',''],['揖让','',''],['揘毕','',''],['揠苗助长','',''],['握云拿雾','',''],['握云携雨','',''],['握住','',''],['握别','',''],['握力','',''],['握发吐哺','',''],['握图临宇','',''],['握手','',''],['握手极欢','',''],['握手言和','',''],['握手言欢','',''],['握拳','',''],['握拳透掌','',''],['握持','',''],['握有','',''],['握椠怀铅','',''],['握法','',''],['握炭流汤','',''],['握牢','',''],['握瑜怪玉','',''],['握着','',''],['握紧','',''],['握紧拳头','',''],['握纲提领','',''],['握股','',''],['握蛇骑虎','',''],['握钩伸铁','',''],['握雨携云','',''],['握风捕影','',''],['揣合逢迎','',''],['揣在怀里','',''],['揣奸把猾','',''],['揣度','',''],['揣想','',''],['揣手','',''],['揣手儿','',''],['揣摩','',''],['揣歪捏怪','',''],['揣测','',''],['揣着','',''],['揣进','',''],['揩去','',''],['揩布','',''],['揩油','',''],['揩泪','',''],['揪人心肺','',''],['揪住','',''],['揪出','',''],['揪心','',''],['揪心扒肝','',''],['揪心揪肺','',''],['揪打','',''],['揪揪','',''],['揪斗','',''],['揪痧','',''],['揪著','',''],['揪辫子','',''],['揪送','',''],['揪错','',''],['揭下','',''],['揭丑','',''],['揭债还债','',''],['揭出','',''],['揭去','',''],['揭发','',''],['揭发者','',''],['揭帖','',''],['揭幕','',''],['揭幕式','',''],['揭底','',''],['揭开','',''],['揭开战幔','',''],['揭批','',''],['揭掉','',''],['揭晓','',''],['揭榜','',''],['揭橥','',''],['揭短','',''],['揭破','',''],['揭示','',''],['揭示者','',''],['揭秘','',''],['揭穿','',''],['揭竿','',''],['揭竿而起','',''],['揭谛','',''],['揭起','',''],['揭载','',''],['揭露','',''],['揭露者','',''],['揭面纱','',''],['揭黑','',''],['援交','',''],['援交妹','',''],['援交小姐','',''],['援例','',''],['援兵','',''],['援军','',''],['援助','',''],['援助之手','',''],['援助交际','',''],['援助机构','',''],['援古证今','',''],['援外','',''],['援建','',''],['援引','',''],['援手','',''],['援救','',''],['援救者','',''],['援溺振渴','',''],['援用','',''],['援笔成章','',''],['援笔立成','',''],['援笔而就','',''],['援藏','',''],['揶揄','',''],['揽在','',''],['揽子','',''],['揽工','',''],['揽权','',''],['揽权纳贿','',''],['揽活','',''],['揽胜','',''],['揽货','',''],['揽辔澄清','',''],['揾食','',''],['揿住','',''],['揿纽','',''],['揿钮','',''],['搀以','',''],['搀住','',''],['搀假','',''],['搀兑','',''],['搀入','',''],['搀合','',''],['搀和','',''],['搀扶','',''],['搀有','',''],['搀杂','',''],['搀杂用','',''],['搀水','',''],['搀行夺市','',''],['搀起','',''],['搀进','',''],['搀酒','',''],['搁下','',''],['搁不住','',''],['搁到','',''],['搁在','',''],['搁延','',''],['搁得住','',''],['搁板','',''],['搁架','',''],['搁浅','',''],['搁着','',''],['搁笔','',''],['搁置','',''],['搁脚板','',''],['搁脚物','',''],['搁起','',''],['搂住','',''],['搂在','',''],['搂头','',''],['搂抱','',''],['搂搂','',''],['搂梯','',''],['搂着','',''],['搂钱','',''],['搂颈','',''],['搅乱','',''],['搅乱器','',''],['搅动','',''],['搅匀','',''],['搅合','',''],['搅和','',''],['搅基','',''],['搅局','',''],['搅扰','',''],['搅拌','',''],['搅拌器','',''],['搅拌机','',''],['搅拌棒','',''],['搅散','',''],['搅浊','',''],['搅浑','',''],['搅海翻江','',''],['搅混','',''],['搅碎','',''],['搅翻','',''],['搅蛋器','',''],['搅过','',''],['搋在怀里','',''],['搋子','',''],['搋面','',''],['搌布','',''],['搏击','',''],['搏动','',''],['搏战','',''],['搏手','',''],['搏手无策','',''],['搏斗','',''],['搏杀','',''],['搏髀','',''],['搐动','',''],['搐搦','',''],['搓动','',''],['搓合','',''],['搓成','',''],['搓手','',''],['搓手跺脚','',''],['搓手顿脚','',''],['搓手顿足','',''],['搓捻','',''],['搓揉','',''],['搓板','',''],['搓洗','',''],['搓澡','',''],['搓粉团朱','',''],['搓粉抟朱','',''],['搓麻将','',''],['搔头','',''],['搔头弄姿','',''],['搔头抓耳','',''],['搔头摸耳','',''],['搔痒','',''],['搔痒症','',''],['搔着痒处','',''],['搔耳捶胸','',''],['搔肤器','',''],['搔首','',''],['搔首弄姿','',''],['搔首踟蹰','',''],['搜出','',''],['搜刮','',''],['搜取','',''],['搜奇抉怪','',''],['搜奇访古','',''],['搜奇选妙','',''],['搜寻','',''],['搜寻出','',''],['搜寻器','',''],['搜寻引擎','',''],['搜寻者','',''],['搜寻软体','',''],['搜扬仄陋','',''],['搜扬侧陋','',''],['搜括','',''],['搜捕','',''],['搜救','',''],['搜救犬','',''],['搜查','',''],['搜根剔牙','',''],['搜根问底','',''],['搜检','',''],['搜求','',''],['搜狐网','',''],['搜狗','',''],['搜索','',''],['搜索引擎','',''],['搜索枯肠','',''],['搜索论','',''],['搜罗','',''],['搜肠刮肚','',''],['搜获','',''],['搜藏','',''],['搜证','',''],['搜身','',''],['搜集','',''],['搜集品','',''],['搜集详尽','',''],['搞不清','',''],['搞乌龙','',''],['搞乱','',''],['搞了','',''],['搞出','',''],['搞到','',''],['搞到手','',''],['搞坏','',''],['搞垮','',''],['搞基','',''],['搞好','',''],['搞定','',''],['搞得','',''],['搞怪','',''],['搞成','',''],['搞活','',''],['搞混','',''],['搞清','',''],['搞特殊化','',''],['搞笑','',''],['搞笑片','',''],['搞糟','',''],['搞细','',''],['搞臭','',''],['搞花样','',''],['搞花样儿','',''],['搞起','',''],['搞通','',''],['搞钱','',''],['搞错','',''],['搞鬼','',''],['搠笔巡街','',''],['搦战','',''],['搦管操斛','',''],['搪塞','',''],['搪瓷','',''],['搪瓷器','',''],['搪突','',''],['搬上','',''],['搬了','',''],['搬光','',''],['搬入','',''],['搬兵','',''],['搬出','',''],['搬出去','',''],['搬到','',''],['搬动','',''],['搬去','',''],['搬口','',''],['搬口弄舌','',''],['搬唆','',''],['搬唇弄舌','',''],['搬唇递舌','',''],['搬场','',''],['搬家','',''],['搬开','',''],['搬弄','',''],['搬弄是非','',''],['搬指','',''],['搬掉','',''],['搬斤播两','',''],['搬来','',''],['搬演','',''],['搬用','',''],['搬石头砸自己的脚','',''],['搬砖砸脚','',''],['搬移','',''],['搬空','',''],['搬请','',''],['搬走','',''],['搬起石头砸自己的脚','',''],['搬迁','',''],['搬迁户','',''],['搬运','',''],['搬运工','',''],['搬进','',''],['搬铺','',''],['搭上','',''],['搭乘','',''],['搭伙','',''],['搭伴','',''],['搭作','',''],['搭便','',''],['搭便车','',''],['搭出','',''],['搭卖','',''],['搭咕','',''],['搭嘴','',''],['搭坐','',''],['搭声','',''],['搭头','',''],['搭好','',''],['搭客','',''],['搭帮','',''],['搭建','',''],['搭成','',''],['搭手','',''],['搭扣','',''],['搭把手','',''],['搭把手儿','',''],['搭拉','',''],['搭挡','',''],['搭接','',''],['搭接片','',''],['搭搭','',''],['搭救','',''],['搭机','',''],['搭架子','',''],['搭柏油','',''],['搭桌','',''],['搭档','',''],['搭桥','',''],['搭棚','',''],['搭牢','',''],['搭班','',''],['搭理','',''],['搭界','',''],['搭白','',''],['搭盖','',''],['搭缝','',''],['搭肩','',''],['搭背','',''],['搭脚儿','',''],['搭脚手架','',''],['搭腔','',''],['搭腰','',''],['搭膊','',''],['搭船','',''],['搭茬','',''],['搭茬儿','',''],['搭街坊','',''],['搭补','',''],['搭裢','',''],['搭讪','',''],['搭话','',''],['搭调','',''],['搭起','',''],['搭赸','',''],['搭车','',''],['搭轻铁','',''],['搭载','',''],['搭连','',''],['搭造','',''],['搭配','',''],['搭钩','',''],['搭铺','',''],['搳拳','',''],['搴旗','',''],['搴旗取将','',''],['搴旗斩馘','',''],['搴旗虏将','',''],['携云挈雨','',''],['携云握雨','',''],['携伴','',''],['携备','',''],['携家带口','',''],['携家带眷','',''],['携带','',''],['携带型','',''],['携带者','',''],['携幼','',''],['携幼扶老','',''],['携式','',''],['携弹','',''],['携手','',''],['携手前进','',''],['携手同行','',''],['携手并肩','',''],['携手并进','',''],['携枪','',''],['携款','',''],['携物','',''],['携男挈女','',''],['携眷','',''],['携老扶幼','',''],['携老挈幼','',''],['携贰','',''],['携领','',''],['携首接武','',''],['搽去','',''],['搽掉','',''],['搽粉','',''],['搽脂抹粉','',''],['摁扣','',''],['摁扣儿','',''],['摁钉','',''],['摁钉儿','',''],['摄位','',''],['摄像','',''],['摄像师','',''],['摄像头','',''],['摄像机','',''],['摄入','',''],['摄入量','',''],['摄制','',''],['摄制组','',''],['摄卫','',''],['摄去','',''],['摄取','',''],['摄在','',''],['摄威擅势','',''],['摄影','',''],['摄影场','',''],['摄影学','',''],['摄影家','',''],['摄影展','',''],['摄影师','',''],['摄影术','',''],['摄影机','',''],['摄影棚','',''],['摄影者','',''],['摄影联展','',''],['摄影记者','',''],['摄成','',''],['摄护腺','',''],['摄护腺肿大','',''],['摄政','',''],['摄政王','',''],['摄氏','',''],['摄氏度','',''],['摄氏温度表','',''],['摄氏温度计','',''],['摄氏表','',''],['摄理','',''],['摄生','',''],['摄生法','',''],['摄行','',''],['摄谱仪','',''],['摄象','',''],['摄食','',''],['摄魄钩魂','',''],['摅忠报国','',''],['摆上','',''],['摆个','',''],['摆乌龙','',''],['摆了','',''],['摆事实讲道理','',''],['摆出','',''],['摆列','',''],['摆到桌面上来','',''],['摆动','',''],['摆卖','',''],['摆在','',''],['摆在面前','',''],['摆在首位','',''],['摆地摊','',''],['摆好','',''],['摆姿势','',''],['摆子','',''],['摆宴','',''],['摆尾摇头','',''],['摆布','',''],['摆平','',''],['摆开','',''],['摆弄','',''],['摆成','',''],['摆手','',''],['摆手舞','',''],['摆掉','',''],['摆摆','',''],['摆摊','',''],['摆摊子','',''],['摆摊设点','',''],['摆擂台','',''],['摆放','',''],['摆明','',''],['摆架子','',''],['摆样子','',''],['摆格','',''],['摆正','',''],['摆渡','',''],['摆满','',''],['摆着','',''],['摆空架子','',''],['摆线','',''],['摆脱','',''],['摆脱危机','',''],['摆脱困境','',''],['摆臭','',''],['摆臭架子','',''],['摆舞','',''],['摆花架子','',''],['摆荡','',''],['摆荡吊环','',''],['摆著','',''],['摆设','',''],['摆设儿','',''],['摆谱','',''],['摆谱儿','',''],['摆轮','',''],['摆造型','',''],['摆酒','',''],['摆钟','',''],['摆门面','',''],['摆阔','',''],['摆阔气','',''],['摆饰','',''],['摆齐','',''],['摆龙门阵','',''],['摇下','',''],['摇了','',''],['摇低','',''],['摇光','',''],['摇出','',''],['摇到','',''],['摇动','',''],['摇匀','',''],['摇号','',''],['摇响','',''],['摇唇','',''],['摇唇鼓舌','',''],['摇头','',''],['摇头丸','',''],['摇头摆尾','',''],['摇头摆脑','',''],['摇头晃脑','',''],['摇奖','',''],['摇尾乞怜','',''],['摇幌','',''],['摇床','',''],['摇得','',''],['摇憾','',''],['摇扇','',''],['摇手','',''],['摇手触禁','',''],['摇把','',''],['摇控','',''],['摇摆','',''],['摇摆不定','',''],['摇摆人','',''],['摇摆着','',''],['摇摆舞','',''],['摇摇','',''],['摇摇头','',''],['摇摇摆摆','',''],['摇摇晃晃','',''],['摇摇欲坠','',''],['摇撼','',''],['摇旗','',''],['摇旗呐喊','',''],['摇晃','',''],['摇晃声','',''],['摇曳','',''],['摇曳多姿','',''],['摇杆','',''],['摇桨','',''],['摇椅','',''],['摇橹','',''],['摇滚','',''],['摇滚乐','',''],['摇滚舞','',''],['摇着','',''],['摇篮','',''],['摇篮曲','',''],['摇篮车','',''],['摇耧','',''],['摇臂','',''],['摇臂钻','',''],['摇船','',''],['摇荡','',''],['摇落','',''],['摇著','',''],['摇蚊','',''],['摇蜜','',''],['摇身','',''],['摇身一变','',''],['摇车','',''],['摇轴','',''],['摇醒','',''],['摇钱树','',''],['摇铃','',''],['摇铃打鼓','',''],['摇首顿足','',''],['摇鹅毛扇','',''],['摈弃','',''],['摈斥','',''],['摈除','',''],['摊主','',''],['摊付','',''],['摊位','',''],['摊儿','',''],['摊入','',''],['摊分','',''],['摊售','',''],['摊商','',''],['摊场','',''],['摊头','',''],['摊子','',''],['摊店','',''],['摊开','',''],['摊手','',''],['摊提','',''],['摊摊','',''],['摊晒','',''],['摊派','',''],['摊点','',''],['摊牌','',''],['摊薄','',''],['摊薄后每股盈利','',''],['摊贩','',''],['摊费','',''],['摊车','',''],['摊还','',''],['摊进','',''],['摊配','',''],['摊钱','',''],['摊销','',''],['摊鸡蛋','',''],['摒弃','',''],['摒挡','',''],['摒除','',''],['摔下','',''],['摔交','',''],['摔伤','',''],['摔倒','',''],['摔到','',''],['摔在','',''],['摔坏','',''],['摔开','',''],['摔得','',''],['摔打','',''],['摔掉','',''],['摔断','',''],['摔死','',''],['摔毁','',''],['摔破','',''],['摔碎','',''],['摔角','',''],['摔跟头','',''],['摔跤','',''],['摘下','',''],['摘伏发隐','',''],['摘借','',''],['摘出','',''],['摘去','',''],['摘发','',''],['摘取','',''],['摘取桂冠','',''],['摘句','',''],['摘句寻章','',''],['摘奸发伏','',''],['摘山煮海','',''],['摘帽','',''],['摘帽子','',''],['摘引','',''],['摘录','',''],['摘录者','',''],['摘心','',''],['摘抄','',''],['摘报','',''],['摘掉','',''],['摘牌','',''],['摘由','',''],['摘编','',''],['摘胆剜心','',''],['摘自','',''],['摘花','',''],['摘苹果','',''],['摘要','',''],['摘记','',''],['摘译','',''],['摘走','',''],['摘述','',''],['摘除','',''],['摞管','',''],['摧兰折玉','',''],['摧坚殪敌','',''],['摧坚获丑','',''],['摧坚陷阵','',''],['摧山搅海','',''],['摧志屈道','',''],['摧折','',''],['摧枯折腐','',''],['摧枯拉朽','',''],['摧枯拉腐','',''],['摧残','',''],['摧毁','',''],['摧眉折腰','',''],['摧胸剖肝','',''],['摧胸破肝','',''],['摧花','',''],['摧花斫柳','',''],['摧身碎首','',''],['摧锋陷阵','',''],['摩下','',''],['摩亨佐・达罗','',''],['摩加迪沙','',''],['摩卡','',''],['摩卡咖啡','',''],['摩厉以须','',''],['摩喉罗伽','',''],['摩城','',''],['摩天','',''],['摩天大厦','',''],['摩天大楼','',''],['摩天楼','',''],['摩天轮','',''],['摩娑','',''],['摩尔','',''],['摩尔人','',''],['摩尔多瓦人','',''],['摩尔定律','',''],['摩尔根','',''],['摩尔根主义','',''],['摩尼','',''],['摩尼教','',''],['摩崖','',''],['摩德纳','',''],['摩托','',''],['摩托化','',''],['摩托化部队','',''],['摩托罗垃','',''],['摩托罗拉','',''],['摩托船','',''],['摩托车','',''],['摩托车的士','',''],['摩拳擦掌','',''],['摩挲','',''],['摩揭陀','',''],['摩撒','',''],['摩擦','',''],['摩擦力','',''],['摩擦声','',''],['摩擦学','',''],['摩擦电','',''],['摩擦系数','',''],['摩擦计','',''],['摩擦阻力','',''],['摩擦音','',''],['摩斯','',''],['摩斯拉','',''],['摩根','',''],['摩根・弗里曼','',''],['摩根士丹利','',''],['摩梭','',''],['摩梭族','',''],['摩电灯','',''],['摩登','',''],['摩登原始人','',''],['摩的','',''],['摩羯','',''],['摩羯座','',''],['摩肩','',''],['摩肩击毂','',''],['摩肩如云','',''],['摩肩接踵','',''],['摩苏尔','',''],['摩莎','',''],['摩萨德','',''],['摩蟹座','',''],['摩西','',''],['摩西五经','',''],['摩西律法','',''],['摩西的律法','',''],['摩诃','',''],['摩诃婆罗多','',''],['摩门','',''],['摩门经','',''],['摩顶放踵','',''],['摩顶至足','',''],['摩顶至踵','',''],['摭华损实','',''],['摭拾','',''],['摸不着','',''],['摸不着头脑','',''],['摸准','',''],['摸出','',''],['摸到','',''],['摸去','',''],['摸吧','',''],['摸头','',''],['摸头不着','',''],['摸底','',''],['摸弄','',''],['摸彩','',''],['摸彩箱','',''],['摸排','',''],['摸摸','',''],['摸有','',''],['摸来','',''],['摸棱两可','',''],['摸清','',''],['摸爬滚打','',''],['摸牌','',''],['摸看','',''],['摸着','',''],['摸着石头过河','',''],['摸石头过河','',''],['摸索','',''],['摸索著','',''],['摸脉','',''],['摸袋子','',''],['摸象','',''],['摸过','',''],['摸透','',''],['摸门不着','',''],['摸门儿','',''],['摸鱼','',''],['摸鸡偷狗','',''],['摸黑','',''],['摸黑儿','',''],['摹仿','',''],['摹写','',''],['摹写品','',''],['摹制','',''],['摹刻','',''],['摹印','',''],['摹古','',''],['摹扎特','',''],['摹拟','',''],['摹描','',''],['摹本','',''],['摹状','',''],['摹画','',''],['摹绘','',''],['摺叠','',''],['摺合','',''],['摺椅','',''],['摺痕','',''],['摺线','',''],['摺缝','',''],['撂下','',''],['撂交','',''],['撂倒','',''],['撂在','',''],['撂地','',''],['撂地摊','',''],['撂手','',''],['撂挑','',''],['撂挑子','',''],['撂荒','',''],['撅嘴','',''],['撅起','',''],['撇下','',''],['撇去','',''],['撇取','',''],['撇号','',''],['撇嘴','',''],['撇子','',''],['撇开','',''],['撇开不谈','',''],['撇弃','',''],['撇掉','',''],['撇清','',''],['撇脱','',''],['撑伞','',''],['撑住','',''],['撑场面','',''],['撑天拄地','',''],['撑开','',''],['撑持','',''],['撑杆','',''],['撑杆跳','',''],['撑杆跳高','',''],['撑架','',''],['撑柱','',''],['撑死','',''],['撑物','',''],['撑眉怒眼','',''],['撑着','',''],['撑破','',''],['撑竿','',''],['撑竿跳','',''],['撑竿跳高','',''],['撑篙','',''],['撑紧','',''],['撑肠拄肚','',''],['撑肠拄腹','',''],['撑腰','',''],['撑船','',''],['撑起','',''],['撑门面','',''],['撒丁岛','',''],['撒丫子','',''],['撒但','',''],['撒克逊','',''],['撒克逊人','',''],['撒刁','',''],['撒切尔','',''],['撒切尔夫人','',''],['撒呓挣','',''],['撒哈拉','',''],['撒哈拉以南','',''],['撒哈拉以南非洲','',''],['撒哈拉沙漠','',''],['撒在','',''],['撒娇','',''],['撒娇卖俏','',''],['撒娇撒痴','',''],['撒尔孟','',''],['撒尿','',''],['撒布','',''],['撒开','',''],['撒手','',''],['撒手不管','',''],['撒手人寰','',''],['撒手锏','',''],['撒手闭眼','',''],['撒拉','',''],['撒拉语','',''],['撒拉逊人','',''],['撒拉铁','',''],['撒播','',''],['撒施','',''],['撒旦','',''],['撒村','',''],['撒欢儿','',''],['撒母耳纪上','',''],['撒母耳纪下','',''],['撒母耳记上','',''],['撒母耳记下','',''],['撒气','',''],['撒水','',''],['撒沙子','',''],['撒泼','',''],['撒泼打滚','',''],['撒泼放刁','',''],['撒满','',''],['撒然','',''],['撒督','',''],['撒种','',''],['撒科打诨','',''],['撒网','',''],['撒网捕风','',''],['撒罗满','',''],['撒胡椒面','',''],['撒脚','',''],['撒腿','',''],['撒营','',''],['撒落','',''],['撒诈捣虚','',''],['撒谎','',''],['撒豆成兵','',''],['撒赖','',''],['撒迦利亚','',''],['撒迦利亚书','',''],['撒遍','',''],['撒都该人','',''],['撒酒疯','',''],['撒野','',''],['撒门','',''],['撒食','',''],['撒马尔干','',''],['撒马尔罕','',''],['撕下','',''],['撕去','',''],['撕咬','',''],['撕坏','',''],['撕开','',''],['撕得','',''],['撕成','',''],['撕打','',''],['撕扯','',''],['撕掉','',''],['撕杀','',''],['撕毁','',''],['撕烂','',''],['撕破','',''],['撕破脸','',''],['撕破脸皮','',''],['撕碎','',''],['撕碎机','',''],['撕票','',''],['撕裂','',''],['撙节','',''],['撞一天钟','',''],['撞上','',''],['撞了','',''],['撞人','',''],['撞伤','',''],['撞倒','',''],['撞入','',''],['撞击','',''],['撞击声','',''],['撞击式印表机','',''],['撞击式打印机','',''],['撞到','',''],['撞坏','',''],['撞声','',''],['撞大运','',''],['撞府冲州','',''],['撞府穿州','',''],['撞开','',''],['撞性','',''],['撞打','',''],['撞撞','',''],['撞歪','',''],['撞死','',''],['撞毁','',''],['撞烂','',''],['撞球','',''],['撞球家','',''],['撞着','',''],['撞破','',''],['撞碎','',''],['撞见','',''],['撞车','',''],['撞运气','',''],['撞进','',''],['撞针','',''],['撞钟','',''],['撞锁','',''],['撞阵冲军','',''],['撞骗','',''],['撤了','',''],['撤佃','',''],['撤侨','',''],['撤免','',''],['撤兵','',''],['撤军','',''],['撤出','',''],['撤去','',''],['撤回','',''],['撤守','',''],['撤完','',''],['撤差','',''],['撤席','',''],['撤并','',''],['撤换','',''],['撤掉','',''],['撤架','',''],['撤款','',''],['撤消','',''],['撤离','',''],['撤空','',''],['撤职','',''],['撤职查办','',''],['撤营','',''],['撤诉','',''],['撤资','',''],['撤走','',''],['撤退','',''],['撤销','',''],['撤销职务','',''],['撤防','',''],['撤除','',''],['撩乱','',''],['撩云拨雨','',''],['撩人','',''],['撩动','',''],['撩开','',''],['撩惹','',''],['撩拨','',''],['撩是生非','',''],['撩望','',''],['撩蜂剔蝎','',''],['撩蜂吃蛰','',''],['撩蜂拔刺','',''],['撩起','',''],['撩逗','',''],['撬动','',''],['撬坏','',''],['撬开','',''],['撬杠','',''],['撬棍','',''],['撬窃','',''],['撬走','',''],['撬起','',''],['撬锁','',''],['撬门','',''],['播下','',''],['播出','',''],['播发','',''],['播客','',''],['播幅','',''],['播弄','',''],['播恶遗臭','',''],['播扬','',''],['播报','',''],['播报员','',''],['播报者','',''],['播撒','',''],['播放','',''],['播放列表','',''],['播放机','',''],['播散','',''],['播映','',''],['播种','',''],['播种期','',''],['播种机','',''],['播种者','',''],['播种面','',''],['播种面积','',''],['播糠眯目','',''],['播讲','',''],['播读','',''],['播转','',''],['播过','',''],['播送','',''],['播送者','',''],['播音','',''],['播音员','',''],['播音室','',''],['撮儿','',''],['撮口呼','',''],['撮合','',''],['撮子','',''],['撮弄','',''],['撮盐入水','',''],['撮盐入火','',''],['撮科打哄','',''],['撮箕','',''],['撮要','',''],['撰书','',''],['撰写','',''],['撰序','',''],['撰录','',''],['撰拟','',''],['撰文','',''],['撰文者','',''],['撰稿','',''],['撰稿人','',''],['撰者','',''],['撰著','',''],['撰述','',''],['撵出','',''],['撵开','',''],['撵走','',''],['撵跑','',''],['撷取','',''],['撸子','',''],['撺哄鸟乱','',''],['撺弄','',''],['撺拳拢袖','',''],['撺掇','',''],['撼人','',''],['撼动','',''],['撼地摇天','',''],['撼天动地','',''],['撼天震地','',''],['撼山拔树','',''],['撼树蚍蚨','',''],['撼树蚍蜉','',''],['擀面杖','',''],['擂台','',''],['擂台赛','',''],['擂天倒地','',''],['擂钵','',''],['擂鼓','',''],['擂鼓筛锣','',''],['擂鼓鸣金','',''],['擅于','',''],['擅作','',''],['擅作威福','',''],['擅入','',''],['擅取','',''],['擅场','',''],['擅定','',''],['擅改','',''],['擅断','',''],['擅权','',''],['擅用','',''],['擅离','',''],['擅离职守','',''],['擅美','',''],['擅自','',''],['擅长','',''],['擅闯','',''],['操之','',''],['操之过急','',''],['操作','',''],['操作上','',''],['操作台','',''],['操作员','',''],['操作器','',''],['操作性','',''],['操作步骤','',''],['操作环境','',''],['操作系统','',''],['操作者','',''],['操作规程','',''],['操作说明','',''],['操作速率','',''],['操你妈','',''],['操典','',''],['操刀','',''],['操刀手','',''],['操切','',''],['操券','',''],['操办','',''],['操劳','',''],['操劳过度','',''],['操场','',''],['操坪','',''],['操守','',''],['操守无暇','',''],['操屄','',''],['操心','',''],['操戈','',''],['操戈入室','',''],['操持','',''],['操控','',''],['操斧伐柯','',''],['操枪','',''],['操法','',''],['操游','',''],['操演','',''],['操琴','',''],['操盘手','',''],['操神','',''],['操纵','',''],['操纵台','',''],['操纵杆','',''],['操纵箱','',''],['操纵者','',''],['操纵自如','',''],['操练','',''],['操翰成章','',''],['操航','',''],['操舵','',''],['操舵室','',''],['操蛋','',''],['操行','',''],['操觚','',''],['操觚染翰','',''],['操课','',''],['操逼','',''],['操队','',''],['擎天','',''],['擎天之柱','',''],['擎天架海','',''],['擎天柱','',''],['擎天玉柱','',''],['擎拳合掌','',''],['擎着','',''],['擎苍牵黄','',''],['擒住','',''],['擒奸讨暴','',''],['擒拿','',''],['擒捉','',''],['擒纵','',''],['擒获','',''],['擒虎拿蛟','',''],['擒贼','',''],['擒贼先擒王','',''],['擒贼擒王','',''],['擒龙缚虎','',''],['擗踊拊心','',''],['擘划','',''],['擘开','',''],['擘画','',''],['擘肌分理','',''],['擘蓝','',''],['擢升','',''],['擢发抽肠','',''],['擢发难数','',''],['擢用','',''],['擢第','',''],['擤鼻涕','',''],['擦上','',''],['擦不掉','',''],['擦了','',''],['擦于','',''],['擦亮','',''],['擦亮眼睛','',''],['擦亮石','',''],['擦伤','',''],['擦光剂','',''],['擦光油','',''],['擦写','',''],['擦净','',''],['擦剂','',''],['擦去','',''],['擦声','',''],['擦子','',''],['擦屁股','',''],['擦干','',''],['擦干净','',''],['擦或压','',''],['擦把','',''],['擦拭','',''],['擦拳抹掌','',''],['擦拳磨掌','',''],['擦掉','',''],['擦掌磨拳','',''],['擦撞而过','',''],['擦擦','',''],['擦桌','',''],['擦棒球','',''],['擦汗','',''],['擦油','',''],['擦洗','',''],['擦澡','',''],['擦热','',''],['擦痕','',''],['擦皮鞋','',''],['擦眼泪','',''],['擦着','',''],['擦破','',''],['擦碎','',''],['擦碗布','',''],['擦磨','',''],['擦粉','',''],['擦网球','',''],['擦肩','',''],['擦肩而过','',''],['擦背','',''],['擦脂抹粉','',''],['擦腚纸','',''],['擦药','',''],['擦身而过','',''],['擦边','',''],['擦边球','',''],['擦过','',''],['擦除','',''],['擦鞋','',''],['擦鞋垫','',''],['擦鞋者','',''],['擦音','',''],['擦黑儿','',''],['攀上','',''],['攀亲','',''],['攀亲托熟','',''],['攀亲道故','',''],['攀今揽古','',''],['攀今比昔','',''],['攀今览古','',''],['攀供','',''],['攀升','',''],['攀害','',''],['攀岩','',''],['攀扯','',''],['攀折','',''],['攀援','',''],['攀援茎','',''],['攀木鱼','',''],['攀枝','',''],['攀枝花地区','',''],['攀比','',''],['攀爬','',''],['攀登','',''],['攀登者','',''],['攀着','',''],['攀缘','',''],['攀花折柳','',''],['攀藤揽葛','',''],['攀藤附葛','',''],['攀蟾折桂','',''],['攀诬','',''],['攀诬陷害','',''],['攀谈','',''],['攀越','',''],['攀车卧辙','',''],['攀辕卧辙','',''],['攀附','',''],['攀附权贵','',''],['攀高接贵','',''],['攀高结贵','',''],['攀鳞附翼','',''],['攀龙托凤','',''],['攀龙附凤','',''],['攀龙附骥','',''],['攉煤机','',''],['攒三聚五','',''],['攒射','',''],['攒成','',''],['攒眉','',''],['攒眉苦脸','',''],['攒簇','',''],['攒聚','',''],['攒钱','',''],['攘人之美','',''],['攘善','',''],['攘场','',''],['攘外','',''],['攘外安内','',''],['攘夷','',''],['攘夺','',''],['攘攘','',''],['攘灾','',''],['攘窃','',''],['攘羊','',''],['攘臂','',''],['攘臂一呼','',''],['攘臂而起','',''],['攘袂','',''],['攘袂切齿','',''],['攘袂扼腕','',''],['攘袖','',''],['攘诟','',''],['攘辟','',''],['攘除','',''],['攥着','',''],['攫住','',''],['攫取','',''],['攫夺','',''],['攫戾执猛','',''],['攮子','',''],['支与流裔','',''],['支书','',''],['支付','',''],['支付不起','',''],['支付协定','',''],['支付得起','',''],['支付日','',''],['支付款','',''],['支付者','',''],['支住','',''],['支使','',''],['支光','',''],['支公司','',''],['支农','',''],['支出','',''],['支前','',''],['支前工作','',''],['支助','',''],['支努干','',''],['支单','',''],['支原体','',''],['支原体肺炎','',''],['支取','',''],['支叶扶疏','',''],['支吾','',''],['支吾其词','',''],['支嘴儿','',''],['支委','',''],['支委会','',''],['支子','',''],['支字','',''],['支局','',''],['支左','',''],['支差','',''],['支库','',''],['支应','',''],['支店','',''],['支座','',''],['支开','',''],['支恐','',''],['支息','',''],['支承','',''],['支承销','',''],['支护','',''],['支招','',''],['支拨','',''],['支持','',''],['支持下','',''],['支持度','',''],['支持点','',''],['支持物','',''],['支持率','',''],['支持者','',''],['支援','',''],['支援前线','',''],['支援者','',''],['支撑','',''],['支撑力','',''],['支撑架','',''],['支撑点','',''],['支撑物','',''],['支支吾吾','',''],['支教','',''],['支数','',''],['支族','',''],['支杆','',''],['支枢','',''],['支架','',''],['支柱','',''],['支柱产业','',''],['支根','',''],['支棱','',''],['支款','',''],['支气管','',''],['支气管炎','',''],['支派','',''],['支流','',''],['支渠','',''],['支炉儿','',''],['支点','',''],['支用','',''],['支着儿','',''],['支票','',''],['支票簿','',''],['支离','',''],['支离破碎','',''],['支离繁碎','',''],['支竿','',''],['支系','',''],['支系统','',''],['支索','',''],['支线','',''],['支绌','',''],['支给','',''],['支脉','',''],['支船柱','',''],['支薪','',''],['支行','',''],['支解','',''],['支走','',''],['支路','',''],['支边','',''],['支那','',''],['支部','',''],['支部书记','',''],['支配','',''],['支配下','',''],['支配人','',''],['支配力','',''],['支配权','',''],['支配者','',''],['支链反应','',''],['支队','',''],['支领','',''],['收下','',''],['收之桑榆','',''],['收买','',''],['收买人','',''],['收付','',''],['收件','',''],['收件人','',''],['收件匣','',''],['收件箱','',''],['收伏','',''],['收信','',''],['收信人','',''],['收信机','',''],['收债','',''],['收假','',''],['收入','',''],['收入政策','',''],['收入水平','',''],['收兵','',''],['收养','',''],['收冬','',''],['收到','',''],['收割','',''],['收割机','',''],['收割者','',''],['收力','',''],['收发','',''],['收发器','',''],['收发室','',''],['收发短信','',''],['收取','',''],['收受','',''],['收受者','',''],['收受贿赂','',''],['收口','',''],['收听','',''],['收听者','',''],['收回','',''],['收回成命','',''],['收场','',''],['收复','',''],['收复失地','',''],['收好','',''],['收妥','',''],['收存','',''],['收存入','',''],['收存箱','',''],['收完','',''],['收官','',''],['收审','',''],['收容','',''],['收容力','',''],['收容审查','',''],['收容所','',''],['收尸','',''],['收尾','',''],['收尾音','',''],['收工','',''],['收差','',''],['收市','',''],['收帐','',''],['收废站','',''],['收归国有','',''],['收当人','',''],['收录','',''],['收录机','',''],['收心','',''],['收悉','',''],['收成','',''],['收房','',''],['收执','',''],['收报','',''],['收报人','',''],['收报员','',''],['收报室','',''],['收报机','',''],['收押','',''],['收拢','',''],['收拾','',''],['收据','',''],['收掉','',''],['收揽','',''],['收摊','',''],['收摊儿','',''],['收操','',''],['收支','',''],['收支平衡','',''],['收支平衡点','',''],['收支相抵','',''],['收放','',''],['收效','',''],['收效甚微','',''],['收敛','',''],['收敛剂','',''],['收敛序列','',''],['收敛性','',''],['收敛级数','',''],['收敛锋芒','',''],['收文','',''],['收方','',''],['收服','',''],['收权','',''],['收束','',''],['收条','',''],['收来','',''],['收款','',''],['收款人','',''],['收款台','',''],['收款员','',''],['收款机','',''],['收残缀轶','',''],['收殓','',''],['收汇','',''],['收治','',''],['收清','',''],['收煞','',''],['收生','',''],['收生婆','',''],['收用','',''],['收留','',''],['收留所','',''],['收益','',''],['收益分配','',''],['收益多','',''],['收益帐户','',''],['收益率','',''],['收监','',''],['收盘','',''],['收盘价','',''],['收看','',''],['收礼','',''],['收票人','',''],['收票员','',''],['收秋','',''],['收租','',''],['收税','',''],['收税人','',''],['收税员','',''],['收税官','',''],['收紧','',''],['收约','',''],['收纳','',''],['收线','',''],['收编','',''],['收缩','',''],['收缩了','',''],['收缩压','',''],['收缩性','',''],['收缩肌','',''],['收缴','',''],['收罗','',''],['收获','',''],['收获期','',''],['收获物','',''],['收获节','',''],['收藏','',''],['收藏品','',''],['收藏夹','',''],['收藏家','',''],['收视','',''],['收视反听','',''],['收视机','',''],['收视率','',''],['收讫','',''],['收讯','',''],['收词','',''],['收话','',''],['收账','',''],['收货','',''],['收货人','',''],['收购','',''],['收购价','',''],['收购价格','',''],['收购站','',''],['收购要约','',''],['收购量','',''],['收购额','',''],['收费','',''],['收费站','',''],['收贿','',''],['收赃者','',''],['收走','',''],['收起','',''],['收足','',''],['收转','',''],['收迄','',''],['收进','',''],['收钱','',''],['收银','',''],['收银台','',''],['收银员','',''],['收银机','',''],['收集','',''],['收集情报','',''],['收集成','',''],['收集者','',''],['收音','',''],['收音机','',''],['收风','',''],['收齐','',''],['攸关','',''],['改业','',''],['改为','',''],['改之','',''],['改乘','',''],['改习','',''],['改产','',''],['改任','',''],['改作','',''],['改俗迁风','',''],['改信','',''],['改修','',''],['改做','',''],['改元','',''],['改写','',''],['改击','',''],['改判','',''],['改制','',''],['改动','',''],['改变','',''],['改变信仰者','',''],['改变形像','',''],['改变方向','',''],['改变者','',''],['改变面貌','',''],['改口','',''],['改名','',''],['改名换姓','',''],['改名易姓','',''],['改向','',''],['改善','',''],['改善关系','',''],['改善生活','',''],['改善通讯','',''],['改嘴','',''],['改回','',''],['改型','',''],['改天','',''],['改天换地','',''],['改头换面','',''],['改姓','',''],['改姓更名','',''],['改嫁','',''],['改寄','',''],['改小','',''],['改帐','',''],['改建','',''],['改张易调','',''],['改弦换张','',''],['改弦易调','',''],['改弦易辙','',''],['改弦更张','',''],['改恶从善','',''],['改恶向善','',''],['改恶行善','',''],['改悔','',''],['改成','',''],['改打','',''],['改换','',''],['改换家门','',''],['改换门庭','',''],['改换门闾','',''],['改掉','',''],['改改','',''],['改日','',''],['改易','',''],['改朝','',''],['改朝换代','',''],['改期','',''],['改样','',''],['改次','',''],['改正','',''],['改正缺点','',''],['改正错误','',''],['改步改玉','',''],['改版','',''],['改玉改行','',''],['改用','',''],['改由','',''],['改种','',''],['改称','',''],['改稿','',''],['改窜','',''],['改组','',''],['改组派','',''],['改编','',''],['改编本','',''],['改良','',''],['改良主义','',''],['改良品种','',''],['改良派','',''],['改良者','',''],['改葬','',''],['改行','',''],['改行迁善','',''],['改装','',''],['改观','',''],['改订','',''],['改订伊犁条约','',''],['改记','',''],['改译','',''],['改说','',''],['改调','',''],['改辕易辙','',''],['改辙','',''],['改过','',''],['改过不吝','',''],['改过从善','',''],['改过作新','',''],['改过向善','',''],['改过自新','',''],['改过迁善','',''],['改进','',''],['改进工作','',''],['改述','',''],['改选','',''],['改途','',''],['改造','',''],['改造思想','',''],['改造社会','',''],['改道','',''],['改邪','',''],['改邪归正','',''],['改错','',''],['改锥','',''],['改革','',''],['改革家','',''],['改革开放','',''],['改革派','',''],['改革者','',''],['改革进程','',''],['攻下','',''],['攻不破','',''],['攻为','',''],['攻事','',''],['攻于','',''],['攻伐','',''],['攻克','',''],['攻入','',''],['攻关','',''],['攻关项目','',''],['攻其','',''],['攻其不备','',''],['攻击','',''],['攻击力','',''],['攻击型核潜艇','',''],['攻击机','',''],['攻击目标','',''],['攻击线','',''],['攻剽','',''],['攻势','',''],['攻占','',''],['攻取','',''],['攻坚','',''],['攻坚战','',''],['攻城','',''],['攻城掠地','',''],['攻城木','',''],['攻城略地','',''],['攻城野战','',''],['攻子之盾','',''],['攻守','',''],['攻守同盟','',''],['攻心','',''],['攻心战','',''],['攻心战术','',''],['攻心翻','',''],['攻打','',''],['攻效','',''],['攻无不克','',''],['攻无不取','',''],['攻歼','',''],['攻灭','',''],['攻略','',''],['攻砭','',''],['攻破','',''],['攻苦食淡','',''],['攻讦','',''],['攻读','',''],['攻错','',''],['攻防','',''],['攻陷','',''],['放上','',''],['放下','',''],['放下包袱','',''],['放下屠刀','',''],['放下屠刀立地成佛','',''],['放下架子','',''],['放不下','',''],['放不下心','',''],['放之四海而皆准','',''],['放了','',''],['放于','',''],['放任','',''],['放任政策','',''],['放任自流','',''],['放低','',''],['放债','',''],['放假','',''],['放光','',''],['放入','',''],['放养','',''],['放冷风','',''],['放出','',''],['放刁','',''],['放刁撒泼','',''],['放到','',''],['放印子','',''],['放后','',''],['放告','',''],['放哨','',''],['放回','',''],['放在','',''],['放在优先地位','',''],['放在心上','',''],['放在眼里','',''],['放在第一位','',''],['放在首位','',''],['放声','',''],['放声大哭','',''],['放大','',''],['放大倍数','',''],['放大器','',''],['放大机','',''],['放大率','',''],['放大系数','',''],['放大纸','',''],['放大镜','',''],['放好','',''],['放学','',''],['放学后','',''],['放定','',''],['放宽','',''],['放对','',''],['放射','',''],['放射作战','',''],['放射免疫测定','',''],['放射学','',''],['放射形','',''],['放射性','',''],['放射性元素','',''],['放射性发光材料','',''],['放射性同位素','',''],['放射性废物','',''],['放射性战剂','',''],['放射性最强点','',''],['放射性材料','',''],['放射性核素','',''],['放射性武器','',''],['放射性污染','',''],['放射性沾染','',''],['放射性沾染物','',''],['放射性活度','',''],['放射性烟羽','',''],['放射性碎片','',''],['放射性碘','',''],['放射性粘染','',''],['放射性落下灰','',''],['放射性衰变','',''],['放射性计时','',''],['放射治疗','',''],['放射源','',''],['放射物','',''],['放射状','',''],['放射率','',''],['放射生成物','',''],['放射疗法','',''],['放射病','',''],['放射线','',''],['放射虫','',''],['放射防护','',''],['放屁','',''],['放屁虫','',''],['放工','',''],['放帐','',''],['放干','',''],['放平','',''],['放开','',''],['放开价格','',''],['放开经营','',''],['放弃','',''],['放弃者','',''],['放得下','',''],['放心','',''],['放心不下','',''],['放怀','',''],['放恣','',''],['放情丘壑','',''],['放慢','',''],['放手','',''],['放手一搏','',''],['放掉','',''],['放散','',''],['放映','',''],['放映室','',''],['放映师','',''],['放映机','',''],['放晴','',''],['放权','',''],['放松','',''],['放松管制','',''],['放枪','',''],['放样','',''],['放款','',''],['放歌','',''],['放步','',''],['放毒','',''],['放气','',''],['放水','',''],['放洋','',''],['放活','',''],['放浪','',''],['放浪不羁','',''],['放浪形骸','',''],['放淤','',''],['放火','',''],['放火狂','',''],['放火者','',''],['放炮','',''],['放烟幕弹','',''],['放热','',''],['放热反应','',''],['放热器','',''],['放焰口','',''],['放爆竹','',''],['放牛','',''],['放牛归马','',''],['放牧','',''],['放球','',''],['放生','',''],['放电','',''],['放盘','',''],['放眼','',''],['放眼世界','',''],['放眼望去','',''],['放着','',''],['放着明白装糊涂','',''],['放空','',''],['放空气','',''],['放空炮','',''],['放纵','',''],['放纵不拘','',''],['放纵不羁','',''],['放线菌','',''],['放缓','',''],['放缩尺','',''],['放置','',''],['放羊','',''],['放羊娃','',''],['放肆','',''],['放胆','',''],['放荒','',''],['放荡','',''],['放荡不拘','',''],['放荡不羁','',''],['放荡者','',''],['放著','',''],['放虎','',''],['放虎归山','',''],['放虎自卫','',''],['放血','',''],['放行','',''],['放言','',''],['放言高论','',''],['放话','',''],['放诞','',''],['放诞不拘','',''],['放诞不羁','',''],['放诞风流','',''],['放诱饵','',''],['放账','',''],['放贷','',''],['放走','',''],['放起','',''],['放轻','',''],['放达','',''],['放过','',''],['放还','',''],['放进','',''],['放远','',''],['放送','',''],['放逐','',''],['放量','',''],['放针','',''],['放钱','',''],['放错','',''],['放长','',''],['放长线钓大鱼','',''],['放青','',''],['放青苗','',''],['放鞭炮','',''],['放音','',''],['放风','',''],['放风筝','',''],['放飞','',''],['放飞机','',''],['放马','',''],['放马后炮','',''],['放高','',''],['放鸽子','',''],['放鹰逐犬','',''],['政事','',''],['政令','',''],['政令不一','',''],['政企','',''],['政企分开','',''],['政体','',''],['政党','',''],['政党政治','',''],['政出多门','',''],['政务','',''],['政务会','',''],['政务官','',''],['政务院','',''],['政区','',''],['政协','',''],['政协委员','',''],['政变','',''],['政商','',''],['政圈','',''],['政坛','',''],['政大','',''],['政委','',''],['政学系','',''],['政审','',''],['政客','',''],['政局','',''],['政局演变','',''],['政工','',''],['政工干部','',''],['政府','',''],['政府代表','',''],['政府债券','',''],['政府军','',''],['政府大学院','',''],['政府官员','',''],['政府工作','',''],['政府工作报告','',''],['政府总理','',''],['政府新闻处','',''],['政府机关','',''],['政府机关开放系统互连总则','',''],['政府机构','',''],['政府警告','',''],['政府部门','',''],['政府首脑','',''],['政情','',''],['政战','',''],['政敌','',''],['政教','',''],['政教合一','',''],['政机机关','',''],['政权','',''],['政权建设','',''],['政权机关','',''],['政权真空','',''],['政柄','',''],['政治','',''],['政治上','',''],['政治事件','',''],['政治人物','',''],['政治任务','',''],['政治体制','',''],['政治关系','',''],['政治制度','',''],['政治动员','',''],['政治化','',''],['政治协商会议','',''],['政治协理员','',''],['政治危机','',''],['政治史','',''],['政治地位','',''],['政治处','',''],['政治委员','',''],['政治学','',''],['政治学院','',''],['政治宣传','',''],['政治家','',''],['政治局','',''],['政治局势','',''],['政治局面','',''],['政治常识','',''],['政治庇护','',''],['政治异议人士','',''],['政治形势','',''],['政治思想','',''],['政治思想史','',''],['政治思想工作','',''],['政治思想教育','',''],['政治思潮','',''],['政治性','',''],['政治情况','',''],['政治战略','',''],['政治报告','',''],['政治指导员','',''],['政治改革','',''],['政治教导员','',''],['政治斗争','',''],['政治方向','',''],['政治机关','',''],['政治机构','',''],['政治权利','',''],['政治权力','',''],['政治气候','',''],['政治活动','',''],['政治派别','',''],['政治犯','',''],['政治理念','',''],['政治理论','',''],['政治生活','',''],['政治社会学','',''],['政治立场','',''],['政治素质','',''],['政治纲领','',''],['政治经济','',''],['政治经济学','',''],['政治统计','',''],['政治罢工','',''],['政治舞台','',''],['政治解决','',''],['政治课','',''],['政治谋略','',''],['政治责任','',''],['政治路线','',''],['政治运动','',''],['政治追求','',''],['政治追讨','',''],['政治避难','',''],['政治部','',''],['政治问题','',''],['政治阴谋','',''],['政治集团','',''],['政治面目','',''],['政治领导','',''],['政法','',''],['政法部门','',''],['政派','',''],['政清狱简','',''],['政理','',''],['政界','',''],['政略','',''],['政略性','',''],['政策','',''],['政策主张','',''],['政策亏损','',''],['政策性','',''],['政策法规','',''],['政策界限','',''],['政策研究','',''],['政简刑清','',''],['政纪','',''],['政纪处分','',''],['政纲','',''],['政经','',''],['政绩','',''],['政要','',''],['政见','',''],['政训处','',''],['政论','',''],['政通','',''],['政通人和','',''],['政风','',''],['故世','',''],['故业','',''],['故主','',''],['故乡','',''],['故书','',''],['故事','',''],['故事书','',''],['故事体','',''],['故事影片','',''],['故事片','',''],['故事诗','',''],['故云','',''],['故交','',''],['故人','',''],['故伎','',''],['故伎重演','',''],['故作','',''],['故作多情','',''],['故作姿态','',''],['故作深沉','',''],['故作端庄','',''],['故做','',''],['故典','',''],['故剑','',''],['故剑情深','',''],['故去','',''],['故友','',''],['故名','',''],['故吏','',''],['故园','',''],['故国','',''],['故土','',''],['故土难移','',''],['故在','',''],['故地','',''],['故地重游','',''],['故址','',''],['故墓','',''],['故多','',''],['故宅','',''],['故实','',''],['故宫','',''],['故宫博物院','',''],['故宫禾黍','',''],['故家','',''],['故家子弟','',''],['故居','',''],['故弄','',''],['故弄悬虚','',''],['故弄玄虚','',''],['故态','',''],['故态复萌','',''],['故意','',''],['故我','',''],['故技','',''],['故技重演','',''],['故旧','',''],['故旧不弃','',''],['故智','',''],['故杀','',''],['故此','',''],['故步自封','',''],['故犯','',''],['故知','',''],['故称','',''],['故第','',''],['故纵','',''],['故纸堆','',''],['故老','',''],['故而','',''],['故要','',''],['故训','',''],['故账','',''],['故辙','',''],['故迹','',''],['故道','',''],['故都','',''],['故里','',''],['故障','',''],['故障排除','',''],['效上','',''],['效价','',''],['效价能','',''],['效仿','',''],['效力','',''],['效劳','',''],['效命','',''],['效尤','',''],['效应','',''],['效应器','',''],['效忠','',''],['效忠誓词','',''],['效果','',''],['效果图','',''],['效果宏大','',''],['效果显著','',''],['效法','',''],['效率','',''],['效率高','',''],['效用','',''],['效益','',''],['效益年活动','',''],['效能','',''],['效颦','',''],['效颦学步','',''],['效验','',''],['敉平','',''],['敌中','',''],['敌人','',''],['敌众我寡','',''],['敌伪','',''],['敌体','',''],['敌兵','',''],['敌军','',''],['敌前','',''],['敌占','',''],['敌占区','',''],['敌友','',''],['敌台','',''],['敌后','',''],['敌国','',''],['敌地','',''],['敌基督','',''],['敌害','',''],['敌寇','',''],['敌对','',''],['敌对性','',''],['敌对者','',''],['敌将','',''],['敌工','',''],['敌师','',''],['敌得过','',''],['敌忾','',''],['敌忾同仇','',''],['敌情','',''],['敌意','',''],['敌我','',''],['敌我矛盾','',''],['敌所','',''],['敌手','',''],['敌探','',''],['敌敌畏','',''],['敌方','',''],['敌机','',''],['敌杀死','',''],['敌档','',''],['敌楼','',''],['敌焰','',''],['敌特','',''],['敌特分子','',''],['敌百虫','',''],['敌稗','',''],['敌群','',''],['敌者','',''],['敌船','',''],['敌营','',''],['敌视','',''],['敌酋','',''],['敌队','',''],['敌阵','',''],['敏原','',''],['敏悟','',''],['敏感','',''],['敏感化','',''],['敏感性','',''],['敏感物质','',''],['敏捷','',''],['敏锐','',''],['救世','',''],['救世主','',''],['救世军','',''],['救主','',''],['救了','',''],['救亡','',''],['救亡图存','',''],['救人','',''],['救人一命','',''],['救人一命胜造七级浮屠','',''],['救人须救彻','',''],['救兵','',''],['救出','',''],['救助','',''],['救去','',''],['救命','',''],['救命恩人','',''],['救命者','',''],['救困扶危','',''],['救国','',''],['救场','',''],['救场如救火','',''],['救市','',''],['救应','',''],['救急','',''],['救急不救穷','',''],['救恩','',''],['救恩计划','',''],['救我','',''],['救护','',''],['救护人员','',''],['救护所','',''],['救护车','',''],['救捞局','',''],['救援','',''],['救援工作','',''],['救援队','',''],['救救','',''],['救星','',''],['救死扶伤','',''],['救母','',''],['救民','',''],['救民水火','',''],['救治','',''],['救法','',''],['救活','',''],['救济','',''],['救济粮','',''],['救济者','',''],['救济费','',''],['救济金','',''],['救济院','',''],['救火','',''],['救火扬沸','',''],['救火船','',''],['救灾','',''],['救灾恤患','',''],['救灾救济司','',''],['救灾款','',''],['救灾物资','',''],['救焚拯溺','',''],['救焚益薪','',''],['救球','',''],['救生','',''],['救生伞','',''],['救生员','',''],['救生圈','',''],['救生筏','',''],['救生索','',''],['救生船','',''],['救生艇','',''],['救生艇甲板','',''],['救生衣','',''],['救生袋','',''],['救生队','',''],['救经引足','',''],['救者','',''],['救苦救难','',''],['救荒','',''],['救赎','',''],['救赎主','',''],['救起','',''],['救过不赡','',''],['救过补阙','',''],['救险','',''],['救难','',''],['救难者','',''],['救难船','',''],['救驾','',''],['敕令','',''],['敕勒','',''],['敕勒人','',''],['敕勒歌','',''],['敕勒族','',''],['敕勒族人','',''],['敕封','',''],['敕许','',''],['敖不可长','',''],['敖包','',''],['敖广','',''],['敖德萨','',''],['敖汉','',''],['敖游','',''],['敖贝得','',''],['敖闰','',''],['敖顺','',''],['教一识百','',''],['教主','',''],['教义','',''],['教义和圣约','',''],['教义学','',''],['教习','',''],['教书','',''],['教书匠','',''],['教书育人','',''],['教了','',''],['教人','',''],['教他','',''],['教代会','',''],['教令','',''],['教仪','',''],['教会','',''],['教会学校','',''],['教具','',''],['教养','',''],['教养员','',''],['教养院','',''],['教制','',''],['教务','',''],['教务处','',''],['教务室','',''],['教务科','',''],['教务长','',''],['教化','',''],['教区','',''],['教友','',''],['教友大会','',''],['教史','',''],['教名','',''],['教员','',''],['教唆','',''],['教唆犯','',''],['教团','',''],['教坊','',''],['教坏','',''],['教堂','',''],['教堂墓地','',''],['教士','',''],['教外','',''],['教头','',''],['教女','',''],['教委','',''],['教子','',''],['教子有方','',''],['教学','',''],['教学大纲','',''],['教学机构','',''],['教学楼','',''],['教学法','',''],['教学相长','',''],['教安','',''],['教宗','',''],['教官','',''],['教室','',''],['教寺','',''],['教导','',''],['教导员','',''],['教导处','',''],['教导队','',''],['教工','',''],['教师','',''],['教师爷','',''],['教师队伍','',''],['教席','',''],['教廷','',''],['教廷大使','',''],['教律','',''],['教徒','',''],['教成','',''],['教授','',''],['教授法','',''],['教改','',''],['教教','',''],['教无常师','',''],['教本','',''],['教权','',''],['教材','',''],['教条','',''],['教条主义','',''],['教案','',''],['教桌','',''],['教正','',''],['教母','',''],['教民','',''],['教法','',''],['教派','',''],['教父','',''],['教狂','',''],['教猱升木','',''],['教理','',''],['教界','',''],['教皇','',''],['教皇权','',''],['教益','',''],['教研','',''],['教研室','',''],['教研组','',''],['教祖','',''],['教科书','',''],['教科文','',''],['教科文卫','',''],['教科文教','',''],['教科文组织','',''],['教程','',''],['教籍','',''],['教练','',''],['教练员','',''],['教练机','',''],['教者','',''],['教职','',''],['教职员','',''],['教职员工','',''],['教职工','',''],['教育','',''],['教育制度','',''],['教育厅','',''],['教育委员会','',''],['教育学','',''],['教育家','',''],['教育局','',''],['教育工作者','',''],['教育性','',''],['教育方针','',''],['教育法','',''],['教育电视','',''],['教育界','',''],['教育相谈','',''],['教育背景','',''],['教育部长','',''],['教范','',''],['教规','',''],['教训','',''],['教训性','',''],['教训者','',''],['教诲','',''],['教诲者','',''],['教课','',''],['教过','',''],['教错','',''],['教长','',''],['教门','',''],['教阶','',''],['教鞭','',''],['教龄','',''],['敛容','',''],['敛性','',''],['敛步','',''],['敛衣','',''],['敛衽','',''],['敛财','',''],['敛足','',''],['敛迹','',''],['敛钱','',''],['敝人','',''],['敝体','',''],['敝县','',''],['敝团','',''],['敝国','',''],['敝局','',''],['敝屣','',''],['敝屣尊荣','',''],['敝帚千金','',''],['敝帚自珍','',''],['敝店','',''],['敝所','',''],['敝村','',''],['敝校','',''],['敝社','',''],['敝舍','',''],['敝部','',''],['敝队','',''],['敞亮','',''],['敞口','',''],['敞口儿','',''],['敞开','',''],['敞开供应','',''],['敞开儿','',''],['敞开思想','',''],['敞篷','',''],['敞篷汽车','',''],['敞篷车','',''],['敞胸','',''],['敞著','',''],['敞蓬','',''],['敞车','',''],['敞露','',''],['敢不从命','',''],['敢不敢','',''],['敢为','',''],['敢为人先','',''],['敢于','',''],['敢于创新','',''],['敢作','',''],['敢作敢为','',''],['敢作敢当','',''],['敢保','',''],['敢做','',''],['敢做敢为','',''],['敢做敢当','',''],['敢勇当先','',''],['敢干','',''],['敢开','',''],['敢当','',''],['敢怒','',''],['敢怒不敢言','',''],['敢怒而不敢言','',''],['敢情','',''],['敢想','',''],['敢想敢干','',''],['敢打','',''],['敢打敢拼','',''],['敢抓','',''],['敢是','',''],['敢死','',''],['敢死队','',''],['敢看','',''],['敢管','',''],['敢自','',''],['敢言','',''],['敢讲','',''],['敢说','',''],['敢达','',''],['敢问','',''],['散乱','',''],['散了','',''],['散亡','',''],['散件','',''],['散伙','',''],['散伙饭','',''],['散会','',''],['散体','',''],['散光','',''],['散光眼镜','',''],['散兵','',''],['散兵坑','',''],['散兵游勇','',''],['散兵线','',''],['散养','',''],['散出','',''],['散列','',''],['散剂','',''],['散匪','',''],['散去','',''],['散发','',''],['散场','',''],['散失','',''],['散失殆尽','',''],['散套','',''],['散学','',''],['散客','',''],['散射','',''],['散尽','',''],['散居','',''],['散工','',''],['散布','',''],['散布性','',''],['散带衡门','',''],['散席','',''],['散座','',''],['散座儿','',''],['散开','',''],['散弹','',''],['散弹枪','',''],['散心','',''],['散心解闷','',''],['散戏','',''],['散户','',''],['散打','',''],['散摊','',''],['散摊子','',''],['散播','',''],['散散步','',''],['散文','',''],['散文体','',''],['散文家','',''],['散文式','',''],['散文诗','',''],['散曲','',''],['散束','',''],['散板','',''],['散架','',''],['散步','',''],['散步场','',''],['散步道','',''],['散毒','',''],['散水','',''],['散沙','',''],['散漫','',''],['散点图','',''],['散热','',''],['散热器','',''],['散热片','',''],['散碎','',''],['散管','',''],['散粉','',''],['散粒','',''],['散职','',''],['散股','',''],['散腿裤','',''],['散落','',''],['散裂','',''],['散装','',''],['散见','',''],['散记','',''],['散话','',''],['散诞','',''],['散货','',''],['散转','',''],['散逸','',''],['散酒','',''],['散钱','',''],['散闷','',''],['散闷消愁','',''],['敦世厉俗','',''],['敦促','',''],['敦促者','',''],['敦刻','',''],['敦刻尔克大撤退','',''],['敦劝','',''],['敦厚','',''],['敦实','',''],['敦巴顿橡树林会议','',''],['敦朴','',''],['敦煌石窟','',''],['敦睦','',''],['敦请','',''],['敦豪快递','',''],['敦豪快递公司','',''],['敦风厉俗','',''],['敦首','',''],['敬上','',''],['敬上接下','',''],['敬上爱下','',''],['敬业','',''],['敬业乐群','',''],['敬事不暇','',''],['敬仰','',''],['敬佩','',''],['敬候','',''],['敬受人时','',''],['敬受桑梓','',''],['敬受民时','',''],['敬启','',''],['敬启者','',''],['敬呈','',''],['敬告','',''],['敬备','',''],['敬天爱民','',''],['敬奉','',''],['敬姜犹绩','',''],['敬小慎微','',''],['敬悉','',''],['敬意','',''],['敬慕','',''],['敬慕者','',''],['敬拜','',''],['敬挽','',''],['敬时爱日','',''],['敬服','',''],['敬烟','',''],['敬爱','',''],['敬献','',''],['敬畏','',''],['敬礼','',''],['敬祝','',''],['敬神','',''],['敬称','',''],['敬老','',''],['敬老尊贤','',''],['敬老席','',''],['敬老恤贫','',''],['敬老慈少','',''],['敬老慈幼','',''],['敬老慈稚','',''],['敬老爱幼','',''],['敬老院','',''],['敬而远之','',''],['敬若神明','',''],['敬茶','',''],['敬虔','',''],['敬词','',''],['敬语','',''],['敬请','',''],['敬请光临','',''],['敬请批评指正','',''],['敬谢','',''],['敬谢不敏','',''],['敬贤爱士','',''],['敬贤礼士','',''],['敬贤重士','',''],['敬贺','',''],['敬赠','',''],['敬辞','',''],['敬送','',''],['敬酒','',''],['敬酒不吃吃罚酒','',''],['敬重','',''],['敬香','',''],['敬鬼神而远之','',''],['数一数二','',''],['数万','',''],['数不上','',''],['数不多','',''],['数不尽','',''],['数不清','',''],['数不着','',''],['数不胜数','',''],['数不过来','',''],['数个','',''],['数九','',''],['数九天','',''],['数九寒天','',''],['数人','',''],['数亿','',''],['数以万计','',''],['数以亿计','',''],['数以千计','',''],['数以百计','',''],['数伏','',''],['数位','',''],['数位信号','',''],['数位化','',''],['数位网路','',''],['数例','',''],['数倍','',''],['数值','',''],['数值分析','',''],['数值解','',''],['数典忘祖','',''],['数出','',''],['数列','',''],['数十','',''],['数十亿','',''],['数十年','',''],['数千','',''],['数发','',''],['数叨','',''],['数周','',''],['数国','',''],['数域','',''],['数多','',''],['数天','',''],['数奇命蹇','',''],['数字','',''],['数字上','',''],['数字信号','',''],['数字分频','',''],['数字化','',''],['数字命理学','',''],['数字导览设施','',''],['数字式','',''],['数字控制','',''],['数字时钟','',''],['数字模型','',''],['数字版权管理','',''],['数字电子计算机','',''],['数字电视','',''],['数字电话','',''],['数字电路','',''],['数字网','',''],['数字订购线路','',''],['数字通信','',''],['数字钟','',''],['数学','',''],['数学上','',''],['数学公式','',''],['数学分析','',''],['数学家','',''],['数学方法','',''],['数学模型','',''],['数学物理','',''],['数学物理学','',''],['数小时','',''],['数尺','',''],['数年','',''],['数度','',''],['数式','',''],['数往知来','',''],['数得着','',''],['数念','',''],['数打','',''],['数据','',''],['数据介面','',''],['数据传输','',''],['数据区','',''],['数据压缩','',''],['数据处理','',''],['数据库','',''],['数据库软件','',''],['数据总线','',''],['数据挖掘','',''],['数据接口','',''],['数据机','',''],['数据段','',''],['数据流','',''],['数据管理','',''],['数据网','',''],['数据网络','',''],['数据表','',''],['数据通信','',''],['数据通讯','',''],['数据链路','',''],['数据链路层','',''],['数据链路连接识别码','',''],['数据项','',''],['数控','',''],['数控技术','',''],['数控机床','',''],['数数','',''],['数断论长','',''],['数日','',''],['数易其稿','',''],['数月','',''],['数来宝','',''],['数模','',''],['数次','',''],['数法','',''],['数清','',''],['数点','',''],['数独','',''],['数珠','',''],['数珠念佛','',''],['数理','',''],['数理分析','',''],['数理化','',''],['数理哲学','',''],['数理经济','',''],['数理经济学','',''],['数理统计','',''],['数理逻辑','',''],['数用','',''],['数白论黄','',''],['数百','',''],['数百万','',''],['数目','',''],['数目字','',''],['数码','',''],['数码化','',''],['数码扫描','',''],['数码港','',''],['数码照相机','',''],['数码相机','',''],['数码通','',''],['数种','',''],['数米而炊','',''],['数组','',''],['数落','',''],['数见不鲜','',''],['数言','',''],['数论','',''],['数词','',''],['数说','',''],['数轴','',''],['数过','',''],['数逻','',''],['数量','',''],['数量分析','',''],['数量指标','',''],['数量积','',''],['数量级','',''],['数量经济学','',''],['数量词','',''],['数钱','',''],['数错','',''],['数集','',''],['数页','',''],['数额','',''],['数黄道白','',''],['数黄道黑','',''],['数黑论白','',''],['数黑论黄','',''],['敲下','',''],['敲丧钟','',''],['敲中背','',''],['敲入','',''],['敲出','',''],['敲击','',''],['敲击者','',''],['敲响','',''],['敲声','',''],['敲大背','',''],['敲定','',''],['敲小背','',''],['敲山震虎','',''],['敲平','',''],['敲开','',''],['敲弯','',''],['敲打','',''],['敲打锣鼓','',''],['敲掉','',''],['敲敲打打','',''],['敲榨','',''],['敲牛宰马','',''],['敲破','',''],['敲碎','',''],['敲竹杠','',''],['敲背','',''],['敲诈','',''],['敲诈勒索','',''],['敲诈勒索罪','',''],['敲诈罪','',''],['敲诈者','',''],['敲边','',''],['敲边鼓','',''],['敲进','',''],['敲金击玉','',''],['敲金击石','',''],['敲金戛玉','',''],['敲钉','',''],['敲钉子','',''],['敲钉钻脚','',''],['敲钟','',''],['敲锣','',''],['敲锣打鼓','',''],['敲门','',''],['敲门砖','',''],['敲门者','',''],['敲骨剥髓','',''],['敲骨吸髓','',''],['敲鼓声','',''],['整个','',''],['整个地球','',''],['整座','',''],['整人','',''],['整付','',''],['整件','',''],['整份','',''],['整体','',''],['整体优势','',''],['整体吊装','',''],['整体效益','',''],['整体数位服务网路','',''],['整体服务数位网路','',''],['整体观念','',''],['整体防护','',''],['整修','',''],['整修者','',''],['整倍数','',''],['整儿','',''],['整党','',''],['整党工作','',''],['整军','',''],['整军经武','',''],['整出','',''],['整列','',''],['整取','',''],['整句','',''],['整合','',''],['整团','',''],['整地','',''],['整块','',''],['整型','',''],['整垮','',''],['整声','',''],['整备','',''],['整夜','',''],['整夜间','',''],['整天','',''],['整套','',''],['整妆','',''],['整字','',''],['整存','',''],['整容','',''],['整幅','',''],['整年','',''],['整年累月','',''],['整并','',''],['整式','',''],['整形','',''],['整形外科','',''],['整形外科医生','',''],['整形术','',''],['整批','',''],['整把','',''],['整捆','',''],['整摞','',''],['整改','',''],['整数','',''],['整数倍数','',''],['整数集合','',''],['整整','',''],['整整一年','',''],['整整齐齐','',''],['整料','',''],['整日','',''],['整旧如新','',''],['整月','',''],['整机','',''],['整条','',''],['整枝','',''],['整桶','',''],['整步','',''],['整段','',''],['整治','',''],['整洁','',''],['整流','',''],['整流器','',''],['整流子','',''],['整流管','',''],['整片','',''],['整环','',''],['整理','',''],['整盘','',''],['整箱','',''],['整篇','',''],['整编','',''],['整肃','',''],['整色性','',''],['整行','',''],['整衣','',''],['整衣敛容','',''],['整补','',''],['整装','',''],['整装待发','',''],['整襟威坐','',''],['整训','',''],['整躬率物','',''],['整车','',''],['整部','',''],['整队','',''],['整除','',''],['整除数','',''],['整页','',''],['整顿','',''],['整顿秩序','',''],['整顿经济秩序','',''],['整顿者','',''],['整风','',''],['整风运动','',''],['整饬','',''],['整齐','',''],['整齐划一','',''],['整齐有序','',''],['敷上','',''],['敷以','',''],['敷层','',''],['敷布','',''],['敷张扬厉','',''],['敷敷','',''],['敷料','',''],['敷演','',''],['敷用','',''],['敷粉','',''],['敷药','',''],['敷衍','',''],['敷衍了事','',''],['敷衍塞责','',''],['敷衍搪塞','',''],['敷裹','',''],['敷设','',''],['敷贴','',''],['敷陈','',''],['文不加点','',''],['文不对题','',''],['文不尽意','',''],['文丑','',''],['文东武西','',''],['文中','',''],['文义','',''],['文书','',''],['文书处理','',''],['文书工作','',''],['文人','',''],['文人墨客','',''],['文人画','',''],['文人相轻','',''],['文从字顺','',''],['文以载道','',''],['文件','',''],['文件名','',''],['文件大小','',''],['文件夹','',''],['文件尾','',''],['文件服务器','',''],['文件格式','',''],['文件汇编','',''],['文件精神','',''],['文体','',''],['文体活动','',''],['文体论','',''],['文侩','',''],['文修武偃','',''],['文修武备','',''],['文具','',''],['文具商','',''],['文具店','',''],['文具盒','',''],['文内','',''],['文冠果','',''],['文凭','',''],['文化','',''],['文化上','',''],['文化书社','',''],['文化买办','',''],['文化事业','',''],['文化交流','',''],['文化人','',''],['文化传统','',''],['文化冲击','',''],['文化冲突','',''],['文化史','',''],['文化合作','',''],['文化圈','',''],['文化城','',''],['文化大革命','',''],['文化娱乐','',''],['文化娱乐活动','',''],['文化宫','',''],['文化局','',''],['文化层','',''],['文化工作','',''],['文化市场','',''],['文化建设','',''],['文化教育','',''],['文化整合','',''],['文化水平','',''],['文化活动','',''],['文化热','',''],['文化理论','',''],['文化生活','',''],['文化界','',''],['文化的交流','',''],['文化知识','',''],['文化科学','',''],['文化程度','',''],['文化站','',''],['文化素质','',''],['文化网址','',''],['文化艺术','',''],['文化节','',''],['文化遗产','',''],['文化障碍','',''],['文化馆','',''],['文案','',''],['文印','',''],['文卷','',''],['文句','',''],['文史','',''],['文史资料','',''],['文史馆','',''],['文号','',''],['文君司马','',''],['文君新寡','',''],['文君早寡','',''],['文告','',''],['文员','',''],['文品','',''],['文圣','',''],['文地','',''],['文场','',''],['文坛','',''],['文墨','',''],['文天祥','',''],['文契','',''],['文如其人','',''],['文娱','',''],['文娱活动','',''],['文字','',''],['文字上','',''],['文字前','',''],['文字处理','',''],['文字学','',''],['文字学家','',''],['文字改革','',''],['文字档','',''],['文字狱','',''],['文字说明','',''],['文学','',''],['文学作品','',''],['文学创作','',''],['文学博士','',''],['文学史','',''],['文学士','',''],['文学家','',''],['文学巨匠','',''],['文学思想','',''],['文学思潮','',''],['文学理论','',''],['文学界','',''],['文学知识','',''],['文学研究','',''],['文学研究会','',''],['文学社','',''],['文学艺术','',''],['文学评论','',''],['文学遗产','',''],['文学革命','',''],['文宗','',''],['文官','',''],['文宣部','',''],['文山会海','',''],['文山区','',''],['文山州','',''],['文峰','',''],['文峰镇','',''],['文工团','',''],['文库','',''],['文庙','',''],['文康','',''],['文式','',''],['文弱','',''],['文征明','',''],['文德武功','',''],['文心雕龙','',''],['文思','',''],['文性','',''],['文恬武嬉','',''],['文戏','',''],['文房','',''],['文房四士','',''],['文房四宝','',''],['文才','',''],['文抄公','',''],['文摘','',''],['文擅雕龙','',''],['文改','',''],['文教','',''],['文教卫生','',''],['文教卫生基金','',''],['文教局','',''],['文斗','',''],['文无加点','',''],['文旦','',''],['文昌鱼','',''],['文明','',''],['文明人','',''],['文明化','',''],['文明单位','',''],['文明史','',''],['文明小史','',''],['文明戏','',''],['文明礼貌','',''],['文明社会','',''],['文景之治','',''],['文本','',''],['文本编辑器','',''],['文档','',''],['文档对象模型','',''],['文档资料','',''],['文武','',''],['文武之道','',''],['文武全才','',''],['文武兼备','',''],['文武兼济','',''],['文武双全','',''],['文武合一','',''],['文武百官','',''],['文殊','',''],['文殊师利菩萨','',''],['文殊菩萨','',''],['文气','',''],['文汇','',''],['文汇报','',''],['文江学海','',''],['文治','',''],['文治武功','',''],['文法','',''],['文法上','',''],['文法家','',''],['文法素','',''],['文海','',''],['文深网密','',''],['文火','',''],['文炳雕龙','',''],['文牍','',''],['文牍主义','',''],['文牒','',''],['文物','',''],['文物古迹','',''],['文物局','',''],['文献','',''],['文献分类','',''],['文献学','',''],['文献工作','',''],['文献标引','',''],['文献检索','',''],['文献汇编','',''],['文献研究室','',''],['文献资料','',''],['文玩','',''],['文理','',''],['文理不通','',''],['文电','',''],['文痞','',''],['文盲','',''],['文石','',''],['文种','',''],['文科','',''],['文科学士','',''],['文秘','',''],['文稿','',''],['文章','',''],['文章巨公','',''],['文章憎命','',''],['文章星斗','',''],['文章盖世','',''],['文章魁首','',''],['文童','',''],['文竹','',''],['文笔','',''],['文绉绉','',''],['文经武略','',''],['文经武纬','',''],['文翰','',''],['文职','',''],['文职人员','',''],['文联','',''],['文脉','',''],['文脉上','',''],['文臣','',''],['文艺','',''],['文艺作品','',''],['文艺复兴','',''],['文艺学','',''],['文艺家','',''],['文艺思想','',''],['文艺批评','',''],['文艺演出','',''],['文艺界','',''],['文艺节目','',''],['文艺语言','',''],['文苑','',''],['文苑英华','',''],['文茵','',''],['文莱达鲁萨兰国','',''],['文藻','',''],['文蛤','',''],['文行','',''],['文言','',''],['文言文','',''],['文诌诌','',''],['文词','',''],['文豪','',''],['文责','',''],['文责自负','',''],['文质','',''],['文质彬彬','',''],['文贵天成','',''],['文身','',''],['文身断发','',''],['文辞','',''],['文过遂非','',''],['文过饰非','',''],['文选','',''],['文部','',''],['文部乡','',''],['文部省','',''],['文采','',''],['文采风流','',''],['文野','',''],['文钱','',''],['文锦渡','',''],['文雅','',''],['文集','',''],['文静','',''],['文面','',''],['文革','',''],['文韬武略','',''],['文韬武韬','',''],['文风','',''],['文风不动','',''],['文饰','',''],['文馆','',''],['文鸟','',''],['文齐福不齐','',''],['斋堂','',''],['斋居蔬食','',''],['斋心涤虑','',''],['斋戒','',''],['斋教','',''],['斋月','',''],['斋期','',''],['斋果','',''],['斋祭','',''],['斋藤','',''],['斋饭','',''],['斐斐','',''],['斐济人','',''],['斐济岛','',''],['斐然','',''],['斐然向风','',''],['斐然成章','',''],['斐理伯','',''],['斐理伯书','',''],['斐迪南','',''],['斑头雁','',''],['斑岩','',''],['斑斑','',''],['斑斓','',''],['斑木','',''],['斑杂','',''],['斑海豹','',''],['斑点','',''],['斑状','',''],['斑疹','',''],['斑疹伤寒','',''],['斑疹热','',''],['斑痕','',''],['斑白','',''],['斑秃','',''],['斑竹','',''],['斑纹','',''],['斑羚','',''],['斑翅山鹑','',''],['斑色','',''],['斑蚊','',''],['斑蝥','',''],['斑谰','',''],['斑马','',''],['斑马线','',''],['斑马鱼','',''],['斑驳','',''],['斑驳陆离','',''],['斑鳖','',''],['斑鳢','',''],['斑鸠','',''],['斗争','',''],['斗争史','',''],['斗争性','',''],['斗争者','',''],['斗人','',''],['斗倒','',''],['斗剑者','',''],['斗升之水','',''],['斗升之禄','',''],['斗南','',''],['斗南一人','',''],['斗南镇','',''],['斗口齿','',''],['斗嘴','',''],['斗地主','',''],['斗垮','',''],['斗士','',''],['斗大','',''],['斗子','',''],['斗室','',''],['斗志','',''],['斗志昂扬','',''],['斗批改','',''],['斗拱','',''],['斗拳','',''],['斗斛之禄','',''],['斗方','',''],['斗方名士','',''],['斗智','',''],['斗柄','',''],['斗橱','',''],['斗殴','',''],['斗气','',''],['斗法','',''],['斗渠','',''],['斗牌','',''],['斗牛','',''],['斗牛㹴','',''],['斗牛士','',''],['斗牛士之歌','',''],['斗牛梗','',''],['斗眼','',''],['斗笠','',''],['斗筲','',''],['斗筲之人','',''],['斗筲之器','',''],['斗筲之徒','',''],['斗筲之才','',''],['斗筲之材','',''],['斗筲之辈','',''],['斗筲小人','',''],['斗筲小器','',''],['斗筲穿窬','',''],['斗箕','',''],['斗篷','',''],['斗绝一隅','',''],['斗胆','',''],['斗舰','',''],['斗蓬','',''],['斗趣儿','',''],['斗车','',''],['斗转参横','',''],['斗转星移','',''],['斗输','',''],['斗酒只鸡','',''],['斗酒学士','',''],['斗酒百篇','',''],['斗重山齐','',''],['斗量车载','',''],['斗门','',''],['斗鸡','',''],['斗鸡眼','',''],['斗鸡走狗','',''],['斗鸡走马','',''],['料不到','',''],['料中','',''],['料事','',''],['料事如神','',''],['料仓','',''],['料净','',''],['料到','',''],['料医少卜','',''],['料单','',''],['料及','',''],['料器','',''],['料场','',''],['料堆','',''],['料头','',''],['料头儿','',''],['料子','',''],['料定','',''],['料峭','',''],['料度','',''],['料想','',''],['料想到','',''],['料持','',''],['料敌制胜','',''],['料敌若神','',''],['料斗','',''],['料架','',''],['料款','',''],['料民','',''],['料理','',''],['料理店','',''],['料算','',''],['料管','',''],['料耗','',''],['料豆儿','',''],['料费','',''],['料车','',''],['料远若近','',''],['料酒','',''],['斜上','',''],['斜井','',''],['斜交','',''],['斜体','',''],['斜体字','',''],['斜倚','',''],['斜压','',''],['斜向','',''],['斜吹','',''],['斜坡','',''],['斜堤','',''],['斜塔','',''],['斜对','',''],['斜射','',''],['斜射球','',''],['斜层','',''],['斜度','',''],['斜径','',''],['斜愣眼','',''],['斜愣眼儿','',''],['斜投影','',''],['斜斜','',''],['斜方型','',''],['斜方形','',''],['斜方肌','',''],['斜晖','',''],['斜杠','',''],['斜桅','',''],['斜桥','',''],['斜楞','',''],['斜照','',''],['斜率','',''],['斜眼','',''],['斜眼看','',''],['斜着','',''],['斜睨','',''],['斜管面','',''],['斜纹','',''],['斜纹布','',''],['斜纹织','',''],['斜纹软呢','',''],['斜线','',''],['斜线号','',''],['斜肌','',''],['斜视','',''],['斜视眼','',''],['斜角','',''],['斜象眼儿','',''],['斜路','',''],['斜身','',''],['斜躺','',''],['斜轴','',''],['斜辉','',''],['斜边','',''],['斜过','',''],['斜道','',''],['斜钩','',''],['斜长石','',''],['斜阳','',''],['斜靠','',''],['斜面','',''],['斜面路','',''],['斜颈','',''],['斜风细雨','',''],['斜高','',''],['斟上','',''],['斟满','',''],['斟茶','',''],['斟酌','',''],['斟酌决定权','',''],['斟酌字句','',''],['斟酒','',''],['斡旋','',''],['斤两','',''],['斤数','',''],['斤斗','',''],['斤斤','',''],['斤斤计较','',''],['斤斤较量','',''],['斤顶','',''],['斥之','',''],['斥候','',''],['斥力','',''],['斥卖','',''],['斥卤','',''],['斥喝','',''],['斥责','',''],['斥责者','',''],['斥资','',''],['斥退','',''],['斥逐','',''],['斥革','',''],['斥骂','',''],['斧凿痕','',''],['斧削','',''],['斧头','',''],['斧子','',''],['斧斩','',''],['斧正','',''],['斧足类','',''],['斧钺之诛','',''],['斧钺汤镬','',''],['斩假石','',''],['斩决','',''],['斩妖','',''],['斩将夺旗','',''],['斩将搴旗','',''],['斩尽杀绝','',''],['斩断','',''],['斩杀','',''],['斩眼','',''],['斩碎','',''],['斩而不奏','',''],['斩草除根','',''],['斩获','',''],['斩蛇逐鹿','',''],['斩钉截铁','',''],['斩钢截铁','',''],['斩首','',''],['斫丧','',''],['斫方为圆','',''],['斫畲','',''],['斫白','',''],['斫营','',''],['斫轮老手','',''],['斫雕为朴','',''],['断七','',''],['断乎','',''],['断乳','',''],['断了','',''],['断了奶','',''],['断井颓垣','',''],['断交','',''],['断从','',''],['断代','',''],['断代史','',''],['断决如流','',''],['断剑','',''],['断力','',''],['断发文身','',''],['断口','',''],['断句','',''],['断后','',''],['断垄','',''],['断垣残壁','',''],['断埯','',''],['断壁残垣','',''],['断壁颓垣','',''],['断头','',''],['断头台','',''],['断头将军','',''],['断奶','',''],['断子绝孙','',''],['断定','',''],['断尾雄鸡','',''],['断层','',''],['断层地震','',''],['断层山','',''],['断层带','',''],['断层湖','',''],['断层线','',''],['断屠','',''],['断崖','',''],['断幅残纸','',''],['断开','',''],['断弦','',''],['断念','',''],['断怪除妖','',''],['断想','',''],['断掉','',''],['断断','',''],['断断续续','',''],['断枝','',''],['断根','',''],['断根绝种','',''],['断案','',''],['断档','',''],['断桥','',''],['断梗流萍','',''],['断梗飞蓬','',''],['断气','',''],['断水','',''],['断法','',''],['断流','',''],['断港绝潢','',''],['断灭','',''],['断灭论','',''],['断炊','',''],['断点','',''],['断烂朝报','',''],['断烟','',''],['断然','',''],['断然拒绝','',''],['断片','',''],['断牙','',''],['断狱','',''],['断瓦残垣','',''],['断电','',''],['断离','',''],['断种','',''],['断章取义','',''],['断章截句','',''],['断章摘句','',''],['断简残编','',''],['断粮','',''],['断纸馀墨','',''],['断线','',''],['断线风筝','',''],['断线鹞子','',''],['断绝','',''],['断绝关系','',''],['断续','',''],['断续性','',''],['断编残简','',''],['断肠','',''],['断肢','',''],['断背','',''],['断背山','',''],['断腿','',''],['断行','',''],['断袖','',''],['断袖之宠','',''],['断袖之癖','',''],['断袖分桃','',''],['断裂','',''],['断裂力学','',''],['断裂带','',''],['断裂强度','',''],['断裂模数','',''],['断言','',''],['断言者','',''],['断语','',''],['断路','',''],['断路器','',''],['断送','',''],['断钗重合','',''],['断长续短','',''],['断长补短','',''],['断雁孤鸿','',''],['断面','',''],['断面图','',''],['断音','',''],['断食','',''],['断骨','',''],['断魂','',''],['断魂椒','',''],['断鹤续凫','',''],['断齑画粥','',''],['斯事体大','',''],['斯人','',''],['斯佩林','',''],['斯佩罗','',''],['斯克里亚宾','',''],['斯卡伯勒礁','',''],['斯哥','',''],['斯哥特','',''],['斯图','',''],['斯图加特','',''],['斯坦佛','',''],['斯坦佛大学','',''],['斯坦利','',''],['斯坦因','',''],['斯坦福','',''],['斯坦福・莱佛士','',''],['斯坦福大学','',''],['斯坦贝克','',''],['斯堪的纳维亚','',''],['斯堪的纳维亚半岛','',''],['斯塔西','',''],['斯大林','',''],['斯大林主义','',''],['斯大林格勒','',''],['斯大林格勒会战','',''],['斯大林格勒战役','',''],['斯奈','',''],['斯宾塞','',''],['斯宾诺莎','',''],['斯密','',''],['斯密约瑟','',''],['斯巴达','',''],['斯巴达克起义','',''],['斯巴鲁','',''],['斯市','',''],['斯帕斯基','',''],['斯当东','',''],['斯彻达尔','',''],['斯德哥尔摩','',''],['斯托肯立石圈','',''],['斯拉夫','',''],['斯拉夫人','',''],['斯拉夫语','',''],['斯拉维尼亚','',''],['斯捷潘','',''],['斯摩棱斯克','',''],['斯文','',''],['斯文・海定','',''],['斯文・赫定','',''],['斯文委地','',''],['斯文扫地','',''],['斯斯文文','',''],['斯时','',''],['斯普利特','',''],['斯普拉特利群岛','',''],['斯普林菲尔德','',''],['斯柯达','',''],['斯沃琪','',''],['斯泰恩谢尔','',''],['斯泰西','',''],['斯洛伐克语','',''],['斯洛发克','',''],['斯洛文尼亚共和国','',''],['斯洛文尼亚语','',''],['斯洛维尼亚','',''],['斯特凡诺普洛斯','',''],['斯特恩','',''],['斯特拉斯堡','',''],['斯特拉特福','',''],['斯瓦希里','',''],['斯瓦希里语','',''],['斯瓦特','',''],['斯瓦特谷地','',''],['斯皮尔伯格','',''],['斯福尔瓦尔','',''],['斯科普里','',''],['斯维尔德洛夫','',''],['斯考特','',''],['斯芬克司','',''],['斯芬克斯','',''],['斯莱特林','',''],['斯蒂文','',''],['斯蒂文森','',''],['斯蒂芬','',''],['斯蒂芬・哈珀','',''],['斯语','',''],['斯诺','',''],['斯诺克','',''],['斯通亨治石栏','',''],['斯里巴加湾港','',''],['斯雷布雷尼察','',''],['斯须','',''],['新一代','',''],['新不伦瑞克','',''],['新不列颠岛','',''],['新世','',''],['新世界','',''],['新世纪','',''],['新中国','',''],['新丰乡','',''],['新义','',''],['新义州市','',''],['新乡地区','',''],['新书','',''],['新买','',''],['新事','',''],['新事新办','',''],['新事物','',''],['新五代史','',''],['新交','',''],['新产品','',''],['新产品推介会','',''],['新产品试销','',''],['新京报','',''],['新亭对泣','',''],['新人','',''],['新人新事','',''],['新仇','',''],['新仇旧恨','',''],['新仇旧憾','',''],['新任','',''],['新任务','',''],['新会','',''],['新会县','',''],['新会市','',''],['新体制','',''],['新作','',''],['新信徒','',''],['新修','',''],['新修本草','',''],['新儒家','',''],['新元史','',''],['新党','',''],['新入','',''],['新兴产业','',''],['新兴经济国家','',''],['新兵','',''],['新军','',''],['新几内亚','',''],['新出炉','',''],['新出现','',''],['新出生','',''],['新刊','',''],['新创','',''],['新到','',''],['新制','',''],['新制度','',''],['新剧','',''],['新剧同志会','',''],['新办','',''],['新加坡人','',''],['新加坡国立大学','',''],['新动向','',''],['新包','',''],['新化市','',''],['新化镇','',''],['新区','',''],['新医','',''],['新华','',''],['新华书店','',''],['新华日报','',''],['新华社','',''],['新华社讯','',''],['新华网','',''],['新华通讯社','',''],['新南威尔士','',''],['新南威尔士州','',''],['新厂','',''],['新发展','',''],['新发明','',''],['新发现','',''],['新古典','',''],['新古典主义','',''],['新台币','',''],['新名','',''],['新名词','',''],['新命名','',''],['新品','',''],['新品种','',''],['新唐书','',''],['新四军','',''],['新园','',''],['新园乡','',''],['新土','',''],['新地','',''],['新址','',''],['新型','',''],['新垦','',''],['新城','',''],['新城乡','',''],['新城县','',''],['新城电台','',''],['新城病','',''],['新埔','',''],['新埔镇','',''],['新埤','',''],['新埤乡','',''],['新塘','',''],['新增','',''],['新墨西哥','',''],['新墨西哥州','',''],['新大陆','',''],['新天地','',''],['新奇','',''],['新奥尔晾','',''],['新奥尔良','',''],['新妆','',''],['新妇','',''],['新威胁','',''],['新娘','',''],['新婚','',''],['新婚夫妇','',''],['新婚宴尔','',''],['新婚燕尔','',''],['新媳妇儿','',''],['新学','',''],['新学小生','',''],['新学科','',''],['新学说','',''],['新安江','',''],['新官','',''],['新官上任三把火','',''],['新实在论','',''],['新宾县','',''],['新宿','',''],['新局面','',''],['新居','',''],['新屋','',''],['新屋乡','',''],['新山','',''],['新岁','',''],['新工艺','',''],['新巧','',''],['新市','',''],['新市乡','',''],['新市兵','',''],['新市镇','',''],['新干线','',''],['新平县','',''],['新年','',''],['新年前夕','',''],['新年快乐','',''],['新年进步','',''],['新庄','',''],['新庄市','',''],['新店','',''],['新店市','',''],['新店溪','',''],['新康德主义','',''],['新开','',''],['新开业','',''],['新开拓','',''],['新异','',''],['新式','',''],['新式拚法','',''],['新形势','',''],['新形势下','',''],['新形式','',''],['新德里','',''],['新思想','',''],['新愁','',''],['新愁旧恨','',''],['新意','',''],['新慕道团','',''],['新成员','',''],['新战士','',''],['新户','',''],['新房','',''],['新手','',''],['新托马斯主义','',''],['新技术','',''],['新技术开发区','',''],['新技术革命','',''],['新招','',''],['新拳','',''],['新收','',''],['新改','',''],['新政','',''],['新教','',''],['新教徒','',''],['新文化运动','',''],['新文学','',''],['新斯科舍','',''],['新新人类','',''],['新方法','',''],['新旧','',''],['新旧交替','',''],['新旧体制','',''],['新时代','',''],['新时期','',''],['新星','',''],['新春','',''],['新春伊始','',''],['新春佳节','',''],['新晃','',''],['新晃县','',''],['新曲','',''],['新月','',''],['新月形','',''],['新月派','',''],['新月状','',''],['新朋友','',''],['新朝','',''],['新材料','',''],['新村','',''],['新来','',''],['新来乍到','',''],['新来的','',''],['新来者','',''],['新林','',''],['新林区','',''],['新枝','',''],['新柏拉图主义','',''],['新欠','',''],['新欢','',''],['新款','',''],['新歌','',''],['新正','',''],['新武器','',''],['新殖民主义','',''],['新殖民化','',''],['新民主主义','',''],['新民主主义论','',''],['新民主主义革命','',''],['新民学会','',''],['新民晚报','',''],['新气象','',''],['新水平','',''],['新水手','',''],['新法','',''],['新泽西','',''],['新泽西州','',''],['新洲','',''],['新派','',''],['新流','',''],['新浦','',''],['新浪漫主义','',''],['新浪网','',''],['新海峡时报','',''],['新消息','',''],['新港','',''],['新港乡','',''],['新潟','',''],['新潟县','',''],['新潮','',''],['新热带','',''],['新热带界','',''],['新片','',''],['新版','',''],['新版本','',''],['新牙','',''],['新玩艺','',''],['新生','',''],['新生事物','',''],['新生代','',''],['新生儿','',''],['新生力量','',''],['新生活','',''],['新生界','',''],['新界','',''],['新畿内亚','',''],['新疆','',''],['新疆小盘鸡','',''],['新疆温宿县','',''],['新疆维吾尔族','',''],['新疆自治区','',''],['新的','',''],['新的不来','',''],['新知','',''],['新石器','',''],['新石器时代','',''],['新硎初试','',''],['新社','',''],['新社乡','',''],['新社会','',''],['新社区','',''],['新禧','',''],['新秀','',''],['新科技','',''],['新秩序','',''],['新税','',''],['新篇章','',''],['新米','',''],['新约','',''],['新约全书','',''],['新纪元','',''],['新纪录','',''],['新经','',''],['新经济政策','',''],['新绿','',''],['新编','',''],['新罕布什尔','',''],['新罕布什尔州','',''],['新罗','',''],['新罗王朝','',''],['新老','',''],['新老交替','',''],['新老用户','',''],['新能源','',''],['新自由主义','',''],['新芬党','',''],['新花样','',''],['新芽','',''],['新苗','',''],['新英格兰','',''],['新荣','',''],['新药','',''],['新著','',''],['新藏公路','',''],['新衣','',''],['新装','',''],['新装置','',''],['新西伯利亚','',''],['新西伯利亚市','',''],['新要求','',''],['新观念','',''],['新设','',''],['新设施','',''],['新词','',''],['新诗','',''],['新语','',''],['新语义','',''],['新货','',''],['新购','',''],['新贵','',''],['新贷','',''],['新路','',''],['新路子','',''],['新辞','',''],['新近','',''],['新进','',''],['新进者','',''],['新选','',''],['新途径','',''],['新造','',''],['新造镇','',''],['新道','',''],['新邱','',''],['新郎','',''],['新都','',''],['新都桥','',''],['新都桥镇','',''],['新金县','',''],['新针疗法','',''],['新铺','',''],['新锐','',''],['新长征','',''],['新问题','',''],['新闻','',''],['新闻业','',''],['新闻主播','',''],['新闻公报','',''],['新闻出版总署','',''],['新闻出版署','',''],['新闻发布会','',''],['新闻发言人','',''],['新闻史','',''],['新闻周刊','',''],['新闻处','',''],['新闻媒体','',''],['新闻学','',''],['新闻工作者','',''],['新闻片','',''],['新闻界','',''],['新闻社','',''],['新闻稿','',''],['新闻纪录影片','',''],['新闻纸','',''],['新闻组','',''],['新闻网','',''],['新闻自由','',''],['新闻记者','',''],['新阶段','',''],['新陈','',''],['新陈代谢','',''],['新院','',''],['新雅','',''],['新青','',''],['新领域','',''],['新颖','',''],['新颖性','',''],['新风','',''],['新风尚','',''],['新马','',''],['新马尔萨斯主义','',''],['新高峰','',''],['新高度','',''],['新鲜','',''],['新鲜事','',''],['新鲜人','',''],['新鲜感','',''],['新鲜空气','',''],['新黑格尔主义','',''],['方丈','',''],['方丈盈前','',''],['方且','',''],['方为','',''],['方为人上人','',''],['方些','',''],['方交','',''],['方今','',''],['方位','',''],['方位判定','',''],['方位物','',''],['方位角','',''],['方位词','',''],['方使','',''],['方便','',''],['方便之门','',''],['方便面','',''],['方兴未已','',''],['方兴未艾','',''],['方册','',''],['方凳','',''],['方出','',''],['方凿圆枘','',''],['方剂','',''],['方可','',''],['方向','',''],['方向性','',''],['方向感','',''],['方向盘','',''],['方向舵','',''],['方命','',''],['方圆','',''],['方地','',''],['方块','',''],['方块字','',''],['方块舞','',''],['方块草皮','',''],['方士','',''],['方外','',''],['方外之人','',''],['方外之士','',''],['方头','',''],['方头不劣','',''],['方头不律','',''],['方头括号','',''],['方头螺帽','',''],['方妮','',''],['方始','',''],['方子','',''],['方字','',''],['方家','',''],['方寸','',''],['方寸之地','',''],['方寸已乱','',''],['方对','',''],['方将','',''],['方尺','',''],['方差','',''],['方巾','',''],['方帽','',''],['方庄','',''],['方底圆盖','',''],['方式','',''],['方形','',''],['方志','',''],['方戏','',''],['方才','',''],['方技','',''],['方括号','',''],['方数','',''],['方文山','',''],['方斯蔑如','',''],['方方','',''],['方方正正','',''],['方方面面','',''],['方时','',''],['方术','',''],['方来','',''],['方枘圆凿','',''],['方根','',''],['方格','',''],['方格纸','',''],['方桃譬李','',''],['方框','',''],['方框图','',''],['方案','',''],['方桌','',''],['方正不苟','',''],['方正不阿','',''],['方步','',''],['方毅','',''],['方法','',''],['方法学','',''],['方法论','',''],['方滋未艾','',''],['方物','',''],['方略','',''],['方盘','',''],['方知','',''],['方石','',''],['方示','',''],['方程','',''],['方程序','',''],['方程式','',''],['方程组','',''],['方竹','',''],['方米','',''],['方糖','',''],['方给','',''],['方胜','',''],['方能','',''],['方脸突额','',''],['方腊','',''],['方腊起义','',''],['方腿','',''],['方自','',''],['方舟','',''],['方药','',''],['方解','',''],['方解石','',''],['方言','',''],['方言区','',''],['方言学','',''],['方许','',''],['方语','',''],['方语言','',''],['方说','',''],['方趾圆颅','',''],['方里','',''],['方釳','',''],['方针','',''],['方针政策','',''],['方钢','',''],['方铅矿','',''],['方阵','',''],['方靖','',''],['方面','',''],['方面军','',''],['方面大耳','',''],['方音','',''],['方顶','',''],['方领矩步','',''],['方驾齐驱','',''],['於下','',''],['於乎','',''],['於事','',''],['於人','',''],['於呼哀哉','',''],['於是','',''],['於菟','',''],['施不望报','',''],['施与','',''],['施丹傅粉','',''],['施为','',''],['施主','',''],['施乐','',''],['施予','',''],['施事','',''],['施事者','',''],['施仁布德','',''],['施仁布恩','',''],['施仁布泽','',''],['施以','',''],['施催','',''],['施加','',''],['施加压力','',''],['施加影响','',''],['施华洛世奇水晶','',''],['施压','',''],['施威','',''],['施展','',''],['施展才华','',''],['施展才能','',''],['施属','',''],['施工','',''],['施工单位','',''],['施工图','',''],['施工队','',''],['施巫术','',''],['施恩','',''],['施惠','',''],['施惠于','',''],['施拾者','',''],['施放','',''],['施政','',''],['施政报告','',''],['施救','',''],['施教','',''],['施斋','',''],['施明德','',''],['施暴','',''],['施朱傅粉','',''],['施法','',''],['施洗','',''],['施洗约翰','',''],['施洗者约翰','',''],['施特劳斯','',''],['施琅','',''],['施瓦布','',''],['施瓦辛格','',''],['施用','',''],['施用量','',''],['施礼','',''],['施粉','',''],['施粥舍饭','',''],['施给','',''],['施罗德','',''],['施耐庵','',''],['施肥','',''],['施肥耙','',''],['施舍','',''],['施舍物','',''],['施药','',''],['施蒂利尔','',''],['施蒂利尔州','',''],['施虐受虐','',''],['施行','',''],['施诊','',''],['施谋用智','',''],['施谋用计','',''],['施谋设计','',''],['施赈','',''],['施赠者','',''],['施食','',''],['旁人','',''],['旁侧','',''],['旁出','',''],['旁切','',''],['旁切圆','',''],['旁压','',''],['旁压力','',''],['旁及','',''],['旁听','',''],['旁听席','',''],['旁岔','',''],['旁征博引','',''],['旁搜博采','',''],['旁搜远绍','',''],['旁支','',''],['旁敲侧击','',''],['旁枝','',''],['旁氏','',''],['旁求俊彦','',''],['旁注','',''],['旁物','',''],['旁生','',''],['旁白','',''],['旁皇','',''],['旁系','',''],['旁系亲属','',''],['旁系血亲','',''],['旁线','',''],['旁腱肌','',''],['旁若无人','',''],['旁落','',''],['旁行斜上','',''],['旁街','',''],['旁见侧出','',''],['旁观','',''],['旁观者','',''],['旁观者清','',''],['旁观袖手','',''],['旁证','',''],['旁证博引','',''],['旁贫儿','',''],['旁路','',''],['旁轨','',''],['旁边','',''],['旁边儿','',''],['旁通','',''],['旁通道','',''],['旁道','',''],['旁遮普','',''],['旁遮普省','',''],['旁遮普邦','',''],['旁门','',''],['旁门外道','',''],['旁门左道','',''],['旁风','',''],['旁骛','',''],['旁鹜','',''],['旃檀','',''],['旄倪','',''],['旄期','',''],['旄车','',''],['旅人','',''],['旅伴','',''],['旅客','',''],['旅客之家','',''],['旅客列车','',''],['旅客机','',''],['旅居','',''],['旅居者','',''],['旅店','',''],['旅日','',''],['旅检','',''],['旅次','',''],['旅游','',''],['旅游业','',''],['旅游事业','',''],['旅游区','',''],['旅游团','',''],['旅游地','',''],['旅游城市','',''],['旅游客','',''],['旅游局','',''],['旅游指南','',''],['旅游景点','',''],['旅游服务','',''],['旅游活动','',''],['旅游点','',''],['旅游热点','',''],['旅游者','',''],['旅游胜地','',''],['旅游资源','',''],['旅游集散','',''],['旅游鞋','',''],['旅社','',''],['旅程','',''],['旅程表','',''],['旅舍','',''],['旅行','',''],['旅行包','',''],['旅行团','',''],['旅行图','',''],['旅行支票','',''],['旅行用','',''],['旅行社','',''],['旅行者','',''],['旅行袋','',''],['旅行装备','',''],['旅行车','',''],['旅费','',''],['旅进旅退','',''],['旅途','',''],['旅长','',''],['旅顺','',''],['旅顺口','',''],['旅顺港','',''],['旅馆','',''],['旅馆费','',''],['旋乾转坤','',''],['旋光','',''],['旋光性','',''],['旋前肌','',''],['旋升','',''],['旋即','',''],['旋回','',''],['旋塞','',''],['旋太紧','',''],['旋子','',''],['旋宫','',''],['旋工','',''],['旋床','',''],['旋度','',''],['旋开','',''],['旋弄','',''],['旋式','',''],['旋形','',''],['旋律','',''],['旋律化','',''],['旋律学','',''],['旋得','',''],['旋扭','',''],['旋木','',''],['旋木雀','',''],['旋松','',''],['旋梯','',''],['旋毛虫','',''],['旋流','',''],['旋涡','',''],['旋涡星云','',''],['旋涡星系','',''],['旋涡状','',''],['旋渊','',''],['旋盘','',''],['旋筒','',''],['旋紧','',''],['旋纽','',''],['旋绕','',''],['旋翼','',''],['旋翼机','',''],['旋耕机','',''],['旋臂','',''],['旋舞','',''],['旋花科','',''],['旋覆花','',''],['旋调管','',''],['旋踵','',''],['旋转','',''],['旋转体','',''],['旋转力','',''],['旋转台','',''],['旋转指标','',''],['旋转曲面','',''],['旋转木马','',''],['旋转极','',''],['旋转烤肉','',''],['旋转物','',''],['旋转球','',''],['旋转行李传送带','',''],['旋转角','',''],['旋转角速度','',''],['旋转轴','',''],['旋转运动','',''],['旋里','',''],['旋量','',''],['旋钮','',''],['旋闸','',''],['旋风','',''],['旋风脚','',''],['旋风装','',''],['旌善惩恶','',''],['旌旗','',''],['旌旗招展','',''],['旌旗蔽天','',''],['旌旗蔽日','',''],['旌旗蔽空','',''],['旌表','',''],['旌阳','',''],['族人','',''],['族仇','',''],['族兄','',''],['族名','',''],['族外','',''],['族姓','',''],['族居','',''],['族权','',''],['族灭','',''],['族类','',''],['族群','',''],['族诛','',''],['族谱','',''],['族长','',''],['族间','',''],['旖旎','',''],['旖旎风光','',''],['旗丁','',''],['旗下','',''],['旗人','',''],['旗儿','',''],['旗兵','',''],['旗号','',''],['旗子','',''],['旗官','',''],['旗山','',''],['旗山镇','',''],['旗帜','',''],['旗帜鲜明','',''],['旗幅','',''],['旗开取胜','',''],['旗开得胜','',''],['旗开马到','',''],['旗手','',''],['旗杆','',''],['旗校','',''],['旗津','',''],['旗津区','',''],['旗牌','',''],['旗竿','',''],['旗籍','',''],['旗绳','',''],['旗舰','',''],['旗舰店','',''],['旗艇','',''],['旗袍','',''],['旗装','',''],['旗语','',''],['旗鱼','',''],['旗鼓相当','',''],['旗鼓相望','',''],['无一','',''],['无一不备','',''],['无一不知','',''],['无一事而不学','',''],['无一例外','',''],['无一处而不得','',''],['无一幸免','',''],['无一时而不学','',''],['无上','',''],['无下箸处','',''],['无不','',''],['无不达','',''],['无与','',''],['无与为比','',''],['无与伦比','',''],['无专利','',''],['无业','',''],['无业人员','',''],['无业游民','',''],['无业闲散','',''],['无丝','',''],['无丝分裂','',''],['无中生有','',''],['无为而治','',''],['无为自化','',''],['无主','',''],['无主义','',''],['无主句','',''],['无主失物','',''],['无主见','',''],['无乃','',''],['无义','',''],['无了无休','',''],['无争','',''],['无争异','',''],['无争议','',''],['无争论','',''],['无事','',''],['无事不登三宝殿','',''],['无事可做','',''],['无事生非','',''],['无事自扰','',''],['无云','',''],['无产','',''],['无产者','',''],['无产阶级','',''],['无产阶级专政','',''],['无产阶级世界观','',''],['无产阶级国际主义','',''],['无产阶级革命','',''],['无亲戚','',''],['无亲托','',''],['无亲无故','',''],['无人','',''],['无人不','',''],['无人之地','',''],['无人之境','',''],['无人住','',''],['无人区','',''],['无人售票','',''],['无人性','',''],['无人机','',''],['无人知晓','',''],['无人过问','',''],['无人迹','',''],['无人问津','',''],['无人驾驶','',''],['无人驾驶飞机','',''],['无从','',''],['无从说起','',''],['无从谈起','',''],['无他','',''],['无以','',''],['无以为报','',''],['无以为生','',''],['无以塞责','',''],['无以复加','',''],['无以成江海','',''],['无以自容','',''],['无以至千里','',''],['无匠气','',''],['无价','',''],['无价之宝','',''],['无价值','',''],['无价宝','',''],['无价珍珠','',''],['无任','',''],['无任之禄','',''],['无任感激','',''],['无休','',''],['无休无止','',''],['无休止','',''],['无伤大雅','',''],['无伤痕','',''],['无伪装','',''],['无伴','',''],['无伴奏','',''],['无伴奏合唱','',''],['无伸','',''],['无似','',''],['无何','',''],['无何有之乡','',''],['无余','',''],['无佛处称尊','',''],['无侍从','',''],['无供给','',''],['无依','',''],['无依无靠','',''],['无保留','',''],['无保证','',''],['无信','',''],['无信义','',''],['无信仰','',''],['无信心','',''],['无倚无靠','',''],['无倾角','',''],['无偏无倚','',''],['无偏无党','',''],['无偏无陂','',''],['无偏见','',''],['无做作','',''],['无偿','',''],['无偿援助','',''],['无储','',''],['无儿女','',''],['无先例','',''],['无光','',''],['无光泽','',''],['无党','',''],['无党无偏','',''],['无党派','',''],['无党派人士','',''],['无党派投票人','',''],['无党派民主人士','',''],['无党派爱国人士','',''],['无公','',''],['无公约','',''],['无关','',''],['无关大局','',''],['无关宏旨','',''],['无关痛痒','',''],['无关系','',''],['无关紧要','',''],['无兴趣','',''],['无养主','',''],['无农药','',''],['无冬无夏','',''],['无决','',''],['无决断','',''],['无准备','',''],['无几','',''],['无出其右','',''],['无击','',''],['无分','',''],['无分别','',''],['无判','',''],['无利','',''],['无利可图','',''],['无利益','',''],['无前','',''],['无前例','',''],['无前因','',''],['无前途','',''],['无副作用','',''],['无力','',''],['无力气','',''],['无功','',''],['无功不受禄','',''],['无功功率','',''],['无功受禄','',''],['无功而禄','',''],['无功而返','',''],['无动于衷','',''],['无动静','',''],['无助','',''],['无助于','',''],['无助感','',''],['无包','',''],['无匹','',''],['无匹配','',''],['无华','',''],['无印痕','',''],['无印象','',''],['无压力','',''],['无厘头','',''],['无原则','',''],['无及','',''],['无双','',''],['无反','',''],['无反响','',''],['无发展前途','',''],['无取胜希望者','',''],['无受限','',''],['无变化','',''],['无口才','',''],['无可','',''],['无可不可','',''],['无可争辩','',''],['无可厚非','',''],['无可否认','',''],['无可奈何','',''],['无可奈何花落去','',''],['无可奉告','',''],['无可如何','',''],['无可指责','',''],['无可挽回','',''],['无可救药','',''],['无可无不可','',''],['无可比拟','',''],['无可比象','',''],['无可置疑','',''],['无可辩辩','',''],['无可辩驳','',''],['无可非议','',''],['无名','',''],['无名孽火','',''],['无名小卒','',''],['无名小辈','',''],['无名帖','',''],['无名战士墓','',''],['无名战死','',''],['无名指','',''],['无名氏','',''],['无名烈士墓','',''],['无名肿毒','',''],['无名英雄','',''],['无后','',''],['无后为大','',''],['无后嗣','',''],['无后坐力炮','',''],['无向','',''],['无吸','',''],['无员','',''],['无味','',''],['无味道','',''],['无呼吸','',''],['无咎无誉','',''],['无咖啡因','',''],['无品','',''],['无回声','',''],['无回答','',''],['无国界','',''],['无国界医生','',''],['无国界记者','',''],['无国籍','',''],['无土','',''],['无土地','',''],['无地址','',''],['无地自处','',''],['无地自容','',''],['无坐力炮','',''],['无坚不摧','',''],['无坚不陷','',''],['无垠','',''],['无基础','',''],['无墙壁','',''],['无声','',''],['无声无息','',''],['无声片','',''],['无声片儿','',''],['无壳','',''],['无壳族','',''],['无壳蜗牛','',''],['无处','',''],['无处不在','',''],['无处可寻','',''],['无处容身','',''],['无复孑遗','',''],['无大无小','',''],['无太','',''],['无头','',''],['无头告示','',''],['无头案','',''],['无头脑','',''],['无奇','',''],['无奇不有','',''],['无奈','',''],['无奈我何','',''],['无奢望','',''],['无奸不商','',''],['无好','',''],['无如','',''],['无如之何','',''],['无如奈何','',''],['无妄之灾','',''],['无妄之福','',''],['无妨','',''],['无妻','',''],['无始无终','',''],['无委','',''],['无威严','',''],['无嫌疑','',''],['无子','',''],['无孔','',''],['无孔不入','',''],['无孔不钻','',''],['无字碑','',''],['无学问','',''],['无宗教','',''],['无宗派','',''],['无官一身轻','',''],['无定','',''],['无定向','',''],['无定形','',''],['无定形碳','',''],['无定期','',''],['无实效','',''],['无实质','',''],['无害','',''],['无家','',''],['无家可奔','',''],['无家可归','',''],['无容','',''],['无容置疑','',''],['无容身之地','',''],['无对','',''],['无对手','',''],['无将牌','',''],['无尚光荣','',''],['无尽','',''],['无尽无休','',''],['无尽无穷','',''],['无尾熊','',''],['无尾猿','',''],['无尿症','',''],['无局','',''],['无层次','',''],['无巧','',''],['无巧不成书','',''],['无巧不成话','',''],['无差','',''],['无差别','',''],['无已','',''],['无师自通','',''],['无帐','',''],['无帮助','',''],['无常','',''],['无干','',''],['无幽不烛','',''],['无序','',''],['无底','',''],['无底坑','',''],['无底洞','',''],['无底稿','',''],['无度','',''],['无庸','',''],['无庸置疑','',''],['无庸置辩','',''],['无庸讳言','',''],['无异','',''],['无异于','',''],['无异议','',''],['无弹力','',''],['无弹性','',''],['无归','',''],['无形','',''],['无形中','',''],['无形体','',''],['无形化','',''],['无形损耗','',''],['无形无影','',''],['无形状','',''],['无形贸易','',''],['无形输出','',''],['无影','',''],['无影无形','',''],['无影无踪','',''],['无影灯','',''],['无往不利','',''],['无往不胜','',''],['无征不信','',''],['无得分','',''],['无得无丧','',''],['无微不至','',''],['无微不致','',''],['无心','',''],['无心插柳柳成阴','',''],['无必要','',''],['无忧','',''],['无忧无虑','',''],['无怀疑','',''],['无思想','',''],['无思无虑','',''],['无性','',''],['无性别','',''],['无性杂交','',''],['无性生殖','',''],['无性繁殖','',''],['无怨无悔','',''],['无怪','',''],['无怪乎','',''],['无恐惧','',''],['无恒','',''],['无恙','',''],['无息','',''],['无息贷款','',''],['无恶不作','',''],['无恶意','',''],['无悔','',''],['无悔意','',''],['无患子','',''],['无情','',''],['无情无义','',''],['无情无绪','',''],['无意','',''],['无意中','',''],['无意义','',''],['无意之中','',''],['无意识','',''],['无意间','',''],['无感情','',''],['无感觉','',''],['无愧','',''],['无愧于','',''],['无憾','',''],['无懈可击','',''],['无成','',''],['无我','',''],['无或','',''],['无房户','',''],['无所','',''],['无所不为','',''],['无所不包','',''],['无所不卖','',''],['无所不及','',''],['无所不可','',''],['无所不在','',''],['无所不容','',''],['无所不措手足','',''],['无所不晓','',''],['无所不有','',''],['无所不用其极','',''],['无所不知','',''],['无所不能','',''],['无所不至','',''],['无所不谈','',''],['无所不通','',''],['无所事事','',''],['无所作为','',''],['无所属','',''],['无所忌惮','',''],['无所忌讳','',''],['无所用心','',''],['无所畏忌','',''],['无所畏惧','',''],['无所谓','',''],['无所适从','',''],['无所顾忌','',''],['无所顾惮','',''],['无手','',''],['无批','',''],['无把握','',''],['无抑制','',''],['无报答','',''],['无抵','',''],['无担保','',''],['无拘无束','',''],['无拘束','',''],['无拳无勇','',''],['无指','',''],['无损','',''],['无损伤','',''],['无接缝','',''],['无掩饰','',''],['无措','',''],['无提供','',''],['无援','',''],['无支','',''],['无支援','',''],['无支祁','',''],['无支票','',''],['无收差','',''],['无改','',''],['无政府','',''],['无政府主义','',''],['无政府工团主义','',''],['无政府状态','',''],['无故','',''],['无效','',''],['无效分蘖','',''],['无效力','',''],['无效果','',''],['无效率','',''],['无效能','',''],['无敌','',''],['无敌于天下','',''],['无教养','',''],['无教育','',''],['无数','',''],['无数字','',''],['无文','',''],['无方','',''],['无方之民','',''],['无旋律','',''],['无无','',''],['无日','',''],['无日期','',''],['无时','',''],['无时无刻','',''],['无时间','',''],['无明','',''],['无明火','',''],['无是无非','',''],['无晶圆','',''],['无暇','',''],['无暗影','',''],['无月','',''],['无朋友','',''],['无服之丧','',''],['无服之殇','',''],['无望','',''],['无期','',''],['无期别','',''],['无期徒刑','',''],['无本之木','',''],['无机','',''],['无机化学','',''],['无机性','',''],['无机物','',''],['无机盐','',''],['无机肥料','',''],['无权','',''],['无权无势','',''],['无权过问','',''],['无束无拘','',''],['无束缚','',''],['无条件','',''],['无条件反射','',''],['无条件投降','',''],['无条理','',''],['无果','',''],['无柄叶','',''],['无标头','',''],['无核','',''],['无核化','',''],['无核区','',''],['无根','',''],['无根之木无源之水','',''],['无根据','',''],['无格式','',''],['无案','',''],['无梦','',''],['无梭织机','',''],['无次序','',''],['无欲','',''],['无欺','',''],['无款','',''],['无止','',''],['无止境','',''],['无歧视','',''],['无母','',''],['无毒','',''],['无毒不丈夫','',''],['无毒无副作用','',''],['无比','',''],['无比较级','',''],['无毛','',''],['无气','',''],['无气力','',''],['无气味','',''],['无气孔','',''],['无氧','',''],['无水','',''],['无水物','',''],['无污点','',''],['无法','',''],['无法形容','',''],['无法忍受','',''],['无法挽救','',''],['无法无天','',''],['无法替代','',''],['无泪','',''],['无活力','',''],['无派','',''],['无济于事','',''],['无涯','',''],['无源之水','',''],['无源之水无本之木','',''],['无灾','',''],['无烟','',''],['无烟囱工业','',''],['无烟火药','',''],['无烟炭','',''],['无烟煤','',''],['无热光','',''],['无焦点','',''],['无照','',''],['无照经营','',''],['无爪','',''],['无爱','',''],['无父','',''],['无牌','',''],['无牙','',''],['无物','',''],['无牵无挂','',''],['无特征','',''],['无特权','',''],['无特色','',''],['无状','',''],['无独有偶','',''],['无猜','',''],['无王牌','',''],['无现金','',''],['无理','',''],['无理函数','',''],['无理取闹','',''],['无理式','',''],['无理性','',''],['无理数','',''],['无理方程','',''],['无理根','',''],['无理由','',''],['无瑕','',''],['无瑕可击','',''],['无瑕疵','',''],['无甚高论','',''],['无生','',''],['无生产','',''],['无生命','',''],['无生气','',''],['无生物','',''],['无用','',''],['无用处','',''],['无用物','',''],['无由','',''],['无畏','',''],['无疆','',''],['无疆之休','',''],['无疑','',''],['无疑虑','',''],['无疑问','',''],['无疗效','',''],['无疵','',''],['无疾','',''],['无病','',''],['无病呻吟','',''],['无病自灸','',''],['无症状','',''],['无痕','',''],['无痕迹','',''],['无痛','',''],['无痛苦','',''],['无的','',''],['无的放矢','',''],['无益','',''],['无盖','',''],['无目','',''],['无目地','',''],['无目的','',''],['无眼','',''],['无着','',''],['无睡','',''],['无知','',''],['无知人','',''],['无知觉','',''],['无知识','',''],['无码','',''],['无碍','',''],['无礼','',''],['无礼下流','',''],['无礼取闹','',''],['无礼貌','',''],['无神','',''],['无神论','',''],['无神论者','',''],['无票','',''],['无禄','',''],['无福消受','',''],['无私','',''],['无私奉献','',''],['无私心','',''],['无私无畏','',''],['无私有弊','',''],['无秩序','',''],['无税','',''],['无稽','',''],['无稽之言','',''],['无稽之谈','',''],['无穷','',''],['无穷大','',''],['无穷小','',''],['无穷尽','',''],['无穷序列','',''],['无穷无尽','',''],['无穷远点','',''],['无穷集','',''],['无空不入','',''],['无空间','',''],['无立足之地','',''],['无立锥之地','',''],['无端','',''],['无端端','',''],['无符号','',''],['无答复','',''],['无策','',''],['无米之炊','',''],['无籽','',''],['无精卵','',''],['无精打彩','',''],['无精打采','',''],['无精神','',''],['无糖','',''],['无系统','',''],['无约束','',''],['无级','',''],['无纪律','',''],['无纸化办公','',''],['无纺织布','',''],['无线','',''],['无线电','',''],['无线电传真','',''],['无线电侦察','',''],['无线电厂','',''],['无线电发射机','',''],['无线电台','',''],['无线电导航','',''],['无线电报','',''],['无线电探空仪','',''],['无线电接收机','',''],['无线电收发机','',''],['无线电收音机','',''],['无线电波','',''],['无线电电子学','',''],['无线电管理委员会','',''],['无线电话','',''],['无线电运动','',''],['无线电通信','',''],['无线网路','',''],['无线通信','',''],['无组织','',''],['无细','',''],['无终','',''],['无终止','',''],['无经验','',''],['无结果','',''],['无绝','',''],['无继','',''],['无绳','',''],['无绳电话','',''],['无维度','',''],['无缘','',''],['无缘无故','',''],['无缝','',''],['无缝连接','',''],['无缝钢管','',''],['无缺','',''],['无缺点','',''],['无网格法','',''],['无罪','',''],['无罪抗辩','',''],['无罪推定','',''],['无翅','',''],['无翼','',''],['无翼而飞','',''],['无翼鸟','',''],['无耻','',''],['无耻之尤','',''],['无耻之徒','',''],['无聊','',''],['无聊乏味','',''],['无聊事','',''],['无聊赖','',''],['无职务','',''],['无联系','',''],['无肠公子','',''],['无胆量','',''],['无胫而行','',''],['无能','',''],['无能为力','',''],['无能为役','',''],['无能力','',''],['无脂','',''],['无脊椎','',''],['无脊椎动物','',''],['无脏污','',''],['无脚','',''],['无臂','',''],['无自信','',''],['无船承运人','',''],['无色','',''],['无色菌','',''],['无艺','',''],['无节制','',''],['无节操','',''],['无花','',''],['无花果','',''],['无苦恼','',''],['无茎','',''],['无菌','',''],['无菌性','',''],['无营养','',''],['无虑','',''],['无虑无忧','',''],['无虑无思','',''],['无虚饰','',''],['无虞','',''],['无虞匮乏','',''],['无血','',''],['无血气','',''],['无血色','',''],['无行','',''],['无补','',''],['无补于事','',''],['无补于时','',''],['无表','',''],['无表情','',''],['无袖','',''],['无袖子','',''],['无被','',''],['无装备','',''],['无装饰','',''],['无要','',''],['无规则','',''],['无视','',''],['无角','',''],['无解','',''],['无言','',''],['无言以对','',''],['无言可对','',''],['无言对答','',''],['无计划','',''],['无计可施','',''],['无计谋','',''],['无训练','',''],['无议','',''],['无记名','',''],['无记名投票','',''],['无记录','',''],['无讳','',''],['无讹','',''],['无论','',''],['无论何事','',''],['无论何人','',''],['无论何处','',''],['无论何时','',''],['无论如何','',''],['无诚意','',''],['无话不说','',''],['无话不谈','',''],['无话可说','',''],['无语','',''],['无谋','',''],['无谎不成媒','',''],['无谓','',''],['无责','',''],['无责任','',''],['无货','',''],['无资格','',''],['无资源','',''],['无赖','',''],['无赖汉','',''],['无趣','',''],['无趣味','',''],['无足','',''],['无足轻重','',''],['无足重轻','',''],['无路','',''],['无路可走','',''],['无路可退','',''],['无路可逃','',''],['无踪','',''],['无踪无影','',''],['无轨','',''],['无轨电车','',''],['无辜','',''],['无辩','',''],['无辩护','',''],['无边','',''],['无边帽','',''],['无边无际','',''],['无边苦海','',''],['无边风月','',''],['无过','',''],['无过失','',''],['无远见','',''],['无连接','',''],['无连络','',''],['无迹可寻','',''],['无适','',''],['无适无莫','',''],['无选择','',''],['无道','',''],['无遗','',''],['无遗漏','',''],['无遮盖','',''],['无遮蔽','',''],['无邪','',''],['无重','',''],['无重力','',''],['无重量','',''],['无重音','',''],['无野心','',''],['无量','',''],['无量寿','',''],['无针注射器','',''],['无钩绦虫','',''],['无钱','',''],['无铅','',''],['无锈','',''],['无错','',''],['无错误','',''],['无锡县','',''],['无锡新区','',''],['无门','',''],['无间','',''],['无间断','',''],['无闻','',''],['无防','',''],['无防备','',''],['无阻','',''],['无阻碍','',''],['无际','',''],['无限','',''],['无限制','',''],['无限大','',''],['无限小','',''],['无限小数','',''],['无限期','',''],['无限花序','',''],['无限风光在险峰','',''],['无随伴','',''],['无隐饰','',''],['无隙可乘','',''],['无障碍','',''],['无雪','',''],['无需','',''],['无需多说','',''],['无霜','',''],['无霜期','',''],['无静电','',''],['无非','',''],['无靠','',''],['无靠无依','',''],['无面','',''],['无面目见江东父老','',''],['无鞍','',''],['无音','',''],['无韵律','',''],['无须','',''],['无顾忌','',''],['无预谋','',''],['无领','',''],['无颌','',''],['无题','',''],['无题诗','',''],['无颜','',''],['无风','',''],['无风三尺浪','',''],['无风不起浪','',''],['无风生浪','',''],['无风起浪','',''],['无风趣','',''],['无首','',''],['无驾','',''],['无骨','',''],['无魅力','',''],['无齿翼龙','',''],['既为','',''],['既使','',''],['既可','',''],['既可以','',''],['既在','',''],['既定','',''],['既定方针','',''],['既已','',''],['既往','',''],['既往不咎','',''],['既得','',''],['既得利益','',''],['既得期间','',''],['既成事实','',''],['既无','',''],['既是','',''],['既有','',''],['既有今日何必当初','',''],['既来之','',''],['既来之则安之','',''],['既然','',''],['既然如此','',''],['既犬不留','',''],['既而','',''],['既能','',''],['既要','',''],['既视感','',''],['既非','',''],['日上三竿','',''],['日下','',''],['日下无双','',''],['日不暇给','',''],['日不移影','',''],['日不移晷','',''],['日与月','',''],['日中','',''],['日中则昃','',''],['日中必彗','',''],['日丽风和','',''],['日久','',''],['日久天长','',''],['日久岁深','',''],['日久月深','',''],['日久生情','',''],['日久见人心','',''],['日书','',''],['日产','',''],['日产量','',''],['日人','',''],['日以继夜','',''],['日俄','',''],['日俄战争','',''],['日俱','',''],['日偏食','',''],['日元','',''],['日光','',''],['日光浴','',''],['日光浴室','',''],['日光浴浴床','',''],['日光灯','',''],['日光节约时','',''],['日全食','',''],['日共','',''],['日内','',''],['日内瓦','',''],['日内瓦会议','',''],['日冕','',''],['日冕层','',''],['日军','',''],['日出','',''],['日出三竿','',''],['日刊','',''],['日创','',''],['日制','',''],['日前','',''],['日加工','',''],['日化','',''],['日升月恒','',''],['日半','',''],['日南郡','',''],['日历','',''],['日后','',''],['日商','',''],['日圆','',''],['日场','',''],['日均','',''],['日坐愁城','',''],['日坛','',''],['日坛公园','',''],['日增','',''],['日增月益','',''],['日处理能力','',''],['日复一日','',''],['日夕','',''],['日夜','',''],['日夜兼程','',''],['日头','',''],['日媒','',''],['日子','',''],['日寇','',''],['日射病','',''],['日射角','',''],['日尔曼','',''],['日就月将','',''],['日居月诸','',''],['日工','',''],['日工资','',''],['日差','',''],['日币','',''],['日常','',''],['日常工作','',''],['日常生活','',''],['日式','',''],['日引月长','',''],['日影','',''],['日往月来','',''],['日心说','',''],['日志','',''],['日志簿','',''],['日思夜想','',''],['日惹','',''],['日慎一日','',''],['日成','',''],['日戳','',''],['日托','',''],['日报','',''],['日报表','',''],['日持','',''],['日收','',''],['日数','',''],['日文','',''],['日斑','',''],['日新','',''],['日新月异','',''],['日方','',''],['日无暇晷','',''],['日日','',''],['日日夜夜','',''],['日旰忘食','',''],['日昃忘食','',''],['日晒','',''],['日晒伤','',''],['日晒雨淋','',''],['日晕','',''],['日晷','',''],['日晷仪','',''],['日暖','',''],['日暖风和','',''],['日暮','',''],['日暮途穷','',''],['日暮途远','',''],['日曜日','',''],['日曰','',''],['日月','',''],['日月丽天','',''],['日月五星','',''],['日月交食','',''],['日月入怀','',''],['日月其除','',''],['日月参辰','',''],['日月合璧','',''],['日月如梭','',''],['日月如流','',''],['日月星辰','',''],['日月晕','',''],['日月潭','',''],['日月经天江河行地','',''],['日月蹉跎','',''],['日月逾迈','',''],['日月重光','',''],['日服','',''],['日朝','',''],['日期','',''],['日本书纪','',''],['日本人','',''],['日本共产党','',''],['日本共同社','',''],['日本刀','',''],['日本化','',''],['日本原子能研究所','',''],['日本国','',''],['日本国志','',''],['日本天皇','',''],['日本学','',''],['日本式','',''],['日本放送协会','',''],['日本政治','',''],['日本柞蚕','',''],['日本海','',''],['日本电报电话公司','',''],['日本社会党','',''],['日本竹筷','',''],['日本米酒','',''],['日本经济','',''],['日本经济新闻','',''],['日本脑炎','',''],['日本航空','',''],['日本语','',''],['日本银行','',''],['日本问题','',''],['日本鬼子','',''],['日本黑道','',''],['日杂','',''],['日来','',''],['日比谷公园','',''],['日没','',''],['日渐','',''],['日渐月染','',''],['日滋月益','',''],['日濡月染','',''],['日炙风吹','',''],['日炙风筛','',''],['日环','',''],['日环食','',''],['日珥','',''],['日班','',''],['日理万机','',''],['日甚一日','',''],['日用','',''],['日用品','',''],['日用工业品','',''],['日用消费品','',''],['日用百货','',''],['日电','',''],['日电电子','',''],['日界','',''],['日界线','',''],['日益','',''],['日益增加','',''],['日益完善','',''],['日益月滋','',''],['日益频繁','',''],['日盛','',''],['日盼','',''],['日省月试','',''],['日省月课','',''],['日知录','',''],['日神','',''],['日积月累','',''],['日程','',''],['日程表','',''],['日立','',''],['日系','',''],['日经','',''],['日经平均','',''],['日经平均指数','',''],['日经指数','',''],['日美','',''],['日耳曼','',''],['日耳曼人','',''],['日耳曼语','',''],['日至','',''],['日臻','',''],['日航','',''],['日英联军','',''],['日落','',''],['日落西山','',''],['日落风生','',''],['日薄','',''],['日薄西山','',''],['日薪','',''],['日蚀','',''],['日行千里','',''],['日表','',''],['日裔','',''],['日西','',''],['日见','',''],['日规','',''],['日规仪','',''],['日角偃月','',''],['日角珠庭','',''],['日记','',''],['日记帐','',''],['日记本','',''],['日记簿','',''],['日试万言','',''],['日语','',''],['日诵五车','',''],['日货','',''],['日资','',''],['日趋','',''],['日趋严重','',''],['日转千街','',''],['日转千阶','',''],['日近长安远','',''],['日里','',''],['日销','',''],['日销月铄','',''],['日锻月炼','',''],['日间','',''],['日食','',''],['日食万钱','',''],['日高三丈','',''],['旦夕','',''],['旦旦','',''],['旦旦信誓','',''],['旦角','',''],['旦角儿','',''],['旧业','',''],['旧中国','',''],['旧习','',''],['旧习惯','',''],['旧书','',''],['旧了','',''],['旧事','',''],['旧五代史','',''],['旧交','',''],['旧仇','',''],['旧仇新恨','',''],['旧体','',''],['旧体诗','',''],['旧作','',''],['旧例','',''],['旧俗','',''],['旧债','',''],['旧制','',''],['旧制度','',''],['旧前','',''],['旧剧','',''],['旧历','',''],['旧历年','',''],['旧友','',''],['旧名','',''],['旧品','',''],['旧唐书','',''],['旧唯物主义','',''],['旧国','',''],['旧地','',''],['旧地重游','',''],['旧址','',''],['旧城','',''],['旧大陆','',''],['旧好','',''],['旧姓','',''],['旧学','',''],['旧宅','',''],['旧家','',''],['旧家行径','',''],['旧居','',''],['旧币','',''],['旧帐','',''],['旧年','',''],['旧式','',''],['旧念复萌','',''],['旧态','',''],['旧态复萌','',''],['旧思想','',''],['旧性','',''],['旧怨','',''],['旧恨','',''],['旧恨新仇','',''],['旧恶','',''],['旧情','',''],['旧愁新恨','',''],['旧损','',''],['旧故','',''],['旧教','',''],['旧料','',''],['旧日','',''],['旧时','',''],['旧时代','',''],['旧时风味','',''],['旧是','',''],['旧景重现','',''],['旧有','',''],['旧框框','',''],['旧案','',''],['旧梦','',''],['旧欠','',''],['旧民主主义革命','',''],['旧法','',''],['旧派','',''],['旧游','',''],['旧燕归巢','',''],['旧爱宿恩','',''],['旧版','',''],['旧物','',''],['旧瓶装新酒','',''],['旧疾','',''],['旧病','',''],['旧病复发','',''],['旧病难医','',''],['旧的','',''],['旧的不去','',''],['旧皇历','',''],['旧知','',''],['旧石器','',''],['旧石器时代','',''],['旧社会','',''],['旧称','',''],['旧约','',''],['旧约全书','',''],['旧者','',''],['旧船','',''],['旧衣','',''],['旧观','',''],['旧识','',''],['旧识新交','',''],['旧诗','',''],['旧话','',''],['旧调','',''],['旧调子','',''],['旧调重弹','',''],['旧貌','',''],['旧账','',''],['旧货','',''],['旧货商','',''],['旧货市场','',''],['旧贯','',''],['旧费','',''],['旧车','',''],['旧车市场','',''],['旧迹','',''],['旧部','',''],['旧都','',''],['旧金','',''],['旧金山','',''],['旧闻','',''],['旧雨','',''],['旧雨今雨','',''],['旨在','',''],['旨意','',''],['旨趣','',''],['旨酒嘉肴','',''],['早一点','',''],['早上好','',''],['早上睡','',''],['早中晚','',''],['早了','',''],['早于','',''],['早些','',''],['早些年','',''],['早些时候','',''],['早亡','',''],['早产','',''],['早产儿','',''],['早先','',''],['早出晚归','',''],['早到','',''],['早前','',''],['早动手','',''],['早半天儿','',''],['早去早回','',''],['早在','',''],['早场','',''],['早夭','',''],['早婚','',''],['早安','',''],['早就','',''],['早岁','',''],['早己','',''],['早已','',''],['早已有之','',''],['早市','',''],['早年','',''],['早恋','',''],['早成','',''],['早报','',''],['早播','',''],['早操','',''],['早收获','',''],['早日','',''],['早日康复','',''],['早早','',''],['早早儿','',''],['早春','',''],['早晚','',''],['早有','',''],['早期','',''],['早期效应','',''],['早期教育','',''],['早期核辐射','',''],['早期白话','',''],['早来','',''],['早来晚走','',''],['早死','',''],['早泄','',''],['早点','',''],['早点名','',''],['早点火','',''],['早熟','',''],['早版','',''],['早班','',''],['早班儿','',''],['早生贵子','',''],['早的','',''],['早睡','',''],['早睡早起','',''],['早知','',''],['早知今日何必当初','',''],['早知今日悔不当初','',''],['早知道','',''],['早秋','',''],['早稻','',''],['早稻田大学','',''],['早老素','',''],['早育','',''],['早茶','',''],['早衰','',''],['早该','',''],['早课','',''],['早谢','',''],['早起','',''],['早起早睡','',''],['早车','',''],['早退','',''],['早逝','',''],['早间','',''],['早霜','',''],['早餐','',''],['早饭','',''],['旬刊','',''],['旬始','',''],['旬岁','',''],['旬年','',''],['旬报','',''],['旬日','',''],['旬时','',''],['旬朔','',''],['旬期','',''],['旬末','',''],['旬节','',''],['旬课','',''],['旬输月送','',''],['旬首','',''],['旭日','',''],['旭日东升','',''],['旭日初升','',''],['旮旮旯旯儿','',''],['旮旯','',''],['旮旯儿','',''],['旰食之劳','',''],['旰食宵衣','',''],['旱井','',''],['旱伞','',''],['旱冰','',''],['旱冰场','',''],['旱厕','',''],['旱地','',''],['旱季','',''],['旱年','',''],['旱情','',''],['旱柳','',''],['旱栖','',''],['旱桥','',''],['旱涝','',''],['旱涝保收','',''],['旱灾','',''],['旱烟','',''],['旱烟袋','',''],['旱獭','',''],['旱生','',''],['旱田','',''],['旱秧','',''],['旱秧田','',''],['旱稻','',''],['旱练','',''],['旱船','',''],['旱苗得雨','',''],['旱荒','',''],['旱象','',''],['旱路','',''],['旱道','',''],['旱金莲','',''],['旱魃','',''],['旱魃为虐','',''],['旱鸭子','',''],['时下','',''],['时不再来','',''],['时不可失','',''],['时不我与','',''],['时不我待','',''],['时不时','',''],['时世','',''],['时为','',''],['时举','',''],['时乖命蹇','',''],['时乖运乖','',''],['时乖运拙','',''],['时乖运蹇','',''],['时事','',''],['时事性','',''],['时事知识','',''],['时事社','',''],['时事评论','',''],['时产','',''],['时人','',''],['时代','',''],['时代不同','',''],['时代华纳','',''],['时代广场','',''],['时代感','',''],['时代气息','',''],['时代特征','',''],['时令','',''],['时令病','',''],['时价','',''],['时伏','',''],['时会','',''],['时俗','',''],['时候','',''],['时值','',''],['时光','',''],['时光似箭日月如梭','',''],['时光隧道','',''],['时兴','',''],['时写时辍','',''],['时冷时热','',''],['时出','',''],['时分','',''],['时制','',''],['时刻','',''],['时刻准备','',''],['时刻表','',''],['时务','',''],['时势','',''],['时势造英雄','',''],['时区','',''],['时取','',''],['时和岁丰','',''],['时和岁稔','',''],['时和年丰','',''],['时在','',''],['时大时小','',''],['时好时坏','',''],['时宜','',''],['时宪书','',''],['时害','',''],['时尚','',''],['时局','',''],['时差','',''],['时常','',''],['时并','',''],['时序','',''],['时异事殊','',''],['时异势殊','',''],['时弊','',''],['时式','',''],['时必','',''],['时快时慢','',''],['时态','',''],['时戳','',''],['时报','',''],['时政','',''],['时效','',''],['时效处理','',''],['时效性','',''],['时数','',''],['时文','',''],['时断时续','',''],['时新','',''],['时方','',''],['时日','',''],['时日无多','',''],['时时','',''],['时时刻刻','',''],['时显时隐','',''],['时有所闻','',''],['时望所归','',''],['时期','',''],['时机','',''],['时来运','',''],['时来运旋','',''],['时来运来','',''],['时来运转','',''],['时样','',''],['时段','',''],['时段分析','',''],['时气','',''],['时漏','',''],['时炸弹','',''],['时点','',''],['时现','',''],['时疫','',''],['时移世变','',''],['时移事改','',''],['时移事迁','',''],['时移俗易','',''],['时程表','',''],['时空','',''],['时空旅行','',''],['时空穿梭','',''],['时空观','',''],['时穿','',''],['时绌举赢','',''],['时绥','',''],['时续','',''],['时而','',''],['时能','',''],['时至','',''],['时至今日','',''],['时节','',''],['时菜','',''],['时蔬','',''],['时行','',''],['时装','',''],['时装业','',''],['时装表','',''],['时装表演','',''],['时装设计师','',''],['时装鞋','',''],['时见','',''],['时讯','',''],['时评','',''],['时调','',''],['时调小曲','',''],['时谈物议','',''],['时贤','',''],['时辰','',''],['时辰未到','',''],['时过境迁','',''],['时运','',''],['时运不济','',''],['时运亨通','',''],['时速','',''],['时逢','',''],['时针','',''],['时钟','',''],['时钟座','',''],['时间','',''],['时间上','',''],['时间内','',''],['时间区间','',''],['时间学','',''],['时间差','',''],['时间序列','',''],['时间性','',''],['时间戳','',''],['时间测定学','',''],['时间等','',''],['时间简史','',''],['时间管理','',''],['时间线','',''],['时间表','',''],['时间词','',''],['时间跨度','',''],['时间轴','',''],['时间进程','',''],['时限','',''],['时隐时现','',''],['时隔','',''],['时隔不久','',''],['时雍','',''],['时风','',''],['时髦','',''],['时髦人','',''],['时鲜','',''],['旷世','',''],['旷世奇才','',''],['旷世无匹','',''],['旷世逸才','',''],['旷代','',''],['旷古','',''],['旷古一人','',''],['旷古未有','',''],['旷古未闻','',''],['旷古绝伦','',''],['旷地','',''],['旷夫','',''],['旷夫怨女','',''],['旷工','',''],['旷废','',''],['旷日','',''],['旷日引久','',''],['旷日引月','',''],['旷日弥久','',''],['旷日持久','',''],['旷日经久','',''],['旷时','',''],['旷时摄影','',''],['旷渺','',''],['旷职','',''],['旷职偾事','',''],['旷若发蒙','',''],['旷课','',''],['旷费','',''],['旷达','',''],['旷野','',''],['旷阔','',''],['旺季','',''],['旺市','',''],['旺月','',''],['旺期','',''],['旺泉','',''],['旺波日山','',''],['旺火','',''],['旺盛','',''],['旺角','',''],['旺销','',''],['昂利','',''],['昂头','',''],['昂头天外','',''],['昂奋','',''],['昂山','',''],['昂山素姬','',''],['昂山素季','',''],['昂扬','',''],['昂昂','',''],['昂昂溪','',''],['昂然','',''],['昂然自得','',''],['昂纳克','',''],['昂船洲','',''],['昂藏','',''],['昂贵','',''],['昂首','',''],['昂首挺胸','',''],['昂首阔步','',''],['昃食宵衣','',''],['昆仑','',''],['昆仑山','',''],['昆仑山脉','',''],['昆仲','',''],['昆剧','',''],['昆卡','',''],['昆塔尔会议','',''],['昆士兰','',''],['昆士兰州','',''],['昆山中学','',''],['昆山片玉','',''],['昆布','',''],['昆廷','',''],['昆弟之好','',''],['昆明池','',''],['昆明湖','',''],['昆曲','',''],['昆汀','',''],['昆汀・塔伦提诺','',''],['昆汀・塔伦蒂诺','',''],['昆河铁路','',''],['昆腔','',''],['昆虫','',''],['昆虫学','',''],['昆虫馆','',''],['昆都仑','',''],['昆阳','',''],['昆阳之战','',''],['昇起','',''],['昊天','',''],['昊天不吊','',''],['昊天罔极','',''],['昌原','',''],['昌原市','',''],['昌吉州','',''],['昌平','',''],['昌披','',''],['昌明','',''],['昌江','',''],['昌江县','',''],['昌盛','',''],['昌言','',''],['昌迪加尔','',''],['昌鱼','',''],['明与暗','',''],['明丽','',''],['明郡','',''],['明书','',''],['明了','',''],['明争','',''],['明争暗斗','',''],['明亮','',''],['明亮度','',''],['明人','',''],['明人不作暗事','',''],['明人不做暗事','',''],['明仁','',''],['明仁宗','',''],['明代','',''],['明令','',''],['明体','',''],['明信片','',''],['明修栈道','',''],['明修栈道暗度陈仓','',''],['明儿','',''],['明儿个','',''],['明光度','',''],['明光蓝','',''],['明冬','',''],['明净','',''],['明刑弼教','',''],['明创','',''],['明初','',''],['明前','',''],['明十三陵','',''],['明升实降','',''],['明升暗降','',''],['明古鲁','',''],['明古鲁市','',''],['明史','',''],['明后天','',''],['明和','',''],['明哲','',''],['明哲保身','',''],['明唐','',''],['明喻','',''],['明器','',''],['明堂','',''],['明处','',''],['明天启','',''],['明天见','',''],['明太祖','',''],['明婚正配','',''],['明媒正娶','',''],['明媚','',''],['明子','',''],['明孝陵','',''],['明定','',''],['明实录','',''],['明宣宗','',''],['明察','',''],['明察暗访','',''],['明察秋毫','',''],['明尼苏达','',''],['明尼苏达州','',''],['明尼阿波利斯','',''],['明山','',''],['明岗暗哨','',''],['明年初','',''],['明德','',''],['明德惟馨','',''],['明德慎罚','',''],['明德镇','',''],['明心见性','',''],['明快','',''],['明性','',''],['明情','',''],['明慧','',''],['明成祖','',''],['明手','',''],['明扬仄陋','',''],['明抢','',''],['明报','',''],['明摆','',''],['明摆着','',''],['明政','',''],['明效','',''],['明效大验','',''],['明教','',''],['明文','',''],['明文规定','',''],['明断','',''],['明斯克','',''],['明日','',''],['明日黄花','',''],['明早','',''],['明时','',''],['明明','',''],['明明白白','',''],['明星','',''],['明春','',''],['明显','',''],['明显的句法线索','',''],['明晃','',''],['明晃晃','',''],['明晚','',''],['明晰','',''],['明智','',''],['明智之举','',''],['明暗','',''],['明暗法','',''],['明月','',''],['明月入怀','',''],['明月清风','',''],['明朗','',''],['明朗化','',''],['明朝','',''],['明朝体','',''],['明末','',''],['明末清初','',''],['明杖','',''],['明来暗往','',''],['明枪','',''],['明枪好躲','',''],['明枪好躲暗箭难防','',''],['明枪容易躲','',''],['明枪易躲','',''],['明枪易躲暗箭难防','',''],['明枪暗箭','',''],['明查','',''],['明查暗访','',''],['明正典刑','',''],['明此','',''],['明武宗','',''],['明沟','',''],['明治','',''],['明治维新','',''],['明法审令','',''],['明清','',''],['明渠','',''],['明澈','',''],['明火','',''],['明火执仗','',''],['明火持杖','',''],['明灭','',''],['明灯','',''],['明熹宗','',''],['明物','',''],['明珠','',''],['明珠弹雀','',''],['明珠暗投','',''],['明珠生蚌','',''],['明理','',''],['明用','',''],['明畅','',''],['明白','',''],['明皎','',''],['明盘','',''],['明目','',''],['明目张胆','',''],['明目达聪','',''],['明眸皓齿','',''],['明眼','',''],['明眼人','',''],['明知','',''],['明知故犯','',''],['明知故问','',''],['明石','',''],['明矾','',''],['明矾石','',''],['明码','',''],['明码标价','',''],['明确','',''],['明确性','',''],['明示','',''],['明窗净几','',''],['明等','',''],['明算帐','',''],['明线光谱','',''],['明细','',''],['明细帐','',''],['明细表','',''],['明细账','',''],['明耻教战','',''],['明胶','',''],['明若观火','',''],['明虾','',''],['明见万里','',''],['明觉','',''],['明言','',''],['明誓','',''],['明订','',''],['明讲','',''],['明证','',''],['明说','',''],['明赏慎罚','',''],['明起','',''],['明辨','',''],['明辨是非','',''],['明达','',''],['明达事理','',''],['明道','',''],['明邃','',''],['明铺暗盖','',''],['明镜','',''],['明镜高悬','',''],['明间','',''],['明间儿','',''],['昏乱','',''],['昏了','',''],['昏倒','',''],['昏厥','',''],['昏君','',''],['昏在','',''],['昏天','',''],['昏天黑地','',''],['昏头','',''],['昏头搭脑','',''],['昏头昏脑','',''],['昏头转向','',''],['昏定晨省','',''],['昏庸','',''],['昏昏','',''],['昏昏入睡','',''],['昏昏欲睡','',''],['昏昏沉沉','',''],['昏星','',''],['昏晕','',''],['昏暗','',''],['昏沉','',''],['昏沉沉','',''],['昏眩','',''],['昏睡','',''],['昏睡病','',''],['昏聩','',''],['昏花','',''],['昏话','',''],['昏谜','',''],['昏过去','',''],['昏迷','',''],['昏迷不醒','',''],['昏镜重明','',''],['昏镜重磨','',''],['昏黄','',''],['昏黑','',''],['易与','',''],['易语言','',''],['易主','',''],['易举','',''],['易于','',''],['易人','',''],['易传','',''],['易传染','',''],['易伤感','',''],['易位','',''],['易使','',''],['易使用','',''],['易俗','',''],['易俗移风','',''],['易倒','',''],['易做','',''],['易兴奋','',''],['易出错','',''],['易分裂','',''],['易切断','',''],['易初莲花','',''],['易办','',''],['易动','',''],['易勃起','',''],['易北河','',''],['易卖','',''],['易卜','',''],['易卜拉辛','',''],['易卜生','',''],['易压碎','',''],['易发','',''],['易发生','',''],['易取','',''],['易取得','',''],['易受','',''],['易受惊','',''],['易受攻击','',''],['易受骗','',''],['易变','',''],['易变动','',''],['易变性','',''],['易司马仪','',''],['易名','',''],['易哭','',''],['易地','',''],['易坏','',''],['易处理','',''],['易如反掌','',''],['易如拾芥','',''],['易如翻掌','',''],['易学','',''],['易守难攻','',''],['易察觉','',''],['易对','',''],['易帜','',''],['易延展','',''],['易建联','',''],['易弄','',''],['易弄碎','',''],['易弯','',''],['易忘','',''],['易忘记','',''],['易怒','',''],['易怒者','',''],['易患','',''],['易感动','',''],['易感染','',''],['易感知','',''],['易感者','',''],['易懂','',''],['易成','',''],['易手','',''],['易抚慰','',''],['易拆','',''],['易拉罐','',''],['易挥发','',''],['易损','',''],['易损害','',''],['易损性','',''],['易掉','',''],['易接','',''],['易接受','',''],['易接近','',''],['易控制','',''],['易撕碎','',''],['易攻击','',''],['易攻占','',''],['易教','',''],['易散发','',''],['易旋转','',''],['易明了','',''],['易曲折','',''],['易染色','',''],['易洛魁人','',''],['易流泪','',''],['易消散','',''],['易液化','',''],['易混合','',''],['易溶','',''],['易滑','',''],['易潮解','',''],['易激动','',''],['易激惹','',''],['易熔合金','',''],['易燃','',''],['易燃性','',''],['易燃易爆','',''],['易燃物','',''],['易燃物品','',''],['易爆','',''],['易爆发','',''],['易物','',''],['易犯','',''],['易犯罪','',''],['易理解','',''],['易生','',''],['易用','',''],['易知','',''],['易破','',''],['易破碎','',''],['易碎','',''],['易粘住','',''],['易经','',''],['易脱节','',''],['易腐','',''],['易腐坏','',''],['易腐烂','',''],['易腐败','',''],['易蔓延','',''],['易行','',''],['易被','',''],['易裂','',''],['易裂性','',''],['易装','',''],['易见','',''],['易解','',''],['易言之','',''],['易误会','',''],['易误解','',''],['易读','',''],['易读性','',''],['易货','',''],['易货贸易','',''],['易起','',''],['易趣','',''],['易辙','',''],['易逃逸','',''],['易逝','',''],['易遭','',''],['易醉','',''],['易错','',''],['易长','',''],['易陷于','',''],['易震动','',''],['易驾驭','',''],['易骗','',''],['昔人','',''],['昔似','',''],['昔岁','',''],['昔年','',''],['昔日','',''],['昔时','',''],['昔比','',''],['昔者','',''],['昔非今比','',''],['昙花','',''],['昙花一现','',''],['星云','',''],['星云表','',''],['星位','',''],['星体','',''],['星儿','',''],['星光','',''],['星光灿烂','',''],['星冰乐','',''],['星前月下','',''],['星占术','',''],['星历','',''],['星号','',''],['星名','',''],['星命家','',''],['星团','',''],['星国','',''],['星图','',''],['星型网','',''],['星夜','',''],['星奔川骛','',''],['星官','',''],['星家','',''],['星宿','',''],['星宿海','',''],['星岛','',''],['星岛日报','',''],['星巴克','',''],['星座','',''],['星座运势','',''],['星形','',''],['星形物','',''],['星形线','',''],['星彩','',''],['星散','',''],['星散于','',''],['星斗','',''],['星星','',''],['星星之火','',''],['星星之火可以燎原','',''],['星星点点','',''],['星曜','',''],['星月','',''],['星期','',''],['星期几','',''],['星毛虫','',''],['星汉','',''],['星河','',''],['星洲','',''],['星洲日报','',''],['星流电击','',''],['星流霆击','',''],['星火','',''],['星火燎原','',''],['星火计划','',''],['星点','',''],['星状','',''],['星状体','',''],['星状物','',''],['星球','',''],['星球大战','',''],['星盘','',''],['星相','',''],['星相图','',''],['星相学','',''],['星相师','',''],['星相术','',''],['星眸皓齿','',''],['星移斗换','',''],['星移斗转','',''],['星移物换','',''],['星空','',''],['星等','',''],['星系','',''],['星系间','',''],['星级','',''],['星罗云布','',''],['星罗棋布','',''],['星群','',''],['星落云散','',''],['星虫','',''],['星行夜归','',''],['星表','',''],['星言夙驾','',''],['星象','',''],['星象图','',''],['星象恶曜','',''],['星辰','',''],['星运','',''],['星际','',''],['星际争霸','',''],['星际旅行','',''],['星际间','',''],['星陈夙驾','',''],['星驰','',''],['星驰电发','',''],['星驰电走','',''],['映像','',''],['映像管','',''],['映入','',''],['映出','',''],['映射','',''],['映射过程','',''],['映山红','',''],['映带','',''],['映照','',''],['映片','',''],['映着','',''],['映衬','',''],['映象','',''],['映雪囊萤','',''],['映雪读书','',''],['春上','',''],['春不老','',''],['春义阑珊','',''],['春事阑珊','',''],['春令','',''],['春假','',''],['春光','',''],['春光乍泄','',''],['春光如海','',''],['春光明媚','',''],['春光漏泄','',''],['春兰','',''],['春兰秋菊','',''],['春凳','',''],['春分点','',''],['春化','',''],['春华秋实','',''],['春卷','',''],['春去秋来','',''],['春和景明','',''],['春回大地','',''],['春地','',''],['春城','',''],['春夏','',''],['春夏秋冬','',''],['春大麦','',''],['春天','',''],['春妇','',''],['春季','',''],['春宫','',''],['春宵','',''],['春宵一刻','',''],['春寒','',''],['春小麦','',''],['春山八字','',''],['春山如笑','',''],['春岑','',''],['春川市','',''],['春归人老','',''],['春心','',''],['春忙','',''],['春情','',''],['春意','',''],['春意盎然','',''],['春播','',''],['春日','',''],['春日乡','',''],['春日融融','',''],['春旱','',''],['春晖','',''],['春景','',''],['春暖','',''],['春暖花开','',''],['春暖花香','',''],['春末','',''],['春来秋去','',''],['春柳','',''],['春柳剧场','',''],['春柳社','',''],['春树暮云','',''],['春梦','',''],['春梦无痕','',''],['春武里府','',''],['春汛','',''],['春江','',''],['春江花月夜','',''],['春深似海','',''],['春游','',''],['春满人间','',''],['春潮','',''],['春灌','',''],['春灯谜','',''],['春牛','',''],['春生','',''],['春生秋杀','',''],['春画','',''],['春瘟','',''],['春社','',''],['春祈秋报','',''],['春神','',''],['春秋','',''],['春秋三传','',''],['春秋五霸','',''],['春秋大梦','',''],['春秋左氏传','',''],['春秋战国','',''],['春秋战国时代','',''],['春秋时代','',''],['春秋笔法','',''],['春秋繁露','',''],['春秋鼎盛','',''],['春种','',''],['春笋','',''],['春绸','',''],['春耕','',''],['春耕生产','',''],['春联','',''],['春肥','',''],['春色','',''],['春色满园','',''],['春花','',''],['春花作物','',''],['春花秋月','',''],['春茶','',''],['春药','',''],['春菇','',''],['春蕾','',''],['春蚓秋蛇','',''],['春蚕','',''],['春蚕到死丝方尽','',''],['春装','',''],['春试','',''],['春诵夏弦','',''],['春辉','',''],['春运','',''],['春闱','',''],['春雨','',''],['春雨绵绵','',''],['春雷','',''],['春霖','',''],['春露秋霜','',''],['春风','',''],['春风一度','',''],['春风化雨','',''],['春风吹又生','',''],['春风和气','',''],['春风夏雨','',''],['春风得意','',''],['春风深醉的晚上','',''],['春风满面','',''],['春风风人','',''],['春饼','',''],['春麦','',''],['春黄菊','',''],['春黄菊属','',''],['昧于','',''],['昧地谩天','',''],['昧天瞒地','',''],['昧己瞒心','',''],['昧心','',''],['昧旦晨兴','',''],['昧死','',''],['昧死以闻','',''],['昧没','',''],['昧着','',''],['昧着良心','',''],['昧良心','',''],['昨儿','',''],['昨儿个','',''],['昨夜','',''],['昨天下午','',''],['昨天夜间','',''],['昨天晚间','',''],['昨日','',''],['昨晚','',''],['昨没','',''],['昨甚','',''],['昨能','',''],['昨非今是','',''],['昭代','',''],['昭和','',''],['昭彰','',''],['昭披耶帕康','',''],['昭披耶河','',''],['昭昭','',''],['昭然','',''],['昭然若揭','',''],['昭示','',''],['昭著','',''],['昭通地区','',''],['昭阳','',''],['昭雪','',''],['是不是','',''],['是古非今','',''],['是可忍孰不可忍','',''],['是否','',''],['是味儿','',''],['是啥说啥','',''],['是故','',''],['是是非非','',''],['是样儿','',''],['是的','',''],['是药三分毒','',''],['是长是短','',''],['是非','',''],['是非不分','',''],['是非之地','',''],['是非之心','',''],['是非人我','',''],['是非分明','',''],['是非功过','',''],['是非只为多开口','',''],['是非得失','',''],['是非曲直','',''],['是非自有公论','',''],['是非莫辨','',''],['是非问题','',''],['是非颠倒','',''],['昱昱','',''],['昴宿星团','',''],['昴星团','',''],['昵友','',''],['昵比','',''],['昵爱','',''],['昵称','',''],['昼伏夜出','',''],['昼伏夜游','',''],['昼出夜息','',''],['昼夜','',''],['昼夜兼程','',''],['昼夜兼行','',''],['昼夜平分点','',''],['昼日','',''],['昼短夜长','',''],['昼锦之荣','',''],['昼锦荣归','',''],['昼间','',''],['显亲扬名','',''],['显位','',''],['显像','',''],['显像剂','',''],['显像管','',''],['显光管','',''],['显出','',''],['显卡','',''],['显名','',''],['显圣','',''],['显型','',''],['显姓扬名','',''],['显学','',''],['显宦','',''],['显山露水','',''],['显形','',''],['显影','',''],['显影剂','',''],['显得','',''],['显微','',''],['显微图','',''],['显微学','',''],['显微摄影','',''],['显微镜','',''],['显微镜座','',''],['显微镜载片','',''],['显微阅读机','',''],['显怀','',''],['显性','',''],['显性基因','',''],['显扬','',''],['显摆','',''],['显效','',''],['显明','',''],['显晦','',''],['显晶','',''],['显来','',''],['显液','',''],['显灵','',''],['显焓','',''],['显然','',''],['显现','',''],['显现日','',''],['显生代','',''],['显生宙','',''],['显白','',''],['显目','',''],['显眼','',''],['显着','',''],['显示','',''],['显示卡','',''],['显示器','',''],['显示屏','',''],['显示板','',''],['显祖','',''],['显祖扬宗','',''],['显祖荣宗','',''],['显神','',''],['显耀','',''],['显老','',''],['显考','',''],['显而','',''],['显而易见','',''],['显职','',''],['显色','',''],['显花植物','',''],['显荣','',''],['显著','',''],['显著成绩','',''],['显著特点','',''],['显著面','',''],['显要','',''],['显要位置','',''],['显见','',''],['显观','',''],['显证','',''],['显豁','',''],['显象','',''],['显象管','',''],['显贵','',''],['显赫','',''],['显赫一时','',''],['显赫人物','',''],['显身','',''],['显身手','',''],['显达','',''],['显镜','',''],['显露','',''],['显露出','',''],['晁错','',''],['晃动','',''],['晃头','',''],['晃悠','',''],['晃晃','',''],['晃晃悠悠','',''],['晃来晃去','',''],['晃眼','',''],['晃着','',''],['晃脑','',''],['晃荡','',''],['晋书','',''],['晋京','',''],['晋代','',''],['晋剧','',''],['晋升','',''],['晋升为','',''],['晋升制度','',''],['晋县','',''],['晋国','',''],['晋安','',''],['晋察冀','',''],['晋封','',''],['晋文公','',''],['晋朝','',''],['晋江地区','',''],['晋源','',''],['晋爵','',''],['晋级','',''],['晋见','',''],['晋谒','',''],['晌午','',''],['晌觉','',''],['晌饭','',''],['晏婴','',''],['晏子','',''],['晏子春秋','',''],['晏平仲','',''],['晏开之警','',''],['晏驾','',''],['晒伤','',''],['晒友','',''],['晒台','',''],['晒图','',''],['晒图纸','',''],['晒场','',''],['晒垡','',''],['晒太阳','',''],['晒客','',''],['晒干','',''],['晒得','',''],['晒成','',''],['晒斑','',''],['晒晒','',''],['晒暖儿','',''],['晒架','',''],['晒烟','',''],['晒盐','',''],['晒网','',''],['晒衣夹','',''],['晒衣架','',''],['晒衣柱','',''],['晒衣用','',''],['晒衣绳','',''],['晒衣绳子','',''],['晒骆驼','',''],['晒黑','',''],['晒黑族','',''],['晒黑网','',''],['晓之以理','',''],['晓事','',''],['晓以大义','',''],['晓市','',''],['晓得','',''],['晓畅','',''],['晓示','',''],['晓色','',''],['晓英','',''],['晓行夜宿','',''],['晓谕','',''],['晓雾','',''],['晓风残月','',''],['晕乎','',''],['晕了','',''],['晕倒','',''],['晕厥','',''],['晕呼呼','',''],['晕场','',''],['晕头','',''],['晕头转向','',''],['晕机','',''],['晕染','',''],['晕死','',''],['晕池','',''],['晕眩','',''],['晕糊','',''],['晕船','',''],['晕色','',''],['晕血','',''],['晕血症','',''],['晕车','',''],['晕针','',''],['晕高儿','',''],['晖映','',''],['晚上好','',''],['晚世','',''],['晚了','',''],['晚于','',''],['晚些','',''],['晚些时候','',''],['晚会','',''],['晚到','',''],['晚半天儿','',''],['晚唐','',''],['晚场','',''],['晚夏','',''],['晚娘','',''],['晚婚','',''],['晚婚晚育','',''],['晚安','',''],['晚宴','',''],['晚岁','',''],['晚年','',''],['晚恋','',''],['晚报','',''],['晚星','',''],['晚春','',''],['晚晌','',''],['晚景','',''],['晚暮','',''],['晚期','',''],['晚期癌症','',''],['晚汤','',''],['晚清','',''],['晚点','',''],['晚熟','',''],['晚班','',''],['晚生','',''],['晚生后学','',''],['晚田','',''],['晚疫病','',''],['晚睡','',''],['晚睡晚起','',''],['晚礼','',''],['晚礼服','',''],['晚祷','',''],['晚秋','',''],['晚秋作物','',''],['晚稻','',''],['晚育','',''],['晚节','',''],['晚节不终','',''],['晚节末路','',''],['晚节黄花','',''],['晚茶','',''],['晚补','',''],['晚装','',''],['晚起','',''],['晚车','',''],['晚辈','',''],['晚近','',''],['晚钟','',''],['晚间','',''],['晚霜','',''],['晚霞','',''],['晚风','',''],['晚餐','',''],['晚饭','',''],['晚香玉','',''],['晤商','',''],['晤见','',''],['晤谈','',''],['晤面','',''],['晦明','',''],['晦暗','',''],['晦暝','',''],['晦气','',''],['晦涩','',''],['晦迹韬光','',''],['晨光','',''],['晨兴夜寐','',''],['晨参暮省','',''],['晨参暮礼','',''],['晨号','',''],['晨夕共处','',''],['晨报','',''],['晨操','',''],['晨昏','',''],['晨昏定省','',''],['晨星','',''],['晨曦','',''],['晨曲','',''],['晨歌','',''],['晨炊星饭','',''],['晨祷','',''],['晨练','',''],['晨钟','',''],['晨钟暮鼓','',''],['晨间','',''],['晨雾','',''],['晨露','',''],['晨风','',''],['普世','',''],['普世基督教','',''],['普世教会','',''],['普京','',''],['普什图语','',''],['普列','',''],['普列谢茨克','',''],['普列谢茨克卫星发射场','',''],['普利司通','',''],['普利策奖','',''],['普利茅斯','',''],['普加乔夫','',''],['普及','',''],['普及型','',''],['普及教育','',''],['普及本','',''],['普及率','',''],['普及读物','',''],['普吉','',''],['普天','',''],['普天下','',''],['普天之下','',''],['普天同庆','',''],['普契尼','',''],['普密蓬','',''],['普密蓬・阿杜德','',''],['普密蓬阿杜德','',''],['普尔','',''],['普尔热瓦尔斯基','',''],['普希金','',''],['普度','',''],['普度众生','',''],['普托','',''],['普拉','',''],['普拉亚','',''],['普拉提','',''],['普普通通','',''],['普朗克','',''],['普朗克常数','',''],['普林斯吨','',''],['普林斯吨大学','',''],['普林斯顿','',''],['普林斯顿大学','',''],['普查','',''],['普桑轿车','',''],['普氏','',''],['普氏小羚羊','',''],['普氏立克次体','',''],['普氏野马','',''],['普法','',''],['普法战争','',''],['普法教育','',''],['普洱茶','',''],['普济众生','',''],['普济群生','',''],['普渡','',''],['普照','',''],['普特','',''],['普米','',''],['普罗','',''],['普罗列塔利亚','',''],['普罗大众','',''],['普罗夫迪夫','',''],['普罗扎克','',''],['普罗提诺','',''],['普罗文学','',''],['普罗旺斯','',''],['普罗旺斯语','',''],['普罗科菲夫','',''],['普罗迪','',''],['普考','',''],['普莱斯','',''],['普萘洛尔','',''],['普西','',''],['普调','',''],['普贤','',''],['普贤菩萨','',''],['普赛','',''],['普选','',''],['普选权','',''],['普通','',''],['普通中学','',''],['普通人','',''],['普通名词','',''],['普通心理学','',''],['普通教育','',''],['普通民众','',''],['普通法','',''],['普通老百姓','',''],['普通股','',''],['普通角闪石','',''],['普通话','',''],['普通赤杨','',''],['普通车','',''],['普通问题','',''],['普通高等学校招生全国统一考试','',''],['普遍','',''],['普遍化','',''],['普遍存在','',''],['普遍性','',''],['普遍性假设','',''],['普遍意义','',''],['普遍推广','',''],['普遍理论','',''],['普遍真理','',''],['普遍行','',''],['普遍规律','',''],['普遍认为','',''],['普里什蒂纳','',''],['普里切特','',''],['普陀','',''],['普陀山','',''],['普降','',''],['普降喜雨','',''],['普降大雨','',''],['普降瑞雪','',''],['普雷克斯流程','',''],['普雷斯堡','',''],['普雷斯顿','',''],['普鲁东','',''],['普鲁东主义','',''],['普鲁卡因','',''],['普鲁士','',''],['普鲁士人','',''],['普鲁斯特','',''],['景东','',''],['景东县','',''],['景从云集','',''],['景仰','',''],['景像','',''],['景况','',''],['景区','',''],['景天','',''],['景宁','',''],['景宁县','',''],['景宁畲乡','',''],['景山','',''],['景山公园','',''],['景慕','',''],['景教','',''],['景星凤皇','',''],['景星庆云','',''],['景星麟凤','',''],['景气','',''],['景泰蓝','',''],['景深','',''],['景点','',''],['景片','',''],['景物','',''],['景福宫','',''],['景美','',''],['景致','',''],['景色','',''],['景观','',''],['景观设计','',''],['景谷','',''],['景谷县','',''],['景象','',''],['景遇','',''],['景颇','',''],['晴云秋月','',''],['晴天','',''],['晴天霹雳','',''],['晴好','',''],['晴暖','',''],['晴朗','',''],['晴毛','',''],['晴空','',''],['晴空万里','',''],['晴纶','',''],['晴转多云','',''],['晴雨','',''],['晴雨表','',''],['晶亮','',''],['晶体','',''],['晶体三极管','',''],['晶体二极管','',''],['晶体振荡器','',''],['晶体点阵','',''],['晶体管','',''],['晶体管收音机','',''],['晶体结构','',''],['晶光','',''],['晶内偏析','',''],['晶化','',''],['晶圆','',''],['晶岩','',''],['晶明','',''],['晶晶','',''],['晶核','',''],['晶格','',''],['晶片','',''],['晶状','',''],['晶状体','',''],['晶石','',''],['晶硅','',''],['晶硅棒','',''],['晶粒','',''],['晶系','',''],['晶胞','',''],['晶莹','',''],['晶质','',''],['晶轴','',''],['晶面','',''],['智人','',''],['智体','',''],['智利人','',''],['智利硝石','',''],['智力','',''],['智力年龄','',''],['智力开发','',''],['智力投资','',''],['智力测验','',''],['智力竞赛','',''],['智勇','',''],['智勇兼全','',''],['智勇双全','',''],['智取','',''],['智商','',''],['智囊','',''],['智囊团','',''],['智囊机构','',''],['智圆行方','',''],['智均力敌','',''],['智多星','',''],['智小言大','',''],['智小谋大','',''],['智尽能索','',''],['智巧','',''],['智库','',''],['智性','',''],['智愚','',''],['智慧','',''],['智慧产权','',''],['智慧财产权','',''],['智慧齿','',''],['智昏','',''],['智术','',''],['智牙','',''],['智珠在握','',''],['智略','',''],['智神星','',''],['智穷','',''],['智者','',''],['智者千虑','',''],['智者千虑必有一失','',''],['智者派','',''],['智者见智','',''],['智育','',''],['智胜','',''],['智能','',''],['智能卡','',''],['智能大楼','',''],['智能手机','',''],['智能设计','',''],['智能障碍','',''],['智能补充','',''],['智能补全','',''],['智虑','',''],['智识','',''],['智谋','',''],['智谋过人','',''],['智障','',''],['智障人士','',''],['智顗','',''],['智齿','',''],['晾干','',''],['晾晒','',''],['晾衣','',''],['晾衣夹','',''],['暂不','',''],['暂且','',''],['暂予','',''],['暂于','',''],['暂付','',''],['暂代','',''],['暂住','',''],['暂住证','',''],['暂作','',''],['暂候','',''],['暂借','',''],['暂停','',''],['暂免','',''],['暂减','',''],['暂别','',''],['暂劳永逸','',''],['暂告','',''],['暂垫','',''],['暂存','',''],['暂存器','',''],['暂定','',''],['暂居','',''],['暂延','',''],['暂态','',''],['暂息','',''],['暂扣','',''],['暂按','',''],['暂搁','',''],['暂收','',''],['暂时','',''],['暂时性','',''],['暂星','',''],['暂欠','',''],['暂测','',''],['暂牙','',''],['暂用','',''],['暂由','',''],['暂留','',''],['暂短','',''],['暂离','',''],['暂缓','',''],['暂缺','',''],['暂行','',''],['暂行办法','',''],['暂行规定','',''],['暄暖','',''],['暄腾','',''],['暄闹','',''],['暇日','',''],['暇时','',''],['暇疵','',''],['暌违','',''],['暑促','',''],['暑假','',''],['暑天','',''],['暑往寒来','',''],['暑期','',''],['暑期学校','',''],['暑来寒往','',''],['暑气','',''],['暑温','',''],['暑热','',''],['暑瘟','',''],['暖人','',''],['暖人心房','',''],['暖人肺腑','',''],['暖化','',''],['暖和','',''],['暖壶','',''],['暖室','',''],['暖寿','',''],['暖巢管家','',''],['暖帘','',''],['暖房','',''],['暖手','',''],['暖暖','',''],['暖暖区','',''],['暖气','',''],['暖气团','',''],['暖气机','',''],['暖气炉','',''],['暖气片','',''],['暖水瓶','',''],['暖洋洋','',''],['暖流','',''],['暖炉','',''],['暖烘','',''],['暖烘烘','',''],['暖热','',''],['暖瓶','',''],['暖色','',''],['暖融融','',''],['暖衣','',''],['暖衣饱食','',''],['暖袖','',''],['暖调','',''],['暖身','',''],['暖酒','',''],['暖锋','',''],['暖阁','',''],['暖风','',''],['暖风机','',''],['暗下决心','',''],['暗中','',''],['暗中参与','',''],['暗中摸索','',''],['暗中操纵','',''],['暗中活动','',''],['暗中监视','',''],['暗中破坏','',''],['暗事','',''],['暗亏','',''],['暗井','',''],['暗伤','',''],['暗光','',''],['暗光鸟','',''],['暗公鸟','',''],['暗取','',''],['暗号','',''],['暗合','',''],['暗含','',''],['暗喜','',''],['暗喻','',''],['暗器','',''],['暗地','',''],['暗地里','',''],['暗场','',''],['暗坝','',''],['暗堡','',''],['暗墓','',''],['暗处','',''],['暗娼','',''],['暗室','',''],['暗室亏心','',''],['暗室私心','',''],['暗室逢灯','',''],['暗害','',''],['暗察明访','',''],['暗射','',''],['暗射地图','',''],['暗帐','',''],['暗度','',''],['暗度陈仓','',''],['暗弱','',''],['暗影','',''],['暗恋','',''],['暗想','',''],['暗房','',''],['暗指','',''],['暗探','',''],['暗敷','',''],['暗斗','',''],['暗无天日','',''],['暗星云','',''],['暗昧','',''],['暗暗','',''],['暗杀','',''],['暗杀活动','',''],['暗楼子','',''],['暗沟','',''],['暗河','',''],['暗泣','',''],['暗流','',''],['暗淡','',''],['暗渠','',''],['暗渡陈仓','',''],['暗滞','',''],['暗滩','',''],['暗潮','',''],['暗灰色','',''],['暗点','',''],['暗然失色','',''],['暗煅','',''],['暗疔','',''],['暗疾','',''],['暗的','',''],['暗盒','',''],['暗盘','',''],['暗码','',''],['暗礁','',''],['暗示','',''],['暗笑','',''],['暗算','',''],['暗箭','',''],['暗箭中人','',''],['暗箭伤人','',''],['暗箭明枪','',''],['暗箭罪难防','',''],['暗箭难防','',''],['暗箱','',''],['暗箱操作','',''],['暗紫色','',''],['暗红','',''],['暗线','',''],['暗线光谱','',''],['暗经','',''],['暗结','',''],['暗自','',''],['暗自思量','',''],['暗自欢喜','',''],['暗色','',''],['暗花','',''],['暗花儿','',''],['暗蓝','',''],['暗藏','',''],['暗补','',''],['暗袋','',''],['暗褐色','',''],['暗视','',''],['暗计','',''],['暗记','',''],['暗记于心','',''],['暗记儿','',''],['暗讽','',''],['暗访','',''],['暗语','',''],['暗转','',''],['暗送','',''],['暗送秋波','',''],['暗适应','',''],['暗道','',''],['暗销','',''],['暗锁','',''],['暗间','',''],['暗间儿','',''],['暗防','',''],['暗降','',''],['暗香','',''],['暗香疏影','',''],['暗鹭','',''],['暡曚','',''],['暧昧','',''],['暧昧关系','',''],['暧暧','',''],['暨南大学','',''],['暨大','',''],['暮云亲舍','',''],['暮去朝来','',''],['暮史朝经','',''],['暮后','',''],['暮四朝三','',''],['暮岁','',''],['暮年','',''],['暮思朝想','',''],['暮春','',''],['暮景','',''],['暮景桑榆','',''],['暮景残光','',''],['暮暮朝朝','',''],['暮更','',''],['暮死','',''],['暮气','',''],['暮气朦胧','',''],['暮生','',''],['暮生儿','',''],['暮礼晨参','',''],['暮色','',''],['暮色苍茫','',''],['暮虢朝虞','',''],['暮雨朝云','',''],['暮霭','',''],['暮鼓晨钟','',''],['暮龄','',''],['暴举','',''],['暴乱','',''],['暴光','',''],['暴内陵外','',''],['暴利','',''],['暴利税','',''],['暴力','',''],['暴力主义','',''],['暴力事件','',''],['暴力手段','',''],['暴力法','',''],['暴力犯罪','',''],['暴力行为','',''],['暴力行动','',''],['暴动','',''],['暴动队','',''],['暴卒','',''],['暴发','',''],['暴发户','',''],['暴吏','',''],['暴君','',''],['暴君政治','',''],['暴增','',''],['暴客','',''],['暴富','',''],['暴徒','',''],['暴怒','',''],['暴戾','',''],['暴戾恣睢','',''],['暴政','',''],['暴敛','',''],['暴晒','',''],['暴死','',''],['暴殄天物','',''],['暴毙','',''],['暴民','',''],['暴民政治','',''],['暴汉','',''],['暴洪','',''],['暴涨','',''],['暴涨暴跌','',''],['暴烈','',''],['暴热','',''],['暴燥','',''],['暴牙','',''],['暴病','',''],['暴眼','',''],['暴突','',''],['暴笑','',''],['暴虎冯河','',''],['暴虐','',''],['暴虐无道','',''],['暴行','',''],['暴裂','',''],['暴跌','',''],['暴跳','',''],['暴跳如雷','',''],['暴躁','',''],['暴躁如雷','',''],['暴雨','',''],['暴雨成灾','',''],['暴雷','',''],['暴露','',''],['暴露文学','',''],['暴露无遗','',''],['暴露目标','',''],['暴风','',''],['暴风雨','',''],['暴风雨般','',''],['暴风雪','',''],['暴风骤雨','',''],['暴食','',''],['暴食暴饮','',''],['暴饮','',''],['暴饮暴食','',''],['暴龙','',''],['暴龙属','',''],['暴龙科','',''],['暹罗','',''],['暹罗语','',''],['暹逻','',''],['暾暾','',''],['暾欲谷','',''],['曙光','',''],['曙后孤星','',''],['曙后星孤','',''],['曙目','',''],['曙色','',''],['曝光','',''],['曝光表','',''],['曝晒','',''],['曝气','',''],['曝露','',''],['曝鳃龙门','',''],['曱甴','',''],['曲交','',''],['曲光','',''],['曲别针','',''],['曲剧','',''],['曲卷','',''],['曲号','',''],['曲品','',''],['曲奇','',''],['曲子','',''],['曲学阿世','',''],['曲射炮','',''],['曲尺','',''],['曲尺楼梯','',''],['曲尽','',''],['曲尽人情','',''],['曲尽其妙','',''],['曲度','',''],['曲式','',''],['曲张','',''],['曲径','',''],['曲径通幽','',''],['曲意','',''],['曲意俯就','',''],['曲意逢迎','',''],['曲折','',''],['曲折处','',''],['曲曲弯弯','',''],['曲曲折折','',''],['曲柄','',''],['曲柄钻','',''],['曲柳','',''],['曲棍','',''],['曲棍球','',''],['曲水流觞','',''],['曲江','',''],['曲池穴','',''],['曲牌','',''],['曲率','',''],['曲率向量','',''],['曲目','',''],['曲直','',''],['曲种','',''],['曲突','',''],['曲突徙薪','',''],['曲笔','',''],['曲笛','',''],['曲线','',''],['曲线图','',''],['曲线拟合','',''],['曲线板','',''],['曲线球','',''],['曲线美','',''],['曲线论','',''],['曲终','',''],['曲终奏雅','',''],['曲绕','',''],['曲肱而枕','',''],['曲膝','',''],['曲膝者','',''],['曲艺','',''],['曲菌','',''],['曲蟮','',''],['曲角','',''],['曲解','',''],['曲调','',''],['曲谱','',''],['曲轴','',''],['曲酒','',''],['曲里拐弯','',''],['曲针','',''],['曲阜孔庙','',''],['曲霉','',''],['曲霉毒素','',''],['曲靖地区','',''],['曲面','',''],['曲面论','',''],['曲颈瓶','',''],['曲颈甑','',''],['曲风','',''],['曲香','',''],['曲高','',''],['曲高和寡','',''],['曳光','',''],['曳光弹','',''],['曳尾泥涂','',''],['曳尾涂中','',''],['曳引','',''],['曳引机','',''],['曳影','',''],['曳步','',''],['曳用','',''],['曳裾王门','',''],['更上一层楼','',''],['更不待言','',''],['更不待说','',''],['更为','',''],['更人','',''],['更仆难数','',''],['更代','',''],['更佳','',''],['更其','',''],['更加','',''],['更动','',''],['更卒','',''],['更名','',''],['更名改姓','',''],['更坏','',''],['更多','',''],['更多的','',''],['更夫','',''],['更好','',''],['更强','',''],['更快','',''],['更始','',''],['更定','',''],['更尽一步','',''],['更属不易','',''],['更年','',''],['更年期','',''],['更张','',''],['更弦易张','',''],['更待何时','',''],['更恶化','',''],['更换','',''],['更换者','',''],['更改','',''],['更改者','',''],['更新','',''],['更新世','',''],['更新换代','',''],['更新版','',''],['更暗','',''],['更替','',''],['更有甚者','',''],['更楼','',''],['更次','',''],['更正','',''],['更深','',''],['更深人静','',''],['更深夜静','',''],['更漏','',''],['更生','',''],['更番','',''],['更端','',''],['更胜一筹','',''],['更衣','',''],['更衣室','',''],['更要','',''],['更进一步','',''],['更进一竿','',''],['更迭','',''],['更递','',''],['更长梦短','',''],['更长漏永','',''],['更阑','',''],['更阑人静','',''],['更高性能','',''],['更鼓','',''],['曹不兴','',''],['曹丕','',''],['曹余章','',''],['曹冲','',''],['曹刚川','',''],['曹州之战','',''],['曹操','',''],['曹植','',''],['曹汝霖','',''],['曹白鱼','',''],['曹社之谋','',''],['曹禺','',''],['曹锟','',''],['曹雪芹','',''],['曹靖华','',''],['曹魏','',''],['曼切斯特','',''],['曼哈坦','',''],['曼哈顿','',''],['曼哈顿区','',''],['曼城','',''],['曼城队','',''],['曼声','',''],['曼妙','',''],['曼妥思','',''],['曼岛','',''],['曼延','',''],['曼彻斯特','',''],['曼彻斯特编码','',''],['曼德勒','',''],['曼德拉','',''],['曼德琳','',''],['曼海姆','',''],['曼联','',''],['曼联球迷','',''],['曼联队','',''],['曼苏尔','',''],['曼荷莲女子学院','',''],['曼荼罗','',''],['曼谷','',''],['曼达尔','',''],['曼陀林','',''],['曼陀琳','',''],['曼陀罗','',''],['曼陀草','',''],['曼陀铃','',''],['曾与','',''],['曾为','',''],['曾予','',''],['曾以','',''],['曾任','',''],['曾使','',''],['曾做','',''],['曾几何时','',''],['曾则','',''],['曾到','',''],['曾参杀人','',''],['曾向','',''],['曾和','',''],['曾国藩','',''],['曾在','',''],['曾外祖母','',''],['曾外祖父','',''],['曾孙','',''],['曾孙女','',''],['曾孝谷','',''],['曾对','',''],['曾将','',''],['曾巩','',''],['曾庆红','',''],['曾无与二','',''],['曾是','',''],['曾有','',''],['曾朴','',''],['曾母投杼','',''],['曾用','',''],['曾用名','',''],['曾祖','',''],['曾祖母','',''],['曾祖父','',''],['曾祖父母','',''],['曾繁仁','',''],['曾纪泽','',''],['曾经','',''],['曾经沧海','',''],['曾经沧海难为水','',''],['曾给','',''],['曾荫权','',''],['曾被','',''],['曾都','',''],['曾金燕','',''],['曾问','',''],['替为','',''],['替人','',''],['替他','',''],['替代','',''],['替代品','',''],['替代性','',''],['替代燃料','',''],['替代物','',''],['替古人担忧','',''],['替古人耽忧','',''],['替品','',''],['替天行道','',''],['替她','',''],['替工','',''],['替您','',''],['替手','',''],['替拿','',''],['替换','',''],['替换物','',''],['替死','',''],['替死鬼','',''],['替派','',''],['替物','',''],['替班','',''],['替班儿','',''],['替续器','',''],['替罪','',''],['替罪人','',''],['替罪羊','',''],['替罪羔羊','',''],['替补','',''],['替角','',''],['替角儿','',''],['替身','',''],['替身演员','',''],['最上','',''],['最上等','',''],['最上策','',''],['最下','',''],['最下方','',''],['最下部','',''],['最不','',''],['最丑','',''],['最丑恶','',''],['最东部','',''],['最严厉','',''],['最中间','',''],['最为','',''],['最主要','',''],['最久','',''],['最乖','',''],['最亮','',''],['最亲近','',''],['最优','',''],['最优化','',''],['最优性','',''],['最低','',''],['最低分','',''],['最低化','',''],['最低水平','',''],['最低温度','',''],['最低潮','',''],['最低点','',''],['最低纲领','',''],['最低谷','',''],['最低限度','',''],['最低限度理论','',''],['最低音','',''],['最低额','',''],['最佳','',''],['最佳值','',''],['最佳利益','',''],['最佳化','',''],['最佳阵容','',''],['最便宜','',''],['最保险','',''],['最值','',''],['最先','',''],['最内部','',''],['最冷','',''],['最初','',''],['最前','',''],['最前线','',''],['最前部','',''],['最北','',''],['最南','',''],['最南端','',''],['最厚','',''],['最受','',''],['最后','',''],['最后一天','',''],['最后决议','',''],['最后头','',''],['最后方','',''],['最后晚餐','',''],['最后期限','',''],['最后的晚餐','',''],['最后通牒','',''],['最后面','',''],['最善','',''],['最喜','',''],['最喜爱','',''],['最坏','',''],['最外','',''],['最外边','',''],['最外面','',''],['最多','',''],['最大','',''],['最大值','',''],['最大公因子','',''],['最大公约数','',''],['最大化','',''],['最大数','',''],['最大速率','',''],['最大限度','',''],['最大熵','',''],['最奸','',''],['最好','',''],['最好成绩','',''],['最密堆积','',''],['最小','',''],['最小二乘','',''],['最小值','',''],['最小公倍数','',''],['最小公分母','',''],['最小化','',''],['最少','',''],['最尖','',''],['最差','',''],['最年长','',''],['最年青','',''],['最底','',''],['最底下','',''],['最底层','',''],['最弱','',''],['最强','',''],['最强音','',''],['最火','',''],['最快','',''],['最性感','',''],['最恨','',''],['最恶劣','',''],['最惠国','',''],['最惠国待遇','',''],['最慢','',''],['最接近','',''],['最新','',''],['最新式','',''],['最新消息','',''],['最新版','',''],['最新近','',''],['最旧','',''],['最早','',''],['最易','',''],['最晚','',''],['最暗','',''],['最最','',''],['最有','',''],['最末','',''],['最末端','',''],['最深','',''],['最深入','',''],['最深奥','',''],['最热','',''],['最爱','',''],['最理想','',''],['最甚','',''],['最畅销','',''],['最短','',''],['最硬','',''],['最穷','',''],['最笨','',''],['最简单','',''],['最糟','',''],['最细','',''],['最终','',''],['最绝','',''],['最老','',''],['最聪明','',''],['最软','',''],['最轻','',''],['最近','',''],['最远','',''],['最远方','',''],['最远点','',''],['最迟','',''],['最适','',''],['最适宜','',''],['最适度','',''],['最重要','',''],['最精彩','',''],['最长','',''],['最难','',''],['最高','',''],['最高人民检察院','',''],['最高人民法院','',''],['最高奖','',''],['最高层','',''],['最高峰','',''],['最高工资限额','',''],['最高标准','',''],['最高气温','',''],['最高水平','',''],['最高法院','',''],['最高温度','',''],['最高潮','',''],['最高点','',''],['最高等','',''],['最高级','',''],['最高纪录','',''],['最高纲领','',''],['最高限价','',''],['最高限额','',''],['最高音','',''],['最黑','',''],['月下','',''],['月下星前','',''],['月下老人','',''],['月下花前','',''],['月下风前','',''],['月中','',''],['月中折桂','',''],['月书赤绳','',''],['月事','',''],['月亏','',''],['月产','',''],['月产量','',''],['月亮','',''],['月亮似','',''],['月亮女神','',''],['月亮门儿','',''],['月令','',''],['月份','',''],['月份会议','',''],['月份牌','',''],['月供','',''],['月俸','',''],['月值年灾','',''],['月偏食','',''],['月光','',''],['月光如水','',''],['月光族','',''],['月光期','',''],['月光石','',''],['月光花','',''],['月光计划','',''],['月光隐遁','',''],['月入','',''],['月全食','',''],['月内','',''],['月出','',''],['月分','',''],['月刊','',''],['月初','',''],['月利','',''],['月前','',''],['月半','',''],['月华','',''],['月历','',''],['月台','',''],['月台票','',''],['月后','',''],['月圆','',''],['月地云阶','',''],['月坑','',''],['月坛','',''],['月城','',''],['月夕','',''],['月夕花朝','',''],['月夜','',''],['月夜花朝','',''],['月头儿','',''],['月女神','',''],['月娘','',''],['月婆子','',''],['月嫂','',''],['月子','',''],['月子病','',''],['月孛','',''],['月季','',''],['月季花','',''],['月宫','',''],['月尾','',''],['月岩','',''],['月工','',''],['月工资','',''],['月底','',''],['月度','',''],['月异','',''],['月形','',''],['月径','',''],['月息','',''],['月报','',''],['月支','',''],['月收','',''],['月收入','',''],['月数','',''],['月日','',''],['月明','',''],['月明如昼','',''],['月明星稀','',''],['月晕','',''],['月晕而风础润而雨','',''],['月曜日','',''],['月月','',''],['月月红','',''],['月朔','',''],['月朗风清','',''],['月未','',''],['月末','',''],['月杪','',''],['月桂','',''],['月桂冠','',''],['月桂叶','',''],['月桂树','',''],['月桂树叶','',''],['月氏','',''],['月氏人','',''],['月海','',''],['月清','',''],['月湖','',''],['月满则亏','',''],['月满花香','',''],['月牙','',''],['月牙形','',''],['月球','',''],['月球仪','',''],['月球车','',''],['月理','',''],['月理学','',''],['月琴','',''],['月白','',''],['月白风清','',''],['月盈','',''],['月盈则食','',''],['月盲症','',''],['月相','',''],['月眉星眼','',''],['月石','',''],['月神','',''],['月票','',''],['月租','',''],['月终','',''],['月经','',''],['月经垫','',''],['月经带','',''],['月经期','',''],['月经棉栓','',''],['月结','',''],['月缺','',''],['月缺花残','',''],['月缺难圆','',''],['月老','',''],['月舱','',''],['月色','',''],['月芽','',''],['月落','',''],['月落乌啼','',''],['月落参横','',''],['月落星沉','',''],['月蓝','',''],['月薪','',''],['月蚀','',''],['月计','',''],['月评','',''],['月貌花容','',''],['月貌花庞','',''],['月费','',''],['月轮','',''],['月过中秋','',''],['月钱','',''],['月锻季炼','',''],['月长石','',''],['月门','',''],['月间','',''],['月阑','',''],['月面','',''],['月食','',''],['月饼','',''],['月饼盒','',''],['月饼袋','',''],['月鳢','',''],['月黑','',''],['月黑天','',''],['月黑风高','',''],['月龄','',''],['有可能','',''],['有一个','',''],['有一些','',''],['有一分热','',''],['发一分光','',''],['有一句没一句','',''],['有一天','',''],['有一套','',''],['有一无二','',''],['有一次','',''],['有丝分裂','',''],['有两下子','',''],['有中国特色','',''],['有为','',''],['有主见','',''],['有义务','',''],['有过之而无不及','',''],['有了','',''],['有了胎','',''],['有争议','',''],['有事','',''],['有些','',''],['有些人','',''],['有人缘','',''],['有仇','',''],['有令不行','',''],['有令即行','',''],['有价证券','',''],['有份量','',''],['有伤','',''],['有伤风化','',''],['有何不可','',''],['有何特长','',''],['有偿','',''],['有偿使用','',''],['有偿服务','',''],['有偿转让','',''],['有关','',''],['有关单位','',''],['有关各方','',''],['有关当局','',''],['有关政策','',''],['有关方面','',''],['有关系','',''],['有关规定','',''],['有关部门','',''],['有关问题','',''],['有其名而无其实','',''],['有其父必有其子','',''],['有典有则','',''],['有凭有据','',''],['有则改之','',''],['无则加勉','',''],['有创见','',''],['有利','',''],['有利于','',''],['有利可图','',''],['有利时机','',''],['有利有弊','',''],['有利条件','',''],['有别','',''],['有别于','',''],['有力','',''],['有力措施','',''],['有力量','',''],['有功之臣','',''],['有功人员','',''],['有功绩','',''],['有加无减','',''],['有加无已','',''],['有助','',''],['有助于','',''],['有劲','',''],['有劳','',''],['有劳了','',''],['有劳得奖','',''],['有劳有逸','',''],['有势','',''],['有势力','',''],['有勇无谋','',''],['有勇有谋','',''],['有勇气','',''],['有区别','',''],['有危险','',''],['有反应','',''],['有变化','',''],['有口无心','',''],['有口无行','',''],['有口皆碑','',''],['有口难分','',''],['有口难言','',''],['有口难辩','',''],['有史以来','',''],['有同情心','',''],['有名','',''],['有名亡实','',''],['有名无实','',''],['有名气','',''],['有名称','',''],['有后跟','',''],['有否','',''],['有含意','',''],['有含蓄','',''],['有启发','',''],['有味','',''],['有味道','',''],['有品味','',''],['有品德','',''],['有品格','',''],['有啥','',''],['有喜','',''],['有嘴无心','',''],['有嘴没舌','',''],['有噪声','',''],['有回响','',''],['有围墙','',''],['有国难投','',''],['有地位','',''],['有型','',''],['有塑性','',''],['有增无减','',''],['有增无已','',''],['有增无损','',''],['有声','',''],['有声书','',''],['有声有色','',''],['有声望','',''],['有声读物','',''],['有备无患','',''],['有备而来','',''],['有天份','',''],['有天分','',''],['有天无日','',''],['有天没日','',''],['有天赋','',''],['有夫之妇','',''],['有失','',''],['有失厚道','',''],['有失身份','',''],['有头无尾','',''],['有头有尾','',''],['有头有脑','',''],['有头有脸','',''],['有头盖','',''],['有头脑','',''],['有头衔','',''],['有奖储蓄','',''],['有奖征文','',''],['有奖活动','',''],['有奖销售','',''],['有女怀春','',''],['有好','',''],['有好处','',''],['有好奇心','',''],['有如','',''],['有始无终','',''],['有始有卒','',''],['有始有终','',''],['有威严','',''],['有威信','',''],['有嫌疑','',''],['有子存焉','',''],['有孔虫','',''],['有学','',''],['有学位','',''],['有学问','',''],['有定论','',''],['有宝何必人前夸','',''],['有实质','',''],['有客','',''],['有害','',''],['有害无利','',''],['有害无益','',''],['有害物','',''],['有害物质','',''],['有家难奔','',''],['有小','',''],['有小节','',''],['有小面','',''],['有局','',''],['有居民','',''],['有屈无伸','',''],['有展性','',''],['有巢氏','',''],['有差错','',''],['有希望','',''],['有带扣','',''],['有帮助','',''],['有年','',''],['有年头','',''],['有幸','',''],['有序','',''],['有序化','',''],['有底','',''],['有度','',''],['有异','',''],['有弊有利','',''],['有张有弛','',''],['有弱点','',''],['有弹性','',''],['有形','',''],['有形损耗','',''],['有形贸易','',''],['有形资产','',''],['有形资本','',''],['有影','',''],['有影响','',''],['有往','',''],['有征无战','',''],['有待','',''],['有待于','',''],['有得','',''],['有得一比','',''],['有得有失','',''],['有微风','',''],['有德行','',''],['有心','',''],['有心人','',''],['有心无力','',''],['有心眼','',''],['有志','',''],['有志不在年高','',''],['有志之士','',''],['有志之者事竟成','',''],['有志于','',''],['有志于此','',''],['有志气','',''],['有志竟成','',''],['有志者事竟成','',''],['有志难酬','',''],['有思','',''],['有性','',''],['有性杂交','',''],['有性生殖','',''],['有恃','',''],['有恃无恐','',''],['有恒','',''],['有息','',''],['有恶意','',''],['有恶臭','',''],['有悖于','',''],['有情','',''],['有情人','',''],['有情人终成眷属','',''],['有愁容','',''],['有意','',''],['有意义','',''],['有意图','',''],['有意志','',''],['有意思','',''],['有意无意','',''],['有意栽花花不发','',''],['有意识','',''],['有感于','',''],['有感而发','',''],['有成','',''],['有成就','',''],['有成绩','',''],['有戒心','',''],['有所','',''],['有所不同','',''],['有所准备','',''],['有所创造','',''],['有所前进','',''],['有所区别','',''],['有所发展','',''],['有所增加','',''],['有所得必有所失','',''],['有所提高','',''],['有所改善','',''],['有所突破','',''],['有所致力','',''],['有手有脚','',''],['有手段','',''],['有才','',''],['有才华','',''],['有才干','',''],['有才无命','',''],['有才能','',''],['有技能','',''],['有把握','',''],['有抑扬','',''],['有折痕','',''],['有报酬','',''],['有指','',''],['有指望','',''],['有损','',''],['有损于','',''],['有损压缩','',''],['有损无益','',''],['有接缝','',''],['有收获','',''],['有攻击性','',''],['有效','',''],['有效值','',''],['有效分蘖','',''],['有效力','',''],['有效功率','',''],['有效地','',''],['有效性','',''],['有效措施','',''],['有效数','',''],['有效数字','',''],['有效期','',''],['有效期内','',''],['有效果','',''],['有效氯','',''],['有效率','',''],['有效负载','',''],['有效验','',''],['有敌意','',''],['有救','',''],['有教养','',''],['有教无类','',''],['有教无类法','',''],['有教益','',''],['有数','',''],['有文化','',''],['有斑点','',''],['有斑痕','',''],['有斑纹','',''],['有料','',''],['有新意','',''],['有方','',''],['有方法','',''],['有旋律','',''],['有无','',''],['有无必要','',''],['有无相通','',''],['有日子','',''],['有旧','',''],['有时','',''],['有时侯','',''],['有时候','',''],['有智力','',''],['有智慧','',''],['有智虑','',''],['有智谋','',''],['有有','',''],['有望','',''],['有朝','',''],['有朝一日','',''],['有朝气','',''],['有期徒刑','',''],['有期限','',''],['有木有','',''],['有木栅','',''],['有木纹','',''],['有角','',''],['有机','',''],['有机体','',''],['有机分子','',''],['有机化合物','',''],['有机化学','',''],['有机可乘','',''],['有机合成','',''],['有机性','',''],['有机染料','',''],['有机氮','',''],['有机物','',''],['有机玻璃','',''],['有机硅','',''],['有机磷','',''],['有机磷农药中毒','',''],['有机磷毒剂','',''],['有机磷酸酯类','',''],['有机肥料','',''],['有机质','',''],['有杂质','',''],['有权','',''],['有权力','',''],['有权势者','',''],['有权威','',''],['有权有势','',''],['有条','',''],['有条不紊','',''],['有条件','',''],['有条有理','',''],['有条有理地','',''],['有条理','',''],['有条纹','',''],['有来历','',''],['有板有眼','',''],['有枝有叶','',''],['有枝添叶','',''],['有枪眼','',''],['有柄杯','',''],['有染','',''],['有标号','',''],['有样','',''],['有核国家','',''],['有根据','',''],['有根有据','',''],['有格式','',''],['有案可查','',''],['有棱有角','',''],['有欠','',''],['有次序','',''],['有欲','',''],['有歉意','',''],['有死无二','',''],['有毅力','',''],['有毒','',''],['有毒性','',''],['有毛','',''],['有毛病','',''],['有气','',''],['有气味','',''],['有气孔','',''],['有气无力','',''],['有气没力','',''],['有气派','',''],['有气质','',''],['有气音','',''],['有氧健身操','',''],['有氧操','',''],['有氧运动','',''],['有水','',''],['有求','',''],['有求于','',''],['有求于人','',''],['有求必应','',''],['有求斯应','',''],['有污点','',''],['有沉有浮','',''],['有没有','',''],['有治','',''],['有法不依','',''],['有法可依','',''],['有法必依','',''],['有波纹','',''],['有活力','',''],['有浓味','',''],['有消息说','',''],['有渣滓','',''],['有湿气','',''],['有滋味','',''],['有滋有味','',''],['有漏洞','',''],['有潜力','',''],['有灵魂','',''],['有点','',''],['有点儿','',''],['有点冷','',''],['有点咸','',''],['有点小','',''],['有点旧','',''],['有点甜','',''],['有点软','',''],['有烟煤','',''],['有物','',''],['有特权','',''],['有特色','',''],['有犯无隐','',''],['有理','',''],['有理函数','',''],['有理分式','',''],['有理式','',''],['有理性','',''],['有理想','',''],['有理数','',''],['有理数域','',''],['有理数集','',''],['有理方程','',''],['有理无情','',''],['有理有据','',''],['有理由','',''],['有理解','',''],['有生之年','',''],['有生以来','',''],['有生力量','',''],['有生命','',''],['有生气','',''],['有用','',''],['有用功','',''],['有用功率','',''],['有用性','',''],['有由','',''],['有电','',''],['有界','',''],['有界线','',''],['有界限','',''],['有疑义','',''],['有疑问','',''],['有疗效','',''],['有病','',''],['有病变','',''],['有病痛','',''],['有症状','',''],['有瘾','',''],['有瘾者','',''],['有百利而无一弊','',''],['有百害而无一利','',''],['有的','',''],['有的放矢','',''],['有的时候','',''],['有的是','',''],['有皮层','',''],['有皱纹','',''],['有益','',''],['有益于','',''],['有益处','',''],['有益无害','',''],['有盐味','',''],['有目共睹','',''],['有目共见','',''],['有目共赏','',''],['有目如盲','',''],['有目无睹','',''],['有目的','',''],['有盼儿','',''],['有眉目','',''],['有眼','',''],['有眼不识泰山','',''],['有眼光','',''],['有眼力','',''],['有眼如盲','',''],['有眼无珠','',''],['有着','',''],['有睫毛','',''],['有知','',''],['有知觉','',''],['有知识','',''],['有码','',''],['有磁力','',''],['有礼','',''],['有礼貌','',''],['有神','',''],['有神论','',''],['有神论者','',''],['有祸同当','',''],['有禁不止','',''],['有福','',''],['有福同享','',''],['有福相','',''],['有种','',''],['有秩序','',''],['有空','',''],['有突起','',''],['有章可循','',''],['有笑','',''],['有等级','',''],['有策略','',''],['有粉刺','',''],['有粘性','',''],['有精神','',''],['有精神病','',''],['有系统','',''],['有约','',''],['有约在先','',''],['有纪律','',''],['有线','',''],['有线广播','',''],['有线新闻网','',''],['有线电报','',''],['有线电视','',''],['有线电话','',''],['有线电通信','',''],['有组织','',''],['有细粒','',''],['有织纹','',''],['有织边','',''],['有终','',''],['有经验','',''],['有结果','',''],['有结节','',''],['有统计学意义','',''],['有缘','',''],['有缘无份','',''],['有缘无分','',''],['有缺点','',''],['有缺陷','',''],['有罪','',''],['有罪不罚','',''],['有罪性','',''],['有罪者','',''],['有罪过失','',''],['有翅难飞','',''],['有翼','',''],['有者','',''],['有耐久力','',''],['有耐心','',''],['有耐性','',''],['有职无权','',''],['有职有权','',''],['有联系','',''],['有胆','',''],['有胆有识','',''],['有胆量','',''],['有胡子','',''],['有能力','',''],['有脉纹','',''],['有脚书橱','',''],['有脚阳春','',''],['有脸','',''],['有自信','',''],['有良心','',''],['有色','',''],['有色人种','',''],['有色金属','',''],['有节','',''],['有节制','',''],['有节有度','',''],['有花边','',''],['有若','',''],['有苦味','',''],['有苦说不出','',''],['有苦难言','',''],['有荫影','',''],['有药性','',''],['有药效','',''],['有药瘾者','',''],['有营养','',''],['有薪水','',''],['有血有肉','',''],['有行','',''],['有行无市','',''],['有袖子','',''],['有裂痕','',''],['有裂缝','',''],['有见识','',''],['有规则','',''],['有规律','',''],['有觉悟','',''],['有言','',''],['有言在先','',''],['有计划','',''],['有记号','',''],['有识','',''],['有识之士','',''],['有诗意','',''],['有诗才','',''],['有话好说','',''],['有话要说','',''],['有说','',''],['有说有笑','',''],['有说服力','',''],['有请','',''],['有谓','',''],['有谱','',''],['有谱儿','',''],['有负于','',''],['有负债','',''],['有负载','',''],['有贡献','',''],['有财产','',''],['有责','',''],['有责任','',''],['有资格','',''],['有赖','',''],['有赖于','',''],['有起色','',''],['有趣','',''],['有趣味','',''],['有蹄动物','',''],['有蹄类','',''],['有轨','',''],['有轨电车','',''],['有轮子','',''],['有边儿','',''],['有过失','',''],['有这','',''],['有进取心','',''],['有进无退','',''],['有远而近','',''],['有远虑','',''],['有远见','',''],['有选举权','',''],['有选择','',''],['有道','',''],['有道具','',''],['有道德','',''],['有道是','',''],['有道理','',''],['有道辞典','',''],['有酒意','',''],['有酒窝','',''],['有酸味','',''],['有野心','',''],['有鉴于此','',''],['有钩绦虫','',''],['有钱','',''],['有钱人','',''],['有钱有势','',''],['有钱有闲','',''],['有钱能使鬼推磨','',''],['有销路','',''],['有错就改','',''],['有错必纠','',''],['有锯口','',''],['有门儿','',''],['有问题','',''],['有闻必录','',''],['有阳台','',''],['有阴影','',''],['有附文','',''],['有限','',''],['有限元','',''],['有限元法','',''],['有限公司','',''],['有限制','',''],['有限单元','',''],['有限君主制','',''],['有限战争','',''],['有限群','',''],['有限花序','',''],['有限集','',''],['有隙可乘','',''],['有难同当','',''],['有雄心','',''],['有雨','',''],['有零','',''],['有雾','',''],['有顶饰','',''],['有顷','',''],['有项','',''],['有预兆','',''],['有预谋','',''],['有颌','',''],['有颜色','',''],['有风','',''],['有风味','',''],['有风趣','',''],['有香味','',''],['有鬃毛','',''],['有鬼','',''],['有佛','',''],['有魄力','',''],['有魅力','',''],['有魔力','',''],['有魔术','',''],['有黏性','',''],['有齿轮','',''],['朊病毒','',''],['朋克','',''],['朋党','',''],['朋党政治','',''],['朋党比周','',''],['朋友','',''],['朋友们','',''],['朋友遍天下','',''],['朋只作奸','',''],['朋比为奸','',''],['朋辈','',''],['服下','',''],['服丧','',''],['服了','',''],['服事','',''],['服于','',''],['服于组织','',''],['服人','',''],['服从','',''],['服从分配','',''],['服从需要','',''],['服他灵','',''],['服低做小','',''],['服侍','',''],['服兵役','',''],['服冕乘轩','',''],['服刑','',''],['服刑者','',''],['服务','',''],['服务上门','',''],['服务业','',''],['服务于','',''],['服务到家','',''],['服务区','',''],['服务台','',''],['服务员','',''],['服务器','',''],['服务型','',''],['服务处','',''],['服务市场','',''],['服务广告协议','',''],['服务态度','',''],['服务性','',''],['服务性行业','',''],['服务所','',''],['服务提供商','',''],['服务提供者','',''],['服务机构','',''],['服务生','',''],['服务站','',''],['服务网','',''],['服务者','',''],['服务行业','',''],['服务规章','',''],['服务质量','',''],['服务费','',''],['服务部','',''],['服务队','',''],['服务项目','',''],['服完','',''],['服帖','',''],['服役','',''],['服役者','',''],['服服','',''],['服服帖帖','',''],['服毒','',''],['服气','',''],['服气吞露','',''],['服气餐霞','',''],['服水土','',''],['服法','',''],['服满','',''],['服理','',''],['服用','',''],['服罪','',''],['服老','',''],['服膺','',''],['服药','',''],['服药过量','',''],['服装','',''],['服装厂','',''],['服装商','',''],['服装秀','',''],['服贴','',''],['服输','',''],['服辩','',''],['服镇','',''],['服食','',''],['服饰','',''],['朔城','',''],['朔日','',''],['朔时空','',''],['朔月','',''],['朔望','',''],['朔望月','',''],['朔望潮','',''],['朔风','',''],['朔风凛冽','',''],['朕兆','',''],['朗吟','',''],['朗姆','',''],['朗姆酒','',''],['朗峰','',''],['朗文','',''],['朗朗','',''],['朗朗上口','',''],['朗照','',''],['朗生','',''],['朗语','',''],['朗诵','',''],['朗诵会','',''],['朗诵者','',''],['朗读','',''],['望不到','',''],['望不到边','',''],['望云之情','',''],['望京','',''],['望人','',''],['望其肩背','',''],['望其肩项','',''],['望其项背','',''],['望到','',''],['望厦条约','',''],['望去','',''],['望台','',''],['望外','',''],['望夫石','',''],['望子','',''],['望子成名','',''],['望子成才','',''],['望子成龙','',''],['望安','',''],['望安乡','',''],['望尘不及','',''],['望尘而拜','',''],['望尘莫及','',''],['望文生义','',''],['望断','',''],['望族','',''],['望日','',''],['望景','',''],['望月','',''],['望望','',''],['望杏瞻榆','',''],['望杏瞻蒲','',''],['望板','',''],['望梅止渴','',''],['望楼','',''],['望洋','',''],['望洋兴叹','',''],['望洋惊叹','',''],['望眼将穿','',''],['望眼欲穿','',''],['望着','',''],['望秋先零','',''],['望穿','',''],['望穿秋水','',''],['望而','',''],['望而兴叹','',''],['望而却步','',''],['望而生畏','',''],['望花','',''],['望衡对宇','',''],['望见','',''],['望角','',''],['望诊','',''],['望远','',''],['望远瞄准镜','',''],['望远镜','',''],['望远镜座','',''],['望门大嚼','',''],['望门寡','',''],['望门投止','',''],['望闻问切','',''],['望风','',''],['望风响应','',''],['望风承旨','',''],['望风披靡','',''],['望风捕影','',''],['望风瓦解','',''],['望风而走','',''],['望风而逃','',''],['望风而遁','',''],['望风而降','',''],['朝三暮四','',''],['朝上','',''],['朝下','',''],['朝下风','',''],['朝不保夕','',''],['朝不保暮','',''],['朝不及夕','',''],['朝不图夕','',''],['朝不虑夕','',''],['朝不谋夕','',''],['朝东','',''],['朝东暮西','',''],['朝中','',''],['朝中社','',''],['朝乾夕惕','',''],['朝云暮雨','',''],['朝他','',''],['朝代','',''],['朝令夕改','',''],['朝令暮改','',''],['朝兢夕惕','',''],['朝内','',''],['朝出夕改','',''],['朝前','',''],['朝劳动党','',''],['朝北','',''],['朝华夕秀','',''],['朝南','',''],['朝参暮礼','',''],['朝发夕至','',''],['朝右','',''],['朝后','',''],['朝向','',''],['朝四暮三','',''],['朝圣','',''],['朝圣者','',''],['朝夕','',''],['朝夕不倦','',''],['朝夕相处','',''],['朝外','',''],['朝天','',''],['朝奉','',''],['朝山','',''],['朝山进香','',''],['朝左','',''],['朝廷','',''],['朝思夕想','',''],['朝思夕计','',''],['朝思暮想','',''],['朝房','',''],['朝拜','',''],['朝拜圣山','',''],['朝政','',''],['朝族','',''],['朝日','',''],['朝日关系','',''],['朝日放送','',''],['朝日新闻','',''],['朝晖','',''],['朝暮','',''],['朝暾','',''],['朝更夕改','',''],['朝更暮改','',''],['朝服','',''],['朝朝','',''],['朝朝寒食夜夜元宵','',''],['朝朝暮暮','',''],['朝来暮去','',''],['朝核问题','',''],['朝梁暮晋','',''],['朝梁暮陈','',''],['朝欢暮乐','',''],['朝歌','',''],['朝歌夜弦','',''],['朝歌暮弦','',''],['朝歌镇','',''],['朝气','',''],['朝气蓬勃','',''],['朝永・振一郎','',''],['朝珠','',''],['朝生暮合','',''],['朝生暮死','',''],['朝着','',''],['朝秦暮楚','',''],['朝纲','',''],['朝经暮史','',''],['朝臣','',''],['朝花夕拾','',''],['朝荣夕悴','',''],['朝荣夕毙','',''],['朝荣暮落','',''],['朝菌','',''],['朝著','',''],['朝行夕改','',''],['朝西','',''],['朝西暮东','',''],['朝见','',''],['朝觐','',''],['朝贡','',''],['朝迁市变','',''],['朝过夕改','',''],['朝里','',''],['朝野','',''],['朝钟暮鼓','',''],['朝门','',''],['朝闻夕改','',''],['朝闻夕死','',''],['朝闻道夕死可矣','',''],['朝阳产业','',''],['朝阳地区','',''],['朝阳花','',''],['朝阳门','',''],['朝雨','',''],['朝霞','',''],['朝露','',''],['朝露暮霭','',''],['朝露溘至','',''],['朝韩','',''],['朝顶','',''],['朝饔夕飧','',''],['朝鲜中央新闻社','',''],['朝鲜中央通讯社','',''],['朝鲜人','',''],['朝鲜八道','',''],['朝鲜军队','',''],['朝鲜劳动党','',''],['朝鲜半岛','',''],['朝鲜太宗','',''],['朝鲜字母','',''],['朝鲜总督府','',''],['朝鲜战争','',''],['朝鲜文','',''],['朝鲜日报','',''],['朝鲜核谈','',''],['朝鲜民主主义人民共和国','',''],['朝鲜海峡','',''],['朝鲜祖国解放战争','',''],['朝鲜筝','',''],['朝鲜语','',''],['朝齑暮盐','',''],['期中','',''],['期中考','',''],['期于','',''],['期以','',''],['期会','',''],['期借','',''],['期内','',''],['期刊','',''],['期刊流通','',''],['期刊目录','',''],['期刊管理','',''],['期刊索引','',''],['期初','',''],['期前','',''],['期待','',''],['期律','',''],['期收','',''],['期攷','',''],['期数','',''],['期月有成','',''],['期望','',''],['期望中','',''],['期望值','',''],['期期','',''],['期期艾艾','',''],['期末','',''],['期末考','',''],['期权','',''],['期栏','',''],['期求','',''],['期汇','',''],['期满','',''],['期盼','',''],['期票','',''],['期约','',''],['期终','',''],['期考','',''],['期航','',''],['期船','',''],['期许','',''],['期货','',''],['期货合约','',''],['期货市场','',''],['期间','',''],['期限','',''],['期限内','',''],['期颐之寿','',''],['朦在鼓里','',''],['朦朦','',''],['朦的','',''],['朦胧','',''],['朦胧诗','',''],['木丛','',''],['木乃伊','',''],['木乃伊化','',''],['木人','',''],['木人石心','',''],['木偶','',''],['木偶剧','',''],['木偶戏','',''],['木偶片','',''],['木偶秀','',''],['木兰属','',''],['木兰科','',''],['木兰纲','',''],['木兰花','',''],['木制','',''],['木制品','',''],['木刻','',''],['木刻家','',''],['木刻水印','',''],['木刻画','',''],['木剑','',''],['木化石','',''],['木匠','',''],['木卡姆','',''],['木变石','',''],['木叶蝶','',''],['木吒','',''],['木器','',''],['木场','',''],['木块','',''],['木型','',''],['木垒','',''],['木垒县','',''],['木垫','',''],['木塞','',''],['木塞子','',''],['木壳','',''],['木夯','',''],['木头','',''],['木头人','',''],['木头木脑','',''],['木子美','',''],['木屋','',''],['木屐','',''],['木屑','',''],['木履','',''],['木工','',''],['木工师','',''],['木工术','',''],['木工艺','',''],['木已成舟','',''],['木巳成舟','',''],['木床','',''],['木底','',''],['木形灰心','',''],['木心石腹','',''],['木房','',''],['木拴','',''],['木排','',''],['木料','',''],['木星','',''],['木曜日','',''],['木本','',''],['木本植物','',''],['木本水源','',''],['木朽不雕','',''],['木杆','',''],['木材','',''],['木材场','',''],['木村','',''],['木条','',''],['木条箱','',''],['木板','',''],['木板画','',''],['木板路','',''],['木林','',''],['木架','',''],['木柱','',''],['木柴','',''],['木柴堆','',''],['木栅','',''],['木栅线','',''],['木栏','',''],['木栓','',''],['木栓层','',''],['木格措','',''],['木框','',''],['木桥','',''],['木桩','',''],['木桶','',''],['木梯','',''],['木梳','',''],['木棉','',''],['木棉树','',''],['木棉科','',''],['木棉花','',''],['木棍','',''],['木棒','',''],['木棚','',''],['木棺','',''],['木椅','',''],['木椆','',''],['木槌','',''],['木槿','',''],['木樨','',''],['木灰','',''],['木炭','',''],['木炭画','',''],['木焦油','',''],['木然','',''],['木片','',''],['木版','',''],['木版画','',''],['木牛','',''],['木犀','',''],['木犀肉','',''],['木状','',''],['木猴而冠','',''],['木球','',''],['木琴','',''],['木瓜','',''],['木瓦','',''],['木盘','',''],['木目金','',''],['木石','',''],['木石为徒','',''],['木立','',''],['木笔','',''],['木笼','',''],['木筏','',''],['木简','',''],['木管','',''],['木管乐器','',''],['木箱','',''],['木粉','',''],['木精','',''],['木糖','',''],['木糖醇','',''],['木纹','',''],['木结','',''],['木结构','',''],['木耳','',''],['木聚糖','',''],['木腿','',''],['木舟','',''],['木船','',''],['木色','',''],['木芙蓉','',''],['木荷','',''],['木莓','',''],['木莲','',''],['木菠萝','',''],['木蓝','',''],['木薯','',''],['木薯淀粉','',''],['木虱','',''],['木蠹','',''],['木蠹蛾','',''],['木行','',''],['木讷','',''],['木讷寡言','',''],['木讷老人','',''],['木豆','',''],['木质','',''],['木质化','',''],['木质素','',''],['木质茎','',''],['木质部','',''],['木贼','',''],['木通','',''],['木造','',''],['木造品','',''],['木道','',''],['木酮糖','',''],['木醇','',''],['木钉','',''],['木锤','',''],['木锨','',''],['木锯','',''],['木锹','',''],['木门','',''],['木雕','',''],['木雕工','',''],['木雕泥塑','',''],['木鞋','',''],['木香','',''],['木马','',''],['木马病毒','',''],['木马计','',''],['木骨都束','',''],['木鱼','',''],['木鸡','',''],['木鸡养到','',''],['木麻黄','',''],['木齿耙','',''],['未上','',''],['未上弦','',''],['未上栓','',''],['未为','',''],['未久','',''],['未之','',''],['未了','',''],['未了公案','',''],['未予','',''],['未亡','',''],['未亡人','',''],['未交','',''],['未亵渎','',''],['未付','',''],['未作','',''],['未使','',''],['未使用','',''],['未供认','',''],['未便','',''],['未修改','',''],['未修正','',''],['未做','',''],['未免','',''],['未兑','',''],['未关','',''],['未冠','',''],['未决','',''],['未决定','',''],['未决意','',''],['未决犯','',''],['未准','',''],['未准备','',''],['未减轻','',''],['未几','',''],['未出','',''],['未出声','',''],['未出货','',''],['未分','',''],['未分割','',''],['未分开','',''],['未分离','',''],['未分裂','',''],['未分选','',''],['未切割','',''],['未刊行','',''],['未列','',''],['未列出','',''],['未删节版','',''],['未到','',''],['未剃须','',''],['未加','',''],['未加工','',''],['未动','',''],['未动过','',''],['未区','',''],['未卖出','',''],['未卜','',''],['未卜先知','',''],['未占','',''],['未占用','',''],['未占领','',''],['未卸下','',''],['未压缩','',''],['未去壳','',''],['未参战','',''],['未及','',''],['未反驳','',''],['未发','',''],['未发展','',''],['未发现','',''],['未发觉','',''],['未发货','',''],['未受','',''],['未受伤','',''],['未受影响','',''],['未受损','',''],['未受理','',''],['未受精','',''],['未受阻','',''],['未变','',''],['未可','',''],['未可厚非','',''],['未可同日而语','',''],['未名','',''],['未向','',''],['未命名','',''],['未和解','',''],['未在','',''],['未垦','',''],['未声明','',''],['未处理','',''],['未央','',''],['未央宫','',''],['未夸张','',''],['未奉命','',''],['未好','',''],['未妥','',''],['未始','',''],['未始不可','',''],['未娶','',''],['未娶妻','',''],['未婚','',''],['未婚夫','',''],['未婚妻','',''],['未孵','',''],['未安排','',''],['未完','',''],['未完待续','',''],['未完成','',''],['未定','',''],['未定义','',''],['未定之天','',''],['未定角','',''],['未审理','',''],['未将','',''],['未尝','',''],['未尝不可','',''],['未就','',''],['未尽','',''],['未尽事宜','',''],['未带','',''],['未干','',''],['未平','',''],['未建造','',''],['未开','',''],['未开化','',''],['未开发','',''],['未开垦','',''],['未开拓','',''],['未归类','',''],['未形成','',''],['未征','',''],['未得','',''],['未必','',''],['未必有','',''],['未必然','',''],['未想','',''],['未意','',''],['未感染','',''],['未成','',''],['未成一篑','',''],['未成冠','',''],['未成功','',''],['未成年','',''],['未成年人','',''],['未成年者','',''],['未成形','',''],['未成熟','',''],['未成长','',''],['未打破','',''],['未扣','',''],['未扫清','',''],['未批准','',''],['未批判','',''],['未折现','',''],['未报','',''],['未指定','',''],['未按','',''],['未损坏','',''],['未捣碎','',''],['未排定','',''],['未推动','',''],['未掩蔽','',''],['未提','',''],['未提到','',''],['未提及','',''],['未揭露','',''],['未收','',''],['未收割','',''],['未改','',''],['未改变','',''],['未改革','',''],['未放','',''],['未救济','',''],['未敢','',''],['未敢苟同','',''],['未料','',''],['未明求衣','',''],['未明言','',''],['未曾','',''],['未有','',''],['未来','',''],['未来业绩','',''],['未来学','',''],['未来式','',''],['未来技术','',''],['未来派','',''],['未来研究','',''],['未标','',''],['未标号','',''],['未标明','',''],['未格','',''],['未歌颂','',''],['未武装','',''],['未毁','',''],['未洗','',''],['未流通','',''],['未消化','',''],['未清','',''],['未清算','',''],['未满','',''],['未满月','',''],['未满足','',''],['未演出','',''],['未灭','',''],['未点燃','',''],['未烘透','',''],['未烹调','',''],['未焚徙薪','',''],['未然','',''],['未煮熟','',''],['未煮过','',''],['未煮透','',''],['未熟','',''],['未琢磨','',''],['未生','',''],['未生效','',''],['未用','',''],['未用尽','',''],['未用过','',''],['未登记','',''],['未知','',''],['未知一丁','',''],['未知万一','',''],['未知所措','',''],['未知数','',''],['未知数儿','',''],['未知量','',''],['未确定','',''],['未确证','',''],['未碰上','',''],['未碰过','',''],['未磨光','',''],['未离','',''],['未移动','',''],['未稀释','',''],['未穿过','',''],['未穿靴','',''],['未竟','',''],['未竟之志','',''],['未答覆','',''],['未签字者','',''],['未粘牢','',''],['未精炼','',''],['未约定','',''],['未纯化','',''],['未纳','',''],['未组成','',''],['未组织','',''],['未经','',''],['未经证实','',''],['未结束','',''],['未缓和','',''],['未编号','',''],['未编辑','',''],['未置可否','',''],['未羊','',''],['未翻转','',''],['未老先衰','',''],['未联合','',''],['未能','',''],['未能免俗','',''],['未能如愿','',''],['未能得逞','',''],['未腐败','',''],['未艾方兴','',''],['未范','',''],['未获','',''],['未获奖','',''],['未行','',''],['未行之患','',''],['未补','',''],['未表示','',''],['未被','',''],['未裂开','',''],['未要','',''],['未见','',''],['未见分晓','',''],['未见到','',''],['未规定','',''],['未觉','',''],['未解','',''],['未解之谜','',''],['未解决','',''],['未解释','',''],['未触动','',''],['未订婚','',''],['未记','',''],['未设','',''],['未设防','',''],['未试过','',''],['未诞生','',''],['未详','',''],['未说','',''],['未说出','',''],['未说明','',''],['未请','',''],['未读','',''],['未贴','',''],['未足为道','',''],['未载名','',''],['未载明','',''],['未达','',''],['未达一间','',''],['未达到','',''],['未过','',''],['未遂','',''],['未遂政变','',''],['未遂犯','',''],['未遑多让','',''],['未配对','',''],['未醉','',''],['未铺设','',''],['未错','',''],['未长成','',''],['未附','',''],['未附属','',''],['未陈旧','',''],['未雕琢','',''],['未雨绸缪','',''],['未预','',''],['未风先雨','',''],['未驯服','',''],['末世','',''],['末了','',''],['末代','',''],['末代皇帝','',''],['末伏','',''],['末位','',''],['末儿','',''],['末叶','',''],['末名','',''],['末名奖品','',''],['末后','',''],['末大不掉','',''],['末大必折','',''],['末如之何','',''],['末子','',''],['末学肤受','',''],['末尾','',''],['末屑','',''],['末席','',''],['末年','',''],['末底改','',''],['末座','',''],['末态','',''],['末愿','',''],['末日','',''],['末日论','',''],['末期','',''],['末枝','',''],['末梢','',''],['末梢神经','',''],['末梢部','',''],['末次','',''],['末段','',''],['末流','',''],['末煤','',''],['末片','',''],['末状','',''],['末班','',''],['末班车','',''],['末稍','',''],['末稍神经','',''],['末端','',''],['末篇','',''],['末考','',''],['末艺','',''],['末节','',''],['末节细行','',''],['末茶','',''],['末药','',''],['末行','',''],['末路','',''],['末路之难','',''],['末路穷途','',''],['末车','',''],['末速','',''],['末造','',''],['末页','',''],['本・拉登','',''],['本上','',''],['本世纪','',''],['本世纪内','',''],['本世纪初','',''],['本世纪末','',''],['本主','',''],['本主儿','',''],['本义','',''],['本乡','',''],['本乡本土','',''],['本书','',''],['本事','',''],['本人','',''],['本份','',''],['本会','',''],['本位','',''],['本位主义','',''],['本位制','',''],['本位货币','',''],['本体','',''],['本体论','',''],['本例','',''],['本俸','',''],['本值','',''],['本儿','',''],['本分','',''],['本刊','',''],['本初','',''],['本初子午线','',''],['本利','',''],['本剧','',''],['本区','',''],['本单位','',''],['本卷','',''],['本厂','',''],['本原','',''],['本县','',''],['本句','',''],['本台','',''],['本台记者','',''],['本号','',''],['本司','',''],['本同末异','',''],['本名','',''],['本周','',''],['本命','',''],['本命年','',''],['本品','',''],['本嗓','',''],['本因坊','',''],['本因坊秀策','',''],['本团','',''],['本固枝荣','',''],['本国','',''],['本国产','',''],['本国人','',''],['本国语','',''],['本土','',''],['本土化','',''],['本土化软件','',''],['本土派','',''],['本地','',''],['本地人','',''],['本地化','',''],['本地区','',''],['本地管理界面','',''],['本场','',''],['本垒','',''],['本垒打','',''],['本埠','',''],['本堂','',''],['本处','',''],['本子','',''],['本字','',''],['本季','',''],['本季度','',''],['本室','',''],['本家','',''],['本家儿','',''],['本小利大','',''],['本小利微','',''],['本尼迪','',''],['本局','',''],['本届','',''],['本岛','',''],['本州','',''],['本州岛','',''],['本币','',''],['本市','',''],['本帮菜','',''],['本平方米','',''],['本年度','',''],['本应','',''],['本底','',''],['本底计数','',''],['本底调查','',''],['本底辐射','',''],['本式','',''],['本当','',''],['本影','',''],['本征值','',''],['本征向量','',''],['本心','',''],['本性','',''],['本性难移','',''],['本息','',''],['本想','',''],['本意','',''],['本戏','',''],['本我','',''],['本所','',''],['本批','',''],['本报','',''],['本报讯','',''],['本报记者','',''],['本拉登','',''],['本拟','',''],['本支百世','',''],['本文','',''],['本族','',''],['本族语','',''],['本日','',''],['本旨','',''],['本旬','',''],['本星期','',''],['本朝','',''],['本期','',''],['本末','',''],['本末倒置','',''],['本本','',''],['本本主义','',''],['本本分分','',''],['本本源源','',''],['本机','',''],['本机振荡','',''],['本村','',''],['本条','',''],['本来','',''],['本来面目','',''],['本杰明','',''],['本杰明・富兰克林','',''],['本校','',''],['本案','',''],['本次','',''],['本港','',''],['本源','',''],['本溪县','',''],['本然','',''],['本片','',''],['本版','',''],['本班','',''],['本生灯','',''],['本田','',''],['本益比','',''],['本相','',''],['本省','',''],['本省人','',''],['本着','',''],['本社','',''],['本票','',''],['本科','',''],['本科生','',''],['本站','',''],['本章','',''],['本笃・十六世','',''],['本籍','',''],['本类','',''],['本系','',''],['本系统','',''],['本级','',''],['本纪','',''],['本组','',''],['本经','',''],['本罪','',''],['本职','',''],['本职工作','',''],['本能','',''],['本能冲动','',''],['本色','',''],['本节','',''],['本茨','',''],['本草','',''],['本草纲目','',''],['本营','',''],['本著','',''],['本行','',''],['本表','',''],['本该','',''],['本该如此','',''],['本说','',''],['本质','',''],['本质上','',''],['本质性','',''],['本质联系','',''],['本身','',''],['本轮','',''],['本那比','',''],['本那比市','',''],['本部','',''],['本部门','',''],['本金','',''],['本钱','',''],['本队','',''],['本院','',''],['本需','',''],['本页','',''],['本项','',''],['本领','',''],['本题','',''],['札幌','',''],['札手舞脚','',''],['札格拉布','',''],['札格瑞布','',''],['札记','',''],['札马剌丁','',''],['札马鲁丁','',''],['术前','',''],['术后','',''],['术治','',''],['术科','',''],['术语','',''],['术语学','',''],['术语表','',''],['术赤','',''],['朱丽亚','',''],['朱丽叶','',''],['朱云折槛','',''],['朱俊','',''],['朱允炆','',''],['朱元璋','',''],['朱利亚尼','',''],['朱利娅','',''],['朱厚照','',''],['朱口皓齿','',''],['朱古力','',''],['朱唇榴齿','',''],['朱唇皓齿','',''],['朱唇粉面','',''],['朱墨','',''],['朱子','',''],['朱孝天','',''],['朱容基','',''],['朱广沪','',''],['朱庇特','',''],['朱弦玉磐','',''],['朱弦疏越','',''],['朱德','',''],['朱批','',''],['朱文','',''],['朱棣','',''],['朱槿','',''],['朱温','',''],['朱漆','',''],['朱熔基','',''],['朱熹','',''],['朱甍碧瓦','',''],['朱由校','',''],['朱瞻基','',''],['朱砂','',''],['朱祁钰','',''],['朱祁镇','',''],['朱笔','',''],['朱粉','',''],['朱紫难别','',''],['朱红','',''],['朱红灯','',''],['朱红色','',''],['朱自清','',''],['朱色','',''],['朱莉娅','',''],['朱衣点头','',''],['朱衣点额','',''],['朱诺','',''],['朱轮华毂','',''],['朱迪亚','',''],['朱镕基','',''],['朱门','',''],['朱门绣户','',''],['朱阁青楼','',''],['朱雀','',''],['朱顶','',''],['朱颜','',''],['朱颜粉面','',''],['朱颜鹤发','',''],['朱高炽','',''],['朱鹭','',''],['朱鹮','',''],['朴刀','',''],['朴厚','',''],['朴子','',''],['朴子市','',''],['朴学','',''],['朴实','',''],['朴实无华','',''],['朴拙','',''],['朴树','',''],['朴次茅斯','',''],['朴正熙','',''],['朴直','',''],['朴硝','',''],['朴素','',''],['朴素唯物主义','',''],['朴素大方','',''],['朴素无华','',''],['朴素的唯物主义','',''],['朴茂','',''],['朴茨茅斯和约','',''],['朴讷诚笃','',''],['朴质','',''],['朴陋','',''],['朵儿','',''],['朵朵','',''],['朵颐','',''],['朵颐大嚼','',''],['机上','',''],['机下','',''],['机不可失','',''],['机不可失失不再来','',''],['机不旋踵','',''],['机中','',''],['机事不密','',''],['机井','',''],['机仓','',''],['机件','',''],['机会','',''],['机会主义','',''],['机会均等','',''],['机会带来成功','',''],['机会成本','',''],['机体','',''],['机修','',''],['机修厂','',''],['机修工','',''],['机关','',''],['机关作风','',''],['机关党委','',''],['机关刊物','',''],['机关布景','',''],['机关干部','',''],['机关报','',''],['机关枪','',''],['机关炮','',''],['机关车','',''],['机具','',''],['机内','',''],['机制','',''],['机前','',''],['机务','',''],['机务段','',''],['机动','',''],['机动保障','',''],['机动力','',''],['机动化','',''],['机动式','',''],['机动性','',''],['机动船','',''],['机动车','',''],['机动车辆','',''],['机动防御','',''],['机化','',''],['机变','',''],['机变如神','',''],['机台','',''],['机名','',''],['机员','',''],['机哩瓜拉','',''],['机器','',''],['机器人','',''],['机器人学','',''],['机器制','',''],['机器油','',''],['机器翻译','',''],['机器脚踏车','',''],['机器般','',''],['机场','',''],['机场大厦','',''],['机坪','',''],['机型','',''],['机壳','',''],['机头','',''],['机头座','',''],['机子','',''],['机宜','',''],['机密','',''],['机密性','',''],['机密文件','',''],['机尾','',''],['机工','',''],['机巧','',''],['机帆船','',''],['机师','',''],['机床','',''],['机库','',''],['机座','',''],['机心','',''],['机房','',''],['机敏','',''],['机时','',''],['机智','',''],['机杼','',''],['机构','',''],['机构改革','',''],['机构调整','',''],['机枪','',''],['机枪手','',''],['机架','',''],['机柜','',''],['机械','',''],['机械传动','',''],['机械制造','',''],['机械化','',''],['机械化军','',''],['机械化步兵','',''],['机械化部队','',''],['机械厂','',''],['机械唯物主义','',''],['机械士','',''],['机械学','',''],['机械工','',''],['机械工业','',''],['机械工人','',''],['机械工程','',''],['机械师','',''],['机械性','',''],['机械性能','',''],['机械手','',''],['机械效率','',''],['机械油','',''],['机械电子工业部','',''],['机械码','',''],['机械翻译','',''],['机械能','',''],['机械论','',''],['机械设备','',''],['机械语言','',''],['机械运动','',''],['机械钟','',''],['机油','',''],['机灌','',''],['机灵','',''],['机率','',''],['机理','',''],['机电','',''],['机电部','',''],['机票','',''],['机种','',''],['机箱','',''],['机米','',''],['机组','',''],['机组人员','',''],['机织','',''],['机织物','',''],['机绣','',''],['机缘','',''],['机罩','',''],['机群','',''],['机翼','',''],['机耕','',''],['机耕船','',''],['机能','',''],['机腹','',''],['机舱','',''],['机芯','',''],['机要','',''],['机要文件','',''],['机警','',''],['机诈','',''],['机译','',''],['机谋','',''],['机身','',''],['机身宽大','',''],['机车','',''],['机轮','',''],['机轴','',''],['机载','',''],['机载设备','',''],['机载雷达','',''],['机运','',''],['机遇','',''],['机长','',''],['机降','',''],['机顶盒','',''],['机首','',''],['朽坏','',''],['朽木','',''],['朽木不雕','',''],['朽木之才','',''],['朽木死灰','',''],['朽木粪土','',''],['朽木粪墙','',''],['朽株枯木','',''],['朽棘不雕','',''],['朽烂','',''],['朽蠹','',''],['朽迈','',''],['杀一儆百','',''],['杀一利百','',''],['杀一警百','',''],['杀亲','',''],['杀人','',''],['杀人不眨眼','',''],['杀人不见血','',''],['杀人不过头点地','',''],['杀人偿命欠债还钱','',''],['杀人如芥','',''],['杀人如草','',''],['杀人如麻','',''],['杀人放火','',''],['杀人未遂','',''],['杀人案','',''],['杀人案件','',''],['杀人灭口','',''],['杀人犯','',''],['杀人狂','',''],['杀人盈野','',''],['杀人罪','',''],['杀人者','',''],['杀人越货','',''],['杀价','',''],['杀伐','',''],['杀伤','',''],['杀伤力','',''],['杀伤性','',''],['杀低','',''],['杀光','',''],['杀头','',''],['杀女','',''],['杀妻','',''],['杀妻求将','',''],['杀婴','',''],['杀子','',''],['杀害','',''],['杀富济贫','',''],['杀幼','',''],['杀彘教子','',''],['杀性','',''],['杀戒','',''],['杀戮','',''],['杀手','',''],['杀手锏','',''],['杀手级应用','',''],['杀掉','',''],['杀掠','',''],['杀敌','',''],['杀敌致果','',''],['杀机','',''],['杀死','',''],['杀毒','',''],['杀毒软件','',''],['杀气','',''],['杀气腾腾','',''],['杀灭','',''],['杀熟','',''],['杀父','',''],['杀牛宰羊','',''],['杀猪','',''],['杀猪宰羊','',''],['杀生','',''],['杀生与夺','',''],['杀生之权','',''],['杀生之柄','',''],['杀真菌','',''],['杀绝','',''],['杀草快','',''],['杀菌','',''],['杀菌作用','',''],['杀菌剂','',''],['杀菌物','',''],['杀菌素','',''],['杀虎斩蛟','',''],['杀虫','',''],['杀虫剂','',''],['杀虫药','',''],['杀螟杆菌','',''],['杀螺剂','',''],['杀蠹药','',''],['杀衣缩食','',''],['杀身','',''],['杀身之祸','',''],['杀身出生','',''],['杀身成义','',''],['杀身成仁','',''],['杀身成名','',''],['杀身报国','',''],['杀身救国','',''],['杀软','',''],['杀进','',''],['杀进杀出','',''],['杀退','',''],['杀除剂','',''],['杀青','',''],['杀风景','',''],['杀马毁车','',''],['杀鸡','',''],['杀鸡为黍','',''],['杀鸡儆猴','',''],['杀鸡取卵','',''],['杀鸡取蛋','',''],['杀鸡吓猴','',''],['杀鸡宰鹅','',''],['杀鸡炊黍','',''],['杀鸡焉用牛刀','',''],['杀鸡给猴看','',''],['杀鸡警猴','',''],['杀鸡骇猴','',''],['杀鼠药','',''],['杂七杂八','',''],['杂乱','',''],['杂乱无章','',''],['杂乱物','',''],['杂事','',''],['杂交','',''],['杂交植物','',''],['杂交派对','',''],['杂交牛','',''],['杂交种','',''],['杂交育种','',''],['杂件','',''],['杂件儿','',''],['杂凑','',''],['杂剧','',''],['杂剧四大家','',''],['杂务','',''],['杂务工','',''],['杂史','',''],['杂和菜','',''],['杂和面','',''],['杂和面儿','',''],['杂品','',''],['杂噪','',''],['杂声','',''],['杂婚','',''],['杂家','',''],['杂居','',''],['杂居地区','',''],['杂工','',''],['杂差','',''],['杂店','',''],['杂录','',''],['杂役','',''],['杂志','',''],['杂志社','',''],['杂念','',''],['杂情','',''],['杂感','',''],['杂戏','',''],['杂技','',''],['杂技团','',''],['杂技场','',''],['杂技演员','',''],['杂拌','',''],['杂拌儿','',''],['杂文','',''],['杂曲','',''],['杂木','',''],['杂木林','',''],['杂树林','',''],['杂款','',''],['杂沓','',''],['杂活','',''],['杂流','',''],['杂烩','',''],['杂牌','',''],['杂牌儿','',''],['杂牌军','',''],['杂物','',''],['杂物室','',''],['杂环','',''],['杂用','',''],['杂症','',''],['杂盐','',''],['杂碎','',''],['杂种','',''],['杂种优势','',''],['杂种性','',''],['杂种狗','',''],['杂税','',''],['杂粮','',''],['杂糅','',''],['杂絮','',''],['杂耍','',''],['杂耍剧','',''],['杂肥','',''],['杂脍','',''],['杂色','',''],['杂草','',''],['杂草似','',''],['杂草多','',''],['杂菜','',''],['杂言','',''],['杂记','',''],['杂评','',''],['杂说','',''],['杂谈','',''],['杂谷脑','',''],['杂谷脑镇','',''],['杂货','',''],['杂货商','',''],['杂货店','',''],['杂货摊','',''],['杂质','',''],['杂费','',''],['杂遝','',''],['杂配','',''],['杂陈','',''],['杂院','',''],['杂院儿','',''],['杂集','',''],['杂霸','',''],['杂面','',''],['杂音','',''],['杂项','',''],['杂食','',''],['杂食动物','',''],['杂食性','',''],['权且','',''],['权位','',''],['权作','',''],['权值','',''],['权倾中外','',''],['权倾天下','',''],['权充','',''],['权利','',''],['权利人','',''],['权利声明','',''],['权利法案','',''],['权利要求','',''],['权力','',''],['权力下放','',''],['权力交接','',''],['权力分享','',''],['权力分享协议','',''],['权力斗争','',''],['权力机关','',''],['权力纷争','',''],['权势','',''],['权变','',''],['权变锋出','',''],['权外','',''],['权威','',''],['权威人士','',''],['权威性','',''],['权宜','',''],['权宜之策','',''],['权宜之计','',''],['权属','',''],['权当','',''],['权数','',''],['权时','',''],['权术','',''],['权杖','',''],['权柄','',''],['权标','',''],['权欲熏心','',''],['权略','',''],['权益','',''],['权职','',''],['权能','',''],['权能区分','',''],['权臣','',''],['权舆','',''],['权衡','',''],['权衡利弊','',''],['权衡者','',''],['权衡轻重','',''],['权要','',''],['权证','',''],['权诈','',''],['权谋','',''],['权豪势要','',''],['权责','',''],['权贵','',''],['权重','',''],['权钥','',''],['权钧力齐','',''],['权钱交易','',''],['权门','',''],['权限','',''],['杆儿','',''],['杆塔','',''],['杆子','',''],['杆弟','',''],['杆档','',''],['杆状','',''],['杆状细菌','',''],['杆秤','',''],['杆菌','',''],['杆菌肽','',''],['杈子','',''],['杉山彬','',''],['杉木','',''],['杉木制','',''],['杉林','',''],['杉林乡','',''],['杉树','',''],['杉篙','',''],['杌凳','',''],['杌子','',''],['杌陧','',''],['李下不整冠','',''],['李下瓜天','',''],['李世民','',''],['李丽珊','',''],['李云娜','',''],['李亚鹏','',''],['李亨','',''],['李代数','',''],['李代桃僵','',''],['李会昌','',''],['李伯元','',''],['李俊','',''],['李修贤','',''],['李儇','',''],['李元昊','',''],['李先念','',''],['李光耀','',''],['李克强','',''],['李公朴','',''],['李冰','',''],['李冰冰','',''],['李劼人','',''],['李卜克内西','',''],['李卫公','',''],['李叔同','',''],['李后主','',''],['李哲','',''],['李商隐','',''],['李嘉欣','',''],['李嘉诚','',''],['李四光','',''],['李国豪','',''],['李大钊','',''],['李天王','',''],['李天禄','',''],['李娃传','',''],['李娜','',''],['李子','',''],['李宁','',''],['李安','',''],['李宗仁','',''],['李宝嘉','',''],['李家短','',''],['李富春','',''],['李小龙','',''],['李尔王','',''],['李岚清','',''],['李希霍芬','',''],['李广','',''],['李延寿','',''],['李建成','',''],['李开复','',''],['李彦宏','',''],['李德','',''],['李德林','',''],['李忱','',''],['李怀远','',''],['李恒','',''],['李悝','',''],['李成桂','',''],['李成江','',''],['李承晚','',''],['李振藩','',''],['李政道','',''],['李敏勇','',''],['李斯','',''],['李斯特','',''],['李斯特氏杆菌','',''],['李斯特氏菌','',''],['李斯特菌','',''],['李旦','',''],['李时珍','',''],['李昂','',''],['李昉','',''],['李昌镐','',''],['李明博','',''],['李显龙','',''],['李晔','',''],['李朝威','',''],['李木','',''],['李林甫','',''],['李树','',''],['李格非','',''],['李氏','',''],['李氏朝鲜','',''],['李汝珍','',''],['李沧','',''],['李治','',''],['李泽楷','',''],['李洪志','',''],['李清照','',''],['李渊','',''],['李渔','',''],['李湛','',''],['李漼','',''],['李瀍','',''],['李煜','',''],['李玟','',''],['李瑞环','',''],['李登辉','',''],['李白','',''],['李百药','',''],['李直夫','',''],['李祝','',''],['李约瑟','',''],['李纯','',''],['李维','',''],['李维史陀','',''],['李绿园','',''],['李缨','',''],['李群','',''],['李翱','',''],['李耳','',''],['李肇','',''],['李肇星','',''],['李自成','',''],['李自成起义','',''],['李舜臣','',''],['李英儒','',''],['李诚恩','',''],['李诵','',''],['李豫','',''],['李贺','',''],['李贽','',''],['李远哲','',''],['李连杰','',''],['李适','',''],['李逵','',''],['李重茂','',''],['李铁','',''],['李长春','',''],['李陵','',''],['李隆基','',''],['李雪健','',''],['李靖','',''],['李鸿章','',''],['李鹏','',''],['杏仁','',''],['杏仁体','',''],['杏仁核','',''],['杏仁豆腐','',''],['杏子','',''],['杏干','',''],['杏林','',''],['杏林区','',''],['杏树','',''],['杏核','',''],['杏眼','',''],['杏红','',''],['杏脯','',''],['杏脸桃腮','',''],['杏色','',''],['杏花','',''],['杏花岭','',''],['杏花村','',''],['杏雨梨云','',''],['杏黄','',''],['材大难用','',''],['材料','',''],['材料力学','',''],['材料厂','',''],['材料学','',''],['材料科学','',''],['材料费','',''],['材疏志大','',''],['材积','',''],['材能兼备','',''],['材质','',''],['材轻德薄','',''],['材高知深','',''],['村上・春树','',''],['村上隆','',''],['村人','',''],['村内','',''],['村前村后','',''],['村办','',''],['村医','',''],['村口','',''],['村史','',''],['村名','',''],['村坊','',''],['村塾','',''],['村外','',''],['村夫','',''],['村夫俗子','',''],['村夫野老','',''],['村女','',''],['村妇','',''],['村姑','',''],['村委会','',''],['村子','',''],['村学','',''],['村寨','',''],['村山富市','',''],['村干部','',''],['村庄','',''],['村式','',''],['村支书','',''],['村村寨寨','',''],['村民','',''],['村生泊长','',''],['村社','',''],['村童','',''],['村筋俗骨','',''],['村级','',''],['村舍','',''],['村落','',''],['村证房','',''],['村里','',''],['村野','',''],['村镇','',''],['村长','',''],['杓子','',''],['杓球场','',''],['杖击','',''],['杖刑','',''],['杖头木偶','',''],['杖子','',''],['杜仲','',''],['杜仲胶','',''],['杜伊斯堡','',''],['杜冷丁','',''],['杜口','',''],['杜口吞声','',''],['杜口无言','',''],['杜口结舌','',''],['杜口绝舌','',''],['杜口绝言','',''],['杜口裹足','',''],['杜塞','',''],['杜塞尔多夫','',''],['杜塞道夫','',''],['杜威','',''],['杜宇','',''],['杜尔伯特','',''],['杜尔伯特县','',''],['杜尚别','',''],['杜布罗夫尼克','',''],['杜康','',''],['杜微慎防','',''],['杜拜','',''],['杜撰','',''],['杜撰者','',''],['杜月笙','',''],['杜本内','',''],['杜松','',''],['杜松子酒','',''],['杜树','',''],['杜梨','',''],['杜比','',''],['杜氏腺','',''],['杜氏腺体','',''],['杜渐','',''],['杜渐防微','',''],['杜渐防萌','',''],['杜渐除微','',''],['杜牧','',''],['杜琪峰','',''],['杜瓦利埃','',''],['杜甫','',''],['杜甫草堂','',''],['杜秋娘歌','',''],['杜绝','',''],['杜绝后患','',''],['杜荀鹤','',''],['杜莎夫人','',''],['杜蕾斯','',''],['杜蘅','',''],['杜衡','',''],['杜邦','',''],['杜邮之戮','',''],['杜门','',''],['杜门不出','',''],['杜门却扫','',''],['杜门屏迹','',''],['杜门晦迹','',''],['杜门自绝','',''],['杜门谢客','',''],['杜集','',''],['杜马','',''],['杜鲁门','',''],['杜鲁门主义','',''],['杜鹃','',''],['杜鹃啼血','',''],['杜鹃座','',''],['杜鹃科','',''],['杜鹃花','',''],['杜鹃花科','',''],['杜鹃鸟','',''],['杞人之忧','',''],['杞人忧天','',''],['杞国','',''],['杞国之忧','',''],['杞国忧天','',''],['杞天之虑','',''],['杞子','',''],['杞宋无征','',''],['杞忧者','',''],['杞柳','',''],['杞梓之林','',''],['束之高阁','',''],['束以','',''],['束住','',''],['束修','',''],['束修自好','',''],['束力','',''],['束发','',''],['束发封帛','',''],['束发带','',''],['束带','',''],['束成','',''],['束手','',''],['束手就擒','',''],['束手就毙','',''],['束手就缚','',''],['束手待死','',''],['束手待毙','',''],['束手旁观','',''],['束手无措','',''],['束手无策','',''],['束手无计','',''],['束手束脚','',''],['束杖理民','',''],['束狭','',''],['束环索','',''],['束矢难折','',''],['束紧','',''],['束缚','',''],['束缚物','',''],['束胸','',''],['束脩','',''],['束腰','',''],['束衣','',''],['束装','',''],['束装盗金','',''],['束身','',''],['束身修行','',''],['束身就缚','',''],['束身自修','',''],['束身自好','',''],['束马悬车','',''],['杠上开花','',''],['杠刀','',''],['杠夫','',''],['杠头','',''],['杠子','',''],['杠房','',''],['杠杆','',''],['杠杆作用','',''],['杠杆收购','',''],['杠竹','',''],['杠荡','',''],['杠铃','',''],['条令','',''],['条件','',''],['条件下','',''],['条件刺激','',''],['条件反射','',''],['条件反应','',''],['条件句','',''],['条件式','',''],['条件概率','',''],['条例','',''],['条几','',''],['条凳','',''],['条分缕晰','',''],['条分缕析','',''],['条块','',''],['条块分割','',''],['条块结合','',''],['条子','',''],['条带','',''],['条幅','',''],['条幅广告','',''],['条形','',''],['条形图','',''],['条形燃料','',''],['条形码','',''],['条捆','',''],['条播','',''],['条数','',''],['条文','',''],['条斑窃蠹','',''],['条施','',''],['条条','',''],['条条块块','',''],['条条大路通罗马','',''],['条条框框','',''],['条板','',''],['条板箱','',''],['条案','',''],['条款','',''],['条状物','',''],['条理','',''],['条理分明','',''],['条畅','',''],['条痕','',''],['条目','',''],['条石','',''],['条码','',''],['条约','',''],['条纹','',''],['条纹羚','',''],['条绒','',''],['条虫','',''],['条规','',''],['条贯','',''],['条钢','',''],['条陈','',''],['条鳎','',''],['来不','',''],['来不了','',''],['来不及','',''],['来不得','',''],['来世','',''],['来世论','',''],['来个','',''],['来临','',''],['来义','',''],['来义乡','',''],['来之','',''],['来之不易','',''],['来书','',''],['来亨鸡','',''],['来京','',''],['来人','',''],['来人儿','',''],['来人来函','',''],['来件','',''],['来作','',''],['来信','',''],['来做','',''],['来养','',''],['来写','',''],['来函','',''],['来到','',''],['来劲','',''],['来势','',''],['来势凶猛','',''],['来势汹汹','',''],['来华','',''],['来华访问','',''],['来历','',''],['来历不明','',''],['来去','',''],['来去匆匆','',''],['来去无踪','',''],['来去自由','',''],['来变','',''],['来台','',''],['来吧','',''],['来呀','',''],['来唱','',''],['来回','',''],['来回来去','',''],['来回来去地','',''],['来回票','',''],['来地','',''],['来处','',''],['来复枪','',''],['来复电路','',''],['来复线','',''],['来头','',''],['来客','',''],['来就','',''],['来已','',''],['来年','',''],['来式','',''],['来归','',''],['来往','',''],['来往港口','',''],['来得','',''],['来得及','',''],['来得容易','',''],['来意','',''],['来手','',''],['来抓','',''],['来拿去','',''],['来接','',''],['来敌','',''],['来文','',''],['来料','',''],['来料加工','',''],['来无影','',''],['来日','',''],['来日大难','',''],['来日方长','',''],['来日正长','',''],['来月经','',''],['来来','',''],['来来往往','',''],['来样','',''],['来样加工','',''],['来此','',''],['来气','',''],['来水','',''],['来港','',''],['来源','',''],['来源于','',''],['来潮','',''],['来火','',''],['来火儿','',''],['来牟','',''],['来犯','',''],['来犯之敌','',''],['来猜','',''],['来生','',''],['来由','',''],['来电','',''],['来电显示','',''],['来的','',''],['来的人','',''],['来看','',''],['来着','',''],['来硬的','',''],['来碗','',''],['来福枪','',''],['来稿','',''],['来给','',''],['来者','',''],['来者不善','',''],['来者不拒','',''],['来聊天','',''],['来自','',''],['来自于','',''],['来舟','',''],['来苏','',''],['来苏糖','',''],['来著','',''],['来袭','',''],['来讲','',''],['来访','',''],['来访者','',''],['来试','',''],['来说','',''],['来请','',''],['来货','',''],['来路','',''],['来路不明','',''],['来路货','',''],['来踪','',''],['来踪去迹','',''],['来过','',''],['来这','',''],['来迟','',''],['来风','',''],['来鸿','',''],['来鸿去燕','',''],['来龙去脉','',''],['杨业','',''],['杨丞琳','',''],['杨亿','',''],['杨俊','',''],['杨凝式','',''],['杨利伟','',''],['杨坚','',''],['杨妃','',''],['杨守仁','',''],['杨宝森','',''],['杨家将','',''],['杨尚昆','',''],['杨建利','',''],['杨开慧','',''],['杨振宁','',''],['杨斌','',''],['杨月清','',''],['杨木','',''],['杨枝鱼','',''],['杨柳','',''],['杨柳科','',''],['杨柳青','',''],['杨树','',''],['杨桃','',''],['杨梅','',''],['杨梅镇','',''],['杨森','',''],['杨洁篪','',''],['杨浦','',''],['杨深秀','',''],['杨澄中','',''],['杨玉环','',''],['杨百翰','',''],['杨百翰大学','',''],['杨福家','',''],['杨秀清','',''],['杨维','',''],['杨致远','',''],['杨花水性','',''],['杨虎城','',''],['杨贵妃','',''],['杨采妮','',''],['杨锐','',''],['杨陵','',''],['杨陵区','',''],['杩头','',''],['杭丁顿舞蹈症','',''],['杭州湾','',''],['杭州萝卜绍兴种','',''],['杭纺','',''],['杭育','',''],['杭锦','',''],['杯中','',''],['杯中之物','',''],['杯中物','',''],['杯垫','',''],['杯子','',''],['杯底','',''],['杯弓蛇影','',''],['杯托','',''],['杯水粒粟','',''],['杯水舆薪','',''],['杯水车薪','',''],['杯状','',''],['杯珓','',''],['杯盏','',''],['杯盘狼籍','',''],['杯盘狼藉','',''],['杯筊','',''],['杯葛','',''],['杯蛇鬼车','',''],['杯觥交错','',''],['杯赛','',''],['杯酒戈矛','',''],['杯酒解怨','',''],['杯酒言欢','',''],['杯酒释兵权','',''],['杰伊汉港','',''],['杰佛兹','',''],['杰作','',''],['杰克','',''],['杰克・伦敦','',''],['杰克森','',''],['杰克逊','',''],['杰出','',''],['杰出人物','',''],['杰出代表','',''],['杰士派','',''],['杰夫','',''],['杰夫・金尼','',''],['杰奎琳','',''],['杰奎琳・肯尼迪','',''],['杰弗逊','',''],['杰弗里乔叟','',''],['杰拉','',''],['杰拉德','',''],['杰瑞','',''],['杰瑞・宋飞','',''],['杰米','',''],['杰西','',''],['杰西・欧文斯','',''],['杰西卡','',''],['杰西卡・艾尔芭','',''],['杰里科','',''],['杰里米','',''],['杲杲','',''],['杳冥','',''],['杳如','',''],['杳如黄鹤','',''],['杳无人烟','',''],['杳无人迹','',''],['杳无信息','',''],['杳无消息','',''],['杳无踪影','',''],['杳无踪迹','',''],['杳无音信','',''],['杳无音讯','',''],['杳无黄鹤','',''],['杳杳','',''],['杳渺','',''],['杳然','',''],['杳眇','',''],['杳茫','',''],['杳霭','',''],['杼柚其空','',''],['杼轴','',''],['松一口气','',''],['松下','',''],['松下公司','',''],['松下电器','',''],['松下电气工业','',''],['松乔之寿','',''],['松了','',''],['松仁','',''],['松动','',''],['松劲','',''],['松化石','',''],['松北','',''],['松口','',''],['松口气','',''],['松口蘑','',''],['松叶','',''],['松土','',''],['松土机','',''],['松坡湖','',''],['松垮','',''],['松塔儿','',''],['松墙子','',''],['松子','',''],['松山','',''],['松岛','',''],['松岭','',''],['松岭区','',''],['松巴哇','',''],['松巴哇岛','',''],['松带','',''],['松开','',''],['松弛','',''],['松弛法','',''],['松心','',''],['松快','',''],['松懈','',''],['松手','',''],['松掉','',''],['松散','',''],['松散物料','',''],['松明','',''],['松木','',''],['松松','',''],['松松垮垮','',''],['松松散散','',''],['松林','',''],['松果','',''],['松果体','',''],['松果腺','',''],['松柏','',''],['松柏之茂','',''],['松柏后雕','',''],['松树','',''],['松桃','',''],['松桃县','',''],['松毛虫','',''],['松气','',''],['松江','',''],['松油','',''],['松泛','',''],['松涛','',''],['松狮犬','',''],['松球','',''],['松田','',''],['松石','',''],['松科','',''],['松筠之节','',''],['松糕','',''],['松紧','',''],['松紧带','',''],['松绑','',''],['松缓','',''],['松耗','',''],['松脂','',''],['松脆','',''],['松脱','',''],['松节','',''],['松节油','',''],['松花','',''],['松花江','',''],['松花蛋','',''],['松茸','',''],['松菌','',''],['松萝','',''],['松萝共倚','',''],['松蕈','',''],['松蘑','',''],['松虎','',''],['松赞干布','',''],['松赞干布陵','',''],['松软','',''],['松辽平原','',''],['松针','',''],['松露','',''],['松露猪','',''],['松饼','',''],['松香','',''],['松驰','',''],['松鸡','',''],['松鸦','',''],['松鹤遐龄','',''],['松鼠','',''],['板上钉钉','',''],['板下','',''],['板书','',''],['板凳','',''],['板刷','',''],['板块','',''],['板块构造','',''],['板块理论','',''],['板墙','',''],['板壁','',''],['板子','',''],['板实','',''],['板岩','',''],['板床','',''],['板式','',''],['板式塔','',''],['板房','',''],['板报','',''],['板擦','',''],['板擦儿','',''],['板斧','',''],['板机','',''],['板材','',''],['板条','',''],['板条箱','',''],['板板','',''],['板板六十四','',''],['板极','',''],['板架','',''],['板栗','',''],['板桩','',''],['板梁桥','',''],['板楼','',''],['板正','',''],['板油','',''],['板滞','',''],['板烟','',''],['板烤','',''],['板片','',''],['板牙','',''],['板状','',''],['板球','',''],['板瓦','',''],['板画','',''],['板皮','',''],['板眼','',''],['板着脸','',''],['板石','',''],['板砖','',''],['板纸','',''],['板结','',''],['板羽球','',''],['板胡','',''],['板脸','',''],['板蓝根','',''],['板规','',''],['板车','',''],['板铺','',''],['板锉','',''],['板门店','',''],['板门店停战村','',''],['板障','',''],['板面','',''],['板鸭','',''],['板鼓','',''],['极不','',''],['极不愉快','',''],['极不相称','',''],['极东','',''],['极为','',''],['极为庞大','',''],['极为重要','',''],['极乐','',''],['极乐世界','',''],['极乐鸟','',''],['极了','',''],['极亮','',''],['极低','',''],['极佳','',''],['极值','',''],['极像','',''],['极光','',''],['极其','',''],['极其重要','',''],['极冠','',''],['极冷','',''],['极出色','',''],['极刑','',''],['极力','',''],['极化','',''],['极北','',''],['极南','',''],['极厚','',''],['极受','',''],['极口','',''],['极右','',''],['极右分子','',''],['极右翼','',''],['极品','',''],['极困难','',''],['极圈','',''],['极在','',''],['极地','',''],['极地气象','',''],['极地狐','',''],['极坏','',''],['极坐标','',''],['极坐标系','',''],['极域','',''],['极多','',''],['极大','',''],['极大值','',''],['极大量','',''],['极好','',''],['极妙','',''],['极客','',''],['极小','',''],['极小量','',''],['极少','',''],['极少数','',''],['极少数人','',''],['极少量','',''],['极尽','',''],['极左','',''],['极差','',''],['极带','',''],['极广','',''],['极度','',''],['极弱','',''],['极强','',''],['极径','',''],['极微','',''],['极微小','',''],['极忙','',''],['极快','',''],['极快速','',''],['极性','',''],['极性键','',''],['极恶','',''],['极恶劣','',''],['极想','',''],['极想念','',''],['极抽象','',''],['极早','',''],['极易','',''],['极有','',''],['极有力','',''],['极有可能','',''],['极机密','',''],['极权','',''],['极权主义','',''],['极板','',''],['极核','',''],['极欲','',''],['极正确','',''],['极深','',''],['极深研几','',''],['极渴','',''],['极漂亮','',''],['极点','',''],['极烫','',''],['极痛','',''],['极瘦','',''],['极盛','',''],['极盛时期','',''],['极目','',''],['极目远望','',''],['极相似','',''],['极短','',''],['极硬','',''],['极神圣','',''],['极端','',''],['极端主义','',''],['极端分子','',''],['极简单','',''],['极累人','',''],['极细小','',''],['极美','',''],['极肥胖','',''],['极致','',''],['极薄','',''],['极蠢','',''],['极西','',''],['极角','',''],['极讨厌','',''],['极谱分析','',''],['极贵重','',''],['极超','',''],['极轴','',''],['极轻','',''],['极辣','',''],['极近','',''],['极远','',''],['极重','',''],['极重要','',''],['极量','',''],['极间电容','',''],['极限','',''],['极难','',''],['极需','',''],['极高','',''],['构上','',''],['构乱','',''],['构件','',''],['构兵','',''],['构化','',''],['构台','',''],['构图','',''],['构地','',''],['构块','',''],['构型','',''],['构建','',''],['构思','',''],['构怨连兵','',''],['构想','',''],['构想图','',''],['构成','',''],['构成者','',''],['构架','',''],['构筑','',''],['构筑物','',''],['构词','',''],['构词学','',''],['构词法','',''],['构词法意识','',''],['构造','',''],['构造上','',''],['构造地震','',''],['构造学','',''],['构造运动','',''],['构陷','',''],['枇杷','',''],['枇杷膏','',''],['枇杷门巷','',''],['枉劳','',''],['枉口拔舌','',''],['枉尺直寻','',''],['枉己正人','',''],['枉径','',''],['枉担虚名','',''],['枉攘','',''],['枉死','',''],['枉法','',''],['枉法徇私','',''],['枉然','',''],['枉用心机','',''],['枉突徙薪','',''],['枉费','',''],['枉费唇舌','',''],['枉费工夫','',''],['枉费心力','',''],['枉费心机','',''],['枉费心计','',''],['枉费日月','',''],['枉费时日','',''],['枉道事人','',''],['枉顾','',''],['枉驾','',''],['枋子','',''],['枋寮','',''],['枋寮乡','',''],['枋山','',''],['枋山乡','',''],['析义','',''],['析出','',''],['析取','',''],['析圭但爵','',''],['析律舞文','',''],['析律贰端','',''],['析毫剖厘','',''],['析法','',''],['析疑','',''],['析疑匡谬','',''],['析离','',''],['析缕分条','',''],['析骸易子','',''],['枕上','',''],['枕中鸿宝','',''],['枕冷衾寒','',''],['枕叶','',''],['枕块','',''],['枕垫','',''],['枕头','',''],['枕头夺','',''],['枕头套','',''],['枕头箱','',''],['枕头般','',''],['枕套','',''],['枕岩漱流','',''],['枕巾','',''],['枕席','',''],['枕席儿','',''],['枕心','',''],['枕戈坐甲','',''],['枕戈寝甲','',''],['枕戈尝胆','',''],['枕戈待敌','',''],['枕戈待旦','',''],['枕戈汗马','',''],['枕戈泣血','',''],['枕戈饮胆','',''],['枕木','',''],['枕梁','',''],['枕流漱石','',''],['枕状玄武岩','',''],['枕石漱流','',''],['枕芯','',''],['枕葄','',''],['枕藉','',''],['枕边','',''],['枕骨','',''],['林下','',''],['林下风气','',''],['林下风致','',''],['林下风范','',''],['林下高风','',''],['林业','',''],['林业厅','',''],['林业局','',''],['林业部','',''],['林业部门','',''],['林中','',''],['林丰正','',''],['林书豪','',''],['林产','',''],['林产化学','',''],['林产品','',''],['林克平大学','',''],['林兽','',''],['林内','',''],['林内乡','',''],['林农','',''],['林冠','',''],['林冲','',''],['林则徐','',''],['林副产品','',''],['林区','',''],['林卡','',''],['林县','',''],['林口乡','',''],['林可霉素','',''],['林园','',''],['林园乡','',''],['林地','',''],['林场','',''],['林型','',''],['林垦','',''],['林堡','',''],['林壑','',''],['林奈','',''],['林子','',''],['林学','',''],['林家翘','',''],['林带','',''],['林彪','',''],['林德布拉德','',''],['林心如','',''],['林忆莲','',''],['林恢复','',''],['林旭','',''],['林木','',''],['林木分化','',''],['林村','',''],['林来疯','',''],['林林总总','',''],['林森','',''],['林檎','',''],['林海','',''],['林涛','',''],['林火','',''],['林相','',''],['林立','',''],['林纾','',''],['林肯','',''],['林肯郡','',''],['林色','',''],['林苑','',''],['林茨','',''],['林荫','',''],['林荫大道','',''],['林荫夹道','',''],['林荫径','',''],['林荫道','',''],['林莽','',''],['林薮','',''],['林边','',''],['林边乡','',''],['林间','',''],['林阴','',''],['林阴大道','',''],['林雕','',''],['林雪平','',''],['林青霞','',''],['林黛玉','',''],['枘凿','',''],['枘圆凿方','',''],['枚举','',''],['枚乘','',''],['枚假','',''],['枚卜','',''],['果不其然','',''],['果为','',''],['果仁','',''],['果仁儿','',''],['果儿','',''],['果农','',''],['果决','',''],['果冻','',''],['果味','',''],['果味胶糖','',''],['果品','',''],['果啤','',''],['果园','',''],['果壳','',''],['果如其言','',''],['果如所料','',''],['果子','',''],['果子冻','',''],['果子狸','',''],['果子盐','',''],['果子酒','',''],['果子酱','',''],['果子露','',''],['果实','',''],['果实散播','',''],['果实累累','',''],['果岭','',''],['果心','',''],['果报','',''],['果播','',''],['果敢','',''],['果料','',''],['果料儿','',''],['果断','',''],['果是','',''],['果期','',''],['果木','',''],['果木园','',''],['果枝','',''],['果柄','',''],['果树','',''],['果树材','',''],['果核','',''],['果毅','',''],['果汁','',''],['果汁器','',''],['果汁机','',''],['果洛','',''],['果洛州','',''],['果渣','',''],['果焰糕点','',''],['果然','',''],['果然不出所料','',''],['果球','',''],['果皮','',''],['果盘','',''],['果真','',''],['果真如此','',''],['果穗','',''],['果类','',''],['果粉','',''],['果糖','',''],['果肉','',''],['果胶','',''],['果脯','',''],['果腹','',''],['果若','',''],['果菜','',''],['果蔬','',''],['果蔬酸酸乳','',''],['果虫','',''],['果蝇','',''],['果豆','',''],['果酒','',''],['果酱','',''],['果酸','',''],['果饵','',''],['果馅饼','',''],['枝丫','',''],['枝叶','',''],['枝叶扶疏','',''],['枝叶扶苏','',''],['枝城','',''],['枝城镇','',''],['枝多','',''],['枝头','',''],['枝子','',''],['枝干','',''],['枝形','',''],['枝捂','',''],['枝接','',''],['枝晶','',''],['枝杈','',''],['枝条','',''],['枝枒','',''],['枝枝节节','',''],['枝柯','',''],['枝桠','',''],['枝梧','',''],['枝状','',''],['枝繁','',''],['枝繁叶茂','',''],['枝节','',''],['枝节横生','',''],['枝蔓','',''],['枝解','',''],['枝词蔓语','',''],['枝附影从','',''],['枞木','',''],['枞树','',''],['枢垣','',''],['枢密院','',''],['枢机','',''],['枢机主教','',''],['枢纽','',''],['枢要','',''],['枢轴','',''],['枣子','',''],['枣树','',''],['枣椰','',''],['枣泥','',''],['枣红','',''],['枨触','',''],['枪乌贼','',''],['枪伤','',''],['枪决','',''],['枪击','',''],['枪击案','',''],['枪刺','',''],['枪匠','',''],['枪匪','',''],['枪口','',''],['枪响了','',''],['枪声','',''],['枪套','',''],['枪子','',''],['枪子儿','',''],['枪尖','',''],['枪尖形','',''],['枪崩','',''],['枪弹','',''],['枪战','',''],['枪手','',''],['枪打出头鸟','',''],['枪托','',''],['枪把','',''],['枪把儿','',''],['枪支','',''],['枪替','',''],['枪术','',''],['枪机','',''],['枪杀','',''],['枪杆','',''],['枪杆儿','',''],['枪杆子','',''],['枪林','',''],['枪林弹雨','',''],['枪林箭雨','',''],['枪枝','',''],['枪枪','',''],['枪柄','',''],['枪栓','',''],['枪械','',''],['枪榴弹','',''],['枪毙','',''],['枪法','',''],['枪炮','',''],['枪炮齐鸣','',''],['枪版','',''],['枪眼','',''],['枪矛','',''],['枪种','',''],['枪筒','',''],['枪管','',''],['枪膛','',''],['枪衣','',''],['枪身','',''],['枪闩','',''],['枪靶','',''],['枫叶','',''],['枫木','',''],['枫杨','',''],['枫树','',''],['枫香木','',''],['枫香树','',''],['枭雄','',''],['枭首','',''],['枭首示众','',''],['枯井','',''],['枯体灰心','',''],['枯叶','',''],['枯叶蛾','',''],['枯坐','',''],['枯寂','',''],['枯干','',''],['枯形灰心','',''],['枯木','',''],['枯木再生','',''],['枯木朽株','',''],['枯木死灰','',''],['枯木生花','',''],['枯木逢春','',''],['枯朽','',''],['枯枝','',''],['枯枝再春','',''],['枯树','',''],['枯树开花','',''],['枯株朽木','',''],['枯槁','',''],['枯死','',''],['枯水','',''],['枯水位','',''],['枯水期','',''],['枯涩','',''],['枯燥','',''],['枯燥乏味','',''],['枯燥无味','',''],['枯瘦','',''],['枯窘','',''],['枯竭','',''],['枯肠','',''],['枯茗','',''],['枯草','',''],['枯草杆菌','',''],['枯草热','',''],['枯菱','',''],['枯萎','',''],['枯萎病','',''],['枯饼','',''],['枯骨','',''],['枯鱼之肆','',''],['枯鱼涸辙','',''],['枯鱼病鹤','',''],['枯鱼衔索','',''],['枯黄','',''],['枯黑','',''],['枳壳','',''],['枳实','',''],['枳机草','',''],['枵肠辘辘','',''],['枵腹从公','',''],['枵腹重趼','',''],['架上','',''],['架不住','',''],['架二郎腿','',''],['架于','',''],['架住','',''],['架势','',''],['架塔','',''],['架好','',''],['架子','',''],['架子猪','',''],['架子花','',''],['架子车','',''],['架开','',''],['架式','',''],['架托梁','',''],['架有','',''],['架构','',''],['架构师','',''],['架架','',''],['架桥','',''],['架次','',''],['架海擎天','',''],['架海金梁','',''],['架电','',''],['架空','',''],['架空索道','',''],['架站','',''],['架线','',''],['架设','',''],['架谎凿空','',''],['架豆','',''],['架走','',''],['架起','',''],['枷带锁抓','',''],['枷板','',''],['枷销','',''],['枷锁','',''],['枸杞','',''],['枸杞子','',''],['枸橘','',''],['枸橼','',''],['柄勺','',''],['柄国','',''],['柄子','',''],['柄政','',''],['柄权','',''],['柄梢','',''],['柄端','',''],['柄脚','',''],['柄臣','',''],['柊叶','',''],['柏举之战','',''],['柏克莱','',''],['柏克郡','',''],['柏克里克千佛洞','',''],['柏崎','',''],['柏崎刈羽','',''],['柏崎市','',''],['柏悦','',''],['柏拉图','',''],['柏拉图哲学','',''],['柏木','',''],['柏林','',''],['柏林会议','',''],['柏林围墙','',''],['柏林墙','',''],['柏林工业大学','',''],['柏林战役','',''],['柏柏尔','',''],['柏树','',''],['柏油','',''],['柏油脚跟之州','',''],['柏油路','',''],['柏油马路','',''],['柏舟之节','',''],['柏舟之誓','',''],['柏节松操','',''],['柏蒂切利','',''],['柏辽兹','',''],['某一','',''],['某一个','',''],['某一地方','',''],['某一方面','',''],['某一时间','',''],['某个','',''],['某事','',''],['某些','',''],['某些人','',''],['某些地区','',''],['某些方面','',''],['某人','',''],['某件','',''],['某位','',''],['某军','',''],['某台','',''],['某君','',''],['某国','',''],['某地','',''],['某处','',''],['某大','',''],['某天','',''],['某女','',''],['某年','',''],['某日','',''],['某时','',''],['某月','',''],['某村','',''],['某某','',''],['某段','',''],['某物','',''],['某甲','',''],['某种','',''],['某种原因','',''],['某种意义','',''],['某种程度','',''],['某类','',''],['某部','',''],['某队','',''],['某项','',''],['柑子','',''],['柑桔','',''],['柑橘','',''],['柑橘园','',''],['柑橘酱','',''],['染上','',''],['染业','',''],['染丝之变','',''],['染剂','',''],['染化厂','',''],['染印','',''],['染印法','',''],['染厂','',''],['染发','',''],['染发剂','',''],['染坊','',''],['染工','',''],['染布','',''],['染得','',''],['染患','',''],['染成','',''],['染房','',''],['染手','',''],['染指','',''],['染指于鼎','',''],['染指垂涎','',''],['染料','',''],['染有','',''],['染毒','',''],['染污','',''],['染法','',''],['染疾','',''],['染病','',''],['染眉','',''],['染睫','',''],['染红','',''],['染织','',''],['染缸','',''],['染翰操纸','',''],['染色','',''],['染色体','',''],['染色体倍性','',''],['染色性','',''],['染色牢度','',''],['染色质','',''],['染花','',''],['染血','',''],['染遍','',''],['染风习俗','',''],['柔佛','',''],['柔佛州','',''],['柔佛海峡','',''],['柔光','',''],['柔和','',''],['柔声下气','',''],['柔如刚吐','',''],['柔姿纱','',''],['柔媚','',''],['柔嫩','',''],['柔弱','',''],['柔心弱骨','',''],['柔性','',''],['柔情','',''],['柔情似水','',''],['柔情侠骨','',''],['柔情媚态','',''],['柔情密意','',''],['柔情绰态','',''],['柔情脉脉','',''],['柔懦寡断','',''],['柔曼','',''],['柔术','',''],['柔板','',''],['柔枝嫩叶','',''],['柔枝嫩条','',''],['柔毛','',''],['柔毛状','',''],['柔滑','',''],['柔细','',''],['柔美','',''],['柔肠寸断','',''],['柔肠百结','',''],['柔肠百转','',''],['柔肤水','',''],['柔能克刚','',''],['柔能制刚','',''],['柔色','',''],['柔茹寡断','',''],['柔荑花序','',''],['柔软','',''],['柔软体操','',''],['柔软剂','',''],['柔软操','',''],['柔远能迩','',''],['柔道','',''],['柔韧','',''],['柔韧性','',''],['柔顺','',''],['柘丝','',''],['柘弓','',''],['柘弹','',''],['柘树','',''],['柘榴','',''],['柘榴石','',''],['柘浆','',''],['柘砚','',''],['柘蚕','',''],['柘袍','',''],['柘黄','',''],['柚子','',''],['柚木','',''],['柜上','',''],['柜台','',''],['柜子','',''],['柜房','',''],['柜架','',''],['柜柳','',''],['柜橱','',''],['柜组','',''],['柜船','',''],['柞丝','',''],['柞丝绸','',''],['柞栎','',''],['柞绸','',''],['柞蚕','',''],['柞蚕丝','',''],['柠檬','',''],['柠檬树','',''],['柠檬桉','',''],['柠檬水','',''],['柠檬汁','',''],['柠檬浮霉状菌','',''],['柠檬片','',''],['柠檬色','',''],['柠檬茶','',''],['柠檬草','',''],['柠檬酸','',''],['柠檬酸循环','',''],['柠檬鸡','',''],['查价','',''],['查克・诺里斯','',''],['查克拉','',''],['查克瑞','',''],['查兑者','',''],['查出','',''],['查到','',''],['查办','',''],['查加斯病','',''],['查勘','',''],['查号台','',''],['查哨','',''],['查处','',''],['查夜','',''],['查字','',''],['查字法','',''],['查完','',''],['查定','',''],['查实','',''],['查对','',''],['查寻','',''],['查封','',''],['查尔斯','',''],['查尔斯・格雷','',''],['查尔斯・狄更斯','',''],['查尔斯顿','',''],['查帐','',''],['查帐员','',''],['查戈斯群岛','',''],['查房','',''],['查找','',''],['查抄','',''],['查报','',''],['查拳','',''],['查探','',''],['查收','',''],['查无实据','',''],['查无此人','',''],['查明','',''],['查明具报','',''],['查普曼','',''],['查查','',''],['查核','',''],['查案','',''],['查清','',''],['查点','',''],['查照','',''],['查理大帝','',''],['查理定律','',''],['查理帝国','',''],['查看','',''],['查票','',''],['查票员','',''],['查禁','',''],['查私','',''],['查税','',''],['查究','',''],['查缉','',''],['查考','',''],['查获','',''],['查补','',''],['查表','',''],['查觉','',''],['查讫','',''],['查访','',''],['查证','',''],['查询','',''],['查询专线','',''],['查询电话','',''],['查调','',''],['查账','',''],['查过','',''],['查退','',''],['查透','',''],['查铺','',''],['查错','',''],['查问','',''],['查阅','',''],['查韦斯','',''],['查验','',''],['柩台','',''],['柩衣','',''],['柩车','',''],['柬吴哥王朝','',''],['柬国','',''],['柬埔寨人民党','',''],['柬帖','',''],['柯南・道尔','',''],['柯城','',''],['柯密','',''],['柯尔克孜','',''],['柯尔克孜语','',''],['柯林','',''],['柯林斯','',''],['柯棣华','',''],['柯沙奇病毒','',''],['柯萨奇病毒','',''],['柯西','',''],['柯达','',''],['柯邵忞','',''],['柰子','',''],['柱体','',''],['柱型图','',''],['柱塞','',''],['柱头','',''],['柱子','',''],['柱廊','',''],['柱式','',''],['柱形','',''],['柱形图','',''],['柱梁','',''],['柱状','',''],['柱石','',''],['柱身','',''],['柱面','',''],['柱顶','',''],['柳丁','',''],['柳丁氨醇','',''],['柳丝','',''],['柳体','',''],['柳公权','',''],['柳北','',''],['柳南','',''],['柳叶刀','',''],['柳叶眉','',''],['柳啼花怨','',''],['柳园','',''],['柳园镇','',''],['柳圣花神','',''],['柳媚花明','',''],['柳子戏','',''],['柳安','',''],['柳宗元','',''],['柳州地区','',''],['柳巷花街','',''],['柳影花阴','',''],['柳户花门','',''],['柳拐子病','',''],['柳暗花明','',''],['柳暗花明又一村','',''],['柳木','',''],['柳杉','',''],['柳杞','',''],['柳条','',''],['柳条做','',''],['柳条工','',''],['柳条帽','',''],['柳条沟事变','',''],['柳条编','',''],['柳条边','',''],['柳枝','',''],['柳树','',''],['柳橙','',''],['柳橙汁','',''],['柳毅传','',''],['柳永','',''],['柳烟花雾','',''],['柳琴','',''],['柳眉','',''],['柳眉倒竖','',''],['柳眉剔竖','',''],['柳眉踢竖','',''],['柳絮','',''],['柳绿桃红','',''],['柳绿花红','',''],['柳罐','',''],['柳腰','',''],['柳莺','',''],['柳营','',''],['柳营乡','',''],['柳陌花巷','',''],['柳陌花街','',''],['柳陌花衢','',''],['柳青','',''],['柴可夫斯基','',''],['柴堆','',''],['柴屋','',''],['柴扉','',''],['柴把','',''],['柴毁灭性','',''],['柴毁骨立','',''],['柴油','',''],['柴油发动机','',''],['柴油机','',''],['柴火','',''],['柴电机车','',''],['柴禾','',''],['柴禾妞','',''],['柴科夫斯基','',''],['柴窑','',''],['柴立不阿','',''],['柴米','',''],['柴米油盐','',''],['柴米油盐酱醋茶','',''],['柴胡','',''],['柴草','',''],['柴薪','',''],['柴达木','',''],['柴达木盆地','',''],['柴门','',''],['柴门小户','',''],['柴鸡','',''],['柽柳','',''],['柿子','',''],['柿子椒','',''],['柿霜','',''],['柿饼','',''],['栀子','',''],['栀子花','',''],['栅子','',''],['栅条','',''],['栅极','',''],['栅栏','',''],['栅格','',''],['栅篱','',''],['栅门','',''],['标书','',''],['标价','',''],['标会','',''],['标兵','',''],['标准','',''],['标准亩','',''],['标准以下','',''],['标准件','',''],['标准像','',''],['标准公顷','',''],['标准化','',''],['标准单位','',''],['标准台','',''],['标准唱片','',''],['标准国语','',''],['标准大气压','',''],['标准尺寸','',''],['标准工资','',''],['标准差','',''],['标准时','',''],['标准时区','',''],['标准时间','',''],['标准普尔','',''],['标准杆','',''],['标准框','',''],['标准模型','',''],['标准溶液','',''],['标准状况','',''],['标准状态','',''],['标准电阻','',''],['标准组织','',''],['标准规','',''],['标准规格','',''],['标准语','',''],['标准间','',''],['标准音','',''],['标出','',''],['标卖','',''],['标号','',''],['标同伐异','',''],['标名','',''],['标售','',''],['标器','',''],['标图','',''],['标图器','',''],['标地','',''],['标定','',''],['标尺','',''],['标帜','',''],['标底','',''],['标度','',''],['标引','',''],['标志','',''],['标志着','',''],['标志符','',''],['标新取异','',''],['标新立异','',''],['标新竞异','',''],['标新领导','',''],['标新领异','',''],['标明','',''],['标普','',''],['标有','',''],['标本','',''],['标本虫','',''],['标杆','',''],['标枪','',''],['标架','',''],['标柱','',''],['标格','',''],['标桩','',''],['标榜','',''],['标注','',''],['标灯','',''],['标点','',''],['标点符号','',''],['标牌','',''],['标用','',''],['标界','',''],['标的','',''],['标目','',''],['标砖','',''],['标示','',''],['标示符','',''],['标称','',''],['标称核武器','',''],['标竿','',''],['标签','',''],['标箱','',''],['标线','',''],['标绘','',''],['标统','',''],['标致','',''],['标记','',''],['标记原子','',''],['标识','',''],['标识器','',''],['标识符','',''],['标识语','',''],['标语','',''],['标语牌','',''],['标购','',''],['标重','',''],['标量','',''],['标金','',''],['标钢','',''],['标键','',''],['标间','',''],['标音','',''],['标音法','',''],['标题','',''],['标题为','',''],['标题之下','',''],['标题字','',''],['标题新闻','',''],['标题栏','',''],['标题语','',''],['标题音乐','',''],['标高','',''],['栈主','',''],['栈单','',''],['栈地址','',''],['栈存储器','',''],['栈山航海','',''],['栈径','',''],['栈恋','',''],['栈房','',''],['栈板','',''],['栈架','',''],['栈桥','',''],['栈桥式码头','',''],['栈租','',''],['栈豆','',''],['栈车','',''],['栈道','',''],['栈阁','',''],['栈顶','',''],['栉比','',''],['栉比鳞差','',''],['栉比鳞次','',''],['栉水母','',''],['栉风沐雨','',''],['栋号','',''],['栋墚','',''],['墚地','',''],['栋折榱崩','',''],['栋梁','',''],['栋梁之材','',''],['栎树','',''],['栏中','',''],['栏位','',''],['栏内','',''],['栏圈','',''],['栏块','',''],['栏外','',''],['栏干','',''],['栏式','',''],['栏把','',''],['栏数','',''],['栏杆','',''],['栏板','',''],['栏架','',''],['栏栅','',''],['栏目','',''],['树上','',''],['树上开花','',''],['树丛','',''],['树串儿','',''],['树人','',''],['树倒','',''],['树倒猢狲散','',''],['树冠','',''],['树凉儿','',''],['树化玉','',''],['树叶','',''],['树墩','',''],['树大招风','',''],['树大根深','',''],['树孔','',''],['树带','',''],['树干','',''],['树影','',''],['树德务滋','',''],['树心','',''],['树懒','',''],['树挂','',''],['树敌','',''],['树木','',''],['树木学','',''],['树木状','',''],['树杈','',''],['树林','',''],['树林市','',''],['树枝','',''],['树枝状晶','',''],['树栖','',''],['树根','',''],['树桩','',''],['树梢','',''],['树欲息而风不停','',''],['树欲静而风不宁','',''],['树欲静而风不止','',''],['树汁','',''],['树汁多','',''],['树洞','',''],['树液','',''],['树熊','',''],['树状','',''],['树状物','',''],['树状细胞','',''],['树獭','',''],['树皮','',''],['树皮布','',''],['树碑','',''],['树碑立传','',''],['树种','',''],['树稍','',''],['树穴','',''],['树突','',''],['树突状细胞','',''],['树立','',''],['树篱','',''],['树结','',''],['树胶','',''],['树胶质','',''],['树脂','',''],['树脂整理','',''],['树脂般','',''],['树脂酚','',''],['树节','',''],['树节点','',''],['树苗','',''],['树荫','',''],['树荫处','',''],['树莓','',''],['树葬','',''],['树薯粉','',''],['树蛙','',''],['树蜂','',''],['树行子','',''],['树袋熊','',''],['树轮','',''],['树阴','',''],['树阴凉儿','',''],['树高千丈落叶归根','',''],['树高招风','',''],['栓上','',''],['栓住','',''],['栓剂','',''],['栓塞','',''],['栓塞物','',''],['栓子','',''],['栓牢','',''],['栓皮','',''],['栓皮栎','',''],['栓绳','',''],['栓锁带','',''],['栖于','',''],['栖住','',''],['栖居','',''],['栖息','',''],['栖息于','',''],['栖息地','',''],['栖息鸟','',''],['栖所','',''],['栖木','',''],['栖枝','',''],['栖栖','',''],['栖止','',''],['栖身','',''],['栗子','',''],['栗暴','',''],['栗树','',''],['栗栗危惧','',''],['栗然','',''],['栗粒状','',''],['栗色','',''],['栗钙土','',''],['栗鼠','',''],['栝楼','',''],['校产','',''],['校党委','',''],['校内','',''],['校准','',''],['校刊','',''],['校办','',''],['校办工厂','',''],['校务','',''],['校勘','',''],['校勘学','',''],['校区','',''],['校医','',''],['校友','',''],['校友会','',''],['校史','',''],['校员','',''],['校团','',''],['校团委','',''],['校园','',''],['校地','',''],['校场','',''],['校址','',''],['校外','',''],['校外活动','',''],['校官','',''],['校定','',''],['校对','',''],['校对人','',''],['校对员','',''],['校对室','',''],['校对机','',''],['校对者','',''],['校尉','',''],['校属','',''],['校工','',''],['校庆','',''],['校徽','',''],['校报','',''],['校改','',''],['校方','',''],['校旗','',''],['校服','',''],['校本','',''],['校样','',''],['校检','',''],['校歌','',''],['校正','',''],['校正子','',''],['校正者','',''],['校点','',''],['校监','',''],['校稿','',''],['校站','',''],['校级','',''],['校编','',''],['校舍','',''],['校花','',''],['校草','',''],['校董','',''],['校规','',''],['校警','',''],['校订','',''],['校订本','',''],['校训','',''],['校车','',''],['校量','',''],['校长','',''],['校门','',''],['校间','',''],['校阅','',''],['校队','',''],['校际','',''],['校雠','',''],['校音','',''],['校风','',''],['校验','',''],['校验码','',''],['栩栩','',''],['栩栩如生','',''],['栩栩生辉','',''],['株守','',''],['株式','',''],['株式会社','',''],['株治','',''],['株距','',''],['株连','',''],['株选','',''],['栲属','',''],['栲栳','',''],['栲胶','',''],['栴檀','',''],['样书','',''],['样件','',''],['样例','',''],['样儿','',''],['样册','',''],['样单','',''],['样品','',''],['样品卡','',''],['样多','',''],['样子','',''],['样子好','',''],['样带','',''],['样式','',''],['样张','',''],['样本','',''],['样机','',''],['样条函数','',''],['样板','',''],['样板戏','',''],['样样','',''],['样款','',''],['样片','',''],['样稿','',''],['样窗','',''],['样貌','',''],['样貌端正','',''],['核不扩散','',''],['核事件','',''],['核交','',''],['核人','',''],['核仁','',''],['核价','',''],['核体','',''],['核僵持','',''],['核儿','',''],['核入','',''],['核军备','',''],['核冬天','',''],['核准','',''],['核减','',''],['核出口控制','',''],['核分裂','',''],['核力','',''],['核力量','',''],['核办','',''],['核动力','',''],['核动力航空母舰','',''],['核动力船','',''],['核势','',''],['核原料','',''],['核反击','',''],['核反应','',''],['核反应堆','',''],['核发','',''],['核发电','',''],['核发电厂','',''],['核变形','',''],['核合成','',''],['核后时代','',''],['核员','',''],['核四级共振','',''],['核国家','',''],['核地雷','',''],['核均势','',''],['核垄断','',''],['核型','',''],['核增','',''],['核外电子','',''],['核大国','',''],['核威','',''],['核威慑','',''],['核威慑力量','',''],['核威慑政策','',''],['核威胁','',''],['核子','',''],['核子力','',''],['核子医学','',''],['核子反应','',''],['核子武器','',''],['核子能','',''],['核安全','',''],['核定','',''],['核实','',''],['核对','',''],['核对峙','',''],['核对帐目','',''],['核导弹','',''],['核小体','',''],['核屏蔽','',''],['核工业','',''],['核工业部','',''],['核工程','',''],['核废物','',''],['核弹','',''],['核弹头','',''],['核当量','',''],['核心','',''],['核心作用','',''],['核心家庭','',''],['核心机密','',''],['核情报','',''],['核战','',''],['核战争','',''],['核战斗部','',''],['核战略','',''],['核扩散','',''],['核批','',''],['核技','',''],['核技术','',''],['核报','',''],['核推进','',''],['核收','',''],['核果','',''],['核查','',''],['核查小组','',''],['核柱','',''],['核桃','',''],['核桃仁','',''],['核桃虫','',''],['核模型','',''],['核武','',''],['核武器','',''],['核武库','',''],['核潜艇','',''],['核热','',''],['核燃料','',''],['核燃料后处理','',''],['核燃料燃耗','',''],['核爆','',''],['核爆炸','',''],['核爆炸装置','',''],['核物理','',''],['核球','',''],['核理论','',''],['核电','',''],['核电厂','',''],['核电磁脉冲','',''],['核电站','',''],['核电荷数','',''],['核相互作用','',''],['核碱基','',''],['核磁','',''],['核磁共振','',''],['核签','',''],['核算','',''],['核算单位','',''],['核糖','',''],['核糖体','',''],['核糖核酸','',''],['核素','',''],['核结构','',''],['核给','',''],['核聚变','',''],['核肉','',''],['核能','',''],['核能源','',''],['核膜','',''],['核自旋','',''],['核苷','',''],['核苷酸','',''],['核蛋白','',''],['核裁','',''],['核裁军','',''],['核裂变','',''],['核装置','',''],['核计','',''],['核讹诈','',''],['核讹诈政策','',''],['核设施','',''],['核证模型','',''],['核试','',''],['核试爆','',''],['核试验','',''],['核试验场','',''],['核试验堆','',''],['核谈判','',''],['核资','',''],['核转变','',''],['核轰炸','',''],['核轰炸机','',''],['核辐射','',''],['核连锁反应','',''],['核酮糖','',''],['核酸','',''],['核酸糖','',''],['核酸酶','',''],['核销','',''],['核门槛','',''],['核问题','',''],['核防御','',''],['核防护','',''],['核陀螺','',''],['核验','',''],['核黄素','',''],['根于','',''],['根儿','',''],['根冠','',''],['根号','',''],['根基','',''],['根壮叶茂','',''],['根外施肥','',''],['根子','',''],['根尖','',''],['根巧枝枯','',''],['根底','',''],['根式','',''],['根拔','',''],['根指数','',''],['根据','',''],['根据以上情况','',''],['根据具体情况','',''],['根据地','',''],['根据规定','',''],['根据需要和可能','',''],['根接','',''],['根插','',''],['根本','',''],['根本上','',''],['根本性','',''],['根本法','',''],['根柢','',''],['根植','',''],['根毛','',''],['根治','',''],['根深','',''],['根深叶茂','',''],['根深土长','',''],['根深蒂固','',''],['根源','',''],['根特','',''],['根状','',''],['根状茎','',''],['根状部','',''],['根由','',''],['根瘤','',''],['根瘤菌','',''],['根究','',''],['根系','',''],['根绝','',''],['根脚','',''],['根芽','',''],['根苗','',''],['根茎','',''],['根茬','',''],['根菜类蔬菜','',''],['根词','',''],['根部','',''],['根除','',''],['根音','',''],['格于成例','',''],['格令','',''],['格但斯克','',''],['格儿','',''],['格兰氏阴性','',''],['格兰特','',''],['格兰芬多','',''],['格列高利历','',''],['格力','',''],['格勒','',''],['格勒诺布尔','',''],['格古通今','',''],['格呢','',''],['格外','',''],['格子','',''],['格子呢','',''],['格子棉布','',''],['格子窗','',''],['格子花呢','',''],['格尔夫波特','',''],['格局','',''],['格式','',''],['格式上','',''],['格式化','',''],['格式塔','',''],['格式塔疗法','',''],['格式栏','',''],['格式纸','',''],['格形','',''],['格律','',''],['格律诗','',''],['格恩西岛','',''],['格拉','',''],['格拉斯哥','',''],['格拉汉姆','',''],['格拉纳达','',''],['格拉茨','',''],['格斗','',''],['格斯塔','',''],['格木','',''],['格杀不论','',''],['格杀勿论','',''],['格林','',''],['格林多','',''],['格林奈尔大学','',''],['格林威治','',''],['格林威治时间','',''],['格林威治村','',''],['格林威治标准时间','',''],['格林尼治','',''],['格林尼治本初子午线','',''],['格林尼治标准时间','',''],['格林斯班','',''],['格格','',''],['格格不入','',''],['格格笑','',''],['格洛斯特','',''],['格洛斯特郡','',''],['格洛纳斯','',''],['格涅沙','',''],['格物','',''],['格物穷理','',''],['格物致知','',''],['格状','',''],['格筛','',''],['格纸','',''],['格线','',''],['格网','',''],['格罗宁根','',''],['格致','',''],['格莱美奖','',''],['格萨尔','',''],['格言','',''],['格调','',''],['格里历','',''],['格里姆斯塔','',''],['格雷','',''],['格雷伯爵茶','',''],['格雷氏解剖学','',''],['格高意远','',''],['格鲁吉亚人','',''],['格鲁派','',''],['栽体','',''],['栽作','',''],['栽倒','',''],['栽培','',''],['栽培技术','',''],['栽培植物','',''],['栽培物','',''],['栽培者','',''],['栽子','',''],['栽树','',''],['栽植','',''],['栽法','',''],['栽种','',''],['栽种机','',''],['栽秧','',''],['栽绒','',''],['栽脏','',''],['栽花','',''],['栽赃','',''],['栽跟头','',''],['栽进','',''],['桀敖不驯','',''],['桀犬吠尧','',''],['桀王','',''],['桀纣','',''],['桀贪骜诈','',''],['桀逆放恣','',''],['桀骜','',''],['桀骜不恭','',''],['桀骜不逊','',''],['桀骜不驯','',''],['桀骜难驯','',''],['桀黠','',''],['桁杨','',''],['桁杨刀锯','',''],['桁架','',''],['桁梁','',''],['桂冠','',''],['桂剧','',''],['桂北越城岭','',''],['桂圆','',''],['桂子兰孙','',''],['桂子飘香','',''],['桂宫柏寝','',''],['桂月','',''],['桂林一枝','',''],['桂林医学院','',''],['桂林地区','',''],['桂枝','',''],['桂树','',''],['桂格','',''],['桂皮','',''],['桂系军阀','',''],['桂纶镁','',''],['桂芝','',''],['桂花','',''],['桂鱼','',''],['桃之夭夭','',''],['桃仁','',''],['桃园三结义','',''],['桃园结义','',''],['桃城','',''],['桃夹','',''],['桃子','',''],['桃山','',''],['桃心','',''],['桃木','',''],['桃李','',''],['桃李不言下自成蹊','',''],['桃李争妍','',''],['桃李争辉','',''],['桃李无言下自成蹊','',''],['桃李满天下','',''],['桃李遍天下','',''],['桃李门墙','',''],['桃来李答','',''],['桃柳争妍','',''],['桃树','',''],['桃核','',''],['桃汛','',''],['桃源乡','',''],['桃符','',''],['桃红','',''],['桃红柳绿','',''],['桃红色','',''],['桃羞杏让','',''],['桃胶','',''],['桃脯','',''],['桃腮杏脸','',''],['桃色','',''],['桃色新闻','',''],['桃色案件','',''],['桃色纠纷','',''],['桃花','',''],['桃花人面','',''],['桃花心木','',''],['桃花汛','',''],['桃花源','',''],['桃花薄命','',''],['桃花讯','',''],['桃花运','',''],['桃金娘','',''],['桃金娘科','',''],['桄子','',''],['桄榔','',''],['桅帆','',''],['桅木','',''],['桅杆','',''],['桅樯','',''],['桅灯','',''],['桅竿','',''],['桅船','',''],['桅顶','',''],['框儿','',''],['框内','',''],['框图','',''],['框子','',''],['框定','',''],['框架','',''],['框格','',''],['框框','',''],['框死','',''],['框缘','',''],['框项','',''],['案书','',''],['案人','',''],['案件','',''],['案例','',''],['案例法','',''],['案兵束甲','',''],['案册','',''],['案卷','',''],['案发','',''],['案发地点','',''],['案头','',''],['案子','',''],['案底','',''],['案情','',''],['案文','',''],['案板','',''],['案桌','',''],['案牍','',''],['案犯','',''],['案由','',''],['案甲休兵','',''],['案目','',''],['案秤','',''],['案称','',''],['案证','',''],['案诗','',''],['案语','',''],['案首','',''],['案验','',''],['桉叶油','',''],['桉树','',''],['桉油','',''],['桌上','',''],['桌上型','',''],['桌上型电脑','',''],['桌下','',''],['桌儿','',''],['桌别林','',''],['桌前','',''],['桌子','',''],['桌巾','',''],['桌布','',''],['桌架','',''],['桌案','',''],['桌椅','',''],['桌椅板凳','',''],['桌游','',''],['桌灯','',''],['桌球','',''],['桌脚','',''],['桌边','',''],['桌面','',''],['桌面儿','',''],['桌面儿上','',''],['桌面系统','',''],['桎梏','',''],['桐人','',''],['桐城派','',''],['桐子','',''],['桐木偶','',''],['桐柏山','',''],['桐油','',''],['桐油树','',''],['桑中之约','',''],['桑内斯','',''],['桑叶','',''],['桑园','',''],['桑地诺民族解放阵线','',''],['桑坦德','',''],['桑塔纳','',''],['桑寄生','',''],['桑巴','',''],['桑巴舞','',''],['桑帕约','',''],['桑弧蓬矢','',''],['桑德尔福德','',''],['桑德拉','',''],['桑托里尼岛','',''],['桑拿','',''],['桑枢瓮牖','',''],['桑树','',''],['桑梓','',''],['桑椹','',''],['桑榆','',''],['桑榆暮影','',''],['桑榆暮景','',''],['桑榆末景','',''],['桑海','',''],['桑田','',''],['桑白皮','',''],['桑皮纸','',''],['桑科','',''],['桑给巴尔','',''],['桑耶','',''],['桑葚','',''],['桑葚儿','',''],['桑蚕','',''],['桑象虫','',''],['桑那','',''],['桑间濮上','',''],['桓仁','',''],['桓仁县','',''],['桓桓','',''],['桓玄','',''],['桔子','',''],['桔树','',''],['桔梗','',''],['桔槔','',''],['桔汁','',''],['桔红','',''],['桔络','',''],['桔色','',''],['桔饼','',''],['桔黄','',''],['桠杈','',''],['桠枫','',''],['桡动脉','',''],['桡骨','',''],['桢干','',''],['档儿','',''],['档册','',''],['档卷','',''],['档口','',''],['档子','',''],['档期','',''],['档板','',''],['档案','',''],['档案传输协定','',''],['档案分配区','',''],['档案夹','',''],['档案学','',''],['档案室','',''],['档案局','',''],['档案属性','',''],['档案建立','',''],['档案总管','',''],['档案执行','',''],['档案服务','',''],['档案资料','',''],['档案转送','',''],['档案转送存取及管理','',''],['档案馆','',''],['档次','',''],['档距','',''],['桤木','',''],['桤树','',''],['桥上','',''],['桥下','',''],['桥东','',''],['桥台','',''],['桥堍','',''],['桥塔','',''],['桥墩','',''],['桥头','',''],['桥头乡','',''],['桥头堡','',''],['桥孔','',''],['桥式起重机','',''],['桥形','',''],['桥接','',''],['桥接器','',''],['桥本','',''],['桥本龙太郎','',''],['桥架','',''],['桥栏','',''],['桥桩','',''],['桥梁','',''],['桥洞','',''],['桥涵','',''],['桥牌','',''],['桥礅','',''],['桥粱','',''],['桥西','',''],['桥身','',''],['桥轴','',''],['桥那边','',''],['桥面','',''],['桦木','',''],['桦木科','',''],['桦林','',''],['桦树','',''],['桨叶','',''],['桨形','',''],['桨手','',''],['桩基','',''],['桩子','',''],['桩构栈道','',''],['桫椤','',''],['桴鼓相应','',''],['桶内','',''],['桶口','',''],['桶孔','',''],['桶形','',''],['桶槽','',''],['桶状','',''],['桶盖','',''],['桶装','',''],['桶里射鱼','',''],['梁上','',''],['梁上君子','',''],['梁书','',''],['梁启超','',''],['梁唐晋汉周书','',''],['梁园','',''],['梁子湖','',''],['梁山伯与祝英台','',''],['梁山市','',''],['梁朝','',''],['梁木','',''],['梁架','',''],['梁柱','',''],['梁湘','',''],['梁漱溟','',''],['梁祝','',''],['梁赞','',''],['梁辰鱼','',''],['梁静茹','',''],['梁龙','',''],['梃子','',''],['梅兰','',''],['梅兰芳','',''],['梅列','',''],['梅园','',''],['梅塞德斯奔驰','',''],['梅子','',''],['梅山','',''],['梅山乡','',''],['梅德韦杰夫','',''],['梅斯','',''],['梅斯梅尔','',''],['梅林','',''],['梅树','',''],['梅核气','',''],['梅森','',''],['梅森素数','',''],['梅毒','',''],['梅氏','',''],['梅氏腺','',''],['梅江','',''],['梅洛','',''],['梅派','',''],['梅瑟','',''],['梅的','',''],['梅童鱼','',''],['梅纳德','',''],['梅花','',''],['梅花大鼓','',''],['梅花形','',''],['梅花拳','',''],['梅花鹿','',''],['梅萨林','',''],['梅西叶','',''],['梅西叶星表','',''],['梅西耶','',''],['梅西耶星表','',''],['梅里亚姆・韦伯斯特','',''],['梅里斯','',''],['梅里斯区','',''],['梅里美','',''],['梅里雪山','',''],['梅雨','',''],['梆子','',''],['梆子腔','',''],['梆梆','',''],['梓官','',''],['梓官乡','',''],['梓童','',''],['梓里','',''],['梗塞','',''],['梗概','',''],['梗死','',''],['梗犬','',''],['梗直','',''],['梗米','',''],['梗阻','',''],['梢头','',''],['梢孔','',''],['梢部','',''],['梣树','',''],['梦中','',''],['梦中人','',''],['梦中说梦','',''],['梦乡','',''],['梦似','',''],['梦兆','',''],['梦兆熊罴','',''],['梦到','',''],['梦劳魂想','',''],['梦呓','',''],['梦呓者','',''],['梦境','',''],['梦寐','',''],['梦寐以求','',''],['梦幻','',''],['梦幻泡影','',''],['梦幻组合','',''],['梦幻般','',''],['梦想','',''],['梦想不到','',''],['梦想家','',''],['梦断魂劳','',''],['梦断魂消','',''],['梦景','',''],['梦梦','',''],['梦游','',''],['梦游症','',''],['梦游者','',''],['梦熊之喜','',''],['梦熟黄梁','',''],['梦神','',''],['梦笔生花','',''],['梦罗园','',''],['梦行症','',''],['梦行者','',''],['梦见','',''],['梦觉黄梁','',''],['梦话','',''],['梦语','',''],['梦遗','',''],['梦里','',''],['梦里南柯','',''],['梦里蝴蝶','',''],['梦魂颠倒','',''],['梦魇','',''],['梦魔','',''],['梧州地区','',''],['梧栖','',''],['梧栖镇','',''],['梧桐','',''],['梧桐木','',''],['梧桐科','',''],['梧鼠之技','',''],['梨俱吠陀','',''],['梨园','',''],['梨园子弟','',''],['梨园弟子','',''],['梨园戏','',''],['梨子','',''],['梨属','',''],['梨形','',''],['梨果','',''],['梨狗','',''],['梨膏','',''],['梨花','',''],['梨花大鼓','',''],['梨颊微涡','',''],['梭子','',''],['梭子蟹','',''],['梭子鱼','',''],['梭巡','',''],['梭标','',''],['梭梭','',''],['梭织','',''],['梭罗树','',''],['梭镖','',''],['梭鱼','',''],['梯也尔','',''],['梯子','',''],['梯山航海','',''],['梯己','',''],['梯度','',''],['梯度回波','',''],['梯式','',''],['梯式配股','',''],['梯形','',''],['梯恩梯','',''],['梯恩梯当量','',''],['梯板','',''],['梯架','',''],['梯次','',''],['梯次配备','',''],['梯次队形','',''],['梯河','',''],['梯状','',''],['梯田','',''],['梯级','',''],['梯级开发','',''],['梯绳','',''],['梯队','',''],['梯队式','',''],['梯阶式','',''],['械工','',''],['械库','',''],['械斗','',''],['械系','',''],['梳刷','',''],['梳头','',''],['梳头发','',''],['梳妆','',''],['梳妆台','',''],['梳妆室','',''],['梳子','',''],['梳成','',''],['梳拢','',''],['梳棉','',''],['梳毛','',''],['梳洗','',''],['梳理','',''],['梳篦','',''],['梳镜','',''],['梵书','',''],['梵册贝叶','',''],['梵刹','',''],['梵呗','',''],['梵哑铃','',''],['梵天','',''],['梵帝冈','',''],['梵教','',''],['梵文','',''],['梵汉对音','',''],['梵烧','',''],['梵蒂冈城','',''],['梵语','',''],['梵谛冈','',''],['梼杌','',''],['梿枷','',''],['检举','',''],['检举人','',''],['检修','',''],['检像镜','',''],['检具','',''],['检出','',''],['检印','',''],['检发','',''],['检场','',''],['检字','',''],['检字法','',''],['检字表','',''],['检定','',''],['检审','',''],['检察','',''],['检察员','',''],['检察学','',''],['检察官','',''],['检察机关','',''],['检察监督','',''],['检察长','',''],['检察院','',''],['检尘','',''],['检尸','',''],['检录','',''],['检控','',''],['检控官','',''],['检控方','',''],['检方','',''],['检束','',''],['检查','',''],['检查人','',''],['检查人员','',''],['检查员','',''],['检查哨','',''],['检查团','',''],['检查官','',''],['检查点','',''],['检查站','',''],['检查组','',''],['检查者','',''],['检查表','',''],['检校','',''],['检毒盒','',''],['检毒箱','',''],['检波','',''],['检波器','',''],['检流计','',''],['检测','',''],['检测仪','',''],['检测器','',''],['检漏','',''],['检点','',''],['检电','',''],['检疫','',''],['检疫所','',''],['检眼镜','',''],['检票','',''],['检票员','',''],['检索','',''],['检索语言','',''],['检视','',''],['检视镜','',''],['检讨','',''],['检证','',''],['检证程序','',''],['检错','',''],['检阅','',''],['检阅使','',''],['检阅台','',''],['检阅官','',''],['检附','',''],['检音器','',''],['检音计','',''],['检验','',''],['检验人','',''],['检验医学','',''],['检验员','',''],['检验法','',''],['棂床','',''],['棉丝','',''],['棉兰','',''],['棉兰老岛','',''],['棉农','',''],['棉制','',''],['棉区','',''],['棉卷','',''],['棉厂','',''],['棉垫','',''],['棉套','',''],['棉布','',''],['棉帽','',''],['棉束','',''],['棉条','',''],['棉枯萎病','',''],['棉树','',''],['棉桃','',''],['棉棒','',''],['棉毛','',''],['棉毛衫','',''],['棉毛裤','',''],['棉毯','',''],['棉火药','',''],['棉猴儿','',''],['棉球','',''],['棉瓦','',''],['棉田','',''],['棉白糖','',''],['棉签','',''],['棉籽','',''],['棉絮','',''],['棉红蜘蛛','',''],['棉红铃虫','',''],['棉纱','',''],['棉纸','',''],['棉纺','',''],['棉纺厂','',''],['棉纺织','',''],['棉纺织厂','',''],['棉线','',''],['棉织','',''],['棉织品','',''],['棉绒','',''],['棉缎','',''],['棉胎','',''],['棉花','',''],['棉花套子','',''],['棉花拳击','',''],['棉花棒','',''],['棉花糖','',''],['棉花绒','',''],['棉花胎','',''],['棉花蛆','',''],['棉药签','',''],['棉蚜','',''],['棉衣','',''],['棉袄','',''],['棉袍子','',''],['棉被','',''],['棉裤','',''],['棉铃','',''],['棉铃虫','',''],['棉麻','',''],['棉黄萎病','',''],['棋具','',''],['棋品','',''],['棋圣','',''],['棋坛','',''],['棋坛新秀','',''],['棋士','',''],['棋子','',''],['棋局','',''],['棋布星罗','',''],['棋战','',''],['棋手','',''],['棋格状','',''],['棋法','',''],['棋王','',''],['棋盘','',''],['棋盘格','',''],['棋社','',''],['棋类','',''],['棋艺','',''],['棋谱','',''],['棋赛','',''],['棋车','',''],['棋迷','',''],['棋逢对手','',''],['棋高','',''],['棍儿','',''],['棍儿茶','',''],['棍子','',''],['棍杖','',''],['棍棒','',''],['棒了','',''],['棒儿香','',''],['棒冰','',''],['棒喝','',''],['棒坛','',''],['棒头','',''],['棒子','',''],['棒子面','',''],['棒子面儿','',''],['棒打','',''],['棒旋星系','',''],['棒杀','',''],['棒材','',''],['棒极了','',''],['棒棒糖','',''],['棒槌','',''],['棒殴','',''],['棒状','',''],['棒球','',''],['棒球场','',''],['棒球运动','',''],['棒球迷','',''],['棒硫','',''],['棒磨机','',''],['棒糖','',''],['棒约翰','',''],['棕丝','',''],['棕刷','',''],['棕垫','',''],['棕头鸥','',''],['棕枝主日','',''],['棕枝全日','',''],['棕树','',''],['棕榈','',''],['棕榈属','',''],['棕榈树','',''],['棕榈油','',''],['棕榈科','',''],['棕毛','',''],['棕毯','',''],['棕熊','',''],['棕矮星','',''],['棕簑猫','',''],['棕红','',''],['棕绳','',''],['棕绷','',''],['棕编','',''],['棕缚','',''],['棕色','',''],['棕蓑猫','',''],['棕闾','',''],['棕黄','',''],['棕黑','',''],['棘手','',''],['棘枣','',''],['棘楚','',''],['棘爪','',''],['棘皮动物','',''],['棘轮','',''],['棘鼻青岛龙','',''],['棚内','',''],['棚圈','',''],['棚外','',''],['棚子','',''],['棚屋','',''],['棚布','',''],['棚式床','',''],['棚户','',''],['棚架','',''],['棚架格子','',''],['棚车','',''],['棚里','',''],['棚顶','',''],['棠树','',''],['棠梨','',''],['棠棣','',''],['棣棠','',''],['棣鄂','',''],['森・喜朗','',''],['森严','',''],['森严壁垒','',''],['森巴舞','',''],['森林','',''],['森林培育','',''],['森林学','',''],['森林法','',''],['森林脑炎','',''],['森林覆盖率','',''],['森森','',''],['森海塞尔','',''],['森然','',''],['森罗','',''],['森罗万象','',''],['森罗宝殿','',''],['森罗殿','',''],['森美兰','',''],['棱住体','',''],['棱台','',''],['棱子','',''],['棱柱','',''],['棱纹','',''],['棱线','',''],['棱缝','',''],['棱角','',''],['棱锥','',''],['棱锥台','',''],['棱镜','',''],['棵儿','',''],['棵子','',''],['棵树','',''],['棵粒','',''],['棺木','',''],['棺材','',''],['棺椁','',''],['棻芳','',''],['椅上','',''],['椅凳','',''],['椅垫','',''],['椅套','',''],['椅子','',''],['椅披','',''],['椅背','',''],['椆水','',''],['椆苕','',''],['椋鸟','',''],['植体','',''],['植保','',''],['植党营私','',''],['植入','',''],['植入式广告','',''],['植入物','',''],['植土','',''],['植林','',''],['植树','',''],['植树造林','',''],['植株','',''],['植根','',''],['植根于','',''],['植民','',''],['植物','',''],['植物人','',''],['植物人状态','',''],['植物保护','',''],['植物园','',''],['植物学','',''],['植物学家','',''],['植物性','',''],['植物性神经','',''],['植物油','',''],['植物状态','',''],['植物界','',''],['植物碱','',''],['植物纤维','',''],['植物群','',''],['植物群落','',''],['植物脂肪','',''],['植物茎','',''],['植皮','',''],['植皮术','',''],['植苗','',''],['植虫学','',''],['植虫类','',''],['植被','',''],['椎体','',''],['椎心泣血','',''],['椎牛飨士','',''],['椎轮大辂','',''],['椎间盘','',''],['椎骨','',''],['椐椐','',''],['椒房','',''],['椒江','',''],['椒油','',''],['椒盐','',''],['椭园','',''],['椭圆','',''],['椭圆体','',''],['椭圆函数','',''],['椭圆形','',''],['椭圆形办公室','',''],['椭圆曲线','',''],['椭圆机','',''],['椭圆积分','',''],['椭球','',''],['椰丝','',''],['椰壳','',''],['椰壳纤维','',''],['椰奶','',''],['椰子','',''],['椰子汁','',''],['椰子酒','',''],['椰揄','',''],['椰林','',''],['椰枣','',''],['椰油','',''],['椰浆','',''],['椰菜','',''],['椰菜花','',''],['椴木','',''],['椴杨','',''],['椴树','',''],['椽子','',''],['椿材','',''],['椿树','',''],['椿萱开貌','',''],['椿蚕','',''],['椿象','',''],['楔子','',''],['楔形','',''],['楔形文字','',''],['楔形物','',''],['楔状','',''],['楚人','',''],['楚剧','',''],['楚囚相对','',''],['楚国','',''],['楚地','',''],['楚尾吴头','',''],['楚州','',''],['楚庄王','',''],['楚弓楚得','',''],['楚怀王','',''],['楚暴诛乱','',''],['楚暴静乱','',''],['楚材晋用','',''],['楚楚','',''],['楚楚不凡','',''],['楚楚动人','',''],['楚楚可怜','',''],['楚歌','',''],['楚汉战争','',''],['楚河汉界','',''],['楚王','',''],['楚辞','',''],['楚雄州','',''],['楚馆秦楼','',''],['楞严','',''],['楞了','',''],['楞住','',''],['楞场','',''],['楞头','',''],['楞子眼','',''],['楞楞','',''],['楞脑','',''],['楞迦','',''],['楞迦岛','',''],['楠木','',''],['楠格哈尔省','',''],['楠梓','',''],['楠梓区','',''],['楠竹','',''],['楠西','',''],['楠西乡','',''],['楣梁','',''],['楦子','',''],['楮纸','',''],['楮遂良','',''],['楷书','',''],['楷体','',''],['楷字','',''],['楷模','',''],['楸树','',''],['楹联','',''],['楼上','',''],['楼下','',''],['楼举百捷','',''],['楼亭','',''],['楼兰','',''],['楼内','',''],['楼前','',''],['楼区','',''],['楼厢','',''],['楼去','',''],['楼台','',''],['楼台亭阁','',''],['楼号','',''],['楼基','',''],['楼堂','',''],['楼堂馆所','',''],['楼外','',''],['楼子','',''],['楼宇','',''],['楼层','',''],['楼市','',''],['楼库','',''],['楼座','',''],['楼房','',''],['楼板','',''],['楼梯','',''],['楼梯口','',''],['楼梯台','',''],['楼梯间','',''],['楼橹','',''],['楼盖','',''],['楼盘','',''],['楼群','',''],['楼船','',''],['楼道','',''],['楼里','',''],['楼门','',''],['楼阁','',''],['楼阁塔','',''],['楼面','',''],['楼顶','',''],['概不','',''],['概不例外','',''],['概予','',''],['概入','',''],['概况','',''],['概则','',''],['概叙','',''],['概叹','',''],['概图','',''],['概型','',''],['概型理论','',''],['概形','',''],['概念','',''],['概念上','',''],['概念依存模型','',''],['概念化','',''],['概念性','',''],['概念论','',''],['概念驱动加工','',''],['概括','',''],['概括化','',''],['概括性','',''],['概数','',''],['概测法','',''],['概率','',''],['概率和数理统计','',''],['概率论','',''],['概生','',''],['概略','',''],['概称','',''],['概算','',''],['概而','',''],['概莫能外','',''],['概要','',''],['概见一般','',''],['概观','',''],['概览','',''],['概论','',''],['概说','',''],['概貌','',''],['概述','',''],['榄角','',''],['榆叶梅','',''],['榆暝豆重','',''],['榆木','',''],['榆木脑壳','',''],['榆林地区','',''],['榆次','',''],['榆罔','',''],['榆荚','',''],['榆钱','',''],['榆阳','',''],['榈树','',''],['榉木','',''],['榔头','',''],['榔榆','',''],['榔槺','',''],['榕树','',''],['榛仁','',''],['榛仁儿','',''],['榛子','',''],['榛实','',''],['榛果','',''],['榛栗','',''],['榛榛','',''],['榛狉未改','',''],['榛色','',''],['榛芜','',''],['榛莽','',''],['榛薮','',''],['榛鸡','',''],['榜上无名','',''],['榜上有名','',''],['榜人','',''],['榜文','',''],['榜样','',''],['榜眼','',''],['榜笞','',''],['榜葛剌','',''],['榜首','',''],['榧子','',''],['榨出','',''],['榨取','',''],['榨寮','',''],['榨干','',''],['榨机','',''],['榨汁','',''],['榨汁机','',''],['榨油','',''],['榨油机','',''],['榨菜','',''],['榨葡萄','',''],['榨酒池','',''],['榫凿','',''],['榫头','',''],['榫子','',''],['榫接','',''],['榫眼','',''],['榫销','',''],['榴弹','',''],['榴弹炮','',''],['榴梿','',''],['榴梿果','',''],['榴火','',''],['榴莲','',''],['榴莲果','',''],['榴霰弹','',''],['榻榻米','',''],['榻米','',''],['槁木死灰','',''],['槁项黄馘','',''],['槌子','',''],['槌棒','',''],['槌状','',''],['槌球','',''],['槌骨沥髓','',''],['槐树','',''],['槐花','',''],['槐荫','',''],['槐蓝','',''],['槐蚕','',''],['槐豆','',''],['槐黄','',''],['槛猿笼鸟','',''],['槛花笼鹤','',''],['槛车','',''],['槜李','',''],['槟城','',''],['槟子','',''],['槟州','',''],['槟榔','',''],['槟榔屿','',''],['槟榔岛','',''],['槟榔树','',''],['槟榔膏','',''],['槟榔西施','',''],['槭木','',''],['槭糖浆','',''],['槲寄生','',''],['槲栎','',''],['槲树','',''],['槽中','',''],['槽具','',''],['槽内','',''],['槽口','',''],['槽坊','',''],['槽头','',''],['槽子','',''],['槽子糕','',''],['槽孔','',''],['槽床','',''],['槽牙','',''],['槽糕','',''],['槽车','',''],['槽轮','',''],['槽钢','',''],['樊城','',''],['樊笼','',''],['樊篱','',''],['樗栎','',''],['樗栎庸才','',''],['樗蒲','',''],['樗蚕','',''],['樟木','',''],['樟脑','',''],['樟脑丸','',''],['樟脑球','',''],['樟蚕','',''],['模件','',''],['模仿','',''],['模仿品','',''],['模仿者','',''],['模仿鸟','',''],['模似','',''],['模倣','',''],['模具','',''],['模具钢','',''],['模压','',''],['模块','',''],['模块化','',''],['模块化理论','',''],['模块单元','',''],['模块式','',''],['模块板','',''],['模型','',''],['模型论','',''],['模壳','',''],['模子','',''],['模式','',''],['模式化','',''],['模式标本','',''],['模式种','',''],['模形','',''],['模态','',''],['模拟','',''],['模拟信号','',''],['模拟器','',''],['模拟放大器','',''],['模拟电子计算机','',''],['模数','',''],['模本','',''],['模板','',''],['模架','',''],['模样','',''],['模棱','',''],['模棱两可','',''],['模模糊糊','',''],['模版','',''],['模版工','',''],['模特','',''],['模特儿','',''],['模糊','',''],['模糊不清','',''],['模糊学','',''],['模糊数学','',''],['模糊论','',''],['模糊逻辑','',''],['模组','',''],['模胡','',''],['模范','',''],['模迹','',''],['模里','',''],['模锻','',''],['横七竖八','',''],['横三竖四','',''],['横事','',''],['横亘','',''],['横体','',''],['横侧','',''],['横倒竖歪','',''],['横写','',''],['横冲直撞','',''],['横击','',''],['横刀','',''],['横刀夺爱','',''],['横切','',''],['横切面','',''],['横列','',''],['横剖','',''],['横剖面','',''],['横加','',''],['横加干涉','',''],['横加指责','',''],['横匾','',''],['横卧','',''],['横向','',''],['横向发展','',''],['横向经济联合','',''],['横向联合','',''],['横在','',''],['横坐标','',''],['横头横脑','',''],['横宽','',''],['横尸遍野','',''],['横山乡','',''],['横帆船','',''],['横幅','',''],['横幅标语','',''],['横座标','',''],['横征暴敛','',''],['横心','',''],['横截','',''],['横截线','',''],['横截面','',''],['横扫','',''],['横扫千军','',''],['横批','',''],['横折','',''],['横披','',''],['横拖倒拽','',''],['横挑鼻子','',''],['横挑鼻子竖挑眼','',''],['横振动','',''],['横排','',''],['横摺','',''],['横放','',''],['横放物','',''],['横斜','',''],['横斜钩','',''],['横断','',''],['横断山脉','',''],['横断步道','',''],['横断物','',''],['横断面','',''],['横是','',''],['横暴','',''],['横木','',''],['横杆','',''],['横杠','',''],['横条','',''],['横标','',''],['横栏','',''],['横桁帆','',''],['横档','',''],['横梁','',''],['横棱纹','',''],['横楣','',''],['横楣子','',''],['横槊赋诗','',''],['横槟','',''],['横正暴敛','',''],['横步','',''],['横死','',''],['横殃飞祸','',''],['横段山脉','',''],['横比','',''],['横波','',''],['横流','',''],['横浜','',''],['横渡','',''],['横溢','',''],['横滨','',''],['横滨市','',''],['横滨轮胎','',''],['横灾飞祸','',''],['横爬行','',''],['横生','',''],['横生枝节','',''],['横痃','',''],['横直','',''],['横眉','',''],['横眉冷对','',''],['横眉冷对千夫指','',''],['横眉怒目','',''],['横眉立目','',''],['横眼','',''],['横着','',''],['横神经','',''],['横祸','',''],['横祸非灾','',''],['横祸飞灾','',''],['横科暴敛','',''],['横空','',''],['横穿','',''],['横竖','',''],['横竖劲儿','',''],['横笔','',''],['横笛','',''],['横筋斗','',''],['横粱','',''],['横系','',''],['横纲','',''],['横纹','',''],['横纹肌','',''],['横线','',''],['横结','',''],['横结肠','',''],['横肉','',''],['横膈','',''],['横膈膜','',''],['横草之功','',''],['横蛮','',''],['横行','',''],['横行天下','',''],['横行无忌','',''],['横行直撞','',''],['横行霸道','',''],['横街','',''],['横议','',''],['横说竖说','',''],['横财','',''],['横贯','',''],['横赋暴敛','',''],['横越','',''],['横跨','',''],['横路','',''],['横躺','',''],['横躺竖卧','',''],['横轴','',''],['横过','',''],['横逆','',''],['横造','',''],['横道','',''],['横遭','',''],['横钩','',''],['横队','',''],['横陈','',''],['横隔','',''],['横隔膜','',''],['横面','',''],['横须','',''],['横须贺','',''],['横须贺市','',''],['横额','',''],['横飞','',''],['横骨','',''],['樯头','',''],['樱岛','',''],['樱桃','',''],['樱桃园','',''],['樱桃小番茄','',''],['樱桃色','',''],['樱桃酒','',''],['樱花','',''],['樱花草','',''],['樱草','',''],['樵夫','',''],['樵子','',''],['樽罍','',''],['橄榄','',''],['橄榄山','',''],['橄榄岩','',''],['橄榄形','',''],['橄榄枝','',''],['橄榄树','',''],['橄榄油','',''],['橄榄球','',''],['橄榄石','',''],['橄榄绿','',''],['橄榄色','',''],['橇棍','',''],['橐中装','',''],['橐囊','',''],['橐橐','',''],['橐笔','',''],['橐笥','',''],['橐驼','',''],['橐龠','',''],['橘园','',''],['橘子','',''],['橘子水','',''],['橘子汁','',''],['橘子酱','',''],['橘录','',''],['橘柑','',''],['橘树','',''],['橘皮组织','',''],['橘类','',''],['橘红','',''],['橘红色','',''],['橘络','',''],['橘色','',''],['橘黄','',''],['橘黄色','',''],['橙兰','',''],['橙剂','',''],['橙子','',''],['橙带','',''],['橙树','',''],['橙汁','',''],['橙皮果酱','',''],['橙红','',''],['橙红色','',''],['橙色','',''],['橙色剂','',''],['橙色战剂','',''],['橙黄','',''],['橛子','',''],['橡子面','',''],['橡子面儿','',''],['橡实','',''],['橡木','',''],['橡木制','',''],['橡树','',''],['橡栗','',''],['橡浆','',''],['橡皮','',''],['橡皮图章','',''],['橡皮圈','',''],['橡皮擦','',''],['橡皮树','',''],['橡皮泥','',''],['橡皮球','',''],['橡皮筋','',''],['橡皮糖','',''],['橡皮线','',''],['橡皮膏','',''],['橡皮船','',''],['橡皮艇','',''],['橡胶','',''],['橡胶布','',''],['橡胶树','',''],['橡胶草','',''],['橡胶鞋','',''],['橡饭菁羹','',''],['橱子','',''],['橱师','',''],['橱柜','',''],['橱灯','',''],['橱窗','',''],['檀君','',''],['檀君王','',''],['檀木','',''],['檀板','',''],['檀树','',''],['檀色','',''],['檀郎谢女','',''],['檀香','',''],['檀香山','',''],['檀香树','',''],['檃栝','',''],['檄书','',''],['檄文','',''],['檐下','',''],['檐口','',''],['檐子','',''],['檐沟','',''],['檑木','',''],['檠天架海','',''],['檩子','',''],['檩条','',''],['檬树','',''],['檵木','',''],['檵花','',''],['櫆师','',''],['欠下','',''],['欠交','',''],['欠产','',''],['欠付','',''],['欠伸','',''],['欠佳','',''],['欠债','',''],['欠债还钱','',''],['欠妥','',''],['欠安','',''],['欠帐','',''],['欠席','',''],['欠当','',''],['欠思','',''],['欠思考','',''],['欠思虑','',''],['欠慎重','',''],['欠户','',''],['欠扁','',''],['欠拨','',''],['欠据','',''],['欠揍','',''],['欠收','',''],['欠收自补','',''],['欠时','',''],['欠明','',''],['欠条','',''],['欠款','',''],['欠爽','',''],['欠的','',''],['欠着','',''],['欠租','',''],['欠税','',''],['欠缴','',''],['欠缺','',''],['欠考虑','',''],['欠薪','',''],['欠账','',''],['欠费','',''],['欠资','',''],['欠身','',''],['欠钱','',''],['欠项','',''],['次一个','',''],['次下标','',''],['次之','',''],['次于','',''],['次亚硫酸钠','',''],['次位','',''],['次佳','',''],['次元','',''],['次内','',''],['次品','',''],['次声武器','',''],['次声波','',''],['次大陆','',''],['次女','',''],['次好','',''],['次子','',''],['次官','',''],['次布','',''],['次幂','',''],['次年','',''],['次序','',''],['次性','',''],['次数','',''],['次文化','',''],['次料','',''],['次方','',''],['次於','',''],['次日','',''],['次月','',''],['次有限战争','',''],['次次','',''],['次氧','',''],['次氯酸','',''],['次源正本','',''],['次溴酸','',''],['次生','',''],['次生林','',''],['次生灾害','',''],['次生矿物','',''],['次目标','',''],['次第','',''],['次等','',''],['次级','',''],['次级品','',''],['次级房屋信贷危机','',''],['次级抵押贷款','',''],['次级线圈','',''],['次级贷款','',''],['次经','',''],['次要','',''],['次语','',''],['次货','',''],['次贫','',''],['次贷','',''],['次贷危机','',''],['次重量级','',''],['次长','',''],['次革','',''],['次音速','',''],['次韵','',''],['次页','',''],['欢乐','',''],['欢乐时光','',''],['欢乐歌','',''],['欢势','',''],['欢呼','',''],['欢呼声','',''],['欢呼雀跃','',''],['欢呼雷动','',''],['欢唱','',''],['欢喜','',''],['欢喜冤家','',''],['欢场','',''],['欢声','',''],['欢声笑语','',''],['欢声雷动','',''],['欢天','',''],['欢天喜地','',''],['欢娱','',''],['欢娱嫌夜短','',''],['欢实','',''],['欢宴','',''],['欢容悦色','',''],['欢庆','',''],['欢度','',''],['欢心','',''],['欢心若狂','',''],['欢快','',''],['欢忻踊跃','',''],['欢忻鼓舞','',''],['欢悦','',''],['欢愉','',''],['欢欢喜喜','',''],['欢欣','',''],['欢欣踊跃','',''],['欢欣雀跃','',''],['欢欣鼓舞','',''],['欢歌笑语','',''],['欢然','',''],['欢畅','',''],['欢眉喜眼','',''],['欢笑','',''],['欢聚','',''],['欢聚一堂','',''],['欢腾','',''],['欢苗爱叶','',''],['欢若平生','',''],['欢跃','',''],['欢跳','',''],['欢蹦乱跳','',''],['欢迎','',''],['欢迎仪式','',''],['欢迎会','',''],['欢迎光临','',''],['欢迎垂询','',''],['欢迎宴会','',''],['欢迎惠顾','',''],['欢迎词','',''],['欢迸乱跳','',''],['欢送','',''],['欢送会','',''],['欢酒','',''],['欢闹','',''],['欢颜','',''],['欣喜','',''],['欣喜若狂','',''],['欣喜雀跃','',''],['欣幸','',''],['欣弗','',''],['欣忭','',''],['欣悉','',''],['欣悦','',''],['欣慰','',''],['欣欣','',''],['欣欣向荣','',''],['欣欣自得','',''],['欣然','',''],['欣然命笔','',''],['欣然自乐','',''],['欣然自喜','',''],['欣然自得','',''],['欣生恶死','',''],['欣羡','',''],['欣赏','',''],['欧亚','',''],['欧亚大陆','',''],['欧亚经济共同体','',''],['欧人','',''],['欧仁','',''],['欧伯林','',''],['欧体','',''],['欧元','',''],['欧元区','',''],['欧共体','',''],['欧几里得','',''],['欧几里德','',''],['欧分','',''],['欧化','',''],['欧吉桑','',''],['欧姆','',''],['欧姆定律','',''],['欧姆蛋','',''],['欧姆表','',''],['欧姆计','',''],['欧安会','',''],['欧安组织','',''],['欧宝','',''],['欧巴桑','',''],['欧巴马','',''],['欧式','',''],['欧式几何','',''],['欧式几何学','',''],['欧当归','',''],['欧拉','',''],['欧文','',''],['欧文斯','',''],['欧柏林','',''],['欧查果','',''],['欧椋鸟','',''],['欧氏','',''],['欧氏几何学','',''],['欧氏管','',''],['欧泊','',''],['欧洲','',''],['欧洲中央银行','',''],['欧洲之星','',''],['欧洲产','',''],['欧洲人','',''],['欧洲共同体','',''],['欧洲共同市场','',''],['欧洲刑警组织','',''],['欧洲原子能联营','',''],['欧洲国家','',''],['欧洲大陆','',''],['欧洲安全与合作组织','',''],['欧洲安全和合作组织','',''],['欧洲山杨','',''],['欧洲杯','',''],['欧洲核子中心','',''],['欧洲核子研究中心','',''],['欧洲法院','',''],['欧洲理事会','',''],['欧洲电视','',''],['欧洲电视歌唱赛','',''],['欧洲联盟','',''],['欧洲自由贸易联盟','',''],['欧洲航天局','',''],['欧洲议会','',''],['欧洲语言','',''],['欧洲货币','',''],['欧洲防风','',''],['欧珀莱','',''],['欧盟','',''],['欧盟委员会','',''],['欧米伽','',''],['欧罗巴','',''],['欧罗巴人种','',''],['欧罗巴洲','',''],['欧美','',''],['欧美同学会','',''],['欧芹','',''],['欧若拉','',''],['欧莱雅','',''],['欧莳萝','',''],['欧蝶鱼','',''],['欧西','',''],['欧语','',''],['欧车前','',''],['欧里庇得斯','',''],['欧阳','',''],['欧阳予倩','',''],['欧阳修','',''],['欧阳询','',''],['欧陆','',''],['欧非','',''],['欧风美雨','',''],['欲与','',''],['欲了解','',''],['欲人勿知莫若勿为','',''],['欲人勿闻莫若勿言','',''],['欲仙','',''],['欲倒','',''],['欲加之罪','',''],['欲加之罪何患无辞','',''],['欲取','',''],['欲取姑与','',''],['欲取姑予','',''],['欲取故与','',''],['欲售','',''],['欲善其事','',''],['欲壑难填','',''],['欲女','',''],['欲将','',''],['欲得','',''],['欲念','',''],['欲想','',''],['欲报复','',''],['欲振乏力','',''],['欲擒','',''],['欲擒故纵','',''],['欲望','',''],['欲求','',''],['欲海','',''],['欲滴','',''],['欲火','',''],['欲火焚身','',''],['欲益反损','',''],['欲盖弥彰','',''],['欲盖而彰','',''],['欲睡','',''],['欲穷千里目','',''],['欲绝','',''],['欲罢','',''],['欲罢不能','',''],['欲罪','',''],['欲补','',''],['欲裂','',''],['欲言又止','',''],['欲设','',''],['欲试','',''],['欲语','',''],['欲说又止','',''],['欲说还休','',''],['欲速不达','',''],['欲速则不达','',''],['欲速而不达','',''],['欷吁','',''],['欷歔','',''],['欺三瞒四','',''],['欺上压下','',''],['欺上瞒下','',''],['欺上罔下','',''],['欺世乱俗','',''],['欺世惑众','',''],['欺世惑俗','',''],['欺世盗名','',''],['欺世罔俗','',''],['欺世钓誉','',''],['欺主罔上','',''],['欺人','',''],['欺人之谈','',''],['欺人太甚','',''],['欺人者','',''],['欺人自欺','',''],['欺以其方','',''],['欺侮','',''],['欺公罔法','',''],['欺凌','',''],['欺压','',''],['欺君','',''],['欺君罔上','',''],['欺君误国','',''],['欺哄','',''],['欺善怕恶','',''],['欺大压小','',''],['欺天罔人','',''],['欺天罔地','',''],['欺天诳地','',''],['欺心','',''],['欺生','',''],['欺男霸女','',''],['欺瞒','',''],['欺瞒夹帐','',''],['欺硬怕软','',''],['欺蒙','',''],['欺诈','',''],['欺诈者','',''],['欺负','',''],['欺软','',''],['欺软怕硬','',''],['欺辱','',''],['欺霜傲雪','',''],['欺骗','',''],['欺骗性','',''],['欺骗者','',''],['欺骗著','',''],['款人','',''],['款以','',''],['款伏','',''],['款儿','',''],['款冬','',''],['款启寡闻','',''],['款员','',''],['款型','',''],['款子','',''],['款学寡闻','',''],['款宴','',''],['款度','',''],['款式','',''],['款待','',''],['款新','',''],['款曲','',''],['款服','',''],['款款','',''],['款步','',''],['款洽','',''],['款源','',''],['款物','',''],['款留','',''],['款目','',''],['款簿','',''],['款级','',''],['款识','',''],['款语温言','',''],['款语移时','',''],['款赠','',''],['款项','',''],['款额','',''],['欿然','',''],['歃血','',''],['歃血为盟','',''],['歃血为誓','',''],['歃血而盟','',''],['歆慕','',''],['歆羡','',''],['歇下','',''],['歇业','',''],['歇乏','',''],['歇伏','',''],['歇凉','',''],['歇后','',''],['歇后语','',''],['歇夏','',''],['歇宿','',''],['歇工','',''],['歇心','',''],['歇息','',''],['歇手','',''],['歇斯底里','',''],['歇晌','',''],['歇枝','',''],['歇气','',''],['歇洛克・福尔摩斯','',''],['歇火','',''],['歇班','',''],['歇着','',''],['歇肩','',''],['歇脚','',''],['歇腿','',''],['歇艎','',''],['歇荫','',''],['歇菜','',''],['歇闲','',''],['歇鞍','',''],['歇顶','',''],['歉仄','',''],['歉年','',''],['歉意','',''],['歉收','',''],['歉疚','',''],['歉虚','',''],['歌仔戏','',''],['歌会','',''],['歌儿','',''],['歌利亚','',''],['歌剧','',''],['歌剧团','',''],['歌剧院','',''],['歌剧院魅影','',''],['歌功颂德','',''],['歌厅','',''],['歌台舞榭','',''],['歌吟','',''],['歌咏','',''],['歌唱','',''],['歌唱家','',''],['歌唱演员','',''],['歌唱赛','',''],['歌唱队','',''],['歌喉','',''],['歌坛','',''],['歌声','',''],['歌声绕梁','',''],['歌女','',''],['歌妓','',''],['歌姬','',''],['歌子','',''],['歌德','',''],['歌手','',''],['歌星','',''],['歌曲','',''],['歌曲集','',''],['歌本','',''],['歌楼舞管','',''],['歌王','',''],['歌碟','',''],['歌筵','',''],['歌组','',''],['歌罗西','',''],['歌罗西书','',''],['歌者','',''],['歌舞','',''],['歌舞伎','',''],['歌舞会','',''],['歌舞剧','',''],['歌舞升平','',''],['歌舞厅','',''],['歌舞团','',''],['歌舞太平','',''],['歌舞妓','',''],['歌莺舞燕','',''],['歌诀','',''],['歌词','',''],['歌诗达邮轮','',''],['歌调','',''],['歌谣','',''],['歌谱','',''],['歌迷','',''],['歌集','',''],['歌颂','',''],['歌鸲','',''],['歙人','',''],['歙漆阿胶','',''],['止不住','',''],['止于','',''],['止于至善','',''],['止付','',''],['止住','',''],['止咳','',''],['止咳糖浆','',''],['止境','',''],['止怒','',''],['止息','',''],['止戈为武','',''],['止戈兴仁','',''],['止戈散马','',''],['止扮自修','',''],['止损点','',''],['止日','',''],['止暴禁非','',''],['止期','',''],['止步','',''],['止汗剂','',''],['止泻','',''],['止泻剂','',''],['止渴','',''],['止渴思梅','',''],['止渴饮鸩','',''],['止疼片','',''],['止痒','',''],['止痛','',''],['止痛剂','',''],['止痛法','',''],['止痛片','',''],['止痛药','',''],['止血','',''],['止血器','',''],['止血垫','',''],['止血栓','',''],['止血钳','',''],['止谤莫若自修','',''],['止跌','',''],['止闹按钮','',''],['正丁醚','',''],['正三角形','',''],['正上','',''],['正下方','',''],['正业','',''],['正东','',''],['正中','',''],['正中下怀','',''],['正中己怀','',''],['正中要害','',''],['正义','',''],['正义事业','',''],['正义党','',''],['正义感','',''],['正义战争','',''],['正义斗争','',''],['正义者同盟','',''],['正书','',''],['正事','',''],['正交','',''],['正交基','',''],['正交群','',''],['正人先正己','',''],['正人君子','',''],['正从','',''],['正仓院','',''],['正传','',''],['正位','',''],['正体','',''],['正体字','',''],['正值','',''],['正像','',''],['正六边形','',''],['正兰旗','',''],['正典','',''],['正册','',''],['正冠李下','',''],['正冠纳履','',''],['正凶','',''],['正击','',''],['正切','',''],['正则','',''],['正则参数','',''],['正前方','',''],['正剧','',''],['正副','',''],['正割','',''],['正化','',''],['正北','',''],['正午','',''],['正半轴','',''],['正南','',''],['正厅','',''],['正压','',''],['正反','',''],['正反两方面','',''],['正反两面','',''],['正反器','',''],['正反面','',''],['正取','',''],['正句','',''],['正史','',''],['正号','',''],['正合适','',''],['正名','',''],['正名责实','',''],['正向','',''],['正向前看','',''],['正告','',''],['正和','',''],['正品','',''],['正在','',''],['正型','',''],['正堂','',''],['正声雅音','',''],['正处','',''],['正处于','',''],['正处在','',''],['正外部性','',''],['正多胞形','',''],['正多边形','',''],['正多面体','',''],['正大','',''],['正大光明','',''],['正大堂皇','',''],['正太','',''],['正太控','',''],['正太铁路','',''],['正好','',''],['正好是','',''],['正如','',''],['正妹','',''],['正子','',''],['正字','',''],['正字法','',''],['正字法模式','',''],['正字法空间','',''],['正字法规则','',''],['正字法阶段','',''],['正学','',''],['正宗','',''],['正室','',''],['正宫娘娘','',''],['正对','',''],['正对着','',''],['正屋','',''],['正巧','',''],['正差','',''],['正己守道','',''],['正币','',''],['正帮','',''],['正常','',''],['正常人','',''],['正常值','',''],['正常关系','',''],['正常化','',''],['正常工作','',''],['正常情况','',''],['正常成本','',''],['正常渠道','',''],['正常现象','',''],['正常生产','',''],['正常生活','',''],['正常秩序','',''],['正常运转','',''],['正座','',''],['正式','',''],['正式化','',''],['正式开始','',''],['正式成立','',''],['正式投票','',''],['正式访问','',''],['正弦','',''],['正弦定理','',''],['正弦形','',''],['正弦波','',''],['正当','',''],['正当中','',''],['正当化','',''],['正当年','',''],['正当性','',''],['正当手段','',''],['正当时','',''],['正当权利','',''],['正当权益','',''],['正当理由','',''],['正当防卫','',''],['正待','',''],['正德','',''],['正心诚意','',''],['正念','',''],['正态分布','',''],['正急','',''],['正想','',''],['正意','',''],['正成大错','',''],['正房','',''],['正手','',''],['正扭','',''],['正投影','',''],['正教','',''],['正教真诠','',''],['正数','',''],['正整数','',''],['正文','',''],['正断层','',''],['正方','',''],['正方体','',''],['正方向','',''],['正方形','',''],['正旦','',''],['正时','',''],['正是','',''],['正本','',''],['正本清源','',''],['正本溯源','',''],['正本澄源','',''],['正极','',''],['正果','',''],['正桥','',''],['正梁','',''],['正楷','',''],['正欢','',''],['正正','',''],['正正堂堂','',''],['正步','',''],['正步走','',''],['正殿','',''],['正比','',''],['正比例','',''],['正气','',''],['正没','',''],['正法','',''],['正法直度','',''],['正法眼藏','',''],['正派','',''],['正港','',''],['正点','',''],['正点背画','',''],['正然','',''],['正片','',''],['正片儿','',''],['正版','',''],['正牙带环','',''],['正理','',''],['正生','',''],['正用','',''],['正由','',''],['正电','',''],['正电子','',''],['正电子发射体层','',''],['正电子发射层析','',''],['正电子发射断层照相术','',''],['正电子发射计算机断层','',''],['正电子断层','',''],['正电子照射断层摄影','',''],['正电荷','',''],['正盐','',''],['正盛','',''],['正直','',''],['正直无私','',''],['正直无邪','',''],['正相','',''],['正相反','',''],['正眼','',''],['正着','',''],['正确','',''],['正确率','',''],['正确地','',''],['正确处理','',''],['正确处理人民内部矛盾','',''],['正确对待','',''],['正确引导','',''],['正确性','',''],['正确方向','',''],['正确理解','',''],['正确认识','',''],['正确路线','',''],['正确轨道','',''],['正确领导','',''],['正磷酸','',''],['正祖','',''],['正离子','',''],['正红','',''],['正经','',''],['正经八百','',''],['正统','',''],['正统思想','',''],['正统性','',''],['正统派','',''],['正统观念','',''],['正编','',''],['正职','',''],['正联','',''],['正色','',''],['正色危言','',''],['正色取言','',''],['正色直言','',''],['正茬','',''],['正菜','',''],['正表','',''],['正被','',''],['正装','',''],['正襟','',''],['正襟危坐','',''],['正襟安坐','',''],['正西','',''],['正要','',''],['正规','',''],['正规军','',''],['正规化','',''],['正规教育','',''],['正视','',''],['正视图','',''],['正视眼','',''],['正视绳行','',''],['正言','',''],['正言不讳','',''],['正言厉色','',''],['正言厉颜','',''],['正言直谏','',''],['正论','',''],['正词法','',''],['正话','',''],['正该','',''],['正误','',''],['正误表','',''],['正象','',''],['正负','',''],['正负号','',''],['正负电子','',''],['正路','',''],['正身','',''],['正身明法','',''],['正身清心','',''],['正身率下','',''],['正轨','',''],['正过','',''],['正途','',''],['正逢','',''],['正道','',''],['正邪','',''],['正邪相争','',''],['正锋','',''],['正长石','',''],['正门','',''],['正问','',''],['正院','',''],['正面','',''],['正面人物','',''],['正面图','',''],['正面战场','',''],['正面教育','',''],['正音','',''],['正音法','',''],['正题','',''],['正颜厉色','',''],['正餐','',''],['正骨','',''],['正骨八法','',''],['正黑','',''],['正龟成鳖','',''],['此一时彼一时','',''],['此世','',''],['此中','',''],['此为','',''],['此举','',''],['此之外','',''],['此书','',''],['此文','',''],['此事','',''],['此事体大','',''],['此人','',''],['此件','',''],['此伏彼起','',''],['此例','',''],['此列','',''],['此刻','',''],['此前','',''],['此发彼应','',''],['此可忍孰不可容','',''],['此可忍孰不可忍','',''],['此后','',''],['此君','',''],['此唱彼和','',''],['此地','',''],['此地无银三百两','',''],['此地无银存而不论','',''],['此处','',''],['此复','',''],['此外','',''],['此属','',''],['此岸','',''],['此岸性','',''],['此情','',''],['此情此景','',''],['此时','',''],['此时以前','',''],['此时此刻','',''],['此时此地','',''],['此期间','',''],['此条','',''],['此栏','',''],['此案','',''],['此次','',''],['此款','',''],['此正','',''],['此法','',''],['此派','',''],['此点','',''],['此版','',''],['此生','',''],['此由','',''],['此画','',''],['此番','',''],['此种','',''],['此税','',''],['此等','',''],['此类','',''],['此而','',''],['此联','',''],['此致','',''],['此致敬礼','',''],['此行','',''],['此表','',''],['此起彼伏','',''],['此起彼落','',''],['此路','',''],['此路不通','',''],['此辈','',''],['此道','',''],['此问彼难','',''],['此间','',''],['此间人士','',''],['此际','',''],['此项','',''],['步人后尘','',''],['步伐','',''],['步伐蹒跚','',''],['步入','',''],['步入正轨','',''],['步兵','',''],['步兵师','',''],['步出','',''],['步哨','',''],['步声','',''],['步子','',''],['步履','',''],['步履紊乱','',''],['步履维艰','',''],['步履艰难','',''],['步履轻盈','',''],['步幅','',''],['步弓','',''],['步态','',''],['步态蹒跚','',''],['步摇','',''],['步操','',''],['步数计','',''],['步斗踏罡','',''],['步月','',''],['步月登云','',''],['步机','',''],['步枪','',''],['步枪队','',''],['步步','',''],['步步为营','',''],['步步生莲花','',''],['步步高升','',''],['步武','',''],['步法','',''],['步测','',''],['步涉者','',''],['步犁','',''],['步程计','',''],['步线行针','',''],['步罡踏斗','',''],['步行','',''],['步行区','',''],['步行机','',''],['步行者','',''],['步行虫','',''],['步行街','',''],['步行道','',''],['步话机','',''],['步调','',''],['步调一致','',''],['步谈机','',''],['步进','',''],['步进制','',''],['步进马达','',''],['步速','',''],['步道','',''],['步量','',''],['步韵','',''],['步骤','',''],['武丁','',''],['武不善作','',''],['武丑','',''],['武举','',''],['武二花','',''],['武人','',''],['武人不惜死','',''],['武仙座','',''],['武侠','',''],['武侠小说','',''],['武侯','',''],['武侯祠','',''],['武偃文修','',''],['武则天','',''],['武剧','',''],['武力','',''],['武功山','',''],['武功镇','',''],['武卫','',''],['武器','',''],['武器可用物质','',''],['武器库','',''],['武器弹药','',''],['武器禁运','',''],['武器系统','',''],['武器级','',''],['武器级别材料','',''],['武器装备','',''],['武土','',''],['武圣','',''],['武场','',''],['武坛','',''],['武士','',''],['武士彟','',''],['武士道','',''],['武备','',''],['武夫','',''],['武夷','',''],['武委会','',''],['武威地区','',''],['武官','',''],['武将','',''],['武山鸡','',''],['武工','',''],['武工队','',''],['武师','',''],['武库','',''],['武庙','',''],['武康镇','',''],['武当','',''],['武当山','',''],['武戏','',''],['武打','',''],['武打片','',''],['武斗','',''],['武断','',''],['武旦','',''],['武昌','',''],['武昌剩竹','',''],['武昌起义','',''],['武昌鱼','',''],['武术','',''],['武松','',''],['武林','',''],['武水','',''],['武汉地区','',''],['武汉大学','',''],['武汉钢铁公司','',''],['武江','',''],['武清','',''],['武溪','',''],['武火','',''],['武王伐纣','',''],['武生','',''],['武略','',''],['武神','',''],['武纪','',''],['武经七书','',''],['武经总要','',''],['武职','',''],['武艺','',''],['武艺高强','',''],['武行','',''],['武装','',''],['武装入侵','',''],['武装冲突','',''],['武装分子','',''],['武装力量','',''],['武装挑衅','',''],['武装斗争','',''],['武装泅渡','',''],['武装警察','',''],['武装部','',''],['武装部队','',''],['武警','',''],['武警战士','',''],['武警部队','',''],['武进','',''],['武都','',''],['武都市','',''],['武陵','',''],['武陵源','',''],['歧义','',''],['歧出','',''],['歧岖','',''],['歧异','',''],['歧见','',''],['歧视','',''],['歧路','',''],['歧路亡羊','',''],['歧路灯','',''],['歧途','',''],['歪七扭八','',''],['歪七竖八','',''],['歪了','',''],['歪倒','',''],['歪像','',''],['歪向','',''],['歪嘴','',''],['歪姿斜态','',''],['歪形','',''],['歪心邪意','',''],['歪打','',''],['歪打正着','',''],['歪斜','',''],['歪曲','',''],['歪曲事实','',''],['歪歪','',''],['歪歪扭扭','',''],['歪歪斜斜','',''],['歪点子','',''],['歪理','',''],['歪瓜劣枣','',''],['歪瓜裂枣','',''],['歪缠','',''],['歪脖','',''],['歪诗','',''],['歪谈乱道','',''],['歪门邪道','',''],['歪风','',''],['歪风邪气','',''],['歹人','',''],['歹徒','',''],['歹意','',''],['歹毒','',''],['死一般','',''],['死不','',''],['死不了','',''],['死不冥目','',''],['死不改悔','',''],['死不旋踵','',''],['死不死活不活','',''],['死不瞑目','',''],['死不足惜','',''],['死不闭目','',''],['死且不朽','',''],['死中求生','',''],['死乞白赖','',''],['死也瞑目','',''],['死了','',''],['死于','',''],['死于安乐','',''],['死于非命','',''],['死亡','',''],['死亡人数','',''],['死亡无日','',''],['死亡率','',''],['死亡笔记','',''],['死亡证','',''],['死产','',''],['死人','',''],['死人般','',''],['死仗','',''],['死伤','',''],['死伤相枕','',''],['死伤相藉','',''],['死伤者','',''],['死信','',''],['死僵','',''],['死光','',''],['死党','',''],['死刑','',''],['死刑犯','',''],['死别','',''],['死别生离','',''],['死到临头','',''],['死前','',''],['死力','',''],['死劲儿','',''],['死区','',''],['死去','',''],['死去活来','',''],['死后','',''],['死告活央','',''],['死命','',''],['死啃','',''],['死囚','',''],['死因','',''],['死地','',''],['死地求生','',''],['死声淘气','',''],['死头脑','',''],['死契','',''],['死守','',''],['死寂','',''],['死对','',''],['死对头','',''],['死尸','',''],['死巷','',''],['死得','',''],['死得其所','',''],['死心','',''],['死心塌地','',''],['死心搭地','',''],['死心眼','',''],['死心眼儿','',''],['死心踏地','',''],['死战','',''],['死扣','',''],['死扣儿','',''],['死抓','',''],['死抠','',''],['死抱着不放','',''],['死抱著不放','',''],['死掉','',''],['死敌','',''],['死文字','',''],['死无对证','',''],['死无葬身之地','',''],['死无遗忧','',''],['死日生年','',''],['死有余戮','',''],['死有余罪','',''],['死有余责','',''],['死有余辜','',''],['死期','',''],['死机','',''],['死机蓝屏','',''],['死板','',''],['死树','',''],['死样','',''],['死样活气','',''],['死棋','',''],['死模活样','',''],['死死','',''],['死气','',''],['死气沉沉','',''],['死气白赖','',''],['死水','',''],['死求白赖','',''],['死活','',''],['死活不顾','',''],['死海','',''],['死海古卷','',''],['死海经卷','',''],['死火','',''],['死火山','',''],['死灭','',''],['死灰','',''],['死灰复燃','',''],['死灰复燎','',''],['死灰槁木','',''],['死灰色','',''],['死点','',''],['死物','',''],['死生','',''],['死生契阔','',''],['死生存亡','',''],['死生有命富贵在天','',''],['死生未卜','',''],['死生活气','',''],['死生荣辱','',''],['死症','',''],['死白色','',''],['死的','',''],['死皮赖脸','',''],['死相','',''],['死相枕藉','',''],['死眉瞪眼','',''],['死硬','',''],['死硬派','',''],['死神','',''],['死穴','',''],['死端','',''],['死等','',''],['死结','',''],['死结难解','',''],['死绝','',''],['死缓','',''],['死缠','',''],['死缠烂打','',''],['死罪','',''],['死翘翘','',''],['死者','',''],['死者相枕','',''],['死而不僵','',''],['死而不悔','',''],['死而不朽','',''],['死而后己','',''],['死而后已','',''],['死而后止','',''],['死而复生','',''],['死而复苏','',''],['死而无怨','',''],['死而无悔','',''],['死胎','',''],['死胡同','',''],['死要','',''],['死规矩','',''],['死角','',''],['死讯','',''],['死记','',''],['死记硬背','',''],['死说活说','',''],['死账','',''],['死路','',''],['死路一条','',''],['死轻鸿毛','',''],['死里求生','',''],['死里逃生','',''],['死钱','',''],['死锁','',''],['死难','',''],['死难者','',''],['死面','',''],['死顽固','',''],['死马当活马医','',''],['死鬼','',''],['死鱼','',''],['歼一警百','',''],['歼击','',''],['歼击机','',''],['歼敌','',''],['歼灭','',''],['歼灭战','',''],['殁而不朽','',''],['殁而无朽','',''],['殃及','',''],['殃及池鱼','',''],['殃国祸家','',''],['殃殃','',''],['殃民','',''],['殆尽','',''],['殆无孑遗','',''],['殆无虚日','',''],['殉义忘身','',''],['殉国','',''],['殉情','',''],['殉教','',''],['殉教史','',''],['殉教者','',''],['殉死','',''],['殉职','',''],['殉节','',''],['殉葬','',''],['殉葬品','',''],['殉道','',''],['殉道者','',''],['殉难','',''],['殉难者','',''],['殊不知','',''],['殊乡','',''],['殊功','',''],['殊功劲节','',''],['殊勋','',''],['殊勋异绩','',''],['殊勋茂绩','',''],['殊域周咨录','',''],['殊姿','',''],['殊异','',''],['殊形妙状','',''],['殊形怪状','',''],['殊形诡状','',''],['殊形诡色','',''],['殊方同致','',''],['殊方异域','',''],['殊方异类','',''],['殊方绝域','',''],['殊死','',''],['殊死搏斗','',''],['殊涂同会','',''],['殊涂同归','',''],['殊涂同致','',''],['殊深轸念','',''],['殊滋异味','',''],['殊煞风景','',''],['殊礼','',''],['殊致','',''],['殊色','',''],['殊荣','',''],['殊言别语','',''],['殊路同归','',''],['殊途同归','',''],['残丘','',''],['残云','',''],['残余','',''],['残余分子','',''],['残余势力','',''],['残余沾染','',''],['残余物','',''],['残值','',''],['残像','',''],['残兵','',''],['残兵败将','',''],['残军败将','',''],['残冬','',''],['残冬腊月','',''],['残匪','',''],['残卷','',''],['残发','',''],['残品','',''],['残喘','',''],['残垣断壁','',''],['残墙','',''],['残夜','',''],['残奥','',''],['残奥会','',''],['残存','',''],['残存物','',''],['残害','',''],['残局','',''],['残山剩水','',''],['残席','',''],['残年','',''],['残年短景','',''],['残废','',''],['残废军人','',''],['残弱','',''],['残忍','',''],['残忍人','',''],['残损','',''],['残敌','',''],['残料','',''],['残星','',''],['残春','',''],['残晖','',''],['残暴','',''],['残月','',''],['残本','',''],['残杀','',''],['残杀者','',''],['残杯冷炙','',''],['残株','',''],['残根','',''],['残次','',''],['残毒','',''],['残民以逞','',''],['残民害物','',''],['残汤剩饭','',''],['残渣','',''],['残渣余孽','',''],['残滓','',''],['残灯','',''],['残烛','',''],['残照','',''],['残片','',''],['残物','',''],['残瓦','',''],['残生','',''],['残留','',''],['残留影象','',''],['残留物','',''],['残疾','',''],['残疾人','',''],['残疾人联合会','',''],['残疾儿','',''],['残破','',''],['残秋','',''],['残积','',''],['残章断简','',''],['残篇','',''],['残篇断简','',''],['残红','',''],['残编断简','',''],['残缺','',''],['残缺不全','',''],['残羹','',''],['残羹冷炙','',''],['残羹冷饭','',''],['残羹剩饭','',''],['残联','',''],['残肢','',''],['残肴','',''],['残花','',''],['残花败柳','',''],['残茎','',''],['残茶剩饭','',''],['残虐','',''],['残败','',''],['残货','',''],['残迹','',''],['残遗','',''],['残部','',''],['残酒','',''],['残酷','',''],['残酷斗争','',''],['残酷无情','',''],['残阳','',''],['残障','',''],['残香','',''],['残骸','',''],['殒命','',''],['殒灭','',''],['殒落','',''],['殒身不恤','',''],['殒身碎首','',''],['殖利','',''],['殖民','',''],['殖民主义','',''],['殖民于','',''],['殖民地','',''],['殖民统治','',''],['殖民者','',''],['殗殜','',''],['殚力','',''],['殚心','',''],['殚心竭虑','',''],['殚思极虑','',''],['殚智竭力','',''],['殚残','',''],['殚竭','',''],['殚精极思','',''],['殚精极虑','',''],['殚精毕力','',''],['殚精毕思','',''],['殚精竭力','',''],['殚精竭虑','',''],['殚见洽闻','',''],['殚诚毕虑','',''],['殚谋戮力','',''],['殚闷','',''],['殜殜','',''],['殡仪','',''],['殡仪员','',''],['殡仪馆','',''],['殡殓','',''],['殡葬','',''],['殡车','',''],['殴伤','',''],['殴偏救弊','',''],['殴打','',''],['殴打罪','',''],['殴斗','',''],['殴气','',''],['段子','',''],['段式','',''],['段数','',''],['段氏','',''],['段汛期','',''],['段玉裁','',''],['段祺瑞','',''],['段荃法','',''],['段落','',''],['段错误','',''],['段长','',''],['殷切','',''],['殷勤','',''],['殷商','',''],['殷墟','',''],['殷天动地','',''],['殷天震地','',''],['殷实','',''],['殷富','',''],['殷弘绪','',''],['殷忧','',''],['殷忧启圣','',''],['殷望','',''],['殷殷','',''],['殷殷勤勤','',''],['殷殷教导','',''],['殷殷田田','',''],['殷民阜利','',''],['殷民阜财','',''],['殷浩书空','',''],['殷红','',''],['殷资','',''],['殷都','',''],['殷鉴','',''],['殷鉴不远','',''],['殷钢','',''],['殿下','',''],['殿军','',''],['殿卫','',''],['殿后','',''],['殿堂','',''],['殿式','',''],['殿本','',''],['殿试','',''],['毁不灭性','',''],['毁了','',''],['毁于','',''],['毁于一旦','',''],['毁伤','',''],['毁冠裂裳','',''],['毁坏','',''],['毁宗夷族','',''],['毁家纾国','',''],['毁家纾难','',''],['毁容','',''],['毁廉灭耻','',''],['毁弃','',''],['毁形','',''],['毁形灭性','',''],['毁损','',''],['毁掉','',''],['毁方投圆','',''],['毁方瓦合','',''],['毁来性','',''],['毁林','',''],['毁灭','',''],['毁灭性','',''],['毁灭性打击','',''],['毁瓦画墁','',''],['毁约','',''],['毁言','',''],['毁誉','',''],['毁誓','',''],['毁诋','',''],['毁谤','',''],['毁车杀马','',''],['毁迹','',''],['毁钟为铎','',''],['毁除','',''],['毁风败俗','',''],['毂击肩摩','',''],['毂壳','',''],['毅力','',''],['毅然','',''],['毅然决然','',''],['毋到','',''],['毋单','',''],['毋宁','',''],['毋宁死','',''],['毋庸','',''],['毋忘','',''],['毋望之祸','',''],['毋望之福','',''],['毋甚高论','',''],['毋翼而飞','',''],['毋躁','',''],['毋需','',''],['毋须','',''],['母乳','',''],['母乳代','',''],['母乳喂养','',''],['母亲','',''],['母亲似','',''],['母以子贵','',''],['母体','',''],['母党','',''],['母公司','',''],['母兽','',''],['母函数','',''],['母后','',''],['母国','',''],['母夜叉','',''],['母女','',''],['母奶','',''],['母子','',''],['母子垂直感染','',''],['母弹','',''],['母性','',''],['母慈子孝','',''],['母教','',''],['母料','',''],['母方','',''],['母本','',''],['母机','',''],['母权制','',''],['母板','',''],['母树','',''],['母树林','',''],['母校','',''],['母株','',''],['母液','',''],['母港','',''],['母爱','',''],['母牛','',''],['母犬','',''],['母狗','',''],['母狮子','',''],['母猪','',''],['母球','',''],['母畜','',''],['母的','',''],['母种','',''],['母系','',''],['母系制','',''],['母系社会','',''],['母线','',''],['母羊','',''],['母老虎','',''],['母舅','',''],['母舰','',''],['母舱','',''],['母船','',''],['母蜂','',''],['母表','',''],['母语','',''],['母质','',''],['母道','',''],['母钟','',''],['母难日','',''],['母音','',''],['母音调和','',''],['母音间','',''],['母题','',''],['母鸡','',''],['母鸭','',''],['母鹿皮','',''],['每一','',''],['每一张','',''],['每一个','',''],['每一处','',''],['每一寸','',''],['每一年','',''],['每一方','',''],['每一种','',''],['每七年','',''],['每下愈况','',''],['每况愈下','',''],['每两','',''],['每个','',''],['每个人','',''],['每个月','',''],['每二','',''],['每五年','',''],['每亩','',''],['每人','',''],['每人每年','',''],['每件','',''],['每件事','',''],['每份','',''],['每位','',''],['每克','',''],['每八年','',''],['每分每秒','',''],['每分钟','',''],['每到','',''],['每刻','',''],['每包','',''],['每匹','',''],['每十年','',''],['每半年','',''],['每单位','',''],['每县','',''],['每双','',''],['每吨','',''],['每周','',''],['每周一次','',''],['每四天','',''],['每四年','',''],['每回','',''],['每地','',''],['每场','',''],['每处','',''],['每夜','',''],['每天','',''],['每头','',''],['每套','',''],['每季','',''],['每家','',''],['每小时','',''],['每层','',''],['每届','',''],['每常','',''],['每平方米','',''],['每年','',''],['每年一度','',''],['每座','',''],['每张','',''],['每当','',''],['每户','',''],['每打','',''],['每批','',''],['每排','',''],['每斤','',''],['每日','',''],['每日快报','',''],['每日性','',''],['每日新闻','',''],['每日电讯报','',''],['每日邮报','',''],['每日镜报','',''],['每日限价','',''],['每旬','',''],['每时','',''],['每时每刻','',''],['每时每日','',''],['每星期','',''],['每晚','',''],['每月','',''],['每期','',''],['每本','',''],['每条','',''],['每样','',''],['每次','',''],['每每','',''],['每片','',''],['每瓶','',''],['每磅','',''],['每种','',''],['每秒','',''],['每秒钟','',''],['每窑','',''],['每端口价格','',''],['每笔','',''],['每类','',''],['每组','',''],['每股','',''],['每节','',''],['每英寸','',''],['每谋辄败','',''],['每车','',''],['每转','',''],['每辆','',''],['每逢','',''],['每逢佳节倍思亲','',''],['每部','',''],['每队','',''],['每隔','',''],['每集','',''],['每页','',''],['每顷','',''],['每项','',''],['每顿','',''],['每颗','',''],['每饭不忘','',''],['毒八角','',''],['毒刑','',''],['毒刺','',''],['毒剂','',''],['毒剂化学','',''],['毒剂弹','',''],['毒剂震检','',''],['毒力','',''],['毒化','',''],['毒品','',''],['毒品贩','',''],['毒品走私','',''],['毒品走私案','',''],['毒奶','',''],['毒奶粉','',''],['毒妇','',''],['毒害','',''],['毒害剂量','',''],['毒性','',''],['毒感','',''],['毒手','',''],['毒手尊拳','',''],['毒打','',''],['毒教','',''],['毒杀','',''],['毒枭','',''],['毒株','',''],['毒死','',''],['毒气','',''],['毒气弹','',''],['毒气战','',''],['毒汁','',''],['毒液','',''],['毒爪','',''],['毒牙','',''],['毒物','',''],['毒物学','',''],['毒狗草','',''],['毒理学','',''],['毒瓦斯','',''],['毒疮','',''],['毒症','',''],['毒瘤','',''],['毒瘾','',''],['毒砂','',''],['毒箭','',''],['毒素','',''],['毒腺','',''],['毒舌','',''],['毒草','',''],['毒草名','',''],['毒药','',''],['毒药苦口','',''],['毒莠定','',''],['毒菌','',''],['毒蕈','',''],['毒虫','',''],['毒蛇','',''],['毒蛇猛兽','',''],['毒蛾','',''],['毒蜘蛛','',''],['毒蝇伞','',''],['毒蝇蕈','',''],['毒计','',''],['毒谋','',''],['毒谷','',''],['毒贩','',''],['毒辣','',''],['毒酒','',''],['毒针','',''],['毒颚','',''],['毒饵','',''],['毒麦','',''],['毓婷','',''],['毓子孕孙','',''],['比一比','',''],['比上不足','',''],['比上不足比下有余','',''],['比下去','',''],['比下有余','',''],['比不上','',''],['比丘','',''],['比丘尼','',''],['比为','',''],['比之','',''],['比书','',''],['比了','',''],['比亚','',''],['比亚迪','',''],['比亚迪汽车','',''],['比什凯克','',''],['比他','',''],['比以往任何时候都','',''],['比价','',''],['比佛利山','',''],['比作','',''],['比例','',''],['比例中项','',''],['比例关系','',''],['比例失调','',''],['比例尺','',''],['比例规','',''],['比值','',''],['比做','',''],['比分','',''],['比划','',''],['比利','',''],['比利时人','',''],['比利牛斯','',''],['比利牛斯山','',''],['比到达终点更美好','',''],['比勒费尔德','',''],['比勒陀利亚','',''],['比历史最高水平','',''],['比去年同期下降','',''],['比及','',''],['比反','',''],['比号','',''],['比哈尔邦','',''],['比喻','',''],['比坚尼','',''],['比埃兹巴伯','',''],['比基尼','',''],['比基尼岛','',''],['比她','',''],['比好','',''],['比如说','',''],['比威力','',''],['比学赶帮','',''],['比学赶帮超','',''],['比安','',''],['比容','',''],['比对','',''],['比尔','',''],['比尔・盖茨','',''],['比尔博','',''],['比屋可封','',''],['比屋而封','',''],['比岁不登','',''],['比干','',''],['比年','',''],['比年不登','',''],['比张比李','',''],['比得','',''],['比得上','',''],['比快','',''],['比手划脚','',''],['比手画脚','',''],['比才','',''],['比拟','',''],['比拼','',''],['比捕','',''],['比数','',''],['比斯开湾','',''],['比斯特','',''],['比方','',''],['比方说','',''],['比杆赛','',''],['比来','',''],['比武','',''],['比比','',''],['比比划划','',''],['比比皆是','',''],['比比皆然','',''],['比湿','',''],['比热','',''],['比照','',''],['比物此志','',''],['比物连类','',''],['比特','',''],['比猫画虎','',''],['比率','',''],['比画','',''],['比目','',''],['比目连枝','',''],['比目鱼','',''],['比着','',''],['比索','',''],['比绍','',''],['比翼','',''],['比翼双飞','',''],['比翼连枝','',''],['比翼鸟','',''],['比翼齐飞','',''],['比肩','',''],['比肩皆是','',''],['比肩继踵','',''],['比肩而事','',''],['比肩而立','',''],['比肩随踵','',''],['比色','',''],['比色分析','',''],['比色计','',''],['比萨','',''],['比萨斜塔','',''],['比萨饼','',''],['比著','',''],['比评','',''],['比试','',''],['比诸','',''],['比赛','',''],['比赛场','',''],['比赛规则','',''],['比赛项目','',''],['比起','',''],['比较','',''],['比长比短','',''],['比较仪','',''],['比较价格','',''],['比较分析','',''],['比较喜欢','',''],['比较器','',''],['比较慢','',''],['比较文学','',''],['比较级','',''],['比较而言','',''],['比邻','',''],['比配','',''],['比重','',''],['比重计','',''],['比量','',''],['比附','',''],['比降','',''],['比高','',''],['毕业','',''],['毕业典礼','',''],['毕业分配','',''],['毕业后','',''],['毕业文凭','',''],['毕业班','',''],['毕业生','',''],['毕业考试','',''],['毕业论文','',''],['毕业设计','',''],['毕业证书','',''],['毕了业','',''],['毕其功于一役','',''],['毕兹','',''],['毕力同心','',''],['毕加索','',''],['毕升','',''],['毕命','',''],['毕宿五','',''],['毕尔巴鄂','',''],['毕尼奥夫','',''],['毕尼奥夫带','',''],['毕恭毕敬','',''],['毕摩','',''],['毕毕剥剥','',''],['毕生','',''],['毕竟','',''],['毕肖','',''],['毕设','',''],['毕达哥拉斯','',''],['毕露','',''],['毗湿奴','',''],['毗耶娑','',''],['毗连','',''],['毗邻','',''],['毙了','',''],['毙伤','',''],['毙命','',''],['毙后','',''],['毙掉','',''],['毙敌','',''],['毙而后已','',''],['毛一般','',''],['毛丛','',''],['毛丛状','',''],['毛主义','',''],['毛主席','',''],['毛主席纪念堂','',''],['毛主席语录','',''],['毛举细事','',''],['毛举细务','',''],['毛举细故','',''],['毛举缕析','',''],['毛估','',''],['毛值','',''],['毛冠鹿','',''],['毛出在羊身上','',''],['毛利','',''],['毛利人','',''],['毛利语','',''],['毛制','',''],['毛刷','',''],['毛刺','',''],['毛发','',''],['毛发之功','',''],['毛发似','',''],['毛发倒竖','',''],['毛发学','',''],['毛发悚然','',''],['毛发森竖','',''],['毛发湿度表','',''],['毛发耸然','',''],['毛口','',''],['毛呢','',''],['毛咕','',''],['毛哔叽','',''],['毛囊','',''],['毛团','',''],['毛地黄','',''],['毛坑','',''],['毛坯','',''],['毛塑像','',''],['毛多','',''],['毛太纸','',''],['毛头','',''],['毛头纸','',''],['毛子','',''],['毛孔','',''],['毛小囊','',''],['毛尖','',''],['毛巾','',''],['毛巾被','',''],['毛布','',''],['毛帽','',''],['毛手','',''],['毛手毛脚','',''],['毛拉','',''],['毛损','',''],['毛掸','',''],['毛掸子','',''],['毛收入','',''],['毛料','',''],['毛施淑姿','',''],['毛条','',''],['毛样','',''],['毛根','',''],['毛桃','',''],['毛概','',''],['毛毛','',''],['毛毛腾腾','',''],['毛毛虫','',''],['毛毛雨','',''],['毛毡','',''],['毛毡苔','',''],['毛毯','',''],['毛泽东','',''],['毛泽东・鲜为人知的故事','',''],['毛泽东主义','',''],['毛泽东思想','',''],['毛洋槐','',''],['毛派','',''],['毛渠','',''],['毛火虫','',''],['毛烘烘','',''],['毛片','',''],['毛犀','',''],['毛状','',''],['毛状体','',''],['毛猪','',''],['毛玻璃','',''],['毛瑟枪','',''],['毛病','',''],['毛白','',''],['毛白杨','',''],['毛皮','',''],['毛皮兽','',''],['毛皮商','',''],['毛皮袋','',''],['毛票','',''],['毛窝','',''],['毛竹','',''],['毛笋','',''],['毛笔','',''],['毛管水','',''],['毛箭','',''],['毛糙','',''],['毛絮','',''],['毛纺','',''],['毛纺厂','',''],['毛纺织厂','',''],['毛线','',''],['毛线衣','',''],['毛细','',''],['毛细孔','',''],['毛细现象','',''],['毛细管','',''],['毛细血管','',''],['毛织','',''],['毛织品','',''],['毛织物','',''],['毛织运动衫','',''],['毛绒','',''],['毛绒玩具','',''],['毛绒绒','',''],['毛绳','',''],['毛肚','',''],['毛腰','',''],['毛腿沙鸡','',''],['毛色','',''],['毛茛','',''],['毛茛科','',''],['毛茶','',''],['毛茸','',''],['毛茸茸','',''],['毛草','',''],['毛蓝','',''],['毛虫','',''],['毛虾','',''],['毛蚴','',''],['毛血旺','',''],['毛衣','',''],['毛袜','',''],['毛装','',''],['毛裤','',''],['毛词','',''],['毛诗','',''],['毛豆','',''],['毛象','',''],['毛躁','',''],['毛边','',''],['毛边纸','',''],['毛遂','',''],['毛遂自荐','',''],['毛邓三','',''],['毛酸浆','',''],['毛里','',''],['毛重','',''],['毛钱','',''],['毛钱儿','',''],['毛难族','',''],['毛领','',''],['毛颚动物','',''],['毛驴','',''],['毛骨悚然','',''],['毛骨竦然','',''],['毛骨耸然','',''],['毡呢','',''],['毡子','',''],['毡帽','',''],['毡条','',''],['毡毯','',''],['毡帐','',''],['圆顶毡帐','',''],['毡笠','',''],['毡衣','',''],['毡靴','',''],['毡馆','',''],['毪子','',''],['毫不','',''],['毫不介意','',''],['毫不动摇','',''],['毫不客气','',''],['毫不怀疑','',''],['毫不犹豫','',''],['毫不留情','',''],['毫不相干','',''],['毫不讲理','',''],['毫不费力','',''],['毫不迟疑','',''],['毫不逊色','',''],['毫亨','',''],['毫伏','',''],['毫克','',''],['毫分缕析','',''],['毫升','',''],['毫厘','',''],['毫厘不爽','',''],['毫厘千里','',''],['毫发','',''],['毫发不爽','',''],['毫发不犯','',''],['毫周波','',''],['毫子','',''],['毫安','',''],['毫安培','',''],['毫安表','',''],['毫巴','',''],['毫微','',''],['毫微秒','',''],['毫微米','',''],['毫无','',''],['毫无二致','',''],['毫无价值','',''],['毫无关系','',''],['毫无意义','',''],['毫无效果','',''],['毫无根据','',''],['毫无疑义','',''],['毫无疑问','',''],['毫无逊色','',''],['毫末','',''],['毫末之利','',''],['毫毛','',''],['毫洋','',''],['毫瓦','',''],['毫秒','',''],['毫米','',''],['毫米数','',''],['毫米水银柱','',''],['毫米汞柱','',''],['毫米波','',''],['毫脉','',''],['毫针','',''],['毯子','',''],['毯类','',''],['毵毵','',''],['毽子','',''],['毽球','',''],['氅衣','',''],['氆氇','',''],['氍毹','',''],['氏族','',''],['民不堪命','',''],['民不安枕','',''],['民不畏死','',''],['民不聊生','',''],['民为邦本','',''],['民主','',''],['民主主义','',''],['民主主义者','',''],['民主人士','',''],['民主促进会','',''],['民主党','',''],['民主党人','',''],['民主党派','',''],['民主化','',''],['民主国','',''],['民主墙','',''],['民主建港协进联盟','',''],['民主德国','',''],['民主改革','',''],['民主政治','',''],['民主权','',''],['民主权利','',''],['民主派','',''],['民主社会主义','',''],['民主进步党','',''],['民主集中制','',''],['民主革命','',''],['民事','',''],['民事权利','',''],['民事案件','',''],['民事法庭','',''],['民事纠纷','',''],['民事诉讼','',''],['民事责任','',''],['民以食为天','',''],['民以食本','',''],['民众','',''],['民俗','',''],['民俗学','',''],['民信局','',''],['民兵','',''],['民兵工作','',''],['民兵建设','',''],['民兵英雄','',''],['民兵队','',''],['民初','',''],['民力','',''],['民力雕弊','',''],['民办','',''],['民办公助','',''],['民办教师','',''],['民协','',''],['民反','',''],['民变','',''],['民变峰起','',''],['民和','',''],['民和县','',''],['民和年丰','',''],['民和年稔','',''],['民品','',''],['民团','',''],['民国','',''],['民国通俗演义','',''],['民夫','',''],['民女','',''],['民委','',''],['民学','',''],['民宅','',''],['民安','',''],['民安国泰','',''],['民安物阜','',''],['民官','',''],['民家','',''],['民宿','',''],['民富国强','',''],['民居','',''],['民工','',''],['民庭','',''],['民康物阜','',''],['民建','',''],['民建联','',''],['民强','',''],['民心','',''],['民怨','',''],['民怨沸腾','',''],['民怨盈涂','',''],['民怨鼎沸','',''],['民情','',''],['民情物理','',''],['民惟邦本','',''],['民意','',''],['民意测验','',''],['民意调查','',''],['民愤','',''],['民户','',''],['民房','',''],['民政','',''],['民政厅','',''],['民政局','',''],['民政工作','',''],['民数记','',''],['民族','',''],['民族主义','',''],['民族主义情绪','',''],['民族乐队','',''],['民族共同语','',''],['民族化','',''],['民族区域自治','',''],['民族同化','',''],['民族团','',''],['民族团结','',''],['民族大学','',''],['民族大迁徙','',''],['民族学','',''],['民族工业','',''],['民族平等','',''],['民族形式','',''],['民族志','',''],['民族性','',''],['民族文化','',''],['民族杂居地区','',''],['民族民主革命','',''],['民族沙文主义','',''],['民族独立','',''],['民族社会主义','',''],['民族自决','',''],['民族自决权','',''],['民族自治','',''],['民族自治地区','',''],['民族舞蹈','',''],['民族英雄','',''],['民族融合','',''],['民族解放运动','',''],['民族语言','',''],['民族资产阶级','',''],['民族资本','',''],['民智','',''],['民有','',''],['民望','',''],['民权主义','',''],['民柬','',''],['民校','',''],['民歌','',''],['民歌手','',''],['民殷国富','',''],['民殷财阜','',''],['民气','',''],['民法','',''],['民法典','',''],['民淳俗厚','',''],['民熙物阜','',''],['民生','',''],['民生主义','',''],['民生凋敝','',''],['民生国计','',''],['民生涂炭','',''],['民生雕敝','',''],['民用','',''],['民用产品','',''],['民用工业','',''],['民用核国家','',''],['民用航空','',''],['民用飞机','',''],['民田','',''],['民瘼','',''],['民盟','',''],['民盟中央','',''],['民穷','',''],['民穷财匮','',''],['民穷财尽','',''],['民答那峨海','',''],['民粹','',''],['民粹派','',''],['民约','',''],['民胞物与','',''],['民脂','',''],['民脂民膏','',''],['民膏','',''],['民膏民脂','',''],['民航','',''],['民航班机','',''],['民船','',''],['民营','',''],['民营化','',''],['民警','',''],['民调','',''],['民谚','',''],['民谣','',''],['民负','',''],['民贼','',''],['民贼独夫','',''],['民运','',''],['民进','',''],['民进党','',''],['民选','',''],['民间','',''],['民间习俗','',''],['民间传说','',''],['民间协定','',''],['民间工艺','',''],['民间故事','',''],['民间文学','',''],['民间组织','',''],['民间舞','',''],['民间舞蹈','',''],['民间艺术','',''],['民间音乐','',''],['民防','',''],['民防体制','',''],['民防建设','',''],['民雄','',''],['民雄乡','',''],['民革','',''],['民革中央','',''],['民风','',''],['民食','',''],['气不公','',''],['气不平','',''],['气不忿儿','',''],['气不过','',''],['气义相投','',''],['气井','',''],['气人','',''],['气体','',''],['气体扩散','',''],['气体状','',''],['气体离心','',''],['气候','',''],['气候上','',''],['气候变化','',''],['气候学','',''],['气候学家','',''],['气候异常','',''],['气候暖化','',''],['气候温和','',''],['气候状况','',''],['气傲心高','',''],['气像人员','',''],['气充志定','',''],['气充志骄','',''],['气克斗牛','',''],['气冠三军','',''],['气冲冲','',''],['气冲斗牛','',''],['气冲牛斗','',''],['气冲霄汉','',''],['气冷','',''],['气冷式反应堆','',''],['气凌霄汉','',''],['气凝胶','',''],['气割','',''],['气力','',''],['气功','',''],['气功疗法','',''],['气动','',''],['气动力','',''],['气动噪声','',''],['气动开关','',''],['气动式','',''],['气动控制','',''],['气动泵','',''],['气动葫芦','',''],['气动车','',''],['气动闸','',''],['气势','',''],['气势凌人','',''],['气势宏伟','',''],['气势汹汹','',''],['气势浩大','',''],['气势熏灼','',''],['气势磅礴','',''],['气包子','',''],['气化','',''],['气压','',''],['气压图','',''],['气压层','',''],['气压山河','',''],['气压带','',''],['气压波','',''],['气压表','',''],['气压计','',''],['气口','',''],['气吁吁','',''],['气吐眉扬','',''],['气吐虹霓','',''],['气吞山河','',''],['气吞河山','',''],['气吞牛斗','',''],['气味','',''],['气味相投','',''],['气呼呼','',''],['气和','',''],['气咻咻','',''],['气咽声丝','',''],['气哼哼','',''],['气喘','',''],['气喘吁吁','',''],['气喘喘','',''],['气喘声','',''],['气喘如牛','',''],['气喘病','',''],['气嗓','',''],['气囊','',''],['气团','',''],['气坏','',''],['气垫','',''],['气垫船','',''],['气塞','',''],['气壮','',''],['气壮山河','',''],['气壮河山','',''],['气壮理直','',''],['气多','',''],['气大','',''],['气夯胸脯','',''],['气头上','',''],['气孔','',''],['气宇','',''],['气宇昂昂','',''],['气宇轩昂','',''],['气定神闲','',''],['气密','',''],['气层','',''],['气床','',''],['气度','',''],['气度不凡','',''],['气度恢宏','',''],['气得','',''],['气得志满','',''],['气忍声吞','',''],['气态','',''],['气急','',''],['气急败丧','',''],['气急败坏','',''],['气性','',''],['气息','',''],['气息奄奄','',''],['气息长','',''],['气恼','',''],['气愤','',''],['气愤等','',''],['气慨','',''],['气我','',''],['气数','',''],['气旋','',''],['气时','',''],['气昂昂','',''],['气昏','',''],['气杀','',''],['气杀钟馗','',''],['气极','',''],['气枪','',''],['气根','',''],['气楼','',''],['气概','',''],['气死','',''],['气死人','',''],['气气','',''],['气氛','',''],['气泡','',''],['气泵','',''],['气派','',''],['气流','',''],['气浪','',''],['气浴','',''],['气消胆夺','',''],['气涌如山','',''],['气涡','',''],['气温','',''],['气溶胶','',''],['气溶胶侦察仪','',''],['气滑式','',''],['气滞','',''],['气满志骄','',''],['气潭','',''],['气潮','',''],['气灯','',''],['气炉','',''],['气炸','',''],['气焊','',''],['气焰','',''],['气焰嚣张','',''],['气焰熏天','',''],['气煤','',''],['气状','',''],['气球','',''],['气瓶','',''],['气生气死','',''],['气田','',''],['气病','',''],['气痛','',''],['气盆','',''],['气盖山河','',''],['气盛','',''],['气眼','',''],['气短','',''],['气穴','',''],['气窗','',''],['气笛','',''],['气笼','',''],['气筒','',''],['气管','',''],['气管切开术','',''],['气管插管术','',''],['气管炎','',''],['气管痉挛','',''],['气管镜','',''],['气粗','',''],['气绝','',''],['气绝身亡','',''],['气缸','',''],['气肿','',''],['气肿疽','',''],['气胀','',''],['气胎','',''],['气胸','',''],['气腔','',''],['气腹','',''],['气臌','',''],['气般','',''],['气船','',''],['气艇','',''],['气色','',''],['气色好','',''],['气节','',''],['气虚','',''],['气血','',''],['气血方刚','',''],['气话','',''],['气谊相投','',''],['气象','',''],['气象万千','',''],['气象卫星','',''],['气象厅','',''],['气象台','',''],['气象图','',''],['气象学','',''],['气象学校','',''],['气象学者','',''],['气象局','',''],['气象情报','',''],['气象火箭','',''],['气象站','',''],['气象观测','',''],['气象观测站','',''],['气象计','',''],['气象雷达','',''],['气质','',''],['气贯长虹','',''],['气轮机','',''],['气运','',''],['气逆','',''],['气逾霄汉','',''],['气道','',''],['气量','',''],['气钻','',''],['气锅','',''],['气锤','',''],['气门','',''],['气门心','',''],['气闷','',''],['气闸','',''],['气阀','',''],['气阱','',''],['气陷','',''],['气隙','',''],['气雾免疫','',''],['气雾剂','',''],['气雾室','',''],['气韵','',''],['气馁','',''],['气骄志满','',''],['气魄','',''],['气鸣乐器','',''],['气鼓','',''],['气鼓鼓','',''],['氖气','',''],['氖灯','',''],['氘核','',''],['氙灯','',''],['氛围','',''],['氟利昂','',''],['氟化','',''],['氟化氢','',''],['氟化物','',''],['氟化钙','',''],['氟化银','',''],['氟橡胶','',''],['氟石','',''],['氟硅酸','',''],['氟酸','',''],['氢净合成油','',''],['氢化','',''],['氢化氰','',''],['氢化物','',''],['氢卤酸','',''],['氢原子','',''],['氢原子核','',''],['氢弹','',''],['氢核','',''],['氢气','',''],['氢氟烃','',''],['氢氟酸','',''],['氢氧','',''],['氢氧化','',''],['氢氧化物','',''],['氢氧化钙','',''],['氢氧化钠','',''],['氢氧化钾','',''],['氢氧化铝','',''],['氢氧化铵','',''],['氢氧吹管','',''],['氢氧基','',''],['氢氧根','',''],['氢氧根离子','',''],['氢氧焰','',''],['氢氧离子','',''],['氢氯酸','',''],['氢氰酸','',''],['氢溴酸','',''],['氢酶','',''],['氢酸','',''],['氢酸盐','',''],['氢键','',''],['氤氲','',''],['氦气','',''],['氦氖','',''],['氧乙炔','',''],['氧乙炔炬','',''],['氧乙炔焊','',''],['氧乙炔焊炬','',''],['氧割','',''],['氧化','',''],['氧化剂','',''],['氧化汞','',''],['氧化焰','',''],['氧化物','',''],['氧化罐','',''],['氧化诰','',''],['氧化还原酶','',''],['氧化酶','',''],['氧化钇','',''],['氧化钙','',''],['氧化钡','',''],['氧化铀','',''],['氧化铁','',''],['氧化铅','',''],['氧化铍','',''],['氧化铜','',''],['氧化铝','',''],['氧化铝陶瓷','',''],['氧化锂','',''],['氧化锌','',''],['氧化镁','',''],['氧化镱','',''],['氧原子','',''],['氧基','',''],['氧性','',''],['氧效应','',''],['氧气','',''],['氧氨','',''],['氧水','',''],['氧炔吹管','',''],['氧炔焰','',''],['氨化','',''],['氨吖啶','',''],['氨哮素','',''],['氨基','',''],['氨基塑料','',''],['氨基树脂','',''],['氨基比林','',''],['氨基甲酸酯类化合物','',''],['氨基苯酸','',''],['氨基葡糖','',''],['氨基葡萄糖','',''],['氨基酸','',''],['氨气','',''],['氨水','',''],['氨硫脲','',''],['氨纶','',''],['氨酸','',''],['氮化','',''],['氮化合','',''],['氮化物','',''],['氮原子','',''],['氮族','',''],['氮气','',''],['氮氧化物','',''],['氮肥','',''],['氮芥气','',''],['氯丁','',''],['氯丁橡胶','',''],['氯丹','',''],['氯乙烯','',''],['氯乙烷','',''],['氯仿','',''],['氯化','',''],['氯化亚锡','',''],['氯化氢','',''],['氯化氰','',''],['氯化物','',''],['氯化磷','',''],['氯化苦','',''],['氯化钙','',''],['氯化钠','',''],['氯化钾','',''],['氯化铁','',''],['氯化铝','',''],['氯化铵','',''],['氯化锌','',''],['氯化镁','',''],['氯单质','',''],['氯喹','',''],['氯安酮','',''],['氯已烯','',''],['氯林可霉素','',''],['氯气','',''],['氯水','',''],['氯洁霉素','',''],['氯甲烷','',''],['氯痤疮','',''],['氯碱工业','',''],['氯磷定','',''],['氯纶','',''],['氯胺酮','',''],['氯苯','',''],['氯酸','',''],['氯酸盐','',''],['氯酸钠','',''],['氯酸钾','',''],['氯霉素','',''],['氰化','',''],['氰化氢','',''],['氰化物','',''],['氰化钠','',''],['氰化钾','',''],['氰基','',''],['氰基细菌','',''],['氰氨','',''],['氰氨化钙','',''],['氰溴甲苯','',''],['氰胺','',''],['氰苷','',''],['氰酸','',''],['氰酸盐','',''],['氰铵','',''],['水上','',''],['水上乡','',''],['水上居民','',''],['水上摩托','',''],['水上运动','',''],['水上飞机','',''],['水下','',''],['水下核爆炸','',''],['水下核试验','',''],['水中','',''],['水中兵器','',''],['水中捉月','',''],['水中捞月','',''],['水中爆破','',''],['水乡','',''],['水乳','',''],['水乳之契','',''],['水乳交融','',''],['水井','',''],['水产','',''],['水产业','',''],['水产养殖','',''],['水产品','',''],['水产局','',''],['水产展','',''],['水亮','',''],['水仙','',''],['水仙花','',''],['水份','',''],['水份多','',''],['水位','',''],['水位标','',''],['水体','',''],['水供','',''],['水俣市','',''],['水俣病','',''],['水僊','',''],['水光','',''],['水光山色','',''],['水光接天','',''],['水兵','',''],['水具','',''],['水军','',''],['水冰','',''],['水冷','',''],['水净鹅飞','',''],['水准','',''],['水准仪','',''],['水准器','',''],['水凼','',''],['水分','',''],['水分多','',''],['水刑','',''],['水刑逼供','',''],['水利','',''],['水利化','',''],['水利厅','',''],['水利学','',''],['水利家','',''],['水利局','',''],['水利工程','',''],['水利建设','',''],['水利枢纽','',''],['水利资源','',''],['水利部','',''],['水到渠成','',''],['水刷石','',''],['水剂','',''],['水前','',''],['水力','',''],['水力发电','',''],['水力发电站','',''],['水力学','',''],['水力资源','',''],['水力鼓风','',''],['水动','',''],['水势','',''],['水化','',''],['水印','',''],['水厂','',''],['水压','',''],['水压机','',''],['水原','',''],['水原市','',''],['水合','',''],['水合物','',''],['水咀','',''],['水团','',''],['水圈','',''],['水土','',''],['水土不服','',''],['水土保持','',''],['水土流失','',''],['水土资源','',''],['水地','',''],['水坑','',''],['水坝','',''],['水坠坝','',''],['水垢','',''],['水域','',''],['水塔','',''],['水塘','',''],['水墨','',''],['水墨画','',''],['水壁','',''],['水声','',''],['水壶','',''],['水壶盖','',''],['水处理','',''],['水大鱼多','',''],['水天一色','',''],['水头','',''],['水孔','',''],['水客','',''],['水害','',''],['水宿风餐','',''],['水密','',''],['水尽','',''],['水尽山穷','',''],['水尽鹅飞','',''],['水层','',''],['水工','',''],['水师','',''],['水帘','',''],['水帘洞','',''],['水带','',''],['水幕','',''],['水平','',''],['水平仪','',''],['水平线','',''],['水平翼','',''],['水平角','',''],['水平轴','',''],['水平面','',''],['水库','',''],['水底','',''],['水底写字板','',''],['水底捞明月','',''],['水底捞针','',''],['水底摸月','',''],['水底相机','',''],['水彩','',''],['水彩画','',''],['水往低处流','',''],['水性','',''],['水性杨花','',''],['水性随邪','',''],['水怪','',''],['水患','',''],['水情','',''],['水成','',''],['水成岩','',''],['水战','',''],['水户市','',''],['水手','',''],['水手长','',''],['水文','',''],['水文地质','',''],['水文学','',''],['水文学家','',''],['水文气象','',''],['水文科学','',''],['水文站','',''],['水文预报','',''],['水斗','',''],['水断陆绝','',''],['水族箱','',''],['水族馆','',''],['水旱','',''],['水旱灾害','',''],['水旱轮作','',''],['水星','',''],['水晶','',''],['水晶体','',''],['水晶制','',''],['水晶宫','',''],['水晶球','',''],['水暖工','',''],['水曜日','',''],['水曲柳','',''],['水月观音','',''],['水月镜像','',''],['水月镜花','',''],['水木','',''],['水杉','',''],['水来','',''],['水来伸手饭来张口','',''],['水来土堰','',''],['水来土掩','',''],['水杨','',''],['水杨酸','',''],['水松','',''],['水林','',''],['水林乡','',''],['水果','',''],['水果刀','',''],['水果商','',''],['水果渣','',''],['水果画','',''],['水果糖','',''],['水果酒','',''],['水枪','',''],['水柱','',''],['水栖','',''],['水栗','',''],['水桶','',''],['水榭','',''],['水槽','',''],['水横枝','',''],['水母','',''],['水母体','',''],['水母目虾','',''],['水气','',''],['水汀','',''],['水池','',''],['水污','',''],['水污染','',''],['水汪汪','',''],['水汽','',''],['水沙','',''],['水沟','',''],['水沫','',''],['水泄','',''],['水泄不漏','',''],['水泄不通','',''],['水泡','',''],['水泡疹','',''],['水波','',''],['水泥','',''],['水泥匠','',''],['水泥厂','',''],['水泥浆','',''],['水泥船','',''],['水泵','',''],['水泻','',''],['水泽','',''],['水洁冰清','',''],['水洗','',''],['水洞','',''],['水洼','',''],['水流','',''],['水流花谢','',''],['水浅','',''],['水浆不入','',''],['水浇','',''],['水浇地','',''],['水浒','',''],['水浒传','',''],['水浒全传','',''],['水浒后传','',''],['水浴','',''],['水浸','',''],['水涝','',''],['水涡','',''],['水涨船高','',''],['水深','',''],['水深度','',''],['水深火热','',''],['水淹','',''],['水清无鱼','',''],['水渍','',''],['水渠','',''],['水温','',''],['水温表','',''],['水源','',''],['水源保护','',''],['水源林','',''],['水溜','',''],['水溶','',''],['水溶性','',''],['水溶液','',''],['水滨','',''],['水滴','',''],['水滴石穿','',''],['水漉漉','',''],['水漏','',''],['水潭','',''],['水火','',''],['水火不容','',''],['水火不相容','',''],['水火不辞','',''],['水火无交','',''],['水火无情','',''],['水灰比','',''],['水灵','',''],['水灵灵','',''],['水灾','',''],['水烟','',''],['水烟筒','',''],['水烟袋','',''],['水煤气','',''],['水煮蛋','',''],['水煮鱼','',''],['水牌','',''],['水牛','',''],['水牛儿','',''],['水牛城','',''],['水牢','',''],['水獭','',''],['水玉','',''],['水玻璃','',''],['水珠','',''],['水球','',''],['水球场','',''],['水理学','',''],['水瓢','',''],['水瓶','',''],['水瓶座','',''],['水生','',''],['水生类蔬菜','',''],['水田','',''],['水田芥','',''],['水电','',''],['水电站','',''],['水电费','',''],['水电部','',''],['水界','',''],['水疗','',''],['水疗法','',''],['水疗院','',''],['水疱','',''],['水痘','',''],['水皮儿','',''],['水盂','',''],['水盆','',''],['水相','',''],['水碓','',''],['水碧山青','',''],['水碱','',''],['水碾','',''],['水磨','',''],['水磨功夫','',''],['水磨沟','',''],['水磨石','',''],['水神','',''],['水禽','',''],['水秀山明','',''],['水稻','',''],['水稻土','',''],['水穷山尽','',''],['水立方','',''],['水竹','',''],['水笔','',''],['水筒','',''],['水筲','',''],['水管','',''],['水管工','',''],['水管工人','',''],['水管车','',''],['水管面','',''],['水箱','',''],['水米无交','',''],['水粉','',''],['水粉画','',''],['水系','',''],['水红','',''],['水纹','',''],['水线','',''],['水绵','',''],['水绿','',''],['水绿山青','',''],['水缸','',''],['水罐','',''],['水网','',''],['水网地','',''],['水翼船','',''],['水老鸦','',''],['水耕法','',''],['水肥','',''],['水肺','',''],['水肿','',''],['水肿病','',''],['水胶','',''],['水能','',''],['水能源','',''],['水能载舟亦能覆舟','',''],['水脉','',''],['水脚','',''],['水臌','',''],['水至清则无鱼','',''],['水舀','',''],['水舀子','',''],['水色','',''],['水色山光','',''],['水花','',''],['水花生','',''],['水芹','',''],['水草','',''],['水荒','',''],['水荡','',''],['水莽','',''],['水菖蒲','',''],['水萍','',''],['水落','',''],['水落归槽','',''],['水落石出','',''],['水落管','',''],['水葫芦','',''],['水葬','',''],['水葱','',''],['水蒸气','',''],['水蒸汽','',''],['水蓼','',''],['水蕹菜','',''],['水藻','',''],['水虎鱼','',''],['水虱','',''],['水虿','',''],['水蚀','',''],['水蚤','',''],['水蛇','',''],['水蛇座','',''],['水蛇腰','',''],['水蛭','',''],['水蛭素','',''],['水蜜桃','',''],['水蜥','',''],['水螅','',''],['水螅体','',''],['水表','',''],['水袖','',''],['水覆难收','',''],['水解','',''],['水解酶','',''],['水貂','',''],['水货','',''],['水质','',''],['水质污染','',''],['水费','',''],['水资源','',''],['水路','',''],['水车','',''],['水车前','',''],['水轮','',''],['水轮机','',''],['水轮泵','',''],['水边','',''],['水运','',''],['水远山摇','',''],['水远山长','',''],['水送山迎','',''],['水选','',''],['水通灯亮','',''],['水遁','',''],['水道','',''],['水道口','',''],['水道学','',''],['水部','',''],['水酒','',''],['水里','',''],['水里乡','',''],['水量','',''],['水钵','',''],['水铅','',''],['水银','',''],['水银剂','',''],['水银柱','',''],['水银灯','',''],['水锈','',''],['水锤','',''],['水门','',''],['水门事件','',''],['水门汀','',''],['水闸','',''],['水阁','',''],['水阔山高','',''],['水陆','',''],['水陆两用','',''],['水陆交通','',''],['水陆师','',''],['水陆毕陈','',''],['水陆空','',''],['水陆联运','',''],['水险','',''],['水障碍','',''],['水雷','',''],['水雷区','',''],['水雾','',''],['水青冈','',''],['水面','',''],['水面上','',''],['水面下','',''],['水靴','',''],['水饺','',''],['水饺儿','',''],['水鬼','',''],['水鳖子','',''],['水鸟','',''],['水鸡','',''],['水鸪鸪','',''],['水鹤','',''],['水鹿','',''],['水龙','',''],['水龙卷','',''],['水龙头','',''],['水龙带','',''],['水水的','',''],['永不','',''],['永不再','',''],['永不生锈','',''],['永世','',''],['永世其芳','',''],['永世无穷','',''],['永久','',''],['永久冻土','',''],['永久和平','',''],['永久居民','',''],['永久性','',''],['永久磁铁','',''],['永久虚电路','',''],['永乐','',''],['永乐大典','',''],['永享','',''],['永传不朽','',''],['永保','',''],['永冻土','',''],['永别','',''],['永动机','',''],['永吉地区','',''],['永和市','',''],['永嘉郡','',''],['永垂','',''],['永垂不朽','',''],['永垂青史','',''],['永字八法','',''],['永存','',''],['永存不朽','',''],['永安乡','',''],['永定河','',''],['永定门','',''],['永居','',''],['永川区','',''],['永往','',''],['永志不忘','',''],['永恒','',''],['永无','',''],['永无休止','',''],['永无止境','',''],['永永无穷','',''],['永永远远','',''],['永济渠','',''],['永珍','',''],['永生','',''],['永生永世','',''],['永生鸟','',''],['永眠','',''],['永矢','',''],['永磁','',''],['永能','',''],['永葆青春','',''],['永诀','',''],['永诀式','',''],['永贞内禅','',''],['永贞革新','',''],['永远','',''],['永逝','',''],['永锡不匮','',''],['永靖乡','',''],['永驻','',''],['氹仔','',''],['氽子','',''],['氽汤','',''],['氽烫','',''],['氾滥','',''],['汀曲','',''],['汀江','',''],['汀洲','',''],['汀渚','',''],['汀线','',''],['汁儿','',''],['汁水','',''],['汁液','',''],['汁质','',''],['求三拜四','',''],['求主','',''],['求之','',''],['求之不得','',''],['求之过急','',''],['求乞','',''],['求亲','',''],['求亲靠友','',''],['求人','',''],['求人不如求己','',''],['求仁得仁','',''],['求他','',''],['求你','',''],['求借','',''],['求值','',''],['求偶','',''],['求全','',''],['求全之毁','',''],['求全责备','',''],['求其友声','',''],['求出','',''],['求利','',''],['求剑刻舟','',''],['求助','',''],['求助于','',''],['求助于人','',''],['求医','',''],['求医癖','',''],['求取','',''],['求变','',''],['求同','',''],['求同存异','',''],['求名夺利','',''],['求名求利','',''],['求名责实','',''],['求告','',''],['求和','',''],['求备一人','',''],['求大同','',''],['求大同存小异','',''],['求好','',''],['求婚','',''],['求子','',''],['求存','',''],['求学','',''],['求学无坦途','',''],['求实','',''],['求幂','',''],['求得','',''],['求怜经','',''],['求情','',''],['求情告饶','',''],['求成','',''],['求成过急','',''],['求我','',''],['求战','',''],['求才','',''],['求才若渴','',''],['求援','',''],['求效益','',''],['求救','',''],['求教','',''],['求新','',''],['求新立异','',''],['求是','',''],['求根','',''],['求死','',''],['求死不得','',''],['求死愿望','',''],['求求','',''],['求求你','',''],['求法','',''],['求活','',''],['求爱','',''],['求爱者','',''],['求生','',''],['求生不得求死不能','',''],['求生不生求死不死','',''],['求生害义','',''],['求生意志','',''],['求田问舍','',''],['求真','',''],['求知','',''],['求知欲','',''],['求神','',''],['求神问卜','',''],['求福','',''],['求福禳灾','',''],['求积','',''],['求积分','',''],['求稳','',''],['求签','',''],['求精','',''],['求索','',''],['求职','',''],['求职信','',''],['求职者','',''],['求胜','',''],['求胜心切','',''],['求艺','',''],['求荣卖国','',''],['求补','',''],['求见','',''],['求解','',''],['求证','',''],['求诊','',''],['求贤','',''],['求贤下士','',''],['求贤如渴','',''],['求贤用士','',''],['求贤若渴','',''],['求过','',''],['求远','',''],['求降','',''],['求雨','',''],['求靠','',''],['求饶','',''],['求马唐肆','',''],['求鱼缘木','',''],['汇业财经集团','',''],['汇业银行','',''],['汇丰','',''],['汇丰券','',''],['汇丰银行','',''],['汇为','',''],['汇了','',''],['汇付','',''],['汇价','',''],['汇兑','',''],['汇入','',''],['汇出','',''],['汇出行','',''],['汇划','',''],['汇到','',''],['汇合','',''],['汇回','',''],['汇寄','',''],['汇川','',''],['汇差','',''],['汇往','',''],['汇总','',''],['汇成','',''],['汇报','',''],['汇报人','',''],['汇报会','',''],['汇报演出','',''],['汇拢','',''],['汇拨','',''],['汇整','',''],['汇映','',''],['汇款','',''],['汇款人','',''],['汇款单','',''],['汇水','',''],['汇泉','',''],['汇注','',''],['汇流','',''],['汇流环','',''],['汇演','',''],['汇炉','',''],['汇点','',''],['汇率','',''],['汇票','',''],['汇积','',''],['汇算','',''],['汇给','',''],['汇编','',''],['汇编程序','',''],['汇编语言','',''],['汇缴','',''],['汇聚','',''],['汇落','',''],['汇表','',''],['汇费','',''],['汇路','',''],['汇量','',''],['汇金','',''],['汇集','',''],['汇集者','',''],['汉中地区','',''],['汉书','',''],['汉人','',''],['汉他病毒','',''],['汉代','',''],['汉元帝','',''],['汉剧','',''],['汉办','',''],['汉化','',''],['汉医','',''],['汉南','',''],['汉卡','',''],['汉口','',''],['汉台','',''],['汉唐','',''],['汉四郡','',''],['汉坦病毒','',''],['汉城','',''],['汉城特别市','',''],['汉堡','',''],['汉堡包','',''],['汉堡王','',''],['汉墓','',''],['汉奸','',''],['汉姓','',''],['汉子','',''],['汉字字体','',''],['汉字查字法','',''],['汉字编码','',''],['汉学','',''],['汉学家','',''],['汉学系','',''],['汉官威仪','',''],['汉宣帝','',''],['汉宫','',''],['汉密尔敦','',''],['汉密尔顿','',''],['汉尼拔','',''],['汉文','',''],['汉文帝','',''],['汉文帝刘恒','',''],['汉斯','',''],['汉旺镇','',''],['汉明帝','',''],['汉显','',''],['汉服','',''],['汉朝','',''],['汉末魏初','',''],['汉森','',''],['汉武帝','',''],['汉民','',''],['汉民族','',''],['汉水','',''],['汉江','',''],['汉沽','',''],['汉滨','',''],['汉献帝','',''],['汉白玉','',''],['汉福斯','',''],['汉简','',''],['汉腔','',''],['汉英','',''],['汉英互译','',''],['汉萨同盟','',''],['汉藏语系','',''],['汉译','',''],['汉语分词','',''],['汉语拼音','',''],['汉语水平考试','',''],['汉诺威','',''],['汉贼不两立','',''],['汉阳','',''],['汉高祖','',''],['汉高祖刘邦','',''],['汊港','',''],['汎滥','',''],['汐止','',''],['汐止市','',''],['汕头地区','',''],['汕头大学','',''],['汗国','',''],['汗如雨下','',''],['汗孔','',''],['汗斑','',''],['汗毛','',''],['汗水','',''],['汗津津','',''],['汗洽股栗','',''],['汗流','',''],['汗流浃背','',''],['汗流满面','',''],['汗液','',''],['汗渍','',''],['汗湿','',''],['汗漫','',''],['汗牛充栋','',''],['汗珠','',''],['汗珠子','',''],['汗碱','',''],['汗脚','',''],['汗腺','',''],['汗腾格里峰','',''],['汗臭','',''],['汗血宝马','',''],['汗衫','',''],['汗褂','',''],['汗褂儿','',''],['汗褟儿','',''],['汗迹','',''],['汗青','',''],['汗颜','',''],['汗马','',''],['汗马之功','',''],['汗马之劳','',''],['汗马之绩','',''],['汗马功劳','',''],['汗马功绩','',''],['汗马勋劳','',''],['汛情','',''],['汛期','',''],['汜滥','',''],['汝南月旦','',''],['汝等','',''],['汝辈','',''],['汞中毒','',''],['汞剂','',''],['汞合金','',''],['汞溴','',''],['汞溴红','',''],['江上','',''],['江东','',''],['江东父老','',''],['江东独步','',''],['江中','',''],['江云渭树','',''],['江八点','',''],['江北','',''],['江华县','',''],['江南','',''],['江南四大才子','',''],['江南大学','',''],['江南海北','',''],['江南省','',''],['江原道','',''],['江右','',''],['江城','',''],['江城县','',''],['江夏','',''],['江天','',''],['江天一色','',''],['江孜地区','',''],['江孜镇','',''],['江宁','',''],['江宁条约','',''],['江山不老','',''],['江山之异','',''],['江山之恨','',''],['江山半壁','',''],['江山好改本性难移','',''],['江山好改秉性难移','',''],['江山如故','',''],['江山如画','',''],['江山易帜','',''],['江山易改','',''],['江山易改禀性难移','',''],['江岸','',''],['江州','',''],['江州区','',''],['江左','',''],['江干','',''],['江平','',''],['江心','',''],['江心补漏','',''],['江户','',''],['江月','',''],['江水','',''],['江汉','',''],['江沙','',''],['江河','',''],['江河战斗','',''],['江河日下','',''],['江河湖海','',''],['江河行地','',''],['江泽民','',''],['江洋大盗','',''],['江津区','',''],['江流','',''],['江浙','',''],['江浦','',''],['江浦县','',''],['江海','',''],['江海之学','',''],['江海同归','',''],['江海心驰魏阙','',''],['江淮','',''],['江湖','',''],['江湖义气','',''],['江湖医生','',''],['江湖艺人','',''],['江湖骗子','',''],['江源区','',''],['江潮','',''],['江猪','',''],['江珧','',''],['江珧柱','',''],['江畔','',''],['江米','',''],['江米酒','',''],['江翻海倒','',''],['江翻海沸','',''],['江蓠','',''],['江表','',''],['江西腊','',''],['江豚','',''],['江轮','',''],['江边','',''],['江郎才尽','',''],['江郎才掩','',''],['江酌之喜','',''],['江青','',''],['江面','',''],['江鱼','',''],['池上','',''],['池上乡','',''],['池中之物','',''],['池堂','',''],['池塘','',''],['池子','',''],['池座','',''],['池水','',''],['池汤','',''],['池沼','',''],['池田勇人','',''],['池盐','',''],['池边','',''],['池鱼之殃','',''],['池鱼之灾','',''],['池鱼林木','',''],['池鱼笼鸟','',''],['池鱼遭殃','',''],['池鹭','',''],['污七八糟','',''],['污七糟八','',''],['污名','',''],['污吏','',''],['污吏黜胥','',''],['污垢','',''],['污损','',''],['污斑','',''],['污染','',''],['污染区','',''],['污染源','',''],['污染物','',''],['污染环境','',''],['污染空气','',''],['污染者','',''],['污毒','',''],['污水','',''],['污水坑','',''],['污水处理','',''],['污水处理厂','',''],['污水池','',''],['污水灌溉','',''],['污泥','',''],['污泥浊水','',''],['污浊','',''],['污渍','',''],['污点','',''],['污物','',''],['污痕','',''],['污秽','',''],['污秽物','',''],['污粘','',''],['污蔑','',''],['污言秽语','',''],['污辱','',''],['污迹','',''],['污黑','',''],['汤剂','',''],['汤力水','',''],['汤加人','',''],['汤加群岛','',''],['汤加里罗','',''],['汤勺','',''],['汤包','',''],['汤匙','',''],['汤团','',''],['汤园','',''],['汤圆','',''],['汤壶','',''],['汤头','',''],['汤姆','',''],['汤姆・克兰西','',''],['汤姆・克鲁斯','',''],['汤姆・索亚历险记','',''],['汤姆・罗宾斯','',''],['汤姆孙','',''],['汤姆斯杯','',''],['汤姆索亚历险记','',''],['汤姆逊','',''],['汤婆子','',''],['汤川','',''],['汤川・秀树','',''],['汤料','',''],['汤旺河','',''],['汤显祖','',''],['汤普森','',''],['汤武革命','',''],['汤水','',''],['汤汁','',''],['汤池','',''],['汤池铁城','',''],['汤汤','',''],['汤泉','',''],['汤液','',''],['汤玉麟','',''],['汤盘','',''],['汤碗','',''],['汤类','',''],['汤罐','',''],['汤药','',''],['汤锅','',''],['汤面','',''],['汤饭','',''],['汤饼筵','',''],['汨水','',''],['汨汨','',''],['汨罗江','',''],['汩声','',''],['汩汩','',''],['汩没','',''],['汪东城','',''],['汪啸风','',''],['汪子','',''],['汪汪','',''],['汪洋','',''],['汪洋大海','',''],['汪洋浩博','',''],['汪洋自恣','',''],['汪洋自肆','',''],['汪洋闳肆','',''],['汪流','',''],['汪精卫','',''],['汪道涵','',''],['汰旧换新','',''],['汲出','',''],['汲取','',''],['汲尽','',''],['汲干','',''],['汲引','',''],['汲水','',''],['汲水桶','',''],['汲汲','',''],['汲汲皇皇','',''],['汴州','',''],['汴梁','',''],['汶川地震','',''],['汶川大地震','',''],['汶莱','',''],['汹汹','',''],['汹涌','',''],['汹涌澎湃','',''],['汽体','',''],['汽化','',''],['汽化器','',''],['汽化热','',''],['汽化物','',''],['汽化计','',''],['汽提','',''],['汽暖','',''],['汽机','',''],['汽枪','',''],['汽水','',''],['汽油','',''],['汽油弹','',''],['汽油机','',''],['汽油醇','',''],['汽泵','',''],['汽浴','',''],['汽灯','',''],['汽球','',''],['汽碾','',''],['汽笛','',''],['汽笛声','',''],['汽缸','',''],['汽船','',''],['汽艇','',''],['汽车','',''],['汽车厂','',''],['汽车号牌','',''],['汽车夏利股份有限公司','',''],['汽车展览会','',''],['汽车库','',''],['汽车戏院','',''],['汽车技工','',''],['汽车旅馆','',''],['汽车炸弹','',''],['汽车炸弹事件','',''],['汽车狂','',''],['汽车站','',''],['汽车道','',''],['汽轮','',''],['汽轮发电机','',''],['汽轮机','',''],['汽运','',''],['汽配','',''],['汽酒','',''],['汽锅','',''],['汽锤','',''],['汽闸','',''],['汽阀','',''],['汾水','',''],['汾河','',''],['汾酒','',''],['沁人心肺','',''],['沁人心脾','',''],['沁人肺腑','',''],['沁入','',''],['沁入心脾','',''],['沂水春风','',''],['沂河','',''],['沃伦','',''],['沃伦・巴菲特','',''],['沃克斯豪尔','',''],['沃土','',''],['沃地','',''],['沃基','',''],['沃壤','',''],['沃尔夫','',''],['沃尔夫奖','',''],['沃尔夫斯堡','',''],['沃尔沃','',''],['沃尔特・惠特曼','',''],['沃尔玛','',''],['沃尔芬森','',''],['沃州','',''],['沃水','',''],['沃灌','',''],['沃特森','',''],['沃田','',''],['沃衍','',''],['沃达丰','',''],['沃野','',''],['沃野千里','',''],['沃顿','',''],['沃饶','',''],['沅水','',''],['沅江九肋','',''],['沆瀣','',''],['沆瀣一气','',''],['沈从文','',''],['沈北新','',''],['沈北新区','',''],['沈国放','',''],['沈复','',''],['沈大铁路','',''],['沈寂','',''],['沈思','',''],['沈河','',''],['沈淀剂','',''],['沈淀物','',''],['沈淀素','',''],['沈溺','',''],['沈约','',''],['沈腰潘鬓','',''],['沈莹','',''],['沈葆祯','',''],['沈谜于','',''],['沈闷','',''],['沈阳军区','',''],['沈静','',''],['沈鱼落雁','',''],['沈默','',''],['沈默寡言','',''],['沉下','',''],['沉不住气','',''],['沉了','',''],['沉井','',''],['沉住气','',''],['沉入','',''],['沉冤','',''],['沉冤莫白','',''],['沉凝','',''],['沉博绝丽','',''],['沉厚寡言','',''],['沉吟','',''],['沉吟不决','',''],['沉吟不语','',''],['沉吟未决','',''],['沉寂','',''],['沉床','',''],['沉得','',''],['沉得住气','',''],['沉思','',''],['沉思冥想','',''],['沉思默想','',''],['沉李浮瓜','',''],['沉毅','',''],['沉水植物','',''],['沉沉','',''],['沉没','',''],['沉没成本','',''],['沉沦','',''],['沉沧','',''],['沉河','',''],['沉浮','',''],['沉浸','',''],['沉浸于','',''],['沉淀','',''],['沉淀出','',''],['沉淀法','',''],['沉淀物','',''],['沉渐刚克','',''],['沉渣','',''],['沉湎','',''],['沉湎淫逸','',''],['沉湎酒色','',''],['沉溺','',''],['沉溺于','',''],['沉滓泛起','',''],['沉滞','',''],['沉潜刚克','',''],['沉潭','',''],['沉灶产蛙','',''],['沉物','',''],['沉甸甸','',''],['沉疴','',''],['沉痛','',''],['沉痛怀念','',''],['沉痼','',''],['沉着','',''],['沉着应战','',''],['沉睡','',''],['沉积','',''],['沉积作用','',''],['沉积岩','',''],['沉积带','',''],['沉积物','',''],['沉稳','',''],['沉箱','',''],['沉缅','',''],['沉缓','',''],['沉舟','',''],['沉舟破釜','',''],['沉船','',''],['沉船事故','',''],['沉落','',''],['沉著','',''],['沉著痛快','',''],['沉迷','',''],['沉邃','',''],['沉郁','',''],['沉郁顿挫','',''],['沉醉','',''],['沉醉于','',''],['沉重','',''],['沉重寡言','',''],['沉重少言','',''],['沉重打击','',''],['沉重负担','',''],['沉闷','',''],['沉降','',''],['沉陷','',''],['沉雄古逸','',''],['沉雄悲壮','',''],['沉雷','',''],['沉静','',''],['沉静寡言','',''],['沉静少言','',''],['沉香','',''],['沉鱼落雁','',''],['沉默','',''],['沉默不语','',''],['沉默寡言','',''],['沉默是金','',''],['沏茶','',''],['沐恩','',''],['沐浴','',''],['沐浴乳','',''],['沐浴油','',''],['沐浴球','',''],['沐浴用品','',''],['沐浴者','',''],['沐浴花','',''],['沐浴露','',''],['沐猴冠冕','',''],['沐猴而冠','',''],['沐猴衣冠','',''],['沐雨栉风','',''],['沓沓','',''],['沙一般','',''],['沙丁胺醇','',''],['沙丁鱼','',''],['沙丘','',''],['沙中','',''],['沙乌地阿拉伯','',''],['沙井','',''],['沙井口','',''],['沙依巴克','',''],['沙俄','',''],['沙僧','',''],['沙利迈度','',''],['沙加缅度','',''],['沙包','',''],['沙化','',''],['沙参','',''],['沙发','',''],['沙司','',''],['沙和尚','',''],['沙哑','',''],['沙嘴','',''],['沙土','',''],['沙地','',''],['沙场','',''],['沙坑','',''],['沙坑杆','',''],['沙坝','',''],['沙坡头','',''],['沙坪坝','',''],['沙堆','',''],['沙堡','',''],['沙声','',''],['沙头角','',''],['沙奎尔・奥尼尔','',''],['沙姆沙伊赫','',''],['沙威玛','',''],['沙子','',''],['沙家浜','',''],['沙尘','',''],['沙尘天气','',''],['沙尘暴','',''],['沙层','',''],['沙岗','',''],['沙岩','',''],['沙岸','',''],['沙巴','',''],['沙市','',''],['沙弥','',''],['沙律','',''],['沙悟净','',''],['沙拉','',''],['沙捞越','',''],['沙文','',''],['沙文主义','',''],['沙暴','',''],['沙朗','',''],['沙朗牛排','',''],['沙林','',''],['沙林水解酶','',''],['沙果','',''],['沙枣','',''],['沙柱','',''],['沙柳','',''],['沙梨','',''],['沙棘','',''],['沙棘属','',''],['沙沙','',''],['沙沙声','',''],['沙法维王朝','',''],['沙洲','',''],['沙浅儿','',''],['沙滩','',''],['沙滩排球','',''],['沙滩鞋','',''],['沙漏','',''],['沙漠','',''],['沙漠中','',''],['沙漠之狐','',''],['沙漠化','',''],['沙漠气候','',''],['沙漠研究','',''],['沙爹','',''],['沙爹酱','',''],['沙特','',''],['沙特阿拉伯人','',''],['沙特鲁','',''],['沙獾','',''],['沙琪玛','',''],['沙瓤','',''],['沙瓦玛','',''],['沙田','',''],['沙画','',''],['沙畹','',''],['沙皇','',''],['沙皇俄国','',''],['沙皇制','',''],['沙盘','',''],['沙盘推演','',''],['沙眼','',''],['沙石','',''],['沙砾','',''],['沙碛','',''],['沙祖康','',''],['沙窗','',''],['沙粒','',''],['沙糖','',''],['沙肝儿','',''],['沙脑鱼','',''],['沙船','',''],['沙茶','',''],['沙荒','',''],['沙虫','',''],['沙蚕','',''],['沙袋','',''],['沙西米','',''],['沙质','',''],['沙里淘金','',''],['沙金','',''],['沙锅','',''],['沙锅浅儿','',''],['沙门','',''],['沙门氏菌','',''],['沙门菌','',''],['沙鱼','',''],['沙鸡','',''],['沙鸥','',''],['沙鹿','',''],['沙鹿镇','',''],['沙鼠','',''],['沙龙','',''],['沛雨甘霖','',''],['沟中','',''],['沟内','',''],['沟区','',''],['沟壑','',''],['沟壕','',''],['沟外','',''],['沟子','',''],['沟床','',''],['沟底','',''],['沟施','',''],['沟桥','',''],['沟槽','',''],['沟沿','',''],['沟沿儿','',''],['沟洫','',''],['沟浅','',''],['沟涧','',''],['沟渎','',''],['沟渠','',''],['沟灌','',''],['沟谷','',''],['沟通','',''],['沟通管道','',''],['沟道','',''],['沟门','',''],['沟鼠','',''],['没上没下','',''],['没不暇给','',''],['没世','',''],['没世不忘','',''],['没世难忘','',''],['没中','',''],['没了','',''],['没事','',''],['没事儿','',''],['没事找事','',''],['没于','',''],['没交','',''],['没亲没故','',''],['没人','',''],['没人住','',''],['没人味','',''],['没人味儿','',''],['没人骑','',''],['没什么','',''],['没住','',''],['没信心','',''],['没入','',''],['没六儿','',''],['没关','',''],['没关系','',''],['没准','',''],['没准儿','',''],['没几天','',''],['没分寸','',''],['没分开','',''],['没到','',''],['没力气','',''],['没办法','',''],['没劲','',''],['没劲儿','',''],['没受','',''],['没变','',''],['没口','',''],['没吃没穿','',''],['没听','',''],['没命','',''],['没啥','',''],['没围','',''],['没处','',''],['没多久','',''],['没大改变','',''],['没大没小','',''],['没头官司','',''],['没头没脑','',''],['没头没脸','',''],['没头脑','',''],['没奈何','',''],['没好','',''],['没安好心','',''],['没完','',''],['没完没了','',''],['没底','',''],['没弄脏','',''],['没当回事','',''],['没影','',''],['没得说','',''],['没心没肺','',''],['没心眼','',''],['没怀','',''],['没思想','',''],['没情没绪','',''],['没想','',''],['没想到','',''],['没意思','',''],['没戏','',''],['没打中','',''],['没把','',''],['没拿到','',''],['没收','',''],['没收物','',''],['没放','',''],['没救','',''],['没数','',''],['没日没夜','',''],['没有','',''],['没有的','',''],['没有不散的宴席','',''],['没有事','',''],['没有人烟','',''],['没有什么','',''],['没有什么不可能','',''],['没有关系','',''],['没有办法','',''],['没有劲头','',''],['没有劲头儿','',''],['没有品味','',''],['没有差别','',''],['没有形状','',''],['没有意义','',''],['没有意思','',''],['没有法','',''],['没有生育能力','',''],['没有脸皮','',''],['没有规矩','',''],['没有说的','',''],['没来','',''],['没来由','',''],['没气力','',''],['没水平','',''],['没没','',''],['没没无闻','',''],['没治','',''],['没治了','',''],['没法','',''],['没法没天','',''],['没深没浅','',''],['没清','',''],['没溜儿','',''],['没热情','',''],['没生','',''],['没用','',''],['没电','',''],['没病','',''],['没皮没脸','',''],['没看到','',''],['没种','',''],['没空儿','',''],['没精打彩','',''],['没精打采','',''],['没精神','',''],['没细菌','',''],['没经验','',''],['没羞','',''],['没羞没臊','',''],['没而不朽','',''],['没能','',''],['没脑筋','',''],['没脚','',''],['没脸','',''],['没脸没皮','',''],['没脸见人','',''],['没良心','',''],['没药','',''],['没药树','',''],['没落','',''],['没落子','',''],['没被','',''],['没觉','',''],['没认','',''],['没词儿','',''],['没话','',''],['没说的','',''],['没谱','',''],['没谱儿','',''],['没赶上','',''],['没趣','',''],['没趣味','',''],['没路','',''],['没身不忘','',''],['没轻没重','',''],['没辙','',''],['没过几天','',''],['没过多久','',''],['没醉','',''],['没钱','',''],['没错','',''],['没门儿','',''],['没问题','',''],['没顶','',''],['没领会','',''],['没风味','',''],['没食','',''],['没骨头','',''],['没齿不忘','',''],['没齿难忘','',''],['没齿难泯','',''],['沣水','',''],['沤凼','',''],['沤粪','',''],['沤肥','',''],['沥水','',''],['沥沥','',''],['沥胆堕肝','',''],['沥胆披肝','',''],['沥胆抽肠','',''],['沥血','',''],['沥血叩心','',''],['沥陈鄙见','',''],['沥青','',''],['沥青铀矿','',''],['沦丧','',''],['沦为','',''],['沦亡','',''],['沦入','',''],['沦没','',''],['沦没丧亡','',''],['沦浃','',''],['沦灭','',''],['沦肌浃髓','',''],['沦落','',''],['沦陷','',''],['沦陷区','',''],['沧桑','',''],['沧桑之变','',''],['沧江','',''],['沧浪','',''],['沧浪亭','',''],['沧海','',''],['沧海一粟','',''],['沧海桑田','',''],['沧海横流','',''],['沧海遗珠','',''],['沧源','',''],['沧源县','',''],['沧溟','',''],['沪剧','',''],['沪宁线','',''],['沪宁铁路','',''],['沪市','',''],['沪杭','',''],['沪杭铁路','',''],['沪深港','',''],['沪综指','',''],['沪语','',''],['沫儿','',''],['沫子','',''],['沫状','',''],['沮丧','',''],['沮洳','',''],['沮遏','',''],['沱沱河','',''],['沱灢','',''],['沱茶','',''],['河不出图','',''],['河东','',''],['河东狮','',''],['河东狮吼','',''],['河中','',''],['河伯','',''],['河内','',''],['河北工业大学','',''],['河北日报','',''],['河北杨','',''],['河北梆子','',''],['河北科技大学','',''],['河南县','',''],['河南坠子','',''],['河南梆子','',''],['河卵石','',''],['河叉','',''],['河口','',''],['河名','',''],['河坝','',''],['河堤','',''],['河塘','',''],['河外','',''],['河外星云','',''],['河外星系','',''],['河套','',''],['河姆渡','',''],['河姆渡遗址','',''],['河山','',''],['河山带砺','',''],['河岸','',''],['河川','',''],['河工','',''],['河床','',''],['河底','',''],['河弯','',''],['河心','',''],['河村','',''],['河柳','',''],['河梁','',''],['河槽','',''],['河殇','',''],['河段','',''],['河水','',''],['河水不犯井水','',''],['河汉','',''],['河汊子','',''],['河江','',''],['河池地区','',''],['河汾门下','',''],['河沟','',''],['河沿','',''],['河泥','',''],['河洛人','',''],['河流','',''],['河流地貌学','',''],['河浜','',''],['河清海晏','',''],['河清难俟','',''],['河渠','',''],['河港','',''],['河湾','',''],['河滨','',''],['河滩','',''],['河漫滩','',''],['河狸','',''],['河畔','',''],['河神','',''],['河童','',''],['河粉','',''],['河系','',''],['河网','',''],['河肥','',''],['河落海干','',''],['河蚌','',''],['河蟹','',''],['河西','',''],['河西堡','',''],['河西堡镇','',''],['河西走廊','',''],['河谷','',''],['河豚','',''],['河豚毒素','',''],['河身','',''],['河边','',''],['河运','',''],['河道','',''],['河里','',''],['河防','',''],['河面','',''],['河马','',''],['河鱼','',''],['河鱼之疾','',''],['河鱼腹疾','',''],['河鼓二','',''],['河鼠','',''],['沸反盈天','',''],['沸水','',''],['沸沸','',''],['沸沸扬扬','',''],['沸泉','',''],['沸点','',''],['沸热','',''],['沸石','',''],['沸腾','',''],['沸腾床','',''],['沸腾钢','',''],['油了','',''],['油泼面','',''],['油井','',''],['油亮','',''],['油价','',''],['油光','',''],['油光光','',''],['油光可鉴','',''],['油光水滑','',''],['油光漆','',''],['油制','',''],['油印','',''],['油印机','',''],['油厂','',''],['油压','',''],['油压机','',''],['油品','',''],['油嘴','',''],['油嘴滑舌','',''],['油嘴狗舌','',''],['油囊','',''],['油坊','',''],['油垢','',''],['油塔','',''],['油墨','',''],['油壶','',''],['油头滑脑','',''],['油头滑脸','',''],['油头粉面','',''],['油子','',''],['油孔','',''],['油封','',''],['油尖旺','',''],['油尺','',''],['油层','',''],['油布','',''],['油库','',''],['油底壳','',''],['油彩','',''],['油性','',''],['油料','',''],['油料作物','',''],['油旋','',''],['油条','',''],['油松','',''],['油枪','',''],['油枯','',''],['油柑','',''],['油柿','',''],['油桃','',''],['油桐','',''],['油桶','',''],['油棕','',''],['油椰子','',''],['油槽','',''],['油橄榄','',''],['油款','',''],['油母页岩','',''],['油毛毡','',''],['油毡','',''],['油气','',''],['油气田','',''],['油水','',''],['油池','',''],['油污','',''],['油汪汪','',''],['油油','',''],['油泥','',''],['油泵','',''],['油渍','',''],['油渍麻花','',''],['油渣','',''],['油渣果','',''],['油温','',''],['油滑','',''],['油滴','',''],['油漆','',''],['油漆匠','',''],['油漆工','',''],['油灯','',''],['油灰','',''],['油炒','',''],['油炸','',''],['油炸圈饼','',''],['油炸锅','',''],['油炸饼','',''],['油炸鬼','',''],['油烟','',''],['油然','',''],['油然而生','',''],['油煎','',''],['油煎火燎','',''],['油煎饼','',''],['油状','',''],['油猾','',''],['油瓜','',''],['油瓶','',''],['油田','',''],['油田伴生气','',''],['油画','',''],['油皮','',''],['油盐酱醋','',''],['油盘','',''],['油石','',''],['油矿','',''],['油砂','',''],['油磨','',''],['油票','',''],['油税','',''],['油站','',''],['油管','',''],['油箱','',''],['油类','',''],['油精','',''],['油纸','',''],['油绿','',''],['油缸','',''],['油罐','',''],['油罐车','',''],['油耗','',''],['油脂','',''],['油腔滑调','',''],['油腻','',''],['油膏','',''],['油船','',''],['油花','',''],['油苗','',''],['油茶','',''],['油茶面儿','',''],['油莎草','',''],['油菜','',''],['油菜籽','',''],['油葫芦','',''],['油藏','',''],['油裙','',''],['油车','',''],['油轮','',''],['油迹','',''],['油酯','',''],['油酸','',''],['油量','',''],['油锅','',''],['油锯','',''],['油门','',''],['油鞋','',''],['油页岩','',''],['油饰','',''],['油饼','',''],['油香','',''],['油鸡','',''],['油麦','',''],['油麦菜','',''],['油黑','',''],['治下','',''],['治不好','',''],['治世','',''],['治丝而棼','',''],['治丧','',''],['治丧从俭','',''],['治乱','',''],['治乱兴亡','',''],['治乱存亡','',''],['治保','',''],['治保主任','',''],['治兵','',''],['治军','',''],['治喘','',''],['治国','',''],['治国安民','',''],['治外法权','',''],['治大国若烹小鲜','',''],['治好','',''],['治学','',''],['治安','',''],['治安员','',''],['治安工作','',''],['治安管理','',''],['治家','',''],['治山','',''],['治性','',''],['治愈','',''],['治愚治穷','',''],['治所','',''],['治未病','',''],['治本','',''],['治标','',''],['治标不治本','',''],['治死','',''],['治气','',''],['治水','',''],['治河','',''],['治理','',''],['治理整顿','',''],['治理环境','',''],['治疗','',''],['治疗前','',''],['治疗学','',''],['治疗法','',''],['治疗炎症','',''],['治病','',''],['治病救人','',''],['治罪','',''],['治肝病','',''],['治装','',''],['治装费','',''],['治这','',''],['治黄','',''],['沼气','',''],['沼泽','',''],['沼泽似','',''],['沼泽地','',''],['沼泽地带','',''],['沼狸','',''],['沽名','',''],['沽名吊誉','',''],['沽名干誉','',''],['沽名邀誉','',''],['沽名钓誉','',''],['沽售','',''],['沽水期','',''],['沽酒当垆','',''],['沾上','',''],['沾亲带故','',''],['沾体涂足','',''],['沾光','',''],['沾唇','',''],['沾手','',''],['沾染','',''],['沾染世俗','',''],['沾染习气','',''],['沾染控制','',''],['沾染程度检查仪','',''],['沾水','',''],['沾污','',''],['沾沾自喜','',''],['沾沾自满','',''],['沾沾自足','',''],['沾湿','',''],['沾满','',''],['沾濡','',''],['沾花惹草','',''],['沾血','',''],['沾襟','',''],['沾边','',''],['沾酱','',''],['沿上','',''],['沿习','',''],['沿伸','',''],['沿例','',''],['沿儿','',''],['沿岸','',''],['沿岸地区','',''],['沿帽','',''],['沿条儿','',''],['沿江','',''],['沿河','',''],['沿河县','',''],['沿波讨源','',''],['沿洄','',''],['沿流溯源','',''],['沿流讨源','',''],['沿海','',''],['沿海发展战略','',''],['沿海地区','',''],['沿海地带','',''],['沿海州','',''],['沿海开放城市','',''],['沿海港口','',''],['沿海经济','',''],['沿海经济区','',''],['沿海经济带','',''],['沿海航行权','',''],['沿滩','',''],['沿用','',''],['沿用至今','',''],['沿着','',''],['沿线','',''],['沿著','',''],['沿街','',''],['沿袭','',''],['沿路','',''],['沿边','',''],['沿边儿','',''],['沿途','',''],['沿门托钵','',''],['沿阶草','',''],['沿革','',''],['泄了','',''],['泄出','',''],['泄劲','',''],['泄密','',''],['泄底','',''],['泄怒','',''],['泄恨','',''],['泄愤','',''],['泄殖肛孔','',''],['泄殖腔','',''],['泄气','',''],['泄泻','',''],['泄洪','',''],['泄洪道','',''],['泄洪闸','',''],['泄流','',''],['泄漏','',''],['泄漏天机','',''],['泄物','',''],['泄痢','',''],['泄私愤','',''],['泄药','',''],['泄露','',''],['泄露天机','',''],['泅水','',''],['泅泳','',''],['泅渡','',''],['泅游','',''],['泉下','',''],['泉华','',''],['泉城','',''],['泉山','',''],['泉币','',''],['泉水','',''],['泉涌','',''],['泉港','',''],['泉源','',''],['泉眼','',''],['泉石膏肓','',''],['泉路','',''],['泊位','',''],['泊地','',''],['泊定','',''],['泊岸','',''],['泊松','',''],['泊松分布','',''],['泊船','',''],['泊车','',''],['泌乳','',''],['泌尿','',''],['泌尿器','',''],['泌尿系统','',''],['泌尿系统感染','',''],['泌液','',''],['泌腺','',''],['泔水','',''],['泔脚','',''],['法上','',''],['法书','',''],['法事','',''],['法人','',''],['法人地位','',''],['法人资格','',''],['法令','',''],['法会','',''],['法位','',''],['法儿','',''],['法兰','',''],['法兰克','',''],['法兰克林','',''],['法兰克福','',''],['法兰克福学派','',''],['法兰克福汇报','',''],['法兰克福证券交易所','',''],['法兰克福车展','',''],['法兰德斯','',''],['法兰斯','',''],['法兰盘','',''],['法兰绒','',''],['法兰西体育场','',''],['法兰西帝国','',''],['法兰西斯','',''],['法兰西斯・培根','',''],['法兰西斯・斐迪南','',''],['法典','',''],['法兹鲁拉','',''],['法军','',''],['法出多门','',''],['法则','',''],['法利赛人','',''],['法制','',''],['法制办公室','',''],['法制化','',''],['法制史','',''],['法制建设','',''],['法制日报','',''],['法制观念','',''],['法制轨道','',''],['法力','',''],['法力无边','',''],['法办','',''],['法务','',''],['法勒斯','',''],['法医','',''],['法医学','',''],['法华经','',''],['法史','',''],['法号','',''],['法名','',''],['法向量','',''],['法商','',''],['法器','',''],['法国一八四八年革命','',''],['法国七月革命','',''],['法国人','',''],['法国号','',''],['法国唯物主义','',''],['法国大革命','',''],['法国式','',''],['法国梧桐','',''],['法国航空','',''],['法国航空公司','',''],['法国资产阶级革命','',''],['法国长棍','',''],['法国革命','',''],['法场','',''],['法塔赫','',''],['法外','',''],['法外施仁','',''],['法子','',''],['法学','',''],['法学博士','',''],['法学士','',''],['法学家','',''],['法学院','',''],['法官','',''],['法官席','',''],['法定','',''],['法定人数','',''],['法定年龄','',''],['法定继承人','',''],['法定货币','',''],['法宝','',''],['法家','',''],['法射线','',''],['法尔卡什','',''],['法属','',''],['法币','',''],['法师','',''],['法帖','',''],['法度','',''],['法庭','',''],['法庭调查','',''],['法庭辩论','',''],['法式','',''],['法式色拉酱','',''],['法律','',''],['法律上','',''],['法律制裁','',''],['法律学','',''],['法律学家','',''],['法律效力','',''],['法律界','',''],['法律约束力','',''],['法律责任','',''],['法律顾问','',''],['法拉','',''],['法拉利','',''],['法拉盛','',''],['法拉第','',''],['法政','',''],['法新社','',''],['法旨','',''],['法曹','',''],['法服','',''],['法朗','',''],['法术','',''],['法权','',''],['法条','',''],['法案','',''],['法棍','',''],['法槌','',''],['法治','',''],['法治建设','',''],['法派','',''],['法海','',''],['法源','',''],['法源寺','',''],['法物','',''],['法王','',''],['法理','',''],['法理学','',''],['法盲','',''],['法相宗','',''],['法码','',''],['法禁','',''],['法种','',''],['法科','',''],['法程','',''],['法筵','',''],['法纪','',''],['法纪教育','',''],['法线','',''],['法统','',''],['法网','',''],['法网恢恢','',''],['法网恢恢疏而不漏','',''],['法网灰灰','',''],['法网难逃','',''],['法老','',''],['法老王','',''],['法者','',''],['法耶德','',''],['法航','',''],['法蒂玛','',''],['法螺','',''],['法衣','',''],['法衣室','',''],['法裔','',''],['法西斯','',''],['法西斯主义','',''],['法西斯党','',''],['法西斯蒂','',''],['法规','',''],['法规汇编','',''],['法警','',''],['法记','',''],['法赫德','',''],['法轮','',''],['法轮功','',''],['法轮大法','',''],['法轮常转','',''],['法郎','',''],['法金币','',''],['法门','',''],['法院','',''],['法院裁决','',''],['法隆寺','',''],['法马古斯塔','',''],['法驾','',''],['法鲁克','',''],['泗州戏','',''],['泛代数','',''],['泛光','',''],['泛光灯','',''],['泛函分析','',''],['泛味','',''],['泛回','',''],['泛大洋','',''],['泛大陆','',''],['泛岛','',''],['泛指','',''],['泛斯拉夫主义','',''],['泛日耳曼主义','',''],['泛民主派','',''],['泛泛','',''],['泛泛之交','',''],['泛泛而谈','',''],['泛滥','',''],['泛滥成灾','',''],['泛爱','',''],['泛珠三角','',''],['泛珠江三角','',''],['泛白','',''],['泛碱','',''],['泛神','',''],['泛神论','',''],['泛称','',''],['泛红','',''],['泛美','',''],['泛美主义','',''],['泛自然神论','',''],['泛舟','',''],['泛色','',''],['泛论','',''],['泛读','',''],['泛起','',''],['泛酸','',''],['泛阿拉伯主义','',''],['泛非主义','',''],['泛音','',''],['泛频','',''],['泝源','',''],['泠泠','',''],['泡一下','',''],['泡上','',''],['泡制','',''],['泡吧','',''],['泡在','',''],['泡妞','',''],['泡子','',''],['泡开','',''],['泡影','',''],['泡打粉','',''],['泡桐','',''],['泡水','',''],['泡汤','',''],['泡沫','',''],['泡沫剂','',''],['泡沫塑料','',''],['泡沫橡胶','',''],['泡沫水泥','',''],['泡沫状','',''],['泡沫玻璃','',''],['泡沫经济','',''],['泡沸石','',''],['泡泡','',''],['泡泡口香糖','',''],['泡泡浴','',''],['泡泡浴露','',''],['泡泡糖','',''],['泡泡纱','',''],['泡浸','',''],['泡温泉','',''],['泡湿','',''],['泡漩','',''],['泡澡','',''],['泡状','',''],['泡疹','',''],['泡病','',''],['泡病号','',''],['泡罩塔','',''],['泡脚','',''],['泡腾','',''],['泡茶','',''],['泡药','',''],['泡菜','',''],['泡蘑菇','',''],['泡货','',''],['泡面','',''],['泡饭','',''],['泡馍','',''],['波义耳','',''],['马略特定律','',''],['波什格伦','',''],['波光','',''],['波光粼粼','',''],['波兰一八六三年起义','',''],['波兰人','',''],['波兰化','',''],['波兰史','',''],['波兰币','',''],['波兰斯基','',''],['波兰舞','',''],['波兰语','',''],['波兹南','',''],['波兹坦','',''],['波兹曼','',''],['波函数','',''],['波利尼西亚','',''],['波动','',''],['波动力学','',''],['波动性','',''],['波动起伏','',''],['波及','',''],['波及面','',''],['波哥大','',''],['波型','',''],['波堤','',''],['波塞冬','',''],['波士','',''],['波士尼亚','',''],['波士顿','',''],['波士顿大学','',''],['波士顿红袜','',''],['波多马克河','',''],['波季','',''],['波导','',''],['波导管','',''],['波尔卡','',''],['波尔多','',''],['波尔多液','',''],['波尔布特','',''],['波尔干','',''],['波尔干地区','',''],['波峰','',''],['波希米亚','',''],['波带','',''],['波带片','',''],['波幅','',''],['波平浪静','',''],['波弗特海','',''],['波形','',''],['波形图','',''],['波影','',''],['波德','',''],['波德申','',''],['波恩','',''],['波恩大学','',''],['波托马克河','',''],['波折','',''],['波拿巴','',''],['波数','',''],['波斯','',''],['波斯人','',''],['波斯尼亚','',''],['波斯尼亚和黑塞哥维纳共和国','',''],['波斯尼亚语','',''],['波斯帝国','',''],['波斯教','',''],['波斯普鲁斯','',''],['波斯普鲁斯海峡','',''],['波斯湾','',''],['波斯湾地区','',''],['波斯猫','',''],['波斯菊','',''],['波斯语','',''],['波斯里亚','',''],['波方程','',''],['波旁','',''],['波旁王朝','',''],['波昂','',''],['波束','',''],['波来克','',''],['波森莓','',''],['波棱盖','',''],['波段','',''],['波江座','',''],['波河','',''],['波洛涅斯','',''],['波浪','',''],['波浪式','',''],['波浪形','',''],['波浪热','',''],['波浪鼓','',''],['波涛','',''],['波涛汹涌','',''],['波涛磷磷','',''],['波涛粼粼','',''],['波源','',''],['波澜','',''],['波澜壮阔','',''],['波澜老成','',''],['波澜起伏','',''],['波特','',''],['波特兰市','',''],['波特率','',''],['波状','',''],['波状云','',''],['波状热','',''],['波痕','',''],['波粒二象性','',''],['波级','',''],['波纹','',''],['波罗','',''],['波罗的海','',''],['波美度','',''],['波美拉尼亚','',''],['波美比重计','',''],['波腹','',''],['波茨坦','',''],['波茨坦会议','',''],['波茨坦公告','',''],['波荡','',''],['波西米亚','',''],['波语','',''],['波谱','',''],['波谲云诡','',''],['波谷','',''],['波路壮阔','',''],['波速','',''],['波道','',''],['波长','',''],['波阳','',''],['波阳县','',''],['波阿斯','',''],['波阿次','',''],['波隆那','',''],['波霎','',''],['波霸','',''],['波霸奶茶','',''],['波面','',''],['波音','',''],['波鸿','',''],['泣下如雨','',''],['泣下沾襟','',''],['泣不成声','',''],['泣别','',''],['泣声','',''],['泣然','',''],['泣者','',''],['泣血捶膺','',''],['泣血枕戈','',''],['泣血椎心','',''],['泣血涟如','',''],['泣血稽颡','',''],['泣诉','',''],['泣谏','',''],['泣谢','',''],['泥中','',''],['泥中隐刺','',''],['泥丸','',''],['泥人','',''],['泥刀','',''],['泥厂','',''],['泥古','',''],['泥古不化','',''],['泥古非今','',''],['泥土','',''],['泥坑','',''],['泥垢','',''],['泥塑','',''],['泥塑木雕','',''],['泥塘','',''],['泥多佛大','',''],['泥子','',''],['泥孩','',''],['泥守','',''],['泥封','',''],['泥岩','',''],['泥工','',''],['泥巴','',''],['泥心','',''],['泥料','',''],['泥板','',''],['泥桨','',''],['泥水','',''],['泥水匠','',''],['泥水选种','',''],['泥污','',''],['泥沙','',''],['泥沙俱下','',''],['泥沼','',''],['泥泞','',''],['泥流','',''],['泥浆','',''],['泥涂轩冕','',''],['泥淖','',''],['泥渣','',''],['泥潭','',''],['泥灰','',''],['泥灰岩','',''],['泥灰砖','',''],['泥灰质','',''],['泥炭','',''],['泥炭藓','',''],['泥煤','',''],['泥煤似','',''],['泥牛入海','',''],['泥猪瓦狗','',''],['泥瓦匠','',''],['泥疗','',''],['泥盆系','',''],['泥盆纪','',''],['泥石','',''],['泥石流','',''],['泥砖','',''],['泥肥','',''],['泥胎','',''],['泥胎儿','',''],['泥腿','',''],['泥船渡河','',''],['泥色','',''],['泥菩萨','',''],['泥菩萨落水','',''],['泥菩萨过江','',''],['泥质','',''],['泥质岩','',''],['泥质页岩','',''],['泥足巨人','',''],['泥醉','',''],['泥金','',''],['泥铲','',''],['泥面','',''],['泥饭碗','',''],['泥鱼','',''],['泥鳅','',''],['注以','',''],['注入','',''],['注入器','',''],['注入式教学','',''],['注册','',''],['注册人','',''],['注册商标','',''],['注册表','',''],['注出','',''],['注口','',''],['注塑','',''],['注定','',''],['注射','',''],['注射剂','',''],['注射器','',''],['注射筒','',''],['注射者','',''],['注射针','',''],['注射针头','',''],['注意','',''],['注意事项','',''],['注意到','',''],['注意力','',''],['注意力缺陷过动症','',''],['注意听','',''],['注意看','',''],['注意着','',''],['注文','',''],['注明','',''],['注有','',''],['注本','',''],['注水','',''],['注满','',''],['注疏','',''],['注目','',''],['注脚','',''],['注色','',''],['注视','',''],['注视者','',''],['注解','',''],['注记','',''],['注资','',''],['注过册','',''],['注释','',''],['注重','',''],['注重实效','',''],['注重质量','',''],['注销','',''],['注音','',''],['注音一式','',''],['注音字母','',''],['注音法','',''],['注音符号','',''],['泪下','',''],['泪下如雨','',''],['泪人','',''],['泪人儿','',''],['泪光','',''],['泪如泉涌','',''],['泪如雨下','',''],['泪弹','',''],['泪水','',''],['泪水涟涟','',''],['泪汪汪','',''],['泪流','',''],['泪流满面','',''],['泪液','',''],['泪滴','',''],['泪珠','',''],['泪痕','',''],['泪眼','',''],['泪眼愁眉','',''],['泪管','',''],['泪腺','',''],['泪花','',''],['泪雨','',''],['泫然','',''],['泯没','',''],['泯灭','',''],['泰东','',''],['泰人','',''],['泰加林','',''],['泰勒','',''],['泰半','',''],['泰华','',''],['泰卢固语','',''],['泰县','',''],['泰国人','',''],['泰国语','',''],['泰坦','',''],['泰坦尼克号','',''],['泰姬陵','',''],['泰安乡','',''],['泰安县','',''],['泰安地区','',''],['泰尔','',''],['泰山之安','',''],['泰山乡','',''],['泰山其颓','',''],['泰山北斗','',''],['泰山压卵','',''],['泰山压顶','',''],['泰山可倚','',''],['泰山梁木','',''],['泰山若厉','',''],['泰山鸿毛','',''],['泰式','',''],['泰恩布德','',''],['泰戈尔','',''],['泰拳','',''],['泰文','',''],['泰斗','',''],['泰晤','',''],['泰晤士','',''],['泰晤士报','',''],['泰晤士河','',''],['泰来否往','',''],['泰来否极','',''],['泰极而否','',''],['泰格・伍兹','',''],['泰格尔','',''],['泰武','',''],['泰武乡','',''],['泰然','',''],['泰然处之','',''],['泰然居之','',''],['泰然自若','',''],['泰特斯・安德洛尼克斯','',''],['泰王','',''],['泰瑟','',''],['泰瑟尔岛','',''],['泰瑟枪','',''],['泰米尔','',''],['泰米尔伊拉姆猛虎解放组织','',''],['泰米尔猛虎组织','',''],['泰米尔纳德','',''],['泰米尔纳德邦','',''],['泰米尔语','',''],['泰罗','',''],['泰而不费','',''],['泰裕','',''],['泰西','',''],['泰西大儒','',''],['泰象啤','',''],['泰达','',''],['泰迪熊','',''],['泰铢','',''],['泰阿倒持','',''],['泰雅族','',''],['泱泱','',''],['泱泱大国','',''],['泳儿','',''],['泳动','',''],['泳场','',''],['泳坛','',''],['泳将','',''],['泳帽','',''],['泳时','',''],['泳池','',''],['泳者','',''],['泳衣','',''],['泳装','',''],['泳裤','',''],['泳镜','',''],['泵房','',''],['泵柄','',''],['泵水','',''],['泵灯','',''],['泵站','',''],['泷水','',''],['泷泽','',''],['泷船','',''],['泸定桥','',''],['泸沽湖','',''],['泻出','',''],['泻密','',''],['泻愤','',''],['泻湖','',''],['泻漏','',''],['泻盐','',''],['泻肚','',''],['泻肚子','',''],['泻药','',''],['泼以','',''],['泼冷水','',''],['泼出','',''],['泼剌','',''],['泼墨','',''],['泼天','',''],['泼妇','',''],['泼妇骂街','',''],['泼性','',''],['泼悍','',''],['泼掉','',''],['泼水','',''],['泼水节','',''],['泼水难收','',''],['泼洒','',''],['泼湿','',''],['泼溅','',''],['泼烟花','',''],['泼物','',''],['泼皮','',''],['泼脏','',''],['泼贱','',''],['泼贱人','',''],['泼辣','',''],['泼醅','',''],['泽兰','',''],['泽及枯骨','',''],['泽国','',''],['泽地','',''],['泽塔','',''],['泽布吕赫','',''],['泽当','',''],['泽当镇','',''],['泽泻','',''],['泽深恩重','',''],['泽西','',''],['泽面','',''],['泾渭不分','',''],['泾渭分明','',''],['洁具','',''],['洁净','',''],['洁净无瑕','',''],['洁剂','',''],['洁器','',''],['洁己奉公','',''],['洁己爱人','',''],['洁度','',''],['洁操','',''],['洁治','',''],['洁癖','',''],['洁白','',''],['洁白无瑕','',''],['洁西卡','',''],['洁西卡・艾芭','',''],['洁言污行','',''],['洁身','',''],['洁身自好','',''],['洁身自爱','',''],['洁面乳','',''],['洁面露','',''],['洁食','',''],['洄游','',''],['洄澜','',''],['洇湿','',''],['洋中脊','',''],['洋为中用','',''],['洋井','',''],['洋人','',''],['洋伞','',''],['洋兵','',''],['洋务','',''],['洋务学堂','',''],['洋务派','',''],['洋务运动','',''],['洋化','',''],['洋员','',''],['洋味','',''],['洋嗓子','',''],['洋地黄','',''],['洋场','',''],['洋场恶少','',''],['洋基','',''],['洋基队','',''],['洋壳','',''],['洋奴','',''],['洋奴哲学','',''],['洋妞','',''],['洋姜','',''],['洋娃娃','',''],['洋学','',''],['洋山深水港','',''],['洋山港','',''],['洋布','',''],['洋底','',''],['洋底地壳','',''],['洋式','',''],['洋房','',''],['洋教','',''],['洋文','',''],['洋服','',''],['洋枪','',''],['洋梨','',''],['洋楼','',''],['洋槐','',''],['洋槐树','',''],['洋橄榄','',''],['洋毫','',''],['洋气','',''],['洋油','',''],['洋法','',''],['洋洋','',''],['洋洋大篇','',''],['洋洋大观','',''],['洋洋得意','',''],['洋洋洒洒','',''],['洋洋自得','',''],['洋派','',''],['洋流','',''],['洋浦','',''],['洋浦经济开发区','',''],['洋淀','',''],['洋溢','',''],['洋漂族','',''],['洋火','',''],['洋灰','',''],['洋灰浆','',''],['洋烟','',''],['洋片','',''],['洋琴','',''],['洋琵琶','',''],['洋瓷','',''],['洋甘菊','',''],['洋画儿','',''],['洋白菜','',''],['洋盘','',''],['洋相','',''],['洋码子','',''],['洋碱','',''],['洋粉','',''],['洋紫苏','',''],['洋紫荆','',''],['洋红','',''],['洋红色','',''],['洋纱','',''],['洋绣球','',''],['洋缎','',''],['洋脊','',''],['洋腔','',''],['洋腔洋调','',''],['洋舰','',''],['洋船','',''],['洋芋','',''],['洋芫荽','',''],['洋苏','',''],['洋药','',''],['洋菜','',''],['洋葱','',''],['洋葱似','',''],['洋蒲桃','',''],['洋蓟','',''],['洋行','',''],['洋装','',''],['洋调','',''],['洋财','',''],['洋货','',''],['洋车','',''],['洋酒','',''],['洋里洋气','',''],['洋金花','',''],['洋钉','',''],['洋钢','',''],['洋钱','',''],['洋铁','',''],['洋铁箔','',''],['洋银','',''],['洋镐','',''],['洋面','',''],['洋香菜','',''],['洋鬼','',''],['洋鬼子','',''],['洒上','',''],['洒了','',''],['洒出','',''],['洒地','',''],['洒家','',''],['洒布','',''],['洒扫','',''],['洒水','',''],['洒水器','',''],['洒水机','',''],['洒水车','',''],['洒泪','',''],['洒泼','',''],['洒洒','',''],['洒满','',''],['洒狗血','',''],['洒脱','',''],['洒药','',''],['洒落','',''],['洒透','',''],['洒遍','',''],['洗三','',''],['洗冤','',''],['洗冤集录','',''],['洗净','',''],['洗刷','',''],['洗剂','',''],['洗削更革','',''],['洗剪吹','',''],['洗劫','',''],['洗劫一空','',''],['洗印','',''],['洗去','',''],['洗发','',''],['洗发乳','',''],['洗发剂','',''],['洗发水','',''],['洗发水儿','',''],['洗发皂','',''],['洗发粉','',''],['洗发精','',''],['洗发膏','',''],['洗发露','',''],['洗垢匿瑕','',''],['洗垢寻痕','',''],['洗垢求瘢','',''],['洗垢索瘢','',''],['洗头','',''],['洗尘','',''],['洗心换骨','',''],['洗心涤虑','',''],['洗心自新','',''],['洗心革志','',''],['洗心革意','',''],['洗心革面','',''],['洗手','',''],['洗手不干','',''],['洗手乳','',''],['洗手台','',''],['洗手奉职','',''],['洗手池','',''],['洗手液','',''],['洗手盆','',''],['洗手间','',''],['洗掉','',''],['洗擦','',''],['洗擦者','',''],['洗染','',''],['洗染店','',''],['洗法','',''],['洗洁剂','',''],['洗洁精','',''],['洗洗','',''],['洗浴','',''],['洗消','',''],['洗消剂','',''],['洗消器材','',''],['洗消场','',''],['洗涤','',''],['洗涤剂','',''],['洗涤器','',''],['洗涤日','',''],['洗涤机','',''],['洗涤桶','',''],['洗涤槽','',''],['洗涤灵','',''],['洗涤者','',''],['洗涤间','',''],['洗液','',''],['洗清','',''],['洗漱','',''],['洗潄','',''],['洗澡','',''],['洗澡间','',''],['洗濯','',''],['洗濯盆','',''],['洗烫','',''],['洗煤','',''],['洗熨','',''],['洗牌','',''],['洗物槽','',''],['洗理费','',''],['洗瓶刷','',''],['洗盐','',''],['洗眼杯','',''],['洗眼液','',''],['洗碗','',''],['洗碗机','',''],['洗碗池','',''],['洗碗精','',''],['洗碟','',''],['洗碱','',''],['洗礼','',''],['洗礼堂','',''],['洗礼盆','',''],['洗米','',''],['洗练','',''],['洗罪','',''],['洗者若翰','',''],['洗耳恭听','',''],['洗耳拱听','',''],['洗耻','',''],['洗肠','',''],['洗胃','',''],['洗脑','',''],['洗脚','',''],['洗脱','',''],['洗脸','',''],['洗脸台','',''],['洗脸盆','',''],['洗脸盆洗盆','',''],['洗脸盘','',''],['洗脸间','',''],['洗菜','',''],['洗衣','',''],['洗衣处','',''],['洗衣妇','',''],['洗衣工','',''],['洗衣店','',''],['洗衣房','',''],['洗衣所','',''],['洗衣日','',''],['洗衣机','',''],['洗衣板','',''],['洗衣盆','',''],['洗衣粉','',''],['洗衣间','',''],['洗足','',''],['洗足礼','',''],['洗身','',''],['洗车','',''],['洗车场','',''],['洗过','',''],['洗选','',''],['洗钱','',''],['洗雪','',''],['洗面','',''],['洗面奶','',''],['洗黑钱','',''],['洛伦茨','',''],['洛佩兹','',''],['洛佩斯','',''],['洛克菲勒','',''],['洛克西德','',''],['洛可可','',''],['洛基','',''],['洛基山','',''],['洛川会议','',''],['洛希尔','',''],['洛德','',''],['洛杉矶','',''],['洛杉矶时报','',''],['洛杉矶湖人','',''],['洛林','',''],['洛桑','',''],['洛江','',''],['洛河','',''],['洛皮塔','',''],['洛皮塔瀑布','',''],['洛矶山','',''],['洛矶山脉','',''],['洛神','',''],['洛美','',''],['洛锡安区','',''],['洛阳地区','',''],['洛阳才子','',''],['洛阳纸贵','',''],['洛龙','',''],['洞中','',''],['洞中肯綮','',''],['洞儿','',''],['洞内','',''],['洞天','',''],['洞天福地','',''],['洞子','',''],['洞孔','',''],['洞察','',''],['洞察一切','',''],['洞察其奸','',''],['洞察力','',''],['洞府','',''],['洞庭湖','',''],['洞开','',''],['洞彻','',''],['洞悉','',''],['洞房','',''],['洞房花烛','',''],['洞房花烛夜','',''],['洞晓','',''],['洞洞','',''],['洞烛其奸','',''],['洞穴','',''],['洞穿','',''],['洞窟','',''],['洞箫','',''],['洞若观火','',''],['洞见','',''],['洞见症结','',''],['洞达','',''],['洞里','',''],['洞鉴','',''],['洞鉴古今','',''],['洣水','',''],['津南','',''],['津塔','',''],['津岛','',''],['津梁','',''],['津沽','',''],['津泽','',''],['津津','',''],['津津乐道','',''],['津津有味','',''],['津浦','',''],['津浪','',''],['津液','',''],['津要','',''],['津贴','',''],['洧水','',''],['洨河','',''],['洪亮','',''],['洪亮吉','',''],['洪佛','',''],['洪区','',''],['洪博培','',''],['洪堡','',''],['洪大','',''],['洪家','',''],['洪山','',''],['洪峰','',''],['洪帮','',''],['洪庙村','',''],['洪恩','',''],['洪森','',''],['洪武','',''],['洪水','',''],['洪水期','',''],['洪水滔滔','',''],['洪水猛兽','',''],['洪水论','',''],['洪汛期','',''],['洪江区','',''],['洪沟','',''],['洪泛区','',''],['洪泽湖','',''],['洪流','',''],['洪涛','',''],['洪涝','',''],['洪渊','',''],['洪灾','',''],['洪炉','',''],['洪炉燎发','',''],['洪熙','',''],['洪福','',''],['洪福齐天','',''],['洪秀全','',''],['洪积层','',''],['洪积说','',''],['洪荒','',''],['洪道','',''],['洪量','',''],['洪钟','',''],['洪门','',''],['洪雅族','',''],['洮北','',''],['洱海','',''],['洲产','',''],['洲府','',''],['洲际','',''],['洲际导弹','',''],['洲际弹道导弹','',''],['活上','',''],['活下','',''],['活下去','',''],['活下来','',''],['活不下去','',''],['活不活死不死','',''],['活了','',''],['活人','',''],['活体','',''],['活体检视','',''],['活佛','',''],['活便','',''],['活像','',''],['活儿','',''],['活分','',''],['活到','',''],['活到九十九','',''],['活到老','',''],['活剥','',''],['活力','',''],['活力四射','',''],['活动','',''],['活动中','',''],['活动中心','',''],['活动人士','',''],['活动分子','',''],['活动力','',''],['活动半径','',''],['活动场所','',''],['活动家','',''],['活动性','',''],['活动房','',''],['活动房屋','',''],['活动扳手','',''],['活动日','',''],['活动曲尺','',''],['活动桌面','',''],['活动能力','',''],['活动门','',''],['活劳动','',''],['活化','',''],['活化分析','',''],['活化剂','',''],['活化石','',''],['活受罪','',''],['活口','',''],['活命','',''],['活命哲学','',''],['活土层','',''],['活在','',''],['活在世上','',''],['活地狱','',''],['活埋','',''],['活塞','',''],['活塞式发动机','',''],['活塞式飞机','',''],['活塞杆','',''],['活塞环','',''],['活契','',''],['活套','',''],['活字','',''],['活字印刷','',''],['活字合金','',''],['活宝','',''],['活底','',''],['活度','',''],['活得','',''],['活性','',''],['活性剂','',''],['活性染料','',''],['活性炭','',''],['活扣','',''],['活报剧','',''],['活捉','',''],['活期','',''],['活期存款','',''],['活期帐户','',''],['活期贷款','',''],['活期资金','',''],['活来','',''],['活板','',''],['活树','',''],['活气','',''],['活水','',''],['活法','',''],['活泛','',''],['活泼','',''],['活活','',''],['活火','',''],['活火山','',''],['活灵活现','',''],['活版','',''],['活版印刷','',''],['活物','',''],['活猪','',''],['活现','',''],['活瓣','',''],['活生生','',''],['活用','',''],['活的','',''],['活着','',''],['活石灰','',''],['活神','',''],['活神仙似','',''],['活禽','',''],['活结','',''],['活络','',''],['活络丸','',''],['活罪','',''],['活脱','',''],['活脱儿','',''],['活脱脱','',''],['活茬','',''],['活菩萨','',''],['活血','',''],['活血止痛','',''],['活见鬼','',''],['活计','',''],['活话','',''],['活该','',''],['活象','',''],['活质','',''],['活跃','',''],['活跃分子','',''],['活路','',''],['活蹦乱跳','',''],['活过','',''],['活钱','',''],['活门','',''],['活页','',''],['活鱼','',''],['活龙活现','',''],['洼地','',''],['洼洼','',''],['洼陷','',''],['洽借','',''],['洽办','',''],['洽商','',''],['洽询','',''],['洽谈','',''],['洽谈会','',''],['洽购','',''],['洽闻博见','',''],['洽闻强记','',''],['派上','',''],['派上用场','',''],['派不是','',''],['派人','',''],['派任','',''],['派任职','',''],['派克','',''],['派克大衣','',''],['派兵','',''],['派军','',''],['派出','',''],['派出所','',''],['派出机构','',''],['派别','',''],['派力奥','',''],['派势','',''],['派员','',''],['派场','',''],['派头','',''],['派头十足','',''],['派定','',''],['派对','',''],['派往','',''],['派性','',''],['派拉蒙影','',''],['派方','',''],['派来','',''],['派派','',''],['派生','',''],['派生物','',''],['派生词','',''],['派系','',''],['派给','',''],['派给工作','',''],['派翠西亚','',''],['派购','',''],['派进','',''],['派送','',''],['派遗','',''],['派遣','',''],['派驻','',''],['流下','',''],['流丽','',''],['流了','',''],['流于','',''],['流于形式','',''],['流亚','',''],['流亡','',''],['流亡在海外','',''],['流亡政府','',''],['流亡者','',''],['流产','',''],['流产政变','',''],['流会','',''],['流传','',''],['流传广','',''],['流体','',''],['流体力学','',''],['流体动力学','',''],['流体核试验','',''],['流俗','',''],['流光','',''],['流光溢彩','',''],['流光瞬息','',''],['流入','',''],['流入物','',''],['流冗','',''],['流出','',''],['流出物','',''],['流出量','',''],['流刑','',''],['流利','',''],['流别','',''],['流到','',''],['流动','',''],['流动人口','',''],['流动儿童','',''],['流动基金','',''],['流动性','',''],['流动性大沙漠','',''],['流动物','',''],['流动红旗','',''],['流动负债','',''],['流动资产','',''],['流动资本','',''],['流动资金','',''],['流去','',''],['流变','',''],['流变学','',''],['流变能力','',''],['流口水','',''],['流向','',''],['流品','',''],['流回','',''],['流域','',''],['流失','',''],['流宕忘反','',''],['流寇','',''],['流寇主义','',''],['流尽','',''],['流层','',''],['流居','',''],['流布','',''],['流干','',''],['流年','',''],['流年不利','',''],['流弊','',''],['流弹','',''],['流形','',''],['流往','',''],['流徙','',''],['流性学','',''],['流恋','',''],['流感','',''],['流感疫苗','',''],['流感病毒','',''],['流掉','',''],['流播','',''],['流放','',''],['流散','',''],['流明','',''],['流星','',''],['流星似','',''],['流星体','',''],['流星坎止','',''],['流星赶月','',''],['流星雨','',''],['流槽','',''],['流毒','',''],['流民','',''],['流氓','',''],['流氓国家','',''],['流氓无产者','',''],['流氓罪','',''],['流氓般','',''],['流氓软件','',''],['流氓集团','',''],['流气','',''],['流水','',''],['流水不腐','',''],['流水作业','',''],['流水帐','',''],['流水席','',''],['流水无情','',''],['流水线','',''],['流水落花','',''],['流水行云','',''],['流水账','',''],['流水高山','',''],['流汗','',''],['流汗浃背','',''],['流沙','',''],['流泆','',''],['流注','',''],['流泪','',''],['流泻','',''],['流派','',''],['流派风格','',''],['流浪','',''],['流浪儿','',''],['流浪汉','',''],['流浪汗','',''],['流浪者','',''],['流浸膏','',''],['流涎','',''],['流涕','',''],['流淌','',''],['流火','',''],['流点','',''],['流物','',''],['流球','',''],['流球群岛','',''],['流理台','',''],['流用','',''],['流电','',''],['流电学','',''],['流畅','',''],['流眄','',''],['流着','',''],['流矢','',''],['流离','',''],['流离失所','',''],['流离琐尾','',''],['流离遇合','',''],['流离颠沛','',''],['流程','',''],['流程图','',''],['流程表','',''],['流窜','',''],['流窜犯','',''],['流纹岩','',''],['流线','',''],['流线型','',''],['流经','',''],['流网','',''],['流脑','',''],['流脓','',''],['流芳','',''],['流芳万古','',''],['流芳千古','',''],['流芳后世','',''],['流芳百世','',''],['流芳遗臭','',''],['流苏','',''],['流荡','',''],['流荡忘反','',''],['流萤','',''],['流落','',''],['流落不偶','',''],['流落他乡','',''],['流血','',''],['流血事件','',''],['流血千里','',''],['流血成河','',''],['流血成渠','',''],['流血浮尸','',''],['流血漂卤','',''],['流血漂杵','',''],['流行','',''],['流行急性结膜炎','',''],['流行性','',''],['流行性乙型脑炎','',''],['流行性出血热','',''],['流行性感冒','',''],['流行性脑脊髓膜炎','',''],['流行性腮腺炎','',''],['流行株','',''],['流行榜','',''],['流行歌曲','',''],['流行病','',''],['流行病学','',''],['流行色','',''],['流行著','',''],['流行语','',''],['流行音乐','',''],['流表','',''],['流览','',''],['流言','',''],['流言切莫轻信','',''],['流言惑众','',''],['流言蜚语','',''],['流言飞文','',''],['流质','',''],['流转','',''],['流辈','',''],['流辉','',''],['流过','',''],['流进','',''],['流连','',''],['流连忘返','',''],['流通','',''],['流通券','',''],['流通基金','',''],['流通手段','',''],['流通渠道','',''],['流通费用','',''],['流通资本','',''],['流通资金','',''],['流通量','',''],['流通领域','',''],['流逝','',''],['流速','',''],['流速计','',''],['流遍全身','',''],['流里流气','',''],['流量','',''],['流量计','',''],['流金铄石','',''],['流露','',''],['流露出','',''],['流韵','',''],['流风余俗','',''],['流风余韵','',''],['流风回雪','',''],['流风遗俗','',''],['流风遗泽','',''],['流风遗烈','',''],['流风遗躅','',''],['流风遗迹','',''],['流食','',''],['流鼻水','',''],['流鼻涕','',''],['浃髓沦肌','',''],['浃髓沦肤','',''],['浅儿','',''],['浅土','',''],['浅子','',''],['浅学','',''],['浅尝','',''],['浅尝者','',''],['浅尝辄止','',''],['浅层','',''],['浅层文字','',''],['浅层正字法','',''],['浅希近求','',''],['浅底','',''],['浅成岩','',''],['浅斟低唱','',''],['浅斟低讴','',''],['浅斟低酌','',''],['浅易','',''],['浅显','',''],['浅显易懂','',''],['浅析','',''],['浅水','',''],['浅浅','',''],['浅浮雕','',''],['浅海','',''],['浅淡','',''],['浅深','',''],['浅源地震','',''],['浅滩','',''],['浅滩指示浮标','',''],['浅灰','',''],['浅白','',''],['浅盆','',''],['浅盘','',''],['浅短','',''],['浅礁','',''],['浅窝','',''],['浅笑','',''],['浅红','',''],['浅绿','',''],['浅绿色','',''],['浅耕','',''],['浅色','',''],['浅草','',''],['浅蓝','',''],['浅蓝色','',''],['浅薄','',''],['浅见','',''],['浅见寡识','',''],['浅见寡闻','',''],['浅见薄识','',''],['浅议','',''],['浅论','',''],['浅说','',''],['浅谈','',''],['浅近','',''],['浅释','',''],['浅锅','',''],['浅陋','',''],['浅露','',''],['浅领','',''],['浅鲜','',''],['浅黄','',''],['浅黄色','',''],['浅黑','',''],['浅黑型','',''],['浅黑色','',''],['浆岩','',''],['浆料','',''],['浆果','',''],['浆汁','',''],['浆洗','',''],['浆液','',''],['浆硬','',''],['浆粕','',''],['浆糊','',''],['浆纱','',''],['浆纸','',''],['浆膜','',''],['浆衣','',''],['浆酒藿肉','',''],['浆酒霍肉','',''],['浇下','',''],['浇冷水','',''],['浇制','',''],['浇在','',''],['浇地','',''],['浇头','',''],['浇水','',''],['浇注','',''],['浇洗','',''],['浇漓','',''],['浇灌','',''],['浇瓜之惠','',''],['浇筑','',''],['浇花','',''],['浇菜','',''],['浇透','',''],['浇铸','',''],['浇风薄俗','',''],['浈江','',''],['浉河','',''],['浊世','',''],['浊度','',''],['浊气','',''],['浊泾清渭','',''],['浊流','',''],['浊浪','',''],['浊液','',''],['浊积岩','',''],['浊臭熏天','',''],['浊质凡姿','',''],['浊辅音','',''],['浊酒','',''],['浊音','',''],['浊骨凡胎','',''],['测云仪','',''],['测候','',''],['测光','',''],['测光表','',''],['测出','',''],['测力','',''],['测力器','',''],['测力计','',''],['测压','',''],['测压管','',''],['测取','',''],['测向','',''],['测地学','',''],['测地曲率','',''],['测地线','',''],['测地线曲率','',''],['测声器','',''],['测天','',''],['测孕','',''],['测字','',''],['测定','',''],['测定法','',''],['测容量','',''],['测度','',''],['测径器','',''],['测得','',''],['测微尺','',''],['测微术','',''],['测微表','',''],['测微计','',''],['测心术','',''],['测慌','',''],['测探','',''],['测控','',''],['测斜器','',''],['测方','',''],['测时','',''],['测时器','',''],['测时法','',''],['测气管','',''],['测测','',''],['测深','',''],['测温','',''],['测温器','',''],['测电','',''],['测知','',''],['测程器','',''],['测算','',''],['测绘','',''],['测绘学','',''],['测良','',''],['测评','',''],['测试','',''],['测试仪','',''],['测试和材料协会','',''],['测试器','',''],['测试版','',''],['测试者','',''],['测谎仪','',''],['测谎器','',''],['测距','',''],['测距仪','',''],['测距器','',''],['测距机','',''],['测过','',''],['测量','',''],['测量仪','',''],['测量学','',''],['测量工具','',''],['测量术','',''],['测量杆','',''],['测量用','',''],['测量者','',''],['测量船','',''],['测锤','',''],['测震表','',''],['测音器','',''],['测音计','',''],['测验','',''],['测验结果','',''],['测高','',''],['测高学','',''],['测高法','',''],['测高计','',''],['济世','',''],['济世之才','',''],['济世匡时','',''],['济世安人','',''],['济世安民','',''],['济世安邦','',''],['济世救人','',''],['济世爱民','',''],['济世经邦','',''],['济事','',''],['济人','',''],['济人利物','',''],['济公','',''],['济助','',''],['济南地区','',''],['济困扶危','',''],['济宁地区','',''],['济寒赈贫','',''],['济州','',''],['济州岛','',''],['济州特别自治道','',''],['济弱扶危','',''],['济弱除强','',''],['济急','',''],['济时拯世','',''],['济时行道','',''],['济河焚舟','',''],['济济','',''],['济济一堂','',''],['济济彬彬','',''],['济胜之具','',''],['济苦怜贫','',''],['济贫','',''],['济贫拔苦','',''],['济贫院','',''],['浏海','',''],['浏览','',''],['浏览器','',''],['浏览者','',''],['浏览软件','',''],['浏览量','',''],['浐河','',''],['浑人','',''],['浑仪','',''],['浑仪注','',''],['浑俗和光','',''],['浑厚','',''],['浑号','',''],['浑名','',''],['浑噩','',''],['浑圆','',''],['浑天仪','',''],['浑天说','',''],['浑如','',''],['浑子','',''],['浑家','',''],['浑成','',''],['浑朴','',''],['浑水','',''],['浑水摸鱼','',''],['浑汗如雨','',''],['浑江','',''],['浑沌','',''],['浑河','',''],['浑浊','',''],['浑浑','',''],['浑浑噩噩','',''],['浑然','',''],['浑然一体','',''],['浑然一色','',''],['浑然不觉','',''],['浑然天成','',''],['浑球','',''],['浑球儿','',''],['浑脱','',''],['浑茫','',''],['浑蛋','',''],['浑象','',''],['浑身','',''],['浑身上下','',''],['浑身是胆','',''],['浑身解数','',''],['浑金璞玉','',''],['浓云','',''],['浓厚','',''],['浓厚兴趣','',''],['浓墨','',''],['浓墨重彩','',''],['浓妆','',''],['浓妆淡抹','',''],['浓妆艳抹','',''],['浓妆艳服','',''],['浓妆艳裹','',''],['浓妆艳质','',''],['浓密','',''],['浓度','',''],['浓情','',''],['浓抹淡妆','',''],['浓桃艳李','',''],['浓汁','',''],['浓汤','',''],['浓浓','',''],['浓液','',''],['浓淡','',''],['浓烈','',''],['浓烟','',''],['浓的','',''],['浓眉','',''],['浓眉大眼','',''],['浓积云','',''],['浓稠','',''],['浓粥','',''],['浓粥状','',''],['浓绿','',''],['浓缩','',''],['浓缩机','',''],['浓缩物','',''],['浓缩铀','',''],['浓艳','',''],['浓茶','',''],['浓荫','',''],['浓装','',''],['浓郁','',''],['浓酒','',''],['浓重','',''],['浓集','',''],['浓集铀','',''],['浓雾','',''],['浓香','',''],['浔阳','',''],['浙南','',''],['浙江三门县','',''],['浙江大学','',''],['浙江天台县','',''],['浙菜','',''],['浙赣','',''],['浙赣铁路','',''],['浚泥船','',''],['浚渫','',''],['浣女','',''],['浣洗','',''],['浣涤','',''],['浣濯','',''],['浣熊','',''],['浣纱','',''],['浣纱记','',''],['浣衣','',''],['浣雪','',''],['浦东','',''],['浦东机场','',''],['浦口','',''],['浦那','',''],['浦项','',''],['浩劫','',''],['浩博','',''],['浩叹','',''],['浩大','',''],['浩如烟海','',''],['浩室','',''],['浩气','',''],['浩气长存','',''],['浩浩','',''],['浩浩荡荡','',''],['浩淼','',''],['浩渺','',''],['浩瀚','',''],['浩然','',''],['浩然之气','',''],['浩然正气','',''],['浩特','',''],['浩繁','',''],['浩翰','',''],['浩茫','',''],['浩荡','',''],['浩阔','',''],['浪人','',''],['浪儿','',''],['浪头','',''],['浪女','',''],['浪子','',''],['浪子回头','',''],['浪子回头金不换','',''],['浪恬波静','',''],['浪拍','',''],['浪木','',''],['浪板','',''],['浪桥','',''],['浪浪','',''],['浪涌','',''],['浪涛','',''],['浪游','',''],['浪漫','',''],['浪漫主义','',''],['浪漫化','',''],['浪潮','',''],['浪船','',''],['浪花','',''],['浪荡','',''],['浪蚀','',''],['浪蝶游蜂','',''],['浪蝶狂蜂','',''],['浪谱','',''],['浪谷','',''],['浪费','',''],['浪费掉','',''],['浪费时间','',''],['浪费狂','',''],['浪费者','',''],['浪费金钱','',''],['浪迹','',''],['浪迹天下','',''],['浪迹天涯','',''],['浪迹江湖','',''],['浪迹萍踪','',''],['浪静','',''],['浪静风恬','',''],['浪鼓','',''],['浮一大白','',''],['浮上','',''],['浮世绘','',''],['浮云','',''],['浮云富贵','',''],['浮云朝露','',''],['浮云蔽日','',''],['浮光掠影','',''],['浮冰','',''],['浮冰群','',''],['浮凸','',''],['浮出','',''],['浮出水面','',''],['浮利','',''],['浮力','',''],['浮力定律','',''],['浮力调整背心','',''],['浮力调整装置','',''],['浮动','',''],['浮动价格','',''],['浮动地狱','',''],['浮动工资','',''],['浮动汇率','',''],['浮升','',''],['浮华','',''],['浮厝','',''],['浮吊','',''],['浮名','',''],['浮名薄利','',''],['浮名虚利','',''],['浮名虚誉','',''],['浮囊','',''],['浮图','',''],['浮圈','',''],['浮土','',''],['浮在','',''],['浮士德博士','',''],['浮头儿','',''],['浮夸','',''],['浮夸风','',''],['浮子','',''],['浮家泛宅','',''],['浮家浮宅','',''],['浮尘','',''],['浮尘子','',''],['浮尸','',''],['浮屠','',''],['浮岛','',''],['浮岩','',''],['浮床','',''],['浮式起重机','',''],['浮想','',''],['浮想联翩','',''],['浮报','',''],['浮掠','',''],['浮木','',''],['浮标','',''],['浮桥','',''],['浮气','',''],['浮水','',''],['浮沉','',''],['浮沫','',''],['浮泛','',''],['浮浅','',''],['浮浪','',''],['浮渣','',''],['浮游','',''],['浮游动物','',''],['浮游植物','',''],['浮游生物','',''],['浮滑','',''],['浮滥','',''],['浮漂','',''],['浮潜','',''],['浮潜器具','',''],['浮点','',''],['浮点数','',''],['浮点运算','',''],['浮燥','',''],['浮物','',''],['浮现','',''],['浮瓜沉李','',''],['浮生','',''],['浮生六记','',''],['浮生若寄','',''],['浮生若梦','',''],['浮皮儿','',''],['浮皮潦草','',''],['浮着','',''],['浮石','',''],['浮石沉木','',''],['浮礼儿','',''],['浮筒','',''],['浮签','',''],['浮翠流丹','',''],['浮肿','',''],['浮肿病','',''],['浮舟','',''],['浮船坞','',''],['浮艳','',''],['浮花浪蕊','',''],['浮荡','',''],['浮萍','',''],['浮萍浪梗','',''],['浮薄','',''],['浮言','',''],['浮记','',''],['浮词','',''],['浮词曲说','',''],['浮语虚辞','',''],['浮财','',''],['浮质','',''],['浮贴','',''],['浮起','',''],['浮躁','',''],['浮选','',''],['浮雕','',''],['浮雕墙纸','',''],['浮面','',''],['浴场','',''],['浴堂','',''],['浴室','',''],['浴巾','',''],['浴帘','',''],['浴帽','',''],['浴柜','',''],['浴池','',''],['浴液','',''],['浴球','',''],['浴疗','',''],['浴疗学','',''],['浴盆','',''],['浴盐','',''],['浴缸','',''],['浴者','',''],['浴花','',''],['浴血','',''],['浴血奋战','',''],['浴血苦战','',''],['浴衣','',''],['浴装','',''],['海上','',''],['海上交通','',''],['海上交通线','',''],['海上奇书','',''],['海上封锁','',''],['海上巡逻','',''],['海上花列传','',''],['海上运动','',''],['海上运输','',''],['海不扬波','',''],['海不波溢','',''],['海东','',''],['海东青','',''],['海中','',''],['海中捞月','',''],['海事','',''],['海事仲裁','',''],['海事处','',''],['海事局','',''],['海事法院','',''],['海于格松','',''],['海产','',''],['海产品','',''],['海伦・凯勒','',''],['海伯利','',''],['海信','',''],['海兔','',''],['海关','',''],['海关官员','',''],['海关总署','',''],['海关检查','',''],['海关部门','',''],['海兽','',''],['海内','',''],['海内外','',''],['海内存知己','',''],['海内无双','',''],['海军','',''],['海军上校','',''],['海军中校','',''],['海军基地','',''],['海军大校','',''],['海军官','',''],['海军少校','',''],['海军总司令','',''],['海军航空兵','',''],['海军蓝','',''],['海军部','',''],['海军陆战队','',''],['海刺芹','',''],['海勃湾','',''],['海北','',''],['海北天南','',''],['海北州','',''],['海区','',''],['海协会','',''],['海南大学','',''],['海南岛','',''],['海南州','',''],['海南戏','',''],['海印寺','',''],['海参','',''],['海参崴','',''],['海员','',''],['海员般','',''],['海味','',''],['海哩','',''],['海啸','',''],['海啸山崩','',''],['海图','',''],['海地人','',''],['海地岛','',''],['海地币','',''],['海域','',''],['海基会','',''],['海堤','',''],['海塘','',''],['海外','',''],['海外侨胞','',''],['海外关系','',''],['海外华人','',''],['海外奇谈','',''],['海外投资','',''],['海外旅行','',''],['海外版','',''],['海妖','',''],['海子','',''],['海学','',''],['海宝','',''],['海尔','',''],['海尔德兰','',''],['海尼根','',''],['海屋添筹','',''],['海屋筹添','',''],['海岛','',''],['海岛市','',''],['海岛棉','',''],['海岬','',''],['海岭','',''],['海岸','',''],['海岸护卫队','',''],['海岸线','',''],['海岸警卫队','',''],['海岸边','',''],['海岸防御','',''],['海峡','',''],['海峡两岸','',''],['海峡两岸关系协会','',''],['海峡交流基金会','',''],['海峡地带','',''],['海峡时报','',''],['海峡群岛','',''],['海峡防御','',''],['海州','',''],['海巡','',''],['海市','',''],['海市蜃搂','',''],['海市蜃楼','',''],['海带','',''],['海平线','',''],['海平面','',''],['海床','',''],['海底','',''],['海底扩张','',''],['海底扩张说','',''],['海底捞月','',''],['海底捞针','',''],['海底管线','',''],['海底轮','',''],['海底隧道','',''],['海康','',''],['海归','',''],['海德','',''],['海德保','',''],['海德公园','',''],['海德堡','',''],['海德尔堡','',''],['海德格尔','',''],['海怪','',''],['海战','',''],['海扁','',''],['海扇','',''],['海报','',''],['海拉尔','',''],['海拔','',''],['海捞','',''],['海损','',''],['海斯','',''],['海日','',''],['海昌蓝','',''],['海明威','',''],['海星','',''],['海晏河清','',''],['海景','',''],['海景画','',''],['海曙','',''],['海月水母','',''],['海枣','',''],['海枯石烂','',''],['海桐花','',''],['海棉','',''],['海棉状','',''],['海棠','',''],['海棠树','',''],['海棠花','',''],['海森伯','',''],['海森堡','',''],['海椒','',''],['海榴','',''],['海模型','',''],['海水','',''],['海水不可斗量','',''],['海水倒灌','',''],['海水养殖','',''],['海水浴','',''],['海水淡化','',''],['海水群飞','',''],['海水难量','',''],['海水面','',''],['海沟','',''],['海沧','',''],['海河','',''],['海沸山摇','',''],['海沸山裂','',''],['海沸江翻','',''],['海沸河翻','',''],['海沸波翻','',''],['海法','',''],['海泡石','',''],['海波','',''],['海波不惊','',''],['海洋','',''],['海洋化学','',''],['海洋地理','',''],['海洋学','',''],['海洋性','',''],['海洋性气候','',''],['海洋性贫血','',''],['海洋污染','',''],['海洋法','',''],['海洋温差发电','',''],['海洋温度','',''],['海洋生物','',''],['海洋科学','',''],['海洋资源','',''],['海洋间','',''],['海洋霸权','',''],['海洛因','',''],['海洛英','',''],['海派','',''],['海流','',''],['海浪','',''],['海涂','',''],['海涂围垦','',''],['海涅','',''],['海涛','',''],['海涵','',''],['海淀','',''],['海淀图书城','',''],['海港','',''],['海湾','',''],['海湾危机','',''],['海湾国家','',''],['海湾地区','',''],['海湾战争','',''],['海滨','',''],['海滨浴场','',''],['海滩','',''],['海滩装','',''],['海潮','',''],['海熊','',''],['海燕','',''],['海牙','',''],['海牙法院','',''],['海牛','',''],['海狗','',''],['海狮','',''],['海狸','',''],['海狸鼠','',''],['海猪','',''],['海獭','',''],['海王星','',''],['海珠','',''],['海瑞','',''],['海瑞乡','',''],['海瑞罢官','',''],['海疆','',''],['海登','',''],['海百合','',''],['海盆','',''],['海监船','',''],['海盗','',''],['海盗船','',''],['海盗行为','',''],['海相','',''],['海相沉积','',''],['海相沉积物','',''],['海砂','',''],['海砂屋','',''],['海碗','',''],['海礁','',''],['海神','',''],['海禁','',''],['海空','',''],['海空军','',''],['海空军基地','',''],['海端','',''],['海端乡','',''],['海笋','',''],['海笔','',''],['海米','',''],['海纳百川','',''],['海线','',''],['海绵','',''],['海绵动物','',''],['海绵宝宝','',''],['海绵橡胶','',''],['海绵状','',''],['海绵田','',''],['海绿色','',''],['海胆','',''],['海航','',''],['海舶','',''],['海船','',''],['海苔','',''],['海草','',''],['海菜','',''],['海葬','',''],['海葵','',''],['海藻','',''],['海虾','',''],['海蚀','',''],['海蛎子','',''],['海蛞蝓','',''],['海蛤蝓','',''],['海蜇','',''],['海蜒','',''],['海螵蛸','',''],['海螺','',''],['海蟹','',''],['海西','',''],['海西州','',''],['海角','',''],['海角天涯','',''],['海誓','',''],['海誓山盟','',''],['海豚','',''],['海豚座','',''],['海豚泳','',''],['海象','',''],['海豹','',''],['海豹科','',''],['海豹部队','',''],['海货','',''],['海贼','',''],['海贼王','',''],['海路','',''],['海轮','',''],['海边','',''],['海运','',''],['海运业','',''],['海运费','',''],['海运费率','',''],['海迪','',''],['海选','',''],['海道','',''],['海部俊树','',''],['海里','',''],['海量','',''],['海错','',''],['海阔天空','',''],['海防','',''],['海陆','',''],['海陆丰农民起义','',''],['海陆军','',''],['海陆煲','',''],['海陆空','',''],['海陵','',''],['海隅','',''],['海难','',''],['海难船','',''],['海震','',''],['海青天','',''],['海面','',''],['海面下','',''],['海鞘','',''],['海顿','',''],['海风','',''],['海马','',''],['海马回','',''],['海魂衫','',''],['海鱼','',''],['海鲜','',''],['海鲜酱','',''],['海鲤','',''],['海鳃','',''],['海鳗','',''],['海鸟','',''],['海鸥','',''],['海鹫','',''],['海龙','',''],['海龟','',''],['浸于','',''],['浸以','',''],['浸会','',''],['浸信会','',''],['浸入','',''],['浸出','',''],['浸剂','',''],['浸取','',''],['浸在','',''],['浸微浸消','',''],['浸微浸灭','',''],['浸明浸昌','',''],['浸染','',''],['浸水','',''],['浸沉','',''],['浸没','',''],['浸泡','',''],['浸泡物','',''],['浸洗','',''],['浸润','',''],['浸润之谮','',''],['浸液','',''],['浸渍','',''],['浸渍者','',''],['浸湿','',''],['浸溶','',''],['浸满','',''],['浸着','',''],['浸礼','',''],['浸礼教','',''],['浸种','',''],['浸膏','',''],['浸蚀','',''],['浸软','',''],['浸过','',''],['浸透','',''],['浸透性','',''],['浽溦','',''],['涂上','',''],['涂乙','',''],['涂了','',''],['涂以','',''],['涂写','',''],['涂剂','',''],['涂加','',''],['涂去','',''],['涂在','',''],['涂地','',''],['涂家','',''],['涂尔干','',''],['涂层','',''],['涂山','',''],['涂径','',''],['涂成','',''],['涂抹','',''],['涂抹剂','',''],['涂抹者','',''],['涂擦','',''],['涂改','',''],['涂敷','',''],['涂料','',''],['涂有','',''],['涂染','',''],['涂水','',''],['涂污','',''],['涂油','',''],['涂油于','',''],['涂油式','',''],['涂油漆','',''],['涂油膏','',''],['涂泽','',''],['涂浆台','',''],['涂润','',''],['涂漆','',''],['涂潭','',''],['涂炭','',''],['涂炭生民','',''],['涂炭生灵','',''],['涂片','',''],['涂画','',''],['涂着','',''],['涂粉','',''],['涂红','',''],['涂脂抹粉','',''],['涂色','',''],['涂色于','',''],['涂装','',''],['涂覆','',''],['涂过','',''],['涂金','',''],['涂附','',''],['涂饰','',''],['涂饰剂','',''],['涂鸦','',''],['涂鸭','',''],['涂黑','',''],['涅槃','',''],['涅瓦','',''],['涅瓦河','',''],['涅白','',''],['涅盘经','',''],['涅石','',''],['涅磐','',''],['涅而不缁','',''],['消亡','',''],['消停','',''],['消像散','',''],['消元','',''],['消减','',''],['消化','',''],['消化不良','',''],['消化剂','',''],['消化力','',''],['消化吸收','',''],['消化性','',''],['消化液','',''],['消化管','',''],['消化系统','',''],['消化腺','',''],['消化道','',''],['消化酒','',''],['消化酶','',''],['消去','',''],['消受','',''],['消声','',''],['消声匿迹','',''],['消声器','',''],['消声灭迹','',''],['消夏','',''],['消夜','',''],['消失','',''],['消失了','',''],['消弭','',''],['消息','',''],['消息儿','',''],['消息报','',''],['消息来源','',''],['消息灵通','',''],['消息灵通人士','',''],['消息闭塞','',''],['消愁','',''],['消愁解闷','',''],['消愁释愦','',''],['消愁释闷','',''],['消损','',''],['消散','',''],['消晕','',''],['消暑','',''],['消极','',''],['消极因素','',''],['消极影响','',''],['消极态度','',''],['消极怠工','',''],['消极浪漫主义','',''],['消极防御','',''],['消歇','',''],['消歧义','',''],['消毒','',''],['消毒剂','',''],['消毒法','',''],['消气','',''],['消沉','',''],['消泯','',''],['消消停停','',''],['消渴','',''],['消溶','',''],['消火栓','',''],['消灭','',''],['消灾','',''],['消灾避邪','',''],['消炎','',''],['消炎片','',''],['消炎粉','',''],['消炎药','',''],['消烟除尘','',''],['消热','',''],['消瘦','',''],['消石灰','',''],['消磁','',''],['消磁器','',''],['消磨','',''],['消磨时光','',''],['消磨时间','',''],['消禁','',''],['消纳','',''],['消纳整合','',''],['消缓','',''],['消耗','',''],['消耗性','',''],['消耗战','',''],['消耗掉','',''],['消耗标准','',''],['消耗热','',''],['消耗用','',''],['消耗量','',''],['消肿','',''],['消能','',''],['消色','',''],['消蚀','',''],['消融','',''],['消解','',''],['消谴','',''],['消费','',''],['消费价格指数','',''],['消费合作社','',''],['消费品','',''],['消费器件','',''],['消费基金','',''],['消费市场','',''],['消费水平','',''],['消费税','',''],['消费结构','',''],['消费群','',''],['消费者','',''],['消费者保护','',''],['消费者协会','',''],['消费资料','',''],['消费量','',''],['消费金融','',''],['消退','',''],['消逝','',''],['消遣','',''],['消释','',''],['消金','',''],['消长','',''],['消闲','',''],['消闲儿','',''],['消防','',''],['消防员','',''],['消防塞','',''],['消防局','',''],['消防栓','',''],['消防署','',''],['消防艇','',''],['消防车','',''],['消防队','',''],['消防队员','',''],['消除','',''],['消除对妇女一切形式歧视公约','',''],['消除歧义','',''],['消除毒剂','',''],['消除者','',''],['消除锯齿','',''],['消险固堤','',''],['消隐','',''],['消震','',''],['消音','',''],['消音器','',''],['消食','',''],['消食儿','',''],['消魂','',''],['涉世','',''],['涉世未深','',''],['涉事','',''],['涉历','',''],['涉及','',''],['涉坚履微','',''],['涉坚履险','',''],['涉外','',''],['涉外企业','',''],['涉外单位','',''],['涉外工作','',''],['涉外活动','',''],['涉外经济','',''],['涉嫌','',''],['涉嫌人','',''],['涉想','',''],['涉案','',''],['涉水','',''],['涉水登山','',''],['涉水者','',''],['涉水靴','',''],['涉水鸟','',''],['涉海登山','',''],['涉渡','',''],['涉猎','',''],['涉禽','',''],['涉笔','',''],['涉者','',''],['涉览','',''],['涉计','',''],['涉讼','',''],['涉足','',''],['涉足其间','',''],['涉过','',''],['涉险','',''],['涉黑','',''],['涉黑案','',''],['涌上','',''],['涌了','',''],['涌入','',''],['涌出','',''],['涌到','',''],['涌动','',''],['涌去','',''],['涌向','',''],['涌回','',''],['涌往','',''],['涌来','',''],['涌泉','',''],['涌泉穴','',''],['涌流','',''],['涌浪','',''],['涌溢','',''],['涌现','',''],['涌至','',''],['涌起','',''],['涌进','',''],['涎水','',''],['涎沫','',''],['涎皮赖脸','',''],['涎着脸','',''],['涓吉','',''],['涓埃','',''],['涓埃之力','',''],['涓涓','',''],['涓滴','',''],['涓滴归公','',''],['涔涔','',''],['涕唾','',''],['涕泗交下','',''],['涕泗交流','',''],['涕泗交颐','',''],['涕泗横流','',''],['涕泗滂沱','',''],['涕泗纵横','',''],['涕泣','',''],['涕泪','',''],['涕泪交下','',''],['涕泪交加','',''],['涕泪交垂','',''],['涕泪交流','',''],['涕泪交集','',''],['涕泪交零','',''],['涕零','',''],['涛声','',''],['涝害','',''],['涝灾','',''],['涟涟','',''],['涟源地区','',''],['涟漪','',''],['涟漪微漾','',''],['涡卷','',''],['涡喷','',''],['涡形','',''],['涡形物','',''],['涡扇','',''],['涡旋','',''],['涡旋形','',''],['涡核','',''],['涡桨','',''],['涡流','',''],['涡漩','',''],['涡虫','',''],['涡虫纲','',''],['涡轮','',''],['涡轮喷气发动机','',''],['涡轮机','',''],['涡轮螺旋桨飞机','',''],['涡轮轴发动机','',''],['涣散','',''],['涣涣','',''],['涣然','',''],['涤卡','',''],['涤去','',''],['涤尘','',''],['涤故更新','',''],['涤棉','',''],['涤槽','',''],['涤汰','',''],['涤瑕','',''],['涤瑕荡垢','',''],['涤瑕荡秽','',''],['涤砚','',''],['涤秽荡瑕','',''],['涤纶','',''],['涤纶线','',''],['涤罪所','',''],['涤荡','',''],['涤虑','',''],['涤除','',''],['润丝','',''],['润例','',''],['润发','',''],['润唇膏','',''],['润喉','',''],['润嗓','',''],['润州','',''],['润格','',''],['润泽','',''],['润湿','',''],['润滑','',''],['润滑剂','',''],['润滑性','',''],['润滑油','',''],['润滑物','',''],['润滑脂','',''],['润笔','',''],['润肠','',''],['润肠通便','',''],['润肤','',''],['润肤乳','',''],['润肤膏','',''],['润肤霜','',''],['润肤露','',''],['润肺','',''],['润色','',''],['润资','',''],['润金','',''],['润饰','',''],['润饼','',''],['涧壑','',''],['涧峡','',''],['涧水','',''],['涧流','',''],['涧溪','',''],['涧西','',''],['涨价','',''],['涨停板','',''],['涨出','',''],['涨到','',''],['涨势','',''],['涨升','',''],['涨大','',''],['涨幅','',''],['涨水','',''],['涨满','',''],['涨潮','',''],['涨潮点','',''],['涨红','',''],['涨落','',''],['涨跌','',''],['涨跌停盘指数','',''],['涨跌幅限制','',''],['涨钱','',''],['涨风','',''],['涩味','',''],['涩的','',''],['涩脉','',''],['涪城','',''],['涪陵','',''],['涪陵地区','',''],['涮洗','',''],['涮火锅','',''],['涮锅子','',''],['涯子','',''],['液位','',''],['液体','',''],['液冷','',''],['液化','',''],['液化器','',''],['液化气','',''],['液化石油气','',''],['液压','',''],['液压传动','',''],['液压千斤顶','',''],['液压支架','',''],['液压机','',''],['液态','',''],['液态奶','',''],['液态气','',''],['液态水','',''],['液晶','',''],['液晶屏','',''],['液晶显示','',''],['液晶显示器','',''],['液果','',''],['液氨','',''],['液氮','',''],['液汁','',''],['液泡','',''],['液流','',''],['液状','',''],['液胞','',''],['液腺','',''],['液计','',''],['液质','',''],['液量','',''],['液面','',''],['涵义','',''],['涵体','',''],['涵养','',''],['涵容','',''],['涵意','',''],['涵江','',''],['涵洞','',''],['涵淡','',''],['涵盖','',''],['涵管','',''],['涵蓄','',''],['涵闸','',''],['涸泽而渔','',''],['涸辙之枯','',''],['涸辙之鱼','',''],['涸辙之鲋','',''],['涸辙枯鱼','',''],['涸辙穷鱼','',''],['淀山湖','',''],['淀积','',''],['淀积物','',''],['淀粉','',''],['淀粉脢','',''],['淀粉质','',''],['淀粉酶','',''],['淄川','',''],['淄蠹','',''],['淅沥','',''],['淅飒','',''],['淆乱','',''],['淆惑','',''],['淆杂','',''],['淇淋','',''],['淇滨','',''],['淋了','',''],['淋冲','',''],['淋巴','',''],['淋巴液','',''],['淋巴球','',''],['淋巴瘤','',''],['淋巴管','',''],['淋巴系统','',''],['淋巴细胞','',''],['淋巴结','',''],['淋巴腺','',''],['淋毒','',''],['淋水','',''],['淋浴','',''],['淋淋','',''],['淋湿','',''],['淋溶层','',''],['淋漓','',''],['淋漓尽致','',''],['淋球菌','',''],['淋病','',''],['淋菌','',''],['淋走','',''],['淋雨','',''],['淌下','',''],['淌出','',''],['淌口水','',''],['淌汗','',''],['淌泪','',''],['淌眼泪','',''],['淑世','',''],['淑人君子','',''],['淑女','',''],['淑静','',''],['淖尔','',''],['淘净','',''],['淘出','',''],['淘宝网','',''],['淘客','',''],['淘换','',''],['淘析','',''],['淘气','',''],['淘气鬼','',''],['淘汰','',''],['淘汰制','',''],['淘汰赛','',''],['淘沙','',''],['淘河','',''],['淘洗','',''],['淘淘','',''],['淘神','',''],['淘空','',''],['淘箩','',''],['淘米','',''],['淘粪','',''],['淘选','',''],['淘金','',''],['淘金潮','',''],['淘金者','',''],['淙淙','',''],['淝水之战','',''],['淞江','',''],['淞沪','',''],['淡光','',''],['淡入','',''],['淡写','',''],['淡出','',''],['淡化','',''],['淡味','',''],['淡啤','',''],['淡啤酒','',''],['淡妆','',''],['淡妆浓抹','',''],['淡季','',''],['淡定','',''],['淡巴菰','',''],['淡忘','',''],['淡月','',''],['淡水','',''],['淡水湖','',''],['淡水镇','',''],['淡水雪','',''],['淡水鱼','',''],['淡水鱼类','',''],['淡泊','',''],['淡泊名利','',''],['淡泊寡味','',''],['淡涂','',''],['淡淡','',''],['淡漠','',''],['淡灰色','',''],['淡然','',''],['淡然处之','',''],['淡的','',''],['淡竹','',''],['淡紫色','',''],['淡红','',''],['淡红色','',''],['淡绿','',''],['淡绿色','',''],['淡色','',''],['淡茶','',''],['淡菜','',''],['淡蓝色','',''],['淡薄','',''],['淡装','',''],['淡褐色','',''],['淡雅','',''],['淡青','',''],['淡青色','',''],['淡静','',''],['淡饭','',''],['淡黄','',''],['淡黄色','',''],['淡黑','',''],['淤伤','',''],['淤塞','',''],['淤斑','',''],['淤沙','',''],['淤泥','',''],['淤泥般','',''],['淤浊不清','',''],['淤滞','',''],['淤灌','',''],['淤积','',''],['淤血','',''],['淤血斑','',''],['淤青','',''],['淫业','',''],['淫乐','',''],['淫书','',''],['淫乱','',''],['淫亵','',''],['淫妇','',''],['淫威','',''],['淫媒','',''],['淫巧','',''],['淫径','',''],['淫念','',''],['淫戏','',''],['淫棍','',''],['淫欲','',''],['淫水','',''],['淫猥','',''],['淫画','',''],['淫癖','',''],['淫秽','',''],['淫秽物品','',''],['淫羊藿','',''],['淫荡','',''],['淫虫','',''],['淫行','',''],['淫词亵语','',''],['淫词秽语','',''],['淫话','',''],['淫语','',''],['淫贱','',''],['淫辱','',''],['淫逸','',''],['淫邪','',''],['淫雨','',''],['淫靡','',''],['淫风','',''],['淫风甚炽','',''],['淫鬼','',''],['淫魔','',''],['淬火','',''],['淬火玻璃','',''],['淬砺','',''],['淬透性','',''],['淮上','',''],['淮剧','',''],['淮南子','',''],['淮南鸡犬','',''],['淮河','',''],['淮海','',''],['淮海戏','',''],['淮海战役','',''],['淮盐','',''],['淮阴','',''],['淮阴地区','',''],['淯水','',''],['深一层','',''],['深不可测','',''],['深为','',''],['深井','',''],['深井泵','',''],['深交','',''],['深仇','',''],['深仇大恨','',''],['深伤','',''],['深信','',''],['深信不疑','',''],['深入','',''],['深入人心','',''],['深入分析','',''],['深入基层','',''],['深入实际','',''],['深入显出','',''],['深入浅出','',''],['深入生活','',''],['深入研究','',''],['深入群众','',''],['深兰色','',''],['深凹','',''],['深切','',''],['深到腰','',''],['深刻','',''],['深刻性','',''],['深加工','',''],['深化','',''],['深化改革','',''],['深厉浅揭','',''],['深厚','',''],['深厚感情','',''],['深县','',''],['深及','',''],['深及膝','',''],['深受','',''],['深受其害','',''],['深吻','',''],['深呼吸','',''],['深圳交易所','',''],['深圳健力宝','',''],['深圳河','',''],['深圳湾','',''],['深坑','',''],['深坑乡','',''],['深处','',''],['深奥','',''],['深奸巨猾','',''],['深宅大院','',''],['深宫','',''],['深密','',''],['深层','',''],['深层文字','',''],['深层次','',''],['深层正字法','',''],['深层清洁','',''],['深层阅读障碍','',''],['深居简出','',''],['深山','',''],['深山穷谷','',''],['深山老林','',''],['深山野岙','',''],['深巷','',''],['深广','',''],['深底','',''],['深度','',''],['深度尺','',''],['深度非词','',''],['深得','',''],['深得人心','',''],['深得民心','',''],['深忧','',''],['深思','',''],['深思熟虑','',''],['深思者','',''],['深思远虑','',''],['深恐','',''],['深恨','',''],['深恶','',''],['深恶痛嫉','',''],['深恶痛恨','',''],['深恶痛绝','',''],['深恶痛诋','',''],['深悉','',''],['深情','',''],['深情厚意','',''],['深情厚谊','',''],['深情款款','',''],['深意','',''],['深感','',''],['深成岩','',''],['深挖','',''],['深挚','',''],['深文功劾','',''],['深文周纳','',''],['深文巧诋','',''],['深明大义','',''],['深暗','',''],['深更半夜','',''],['深有','',''],['深有体会','',''],['深有同感','',''],['深有感触','',''],['深望','',''],['深根固柢','',''],['深根固蒂','',''],['深棕','',''],['深棕色','',''],['深槽','',''],['深橙色','',''],['深水','',''],['深水埗','',''],['深水波','',''],['深水炸弹','',''],['深沉','',''],['深沟','',''],['深沟坚垒','',''],['深沟坚壁','',''],['深沟高垒','',''],['深沟高壁','',''],['深洼','',''],['深浅','',''],['深测','',''],['深海','',''],['深海围网','',''],['深海烟囱','',''],['深深','',''],['深渊','',''],['深渊薄冰','',''],['深港','',''],['深湛','',''],['深源地震','',''],['深潭','',''],['深灰','',''],['深灰色','',''],['深爱','',''],['深痛','',''],['深痛恶绝','',''],['深的','',''],['深省','',''],['深知','',''],['深秋','',''],['深稽博考','',''],['深究','',''],['深空','',''],['深紫','',''],['深红','',''],['深红色','',''],['深绿','',''],['深绿色','',''],['深翻','',''],['深耕','',''],['深耕犁','',''],['深耕细作','',''],['深致谢意','',''],['深色','',''],['深草','',''],['深蓝','',''],['深蓝色','',''],['深藏','',''],['深藏若虚','',''],['深藏远遁','',''],['深虑','',''],['深表','',''],['深表谢意','',''],['深表遗憾','',''],['深褐','',''],['深褐色','',''],['深言','',''],['深计远虑','',''],['深识远虑','',''],['深谈','',''],['深谋','',''],['深谋远猷','',''],['深谋远略','',''],['深谋远虑','',''],['深谷','',''],['深蹲','',''],['深远','',''],['深透','',''],['深通','',''],['深造','',''],['深邃','',''],['深部','',''],['深醒','',''],['深重','',''],['深长','',''],['深闭固拒','',''],['深闭固距','',''],['深闺','',''],['深院','',''],['深陷','',''],['淳于','',''],['淳厚','',''],['淳朴','',''],['淳淳','',''],['混一','',''],['混世魔王','',''],['混为','',''],['混为一体','',''],['混为一谈','',''],['混乱','',''],['混事','',''],['混交','',''],['混交林','',''],['混以','',''],['混作','',''],['混俗和光','',''],['混元','',''],['混充','',''],['混入','',''],['混养','',''],['混凝剂','',''],['混凝土','',''],['混到','',''],['混制','',''],['混参','',''],['混号','',''],['混合','',''],['混合词','',''],['混合体','',''],['混合剂','',''],['混合动力车','',''],['混合双打','',''],['混合台','',''],['混合器','',''],['混合型汽车','',''],['混合失语症','',''],['混合感染','',''],['混合成','',''],['混合授粉','',''],['混合模型','',''],['混合毒剂','',''],['混合泳','',''],['混合物','',''],['混合电子计算机','',''],['混合肥料','',''],['混合面','',''],['混同','',''],['混名','',''],['混名儿','',''],['混吣','',''],['混和','',''],['混响','',''],['混在','',''],['混子','',''],['混帐','',''],['混得','',''],['混性','',''],['混成','',''],['混成曲','',''],['混战','',''],['混拌','',''],['混排','',''],['混搭','',''],['混放','',''],['混日子','',''],['混有','',''],['混有盐','',''],['混杂','',''],['混杂物','',''],['混棉','',''],['混氧燃料','',''],['混水墙','',''],['混水摸鱼','',''],['混汞','',''],['混沌','',''],['混沌学','',''],['混流泵','',''],['混浊','',''],['混浊不清','',''],['混淆','',''],['混淆不清','',''],['混淆是非','',''],['混淆视听','',''],['混淆黑白','',''],['混混','',''],['混混儿','',''],['混熟','',''],['混球','',''],['混球儿','',''],['混用','',''],['混种','',''],['混纺','',''],['混编','',''],['混茫','',''],['混蒙','',''],['混蛋','',''],['混血','',''],['混血儿','',''],['混血种','',''],['混行','',''],['混记','',''],['混语','',''],['混账','',''],['混身','',''],['混过','',''],['混进','',''],['混迹','',''],['混迹其中','',''],['混造黑白','',''],['混频','',''],['混频器','',''],['混饭','',''],['混骗','',''],['淹了','',''],['淹博','',''],['淹旬旷月','',''],['淹死','',''],['淹水','',''],['淹没','',''],['淹淹一息','',''],['淹溺','',''],['淹灌','',''],['淹灭','',''],['淹留','',''],['淹盖','',''],['添丁','',''],['添上','',''],['添乱','',''],['添仓','',''],['添入','',''],['添兵减灶','',''],['添凑','',''],['添办','',''],['添加','',''],['添加剂','',''],['添加物','',''],['添建','',''],['添枝加叶','',''],['添油加醋','',''],['添注','',''],['添添','',''],['添满','',''],['添煤','',''],['添燃','',''],['添砖加瓦','',''],['添箱','',''],['添置','',''],['添翼','',''],['添菜','',''],['添补','',''],['添设','',''],['添购','',''],['添附','',''],['添饭','',''],['添麻烦','',''],['淼茫','',''],['清一色','',''],['清丈','',''],['清丽','',''],['清丽俊逸','',''],['清产','',''],['清产核资','',''],['清亮','',''],['清人','',''],['清仓','',''],['清仓查库','',''],['清代','',''],['清代通史','',''],['清偿','',''],['清偿债务','',''],['清党','',''],['清关','',''],['清兵','',''],['清册','',''],['清军','',''],['清冷','',''],['清净','',''],['清凉','',''],['清凉油','',''],['清凉饮料','',''],['清凌凌','',''],['清减','',''],['清初','',''],['清剿','',''],['清华','',''],['清华大学','',''],['清单','',''],['清厕夫','',''],['清原','',''],['清原县','',''],['清史','',''],['清史列传','',''],['清史稿','',''],['清史馆','',''],['清君侧','',''],['清和','',''],['清唱','',''],['清唱剧','',''],['清嗓','',''],['清圣浊贤','',''],['清场','',''],['清垢','',''],['清城','',''],['清塘','',''],['清夜','',''],['清太宗','',''],['清太祖','',''],['清存货','',''],['清官','',''],['清官难断家务事','',''],['清宛县','',''],['清实录','',''],['清客','',''],['清宫','',''],['清寒','',''],['清寒情操','',''],['清尘浊水','',''],['清州','',''],['清州市','',''],['清帐','',''],['清平','',''],['清平世界','',''],['清幽','',''],['清库','',''],['清廉','',''],['清廷','',''],['清律','',''],['清心','',''],['清心寡欲','',''],['清心省事','',''],['清恬','',''],['清扫','',''],['清扫者','',''],['清扬','',''],['清拆','',''],['清拆户','',''],['清政府','',''],['清教','',''],['清教徒','',''],['清新俊逸','',''],['清新自然','',''],['清族','',''],['清早','',''],['清明菜','',''],['清晰','',''],['清晰度','',''],['清曹峻府','',''],['清朗','',''],['清朝','',''],['清末','',''],['清末民初','',''],['清柠檬','',''],['清查','',''],['清查工作','',''],['清栏','',''],['清样','',''],['清楚','',''],['清欠','',''],['清歌妙舞','',''],['清正','',''],['清正廉明','',''],['清正廉洁','',''],['清水墙','',''],['清水寺','',''],['清水衙门','',''],['清水镇','',''],['清江','',''],['清汤','',''],['清汤寡水','',''],['清河门','',''],['清油','',''],['清泉','',''],['清波','',''],['清泪','',''],['清洁','',''],['清洁剂','',''],['清洁化','',''],['清洁卫生','',''],['清洁器','',''],['清洁工','',''],['清洁袋','',''],['清洁车','',''],['清洗','',''],['清津市','',''],['清浊','',''],['清浊同流','',''],['清浦','',''],['清涤','',''],['清液','',''],['清淡','',''],['清清','',''],['清清楚楚','',''],['清清白白','',''],['清渭浊泾','',''],['清湛','',''],['清源','',''],['清源正本','',''],['清漆','',''],['清澄','',''],['清澈','',''],['清澈见底','',''],['清火','',''],['清灰冷灶','',''],['清炖','',''],['清点','',''],['清点帐目','',''],['清热','',''],['清爽','',''],['清玩','',''],['清理','',''],['清理队伍','',''],['清甜','',''],['清瘦','',''],['清癯','',''],['清白','',''],['清皇朝','',''],['清盘','',''],['清真','',''],['清真寺','',''],['清真教','',''],['清福','',''],['清秀','',''],['清税','',''],['清稿','',''],['清空','',''],['清算','',''],['清算业务','',''],['清算人','',''],['清算行','',''],['清红帮','',''],['清纯','',''],['清绮','',''],['清缴','',''],['清耳悦心','',''],['清脆','',''],['清芬','',''],['清苦','',''],['清茶','',''],['清茶淡饭','',''],['清莹','',''],['清蒸','',''],['清规','',''],['清规戒律','',''],['清誉','',''],['清议','',''],['清议不容','',''],['清词丽句','',''],['清谈','',''],['清谈高论','',''],['清账','',''],['清贫','',''],['清贫如洗','',''],['清贫寡欲','',''],['清越','',''],['清跸传道','',''],['清辅音','',''],['清迈','',''],['清运','',''],['清还','',''],['清退','',''],['清选机','',''],['清通','',''],['清逸','',''],['清道','',''],['清道夫','',''],['清酌','',''],['清酒','',''],['清醇','',''],['清醒','',''],['清野','',''],['清锅冷灶','',''],['清闲','',''],['清闲自在','',''],['清队','',''],['清除','',''],['清除出党','',''],['清雅','',''],['清雅绝尘','',''],['清零','',''],['清静','',''],['清静寡欲','',''],['清静无为','',''],['清音','',''],['清音丸','',''],['清风','',''],['清风两袖','',''],['清风劲节','',''],['清风峻节','',''],['清风明月','',''],['清风郎月','',''],['清风高节','',''],['清风高谊','',''],['清香','',''],['清馨','',''],['清高','',''],['渊冲','',''],['渊博','',''],['渊壑','',''],['渊富','',''],['渊广','',''],['渊泉','',''],['渊泓','',''],['渊海','',''],['渊深','',''],['渊渊','',''],['渊源','',''],['渊玄','',''],['渊薮','',''],['渊虑','',''],['渊识','',''],['渊诣','',''],['渊谋','',''],['渊谷','',''],['渊远','',''],['渊默','',''],['渎犯','',''],['渎神','',''],['渎者','',''],['渎职','',''],['渎职罪','',''],['渐伸','',''],['渐使','',''],['渐入佳境','',''],['渐减','',''],['渐变','',''],['渐增','',''],['渐多','',''],['渐少','',''],['渐屈线','',''],['渐弱','',''],['渐强','',''],['渐慢','',''],['渐成','',''],['渐新世','',''],['渐新统','',''],['渐明','',''],['渐显','',''],['渐有','',''],['渐染','',''],['渐欠','',''],['渐次','',''],['渐没','',''],['渐浓','',''],['渐淡','',''],['渐混','',''],['渐渐','',''],['渐满','',''],['渐熄','',''],['渐现','',''],['渐短','',''],['渐老','',''],['渐至佳境','',''],['渐行渐远','',''],['渐被','',''],['渐趋','',''],['渐近','',''],['渐近线','',''],['渐进','',''],['渐降法','',''],['渐隐','',''],['渐露端倪','',''],['渐黑','',''],['渔业','',''],['渔产','',''],['渔人','',''],['渔人之利','',''],['渔人得利','',''],['渔具','',''],['渔利','',''],['渔区','',''],['渔场','',''],['渔夫','',''],['渔妇','',''],['渔家','',''],['渔市','',''],['渔捞','',''],['渔政','',''],['渔期','',''],['渔村','',''],['渔歌','',''],['渔民','',''],['渔汛','',''],['渔汛期','',''],['渔池','',''],['渔港','',''],['渔火','',''],['渔猎','',''],['渔笼','',''],['渔经猎史','',''],['渔网','',''],['渔翁','',''],['渔翁之利','',''],['渔翁得利','',''],['渔舟','',''],['渔船','',''],['渔船队','',''],['渔轮','',''],['渔钩','',''],['渔钩儿','',''],['渔阳','',''],['渔阳鼙鼓','',''],['渔霸','',''],['渔鼓','',''],['渖阳','',''],['渗井','',''],['渗入','',''],['渗凉','',''],['渗出','',''],['渗出液','',''],['渗出物','',''],['渗出量','',''],['渗化','',''],['渗变','',''],['渗坑','',''],['渗性','',''],['渗析','',''],['渗水','',''],['渗沟','',''],['渗流','',''],['渗滤','',''],['渗滤器','',''],['渗滤壶','',''],['渗漏','',''],['渗碳','',''],['渗色','',''],['渗进','',''],['渗透','',''],['渗透压','',''],['渗透性','',''],['渗透物','',''],['渗透者','',''],['渝中','',''],['渝北','',''],['渝水','',''],['渠沟','',''],['渠灌','',''],['渠道','',''],['渠魁','',''],['渡假','',''],['渡口','',''],['渡头','',''],['渡期','',''],['渡桥','',''],['渡槽','',''],['渡江','',''],['渡江战役','',''],['渡河','',''],['渡河器材','',''],['渡河香象','',''],['渡海','',''],['渡渡鸟','',''],['渡船','',''],['渡船业','',''],['渡费','',''],['渡轮','',''],['渡轮船','',''],['渡过','',''],['渡鸦','',''],['渣土','',''],['渣块','',''],['渣堆','',''],['渣子','',''],['渣打','',''],['渣打券','',''],['渣打银行','',''],['渣油','',''],['渣滓','',''],['渣炉','',''],['渤海','',''],['渤海湾','',''],['渤澥桑田','',''],['渥太华','',''],['温乎','',''],['温习','',''],['温书','',''],['温切斯特','',''],['温压','',''],['温厚','',''],['温吞','',''],['温和','',''],['温和性','',''],['温和派','',''],['温哥华','',''],['温哥华岛','',''],['温婉','',''],['温存','',''],['温室','',''],['温室废气储存','',''],['温室效应','',''],['温室气体','',''],['温家宝','',''],['温尼伯','',''],['温层','',''],['温居','',''],['温差','',''],['温布尔登','',''],['温布尔登网球公开赛','',''],['温布尔顿','',''],['温布顿','',''],['温带','',''],['温床','',''],['温度','',''],['温度梯度','',''],['温度表','',''],['温度计','',''],['温得和克','',''],['温性','',''],['温情','',''],['温情定省','',''],['温情脉脉','',''],['温故','',''],['温故知新','',''],['温故而知新','',''],['温文','',''],['温文儒雅','',''],['温文尔雅','',''],['温文有礼','',''],['温文而雅','',''],['温斯顿','',''],['温暖','',''],['温暖如春','',''],['温暾','',''],['温柔','',''],['温柔敦厚','',''],['温标','',''],['温水','',''],['温江','',''],['温江地区','',''],['温汤','',''],['温汤浸种','',''],['温泉城','',''],['温浴','',''],['温润','',''],['温温','',''],['温湿图','',''],['温湿布','',''],['温湿度','',''],['温热','',''],['温煦','',''],['温特图尔','',''],['温疟','',''],['温病','',''],['温网','',''],['温良','',''],['温良俭让','',''],['温良忍让','',''],['温良恭俭','',''],['温良恭俭让','',''],['温蔼','',''],['温蠖','',''],['温血','',''],['温血动物','',''],['温觉','',''],['温课','',''],['温过','',''],['温酒','',''],['温雅','',''],['温静','',''],['温顺','',''],['温食','',''],['温饱','',''],['温饱工程','',''],['温香艳玉','',''],['温香软玉','',''],['温馨','',''],['温馨提示','',''],['温驯','',''],['渭华起义','',''],['渭南地区','',''],['渭城','',''],['渭水','',''],['渭河','',''],['渭滨','',''],['渭阳之思','',''],['渭阳之情','',''],['港九','',''],['港交所','',''],['港人','',''],['港令','',''],['港元','',''],['港内','',''],['港务','',''],['港务局','',''],['港务长','',''],['港北','',''],['港区','',''],['港南','',''],['港口','',''],['港口城市','',''],['港台','',''],['港名','',''],['港员','',''],['港商','',''],['港域','',''],['港埠','',''],['港外','',''],['港女','',''],['港客','',''],['港局','',''],['港岛','',''],['港币','',''],['港市','',''],['港府','',''],['港式月饼','',''],['港弯','',''],['港汊','',''],['港湾','',''],['港澳','',''],['港澳办','',''],['港澳办公室','',''],['港澳台','',''],['港澳同胞','',''],['港澳地区','',''],['港澳工委','',''],['港督','',''],['港股','',''],['港舰','',''],['港英政府','',''],['港警','',''],['港资','',''],['港邮','',''],['港都','',''],['港闸','',''],['港龙','',''],['港龙航空','',''],['渲染','',''],['渴不可耐','',''],['渴念','',''],['渴想','',''],['渴慕','',''],['渴望','',''],['渴望着','',''],['渴死','',''],['渴求','',''],['渴着','',''],['渴骥奔泉','',''],['游丝','',''],['游丝飞絮','',''],['游乐','',''],['游乐园','',''],['游乐场','',''],['游乡','',''],['游于','',''],['游云惊龙','',''],['游人','',''],['游人如织','',''],['游仙','',''],['游仙诗','',''],['游伴','',''],['游侠','',''],['游侠骑士','',''],['游兴','',''],['游击','',''],['游击区','',''],['游击战','',''],['游击战术','',''],['游击队','',''],['游击队员','',''],['游刃','',''],['游刃有余','',''],['游动','',''],['游动哨','',''],['游勇','',''],['游历','',''],['游历者','',''],['游去','',''],['游吟诗人','',''],['游园','',''],['游园会','',''],['游子','',''],['游学','',''],['游客','',''],['游客止步','',''],['游导','',''],['游尺','',''],['游山','',''],['游山玩水','',''],['游廊','',''],['游弋','',''],['游心寓目','',''],['游心骋目','',''],['游憩','',''],['游憩场','',''],['游戏','',''],['游戏三昧','',''],['游戏人间','',''],['游戏场','',''],['游戏尘寰','',''],['游戏机','',''],['游戏池','',''],['游戏王','',''],['游戏者','',''],['游戏装','',''],['游戏设备','',''],['游戏说','',''],['游手','',''],['游手好闲','',''],['游抏','',''],['游方','',''],['游星','',''],['游春','',''],['游来','',''],['游标','',''],['游标卡尺','',''],['游标尺','',''],['游民','',''],['游民改造','',''],['游民无产者','',''],['游水','',''],['游水器','',''],['游泳','',''],['游泳池','',''],['游泳者','',''],['游泳衣','',''],['游泳裤','',''],['游泳镜','',''],['游泳馆','',''],['游牧','',''],['游牧人','',''],['游牧区','',''],['游牧民','',''],['游牧民族','',''],['游牧长城','',''],['游玩','',''],['游目骋怀','',''],['游神','',''],['游离','',''],['游离电子','',''],['游禽','',''],['游移','',''],['游船','',''],['游艇','',''],['游艺','',''],['游艺会','',''],['游艺团','',''],['游艺场','',''],['游艺机','',''],['游荡','',''],['游荡者','',''],['游蛇','',''],['游蜂戏蝶','',''],['游蜂浪蝶','',''],['游行','',''],['游行示威','',''],['游行者','',''],['游街','',''],['游街示众','',''],['游览','',''],['游览区','',''],['游览图','',''],['游记','',''],['游说','',''],['游说团','',''],['游说团体','',''],['游说者','',''],['游说集团','',''],['游谈无根','',''],['游资','',''],['游走','',''],['游踪','',''],['游辞浮说','',''],['游过','',''],['游逛','',''],['游锡堃','',''],['游隼','',''],['游骑兵','',''],['游骑无归','',''],['游魂','',''],['游鱼','',''],['游鱼出听','',''],['渺乎其微','',''],['渺子','',''],['渺小','',''],['渺无人烟','',''],['渺无音信','',''],['渺渺茫茫','',''],['渺茫','',''],['渺虚','',''],['渺视','',''],['渺运','',''],['渺远','',''],['湄公河','',''],['湄公河三角洲','',''],['湄洲岛','',''],['湉湉','',''],['湍急','',''],['湍流','',''],['湍湍','',''],['湎于','',''],['湔洗','',''],['湔涤','',''],['湔雪','',''],['湖上','',''],['湖人','',''],['湖光','',''],['湖光山色','',''],['湖内','',''],['湖内乡','',''],['湖北大鼓','',''],['湖北花楸','',''],['湖区','',''],['湖南大学','',''],['湖口乡','',''],['湖名','',''],['湖广','',''],['湖心','',''],['湖水','',''],['湖沼','',''],['湖沼学','',''],['湖泊','',''],['湖泽','',''],['湖滨','',''],['湖滩','',''],['湖田','',''],['湖畔','',''],['湖笔','',''],['湖绉','',''],['湖羊','',''],['湖色','',''],['湖西','',''],['湖西乡','',''],['湖边','',''],['湖里','',''],['湖面','',''],['湘东','',''],['湘军','',''],['湘剧','',''],['湘勇','',''],['湘南起义','',''],['湘妃竹','',''],['湘帘','',''],['湘桂运河','',''],['湘桂铁路','',''],['湘桥','',''],['湘江','',''],['湘潭地区','',''],['湘竹','',''],['湘绣','',''],['湘菜','',''],['湘西','',''],['湘西鄂西起义','',''],['湘语','',''],['湘黔','',''],['湘黔铁路','',''],['湛江地区','',''],['湛江师范学院','',''],['湛江港','',''],['湛河','',''],['湛蓝','',''],['湟水','',''],['湟鱼','',''],['湫隘','',''],['湮没','',''],['湮没无闻','',''],['湮灭','',''],['湮补','',''],['湾仔','',''],['湾内','',''],['湾潭','',''],['湾环','',''],['湾里','',''],['湾鳄','',''],['湿冷','',''],['湿吻','',''],['湿地','',''],['湿地中','',''],['湿婆','',''],['湿季','',''],['湿布','',''],['湿度','',''],['湿度器','',''],['湿度学','',''],['湿度表','',''],['湿度计','',''],['湿气','',''],['湿润','',''],['湿润剂','',''],['湿淋淋','',''],['湿渌渌','',''],['湿温','',''],['湿漉漉','',''],['湿热','',''],['湿球温度','',''],['湿疣','',''],['湿疹','',''],['湿症','',''],['湿的','',''],['湿衣','',''],['湿货','',''],['湿软','',''],['湿透','',''],['湿透了','',''],['湿黏','',''],['溃不成军','',''],['溃乱','',''],['溃于蚁穴','',''],['溃兵','',''],['溃军','',''],['溃决','',''],['溃坝','',''],['溃堤','',''],['溃处','',''],['溃敌','',''],['溃散','',''],['溃灭','',''],['溃烂','',''],['溃疡','',''],['溃疡性','',''],['溃裂','',''],['溃败','',''],['溃退','',''],['溃逃','',''],['溅出','',''],['溅射','',''],['溅开','',''],['溅散','',''],['溅水','',''],['溅污','',''],['溅泼','',''],['溅洒','',''],['溅湿','',''],['溅溢','',''],['溅落','',''],['溅起来','',''],['溅迸','',''],['溅酒','',''],['溉涤','',''],['溏便','',''],['源・赖朝','',''],['源于','',''],['源代码','',''],['源出','',''],['源器官','',''],['源城','',''],['源头','',''],['源殊派异','',''],['源氏物语','',''],['源汇','',''],['源泉','',''],['源流','',''],['源深流长','',''],['源清流净','',''],['源清流洁','',''],['源清流清','',''],['源源','',''],['源源不断','',''],['源源不绝','',''],['源源本本','',''],['源源而来','',''],['源点','',''],['源点地址','',''],['源由','',''],['源盘','',''],['源码','',''],['源程序','',''],['源自','',''],['源自于','',''],['源起','',''],['源远流长','',''],['溘先朝露','',''],['溘然','',''],['溘逝','',''],['溜之','',''],['溜之大吉','',''],['溜了','',''],['溜光','',''],['溜冰','',''],['溜冰场','',''],['溜冰者','',''],['溜冰鞋','',''],['溜出','',''],['溜号','',''],['溜哒','',''],['溜圆','',''],['溜子','',''],['溜平','',''],['溜开','',''],['溜掉','',''],['溜旱冰','',''],['溜槽','',''],['溜溜','',''],['溜溜球','',''],['溜溜转','',''],['溜滑','',''],['溜烟','',''],['溜狗','',''],['溜肉','',''],['溜肩','',''],['溜肩膀','',''],['溜脱','',''],['溜舐','',''],['溜走','',''],['溜转','',''],['溜边','',''],['溜边儿','',''],['溜达','',''],['溜进','',''],['溜长','',''],['溜须拍马','',''],['溟岛','',''],['溟池','',''],['溟海','',''],['溟溟','',''],['溟漭','',''],['溟蒙','',''],['溢于','',''],['溢于言表','',''],['溢价','',''],['溢余','',''],['溢值','',''],['溢出','',''],['溢出效应','',''],['溢泼','',''],['溢洪道','',''],['溢流','',''],['溢流孔','',''],['溢流道','',''],['溢满','',''],['溢美','',''],['溢血','',''],['溢过','',''],['溢量','',''],['溥仪','',''],['溥俊','',''],['溥天同庆','',''],['溪口','',''],['溪口乡','',''],['溪壑','',''],['溪壑无厌','',''],['溪州','',''],['溪州乡','',''],['溪径','',''],['溪水','',''],['溪流','',''],['溪涧','',''],['溪湖','',''],['溪湖镇','',''],['溪蟹','',''],['溪谷','',''],['溪间','',''],['溪黄草','',''],['溯力','',''],['溯江','',''],['溯流','',''],['溯流从源','',''],['溯流徂源','',''],['溯流求源','',''],['溯源','',''],['溯源穷流','',''],['溴化氰','',''],['溴化物','',''],['溴化钾','',''],['溴化银','',''],['溴单质','',''],['溴水','',''],['溴甲烷','',''],['溴酸','',''],['溴酸盐','',''],['溴钨灯','',''],['溶为','',''],['溶于','',''],['溶体','',''],['溶入','',''],['溶剂','',''],['溶化','',''],['溶合','',''],['溶岩','',''],['溶岩流','',''],['溶度','',''],['溶性','',''],['溶水','',''],['溶没','',''],['溶洞','',''],['溶液','',''],['溶源性','',''],['溶溶','',''],['溶点','',''],['溶胶','',''],['溶脢体','',''],['溶脢储存疾病','',''],['溶茶','',''],['溶蚀','',''],['溶蚀作用','',''],['溶血','',''],['溶血病','',''],['溶解','',''],['溶解力','',''],['溶解度','',''],['溶解性','',''],['溶解物','',''],['溶质','',''],['溶酶体','',''],['溷厕','',''],['溺于','',''],['溺婴','',''],['溺宠','',''],['溺死','',''],['溺毙','',''],['溺水','',''],['溺爱','',''],['溽暑','',''],['滁县','',''],['滂沱','',''],['滂沱大雨','',''],['滂湃','',''],['滇东','',''],['滇剧','',''],['滇池','',''],['滇红','',''],['滇缅','',''],['滇藏','',''],['滋事','',''],['滋养','',''],['滋养品','',''],['滋养层','',''],['滋养物','',''],['滋味','',''],['滋扰','',''],['滋润','',''],['滋滋','',''],['滋生','',''],['滋育','',''],['滋芽','',''],['滋蔓','',''],['滋蔓难图','',''],['滋补','',''],['滋补剂','',''],['滋补品','',''],['滋贺','',''],['滋贺县','',''],['滋长','',''],['滑下','',''],['滑不唧溜','',''],['滑了','',''],['滑倒','',''],['滑入','',''],['滑冰','',''],['滑冰者','',''],['滑出','',''],['滑出跑道','',''],['滑到','',''],['滑动','',''],['滑动摩擦','',''],['滑动轴承','',''],['滑向','',''],['滑回','',''],['滑块','',''],['滑坡','',''],['滑头','',''],['滑开','',''],['滑旱冰','',''],['滑杆','',''],['滑板','',''],['滑标','',''],['滑梯','',''],['滑槽','',''],['滑模','',''],['滑步','',''],['滑步走','',''],['滑水','',''],['滑水板','',''],['滑沙','',''],['滑流','',''],['滑润','',''],['滑溜','',''],['滑溜溜','',''],['滑滑','',''],['滑环','',''],['滑的','',''],['滑盖','',''],['滑石','',''],['滑石粉','',''],['滑离','',''],['滑移','',''],['滑稽','',''],['滑稽人','',''],['滑稽剧','',''],['滑稽化','',''],['滑稽可笑','',''],['滑稽戏','',''],['滑竿','',''],['滑粉','',''],['滑精','',''],['滑翔','',''],['滑翔伞','',''],['滑翔术','',''],['滑翔机','',''],['滑翔翼','',''],['滑翔者','',''],['滑翔运动','',''],['滑胎','',''],['滑脉','',''],['滑脱','',''],['滑腻','',''],['滑膛','',''],['滑膜','',''],['滑舌','',''],['滑落','',''],['滑行','',''],['滑行道','',''],['滑走','',''],['滑跤','',''],['滑车','',''],['滑车神经','',''],['滑轮','',''],['滑轮组','',''],['滑过','',''],['滑道','',''],['滑铁卢','',''],['滑铁卢战役','',''],['滑铁卢火车站','',''],['滑门','',''],['滑阀','',''],['滑降','',''],['滑雪','',''],['滑雪术','',''],['滑雪板','',''],['滑雪索道','',''],['滑雪者','',''],['滑雪衫','',''],['滑雪运动','',''],['滑面','',''],['滑面粉','',''],['滑音','',''],['滑鼠','',''],['滑鼠垫','',''],['滑鼠蛇','',''],['滔天','',''],['滔天之罪','',''],['滔天大罪','',''],['滔天罪行','',''],['滔滔','',''],['滔滔不尽','',''],['滔滔不断','',''],['滔滔不竭','',''],['滔滔不绝','',''],['滕县','',''],['滕家','',''],['滕家镇','',''],['滕斯贝格','',''],['滕王阁','',''],['滚上','',''],['滚作','',''],['滚倒','',''],['滚刀','',''],['滚刀块','',''],['滚刀肉','',''],['滚利','',''],['滚动','',''],['滚动摩擦','',''],['滚动条','',''],['滚动轴承','',''],['滚回','',''],['滚圆','',''],['滚奏','',''],['滚子','',''],['滚子轴承','',''],['滚存','',''],['滚屏','',''],['滚开','',''],['滚彩蛋','',''],['滚得','',''],['滚打','',''],['滚木','',''],['滚杠','',''],['滚柱轴承','',''],['滚水','',''],['滚水坝','',''],['滚汤','',''],['滚沸','',''],['滚油煎心','',''],['滚滑','',''],['滚滚','',''],['滚滚向前','',''],['滚滚而来','',''],['滚烫','',''],['滚热','',''],['滚珠','',''],['滚珠轴承','',''],['滚球','',''],['滚瓜溜圆','',''],['滚瓜烂熟','',''],['滚着','',''],['滚石','',''],['滚筒','',''],['滚翻','',''],['滚落','',''],['滚蛋','',''],['滚转','',''],['滚轮','',''],['滚轴','',''],['滚边','',''],['滚过','',''],['滚进','',''],['滚针','',''],['滚针轴承','',''],['滚铣','',''],['滚雪球','',''],['滞后','',''],['滞塞','',''],['滞期费','',''],['滞水','',''],['滞留','',''],['滞留费','',''],['滞碍','',''],['滞积','',''],['滞纳','',''],['滞纳金','',''],['滞胀','',''],['滞销','',''],['滞销品','',''],['滞销货','',''],['满不','',''],['满不在乎','',''],['满世界','',''],['满也','',''],['满了','',''],['满于','',''],['满人','',''],['满位','',''],['满兜','',''],['满公','',''],['满出','',''],['满分','',''],['满剌加','',''],['满口','',''],['满口之乎者也','',''],['满口应承','',''],['满口称赞','',''],['满口答应','',''],['满口胡柴','',''],['满口胡言','',''],['满口脏话','',''],['满口袋','',''],['满口谎言','',''],['满含热泪','',''],['满员','',''],['满嘴','',''],['满嘴喷粪','',''],['满嘴起疱','',''],['满园春色','',''],['满地','',''],['满场','',''],['满场一致','',''],['满坐寂然','',''],['满坑满谷','',''],['满垒','',''],['满城尽带黄金甲','',''],['满城风雨','',''],['满堂','',''],['满堂彩','',''],['满堂灌','',''],['满堂红','',''],['满处','',''],['满天','',''],['满天星','',''],['满天繁星','',''],['满天飞','',''],['满头','',''],['满头大汗','',''],['满孝','',''],['满射','',''],['满屋','',''],['满屏','',''],['满山遍野','',''],['满岁','',''],['满州','',''],['满州乡','',''],['满州人','',''],['满州里','',''],['满布','',''],['满帆','',''],['满师','',''],['满座','',''],['满座风生','',''],['满当当','',''],['满心','',''],['满心欢喜','',''],['满怀','',''],['满怀信心','',''],['满意','',''],['满手','',''],['满打满算','',''],['满招','',''],['满招损','',''],['满招损谦受益','',''],['满拧','',''],['满文','',''],['满旗','',''],['满是','',''],['满月','',''],['满有','',''],['满有谱','',''],['满服','',''],['满期','',''],['满条','',''],['满杯','',''],['满桶','',''],['满汉','',''],['满汉全席','',''],['满江红','',''],['满洲','',''],['满洲国','',''],['满洲问题','',''],['满清','',''],['满清政府','',''],['满溢','',''],['满满','',''],['满满当当','',''],['满满登登','',''],['满满的','',''],['满潮','',''],['满点','',''],['满登登','',''],['满的','',''],['满盆','',''],['满盈','',''],['满盘','',''],['满目','',''],['满目琳琅','',''],['满目疮痍','',''],['满目荆榛','',''],['满眼','',''],['满碗','',''],['满箱','',''],['满篮','',''],['满而不溢','',''],['满脑','',''],['满脸','',''],['满脸生花','',''],['满脸通红','',''],['满脸风尘','',''],['满腔','',''],['满腔热忱','',''],['满腔热情','',''],['满腔热血','',''],['满腹','',''],['满腹文章','',''],['满腹牢骚','',''],['满腹狐疑','',''],['满腹经纶','',''],['满舌生花','',''],['满舵','',''],['满街','',''],['满袋','',''],['满袖春风','',''],['满语','',''],['满负荷','',''],['满贯','',''],['满足','',''],['满足于','',''],['满足感','',''],['满身','',''],['满身尘埃','',''],['满载','',''],['满载而归','',''],['满都','',''],['满钱袋','',''],['满门','',''],['满门抄斩','',''],['满面','',''],['满面春风','',''],['满面红光','',''],['满额','',''],['滤光','',''],['滤出','',''],['滤去','',''],['滤取','',''],['滤嘴','',''],['滤器','',''],['滤尘器','',''],['滤掉','',''],['滤斗','',''],['滤毒','',''],['滤毒通风装置','',''],['滤池','',''],['滤波','',''],['滤波器','',''],['滤液','',''],['滤清','',''],['滤清器','',''],['滤砂','',''],['滤纸','',''],['滤网','',''],['滤膜','',''],['滤色镜','',''],['滤过','',''],['滤过性病毒','',''],['滤锅','',''],['滤除','',''],['滤饼','',''],['滥交','',''],['滥伐','',''],['滥写','',''],['滥减','',''],['滥刑','',''],['滥占','',''],['滥印','',''],['滥发','',''],['滥吏赃官','',''],['滥垦','',''],['滥增','',''],['滥套子','',''],['滥好人','',''],['滥官污吏','',''],['滥成','',''],['滥捕','',''],['滥摊','',''],['滥施','',''],['滥服','',''],['滥杀','',''],['滥杀无辜','',''],['滥污','',''],['滥漫','',''],['滥用','',''],['滥用权力','',''],['滥用职权','',''],['滥砍','',''],['滥砍滥伐','',''],['滥竽','',''],['滥竽充数','',''],['滥觞','',''],['滥调','',''],['滥贴','',''],['滥造','',''],['滥骂','',''],['滦河','',''],['滨临','',''],['滨城','',''],['滨州地区','',''],['滨松','',''],['滨松市','',''],['滨江','',''],['滨洲铁路','',''],['滨海新区','',''],['滨海边疆区','',''],['滨湖','',''],['滨田','',''],['滨田・靖一','',''],['滨绥铁路','',''],['滩上','',''],['滩地','',''],['滩头','',''],['滩头堡','',''],['滩头阵','',''],['滩涂','',''],['滩簧','',''],['滩羊','',''],['滩装','',''],['滴下','',''],['滴下物','',''],['滴出','',''],['滴剂','',''],['滴定','',''],['滴定管','',''],['滴干','',''],['滴水','',''],['滴水不漏','',''],['滴水不羼','',''],['滴水成冰','',''],['滴水成冻','',''],['滴水瓦','',''],['滴水石','',''],['滴水石穿','',''],['滴水穿石','',''],['滴沥','',''],['滴注','',''],['滴流','',''],['滴溜','',''],['滴溜儿','',''],['滴溜溜','',''],['滴滴','',''],['滴滴涕','',''],['滴漏','',''],['滴漏计时器','',''],['滴灌','',''],['滴点','',''],['滴瓶','',''],['滴石','',''],['滴答','',''],['滴答声','',''],['滴管','',''],['滴翠','',''],['滴落','',''],['滴虫','',''],['滴虫类','',''],['滴血','',''],['滴道','',''],['滴酒不沾','',''],['滴里嘟噜','',''],['滴里耷拉','',''],['滴量','',''],['滴量计','',''],['漂了','',''],['漂亮','',''],['漂亮话','',''],['漂儿','',''],['漂净','',''],['漂去','',''],['漂向','',''],['漂摇','',''],['漂散','',''],['漂来物','',''],['漂染','',''],['漂母进饭','',''],['漂泊','',''],['漂洋','',''],['漂洋过海','',''],['漂洗','',''],['漂流','',''],['漂流物','',''],['漂流瓶','',''],['漂流者','',''],['漂浮','',''],['漂浮物','',''],['漂浮者','',''],['漂海','',''],['漂游','',''],['漂渺','',''],['漂漂','',''],['漂漂亮亮','',''],['漂白','',''],['漂白剂','',''],['漂白水','',''],['漂白粉','',''],['漂着','',''],['漂砾','',''],['漂移','',''],['漂荡','',''],['漂落','',''],['漂行','',''],['漂起','',''],['漂进','',''],['漂零','',''],['漂零蓬断','',''],['漂雷','',''],['漆上','',''],['漆包线','',''],['漆匠','',''],['漆器','',''],['漆工','',''],['漆布','',''],['漆弹','',''],['漆成','',''],['漆木纹','',''],['漆枪','',''],['漆树','',''],['漆树科','',''],['漆桶','',''],['漆漆','',''],['漆片','',''],['漆画','',''],['漆皮','',''],['漆身吞炭','',''],['漆雕','',''],['漆黑','',''],['漆黑一团','',''],['漉漉','',''],['漉网','',''],['漏了','',''],['漏做','',''],['漏光','',''],['漏兜','',''],['漏出','',''],['漏出量','',''],['漏划','',''],['漏列','',''],['漏办','',''],['漏加','',''],['漏勺','',''],['漏卮','',''],['漏嘴','',''],['漏填','',''],['漏壶','',''],['漏夜','',''],['漏失','',''],['漏子','',''],['漏字','',''],['漏尽','',''],['漏尽更阑','',''],['漏屋','',''],['漏底','',''],['漏征','',''],['漏扣','',''],['漏报','',''],['漏损','',''],['漏掉','',''],['漏接球','',''],['漏收','',''],['漏斗','',''],['漏斗云','',''],['漏斗形','',''],['漏查','',''],['漏气','',''],['漏水','',''],['漏水转浑天仪','',''],['漏池','',''],['漏油','',''],['漏泄','',''],['漏泄天机','',''],['漏泄春光','',''],['漏洞','',''],['漏洞百出','',''],['漏瓮沃焦釜','',''],['漏电','',''],['漏疮','',''],['漏税','',''],['漏纳','',''],['漏缝','',''],['漏缴','',''],['漏网','',''],['漏网之鱼','',''],['漏网游鱼','',''],['漏脯充饥','',''],['漏计','',''],['漏记','',''],['漏误','',''],['漏读','',''],['漏转','',''],['漏锅','',''],['漏隙','',''],['漏雨','',''],['漏风','',''],['漓江','',''],['演义','',''],['演习','',''],['演人','',''],['演出','',''],['演出团','',''],['演出地点','',''],['演出者','',''],['演到','',''],['演剧','',''],['演化','',''],['演变','',''],['演古劝今','',''],['演员','',''],['演员阵容','',''],['演唱','',''],['演唱会','',''],['演回','',''],['演坛','',''],['演奏','',''],['演奏会','',''],['演奏台','',''],['演奏员','',''],['演奏家','',''],['演奏者','',''],['演完','',''],['演得','',''],['演戏','',''],['演戏似','',''],['演戏船','',''],['演成','',''],['演技','',''],['演技术','',''],['演播','',''],['演播室','',''],['演替','',''],['演有','',''],['演武','',''],['演武修文','',''],['演法','',''],['演示','',''],['演算','',''],['演算出','',''],['演算法','',''],['演练','',''],['演绎','',''],['演绎出','',''],['演绎式','',''],['演绎推理','',''],['演绎法','',''],['演者','',''],['演艺','',''],['演艺人员','',''],['演艺圈','',''],['演艺界','',''],['演讲','',''],['演讲会','',''],['演讲学','',''],['演讲家','',''],['演讲术','',''],['演讲者','',''],['演讲词','',''],['演讲集','',''],['演说','',''],['演说台','',''],['演说家','',''],['演说术','',''],['演说等','',''],['演说者','',''],['演进','',''],['漕河','',''],['漕渡','',''],['漕粮','',''],['漕船','',''],['漕运','',''],['漠不关心','',''],['漠漠','',''],['漠然','',''],['漠然置之','',''],['漠视','',''],['漩涡','',''],['漩风','',''],['漫不经心','',''],['漫儿','',''],['漫卷','',''],['漫反射','',''],['漫地满天','',''],['漫天','',''],['漫天匝地','',''],['漫天塞地','',''],['漫天彻地','',''],['漫天漫地','',''],['漫天盖地','',''],['漫天要价','',''],['漫天遍地','',''],['漫天遍野','',''],['漫天飞舞','',''],['漫射','',''],['漫山','',''],['漫山遍野','',''],['漫应','',''],['漫延','',''],['漫散','',''],['漫无','',''],['漫无止境','',''],['漫无目的','',''],['漫无边际','',''],['漫步','',''],['漫步者','',''],['漫游','',''],['漫游生物','',''],['漫溢','',''],['漫漫','',''],['漫漫长夜','',''],['漫漶','',''],['漫灌','',''],['漫画','',''],['漫画家','',''],['漫笔','',''],['漫记','',''],['漫话','',''],['漫诞不稽','',''],['漫说','',''],['漫谈','',''],['漫过','',''],['漫道','',''],['漫长','',''],['漫长岁月','',''],['漫长的','',''],['漫骂','',''],['漭漭','',''],['漱口','',''],['漱口剂','',''],['漱喉','',''],['漱洗','',''],['漱流','',''],['漱流枕石','',''],['漾奶','',''],['漾濞','',''],['潆洄','',''],['潇沥','',''],['潇洒','',''],['潇洒风流','',''],['潇湘','',''],['潇潇','',''],['潇潇细雨','',''],['潋滟','',''],['潍坊地区','',''],['潍城','',''],['潘基文','',''],['潘塔纳尔','',''],['潘多拉','',''],['潘多拉魔盒','',''],['潘太克斯','',''],['潘婷','',''],['潘安','',''],['潘岳','',''],['潘杨之睦','',''],['潘江陆海','',''],['潘通','',''],['潘金莲','',''],['潘陆江海','',''],['潘集','',''],['潘鬓成霜','',''],['潘鬓沈腰','',''],['潜下','',''],['潜亏','',''],['潜伏','',''],['潜伏性','',''],['潜伏所','',''],['潜伏期','',''],['潜伏着','',''],['潜入','',''],['潜力','',''],['潜动','',''],['潜势','',''],['潜匿','',''],['潜台词','',''],['潜图问鼎','',''],['潜在','',''],['潜在力量','',''],['潜在危险度','',''],['潜在威胁','',''],['潜在媒介','',''],['潜在性','',''],['潜山隐市','',''],['潜形匿迹','',''],['潜影','',''],['潜心','',''],['潜心于','',''],['潜意识','',''],['潜望','',''],['潜望镜','',''],['潜水','',''],['潜水人','',''],['潜水刀','',''],['潜水员','',''],['潜水夫病','',''],['潜水夫症','',''],['潜水服','',''],['潜水泵','',''],['潜水球','',''],['潜水者','',''],['潜水艇','',''],['潜水衣','',''],['潜水装备拖轮箱','',''],['潜水运动','',''],['潜水鸟','',''],['潜没','',''],['潜泳','',''],['潜流','',''],['潜涵病','',''],['潜游','',''],['潜滋暗长','',''],['潜热','',''],['潜神默思','',''],['潜神默记','',''],['潜科学','',''],['潜移','',''],['潜移暗化','',''],['潜移阴夺','',''],['潜移默化','',''],['潜移默夺','',''],['潜移默运','',''],['潜能','',''],['潜航','',''],['潜舰','',''],['潜艇','',''],['潜藏','',''],['潜蛟困凤','',''],['潜血','',''],['潜行','',''],['潜规则','',''],['潜质','',''],['潜踪','',''],['潜身远祸','',''],['潜身远迹','',''],['潜逃','',''],['潜逃无踪','',''],['潜随','',''],['潜骸窜影','',''],['潜鸟','',''],['潜龙伏虎','',''],['潜龙勿用','',''],['潟湖','',''],['潢池弄兵','',''],['潢潦可荐','',''],['潦乱','',''],['潦倒','',''],['潦写','',''],['潦潦草草','',''],['潦草','',''],['潭奥','',''],['潭子','',''],['潭子乡','',''],['潭底','',''],['潭府','',''],['潭影','',''],['潭柘寺','',''],['潭水','',''],['潭祉','',''],['潭第','',''],['潭腿','',''],['潮位','',''],['潮剧','',''],['潮力','',''],['潮南','',''],['潮呼呼','',''],['潮声','',''],['潮州镇','',''],['潮差','',''],['潮气','',''],['潮水','',''],['潮汐','',''],['潮汐发电','',''],['潮汐电站','',''],['潮汕','',''],['潮汛','',''],['潮洲','',''],['潮流','',''],['潮涌','',''],['潮涨潮落','',''],['潮湿','',''],['潮白','',''],['潮红','',''],['潮脑','',''],['潮落','',''],['潮虫','',''],['潮解','',''],['潮解性','',''],['潮讯','',''],['潮语','',''],['潮起','',''],['潮起潮落','',''],['潮退','',''],['潮退了','',''],['潮间带','',''],['潮阳','',''],['潲水','',''],['潴留','',''],['潸潸','',''],['潸然','',''],['潸然泪下','',''],['潺声','',''],['潺潺','',''],['潺潺声','',''],['澄彻','',''],['澄思寂虑','',''],['澄沙','',''],['澄浆泥','',''],['澄海','',''],['澄清','',''],['澄清事实','',''],['澄清剂','',''],['澄清天下','',''],['澄渊','',''],['澄湛','',''],['澄澈','',''],['澄莹','',''],['澈底','',''],['澈查','',''],['澌灭','',''],['澎湃','',''],['澎湖','',''],['澎湖列岛','',''],['澎湖岛','',''],['澎湖湾','',''],['澎湖群岛','',''],['澜沧','',''],['澜沧县','',''],['澜沧江','',''],['澡垢索疵','',''],['澡堂','',''],['澡堂子','',''],['澡塘','',''],['澡巾','',''],['澡房','',''],['澡池','',''],['澡盆','',''],['澡票','',''],['澡类学','',''],['澡罐','',''],['澡身浴德','',''],['澧水','',''],['澳元','',''],['澳大利亚国立大学','',''],['澳大利亚总督','',''],['澳大利亚洲','',''],['澳大利亚联邦','',''],['澳大利亚首都特区','',''],['澳币','',''],['澳式橄榄球','',''],['澳新军团','',''],['澳新军团日','',''],['澳洲','',''],['澳洲人','',''],['澳洲小鹦鹉','',''],['澳洲广播电台','',''],['澳洲黑鸡','',''],['澳纽','',''],['澳门国际机场','',''],['澳门币','',''],['澳门市','',''],['澳门立法会','',''],['澳际','',''],['澹台','',''],['澹泊寡欲','',''],['澹泊明志','',''],['澹然','',''],['激光','',''],['激光二极管','',''],['激光印字机','',''],['激光唱片','',''],['激光器','',''],['激光打印机','',''],['激光打引机','',''],['激光测距仪','',''],['激光焊接','',''],['激光照排','',''],['激光通信','',''],['激光雷达','',''],['激凸','',''],['激切','',''],['激动','',''],['激动不安','',''],['激动人心','',''],['激励','',''],['激励机制','',''],['激化','',''],['激发','',''],['激发态','',''],['激发注射','',''],['激变','',''],['激变论','',''],['激增','',''],['激奋','',''],['激射','',''],['激将','',''],['激将法','',''],['激忿填膺','',''],['激怒','',''],['激性','',''],['激恼','',''],['激情','',''],['激愤','',''],['激战','',''],['激打','',''],['激扬','',''],['激昂','',''],['激昂慷慨','',''],['激波','',''],['激活','',''],['激活扩散网络','',''],['激活整合模型','',''],['激流','',''],['激流勇退','',''],['激浊扬清','',''],['激浪','',''],['激灵','',''],['激烈','',''],['激烈化','',''],['激磁','',''],['激素','',''],['激荡','',''],['激论','',''],['激贪厉俗','',''],['激赏','',''],['激赞','',''],['激起','',''],['激越','',''],['激辩','',''],['激进','',''],['激进主义','',''],['激进分子','',''],['激进化','',''],['激进武装','',''],['激进武装分子','',''],['激进派','',''],['激进论','',''],['激酶','',''],['濊貊','',''],['濑鱼','',''],['濒临','',''],['濒临灭绝','',''],['濒临破产','',''],['濒临绝境','',''],['濒于','',''],['濒于倒闭','',''],['濒危','',''],['濒危动物','',''],['濒危物种','',''],['濒危野生动植物种国际贸易公约','',''],['濒死','',''],['濒河','',''],['濒海','',''],['濒灭','',''],['濒近','',''],['濠江','',''],['濠沟','',''],['濡染','',''],['濡毫','',''],['濡沫涸辙','',''],['濡湿','',''],['濮上之音','',''],['濮上桑间','',''],['濯污扬清','',''],['濯濯','',''],['濯盥','',''],['濯缨弹冠','',''],['濯缨沧浪','',''],['濯缨洗耳','',''],['濯缨濯足','',''],['濯足','',''],['濯身','',''],['濯锦以鱼','',''],['瀍水','',''],['瀍河','',''],['瀍河回族区','',''],['瀑布','',''],['瀚海','',''],['瀛台','',''],['瀛寰','',''],['瀛洲','',''],['瀵泉','',''],['灌上','',''],['灌下','',''],['灌丛','',''],['灌了','',''],['灌于','',''],['灌入','',''],['灌制','',''],['灌区','',''],['灌县','',''],['灌夫骂坐','',''],['灌录','',''],['灌木','',''],['灌木丛','',''],['灌木林','',''],['灌水','',''],['灌法','',''],['灌注','',''],['灌注法','',''],['灌洗','',''],['灌浆','',''],['灌渠','',''],['灌溉','',''],['灌溉渠','',''],['灌溉系统','',''],['灌溉者','',''],['灌满','',''],['灌濯','',''],['灌瓜之义','',''],['灌站','',''],['灌篮','',''],['灌米汤','',''],['灌肠','',''],['灌肠剂','',''],['灌药','',''],['灌装','',''],['灌输','',''],['灌进','',''],['灌酒','',''],['灌醉','',''],['灌音','',''],['灞桥','',''],['火上','',''],['火上加油','',''],['火上弄冰','',''],['火上弄冰凌','',''],['火上浇油','',''],['火上添油','',''],['火中','',''],['火中取栗','',''],['火主','',''],['火井','',''],['火亮','',''],['火伞高张','',''],['火伤','',''],['火伴','',''],['火候','',''],['火儿','',''],['火光','',''],['火具','',''],['火冒三丈','',''],['火刀','',''],['火刑','',''],['火刑柱','',''],['火前','',''],['火剪','',''],['火力','',''],['火力发电','',''],['火力发电厂','',''],['火力圈','',''],['火力点','',''],['火力配置','',''],['火势','',''],['火化','',''],['火匣子','',''],['火卫一','',''],['火印','',''],['火口','',''],['火器','',''],['火地','',''],['火地群岛','',''],['火场','',''],['火场留守分队','',''],['火坑','',''],['火堆','',''],['火塘','',''],['火墙','',''],['火大','',''],['火夫','',''],['火头','',''],['火头上','',''],['火头军','',''],['火奴鲁鲁','',''],['火媒','',''],['火居道士','',''],['火山','',''],['火山似','',''],['火山口','',''],['火山土','',''],['火山地震','',''],['火山学','',''],['火山岛','',''],['火山岩','',''],['火山带','',''],['火山汤海','',''],['火山活动','',''],['火山灰','',''],['火山爆发','',''],['火山爆发指数','',''],['火山砾','',''],['火山碎屑流','',''],['火并','',''],['火影忍者','',''],['火德星君','',''],['火急','',''],['火性','',''],['火情','',''],['火成','',''],['火成岩','',''],['火成碎屑','',''],['火把','',''],['火把节','',''],['火拼','',''],['火捻','',''],['火控','',''],['火攻','',''],['火星','',''],['火星人','',''],['火星快车','',''],['火星撞地球','',''],['火星文','',''],['火暴','',''],['火曜日','',''],['火机','',''],['火枪','',''],['火枪手','',''],['火柱','',''],['火柴','',''],['火柴盒','',''],['火树','',''],['火树琪花','',''],['火树银花','',''],['火棒','',''],['火气','',''],['火油','',''],['火浣布','',''],['火海','',''],['火海刀山','',''],['火湖','',''],['火漆','',''],['火火','',''],['火灭烟消','',''],['火灾','',''],['火炉','',''],['火炕','',''],['火炬','',''],['火炬手','',''],['火炬计划','',''],['火炭','',''],['火炮','',''],['火点','',''],['火炽','',''],['火烈鸟','',''],['火烛','',''],['火烛小心','',''],['火烧','',''],['火烧云','',''],['火烧似','',''],['火烧火燎','',''],['火烧眉毛','',''],['火烫','',''],['火热','',''],['火热水深','',''],['火焚','',''],['火焰','',''],['火焰似','',''],['火焰喷射器','',''],['火焰山','',''],['火然泉达','',''],['火煤','',''],['火爆','',''],['火犁','',''],['火狐','',''],['火环','',''],['火电','',''],['火电站','',''],['火盆','',''],['火眼','',''],['火眼金睛','',''],['火眼金睛识真假','',''],['火石','',''],['火砖','',''],['火硝','',''],['火碱','',''],['火磨','',''],['火神','',''],['火种','',''],['火笼','',''],['火筷子','',''],['火箭','',''],['火箭学','',''],['火箭弹','',''],['火箭炮','',''],['火箭爆破器','',''],['火箭筒','',''],['火箸','',''],['火红','',''],['火红色','',''],['火纸','',''],['火线','',''],['火绒','',''],['火绒草','',''],['火绳','',''],['火罐','',''],['火罐儿','',''],['火网','',''],['火老鸦','',''],['火耕水种','',''],['火耕水耨','',''],['火耕流种','',''],['火耨刀耕','',''],['火肉','',''],['火腿','',''],['火腿肠','',''],['火舌','',''],['火色','',''],['火花','',''],['火花塞','',''],['火苗','',''],['火药','',''],['火药味','',''],['火药味甚浓','',''],['火葬','',''],['火葬场','',''],['火葬炉','',''],['火葬者','',''],['火蛇','',''],['火蛛蛛','',''],['火蜥蜴','',''],['火蝎子','',''],['火表','',''],['火警','',''],['火车','',''],['火车头','',''],['火车票','',''],['火车站','',''],['火轮','',''],['火轮船','',''],['火辣','',''],['火辣辣','',''],['火速','',''],['火酒','',''],['火钳','',''],['火锅','',''],['火镜','',''],['火镰','',''],['火门','',''],['火险','',''],['火鸡','',''],['火鸡肉','',''],['火鹤','',''],['火鹤花','',''],['火龙','',''],['火龙果','',''],['灭亡','',''],['灭亲','',''],['灭口','',''],['灭失','',''],['灭尸','',''],['灭度','',''],['灭掉','',''],['灭敌','',''],['灭教','',''],['灭族','',''],['灭此','',''],['灭此朝食','',''],['灭火','',''],['灭火器','',''],['灭火筒','',''],['灭私奉公','',''],['灭种','',''],['灭种罪','',''],['灭绝','',''],['灭绝人性','',''],['灭绝种族','',''],['灭茬','',''],['灭菌','',''],['灭虫','',''],['灭虫宁','',''],['灭迹','',''],['灭门','',''],['灭门之祸','',''],['灭门绝户','',''],['灭音器','',''],['灭顶','',''],['灭顶之灾','',''],['灭鼠','',''],['灭鼠药','',''],['灯丝','',''],['灯中','',''],['灯会','',''],['灯伞','',''],['灯光','',''],['灯光秀','',''],['灯具','',''],['灯台','',''],['灯台不自照','',''],['灯号','',''],['灯坠','',''],['灯夫','',''],['灯头','',''],['灯市','',''],['灯座','',''],['灯彩','',''],['灯影','',''],['灯心','',''],['灯心绒','',''],['灯心草','',''],['灯杆','',''],['灯架','',''],['灯柱','',''],['灯标','',''],['灯油','',''],['灯泡','',''],['灯火','',''],['灯火万家','',''],['灯火管制','',''],['灯火辉煌','',''],['灯火通明','',''],['灯灰','',''],['灯片','',''],['灯盏','',''],['灯笼','',''],['灯笼库','',''],['灯笼果','',''],['灯笼花','',''],['灯笼裤','',''],['灯笼鱼','',''],['灯管','',''],['灯红酒绿','',''],['灯罩','',''],['灯节','',''],['灯芯','',''],['灯芯绒','',''],['灯芯草','',''],['灯花','',''],['灯苗','',''],['灯草','',''],['灯草绒','',''],['灯蕊','',''],['灯虎','',''],['灯蛾','',''],['灯蛾扑火','',''],['灯语','',''],['灯谜','',''],['灰不喇唧','',''],['灰不溜丢','',''],['灰不溜秋','',''],['灰光','',''],['灰分','',''],['灰化土','',''],['灰口铁','',''],['灰土','',''],['灰头土脸','',''],['灰头土脸儿','',''],['灰头土面','',''],['灰头草面','',''],['灰姑娘','',''],['灰尘','',''],['灰尘肺','',''],['灰岩','',''],['灰岩残丘','',''],['灰度','',''],['灰廓','',''],['灰心','',''],['灰心丧意','',''],['灰心丧气','',''],['灰心槁形','',''],['灰暗','',''],['灰棚','',''],['灰泥','',''],['灰浆','',''],['灰渣','',''],['灰溜','',''],['灰溜溜','',''],['灰火','',''],['灰灰','',''],['灰烬','',''],['灰熊','',''],['灰狼','',''],['灰猎犬','',''],['灰獴','',''],['灰白','',''],['灰白色','',''],['灰碴','',''],['灰绿色','',''],['灰色','',''],['灰色市场','',''],['灰蒙','',''],['灰蒙蒙','',''],['灰蓝色','',''],['灰衣服','',''],['灰褐','',''],['灰褐色','',''],['灰质','',''],['灰赤杨','',''],['灰身粉骨','',''],['灰躯靡骨','',''],['灰铁','',''],['灰铸铁','',''],['灰锰氧','',''],['灰雾','',''],['灰顶','',''],['灰领','',''],['灰飞烟灭','',''],['灰鹤','',''],['灰黄','',''],['灰黄色','',''],['灰黑','',''],['灰黑花','',''],['灰鼠','',''],['灵丹','',''],['灵丹圣药','',''],['灵丹妙药','',''],['灵位','',''],['灵体','',''],['灵便','',''],['灵光','',''],['灵利','',''],['灵前','',''],['灵动','',''],['灵命','',''],['灵堂','',''],['灵塔','',''],['灵妙','',''],['灵家','',''],['灵寝','',''],['灵巧','',''],['灵床','',''],['灵异','',''],['灵快','',''],['灵性','',''],['灵怪','',''],['灵恩','',''],['灵恩派','',''],['灵感','',''],['灵效','',''],['灵敏','',''],['灵敏度','',''],['灵敏性','',''],['灵曲','',''],['灵机','',''],['灵机一动','',''],['灵杰','',''],['灵枢经','',''],['灵柩','',''],['灵柩台','',''],['灵柩车','',''],['灵棺','',''],['灵榇','',''],['灵气','',''],['灵泛','',''],['灵活','',''],['灵活多样','',''],['灵活性','',''],['灵活机动','',''],['灵活经营','',''],['灵渠','',''],['灵牌','',''],['灵牙俐齿','',''],['灵物','',''],['灵犀','',''],['灵犀一点通','',''],['灵犀相通','',''],['灵猫','',''],['灵猫类','',''],['灵界','',''],['灵的世界','',''],['灵知','',''],['灵符','',''],['灵肉','',''],['灵芝','',''],['灵药','',''],['灵蛇之珠','',''],['灵语','',''],['灵谷寺','',''],['灵车','',''],['灵透','',''],['灵通','',''],['灵长','',''],['灵长目','',''],['灵长类','',''],['灵长类动物','',''],['灵雀寺','',''],['灵验','',''],['灵魂','',''],['灵魂人物','',''],['灵魂出窍','',''],['灵魂深处','',''],['灵鸟','',''],['灶上骚除','',''],['灶具','',''],['灶匠','',''],['灶台','',''],['灶君','',''],['灶头','',''],['灶房','',''],['灶披间','',''],['灶火','',''],['灶王','',''],['灶王爷','',''],['灶眼','',''],['灶神','',''],['灶神星','',''],['灶间','',''],['灶马','',''],['灶鸡','',''],['灼伤','',''],['灼急','',''],['灼灼','',''],['灼烧','',''],['灼热','',''],['灼痛','',''],['灼背烧顶','',''],['灼艾分痛','',''],['灼见','',''],['灼见真知','',''],['灾区','',''],['灾变','',''],['灾变论','',''],['灾变说','',''],['灾后','',''],['灾后重建','',''],['灾场','',''],['灾害','',''],['灾害救济','',''],['灾害链','',''],['灾年','',''],['灾患','',''],['灾情','',''],['灾星','',''],['灾殃','',''],['灾民','',''],['灾祸','',''],['灾荒','',''],['灾难','',''],['灾难性','',''],['灾难片','',''],['灿烂','',''],['灿烂多彩','',''],['灿然','',''],['灿然一新','',''],['灿若繁星','',''],['炀金','',''],['炉上','',''],['炉丝','',''],['炉具','',''],['炉前','',''],['炉口','',''],['炉台','',''],['炉坑','',''],['炉子','',''],['炉工','',''],['炉床','',''],['炉底','',''],['炉料','',''],['炉条','',''],['炉架','',''],['炉桥','',''],['炉渣','',''],['炉温','',''],['炉火','',''],['炉火纯青','',''],['炉灰','',''],['炉灶','',''],['炉甘石','',''],['炉盘','',''],['炉窑','',''],['炉箅子','',''],['炉膛','',''],['炉衬','',''],['炉边','',''],['炉门','',''],['炉顶','',''],['炉龄','',''],['炊事','',''],['炊事员','',''],['炊事班','',''],['炊具','',''],['炊器','',''],['炊帚','',''],['炊沙作饭','',''],['炊沙镂冰','',''],['炊火','',''],['炊烟','',''],['炊臼之戚','',''],['炊臼之痛','',''],['炊金馔饭','',''],['炎亚纶','',''],['炎凉','',''],['炎凉世态','',''],['炎夏','',''],['炎帝','',''],['炎帝陵','',''],['炎性','',''],['炎性反应','',''],['炎暑','',''],['炎炎','',''],['炎热','',''],['炎症','',''],['炎黄','',''],['炎黄子孙','',''],['炒买炒卖','',''],['炒作','',''],['炒冷饭','',''],['炒勺','',''],['炒匀','',''],['炒卖','',''],['炒向','',''],['炒地皮','',''],['炒家','',''],['炒房','',''],['炒更','',''],['炒汇','',''],['炒热','',''],['炒熟','',''],['炒米','',''],['炒粉','',''],['炒股','',''],['炒股票','',''],['炒菜','',''],['炒菠菜','',''],['炒蛋','',''],['炒货','',''],['炒过','',''],['炒锅','',''],['炒青','',''],['炒面','',''],['炒饭','',''],['炒鱿鱼','',''],['炒鸡蛋','',''],['炔烃','',''],['炕上','',''],['炕下','',''],['炕去','',''],['炕头','',''],['炕席','',''],['炕床','',''],['炕桌','',''],['炕桌儿','',''],['炕沿','',''],['炕洞','',''],['炖汤','',''],['炖烂','',''],['炖煌','',''],['炖煮','',''],['炖熟','',''],['炖肉','',''],['炖菜','',''],['炖锅','',''],['炖鱼','',''],['炙冰使燥','',''],['炙凤烹龙','',''],['炙手可热','',''],['炙手而热','',''],['炙烤','',''],['炙热','',''],['炙肤皲足','',''],['炙酷','',''],['炙鸡渍酒','',''],['炫富','',''],['炫异争奇','',''],['炫昼缟夜','',''],['炫玉贾石','',''],['炫目','',''],['炫示','',''],['炫耀','',''],['炫鬻','',''],['炬者','',''],['炭刷','',''],['炭化','',''],['炭层','',''],['炭材','',''],['炭棒','',''],['炭火','',''],['炭炉','',''],['炭画','',''],['炭疽','',''],['炭疽杆菌','',''],['炭疽热','',''],['炭疽病','',''],['炭疽菌苗','',''],['炭盆','',''],['炭窑','',''],['炭笔','',''],['炭精','',''],['炭精棒','',''],['炭素','',''],['炭黑','',''],['炮仗','',''],['炮位','',''],['炮儿局','',''],['炮兵','',''],['炮兵营','',''],['炮兵连','',''],['炮凤烹龙','',''],['炮击','',''],['炮制','',''],['炮口','',''],['炮台','',''],['炮响','',''],['炮塔','',''],['炮声','',''],['炮姜','',''],['炮子儿','',''],['炮座','',''],['炮弹','',''],['炮战','',''],['炮手','',''],['炮打','',''],['炮打灯儿','',''],['炮术','',''],['炮架','',''],['炮栓','',''],['炮格','',''],['炮楼','',''],['炮火','',''],['炮火连天','',''],['炮灰','',''],['炮炼','',''],['炮烙','',''],['炮眼','',''],['炮种','',''],['炮筒','',''],['炮筒子','',''],['炮管','',''],['炮索','',''],['炮耳','',''],['炮舰','',''],['炮舰外交','',''],['炮舰政策','',''],['炮艇','',''],['炮衣','',''],['炮身','',''],['炮车','',''],['炮轰','',''],['炮钎','',''],['炮铳','',''],['炮队','',''],['炮龙烹凤','',''],['炯炯','',''],['炯炯有神','',''],['炳如日星','',''],['炳文','',''],['炳炳凿凿','',''],['炳炳麟麟','',''],['炳烛','',''],['炳烛夜游','',''],['炳焕','',''],['炳然','',''],['炳耀','',''],['炳耀千秋','',''],['炳若日星','',''],['炳著','',''],['炳蔚','',''],['炷香','',''],['炸两','',''],['炸丸子','',''],['炸伤','',''],['炸出','',''],['炸土','',''],['炸土豆条','',''],['炸土豆条儿','',''],['炸土豆片','',''],['炸坏','',''],['炸垮','',''],['炸声','',''],['炸子鸡','',''],['炸开','',''],['炸弹','',''],['炸得','',''],['炸成','',''],['炸掉','',''],['炸断','',''],['炸机','',''],['炸死','',''],['炸毁','',''],['炸油','',''],['炸油饼','',''],['炸破','',''],['炸碎','',''],['炸窝','',''],['炸糕','',''],['炸肉排','',''],['炸药','',''],['炸薯片','',''],['炸裂','',''],['炸酱','',''],['炸酱面','',''],['炸锅','',''],['炸雷','',''],['炸饼','',''],['炸鱼','',''],['炸鸡','',''],['炸鸡翅','',''],['炸鸡褪','',''],['点上','',''],['点了','',''],['点交','',''],['点亮','',''],['点人','',''],['点人数','',''],['点儿','',''],['点兵','',''],['点军','',''],['点出','',''],['点击','',''],['点击付费广告','',''],['点击数','',''],['点击率','',''],['点到为止','',''],['点到即止','',''],['点化','',''],['点半','',''],['点卯','',''],['点厾','',''],['点发','',''],['点号','',''],['点名','',''],['点名册','',''],['点名簿','',''],['点名羞辱','',''],['点唱','',''],['点在','',''],['点头','',''],['点头咂嘴','',''],['点头哈腰','',''],['点头招呼','',''],['点好','',''],['点子','',''],['点字','',''],['点字机','',''],['点定','',''],['点对点','',''],['点射','',''],['点将','',''],['点开','',''],['点心','',''],['点心坊','',''],['点戏','',''],['点拨','',''],['点描法','',''],['点播','',''],['点收','',''],['点数','',''],['点施','',''],['点明','',''],['点染','',''],['点查','',''],['点检','',''],['点歌','',''],['点水','',''],['点水不漏','',''],['点津','',''],['点清','',''],['点滴','',''],['点滴试验','',''],['点火','',''],['点火器','',''],['点火孔','',''],['点火开关','',''],['点灯','',''],['点点','',''],['点点滴滴','',''],['点烟','',''],['点烟器','',''],['点烟斗','',''],['点焊','',''],['点燃','',''],['点球','',''],['点电荷','',''],['点画','',''],['点眼','',''],['点着','',''],['点睛','',''],['点睛之笔','',''],['点石成金','',''],['点破','',''],['点票','',''],['点种','',''],['点积','',''],['点穴','',''],['点穿','',''],['点窜','',''],['点缀','',''],['点缀著','',''],['点脉','',''],['点菜','',''],['点著','',''],['点补','',''],['点见','',''],['点视','',''],['点视厅','',''],['点评','',''],['点金成铁','',''],['点金石','',''],['点钟','',''],['点钱','',''],['点铁成金','',''],['点阅','',''],['点阵','',''],['点阵字体','',''],['点阵式','',''],['点阵式打印机','',''],['点阵打印机','',''],['点集合','',''],['点面结合','',''],['点题','',''],['点饥','',''],['点验','',''],['点鬼火','',''],['炻器','',''],['炼丹','',''],['炼丹八卦炉','',''],['炼丹术','',''],['炼之未定','',''],['炼乳','',''],['炼制','',''],['炼制厂','',''],['炼化','',''],['炼厂气','',''],['炼句','',''],['炼奶','',''],['炼字','',''],['炼山','',''],['炼油','',''],['炼油厂','',''],['炼焦','',''],['炼焦炉','',''],['炼狱','',''],['炼珍','',''],['炼话','',''],['炼金','',''],['炼金术','',''],['炼金术士','',''],['炼钢','',''],['炼钢厂','',''],['炼铁','',''],['炼铁厂','',''],['炼铁炉','',''],['炽烈','',''],['炽热','',''],['炽热火山云','',''],['炽燥','',''],['炽盛','',''],['烁烁','',''],['烁石流金','',''],['烂崽','',''],['烂帐','',''],['烂成','',''],['烂掉','',''],['烂摊','',''],['烂摊子','',''],['烂死','',''],['烂污货','',''],['烂泥','',''],['烂泥浆','',''],['烂漫','',''],['烂炸','',''],['烂烂','',''],['烂熟','',''],['烂熳','',''],['烂糊','',''],['烂肠瘟','',''],['烂舌头','',''],['烂调','',''],['烂账','',''],['烂货','',''],['烂透','',''],['烂醉','',''],['烂醉如泥','',''],['烂铁','',''],['烂额焦头','',''],['烃化作用','',''],['烃类','',''],['烃蜡','',''],['烈军属','',''],['烈士','',''],['烈士墓','',''],['烈士徇名','',''],['烈士陵','',''],['烈士陵园','',''],['烈女','',''],['烈女不嫁二夫','',''],['烈女不更二夫','',''],['烈妇','',''],['烈属','',''],['烈山','',''],['烈屿','',''],['烈屿乡','',''],['烈度','',''],['烈怒','',''],['烈性','',''],['烈性酒','',''],['烈日','',''],['烈暑','',''],['烈火','',''],['烈火干柴','',''],['烈火真金','',''],['烈火见真金','',''],['烈烈轰轰','',''],['烈焰','',''],['烈节','',''],['烈酒','',''],['烈风','',''],['烈马','',''],['烈鸟','',''],['烊金','',''],['烘云托月','',''],['烘制','',''],['烘干','',''],['烘干机','',''],['烘成','',''],['烘房','',''],['烘托','',''],['烘染','',''],['烘炉','',''],['烘烘','',''],['烘烤','',''],['烘烤似','',''],['烘烤器','',''],['烘焙','',''],['烘焦','',''],['烘笼','',''],['烘笼儿','',''],['烘箱','',''],['烘篮','',''],['烘缸','',''],['烘衬','',''],['烘豆','',''],['烙刑','',''],['烙制','',''],['烙印','',''],['烙画','',''],['烙画术','',''],['烙痕','',''],['烙花','',''],['烙铁','',''],['烙饼','',''],['烛光','',''],['烛台','',''],['烛心','',''],['烛架','',''],['烛泪','',''],['烛火','',''],['烛照','',''],['烛照数计','',''],['烛花','',''],['烛蕊','',''],['烝民','',''],['烝黎','',''],['烟丝','',''],['烟云','',''],['烟云供养','',''],['烟云过眼','',''],['烟价','',''],['烟具','',''],['烟农','',''],['烟卷','',''],['烟卷儿','',''],['烟厂','',''],['烟台地区','',''],['烟叶','',''],['烟味','',''],['烟嘴','',''],['烟嘴儿','',''],['烟囱','',''],['烟圈','',''],['烟土','',''],['烟垢','',''],['烟壳','',''],['烟多','',''],['烟夜蛾','',''],['烟头','',''],['烟子','',''],['烟孔','',''],['烟尘','',''],['烟屁','',''],['烟屁股','',''],['烟岚云岫','',''],['烟幕','',''],['烟幕弹','',''],['烟径','',''],['烟感','',''],['烟斗','',''],['烟斗柄','',''],['烟枪','',''],['烟柱','',''],['烟树','',''],['烟民','',''],['烟气','',''],['烟波','',''],['烟波浩渺','',''],['烟波钓徒','',''],['烟洞','',''],['烟海','',''],['烟消云散','',''],['烟消火散','',''],['烟消雾散','',''],['烟火','',''],['烟火器材','',''],['烟火食','',''],['烟灰','',''],['烟灰缸','',''],['烟烬','',''],['烟煤','',''],['烟熏','',''],['烟熏妆','',''],['烟熏火烤','',''],['烟熏火燎','',''],['烟熏眼','',''],['烟熏着','',''],['烟瘾','',''],['烟盒','',''],['烟硷','',''],['烟碱','',''],['烟碱酸','',''],['烟突','',''],['烟筒','',''],['烟管','',''],['烟管面','',''],['烟类','',''],['烟缸','',''],['烟肉','',''],['烟膏','',''],['烟色','',''],['烟花','',''],['烟花债','',''],['烟花厂','',''],['烟花场','',''],['烟花女','',''],['烟花寨','',''],['烟花巷','',''],['烟花市','',''],['烟花柳巷','',''],['烟花簿','',''],['烟花粉柳','',''],['烟花粉黛','',''],['烟花行院','',''],['烟花阵','',''],['烟花风月','',''],['烟草','',''],['烟草商','',''],['烟蒂','',''],['烟蓑雨笠','',''],['烟薰','',''],['烟蚜','',''],['烟袋','',''],['烟袋锅','',''],['烟视媚行','',''],['烟贩','',''],['烟道','',''],['烟酒','',''],['烟酒不沾','',''],['烟酒税','',''],['烟酸','',''],['烟锅','',''],['烟雨','',''],['烟雾','',''],['烟雾剂','',''],['烟雾弥漫','',''],['烟雾症','',''],['烟雾质','',''],['烟霏雾集','',''],['烟霞','',''],['烟霞痼疾','',''],['烟霞癖','',''],['烟霭','',''],['烟霾','',''],['烟飞星散','',''],['烟飞露结','',''],['烟鬼','',''],['烤干','',''],['烤成','',''],['烤房','',''],['烤架','',''],['烤火','',''],['烤炉','',''],['烤炙','',''],['烤烟','',''],['烤焦','',''],['烤电','',''],['烤的','',''],['烤盘','',''],['烤着','',''],['烤箱','',''],['烤肉','',''],['烤肉叉','',''],['烤肉酱','',''],['烤肉馆','',''],['烤胡椒香肠','',''],['烤蓝','',''],['烤过','',''],['烤面','',''],['烤面包','',''],['烤面包机','',''],['烤饼','',''],['烤鸡','',''],['烤鸭','',''],['烦乱','',''],['烦了','',''],['烦事','',''],['烦人','',''],['烦冗','',''],['烦冤','',''],['烦劳','',''],['烦嚣','',''],['烦天恼地','',''],['烦心','',''],['烦心事','',''],['烦忧','',''],['烦恼','',''],['烦扰','',''],['烦文','',''],['烦杂','',''],['烦燥','',''],['烦琐','',''],['烦琐哲学','',''],['烦碎','',''],['烦累','',''],['烦言','',''],['烦言碎语','',''],['烦言碎辞','',''],['烦请','',''],['烦躁','',''],['烦闷','',''],['烦难','',''],['烧不尽','',''],['烧伤','',''],['烧光','',''],['烧到','',''],['烧制','',''],['烧包','',''],['烧化','',''],['烧卖','',''],['烧叉肉','',''],['烧味','',''],['烧坏','',''],['烧埋','',''],['烧夷弹','',''],['烧完','',''],['烧尽','',''],['烧屋','',''],['烧干','',''],['烧开','',''],['烧开水','',''],['烧录','',''],['烧得','',''],['烧心','',''],['烧心壶','',''],['烧成','',''],['烧成灰','',''],['烧成炭','',''],['烧掉','',''],['烧料','',''],['烧断','',''],['烧杯','',''],['烧死','',''],['烧毁','',''],['烧毛','',''],['烧水','',''],['烧水壶','',''],['烧沸','',''],['烧油','',''],['烧火','',''],['烧灼','',''],['烧灼伤','',''],['烧灼感','',''],['烧灼疼','',''],['烧炉','',''],['烧炭','',''],['烧烤','',''],['烧烤酱','',''],['烧烧','',''],['烧热','',''],['烧焊','',''],['烧焦','',''],['烧煤','',''],['烧煮','',''],['烧熟','',''],['烧猪','',''],['烧瓶','',''],['烧瓷','',''],['烧用','',''],['烧眉之急','',''],['烧着','',''],['烧砖','',''],['烧硬','',''],['烧碱','',''],['烧窑','',''],['烧红','',''],['烧纸','',''],['烧结','',''],['烧结矿','',''],['烧肉','',''],['烧腊','',''],['烧茄子','',''],['烧茶','',''],['烧荒','',''],['烧菜','',''],['烧蓝','',''],['烧蚀','',''],['烧蚀体','',''],['烧起来','',''],['烧过','',''],['烧进','',''],['烧酒','',''],['烧锅','',''],['烧饭','',''],['烧饼','',''],['烧香','',''],['烧香拜佛','',''],['烧高香','',''],['烧鱼','',''],['烧鸡','',''],['烧麦','',''],['烧黑','',''],['烩面','',''],['烩饭','',''],['烫了','',''],['烫伤','',''],['烫发','',''],['烫头发','',''],['烫平','',''],['烫得','',''],['烫手','',''],['烫手山芋','',''],['烫死','',''],['烫洗','',''],['烫花','',''],['烫蜡','',''],['烫衣','',''],['烫衣服','',''],['烫衣板','',''],['烫酒','',''],['烫金','',''],['烫面','',''],['热中','',''],['热中子','',''],['热中者','',''],['热乎','',''],['热乎乎','',''],['热乎劲','',''],['热交换','',''],['热传导','',''],['热值','',''],['热光','',''],['热函','',''],['热分解','',''],['热切','',''],['热制','',''],['热制导','',''],['热剌剌','',''],['热力','',''],['热力学','',''],['热力学温度','',''],['热力学温标','',''],['热功当量','',''],['热加工','',''],['热动平衡','',''],['热劲','',''],['热化','',''],['热化学','',''],['热卖','',''],['热卖品','',''],['热压','',''],['热压釜','',''],['热合','',''],['热吻','',''],['热呼','',''],['热呼呼','',''],['热和','',''],['热固性','',''],['热土','',''],['热地蚰蜓','',''],['热塑性','',''],['热处理','',''],['热天','',''],['热孝','',''],['热季','',''],['热学','',''],['热定型','',''],['热容','',''],['热容量','',''],['热对流','',''],['热导','',''],['热导率','',''],['热射病','',''],['热尔韦','',''],['热岛','',''],['热岛效应','',''],['热带','',''],['热带地区','',''],['热带病','',''],['热带雨林','',''],['热带风暴','',''],['热带鱼','',''],['热干面','',''],['热度','',''],['热得','',''],['热得快','',''],['热心','',''],['热心人','',''],['热心家','',''],['热心者','',''],['热心肠','',''],['热忱','',''],['热念','',''],['热恋','',''],['热情','',''],['热情关注','',''],['热情周到','',''],['热情接待','',''],['热情款待','',''],['热情洋溢','',''],['热意','',''],['热感','',''],['热成层','',''],['热战','',''],['热打','',''],['热捧','',''],['热插拔','',''],['热敏','',''],['热敏性','',''],['热敏电阻','',''],['热敷','',''],['热昏','',''],['热月政变','',''],['热望','',''],['热机','',''],['热材料','',''],['热核','',''],['热核反应','',''],['热核反应堆','',''],['热核武器','',''],['热核聚变反应','',''],['热比亚','',''],['热比亚・卡德尔','',''],['热比娅','',''],['热比娅・卡德尔','',''],['热毯','',''],['热气','',''],['热气球','',''],['热气腾腾','',''],['热水','',''],['热水器','',''],['热水澡','',''],['热水瓶','',''],['热水袋','',''],['热污染','',''],['热汤','',''],['热汽','',''],['热河','',''],['热法','',''],['热泪','',''],['热泪盈眶','',''],['热泵','',''],['热流','',''],['热浪','',''],['热浴','',''],['热涨','',''],['热源','',''],['热潮','',''],['热火','',''],['热火朝天','',''],['热炉','',''],['热炒','',''],['热炒热卖','',''],['热点','',''],['热烈','',''],['热烘烘','',''],['热烫','',''],['热热闹闹','',''],['热焓','',''],['热熬翻饼','',''],['热爱','',''],['热爱者','',''],['热狗','',''],['热电','',''],['热电偶','',''],['热电厂','',''],['热电堆','',''],['热电子','',''],['热电效应','',''],['热电站','',''],['热病','',''],['热症','',''],['热痉挛','',''],['热磁','',''],['热离','',''],['热离子','',''],['热管','',''],['热线','',''],['热线电话','',''],['热络','',''],['热罨','',''],['热肠','',''],['热胀','',''],['热能','',''],['热脆','',''],['热脆性','',''],['热脉冲','',''],['热腾腾','',''],['热膨胀','',''],['热茶','',''],['热药','',''],['热薄饼','',''],['热血','',''],['热血沸腾','',''],['热补','',''],['热衷','',''],['热衷于','',''],['热衷者','',''],['热被','',''],['热裤','',''],['热解','',''],['热认','',''],['热议','',''],['热讽','',''],['热诚','',''],['热身','',''],['热身赛','',''],['热轧','',''],['热载体','',''],['热辐射','',''],['热辣辣','',''],['热过','',''],['热运动','',''],['热连球菌','',''],['热那亚','',''],['热量','',''],['热量单位','',''],['热量计','',''],['热钢','',''],['热钱','',''],['热销','',''],['热锅上的蚂蚁','',''],['热锅上蚂蚁','',''],['热键','',''],['热镀','',''],['热门','',''],['热门货','',''],['热闹','',''],['热障','',''],['热风','',''],['热食','',''],['热饮','',''],['热香饼','',''],['烯烃','',''],['烯类','',''],['烷基','',''],['烷基苯','',''],['烷基苯磺酸钠','',''],['烷氧基','',''],['烷烃','',''],['烹具','',''],['烹制','',''],['烹煮','',''],['烹犬藏弓','',''],['烹茶','',''],['烹调','',''],['烹调学','',''],['烹调术','',''],['烹调法','',''],['烹饪','',''],['烹饪学','',''],['烹饪法','',''],['烹龙炮凤','',''],['烽火','',''],['烽火台','',''],['烽火四起','',''],['烽火连天','',''],['烽烟','',''],['烽烟四起','',''],['烽烟遍地','',''],['烽燧','',''],['焉得','',''],['焉得虎子','',''],['焉敢','',''],['焉有','',''],['焉用','',''],['焉知','',''],['焉耆','',''],['焉耆县','',''],['焉耆盆地','',''],['焉能','',''],['焊丝','',''],['焊剂','',''],['焊口','',''],['焊合','',''],['焊头','',''],['焊工','',''],['焊接','',''],['焊接工','',''],['焊料','',''],['焊机','',''],['焊条','',''],['焊枪','',''],['焊牢','',''],['焊管','',''],['焊缝','',''],['焊药','',''],['焊补','',''],['焊钳','',''],['焊锡','',''],['焌油','',''],['焌黑','',''],['焕发','',''],['焕然','',''],['焕然一新','',''],['焕然冰释','',''],['焕若冰释','',''],['焖烧','',''],['焖烧锅','',''],['焖饭','',''],['焗油','',''],['焙干','',''],['焙烤','',''],['焙烧','',''],['焙煎','',''],['焙粉','',''],['焚书','',''],['焚书坑儒','',''],['焚化','',''],['焚化炉','',''],['焚如之祸','',''],['焚尸','',''],['焚尸扬灰','',''],['焚尸炉','',''],['焚林之求','',''],['焚林而田','',''],['焚林而畋','',''],['焚毁','',''],['焚烧','',''],['焚琴煮鹤','',''],['焚砚','',''],['焚膏继晷','',''],['焚舟破釜','',''],['焚芝锄蕙','',''],['焚身','',''],['焚风','',''],['焚香','',''],['焚香敬神','',''],['焚香顶礼','',''],['焚骨扬灰','',''],['焢肉','',''],['焦化','',''],['焦噪','',''],['焦土','',''],['焦头烂额','',''],['焦干','',''],['焦心','',''],['焦心劳思','',''],['焦急','',''],['焦成','',''],['焦木','',''],['焦枯','',''],['焦比','',''],['焦沙烂石','',''],['焦油','',''],['焦渴','',''],['焦灼','',''],['焦炉','',''],['焦炙','',''],['焦炭','',''],['焦点','',''],['焦热电','',''],['焦焦','',''],['焦煤','',''],['焦熬投石','',''],['焦燥','',''],['焦痕','',''],['焦碳','',''],['焦糖','',''],['焦糖舞','',''],['焦耳','',''],['焦虑','',''],['焦虑不安','',''],['焦虑症','',''],['焦距','',''],['焦躁','',''],['焦金流石','',''],['焦雷','',''],['焦饭','',''],['焦黄','',''],['焦黑','',''],['焰口','',''],['焰心','',''],['焰火','',''],['焰状','',''],['然也','',''],['然则','',''],['然后','',''],['然糠照薪','',''],['然而','',''],['然诺','',''],['然顷','',''],['煅成末','',''],['煅炉','',''],['煅炼','',''],['煅烧','',''],['煅石灰','',''],['煅石膏','',''],['煊赫','',''],['煌煌','',''],['煌煌巨著','',''],['煌熠','',''],['煎作','',''],['煎成','',''],['煎水作冰','',''],['煎炒','',''],['煎炸','',''],['煎炸油','',''],['煎炸食品','',''],['煎煮','',''],['煎熬','',''],['煎牛扒','',''],['煎猪扒','',''],['煎膏炊骨','',''],['煎药','',''],['煎蛋','',''],['煎蛋卷','',''],['煎蛋饼','',''],['煎铲','',''],['煎锅','',''],['煎饺','',''],['煎饼','',''],['煎鱼','',''],['煜煜','',''],['煜熠','',''],['煞住','',''],['煞尾','',''],['煞废心机','',''],['煞性子','',''],['煞星','',''],['煞是','',''],['煞有介事','',''],['煞气','',''],['煞气腾腾','',''],['煞没','',''],['煞白','',''],['煞神','',''],['煞笔','',''],['煞账','',''],['煞费','',''],['煞费心机','',''],['煞费苦心','',''],['煞车','',''],['煞风景','',''],['煤井','',''],['煤仓','',''],['煤价','',''],['煤储量','',''],['煤化','',''],['煤区','',''],['煤厂','',''],['煤坑','',''],['煤块','',''],['煤堆','',''],['煤夫','',''],['煤尘','',''],['煤层','',''],['煤层气','',''],['煤屑','',''],['煤库','',''],['煤斗','',''],['煤斤','',''],['煤核','',''],['煤核儿','',''],['煤毒','',''],['煤气','',''],['煤气化','',''],['煤气灯','',''],['煤气灶','',''],['煤气炉','',''],['煤气罐','',''],['煤气表','',''],['煤油','',''],['煤渣','',''],['煤火','',''],['煤灰','',''],['煤炉','',''],['煤炭','',''],['煤炭工业','',''],['煤烟','',''],['煤焦油','',''],['煤球','',''],['煤田','',''],['煤矸石','',''],['煤矿','',''],['煤矿主','',''],['煤矿内','',''],['煤矿工人','',''],['煤砖','',''],['煤砟子','',''],['煤窑','',''],['煤箱','',''],['煤粉灰','',''],['煤精','',''],['煤系','',''],['煤耗','',''],['煤船','',''],['煤质','',''],['煤车','',''],['煤都','',''],['煤量名','',''],['煤饼','',''],['煤黑','',''],['煤黑油','',''],['煦仁孑义','',''],['煦日','',''],['煦暖','',''],['煦煦','',''],['照临','',''],['照亮','',''],['照人','',''],['照付','',''],['照价','',''],['照会','',''],['照作不误','',''],['照例','',''],['照做','',''],['照像','',''],['照像机','',''],['照光','',''],['照公理','',''],['照准','',''],['照出','',''],['照到','',''],['照办','',''],['照功行赏','',''],['照单全收','',''],['照原样','',''],['照发','',''],['照墙','',''],['照壁','',''],['照妖镜','',''],['照实','',''],['照射','',''],['照常','',''],['照应','',''],['照度','',''],['照度计','',''],['照录','',''],['照征','',''],['照得','',''],['照惯例','',''],['照抄','',''],['照护','',''],['照拂','',''],['照提','',''],['照搬','',''],['照收','',''],['照数','',''],['照料','',''],['照旧','',''],['照明','',''],['照明弹','',''],['照明灯','',''],['照明者','',''],['照映','',''],['照本宣科','',''],['照材','',''],['照样','',''],['照此','',''],['照灯','',''],['照照','',''],['照片','',''],['照片儿','',''],['照片子','',''],['照片底版','',''],['照物','',''],['照猫画虎','',''],['照理','',''],['照用','',''],['照登','',''],['照直','',''],['照相','',''],['照相侦察','',''],['照相制版','',''],['照相师','',''],['照相机','',''],['照相版','',''],['照相簿','',''],['照相纸','',''],['照相馆','',''],['照看','',''],['照眼','',''],['照着','',''],['照章','',''],['照章办事','',''],['照管','',''],['照约定','',''],['照纳','',''],['照缴','',''],['照耀','',''],['照老','',''],['照萤映雪','',''],['照著','',''],['照葫芦画瓢','',''],['照见','',''],['照记','',''],['照说','',''],['照镜','',''],['照镜子','',''],['照面','',''],['照面儿','',''],['照顾','',''],['照领','',''],['煨干就湿','',''],['煨干避湿','',''],['煮出','',''],['煮好','',''],['煮干','',''],['煮开','',''],['煮得','',''],['煮成','',''],['煮掉','',''],['煮沸','',''],['煮法','',''],['煮滚','',''],['煮烂','',''],['煮热','',''],['煮熟','',''],['煮硬','',''],['煮粥焚须','',''],['煮肉','',''],['煮菜','',''],['煮蛋','',''],['煮蛋计时器','',''],['煮豆燃萁','',''],['煮过','',''],['煮酒','',''],['煮锅','',''],['煮饭','',''],['煮鹤焚琴','',''],['煸炒','',''],['煽动','',''],['煽动性','',''],['煽动者','',''],['煽动颠覆国家政权','',''],['煽动颠覆国家罪','',''],['煽情','',''],['煽惑','',''],['煽扇人','',''],['煽火','',''],['煽诱','',''],['煽起','',''],['煽阴风','',''],['煽风','',''],['煽风点火','',''],['熄火','',''],['熄灭','',''],['熄灭了','',''],['熄灯','',''],['熊一样','',''],['熊倪','',''],['熊包','',''],['熊市','',''],['熊心豹胆','',''],['熊成基','',''],['熊掌','',''],['熊本','',''],['熊本县','',''],['熊本市','',''],['熊熊','',''],['熊熊大火','',''],['熊熊燃烧','',''],['熊狸','',''],['熊猫','',''],['熊猫眼','',''],['熊猴','',''],['熊皮','',''],['熊皮帽','',''],['熊瞎子','',''],['熊类','',''],['熊经鸟申','',''],['熊经鸱颈','',''],['熊罢之祥','',''],['熊罴','',''],['熊罴之士','',''],['熊耳山','',''],['熊胆','',''],['熊胆草','',''],['熊腰虎背','',''],['熊虎之士','',''],['熊蜂','',''],['熏制','',''],['熏制厂','',''],['熏制者','',''],['熏天','',''],['熏天吓地','',''],['熏得','',''],['熏心','',''],['熏染','',''],['熏沐','',''],['熏烤','',''],['熏着','',''],['熏肉','',''],['熏腐之余','',''],['熏蒸','',''],['熏蒸剂','',''],['熏衣草','',''],['熏陶','',''],['熏陶成性','',''],['熏风','',''],['熏风徐来','',''],['熏香','',''],['熏黑','',''],['熏黑了','',''],['熔丝','',''],['熔为','',''],['熔剂','',''],['熔化','',''],['熔化点','',''],['熔合','',''],['熔岩','',''],['熔岩山','',''],['熔岩流','',''],['熔岩湖','',''],['熔岩穹丘','',''],['熔岩高原','',''],['熔接','',''],['熔断','',''],['熔断器','',''],['熔毁','',''],['熔浆','',''],['熔渣','',''],['熔炉','',''],['熔点','',''],['熔炼','',''],['熔焊','',''],['熔矿炉','',''],['熔胶锅','',''],['熔融','',''],['熔融岩浆','',''],['熔解','',''],['熔解热','',''],['熔铸','',''],['熙壤','',''],['熙提','',''],['熙攘','',''],['熙春茶','',''],['熙来攘往','',''],['熙熙','',''],['熙熙壤壤','',''],['熙熙攘攘','',''],['熙熙融融','',''],['熟丝','',''],['熟习','',''],['熟了','',''],['熟人','',''],['熟人熟事','',''],['熟制','',''],['熟化','',''],['熟友','',''],['熟啤酒','',''],['熟土','',''],['熟地','',''],['熟女','',''],['熟字','',''],['熟客','',''],['熟年','',''],['熟念','',''],['熟思','',''],['熟悉','',''],['熟成','',''],['熟手','',''],['熟料','',''],['熟无熟手','',''],['熟橡胶','',''],['熟烂','',''],['熟烫','',''],['熟睡','',''],['熟知','',''],['熟石灰','',''],['熟石膏','',''],['熟稔','',''],['熟练','',''],['熟练工人','',''],['熟练者','',''],['熟肉','',''],['熟能无惑','',''],['熟能生巧','',''],['熟荒','',''],['熟菜','',''],['熟落','',''],['熟虑','',''],['熟蚕','',''],['熟视','',''],['熟视无睹','',''],['熟记','',''],['熟识','',''],['熟语','',''],['熟请','',''],['熟读','',''],['熟谙','',''],['熟路','',''],['熟路轻车','',''],['熟路轻辙','',''],['熟透','',''],['熟道','',''],['熟道儿','',''],['熟铁','',''],['熟铜','',''],['熟门熟路','',''],['熟食','',''],['熟食店','',''],['熟饭','',''],['熠烁','',''],['熠煜','',''],['熠熠','',''],['熠耀','',''],['熨帖','',''],['熨平','',''],['熨斗','',''],['熨法','',''],['熨烫','',''],['熨衣','',''],['熨袖架','',''],['熬出','',''],['熬到','',''],['熬夜','',''],['熬头儿','',''],['熬心','',''],['熬成','',''],['熬更守夜','',''],['熬汁','',''],['熬汤','',''],['熬炼','',''],['熬煎','',''],['熬煮','',''],['熬熬','',''],['熬磨','',''],['熬稃','',''],['熬粥','',''],['熬膏','',''],['熬药','',''],['熬过','',''],['熵值','',''],['熹平石经','',''],['熹微','',''],['燃放','',''],['燃放鞭炮','',''],['燃料','',''],['燃料元件细棒','',''],['燃料库','',''],['燃料循环','',''],['燃料油','',''],['燃料电池','',''],['燃料组合','',''],['燃料舱','',''],['燃料芯块','',''],['燃木','',''],['燃松读书','',''],['燃气','',''],['燃气电厂','',''],['燃气轮机','',''],['燃油','',''],['燃油舱','',''],['燃灯佛','',''],['燃点','',''],['燃烧','',''],['燃烧剂','',''],['燃烧器','',''],['燃烧室','',''],['燃烧弹','',''],['燃烧武器','',''],['燃烧瓶','',''],['燃烧着','',''],['燃煤','',''],['燃煤锅炉','',''],['燃爆','',''],['燃物','',''],['燃犀温峤','',''],['燃用价值','',''],['燃眉','',''],['燃眉之急','',''],['燃着','',''],['燃糠自照','',''],['燃素','',''],['燃素说','',''],['燃耗','',''],['燃膏继晷','',''],['燃起','',''],['燃香','',''],['燎原','',''],['燎原之火','',''],['燎泡','',''],['燔书坑儒','',''],['燕京','',''],['燕京啤酒','',''],['燕京大学','',''],['燕京酒','',''],['燕侣莺俦','',''],['燕俦莺侣','',''],['燕儿','',''],['燕北','',''],['燕啄皇孙','',''],['燕国','',''],['燕太子丹','',''],['燕好','',''],['燕妒莺惭','',''],['燕婉之欢','',''],['燕子','',''],['燕子衔泥垒大窝','',''],['燕安鸩毒','',''],['燕尔新婚','',''],['燕尾','',''],['燕尾旗','',''],['燕尾服','',''],['燕尾状','',''],['燕尾蝶','',''],['燕山','',''],['燕山山脉','',''],['燕巢','',''],['燕巢乡','',''],['燕巢于幕','',''],['燕瘦环肥','',''],['燕科','',''],['燕窝','',''],['燕粥','',''],['燕约莺期','',''],['燕舞','',''],['燕舞莺啼','',''],['燕语','',''],['燕语莺呼','',''],['燕语莺啼','',''],['燕语莺声','',''],['燕赵','',''],['燕赵都市报','',''],['燕足系诗','',''],['燕隼','',''],['燕雀','',''],['燕雀乌鹊','',''],['燕雀处堂','',''],['燕雀处屋','',''],['燕雀安知鸿鹄之志','',''],['燕雀焉知鸿鹄之志','',''],['燕雀相贺','',''],['燕雁代飞','',''],['燕颔虎头','',''],['燕颔虎须','',''],['燕颔虎颈','',''],['燕鱼','',''],['燕麦','',''],['燕麦片','',''],['燕麦粥','',''],['燠热','',''],['燥热','',''],['燥者','',''],['燧人','',''],['燧人氏','',''],['燧发','',''],['燧石','',''],['燧石质','',''],['燮友','',''],['燮和','',''],['燮和之任','',''],['燮理','',''],['燮理阴阳','',''],['爆乳','',''],['爆了','',''],['爆光','',''],['爆内幕','',''],['爆冷','',''],['爆冷门','',''],['爆冷门儿','',''],['爆出','',''],['爆发','',''],['爆发力','',''],['爆发性','',''],['爆发户','',''],['爆发星','',''],['爆发音','',''],['爆响','',''],['爆声','',''],['爆开','',''],['爆弹','',''],['爆料','',''],['爆机','',''],['爆棚','',''],['爆气','',''],['爆满','',''],['爆炒','',''],['爆炸','',''],['爆炸事件','',''],['爆炸力','',''],['爆炸力学','',''],['爆炸动力学','',''],['爆炸声','',''],['爆炸性','',''],['爆炸波','',''],['爆炸物','',''],['爆炸的无效弹','',''],['爆燃','',''],['爆燥如雷','',''],['爆玉米花','',''],['爆破','',''],['爆破作业','',''],['爆破器材','',''],['爆破手','',''],['爆破筒','',''],['爆竹','',''],['爆笑','',''],['爆管','',''],['爆米花','',''],['爆缩型核武器','',''],['爆肚','',''],['爆肚儿','',''],['爆胎','',''],['爆舱','',''],['爆花','',''],['爆表','',''],['爆裂','',''],['爆裂声','',''],['爆裂物','',''],['爆雷','',''],['爆震','',''],['爆音','',''],['爆鸣','',''],['爪儿','',''],['爪印','',''],['爪哇','',''],['爪哇人','',''],['爪哇岛','',''],['爪哇语','',''],['爪子','',''],['爪尖儿','',''],['爪牙','',''],['爪牙之士','',''],['爪牙之将','',''],['爪甲','',''],['爪痕','',''],['爪蟾','',''],['爬上','',''],['爬下','',''],['爬出','',''],['爬到','',''],['爬动','',''],['爬升','',''],['爬坡','',''],['爬墙','',''],['爬山','',''],['爬山涉水','',''],['爬山者','',''],['爬山虎','',''],['爬岩','',''],['爬岩术','',''],['爬得','',''],['爬树','',''],['爬格子','',''],['爬梳剔抉','',''],['爬泳','',''],['爬满','',''],['爬灰','',''],['爬犁','',''],['爬着','',''],['爬着走','',''],['爬竿','',''],['爬绳','',''],['爬网','',''],['爬罗剔抉','',''],['爬耳搔腮','',''],['爬藤','',''],['爬虫','',''],['爬虫动物','',''],['爬虫类','',''],['爬行','',''],['爬行动物','',''],['爬行类','',''],['爬行者','',''],['爬过','',''],['爬进','',''],['爬高','',''],['爱丁堡','',''],['爱上','',''],['爱不忍释','',''],['爱不释手','',''],['爱与','',''],['爱丽丝','',''],['爱丽丝漫游奇境记','',''],['爱丽思泉','',''],['爱丽舍宫','',''],['爱之如命','',''],['爱乐','',''],['爱乐乐团','',''],['爱书','',''],['爱交','',''],['爱人','',''],['爱人儿','',''],['爱人好士','',''],['爱人如己','',''],['爱人民','',''],['爱他','',''],['爱伦','',''],['爱侣','',''],['爱假','',''],['爱偷','',''],['爱克斯光','',''],['爱克斯射线','',''],['爱写','',''],['爱动','',''],['爱劳动','',''],['爱卫会','',''],['爱卿','',''],['爱厂如家','',''],['爱吃','',''],['爱听','',''],['爱哭','',''],['爱喝','',''],['爱因斯坦','',''],['爱国','',''],['爱国主义','',''],['爱国卫生运动委员会','',''],['爱国如家','',''],['爱国心','',''],['爱国活动','',''],['爱国精神','',''],['爱国者','',''],['爱在','',''],['爱奥华','',''],['爱奥华州','',''],['爱奥尼亚海','',''],['爱女','',''],['爱奴','',''],['爱好','',''],['爱好和平','',''],['爱好者','',''],['爱妻','',''],['爱妾','',''],['爱子','',''],['爱学习','',''],['爱宠','',''],['爱富嫌贫','',''],['爱将','',''],['爱小','',''],['爱尔兰人','',''],['爱尔兰共和军','',''],['爱尔兰共和国','',''],['爱尔兰海','',''],['爱尔兰语','',''],['爱屋及乌','',''],['爱屋及鸟','',''],['爱岗','',''],['爱岗敬业','',''],['爱州','',''],['爱巢','',''],['爱幻想','',''],['爱德','',''],['爱德华','',''],['爱德华・达拉第','',''],['爱德华兹','',''],['爱德华岛','',''],['爱德华王子岛','',''],['爱德斯沃尔','',''],['爱德玲','',''],['爱心','',''],['爱怜','',''],['爱恋','',''],['爱恨','',''],['爱悦','',''],['爱情','',''],['爱情喜剧','',''],['爱情征服一切','',''],['爱情片','',''],['爱惜','',''],['爱惜羽毛','',''],['爱意','',''],['爱慕','',''],['爱憎','',''],['爱憎分明','',''],['爱戴','',''],['爱才','',''],['爱才好士','',''],['爱才如命','',''],['爱才若渴','',''],['爱把','',''],['爱抚','',''],['爱护','',''],['爱护公共财物','',''],['爱提','',''],['爱搭','',''],['爱斯基摩','',''],['爱斯基摩人','',''],['爱新觉罗','',''],['爱日惜力','',''],['爱昵','',''],['爱晚亭','',''],['爱染','',''],['爱毛反裘','',''],['爱民','',''],['爱民如子','',''],['爱民模范','',''],['爱河','',''],['爱游玩','',''],['爱滋','',''],['爱滋病','',''],['爱滋病毒','',''],['爱漂亮','',''],['爱物','',''],['爱犬','',''],['爱玉子','',''],['爱玛','',''],['爱玛・沃特森','',''],['爱玩','',''],['爱现','',''],['爱理不理','',''],['爱琴','',''],['爱琴文化','',''],['爱琴海','',''],['爱用','',''],['爱留根纳','',''],['爱畜','',''],['爱看','',''],['爱睡','',''],['爱知','',''],['爱知县','',''],['爱祖国','',''],['爱神','',''],['爱科学','',''],['爱称','',''],['爱窝窝','',''],['爱立信','',''],['爱笑','',''],['爱答不理','',''],['爱管','',''],['爱管闲事','',''],['爱美','',''],['爱美的','',''],['爱老虎你','',''],['爱耍','',''],['爱能移山','',''],['爱荷华','',''],['爱莉丝','',''],['爱莫之助','',''],['爱莫利维尔','',''],['爱莫大于心死','',''],['爱莫能助','',''],['爱讲','',''],['爱词霸','',''],['爱说爱笑','',''],['爱读','',''],['爱谈','',''],['爱财','',''],['爱财如命','',''],['爱起','',''],['爱辉','',''],['爱达荷','',''],['爱达荷州','',''],['爱远恶近','',''],['爱迪生','',''],['爱钱如命','',''],['爱问','',''],['爱面子','',''],['爱鸟','',''],['爱鹤失众','',''],['爵位','',''],['爵士','',''],['爵士乐','',''],['爵士舞','',''],['爵士音乐','',''],['爵禄','',''],['父严子孝','',''],['父为子隐','',''],['父亲','',''],['父兄','',''],['父名','',''],['父命','',''],['父女','',''],['父子','',''],['父慈子孝','',''],['父执','',''],['父执辈','',''],['父方','',''],['父本','',''],['父权','',''],['父权制','',''],['父析子荷','',''],['父母','',''],['父母之命媒妁之言','',''],['父母之邦','',''],['父母亲','',''],['父母双亡','',''],['父母在不远游','',''],['父母官','',''],['父母恩勤','',''],['父爱','',''],['父王','',''],['父称','',''],['父系','',''],['父系大家族','',''],['父老','',''],['父老兄弟','',''],['父辈','',''],['父道','',''],['爷们','',''],['爷们儿','',''],['爷儿','',''],['爷儿们','',''],['爷子','',''],['爷孙','',''],['爷爷','',''],['爷羹娘饭','',''],['爷门','',''],['爷饭娘羹','',''],['爸妈','',''],['爸爸','',''],['爹地','',''],['爹妈','',''],['爹娘','',''],['爹爹','',''],['爽亮','',''],['爽健','',''],['爽利','',''],['爽口','',''],['爽呆了','',''],['爽地','',''],['爽当','',''],['爽心悦目','',''],['爽心美食','',''],['爽心豁目','',''],['爽快','',''],['爽性','',''],['爽意','',''],['爽捷','',''],['爽朗','',''],['爽歪歪','',''],['爽死我了','',''],['爽气','',''],['爽然','',''],['爽然自失','',''],['爽然若失','',''],['爽爽快快','',''],['爽畅','',''],['爽目','',''],['爽直','',''],['爽约','',''],['爽肤水','',''],['爽脆','',''],['爽言','',''],['爽身粉','',''],['片上','',''],['片中','',''],['片云','',''],['片云遮顶','',''],['片假名','',''],['片儿','',''],['片儿会','',''],['片儿汤','',''],['片儿警','',''],['片刻','',''],['片刻前','',''],['片剂','',''],['片名','',''],['片善小才','',''],['片头','',''],['片子','',''],['片尾','',''],['片岩','',''],['片形','',''],['片接寸附','',''],['片断','',''],['片时','',''],['片栏','',''],['片段','',''],['片片','',''],['片状','',''],['片瓦','',''],['片瓦无存','',''],['片甲','',''],['片甲不回','',''],['片甲不存','',''],['片甲不留','',''],['片甲无存','',''],['片目','',''],['片簿','',''],['片约','',''],['片纸','',''],['片纸只字','',''],['片艳纸','',''],['片言','',''],['片言一字','',''],['片言只字','',''],['片言只语','',''],['片言折狱','',''],['片语','',''],['片语只辞','',''],['片酬','',''],['片长','',''],['片长末技','',''],['片长薄技','',''],['片集','',''],['片面','',''],['片面强调','',''],['片面性','',''],['片鳞半爪','',''],['片鳞碎甲','',''],['片麻岩','',''],['版主','',''],['版位','',''],['版刻','',''],['版口','',''],['版图','',''],['版块','',''],['版工','',''],['版式','',''],['版彩','',''],['版心','',''],['版本','',''],['版术','',''],['版权','',''],['版权所有','',''],['版权页','',''],['版材','',''],['版次','',''],['版照','',''],['版版六十四','',''],['版物','',''],['版画','',''],['版税','',''],['版筑','',''],['版筑饭牛','',''],['版纳','',''],['版色','',''],['版面','',''],['牌价','',''],['牌位','',''],['牌匾','',''],['牌号','',''],['牌名','',''],['牌品','',''],['牌坊','',''],['牌子','',''],['牌子曲','',''],['牌局','',''],['牌戏','',''],['牌桌','',''],['牌楼','',''],['牌照','',''],['牌示','',''],['牌种','',''],['牌赌','',''],['牒谱','',''],['牖中窥日','',''],['牙买加人','',''],['牙买加胡椒','',''],['牙人','',''],['牙侩','',''],['牙关','',''],['牙冠','',''],['牙刷','',''],['牙医','',''],['牙印','',''],['牙口','',''],['牙周炎','',''],['牙周病','',''],['牙商','',''],['牙垢','',''],['牙城','',''],['牙外','',''],['牙套','',''],['牙婆','',''],['牙子','',''],['牙床','',''],['牙座','',''],['牙慧','',''],['牙本质','',''],['牙机巧制','',''],['牙根','',''],['牙桥','',''],['牙椅','',''],['牙牌','',''],['牙牙','',''],['牙牙学语','',''],['牙班','',''],['牙疳','',''],['牙疼','',''],['牙痛','',''],['牙白','',''],['牙白口清','',''],['牙石','',''],['牙碜','',''],['牙祭','',''],['牙科','',''],['牙科医生','',''],['牙筷','',''],['牙签','',''],['牙签万轴','',''],['牙签犀轴','',''],['牙签玉轴','',''],['牙签锦轴','',''],['牙粉','',''],['牙线','',''],['牙线棒','',''],['牙缝','',''],['牙缝儿','',''],['牙膏','',''],['牙色','',''],['牙花','',''],['牙菌斑','',''],['牙虫','',''],['牙行','',''],['牙质','',''],['牙轮','',''],['牙釉质','',''],['牙雕','',''],['牙音','',''],['牙饰','',''],['牙髓','',''],['牙鲆','',''],['牙齿','',''],['牙龈','',''],['牙龈炎','',''],['牛之一毛','',''],['牛乳','',''],['牛仔','',''],['牛仔帽','',''],['牛仔衫','',''],['牛仔裤','',''],['牛刀','',''],['牛刀割鸡','',''],['牛刀小试','',''],['牛劲','',''],['牛叫','',''],['牛头','',''],['牛头㹴','',''],['牛头不对马嘴','',''],['牛头不对马面','',''],['牛头刨','',''],['牛头梗','',''],['牛头犬','',''],['牛头马面','',''],['牛奶','',''],['牛奶场','',''],['牛奶等','',''],['牛奶糖','',''],['牛奶酒','',''],['牛娃','',''],['牛尾','',''],['牛屄','',''],['牛屎','',''],['牛山濯濯','',''],['牛崽裤','',''],['牛市','',''],['牛年','',''],['牛年马月','',''],['牛性','',''],['牛扒','',''],['牛排','',''],['牛排餐厅','',''],['牛排馆','',''],['牛柳','',''],['牛栏','',''],['牛桥','',''],['牛棚','',''],['牛樟','',''],['牛比','',''],['牛毛','',''],['牛毛细雨','',''],['牛毛雨','',''],['牛气','',''],['牛油','',''],['牛油戟','',''],['牛油果','',''],['牛津','',''],['牛津城','',''],['牛津大学','',''],['牛津群','',''],['牛海绵状脑病','',''],['牛溲马勃','',''],['牛犊','',''],['牛犊子','',''],['牛痘','',''],['牛痘病','',''],['牛痘苗','',''],['牛瘟','',''],['牛百叶','',''],['牛皮','',''],['牛皮癣','',''],['牛皮纸','',''],['牛皮色','',''],['牛皮菜','',''],['牛眼','',''],['牛磺酸','',''],['牛筋','',''],['牛粪','',''],['牛羊','',''],['牛群','',''],['牛耳','',''],['牛肉','',''],['牛肉丸','',''],['牛肉干','',''],['牛肉汁','',''],['牛肉面','',''],['牛肺','',''],['牛肺疫','',''],['牛脂','',''],['牛脊肉','',''],['牛脖','',''],['牛脖子','',''],['牛脾气','',''],['牛腩','',''],['牛腿','',''],['牛膝','',''],['牛膝草','',''],['牛至','',''],['牛舌','',''],['牛舌草','',''],['牛舍','',''],['牛蒡','',''],['牛虻','',''],['牛蛙','',''],['牛蝇','',''],['牛衣对泣','',''],['牛角','',''],['牛角包','',''],['牛角尖','',''],['牛角挂书','',''],['牛角椒','',''],['牛角面包','',''],['牛蹄中鱼','',''],['牛车','',''],['牛轧糖','',''],['牛轭湖','',''],['牛逼','',''],['牛郎','',''],['牛郎星','',''],['牛郎织女','',''],['牛鞅','',''],['牛鞭','',''],['牛顿','',''],['牛顿力学','',''],['牛顿运动定律','',''],['牛饩退敌','',''],['牛饮','',''],['牛马','',''],['牛骥共牢','',''],['牛骥同槽','',''],['牛骥同皂','',''],['牛鬼','',''],['牛鬼蛇神','',''],['牛魔王','',''],['牛鸣声','',''],['牛黄','',''],['牛黄上清丸','',''],['牛黄清心丸','',''],['牛鼎烹鸡','',''],['牛鼻','',''],['牛鼻子','',''],['牝牡','',''],['牝牡骊黄','',''],['牝马','',''],['牝鸡司晨','',''],['牝鸡无晨','',''],['牝鸡晨鸣','',''],['牝鸡牡鸣','',''],['牟利','',''],['牟取','',''],['牟取暴利','',''],['牟平','',''],['牡丹','',''],['牡丹乡','',''],['牡丹亭','',''],['牡丹卡','',''],['牡丹坊','',''],['牡丹江地区','',''],['牡丹虽好','',''],['牡牛','',''],['牡羊座','',''],['牡蛎','',''],['牡鹿','',''],['牢不可拔','',''],['牢不可破','',''],['牢固','',''],['牢房','',''],['牢牢','',''],['牢狱','',''],['牢稳','',''],['牢笼','',''],['牢系','',''],['牢记','',''],['牢里','',''],['牢门','',''],['牢靠','',''],['牢靠妥当','',''],['牢骚','',''],['牤牛','',''],['牦牛','',''],['牧业','',''],['牧主','',''],['牧人','',''],['牧养','',''],['牧区','',''],['牧厂','',''],['牧圉','',''],['牧地','',''],['牧场','',''],['牧夫座','',''],['牧女','',''],['牧奴','',''],['牧工','',''],['牧师','',''],['牧师之职','',''],['牧师会','',''],['牧放','',''],['牧歌','',''],['牧民','',''],['牧活','',''],['牧渔','',''],['牧牛','',''],['牧牛者','',''],['牧犬','',''],['牧猪奴戏','',''],['牧畜','',''],['牧神','',''],['牧神午后','',''],['牧神节','',''],['牧童','',''],['牧笛','',''],['牧羊','',''],['牧羊人','',''],['牧羊场','',''],['牧羊女','',''],['牧羊犬','',''],['牧羊者','',''],['牧群','',''],['牧草','',''],['牧草地','',''],['牧豕听经','',''],['牧郎','',''],['牧野','',''],['牧马','',''],['牧马人','',''],['牧马者','',''],['物不平则鸣','',''],['物业','',''],['物业税','',''],['物业管理','',''],['物中','',''],['物主','',''],['物主代词','',''],['物主限定词','',''],['物事','',''],['物产','',''],['物仓','',''],['物以稀为贵','',''],['物以类聚','',''],['物件','',''],['物价','',''],['物价上涨','',''],['物价局','',''],['物价工作','',''],['物价指数','',''],['物价改革','',''],['物价政策','',''],['物价检查','',''],['物价管理','',''],['物价补贴','',''],['物伤其类','',''],['物体','',''],['物候','',''],['物候学','',''],['物力','',''],['物力维艰','',''],['物化','',''],['物化劳动','',''],['物华天宝','',''],['物博','',''],['物各有主','',''],['物品','',''],['物堆','',''],['物尽其用','',''],['物建','',''],['物归原主','',''],['物归旧主','',''],['物态','',''],['物性','',''],['物情','',''],['物换星移','',''],['物探','',''],['物故','',''],['物料','',''],['物联','',''],['物联网','',''],['物是人非','',''],['物极则衰','',''],['物极必反','',''],['物架','',''],['物欲','',''],['物欲世界','',''],['物流','',''],['物流管理','',''],['物物','',''],['物物交换','',''],['物理','',''],['物理上','',''],['物理光学','',''],['物理力学','',''],['物理化学','',''],['物理变化','',''],['物理学','',''],['物理学家','',''],['物理层','',''],['物理性质','',''],['物理疗法','',''],['物理结构','',''],['物理诊断','',''],['物理量','',''],['物盛则衰','',''],['物离乡贵','',''],['物种','',''],['物种学','',''],['物种起源','',''],['物竞天择','',''],['物类','',''],['物美','',''],['物美价廉','',''],['物耗','',''],['物腐虫生','',''],['物自体','',''],['物至则反','',''],['物色','',''],['物议','',''],['物议沸腾','',''],['物论沸腾','',''],['物证','',''],['物语','',''],['物诱','',''],['物象','',''],['物质','',''],['物质不灭定律','',''],['物质享受','',''],['物质性','',''],['物质损耗','',''],['物质文明','',''],['物质文明和精神文明','',''],['物质财富','',''],['物资','',''],['物资供应','',''],['物资储备','',''],['物资局','',''],['物资部','',''],['物镜','',''],['物阜民安','',''],['物阜民熙','',''],['物面','',''],['牯牛','',''],['牲口','',''],['牲品','',''],['牲畜','',''],['牲畜粪','',''],['牲粉','',''],['牴牾','',''],['牴触','',''],['牵一发而动全身','',''],['牵伸','',''],['牵住','',''],['牵入','',''],['牵制','',''],['牵制性','',''],['牵力','',''],['牵动','',''],['牵合附会','',''],['牵头','',''],['牵就','',''],['牵带','',''],['牵引','',''],['牵引力','',''],['牵引器','',''],['牵引机','',''],['牵引车','',''],['牵引量','',''],['牵强','',''],['牵强附会','',''],['牵心','',''],['牵心挂肠','',''],['牵念','',''],['牵手','',''],['牵扯','',''],['牵扶','',''],['牵拌','',''],['牵挂','',''],['牵掣','',''],['牵涉','',''],['牵涉到','',''],['牵涉面','',''],['牵牛','',''],['牵牛属','',''],['牵牛星','',''],['牵牛花','',''],['牵着鼻子走','',''],['牵累','',''],['牵线','',''],['牵线人','',''],['牵线搭桥','',''],['牵绊','',''],['牵绳','',''],['牵缠','',''],['牵羊','',''],['牵羊担酒','',''],['牵肠割肚','',''],['牵肠挂肚','',''],['牵萝补屋','',''],['牵记','',''],['牵起','',''],['牵车','',''],['牵连','',''],['牵马到河易','',''],['牸牛','',''],['牸马','',''],['特为','',''],['特书','',''],['特产','',''],['特价','',''],['特价品','',''],['特价菜','',''],['特任','',''],['特优','',''],['特作','',''],['特使','',''],['特例','',''],['特克斯市','',''],['特克斯河','',''],['特免','',''],['特内里费','',''],['特写','',''],['特准','',''],['特出','',''],['特刊','',''],['特利','',''],['特别','',''],['特别严重','',''],['特别代办','',''],['特别任务连','',''],['特别会议','',''],['特别奖','',''],['特别客串','',''],['特别室','',''],['特别小','',''],['特别强调','',''],['特别待遇','',''],['特别感谢','',''],['特别护理','',''],['特别提款权','',''],['特别是','',''],['特别法','',''],['特别法庭','',''],['特别行政区','',''],['特别高','',''],['特制','',''],['特制品','',''],['特务','',''],['特勤','',''],['特化','',''],['特区','',''],['特区建设','',''],['特卖','',''],['特卫强','',''],['特发症','',''],['特古西加尔巴','',''],['特向','',''],['特告','',''],['特命','',''],['特命全权大使','',''],['特困户','',''],['特地','',''],['特备','',''],['特大','',''],['特大号','',''],['特奖','',''],['特奥会','',''],['特好','',''],['特嫌','',''],['特定','',''],['特定场合','',''],['特定条件','',''],['特将','',''],['特小','',''],['特屈儿','',''],['特工','',''],['特座','',''],['特异','',''],['特异功能','',''],['特异性','',''],['特异质','',''],['特异选择','',''],['特强','',''],['特征','',''],['特征值','',''],['特征向量','',''],['特征群','',''],['特征联合','',''],['特忧','',''],['特快','',''],['特快专递','',''],['特快车','',''],['特快邮递','',''],['特急','',''],['特性','',''],['特怪','',''],['特惠','',''],['特惠关税','',''],['特惠金','',''],['特意','',''],['特批','',''],['特技','',''],['特技摄影','',''],['特技演员','',''],['特技跳伞','',''],['特护','',''],['特护区','',''],['特拉华','',''],['特拉华州','',''],['特拉华河','',''],['特拉法加广场','',''],['特拉法尔加','',''],['特拉法尔加广场','',''],['特拉维夫','',''],['特指','',''],['特提斯海','',''],['特效','',''],['特效药','',''],['特敏福','',''],['特斯拉','',''],['特易购','',''],['特有','',''],['特权','',''],['特权阶级','',''],['特来','',''],['特案','',''],['特此','',''],['特此证明','',''],['特此通知','',''],['特殊','',''],['特殊任务','',''],['特殊作用','',''],['特殊关系','',''],['特殊函数','',''],['特殊化','',''],['特殊性','',''],['特殊情况下','',''],['特殊护理','',''],['特殊政策','',''],['特殊教育','',''],['特殊符号','',''],['特殊要求','',''],['特殊规律','',''],['特殊需要','',''],['特洛伊','',''],['特洛伊木马','',''],['特派','',''],['特派员','',''],['特混','',''],['特点','',''],['特烦','',''],['特瓦族','',''],['特用','',''],['特瘦','',''],['特种','',''],['特种兵','',''],['特种工艺','',''],['特种战争','',''],['特种空勤团','',''],['特种营业','',''],['特种警察','',''],['特种部队','',''],['特称','',''],['特稿','',''],['特立尼达','',''],['特立独行','',''],['特等','',''],['特等功','',''],['特等奖','',''],['特约','',''],['特约记者','',''],['特级','',''],['特组','',''],['特罗多斯','',''],['特聘','',''],['特舱','',''],['特色','',''],['特解','',''],['特警','',''],['特计','',''],['特许','',''],['特许半导体','',''],['特许状','',''],['特许经营','',''],['特许证','',''],['特设','',''],['特调','',''],['特谈','',''],['特质','',''],['特赦','',''],['特起','',''],['特载','',''],['特辑','',''],['特选','',''],['特逗','',''],['特遣','',''],['特遣队','',''],['特邀','',''],['特邀代表','',''],['特郡','',''],['特里普拉','',''],['特错','',''],['特长','',''],['特集','',''],['特雷沃','',''],['特雷莎','',''],['特需','',''],['特项经费','',''],['特首','',''],['特鲁埃尔','',''],['牺牲','',''],['牺牲品','',''],['牺牲打','',''],['牺牲者','',''],['牺牲节','',''],['犀利','',''],['犀牛','',''],['犀牛望月','',''],['犀甲','',''],['犀皮','',''],['犀角','',''],['犀鸟','',''],['犀黄丸','',''],['犁地','',''],['犁壁','',''],['犁头','',''],['犁庭扫穴','',''],['犁庭扫闾','',''],['犁杖','',''],['犁沟','',''],['犁牛','',''],['犁田','',''],['犁耕','',''],['犁铧','',''],['犁镜','',''],['犁靬','',''],['犁骨','',''],['犂靬','',''],['犄角','',''],['犄角之势','',''],['犄角旮旯','',''],['犊子','',''],['犊牛','',''],['犍牛','',''],['犍陀罗','',''],['犎牛','',''],['犏牛','',''],['犒劳','',''],['犒赏','',''],['犟劲','',''],['犟劲儿','',''],['犪牛','',''],['犬不夜吠','',''],['犬儒','',''],['犬儒主义','',''],['犬兔俱毙','',''],['犬吠','',''],['犬吠之警','',''],['犬嗅觉','',''],['犬声','',''],['犬夜叉','',''],['犬戎','',''],['犬敲门砖','',''],['犬牙','',''],['犬牙交错','',''],['犬牙差互','',''],['犬牙盘石','',''],['犬牙相临','',''],['犬牙相制','',''],['犬牙鹰爪','',''],['犬种','',''],['犬科','',''],['犬马','',''],['犬马之养','',''],['犬马之劳','',''],['犬马之命','',''],['犬马之年','',''],['犬马之心','',''],['犬马之恋','',''],['犬马之报','',''],['犬马之疾','',''],['犬马之计','',''],['犬马之诚','',''],['犬马之齿','',''],['犬马恋主','',''],['犬马齿劳','',''],['犬马齿索','',''],['犬齿','',''],['犯上','',''],['犯上作乱','',''],['犯下','',''],['犯不上','',''],['犯不着','',''],['犯不著','',''],['犯了','',''],['犯了罪','',''],['犯事','',''],['犯人','',''],['犯做','',''],['犯傻','',''],['犯劲','',''],['犯嘴','',''],['犯境','',''],['犯夜','',''],['犯大错','',''],['犯天下之大不韪','',''],['犯得上','',''],['犯得着','',''],['犯忌','',''],['犯愁','',''],['犯意','',''],['犯戒','',''],['犯有','',''],['犯有前科','',''],['犯杀','',''],['犯案','',''],['犯毒','',''],['犯法','',''],['犯法者','',''],['犯浑','',''],['犯疑','',''],['犯病','',''],['犯禁','',''],['犯罪','',''],['犯罪分子','',''],['犯罪团伙','',''],['犯罪学','',''],['犯罪率','',''],['犯罪现场','',''],['犯罪者','',''],['犯罪行为','',''],['犯罪集团','',''],['犯者','',''],['犯而不校','',''],['犯而务校','',''],['犯节气','',''],['犯规','',''],['犯贫','',''],['犯过者','',''],['犯错','',''],['犯错误','',''],['犯难','',''],['犯颜','',''],['犯颜极谏','',''],['犯颜苦谏','',''],['犰狳','',''],['状元','',''],['状况','',''],['状告','',''],['状声词','',''],['状好','',''],['状子','',''],['状小','',''],['状态','',''],['状物','',''],['状纸','',''],['状胆','',''],['状词','',''],['状语','',''],['状貌','',''],['犷悍','',''],['犹之乎','',''],['犹他','',''],['犹他州','',''],['犹可','',''],['犹在','',''],['犹大','',''],['犹大书','',''],['犹太','',''],['犹太人','',''],['犹太会堂','',''],['犹太历','',''],['犹太史','',''],['犹太复国主义','',''],['犹太复国主义者','',''],['犹太教','',''],['犹太教堂','',''],['犹太法典','',''],['犹如','',''],['犹存','',''],['犹斗','',''],['犹新','',''],['犹未为晚','',''],['犹热','',''],['犹犹豫豫','',''],['犹疑','',''],['犹自','',''],['犹若','',''],['犹言','',''],['犹豫','',''],['犹豫不决','',''],['犹豫不前','',''],['犹豫不定','',''],['犹豫未决','',''],['犹达','',''],['犹达斯','',''],['犹鱼得水','',''],['狂三诈四','',''],['狂乐乱舞','',''],['狂乱','',''],['狂人','',''],['狂人日记','',''],['狂似','',''],['狂信','',''],['狂信者','',''],['狂傲','',''],['狂叫','',''],['狂吟老监','',''],['狂吠','',''],['狂吹','',''],['狂吼','',''],['狂呼','',''],['狂啸','',''],['狂喜','',''],['狂夸','',''],['狂奔','',''],['狂女','',''],['狂奴故态','',''],['狂妄','',''],['狂妄自大','',''],['狂徒','',''],['狂态','',''],['狂怒','',''],['狂恋','',''],['狂恣','',''],['狂想','',''],['狂想曲','',''],['狂战士','',''],['狂放','',''],['狂文','',''],['狂暴','',''],['狂暴者','',''],['狂欢','',''],['狂欢的','',''],['狂欢节','',''],['狂歌','',''],['狂气','',''],['狂涛巨浪','',''],['狂涛骇浪','',''],['狂涨','',''],['狂满','',''],['狂潮','',''],['狂澜','',''],['狂烈','',''],['狂热','',''],['狂热家','',''],['狂热者','',''],['狂牛病','',''],['狂犬','',''],['狂犬病','',''],['狂甩','',''],['狂病人','',''],['狂笑','',''],['狂者','',''],['狂花病叶','',''],['狂草','',''],['狂蜂浪蝶','',''],['狂袭','',''],['狂言','',''],['狂诗','',''],['狂话','',''],['狂说','',''],['狂跌','',''],['狂跑','',''],['狂跳','',''],['狂躁','',''],['狂轰','',''],['狂轰滥炸','',''],['狂野','',''],['狂闹','',''],['狂顶','',''],['狂风','',''],['狂风暴雨','',''],['狂风沙','',''],['狂风骤雨','',''],['狂飙','',''],['狂飙运动','',''],['狂饮','',''],['狂饮暴食','',''],['狄仁杰','',''],['狄俄倪索斯','',''],['狄公案','',''],['狄塞耳机','',''],['狄奥多','',''],['狄奥多・阿多诺','',''],['狄拉克','',''],['狄更斯','',''],['狍子','',''],['狎妓','',''],['狎妓冶游','',''],['狎客','',''],['狎弄','',''],['狎昵','',''],['狐仙','',''],['狐假虎威','',''],['狐假鸱张','',''],['狐兔之悲','',''],['狐凭鼠伏','',''],['狐奔鼠窜','',''],['狐女','',''],['狐媚','',''],['狐媚猿攀','',''],['狐媚魇道','',''],['狐性','',''],['狐朋狗党','',''],['狐朋狗友','',''],['狐步','',''],['狐步舞','',''],['狐死兔泣','',''],['狐死首丘','',''],['狐潜鼠伏','',''],['狐狸','',''],['狐狸似','',''],['狐狸尾巴','',''],['狐狸座','',''],['狐狸精','',''],['狐猴','',''],['狐獴','',''],['狐疑','',''],['狐疑未决','',''],['狐穴','',''],['狐精','',''],['狐群狗党','',''],['狐肷','',''],['狐臊','',''],['狐臭','',''],['狐藉虎威','',''],['狐虎之威','',''],['狐蝠','',''],['狐裘','',''],['狐裘羔袖','',''],['狐裘蒙戎','',''],['狐裘蒙茸','',''],['狐裘龙茸','',''],['狐鬼神仙','',''],['狐鸣狗盗','',''],['狐鸣鱼书','',''],['狐鼠之徒','',''],['狒狒','',''],['狗崽子','',''],['狗交媾般','',''],['狗仔式','',''],['狗仔队','',''],['狗仗人势','',''],['狗仗官势','',''],['狗似','',''],['狗偷鼠窃','',''],['狗党','',''],['狗党狐群','',''],['狗刨','',''],['狗口里吐不出象牙','',''],['狗叫','',''],['狗吃屎','',''],['狗吠','',''],['狗吠之警','',''],['狗吠声','',''],['狗吠非主','',''],['狗命','',''],['狗咬吕洞宾','',''],['狗咬狗','',''],['狗嘴里吐不出象牙','',''],['狗头','',''],['狗头军师','',''],['狗娘养的','',''],['狗宝','',''],['狗尾续貂','',''],['狗尾草','',''],['狗尿苔','',''],['狗屁','',''],['狗屁不通','',''],['狗屋','',''],['狗屎','',''],['狗屎堆','',''],['狗屎运','',''],['狗年','',''],['狗彘不若','',''],['狗彘不食','',''],['狗急跳墙','',''],['狗拳','',''],['狗拿耗子','',''],['狗改不了吃屎','',''],['狗日','',''],['狗日的粮食','',''],['狗橇','',''],['狗洞','',''],['狗熊','',''],['狗爬式','',''],['狗獾','',''],['狗玩儿的','',''],['狗男女','',''],['狗皮','',''],['狗皮膏药','',''],['狗盗鸡鸣','',''],['狗盗鼠窃','',''],['狗秀','',''],['狗窝','',''],['狗窦','',''],['狗窦大开','',''],['狗粮','',''],['狗续貂尾','',''],['狗群','',''],['狗肉','',''],['狗肺狼心','',''],['狗胆','',''],['狗胆包天','',''],['狗腿','',''],['狗腿子','',''],['狗苟蝇营','',''],['狗蚤','',''],['狗蝇','',''],['狗血','',''],['狗血喷头','',''],['狗血淋头','',''],['狗行狼心','',''],['狗豆子','',''],['狗贼','',''],['狗追耗子','',''],['狗逮老鼠','',''],['狗颠屁股','',''],['狗食','',''],['狗食袋','',''],['狗马之心','',''],['狗马声色','',''],['狗鱼','',''],['狗鹫','',''],['狙击','',''],['狙击兵','',''],['狙击手','',''],['狙刺','',''],['狞恶可怖','',''],['狞猛性','',''],['狞猫','',''],['狞笑','',''],['狠刹','',''],['狠劲','',''],['狠命','',''],['狠巴巴','',''],['狠心','',''],['狠心肠','',''],['狠愎自用','',''],['狠打','',''],['狠抓','',''],['狠拱','',''],['狠揍','',''],['狠毒','',''],['狠治','',''],['狠狠','',''],['狡免三窟','',''],['狡兔','',''],['狡兔三穴','',''],['狡兔三窟','',''],['狡兔死良犬烹','',''],['狡兔死良狗烹','',''],['狡涛作浪','',''],['狡滑','',''],['狡狯','',''],['狡猾','',''],['狡计','',''],['狡诈','',''],['狡谲','',''],['狡赖','',''],['狡辩','',''],['狡黠','',''],['狩猎','',''],['独一','',''],['独一无二','',''],['独个','',''],['独个儿','',''],['独二代','',''],['独享','',''],['独人秀','',''],['独体','',''],['独体字','',''],['独具','',''],['独具一格','',''],['独具匠心','',''],['独出一时','',''],['独出心裁','',''],['独创','',''],['独创力','',''],['独创性','',''],['独到','',''],['独到之处','',''],['独力','',''],['独占','',''],['独占者','',''],['独占资本','',''],['独占鳌头','',''],['独占鼇头','',''],['独吞','',''],['独唱','',''],['独唱会','',''],['独善其身','',''],['独在异乡为异客','',''],['独坐','',''],['独块','',''],['独处','',''],['独夫','',''],['独夫民贼','',''],['独奏','',''],['独奏曲','',''],['独奏者','',''],['独子','',''],['独孤','',''],['独孤求败','',''],['独学寡闻','',''],['独守空房','',''],['独家','',''],['独家生产','',''],['独家经营','',''],['独尊','',''],['独尊儒术','',''],['独居','',''],['独居石','',''],['独属','',''],['独山子','',''],['独岛','',''],['独幕','',''],['独幕剧','',''],['独当一面','',''],['独往','',''],['独往独来','',''],['独得','',''],['独揽','',''],['独揽市场','',''],['独擅胜场','',''],['独放异彩','',''],['独断','',''],['独断专行','',''],['独断家','',''],['独断独行','',''],['独有','',''],['独木不成林','',''],['独木不林','',''],['独木桥','',''],['独木舟','',''],['独木难支','',''],['独来独往','',''],['独栋','',''],['独树一帜','',''],['独桅','',''],['独桅艇','',''],['独此一家别无分号','',''],['独步','',''],['独特','',''],['独独','',''],['独生','',''],['独生女','',''],['独生子','',''],['独生子女','',''],['独生子女政策','',''],['独白','',''],['独白者','',''],['独眼','',''],['独眼龙','',''],['独秀','',''],['独立','',''],['独立不群','',''],['独立中文笔会','',''],['独立国','',''],['独立国家联合体','',''],['独立宣言','',''],['独立市','',''],['独立性','',''],['独立战争','',''],['独立报','',''],['独立核算','',''],['独立王国','',''],['独立者','',''],['独立自主','',''],['独立选民','',''],['独立钻石','',''],['独立门户','',''],['独缺','',''],['独联体','',''],['独胆','',''],['独胆英雄','',''],['独脚','',''],['独脚戏','',''],['独脚架','',''],['独腿','',''],['独自','',''],['独自一人','',''],['独舞','',''],['独苗','',''],['独行','',''],['独行侠','',''],['独行其是','',''],['独行其道','',''],['独行独断','',''],['独裁','',''],['独裁官','',''],['独裁政府','',''],['独裁政治','',''],['独裁权','',''],['独裁统治','',''],['独裁者','',''],['独角兽','',''],['独角戏','',''],['独角鲸','',''],['独词句','',''],['独语','',''],['独语句','',''],['独语者','',''],['独资','',''],['独资企业','',''],['独赢','',''],['独身','',''],['独身主义','',''],['独身者','',''],['独轮','',''],['独轮车','',''],['独辟蹊径','',''],['独酌','',''],['独门儿','',''],['独门独户','',''],['独院','',''],['独院儿','',''],['独霸','',''],['独霸一方','',''],['独领风骚','',''],['独饮','',''],['独龙','',''],['独龙江','',''],['狭义','',''],['狭义相对论','',''],['狭小','',''],['狭尖','',''],['狭巷','',''],['狭带','',''],['狭径','',''],['狭心症','',''],['狭槽','',''],['狭窄','',''],['狭缝','',''],['狭航道','',''],['狭谷','',''],['狭路','',''],['狭路相逢','',''],['狭轨','',''],['狭道','',''],['狭量','',''],['狭长','',''],['狭隘','',''],['狮位素餐','',''],['狮吼','',''],['狮城','',''],['狮头石竹','',''],['狮头鹅','',''],['狮子','',''],['狮子乡','',''],['狮子头','',''],['狮子山','',''],['狮子座','',''],['狮子搏兔亦用全力','',''],['狮子林园','',''],['狮子狗','',''],['狮子舞','',''],['狮子般','',''],['狮子鼻','',''],['狮尾狒','',''],['狮心王理查','',''],['狮泉河','',''],['狮潭','',''],['狮潭乡','',''],['狮王','',''],['狮禄素餐','',''],['狮虎兽','',''],['狮身','',''],['狮身人面像','',''],['狰狞','',''],['狰狞面目','',''],['狱中','',''],['狱卒','',''],['狱吏','',''],['狱官','',''],['狱室','',''],['狱长','',''],['狱门','',''],['狴犴','',''],['狷介','',''],['狷急','',''],['狸子','',''],['狸猫','',''],['狸藻','',''],['狸鼠','',''],['狺狺','',''],['狻猊','',''],['狼井','',''],['狼人','',''],['狼号鬼哭','',''],['狼叼','',''],['狼吞虎咽','',''],['狼吞虎噬','',''],['狼嗥','',''],['狼嚎','',''],['狼嚎鬼哭','',''],['狼图腾','',''],['狼多肉少','',''],['狼头','',''],['狼奔豕突','',''],['狼奔鼠窜','',''],['狼子兽心','',''],['狼子野心','',''],['狼孩','',''],['狼尾草','',''],['狼山鸡','',''],['狼崽','',''],['狼心狗肺','',''],['狼心狗行','',''],['狼毒','',''],['狼毫','',''],['狼烟','',''],['狼烟四起','',''],['狼牙','',''],['狼牙棒','',''],['狼犬','',''],['狼狈','',''],['狼狈不堪','',''],['狼狈为奸','',''],['狼狗','',''],['狼猛蜂毒','',''],['狼獾','',''],['狼疮','',''],['狼疮性','',''],['狼皮','',''],['狼群','',''],['狼般','',''],['狼藉','',''],['狼蛛','',''],['狼蜘','',''],['狼贪鼠窃','',''],['狼顾','',''],['狼顾狐疑','',''],['狼飧虎咽','',''],['狼餐虎咽','',''],['猃狁','',''],['猇亭','',''],['猎人','',''],['猎兔','',''],['猎兔狗','',''],['猎刀','',''],['猎到','',''],['猎区','',''],['猎取','',''],['猎场','',''],['猎头','',''],['猎头人','',''],['猎奇','',''],['猎户','',''],['猎户座','',''],['猎户座大星云','',''],['猎户臂','',''],['猎手','',''],['猎捕','',''],['猎杀','',''],['猎杀红色十月号','',''],['猎枪','',''],['猎潜','',''],['猎潜艇','',''],['猎物','',''],['猎犬','',''],['猎犬座','',''],['猎狗','',''],['猎猎','',''],['猎艳','',''],['猎获','',''],['猎装','',''],['猎豹','',''],['猎隼','',''],['猎食','',''],['猎鸟','',''],['猎鸟者','',''],['猎鹰','',''],['猎鹿','',''],['猕狲入布袋','',''],['猕猴','',''],['猕猴桃','',''],['猕猴骑土牛','',''],['猖乱','',''],['猖厉','',''],['猖披','',''],['猖狂','',''],['猖猖狂狂','',''],['猖獗','',''],['猗猗','',''],['猛一看','',''],['猛丁','',''],['猛不防','',''],['猛乍','',''],['猛使','',''],['猛兽','',''],['猛冲','',''],['猛冲者','',''],['猛击','',''],['猛击一掌','',''],['猛刺','',''],['猛力','',''],['猛劲','',''],['猛劲儿','',''],['猛升','',''],['猛可','',''],['猛吃','',''],['猛吸','',''],['猛咬','',''],['猛地','',''],['猛增','',''],['猛士','',''],['猛夺','',''],['猛子','',''],['猛孤丁地','',''],['猛射','',''],['猛将','',''],['猛干','',''],['猛性','',''],['猛戳','',''],['猛扑','',''],['猛打','',''],['猛扭','',''],['猛抓','',''],['猛抛','',''],['猛抬','',''],['猛拉','',''],['猛拍','',''],['猛拐','',''],['猛拽','',''],['猛按','',''],['猛推','',''],['猛掷','',''],['猛揍','',''],['猛摆','',''],['猛撞','',''],['猛攻','',''],['猛敲','',''],['猛料','',''],['猛汉','',''],['猛涨','',''],['猛火','',''],['猛炸','',''],['猛烈','',''],['猛然','',''],['猛然间','',''],['猛犬','',''],['猛犸','',''],['猛犸象','',''],['猛省','',''],['猛砍','',''],['猛禽','',''],['猛落','',''],['猛虎','',''],['猛袭','',''],['猛跌','',''],['猛身','',''],['猛进','',''],['猛追','',''],['猛酒','',''],['猛醒','',''],['猛降','',''],['猛龙怪客','',''],['猜不透','',''],['猜中','',''],['猜出','',''],['猜到','',''],['猜奖','',''],['猜嫌','',''],['猜对','',''],['猜度','',''],['猜得对','',''],['猜得透','',''],['猜忌','',''],['猜忍','',''],['猜想','',''],['猜拳','',''],['猜拳行令','',''],['猜枚','',''],['猜测','',''],['猜游戏','',''],['猜猜','',''],['猜疑','',''],['猜谜','',''],['猜谜儿','',''],['猜错','',''],['猝倒','',''],['猝发','',''],['猝死','',''],['猝然','',''],['猝病','',''],['猞猁','',''],['猢狲','',''],['猥亵','',''],['猥亵性暴露','',''],['猥劣','',''],['猥獕','',''],['猥琐','',''],['猥词','',''],['猥辞','',''],['猥陋','',''],['猥集','',''],['猩猩','',''],['猩猩草','',''],['猩红','',''],['猩红热','',''],['猩红色','',''],['猪一样','',''],['猪一般','',''],['猪下水','',''],['猪仔','',''],['猪仔包','',''],['猪仔馆','',''],['猪似','',''],['猪倌','',''],['猪儿','',''],['猪八戒','',''],['猪叫','',''],['猪嘴','',''],['猪囊虫病','',''],['猪圈','',''],['猪场','',''],['猪头','',''],['猪婆龙','',''],['猪尾','',''],['猪尾巴','',''],['猪屎','',''],['猪崽','',''],['猪崽儿','',''],['猪年','',''],['猪悟能','',''],['猪扒','',''],['猪拱菌','',''],['猪排','',''],['猪柳','',''],['猪栏','',''],['猪水泡病','',''],['猪油','',''],['猪油果','',''],['猪油状','',''],['猪流感','',''],['猪流感病毒','',''],['猪湾','',''],['猪狗','',''],['猪狗不如','',''],['猪猡','',''],['猪獾','',''],['猪瘟','',''],['猪皮','',''],['猪窠','',''],['猪笼草','',''],['猪类','',''],['猪群','',''],['猪耳','',''],['猪肉','',''],['猪肉饼','',''],['猪肚','',''],['猪肝','',''],['猪肺','',''],['猪脚','',''],['猪腰','',''],['猪腿肉','',''],['猪舌','',''],['猪舍','',''],['猪般','',''],['猪苓','',''],['猪苗','',''],['猪血','',''],['猪蹄','',''],['猪链球菌','',''],['猪链球菌病','',''],['猪革','',''],['猪食','',''],['猪鬃','',''],['猪鼻','',''],['猫儿','',''],['猫儿山','',''],['猫儿眼','',''],['猫匿','',''],['猫叫','',''],['猫叫声','',''],['猫咪','',''],['猫哭老鼠','',''],['猫哭耗子','',''],['猫声','',''],['猫声鸟','',''],['猫头鹰','',''],['猫尾草','',''],['猫属','',''],['猫沙','',''],['猫熊','',''],['猫爪','',''],['猫王','',''],['猫皮','',''],['猫眼','',''],['猫眼儿','',''],['猫眼石','',''],['猫睛石','',''],['猫科','',''],['猫耳','',''],['猫耳洞','',''],['猫腰','',''],['猫腻','',''],['猫雾族','',''],['猫鱼','',''],['猫鼠同眠','',''],['猫鼠游戏','',''],['猫鼬','',''],['献上','',''],['献丑','',''],['献于','',''],['献佛','',''],['献出','',''],['献可替不','',''],['献可替否','',''],['献呈','',''],['献媚','',''],['献宝','',''],['献技','',''],['献捐','',''],['献旗','',''],['献智','',''],['献替可否','',''],['献歌','',''],['献殷勤','',''],['献疑','',''],['献礼','',''],['献祭','',''],['献策','',''],['献纳','',''],['献给','',''],['献者','',''],['献艺','',''],['献花','',''],['献血','',''],['献血者','',''],['献血证','',''],['献言','',''],['献计','',''],['献计献策','',''],['献词','',''],['献诗','',''],['献身','',''],['献身四化','',''],['献身精神','',''],['献身者','',''],['献辞','',''],['献酒','',''],['献金','',''],['猳国','',''],['猴儿','',''],['猴儿精','',''],['猴头','',''],['猴头菇','',''],['猴头鹰','',''],['猴子','',''],['猴孩子','',''],['猴年','',''],['猴年马月','',''],['猴急','',''],['猴戏','',''],['猴拳','',''],['猴王','',''],['猴痘病毒','',''],['猴皮筋儿','',''],['猴类','',''],['猴精','',''],['猴面包','',''],['猴面包树','',''],['猸子','',''],['猿人','',''],['猿叶虫','',''],['猿声','',''],['猿猴','',''],['猿玃','',''],['猿类','',''],['猿鹤虫沙','',''],['獐头鼠目','',''],['獐头鼠脑','',''],['獐子','',''],['獒犬','',''],['獠牙','',''],['獬豸','',''],['獭皮','',''],['獭祭','',''],['獯鬻','',''],['獴科','',''],['獾油','',''],['玃猿','',''],['玄之又玄','',''],['玄乎','',''],['玄关','',''],['玄关妙理','',''],['玄参','',''],['玄圃','',''],['玄圃积玉','',''],['玄奘','',''],['玄奥','',''],['玄妙','',''],['玄妙入神','',''],['玄妙无穷','',''],['玄妙莫测','',''],['玄孙','',''],['玄学','',''],['玄学家','',''],['玄想','',''],['玄教','',''],['玄明粉','',''],['玄机','',''],['玄机妙算','',''],['玄武','',''],['玄武岩','',''],['玄武质熔岩','',''],['玄武门之变','',''],['玄狐','',''],['玄理','',''],['玄疑','',''],['玄石','',''],['玄秘','',''],['玄秘主义','',''],['玄米茶','',''],['玄菟郡','',''],['玄虚','',''],['玄谋庙算','',''],['玄远','',''],['玄青','',''],['玄黄翻覆','',''],['率以为常','',''],['率先','',''],['率兵','',''],['率兽食人','',''],['率土之滨','',''],['率土同庆','',''],['率土宅心','',''],['率土归心','',''],['率尔','',''],['率尔成章','',''],['率尔操觚','',''],['率师','',''],['率性任意','',''],['率然','',''],['率由卓章','',''],['率由旧则','',''],['率由旧章','',''],['率直','',''],['率真','',''],['率部','',''],['率队','',''],['率领','',''],['率马以骥','',''],['玉井','',''],['玉井乡','',''],['玉人','',''],['玉人吹箫','',''],['玉体','',''],['玉佛','',''],['玉佩','',''],['玉兔','',''],['玉兔东升','',''],['玉兰','',''],['玉兰片','',''],['玉兰花','',''],['玉减香消','',''],['玉制','',''],['玉卮无当','',''],['玉友金昆','',''],['玉叶','',''],['玉叶金枝','',''],['玉叶金柯','',''],['玉器','',''],['玉堂金门','',''],['玉堂金马','',''],['玉壶','',''],['玉夫座','',''],['玉女','',''],['玉宇','',''],['玉宇琼楼','',''],['玉尺量才','',''],['玉屏','',''],['玉屏县','',''],['玉山倾倒','',''],['玉山倾颓','',''],['玉山将崩','',''],['玉川','',''],['玉川市','',''],['玉州','',''],['玉帛','',''],['玉帝','',''],['玉带','',''],['玉律金科','',''],['玉成','',''],['玉成其事','',''],['玉成其美','',''],['玉手','',''],['玉振金声','',''],['玉搔头','',''],['玉昆金友','',''],['玉普西隆','',''],['玉札','',''],['玉林地区','',''],['玉枝金叶','',''],['玉树州','',''],['玉楼金殿','',''],['玉楼金阁','',''],['玉楼金阙','',''],['玉泉','',''],['玉泉营','',''],['玉洁冰清','',''],['玉浆','',''],['玉液琼浆','',''],['玉溪地区','',''],['玉滴石','',''],['玉照','',''],['玉版宣','',''],['玉版纸','',''],['玉玺','',''],['玉珉','',''],['玉璞','',''],['玉皇','',''],['玉皇大帝','',''],['玉皇顶','',''],['玉盘','',''],['玉石','',''],['玉石不分','',''],['玉石俱摧','',''],['玉石俱烬','',''],['玉石俱焚','',''],['玉石同沉','',''],['玉石同烬','',''],['玉石同焚','',''],['玉石景天','',''],['玉碎','',''],['玉碎珠沉','',''],['玉碎花销','',''],['玉碎香残','',''],['玉碎香消','',''],['玉立','',''],['玉立亭亭','',''],['玉竹','',''],['玉簪','',''],['玉米','',''],['玉米大斑病','',''],['玉米淀粉','',''],['玉米片','',''],['玉米笋','',''],['玉米粉','',''],['玉米粥','',''],['玉米糁','',''],['玉米糕','',''],['玉米糖浆','',''],['玉米花','',''],['玉米螟','',''],['玉米赤霉烯酮','',''],['玉米面','',''],['玉米饼','',''],['玉素甫','',''],['玉红省','',''],['玉腿','',''],['玉臂','',''],['玉般','',''],['玉色','',''],['玉茭','',''],['玉荷包','',''],['玉蜀','',''],['玉蜀黍','',''],['玉衡','',''],['玉言','',''],['玉貌花容','',''],['玉质金相','',''],['玉软花柔','',''],['玉软香温','',''],['玉里','',''],['玉里镇','',''],['玉钗','',''],['玉镯','',''],['玉门关','',''],['玉雕','',''],['玉露','',''],['玉露如珠','',''],['玉音','',''],['玉食锦衣','',''],['玉骨冰肌','',''],['玉髓','',''],['玉麦','',''],['玉齿','',''],['玉龙','',''],['玉龙县','',''],['玉龙雪山','',''],['王世充','',''],['王丹','',''],['王义夫','',''],['王书文','',''],['王五','',''],['王仙芝','',''],['王仙芝起义','',''],['王伾','',''],['王位','',''],['王佐之才','',''],['王侯','',''],['王侯公卿','',''],['王候将相','',''],['王储','',''],['王充','',''],['王光良','',''],['王八','',''],['王八蛋','',''],['王公','',''],['王公大人','',''],['王公贵人','',''],['王公贵戚','',''],['王公贵族','',''],['王军霞','',''],['王冠','',''],['王力宏','',''],['王励勤','',''],['王勃','',''],['王化','',''],['王叔文','',''],['王后','',''],['王君如','',''],['王国','',''],['王国维','',''],['王国聚会所','',''],['王士禛','',''],['王太后','',''],['王夫之','',''],['王妃','',''],['王婆卖瓜','',''],['王子','',''],['王子犯法庶民同罪','',''],['王孙','',''],['王孙公子','',''],['王孙贵戚','',''],['王安石','',''],['王安石变法','',''],['王官','',''],['王实甫','',''],['王室','',''],['王宫','',''],['王家','',''],['王家卫','',''],['王家瑞','',''],['王导','',''],['王小波','',''],['王小波李顺起义','',''],['王岱舆','',''],['王希孟','',''],['王平','',''],['王府','',''],['王府井','',''],['王座','',''],['王廷相','',''],['王建民','',''],['王心凌','',''],['王敦','',''],['王族','',''],['王明','',''],['王昭君','',''],['王朔','',''],['王朝','',''],['王权','',''],['王楠','',''],['王母','',''],['王母娘娘','',''],['王水','',''],['王永民','',''],['王治郅','',''],['王法','',''],['王洪文','',''],['王浆','',''],['王爵','',''],['王爷','',''],['王牌','',''],['王猛','',''],['王益','',''],['王相','',''],['王码','',''],['王祖贤','',''],['王祥卧冰','',''],['王禹偁','',''],['王维','',''],['王羲之','',''],['王老五','',''],['王老吉','',''],['王肃','',''],['王英','',''],['王莽','',''],['王菲','',''],['王著','',''],['王薄起义','',''],['王贡弹冠','',''],['王选','',''],['王道','',''],['王钦若','',''],['王铜','',''],['王震','',''],['王霸','',''],['王顾左右而言他','',''],['王颖','',''],['玎玲','',''],['玓瓅','',''],['玛丽','',''],['玛丽亚','',''],['玛丽娅','',''],['玛丽莲・梦露','',''],['玛俐欧','',''],['玛利亚','',''],['玛奇朵','',''],['玛家','',''],['玛家乡','',''],['玛尼','',''],['玛德琳','',''],['玛拉基书','',''],['玛拉基亚','',''],['玛拿西','',''],['玛格丽特','',''],['玛瑙','',''],['玛瑙贝','',''],['玛窦','',''],['玛窦福音','',''],['玛纳斯河','',''],['玛纳斯镇','',''],['玛莎拉蒂','',''],['玛迪达','',''],['玛门','',''],['玛雅','',''],['玛雅人','',''],['玩世','',''],['玩世不恭','',''],['玩世不羁','',''],['玩乐','',''],['玩人丧德','',''],['玩伴','',''],['玩偶','',''],['玩偶之家','',''],['玩儿','',''],['玩儿不转','',''],['玩儿命','',''],['玩儿坏','',''],['玩儿完','',''],['玩儿得转','',''],['玩儿票','',''],['玩儿花招','',''],['玩儿闹','',''],['玩兴','',''],['玩具','',''],['玩具厂','',''],['玩具店','',''],['玩具枪','',''],['玩具狗','',''],['玩具箱','',''],['玩厌','',''],['玩味','',''],['玩命','',''],['玩器','',''],['玩地','',''],['玩场','',''],['玩失踪','',''],['玩完','',''],['玩家','',''],['玩弄','',''],['玩弄词藻','',''],['玩忽','',''],['玩忽职守','',''],['玩意','',''],['玩意儿','',''],['玩手腕','',''],['玩木','',''],['玩水','',''],['玩法','',''],['玩滚','',''],['玩火','',''],['玩火自焚','',''],['玩牌','',''],['玩物','',''],['玩物丧志','',''],['玩狎','',''],['玩猫和老鼠的游戏','',''],['玩玩','',''],['玩癖','',''],['玩票','',''],['玩笑','',''],['玩索','',''],['玩者','',''],['玩耍','',''],['玩艺','',''],['玩艺儿','',''],['玩花招','',''],['玩蛇','',''],['玩话','',''],['玩赏','',''],['玩起','',''],['玩遍','',''],['玩闹','',''],['玫瑰','',''],['玫瑰战争','',''],['玫瑰星云','',''],['玫瑰油','',''],['玫瑰色','',''],['玫瑰花','',''],['环伺','',''],['环住','',''],['环保','',''],['环保主义','',''],['环保主义者','',''],['环保型','',''],['环保局','',''],['环保斗士','',''],['环保科学','',''],['环保筷','',''],['环保署','',''],['环保部','',''],['环化','',''],['环区','',''],['环卫','',''],['环围','',''],['环城','',''],['环城公路','',''],['环堵萧然','',''],['环境','',''],['环境保护','',''],['环境卫生','',''],['环境因素','',''],['环境影响','',''],['环境影响评估','',''],['环境损害','',''],['环境污染','',''],['环境法','',''],['环境温度','',''],['环境监测','',''],['环境科学','',''],['环境行动主义','',''],['环境规划','',''],['环境重灾区','',''],['环太平洋','',''],['环太平洋地震带','',''],['环太平洋火山带','',''],['环子','',''],['环山','',''],['环岛','',''],['环带','',''],['环幕','',''],['环式','',''],['环形','',''],['环形公路','',''],['环形山','',''],['环形结构','',''],['环形路','',''],['环往','',''],['环戊烯','',''],['环扣','',''],['环抱','',''],['环极涡旋','',''],['环比','',''],['环氧乙烷','',''],['环氧树脂','',''],['环水','',''],['环江','',''],['环江县','',''],['环法','',''],['环法国','',''],['环法自行车赛','',''],['环流','',''],['环海','',''],['环渤海湾地区','',''],['环游','',''],['环烃','',''],['环烷','',''],['环烷烃','',''],['环状','',''],['环状列石','',''],['环环','',''],['环环紧扣','',''],['环球','',''],['环球化','',''],['环球定位系统','',''],['环球旅行','',''],['环球时报','',''],['环礁','',''],['环秀山庄','',''],['环箍','',''],['环索','',''],['环线','',''],['环绕','',''],['环绕速度','',''],['环翠','',''],['环肌','',''],['环肥燕瘦','',''],['环航','',''],['环节','',''],['环节动物','',''],['环节动物门','',''],['环行','',''],['环行线','',''],['环衬','',''],['环视','',''],['环评','',''],['环路','',''],['环道','',''],['环链','',''],['环镜学','',''],['环面','',''],['环靶','',''],['环顾','',''],['环食','',''],['现下','',''],['现世','',''],['现世报','',''],['现世现报','',''],['现为','',''],['现买','',''],['现予','',''],['现今','',''],['现代','',''],['现代主义','',''],['现代五项','',''],['现代人','',''],['现代修正主义','',''],['现代化','',''],['现代史','',''],['现代式','',''],['现代形式','',''],['现代性','',''],['现代感','',''],['现代戏','',''],['现代战争','',''],['现代新儒家','',''],['现代派','',''],['现代舞','',''],['现代集团','',''],['现代音乐','',''],['现以','',''],['现价','',''],['现任','',''],['现住者','',''],['现值','',''],['现像','',''],['现况','',''],['现出','',''],['现势','',''],['现卖','',''],['现喜色','',''],['现在','',''],['现在分词','',''],['现在式','',''],['现在是过去钥匙','',''],['现地','',''],['现场','',''],['现场会','',''],['现场会议','',''],['现场报道','',''],['现场直播','',''],['现场视察','',''],['现场采访','',''],['现型','',''],['现大洋','',''],['现存','',''],['现学现用','',''],['现实','',''],['现实主义','',''],['现实性','',''],['现实情况','',''],['现实意义','',''],['现寄','',''],['现将','',''],['现就','',''],['现局','',''],['现居','',''],['现已','',''],['现年','',''],['现形','',''],['现役','',''],['现役军人','',''],['现成','',''],['现成话','',''],['现成饭','',''],['现房','',''],['现抓','',''],['现政府','',''],['现时','',''],['现有','',''],['现有人口','',''],['现有企业','',''],['现期','',''],['现款','',''],['现正','',''],['现汇','',''],['现法','',''],['现洋','',''],['现炒现卖','',''],['现烤','',''],['现物','',''],['现状','',''],['现率','',''],['现现','',''],['现用','',''],['现眼','',''],['现磨','',''],['现笑容','',''],['现经','',''],['现职','',''],['现行','',''],['现行制度','',''],['现行政策','',''],['现行标准','',''],['现行犯','',''],['现话','',''],['现说','',''],['现象','',''],['现象学','',''],['现象论','',''],['现货','',''],['现货价','',''],['现货供应','',''],['现购','',''],['现身','',''],['现身说法','',''],['现进','',''],['现量相违','',''],['现金','',''],['现金周转','',''],['现金基础','',''],['现金帐','',''],['现金流转','',''],['现金流转表','',''],['现金流量','',''],['现金流量表','',''],['现金结算','',''],['现钞','',''],['现钱','',''],['现阶段','',''],['现饕','',''],['现饭','',''],['玲玲','',''],['玲珑','',''],['玲珑剔透','',''],['玳瑁','',''],['玳瑁壳','',''],['玳瑁眼镜','',''],['玷污','',''],['玷辱','',''],['玺印','',''],['玻利尼西亚','',''],['玻尿酸','',''],['玻意耳','',''],['玻意耳定律','',''],['玻片','',''],['玻璃','',''],['玻璃丝','',''],['玻璃似','',''],['玻璃体','',''],['玻璃化','',''],['玻璃器皿','',''],['玻璃市','',''],['玻璃布','',''],['玻璃幕墙','',''],['玻璃杯','',''],['玻璃板','',''],['玻璃柜','',''],['玻璃沫','',''],['玻璃状','',''],['玻璃珠','',''],['玻璃瓶','',''],['玻璃砂','',''],['玻璃砖','',''],['玻璃管','',''],['玻璃粉','',''],['玻璃纤维','',''],['玻璃纱','',''],['玻璃纸','',''],['玻璃缸','',''],['玻璃罩','',''],['玻璃肥料','',''],['玻璃质','',''],['玻璃钢','',''],['玻色子','',''],['珀斯','',''],['珀西・比希・雪莱','',''],['珀金','',''],['珂罗版','',''],['珉玉','',''],['珉玉杂淆','',''],['珊卓','',''],['珊湖','',''],['珊瑚','',''],['珊瑚在网','',''],['珊瑚岛','',''],['珊瑚海','',''],['珊瑚潭','',''],['珊瑚状','',''],['珊瑚石','',''],['珊瑚礁','',''],['珊瑚色','',''],['珊瑚虫','',''],['珍・奥斯汀','',''],['珍品','',''],['珍奇','',''],['珍奶','',''],['珍宝','',''],['珍宝岛事件','',''],['珍异','',''],['珍惜','',''],['珍摄','',''],['珍本','',''],['珍爱','',''],['珍玩','',''],['珍珠','',''],['珍珠似','',''],['珍珠小番茄','',''],['珍珠岩','',''],['珍珠梅','',''],['珍珠港','',''],['珍珠港事件','',''],['珍珠米','',''],['珍珠色','',''],['珍珠贝','',''],['珍珠质','',''],['珍珠鸡','',''],['珍禽','',''],['珍禽奇兽','',''],['珍禽异兽','',''],['珍秘','',''],['珍稀','',''],['珍稀动物','',''],['珍羞','',''],['珍藏','',''],['珍视','',''],['珍贵','',''],['珍贵文物','',''],['珍重','',''],['珍闻','',''],['珍馐','',''],['珍馐美味','',''],['珍馐美馔','',''],['珐琅','',''],['珐琅质','',''],['珑玲','',''],['珑璁','',''],['珙桐','',''],['珞巴语','',''],['珠三角','',''],['珠串','',''],['珠儿','',''],['珠光','',''],['珠光体','',''],['珠光宝气','',''],['珠兰','',''],['珠围翠绕','',''],['珠圆玉润','',''],['珠子','',''],['珠宝','',''],['珠宝商','',''],['珠宝店','',''],['珠宝箱','',''],['珠宝翠钻','',''],['珠宫贝阙','',''],['珠山','',''],['珠峰','',''],['珠崖','',''],['珠帘','',''],['珠干玉戚','',''],['珠晖','',''],['珠残玉碎','',''],['珠母','',''],['珠江','',''],['珠江三角洲','',''],['珠江口','',''],['珠沉玉没','',''],['珠沉璧碎','',''],['珠流','',''],['珠流璧转','',''],['珠灰','',''],['珠玉','',''],['珠玉之论','',''],['珠玉在侧','',''],['珠玉在傍','',''],['珠玑','',''],['珠玑咳唾','',''],['珠穆朗玛','',''],['珠穆朗玛峰','',''],['珠箔','',''],['珠算','',''],['珠绕翠围','',''],['珠翠','',''],['珠翠罗绮','',''],['珠联璧合','',''],['珠茶','',''],['珠质','',''],['珠辉玉丽','',''],['珠还合浦','',''],['珠饰','',''],['珣玗琪','',''],['珥金拖紫','',''],['珩磨','',''],['班上','',''],['班主任','',''],['班什','',''],['班会','',''],['班副','',''],['班功行赏','',''],['班加罗尔','',''],['班务','',''],['班务会','',''],['班卓琴','',''],['班台','',''],['班吉','',''],['班固','',''],['班图斯坦','',''],['班外','',''],['班子','',''],['班师','',''],['班师得胜','',''],['班底','',''],['班房','',''],['班数','',''],['班期','',''],['班机','',''],['班次','',''],['班珠尔','',''],['班班','',''],['班禅','',''],['班禅喇嘛','',''],['班级','',''],['班纪德','',''],['班线','',''],['班组','',''],['班组长','',''],['班荆相对','',''],['班荆道故','',''],['班荆道旧','',''],['班衣戏彩','',''],['班费','',''],['班超','',''],['班车','',''],['班轮','',''],['班辈','',''],['班辈儿','',''],['班达亚齐','',''],['班里','',''],['班长','',''],['班门弄斧','',''],['班际','',''],['班雅明','',''],['班香宋艳','',''],['班马文章','',''],['班驳','',''],['球中','',''],['球会','',''],['球体','',''],['球儿','',''],['球内','',''],['球区','',''],['球半径','',''],['球友','',''],['球台','',''],['球员','',''],['球场','',''],['球场会馆','',''],['球坛','',''],['球墨铸铁','',''],['球外','',''],['球孢子菌病','',''],['球季','',''],['球局','',''],['球差','',''],['球座','',''],['球弹','',''],['球形','',''],['球径计','',''],['球心','',''],['球感','',''],['球戏','',''],['球手','',''],['球技','',''],['球拍','',''],['球星','',''],['球晶','',''],['球杆','',''],['球果','',''],['球架','',''],['球棍','',''],['球棒','',''],['球状','',''],['球状体','',''],['球状物','',''],['球状蛋白质','',''],['球状软骨','',''],['球王','',''],['球瘾','',''],['球磨机','',''],['球种','',''],['球童','',''],['球竿','',''],['球类','',''],['球粒陨石','',''],['球网','',''],['球胆','',''],['球腔菌','',''],['球腱','',''],['球艺','',''],['球芽甘蓝','',''],['球茎','',''],['球茎甘蓝','',''],['球菌','',''],['球虫','',''],['球虫病','',''],['球蛋白','',''],['球衣','',''],['球衫','',''],['球赛','',''],['球路','',''],['球轴承','',''],['球运','',''],['球迷','',''],['球速','',''],['球道','',''],['球门','',''],['球阀','',''],['球队','',''],['球面','',''],['球面几何','',''],['球面镜','',''],['球鞋','',''],['琅威理','',''],['琅嬛','',''],['琅玡','',''],['琅玡区','',''],['琅玡山','',''],['琅琅','',''],['琅琅上口','',''],['琅琊','',''],['琅质','',''],['理不忘乱','',''],['理不胜词','',''],['理事','',''],['理事会','',''],['理事长','',''],['理亏','',''],['理人','',''],['理会','',''],['理儿','',''],['理光','',''],['理出','',''],['理则','',''],['理则学','',''],['理化','',''],['理化因素','',''],['理发','',''],['理发厅','',''],['理发员','',''],['理发师','',''],['理发店','',''],['理发院','',''],['理合','',''],['理喻','',''],['理固当然','',''],['理头','',''],['理学','',''],['理学士','',''],['理学家','',''],['理学硕士','',''],['理学硕士学位','',''],['理容','',''],['理容中心','',''],['理屈','',''],['理屈事穷','',''],['理屈词穷','',''],['理工','',''],['理工大学','',''],['理工科','',''],['理应','',''],['理当','',''],['理念','',''],['理性','',''],['理性与感性','',''],['理性主义','',''],['理性知识','',''],['理性认识','',''],['理想','',''],['理想主义','',''],['理想化','',''],['理想国','',''],['理想家','',''],['理想美','',''],['理所不容','',''],['理所应当','',''],['理所当然','',''],['理智','',''],['理查','',''],['理查德','',''],['理查森','',''],['理气','',''],['理气化痰','',''],['理清','',''],['理理发','',''],['理由','',''],['理疗','',''],['理疗师','',''],['理直气壮','',''],['理睬','',''],['理短','',''],['理神论','',''],['理科','',''],['理科学士','',''],['理纷解结','',''],['理自','',''],['理解','',''],['理解力','',''],['理论','',''],['理论上','',''],['理论体系','',''],['理论依据','',''],['理论化','',''],['理论基础','',''],['理论家','',''],['理论工作者','',''],['理论指导','',''],['理论派','',''],['理论物理学','',''],['理论界','',''],['理论研究','',''],['理论联系实际','',''],['理论贡献','',''],['理论问题','',''],['理该','',''],['理财','',''],['理财学','',''],['理财家','',''],['理赔','',''],['理路','',''],['理过','',''],['理过其辞','',''],['理顺','',''],['琉球','',''],['琉球乡','',''],['琉球国','',''],['琉球海','',''],['琉球王国','',''],['琉球群岛','',''],['琉璃','',''],['琉璃塔','',''],['琉璃庙','',''],['琉璃瓦','',''],['琐事','',''],['琐务','',''],['琐呐','',''],['琐尾流离','',''],['琐屑','',''],['琐物','',''],['琐琐碎碎','',''],['琐碎','',''],['琐紧','',''],['琐细','',''],['琐罗亚斯德','',''],['琐罗亚斯德教','',''],['琐罗亚斯特','',''],['琐言','',''],['琐记','',''],['琐闻','',''],['琢玉成器','',''],['琢石','',''],['琢磨','',''],['琢磨不透','',''],['琥珀','',''],['琥珀色','',''],['琥珀金','',''],['琪花瑶草','',''],['琳・戴维斯','',''],['琳琅','',''],['琳琅满目','',''],['琴书','',''],['琴剑飘零','',''],['琴声','',''],['琴家','',''],['琴师','',''],['琴座','',''],['琴弓','',''],['琴弦','',''],['琴心剑胆','',''],['琴心相挑','',''],['琴房','',''],['琴手','',''],['琴断朱弦','',''],['琴斯托霍瓦','',''],['琴架','',''],['琴棋书画','',''],['琴瑟','',''],['琴瑟不调','',''],['琴瑟和同','',''],['琴瑟和谐','',''],['琴瑟和鸣','',''],['琴瑟失调','',''],['琴瑟相调','',''],['琴瑟调和','',''],['琴者','',''],['琴调','',''],['琴酒','',''],['琴锤','',''],['琴键','',''],['琴马','',''],['琴鸟','',''],['琵琶','',''],['琵琶别抱','',''],['琵琶行','',''],['琵琶骨','',''],['琵琶鱼','',''],['琵鹭','',''],['琼中','',''],['琼中县','',''],['琼剧','',''],['琼华','',''],['琼厨金穴','',''],['琼台玉宇','',''],['琼台玉阁','',''],['琼堆玉砌','',''],['琼山','',''],['琼山市','',''],['琼崖','',''],['琼州','',''],['琼州海峡','',''],['琼斯','',''],['琼斯顿','',''],['琼林玉树','',''],['琼林玉质','',''],['琼枝玉叶','',''],['琼枝玉树','',''],['琼楼','',''],['琼楼玉宇','',''],['琼浆','',''],['琼浆玉液','',''],['琼浆金液','',''],['琼瑛','',''],['琼瑶','',''],['琼筵','',''],['琼脂','',''],['琼阁','',''],['瑕不掩玉','',''],['瑕不掩瑜','',''],['瑕玷','',''],['瑕瑜','',''],['瑕瑜互见','',''],['瑕疵','',''],['瑚琏之器','',''],['瑜不掩瑕','',''],['瑜伽','',''],['瑜珈','',''],['瑜迦','',''],['瑞亚','',''],['瑞兆','',''],['瑞典人','',''],['瑞典语','',''],['瑞兽','',''],['瑞士人','',''],['瑞士军刀','',''],['瑞士卷','',''],['瑞士法郎','',''],['瑞朗','',''],['瑞氏染料','',''],['瑞氏染色','',''],['瑞气','',''],['瑞气祥云','',''],['瑞狮','',''],['瑞穗','',''],['瑞穗乡','',''],['瑞签','',''],['瑞色','',''],['瑞芳','',''],['瑞芳镇','',''],['瑞萨','',''],['瑞萨科技','',''],['瑞雪','',''],['瑞香','',''],['瑟弄琴调','',''],['瑟瑟','',''],['瑟瑟发抖','',''],['瑟缩','',''],['瑟调琴弄','',''],['瑰丽','',''],['瑰伟','',''],['瑰奇','',''],['瑰宝','',''],['瑰异','',''],['瑰意琦行','',''],['瑰玮','',''],['瑶之圃','',''],['瑶台琼室','',''],['瑶台银阙','',''],['瑶林琼树','',''],['瑶池','',''],['瑶池玉液','',''],['瑶池阆苑','',''],['瑶海','',''],['瑶环瑜珥','',''],['瑶草琪花','',''],['瑷珲条约','',''],['璀灿','',''],['璀璀','',''],['璀璨','',''],['璀璨夺目','',''],['璀错','',''],['璇玑','',''],['璎珞','',''],['璐珞','',''],['璞玉浑金','',''],['璧合珠连','',''],['璧玉','',''],['璧谢','',''],['璧还','',''],['璨然','',''],['璨玉','',''],['璨璨','',''],['璨美','',''],['瓜仁','',''],['瓜代','',''],['瓜农','',''],['瓜分','',''],['瓜分豆剖','',''],['瓜剖豆分','',''],['瓜地','',''],['瓜地马拉','',''],['瓜子','',''],['瓜子脸','',''],['瓜字初分','',''],['瓜州','',''],['瓜州县','',''],['瓜拉丁加奴','',''],['瓜拿纳','',''],['瓜李之嫌','',''],['瓜条','',''],['瓜果','',''],['瓜棚','',''],['瓜熟','',''],['瓜熟蒂落','',''],['瓜片','',''],['瓜瓤','',''],['瓜田','',''],['瓜田不纳履','',''],['瓜田之嫌','',''],['瓜田李下','',''],['瓜皮','',''],['瓜皮帽','',''],['瓜秧','',''],['瓜类','',''],['瓜类蔬菜','',''],['瓜肉','',''],['瓜脐','',''],['瓜菜','',''],['瓜萤','',''],['瓜葛','',''],['瓜蒂','',''],['瓜蔓','',''],['瓜达卡纳尔岛','',''],['瓜达卡纳尔战役','',''],['瓜达拉哈拉','',''],['瓜达拉马','',''],['瓜达拉马山','',''],['瓠子','',''],['瓠瓜','',''],['瓢儿','',''],['瓢儿菜','',''],['瓢泼','',''],['瓢泼大雨','',''],['瓢泼瓦灌','',''],['瓢泼而下','',''],['瓢葫苹','',''],['瓢虫','',''],['瓣形','',''],['瓣状','',''],['瓣胃','',''],['瓣膜','',''],['瓣花','',''],['瓣鳃类','',''],['瓣鳃纲','',''],['瓤儿','',''],['瓤子','',''],['瓦全','',''],['瓦刀','',''],['瓦利','',''],['瓦剌','',''],['瓦加杜古','',''],['瓦努阿图','',''],['瓦匠','',''],['瓦千时','',''],['瓦合之卒','',''],['瓦哈比教派','',''],['瓦器','',''],['瓦器蚌盘','',''],['瓦圈','',''],['瓦块','',''],['瓦垄','',''],['瓦垄子','',''],['瓦城','',''],['瓦头','',''],['瓦尔基里','',''],['瓦尔德','',''],['瓦尔特','',''],['瓦尔纳','',''],['瓦尔达克','',''],['瓦尔达克省','',''],['瓦屋','',''],['瓦岗军','',''],['瓦工','',''],['瓦当','',''],['瓦当文','',''],['瓦影龟鱼','',''],['瓦德瑟','',''],['瓦德西','',''],['瓦房','',''],['瓦数','',''],['瓦斯','',''],['瓦时','',''],['瓦杜兹','',''],['瓦棺篆鼎','',''],['瓦楞','',''],['瓦楞子','',''],['瓦楞纸','',''],['瓦片','',''],['瓦特','',''],['泰勒起义','',''],['瓦特小时计','',''],['瓦特数','',''],['瓦特时','',''],['瓦特表','',''],['瓦特计','',''],['瓦状','',''],['瓦盆','',''],['瓦砚','',''],['瓦砾','',''],['瓦砾堆','',''],['瓦窑堡会议','',''],['瓦类','',''],['瓦罐','',''],['瓦罐不离井口破','',''],['瓦罕走廊','',''],['瓦良格','',''],['瓦莱塔','',''],['瓦西里','',''],['瓦西里耶维奇','',''],['瓦解','',''],['瓦解云散','',''],['瓦解冰泮','',''],['瓦解冰消','',''],['瓦解冰销','',''],['瓦解土崩','',''],['瓦解星散','',''],['瓦解星飞','',''],['瓦赫基尔河','',''],['瓦里斯','',''],['瓦釜之鸣','',''],['瓦釜雷鸣','',''],['瓦隆','',''],['瓮中之鳖','',''],['瓮中捉鳖','',''],['瓮城','',''],['瓮声瓮气','',''],['瓮天蠡海','',''],['瓮尽杯干','',''],['瓮棺','',''],['瓮棺葬','',''],['瓮牖绳枢','',''],['瓮菜','',''],['瓮里醯鸡','',''],['瓯子','',''],['瓯海','',''],['瓯绣','',''],['瓶中','',''],['瓶内','',''],['瓶口','',''],['瓶嘴','',''],['瓶坠簪折','',''],['瓶塞','',''],['瓶塞钻','',''],['瓶子','',''],['瓶帽','',''],['瓶底','',''],['瓶沉簪折','',''],['瓶盂','',''],['瓶盖','',''],['瓶罐','',''],['瓶胆','',''],['瓶胚','',''],['瓶装','',''],['瓶领','',''],['瓶颈','',''],['瓶鼻海豚','',''],['瓷件','',''],['瓷器','',''],['瓷土','',''],['瓷实','',''],['瓷漆','',''],['瓷片','',''],['瓷瓶','',''],['瓷画','',''],['瓷盘','',''],['瓷砖','',''],['瓷碗','',''],['瓷窑','',''],['瓷窖','',''],['瓷缸','',''],['瓷釉','',''],['瓷雕','',''],['甄别','',''],['甄别考试','',''],['甄奇录异','',''],['甄审','',''],['甄录','',''],['甄才品能','',''],['甄拔','',''],['甄汰','',''],['甄烦就简','',''],['甄用','',''],['甄综','',''],['甄藻','',''],['甄试','',''],['甄选','',''],['甄陶','',''],['甑子','',''],['甑尘釜鱼','',''],['甘丹寺','',''],['甘之如荠','',''],['甘之如饴','',''],['甘之若素','',''],['甘之若饴','',''],['甘于','',''],['甘井先竭','',''],['甘休','',''],['甘冒','',''],['甘冒虎口','',''],['甘分随时','',''],['甘南州','',''],['甘受','',''],['甘味','',''],['甘味剂','',''],['甘味料','',''],['甘地','',''],['甘处下流','',''],['甘孜州','',''],['甘守','',''],['甘居中游','',''],['甘州','',''],['甘巴里','',''],['甘当','',''],['甘当无名英雄','',''],['甘心','',''],['甘心如荠','',''],['甘心情愿','',''],['甘心瞑目','',''],['甘愿','',''],['甘托克','',''],['甘拜','',''],['甘拜下风','',''],['甘旨','',''],['甘旨肥浓','',''],['甘松香','',''],['甘棠之惠','',''],['甘棠之爱','',''],['甘棠遗爱','',''],['甘死如饴','',''],['甘比','',''],['甘氨酸','',''],['甘汁','',''],['甘汞','',''],['甘油','',''],['甘油三脂','',''],['甘油三酯','',''],['甘油栓剂','',''],['甘油酯','',''],['甘油醛','',''],['甘泉必竭','',''],['甘瓜苦蒂','',''],['甘甜','',''],['甘糖醇','',''],['甘紫菜','',''],['甘结','',''],['甘美','',''],['甘美多汁','',''],['甘苦','',''],['甘草','',''],['甘菊','',''],['甘蓝','',''],['甘蓝型油菜','',''],['甘蓝类蔬菜','',''],['甘蓝菜','',''],['甘蔗','',''],['甘蔗渣','',''],['甘蕉','',''],['甘薯','',''],['甘薯黑斑病','',''],['甘言厚币','',''],['甘言厚礼','',''],['甘言好辞','',''],['甘言巧辞','',''],['甘言美语','',''],['甘言蜜语','',''],['甘贫乐道','',''],['甘贫守分','',''],['甘贫守志','',''],['甘贫守节','',''],['甘雨','',''],['甘雨随车','',''],['甘霖','',''],['甘露','',''],['甘露法雨','',''],['甘露糖醇','',''],['甘露醇','',''],['甘馨之费','',''],['甚且','',''],['甚为','',''],['甚么','',''],['甚于','',''],['甚低频','',''],['甚佳','',''],['甚嚣尘上','',''],['甚多','',''],['甚大','',''],['甚小','',''],['甚少','',''],['甚巨','',''],['甚广','',''],['甚微','',''],['甚感诧异','',''],['甚或','',''],['甚浓','',''],['甚深','',''],['甚而','',''],['甚至','',''],['甚至于','',''],['甚解','',''],['甚轻','',''],['甚远','',''],['甚钜','',''],['甚高','',''],['甚高频','',''],['甜不辣','',''],['甜叶菊','',''],['甜味','',''],['甜味剂','',''],['甜品','',''],['甜嘴蜜舌','',''],['甜圈','',''],['甜头','',''],['甜如蜜','',''],['甜密','',''],['甜心','',''],['甜料','',''],['甜枣','',''],['甜橙','',''],['甜水','',''],['甜津津','',''],['甜润','',''],['甜滋滋','',''],['甜点','',''],['甜烈酒','',''],['甜瓜','',''],['甜瓜类','',''],['甜甜圈','',''],['甜甜的','',''],['甜甜蜜蜜','',''],['甜的','',''],['甜笑','',''],['甜筒','',''],['甜美','',''],['甜腻','',''],['甜菊','',''],['甜菊糖','',''],['甜菜','',''],['甜蜜','',''],['甜蜜蜜','',''],['甜言','',''],['甜言媚语','',''],['甜言密语','',''],['甜言美语','',''],['甜言花言','',''],['甜言蜜语','',''],['甜言软语','',''],['甜调','',''],['甜豆','',''],['甜辣','',''],['甜酒','',''],['甜酱','',''],['甜酸','',''],['甜酸肉','',''],['甜酸苦辣','',''],['甜面酱','',''],['甜食','',''],['甜饼','',''],['甜香','',''],['生下','',''],['生不逢时','',''],['生不逢辰','',''],['生不遇时','',''],['生业','',''],['生丝','',''],['生为','',''],['生义','',''],['生了','',''],['生了锈','',''],['生事','',''],['生事扰民','',''],['生于','',''],['生于优患','',''],['生于忧患死于安乐','',''],['生产','',''],['生产上','',''],['生产专业化','',''],['生产企业','',''],['生产关系','',''],['生产关系一定要适合生产力性质的规律','',''],['生产力','',''],['生产力与生产关系','',''],['生产劳动','',''],['生产单位','',''],['生产反应堆','',''],['生产合作社','',''],['生产国','',''],['生产基金','',''],['生产大队','',''],['生产工作者劳动报酬基金','',''],['生产工具','',''],['生产性','',''],['生产性建设','',''],['生产总值','',''],['生产成本','',''],['生产战线','',''],['生产指标','',''],['生产操','',''],['生产方式','',''],['生产条件','',''],['生产水平','',''],['生产率','',''],['生产社会化','',''],['生产秩序','',''],['生产线','',''],['生产者','',''],['生产能力','',''],['生产自救','',''],['生产要素','',''],['生产设施','',''],['生产责任制','',''],['生产费用','',''],['生产资料','',''],['生产资料所有制','',''],['生产资本','',''],['生产过剩','',''],['生产量','',''],['生产队','',''],['生产额','',''],['生人','',''],['生人涂炭','',''],['生仔','',''],['生他','',''],['生佛万家','',''],['生俘','',''],['生僻','',''],['生儿','',''],['生儿育女','',''],['生光','',''],['生公说法顽石点头','',''],['生关死劫','',''],['生养','',''],['生冷','',''],['生凑','',''],['生出','',''],['生分','',''],['生前','',''],['生前友好','',''],['生力军','',''],['生动','',''],['生动活泼','',''],['生势','',''],['生化','',''],['生化学','',''],['生化武器','',''],['生卒年','',''],['生卒年月','',''],['生厌','',''],['生反感','',''],['生发','',''],['生受','',''],['生变','',''],['生吃','',''],['生合成','',''],['生同衾死同穴','',''],['生吞','',''],['生吞活剥','',''],['生员','',''],['生命','',''],['生命不息','',''],['生命力','',''],['生命吠陀','',''],['生命周期','',''],['生命在于运动','',''],['生命多样性','',''],['生命学','',''],['生命层','',''],['生命征象','',''],['生命攸关','',''],['生命的遗迹','',''],['生命科学','',''],['生命素质','',''],['生命线','',''],['生命财产','',''],['生命迹象','',''],['生啤','',''],['生啤酒','',''],['生土','',''],['生在','',''],['生地','',''],['生圹','',''],['生坯','',''],['生境','',''],['生处','',''],['生夺硬抱','',''],['生女','',''],['生妖作怪','',''],['生姜','',''],['生姜丝','',''],['生子','',''],['生字','',''],['生存','',''],['生存保险','',''],['生存农业','',''],['生存斗争','',''],['生存权','',''],['生存率','',''],['生存环境','',''],['生存能力','',''],['生客','',''],['生寄死归','',''],['生小孩','',''],['生小牛','',''],['生就','',''],['生平','',''],['生平事迹','',''],['生平简介','',''],['生年','',''],['生张熟魏','',''],['生态','',''],['生态位','',''],['生态圈','',''],['生态孤岛','',''],['生态学','',''],['生态学家','',''],['生态平衡','',''],['生态建设','',''],['生态旅游','',''],['生态环境','',''],['生态环境游','',''],['生态系统','',''],['生态经济学','',''],['生态艺术','',''],['生态足迹','',''],['生怕','',''],['生性','',''],['生恐','',''],['生息','',''],['生息蕃庶','',''],['生悲','',''],['生情见景','',''],['生惧','',''],['生意','',''],['生意人','',''],['生意兴隆','',''],['生意经','',''],['生愿','',''],['生成','',''],['生成树','',''],['生成物','',''],['生我劬劳','',''],['生手','',''],['生技','',''],['生技医药','',''],['生抽','',''],['生拉活扯','',''],['生拉硬拽','',''],['生搬硬套','',''],['生擒','',''],['生擒活拿','',''],['生擒活捉','',''],['生效','',''],['生料','',''],['生於','',''],['生日','',''],['生日卡','',''],['生日快乐','',''],['生日蛋糕','',''],['生日贺卡','',''],['生时','',''],['生有','',''],['生有权','',''],['生机','',''],['生机勃勃','',''],['生杀与夺','',''],['生杀之权','',''],['生杀予夺','',''],['生杀大权','',''],['生权','',''],['生材','',''],['生来','',''],['生来死去','',''],['生染','',''],['生栋覆屋','',''],['生树脂','',''],['生根','',''],['生桑之梦','',''],['生橡胶','',''],['生死','',''],['生死不渝','',''],['生死之交','',''],['生死予夺','',''],['生死关','',''],['生死关头','',''],['生死别离','',''],['生死存亡','',''],['生死攸关','',''],['生死有命','',''],['生死线','',''],['生死肉骨','',''],['生死观','',''],['生死轮回','',''],['生殖','',''],['生殖力','',''],['生殖器','',''],['生殖器官','',''],['生殖期','',''],['生殖洄游','',''],['生殖系统','',''],['生殖细胞','',''],['生殖者','',''],['生殖腺','',''],['生殖轮','',''],['生母','',''],['生毛','',''],['生民','',''],['生民涂炭','',''],['生气','',''],['生气勃勃','',''],['生气盎然','',''],['生气蓬勃','',''],['生水','',''],['生水果','',''],['生水泡','',''],['生油','',''],['生法','',''],['生活','',''],['生活上','',''],['生活会','',''],['生活作风','',''],['生活区','',''],['生活垃圾','',''],['生活形态','',''],['生活必需品','',''],['生活方式','',''],['生活水平','',''],['生活污水','',''],['生活素质','',''],['生活者','',''],['生活设施','',''],['生活质料','',''],['生活费','',''],['生活资料','',''],['生活阔绰','',''],['生涩','',''],['生涯','',''],['生溃疡','',''],['生源','',''],['生源论','',''],['生满','',''],['生漆','',''],['生火','',''],['生灭','',''],['生灵','',''],['生灵涂炭','',''],['生炒热卖','',''],['生热','',''],['生煎','',''],['生煎包','',''],['生煮','',''],['生父','',''],['生父母','',''],['生物','',''],['生物专一性','',''],['生物传感器','',''],['生物伦琴当量','',''],['生物体','',''],['生物分析法','',''],['生物制剂','',''],['生物制品','',''],['生物剂量仪','',''],['生物力学','',''],['生物化学','',''],['生物化学家','',''],['生物化学站剂','',''],['生物医学工程','',''],['生物反应器','',''],['生物圈','',''],['生物多元化','',''],['生物多样性','',''],['生物大灭绝','',''],['生物媒介','',''],['生物学','',''],['生物学家','',''],['生物学最低温度','',''],['生物学界','',''],['生物工程','',''],['生物工程学','',''],['生物弹药','',''],['生物态','',''],['生物性','',''],['生物恐怖主义','',''],['生物战','',''],['生物战剂','',''],['生物技术','',''],['生物晶片','',''],['生物材料','',''],['生物柴油','',''],['生物武器','',''],['生物气体','',''],['生物活化性','',''],['生物测定','',''],['生物燃料','',''],['生物电','',''],['生物电流','',''],['生物界','',''],['生物碱','',''],['生物科技','',''],['生物群','',''],['生物能','',''],['生物质','',''],['生物质能','',''],['生物资源','',''],['生物转化','',''],['生物量','',''],['生物钟','',''],['生物链','',''],['生物防治','',''],['生物降解','',''],['生物风化','',''],['生物高分子','',''],['生猛','',''],['生猪','',''],['生球根','',''],['生理','',''],['生理卫生','',''],['生理学','',''],['生理学家','',''],['生理心理学','',''],['生理性','',''],['生理特点','',''],['生理用品','',''],['生理盐水','',''],['生生不息','',''],['生生世世','',''],['生男育女','',''],['生畏','',''],['生番','',''],['生疏','',''],['生疏了','',''],['生疑','',''],['生疥癣','',''],['生疼','',''],['生病','',''],['生的','',''],['生皮','',''],['生皮鞋','',''],['生石灰','',''],['生石膏','',''],['生硬','',''],['生离死别','',''],['生离死绝','',''],['生端','',''],['生米','',''],['生米做成熟饭','',''],['生米煮成熟饭','',''],['生米熟饭','',''],['生粉','',''],['生粉水','',''],['生羽毛','',''],['生老病死','',''],['生者','',''],['生而','',''],['生而知之','',''],['生耗氧量','',''],['生聚教训','',''],['生肉','',''],['生肉芽','',''],['生肖','',''],['生肖属相','',''],['生育','',''],['生育率','',''],['生育能力','',''],['生脓泡','',''],['生色','',''],['生花妙笔','',''],['生苔','',''],['生荒','',''],['生荣死哀','',''],['生药','',''],['生菜','',''],['生虫','',''],['生蛆','',''],['生蛋','',''],['生角','',''],['生计','',''],['生词','',''],['生词本','',''],['生词语','',''],['生谱','',''],['生财','',''],['生财之道','',''],['生财有道','',''],['生趣','',''],['生路','',''],['生身父母','',''],['生辉','',''],['生辰','',''],['生辰八字','',''],['生达','',''],['生达乡','',''],['生达县','',''],['生还','',''],['生还者','',''],['生造','',''],['生铁','',''],['生铜','',''],['生锈','',''],['生长','',''],['生长出','',''],['生长发育','',''],['生长期','',''],['生长激素','',''],['生长点','',''],['生长率','',''],['生长素','',''],['生闷气','',''],['生霉','',''],['生非作歹','',''],['生面','',''],['生面团','',''],['生食','',''],['生饼','',''],['生香油','',''],['生鱼片','',''],['生齐','',''],['生齿','',''],['生齿日繁','',''],['生龙活虎','',''],['甥女','',''],['用一句话来说','',''],['用一当十','',''],['用上','',''],['用不','',''],['用不了','',''],['用不完','',''],['用不着','',''],['用不著','',''],['用两','',''],['用两耳','',''],['用为','',''],['用之','',''],['用之不竭','',''],['用之于','',''],['用了','',''],['用事','',''],['用于','',''],['用人','',''],['用人不当','',''],['用人单位','',''],['用人经费','',''],['用什麽','',''],['用他','',''],['用以','',''],['用作','',''],['用作配种','',''],['用光','',''],['用兵','',''],['用兵一时','',''],['用兵如神','',''],['用其所长','',''],['用具','',''],['用出','',''],['用分','',''],['用刑','',''],['用到','',''],['用力','',''],['用力扯','',''],['用力拉','',''],['用力拖','',''],['用功','',''],['用劲','',''],['用印','',''],['用去','',''],['用反','',''],['用后','',''],['用吧','',''],['用品','',''],['用唇','',''],['用嘴','',''],['用图','',''],['用图表','',''],['用在','',''],['用在一朝','',''],['用地','',''],['用场','',''],['用坏','',''],['用声音','',''],['用处','',''],['用处小','',''],['用夏变夷','',''],['用天因地','',''],['用头','',''],['用好','',''],['用字','',''],['用完','',''],['用家','',''],['用尽','',''],['用尽心机','',''],['用工','',''],['用工夫','',''],['用布','',''],['用带','',''],['用度','',''],['用得上','',''],['用得着','',''],['用心','',''],['用心竭力','',''],['用心良苦','',''],['用性','',''],['用意','',''],['用意何在','',''],['用户','',''],['用户创造内容','',''],['用户到网络接口','',''],['用户到网络的接口','',''],['用户名','',''],['用户定义','',''],['用户意见','',''],['用户界面','',''],['用户端设备','',''],['用户线','',''],['用户至上','',''],['用房','',''],['用手','',''],['用把','',''],['用指','',''],['用掉','',''],['用文','',''],['用料','',''],['用旧','',''],['用旧了','',''],['用智铺谋','',''],['用材','',''],['用材林','',''],['用来','',''],['用来配种','',''],['用枪','',''],['用款','',''],['用此','',''],['用武','',''],['用武之地','',''],['用毕','',''],['用气','',''],['用水','',''],['用汇','',''],['用法','',''],['用煤','',''],['用用','',''],['用电','',''],['用电量','',''],['用的','',''],['用着','',''],['用破','',''],['用管窥天','',''],['用粮','',''],['用者','',''],['用职','',''],['用脑','',''],['用膳','',''],['用舍行藏','',''],['用草奇花','',''],['用药','',''],['用行舍藏','',''],['用计','',''],['用计铺谋','',''],['用词','',''],['用词不当','',''],['用语','',''],['用财','',''],['用贤任能','',''],['用费','',''],['用车','',''],['用辞','',''],['用过','',''],['用途','',''],['用逸代劳','',''],['用量','',''],['用钱','',''],['用钱如水','',''],['用错','',''],['用间','',''],['用非其人','',''],['用非所学','',''],['用项','',''],['用餐','',''],['用餐时间','',''],['甩上','',''],['甩了','',''],['甩到','',''],['甩动','',''],['甩包袱','',''],['大甩卖','',''],['甩卖','',''],['甩头','',''],['甩尾','',''],['甩开','',''],['甩开膀子','',''],['甩手','',''],['甩手掌柜','',''],['甩手顿脚','',''],['甩掉','',''],['甩脱','',''],['甩脸子','',''],['甩落','',''],['甩袖子','',''],['甩车','',''],['甩远','',''],['甩钟','',''],['甪端','',''],['甬剧','',''],['甬江','',''],['甬路','',''],['甬道','',''],['甭提','',''],['甭管','',''],['甭说','',''],['田七','',''],['田中','',''],['田中角荣','',''],['田中镇','',''],['田主','',''],['田产','',''],['田亩','',''],['田亮','',''],['田园','',''],['田园化','',''],['田园诗','',''],['田园风光','',''],['田土','',''],['田地','',''],['田垄','',''],['田埂','',''],['田塍','',''],['田夫野老','',''],['田头','',''],['田契','',''],['田宅','',''],['田家庵','',''],['田寮','',''],['田寮乡','',''],['田尾','',''],['田尾乡','',''],['田庄','',''],['田役','',''],['田径','',''],['田径赛','',''],['田径运动','',''],['田文','',''],['田汉','',''],['田湾','',''],['田父之获','',''],['田猎','',''],['田畴','',''],['田租','',''],['田粮','',''],['田纳西','',''],['田纳西州','',''],['田联','',''],['田舍','',''],['田营','',''],['田营市','',''],['田螺','',''],['田赋','',''],['田赛','',''],['田边地头','',''],['田连仟陌','',''],['田连阡陌','',''],['田里','',''],['田野','',''],['田野工作','',''],['田长霖','',''],['田间','',''],['田间管理','',''],['田陌','',''],['田鳖','',''],['田鸡','',''],['田鹨','',''],['田鼠','',''],['由上','',''],['由上向下','',''],['由上而下','',''],['由下向上','',''],['由下而上','',''],['由不得','',''],['由东向西','',''],['由中之言','',''],['由之','',''],['由于','',''],['由于上述原因','',''],['由于某种原因','',''],['由于种种原因','',''],['由人','',''],['由其','',''],['由冷','',''],['由加','',''],['由北向南','',''],['由南向北','',''],['由博返约','',''],['由右向左','',''],['由大到小','',''],['由头','',''],['由始至终','',''],['由左向右','',''],['由径','',''],['由得','',''],['由旬','',''],['由易到难','',''],['由来','',''],['由来已久','',''],['由此','',''],['由此及彼','',''],['由此可以看出','',''],['由此可见','',''],['由此可证','',''],['由此来看','',''],['由此而来','',''],['由浅入深','',''],['由点到面','',''],['由盛而衰','',''],['由省','',''],['由着','',''],['由窦尚书','',''],['由表及里','',''],['由衷','',''],['由衷之言','',''],['由衷感谢','',''],['由西向东','',''],['由证','',''],['由该','',''],['由近','',''],['由近及远','',''],['由远','',''],['由远而近','',''],['由难到易','',''],['甲乙','',''],['甲乙丙','',''],['甲乙双方','',''],['甲二醇','',''],['甲亢','',''],['甲仙','',''],['甲仙乡','',''],['甲克','',''],['甲兵','',''],['甲冑','',''],['甲午','',''],['甲午战争','',''],['甲型','',''],['甲型肝炎','',''],['甲基','',''],['甲基安非他命','',''],['甲基苯丙胺','',''],['甲士','',''],['甲壳','',''],['甲壳动物','',''],['甲壳类','',''],['甲壳素','',''],['甲壳虫','',''],['甲壳虫类','',''],['甲夜','',''],['甲天下','',''],['甲子','',''],['甲寅','',''],['甲形球蛋白','',''],['甲戌','',''],['甲方','',''],['甲替色氨酸','',''],['甲板','',''],['甲氧基','',''],['甲氧西林','',''],['甲氨','',''],['甲氨基','',''],['甲流','',''],['甲烷','',''],['甲状','',''],['甲状旁腺','',''],['甲状腺','',''],['甲状腺功能亢进','',''],['甲状腺素','',''],['甲状腺肿','',''],['甲状软骨','',''],['甲班','',''],['甲申','',''],['甲申政变','',''],['甲癣','',''],['甲硝唑','',''],['甲硫氨酸','',''],['甲磺磷定','',''],['甲种','',''],['甲种射线','',''],['甲种粒子','',''],['甲第','',''],['甲第星罗','',''],['甲第连云','',''],['甲等','',''],['甲类','',''],['甲紫','',''],['甲级','',''],['甲级战犯','',''],['甲级队','',''],['甲肝','',''],['甲胄','',''],['甲胺磷','',''],['甲苯','',''],['甲虫','',''],['甲虫类','',''],['甲虫车','',''],['甲辰','',''],['甲酚','',''],['甲酸','',''],['甲醇','',''],['甲醇中毒','',''],['甲醚','',''],['甲醛','',''],['甲铠','',''],['甲骨','',''],['甲骨文','',''],['甲骨文字','',''],['甲鱼','',''],['申不害','',''],['申令','',''],['申冤','',''],['申办','',''],['申命记','',''],['申城','',''],['申奏','',''],['申屠','',''],['申报','',''],['申报单','',''],['申报者','',''],['申斥','',''],['申旦达夕','',''],['申明','',''],['申易','',''],['申曲','',''],['申根','',''],['申状','',''],['申猴','',''],['申理','',''],['申申','',''],['申言','',''],['申讨','',''],['申论','',''],['申诉','',''],['申诉书','',''],['申诉电话','',''],['申诫','',''],['申说','',''],['申请','',''],['申请书','',''],['申请人','',''],['申请表','',''],['申谢','',''],['申购','',''],['申辨','',''],['申辩','',''],['申述','',''],['申雪','',''],['申领','',''],['申饬','',''],['电业','',''],['电业局','',''],['电介体','',''],['电介质','',''],['电令','',''],['电价','',''],['电传','',''],['电传机','',''],['电位','',''],['电位器','',''],['电位差','',''],['电位计','',''],['电信号','',''],['电信局','',''],['电信工作','',''],['电信术','',''],['电信网路','',''],['电偶','',''],['电光','',''],['电光朝露','',''],['电光石火','',''],['电冰柜','',''],['电冰箱','',''],['电冶','',''],['电击','',''],['电击伤','',''],['电函','',''],['电刀','',''],['电刑','',''],['电刨','',''],['电刷','',''],['电力','',''],['电力供应','',''],['电力学','',''],['电力局','',''],['电力工业','',''],['电力机车','',''],['电力线','',''],['电力网','',''],['电功率','',''],['电功率表','',''],['电加工','',''],['电动','',''],['电动势','',''],['电动工具','',''],['电动机','',''],['电动船','',''],['电动葫芦','',''],['电动转盘','',''],['电势','',''],['电势差','',''],['电化','',''],['电化学','',''],['电化教学','',''],['电化教育','',''],['电匠','',''],['电匣子','',''],['电单车','',''],['电卷星飞','',''],['电卷风驰','',''],['电厂','',''],['电压','',''],['电压互感器','',''],['电压表','',''],['电压计','',''],['电台','',''],['电吉他','',''],['电吹风','',''],['电告','',''],['电唁','',''],['电唱','',''],['电唱头','',''],['电唱机','',''],['电唱盘','',''],['电嘴','',''],['电器','',''],['电器化','',''],['电器设备','',''],['电场','',''],['电塔','',''],['电声','',''],['电壶','',''],['电大','',''],['电子','',''],['电子产品','',''],['电子展','',''],['电子业','',''],['电子书','',''],['电子云','',''],['电子价','',''],['电子伏','',''],['电子伏特','',''],['电子信箱','',''],['电子元件','',''],['电子元器件','',''],['电子光学','',''],['电子化营业','',''],['电子商务','',''],['电子器件','',''],['电子型半导体','',''],['电子学','',''],['电子学系','',''],['电子宠物','',''],['电子对','',''],['电子层','',''],['电子层数','',''],['电子工业','',''],['电子工业部','',''],['电子工程','',''],['电子战','',''],['电子所','',''],['电子手表','',''],['电子技术','',''],['电子振兴办公室','',''],['电子数据交换','',''],['电子文件','',''],['电子显微镜','',''],['电子望远镜','',''],['电子束','',''],['电子束焊接','',''],['电子枪','',''],['电子流','',''],['电子游戏','',''],['电子狗','',''],['电子环保亭','',''],['电子琴','',''],['电子电路','',''],['电子盘','',''],['电子眼','',''],['电子科技大学','',''],['电子空间','',''],['电子管','',''],['电子网络','',''],['电子表','',''],['电子警察','',''],['电子计算机','',''],['电子论','',''],['电子货币','',''],['电子邮件','',''],['电子邮件传送服务','',''],['电子钟','',''],['电学','',''],['电容','',''],['电容器','',''],['电容量','',''],['电导','',''],['电导体','',''],['电导率','',''],['电工','',''],['电工学','',''],['电平','',''],['电度表','',''],['电度计','',''],['电弧','',''],['电弧焊','',''],['电弧焊接','',''],['电影','',''],['电影戏','',''],['电影制作','',''],['电影制片','',''],['电影剧','',''],['电影剧本','',''],['电影周','',''],['电影圈','',''],['电影奖','',''],['电影字幕','',''],['电影导演','',''],['电影工作者','',''],['电影摄影机','',''],['电影放映机','',''],['电影晚会','',''],['电影机','',''],['电影演员','',''],['电影界','',''],['电影票','',''],['电影节','',''],['电影院','',''],['电性','',''],['电感','',''],['电感器','',''],['电扇','',''],['电打','',''],['电打字机','',''],['电扶梯','',''],['电抗','',''],['电抗器','',''],['电抛光','',''],['电报','',''],['电报局','',''],['电报挂号','',''],['电报机','',''],['电报通知','',''],['电掣星驰','',''],['电掣风驰','',''],['电控','',''],['电教','',''],['电文','',''],['电料','',''],['电晕','',''],['电暖器','',''],['电木','',''],['电机','',''],['电机及电子学工程师联合会','',''],['电机师','',''],['电杆','',''],['电板','',''],['电极','',''],['电枢','',''],['电柜','',''],['电桥','',''],['电桨','',''],['电梯','',''],['电检','',''],['电棒','',''],['电椅','',''],['电死','',''],['电气','',''],['电气化','',''],['电气工程','',''],['电气石','',''],['电汇','',''],['电池','',''],['电波','',''],['电泳','',''],['电洽','',''],['电流','',''],['电流强度','',''],['电流表','',''],['电流计','',''],['电渗析','',''],['电渣炉','',''],['电渣焊','',''],['电源','',''],['电源供应器','',''],['电源插座','',''],['电源线','',''],['电滚子','',''],['电灌','',''],['电灌站','',''],['电火花','',''],['电火花加工','',''],['电灯','',''],['电灯架','',''],['电灯柱','',''],['电灯泡','',''],['电灯等','',''],['电灶','',''],['电炉','',''],['电烙铁','',''],['电烫','',''],['电热','',''],['电热器','',''],['电热毯','',''],['电焊','',''],['电焊机','',''],['电照明','',''],['电熨斗','',''],['电牌','',''],['电珠','',''],['电瓶','',''],['电瓶车','',''],['电瓷','',''],['电疗','',''],['电疗法','',''],['电眼','',''],['电石','',''],['电石气','',''],['电石灯','',''],['电码','',''],['电磁','',''],['电磁兼容性','',''],['电磁力','',''],['电磁噪声','',''],['电磁场','',''],['电磁学','',''],['电磁干扰','',''],['电磁感应','',''],['电磁振荡','',''],['电磁波','',''],['电磁流体力学','',''],['电磁理论','',''],['电磁相互作用','',''],['电磁脉冲','',''],['电磁说','',''],['电磁辐射','',''],['电磁铁','',''],['电磨','',''],['电示','',''],['电离','',''],['电离室','',''],['电离层','',''],['电离能','',''],['电离辐射','',''],['电站','',''],['电筒','',''],['电筒光','',''],['电算','',''],['电箱','',''],['电纸书','',''],['电纽','',''],['电线','',''],['电线匣','',''],['电线杆','',''],['电缆','',''],['电缆塔','',''],['电缆调制解调器','',''],['电网','',''],['电老虎','',''],['电育','',''],['电能','',''],['电脑','',''],['电脑与电话系统整合','',''],['电脑业者','',''],['电脑企业','',''],['电脑化','',''],['电脑操作','',''],['电脑断层扫描','',''],['电脑病毒','',''],['电脑系统','',''],['电脑绘图','',''],['电脑网','',''],['电脑网络','',''],['电脑网路','',''],['电脑语言','',''],['电脑软件','',''],['电脑辅助工程','',''],['电脑辅助教材','',''],['电脑辅助设计','',''],['电脑辅助设计与绘图','',''],['电脑部','',''],['电荒','',''],['电荷','',''],['电荷耦合','',''],['电荷耦合器件','',''],['电荷量','',''],['电表','',''],['电视','',''],['电视专题片','',''],['电视剧','',''],['电视发射塔','',''],['电视台','',''],['电视塔','',''],['电视广播','',''],['电视接收机','',''],['电视机','',''],['电视片','',''],['电视电话','',''],['电视真人秀节目','',''],['电视秀','',''],['电视网','',''],['电视节目','',''],['电视转播','',''],['电视连续剧','',''],['电视采访','',''],['电解','',''],['电解槽','',''],['电解法','',''],['电解液','',''],['电解电容器','',''],['电解质','',''],['电讯','',''],['电讯术','',''],['电话','',''],['电话交换机','',''],['电话亭','',''],['电话会议','',''],['电话信号','',''],['电话区号','',''],['电话区码','',''],['电话卡','',''],['电话号码','',''],['电话局','',''],['电话接线生','',''],['电话服务','',''],['电话机','',''],['电话簿','',''],['电话线','',''],['电话线路','',''],['电话网','',''],['电话网路','',''],['电话采访','',''],['电话铃声','',''],['电话门','',''],['电话间','',''],['电询','',''],['电谢','',''],['电贝斯','',''],['电负性','',''],['电费','',''],['电贺','',''],['电路','',''],['电路分析','',''],['电路图','',''],['电路板','',''],['电车','',''],['电转儿','',''],['电转盘','',''],['电邀','',''],['电邮','',''],['电邮位置','',''],['电邮地址','',''],['电量','',''],['电量表','',''],['电量计','',''],['电针疗法','',''],['电钟','',''],['电钮','',''],['电钻','',''],['电铃','',''],['电铲','',''],['电铸','',''],['电锅','',''],['电键','',''],['电锯','',''],['电镀','',''],['电镀品','',''],['电镐','',''],['电门','',''],['电闪','',''],['电闸','',''],['电阻','',''],['电阻器','',''],['电阻率','',''],['电阻箱','',''],['电阻表','',''],['电陈','',''],['电震','',''],['电音','',''],['电颤琴','',''],['电风扇','',''],['电饭煲','',''],['电饭锅','',''],['电驴子','',''],['电驿','',''],['电鳗','',''],['男中音','',''],['男主角','',''],['男亲属','',''],['男人','',''],['男人不坏','',''],['男人们','',''],['男人似','',''],['男人婆','',''],['男人家','',''],['男人膝下有黄金','',''],['男仆','',''],['男低音','',''],['男侍','',''],['男修道院长','',''],['男傧相','',''],['男像柱','',''],['男儿','',''],['男儿有泪不轻弹','',''],['男单','',''],['男厕','',''],['男厕所','',''],['男友','',''],['男双','',''],['男同','',''],['男同志','',''],['男名','',''],['男唱女随','',''],['男团','',''],['男基尼','',''],['男士','',''],['男声','',''],['男外套','',''],['男大当婚','',''],['男大须婚','',''],['男女','',''],['男女关系','',''],['男女双方','',''],['男女平等','',''],['男女授受不亲','',''],['男女有别','',''],['男女老少','',''],['男女老幼','',''],['男女队','',''],['男娃','',''],['男娼','',''],['男婚女娉','',''],['男婚女嫁','',''],['男婴','',''],['男媒女妁','',''],['男子','',''],['男子似','',''],['男子单','',''],['男子单打','',''],['男子双打','',''],['男子名','',''],['男子气','',''],['男子气概','',''],['男子汉','',''],['男子汉大丈夫','',''],['男子篮球','',''],['男学生','',''],['男孩','',''],['男孩乐队','',''],['男孩儿','',''],['男孩子','',''],['男室女家','',''],['男家','',''],['男宾','',''],['男尊女卑','',''],['男工','',''],['男左','',''],['男左女右','',''],['男巫','',''],['男式','',''],['男怕入错行','',''],['男性','',''],['男性主义','',''],['男性亲属','',''],['男性化','',''],['男性厌恶','',''],['男性素','',''],['男性贬抑','',''],['男才女貌','',''],['男扮女装','',''],['男排','',''],['男教师','',''],['男方','',''],['男星','',''],['男朋友','',''],['男服','',''],['男欢女爱','',''],['男演员','',''],['男爵','',''],['男生','',''],['男用','',''],['男男女女','',''],['男的','',''],['男盗女娼','',''],['男童','',''],['男管家','',''],['男篮','',''],['男系','',''],['男耕女织','',''],['男舍','',''],['男色','',''],['男装','',''],['男裤','',''],['男辈','',''],['男队','',''],['男青年','',''],['男高音','',''],['男高音部','',''],['甸园','',''],['甸子','',''],['画上','',''],['画下','',''],['画个圆','',''],['画中有诗','',''],['画为','',''],['画了','',''],['画于','',''],['画供','',''],['画像','',''],['画儿','',''],['画具','',''],['画册','',''],['画出','',''],['画刊','',''],['画到','',''],['画匠','',''],['画十字','',''],['画卷','',''],['画史','',''],['画品','',''],['画图','',''],['画圆','',''],['画圈','',''],['画地为牢','',''],['画地为狱','',''],['画地成图','',''],['画地而趋','',''],['画地自限','',''],['画坛','',''],['画境','',''],['画外','',''],['画外音','',''],['画字','',''],['画室','',''],['画家','',''],['画尺','',''],['画尽意在','',''],['画屏','',''],['画展','',''],['画工','',''],['画布','',''],['画师','',''],['画帖','',''],['画幅','',''],['画幕','',''],['画店','',''],['画廊','',''],['画开','',''],['画影图形','',''],['画得','',''],['画意诗情','',''],['画成','',''],['画报','',''],['画押','',''],['画插图者','',''],['画本','',''],['画板','',''],['画架','',''],['画栋雕梁','',''],['画框','',''],['画梁雕栋','',''],['画毡','',''],['画法','',''],['画法几何','',''],['画派','',''],['画片','',''],['画片儿','',''],['画瓢','',''],['画画','',''],['画界线','',''],['画的','',''],['画皮','',''],['画眉','',''],['画眉举案','',''],['画眉张敞','',''],['画眉鸟','',''],['画着','',''],['画知','',''],['画稿','',''],['画笔','',''],['画符','',''],['画策','',''],['画策设谋','',''],['画纸','',''],['画线','',''],['画线器','',''],['画脂镂冰','',''],['画舫','',''],['画荻教子','',''],['画虎不成反类犬','',''],['画虎不成反类狗','',''],['画虎成狗','',''],['画虎类犬','',''],['画蛇添足','',''],['画蛇著足','',''],['画行','',''],['画谜','',''],['画谱','',''],['画轮廓','',''],['画轴','',''],['画间','',''],['画阁朱楼','',''],['画阴影','',''],['画院','',''],['画面','',''],['画页','',''],['画饼','',''],['画饼充饥','',''],['画龙不成反为狗','',''],['画龙点睛','',''],['甾酮','',''],['畅书','',''],['畅叙','',''],['畅心','',''],['畅快','',''],['畅怀','',''],['畅想','',''],['畅所欲言','',''],['畅旺','',''],['畅流','',''],['畅游','',''],['畅行','',''],['畅行无阻','',''],['畅谈','',''],['畅谈话卡','',''],['畅达','',''],['畅通','',''],['畅通无阻','',''],['畅销','',''],['畅销书','',''],['畅销品','',''],['畅销货','',''],['畅饮','',''],['界乎','',''],['界于','',''],['界值','',''],['界内球','',''],['界别','',''],['界址','',''],['界外','',''],['界外球','',''],['界外线','',''],['界定','',''],['界尺','',''],['界层','',''],['界志','',''],['界标','',''],['界桩','',''],['界河','',''],['界点','',''],['界状','',''],['界石','',''],['界碑','',''],['界符','',''],['界第','',''],['界约','',''],['界线','',''],['界说','',''],['界限','',''],['界限量规','',''],['界面','',''],['畎亩','',''],['畎亩之中','',''],['畎母下才','',''],['畏之如虎','',''],['畏光','',''],['畏友','',''],['畏口','',''],['畏吓','',''],['畏天恤民','',''],['畏天爱民','',''],['畏天知命','',''],['畏威怀德','',''],['畏岁','',''],['畏影而走','',''],['畏忌','',''],['畏怯','',''],['畏惧','',''],['畏敬','',''],['畏死','',''],['畏死贪生','',''],['畏畏缩缩','',''],['畏神','',''],['畏缩','',''],['畏缩不前','',''],['畏罪','',''],['畏罪自杀','',''],['畏葸','',''],['畏葸不前','',''],['畏途','',''],['畏避','',''],['畏难','',''],['畏难情绪','',''],['畏难苟安','',''],['畏首畏尾','',''],['畏首畏足','',''],['畔援','',''],['留一手','',''],['留下','',''],['留个','',''],['留中不发','',''],['留了','',''],['留任','',''],['留传','',''],['留住','',''],['留余地','',''],['留作','',''],['留信','',''],['留党察看','',''],['留兰香','',''],['留军壁邺','',''],['留出','',''],['留别','',''],['留到','',''],['留医','',''],['留厂察看','',''],['留名','',''],['留后手','',''],['留后路','',''],['留园','',''],['留在','',''],['留地步','',''],['留声','',''],['留声机','',''],['留头','',''],['留存','',''],['留存收益','',''],['留学','',''],['留学生','',''],['留守','',''],['留守处','',''],['留客','',''],['留宿','',''],['留尼汪','',''],['留尾巴','',''],['留居','',''],['留底','',''],['留归','',''],['留影','',''],['留待','',''],['留得青山在','',''],['留心','',''],['留念','',''],['留恋','',''],['留恋不舍','',''],['留情','',''],['留意','',''],['留意到','',''],['留成','',''],['留成儿','',''],['留有','',''],['留有余地','',''],['留校','',''],['留校察看','',''],['留步','',''],['留治','',''],['留法','',''],['留洋','',''],['留海','',''],['留点','',''],['留班','',''],['留用','',''],['留痕迹','',''],['留白','',''],['留着','',''],['留神','',''],['留神听','',''],['留种','',''],['留种地','',''],['留空','',''],['留级','',''],['留给','',''],['留置','',''],['留置权','',''],['留美','',''],['留职','',''],['留职停薪','',''],['留芳千古','',''],['留芳百世','',''],['留解','',''],['留言','',''],['留言本','',''],['留言条','',''],['留言板','',''],['留言簿','',''],['流云','',''],['流云苍狗','',''],['留话','',''],['留起','',''],['留足','',''],['留连','',''],['留连果','',''],['留连论诗','',''],['留遗','',''],['留都','',''],['留针','',''],['留门','',''],['留难','',''],['留题','',''],['留饭','',''],['留饮','',''],['留香久','',''],['留驻','',''],['留鸟','',''],['畚斗','',''],['畚箕','',''],['畛域','',''],['畜产','',''],['畜产品','',''],['畜养','',''],['畜力','',''],['畜栏','',''],['畜牧','',''],['畜牧业','',''],['畜牧场','',''],['畜牧学','',''],['畜牲','',''],['畜生','',''],['畜疫','',''],['畜禽','',''],['畜类','',''],['畜羊','',''],['畜群','',''],['畜肥','',''],['畜舍内','',''],['略上','',''],['略感','',''],['略为','',''],['略举','',''],['略作','',''],['略先','',''],['略加','',''],['略去','',''],['略可','',''],['略同','',''],['略图','',''],['略地侵城','',''],['略地攻城','',''],['略大','',''],['略夺','',''],['略好','',''],['略嫌','',''],['略字','',''],['略宽','',''],['略小','',''],['略少','',''],['略带','',''],['略底','',''],['略异','',''],['略录','',''],['略后','',''],['略微','',''],['略慢','',''],['略懂','',''],['略提','',''],['略施','',''],['略显','',''],['略有','',''],['略有结余','',''],['略略','',''],['略白','',''],['略看','',''],['略知','',''],['略知一二','',''],['略知皮毛','',''],['略码','',''],['略示','',''],['略称','',''],['略等','',''],['略粗','',''],['略胜','',''],['略胜一筹','',''],['略表','',''],['略见','',''],['略见一斑','',''],['略记','',''],['略论','',''],['略识之无','',''],['略语','',''],['略说','',''],['略读','',''],['略读者','',''],['略轻','',''],['略过','',''],['略近','',''],['略远','',''],['略述','',''],['略迹原情','',''],['略逊','',''],['略释','',''],['略长','',''],['略高','',''],['略高一筹','',''],['略高于','',''],['畦灌','',''],['畦田','',''],['番人','',''],['番号','',''],['番天覆地','',''],['番属','',''],['番木','',''],['番木瓜','',''],['番木鳖','',''],['番来复去','',''],['番椒','',''],['番瓜','',''],['番番','',''],['番石榴','',''],['番禺','',''],['番红花','',''],['番茄','',''],['番茄汁','',''],['番茄汤','',''],['番茄红素','',''],['番茄酱','',''],['番荔枝','',''],['番菜','',''],['番薯','',''],['番路','',''],['番路乡','',''],['番邦','',''],['番麦','',''],['畲乡','',''],['畴人','',''],['畴咨之忧','',''],['畴昔','',''],['畴曲','',''],['畸人','',''],['畸变','',''],['畸型','',''],['畸型体','',''],['畸型物','',''],['畸形','',''],['畸形儿','',''],['畸形发展','',''],['畸形学','',''],['畸态','',''],['畸性','',''],['畸恋','',''],['畸胎','',''],['畸轻畸重','',''],['畸零','',''],['畹町','',''],['畹町市','',''],['畿辅','',''],['疆吏','',''],['疆土','',''],['疆场','',''],['疆域','',''],['疆埸','',''],['疆界','',''],['疍民','',''],['疏不见亲','',''],['疏不谋亲','',''],['疏不间亲','',''],['疏了','',''],['疏于','',''],['疏于防范','',''],['疏剪','',''],['疏勒国','',''],['疏备','',''],['疏失','',''],['疏学','',''],['疏宕不拘','',''],['疏定','',''],['疏密','',''],['疏导','',''],['疏开','',''],['疏忽','',''],['疏忽大意','',''],['疏忽职守','',''],['疏慵愚钝','',''],['疏懒','',''],['疏才仗义','',''],['疏挖','',''],['疏放','',''],['疏散','',''],['疏散措施','',''],['疏松','',''],['疏水','',''],['疏水箪瓢','',''],['疏浚','',''],['疏淡','',''],['疏漏','',''],['疏狂','',''],['疏率','',''],['疏理','',''],['疏略','',''],['疏疏','',''],['疏离','',''],['疏缝','',''],['疏而不失','',''],['疏而不漏','',''],['疏肝理气','',''],['疏落','',''],['疏虞','',''],['疏解','',''],['疏证','',''],['疏谋少略','',''],['疏财仗义','',''],['疏财尚气','',''],['疏财重义','',''],['疏远','',''],['疏通','',''],['疏阔','',''],['疏食饮水','',''],['疑为','',''],['疑义','',''],['疑事无功','',''],['疑事无功疑行无名','',''],['疑云','',''],['疑人勿使使人勿疑','',''],['疑人疑鬼','',''],['疑似','',''],['疑信参半','',''],['疑兵','',''],['疑冰','',''],['疑凶','',''],['疑团','',''],['疑心','',''],['疑心生暗鬼','',''],['疑心生鬼','',''],['疑心病','',''],['疑忌','',''],['疑念','',''],['疑惑','',''],['疑惧','',''],['疑案','',''],['疑点','',''],['疑犯','',''],['疑狱','',''],['疑病症','',''],['疑神疑鬼','',''],['疑神见鬼','',''],['疑窦','',''],['疑者','',''],['疑虑','',''],['疑行无名疑事无功','',''],['疑行无成疑事无功','',''],['疑问','',''],['疑问代词','',''],['疑问句','',''],['疑阵','',''],['疑难','',''],['疑难杂症','',''],['疑难解答','',''],['疑难问题','',''],['疑鬼疑神','',''],['疔疮','',''],['疖子','',''],['疖疮','',''],['疗伤','',''],['疗伤止痛','',''],['疗养','',''],['疗养所','',''],['疗养院','',''],['疗效','',''],['疗方','',''],['疗毒','',''],['疗法','',''],['疗疮剜肉','',''],['疗程','',''],['疗贫','',''],['疗饥','',''],['疙疙瘩瘩','',''],['疙疸','',''],['疙瘩','',''],['疚心疾首','',''],['疝气','',''],['疝气痛','',''],['疟原虫','',''],['疟子','',''],['疟涤平','',''],['疟疾','',''],['疟疾病','',''],['疟虫','',''],['疟蚊','',''],['疣状','',''],['疣猪','',''],['疣肿','',''],['疣赘','',''],['疤点','',''],['疤痕','',''],['疤瘌','',''],['疤瘌眼儿','',''],['疥疮','',''],['疥癞之患','',''],['疥癣','',''],['疥癣之疾','',''],['疥虫','',''],['疥蛤蟆','',''],['疥赖之疾','',''],['疫区','',''],['疫性','',''],['疫情','',''],['疫疠','',''],['疫病','',''],['疫苗','',''],['疮口','',''],['疮疤','',''],['疮痂','',''],['疮痍','',''],['疮痍满目','',''],['疮痕','',''],['疯了','',''],['疯人','',''],['疯人院','',''],['疯似','',''],['疯去','',''],['疯女','',''],['疯子','',''],['疯杈','',''],['疯枝','',''],['疯牛病','',''],['疯犬','',''],['疯狂','',''],['疯狂似','',''],['疯狂般','',''],['疯狗','',''],['疯疯癫癫','',''],['疯病','',''],['疯症','',''],['疯瘫','',''],['疯癫','',''],['疯话','',''],['疯长','',''],['疯魔','',''],['疰夏','',''],['疱代','',''],['疱疹','',''],['疱疹病毒','',''],['疲乏','',''],['疲于','',''],['疲于奔命','',''],['疲倦','',''],['疲倦不堪','',''],['疲倦了','',''],['疲劳','',''],['疲劳力学','',''],['疲劳强度','',''],['疲劳极限','',''],['疲劳症','',''],['疲匮','',''],['疲困','',''],['疲塌','',''],['疲弱','',''],['疲惫','',''],['疲惫不堪','',''],['疲惫感','',''],['疲敝','',''],['疲沓','',''],['疲癃','',''],['疲竭','',''],['疲累','',''],['疲软','',''],['疲顿','',''],['疳疮','',''],['疵点','',''],['疵瑕','',''],['疵议','',''],['疵谬','',''],['疸病','',''],['疹子','',''],['疼不','',''],['疼心泣血','',''],['疼惜','',''],['疼死','',''],['疼爱','',''],['疼痛','',''],['疽热','',''],['疽病','',''],['疾世愤俗','',''],['疾之如仇','',''],['疾之若仇','',''],['疾书','',''],['疾呼','',''],['疾声厉色','',''],['疾声大呼','',''],['疾如旋踵','',''],['疾如雷电','',''],['疾恶好善','',''],['疾恶如仇','',''],['疾恶若仇','',''],['疾患','',''],['疾控中心','',''],['疾步','',''],['疾病','',''],['疾病控制中心','',''],['疾病突发','',''],['疾病预防中心','',''],['疾痛惨怛','',''],['疾苦','',''],['疾行','',''],['疾言','',''],['疾言厉色','',''],['疾言遽色','',''],['疾走','',''],['疾足先得','',''],['疾跑','',''],['疾速','',''],['疾雷不及塞耳','',''],['疾雷不及掩耳','',''],['疾风','',''],['疾风劲草','',''],['疾风扫落叶','',''],['疾风暴雨','',''],['疾风甚雨','',''],['疾风知劲草','',''],['疾风骤雨','',''],['疾飞','',''],['疾首','',''],['疾首痛心','',''],['疾首蹙额','',''],['疾驰','',''],['疾驰而过','',''],['疾驱','',''],['疾驶','',''],['痄腮','',''],['病中','',''],['病了','',''],['病事假','',''],['病人','',''],['病人用','',''],['病从口入','',''],['病休','',''],['病体','',''],['病例','',''],['病倒','',''],['病候','',''],['病假','',''],['病兆','',''],['病入膏肓','',''],['病况','',''],['病势','',''],['病包儿','',''],['病区','',''],['病危','',''],['病历','',''],['病厌厌','',''],['病原','',''],['病原体','',''],['病原性','',''],['病原菌','',''],['病原虫','',''],['病去如抽丝','',''],['病友','',''],['病发','',''],['病变','',''],['病史','',''],['病号','',''],['病名','',''],['病员','',''],['病啦','',''],['病因','',''],['病因子','',''],['病因学','',''],['病国殃民','',''],['病在膏肓','',''],['病夫','',''],['病媒','',''],['病学','',''],['病室','',''],['病害','',''],['病家','',''],['病容','',''],['病床','',''],['病弱','',''],['病弱者','',''],['病征','',''],['病得','',''],['病态','',''],['病态肥胖','',''],['病急乱投医','',''],['病恹恹','',''],['病患','',''],['病情','',''],['病情复发','',''],['病情恶化','',''],['病愈','',''],['病房','',''],['病故','',''],['病机','',''],['病来如山倒','',''],['病染膏肓','',''],['病株','',''],['病根','',''],['病案','',''],['病榻','',''],['病死','',''],['病残','',''],['病毒','',''],['病毒学','',''],['病毒学家','',''],['病毒式营销','',''],['病毒性','',''],['病毒性肝炎','',''],['病毒性营销','',''],['病毒感染','',''],['病毒科','',''],['病毒营销','',''],['病毒血症','',''],['病民害国','',''],['病民蛊国','',''],['病源','',''],['病灶','',''],['病状','',''],['病狂丧心','',''],['病理','',''],['病理上','',''],['病理学','',''],['病理学家','',''],['病理学者','',''],['病由口入','',''],['病病歪歪','',''],['病症','',''],['病痛','',''],['病的','',''],['病科','',''],['病程','',''],['病笃','',''],['病粒','',''],['病者','',''],['病脉','',''],['病药','',''],['病菌','',''],['病虫','',''],['病虫害','',''],['病象','',''],['病身','',''],['病退','',''],['病逝','',''],['病邪','',''],['病重','',''],['病院','',''],['病魔','',''],['病魔缠身','',''],['症侯','',''],['症侯群','',''],['症候','',''],['症候群','',''],['症像','',''],['症状','',''],['症状性','',''],['症结','',''],['症象','',''],['痈疽','',''],['痉挛','',''],['痊愈','',''],['痒疹','',''],['痒症','',''],['痒痒','',''],['痒痒挠','',''],['痒的很','',''],['痔漏','',''],['痔疮','',''],['痔疾','',''],['痕迹','',''],['痕量','',''],['痘浆','',''],['痘疮','',''],['痘疱','',''],['痘痂','',''],['痘痕','',''],['痘瘢','',''],['痘苗','',''],['痛不堪忍','',''],['痛不欲生','',''],['痛中','',''],['痛之入骨','',''],['痛入骨髓','',''],['痛击','',''],['痛切','',''],['痛切心骨','',''],['痛哭','',''],['痛哭失声','',''],['痛哭流涕','',''],['痛处','',''],['痛失','',''],['痛失良机','',''],['痛定思痛','',''],['痛彻心肺','',''],['痛彻心腑','',''],['痛彻骨髓','',''],['痛心','',''],['痛心入骨','',''],['痛心切齿','',''],['痛心刻骨','',''],['痛心泣血','',''],['痛心疾首','',''],['痛快','',''],['痛快淋漓','',''],['痛性痉挛','',''],['痛恨','',''],['痛恶','',''],['痛悔','',''],['痛悼','',''],['痛惜','',''],['痛惩','',''],['痛感','',''],['痛成','',''],['痛打','',''],['痛批','',''],['痛抱西河','',''],['痛改前非','',''],['痛斥','',''],['痛样','',''],['痛楚','',''],['痛楚彻骨','',''],['痛殴','',''],['痛毁前非','',''],['痛毁极诋','',''],['痛涤前非','',''],['痛痒','',''],['痛痒相关','',''],['痛痛快快','',''],['痛痹','',''],['痛砭','',''],['痛砭时弊','',''],['痛经','',''],['痛自','',''],['痛苦','',''],['痛觉','',''],['痛话','',''],['痛责','',''],['痛风','',''],['痛饮','',''],['痛饮黄龙','',''],['痛骂','',''],['痞块','',''],['痞子','',''],['痞子蔡','',''],['痞积','',''],['痢特灵','',''],['痢疾','',''],['痤疮','',''],['痦子','',''],['痧子','',''],['痨病','',''],['痰厥','',''],['痰喘','',''],['痰桶','',''],['痰气','',''],['痰液','',''],['痰盂','',''],['痰盂儿','',''],['痰盂式','',''],['痰筒','',''],['痰迷心窍','',''],['痱子','',''],['痱子粉','',''],['痲疹','',''],['痲痹','',''],['痴人','',''],['痴人痴福','',''],['痴人说梦','',''],['痴傻','',''],['痴呆','',''],['痴呆懵懂','',''],['痴呆症','',''],['痴子','',''],['痴心','',''],['痴心女子负心汉','',''],['痴心妄想','',''],['痴心妇人负心汉','',''],['痴心梦想','',''],['痴恋','',''],['痴情','',''],['痴想','',''],['痴男怨女','',''],['痴痴','',''],['痴笑','',''],['痴肥','',''],['痴迷','',''],['痴迷不悟','',''],['痴醉','',''],['痴长','',''],['痴騃','',''],['痹证','',''],['痼习','',''],['痼疾','',''],['痼癖','',''],['瘀伤','',''],['瘀泥','',''],['瘀滞','',''],['瘀积','',''],['瘀血','',''],['瘀青','',''],['瘅恶彰善','',''],['瘅疟','',''],['瘊子','',''],['瘌痢','',''],['瘌痢头','',''],['瘗玉埋香','',''],['瘘管','',''],['瘙痒','',''],['瘙痒病','',''],['瘙痒症','',''],['瘛疭','',''],['瘟疫','',''],['瘟疹','',''],['瘟病','',''],['瘟神','',''],['瘠人肥己','',''],['瘠地','',''],['瘠己肥人','',''],['瘠牛偾豚','',''],['瘠田','',''],['瘠薄','',''],['瘢点','',''],['瘢痕','',''],['瘤块','',''],['瘤子','',''],['瘤牛','',''],['瘤病','',''],['瘤胃','',''],['瘦人','',''],['瘦削','',''],['瘦商百富','',''],['瘦子','',''],['瘦小','',''],['瘦弱','',''],['瘦得','',''],['瘦果','',''],['瘦溜','',''],['瘦煤','',''],['瘦瘠','',''],['瘦瘦','',''],['瘦瘪','',''],['瘦的','',''],['瘦肉','',''],['瘦肉精','',''],['瘦脊','',''],['瘦脸','',''],['瘦身','',''],['瘦长','',''],['瘦马','',''],['瘦骨伶仃','',''],['瘦骨如柴','',''],['瘦骨嶙峋','',''],['瘩背','',''],['瘪三','',''],['瘪嘴','',''],['瘪螺痧','',''],['瘪陷','',''],['瘫坐','',''],['瘫子','',''],['瘫痪','',''],['瘫软','',''],['瘭疽','',''],['瘰疬','',''],['瘰螈','',''],['瘴气','',''],['瘴疠','',''],['瘸子','',''],['瘸腿','',''],['瘸行','',''],['瘾君子','',''],['瘾头','',''],['瘾头儿','',''],['癀病','',''],['癃闭','',''],['癌变','',''],['癌学','',''],['癌状','',''],['癌病','',''],['癌症','',''],['癌瘤','',''],['癌细胞','',''],['癌肿','',''],['癔病','',''],['癖好','',''],['癖性','',''],['癞子','',''],['癞瓜','',''],['癞疮','',''],['癞病','',''],['癞癣','',''],['癞皮狗','',''],['癞皮病','',''],['癞蛤蟆','',''],['癞蛤蟆想吃天鹅肉','',''],['癣疥','',''],['癣疥之疾','',''],['癫状','',''],['癫狂','',''],['癫痫','',''],['癫间','',''],['癫风','',''],['癯瘦','',''],['癸丑','',''],['癸亥','',''],['癸卯','',''],['癸巳','',''],['癸未','',''],['癸酉','',''],['登上','',''],['登临','',''],['登乘','',''],['登仙','',''],['登位','',''],['登入','',''],['登出','',''],['登出来','',''],['登台','',''],['登台拜将','',''],['登台献艺','',''],['登台表演','',''],['登在','',''],['登场','',''],['登坛拜将','',''],['登基','',''],['登堂入室','',''],['登天','',''],['登山','',''],['登山临水','',''],['登山家','',''],['登山小鲁','',''],['登山杖','',''],['登山涉水','',''],['登山蓦岭','',''],['登山越岭','',''],['登山运动','',''],['登山队','',''],['登岸','',''],['登峰','',''],['登峰造极','',''],['登帐','',''],['登广','',''],['登广告','',''],['登庸','',''],['登庸人才','',''],['登录','',''],['登录档','',''],['登录项','',''],['登徒子','',''],['登报','',''],['登攀','',''],['登时','',''],['登月','',''],['登月舱','',''],['登机','',''],['登机入口','',''],['登机口','',''],['登机廊桥','',''],['登机手续','',''],['登机手续柜台','',''],['登机桥','',''],['登机楼','',''],['登机牌','',''],['登机证','',''],['登机门','',''],['登极','',''],['登楼','',''],['登科','',''],['登程','',''],['登第','',''],['登级','',''],['登船','',''],['登记','',''],['登记册','',''],['登记名','',''],['登记吨','',''],['登记员','',''],['登记处','',''],['登记用户','',''],['登记簿','',''],['登记者','',''],['登记表','',''],['登账','',''],['登轮','',''],['登载','',''],['登遐','',''],['登门','',''],['登门拜访','',''],['登陆','',''],['登陆场','',''],['登陆月球','',''],['登陆舰','',''],['登陆艇','',''],['登革热','',''],['登革疫苗','',''],['登革病毒','',''],['登高','',''],['登高一呼','',''],['登高望远','',''],['登高能赋','',''],['登高自卑','',''],['登龙门','',''],['白丁','',''],['白丁俗客','',''],['白三叶草','',''],['白下','',''],['白不呲咧','',''],['白专','',''],['白乳胶','',''],['白事','',''],['白云','',''],['白云亲舍','',''],['白云孤飞','',''],['白云山','',''],['白云岩','',''],['白云机场','',''],['白云母','',''],['白云石','',''],['白云苍狗','',''],['白人','',''],['白令','',''],['白令海','',''],['白令海峡','',''],['白体','',''],['白佛','',''],['白俄','',''],['白俄罗斯人','',''],['白做','',''],['白僵蚕','',''],['白先勇','',''],['白光','',''],['白兔','',''],['白党','',''],['白兰','',''],['白兰地','',''],['白兰地酒','',''],['白兰瓜','',''],['白兰花','',''],['白内障','',''],['白军','',''],['白冰冰','',''],['白净','',''],['白刃','',''],['白刃战','',''],['白刃格斗','',''],['白切鸡','',''],['白化','',''],['白化病','',''],['白化症','',''],['白匪','',''],['白区','',''],['白华之怨','',''],['白卫军','',''],['白卷','',''],['白厅','',''],['白发','',''],['白发人送黑发人','',''],['白发朱颜','',''],['白发相守','',''],['白发红颜','',''],['白发苍苍','',''],['白发苍颜','',''],['白发青衫','',''],['白叟黄童','',''],['白口','',''],['白口铁','',''],['白吃','',''],['白吃白喝','',''],['白唇鹿','',''],['白喉','',''],['白喉杆菌','',''],['白喉毒素','',''],['白喝','',''],['白嘴儿','',''],['白土子','',''],['白地','',''],['白坐','',''],['白垩','',''],['白垩世','',''],['白垩系','',''],['白垩纪','',''],['白城地区','',''],['白堤','',''],['白塔','',''],['白塔寺','',''],['白壁','',''],['白夜','',''],['白大褂','',''],['白天','',''],['白天黑夜','',''],['白头','',''],['白头之叹','',''],['白头偕老','',''],['白头到老','',''],['白头发','',''],['白头如新','',''],['白头山','',''],['白头相守','',''],['白头翁','',''],['白头鸟','',''],['白头鹎','',''],['白头鹰','',''],['白契','',''],['白奴','',''],['白如','',''],['白娘子','',''],['白嫩','',''],['白字','',''],['白学','',''],['白安居','',''],['白宫','',''],['白宫群英','',''],['白居易','',''],['白屈菜','',''],['白屋寒门','',''],['白山宗','',''],['白山派','',''],['白山黑水','',''],['白崇禧','',''],['白布','',''],['白帝城','',''],['白带','',''],['白干','',''],['白干儿','',''],['白底','',''],['白开水','',''],['白忙','',''],['白手','',''],['白手成家','',''],['白手起家','',''],['白打','',''],['白扔','',''],['白托','',''],['白扯淡','',''],['白扯蛋','',''],['白报纸','',''],['白拣','',''],['白描','',''],['白搭','',''],['白撞','',''],['白文','',''],['白斑','',''],['白斑病','',''],['白旄黄钺','',''],['白族吹吹腔','',''],['白旗','',''],['白日','',''],['白日做梦','',''],['白日升天','',''],['白日撞','',''],['白日梦','',''],['白日衣绣','',''],['白日见鬼','',''],['白昼','',''],['白晃晃','',''],['白晓燕','',''],['白暨豚','',''],['白朗宁','',''],['白朗起义','',''],['白木','',''],['白木耳','',''],['白术','',''],['白朴','',''],['白条','',''],['白条猪','',''],['白杨','',''],['白杨树','',''],['白板','',''],['白板天子','',''],['白板笔','',''],['白果','',''],['白果儿','',''],['白核','',''],['白案','',''],['白桦','',''],['白梨','',''],['白棉纸','',''],['白榴石','',''],['白死','',''],['白毛','',''],['白毛女','',''],['白毛风','',''],['白毫之赐','',''],['白水晶','',''],['白水江自然保护区','',''],['白水泥','',''],['白求恩','',''],['白汤','',''],['白沙','',''],['白沙乡','',''],['白沙县','',''],['白沙工农区','',''],['白沙瓦','',''],['白沫','',''],['白河镇','',''],['白泽','',''],['白洋淀','',''],['白活','',''],['白浆','',''],['白浊','',''],['白浪','',''],['白海','',''],['白灰','',''],['白点','',''],['白炽','',''],['白炽灯','',''],['白炽电灯','',''],['白热','',''],['白热化','',''],['白煤','',''],['白熊','',''],['白片','',''],['白狐','',''],['白猪','',''],['白玉微瑕','',''],['白玉无瑕','',''],['白班','',''],['白班儿','',''],['白璧微瑕','',''],['白璧无瑕','',''],['白璧青蝇','',''],['白瓷','',''],['白痢','',''],['白痴','',''],['白癜疯','',''],['白癜风','',''],['白癣','',''],['白癫风','',''],['白白','',''],['白的','',''],['白皑皑','',''],['白皙','',''],['白皮','',''],['白皮书','',''],['白皮松','',''],['白目','',''],['白相','',''],['白眉拳','',''],['白眉赤眼','',''],['白眼','',''],['白眼珠','',''],['白眼珠儿','',''],['白矮星','',''],['白石','',''],['白石砬子','',''],['白矾','',''],['白砂糖','',''],['白砒','',''],['白碑','',''],['白碱滩','',''],['白磷','',''],['白票','',''],['白秃风','',''],['白秆','',''],['白种','',''],['白种人','',''],['白简','',''],['白米','',''],['白粉','',''],['白粉病','',''],['白粥','',''],['白糖','',''],['白素贞','',''],['白纱','',''],['白纸','',''],['白纸黑字','',''],['白线','',''],['白细','',''],['白细胞','',''],['白给','',''],['白羊','',''],['白羊座','',''],['白羊朝','',''],['白翎岛','',''],['白翎面','',''],['白翳','',''],['白者','',''],['白肉','',''],['白肤','',''],['白胡椒','',''],['白脱牛奶','',''],['白脸','',''],['白色','',''],['白色人种','',''],['白色体','',''],['白色恐怖','',''],['白色情人节','',''],['白色战剂','',''],['白色香橙花','',''],['白芍','',''],['白芝麻','',''],['白芨','',''],['白花','',''],['白花花','',''],['白花蛇','',''],['白花蛇舌草','',''],['白花齐放','',''],['白芷','',''],['白苋','',''],['白苋紫茄','',''],['白苏','',''],['白茅','',''],['白茫茫','',''],['白药','',''],['白莲','',''],['白莲教','',''],['白菊','',''],['白菜','',''],['白菜价','',''],['白菜型油菜','',''],['白菜类蔬菜','',''],['白菜豆','',''],['白萝卜','',''],['白葡萄酒','',''],['白蒙蒙','',''],['白蔹','',''],['白薯','',''],['白藤','',''],['白虎','',''],['白虎通','',''],['白虫','',''],['白虹贯日','',''],['白蚁','',''],['白蛇','',''],['白蛇传','',''],['白蛉','',''],['白蛉热','',''],['白蛋白','',''],['白蜡','',''],['白蜡明经','',''],['白蜡杆子','',''],['白蜡树','',''],['白蜡虫','',''],['白血球','',''],['白血病','',''],['白行简','',''],['白衣','',''],['白衣公卿','',''],['白衣卿相','',''],['白衣天使','',''],['白衣宰相','',''],['白衣战士','',''],['白衣秀士','',''],['白衣苍狗','',''],['白裙','',''],['白话','',''],['白话文','',''],['白话诗','',''],['白豆蔻','',''],['白质','',''],['白费','',''],['白费力气','',''],['白费唇舌','',''],['白费心机','',''],['白赔','',''],['白起','',''],['白跑一趟','',''],['白车','',''],['白送','',''],['白道','',''],['白酒','',''],['白醋','',''],['白醭','',''],['白里透红','',''],['白金','',''],['白金汉宫','',''],['白金汉郡','',''],['白钢','',''],['白钨矿','',''],['白铁','',''],['白铁皮','',''],['白铁矿','',''],['白铅矿','',''],['白铜','',''],['白银书','',''],['白镪','',''],['白镴','',''],['白附','',''],['白附片','',''],['白陶','',''],['白雪','',''],['白雪公主','',''],['白雪皑皑','',''],['白雪纷飞','',''],['白雪阳春','',''],['白霜','',''],['白面','',''],['白面书生','',''],['白面儿','',''],['白页','',''],['白领','',''],['白领工人','',''],['白领阶级','',''],['白颊','',''],['白食','',''],['白饭','',''],['白首','',''],['白首一节','',''],['白首之心','',''],['白首北面','',''],['白首同归','',''],['白首如新','',''],['白首无成','',''],['白首相知','',''],['白首穷经','',''],['白首空归','',''],['白香词谱','',''],['白马','',''],['白马寺','',''],['白马王子','',''],['白马雪山','',''],['白马非马','',''],['白驹空谷','',''],['白驹过隙','',''],['白骨','',''],['白骨精','',''],['白骨顶','',''],['白鬼','',''],['白鬼笔','',''],['白鱼','',''],['白鱼入舟','',''],['白鲞','',''],['白鲸','',''],['白鳍豚','',''],['白鳗','',''],['白鳝','',''],['白鳞鱼','',''],['白鹄','',''],['白鹅','',''],['白鹇','',''],['白鹤','',''],['白鹤拳','',''],['白鹤梁','',''],['白鹭','',''],['白鹳','',''],['白麻子','',''],['白黑','',''],['白黑分明','',''],['白鼠','',''],['白鼻子','',''],['白龙微服','',''],['白龙鱼服','',''],['百万','',''],['百万个','',''],['百万买宅千万买邻','',''],['百万位','',''],['百万倍','',''],['百万吨','',''],['百万吨级','',''],['百万吨级核武器','',''],['百万富翁','',''],['百万赫兹','',''],['百万雄兵','',''],['百万雄狮','',''],['百丈','',''],['百丈竿头','',''],['百不一失','',''],['百不一爽','',''],['百不一遇','',''],['百不咋','',''],['百不失一','',''],['百不当一','',''],['百不杂','',''],['百世','',''],['百世不易','',''],['百世不磨','',''],['百世之利','',''],['百世之师','',''],['百世师','',''],['百世流芳','',''],['百个','',''],['百中','',''],['百中百发','',''],['百举百全','',''],['百乐餐','',''],['百事俱废','',''],['百事可乐','',''],['百事大吉','',''],['百事无成','',''],['百事轻怡','',''],['百事通','',''],['百二关山','',''],['百二山河','',''],['百五','',''],['百代文宗','',''],['百代过客','',''],['百份','',''],['百伶百俐','',''],['百位','',''],['百余','',''],['百依百随','',''],['百依百顺','',''],['百保利','',''],['百倍','',''],['百儿八十','',''],['百元','',''],['百克','',''],['百兵列阵','',''],['百兽','',''],['百兽率舞','',''],['百几个','',''],['百出','',''],['百分','',''],['百分之','',''],['百分之一','',''],['百分之一百','',''],['百分之百','',''],['百分制','',''],['百分号','',''],['百分尺','',''],['百分数','',''],['百分比','',''],['百分点','',''],['百分率','',''],['百分百','',''],['百分表','',''],['百利甜','',''],['百利甜酒','',''],['百动不如一静','',''],['百十','',''],['百升','',''],['百卉千葩','',''],['百卉含英','',''],['百发百中','',''],['百口莫辩','',''],['百口难分','',''],['百叶','',''],['百叶窗','',''],['百叶箱','',''],['百合','',''],['百合子','',''],['百合科','',''],['百合花','',''],['百合花饰','',''],['百名','',''],['百吨','',''],['百听不厌','',''],['百响','',''],['百商','',''],['百善孝为先','',''],['百喙莫辩','',''],['百回','',''],['百团大战','',''],['百城之富','',''],['百堵皆作','',''],['百姓','',''],['百姿千态','',''],['百威','',''],['百威啤酒','',''],['百媚千娇','',''],['百孔','',''],['百孔千创','',''],['百孔千疮','',''],['百官','',''],['百家','',''],['百家乐','',''],['百家争呜','',''],['百家争鸣','',''],['百家姓','',''],['百家诸子','',''],['百尺','',''],['百尺竿头','',''],['百岁','',''],['百岁之后','',''],['百岁千秋','',''],['百岁老人','',''],['百川归海','',''],['百巧千穷','',''],['百巧成穷','',''],['百帕','',''],['百年','',''],['百年不遇','',''],['百年之业','',''],['百年之后','',''],['百年之好','',''],['百年之柄','',''],['百年偕老','',''],['百年到老','',''],['百年大计','',''],['百年战争','',''],['百年树人','',''],['百年谐老','',''],['百应','',''],['百废','',''],['百废俱举','',''],['百废俱兴','',''],['百废具兴','',''],['百废备举','',''],['百废待举','',''],['百废待兴','',''],['百度币','',''],['百度百科','',''],['百度知道','',''],['百弊','',''],['百弊丛生','',''],['百强','',''],['百忙','',''],['百忙之中','',''],['百忙当中','',''],['百念俱灰','',''],['百念皆灰','',''],['百态','',''],['百思','',''],['百思不得其解','',''],['百思不解','',''],['百思买','',''],['百思而不得其解','',''],['百思莫解','',''],['百怪','',''],['百总','',''],['百感','',''],['百感交集','',''],['百慕','',''],['百慕大三角','',''],['百戏','',''],['百战','',''],['百战不殆','',''],['百战奇略','',''],['百战百胜','',''],['百折','',''],['百折不回','',''],['百折不挠','',''],['百挑不厌','',''],['百无一失','',''],['百无一是','',''],['百无一漏','',''],['百无一用','',''],['百无一能','',''],['百无所忌','',''],['百无所成','',''],['百无禁忌','',''],['百无聊赖','',''],['百日','',''],['百日咳','',''],['百日战争','',''],['百日王朝','',''],['百日维新','',''],['百日草','',''],['百日菊','',''],['百果','',''],['百步','',''],['百步无轻担','',''],['百步穿杨','',''],['百死一生','',''],['百济','',''],['百渡','',''],['百灵','',''],['百灵百验','',''],['百灵鸟','',''],['百炼','',''],['百炼之钢','',''],['百炼刚','',''],['百炼千锤','',''],['百炼成钢','',''],['百煅千炼','',''],['百物','',''],['百病','',''],['百盒','',''],['百看不厌','',''],['百眼巨人','',''],['百磅','',''],['百福具臻','',''],['百科','',''],['百科事典','',''],['百科全书','',''],['百科全书派','',''],['百科知识','',''],['百科词典','',''],['百端交集','',''],['百端待举','',''],['百米','',''],['百米赛跑','',''],['百粤','',''],['百紫千红','',''],['百纵千随','',''],['百老汇','',''],['百胜','',''],['百胜餐饮','',''],['百胜餐饮集团','',''],['百脚','',''],['百舌之声','',''],['百舌鸟','',''],['百舍重茧','',''],['百舍重趼','',''],['百般','',''],['百般刁难','',''],['百般奉承','',''],['百般巴结','',''],['百般挑剔','',''],['百色地区','',''],['百色起义','',''],['百花','',''],['百花争艳','',''],['百花园','',''],['百花奖','',''],['百花盛开','',''],['百花齐放','',''],['百草','',''],['百草枯','',''],['百行','',''],['百衲本','',''],['百衲衣','',''],['百褶裙','',''],['百计','',''],['百计千心','',''],['百计千方','',''],['百计千谋','',''],['百读不厌','',''],['百谋千计','',''],['百谷','',''],['百货','',''],['百货公司','',''],['百货商场','',''],['百货商店','',''],['百货大厦','',''],['百货大楼','',''],['百货店','',''],['百越','',''],['百足','',''],['百足不僵','',''],['百足之虫死而不僵','',''],['百足之虫至死不僵','',''],['百身何赎','',''],['百身莫赎','',''],['百部','',''],['百里','',''],['百里才','',''],['百里挑一','',''],['百里者半九十','',''],['百里香','',''],['百金花','',''],['百问不烦','',''],['百闻不如一见','',''],['百页窗','',''],['百顺百依','',''],['百香','',''],['百香果','',''],['百鸟朝凤','',''],['百龄','',''],['百龄眉寿','',''],['百龙之智','',''],['皂丝麻线','',''],['皂化','',''],['皂液','',''],['皂片','',''],['皂白','',''],['皂皮树','',''],['皂盒','',''],['皂石','',''],['皂矾','',''],['皂碱','',''],['皂荚','',''],['皂荚树','',''],['皂角','',''],['皂隶','',''],['的哥','',''],['的士','',''],['的士高','',''],['的当','',''],['的款','',''],['的确','',''],['的确良','',''],['的话','',''],['的黎波里','',''],['皆不','',''],['皆为','',''],['皆以','',''],['皆佳','',''],['皆兵','',''],['皆可','',''],['皆因','',''],['皆大','',''],['皆大欢喜','',''],['皆巳','',''],['皆无','',''],['皆是','',''],['皆有','',''],['皆然','',''],['皆白','',''],['皆知','',''],['皆空','',''],['皆纵即逝','',''],['皆输','',''],['皇上','',''],['皇亲国戚','',''],['皇位','',''],['皇储','',''],['皇党','',''],['皇军','',''],['皇冠','',''],['皇冠上的明珠','',''],['皇冠假日酒店','',''],['皇冠出版','',''],['皇冠出版集团','',''],['皇历','',''],['皇古','',''],['皇后','',''],['皇后区','',''],['皇城','',''],['皇堡','',''],['皇天','',''],['皇天不亲惟德是辅','',''],['皇天不负苦心人','',''],['皇天后土','',''],['皇太','',''],['皇太后','',''],['皇太子','',''],['皇太极','',''],['皇太极清太宗','',''],['皇女','',''],['皇姑','',''],['皇姑屯事件','',''],['皇子','',''],['皇室','',''],['皇宫','',''],['皇家','',''],['皇家加勒比海游轮公司','',''],['皇家学会','',''],['皇家海军','',''],['皇家香港警察','',''],['皇家马德里','',''],['皇家骑警','',''],['皇帝','',''],['皇帝的新衣','',''],['皇帝菜','',''],['皇庄','',''],['皇恩','',''],['皇族','',''],['皇族内阁','',''],['皇朝','',''],['皇权','',''],['皇甫','',''],['皇甫嵩','',''],['皇甫镈','',''],['皇皇','',''],['皇粮','',''],['皇统','',''],['皇陵','',''],['皇马','',''],['皈依','',''],['皈依者','',''],['皎厉','',''],['皎月','',''],['皎洁','',''],['皎白','',''],['皎皎','',''],['皎皎者易污','',''],['皑皑','',''],['皒皒','',''],['皓月','',''],['皓白','',''],['皓矾','',''],['皓首','',''],['皓首穷经','',''],['皓首苍颜','',''],['皓齿','',''],['皓齿明眸','',''],['皓齿星眸','',''],['皓齿朱唇','',''],['皓齿蛾眉','',''],['皖北','',''],['皖南','',''],['皖南事变','',''],['皖系军阀','',''],['皖系战败','',''],['皮下','',''],['皮下注射','',''],['皮下的','',''],['皮下组织','',''],['皮之不存','',''],['皮之不存毛将焉傅','',''],['皮件','',''],['皮傅','',''],['皮儿','',''],['皮克斯','',''],['皮克林','',''],['皮具','',''],['皮内注射','',''],['皮划艇','',''],['皮划艇激流回旋','',''],['皮划艇静水','',''],['皮制','',''],['皮制品','',''],['皮包','',''],['皮包公司','',''],['皮包骨','',''],['皮包骨头','',''],['皮匠','',''],['皮卡尔','',''],['皮厚','',''],['皮囊','',''],['皮围','',''],['皮围巾','',''],['皮圈','',''],['皮垫','',''],['皮埃尔','',''],['皮塔饼','',''],['皮壳','',''],['皮外','',''],['皮夹','',''],['皮夹子','',''],['皮套','',''],['皮子','',''],['皮实','',''],['皮尔森','',''],['皮尺','',''],['皮层','',''],['皮层下失语症','',''],['皮层性','',''],['皮层性视损伤','',''],['皮屑','',''],['皮带','',''],['皮带传动','',''],['皮带扣','',''],['皮带轮','',''],['皮带运输机','',''],['皮帽','',''],['皮开肉破','',''],['皮开肉绽','',''],['皮开肉锭','',''],['皮弗娄牛','',''],['皮张','',''],['皮影','',''],['皮影戏','',''],['皮掌儿','',''],['皮星','',''],['皮条','',''],['皮条客','',''],['皮松肉紧','',''],['皮板儿','',''],['皮桶','',''],['皮桶子','',''],['皮棉','',''],['皮毛','',''],['皮炎','',''],['皮特凯恩群岛','',''],['皮特拉克','',''],['皮猴','',''],['皮猴儿','',''],['皮球','',''],['皮疹','',''],['皮癌','',''],['皮的','',''],['皮相','',''],['皮相之士','',''],['皮相之见','',''],['皮相之谈','',''],['皮破','',''],['皮硝','',''],['皮秒','',''],['皮笑','',''],['皮笑肉不笑','',''],['皮筋','',''],['皮筏','',''],['皮箱','',''],['皮糖','',''],['皮纸','',''],['皮线','',''],['皮肉','',''],['皮肉之苦','',''],['皮肤','',''],['皮肤上','',''],['皮肤之见','',''],['皮肤炎','',''],['皮肤病','',''],['皮肤癌','',''],['皮肤科','',''],['皮肤粗糙','',''],['皮肤肌肉囊','',''],['皮胶','',''],['皮脂','',''],['皮脂腺','',''],['皮脸','',''],['皮脸儿','',''],['皮艇','',''],['皮花','',''],['皮草','',''],['皮萨饼','',''],['皮蛋','',''],['皮衣','',''],['皮袄','',''],['皮袋','',''],['皮裤','',''],['皮诺切特','',''],['皮货','',''],['皮质','',''],['皮质醇','',''],['皮软','',''],['皮辊','',''],['皮辊花','',''],['皮部','',''],['皮里春秋','',''],['皮里阳秋','',''],['皮重','',''],['皮钦语','',''],['皮面','',''],['皮革','',''],['皮革商','',''],['皮靴','',''],['皮鞋','',''],['皮鞋匠','',''],['皮鞋油','',''],['皮鞭','',''],['皮黄','',''],['皱叶欧芹','',''],['皱巴巴','',''],['皱折','',''],['皱摺','',''],['皱痕','',''],['皱眉','',''],['皱眉头','',''],['皱眉肌','',''],['皱眉蹙眼','',''],['皱纹','',''],['皱缩','',''],['皱胃','',''],['皱褶','',''],['皱褶多','',''],['皱襞','',''],['皱起','',''],['皱边','',''],['皱额','',''],['皲肿','',''],['皲裂','',''],['皴法','',''],['皴裂','',''],['盂兰盆会','',''],['盂方水方','',''],['盅子','',''],['盆中','',''],['盆倾瓮倒','',''],['盆儿','',''],['盆地','',''],['盆堂','',''],['盆塘','',''],['盆子','',''],['盆景','',''],['盆架','',''],['盆栽','',''],['盆植','',''],['盆汤','',''],['盆浴','',''],['盆状','',''],['盆腔','',''],['盆腔炎','',''],['盆花','',''],['盆菜','',''],['盆钵','',''],['盈亏','',''],['盈亏自负','',''],['盈余','',''],['盈凸月','',''],['盈则不亏','',''],['盈利','',''],['盈千累万','',''],['盈千累百','',''],['盈尺之地','',''],['盈月','',''],['盈溢','',''],['盈满','',''],['盈满之咎','',''],['盈盈','',''],['盈盈一水','',''],['盈盈在目','',''],['盈盈秋水','',''],['盈眶','',''],['盈箱累箧','',''],['盈篇累牍','',''],['盈门','',''],['益上损下','',''],['益于','',''],['益加','',''],['益友','',''],['益发','',''],['益善','',''],['益国利民','',''],['益处','',''],['益寿','',''],['益寿延年','',''],['益州','',''],['益性','',''],['益无忌惮','',''],['益智','',''],['益母','',''],['益母草','',''],['益民','',''],['益气','',''],['益胃生津','',''],['益虫','',''],['益觉困难','',''],['益谦亏盈','',''],['益趋','',''],['益阳地区','',''],['益高','',''],['益鸟','',''],['盎司','',''],['盎士','',''],['盎斯','',''],['盎格鲁','',''],['盎格鲁撒克逊','',''],['盎格鲁撒克逊人','',''],['盎格鲁萨克逊','',''],['盎然','',''],['盎盂相击','',''],['盎盂相敲','',''],['盏灯','',''],['盐业','',''],['盐井','',''],['盐井乡','',''],['盐井县','',''],['盐价','',''],['盐份','',''],['盐分','',''],['盐区','',''],['盐卤','',''],['盐味','',''],['盐商','',''],['盐土','',''],['盐场','',''],['盐坨子','',''],['盐埔','',''],['盐埔乡','',''],['盐埕','',''],['盐埕区','',''],['盐层','',''],['盐工','',''],['盐巴','',''],['盐度','',''],['盐性','',''],['盐析','',''],['盐枭','',''],['盐水','',''],['盐水湖','',''],['盐水选种','',''],['盐水镇','',''],['盐汽水','',''],['盐泉','',''],['盐渍化','',''],['盐湖','',''],['盐湖城','',''],['盐滩','',''],['盐田','',''],['盐碱','',''],['盐碱土','',''],['盐碱地','',''],['盐碱湿地','',''],['盐碱滩','',''],['盐类','',''],['盐肤木','',''],['盐花','',''],['盐蛇','',''],['盐都','',''],['盐酸','',''],['盐酸克仑特罗','',''],['盐酸盐','',''],['盐量计','',''],['盐铁论','',''],['盐霜','',''],['监临自盗','',''],['监主自盗','',''],['监事','',''],['监交','',''],['监候','',''],['监军','',''],['监制','',''],['监卖','',''],['监印','',''],['监听','',''],['监听器','',''],['监国','',''],['监场','',''],['监外执行','',''],['监委','',''],['监守','',''],['监守官','',''],['监守自盗','',''],['监察','',''],['监察人','',''],['监察员','',''],['监察局','',''],['监察部','',''],['监察院','',''],['监工','',''],['监房','',''],['监护','',''],['监护人','',''],['监护权','',''],['监押','',''],['监控','',''],['监控器','',''],['监收','',''],['监查','',''],['监查员','',''],['监测','',''],['监测站','',''],['监牢','',''],['监牧','',''],['监犯','',''],['监狱','',''],['监理','',''],['监理所','',''],['监生','',''],['监用','',''],['监督','',''],['监督人','',''],['监督员','',''],['监督哨','',''],['监督官','',''],['监督站','',''],['监督者','',''],['监审','',''],['监票','',''],['监禁','',''],['监管','',''],['监管体制','',''],['监织造','',''],['监缴','',''],['监考','',''],['监考人','',''],['监考官','',''],['监舍','',''],['监视','',''],['监视人','',''],['监视员','',''],['监视器','',''],['监视孔','',''],['监视居住','',''],['监视者','',''],['监视雷达','',''],['监趸','',''],['监销','',''],['监门','',''],['监门之养','',''],['监院','',''],['盒中','',''],['盒子','',''],['盒子枪','',''],['盒子菜','',''],['盒尺','',''],['盒带','',''],['盒式','',''],['盒式录音磁带','',''],['盒装','',''],['盒饭','',''],['盔头','',''],['盔子','',''],['盔甲','',''],['盔甲上','',''],['盖上','',''],['盖世','',''],['盖世太保','',''],['盖世无双','',''],['盖了','',''],['盖以','',''],['盖住','',''],['盖儿','',''],['盖兹','',''],['盖印','',''],['盖县','',''],['盖在','',''],['盖头','',''],['盖好','',''],['盖子','',''],['盖尔','',''],['盖尔语','',''],['盖层','',''],['盖屋','',''],['盖帽','',''],['盖帽儿','',''],['盖度','',''],['盖戮','',''],['盖戳','',''],['盖房子','',''],['盖有','',''],['盖板','',''],['盖柿','',''],['盖棺','',''],['盖棺定论','',''],['盖棺论定','',''],['盖楼','',''],['盖没','',''],['盖法','',''],['盖浇饭','',''],['盖满','',''],['盖然性','',''],['盖然论','',''],['盖物','',''],['盖特纳','',''],['盖率','',''],['盖瓦','',''],['盖着','',''],['盖碗','',''],['盖章','',''],['盖茨','',''],['盖茨比','',''],['盖菜','',''],['盖被','',''],['盖起','',''],['盖过','',''],['盖邮戳','',''],['盖门','',''],['盖革计数器','',''],['盖饭','',''],['盖骑','',''],['盗亦有道','',''],['盗伐','',''],['盗劫','',''],['盗匪','',''],['盗卖','',''],['盗印','',''],['盗取','',''],['盗名欺世','',''],['盗坟','',''],['盗墓','',''],['盗尸','',''],['盗尸者','',''],['盗怨主人','',''],['盗憎主人','',''],['盗掘','',''],['盗案','',''],['盗汗','',''],['盗版','',''],['盗版党','',''],['盗版者','',''],['盗犯','',''],['盗猎','',''],['盗用','',''],['盗癖','',''],['盗窃','',''],['盗窃案','',''],['盗窃犯','',''],['盗窃癖','',''],['盗船','',''],['盗贼','',''],['盗走','',''],['盗钟掩耳','',''],['盗铃','',''],['盗铃掩耳','',''],['盗领','',''],['盗马','',''],['盗骗','',''],['盗龙','',''],['盘中','',''],['盘亘','',''],['盘估','',''],['盘住','',''],['盘倒','',''],['盘儿菜','',''],['盘剥','',''],['盘古','',''],['盘古氏','',''],['盘号','',''],['盘场','',''],['盘坐','',''],['盘头','',''],['盘子','',''],['盘存','',''],['盘定','',''],['盘察','',''],['盘尼西林','',''],['盘川','',''],['盘帐','',''],['盘库','',''],['盘底','',''],['盘店','',''],['盘弄','',''],['盘据','',''],['盘整','',''],['盘旋','',''],['盘旋曲折','',''],['盘旋物','',''],['盘曲','',''],['盘杠子','',''],['盘条','',''],['盘查','',''],['盘标','',''],['盘根','',''],['盘根究底','',''],['盘根错节','',''],['盘根问底','',''],['盘桓','',''],['盘梯','',''],['盘水加剑','',''],['盘沙简金','',''],['盘点','',''],['盘片','',''],['盘状物','',''],['盘盘','',''],['盘着腿','',''],['盘石','',''],['盘石之固','',''],['盘石之安','',''],['盘石桑苞','',''],['盘石犬牙','',''],['盘碗','',''],['盘秤','',''],['盘程','',''],['盘究','',''],['盘符','',''],['盘算','',''],['盘管','',''],['盘结','',''],['盘绕','',''],['盘绳栓','',''],['盘缠','',''],['盘羊','',''],['盘腿','',''],['盘膝','',''],['盘诘','',''],['盘账','',''],['盘货','',''],['盘费','',''],['盘赌','',''],['盘跚','',''],['盘踞','',''],['盘运','',''],['盘道','',''],['盘错','',''],['盘问','',''],['盘陀','',''],['盘陀路','',''],['盘飧','',''],['盘餐','',''],['盘香','',''],['盘马弯弓','',''],['盘驳','',''],['盘龙','',''],['盘龙卧虎','',''],['盛不忘衰','',''],['盛世','',''],['盛举','',''],['盛事','',''],['盛产','',''],['盛京','',''],['盛会','',''],['盛传','',''],['盛入','',''],['盛典','',''],['盛况','',''],['盛况空前','',''],['盛势','',''],['盛名','',''],['盛名之下其实难副','',''],['盛名难副','',''],['盛唐','',''],['盛器','',''],['盛在','',''],['盛夏','',''],['盛大','',''],['盛大舞会','',''],['盛妆','',''],['盛季','',''],['盛宴','',''],['盛年','',''],['盛开','',''],['盛开过','',''],['盛得遗范','',''],['盛德','',''],['盛德不泯','',''],['盛必虑衰','',''],['盛怒','',''],['盛情','',''],['盛情款待','',''],['盛情难却','',''],['盛意','',''],['盛放','',''],['盛时','',''],['盛明','',''],['盛景','',''],['盛暑','',''],['盛暑祈寒','',''],['盛服','',''],['盛期','',''],['盛极','',''],['盛极一时','',''],['盛气','',''],['盛气临人','',''],['盛气凌人','',''],['盛水','',''],['盛水不漏','',''],['盛称','',''],['盛筵','',''],['盛筵必散','',''],['盛筵易散','',''],['盛筵难再','',''],['盛行','',''],['盛衰','',''],['盛衰兴废','',''],['盛衰利寒','',''],['盛衰相乘','',''],['盛衰荣辱','',''],['盛装','',''],['盛观','',''],['盛誉','',''],['盛赞','',''],['盛食厉兵','',''],['盛饭','',''],['盛馔','',''],['盟主','',''],['盟主权','',''],['盟兄','',''],['盟兄弟','',''],['盟军','',''],['盟友','',''],['盟员','',''],['盟国','',''],['盟山誓海','',''],['盟弟','',''],['盟旗制度','',''],['盟约','',''],['盟誓','',''],['盟邦','',''],['盥洗','',''],['盥洗台','',''],['盥洗室','',''],['盥洗用具','',''],['盥漱','',''],['盥耳山栖','',''],['盥踵灭顶','',''],['目上','',''],['目下','',''],['目下十行','',''],['目不交睫','',''],['目不妄视','',''],['目不忍睹','',''],['目不忍见','',''],['目不忍视','',''],['目不暇接','',''],['目不暇给','',''],['目不知书','',''],['目不窥园','',''],['目不给视','',''],['目不见睫','',''],['目不识丁','',''],['目不识字','',''],['目不转晴','',''],['目不转睛','',''],['目不转视','',''],['目不邪视','',''],['目中','',''],['目中无人','',''],['目人','',''],['目今','',''],['目使颐令','',''],['目光','',''],['目光呆滞','',''],['目光如炬','',''],['目光如豆','',''],['目光如鼠','',''],['目光短浅','',''],['目光锐利','',''],['目击','',''],['目击者','',''],['目击耳闻','',''],['目击道存','',''],['目前','',''],['目力','',''],['目力表','',''],['目即成诵','',''],['目呆口咂','',''],['目大不睹','',''],['目定口呆','',''],['目录','',''],['目录学','',''],['目录树','',''],['目怆有天','',''],['目怔口呆','',''],['目成','',''],['目成心许','',''],['目所未睹','',''],['目披手抄','',''],['目指气使','',''],['目挑心招','',''],['目断飞鸿','',''],['目断魂销','',''],['目断鳞鸿','',''],['目无下尘','',''],['目无余子','',''],['目无光泽','',''],['目无全牛','',''],['目无法纪','',''],['目无流视','',''],['目无组织','',''],['目无见睫','',''],['目明','',''],['目染耳濡','',''],['目标','',''],['目标伪装','',''],['目标侦察','',''],['目标匹配作业','',''],['目标地址','',''],['目标市场','',''],['目标管理','',''],['目标责任制','',''],['目次','',''],['目测','',''],['目濡耳染','',''],['目牛无全','',''],['目牛游刃','',''],['目珠','',''],['目疾','',''],['目的','',''],['目的在','',''],['目的在于','',''],['目的地','',''],['目的性','',''],['目的意义','',''],['目的论','',''],['目盲','',''],['目盼心思','',''],['目眦','',''],['目眩','',''],['目眩头昏','',''],['目眩心花','',''],['目眩神摇','',''],['目眩神迷','',''],['目眩魂摇','',''],['目睁口呆','',''],['目睹','',''],['目睹耳闻','',''],['目瞠口哆','',''],['目瞤','',''],['目瞪','',''],['目瞪口呆','',''],['目瞪神呆','',''],['目瞪舌疆','',''],['目空','',''],['目空一世','',''],['目空一切','',''],['目空四海','',''],['目窕心与','',''],['目若悬珠','',''],['目见','',''],['目见耳闻','',''],['目视','',''],['目论','',''],['目语','',''],['目迷五色','',''],['目送','',''],['目送手挥','',''],['目镜','',''],['盯人','',''],['盯住','',''],['盯市','',''],['盯梢','',''],['盯着','',''],['盯着看','',''],['盯视','',''],['盱衡','',''],['盲人','',''],['盲人把烛','',''],['盲人摸象','',''],['盲人瞎马','',''],['盲人说象','',''],['盲从','',''],['盲信','',''],['盲动','',''],['盲动主义','',''],['盲区','',''],['盲哑','',''],['盲哑教育','',''],['盲囊','',''],['盲女','',''],['盲字','',''],['盲干','',''],['盲打','',''],['盲文','',''],['盲棋','',''],['盲椿象','',''],['盲法','',''],['盲流','',''],['盲点','',''],['盲生','',''],['盲症','',''],['盲目','',''],['盲目不盲心','',''],['盲目乐观','',''],['盲目发展','',''],['盲目性','',''],['盲目生产','',''],['盲眼','',''],['盲眼无珠','',''],['盲端','',''],['盲者','',''],['盲者得镜','',''],['盲聋','',''],['盲聋哑','',''],['盲肠','',''],['盲肠炎','',''],['盲蛇','',''],['盲障','',''],['盲骑瞎马','',''],['盲鳗','',''],['盲鼠','',''],['直上','',''],['直上云霄','',''],['直上青云','',''],['直下','',''],['直不','',''],['直书','',''],['直交','',''],['直僵','',''],['直入','',''],['直内方外','',''],['直冲横撞','',''],['直到','',''],['直到现在','',''],['直前','',''],['直勾勾','',''],['直升','',''],['直升机','',''],['直升飞机','',''],['直发','',''],['直发器','',''],['直发板','',''],['直叙','',''],['直号','',''],['直呼','',''],['直哭','',''],['直喘气','',''],['直喻','',''],['直奉战争','',''],['直奔','',''],['直定','',''],['直射','',''],['直尺','',''],['直属','',''],['直属单位','',''],['直属机关','',''],['直属机构','',''],['直峭','',''],['直布罗陀海峡','',''],['直径','',''],['直待','',''],['直心眼儿','',''],['直性','',''],['直性子','',''],['直情径行','',''],['直感','',''],['直愣愣','',''],['直截','',''],['直截了当','',''],['直抒','',''],['直抒己见','',''],['直抒胸臆','',''],['直抵','',''],['直拍','',''],['直拨','',''],['直指','',''],['直挺','',''],['直挺挺','',''],['直捣','',''],['直捣黄龙','',''],['直捷','',''],['直掇','',''],['直排','',''],['直接','',''],['直接了当','',''],['直接原因','',''],['直接参与','',''],['直接宾语','',''],['直接对话','',''],['直接影响','',''],['直接投资','',''],['直接推理','',''],['直接数据','',''],['直接染料','',''],['直接税','',''],['直接竞争','',''],['直接经验','',''],['直接肥料','',''],['直接贸易','',''],['直接费用','',''],['直接进行','',''],['直接选举','',''],['直接领导','',''],['直插','',''],['直撅撅','',''],['直撞','',''],['直撞横冲','',''],['直播','',''],['直播间','',''],['直敪','',''],['直方图','',''],['直昇机','',''],['直昇飞机','',''],['直是','',''],['直木必伐','',''],['直条','',''],['直来直去','',''],['直来直往','',''],['直根','',''],['直流','',''],['直流发电机','',''],['直流电','',''],['直流电动机','',''],['直溜','',''],['直溜溜','',''],['直爽','',''],['直率','',''],['直白','',''],['直皖战争','',''],['直直','',''],['直眉','',''],['直眉瞪眼','',''],['直着','',''],['直瞄','',''],['直瞪瞪','',''],['直码尺','',''],['直积','',''],['直立','',''],['直立人','',''],['直立茎','',''],['直笔','',''],['直系','',''],['直系亲属','',''],['直系军阀','',''],['直系祖先','',''],['直系血亲','',''],['直线','',''],['直线加速器','',''],['直线性加速器','',''],['直经','',''],['直翅目','',''],['直而不挺','',''],['直肠','',''],['直肠子','',''],['直肠炎','',''],['直肠癌','',''],['直肠镜','',''],['直至','',''],['直航','',''],['直节劲气','',''],['直落','',''],['直落布兰雅','',''],['直行','',''],['直裰','',''],['直观','',''],['直视','',''],['直觉','',''],['直觉性','',''],['直角','',''],['直角三角','',''],['直角三角形','',''],['直角器','',''],['直角坐标','',''],['直角尺','',''],['直言','',''],['直言不讳','',''],['直言勿讳','',''],['直言危行','',''],['直言取祸','',''],['直言命题','',''],['直言尽意','',''],['直言无讳','',''],['直言无隐','',''],['直言极谏','',''],['直言止论','',''],['直言正色','',''],['直言正谏','',''],['直言谠议','',''],['直言贾祸','',''],['直言骨鲠','',''],['直讲','',''],['直证','',''],['直译','',''],['直话','',''],['直说','',''],['直谅多闻','',''],['直谏','',''],['直贡呢','',''],['直走','',''],['直路','',''],['直跳','',''],['直躺','',''],['直辖','',''],['直辖市','',''],['直达','',''],['直运','',''],['直进','',''],['直述','',''],['直退','',''],['直送','',''],['直选','',''],['直通','',''],['直通火车','',''],['直通车','',''],['直逼','',''],['直道','',''],['直道不容','',''],['直道事人','',''],['直道而行','',''],['直链','',''],['直销','',''],['直门','',''],['直隶','',''],['直音','',''],['直飞','',''],['直馏','',''],['直驶','',''],['相一致','',''],['相与','',''],['相与为命','',''],['相中','',''],['相为表里','',''],['相乘','',''],['相书','',''],['相争','',''],['相互','',''],['相互作用','',''],['相互保证毁灭','',''],['相互关系','',''],['相互兼容','',''],['相互性','',''],['相互理解','',''],['相互矛盾','',''],['相互辉映','',''],['相互配合','',''],['相互间','',''],['相交','',''],['相交数','',''],['相亲','',''],['相亲相爱','',''],['相从','',''],['相仿','',''],['相会','',''],['相传','',''],['相伴','',''],['相似','',''],['相似形','',''],['相似性','',''],['相似物','',''],['相位','',''],['相位差','',''],['相位角','',''],['相体裁衣','',''],['相依','',''],['相依为命','',''],['相保','',''],['相信','',''],['相信人','',''],['相信组织','',''],['相信群众','',''],['相倚为命','',''],['相倚为强','',''],['相偎','',''],['相偕','',''],['相像','',''],['相克','',''],['相公','',''],['相关','',''],['相关器','',''],['相关图','',''],['相关性','',''],['相关物','',''],['相关者','',''],['相册','',''],['相冲','',''],['相减','',''],['相切','',''],['相劝','',''],['相加','',''],['相加性的','',''],['相助','',''],['相匹敌','',''],['相去不远','',''],['相去咫尺','',''],['相去天渊','',''],['相去无几','',''],['相去甚远','',''],['相反','',''],['相反物','',''],['相反相成','',''],['相变','',''],['相合','',''],['相同','',''],['相同之处','',''],['相同名字','',''],['相同样','',''],['相向','',''],['相向突击','',''],['相吸','',''],['相吻合','',''],['相告','',''],['相命','',''],['相命者','',''],['相商','',''],['相善','',''],['相国','',''],['相图','',''],['相城','',''],['相士','',''],['相声','',''],['相处','',''],['相夫','',''],['相夫教子','',''],['相契','',''],['相奸','',''],['相好','',''],['相媲美','',''],['相学','',''],['相守','',''],['相安','',''],['相安无事','',''],['相宜','',''],['相家','',''],['相容','',''],['相容性','',''],['相容条件','',''],['相对','',''],['相对主义','',''],['相对于','',''],['相对位置','',''],['相对剩余价值','',''],['相对地址','',''],['相对密度','',''],['相对性','',''],['相对数','',''],['相对来说','',''],['相对比','',''],['相对湿度','',''],['相对物','',''],['相对真理','',''],['相对而言','',''],['相对论','',''],['相对论性','',''],['相对误差','',''],['相对说来','',''],['相对象','',''],['相对运动','',''],['相对高度','',''],['相山','',''],['相左','',''],['相差','',''],['相差不多','',''],['相差悬殊','',''],['相差无几','',''],['相师','',''],['相帮','',''],['相干','',''],['相平面','',''],['相应','',''],['相应措施','',''],['相异','',''],['相当','',''],['相当于','',''],['相当于或大于','',''],['相当可观','',''],['相当多','',''],['相当大','',''],['相当规模','',''],['相当陡','',''],['相形','',''],['相形失色','',''],['相形见绌','',''],['相形见逊','',''],['相待','',''],['相待如宾','',''],['相待而成','',''],['相得恨晚','',''],['相得益彰','',''],['相忍','',''],['相忍为国','',''],['相怜','',''],['相思','',''],['相思子','',''],['相思病','',''],['相思豆','',''],['相思鸟','',''],['相恋','',''],['相恶','',''],['相悖','',''],['相情','',''],['相惊伯有','',''],['相成','',''],['相扑','',''],['相托','',''],['相扰','',''],['相扶','',''],['相承','',''],['相投','',''],['相抵','',''],['相持','',''],['相持不下','',''],['相接','',''],['相提并论','',''],['相撞','',''],['相敬如宾','',''],['相斗','',''],['相斥','',''],['相时而动','',''],['相映','',''],['相映成趣','',''],['相望','',''],['相术','',''],['相机','',''],['相机而动','',''],['相机而行','',''],['相机而言','',''],['相机行事','',''],['相机观变','',''],['相架','',''],['相框','',''],['相棋','',''],['相比','',''],['相比之下','',''],['相比较','',''],['相求','',''],['相沿','',''],['相沿成习','',''],['相混','',''],['相混合','',''],['相濡','',''],['相濡一沫','',''],['相濡以沫','',''],['相灭相生','',''],['相烦','',''],['相煎何急','',''],['相熟','',''],['相爱','',''],['相片','',''],['相片儿','',''],['相率','',''],['相生','',''],['相生相克','',''],['相电压','',''],['相电流','',''],['相看','',''],['相知','',''],['相知恨晚','',''],['相知相惜','',''],['相碰','',''],['相碰撞','',''],['相礼','',''],['相离','',''],['相称','',''],['相稔','',''],['相空间','',''],['相符','',''],['相符合','',''],['相等','',''],['相等物','',''],['相簿','',''],['相类','',''],['相类相从','',''],['相约','',''],['相纸','',''],['相结','',''],['相结合','',''],['相继','',''],['相继问世','',''],['相者','',''],['相联','',''],['相联系','',''],['相聚','',''],['相背','',''],['相若','',''],['相补','',''],['相衬','',''],['相见','',''],['相见恨晚','',''],['相见无日','',''],['相视','',''],['相视莫逆','',''],['相觑','',''],['相角','',''],['相触','',''],['相认','',''],['相讥','',''],['相让','',''],['相许','',''],['相识','',''],['相识人','',''],['相谈','',''],['相象','',''],['相貌','',''],['相貌堂堂','',''],['相距','',''],['相轻','',''],['相较','',''],['相辅','',''],['相辅相成','',''],['相辅而行','',''],['相迎','',''],['相近','',''],['相违','',''],['相连','',''],['相迫','',''],['相适合','',''],['相适应','',''],['相通','',''],['相逢','',''],['相逢恨晚','',''],['相逢狭路','',''],['相遇','',''],['相邻','',''],['相配','',''],['相配人','',''],['相配物','',''],['相里','',''],['相门出相','',''],['相门有相','',''],['相间','',''],['相除','',''],['相陪','',''],['相随','',''],['相隔','',''],['相面','',''],['相须为命','',''],['相须而行','',''],['相顾','',''],['相顾失色','',''],['相风使帆','',''],['相馆','',''],['相骂','',''],['盹儿','',''],['盼复','',''],['盼头','',''],['盼星星盼月亮','',''],['盼望','',''],['盼睐','',''],['盾形','',''],['盾板','',''],['盾牌','',''],['盾牌座','',''],['盾状','',''],['盾甲','',''],['省下','',''],['省中','',''],['省主席','',''],['省事','',''],['省亲','',''],['省人民办','',''],['省份','',''],['省优','',''],['省会','',''],['省便','',''],['省俗观风','',''],['省俭','',''],['省内','',''],['省内外','',''],['省军区','',''],['省军级','',''],['省农业厅','',''],['省刑薄敛','',''],['省力','',''],['省劲','',''],['省劲儿','',''],['省区','',''],['省却','',''],['省去','',''],['省县','',''],['省吃俭用','',''],['省垣','',''],['省城','',''],['省墓','',''],['省外','',''],['省委','',''],['省委书记','',''],['省委员会','',''],['省字','',''],['省字号','',''],['省察','',''],['省小钱','',''],['省局','',''],['省属','',''],['省工','',''],['省市','',''],['省市区','',''],['省府','',''],['省得','',''],['省心','',''],['省思','',''],['省悟','',''],['省掉','',''],['省政府','',''],['省文明办','',''],['省料','',''],['省方观俗','',''],['省方观民','',''],['省时','',''],['省欲去箸','',''],['省治','',''],['省港','',''],['省点','',''],['省烦从简','',''],['省用','',''],['省用足财','',''],['省电','',''],['省界','',''],['省略','',''],['省略句','',''],['省略号','',''],['省略符号','',''],['省直','',''],['省直机关','',''],['省直管县','',''],['省科委','',''],['省称','',''],['省立','',''],['省籍','',''],['省级','',''],['省纪','',''],['省纪委','',''],['省行','',''],['省视','',''],['省财税厅','',''],['省辖','',''],['省辖市','',''],['省过','',''],['省道','',''],['省部级','',''],['省钱','',''],['省着点','',''],['省长','',''],['眄眄','',''],['眄睐','',''],['眄睨','',''],['眄视','',''],['眇小','',''],['眇眇','',''],['眈眈','',''],['眉南面北','',''],['眉头','',''],['眉头一皱计上心来','',''],['眉宇','',''],['眉尖','',''],['眉峰','',''],['眉开眼笑','',''],['眉形','',''],['眉心','',''],['眉心轮','',''],['眉批','',''],['眉月','',''],['眉来眼去','',''],['眉来语去','',''],['眉梢','',''],['眉棱','',''],['眉棱骨','',''],['眉欢眼笑','',''],['眉毛','',''],['眉毛胡子一把抓','',''],['眉毛钳','',''],['眉注','',''],['眉清目秀','',''],['眉目','',''],['眉目不清','',''],['眉目传情','',''],['眉目如画','',''],['眉眼','',''],['眉眼传情','',''],['眉眼高低','',''],['眉睫','',''],['眉睫之内','',''],['眉睫之利','',''],['眉睫之祸','',''],['眉端','',''],['眉笔','',''],['眉肌','',''],['眉花眼笑','',''],['眉间','',''],['眉间轮','',''],['眉题','',''],['眉额','',''],['眉飞','',''],['眉飞色舞','',''],['眉高眼低','',''],['眉鸟','',''],['眉黛','',''],['看一下','',''],['看一看','',''],['看上','',''],['看上去','',''],['看上去是','',''],['看下','',''],['看不','',''],['看不上眼','',''],['看不中','',''],['看不习惯','',''],['看不出','',''],['看不惯','',''],['看不懂','',''],['看不清','',''],['看不见','',''],['看不起','',''],['看不过','',''],['看不过去','',''],['看不顺眼','',''],['看中','',''],['看书','',''],['看了','',''],['看些','',''],['看人','',''],['看人眉睫','',''],['看人行事','',''],['看他','',''],['看似','',''],['看低','',''],['看作','',''],['看倌','',''],['看做','',''],['看准','',''],['看出','',''],['看到','',''],['看医','',''],['看厌','',''],['看去','',''],['看台','',''],['看后','',''],['看呆','',''],['看图','',''],['看在','',''],['看在眼里','',''],['看头','',''],['看好','',''],['看孩子','',''],['看守','',''],['看守人','',''],['看守内客','',''],['看守内阁','',''],['看守所','',''],['看守者','',''],['看完','',''],['看官','',''],['看定','',''],['看客','',''],['看家','',''],['看家戏','',''],['看家狗','',''],['看开','',''],['看待','',''],['看得','',''],['看得中','',''],['看得出','',''],['看得惯','',''],['看得清','',''],['看得见','',''],['看得起','',''],['看得过','',''],['看得过儿','',''],['看得远','',''],['看您','',''],['看情况','',''],['看惯','',''],['看懂','',''],['看戏','',''],['看成','',''],['看扁','',''],['看手','',''],['看承','',''],['看护','',''],['看护人','',''],['看报','',''],['看押','',''],['看文巨眼','',''],['看文老眼','',''],['看景生情','',''],['看有','',''],['看望','',''],['看朱成碧','',''],['看来','',''],['看来好像','',''],['看来好象','',''],['看样','',''],['看样子','',''],['看法','',''],['看涨','',''],['看清','',''],['看漏','',''],['看热闹','',''],['看球','',''],['看用','',''],['看电影','',''],['看电视','',''],['看病','',''],['看的','',''],['看相','',''],['看看','',''],['看着','',''],['看着不管','',''],['看着锅里','',''],['看破','',''],['看破红尘','',''],['看穿','',''],['看管','',''],['看管者','',''],['看者','',''],['看花','',''],['看花眼','',''],['看菜吃饭','',''],['看菜吃饭量体裁衣','',''],['看著','',''],['看表','',''],['看见','',''],['看财奴','',''],['看起来','',''],['看跌','',''],['看车','',''],['看轻','',''],['看过','',''],['看这','',''],['看透','',''],['看都不看','',''],['看重','',''],['看错','',''],['看门','',''],['看门人','',''],['看门犬','',''],['看门狗','',''],['看青','',''],['看顾','',''],['看风','',''],['看风使帆','',''],['看风使舵','',''],['看风使船','',''],['看风行事','',''],['看风转舵','',''],['看风驶篷','',''],['看鸟人','',''],['看齐','',''],['眍䁖','',''],['真丝','',''],['真个','',''],['真主','',''],['真主党','',''],['真义','',''],['真书','',''],['真事','',''],['真亮','',''],['真人','',''],['真人真事','',''],['真人秀','',''],['真传','',''],['真伪','',''],['真伪莫辨','',''],['真值表','',''],['真假','',''],['真假难辨','',''],['真傻','',''],['真凭实据','',''],['真凶实犯','',''],['真刀实枪','',''],['真刀真枪','',''],['真分数','',''],['真切','',''],['真功夫','',''],['真名实姓','',''],['真后生动物','',''],['真否定句','',''],['真命','',''],['真品','',''],['真善美','',''],['真坏','',''],['真声','',''],['真声最高音','',''],['真奇怪','',''],['真好','',''],['真烂','',''],['真如','',''],['真子集','',''],['真实','',''],['真实性','',''],['真实感','',''],['真容','',''],['真巧','',''],['真彩色','',''],['真影','',''],['真心','',''],['真心实意','',''],['真心实意地','',''],['真心真意','',''],['真心诚意','',''],['真心话','',''],['真心话大冒险','',''],['真性','',''],['真怪','',''],['真情','',''],['真情实意','',''],['真情实感','',''],['真想','',''],['真意','',''],['真才','',''],['真才实学','',''],['真抓实干','',''],['真挚','',''],['真数','',''],['真是','',''],['真是的','',''],['真有你的','',''],['真果','',''],['真枪','',''],['真枪实弹','',''],['真核','',''],['真核细胞','',''],['真格','',''],['真格的','',''],['真棒','',''],['真正','',''],['真正的社会主义','',''],['真武','',''],['真没想到','',''],['真溶液','',''],['真爱','',''],['真版','',''],['真牛','',''],['真率','',''],['真珠','',''],['真理','',''],['真理报','',''],['真理论','',''],['真理部','',''],['真番郡','',''],['真皮','',''],['真皮层','',''],['真相','',''],['真相大白','',''],['真相毕露','',''],['真真','',''],['真真切切','',''],['真知','',''],['真知灼见','',''],['真确','',''],['真神','',''],['真空','',''],['真空泵','',''],['真空管','',''],['真空计','',''],['真纳','',''],['真经','',''],['真肯定句','',''],['真腊','',''],['真菌','',''],['真菌纲','',''],['真言','',''],['真言宗','',''],['真言真语','',''],['真诚','',''],['真话','',''],['真诠','',''],['真谛','',''],['真象','',''],['真赃实犯','',''],['真身','',''],['真迹','',''],['真道','',''],['真释','',''],['真金','',''],['真金不怕火来烧','',''],['真金不怕火炼','',''],['真金不怕火烧','',''],['真金烈火','',''],['真际','',''],['真面目','',''],['真髓','',''],['真鲷','',''],['眠双卧雪','',''],['眠思梦想','',''],['眠曲','',''],['眠花卧柳','',''],['眠花宿柳','',''],['眠蚕','',''],['眢井','',''],['眦睚','',''],['眨动','',''],['眨巴','',''],['眨眼','',''],['眨眼睛','',''],['眩丽','',''],['眩乱','',''],['眩人','',''],['眩光','',''],['眩惑','',''],['眩晕','',''],['眩目','',''],['眩目震耳','',''],['眩眼','',''],['眩耀','',''],['眯盹儿','',''],['眯眯','',''],['眯眼','',''],['眯着','',''],['眯缝','',''],['眯过','',''],['眯逢','',''],['眳睛','',''],['眵目糊','',''],['眷区','',''],['眷属','',''],['眷念','',''],['眷怀','',''],['眷恋','',''],['眷本','',''],['眷注','',''],['眷爱','',''],['眷眷','',''],['眷眷之心','',''],['眷顾','',''],['眸子','',''],['眺望','',''],['眺远','',''],['眼下','',''],['眼不见为净','',''],['眼不见心不烦','',''],['眼不转睛','',''],['眼中','',''],['眼中刺','',''],['眼中疔肉中刺','',''],['眼中钉','',''],['眼中钉肉中刺','',''],['眼亮','',''],['眼低','',''],['眼儿','',''],['眼光','',''],['眼光敏锐','',''],['眼光浅','',''],['眼光短','',''],['眼光短浅','',''],['眼光远大','',''],['眼内无珠','',''],['眼冒金星','',''],['眼前','',''],['眼前利益','',''],['眼力','',''],['眼力好','',''],['眼动','',''],['眼动技术','',''],['眼动记录','',''],['眼压','',''],['眼去眉来','',''],['眼圈','',''],['眼圈红了','',''],['眼孔','',''],['眼尖','',''],['眼尾','',''],['眼屎','',''],['眼岔','',''],['眼巴巴','',''],['眼帘','',''],['眼干症','',''],['眼底','',''],['眼底下','',''],['眼形','',''],['眼影','',''],['眼快','',''],['眼成穿','',''],['眼房','',''],['眼房水','',''],['眼拙','',''],['眼旁','',''],['眼时','',''],['眼明','',''],['眼明手快','',''],['眼明手捷','',''],['眼晕','',''],['眼柄','',''],['眼格','',''],['眼梢','',''],['眼水','',''],['眼泡','',''],['眼波','',''],['眼泪','',''],['眼泪横流','',''],['眼泪洗面','',''],['眼液','',''],['眼点','',''],['眼热','',''],['眼熟','',''],['眼犄角儿','',''],['眼状物','',''],['眼珠','',''],['眼珠儿','',''],['眼珠子','',''],['眼球','',''],['眼生','',''],['眼电图','',''],['眼界','',''],['眼疲劳','',''],['眼疾','',''],['眼疾手快','',''],['眼病','',''],['眼白','',''],['眼皮','',''],['眼皮哭肿','',''],['眼皮子','',''],['眼皮子浅','',''],['眼目','',''],['眼眉','',''],['眼看','',''],['眼看着','',''],['眼眵','',''],['眼眶','',''],['眼眸','',''],['眼睁睁','',''],['眼睑','',''],['眼睛','',''],['眼睛尖','',''],['眼睫毛','',''],['眼瞅','',''],['眼瞎','',''],['眼瞎耳聋','',''],['眼瞓','',''],['眼神','',''],['眼神不好','',''],['眼神不济','',''],['眼福','',''],['眼离','',''],['眼科','',''],['眼科医生','',''],['眼科学','',''],['眼空四海','',''],['眼空无物','',''],['眼穿肠断','',''],['眼窝','',''],['眼窝上','',''],['眼笑','',''],['眼红','',''],['眼线','',''],['眼线液','',''],['眼线笔','',''],['眼线膏','',''],['眼网膜','',''],['眼罩','',''],['眼色','',''],['眼色素层黑色素瘤','',''],['眼花','',''],['眼花撩乱','',''],['眼花潦乱','',''],['眼花缭乱','',''],['眼花耳热','',''],['眼花雀乱','',''],['眼药','',''],['眼药水','',''],['眼虫','',''],['眼虫藻','',''],['眼袋','',''],['眼见','',''],['眼见为实','',''],['眼见得','',''],['眼观','',''],['眼观六路耳听八方','',''],['眼观四处耳听八方','',''],['眼角','',''],['眼角膜','',''],['眼距宽','',''],['眼跳','',''],['眼跳动','',''],['眼过劳','',''],['眼部','',''],['眼里','',''],['眼里容不得沙子','',''],['眼镜','',''],['眼镜堡','',''],['眼镜片','',''],['眼镜腿','',''],['眼镜蛇','',''],['眼霜','',''],['眼露杀气','',''],['眼风','',''],['眼馋','',''],['眼馋肚饱','',''],['眼高手低','',''],['着三不着两','',''],['着了魔','',''],['着于','',''],['着使','',''],['着儿','',''],['着凉','',''],['着力','',''],['着办','',''],['着劲儿','',''],['着呢','',''],['着地','',''],['着墨','',''],['着处','',''],['着实','',''],['着帆','',''],['着床','',''],['着忙','',''],['着急','',''],['着恼','',''],['着想','',''],['着意','',''],['着慌','',''],['着手','',''],['着手做','',''],['着手成春','',''],['着数','',''],['着棋','',''],['着法','',''],['着火','',''],['着火了','',''],['着火点','',''],['着然','',''],['着看','',''],['着眼','',''],['着眼于','',''],['着眼点','',''],['着着失败','',''],['着睡','',''],['着笔','',''],['着紧','',''],['着脸','',''],['着色','',''],['着色于','',''],['着色剂','',''],['着花','',''],['着落','',''],['着衣','',''],['着装','',''],['着谈','',''],['着边','',''],['着边儿','',''],['着迷','',''],['着重','',''],['着重于','',''],['着重号','',''],['着重指','',''],['着重点','',''],['着陆','',''],['着陆器','',''],['着陆场','',''],['着陆点','',''],['着魔','',''],['睁一只眼闭一只眼','',''],['睁一眼闭一眼','',''],['睁只眼闭只眼','',''],['睁大','',''],['睁大眼睛','',''],['睁开','',''],['睁开眼睛','',''],['睁目','',''],['睁眼','',''],['睁眼瞎子','',''],['睁着','',''],['睁睁','',''],['睁视','',''],['睁起','',''],['睃巡','',''],['睑腺炎','',''],['睚眦','',''],['睚眦之嫌','',''],['睚眦之怨','',''],['睚眦之私','',''],['睚眦之隙','',''],['睚眦必报','',''],['睛和','',''],['睡一觉','',''],['睡下','',''],['睡不著','',''],['睡乡','',''],['睡了','',''],['睡像','',''],['睡前','',''],['睡午觉','',''],['睡卧不宁','',''],['睡卧不安','',''],['睡去','',''],['睡回笼觉','',''],['睡在','',''],['睡好','',''],['睡帽','',''],['睡床','',''],['睡得','',''],['睡态','',''],['睡思','',''],['睡意','',''],['睡意正浓','',''],['睡懒觉','',''],['睡房','',''],['睡服','',''],['睡梦','',''],['睡椅','',''],['睡游病','',''],['睡熟','',''],['睡狮','',''],['睡病虫','',''],['睡相','',''],['睡眠','',''],['睡眠不足','',''],['睡眠中','',''],['睡眠失调','',''],['睡眠疗法','',''],['睡眠症','',''],['睡眠者','',''],['睡眠虫','',''],['睡眼','',''],['睡眼惺忪','',''],['睡着','',''],['睡着了','',''],['睡睡','',''],['睡神','',''],['睡美人','',''],['睡者','',''],['睡莲','',''],['睡著','',''],['睡衣','',''],['睡衣裤','',''],['睡袋','',''],['睡袍','',''],['睡裙','',''],['睡裤','',''],['睡觉','',''],['睡起','',''],['睡足','',''],['睡过','',''],['睡过头','',''],['睡醒','',''],['睡魔','',''],['睡鼠','',''],['睢阳','',''],['睢鸠','',''],['督促','',''],['督促检查','',''],['督促者','',''],['督军','',''],['督办','',''],['督励','',''],['督学','',''],['督察','',''],['督察大队','',''],['督察小组','',''],['督察长','',''],['督导','',''],['督导员','',''],['督工','',''],['督师','',''],['督府','',''],['督建','',''],['督战','',''],['督抚','',''],['督标','',''],['督责','',''],['督龟','',''],['睥睨','',''],['睥睨物表','',''],['睦亲','',''],['睦相','',''],['睦谊','',''],['睦邻','',''],['睦邻政策','',''],['睨视','',''],['睫毛','',''],['睫毛油','',''],['睫毛膏','',''],['睫状','',''],['睫状体','',''],['睹微知著','',''],['睹景伤情','',''],['睹物伤情','',''],['睹物兴悲','',''],['睹物兴情','',''],['睹物怀人','',''],['睹物思人','',''],['睽异','',''],['睽情度理','',''],['睽睽','',''],['睽违','',''],['睽隔','',''],['睾丸','',''],['睾丸激素','',''],['睾丸炎','',''],['睾丸甾酮','',''],['睾丸素','',''],['睾丸酮','',''],['睾甾酮','',''],['睾酮','',''],['睿智','',''],['睿达','',''],['瞄准','',''],['瞄准仪','',''],['瞄准具','',''],['瞄准器','',''],['瞄准洞','',''],['瞄出','',''],['瞄着','',''],['瞅着','',''],['瞅睬','',''],['瞅著','',''],['瞅见','',''],['瞈蒙','',''],['瞋目','',''],['瞌睡','',''],['瞎了','',''],['瞎吹','',''],['瞎奶','',''],['瞎子','',''],['瞎子摸象','',''],['瞎子摸鱼','',''],['瞎弄','',''],['瞎忙','',''],['瞎扯','',''],['瞎扯淡','',''],['瞎扯蛋','',''],['瞎抓','',''],['瞎指挥','',''],['瞎掰','',''],['瞎搞','',''],['瞎炮','',''],['瞎猜','',''],['瞎眼','',''],['瞎碰','',''],['瞎编','',''],['瞎编乱造','',''],['瞎聊','',''],['瞎自夸','',''],['瞎诌','',''],['瞎话','',''],['瞎说','',''],['瞎调','',''],['瞎谈','',''],['瞎转','',''],['瞎逛','',''],['瞎闯','',''],['瞎闹','',''],['瞑想','',''],['瞑目','',''],['瞑眩','',''],['瞒上不瞒下','',''],['瞒上欺下','',''],['瞒人','',''],['瞒哄','',''],['瞒天席地','',''],['瞒天昧地','',''],['瞒天过海','',''],['瞒心昧己','',''],['瞒报','',''],['瞒混','',''],['瞒着','',''],['瞒神吓鬼','',''],['瞒神唬鬼','',''],['瞒著','',''],['瞒过','',''],['瞒骗','',''],['瞓觉','',''],['瞟一眼','',''],['瞟见','',''],['瞠呼其后','',''],['瞠目','',''],['瞠目结舌','',''],['瞠目而视','',''],['瞤息','',''],['瞥然','',''],['瞥见','',''],['瞥视','',''],['瞧不起','',''],['瞧人','',''],['瞧你','',''],['瞧出','',''],['瞧得起','',''],['瞧着','',''],['瞧着办','',''],['瞧着锅里','',''],['瞧瞧','',''],['瞧见','',''],['瞧这','',''],['瞧香的','',''],['瞩望','',''],['瞩目','',''],['瞪了','',''],['瞪大','',''],['瞪头转向','',''],['瞪目凝视','',''],['瞪眼','',''],['瞪着','',''],['瞪羚','',''],['瞪著','',''],['瞪著眼','',''],['瞪视','',''],['瞬发中子','',''],['瞬发辐射','',''],['瞬息','',''],['瞬息万变','',''],['瞬息之间','',''],['瞬息千变','',''],['瞬时','',''],['瞬时计','',''],['瞬时辐射','',''],['瞬时速度','',''],['瞬膜','',''],['瞬间','',''],['瞬间即逝','',''],['瞬间转移','',''],['瞬霎','',''],['瞭哨','',''],['瞭望','',''],['瞭望台','',''],['瞭望哨','',''],['瞰临','',''],['瞰制','',''],['瞰图','',''],['瞰望','',''],['瞳人','',''],['瞳仁','',''],['瞳孔','',''],['瞻仰','',''],['瞻养','',''],['瞻前忽后','',''],['瞻前顾后','',''],['瞻天恋阙','',''],['瞻念','',''],['瞻拜','',''],['瞻望','',''],['瞻礼','',''],['瞻顾','',''],['瞽言妄举','',''],['瞽阇','',''],['瞿塘峡','',''],['瞿昙','',''],['瞿秋白','',''],['矍烁','',''],['矍矍','',''],['矍铄','',''],['矗立','',''],['矛刺','',''],['矛和盾','',''],['矛头','',''],['矛头指向','',''],['矛尖','',''],['矛尖状','',''],['矛柄','',''],['矛盾','',''],['矛盾加剧','',''],['矛盾律','',''],['矛盾激化','',''],['矛盾的普遍性','',''],['矛盾的特殊性','',''],['矛盾相向','',''],['矛盾规律','',''],['矛盾论','',''],['矛盾转化','',''],['矛隼','',''],['矜功不立','',''],['矜功伐善','',''],['矜功恃宠','',''],['矜功自伐','',''],['矜功负气','',''],['矜功负胜','',''],['矜名妒能','',''],['矜名嫉能','',''],['矜夸','',''],['矜奇立异','',''],['矜寡孤独','',''],['矜己任智','',''],['矜己自饰','',''],['矜才使气','',''],['矜持','',''],['矜智负能','',''],['矜矜业业','',''],['矜纠收缭','',''],['矜能负才','',''],['矜贫恤独','',''],['矜贫救厄','',''],['矜贵','',''],['矜重','',''],['矢下如雨','',''],['矢不虚发','',''],['矢口','',''],['矢口否认','',''],['矢口抵赖','',''],['矢在','',''],['矢在弦上','',''],['矢如雨集','',''],['矢尽兵穷','',''],['矢志','',''],['矢志不屈','',''],['矢志不渝','',''],['矢志捐躯','',''],['矢无虚发','',''],['矢枪','',''],['矢死不二','',''],['矢的','',''],['矢石','',''],['矢石之间','',''],['矢石之难','',''],['矢言','',''],['矢车菊','',''],['矢量','',''],['知一不知十','',''],['知一而不知二','',''],['知不','',''],['知不诈愚','',''],['知之不辱','',''],['知之为知之','',''],['知之甚多','',''],['知之甚少','',''],['知书','',''],['知书知礼','',''],['知书识礼','',''],['知书达理','',''],['知书达礼','',''],['知了','',''],['知事','',''],['知交','',''],['知人','',''],['知人下士','',''],['知人之明','',''],['知人之术','',''],['知人则哲','',''],['知人善任','',''],['知人善察','',''],['知人待士','',''],['知人料事','',''],['知人知面不知心','',''],['知人论世','',''],['知今博古','',''],['知会','',''],['知其一不知其二','',''],['知其一不达其二','',''],['知其一未睹其二','',''],['知冷知热','',''],['知单','',''],['知县','',''],['知名','',''],['知名人士','',''],['知名度','',''],['知名当世','',''],['知命','',''],['知命之年','',''],['知命乐天','',''],['知命安身','',''],['知地知天','',''],['知子莫如父','',''],['知安忘危','',''],['知客','',''],['知宾','',''],['知小谋大','',''],['知尽能索','',''],['知州','',''],['知己','',''],['知己之遇','',''],['知己知彼','',''],['知已','',''],['知底','',''],['知府','',''],['知彼知己','',''],['知往鉴今','',''],['知微知彰','',''],['知心','',''],['知心人','',''],['知心朋友','',''],['知心着意','',''],['知心话','',''],['知必言言必尽','',''],['知性','',''],['知恩','',''],['知恩不报','',''],['知恩报德','',''],['知恩报恩','',''],['知悉','',''],['知悭识俭','',''],['知情','',''],['知情不举','',''],['知情不报','',''],['知情人','',''],['知情同意','',''],['知情者','',''],['知情认趣','',''],['知情识趣','',''],['知情达理','',''],['知数','',''],['知无不为','',''],['知无不尽','',''],['知无不言','',''],['知无不言言无不听','',''],['知无不言言无不尽','',''],['知时识务','',''],['知易行难','',''],['知晓','',''],['知更鸟','',''],['知机识变','',''],['知机识窍','',''],['知来藏往','',''],['知根知底','',''],['知止不辱知足不殆','',''],['知母','',''],['知水仁山','',''],['知法','',''],['知法犯法','',''],['知照','',''],['知畿其神','',''],['知疼着热','',''],['知白守黑','',''],['知礼','',''],['知章知微','',''],['知罪','',''],['知羞识廉','',''],['知者','',''],['知而不言','',''],['知耻','',''],['知耻近乎勇','',''],['知觉','',''],['知觉力','',''],['知觉外','',''],['知觉解体','',''],['知识','',''],['知识产权','',''],['知识产权法','',''],['知识分子','',''],['知识化','',''],['知识宝库','',''],['知识密集','',''],['知识就是力量','',''],['知识工程师','',''],['知识库','',''],['知识性','',''],['知识更新','',''],['知识界','',''],['知识竞赛','',''],['知识结构','',''],['知识论','',''],['知识越多越反动','',''],['知识青年','',''],['知识面','',''],['知趣','',''],['知足','',''],['知足不辱知止不殆','',''],['知足常乐','',''],['知足常足','',''],['知足无求','',''],['知足知止','',''],['知足者常乐','',''],['知过','',''],['知过必改','',''],['知过改过','',''],['知过能改','',''],['知返','',''],['知遇','',''],['知遇之恩','',''],['知遇之荣','',''],['知道','',''],['知错必改','',''],['知难而上','',''],['知难而行','',''],['知难而进','',''],['知难而退','',''],['知难行易','',''],['知雄守雌','',''],['知青','',''],['知面不知心','',''],['知面伯明','',''],['知面伯鉴','',''],['知音','',''],['知音识曲','',''],['知音识趣','',''],['知音谙吕','',''],['知高识低','',''],['矩尺','',''],['矩尺座','',''],['矩形','',''],['矩步方行','',''],['矩阵','',''],['矫世励俗','',''],['矫世变俗','',''],['矫健','',''],['矫健敏捷','',''],['矫味剂','',''],['矫宠','',''],['矫形','',''],['矫形医生','',''],['矫形外科','',''],['矫形牙套','',''],['矫情','',''],['矫情干誉','',''],['矫情自饰','',''],['矫情针物','',''],['矫情饰行','',''],['矫情饰诈','',''],['矫情饰貌','',''],['矫捷','',''],['矫揉做作','',''],['矫揉造作','',''],['矫枉过中','',''],['矫枉过正','',''],['矫枉过直','',''],['矫柔','',''],['矫正','',''],['矫正透镜','',''],['矫治','',''],['矫激奇诡','',''],['矫直','',''],['矫矜','',''],['矫矫','',''],['矫若惊龙','',''],['矫言伪行','',''],['矫诏','',''],['矫邪归正','',''],['矫顽性','',''],['矫饰','',''],['矫饰伪行','',''],['矫饰者','',''],['矬子','',''],['短上衣','',''],['短不了','',''],['短中取长','',''],['短中抽长','',''],['短了','',''],['短会','',''],['短传','',''],['短促','',''],['短信','',''],['短债','',''],['短兵接战','',''],['短兵相接','',''],['短内裤','',''],['短刀','',''],['短剑','',''],['短剧','',''],['短卷发','',''],['短发','',''],['短句','',''],['短号','',''],['短叹长吁','',''],['短吨','',''],['短吻','',''],['短命','',''],['短垣自逾','',''],['短处','',''],['短外套','',''],['短大衣','',''],['短寿促命','',''],['短小','',''],['短小精悍','',''],['短少','',''],['短尾巴','',''],['短尾猴','',''],['短尾猿','',''],['短尾矮袋鼠','',''],['短局','',''],['短工','',''],['短帷幔','',''],['短平快','',''],['短打','',''],['短打扮','',''],['短指','',''],['短收','',''],['短文','',''],['短斤少两','',''],['短日照植物','',''],['短时储存','',''],['短时语音记忆','',''],['短时间','',''],['短暂','',''],['短期','',''],['短期内','',''],['短期培训','',''],['短期投资','',''],['短期融资','',''],['短期行为','',''],['短期计划','',''],['短杖','',''],['短枪','',''],['短柄','',''],['短桩','',''],['短梗飘萍','',''],['短梗飘蓬','',''],['短棍','',''],['短欠','',''],['短款','',''],['短歌','',''],['短毛','',''],['短气','',''],['短波','',''],['短波天线','',''],['短波长','',''],['短浅','',''],['短烟斗','',''],['短片','',''],['短白衣','',''],['短的','',''],['短短','',''],['短短几天','',''],['短短的','',''],['短矮','',''],['短码','',''],['短程','',''],['短程线','',''],['短笛','',''],['短简','',''],['短篇','',''],['短篇小说','',''],['短粗','',''],['短纤维','',''],['短线','',''],['短线产品','',''],['短统靴','',''],['短绠汲深','',''],['短绳','',''],['短缺','',''],['短缺商品','',''],['短羹吹齑','',''],['短脚','',''],['短腮','',''],['短腿','',''],['短腿猎犬','',''],['短至','',''],['短衣','',''],['短衣帮','',''],['短衫','',''],['短袖','',''],['短袜','',''],['短装','',''],['短裙','',''],['短裤','',''],['短褐','',''],['短褐不全','',''],['短褐不完','',''],['短见','',''],['短视','',''],['短角牛','',''],['短训班','',''],['短讯','',''],['短论','',''],['短评','',''],['短诗','',''],['短语','',''],['短语录','',''],['短说','',''],['短跑','',''],['短距离','',''],['短距起落飞机','',''],['短路','',''],['短途','',''],['短途运输','',''],['短锯','',''],['短长','',''],['短靴','',''],['短音','',''],['短音符','',''],['短音阶','',''],['短骨','',''],['矮丛','',''],['矮丛林','',''],['矮个','',''],['矮个儿','',''],['矮个子','',''],['矮人','',''],['矮凳','',''],['矮化','',''],['矮半截','',''],['矮呆病','',''],['矮地茶','',''],['矮墙','',''],['矮墩','',''],['矮墩墩','',''],['矮壮素','',''],['矮子','',''],['矮子看场','',''],['矮子看戏','',''],['矮子观场','',''],['矮子里拔将军','',''],['矮小','',''],['矮小精悍','',''],['矮屋','',''],['矮床','',''],['矮房','',''],['矮星','',''],['矮杆品种','',''],['矮杨梅','',''],['矮松','',''],['矮林','',''],['矮树','',''],['矮瓜','',''],['矮的','',''],['矮短','',''],['矮矮','',''],['矮秆作物','',''],['矮种','',''],['矮糠','',''],['矮胖','',''],['矮脚白花蛇利草','',''],['矮脚罗伞','',''],['矮脚苦蒿','',''],['矮茎朱砂根','',''],['矮行星','',''],['矮鹿','',''],['矮黑人','',''],['石一般','',''],['石作','',''],['石像','',''],['石冈','',''],['石冈乡','',''],['石决明','',''],['石凳','',''],['石刁柏','',''],['石刑','',''],['石制','',''],['石刻','',''],['石勒','',''],['石化','',''],['石化厂','',''],['石匠','',''],['石匠痨','',''],['石南属','',''],['石南树','',''],['石南花','',''],['石印','',''],['石印品','',''],['石原慎太郎','',''],['石咀山','',''],['石咀山区','',''],['石咀山市','',''],['石嘴山区','',''],['石器','',''],['石器时代','',''],['石场','',''],['石坎','',''],['石坑','',''],['石块','',''],['石基','',''],['石堆','',''],['石塔','',''],['石墙','',''],['石墨','',''],['石墨气冷堆','',''],['石壁','',''],['石太铁路','',''],['石头','',''],['石头、剪子、布','',''],['石头子儿','',''],['石头火锅','',''],['石女','',''],['石子','',''],['石子儿','',''],['石室金匮','',''],['石家庄地区','',''],['石屎','',''],['石屎森林','',''],['石山','',''],['石岗','',''],['石岛','',''],['石工','',''],['石库门','',''],['石庭','',''],['石弩','',''],['石径','',''],['石德铁路','',''],['石心','',''],['石心木肠','',''],['石投大海','',''],['石担','',''],['石拱','',''],['石敢当','',''],['石斑鱼','',''],['石料','',''],['石斛','',''],['石斛夜光丸','',''],['石斧','',''],['石方','',''],['石景','',''],['石景山','',''],['石末沉着病','',''],['石末肺','',''],['石材','',''],['石村','',''],['石松','',''],['石板','',''],['石板样','',''],['石板瓦','',''],['石板路','',''],['石林','',''],['石林县','',''],['石林风景区','',''],['石枯松老','',''],['石柱','',''],['石柱县','',''],['石栏','',''],['石栗','',''],['石桥','',''],['石梯','',''],['石棉水泥瓦','',''],['石棉瓦','',''],['石棉纤维','',''],['石棺','',''],['石楠','',''],['石榴','',''],['石榴子','',''],['石榴树','',''],['石榴石','',''],['石沉大海','',''],['石油','',''],['石油勘探','',''],['石油化学','',''],['石油化工','',''],['石油商','',''],['石油地理','',''],['石油工业','',''],['石油市场','',''],['石油换食品项目','',''],['石油气','',''],['石油精','',''],['石油蜡','',''],['石油输出国组织','',''],['石油醚','',''],['石洞','',''],['石涛','',''],['石渠阁','',''],['石渠阁议','',''],['石渣','',''],['石火电光','',''],['石灰','',''],['石灰乳','',''],['石灰化','',''],['石灰华','',''],['石灰岩','',''],['石灰水','',''],['石灰石','',''],['石灰窑','',''],['石灰质','',''],['石炭','',''],['石炭井','',''],['石炭井区','',''],['石炭系','',''],['石炭纪','',''],['石炭酸','',''],['石烂','',''],['石烂海枯','',''],['石煤','',''],['石燕','',''],['石片','',''],['石版','',''],['石版家','',''],['石版画','',''],['石状','',''],['石狮子','',''],['石玉昆','',''],['石田芳夫','',''],['石盐','',''],['石砌','',''],['石砬子','',''],['石破天惊','',''],['石砾','',''],['石硫合剂','',''],['石碇','',''],['石碇乡','',''],['石碑','',''],['石碓','',''],['石碣','',''],['石碴','',''],['石磙','',''],['石磨','',''],['石穿','',''],['石窑','',''],['石窟','',''],['石竹','',''],['石竹属','',''],['石竹目','',''],['石竹科','',''],['石笋','',''],['石笔','',''],['石粉','',''],['石级','',''],['石绵','',''],['石绿','',''],['石缝','',''],['石罅','',''],['石羊','',''],['石脑油','',''],['石腊','',''],['石膏','',''],['石膏像','',''],['石膏墙板','',''],['石膏粉','',''],['石膏绷带','',''],['石膏质','',''],['石臼','',''],['石舫','',''],['石花胶','',''],['石花菜','',''],['石苔','',''],['石英','',''],['石英卤素灯','',''],['石英岩','',''],['石英手表','',''],['石英脉','',''],['石英钟','',''],['石菖蒲','',''],['石蒜','',''],['石蕊','',''],['石蕊试纸','',''],['石虎','',''],['石蜡','',''],['石质','',''],['石酸','',''],['石钟乳','',''],['石铺','',''],['石锁','',''],['石门乡','',''],['石阶','',''],['石雕','',''],['石雷','',''],['石青','',''],['石首鱼','',''],['石鲮鱼','',''],['石鼓','',''],['石鼓文','',''],['石龙','',''],['石龙子','',''],['矸子','',''],['矸石','',''],['矻矻','',''],['矽土','',''],['矽晶片','',''],['矽末病','',''],['矽片','',''],['矽石','',''],['矽肺','',''],['矽肺病','',''],['矽胶','',''],['矽藻','',''],['矽谷','',''],['矽酸','',''],['矽酸盐','',''],['矽钢','',''],['矽钢片','',''],['矽铝层','',''],['矽镁层','',''],['矾土','',''],['矾石','',''],['矿上','',''],['矿业','',''],['矿业经济','',''],['矿主','',''],['矿井','',''],['矿井口','',''],['矿产','',''],['矿产品','',''],['矿产综合利用','',''],['矿产资源','',''],['矿体','',''],['矿内','',''],['矿务','',''],['矿务局','',''],['矿厂','',''],['矿场','',''],['矿坑','',''],['矿尘','',''],['矿局','',''],['矿层','',''],['矿山','',''],['矿工','',''],['矿带','',''],['矿床','',''],['矿房','',''],['矿柱','',''],['矿棉','',''],['矿水','',''],['矿油精','',''],['矿泉','',''],['矿泉水','',''],['矿泥','',''],['矿洞','',''],['矿浆','',''],['矿渣','',''],['矿渣堆','',''],['矿渣棉','',''],['矿渣水泥','',''],['矿灯','',''],['矿物','',''],['矿物学','',''],['矿物油','',''],['矿物燃料','',''],['矿物纤维','',''],['矿物质','',''],['矿盐','',''],['矿石','',''],['矿石收音机','',''],['矿石机','',''],['矿砂','',''],['矿种','',''],['矿穴','',''],['矿类','',''],['矿粉','',''],['矿脂','',''],['矿脉','',''],['矿苗','',''],['矿藏','',''],['矿质','',''],['矿车','',''],['矿部','',''],['矿长','',''],['矿难','',''],['码位','',''],['码元','',''],['码分多址','',''],['码头','',''],['码子','',''],['码字','',''],['码尺','',''],['码放','',''],['码数','',''],['码线','',''],['码表','',''],['码长城','',''],['码云','',''],['砂仁','',''],['砂器','',''],['砂土','',''],['砂型','',''],['砂堆','',''],['砂子','',''],['砂岩','',''],['砂布','',''],['砂心','',''],['砂拉越','',''],['砂样','',''],['砂模','',''],['砂浆','',''],['砂烬','',''],['砂眼','',''],['砂石','',''],['砂砾','',''],['砂礓','',''],['砂积矿床','',''],['砂箱','',''],['砂糖','',''],['砂纸','',''],['砂轮','',''],['砂金石','',''],['砂锅','',''],['砌体','',''],['砌合','',''],['砌合法','',''],['砌块','',''],['砌基脚','',''],['砌墙','',''],['砌层','',''],['砌成','',''],['砌末','',''],['砌石','',''],['砌砖','',''],['砌砖工','',''],['砌词捏控','',''],['砌路','',''],['砍下','',''],['砍价','',''],['砍伐','',''],['砍伐者','',''],['砍伤','',''],['砍倒','',''],['砍光','',''],['砍刀','',''],['砍到','',''],['砍去','',''],['砍坏','',''],['砍大山','',''],['砍头','',''],['砍头疮','',''],['砍开','',''],['砍得','',''],['砍成','',''],['砍掉','',''],['砍断','',''],['砍木','',''],['砍杀','',''],['砍林','',''],['砍柴','',''],['砍树','',''],['砍死','',''],['砍瓜切菜','',''],['砍痕','',''],['砑光','',''],['砒霜','',''],['研习','',''],['研京练都','',''],['研修','',''],['研修员','',''],['研修班','',''],['研光','',''],['研几探赜','',''],['研几析理','',''],['研判','',''],['研制','',''],['研制出','',''],['研制成','',''],['研制者','',''],['研制过程','',''],['研华','',''],['研发','',''],['研商对策','',''],['研定','',''],['研成','',''],['研拟','',''],['研析','',''],['研桑心计','',''],['研求','',''],['研深覃精','',''],['研碎','',''],['研磨','',''],['研磨剂','',''],['研磨料','',''],['研磨机','',''],['研磨材料','',''],['研磨用','',''],['研磨盘','',''],['研磨者','',''],['研究','',''],['研究中心','',''],['研究人员','',''],['研究会','',''],['研究出','',''],['研究反应堆','',''],['研究员','',''],['研究室','',''],['研究小组','',''],['研究工作','',''],['研究成果','',''],['研究所','',''],['研究报告','',''],['研究机构','',''],['研究生','',''],['研究生院','',''],['研究者','',''],['研究资料','',''],['研究院','',''],['研究领域','',''],['研粉','',''],['研精苦思','',''],['研精覃奥','',''],['研精覃思','',''],['研精覃虑','',''],['研精钩深','',''],['研精铸史','',''],['研精静虑','',''],['研考','',''],['研讨','',''],['研讨会','',''],['研读','',''],['研钵','',''],['砖匠','',''],['砖厂','',''],['砖块','',''],['砖坯','',''],['砖墙','',''],['砖壁','',''],['砖头','',''],['砖工','',''],['砖房','',''],['砖模','',''],['砖瓦','',''],['砖石','',''],['砖石工','',''],['砖窑','',''],['砖窑场','',''],['砖窖','',''],['砖红土','',''],['砖色','',''],['砖茶','',''],['砖雕','',''],['砖面','',''],['砗磲','',''],['砘子','',''],['砚兄','',''],['砚兄砚弟','',''],['砚友','',''],['砚台','',''],['砚室','',''],['砚席','',''],['砚弟','',''],['砚水壶儿','',''],['砚池','',''],['砚滴','',''],['砚瓦','',''],['砚田','',''],['砚田之食','',''],['砚盒','',''],['砚石','',''],['砚耕','',''],['砝码','',''],['砟子','',''],['砢碜','',''],['砣子','',''],['砥兵砺伍','',''],['砥名励节','',''],['砥平绳直','',''],['砥柱','',''],['砥柱中流','',''],['砥石','',''],['砥砺','',''],['砥砺名号','',''],['砥砺名节','',''],['砥砺名行','',''],['砥砺廉隅','',''],['砥砺清节','',''],['砥砺风节','',''],['砥节奉公','',''],['砥节守公','',''],['砥节砺行','',''],['砥行磨名','',''],['砥行立名','',''],['砧台','',''],['砧子','',''],['砧木','',''],['砧板','',''],['砧骨','',''],['砬子','',''],['砭灸','',''],['砭灸术','',''],['砭石','',''],['砭针','',''],['砭骨','',''],['砰击声','',''],['砰地','',''],['砰地一声','',''],['砰声','',''],['砰然','',''],['砰然声','',''],['砰砰','',''],['破业失产','',''],['破了','',''],['破五','',''],['破亡','',''],['破产','',''],['破产法','',''],['破产者','',''],['破伤风','',''],['破体字','',''],['破例','',''],['破关','',''],['破关斩将','',''],['破冰','',''],['破冰型艏','',''],['破冰舰','',''],['破冰船','',''],['破击','',''],['破击战','',''],['破口','',''],['破口大骂','',''],['破句','',''],['破哓','',''],['破四','',''],['破四旧','',''],['破国亡宗','',''],['破土','',''],['破土典礼','',''],['破土动工','',''],['破坏','',''],['破坏分子','',''],['破坏力','',''],['破坏性','',''],['破坏无遗','',''],['破坏活动','',''],['破坏者','',''],['破城','',''],['破壁','',''],['破壁飞去','',''],['破壳','',''],['破处','',''],['破天荒','',''],['破家','',''],['破家为国','',''],['破家危国','',''],['破家散业','',''],['破家鬻子','',''],['破密','',''],['破局','',''],['破布','',''],['破帽','',''],['破庙','',''],['破开','',''],['破成','',''],['破戒','',''],['破折','',''],['破折号','',''],['破损','',''],['破掉','',''],['破敝','',''],['破旧','',''],['破旧不堪','',''],['破旧立新','',''],['破晓','',''],['破格','',''],['破案','',''],['破案率','',''],['破洞','',''],['破浪','',''],['破涕','',''],['破涕为笑','',''],['破溃','',''],['破漏','',''],['破灭','',''],['破烂','',''],['破烂不堪','',''],['破烂货','',''],['破片','',''],['破琴绝弦','',''],['破瓦寒窑','',''],['破瓦颓垣','',''],['破甑生尘','',''],['破甲弹','',''],['破的','',''],['破皮','',''],['破相','',''],['破破','',''],['破破烂烂','',''],['破碎','',''],['破碎支离','',''],['破碎片','',''],['破碗破摔','',''],['破竹之势','',''],['破竹建瓴','',''],['破约','',''],['破纪录','',''],['破绽','',''],['破绽百出','',''],['破缺','',''],['破罐破摔','',''],['破胆','',''],['破胆丧魂','',''],['破胆寒心','',''],['破脸','',''],['破船','',''],['破获','',''],['破落','',''],['破落户','',''],['破蛹','',''],['破衣','',''],['破衣服','',''],['破裂','',''],['破裂摩擦音','',''],['破裂音','',''],['破规为圜','',''],['破觚为圆','',''],['破觚为圜','',''],['破解','',''],['破计','',''],['破记录','',''],['破译','',''],['破读','',''],['破谜儿','',''],['破财','',''],['破财免灾','',''],['破败','',''],['破败不堪','',''],['破费','',''],['破身','',''],['破车','',''],['破釜沉舟','',''],['破釜沉船','',''],['破钞','',''],['破镜','',''],['破镜分钗','',''],['破镜重合','',''],['破镜重圆','',''],['破镜重归','',''],['破门','',''],['破门而入','',''],['破阵','',''],['破除','',''],['破除迷信','',''],['破鞋','',''],['破音字','',''],['破题','',''],['破颜','',''],['砷中毒','',''],['砷化氢','',''],['砷化物','',''],['砷酸盐','',''],['砷黄铁矿','',''],['砸下','',''],['砸了','',''],['砸伤','',''],['砸在','',''],['砸坏','',''],['砸夯','',''],['砸开','',''],['砸抢','',''],['砸死','',''],['砸毁','',''],['砸烂','',''],['砸破','',''],['砸碎','',''],['砸舌','',''],['砸锅','',''],['砸锅卖铁','',''],['砸饭碗','',''],['砺兵秣马','',''],['砺山带河','',''],['砺戈秣马','',''],['砻糠','',''],['砾层','',''],['砾岩','',''],['砾石','',''],['硅化木','',''],['硅土','',''],['硅晶片','',''],['硅橡胶','',''],['硅沙','',''],['硅油','',''],['硅灰石','',''],['硅片','',''],['硅石','',''],['硅砖','',''],['硅肺','',''],['硅肺病','',''],['硅胶','',''],['硅藻','',''],['硅藻土','',''],['硅藻门','',''],['硅质','',''],['硅质岩','',''],['硅酐','',''],['硅酸','',''],['硅酸氟铝','',''],['硅酸盐','',''],['硅酸盐工业','',''],['硅酸盐水泥','',''],['硅酸钠','',''],['硅酸铅','',''],['硅钢','',''],['硅钢片','',''],['硅铁','',''],['硅铝质','',''],['硇砂','',''],['硌牙','',''],['硌破','',''],['硐室','',''],['硕丽','',''],['硕士','',''],['硕士学位','',''],['硕士生','',''],['硕士研究生','',''],['硕大','',''],['硕大无朋','',''],['硕大无比','',''],['硕果','',''],['硕果仅存','',''],['硕果累累','',''],['硗确','',''],['硗薄','',''],['硙硙','',''],['硚口','',''],['硚头','',''],['硝化','',''],['硝化作用','',''],['硝化甘油','',''],['硝基','',''],['硝基苯','',''],['硝氮','',''],['硝烟','',''],['硝烟弥漫','',''],['硝烟弹雨','',''],['硝烟滚滚','',''],['硝盐','',''],['硝石','',''],['硝碱','',''],['硝磺','',''],['硝胺','',''],['硝酸','',''],['硝酸甘油','',''],['硝酸盐','',''],['硝酸钙','',''],['硝酸钠','',''],['硝酸钾','',''],['硝酸铵','',''],['硝酸银','',''],['硝镪水','',''],['硫代硫酸钠','',''],['硫分','',''],['硫化','',''],['硫化橡胶','',''],['硫化氢','',''],['硫化汞','',''],['硫化物','',''],['硫化碱','',''],['硫化碳','',''],['硫化钠','',''],['硫化铁','',''],['硫化铅','',''],['硫化锌','',''],['硫华','',''],['硫氰酸','',''],['硫氰酸盐','',''],['硫氰酸酶','',''],['硫球','',''],['硫磷铵','',''],['硫磺','',''],['硫磺般','',''],['硫磺色','',''],['硫粉','',''],['硫胺素','',''],['硫苦','',''],['硫茚','',''],['硫酸','',''],['硫酸亚铁','',''],['硫酸亚铁铵','',''],['硫酸盐','',''],['硫酸钙','',''],['硫酸钠','',''],['硫酸钡','',''],['硫酸钾','',''],['硫酸铁','',''],['硫酸铜','',''],['硫酸铝','',''],['硫酸铵','',''],['硫酸锌','',''],['硫酸镁','',''],['硫醇','',''],['硫铁矿','',''],['硫黄','',''],['硬了','',''],['硬仗','',''],['硬件','',''],['硬件平台','',''],['硬体','',''],['硬冲','',''],['硬功夫','',''],['硬化','',''],['硬化症','',''],['硬卡','',''],['硬卧','',''],['硬取','',''],['硬块','',''],['硬壳','',''],['硬壳子','',''],['硬壳果','',''],['硬实','',''],['硬币','',''],['硬币坯','',''],['硬币形','',''],['硬席','',''],['硬干','',''],['硬度','',''],['硬度计','',''],['硬座','',''],['硬弓','',''],['硬性','',''],['硬性摊派','',''],['硬性规定','',''],['硬手','',''],['硬扯','',''],['硬拖','',''],['硬拷贝','',''],['硬拼','',''],['硬挣','',''],['硬挤','',''],['硬挺','',''],['硬推','',''],['硬撅撅','',''],['硬撑','',''],['硬是','',''],['硬朗','',''],['硬木','',''],['硬来','',''],['硬核','',''],['硬梆梆','',''],['硬棒','',''],['硬橡皮','',''],['硬橡胶','',''],['硬毛','',''],['硬气','',''],['硬水','',''],['硬汉','',''],['硬汉子','',''],['硬派','',''],['硬煤','',''],['硬玉','',''],['硬生生','',''],['硬的','',''],['硬皮','',''],['硬盘','',''],['硬目标','',''],['硬直','',''],['硬着','',''],['硬着头皮','',''],['硬着陆','',''],['硬石膏','',''],['硬硬','',''],['硬碟','',''],['硬碟机','',''],['硬碰','',''],['硬碰硬','',''],['硬磁盘','',''],['硬笔','',''],['硬糖','',''],['硬纸','',''],['硬纸板','',''],['硬结','',''],['硬给','',''],['硬而','',''],['硬背','',''],['硬脂','',''],['硬脂酸','',''],['硬脂酸钙','',''],['硬腭','',''],['硬花','',''],['硬要','',''],['硬记','',''],['硬语盘空','',''],['硬说','',''],['硬调','',''],['硬质','',''],['硬质合金','',''],['硬通货','',''],['硬逼','',''],['硬邦邦','',''],['硬闯','',''],['硬面','',''],['硬顶','',''],['硬顶跑车','',''],['硬领','',''],['硬饼','',''],['硬驱','',''],['硬骨','',''],['硬骨头','',''],['硬骨鱼','',''],['硭硝','',''],['确乎','',''],['确保','',''],['确信','',''],['确信无疑','',''],['确凿','',''],['确凿不移','',''],['确切','',''],['确切性','',''],['确切无疑','',''],['确守','',''],['确定','',''],['确定不移','',''],['确定性','',''],['确定效应','',''],['确实','',''],['确实性','',''],['确当','',''],['确是','',''],['确有其事','',''],['确确实实','',''],['确立','',''],['确认','',''],['确证','',''],['确证者','',''],['确诊','',''],['确非易事','',''],['硷酸','',''],['硼化物','',''],['硼玻璃','',''],['硼砂','',''],['硼酸','',''],['硼酸盐','',''],['硼钢','',''],['硼铁','',''],['碇泊','',''],['碉堡','',''],['碉楼','',''],['碌碌','',''],['碌碌庸才','',''],['碌碌庸流','',''],['碌碌无为','',''],['碌碌无能','',''],['碌碌无闻','',''],['碌碡','',''],['碍事','',''],['碍口','',''],['碍口识羞','',''],['碍手','',''],['碍手碍脚','',''],['碍物','',''],['碍眼','',''],['碍胃口','',''],['碍脚','',''],['碍难','',''],['碍难从命','',''],['碍面子','',''],['碎了','',''],['碎催','',''],['碎冰','',''],['碎冰船','',''],['碎嘴子','',''],['碎块','',''],['碎块儿','',''],['碎声','',''],['碎尸','',''],['碎屑','',''],['碎屑岩','',''],['碎屑沉积物','',''],['碎布','',''],['碎布条','',''],['碎心裂胆','',''],['碎成','',''],['碎掉','',''],['碎料','',''],['碎末','',''],['碎杏仁','',''],['碎步','',''],['碎步儿','',''],['碎片','',''],['碎片性','',''],['碎片整理','',''],['碎物','',''],['碎琼乱玉','',''],['碎皮','',''],['碎石','',''],['碎石堆','',''],['碎石路','',''],['碎粉状','',''],['碎纸','',''],['碎纸机','',''],['碎肉','',''],['碎肉器','',''],['碎裂','',''],['碎身粉骨','',''],['碎钻','',''],['碎首糜身','',''],['碎骨粉身','',''],['碑亭','',''],['碑刻','',''],['碑匾','',''],['碑帖','',''],['碑座','',''],['碑座儿','',''],['碑志','',''],['碑文','',''],['碑林','',''],['碑珓','',''],['碑石','',''],['碑碣','',''],['碑记','',''],['碑铭','',''],['碑阴','',''],['碑额','',''],['碓房','',''],['碗儿','',''],['碗柜','',''],['碗橱','',''],['碗盆','',''],['碗盘','',''],['碗碗腔','',''],['碗碟','',''],['碗碟橱','',''],['碗筷','',''],['碗豆','',''],['碗边','',''],['碗里','',''],['碘中毒','',''],['碘仿','',''],['碘化物','',''],['碘化钠','',''],['碘化钾','',''],['碘化银','',''],['碘片','',''],['碘酒','',''],['碘酸','',''],['碘酸盐','',''],['碘钨灯','',''],['碟子','',''],['碟形','',''],['碟片','',''],['碟盆类','',''],['碧云','',''],['碧土','',''],['碧土县','',''],['碧桃','',''],['碧欧泉','',''],['碧水','',''],['碧水苍天','',''],['碧油油','',''],['碧波','',''],['碧海','',''],['碧海青天','',''],['碧潭','',''],['碧玉','',''],['碧玺','',''],['碧瑶','',''],['碧瓦','',''],['碧瓦朱甍','',''],['碧眼','',''],['碧空','',''],['碧绿','',''],['碧绿色','',''],['碧色','',''],['碧草','',''],['碧草如茵','',''],['碧落','',''],['碧落黄泉','',''],['碧蓝','',''],['碧螺春','',''],['碧血','',''],['碧血丹心','',''],['碰一鼻子灰','',''],['碰上','',''],['碰了','',''],['碰伤','',''],['碰倒','',''],['碰击','',''],['碰击声','',''],['碰到','',''],['碰劲儿','',''],['碰坏','',''],['碰壁','',''],['碰声','',''],['碰头','',''],['碰头会','',''],['碰巧','',''],['碰损','',''],['碰撞','',''],['碰撞造山','',''],['碰擦','',''],['碰杯','',''],['碰碰','',''],['碰碰车','',''],['碰磁','',''],['碰磁人','',''],['碰磁儿','',''],['碰翻','',''],['碰著','',''],['碰见','',''],['碰触','',''],['碰车','',''],['碰过','',''],['碰运','',''],['碰钉子','',''],['碰锁','',''],['碰面','',''],['碱化','',''],['碱叫','',''],['碱土','',''],['碱土金属','',''],['碱地','',''],['碱场','',''],['碱基','',''],['碱基互补配对','',''],['碱基对','',''],['碱基配对','',''],['碱度','',''],['碱式','',''],['碱式盐','',''],['碱性','',''],['碱性化','',''],['碱性土','',''],['碱性尘雾','',''],['碱性岩','',''],['碱性蓝','',''],['碱性金属','',''],['碱斑','',''],['碱水','',''],['碱水湖','',''],['碱法纸浆','',''],['碱洗','',''],['碱液','',''],['碱熔','',''],['碱类','',''],['碱腺','',''],['碱荒','',''],['碱试法','',''],['碱质','',''],['碱金属','',''],['碲化物','',''],['碳减排','',''],['碳化','',''],['碳化氢','',''],['碳化物','',''],['碳化硅','',''],['碳化钙','',''],['碳原子','',''],['碳棒','',''],['碳氢化合物','',''],['碳水','',''],['碳水化合物','',''],['碳汇','',''],['碳焙','',''],['碳粉','',''],['碳精','',''],['碳素','',''],['碳素钢','',''],['碳足印','',''],['碳酐','',''],['碳酰基','',''],['碳酰氯','',''],['碳酸','',''],['碳酸岩','',''],['碳酸气','',''],['碳酸氢钠','',''],['碳酸氢铵','',''],['碳酸盐','',''],['碳酸钙','',''],['碳酸钠','',''],['碳酸钾','',''],['碳酸铵','',''],['碳酸镁','',''],['碳钢','',''],['碳链','',''],['碳链纤维','',''],['碳隔离','',''],['碳黑','',''],['碴儿','',''],['碴土','',''],['碴子','',''],['碾压','',''],['碾场','',''],['碾坊','',''],['碾子','',''],['碾子山','',''],['碾平','',''],['碾槌','',''],['碾盘','',''],['碾砣','',''],['碾碎','',''],['碾磙子','',''],['碾磨','',''],['碾米','',''],['碾米机','',''],['碾轧','',''],['碾过','',''],['磁介质','',''],['磁体','',''],['磁倾角','',''],['磁偏角','',''],['磁共振','',''],['磁共振成像','',''],['磁力','',''],['磁力线','',''],['磁力计','',''],['磁力锁','',''],['磁动','',''],['磁化','',''],['磁化器','',''],['磁单极子','',''],['磁卡','',''],['磁合金','',''],['磁器','',''],['磁场','',''],['磁场强度','',''],['磁块','',''],['磁头','',''],['磁学','',''],['磁学家','',''],['磁导','',''],['磁导率','',''],['磁层','',''],['磁带','',''],['磁带机','',''],['磁异常','',''],['磁心','',''],['磁性','',''],['磁性录象','',''],['磁性录音','',''],['磁性瓷','',''],['磁悬浮','',''],['磁感应','',''],['磁感应强度','',''],['磁感线','',''],['磁控管','',''],['磁效应','',''],['磁暴','',''],['磁束','',''],['磁条','',''],['磁极','',''],['磁棒','',''],['磁气圈','',''],['磁泡','',''],['磁波','',''],['磁流','',''],['磁流体','',''],['磁流体发电','',''],['磁浮','',''],['磁片','',''],['磁珠','',''],['磁球','',''],['磁瓶','',''],['磁电','',''],['磁电学','',''],['磁电机','',''],['磁电管','',''],['磁疗','',''],['磁疗器','',''],['磁盘','',''],['磁盘片','',''],['磁盘驱动器','',''],['磁矩','',''],['磁石','',''],['磁碟','',''],['磁碟机','',''],['磁管','',''],['磁粉','',''],['磁线','',''],['磁能','',''],['磁膜','',''],['磁芯','',''],['磁质','',''],['磁路','',''],['磁轨','',''],['磁轴','',''],['磁选','',''],['磁通','',''],['磁通量','',''],['磁道','',''],['磁针','',''],['磁钉','',''],['磁钢','',''],['磁铁','',''],['磁铁矿','',''],['磁鼓','',''],['磅值','',''],['磅盘','',''],['磅礴','',''],['磅秤','',''],['磅达','',''],['磊磊','',''],['磊磊落落','',''],['磊磊轶荡','',''],['磊落','',''],['磊落不凡','',''],['磊落不羁','',''],['磊落大方','',''],['磋商','',''],['磋商会','',''],['磋商者','',''],['磋跎','',''],['磐石之安','',''],['磐石县','',''],['磕头','',''],['磕头如捣','',''],['磕头虫','',''],['磕巴','',''],['磕打','',''],['磕牙','',''],['磕牙料嘴','',''],['磕睡','',''],['磕碰','',''],['磕碰儿','',''],['磕磕','',''],['磕磕巴巴','',''],['磕磕撞撞','',''],['磕磕碰碰','',''],['磕磕绊绊','',''],['磕膝盖','',''],['磙子','',''],['磨不开','',''],['磨亮','',''],['磨人','',''],['磨伤','',''],['磨光','',''],['磨光器','',''],['磨具','',''],['磨出','',''],['磨刀','',''],['磨刀石','',''],['磨刀霍霍','',''],['磨制石器','',''],['磨削','',''],['磨厉以须','',''],['磨去','',''],['磨叨','',''],['磨叽','',''],['磨合','',''],['磨唧','',''],['磨嘴','',''],['磨嘴皮','',''],['磨嘴皮子','',''],['磨坊','',''],['磨坊主','',''],['磨子','',''],['磨工','',''],['磨工病','',''],['磨平','',''],['磨床','',''],['磨得开','',''],['磨快','',''],['磨性','',''],['磨成','',''],['磨成粉','',''],['磨折','',''],['磨拳擦掌','',''],['磨损','',''],['磨损了','',''],['磨损性','',''],['磨损率','',''],['磨掉','',''],['磨揉迁革','',''],['磨擦','',''],['磨擦声','',''],['磨料','',''],['磨机','',''],['磨杵成针','',''],['磨枪','',''],['磨洋工','',''],['磨灭','',''],['磨炼','',''],['磨烦','',''],['磨片','',''],['磨牙','',''],['磨盘','',''],['磨盾之暇','',''],['磨石','',''],['磨石砂砾','',''],['磨石粗砂岩','',''],['磨砂','',''],['磨砂玻璃','',''],['磨砂膏','',''],['磨研','',''],['磨砖对缝','',''],['磨破','',''],['磨破口舌','',''],['磨破嘴皮','',''],['磨破嘴皮子','',''],['磨砺','',''],['磨砺以须','',''],['磨砻砥砺','',''],['磨碎','',''],['磨碎机','',''],['磨磨蹭蹭','',''],['磨穿','',''],['磨穿铁砚','',''],['磨粉','',''],['磨粉厂','',''],['磨粉机','',''],['磨练','',''],['磨细','',''],['磨而不磷','',''],['磨耗','',''],['磨舌头','',''],['磨菇','',''],['磨蚀','',''],['磨谷物','',''],['磨豆腐','',''],['磨起泡','',''],['磨蹭','',''],['磨过','',''],['磨难','',''],['磨顶至踵','',''],['磨齿','',''],['磬竭','',''],['磷光','',''],['磷化','',''],['磷化氢','',''],['磷化钙','',''],['磷火','',''],['磷灰石','',''],['磷灰粉','',''],['磷石','',''],['磷矿','',''],['磷矿石','',''],['磷矿粉','',''],['磷磷','',''],['磷肥','',''],['磷脂','',''],['磷虾','',''],['磷酰基磷酸酶','',''],['磷酸','',''],['磷酸盐','',''],['磷酸盐岩','',''],['磷酸质','',''],['磷酸钙','',''],['磷酸钠','',''],['磷酸铵','',''],['磷铵','',''],['磺化','',''],['磺胺','',''],['磺胺噻唑','',''],['磺胺类','',''],['磺胺脒','',''],['磺酸','',''],['礁岛','',''],['礁岩','',''],['礁湖','',''],['礁湖星云','',''],['礁溪','',''],['礁溪乡','',''],['礁石','',''],['礌石','',''],['礜石','',''],['礞石','',''],['礤床','',''],['礤床儿','',''],['示人','',''],['示以','',''],['示众','',''],['示例','',''],['示例代码','',''],['示图','',''],['示复','',''],['示好','',''],['示威','',''],['示威游行','',''],['示威者','',''],['示威运动','',''],['示寂','',''],['示弱','',''],['示性','',''],['示性类','',''],['示恩','',''],['示意','',''],['示意图','',''],['示意性','',''],['示数器','',''],['示法','',''],['示波器','',''],['示波图','',''],['示波管','',''],['示波镜','',''],['示爱','',''],['示物','',''],['示现','',''],['示范','',''],['示范作用','',''],['示范动作','',''],['示范区','',''],['示范户','',''],['示范表演','',''],['示警','',''],['示踪原子','',''],['礼不亲授','',''],['礼义','',''],['礼义廉耻','',''],['礼之用和为贵','',''],['礼乐','',''],['礼乐崩坏','',''],['礼仪','',''],['礼俗','',''],['礼冠','',''],['礼制','',''],['礼券','',''],['礼单','',''],['礼品','',''],['礼器','',''],['礼坏乐崩','',''],['礼坏乐缺','',''],['礼堂','',''],['礼士亲贤','',''],['礼多人不怪','',''],['礼奢宁俭','',''],['礼宾','',''],['礼宾司','',''],['礼尚往来','',''],['礼崩乐坏','',''],['礼带','',''],['礼帽','',''],['礼废乐崩','',''],['礼成','',''],['礼拜','',''],['礼拜一','',''],['礼拜三','',''],['礼拜二','',''],['礼拜五','',''],['礼拜仪式','',''],['礼拜六','',''],['礼拜四','',''],['礼拜堂','',''],['礼拜天','',''],['礼拜室','',''],['礼拜式','',''],['礼拜日','',''],['礼教','',''],['礼教吃人','',''],['礼数','',''],['礼无不答','',''],['礼服','',''],['礼服呢','',''],['礼治','',''],['礼法','',''],['礼炮','',''],['礼炮号','',''],['礼物','',''],['礼盒','',''],['礼盘','',''],['礼经','',''],['礼聘','',''],['礼节','',''],['礼节性','',''],['礼花','',''],['礼让','',''],['礼让为国','',''],['礼记','',''],['礼貌','',''],['礼貌待客','',''],['礼贤','',''],['礼贤下士','',''],['礼贤接士','',''],['礼贤远佞','',''],['礼赞','',''],['礼路儿','',''],['礼轻','',''],['礼轻人意重','',''],['礼轻情义重','',''],['礼轻情意重','',''],['礼遇','',''],['礼部','',''],['礼部尚书','',''],['礼金','',''],['礼顺人情','',''],['礼饼','',''],['社交','',''],['社交上','',''],['社交室','',''],['社交性','',''],['社交恐惧症','',''],['社交才能','',''],['社交界','',''],['社交舞','',''],['社交艺术','',''],['社交语言','',''],['社会','',''],['社会上','',''],['社会主义','',''],['社会主义国家共产党和工人党代表会议','',''],['社会主义国有化','',''],['社会主义工人国际','',''],['社会主义所有制','',''],['社会主义改造','',''],['社会主义教育运动','',''],['社会主义现实主义','',''],['社会主义社会','',''],['社会主义积累','',''],['社会主义者','',''],['社会主义革命','',''],['社会事业','',''],['社会保证基金','',''],['社会保险','',''],['社会保险基金','',''],['社会保障','',''],['社会党','',''],['社会党国际','',''],['社会公共利益','',''],['社会公德','',''],['社会关怀','',''],['社会关系','',''],['社会分工','',''],['社会制度','',''],['社会动乱','',''],['社会化','',''],['社会危机','',''],['社会名流','',''],['社会后备基金','',''],['社会团体','',''],['社会基本矛盾','',''],['社会存在','',''],['社会学','',''],['社会实践','',''],['社会工作','',''],['社会工作者','',''],['社会帝国主义','',''],['社会平等','',''],['社会形态','',''],['社会必要劳动','',''],['社会性','',''],['社会总产品','',''],['社会总需求','',''],['社会意识','',''],['社会意识形态','',''],['社会教育','',''],['社会服务','',''],['社会正义','',''],['社会民主','',''],['社会民主主义','',''],['社会民主党','',''],['社会沙文主义','',''],['社会活动','',''],['社会环境','',''],['社会生产两大部类','',''],['社会科学','',''],['社会科学院','',''],['社会等级','',''],['社会纯收入','',''],['社会经济','',''],['社会经济形态','',''],['社会经济结构','',''],['社会行动','',''],['社会语言学','',''],['社会阶层','',''],['社会青年','',''],['社保','',''],['社保体系','',''],['社区','',''],['社区发展','',''],['社区工作','',''],['社区意识','',''],['社友','',''],['社员','',''],['社团','',''],['社团组织','',''],['社址','',''],['社头','',''],['社头乡','',''],['社学','',''],['社工','',''],['社工人','',''],['社戏','',''],['社教','',''],['社民党','',''],['社火','',''],['社科','',''],['社科院','',''],['社稷','',''],['社稷为墟','',''],['社稷之器','',''],['社稷之役','',''],['社稷之臣','',''],['社稷生民','',''],['社纪','',''],['社维法','',''],['社群','',''],['社论','',''],['社评','',''],['社长','',''],['社队','',''],['社鼠城狐','',''],['祀为神','',''],['祀堂','',''],['祀奉','',''],['祀物','',''],['祀神','',''],['祁剧','',''],['祁奚','',''],['祁奚举午','',''],['祁奚举子','',''],['祁奚之举','',''],['祁奚之荐','',''],['祁寒暑雨','',''],['祁寒溽雨','',''],['祁山','',''],['祁红','',''],['祁连山','',''],['祁连山脉','',''],['祆教','',''],['祆道','',''],['祈仙台','',''],['祈佑','',''],['祈使','',''],['祈使句','',''],['祈使法','',''],['祈免','',''],['祈愿','',''],['祈晴祷雨','',''],['祈望','',''],['祈树有缘','',''],['祈求','',''],['祈求者','',''],['祈祷','',''],['祈祷文','',''],['祈祷者','',''],['祈福','',''],['祈福禳灾','',''],['祈请','',''],['祈雨','',''],['祉助金','',''],['祉禄','',''],['祎隋','',''],['祓濯','',''],['祓禊','',''],['祓饰','',''],['祖上','',''],['祖业','',''],['祖产','',''],['祖传','',''],['祖传秘方','',''],['祖先','',''],['祖冲之','',''],['祖国','',''],['祖国光复会','',''],['祖国各地','',''],['祖国和平统一委员会','',''],['祖国统一','',''],['祖坟','',''],['祖姑母','',''],['祖孙','',''],['祖宗','',''],['祖居','',''],['祖师','',''],['祖师爷','',''],['祖性','',''],['祖本','',''],['祖母','',''],['祖母绿','',''],['祖父','',''],['祖父母','',''],['祖父辈','',''],['祖率','',''],['祖祖辈辈','',''],['祖籍','',''],['祖系','',''],['祖舜宗尧','',''],['祖语','',''],['祖辈','',''],['祖述','',''],['祖述尧舜宪章文武','',''],['祖逖之誓','',''],['祖遗','',''],['祖马','',''],['祖鲁','',''],['祖鲁人','',''],['祖鸟','',''],['祖鸟类','',''],['祖龙一炬','',''],['祛寒','',''],['祛暑','',''],['祛淤','',''],['祛疑','',''],['祛病','',''],['祛痰','',''],['祛痰剂','',''],['祛痰药','',''],['祛瘀','',''],['祛蠹除奸','',''],['祛邪','',''],['祛邪除灾','',''],['祛除','',''],['祛风','',''],['祛鬼','',''],['祝你','',''],['祝允明','',''],['祝发','',''],['祝君','',''],['祝哽祝噎','',''],['祝嘏','',''],['祝好','',''],['祝婚','',''],['祝宴','',''],['祝寿','',''],['祝寿延年','',''],['祝您','',''],['祝愿','',''],['祝捷','',''],['祝枝山','',''],['祝歌','',''],['祝祷','',''],['祝福','',''],['祝福者','',''],['祝融','',''],['祝词','',''],['祝谢','',''],['祝贺','',''],['祝贺者','',''],['祝贺词','',''],['祝辞','',''],['祝酒','',''],['祝酒歌','',''],['祝酒词','',''],['祝酒辞','',''],['祝颂','',''],['神上','',''],['神不主体','',''],['神不守舍','',''],['神不知鬼不觉','',''],['神丹','',''],['神丹妙药','',''],['神主','',''],['神乎其技','',''],['神乎其神','',''],['神交','',''],['神人','',''],['神人共悦','',''],['神人鉴知','',''],['神仙','',''],['神仙中人','',''],['神仙眷属','',''],['神会心契','',''],['神伤','',''],['神似','',''],['神位','',''],['神体','',''],['神佛','',''],['神侃','',''],['神僊','',''],['神像','',''],['神兵','',''],['神兽','',''],['神冈','',''],['神冈乡','',''],['神农','',''],['神农本草经','',''],['神农架地区','',''],['神农氏','',''],['神出鬼入','',''],['神出鬼没','',''],['神分志夺','',''],['神力','',''],['神功','',''],['神动色飞','',''],['神助','',''],['神助似','',''],['神劳形瘁','',''],['神勇','',''],['神化','',''],['神医','',''],['神号鬼哭','',''],['神名','',''],['神品','',''],['神器','',''],['神嚎鬼哭','',''],['神圣','',''],['神圣不可侵犯','',''],['神圣化','',''],['神圣同盟','',''],['神圣周','',''],['神圣罗马帝国','',''],['神坛','',''],['神塔','',''],['神头鬼面','',''],['神奇','',''],['神奇侠侣','',''],['神奇荒怪','',''],['神奈川','',''],['神奈川县','',''],['神奥','',''],['神女','',''],['神女峰','',''],['神女生涯','',''],['神妙','',''],['神妙隽美','',''],['神威','',''],['神婆','',''],['神学','',''],['神学士','',''],['神学家','',''],['神学研究所','',''],['神学者','',''],['神学院','',''],['神宇','',''],['神安气定','',''],['神完气足','',''],['神宗','',''],['神家园','',''],['神山','',''],['神州','',''],['神州大地','',''],['神州赤县','',''],['神州陆沉','',''],['神工妙力','',''],['神工鬼力','',''],['神工鬼斧','',''],['神巫','',''],['神差鬼使','',''],['神庙','',''],['神异','',''],['神往','',''],['神志','',''],['神志不清','',''],['神志昏迷','',''],['神态','',''],['神态自若','',''],['神怒人弃','',''],['神怒人怨','',''],['神怒天诛','',''],['神怒民怨','',''],['神怒民痛','',''],['神怒鬼怨','',''],['神思','',''],['神思恍惚','',''],['神怡','',''],['神怡心旷','',''],['神怡心醉','',''],['神性','',''],['神怪','',''],['神悟','',''],['神情','',''],['神情恍惚','',''],['神意','',''],['神慰','',''],['神成为人','',''],['神户','',''],['神探','',''],['神摇意夺','',''],['神摇目眩','',''],['神摇魂荡','',''],['神效','',''],['神教','',''],['神施鬼设','',''],['神明','',''],['神昏意乱','',''],['神智','',''],['神曲','',''],['神术','',''],['神术妙法','',''],['神术妙策','',''],['神术妙计','',''],['神机妙术','',''],['神机妙用','',''],['神机妙策','',''],['神机妙算','',''],['神机莫测','',''],['神权','',''],['神权政治','',''],['神权统治','',''],['神来之笔','',''],['神枪手','',''],['神枯','',''],['神格','',''],['神武','',''],['神殿','',''],['神气','',''],['神气十足','',''],['神气扬扬','',''],['神气活现','',''],['神水','',''],['神汉','',''],['神治国','',''],['神清气全','',''],['神清气正','',''],['神清气爽','',''],['神清气郎','',''],['神清骨秀','',''],['神游','',''],['神灯','',''],['神灵','',''],['神爱世人','',''],['神父','',''],['神爷','',''],['神物','',''],['神甫','',''],['神的儿子','',''],['神社','',''],['神祇','',''],['神祖','',''],['神祠','',''],['神离','',''],['神离貌合','',''],['神秘','',''],['神秘主义','',''],['神秘化','',''],['神秘学','',''],['神秘感','',''],['神秘色彩','',''],['神秘莫测','',''],['神童','',''],['神笔','',''],['神算','',''],['神籁自韵','',''],['神经','',''],['神经中枢','',''],['神经元','',''],['神经元网','',''],['神经原','',''],['神经外科','',''],['神经大条','',''],['神经失常','',''],['神经学','',''],['神经学家','',''],['神经官能症','',''],['神经性','',''],['神经性毒剂','',''],['神经性皮炎','',''],['神经性视损伤','',''],['神经末梢','',''],['神经毒素','',''],['神经氨酸酶','',''],['神经生物学','',''],['神经病','',''],['神经症','',''],['神经痛','',''],['神经科','',''],['神经突','',''],['神经管','',''],['神经系统','',''],['神经索','',''],['神经纤维','',''],['神经纤维瘤','',''],['神经组织','',''],['神经细胞','',''],['神经网','',''],['神经网络','',''],['神经网路','',''],['神经胶质','',''],['神经胶质细胞','',''],['神经节','',''],['神经衰弱','',''],['神经质','',''],['神经过敏','',''],['神经错乱','',''],['神经键','',''],['神而明之存乎其人','',''],['神聊','',''],['神职','',''],['神职人员','',''],['神职者','',''],['神舆','',''],['神舟','',''],['神舟号飞船','',''],['神舟电脑','',''],['神色','',''],['神色不动','',''],['神色不对','',''],['神色不惊','',''],['神色不挠','',''],['神色怡然','',''],['神色自得','',''],['神色自若','',''],['神药','',''],['神论','',''],['神话','',''],['神话故事','',''],['神话般','',''],['神谋妙策','',''],['神谋妙算','',''],['神谕','',''],['神谱','',''],['神迷','',''],['神迹','',''],['神通','',''],['神通广大','',''],['神通郁垒','',''],['神速','',''],['神道','',''],['神道教','',''],['神道碑','',''],['神道设教','',''],['神采','',''],['神采奕奕','',''],['神采奕然','',''],['神采焕发','',''],['神采英拔','',''],['神采飞扬','',''],['神雕侠侣','',''],['神韵','',''],['神风','',''],['神风特别攻击队','',''],['神风特攻队','',''],['神飞色动','',''],['神飞色舞','',''],['神马','',''],['神驰','',''],['神髓','',''],['神鬼不测','',''],['神鬼出没','',''],['神鬼莫测','',''],['神鬼难测','',''],['神魂','',''],['神魂摇荡','',''],['神魂撩乱','',''],['神魂荡扬','',''],['神魂颠倒','',''],['神魂飘荡','',''],['神魂飞越','',''],['神魔小说','',''],['神鸟','',''],['神龙失势','',''],['神龙汽车','',''],['神龙见首不见尾','',''],['神龛','',''],['祟高','',''],['祠堂','',''],['祠墓','',''],['祠庙','',''],['祥云瑞彩','',''],['祥云瑞气','',''],['祥光','',''],['祥和','',''],['祥春','',''],['祥林','',''],['祥物','',''],['祥瑞','',''],['祥符','',''],['祥补','',''],['祥麟威凤','',''],['祥麟瑞凤','',''],['票人','',''],['票价','',''],['票具','',''],['票券','',''],['票单','',''],['票友','',''],['票友儿','',''],['票口','',''],['票号','',''],['票员','',''],['票头','',''],['票夹','',''],['票子','',''],['票庄','',''],['票式','',''],['票戏','',''],['票房','',''],['票据','',''],['票据法','',''],['票据簿','',''],['票数','',''],['票样','',''],['票根','',''],['票款','',''],['票汇','',''],['票活','',''],['票源','',''],['票站','',''],['票签','',''],['票箱','',''],['票簿','',''],['票证','',''],['票贩子','',''],['票选','',''],['票面','',''],['票面值','',''],['票额','',''],['祭仪','',''],['祭位','',''],['祭典','',''],['祭司','',''],['祭司席','',''],['祭司权术','',''],['祭吊','',''],['祭告','',''],['祭品','',''],['祭器','',''],['祭地','',''],['祭坛','',''],['祭墓','',''],['祭天','',''],['祭奠','',''],['祭扫','',''],['祭拜','',''],['祭文','',''],['祭日','',''],['祭服','',''],['祭灶','',''],['祭物','',''],['祭礼','',''],['祭祀','',''],['祭祖','',''],['祭神','',''],['祭神如神在','',''],['祭赛','',''],['祭酒','',''],['祷告','',''],['祷室','',''],['祷念','',''],['祷文','',''],['祷祝','',''],['祷词','',''],['祷辞','',''],['祸不单行','',''],['祸不反踵','',''],['祸不妄至','',''],['祸不旋踵','',''],['祸中有福','',''],['祸为福先','',''],['祸乱','',''],['祸乱交兴','',''],['祸乱滔天','',''],['祸事','',''],['祸于','',''],['祸于福邻','',''],['祸从口出','',''],['祸从天降','',''],['祸作福阶','',''],['祸兴萧墙','',''],['祸出不测','',''],['祸及','',''],['祸发萧墙','',''],['祸发齿牙','',''],['祸因恶积','',''],['祸国','',''],['祸国殃民','',''],['祸在旦夕','',''],['祸在朝夕','',''],['祸害','',''],['祸心','',''],['祸患','',''],['祸枣灾梨','',''],['祸根','',''],['祸殃','',''],['祸水','',''],['祸生不测','',''],['祸生于忽','',''],['祸生肘腋','',''],['祸生萧墙','',''],['祸盈恶稔','',''],['祸福','',''],['祸福与共','',''],['祸福吉凶','',''],['祸福同门','',''],['祸福惟人','',''],['祸福无偏','',''],['祸福无常','',''],['祸福无门','',''],['祸福有命','',''],['祸福由人','',''],['祸福相倚','',''],['祸福相生','',''],['祸福靡常','',''],['祸种','',''],['祸稔恶盈','',''],['祸稔萧墙','',''],['祸端','',''],['祸结兵连','',''],['祸结衅深','',''],['祸绝福连','',''],['祸胎','',''],['祸至神昧','',''],['祸色','',''],['祸起萧墙','',''],['祸起隐微','',''],['祸起飞语','',''],['祸首','',''],['祸首罪魁','',''],['禀告','',''],['禀复','',''],['禀帖','',''],['禀性','',''],['禀承','',''],['禀报','',''],['禀明','',''],['禀赋','',''],['禀陈','',''],['禁不住','',''],['禁不起','',''],['禁书','',''],['禁令','',''],['禁伐','',''],['禁例','',''],['禁军','',''],['禁制','',''],['禁制令','',''],['禁制品','',''],['禁区','',''],['禁卫','',''],['禁卫军','',''],['禁受','',''],['禁受时间的考验','',''],['禁品','',''],['禁售','',''],['禁地','',''],['禁城','',''],['禁夜','',''],['禁奸除猾','',''],['禁子','',''],['禁得住','',''],['禁得起','',''],['禁忌','',''],['禁忌症','',''],['禁忌语','',''],['禁戒','',''],['禁捕','',''],['禁放','',''],['禁期','',''],['禁条','',''],['禁果','',''],['禁核','',''],['禁欲','',''],['禁欲主义','',''],['禁止','',''],['禁止令','',''],['禁止令行','',''],['禁止吸烟','',''],['禁止喧哗','',''],['禁止外出','',''],['禁止性','',''],['禁止核武器试验条约','',''],['禁止者','',''],['禁止通行','',''],['禁止驶入','',''],['禁毒','',''],['禁渔','',''],['禁演','',''],['禁烟','',''],['禁烟运动','',''],['禁猎','',''],['禁用','',''],['禁约','',''],['禁绝','',''],['禁网疏阔','',''],['禁脔','',''],['禁苑','',''],['禁药','',''],['禁见','',''],['禁语','',''],['禁购','',''],['禁赌','',''],['禁足','',''],['禁运','',''],['禁造','',''],['禁酒','',''],['禁酒令','',''],['禁酒法','',''],['禁锢','',''],['禁闭','',''],['禁阻','',''],['禁飞','',''],['禁食','',''],['禄位','',''],['禄俸','',''],['禄养','',''],['禄劝','',''],['禄劝县','',''],['禄命','',''],['禄无常家福无定门','',''],['禄星','',''],['禄秩','',''],['禄籍','',''],['禄蠹','',''],['禄食','',''],['禄饵','',''],['禅位','',''],['禅功','',''],['禅城','',''],['禅堂','',''],['禅学','',''],['禅宗','',''],['禅寺','',''],['禅师','',''],['禅思','',''],['禅房','',''],['禅机','',''],['禅杖','',''],['禅林','',''],['禅理','',''],['禅让','',''],['禅门五宗','',''],['禅院','',''],['福不徒来','',''],['福不重至祸必重来','',''],['福业相牵','',''],['福中','',''],['福为祸先','',''],['福为祸始','',''],['福于天齐','',''],['福份','',''],['福佑','',''],['福佬','',''],['福克','',''],['福克纳','',''],['福兮祸所伏','',''],['福兮祸所倚','',''],['福兴','',''],['福兴乡','',''],['福冈','',''],['福冈县','',''],['福分','',''],['福利','',''],['福利主义','',''],['福利事业','',''],['福利厂','',''],['福利待遇','',''],['福利政策','',''],['福利费','',''],['福利院','',''],['福善祸淫','',''],['福地','',''],['福地洞天','',''],['福如东海','',''],['福如山岳','',''],['福如海渊','',''],['福委会','',''],['福娃','',''],['福寿','',''],['福寿双全','',''],['福寿天成','',''],['福寿年高','',''],['福寿康宁','',''],['福寿绵绵','',''],['福寿绵长','',''],['福寿螺','',''],['福寿齐天','',''],['福尔','',''],['福尔摩斯','',''],['福尔马林','',''],['福山','',''],['福岛','',''],['福岛县','',''],['福州戏','',''],['福布斯','',''],['福建事变','',''],['福惠双修','',''],['福报','',''],['福摩萨','',''],['福斯塔夫','',''],['福斯特','',''],['福无十全','',''],['福无双至祸不单行','',''],['福星','',''],['福星高照','',''],['福晋','',''],['福来','',''],['福林','',''],['福柯','',''],['福橘','',''],['福气','',''],['福泽','',''],['福泽谕吉','',''],['福煦','',''],['福物','',''],['福特','',''],['福特汽车','',''],['福生于微','',''],['福田','',''],['福相','',''],['福礼','',''],['福祉','',''],['福神','',''],['福祸','',''],['福禄双全','',''],['福禄贝尔','',''],['福维克','',''],['福至心灵','',''],['福过灾生','',''],['福音','',''],['福音书','',''],['福马林','',''],['福齐南山','',''],['禧玛诺','',''],['禳补','',''],['禳解','',''],['禹会','',''],['禹域','',''],['禹王台','',''],['禹王台区','',''],['禹行舜趋','',''],['离不','',''],['离不开','',''],['离不远','',''],['离世','',''],['离乡','',''],['离乡背井','',''],['离乳','',''],['离了','',''],['离京','',''],['离任','',''],['离休','',''],['离休干部','',''],['离你','',''],['离别','',''],['离去','',''],['离合','',''],['离合器','',''],['离合板','',''],['离合词','',''],['离合诗','',''],['离土不离乡','',''],['离地','',''],['离境','',''],['离奇','',''],['离奇有趣','',''],['离娄之明','',''],['离婚','',''],['离婚者','',''],['离婚证','',''],['离子','',''],['离子交换','',''],['离子交换树脂','',''],['离子化','',''],['离子束','',''],['离子键','',''],['离宫','',''],['离家','',''],['离家出走','',''],['离家别井','',''],['离层','',''],['离岗','',''],['离岛','',''],['离岸','',''],['离岸价','',''],['离差','',''],['离席','',''],['离座','',''],['离开','',''],['离开人世','',''],['离开故乡','',''],['离异','',''],['离弃','',''],['离弦','',''],['离弦之箭','',''],['离得','',''],['离得开','',''],['离心','',''],['离心分离机','',''],['离心力','',''],['离心机','',''],['离心泵','',''],['离心率','',''],['离心离德','',''],['离性','',''],['离恨','',''],['离您','',''],['离情','',''],['离情别绪','',''],['离愁','',''],['离手','',''],['离散','',''],['离散化','',''],['离散性','',''],['离散数学','',''],['离析','',''],['离校','',''],['离格','',''],['离格儿','',''],['离歌','',''],['离法','',''],['离港','',''],['离港大厅','',''],['离独','',''],['离瓣花冠','',''],['离着','',''],['离石','',''],['离离光光','',''],['离索','',''],['离线','',''],['离经','',''],['离经叛道','',''],['离群','',''],['离群索居','',''],['离者','',''],['离职','',''],['离解','',''],['离谱','',''],['离贰','',''],['离身','',''],['离轨','',''],['离辐','',''],['离辙','',''],['离远','',''],['离退休','',''],['离间','',''],['离队','',''],['离题','',''],['离题万里','',''],['离骚','',''],['离鸾别凤','',''],['禽兽','',''],['禽兽不如','',''],['禽困覆车','',''],['禽奔兽遁','',''],['禽息鸟视','',''],['禽流感','',''],['禽畜','',''],['禽类','',''],['禽肉','',''],['禽舍','',''],['禽蛋','',''],['禽贩','',''],['禽鸟','',''],['禽龙','',''],['禾场','',''],['禾木科','',''],['禾本科','',''],['禾秆','',''],['禾苗','',''],['禾草','',''],['禾谷','',''],['秀丽','',''],['秀出班行','',''],['秀发','',''],['秀发垂肩','',''],['秀外惠中','',''],['秀外慧中','',''],['秀媚','',''],['秀山','',''],['秀山县','',''],['秀屿','',''],['秀峰','',''],['秀才','',''],['秀才人情','',''],['秀拔','',''],['秀林','',''],['秀林乡','',''],['秀气','',''],['秀水','',''],['秀水乡','',''],['秀洲','',''],['秀眉','',''],['秀美','',''],['秀而不实','',''],['秀色','',''],['秀色可餐','',''],['秀色孙鲽','',''],['秀英','',''],['秀逸','',''],['秀雅','',''],['私下','',''],['私下交易','',''],['私下谈','',''],['私之处','',''],['私买','',''],['私了','',''],['私事','',''],['私交','',''],['私产','',''],['私人','',''],['私人企业','',''],['私人关系','',''],['私人访问','',''],['私人资本','',''],['私人钥匙','',''],['私仇','',''],['私仇不及公','',''],['私企','',''],['私会','',''],['私信','',''],['私债','',''],['私偏','',''],['私党','',''],['私养','',''],['私分','',''],['私刑','',''],['私利','',''],['私刻','',''],['私办','',''],['私募','',''],['私募基金','',''],['私卖','',''],['私占','',''],['私印','',''],['私吞','',''],['私售','',''],['私商','',''],['私喻','',''],['私囊','',''],['私图','',''],['私塾','',''],['私增','',''],['私处','',''],['私奔','',''],['私娼','',''],['私学','',''],['私宅','',''],['私定终身','',''],['私室','',''],['私家','',''],['私家车','',''],['私密','',''],['私底下','',''],['私弊','',''],['私德','',''],['私心','',''],['私心杂念','',''],['私念','',''],['私怨','',''],['私恩小惠','',''],['私情','',''],['私意','',''],['私愤','',''],['私房','',''],['私房话','',''],['私房钱','',''],['私拿','',''],['私掠船','',''],['私方','',''],['私有','',''],['私有制','',''],['私有化','',''],['私有财产','',''],['私欲','',''],['私法','',''],['私活','',''],['私淑','',''],['私淑弟子','',''],['私生','',''],['私生子','',''],['私生子女','',''],['私生活','',''],['私用','',''],['私盐','',''],['私相传授','',''],['私相授受','',''],['私秘','',''],['私窝子','',''],['私立','',''],['私立学校','',''],['私章','',''],['私线','',''],['私罚','',''],['私股','',''],['私自','',''],['私船','',''],['私营','',''],['私营企业','',''],['私蓄','',''],['私藏','',''],['私行','',''],['私见','',''],['私设','',''],['私设公堂','',''],['私访','',''],['私话','',''],['私语','',''],['私谋叛国','',''],['私财','',''],['私货','',''],['私贩','',''],['私费','',''],['私运','',''],['私逃','',''],['私通','',''],['私通者','',''],['私道','',''],['私邸','',''],['私酒','',''],['私销','',''],['秃发','',''],['秃发症','',''],['秃头','',''],['秃子','',''],['秃宝盖','',''],['秃山','',''],['秃树','',''],['秃瓢','',''],['秃疮','',''],['秃石','',''],['秃秃','',''],['秃笔','',''],['秃顶','',''],['秃驴','',''],['秃鹫','',''],['秃鹰','',''],['秃鹰似','',''],['秆子','',''],['秆茎','',''],['秆锈病','',''],['秉公','',''],['秉公办事','',''],['秉公办理','',''],['秉公无私','',''],['秉公而断','',''],['秉性','',''],['秉承','',''],['秉持','',''],['秉政','',''],['秉烛','',''],['秉烛夜游','',''],['秉直','',''],['秉笏披袍','',''],['秉笔','',''],['秉笔直书','',''],['秉要执本','',''],['秉赋','',''],['秋令','',''],['秋假','',''],['秋兰','',''],['秋冬','',''],['秋冬季','',''],['秋决','',''],['秋凉','',''],['秋刀鱼','',''],['秋分点','',''],['秋千','',''],['秋叶','',''],['秋叶原','',''],['秋后','',''],['秋后算帐','',''],['秋后算账','',''],['秋地','',''],['秋声','',''],['秋天','',''],['秋子梨','',''],['秋季','',''],['秋审','',''],['秋庄稼','',''],['秋征','',''],['秋思','',''],['秋意','',''],['秋成','',''],['秋播','',''],['秋收','',''],['秋收冬藏','',''],['秋收起义','',''],['秋日','',''],['秋景','',''],['秋月','',''],['秋月寒江','',''],['秋月春花','',''],['秋月春风','',''],['秋树','',''],['秋残','',''],['秋毫','',''],['秋毫不犯','',''],['秋毫之末','',''],['秋毫无犯','',''],['秋水','',''],['秋水仙','',''],['秋水伊人','',''],['秋汛','',''],['秋波','',''],['秋海棠','',''],['秋海棠花','',''],['秋游','',''],['秋灌','',''],['秋熟','',''],['秋燥','',''],['秋狝','',''],['秋瑾','',''],['秋田','',''],['秋田县','',''],['秋社','',''],['秋秋','',''],['秋粮','',''],['秋老虎','',''],['秋耕','',''],['秋色','',''],['秋节','',''],['秋草人请','',''],['秋荼密网','',''],['秋菊傲霜','',''],['秋菜','',''],['秋葵','',''],['秋葵荚','',''],['秋虫','',''],['秋蝉','',''],['秋衣','',''],['秋裤','',''],['秋试','',''],['秋闱','',''],['秋雨','',''],['秋霜','',''],['秋风','',''],['秋风团扇','',''],['秋风扫落叶','',''],['秋风落叶','',''],['秋风过耳','',''],['秋风送爽','',''],['秋风飒飒','',''],['秋香','',''],['秋高气爽','',''],['秋高气肃','',''],['秋高马肥','',''],['秋麦','',''],['种上','',''],['种下','',''],['种了','',''],['种仁','',''],['种公畜','',''],['种养','',''],['种内杂交','',''],['种别','',''],['种在','',''],['种地','',''],['种块','',''],['种姓','',''],['种姓制','',''],['种姓制度','',''],['种子','',''],['种子园','',''],['种子地','',''],['种子处理','',''],['种子岛','',''],['种子植物','',''],['种子田','',''],['种子选手','',''],['种差','',''],['种形成','',''],['种数','',''],['种族','',''],['种族中心主义','',''],['种族主义','',''],['种族主义者','',''],['种族学','',''],['种族政策','',''],['种族歧视','',''],['种族清洗','',''],['种族清除','',''],['种族灭绝','',''],['种族间','',''],['种族隔离','',''],['种树','',''],['种植','',''],['种植业','',''],['种植园','',''],['种植场','',''],['种植者','',''],['种概念','',''],['种牛痘','',''],['种猪','',''],['种瓜','',''],['种瓜得瓜','',''],['种瓜得瓜种豆得豆','',''],['种田','',''],['种畜','',''],['种痘','',''],['种的','',''],['种皮','',''],['种禽','',''],['种种','',''],['种种迹像表明','',''],['种稻','',''],['种类','',''],['种籽','',''],['种粮','',''],['种系','',''],['种群','',''],['种肥','',''],['种脐','',''],['种花','',''],['种花人','',''],['种苗','',''],['种草','',''],['种菜','',''],['种薯','',''],['种蛋','',''],['种豆','',''],['种豆得豆','',''],['种马','',''],['种麦得麦','',''],['种麻','',''],['科举','',''],['科举制','',''],['科举考试','',''],['科什图尼察','',''],['科以','',''],['科伦坡','',''],['科佩尔','',''],['科克','',''],['科利奥兰纳斯','',''],['科别','',''],['科协','',''],['科协工作','',''],['科卿','',''],['科右中旗','',''],['科右前旗','',''],['科名','',''],['科员','',''],['科场','',''],['科大','',''],['科头箕裾','',''],['科头箕踞','',''],['科头跣足','',''],['科委','',''],['科威特人','',''],['科学','',''],['科学上','',''],['科学主义','',''],['科学共产主义','',''],['科学分析','',''],['科学化','',''],['科学卫星','',''],['科学发展观','',''],['科学史','',''],['科学学','',''],['科学实验','',''],['科学家','',''],['科学幻想','',''],['科学性','',''],['科学怪人','',''],['科学执政','',''],['科学技术','',''],['科学技术是第一生产力','',''],['科学技术现代化','',''],['科学教育影片','',''],['科学普及','',''],['科学界','',''],['科学的交流','',''],['科学知识','',''],['科学研究','',''],['科学社会主义','',''],['科学种田','',''],['科学管理','',''],['科学编辑','',''],['科学育儿','',''],['科学院','',''],['科室','',''],['科尔','',''],['科尔多瓦','',''],['科尔沁','',''],['科尔沁左翼中','',''],['科尔沁左翼后','',''],['科尼赛克','',''],['科布多','',''],['科幻','',''],['科幻小说','',''],['科幻电影','',''],['科恩','',''],['科托努','',''],['科技','',''],['科技人员','',''],['科技司','',''],['科技型','',''],['科技大学','',''],['科技工作者','',''],['科技惊悚','',''],['科技惊悚小说','',''],['科技界','',''],['科技馆','',''],['科摩洛','',''],['科教','',''],['科教兴国','',''],['科教片','',''],['科教片儿','',''],['科斗','',''],['科普','',''],['科普读物','',''],['科林','',''],['科林・弗思','',''],['科林斯','',''],['科比・布莱恩特','',''],['科泽科德','',''],['科海','',''],['科特布斯','',''],['科特迪瓦共和国','',''],['科班','',''],['科班出身','',''],['科甲','',''],['科白','',''],['科目','',''],['科盲','',''],['科研','',''],['科研人员','',''],['科研小组','',''],['科研成果','',''],['科研所','',''],['科研样机','',''],['科研部','',''],['科第','',''],['科系','',''],['科索沃','',''],['科级','',''],['科纳克里','',''],['科组','',''],['科罗娜','',''],['科罗恩病','',''],['科罗拉多','',''],['科罗拉多大峡谷','',''],['科罗拉多州','',''],['科罗纳','',''],['科考','',''],['科考队','',''],['科股','',''],['科茨沃尔德','',''],['科莫多龙','',''],['科西嘉岛','',''],['科迪勒拉','',''],['科迪勒拉山系','',''],['科长','',''],['科隆','',''],['秒差距','',''],['秒杀','',''],['秒秒','',''],['秒表','',''],['秒针','',''],['秒钟','',''],['秕子','',''],['秕糠','',''],['秘书','',''],['秘书处','',''],['秘书学','',''],['秘书工作','',''],['秘书长','',''],['秘传','',''],['秘史','',''],['秘地','',''],['秘室','',''],['秘密','',''],['秘密会晤','',''],['秘密会社','',''],['秘密活动','',''],['秘密社会','',''],['秘密组织','',''],['秘密警察','',''],['秘技','',''],['秘教','',''],['秘方','',''],['秘本','',''],['秘法','',''],['秘法家','',''],['秘洞','',''],['秘牢','',''],['秘笈','',''],['秘籍','',''],['秘结','',''],['秘结性','',''],['秘而不宣','',''],['秘而不露','',''],['秘药','',''],['秘藏','',''],['秘议','',''],['秘诀','',''],['秘说','',''],['秘鲁人','',''],['秘鲁币','',''],['秘鲁苦蘵','',''],['租下','',''],['租人','',''],['租价','',''],['租佃','',''],['租佃关系','',''],['租住','',''],['租借','',''],['租借人','',''],['租借地','',''],['租借物','',''],['租借者','',''],['租债','',''],['租入','',''],['租出','',''],['租售','',''],['租地','',''],['租地人','',''],['租地人投标票权','',''],['租契','',''],['租子','',''],['租客','',''],['租屋','',''],['租屋人','',''],['租屋者','',''],['租得','',''],['租息','',''],['租户','',''],['租房','',''],['租房子','',''],['租方','',''],['租期','',''],['租用','',''],['租界','',''],['租税','',''],['租税转嫁','',''],['租籍','',''],['租米','',''],['租约','',''],['租给','',''],['租船','',''],['租让','',''],['租贷','',''],['租贷人','',''],['租费','',''],['租赁','',''],['租赁承包','',''],['租赁经营','',''],['租车','',''],['租金','',''],['租钱','',''],['租额','',''],['秣员','',''],['秣马','',''],['秣马利兵','',''],['秣马厉兵','',''],['秤坨','',''],['秤星','',''],['秤杆','',''],['秤架','',''],['秤毫','',''],['秤盘','',''],['秤盘子','',''],['秤砣','',''],['秤砣虽小压千斤','',''],['秤称','',''],['秤纽','',''],['秤钩','',''],['秤锤','',''],['秦代','',''],['秦军','',''],['秦吉了','',''],['秦国','',''],['秦失其鹿','',''],['秦始皇','',''],['秦始皇帝','',''],['秦始皇帝陵','',''],['秦始皇陵','',''],['秦孝公','',''],['秦岭','',''],['秦岭山脉','',''],['秦岭蜀栈道','',''],['秦州','',''],['秦州区','',''],['秦庭之哭','',''],['秦庭郎镜','',''],['秦惠文王','',''],['秦晋之好','',''],['秦晋之缘','',''],['秦朝','',''],['秦末','',''],['秦桧','',''],['秦椒','',''],['秦楼楚馆','',''],['秦楼谢馆','',''],['秦欢晋爱','',''],['秦汉','',''],['秦池','',''],['秦淮','',''],['秦火','',''],['秦牧','',''],['秦王','',''],['秦皇','',''],['秦穆公','',''],['秦篆','',''],['秦腔','',''],['秦艽','',''],['秦都','',''],['秦镜高悬','',''],['秦陵','',''],['秦韬玉','',''],['秧子','',''],['秧歌','',''],['秧歌剧','',''],['秧歌舞','',''],['秧田','',''],['秧脚','',''],['秧苗','',''],['秧鸡','',''],['秧龄','',''],['秩序','',''],['秩序井然','',''],['秩序美','',''],['秩然不紊','',''],['秩禄','',''],['秫秫','',''],['秫秸','',''],['秫米','',''],['积不相能','',''],['积久','',''],['积习','',''],['积习成俗','',''],['积习成常','',''],['积习生常','',''],['积习难改','',''],['积于忽微','',''],['积云','',''],['积云状','',''],['积储','',''],['积冰','',''],['积分','',''],['积分变换','',''],['积分学','',''],['积分常数','',''],['积分方程','',''],['积分榜','',''],['积分电路','',''],['积劳','',''],['积劳成疾','',''],['积卷云','',''],['积压','',''],['积压品','',''],['积压物资','',''],['积厚流广','',''],['积叠','',''],['积善','',''],['积善之家必有余庆','',''],['积善余庆','',''],['积善行','',''],['积土成山','',''],['积垢','',''],['积处','',''],['积存','',''],['积小成大','',''],['积少成多','',''],['积年','',''],['积年累月','',''],['积弊','',''],['积弱','',''],['积微成著','',''],['积德','',''],['积德累仁','',''],['积德累功','',''],['积忧成疾','',''],['积怨','',''],['积恶','',''],['积恶余殃','',''],['积愤','',''],['积攒','',''],['积数','',''],['积木','',''],['积极','',''],['积极分子','',''],['积极反应','',''],['积极性','',''],['积极浪漫主义','',''],['积极防御','',''],['积案','',''],['积欠','',''],['积毁销骨','',''],['积水','',''],['积水成渊','',''],['积淀','',''],['积渐','',''],['积温','',''],['积满','',''],['积灰','',''],['积物','',''],['积玉堆金','',''],['积甲山齐','',''],['积着','',''],['积祖','',''],['积福','',''],['积粮','',''],['积累','',''],['积累基金','',''],['积累性','',''],['积累毒性','',''],['积羽成舟','',''],['积羽沉舟','',''],['积聚','',''],['积聚物','',''],['积聚者','',''],['积肥','',''],['积草屯粮','',''],['积蓄','',''],['积薪厝火','',''],['积薪量水','',''],['积衰新造','',''],['积谷防饥','',''],['积贮','',''],['积贼','',''],['积重难返','',''],['积金累玉','',''],['积铢累寸','',''],['积雨云','',''],['积雪','',''],['积雪场','',''],['积非成是','',''],['积食','',''],['称上','',''],['称为','',''],['称之','',''],['称之为','',''],['称作','',''],['称便','',''],['称做','',''],['称兄道弟','',''],['称兵','',''],['称出','',''],['称号','',''],['称叹','',''],['称呼','',''],['称善','',''],['称奇','',''],['称孤道寡','',''],['称家有无','',''],['称引','',''],['称得','',''],['称得上','',''],['称心','',''],['称心如意','',''],['称心满意','',''],['称快','',''],['称意','',''],['称愿','',''],['称扬','',''],['称斤注两','',''],['称曰','',''],['称王','',''],['称王称霸','',''],['称病','',''],['称羡','',''],['称职','',''],['称臣','',''],['称臣纳贡','',''],['称誉','',''],['称许','',''],['称说','',''],['称谓','',''],['称谢','',''],['称贤荐能','',''],['称贷','',''],['称赏','',''],['称赞','',''],['称身','',''],['称述','',''],['称道','',''],['称重','',''],['称重量','',''],['称量','',''],['称锤落井','',''],['称雄','',''],['称霸','',''],['称颂','',''],['秸杆','',''],['秸秆','',''],['移东就西','',''],['移东换西','',''],['移东补西','',''],['移了','',''],['移交','',''],['移伙','',''],['移位','',''],['移作','',''],['移值体','',''],['移入','',''],['移军','',''],['移出','',''],['移到','',''],['移动平均线','',''],['移动平均线指标','',''],['移动式','',''],['移动式电话','',''],['移动性','',''],['移动电话','',''],['移动设备','',''],['移动通信网络','',''],['移去','',''],['移向','',''],['移天徙日','',''],['移天易日','',''],['移孝为忠','',''],['移宫换羽','',''],['移居','',''],['移居者','',''],['移山','',''],['移山倒海','',''],['移山志','',''],['移山添海','',''],['移师','',''],['移开','',''],['移归','',''],['移往','',''],['移性','',''],['移情','',''],['移情别恋','',''],['移挪','',''],['移掉','',''],['移易','',''],['移星换斗','',''],['移有足无','',''],['移来','',''],['移栖','',''],['移栽','',''],['移植','',''],['移植性','',''],['移植手术','',''],['移植法','',''],['移樽就教','',''],['移步','',''],['移殖','',''],['移民','',''],['移民局','',''],['移民工','',''],['移民者','',''],['移液管','',''],['移灵','',''],['移用','',''],['移移','',''],['移置','',''],['移至','',''],['移花接木','',''],['移苗','',''],['移译','',''],['移调','',''],['移走','',''],['移转','',''],['移过','',''],['移近','',''],['移送','',''],['移送法办','',''],['移防','',''],['移除','',''],['移项','',''],['移风易俗','',''],['秽名','',''],['秽土','',''],['秽淫','',''],['秽物','',''],['秽行','',''],['秽语','',''],['秽迹','',''],['秽闻','',''],['稀世','',''],['稀世之鸟','',''],['稀世之宝','',''],['稀世珍宝','',''],['稀哩哗啦','',''],['稀土','',''],['稀土元素','',''],['稀土金属','',''],['稀奇','',''],['稀奇古怪','',''],['稀客','',''],['稀少','',''],['稀巴烂','',''],['稀有','',''],['稀有元素','',''],['稀有气体','',''],['稀有金属','',''],['稀朗','',''],['稀松','',''],['稀松骨质','',''],['稀泥','',''],['稀溜溜','',''],['稀烂','',''],['稀疏','',''],['稀盐酸','',''],['稀稀','',''],['稀稀拉拉','',''],['稀稀落落','',''],['稀粘液','',''],['稀粥','',''],['稀糟','',''],['稀缺','',''],['稀罕','',''],['稀落','',''],['稀薄','',''],['稀释','',''],['稀里光当','',''],['稀里哗啦','',''],['稀里糊涂','',''],['稀饭','',''],['程仪','',''],['程子','',''],['程序','',''],['程序上','',''],['程序员','',''],['程序库','',''],['程序性','',''],['程序控制','',''],['程序法','',''],['程序表','',''],['程序设计','',''],['程序语言','',''],['程度','',''],['程度不同','',''],['程式','',''],['程式动作','',''],['程式管理员','',''],['程式语言','',''],['程控','',''],['程控交换机','',''],['程控技术','',''],['程控机','',''],['程控机床','',''],['程控电话','',''],['程昱','',''],['程朱学派','',''],['程海湖','',''],['程潜','',''],['程砚秋','',''],['程邈','',''],['程门立雪','',''],['程限','',''],['程颐','',''],['程颢','',''],['稍不','',''],['稍个信','',''],['稍为','',''],['稍事','',''],['稍低','',''],['稍作','',''],['稍候','',''],['稍减','',''],['稍加','',''],['稍可','',''],['稍后','',''],['稍多','',''],['稍大','',''],['稍好','',''],['稍嫌','',''],['稍安勿躁','',''],['稍安毋躁','',''],['稍宽','',''],['稍小','',''],['稍尖','',''],['稍差','',''],['稍带','',''],['稍干','',''],['稍平','',''],['稍异','',''],['稍微','',''],['稍快','',''],['稍息','',''],['稍慢','',''],['稍懈','',''],['稍旧','',''],['稍早','',''],['稍早时','',''],['稍暗','',''],['稍有','',''],['稍歇','',''],['稍白','',''],['稍睡','',''],['稍知','',''],['稍短','',''],['稍稍','',''],['稍等','',''],['稍纵即逝','',''],['稍缓','',''],['稍老','',''],['稍胜一筹','',''],['稍许','',''],['稍迟','',''],['稍逊','',''],['稍逊一筹','',''],['稍长','',''],['稍顷','',''],['稍高','',''],['税人','',''],['税关','',''],['税则','',''],['税利','',''],['税制','',''],['税前','',''],['税务','',''],['税务员','',''],['税务局','',''],['税务所','',''],['税区','',''],['税单','',''],['税号','',''],['税名','',''],['税后','',''],['税后还贷','',''],['税员','',''],['税基','',''],['税契','',''],['税官','',''],['税局','',''],['税式','',''],['税户','',''],['税所','',''],['税捐','',''],['税捐稽征处','',''],['税收','',''],['税收制度','',''],['税收收入','',''],['税收政策','',''],['税收理论','',''],['税收管理','',''],['税改','',''],['税政','',''],['税权','',''],['税校','',''],['税款','',''],['税法','',''],['税源','',''],['税率','',''],['税目','',''],['税盲','',''],['税票','',''],['税种','',''],['税管','',''],['税类','',''],['税警','',''],['税负','',''],['税费','',''],['税赋','',''],['税金','',''],['税钱','',''],['税额','',''],['稔恶不悛','',''],['稗史','',''],['稗子','',''],['稗官小说','',''],['稗官野史','',''],['稚女','',''],['稚嫩','',''],['稚子','',''],['稚弱','',''],['稚拙','',''],['稚气','',''],['稚气未脱','',''],['稚虫','',''],['稞麦','',''],['稠人广众','',''],['稠人广座','',''],['稠密','',''],['稠度','',''],['稠油','',''],['稠糊','',''],['稳中有降','',''],['稳产','',''],['稳产高产','',''],['稳价','',''],['稳住','',''],['稳住阵脚','',''],['稳便','',''],['稳健','',''],['稳健派','',''],['稳准狠','',''],['稳压','',''],['稳压器','',''],['稳厚','',''],['稳固','',''],['稳坐','',''],['稳坐钓鱼台','',''],['稳如泰山','',''],['稳妥','',''],['稳婆','',''],['稳定','',''],['稳定塘','',''],['稳定增长','',''],['稳定局势','',''],['稳定平衡','',''],['稳定度','',''],['稳定性','',''],['稳定情绪','',''],['稳定收入','',''],['稳定物价','',''],['稳实','',''],['稳当','',''],['稳态','',''],['稳态理论','',''],['稳恒','',''],['稳恒态','',''],['稳扎稳打','',''],['稳打','',''],['稳拟','',''],['稳拿','',''],['稳操','',''],['稳操左券','',''],['稳操胜券','',''],['稳操胜算','',''],['稳步','',''],['稳步不前','',''],['稳步前进','',''],['稳步发展','',''],['稳步增长','',''],['稳流','',''],['稳稳','',''],['稳稳当当','',''],['稳练','',''],['稳胜','',''],['稳获','',''],['稳贴','',''],['稳赚','',''],['稳重','',''],['稳键','',''],['稳静','',''],['稻场','',''],['稻堆','',''],['稻壳','',''],['稻子','',''],['稻树','',''],['稻田','',''],['稻田皮炎','',''],['稻瘟','',''],['稻瘟病','',''],['稻白叶枯病','',''],['稻种','',''],['稻秧','',''],['稻穗','',''],['稻米','',''],['稻糠','',''],['稻苗','',''],['稻苞虫','',''],['稻草','',''],['稻草人','',''],['稻螟','',''],['稻谷','',''],['稻飞虱','',''],['稻香','',''],['稼穑','',''],['稼穑艰难','',''],['稽古','',''],['稽古振今','',''],['稽延','',''],['稽征','',''],['稽查','',''],['稽查人员','',''],['稽查员','',''],['稽核','',''],['稽留','',''],['稽留热','',''],['稽管','',''],['稽考','',''],['稽颡','',''],['稽首','',''],['稿人','',''],['稿件','',''],['稿员','',''],['稿子','',''],['稿底','',''],['稿本','',''],['稿约','',''],['稿纸','',''],['稿荐','',''],['稿费','',''],['稿酬','',''],['穆加贝','',''],['穆圣','',''],['穆如清风','',''],['穆巴拉克','',''],['穆斯林','',''],['穆桂英','',''],['穆沙拉夫','',''],['穆然','',''],['穆索尔斯基','',''],['穆罕','',''],['穆罕默德','',''],['穆罕默德・欧玛','',''],['穆罕默德六世','',''],['穆萨维','',''],['穆迪','',''],['穆通','',''],['穗子','',''],['穗带','',''],['穗期','',''],['穗状','',''],['穗状花序','',''],['穗轴','',''],['穗选','',''],['穗饰','',''],['穰穰','',''],['穴中','',''],['穴位','',''],['穴位封闭','',''],['穴处之徒','',''],['穴处知雨','',''],['穴头','',''],['穴居','',''],['穴居人','',''],['穴居野处','',''],['穴播','',''],['穴施','',''],['穴脉','',''],['穴见小儒','',''],['穴道','',''],['穴鸟','',''],['究其','',''],['究其原因','',''],['究其根源','',''],['究办','',''],['究理','',''],['究竟','',''],['究诘','',''],['穷不失义','',''],['穷且益坚','',''],['穷乏','',''],['穷乡','',''],['穷乡僻壤','',''],['穷二代','',''],['穷人','',''],['穷光蛋','',''],['穷兵','',''],['穷兵极武','',''],['穷兵黩武','',''],['穷冬','',''],['穷凶极恶','',''],['穷凶极虐','',''],['穷则思变','',''],['穷匮','',''],['穷原竟委','',''],['穷困','',''],['穷困户','',''],['穷国','',''],['穷坑难满','',''],['穷境','',''],['穷大失居','',''],['穷天极地','',''],['穷奢极侈','',''],['穷奢极欲','',''],['穷妙极巧','',''],['穷家富路','',''],['穷寇','',''],['穷寇勿追','',''],['穷富极贵','',''],['穷尽','',''],['穷山','',''],['穷山僻壤','',''],['穷山恶水','',''],['穷工极巧','',''],['穷年累世','',''],['穷年累岁','',''],['穷年累月','',''],['穷幽极微','',''],['穷当益坚','',''],['穷形尽相','',''],['穷形极状','',''],['穷形极相','',''],['穷得','',''],['穷心剧力','',''],['穷忙','',''],['穷愁','',''],['穷愁潦倒','',''],['穷措大','',''],['穷摆','',''],['穷文人','',''],['穷日子','',''],['穷日落月','',''],['穷期','',''],['穷本极源','',''],['穷极其妙','',''],['穷极则变','',''],['穷极无聊','',''],['穷极要妙','',''],['穷根寻叶','',''],['穷根究底','',''],['穷棒子','',''],['穷池之鱼','',''],['穷源推本','',''],['穷源竟委','',''],['穷猿失木','',''],['穷猿奔林','',''],['穷猿投林','',''],['穷理','',''],['穷理尽性','',''],['穷病人','',''],['穷的','',''],['穷目','',''],['穷相','',''],['穷神知化','',''],['穷神观化','',''],['穷究','',''],['穷竭','',''],['穷竭心计','',''],['穷竭法','',''],['穷纤入微','',''],['穷结','',''],['穷结县','',''],['穷而后工','',''],['穷苦','',''],['穷贵极富','',''],['穷蹙','',''],['穷达有命','',''],['穷追','',''],['穷追不舍','',''],['穷途','',''],['穷途之哭','',''],['穷途日暮','',''],['穷途末路','',''],['穷途潦倒','',''],['穷途落魄','',''],['穷通皆命','',''],['穷酸','',''],['穷酸气','',''],['穷酸相','',''],['穷酸饿醋','',''],['穷醋大','',''],['穷阎漏屋','',''],['穷队','',''],['穷饿','',''],['穷鬼','',''],['穷鸟入怀','',''],['穷鼠啮狸','',''],['穹丘','',''],['穹天','',''],['穹庐','',''],['穹形','',''],['穹窿','',''],['穹肋','',''],['穹苍','',''],['穹隆','',''],['穹顶','',''],['空中','',''],['空中交通管制','',''],['空中交通管制员','',''],['空中加油','',''],['空中客车','',''],['空中小姐','',''],['空中少爷','',''],['空中核爆炸','',''],['空中格斗','',''],['空中楼阁','',''],['空中炮舰','',''],['空中走廊','',''],['空中飘浮','',''],['空中飞人','',''],['空乏','',''],['空了','',''],['空人','',''],['空位','',''],['空余','',''],['空信','',''],['空儿','',''],['空军','',''],['空军一号','',''],['空军司令','',''],['空军基地','',''],['空出','',''],['空前','',''],['空前团结','',''],['空前未有','',''],['空前绝后','',''],['空勤','',''],['空包弹','',''],['空匮','',''],['空口','',''],['空口无凭','',''],['空口汤圆','',''],['空口白话','',''],['空口说白话','',''],['空名','',''],['空吸','',''],['空喊','',''],['空地','',''],['空地导弹','',''],['空地战','',''],['空坦','',''],['空城','',''],['空城计','',''],['空域','',''],['空处','',''],['空头','',''],['空头支票','',''],['空姐','',''],['空子','',''],['空客公司','',''],['空室','',''],['空室清野','',''],['空寂','',''],['空对','',''],['空对地','',''],['空对空','',''],['空对空导弹','',''],['空就','',''],['空屋','',''],['空巢','',''],['空巷','',''],['空幻','',''],['空廓','',''],['空弹','',''],['空当','',''],['空当子','',''],['空心','',''],['空心儿','',''],['空心墙','',''],['空心大老官','',''],['空心架子','',''],['空心汤团','',''],['空心汤圆','',''],['空心砖','',''],['空心老大','',''],['空心莲子草','',''],['空心菜','',''],['空心萝卜','',''],['空心面','',''],['空怀','',''],['空怒','',''],['空性','',''],['空想','',''],['空想共产主义','',''],['空想家','',''],['空想社会主义','',''],['空想者','',''],['空战','',''],['空房','',''],['空房间','',''],['空手','',''],['空手而归','',''],['空手道','',''],['空扰','',''],['空投','',''],['空挡','',''],['空摄','',''],['空文','',''],['空无','',''],['空无一人','',''],['空无所有','',''],['空日','',''],['空旷','',''],['空暇','',''],['空板子','',''],['空架子','',''],['空格','',''],['空格键','',''],['空桐树','',''],['空档','',''],['空桶','',''],['空检','',''],['空气','',''],['空气剂量','',''],['空气动力','',''],['空气动力学','',''],['空气压缩机','',''],['空气取样','',''],['空气取样器','',''],['空气团','',''],['空气床','',''],['空气污染','',''],['空气流','',''],['空气流通','',''],['空气浴','',''],['空气状','',''],['空气缓冲间','',''],['空气调节','',''],['空气轴承','',''],['空气锤','',''],['空气阻力','',''],['空泛','',''],['空洞','',''],['空洞无物','',''],['空洞音','',''],['空灵','',''],['空炮','',''],['空理','',''],['空瓶','',''],['空疏','',''],['空白','',''],['空白支票','',''],['空白点','',''],['空的','',''],['空盘','',''],['空着','',''],['空着手','',''],['空穴','',''],['空穴型半导体','',''],['空穴来风','',''],['空穴来风未必无因','',''],['空空','',''],['空空如也','',''],['空空导弹','',''],['空空洞洞','',''],['空空荡荡','',''],['空竹','',''],['空等','',''],['空管','',''],['空箱','',''],['空给','',''],['空缺','',''],['空罐','',''],['空置','',''],['空翻','',''],['空耗','',''],['空肚','',''],['空肠','',''],['空腔','',''],['空腹','',''],['空腹便便','',''],['空腹高心','',''],['空舱','',''],['空花绣','',''],['空荡','',''],['空荡荡','',''],['空落落','',''],['空虚','',''],['空行','',''],['空袭','',''],['空言无补','',''],['空言虚语','',''],['空论','',''],['空论家','',''],['空话','',''],['空话连篇','',''],['空说','',''],['空调','',''],['空调器','',''],['空调机','',''],['空调车','',''],['空谈','',''],['空谈者','',''],['空谷传声','',''],['空谷幽兰','',''],['空谷足音','',''],['空跑','',''],['空跑一趟','',''],['空身','',''],['空车','',''],['空转','',''],['空载','',''],['空运','',''],['空运费','',''],['空速','',''],['空道','',''],['空钟','',''],['空门','',''],['空闲','',''],['空间','',''],['空间图形','',''],['空间局','',''],['空间性','',''],['空间探测','',''],['空间波','',''],['空间点阵','',''],['空间电荷','',''],['空间站','',''],['空阒','',''],['空阔','',''],['空防','',''],['空际','',''],['空降','',''],['空降兵','',''],['空隙','',''],['空难','',''],['空集','',''],['空页','',''],['空额','',''],['穿一条裤子','',''],['穿上','',''],['穿不下','',''],['穿云','',''],['穿云破雾','',''],['穿云裂石','',''],['穿以','',''],['穿住','',''],['穿便衣','',''],['穿入','',''],['穿凿','',''],['穿凿附会','',''],['穿制','',''],['穿制服','',''],['穿刺','',''],['穿回','',''],['穿在','',''],['穿坏','',''],['穿堂','',''],['穿堂儿','',''],['穿堂门','',''],['穿堂风','',''],['穿墙','',''],['穿好','',''],['穿孔','',''],['穿孔员','',''],['穿孔器','',''],['穿孔机','',''],['穿孔者','',''],['穿孝','',''],['穿小鞋','',''],['穿山甲','',''],['穿山越岭','',''],['穿带','',''],['穿帮','',''],['穿常风','',''],['穿廊','',''],['穿得','',''],['穿得好','',''],['穿心莲','',''],['穿戴','',''],['穿房入户','',''],['穿换','',''],['穿插','',''],['穿暖','',''],['穿来','',''],['穿杨','',''],['穿梭','',''],['穿梭外交','',''],['穿梭往返','',''],['穿洞','',''],['穿烂','',''],['穿用','',''],['穿用者','',''],['穿甲弹','',''],['穿着','',''],['穿着入时','',''],['穿着打扮','',''],['穿着者','',''],['穿着讲究','',''],['穿破','',''],['穿窬','',''],['穿窬之盗','',''],['穿红着绿','',''],['穿线','',''],['穿耳','',''],['穿花蛱蝶','',''],['穿著','',''],['穿行','',''],['穿衣','',''],['穿衣服','',''],['穿衣镜','',''],['穿袜','',''],['穿越','',''],['穿过','',''],['穿进','',''],['穿透','',''],['穿透性','',''],['穿透电流','',''],['穿透辐射','',''],['穿通','',''],['穿金戴银','',''],['穿针','',''],['穿针引线','',''],['穿针走线','',''],['穿钉','',''],['穿靴','',''],['穿鞋','',''],['穿马路','',''],['穿鼻','',''],['窀穸','',''],['突兀','',''],['突入','',''],['突出','',''],['突出点','',''],['突出表现','',''],['突出贡献','',''],['突击','',''],['突击手','',''],['突击检查','',''],['突击组','',''],['突击队','',''],['突击队员','',''],['突升','',''],['突厥','',''],['突厥人','',''],['突厥斯坦','',''],['突发','',''],['突发事件','',''],['突发奇想','',''],['突发性','',''],['突变','',''],['突变型','',''],['突变学','',''],['突变株','',''],['突变理论','',''],['突变种','',''],['突变论','',''],['突围','',''],['突围期','',''],['突地','',''],['突堤','',''],['突如','',''],['突如其来','',''],['突尼斯市','',''],['突尼西亚','',''],['突感','',''],['突显','',''],['突梯滑稽','',''],['突然','',''],['突然性','',''],['突然袭击','',''],['突然间','',''],['突现','',''],['突破','',''],['突破口','',''],['突破性','',''],['突破点','',''],['突破者','',''],['突破防御','',''],['突破难关','',''],['突突','',''],['突袭','',''],['突触','',''],['突触后','',''],['突起','',''],['突起部','',''],['突转','',''],['突进','',''],['突遭','',''],['突降','',''],['突飞','',''],['突飞猛进','',''],['窃位','',''],['窃位素餐','',''],['窃取','',''],['窃名','',''],['窃听','',''],['窃听器','',''],['窃喜','',''],['窃国','',''],['窃国者侯','',''],['窃密','',''],['窃幸乘宠','',''],['窃弄威权','',''],['窃据','',''],['窃权','',''],['窃案','',''],['窃物','',''],['窃犯','',''],['窃玉偷香','',''],['窃用','',''],['窃癖','',''],['窃盗','',''],['窃盗案','',''],['窃盗犯','',''],['窃盗癖','',''],['窃盗罪','',''],['窃窃','',''],['窃窃私语','',''],['窃窃细语','',''],['窃笑','',''],['窃簪之臣','',''],['窃蛋龙','',''],['窃蠹甲','',''],['窃谓','',''],['窃贼','',''],['窃走','',''],['窃钟掩耳','',''],['窃钩窃国','',''],['窃钩者诛','',''],['窄地','',''],['窄小','',''],['窄巴','',''],['窄巷','',''],['窄幅','',''],['窄床','',''],['窄打','',''],['窄播','',''],['窄桥','',''],['窄狭','',''],['窄用','',''],['窄缝','',''],['窄路','',''],['窄轨','',''],['窄道','',''],['窄门','',''],['窄门窄户','',''],['窅然','',''],['窈冥','',''],['窈窈','',''],['窈窕','',''],['窈窕冥冥','',''],['窈窕淑女','',''],['窈霭','',''],['窍门','',''],['窍门儿','',''],['窑内','',''],['窑场','',''],['窑坑','',''],['窑姐儿','',''],['窑子','',''],['窑工','',''],['窑洞','',''],['窑炉','',''],['窒息','',''],['窒息性毒剂','',''],['窒碍','',''],['窒闷','',''],['窕邃','',''],['窖子','',''],['窖肥','',''],['窖藏','',''],['窗体','',''],['窗侧','',''],['窗前','',''],['窗口','',''],['窗台','',''],['窗外','',''],['窗子','',''],['窗屉子','',''],['窗帘','',''],['窗幔','',''],['窗户','',''],['窗户棂','',''],['窗扇','',''],['窗旁','',''],['窗明','',''],['窗明几净','',''],['窗板','',''],['窗格','',''],['窗格子','',''],['窗框','',''],['窗棂','',''],['窗棂子','',''],['窗沿','',''],['窗洞','',''],['窗玻璃','',''],['窗盖','',''],['窗纱','',''],['窗花','',''],['窗钩','',''],['窗闩','',''],['窗间过马','',''],['窗饰','',''],['窘住','',''],['窘促','',''],['窘况','',''],['窘匮','',''],['窘困','',''],['窘地','',''],['窘境','',''],['窘态','',''],['窘色','',''],['窘迫','',''],['窜入','',''],['窜出','',''],['窜匿','',''],['窜扰','',''],['窜改','',''],['窜犯','',''],['窜红','',''],['窜踞','',''],['窜进','',''],['窜逃','',''],['窝上','',''],['窝主','',''],['窝停主人','',''],['窝儿','',''],['窝咑','',''],['窝囊','',''],['窝囊废','',''],['窝囊气','',''],['窝头','',''],['窝家','',''],['窝巢','',''],['窝工','',''],['窝心','',''],['窝憋','',''],['窝棚','',''],['窝火','',''],['窝瓜','',''],['窝窝','',''],['窝窝头','',''],['窝脓包','',''],['窝脖儿','',''],['窝藏','',''],['窝蜂','',''],['窝赃','',''],['窝边草','',''],['窝里','',''],['窝里反','',''],['窝里斗','',''],['窝铺','',''],['窝阔台','',''],['窝阔台汗','',''],['窟宅','',''],['窟穴','',''],['窟窿','',''],['窟窿眼儿','',''],['窟臀','',''],['窠臼','',''],['窥伺','',''],['窥全豹','',''],['窥孔','',''],['窥察','',''],['窥探','',''],['窥探者','',''],['窥望','',''],['窥求','',''],['窥测','',''],['窥牖小儿','',''],['窥看','',''],['窥知','',''],['窥见','',''],['窥视','',''],['窥视孔','',''],['窥豹','',''],['窥豹一斑','',''],['窥镜','',''],['窦娥冤','',''],['窦建德起义','',''],['窦状','',''],['窦窖','',''],['窦道','',''],['窨井','',''],['窬墙窥视','',''],['窳劣','',''],['窳惰','',''],['窳败','',''],['窸窣','',''],['立下','',''],['立业','',''],['立业安邦','',''],['立为','',''],['立于','',''],['立于不败之地','',''],['立井','',''],['立交','',''],['立交桥','',''],['立人','',''],['立人达人','',''],['立传','',''],['立体','',''],['立体交叉','',''],['立体几何','',''],['立体图','',''],['立体声','',''],['立体异构','',''],['立体异构体','',''],['立体性','',''],['立体感','',''],['立体摄像机','',''],['立体摄影','',''],['立体派','',''],['立体照片','',''],['立体电影','',''],['立体电影院','',''],['立体画','',''],['立体角','',''],['立体镜','',''],['立体音','',''],['立候','',''],['立像','',''],['立克次体','',''],['立党为公','',''],['立决','',''],['立刀旁','',''],['立刻','',''],['立功','',''],['立功受奖','',''],['立功喜报','',''],['立功立事','',''],['立功自效','',''],['立功赎罪','',''],['立升','',''],['立即','',''],['立卷','',''],['立吃地陷','',''],['立命','',''],['立命安身','',''],['立嗣','',''],['立国','',''],['立国之本','',''],['立国安邦','',''],['立地','',''],['立地书橱','',''],['立地成佛','',''],['立地金刚','',''],['立场','',''],['立契','',''],['立委','',''],['立委选举','',''],['立姿','',''],['立定','',''],['立定脚跟','',''],['立宪','',''],['立宪派','',''],['立异','',''],['立式','',''],['立式琴','',''],['立德','',''],['立德粉','',''],['立志','',''],['立性','',''],['立意','',''],['立感','',''],['立战功','',''],['立户','',''],['立扫千言','',''],['立据','',''],['立新','',''],['立方','',''],['立方体','',''],['立方公尺','',''],['立方厘米','',''],['立方形','',''],['立方根','',''],['立方米','',''],['立方英尺','',''],['立时','',''],['立时三刻','',''],['立有','',''],['立木','',''],['立杆见影','',''],['立枯病','',''],['立柜','',''],['立柱','',''],['立案','',''],['立案侦查','',''],['立正','',''],['立此','',''],['立此存照','',''],['立氏立克次体','',''],['立法','',''],['立法会','',''],['立法委员','',''],['立法委员会','',''],['立法机关','',''],['立法权','',''],['立法者','',''],['立法院','',''],['立派','',''],['立盹行眠','',''],['立眉瞪眼','',''],['立着','',''],['立碑','',''],['立竿','',''],['立竿见影','',''],['立等','',''],['立米','',''],['立约','',''],['立约人','',''],['立统','',''],['立者','',''],['立脚','',''],['立脚点','',''],['立著','',''],['立言','',''],['立誓','',''],['立论','',''],['立说','',''],['立谈之间','',''],['立贤无方','',''],['立起','',''],['立足','',''],['立足之地','',''],['立足于','',''],['立足处','',''],['立足点','',''],['立身','',''],['立身处世','',''],['立身扬名','',''],['立身行己','',''],['立身行道','',''],['立轴','',''],['立达','',''],['立遗嘱','',''],['立锥之土','',''],['立锥之地','',''],['立陶宛人','',''],['立面','',''],['立面图','',''],['立项','',''],['立顿','',''],['立马','',''],['立鱼','',''],['竖井','',''],['竖儒','',''],['竖写','',''],['竖在','',''],['竖子','',''],['竖子不足与谋','',''],['竖式','',''],['竖弯钩','',''],['竖折','',''],['竖挑眼','',''],['竖排','',''],['竖标','',''],['竖框','',''],['竖琴','',''],['竖琴似','',''],['竖目','',''],['竖直','',''],['竖直面','',''],['竖眉','',''],['竖眼','',''],['竖着','',''],['竖立','',''],['竖笔','',''],['竖笛','',''],['竖线','',''],['竖蜻蜓','',''],['竖行','',''],['竖起','',''],['竖起大拇指','',''],['竖起耳朵','',''],['竖起脊梁','',''],['竖钩','',''],['竖领','',''],['站上','',''],['站下','',''],['站不住','',''],['站不住脚','',''],['站了','',''],['站人','',''],['站位','',''],['站住','',''],['站住脚','',''],['站儿','',''],['站军姿','',''],['站到','',''],['站前','',''],['站友','',''],['站口','',''],['站台','',''],['站台票','',''],['站名','',''],['站员','',''],['站在','',''],['站地','',''],['站好','',''],['站姿','',''],['站定','',''],['站岗','',''],['站开','',''],['站得住','',''],['站得住脚','',''],['站得稳','',''],['站得高','',''],['站或坐','',''],['站拢','',''],['站柜台','',''],['站检','',''],['站点','',''],['站牌','',''],['站的','',''],['站直','',''],['站相','',''],['站着','',''],['站着说话不腰疼','',''],['站票','',''],['站稳','',''],['站稳脚跟','',''],['站立','',''],['站端','',''],['站管理','',''],['站著','',''],['站起','',''],['站起来','',''],['站长','',''],['站队','',''],['竞买','',''],['竞买人','',''],['竞争','',''],['竞争产品','',''],['竞争力','',''],['竞争和聚合','',''],['竞争性','',''],['竞争机制','',''],['竞争模式','',''],['竞争者','',''],['竞争能力','',''],['竞价','',''],['竞夺','',''],['竞得','',''],['竞态','',''],['竞技','',''],['竞技体操','',''],['竞技动物','',''],['竞技场','',''],['竞技性','',''],['竞技状态','',''],['竞板','',''],['竞标','',''],['竞渡','',''],['竞猜','',''],['竞相','',''],['竞短争长','',''],['竞秀','',''],['竞答','',''],['竞艳','',''],['竞购','',''],['竞赛','',''],['竞赛活动','',''],['竞赛者','',''],['竞走','',''],['竞选','',''],['竞选副手','',''],['竞选搭档','',''],['竞选活动','',''],['竞逐','',''],['竞金疏古','',''],['竟为','',''],['竟争','',''],['竟会','',''],['竟技场','',''],['竟敢','',''],['竟日','',''],['竟是','',''],['竟有','',''],['竟未','',''],['竟然','',''],['竟然会','',''],['竟能','',''],['竟自','',''],['竟至','',''],['竟达','',''],['竟陵','',''],['章决句断','',''],['章则','',''],['章句','',''],['章句之徒','',''],['章台','',''],['章台杨柳','',''],['章回','',''],['章回体','',''],['章回小说','',''],['章士钊','',''],['章太炎','',''],['章子','',''],['章子怡','',''],['章孝严','',''],['章服','',''],['章法','',''],['章炳麟','',''],['章甫','',''],['章甫荐履','',''],['章程','',''],['章节','',''],['章草','',''],['章贡','',''],['章鱼','',''],['竣工','',''],['童乩','',''],['童仆','',''],['童便','',''],['童儿','',''],['童养媳','',''],['童养媳妇','',''],['童军','',''],['童叟无欺','',''],['童声','',''],['童女','',''],['童子','',''],['童子军','',''],['童子痨','',''],['童子鸡','',''],['童山','',''],['童工','',''],['童席','',''],['童帽','',''],['童年','',''],['童年期','',''],['童床','',''],['童心','',''],['童心未泯','',''],['童星','',''],['童服','',''],['童牛角马','',''],['童生','',''],['童男','',''],['童真','',''],['童稚','',''],['童蒙','',''],['童袜','',''],['童装','',''],['童裤','',''],['童言无忌','',''],['童话','',''],['童话故事','',''],['童语','',''],['童谣','',''],['童贞','',''],['童趣','',''],['童车','',''],['童难童女','',''],['童鞋','',''],['童音','',''],['童颜','',''],['童颜鹤发','',''],['竭力','',''],['竭尽','',''],['竭尽全力','',''],['竭心','',''],['竭智尽力','',''],['竭智尽忠','',''],['竭泽而渔','',''],['竭虑','',''],['竭诚','',''],['竭诚尽节','',''],['竭诚服务','',''],['竭蹶','',''],['端上','',''],['端五','',''],['端人正士','',''],['端倪','',''],['端出','',''],['端午','',''],['端口','',''],['端向','',''],['端坐','',''],['端委','',''],['端子','',''],['端子线','',''],['端州','',''],['端庄','',''],['端接','',''],['端整','',''],['端方','',''],['端木','',''],['端木赐','',''],['端本正源','',''],['端本清源','',''],['端机','',''],['端来','',''],['端架子','',''],['端柱','',''],['端正','',''],['端正党风','',''],['端水','',''],['端点','',''],['端然','',''],['端由','',''],['端电压','',''],['端的','',''],['端相','',''],['端着','',''],['端砚','',''],['端站','',''],['端端正正','',''],['端粒','',''],['端粒脢','',''],['端系统','',''],['端纳','',''],['端线','',''],['端绪','',''],['端节','',''],['端茶','',''],['端菜','',''],['端行','',''],['端视','',''],['端详','',''],['端赖','',''],['端量','',''],['端阳','',''],['端阳节','',''],['端面','',''],['竹东','',''],['竹东镇','',''],['竹丝鸡','',''],['竹书纪年','',''],['竹刀','',''],['竹制','',''],['竹刻','',''],['竹南','',''],['竹南镇','',''],['竹叶','',''],['竹叶青','',''],['竹叶青蛇','',''],['竹器','',''],['竹园','',''],['竹塘','',''],['竹塘乡','',''],['竹头木屑','',''],['竹子','',''],['竹山镇','',''],['竹岛','',''],['竹崎','',''],['竹崎乡','',''],['竹布','',''],['竹帘','',''],['竹帛','',''],['竹席','',''],['竹报平安','',''],['竹排','',''],['竹木','',''],['竹材','',''],['竹杠','',''],['竹条','',''],['竹板','',''],['竹板书','',''],['竹林','',''],['竹林七贤','',''],['竹林之游','',''],['竹枝','',''],['竹枝词','',''],['竹椅','',''],['竹楼','',''],['竹片','',''],['竹片状','',''],['竹田','',''],['竹田乡','',''],['竹竿','',''],['竹笋','',''],['竹笙','',''],['竹笼','',''],['竹筏','',''],['竹筐','',''],['竹筒','',''],['竹筒倒豆子','',''],['竹筷','',''],['竹签','',''],['竹简','',''],['竹箍儿','',''],['竹管','',''],['竹篓','',''],['竹篦','',''],['竹篮','',''],['竹篮打水','',''],['竹篱笆','',''],['竹簧','',''],['竹类','',''],['竹纸','',''],['竹编','',''],['竹舆','',''],['竹节','',''],['竹节虫','',''],['竹芋','',''],['竹苞松茂','',''],['竹茹','',''],['竹马','',''],['竹马之交','',''],['竹马之友','',''],['竹马之好','',''],['竹鲛','',''],['竹鸡','',''],['竹黄','',''],['竺书','',''],['竺乾','',''],['竺可桢','',''],['竺学','',''],['竺教','',''],['竺法','',''],['竿头','',''],['竿头一步','',''],['竿子','',''],['竿跳','',''],['笃专','',''],['笃信','',''],['笃信好学','',''],['笃厚','',''],['笃学','',''],['笃学好古','',''],['笃守','',''],['笃定','',''],['笃实','',''],['笃志','',''],['笃志好学','',''],['笃志爱古','',''],['笃挚','',''],['笃爱','',''],['笃病','',''],['笃行','',''],['笄之年','',''],['笄冠','',''],['笄年','',''],['笄蛭','',''],['笆围','',''],['笆斗','',''],['笆篓','',''],['笆篱','',''],['笆篱子','',''],['笊篱','',''],['笋子','',''],['笋干','',''],['笋状','',''],['笋瓜','',''],['笋鸡','',''],['笑不可仰','',''],['笑不河清','',''],['笑了','',''],['笑傲','',''],['笑出','',''],['笑剧','',''],['笑口','',''],['笑口弥勒','',''],['笑后','',''],['笑吟吟','',''],['笑呵呵','',''],['笑咪咪','',''],['笑哈哈','',''],['笑啦','',''],['笑嘻嘻','',''],['笑噱','',''],['笑声','',''],['笑容','',''],['笑容可掬','',''],['笑影','',''],['笑得','',''],['笑意','',''],['笑掉','',''],['笑掉大牙','',''],['笑料','',''],['笑林','',''],['笑柄','',''],['笑死','',''],['笑气','',''],['笑涡','',''],['笑盈盈','',''],['笑眯眯','',''],['笑眼','',''],['笑着','',''],['笑破','',''],['笑破肚皮','',''],['笑窝','',''],['笑笑','',''],['笑纳','',''],['笑纹','',''],['笑者','',''],['笑脸','',''],['笑脸儿','',''],['笑脸相迎','',''],['笑著','',''],['笑著说','',''],['笑话','',''],['笑话书','',''],['笑语','',''],['笑说','',''],['笑谈','',''],['笑貌','',''],['笑贫不笑娼','',''],['笑逐颜开','',''],['笑里藏刀','',''],['笑面外交','',''],['笑面夜叉','',''],['笑面虎','',''],['笑靥','',''],['笑颜','',''],['笑骂','',''],['笑骂从汝','',''],['笔下','',''],['笔下生花','',''],['笔下超生','',''],['笔伐','',''],['笔会','',''],['笔供','',''],['笔具','',''],['笔写','',''],['笔刀','',''],['笔划','',''],['笔划检字表','',''],['笔削','',''],['笔力','',''],['笔势','',''],['笔勾','',''],['笔友','',''],['笔受','',''],['笔名','',''],['笔墨','',''],['笔墨官司','',''],['笔头','',''],['笔头儿','',''],['笔夹','',''],['笔套','',''],['笔尖','',''],['笔帽','',''],['笔底','',''],['笔底下','',''],['笔式','',''],['笔录','',''],['笔形','',''],['笔心','',''],['笔意','',''],['笔战','',''],['笔扫千军','',''],['笔挺','',''],['笔插','',''],['笔替','',''],['笔札','',''],['笔杆','',''],['笔杆儿','',''],['笔杆子','',''],['笔架','',''],['笔法','',''],['笔洗','',''],['笔电','',''],['笔画','',''],['笔画数','',''],['笔直','',''],['笔石','',''],['笔砚','',''],['笔端','',''],['笔筒','',''],['笔答','',''],['笔算','',''],['笔管','',''],['笔管面','',''],['笔翰如流','',''],['笔者','',''],['笔耕','',''],['笔耕不辍','',''],['笔胜于刀文比武强','',''],['笔致','',''],['笔舌','',''],['笔芯','',''],['笔触','',''],['笔记','',''],['笔记型电脑','',''],['笔记小说','',''],['笔记本','',''],['笔记本电脑','',''],['笔记本计算机','',''],['笔译','',''],['笔试','',''],['笔误','',''],['笔调','',''],['笔谈','',''],['笔资','',''],['笔走龙蛇','',''],['笔路','',''],['笔迹','',''],['笔铅','',''],['笔锋','',''],['笔顺','',''],['笔风','',''],['笙歌','',''],['笙歌鼎沸','',''],['笙管','',''],['笙箫','',''],['笙簧','',''],['笛卡儿','',''],['笛卡儿坐标制','',''],['笛卡尔','',''],['笛声','',''],['笛子','',''],['笛手','',''],['笛曲','',''],['笛沙格','',''],['笛膜','',''],['笞击','',''],['笞刑','',''],['笞打','',''],['笞挞','',''],['笞掠','',''],['笞杖','',''],['笞棰','',''],['笞背','',''],['笞臀','',''],['笞责','',''],['笞辱','',''],['笞骂','',''],['笠草','',''],['笤帚','',''],['笥匮囊空','',''],['符串','',''],['符号','',''],['符号为','',''],['符号化','',''],['符号学','',''],['符号法','',''],['符号论','',''],['符合','',''],['符合标准','',''],['符咒','',''],['符山石','',''],['符拉迪沃斯托克','',''],['符木','',''],['符板','',''],['符牌','',''],['符瑞','',''],['符箓','',''],['符类福音','',''],['符腾堡','',''],['符节','',''],['符记','',''],['符记环','',''],['笨举','',''],['笨人','',''],['笨伯','',''],['笨口拙舌','',''],['笨嘴拙腮','',''],['笨嘴拙舌','',''],['笨嘴笨舌','',''],['笨头笨脑','',''],['笨手笨脚','',''],['笨拙','',''],['笨拙不雅','',''],['笨死','',''],['笨瓜','',''],['笨的','',''],['笨笨','',''],['笨蛋','',''],['笨货','',''],['笨重','',''],['笨驴','',''],['笨鸟先飞','',''],['第一','',''],['第一世界','',''],['第一个','',''],['第一个层次','',''],['第一书记','',''],['第一产业','',''],['第一人称','',''],['第一位','',''],['第一例','',''],['第一信号系统','',''],['第一名','',''],['第一国际','',''],['第一型糖尿病','',''],['第一基本形式','',''],['第一声','',''],['第一天','',''],['第一夫人','',''],['第一季度','',''],['第一宇宙速度','',''],['第一届','',''],['第一年','',''],['第一手','',''],['第一手材料','',''],['第一把手','',''],['第一推动力','',''],['第一桶金','',''],['第一次','',''],['第一次世界大战','',''],['第一次国内革命战争','',''],['第一步','',''],['第一流','',''],['第一炮','',''],['第一章','',''],['第一级','',''],['第一线','',''],['第一象限','',''],['第一路军','',''],['第一轮','',''],['第七','',''],['第七年','',''],['第七音','',''],['第三','',''],['第三世界','',''],['第三世界国家','',''],['第三产业','',''],['第三代','',''],['第三位','',''],['第三名','',''],['第三国','',''],['第三国际','',''],['第三声','',''],['第三天','',''],['第三季','',''],['第三季度','',''],['第三宇宙速度','',''],['第三年','',''],['第三方','',''],['第三梯队','',''],['第三次','',''],['第三次国内革命战争','',''],['第三步','',''],['第三流','',''],['第三等','',''],['第三等级','',''],['第三系','',''],['第三级','',''],['第三纪','',''],['第三者','',''],['第九','',''],['第九年','',''],['第二','',''],['第二世界','',''],['第二个','',''],['第二产业','',''],['第二位','',''],['第二信号系统','',''],['第二半国际','',''],['第二名','',''],['第二国际','',''],['第二型糖尿病','',''],['第二声','',''],['第二天','',''],['第二季度','',''],['第二宇宙速度','',''],['第二层','',''],['第二年','',''],['第二性','',''],['第二手','',''],['第二批','',''],['第二把手','',''],['第二日','',''],['第二次','',''],['第二次世界大战','',''],['第二次国内革命战争','',''],['第二流','',''],['第二线','',''],['第二轮','',''],['第二音','',''],['第五','',''],['第五个现代化','',''],['第五名','',''],['第五年','',''],['第五类','',''],['第五纵队','',''],['第八','',''],['第八个五年计划','',''],['第八年','',''],['第六','',''],['第六个','',''],['第六年','',''],['第六感','',''],['第六感觉','',''],['第几','',''],['第几层','',''],['第勒尼安海','',''],['第十','',''],['第十一','',''],['第十一届','',''],['第十七','',''],['第十三','',''],['第十九','',''],['第十二','',''],['第十二届','',''],['第十五','',''],['第十亿','',''],['第十八','',''],['第十六','',''],['第十四','',''],['第十年','',''],['第四','',''],['第四卷','',''],['第四台','',''],['第四名','',''],['第四国际','',''],['第四堵墙','',''],['第四声','',''],['第四季','',''],['第四季度','',''],['第四年','',''],['第四系','',''],['第四纪','',''],['第戎','',''],['第比利斯','',''],['第纳尔','',''],['笸箩','',''],['笸篮','',''],['笺本','',''],['笺注','',''],['笺纸','',''],['笺薄','',''],['笺言','',''],['笼中','',''],['笼中之鸟','',''],['笼中穷鸟','',''],['笼内','',''],['笼咚','',''],['笼嘴','',''],['笼头','',''],['笼子','',''],['笼屉','',''],['笼式','',''],['笼槛','',''],['笼火','',''],['笼络','',''],['笼络人心','',''],['笼统','',''],['笼罩','',''],['笼街喝道','',''],['笼鸟','',''],['笼鸟槛猿','',''],['筀竹','',''],['筅帚','',''],['等一下','',''],['等一下儿','',''],['等一会','',''],['等一会儿','',''],['等一等','',''],['等上','',''],['等不及','',''],['等中','',''],['等之','',''],['等了','',''],['等于','',''],['等于零','',''],['等人','',''],['等他','',''],['等价','',''],['等价交换','',''],['等价关系','',''],['等价物','',''],['等份','',''],['等位基因','',''],['等你','',''],['等侯','',''],['等倍','',''],['等倍数','',''],['等候','',''],['等值','',''],['等值线','',''],['等分','',''],['等到','',''],['等力','',''],['等势','',''],['等压','',''],['等压线','',''],['等变压线','',''],['等右','',''],['等号','',''],['等同','',''],['等同性','',''],['等周','',''],['等周不等式','',''],['等品','',''],['等因奉此','',''],['等国','',''],['等在','',''],['等地','',''],['等外','',''],['等外品','',''],['等奖','',''],['等宽','',''],['等差','',''],['等差数列','',''],['等差级数','',''],['等幅','',''],['等幅上涨','',''],['等度','',''],['等式','',''],['等待','',''],['等得','',''],['等我','',''],['等把','',''],['等效','',''],['等效电路','',''],['等效百万吨当量','',''],['等日','',''],['等时','',''],['等机','',''],['等次','',''],['等死','',''],['等比','',''],['等比数','',''],['等比数列','',''],['等比级数','',''],['等温','',''],['等温线','',''],['等熵线','',''],['等用','',''],['等电位','',''],['等着','',''],['等着瞧','',''],['等离子','',''],['等离子体','',''],['等离子态','',''],['等离子焊接','',''],['等第','',''],['等等','',''],['等米下锅','',''],['等类','',''],['等级','',''],['等级低','',''],['等级制','',''],['等级制度','',''],['等级森严','',''],['等而下之','',''],['等而视之','',''],['等腰','',''],['等腰三角形','',''],['等著','',''],['等补','',''],['等衰','',''],['等角','',''],['等货','',''],['等距','',''],['等距离','',''],['等轴晶系','',''],['等边','',''],['等边三角形','',''],['等速','',''],['等速运动','',''],['等量','',''],['等量齐观','',''],['等闲','',''],['等闲之辈','',''],['等闲观之','',''],['等闲视之','',''],['等震线','',''],['等面','',''],['等额','',''],['等额比基金','',''],['等高','',''],['等高种植','',''],['等高线','',''],['筊杯','',''],['筋圈','',''],['筋斗','',''],['筋斗云','',''],['筋疲力尽','',''],['筋疲力竭','',''],['筋络','',''],['筋肉','',''],['筋脉','',''],['筋腱','',''],['筋节','',''],['筋骨','',''],['筏子','',''],['筏道','',''],['筐子','',''],['筐箧','',''],['筐箧中物','',''],['筑土墙','',''],['筑坛拜将','',''],['筑坝','',''],['筑城','',''],['筑基','',''],['筑堤','',''],['筑墙','',''],['筑室反耕','',''],['筑室道谋','',''],['筑巢','',''],['筑成','',''],['筑沟','',''],['筑波','',''],['筑起','',''],['筑路','',''],['筑造','',''],['筑造学','',''],['筒似','',''],['筒子','',''],['筒子楼','',''],['筒形','',''],['筒灯','',''],['筒状花','',''],['筒瓦','',''],['筒纸','',''],['筒袜','',''],['筒裤','',''],['筒阀','',''],['答中','',''],['答儿','',''],['答允','',''],['答出','',''],['答卷','',''],['答声','',''],['答复','',''],['答对','',''],['答应','',''],['答式','',''],['答录','',''],['答录机','',''],['答拜','',''],['答数','',''],['答案','',''],['答理','',''],['答疑','',''],['答白','',''],['答礼','',''],['答答','',''],['答腔','',''],['答茬','',''],['答茬儿','',''],['答覆','',''],['答记者问','',''],['答访','',''],['答词','',''],['答话','',''],['答语','',''],['答读者问','',''],['答谢','',''],['答谢宴会','',''],['答辞','',''],['答辨','',''],['答辩','',''],['答辩状','',''],['答辩者','',''],['答问','',''],['答非所问','',''],['答题','',''],['策划','',''],['策划了','',''],['策划人','',''],['策划者','',''],['策动','',''],['策励','',''],['策勉','',''],['策反','',''],['策士','',''],['策应','',''],['策杖','',''],['策源地','',''],['策画','',''],['策略','',''],['策略上','',''],['策略性','',''],['策论','',''],['策试','',''],['策谋','',''],['策问','',''],['策马','',''],['筚篥','',''],['筚路蓝缕','',''],['筚门闺窦','',''],['筛分','',''],['筛去','',''],['筛子','',''],['筛板','',''],['筛查','',''],['筛检','',''],['筛法','',''],['筛状','',''],['筛眼','',''],['筛筛','',''],['筛管','',''],['筛糠','',''],['筛过','',''],['筛选','',''],['筛除','',''],['筛骨','',''],['筢子','',''],['筲箍','',''],['筲箕','',''],['筵上','',''],['筵宴','',''],['筵席','',''],['筵席捐','',''],['筵謦','',''],['筷子','',''],['筷子芥','',''],['筹借','',''],['筹出','',''],['筹划','',''],['筹办','',''],['筹募','',''],['筹商','',''],['筹备','',''],['筹备会','',''],['筹委会','',''],['筹子','',''],['筹建','',''],['筹得','',''],['筹思','',''],['筹拍','',''],['筹拨','',''],['筹措','',''],['筹款','',''],['筹画','',''],['筹略','',''],['筹码','',''],['筹算','',''],['筹组','',''],['筹议','',''],['筹设','',''],['筹谋','',''],['筹资','',''],['筹赈','',''],['筹钱','',''],['筹集','',''],['筹集者','',''],['筹集资金','',''],['筼筜','',''],['筼筜湖','',''],['签了','',''],['签于','',''],['签入','',''],['签写','',''],['签准','',''],['签出','',''],['签到','',''],['签单','',''],['签印','',''],['签发','',''],['签发地点','',''],['签发日期','',''],['签名','',''],['签名人','',''],['签名簿','',''],['签呈','',''],['签子','',''],['签字','',''],['签字笔','',''],['签字者','',''],['签字费','',''],['签完','',''],['签定','',''],['签封','',''],['签帐卡','',''],['签批','',''],['签报','',''],['签押','',''],['签收','',''],['签有','',''],['签条','',''],['签注','',''],['签派室','',''],['签牌','',''],['签章','',''],['签筒','',''],['签约','',''],['签约国','',''],['签约奖金','',''],['签约者','',''],['签署','',''],['签署者','',''],['签订','',''],['签认','',''],['签证','',''],['签语饼','',''],['签过','',''],['签退','',''],['签领','',''],['简・爱','',''],['简义','',''],['简介','',''],['简令','',''],['简仪','',''],['简任','',''],['简体','',''],['简体字','',''],['简作','',''],['简便','',''],['简册','',''],['简写','',''],['简况','',''],['简分','',''],['简分数','',''],['简划','',''],['简则','',''],['简化','',''],['简化字','',''],['简化汉字','',''],['简单','',''],['简单再生产','',''],['简单判断','',''],['简单劳动','',''],['简单化','',''],['简单协作','',''],['简单地说','',''],['简单多数','',''],['简单扼要','',''],['简单明了','',''],['简单易学','',''],['简单机械','',''],['简单生产','',''],['简单网络管理协议','',''],['简历','',''],['简古','',''],['简史','',''],['简图','',''],['简在帝心','',''],['简复','',''],['简字','',''],['简师','',''],['简帖','',''],['简帖儿','',''],['简并','',''],['简慢','',''],['简截了当','',''],['简扼','',''],['简报','',''],['简括','',''],['简拼','',''],['简捷','',''],['简政','',''],['简明','',''],['简明扼要','',''],['简易','',''],['简易师范','',''],['简易煤气','',''],['简本','',''],['简札','',''],['简朴','',''],['简板','',''],['简氏防务周刊','',''],['简洁','',''],['简炼','',''],['简爱','',''],['简牍','',''],['简略','',''],['简略见告','',''],['简直','',''],['简直不','',''],['简短','',''],['简短介绍','',''],['简码','',''],['简称','',''],['简章','',''],['简简单单','',''],['简繁','',''],['简繁转换','',''],['简约','',''],['简纳','',''],['简练','',''],['简编','',''],['简缩','',''],['简而言之','',''],['简表','',''],['简装','',''],['简要','',''],['简要介绍','',''],['简言之','',''],['简讯','',''],['简记','',''],['简论','',''],['简谐','',''],['简谐振动','',''],['简谐波','',''],['简谐运动','',''],['简谱','',''],['简述','',''],['简陋','',''],['简除','',''],['箅子','',''],['箍咒','',''],['箍嘴','',''],['箍子','',''],['箍带','',''],['箍桶','',''],['箍桶匠','',''],['箍桶店','',''],['箍紧','',''],['箍节儿','',''],['箍麻','',''],['箔匠','',''],['箔材','',''],['箔条','',''],['箔片','',''],['箔纸','',''],['箕子','',''],['箕山之志','',''],['箕山之节','',''],['箕帚之使','',''],['箕裘相继','',''],['箕踞','',''],['箕风毕雨','',''],['算上','',''],['算不了','',''],['算不得','',''],['算了','',''],['算人','',''],['算作','',''],['算做','',''],['算入','',''],['算出','',''],['算出来','',''],['算卦','',''],['算去','',''],['算命','',''],['算命先生','',''],['算命家','',''],['算命者','',''],['算哪根葱','',''],['算啦','',''],['算在','',''],['算子','',''],['算学','',''],['算定','',''],['算尺','',''],['算帐','',''],['算式','',''],['算得','',''],['算得了','',''],['算数','',''],['算方','',''],['算无遗策','',''],['算是','',''],['算术','',''],['算术化','',''],['算术家','',''],['算术平均','',''],['算术平均数','',''],['算术式','',''],['算术级数','',''],['算术题','',''],['算来','',''],['算法','',''],['算法语言','',''],['算清','',''],['算盘','',''],['算盘子儿','',''],['算草','',''],['算计','',''],['算计儿','',''],['算话','',''],['算账','',''],['算起','',''],['算进','',''],['算错','',''],['算题','',''],['箜篌','',''],['箜簧','',''],['箝制','',''],['箝口结舌','',''],['管不着','',''],['管严','',''],['管中','',''],['管中窥天','',''],['管中窥豹','',''],['管乐','',''],['管乐器','',''],['管了','',''],['管事','',''],['管井','',''],['管人','',''],['管他','',''],['管仲','',''],['管件','',''],['管住','',''],['管保','',''],['管儿','',''],['管制','',''],['管制区','',''],['管区','',''],['管卡','',''],['管取','',''],['管口','',''],['管吃','',''],['管圆线虫','',''],['管城区','',''],['管城毛颖','',''],['管壁','',''],['管壳','',''],['管处','',''],['管套','',''],['管好','',''],['管委会','',''],['管子','',''],['管子工','',''],['管子钳','',''],['管宁割席','',''],['管家','',''],['管家婆','',''],['管家职务','',''],['管工','',''],['管帐','',''],['管带','',''],['管店','',''],['管座','',''],['管弦','',''],['管弦乐','',''],['管弦乐团','',''],['管弦乐队','',''],['管形','',''],['管待','',''],['管情','',''],['管我','',''],['管户','',''],['管手管脚','',''],['管扳子','',''],['管扳手','',''],['管护','',''],['管押','',''],['管控','',''],['管教','',''],['管教好','',''],['管教无方','',''],['管机','',''],['管材','',''],['管束','',''],['管查','',''],['管死','',''],['管治','',''],['管灯','',''],['管片','',''],['管状','',''],['管状花','',''],['管理','',''],['管理人','',''],['管理信息库','',''],['管理功能','',''],['管理员','',''],['管理器','',''],['管理处','',''],['管理委员会','',''],['管理学','',''],['管理学院','',''],['管理局','',''],['管理层收购','',''],['管理所','',''],['管理接口','',''],['管理站','',''],['管理者','',''],['管理费','',''],['管用','',''],['管界','',''],['管窖人','',''],['管窥','',''],['管窥之见','',''],['管窥所及','',''],['管窥筐举','',''],['管窥蠡测','',''],['管纱','',''],['管线','',''],['管网','',''],['管胞','',''],['管脚','',''],['管自','',''],['管芯','',''],['管见','',''],['管见所及','',''],['管训','',''],['管谁','',''],['管账','',''],['管路','',''],['管辖','',''],['管辖权','',''],['管过','',''],['管道','',''],['管道工','',''],['管道运输','',''],['管钳','',''],['管钳子','',''],['管闲事','',''],['管队','',''],['管风琴','',''],['管饭','',''],['管鲍之交','',''],['管鲍分金','',''],['管龠','',''],['箢箕','',''],['箧笥','',''],['箧箧','',''],['箧衍','',''],['箩筐','',''],['箪瓢屡空','',''],['箪瓢陋巷','',''],['箪笥','',''],['箪食壶浆','',''],['箪食瓢饮','',''],['箫韶九成','',''],['箬帽','',''],['箬竹','',''],['箭在弦上','',''],['箭垛子','',''],['箭头','',''],['箭头键','',''],['箭尾','',''],['箭术','',''],['箭杆','',''],['箭杆杨','',''],['箭楼','',''],['箭步','',''],['箭毒蛙','',''],['箭牌','',''],['箭猪','',''],['箭矢','',''],['箭石','',''],['箭竹','',''],['箭筒','',''],['箭镞','',''],['箭靶子','',''],['箭鱼','',''],['箱体','',''],['箱内','',''],['箱包','',''],['箱子','',''],['箱底','',''],['箱柜','',''],['箱根','',''],['箱梁','',''],['箱检','',''],['箱笼','',''],['箱箧','',''],['箱门','',''],['箴规','',''],['箴言','',''],['箴言式','',''],['箸长碗短','',''],['篆书','',''],['篆体','',''],['篆刻','',''],['篆刻家','',''],['篆字','',''],['篆工','',''],['篆文','',''],['篇名','',''],['篇子','',''],['篇幅','',''],['篇目','',''],['篇章','',''],['篇集','',''],['篇页','',''],['篓子','',''],['篓筐','',''],['篙头','',''],['篙子','',''],['篝火','',''],['篝火狐鸣','',''],['篡位','',''],['篡党','',''],['篡军','',''],['篡夺','',''],['篡夺者','',''],['篡弑','',''],['篡改','',''],['篡政','',''],['篡权','',''],['篡窃','',''],['篡立','',''],['篡贼','',''],['篡逆','',''],['篦头','',''],['篦子','',''],['篦麻','',''],['篮协','',''],['篮圈','',''],['篮坛','',''],['篮子','',''],['篮板','',''],['篮板球','',''],['篮框','',''],['篮状','',''],['篮球','',''],['篮球场','',''],['篮球赛','',''],['篮球队','',''],['篮筐','',''],['篮细工','',''],['篱垣','',''],['篱墙','',''],['篱壁间物','',''],['篱栅','',''],['篱牢犬不入','',''],['篱笆','',''],['篱落','',''],['篷子','',''],['篷形','',''],['篷盖布','',''],['篷船','',''],['篷车','',''],['篷顶','',''],['篷首垢面','',''],['篷马车','',''],['篼子','',''],['篾匠','',''],['篾条','',''],['篾片','',''],['篾青','',''],['篾黄','',''],['簇叶','',''],['簇射','',''],['簇拥','',''],['簇新','',''],['簇状','',''],['簇生','',''],['簇茎石竹','',''],['簇鱼之祸','',''],['簇鱼堂燕','',''],['簉室','',''],['簌簌','',''],['簌簌发抖','',''],['簦过','',''],['簧片','',''],['簧秤','',''],['簧管','',''],['簧舌','',''],['簧风琴','',''],['簧鼓','',''],['簪子','',''],['簪缨世胄','',''],['簪缨门第','',''],['簸扬','',''],['簸箕','',''],['簸荡','',''],['簸谷','',''],['簿上','',''],['簿册','',''],['簿子','',''],['簿本','',''],['簿籍','',''],['簿藉','',''],['簿记','',''],['簿记员','',''],['簿记管理员','',''],['籀书','',''],['籀文','',''],['籍册','',''],['籍口','',''],['籍籍','',''],['籍籍无名','',''],['籍贯','',''],['米寿','',''],['米仓','',''],['米价','',''],['米兰','',''],['米凯拉','',''],['米利班德','',''],['米制','',''],['米厂','',''],['米哈伊尔・普罗霍罗夫','',''],['米团','',''],['米国','',''],['米夫','',''],['米奇','',''],['米尔斯','',''],['米尔顿','',''],['米尺','',''],['米店','',''],['米开朗基罗','',''],['米德尔伯里','',''],['米拉','',''],['米格','',''],['米格尔・德・塞万提斯・萨维德拉','',''],['米欧','',''],['米歇尔','',''],['米汤','',''],['米泔水','',''],['米波','',''],['米特・罗姆尼','',''],['米珠薪桂','',''],['米盐博辩','',''],['米票','',''],['米突','',''],['米粉','',''],['米粉肉','',''],['米粒','',''],['米粒之珠','',''],['米粥','',''],['米粮','',''],['米粮川','',''],['米糕','',''],['米糠','',''],['米纳尔迪','',''],['米线','',''],['米老鼠','',''],['米色','',''],['米芾','',''],['米苏里州','',''],['米行','',''],['米该亚','',''],['米诺安','',''],['米象','',''],['米酒','',''],['米铺','',''],['米面','',''],['米饭','',''],['米饼','',''],['米高扬','',''],['米麴菌','',''],['米黄','',''],['类义','',''],['类义字','',''],['类乎','',''],['类书','',''],['类于','',''],['类人','',''],['类人猿','',''],['类似','',''],['类似于','',''],['类似点','',''],['类似物','',''],['类似问题','',''],['类别','',''],['类化','',''],['类同','',''],['类固醇','',''],['类地行星','',''],['类型','',''],['类属','',''],['类属词典','',''],['类推','',''],['类推者','',''],['类新星','',''],['类星体','',''],['类有','',''],['类木行星','',''],['类次','',''],['类此','',''],['类毒素','',''],['类比','',''],['类比推理','',''],['类比法','',''],['类比策略','',''],['类比错误','',''],['类球面','',''],['类目','',''],['类群','',''],['类聚','',''],['类胡萝卜素','',''],['类脂醇','',''],['类语辞典','',''],['类质同像','',''],['类金属','',''],['类项','',''],['类频数','',''],['类风湿因子','',''],['类鼻疽','',''],['类鼻疽单细胞','',''],['籼稻','',''],['籼米','',''],['籽棉','',''],['籽粒','',''],['粉丝','',''],['粉刷','',''],['粉刺','',''],['粉剂','',''],['粉土','',''],['粉坊','',''],['粉墙','',''],['粉墨','',''],['粉墨登场','',''],['粉妆玉琢','',''],['粉嫩','',''],['粉尘','',''],['粉底','',''],['粉彩','',''],['粉扑','',''],['粉扑儿','',''],['粉擦','',''],['粉料','',''],['粉末','',''],['粉末冶金','',''],['粉末状','',''],['粉条','',''],['粉板','',''],['粉沙','',''],['粉沫','',''],['粉浆','',''],['粉煤','',''],['粉煤灰','',''],['粉牌','',''],['粉状','',''],['粉白','',''],['粉白墨黑','',''],['粉白黛绿','',''],['粉白黛黑','',''],['粉皮','',''],['粉盒','',''],['粉砂岩','',''],['粉砂石','',''],['粉碎','',''],['粉碎器','',''],['粉碎机','',''],['粉笔','',''],['粉红','',''],['粉红色','',''],['粉线','',''],['粉肠','',''],['粉膏','',''],['粉色','',''],['粉芡','',''],['粉蒸肉','',''],['粉蜜','',''],['粉蜡笔','',''],['粉蝶','',''],['粉语','',''],['粉身灰骨','',''],['粉身碎骨','',''],['粉酶','',''],['粉面','',''],['粉面油头','',''],['粉饰','',''],['粉饰太平','',''],['粉饼','',''],['粉骨碎身','',''],['粉黛','',''],['粑粑','',''],['粒儿','',''],['粒大','',''],['粒子','',''],['粒子加速器','',''],['粒子束','',''],['粒子流','',''],['粒子物理','',''],['粒子物理学','',''],['粒岩','',''],['粒度','',''],['粒径','',''],['粒状','',''],['粒状物','',''],['粒白细胞','',''],['粒米束薪','',''],['粒米狼戾','',''],['粒细胞','',''],['粒肥','',''],['粒质','',''],['粒选','',''],['粗中有细','',''],['粗人','',''],['粗估','',''],['粗体','',''],['粗体字','',''],['粗俗','',''],['粗俗人','',''],['粗俗话','',''],['粗制','',''],['粗制品','',''],['粗制滥造','',''],['粗刻','',''],['粗加工','',''],['粗加工制品','',''],['粗劣','',''],['粗劣作品','',''],['粗卤','',''],['粗厉','',''],['粗口','',''],['粗呢','',''],['粗哑','',''],['粗壮','',''],['粗声','',''],['粗声粗气','',''],['粗大','',''],['粗实','',''],['粗工','',''],['粗布','',''],['粗心','',''],['粗心大意','',''],['粗心浮气','',''],['粗拉','',''],['粗放','',''],['粗放经营','',''],['粗暴','',''],['粗服乱头','',''],['粗枝','',''],['粗枝大叶','',''],['粗查','',''],['粗榧','',''],['粗毛','',''],['粗毛羊','',''],['粗气','',''],['粗活','',''],['粗浅','',''],['粗犷','',''],['粗率','',''],['粗略','',''],['粗疏','',''],['粗盈守成','',''],['粗盈守虚','',''],['粗盐','',''],['粗眉','',''],['粗短','',''],['粗砂','',''],['粗硬','',''],['粗碾','',''],['粗笨','',''],['粗筛','',''],['粗管面','',''],['粗粗','',''],['粗粝','',''],['粗粮','',''],['粗糙','',''],['粗糠','',''],['粗纱','',''],['粗纺','',''],['粗线','',''],['粗线条','',''],['粗细','',''],['粗绒','',''],['粗绳','',''],['粗缝','',''],['粗而','',''],['粗腿病','',''],['粗茶','',''],['粗茶淡饭','',''],['粗蛋白质','',''],['粗衣淡饭','',''],['粗衣粝食','',''],['粗览','',''],['粗话','',''],['粗语','',''],['粗读','',''],['粗豪','',''],['粗货','',''],['粗贱','',''],['粗选','',''],['粗通','',''],['粗鄙','',''],['粗鄙下流','',''],['粗重','',''],['粗野','',''],['粗野无礼','',''],['粗长','',''],['粗陋','',''],['粗面','',''],['粗风暴雨','',''],['粗饭','',''],['粗饲料','',''],['粗鲁','',''],['粗鲁无礼','',''],['粗麻','',''],['粘上','',''],['粘丝体','',''],['粘乎乎','',''],['粘住','',''],['粘剂','',''],['粘合','',''],['粘合剂','',''],['粘合性','',''],['粘固','',''],['粘土','',''],['粘在','',''],['粘块','',''],['粘帖','',''],['粘度','',''],['粘弹性','',''],['粘性','',''],['粘性力','',''],['粘有','',''],['粘木','',''],['粘板','',''],['粘染','',''],['粘涎','',''],['粘液','',''],['粘液素','',''],['粘液质','',''],['粘滑','',''],['粘滞','',''],['粘滞度','',''],['粘滞性','',''],['粘牙','',''],['粘牢','',''],['粘皮带骨','',''],['粘皮著骨','',''],['粘着','',''],['粘着剂','',''],['粘着力','',''],['粘着性','',''],['粘稠','',''],['粘米','',''],['粘粘','',''],['粘糊','',''],['粘紧','',''],['粘结','',''],['粘缠','',''],['粘聚','',''],['粘胶','',''],['粘胶布','',''],['粘胶液','',''],['粘胶纤维','',''],['粘膜','',''],['粘膜炎','',''],['粘花惹絮','',''],['粘花惹草','',''],['粘菌','',''],['粘著','',''],['粘著性','',''],['粘虫','',''],['粘质','',''],['粘质物','',''],['粘贴','',''],['粘贴处','',''],['粘连','',''],['粘附','',''],['粘附力','',''],['粜风卖雨','',''],['粝食粗衣','',''],['粝食粗餐','',''],['粟子','',''],['粟米','',''],['粟类','',''],['粟红贯朽','',''],['粟裕','',''],['粟谷','',''],['粟陈贯朽','',''],['粤东','',''],['粤剧','',''],['粤拼','',''],['粤歌','',''],['粤汉铁路','',''],['粤海','',''],['粤港','',''],['粤犬吠雪','',''],['粤若稽古','',''],['粤菜','',''],['粤语拼音','',''],['粥似','',''],['粥少僧多','',''],['粥样','',''],['粥样硬化','',''],['粥状','',''],['粥粥无能','',''],['粪便','',''],['粪便学','',''],['粪凼','',''],['粪土','',''],['粪坑','',''],['粪堆','',''],['粪尿','',''],['粪桶','',''],['粪池','',''],['粪筐','',''],['粪箕子','',''],['粪耙','',''],['粪肥','',''],['粪蛆','',''],['粪蛋','',''],['粪车','',''],['粪道','',''],['粪金龟','',''],['粪金龟子','',''],['粪门','',''],['粪除','',''],['粪青','',''],['粮人','',''],['粮仓','',''],['粮价','',''],['粮农','',''],['粮农组织','',''],['粮多草广','',''],['粮尽援绝','',''],['粮库','',''],['粮店','',''],['粮户','',''],['粮本','',''],['粮栈','',''],['粮棉','',''],['粮款','',''],['粮油','',''],['粮田','',''],['粮票','',''],['粮秣','',''],['粮税','',''],['粮站','',''],['粮管所','',''],['粮船','',''],['粮草','',''],['粮草先行','',''],['粮荒','',''],['粮行','',''],['粮袋','',''],['粮谷','',''],['粮道','',''],['粮食','',''],['粮食作物','',''],['粮食局','',''],['粮饷','',''],['粲夸克','',''],['粲然','',''],['粲然可观','',''],['粳稻','',''],['粳米','',''],['粼粼','',''],['粽子','',''],['精义入神','',''],['精于','',''],['精于此道','',''],['精光','',''],['精兵','',''],['精兵猛将','',''],['精兵简政','',''],['精准','',''],['精减','',''],['精到','',''],['精制','',''],['精力','',''],['精力充沛','',''],['精包','',''],['精华','',''],['精卫','',''],['精卫填海','',''],['精卫添海','',''],['精品','',''],['精囊','',''],['精国','',''],['精图','',''],['精壮','',''],['精奇古怪','',''],['精妙','',''],['精妙入神','',''],['精妙绝伦','',''],['精子','',''],['精子密度','',''],['精审','',''],['精密','',''],['精密仪器','',''],['精密化','',''],['精密度','',''],['精巢','',''],['精工','',''],['精巧','',''],['精干','',''],['精干高效','',''],['精度','',''],['精当','',''],['精彩','',''],['精彩逼人','',''],['精微','',''],['精心','',''],['精心励志','',''],['精忠','',''],['精忠报国','',''],['精怪','',''],['精悍','',''],['精悍短小','',''],['精打','',''],['精打光','',''],['精打细算','',''],['精挑','',''],['精整','',''],['精明','',''],['精明强干','',''],['精明能干','',''],['精校本','',''],['精梳','',''],['精气','',''],['精气神','',''],['精氨酸','',''],['精油','',''],['精液','',''],['精深','',''],['精深博大','',''],['精湛','',''],['精灵','',''],['精灵宝钻','',''],['精灵文','',''],['精炼','',''],['精炼厂','',''],['精疲力尽','',''],['精疲力竭','',''],['精益求精','',''],['精盐','',''],['精矿','',''],['精研','',''],['精确','',''],['精确度','',''],['精确性','',''],['精神','',''],['精神上','',''],['精神世界','',''],['精神健康','',''],['精神分析','',''],['精神分裂症','',''],['精神奕奕','',''],['精神好','',''],['精神学','',''],['精神学家','',''],['精神崩溃','',''],['精神性','',''],['精神性厌食症','',''],['精神恍惚','',''],['精神所加金石为开','',''],['精神抖擞','',''],['精神损耗','',''],['精神支柱','',''],['精神文明','',''],['精神满腹','',''],['精神焕发','',''],['精神状态','',''],['精神狂乱','',''],['精神生活','',''],['精神疗法','',''],['精神疾病','',''],['精神病','',''],['精神病医院','',''],['精神病学','',''],['精神病患','',''],['精神百倍','',''],['精神药物','',''],['精神衰弱','',''],['精神论','',''],['精神财富','',''],['精神错乱','',''],['精神领袖','',''],['精神饱满','',''],['精简','',''],['精简了','',''],['精简人员','',''],['精简开支','',''],['精简整编','',''],['精简机构','',''],['精算','',''],['精算师','',''],['精米','',''],['精粮','',''],['精粹','',''],['精索','',''],['精纯','',''],['精纺','',''],['精练','',''],['精细','',''],['精细管','',''],['精美','',''],['精耕','',''],['精耕细作','',''],['精肉','',''],['精致','',''],['精良','',''],['精英','',''],['精英奖','',''],['精英赛','',''],['精萃','',''],['精虫','',''],['精虫冲脑','',''],['精表','',''],['精装','',''],['精装书','',''],['精装本','',''],['精讲多练','',''],['精诚','',''],['精诚团结','',''],['精诚所加','',''],['精诚所加金石为开','',''],['精诚所至','',''],['精诚贯日','',''],['精读','',''],['精读课','',''],['精贯白日','',''],['精辟','',''],['精进','',''],['精选','',''],['精选者','',''],['精通','',''],['精采','',''],['精金百炼','',''],['精金美玉','',''],['精金良玉','',''],['精锐','',''],['精锐部队','',''],['精雕','',''],['精雕细刻','',''],['精雕细镂','',''],['精饲料','',''],['精馏','',''],['精馏塔','',''],['精髓','',''],['精魂','',''],['糅合','',''],['糊刷','',''],['糊剂','',''],['糊口','',''],['糊嘴','',''],['糊墙','',''],['糊墙纸','',''],['糊封','',''],['糊弄','',''],['糊弄局','',''],['糊料','',''],['糊涂','',''],['糊涂虫','',''],['糊涂账','',''],['糊状','',''],['糊状物','',''],['糊的','',''],['糊精','',''],['糊糊','',''],['糊糊涂涂','',''],['糊纸','',''],['糊话','',''],['糊里糊涂','',''],['糌粑','',''],['糍粑','',''],['糕干','',''],['糕点','',''],['糕饼','',''],['糖业','',''],['糖份','',''],['糖元','',''],['糖分','',''],['糖化','',''],['糖化物','',''],['糖厂','',''],['糖原','',''],['糖合物','',''],['糖块','',''],['糖寮','',''],['糖尿病','',''],['糖弹','',''],['糖心','',''],['糖房','',''],['糖料','',''],['糖果','',''],['糖果店','',''],['糖水','',''],['糖汁','',''],['糖浆','',''],['糖状','',''],['糖瓜','',''],['糖皮质激素','',''],['糖盒','',''],['糖稀','',''],['糖类','',''],['糖粉','',''],['糖精','',''],['糖纸','',''],['糖脂','',''],['糖膏','',''],['糖舌蜜口','',''],['糖苷','',''],['糖萝卜','',''],['糖萼','',''],['糖葫芦','',''],['糖蛋白','',''],['糖蜜','',''],['糖衣','',''],['糖衣宣传','',''],['糖衣炮弹','',''],['糖质','',''],['糖酯','',''],['糖酵解','',''],['糖酶','',''],['糖酸','',''],['糖酸盐','',''],['糖醇','',''],['糖醋','',''],['糖醋肉','',''],['糖醋里脊','',''],['糖醋鱼','',''],['糖量计','',''],['糖食','',''],['糗事','',''],['糗大','',''],['糙皮病','',''],['糙米','',''],['糙粮','',''],['糙面内质网','',''],['糜子','',''],['糜烂','',''],['糜烂性毒剂','',''],['糜费','',''],['糜鹿','',''],['糟了','',''],['糟塌','',''],['糟害','',''],['糟心','',''],['糟改','',''],['糟溜黄鱼','',''],['糟溜黄鱼片','',''],['糟粕','',''],['糟糕','',''],['糟糠','',''],['糟糠之妻','',''],['糟糠之妻不下堂','',''],['糟行','',''],['糟践','',''],['糟踏','',''],['糟蹋','',''],['糟透','',''],['糟齿类爬虫','',''],['糠油','',''],['糠疹','',''],['糠皮','',''],['糠秕','',''],['糠醛','',''],['糠麸','',''],['糢糊','',''],['糨子','',''],['糨糊','',''],['糯稻','',''],['糯米','',''],['糯米粉','',''],['糯米糍','',''],['糯米糕','',''],['糯米纸','',''],['糯米臀','',''],['糯麦','',''],['系上','',''],['系主任','',''],['系于','',''],['系人','',''],['系从','',''],['系以','',''],['系住','',''],['系内','',''],['系出名门','',''],['系刊','',''],['系列','',''],['系列产品','',''],['系列剧','',''],['系列化','',''],['系列放大器','',''],['系列片','',''],['系囚','',''],['系在','',''],['系外','',''],['系带','',''],['系念','',''],['系指','',''],['系数','',''],['系有','',''],['系柱','',''],['系栓','',''],['系泊','',''],['系牢','',''],['系由','',''],['系着','',''],['系窗','',''],['系紧','',''],['系结物','',''],['系统','',''],['系统分析','',''],['系统化','',''],['系统工程','',''],['系统工程学','',''],['系统性','',''],['系统控制','',''],['系统研究','',''],['系统管理','',''],['系统论','',''],['系绳','',''],['系缚','',''],['系而不食','',''],['系船','',''],['系词','',''],['系铃','',''],['系铃解铃','',''],['系领带','',''],['系风捕影','',''],['系风捕景','',''],['紊乱','',''],['紊流','',''],['素不相识','',''],['素丝羔羊','',''],['素丝良马','',''],['素交','',''],['素什锦','',''],['素以','',''],['素仰','',''],['素养','',''],['素净','',''],['素原促进','',''],['素口骂人','',''],['素席','',''],['素常','',''],['素性','',''],['素愿','',''],['素手','',''],['素描','',''],['素数','',''],['素斋','',''],['素日','',''],['素昧平生','',''],['素昧生平','',''],['素有','',''],['素服','',''],['素未','',''],['素朴','',''],['素朴实在论','',''],['素材','',''],['素来','',''],['素油','',''],['素淡','',''],['素爱','',''],['素筵','',''],['素缎','',''],['素色','',''],['素菜','',''],['素衣','',''],['素质','',''],['素质差','',''],['素质教育','',''],['素车白马','',''],['素酒','',''],['素钢','',''],['素门凡流','',''],['素闻','',''],['素隐行怪','',''],['素雅','',''],['素面朝天','',''],['素颜','',''],['素食','',''],['素食主义','',''],['素食者','',''],['素餐','',''],['素餐尸位','',''],['素馅','',''],['素馨花','',''],['素鸡','',''],['索人','',''],['索价','',''],['索价高','',''],['索债','',''],['索兴','',''],['索具','',''],['索具装置','',''],['索取','',''],['索句','',''],['索命','',''],['索回','',''],['索国','',''],['索垢寻疵','',''],['索多玛','',''],['索多玛与哈摩辣','',''],['索契','',''],['索子','',''],['索尔','',''],['索尔仁尼琴','',''],['索尔兹伯里平原','',''],['索尔兹伯里石环','',''],['索尼','',''],['索尽枯肠','',''],['索引','',''],['索引簿','',''],['索性','',''],['索戈拉特斯','',''],['索拿','',''],['索捕','',''],['索普','',''],['索杰纳','',''],['索桥','',''],['索求','',''],['索然','',''],['索然寡味','',''],['索然无味','',''],['索环','',''],['索福克勒斯','',''],['索福克里斯','',''],['索索','',''],['索绪尔','',''],['索罗斯','',''],['索罗门','',''],['索菲亚','',''],['索要','',''],['索解','',''],['索讨','',''],['索贿','',''],['索赔','',''],['索赔者','',''],['索还','',''],['索道','',''],['索邦大学','',''],['索里亚','',''],['索隐行怪','',''],['索非亚','',''],['索韵','',''],['索饵洄游','',''],['索马利','',''],['索马利亚','',''],['索马里亚','',''],['索马里人','',''],['紧了','',''],['紧促','',''],['紧俏','',''],['紧俏商品','',''],['紧俏货','',''],['紧凑','',''],['紧凑型车','',''],['紧凑渺子线圈','',''],['紧压茶','',''],['紧固','',''],['紧塞','',''],['紧密','',''],['紧密团结','',''],['紧密相联','',''],['紧密织物','',''],['紧密结合','',''],['紧密联系','',''],['紧密配合','',''],['紧巴','',''],['紧巴巴','',''],['紧带','',''],['紧张','',''],['紧张局势','',''],['紧张状况','',''],['紧张状态','',''],['紧张缓和','',''],['紧急','',''],['紧急事件','',''],['紧急会议','',''],['紧急关头','',''],['紧急医疗','',''],['紧急危害','',''],['紧急应变','',''],['紧急措施','',''],['紧急状态','',''],['紧急疏散','',''],['紧急通知','',''],['紧急集合','',''],['紧扣','',''],['紧抓','',''],['紧抱','',''],['紧挤','',''],['紧挨','',''],['紧排','',''],['紧接','',''],['紧接着','',''],['紧接著','',''],['紧握','',''],['紧日','',''],['紧日子','',''],['紧盯','',''],['紧着','',''],['紧箍咒','',''],['紧紧','',''],['紧紧张张','',''],['紧绌','',''],['紧绑','',''],['紧绷','',''],['紧绷绷','',''],['紧缩','',''],['紧缺','',''],['紧胸','',''],['紧腰衣','',''],['紧裹','',''],['紧要','',''],['紧要关头','',''],['紧贴','',''],['紧跟','',''],['紧跟形势','',''],['紧身','',''],['紧身儿','',''],['紧身衣','',''],['紧迫','',''],['紧迫性','',''],['紧迫感','',''],['紧迫盯人','',''],['紧追','',''],['紧逼','',''],['紧邻','',''],['紧锣密鼓','',''],['紧闭','',''],['紧附','',''],['紧随','',''],['紧随其后','',''],['紧集','',''],['紧靠','',''],['紫丁香','',''],['紫云','',''],['紫云英','',''],['紫光','',''],['紫坪铺','',''],['紫坪铺大坝','',''],['紫坪铺水库','',''],['紫堇','',''],['紫外','',''],['紫外光','',''],['紫外射线','',''],['紫外线','',''],['紫外线光','',''],['紫外线灯','',''],['紫式部','',''],['紫微宫','',''],['紫微斗数','',''],['紫斑','',''],['紫景天','',''],['紫晶','',''],['紫杉','',''],['紫檀','',''],['紫毫','',''],['紫气','',''],['紫气东来','',''],['紫水晶','',''],['紫河车','',''],['紫珠草','',''],['紫电清霜','',''],['紫癜','',''],['紫石英','',''],['紫石英号','',''],['紫禁城','',''],['紫穗槐','',''],['紫竹','',''],['紫红','',''],['紫红色','',''],['紫缓金章','',''],['紫罗','',''],['紫罗兰','',''],['紫罗兰色','',''],['紫翠玉','',''],['紫胶虫','',''],['紫色','',''],['紫芝','',''],['紫芝眉宇','',''],['紫花','',''],['紫花地丁','',''],['紫花苜蓿','',''],['紫苏','',''],['紫苏属','',''],['紫茉莉','',''],['紫荆','',''],['紫草','',''],['紫草科','',''],['紫草茸','',''],['紫药水','',''],['紫菀','',''],['紫菜','',''],['紫菜包饭','',''],['紫菜属','',''],['紫菜苔','',''],['紫萍','',''],['紫葳','',''],['紫蓝','',''],['紫薇','',''],['紫藤','',''],['紫袍','',''],['紫袍玉带','',''],['紫貂','',''],['紫金山','',''],['紫金山天文台','',''],['紫金牛','',''],['紫铜','',''],['紫陌红尘','',''],['紫雪','',''],['紫雪糕','',''],['累世','',''],['累了','',''],['累人','',''],['累倒','',''],['累债','',''],['累减','',''],['累加','',''],['累加器','',''],['累加总数','',''],['累卵','',''],['累卵之危','',''],['累及','',''],['累土聚沙','',''],['累土至山','',''],['累坏','',''],['累块积苏','',''],['累坠','',''],['累垮','',''],['累年','',''],['累得','',''],['累得要死','',''],['累心','',''],['累教不改','',''],['累月','',''],['累月经年','',''],['累极','',''],['累次','',''],['累死','',''],['累死累活','',''],['累活','',''],['累牍','',''],['累牍连篇','',''],['累犯','',''],['累瓦结绳','',''],['累病','',''],['累积','',''],['累积剂量','',''],['累积者','',''],['累累','',''],['累见不鲜','',''],['累计','',''],['累赘','',''],['累足成步','',''],['累进','',''],['累进税','',''],['累进税率','',''],['累退','',''],['累鸟','',''],['絘布','',''],['絮叨','',''],['絮嘴','',''],['絮棉','',''],['絮烦','',''],['絮片','',''],['絮状','',''],['絮状物','',''],['絮球','',''],['絮絮','',''],['絮絮叨叨','',''],['絮聒','',''],['絮语','',''],['絮说','',''],['綷縩','',''],['繁丽','',''],['繁乱','',''],['繁体','',''],['繁体字','',''],['繁冗','',''],['繁分数','',''],['繁刑重敛','',''],['繁刑重赋','',''],['繁华','',''],['繁华损枝','',''],['繁博','',''],['繁叶饰','',''],['繁复','',''],['繁多','',''],['繁密','',''],['繁弦急管','',''],['繁征博引','',''],['繁忙','',''],['繁文','',''],['繁文末节','',''],['繁文缛礼','',''],['繁文缛节','',''],['繁文褥节','',''],['繁星','',''],['繁本','',''],['繁杂','',''],['繁殖','',''],['繁殖力','',''],['繁殖率','',''],['繁殖者','',''],['繁琐','',''],['繁盛','',''],['繁简','',''],['繁缛','',''],['繁育','',''],['繁芜','',''],['繁花','',''],['繁花似锦','',''],['繁茂','',''],['繁荣','',''],['繁荣富强','',''],['繁荣市场','',''],['繁荣昌盛','',''],['繁荣经济','',''],['繁衍','',''],['繁重','',''],['繁闹','',''],['繁难','',''],['纂修','',''],['纠众','',''],['纠偏','',''],['纠分','',''],['纠合','',''],['纠合之众','',''],['纠察','',''],['纠察员','',''],['纠察队','',''],['纠弹','',''],['纠查','',''],['纠正','',''],['纠纷','',''],['纠纷案','',''],['纠结','',''],['纠结点','',''],['纠编','',''],['纠缠','',''],['纠缠不休','',''],['纠缠不清','',''],['纠缪绳违','',''],['纠葛','',''],['纠错','',''],['纠集','',''],['纡介不遗','',''],['纡子','',''],['纡尊降贵','',''],['纡朱怀金','',''],['纡青拖紫','',''],['红三叶','',''],['红三叶草','',''],['红不棱登','',''],['红与黑','',''],['红专','',''],['红丝待选','',''],['红丝暗系','',''],['红丹','',''],['红了','',''],['红五军团','',''],['红五星旗','',''],['红人','',''],['红光','',''],['红光满面','',''],['红六军团','',''],['红军','',''],['红净','',''],['红利','',''],['红利股票','',''],['红包','',''],['红区','',''],['红十字','',''],['红卫兵','',''],['红发','',''],['红古','',''],['红叶','',''],['红叶之题','',''],['红嘴鸥','',''],['红土','',''],['红土子','',''],['红地毯','',''],['红场','',''],['红堡','',''],['红塔','',''],['红墨水','',''],['红壤','',''],['红外','',''],['红外光谱','',''],['红外对抗','',''],['红外技术','',''],['红外测距','',''],['红外热像仪','',''],['红外线','',''],['红外线导引飞弹','',''],['红外线摄影','',''],['红外线灯','',''],['红外线瞄准镜','',''],['红外线通信','',''],['红头发','',''],['红头菜','',''],['红头蝇','',''],['红契','',''],['红妆','',''],['红姑娘','',''],['红娘','',''],['红字','',''],['红学','',''],['红孩症','',''],['红宝书','',''],['红宝石','',''],['红寡妇鸟','',''],['红寺堡','',''],['红寺堡区','',''],['红寺堡镇','',''],['红小兵','',''],['红小豆','',''],['红尘','',''],['红尘客梦','',''],['红山','',''],['红岗','',''],['红巨星','',''],['红巾军','',''],['红巾起义','',''],['红布','',''],['红帽子','',''],['红彤彤','',''],['红得发紫','',''],['红心','',''],['红愁绿惨','',''],['红扑扑','',''],['红教','',''],['红斑','',''],['红斑性狼疮','',''],['红新月','',''],['红新月会','',''],['红旗','',''],['红旗手','',''],['红旗报捷','',''],['红旗竞赛','',''],['红日','',''],['红日三竿','',''],['红星','',''],['红晕','',''],['红景天','',''],['红曲','',''],['红木','',''],['红杉','',''],['红杉木','',''],['红杏出墙','',''],['红松','',''],['红极一时','',''],['红果','',''],['红果儿','',''],['红枣','',''],['红枪会','',''],['红柳','',''],['红树','',''],['红树林','',''],['红样','',''],['红桃','',''],['红案','',''],['红桤树','',''],['红桥','',''],['红梅','',''],['红棉','',''],['红椒','',''],['红楼','',''],['红楼梦','',''],['红榜','',''],['红模子','',''],['红樱枪','',''],['红橙','',''],['红橙色','',''],['红橙黄绿蓝靛紫','',''],['红殷殷','',''],['红毛','',''],['红毛丹','',''],['红毛坭','',''],['红毯','',''],['红水晶','',''],['红汞','',''],['红河州','',''],['红油','',''],['红泥月亮','',''],['红海','',''],['红润','',''],['红潮','',''],['红火','',''],['红火蚁','',''],['红灯','',''],['红灯区','',''],['红灯照','',''],['红灯记','',''],['红点颏','',''],['红烛','',''],['红烧','',''],['红烧肉','',''],['红热','',''],['红煤','',''],['红酒','',''],['红熊猫','',''],['红牌','',''],['红牛','',''],['红牛皮菜','',''],['红狐','',''],['红玉髓','',''],['红玛瑙','',''],['红珊瑚','',''],['红璧玺','',''],['红生','',''],['红男绿女','',''],['红瘦绿肥','',''],['红白','',''],['红白喜事','',''],['红的','',''],['红皮','',''],['红皮书','',''],['红盘','',''],['红眼','',''],['红眼圈','',''],['红眼病','',''],['红着脸','',''],['红矮星','',''],['红矾','',''],['红砒','',''],['红砖','',''],['红磷','',''],['红票','',''],['红种','',''],['红移','',''],['红笔','',''],['红筹股','',''],['红箍儿','',''],['红粉','',''],['红粉青楼','',''],['红粉青蛾','',''],['红糖','',''],['红红','',''],['红线','',''],['红细胞','',''],['红绸','',''],['红绿','',''],['红绿灯','',''],['红缨','',''],['红缨枪','',''],['红羊劫','',''],['红肠','',''],['红股','',''],['红肿','',''],['红背蜘蛛','',''],['红胡子','',''],['红脖子','',''],['红脸','',''],['红腐贯朽','',''],['红腹灰雀','',''],['红臂章','',''],['红色','',''],['红色娘子军','',''],['红色政权','',''],['红色高棉','',''],['红艳','',''],['红艳艳','',''],['红花','',''],['红花岗','',''],['红花草','',''],['红苕','',''],['红茶','',''],['红药水','',''],['红莲','',''],['红萍','',''],['红萝卜','',''],['红葡萄酒','',''],['红蓝','',''],['红薯','',''],['红藤','',''],['红藻','',''],['红蛋','',''],['红蜘蛛','',''],['红螺','',''],['红血球','',''],['红血球生成素','',''],['红衣','',''],['红衣主教','',''],['红衰绿减','',''],['红袄军','',''],['红袖添香','',''],['红装','',''],['红褐','',''],['红褐色','',''],['红角儿','',''],['红豆','',''],['红豆沙','',''],['红豆相思','',''],['红货','',''],['红超巨星','',''],['红轮','',''],['红辉','',''],['红辣椒','',''],['红辣椒粉','',''],['红运','',''],['红透','',''],['红通通','',''],['红遍','',''],['红醋栗','',''],['红铃虫','',''],['红铜','',''],['红铜时代','',''],['红锌矿','',''],['红隼','',''],['红霉素','',''],['红霞','',''],['红青','',''],['红鞋','',''],['红领巾','',''],['红颈瓣蹼鹬','',''],['红颜','',''],['红颜知己','',''],['红颜薄命','',''],['红马甲','',''],['红骨髓','',''],['红高粱','',''],['红魔鬼','',''],['红鱼','',''],['红鲣','',''],['红麻','',''],['红麻料儿','',''],['纣棍','',''],['纣辛','',''],['纤体','',''],['纤夫','',''],['纤密','',''],['纤小','',''],['纤尘','',''],['纤尘不染','',''],['纤屑','',''],['纤巧','',''],['纤度','',''],['纤弱','',''],['纤微','',''],['纤悉','',''],['纤悉不遗','',''],['纤悉无遗','',''],['纤手','',''],['纤指','',''],['纤柔','',''],['纤毛','',''],['纤毛动力蛋白','',''],['纤毛虫','',''],['纤毫','',''],['纤瘦','',''],['纤纤','',''],['纤细','',''],['纤绳','',''],['纤维','',''],['纤维丛','',''],['纤维囊泡症','',''],['纤维性','',''],['纤维板','',''],['纤维植物','',''],['纤维状','',''],['纤维症','',''],['纤维瘤','',''],['纤维素','',''],['纤维肌痛','',''],['纤维胶','',''],['纤维蛋白','',''],['纤维蛋白原','',''],['纤维镜','',''],['纤美','',''],['纤腰','',''],['纤芥','',''],['纤芯','',''],['纤芯直径','',''],['纤道','',''],['纥字不识','',''],['约为','',''],['约之','',''],['约书亚','',''],['约书亚记','',''],['约人','',''],['约他','',''],['约会','',''],['约会对象','',''],['约伯','',''],['约伯记','',''],['约但','',''],['约但河','',''],['约值','',''],['约克','',''],['约克郡','',''],['约出','',''],['约分','',''],['约制','',''],['约占','',''],['约去','',''],['约合','',''],['约同','',''],['约在','',''],['约坦','',''],['约塔','',''],['约契','',''],['约好','',''],['约定','',''],['约定俗成','',''],['约定资讯速率','',''],['约当现金','',''],['约成','',''],['约拿书','',''],['约据','',''],['约摸','',''],['约数','',''],['约旦人','',''],['约旦河','',''],['约晤','',''],['约有','',''],['约期','',''],['约束','',''],['约束力','',''],['约束条件','',''],['约柜','',''],['约根','',''],['约沙法','',''],['约法','',''],['约法三章','',''],['约珥书','',''],['约瑟','',''],['约瑟夫','',''],['约瑟夫・斯大林','',''],['约略','',''],['约略估计','',''],['约稿','',''],['约章','',''],['约等于','',''],['约纳','',''],['约维克','',''],['布朗起义','',''],['约翰・厄普代克','',''],['约翰・拉贝','',''],['约翰・本仁','',''],['约翰・霍金斯','',''],['约翰一书','',''],['约翰三书','',''],['约翰二书','',''],['约翰保罗','',''],['约翰内斯堡','',''],['约翰参书','',''],['约翰壹书','',''],['约翰斯顿','',''],['约翰福音','',''],['约翰贰书','',''],['约者','',''],['约莫','',''],['约西亚','',''],['约见','',''],['约言','',''],['约计','',''],['约请','',''],['约谈','',''],['约集','',''],['约需','',''],['级任','',''],['级别','',''],['级差','',''],['级差地租','',''],['级强','',''],['级数','',''],['级次','',''],['级联','',''],['级距','',''],['纨扇','',''],['纨绔子弟','',''],['纨绔弟子','',''],['纨裤子弟','',''],['纪事','',''],['纪事本末体','',''],['纪传体','',''],['纪元','',''],['纪元前','',''],['纪委','',''],['纪实','',''],['纪实小说','',''],['纪实文学','',''],['纪层','',''],['纪年','',''],['纪录','',''],['纪录创造者','',''],['纪录影片','',''],['纪录片','',''],['纪律','',''],['纪律严明','',''],['纪律处分','',''],['纪律性','',''],['纪律整顿','',''],['纪律科','',''],['纪念','',''],['纪念会','',''],['纪念册','',''],['纪念品','',''],['纪念堂','',''],['纪念塔','',''],['纪念奖','',''],['纪念封','',''],['纪念日','',''],['纪念活动','',''],['纪念物','',''],['纪念碑','',''],['纪念章','',''],['纪念邮票','',''],['纪念馆','',''],['纪效新书','',''],['纪昀','',''],['纪检','',''],['纪检委','',''],['纪纲','',''],['纪纲人伦','',''],['纪行','',''],['纪要','',''],['纫佩','',''],['纬书','',''],['纬圈','',''],['纬地经天','',''],['纬密','',''],['纬度','',''],['纬武经文','',''],['纬纱','',''],['纬线','',''],['纬线圈','',''],['纬编','',''],['纬锦','',''],['纭纭','',''],['纯一','',''],['纯为','',''],['纯作','',''],['纯净','',''],['纯利','',''],['纯利润','',''],['纯利益','',''],['纯化','',''],['纯品','',''],['纯小数','',''],['纯属','',''],['纯属偶然','',''],['纯度','',''],['纯态','',''],['纯情','',''],['纯收','',''],['纯收入','',''],['纯收益','',''],['纯文字','',''],['纯文字页','',''],['纯朴','',''],['纯棉','',''],['纯正','',''],['纯毛','',''],['纯氧','',''],['纯洁','',''],['纯然','',''],['纯熟','',''],['纯爱','',''],['纯牛奶','',''],['纯理','',''],['纯白','',''],['纯真','',''],['纯真无垢','',''],['纯碱','',''],['纯种','',''],['纯种马','',''],['纯粹','',''],['纯粹数学','',''],['纯系','',''],['纯素','',''],['纯素颜','',''],['纯素食','',''],['纯素食主义','',''],['纯素食者','',''],['纯纯','',''],['纯绵','',''],['纯美','',''],['纯色','',''],['纯苯','',''],['纯血种','',''],['纯血统','',''],['纯金','',''],['纯钢','',''],['纯铁','',''],['纯银','',''],['纯音','',''],['纰漏','',''],['纰缪','',''],['纱包','',''],['纱包线','',''],['纱厂','',''],['纱头','',''],['纱巾','',''],['纱布','',''],['纱布口罩','',''],['纱带','',''],['纱帽','',''],['纱支','',''],['纱橱','',''],['纱灯','',''],['纱窗','',''],['纱笼','',''],['纱筒','',''],['纱管','',''],['纱线','',''],['纱绽','',''],['纱罩','',''],['纱车','',''],['纱锭','',''],['纲丝绳','',''],['纲举目张','',''],['纲常','',''],['纲常扫地','',''],['纲目','',''],['纲目不疏','',''],['纲目体','',''],['纲索','',''],['纲纪','',''],['纲纪废弛','',''],['纲要','',''],['纲记','',''],['纲领','',''],['纲领性','',''],['纲领性文件','',''],['纳人','',''],['纳什','',''],['纳入','',''],['纳凉','',''],['纳匝肋','',''],['纳卫星','',''],['纳吉布','',''],['纳员','',''],['纳垢藏污','',''],['纳塔乃耳','',''],['纳士招贤','',''],['纳妾','',''],['纳尔逊','',''],['纳尼亚','',''],['纳尼亚传奇','',''],['纳屡踵决','',''],['纳彩','',''],['纳德阿里','',''],['纳扎尔巴耶夫','',''],['纳指','',''],['纳撒尼尔・霍桑','',''],['纳斯达克','',''],['纳新','',''],['纳新吐故','',''],['纳星','',''],['纳木错','',''],['纳杰夫','',''],['纳树','',''],['纳污','',''],['纳溪','',''],['纳瓦特尔语','',''],['纳瓦萨','',''],['纳福','',''],['纳秒','',''],['纳税','',''],['纳税人','',''],['纳米','',''],['纳米技术','',''],['纳粮','',''],['纳粹','',''],['纳粹主义','',''],['纳粹党','',''],['纳粹分子','',''],['纳粹化','',''],['纳粹德国','',''],['纳罕','',''],['纳聘','',''],['纳芬','',''],['纳西','',''],['纳言','',''],['纳谏','',''],['纳谏如流','',''],['纳豆','',''],['纳豆菌','',''],['纳贡','',''],['纳贡称臣','',''],['纳贿','',''],['纳赛尔','',''],['纳赫雄','',''],['纳闷','',''],['纳闷儿','',''],['纳闽','',''],['纳降','',''],['纳霍德卡','',''],['纳鞋','',''],['纳骨堂','',''],['纳鸿','',''],['纴织','',''],['纵令','',''],['纵任','',''],['纵使','',''],['纵停留时间','',''],['纵切面','',''],['纵列','',''],['纵剖面','',''],['纵向','',''],['纵坐标','',''],['纵声','',''],['纵容','',''],['纵帆','',''],['纵座标','',''],['纵情','',''],['纵情恣欲','',''],['纵情遂欲','',''],['纵情酒色','',''],['纵意','',''],['纵排','',''],['纵断面','',''],['纵曲枉直','',''],['纵杆','',''],['纵梁','',''],['纵横','',''],['纵横交贯','',''],['纵横交错','',''],['纵横天下','',''],['纵横字','',''],['纵横字谜','',''],['纵横家','',''],['纵横捭阖','',''],['纵横驰骋','',''],['纵欲','',''],['纵步','',''],['纵波','',''],['纵深','',''],['纵火','',''],['纵火犯','',''],['纵火者','',''],['纵然','',''],['纵目','',''],['纵神经索','',''],['纵纹','',''],['纵线','',''],['纵肌','',''],['纵虎归山','',''],['纵裂','',''],['纵观','',''],['纵览','',''],['纵言','',''],['纵论','',''],['纵谈','',''],['纵贯','',''],['纵身','',''],['纵轴','',''],['纵酒','',''],['纵长','',''],['纵队','',''],['纵隔','',''],['纵风止燎','',''],['纵马横刀','',''],['纶巾','',''],['纷乱','',''],['纷争','',''],['纷华','',''],['纷吹','',''],['纷呈','',''],['纷扰','',''],['纷披','',''],['纷杂','',''],['纷沓','',''],['纷繁','',''],['纷红骇绿','',''],['纷纭','',''],['纷纭杂沓','',''],['纷纶','',''],['纷纷','',''],['纷纷扬扬','',''],['纷纷攘攘','',''],['纷纷籍籍','',''],['纷聚','',''],['纷至沓来','',''],['纷落','',''],['纷飞','',''],['纸上','',''],['纸上谈兵','',''],['纸人','',''],['纸人纸马','',''],['纸伞','',''],['纸做','',''],['纸刀','',''],['纸包不住火','',''],['纸包饮品','',''],['纸卷','',''],['纸厂','',''],['纸压','',''],['纸叶子','',''],['纸品','',''],['纸团','',''],['纸型','',''],['纸垫','',''],['纸堆','',''],['纸头','',''],['纸夹','',''],['纸婚','',''],['纸媒','',''],['纸媒儿','',''],['纸孔','',''],['纸屑','',''],['纸巾','',''],['纸币','',''],['纸带','',''],['纸张','',''],['纸扇','',''],['纸捻','',''],['纸条','',''],['纸杯','',''],['纸板','',''],['纸板盒','',''],['纸样','',''],['纸框','',''],['纸桨','',''],['纸桶','',''],['纸浆','',''],['纸浆质','',''],['纸火柴','',''],['纸灯','',''],['纸灰','',''],['纸烟','',''],['纸煤儿','',''],['纸片','',''],['纸版','',''],['纸牌','',''],['纸盆','',''],['纸盒','',''],['纸盒纸','',''],['纸盘','',''],['纸短情长','',''],['纸笔','',''],['纸箔','',''],['纸管','',''],['纸箱','',''],['纸篓','',''],['纸簿','',''],['纸类','',''],['纸糊','',''],['纸绳','',''],['纸老虎','',''],['纸色','',''],['纸芯','',''],['纸花','',''],['纸茑','',''],['纸草','',''],['纸袋','',''],['纸证','',''],['纸贵洛城','',''],['纸边','',''],['纸醉金迷','',''],['纸里包不住火','',''],['纸钱','',''],['纸锭','',''],['纸面','',''],['纸页','',''],['纸饰','',''],['纸马','',''],['纸马儿','',''],['纸鱼','',''],['纸鸢','',''],['纸鹞','',''],['纸鹤','',''],['纸黄金','',''],['纹丝','',''],['纹丝不动','',''],['纹丝儿','',''],['纹儿','',''],['纹刺','',''],['纹印','',''],['纹层','',''],['纹布','',''],['纹沟','',''],['纹法','',''],['纹理','',''],['纹理状','',''],['纹眉','',''],['纹章','',''],['纹章学','',''],['纹线','',''],['纹缕','',''],['纹缕儿','',''],['纹路','',''],['纹路儿','',''],['纹身','',''],['纹银','',''],['纹面','',''],['纹风不动','',''],['纹饰','',''],['纺丝','',''],['纺成','',''],['纺纱','',''],['纺纱机','',''],['纺线','',''],['纺织','',''],['纺织业','',''],['纺织厂','',''],['纺织品','',''],['纺织娘','',''],['纺织工业','',''],['纺织工业部','',''],['纺织成','',''],['纺织机','',''],['纺织物','',''],['纺织纤维','',''],['纺织者','',''],['纺织部','',''],['纺绸','',''],['纺车','',''],['纺轮','',''],['纺锤','',''],['纺锤形','',''],['纺锤状','',''],['纺锭','',''],['纽伦堡','',''],['纽几内亚','',''],['纽卡斯尔','',''],['纽卡素','',''],['纽国','',''],['纽子','',''],['纽带','',''],['纽扣','',''],['纽扣儿','',''],['纽时','',''],['纽泽西','',''],['纽瓦克','',''],['纽约','',''],['纽约人','',''],['纽约大学','',''],['纽约客','',''],['纽约州','',''],['纽约市','',''],['纽约帝国大厦','',''],['纽约时报','',''],['纽约证券交易所','',''],['纽约邮报','',''],['纽绊','',''],['纽芬兰','',''],['纽芬兰与拉布拉多','',''],['纽芬兰人','',''],['纽襻','',''],['纽西兰','',''],['纾困','',''],['纾缓','',''],['纾解','',''],['线上','',''],['线上查询','',''],['线下','',''],['线人','',''],['线卡','',''],['线呢','',''],['线哨','',''],['线团','',''],['线图','',''],['线圈','',''],['线圈般','',''],['线坯子','',''],['线型','',''],['线外','',''],['线头','',''],['线宽','',''],['线式','',''],['线形','',''],['线形动物','',''],['线性','',''],['线性代数','',''],['线性元件','',''],['线性函数','',''],['线性化','',''],['线性变换','',''],['线性方程','',''],['线性波','',''],['线性算子','',''],['线性系统','',''],['线性规划','',''],['线抽傀儡','',''],['线断风筝','',''],['线春','',''],['线杆','',''],['线材','',''],['线条','',''],['线栏','',''],['线桄子','',''],['线槽','',''],['线段','',''],['线毯','',''],['线民','',''],['线状','',''],['线球','',''],['线电压','',''],['线盘','',''],['线程','',''],['线粒体','',''],['线索','',''],['线绳','',''],['线缆','',''],['线胀系数','',''],['线脚','',''],['线膨胀','',''],['线般','',''],['线虫','',''],['线虫类','',''],['线衣','',''],['线袜','',''],['线装','',''],['线装书','',''],['线西','',''],['线西乡','',''],['线规','',''],['线路','',''],['线轴','',''],['线轴儿','',''],['线速度','',''],['线锯','',''],['线香','',''],['线麻','',''],['绀青','',''],['练习','',''],['练习册','',''],['练习场','',''],['练习曲','',''],['练习本','',''],['练习生','',''],['练习簿','',''],['练习题','',''],['练了','',''],['练人','',''],['练兵','',''],['练兵场','',''],['练功','',''],['练厂','',''],['练声','',''],['练字','',''],['练就','',''],['练成','',''],['练打','',''],['练拳','',''],['练武','',''],['练球','',''],['练练','',''],['练达','',''],['练达老成','',''],['练金','',''],['练队','',''],['练鹊','',''],['练齿','',''],['组件','',''],['组分','',''],['组别','',''],['组合','',''],['组合图','',''],['组合夹具','',''],['组合式','',''],['组合数学','',''],['组合机床','',''],['组合柜','',''],['组合论','',''],['组合音响','',''],['组员','',''],['组团','',''],['组图','',''],['组块','',''],['组委','',''],['组委会','',''],['组字','',''],['组屋','',''],['组建','',''],['组成','',''],['组成者','',''],['组成部分','',''],['组播','',''],['组曲','',''],['组歌','',''],['组氨酸','',''],['组版','',''],['组画','',''],['组稿','',''],['组织','',''],['组织上','',''],['组织体制','',''],['组织关系','',''],['组织化','',''],['组织原则','',''],['组织委员','',''],['组织委员会','',''],['组织学','',''],['组织性','',''],['组织沿革','',''],['组织法','',''],['组织活动','',''],['组织浆霉菌病','',''],['组织液','',''],['组织生活','',''],['组织疗法','',''],['组织纪律','',''],['组织纪律性','',''],['组织者','',''],['组织胞浆菌病','',''],['组织胺','',''],['组织观念','',''],['组织路线','',''],['组织部','',''],['组织部长','',''],['组织部门','',''],['组胺','',''],['组装','',''],['组训','',''],['组词','',''],['组配','',''],['组长','',''],['组间','',''],['组阁','',''],['组项','',''],['绅士','',''],['绅士们','',''],['绅士协定','',''],['绅宦','',''],['绅耆','',''],['细不容发','',''],['细丝','',''],['细丝带','',''],['细丝状','',''],['细了','',''],['细作','',''],['细分','',''],['细切','',''],['细则','',''],['细别','',''],['细动脉','',''],['细化','',''],['细发','',''],['细叶脉','',''],['细听','',''],['细咬','',''],['细品','',''],['细嚼','',''],['细嚼慢咽','',''],['细圆','',''],['细声','',''],['细声细气','',''],['细大不捐','',''],['细大不逾','',''],['细大无遗','',''],['细如','',''],['细嫩','',''],['细孔','',''],['细密','',''],['细察','',''],['细小','',''],['细尾獴','',''],['细工','',''],['细巧','',''],['细布','',''],['细帐','',''],['细底','',''],['细弱','',''],['细弹','',''],['细微','',''],['细微末节','',''],['细心','',''],['细情','',''],['细想','',''],['细挑','',''],['细故','',''],['细数','',''],['细明体','',''],['细木','',''],['细木工板','',''],['细末','',''],['细条','',''],['细条纹','',''],['细枝','',''],['细枝末节','',''],['细枝条','',''],['细枝状','',''],['细查','',''],['细梳','',''],['细棒','',''],['细毛','',''],['细毛羊','',''],['细水长流','',''],['细沙','',''],['细沟','',''],['细河','',''],['细活','',''],['细流','',''],['细润','',''],['细瓷','',''],['细痕','',''],['细的','',''],['细盐','',''],['细目','',''],['细看','',''],['细短','',''],['细砂','',''],['细碎','',''],['细磨刀石','',''],['细究','',''],['细算','',''],['细管','',''],['细类','',''],['细粉','',''],['细粒','',''],['细粮','',''],['细纱','',''],['细纺','',''],['细线','',''],['细细','',''],['细细品味','',''],['细细地流','',''],['细绳','',''],['细缝','',''],['细胞','',''],['细胞体','',''],['细胞内','',''],['细胞分裂','',''],['细胞周期','',''],['细胞器','',''],['细胞器官','',''],['细胞因子','',''],['细胞培养','',''],['细胞培养器','',''],['细胞壁','',''],['细胞外液','',''],['细胞学','',''],['细胞核','',''],['细胞毒','',''],['细胞毒性','',''],['细胞液','',''],['细胞生物学','',''],['细胞膜','',''],['细胞色素','',''],['细胞融合','',''],['细胞质','',''],['细胞骨架','',''],['细胶团','',''],['细腰','',''],['细腻','',''],['细致','',''],['细节','',''],['细菌','',''],['细菌学','',''],['细菌性痢疾','',''],['细菌战','',''],['细菌武器','',''],['细菌状','',''],['细菌病毒','',''],['细菌群','',''],['细菌肥料','',''],['细菜','',''],['细表','',''],['细语','',''],['细说','',''],['细读','',''],['细读者','',''],['细调','',''],['细谈','',''],['细软','',''],['细辛','',''],['细过','',''],['细述','',''],['细选','',''],['细部','',''],['细量','',''],['细针密线','',''],['细针密缕','',''],['细铅字','',''],['细长','',''],['细雨','',''],['细音','',''],['细颈','',''],['细颈瓶','',''],['细香葱','',''],['细高','',''],['细高挑儿','',''],['细齿','',''],['织为','',''],['织了','',''],['织入','',''],['织出','',''],['织厂','',''],['织合','',''],['织品','',''],['织在','',''],['织女','',''],['织女星','',''],['织工','',''],['织布','',''],['织布机','',''],['织式','',''],['织当访婢','',''],['织成','',''],['织机','',''],['织染','',''],['织法','',''],['织物','',''],['织物组织','',''],['织田信长','',''],['织着','',''],['织纴','',''],['织网','',''],['织花','',''],['织补','',''],['织补物','',''],['织袜','',''],['织边','',''],['织造','',''],['织金锦','',''],['织锦','',''],['织锦回文','',''],['织锦画','',''],['织锦缎','',''],['终一','',''],['终世若一','',''],['终久','',''],['终了','',''],['终于','',''],['终产物','',''],['终伏','',''],['终会','',''],['终值','',''],['终傅','',''],['终其','',''],['终南','',''],['终南山','',''],['终南捷径','',''],['终古','',''],['终句','',''],['终因','',''],['终场','',''],['终场锣声','',''],['终声','',''],['终夜','',''],['终天','',''],['终天之恨','',''],['终天之慕','',''],['终天抱恨','',''],['终如','',''],['终始不渝','',''],['终审','',''],['终审法院','',''],['终将','',''],['终局','',''],['终岁','',''],['终年','',''],['终年积雪','',''],['终归','',''],['终性','',''],['终成','',''],['终成泡影','',''],['终成眷属','',''],['终战','',''],['终战日','',''],['终日','',''],['终曲','',''],['终有','',''],['终期','',''],['终期癌','',''],['终极','',''],['终止','',''],['终点','',''],['终点地址','',''],['终点站','',''],['终点线','',''],['终焉之志','',''],['终生','',''],['终生伴侣','',''],['终生教育','',''],['终究','',''],['终站','',''],['终竟','',''],['终端','',''],['终端机','',''],['终端用户','',''],['终端设备','',''],['终篇','',''],['终结','',''],['终结者','',''],['终结部','',''],['终老','',''],['终而复始','',''],['终身','',''],['终身为父','',''],['终身伴侣','',''],['终身制','',''],['终身大事','',''],['终身监禁','',''],['终身职','',''],['终速','',''],['终霜','',''],['终须','',''],['终须绿叶扶持','',''],['绉布','',''],['绉痕','',''],['绉纱','',''],['绉纹','',''],['绉褶','',''],['绉起','',''],['绉边','',''],['绊住','',''],['绊倒','',''],['绊网','',''],['绊脚','',''],['绊脚石','',''],['绊跤','',''],['绍介','',''],['绍兴地区','',''],['绍兴酒','',''],['绍剧','',''],['绍莫吉州','',''],['绍酒','',''],['绎克一物','',''],['绎出','',''],['绎性','',''],['绎法','',''],['经一事长一智','',''],['经上级批准','',''],['经不住','',''],['经不起','',''],['经不起推究','',''],['经世','',''],['经世之才','',''],['经丝彩色显花','',''],['经久','',''],['经久不息','',''],['经久不衰','',''],['经久耐用','',''],['经书','',''],['经互会','',''],['经人介绍','',''],['经传','',''],['经典','',''],['经典动力系统','',''],['经典场论','',''],['经典案例','',''],['经典著作','',''],['经办','',''],['经办人','',''],['经匣','',''],['经卦','',''],['经卷','',''],['经历','',''],['经历风雨','',''],['经受','',''],['经受住','',''],['经史','',''],['经史子集','',''],['经合','',''],['经合组织','',''],['经售','',''],['经商','',''],['经国之才','',''],['经圈','',''],['经堂','',''],['经处','',''],['经天纬地','',''],['经委','',''],['经学','',''],['经官动府','',''],['经密','',''],['经已','',''],['经常','',''],['经常化','',''],['经常性','',''],['经幢','',''],['经年','',''],['经年累月','',''],['经度','',''],['经得住','',''],['经得起','',''],['经心','',''],['经意','',''],['经手','',''],['经手人','',''],['经援','',''],['经撞','',''],['经文','',''],['经文歌','',''],['经文纬武','',''],['经明行修','',''],['经期','',''],['经查','',''],['经武纬文','',''],['经气聚集','',''],['经洗','',''],['经济','',''],['经济上','',''],['经济主义','',''],['经济人','',''],['经济仓','',''],['经济体制','',''],['经济体系','',''],['经济作物','',''],['经济共同体','',''],['经济制度','',''],['经济制裁','',''],['经济前途','',''],['经济力量','',''],['经济区','',''],['经济协力开发机构','',''],['经济危机','',''],['经济危机周期','',''],['经济发展','',''],['经济合作与发展组织','',''],['经济周期','',''],['经济唯物主义','',''],['经济困境','',''],['经济基础','',''],['经济增加值','',''],['经济增长','',''],['经济增长率','',''],['经济学','',''],['经济学家','',''],['经济学者','',''],['经济安全','',''],['经济座','',''],['经济强区','',''],['经济强国','',''],['经济强省','',''],['经济情况','',''],['经济成分','',''],['经济改革','',''],['经济效益','',''],['经济斗争','',''],['经济日报','',''],['经济昆虫','',''],['经济有效','',''],['经济杂交','',''],['经济林','',''],['经济核算','',''],['经济法','',''],['经济活动','',''],['经济派','',''],['经济特区','',''],['经济状况','',''],['经济界','',''],['经济社会及文化权利国际公约','',''],['经济管理','',''],['经济紧缩','',''],['经济繁荣','',''],['经济罢工','',''],['经济舱','',''],['经济萧条','',''],['经济落后','',''],['经济衰退','',''],['经济规律','',''],['经济问题','',''],['经热','',''],['经理','',''],['经理部','',''],['经用','',''],['经由','',''],['经界','',''],['经略','',''],['经痛','',''],['经看','',''],['经研究决定','',''],['经筵','',''],['经管','',''],['经籍','',''],['经籍志','',''],['经纪','',''],['经纪业','',''],['经纪人','',''],['经纬','',''],['经纬仪','',''],['经纬天下','',''],['经纬度','',''],['经纬线','',''],['经纬网','',''],['经纱','',''],['经纶','',''],['经纶济世','',''],['经纶满腹','',''],['经线','',''],['经络','',''],['经编','',''],['经而','',''],['经脉','',''],['经营','',''],['经营之道','',''],['经营型','',''],['经营思想','',''],['经营承包','',''],['经营承包制','',''],['经营承包责任制','',''],['经营擘划','',''],['经营效果','',''],['经营方式','',''],['经营有术','',''],['经营机制','',''],['经营权','',''],['经营管理','',''],['经营管理和维护','',''],['经营管理权','',''],['经营者','',''],['经营自主权','',''],['经营费用','',''],['经营部','',''],['经血','',''],['经行','',''],['经表','',''],['经许可','',''],['经论','',''],['经贸','',''],['经贸公司','',''],['经贸合作','',''],['经贸部','',''],['经费','',''],['经费支出','',''],['经轴','',''],['经过','',''],['经邦论道','',''],['经部','',''],['经销','',''],['经销商','',''],['经销权','',''],['经销部','',''],['经锦','',''],['经闭','',''],['经陆路','',''],['经院','',''],['经院哲学','',''],['经风雨见世面','',''],['经验','',''],['经验一元论','',''],['经验丰富','',''],['经验主义','',''],['经验之谈','',''],['经验交流','',''],['经验交流会','',''],['经验性','',''],['经验总结','',''],['经验批判主义','',''],['经验教训','',''],['经验符号论','',''],['经验论','',''],['绑上','',''],['绑住','',''],['绑匪','',''],['绑在','',''],['绑定','',''],['绑好','',''],['绑带','',''],['绑扎','',''],['绑架','',''],['绑牢','',''],['绑票','',''],['绑紧','',''],['绑缚','',''],['绑腿','',''],['绑走','',''],['绑赴','',''],['绑赴市曹','',''],['绑起','',''],['绒丝带','',''],['绒似','',''],['绒头绳','',''],['绒布','',''],['绒帽','',''],['绒毛','',''],['绒毛似','',''],['绒毛性腺激素','',''],['绒毛状','',''],['绒毛膜','',''],['绒毯','',''],['绒状','',''],['绒的','',''],['绒类','',''],['绒线','',''],['绒绒','',''],['绒绣','',''],['绒花','',''],['绒螯蟹','',''],['绒衣','',''],['绒被','',''],['绒裤','',''],['绒面','',''],['绒领','',''],['绒鸟','',''],['结下','',''],['结业','',''],['结业生','',''],['结业证书','',''],['结为','',''],['结义','',''],['结了','',''],['结了婚','',''],['结交','',''],['结亲','',''],['结仇','',''],['结付','',''],['结伙','',''],['结伴','',''],['结伴而行','',''],['结余','',''],['结余归己','',''],['结党','',''],['结党联群','',''],['结党聚群','',''],['结党营私','',''],['结冰','',''],['结冻','',''],['结出','',''],['结单','',''],['结发','',''],['结发夫妻','',''],['结合','',''],['结合体','',''],['结合力','',''],['结合实际','',''],['结合律','',''],['结合模型','',''],['结合水','',''],['结合者','',''],['结合能','',''],['结合膜','',''],['结合过程','',''],['结喉','',''],['结块','',''],['结垢','',''],['结壳','',''],['结婚','',''],['结婚前','',''],['结婚后','',''],['结婚期','',''],['结婚登记','',''],['结婚礼','',''],['结婚纪念日','',''],['结婚证','',''],['结子','',''],['结存','',''],['结实','',''],['结实粗壮','',''],['结对子','',''],['结尾','',''],['结尾辞','',''],['结局','',''],['结巴','',''],['结帐','',''],['结带','',''],['结幕','',''],['结平','',''],['结庐','',''],['结彩','',''],['结怨','',''],['结成','',''],['结扎','',''],['结扎带','',''],['结扎线','',''],['结拜','',''],['结晶','',''],['结晶体','',''],['结晶学','',''],['结晶水','',''],['结晶状','',''],['结有','',''],['结末','',''],['结束','',''],['结束工作','',''],['结束语','',''],['结构','',''],['结构上','',''],['结构主义','',''],['结构力学','',''],['结构助词','',''],['结构图','',''],['结构式','',''],['结构性','',''],['结构模式','',''],['结构物','',''],['结构理论','',''],['结构设计','',''],['结构调整','',''],['结构钢','',''],['结果','',''],['结核','',''],['结核性','',''],['结核杆菌','',''],['结核病','',''],['结核菌素','',''],['结案','',''],['结欠','',''],['结欢','',''],['结止','',''],['结水','',''],['结汇','',''],['结清','',''],['结满','',''],['结点','',''],['结焦','',''],['结牢','',''],['结物','',''],['结环','',''],['结球甘蓝','',''],['结球白菜','',''],['结界','',''],['结疤','',''],['结痂','',''],['结症','',''],['结盟','',''],['结石','',''],['结石病','',''],['结社','',''],['结社自由','',''],['结穴','',''],['结算','',''],['结算方式','',''],['结纳','',''],['结结','',''],['结结实实','',''],['结结巴巴','',''],['结绳','',''],['结绳而治','',''],['结缔组织','',''],['结缘','',''],['结缡','',''],['结缨','',''],['结网','',''],['结肠','',''],['结肠炎','',''],['结肠镜检查','',''],['结脉','',''],['结膜','',''],['结膜炎','',''],['结舌','',''],['结舌杜口','',''],['结节','',''],['结草','',''],['结草悬环','',''],['结草衔环','',''],['结褵','',''],['结记','',''],['结论','',''],['结论性','',''],['结识','',''],['结语','',''],['结账','',''],['结转','',''],['结过','',''],['结过婚','',''],['结连','',''],['结邻','',''],['结队','',''],['结队成群','',''],['结集','',''],['结霜','',''],['结露','',''],['结驷联骑','',''],['绔子','',''],['绔带','',''],['绔裙','',''],['绕一周','',''],['绕以','',''],['绕口','',''],['绕口令','',''],['绕嘴','',''],['绕回','',''],['绕圈','',''],['绕圈子','',''],['绕地','',''],['绕地球','',''],['绕射','',''],['绕开','',''],['绕弯','',''],['绕弯儿','',''],['绕弯子','',''],['绕弯子儿','',''],['绕成','',''],['绕手','',''],['绕指柔肠','',''],['绕来绕去','',''],['绕梁三日','',''],['绕梁之音','',''],['绕毓','',''],['绕流','',''],['绕物','',''],['绕着','',''],['绕组','',''],['绕绕','',''],['绕脖','',''],['绕脖子','',''],['绕腾','',''],['绕膝','',''],['绕膝承欢','',''],['绕舌','',''],['绕航','',''],['绕虫','',''],['绕行','',''],['绕行者','',''],['绕越','',''],['绕路','',''],['绕过','',''],['绕远','',''],['绕远儿','',''],['绕道','',''],['绕道而行','',''],['绗缝','',''],['绘事','',''],['绘事后素','',''],['绘具箱','',''],['绘出','',''],['绘制','',''],['绘图','',''],['绘图仪','',''],['绘图技术','',''],['绘图机','',''],['绘图板','',''],['绘图法','',''],['绘声绘影','',''],['绘声绘色','',''],['绘影绘声','',''],['绘成','',''],['绘架座','',''],['绘画','',''],['绘画般','',''],['绘色','',''],['给与','',''],['给与者','',''],['给予','',''],['给事','',''],['给于','',''],['给人','',''],['给以','',''],['给你点颜色看看','',''],['给做','',''],['给养','',''],['给出','',''],['给力','',''],['给定','',''],['给水','',''],['给水保障','',''],['给水器材','',''],['给物','',''],['给用户','',''],['给穿','',''],['给药','',''],['给足','',''],['绚丽','',''],['绚丽多姿','',''],['绚丽多彩','',''],['绚烂','',''],['绛紫','',''],['络丝','',''],['络合','',''],['络合物','',''],['络子','',''],['络状','',''],['络盐','',''],['络线','',''],['络绎','',''],['络绎不绝','',''],['络腮','',''],['络腮胡子','',''],['络酸盐','',''],['绝不','',''],['绝不会','',''],['绝不止于此','',''],['绝不食言','',''],['绝世','',''],['绝世佳人','',''],['绝世出尘','',''],['绝世无伦','',''],['绝世无双','',''],['绝世独立','',''],['绝世超伦','',''],['绝了','',''],['绝交','',''],['绝产','',''],['绝人','',''],['绝仁弃义','',''],['绝代','',''],['绝代佳人','',''],['绝伦','',''],['绝作','',''],['绝佳','',''],['绝俗离世','',''],['绝倒','',''],['绝口','',''],['绝口不提','',''],['绝口不道','',''],['绝句','',''],['绝后','',''],['绝后光前','',''],['绝命','',''],['绝命书','',''],['绝品','',''],['绝响','',''],['绝唱','',''],['绝嗣','',''],['绝国殊俗','',''],['绝圣弃智','',''],['绝地','',''],['绝域','',''],['绝域异方','',''],['绝域殊方','',''],['绝境','',''],['绝壁','',''],['绝处逢生','',''],['绝大','',''],['绝大多数','',''],['绝大多数人','',''],['绝大部分','',''],['绝妙','',''],['绝妙好辞','',''],['绝子绝孙','',''],['绝学','',''],['绝密','',''],['绝密件','',''],['绝密文件','',''],['绝对','',''],['绝对主义','',''],['绝对值','',''],['绝对化','',''],['绝对命令','',''],['绝对唯心主义','',''],['绝对地址','',''],['绝对地租','',''],['绝对大多数','',''],['绝对平均主义','',''],['绝对性','',''],['绝对数','',''],['绝对数字','',''],['绝对民主','',''],['绝对温度','',''],['绝对温标','',''],['绝对湿度','',''],['绝对真理','',''],['绝对观念','',''],['绝对误差','',''],['绝对连续','',''],['绝对零度','',''],['绝对高度','',''],['绝少分甘','',''],['绝尘拔俗','',''],['绝径','',''],['绝念','',''],['绝情','',''],['绝户','',''],['绝才','',''],['绝技','',''],['绝招','',''],['绝无','',''],['绝无仅有','',''],['绝无可疑','',''],['绝早','',''],['绝景','',''],['绝望','',''],['绝望的境地','',''],['绝气','',''],['绝法','',''],['绝活','',''],['绝活儿','',''],['绝渡逢舟','',''],['绝灭','',''],['绝热','',''],['绝热漆','',''],['绝然','',''],['绝版','',''],['绝甘分少','',''],['绝症','',''],['绝着','',''],['绝种','',''],['绝笔','',''],['绝等','',''],['绝粒','',''],['绝粮','',''],['绝经','',''],['绝经期','',''],['绝续','',''],['绝缘','',''],['绝缘体','',''],['绝缘子','',''],['绝缘材料','',''],['绝缘漆','',''],['绝缘纸','',''],['绝罚','',''],['绝育','',''],['绝育术','',''],['绝色','',''],['绝色佳人','',''],['绝艺','',''],['绝裾而去','',''],['绝诗','',''],['绝诣','',''],['绝路','',''],['绝迹','',''],['绝配','',''],['绝长继短','',''],['绝长续短','',''],['绝长补短','',''],['绝门儿','',''],['绝非','',''],['绝非易事','',''],['绝顶','',''],['绝顶聪明','',''],['绝食','',''],['绝食抗议','',''],['绞丝','',''],['绞人','',''],['绞刀','',''],['绞刑','',''],['绞刑具','',''],['绞刑架','',''],['绞包针','',''],['绞合','',''],['绞尽脑汁','',''],['绞手','',''],['绞扭','',''],['绞接','',''],['绞杀','',''],['绞杀战','',''],['绞杀者','',''],['绞架','',''],['绞死','',''],['绞痛','',''],['绞盘','',''],['绞盘机','',''],['绞碎','',''],['绞索','',''],['绞绳','',''],['绞缠','',''],['绞缢','',''],['绞肉','',''],['绞肉机','',''],['绞肠痧','',''],['绞脑汁','',''],['绞衣机','',''],['绞起','',''],['绞车','',''],['绞链','',''],['绞首','',''],['统一','',''],['统一体','',''],['统一分配','',''],['统一化','',''],['统一发票','',''],['统一口径','',''],['统一大业','',''],['统一思想','',''],['统一性','',''],['统一战线','',''],['统一战线工作部','',''],['统一战线理论','',''],['统一招生','',''],['统一新罗','',''],['统一标准','',''],['统一码','',''],['统一祖国','',''],['统一组织','',''],['统一经营','',''],['统一者','',''],['统一规划','',''],['统一认识','',''],['统一资源','',''],['统一资源定位','',''],['统一资源定位符','',''],['统一领导','',''],['统借','',''],['统假设','',''],['统共','',''],['统分','',''],['统分结合','',''],['统制','',''],['统化','',''],['统合','',''],['统属','',''],['统帅','',''],['统帅体制','',''],['统帅机构','',''],['统帅部','',''],['统带','',''],['统建','',''],['统御','',''],['统御力','',''],['统感','',''],['统战','',''],['统战部','',''],['统揽','',''],['统摄','',''],['统操','',''],['统支','',''],['统收','',''],['统汉字','',''],['统治','',''],['统治权','',''],['统治者','',''],['统治阶级','',''],['统派','',''],['统独','',''],['统率','',''],['统由','',''],['统称','',''],['统称为','',''],['统稿','',''],['统筹','',''],['统筹兼顾','',''],['统筹学','',''],['统筹安排','',''],['统筹法','',''],['统管','',''],['统统','',''],['统缉','',''],['统编','',''],['统考','',''],['统舱','',''],['统观','',''],['统觉','',''],['统计','',''],['统计分析','',''],['统计员','',''],['统计学','',''],['统计学史','',''],['统计局','',''],['统计工作','',''],['统计指标','',''],['统计数字','',''],['统计数据','',''],['统计法','',''],['统计理论','',''],['统计监督','',''],['统计结果','',''],['统计表','',''],['统计调查','',''],['统计资料','',''],['统记','',''],['统讲','',''],['统货','',''],['统购','',''],['统购派购','',''],['统购统销','',''],['统辖','',''],['统还','',''],['统选','',''],['统通','',''],['统配','',''],['统铺','',''],['统销','',''],['统靴','',''],['统领','',''],['统驭','',''],['绠短汲深','',''],['绢丝','',''],['绢人','',''],['绢印','',''],['绢子','',''],['绢布','',''],['绢本','',''],['绢纺','',''],['绢绸','',''],['绢花','',''],['绣像','',''],['绣口锦心','',''],['绣品','',''],['绣墩','',''],['绣墩草','',''],['绣帷','',''],['绣房','',''],['绣法','',''],['绣球','',''],['绣球花','',''],['绣球藤','',''],['绣球风','',''],['绣花','',''],['绣花枕头','',''],['绣花鞋','',''],['绣虎雕龙','',''],['绣衣','',''],['绣边','',''],['绣鞋','',''],['绥化地区','',''],['绥远','',''],['绥远省','',''],['绥靖','',''],['绥靖主义','',''],['绥靖政策','',''],['绦子','',''],['绦带','',''],['绦纶','',''],['绦虫','',''],['绦虫病','',''],['绦虫纲','',''],['继业','',''],['继之','',''],['继亲','',''],['继任','',''],['继任者','',''],['继位','',''],['继发','',''],['继发性','',''],['继嗣','',''],['继天立极','',''],['继女','',''],['继子','',''],['继子女','',''],['继室','',''],['继往','',''],['继往开来','',''],['继志述事','',''],['继承','',''],['继承人','',''],['继承性','',''],['继承权','',''],['继承法','',''],['继承物','',''],['继承者','',''],['继承衣钵','',''],['继晷焚膏','',''],['继武','',''],['继母','',''],['继父','',''],['继父母','',''],['继电器','',''],['继绝兴亡','',''],['继绝存亡','',''],['继绝扶倾','',''],['继续','',''],['继续性','',''],['继续走','',''],['继续革命','',''],['继而','',''],['继起','',''],['继踵而至','',''],['继进','',''],['继配','',''],['绩效','',''],['绩效不彰','',''],['绪上','',''],['绪言','',''],['绪论','',''],['绪语','',''],['绫子','',''],['绫绢','',''],['绫罗','',''],['续书','',''],['续任','',''],['续保','',''],['续借','',''],['续假','',''],['续前','',''],['续加','',''],['续发感染','',''],['续后','',''],['续和','',''],['续增','',''],['续娶','',''],['续存','',''],['续完','',''],['续局','',''],['续建','',''],['续弦','',''],['续报','',''],['续教','',''],['续文','',''],['续断','',''],['续期','',''],['续杯','',''],['续流','',''],['续版','',''],['续租','',''],['续签','',''],['续篇','',''],['续约','',''],['续续','',''],['续编','',''],['续聘','',''],['续航','',''],['续航力','',''],['续行','',''],['续表','',''],['续西游记','',''],['续订','',''],['续貂','',''],['续跌','',''],['续集','',''],['续革','',''],['续音','',''],['绮丽','',''],['绮云','',''],['绮井','',''],['绮室','',''],['绮岁','',''],['绮年','',''],['绮思','',''],['绮想','',''],['绮想曲','',''],['绮梦','',''],['绮灿','',''],['绮窗','',''],['绮筵','',''],['绮绣','',''],['绮罗','',''],['绮罗粉黛','',''],['绮色佳','',''],['绮衣','',''],['绮襦纨绔','',''],['绮语','',''],['绮貌','',''],['绮陌','',''],['绮靡','',''],['绯红','',''],['绯色新闻','',''],['绯闻','',''],['绰号','',''],['绰敬','',''],['绰有余裕','',''],['绰约','',''],['绰约多姿','',''],['绰绰','',''],['绰绰有余','',''],['绰绰有裕','',''],['绲边','',''],['绳之以法','',''],['绳儿','',''],['绳其祖武','',''],['绳厥祖武','',''],['绳墨','',''],['绳墨之言','',''],['绳套','',''],['绳子','',''],['绳带','',''],['绳床','',''],['绳床瓦灶','',''],['绳愆纠缪','',''],['绳愆纠谬','',''],['绳技','',''],['绳文','',''],['绳杆','',''],['绳枢之士','',''],['绳枢之子','',''],['绳栓','',''],['绳梯','',''],['绳环','',''],['绳索','',''],['绳索套','',''],['绳线','',''],['绳绑','',''],['绳结','',''],['绳网','',''],['绳趋尺步','',''],['绳锯木断','',''],['维也纳','',''],['维也纳会议','',''],['维京人','',''],['维他命','',''],['维修','',''],['维修保养','',''],['维修区','',''],['维修服务','',''],['维修部','',''],['维克多・雨果','',''],['维克托','',''],['维吉尔','',''],['维吉尼亚','',''],['维吾尔','',''],['维吾尔人','',''],['维吾尔语','',''],['维和','',''],['维和部队','',''],['维基','',''],['维基媒体基金会','',''],['维基数据','',''],['维基物种','',''],['维基词典','',''],['维多利亚','',''],['维多利亚公园','',''],['维多利亚女王','',''],['维多利亚岛','',''],['维多利亚州','',''],['维多利亚港','',''],['维多利亚湖','',''],['维多利亚瀑布','',''],['维奇','',''],['维妙维肖','',''],['维它命','',''],['维尔容','',''],['维尔斯特拉斯','',''],['维尔纽斯','',''],['维尼熊','',''],['维尼纶','',''],['维度','',''],['维德角','',''],['维恩图解','',''],['维扬','',''],['维护','',''],['维护世界和平','',''],['维护和平','',''],['维护好','',''],['维护者','',''],['维拉','',''],['维持','',''],['维持会','',''],['维持原判','',''],['维持生活','',''],['维持秩序','',''],['维持费','',''],['维数','',''],['维文','',''],['维新','',''],['维新变法','',''],['维新派','',''],['维族','',''],['维权','',''],['维权人士','',''],['维棉布','',''],['维港','',''],['维特','',''],['维特根斯坦','',''],['维珍','',''],['维生','',''],['维生素','',''],['维管','',''],['维管束','',''],['维管束植物','',''],['维管柱','',''],['维系','',''],['维纳斯','',''],['维纶','',''],['维罗纳','',''],['维艰','',''],['维萨','',''],['维西县','',''],['维谷','',''],['维达','',''],['维面','',''],['绵亘','',''],['绵力','',''],['绵力薄材','',''],['绵子','',''],['绵密','',''],['绵延','',''],['绵延不绝','',''],['绵延起伏','',''],['绵惙','',''],['绵白糖','',''],['绵竹县','',''],['绵纸','',''],['绵绵','',''],['绵绵不息','',''],['绵绵不绝','',''],['绵绵瓜瓞','',''],['绵绸','',''],['绵羊','',''],['绵联','',''],['绵薄','',''],['绵裹秤锤','',''],['绵软','',''],['绵远','',''],['绵邈','',''],['绵里藏针','',''],['绵长','',''],['绵阳地区','',''],['绵马','',''],['绶带','',''],['绶带鸟','',''],['绷住','',''],['绷场面','',''],['绷子','',''],['绷巴吊拷','',''],['绷带','',''],['绷床','',''],['绷开','',''],['绷得','',''],['绷扒吊拷','',''],['绷瓷','',''],['绷直','',''],['绷着脸','',''],['绷簧','',''],['绷紧','',''],['绷脸','',''],['绷著脸','',''],['绸丝','',''],['绸伞','',''],['绸子','',''],['绸布','',''],['绸纹纸','',''],['绸缎','',''],['绸缪','',''],['绸舞','',''],['绸锻','',''],['综上','',''],['综上所述','',''],['综丝','',''],['综合','',''],['综合业务数字网','',''],['综合体','',''],['综合分析','',''],['综合利用','',''],['综合叙述','',''],['综合商店','',''],['综合国力','',''],['综合大学','',''],['综合奖','',''],['综合布线','',''],['综合平衡','',''],['综合开发','',''],['综合征','',''],['综合性','',''],['综合报导','',''],['综合报道','',''],['综合服务数位网络','',''],['综合法','',''],['综合疗法','',''],['综合症','',''],['综合研究','',''],['综合经营','',''],['综合者','',''],['综合艺术','',''],['综合语','',''],['综合防治','',''],['综括','',''],['综效','',''],['综析','',''],['综艺','',''],['综艺大观','',''],['综艺节目','',''],['综观','',''],['综览','',''],['综计','',''],['综述','',''],['绽开','',''],['绽放','',''],['绽破','',''],['绽线','',''],['绽裂','',''],['绽露','',''],['绾带','',''],['绾毂','',''],['绿党','',''],['绿内障','',''],['绿化','',''],['绿化祖国','',''],['绿区','',''],['绿卡','',''],['绿叶','',''],['绿叶成荫','',''],['绿叶类蔬菜','',''],['绿园','',''],['绿地','',''],['绿坝','',''],['绿坝・花季护航','',''],['绿头','',''],['绿头巾','',''],['绿头鸭','',''],['绿女红男','',''],['绿宝石','',''],['绿岛','',''],['绿岛乡','',''],['绿带区','',''],['绿帽','',''],['绿帽子','',''],['绿惨红愁','',''],['绿意','',''],['绿旗兵','',''],['绿暗红稀','',''],['绿松','',''],['绿松石','',''],['绿林','',''],['绿林好汉','',''],['绿林豪客','',''],['绿林起义','',''],['绿柱玉','',''],['绿柱石','',''],['绿树','',''],['绿树成荫','',''],['绿水','',''],['绿水青山','',''],['绿油油','',''],['绿泥石','',''],['绿洲','',''],['绿灯','',''],['绿灰色','',''],['绿玉髓','',''],['绿玛瑙','',''],['绿的','',''],['绿皮','',''],['绿皮书','',''],['绿眼','',''],['绿矾','',''],['绿竹','',''],['绿箭','',''],['绿篱','',''],['绿绿','',''],['绿肥','',''],['绿肥作物','',''],['绿肥红瘦','',''],['绿脓杆菌','',''],['绿色','',''],['绿色和平','',''],['绿色工程','',''],['绿色植物','',''],['绿色革命','',''],['绿色食品','',''],['绿芽','',''],['绿苔','',''],['绿茵','',''],['绿茵场','',''],['绿茵茵','',''],['绿茶','',''],['绿茸茸','',''],['绿草','',''],['绿草如茵','',''],['绿荫','',''],['绿莹莹','',''],['绿菜花','',''],['绿营','',''],['绿营兵','',''],['绿蓝','',''],['绿蔷薇','',''],['绿藻','',''],['绿衣使者','',''],['绿衣黄里','',''],['绿豆','',''],['绿豆蝇','',''],['绿赤杨','',''],['绿野','',''],['绿锈','',''],['绿闪石','',''],['绿阴','',''],['绿雀','',''],['绿霉素','',''],['绿青','',''],['绿鬓朱颜','',''],['缀合','',''],['缀字','',''],['缀字课本','',''],['缀文','',''],['缀文之士','',''],['缀饰','',''],['缄口','',''],['缄口不言','',''],['缄口如瓶','',''],['缄口结舌','',''],['缄封','',''],['缄舌封口','',''],['缄舌结口','',''],['缄舌闭口','',''],['缄言','',''],['缄默','',''],['缅元','',''],['缅因','',''],['缅因州','',''],['缅怀','',''],['缅想','',''],['缅文','',''],['缅甸人','',''],['缅甸币','',''],['缅甸联邦','',''],['缅甸语','',''],['缅茄','',''],['缅语','',''],['缅邈','',''],['缆桩','',''],['缆索','',''],['缆索吊椅','',''],['缆索道','',''],['缆线','',''],['缆绳','',''],['缆车','',''],['缆道','',''],['缉拿','',''],['缉捕','',''],['缉查','',''],['缉毒','',''],['缉毒犬','',''],['缉盗','',''],['缉私','',''],['缉获','',''],['缉访','',''],['缎子','',''],['缎布','',''],['缎带','',''],['缎纹','',''],['缎纹织','',''],['缎织','',''],['缓不济急','',''],['缓交','',''],['缓兵','',''],['缓兵之计','',''],['缓军','',''],['缓冲','',''],['缓冲剂','',''],['缓冲区','',''],['缓冲器','',''],['缓冲国','',''],['缓冲溶液','',''],['缓刑','',''],['缓办','',''],['缓动','',''],['缓发中子','',''],['缓召','',''],['缓和','',''],['缓和剂','',''],['缓和器','',''],['缓和战略','',''],['缓坡','',''],['缓存','',''],['缓建','',''],['缓役','',''],['缓征','',''],['缓急','',''],['缓急相济','',''],['缓急轻重','',''],['缓性','',''],['缓慢','',''],['缓效','',''],['缓期','',''],['缓期付款','',''],['缓步','',''],['缓步代车','',''],['缓气','',''],['缓泄药','',''],['缓流','',''],['缓缓','',''],['缓缓而行','',''],['缓聘','',''],['缓蚀剂','',''],['缓行','',''],['缓解','',''],['缓议','',''],['缓醒','',''],['缓释','',''],['缓量','',''],['缓降','',''],['缓降器','',''],['缓颊','',''],['缔交','',''],['缔构','',''],['缔约','',''],['缔约国','',''],['缔约方','',''],['缔结','',''],['缔缘','',''],['缔造','',''],['缔造者','',''],['缕息仅存','',''],['缕析','',''],['缕缕','',''],['缕花锯','',''],['缕述','',''],['缕陈','',''],['编上','',''],['编为','',''],['编书','',''],['编了','',''],['编余','',''],['编余人员','',''],['编修','',''],['编入','',''],['编内','',''],['编写','',''],['编写者','',''],['编列','',''],['编列预算','',''],['编制','',''],['编剧','',''],['编印','',''],['编发','',''],['编史','',''],['编号','',''],['编后记','',''],['编址','',''],['编外','',''],['编外人员','',''],['编委','',''],['编委会','',''],['编审','',''],['编导','',''],['编席','',''],['编年','',''],['编年体','',''],['编年史','',''],['编录','',''],['编得','',''],['编成','',''],['编报','',''],['编排','',''],['编撰','',''],['编整','',''],['编曲','',''],['编本','',''],['编档','',''],['编次','',''],['编法','',''],['编注','',''],['编派','',''],['编班','',''],['编班考试','',''],['编目','',''],['编码','',''],['编码器','',''],['编码字符集','',''],['编码方案','',''],['编码系统','',''],['编磬','',''],['编程','',''],['编程序','',''],['编篡','',''],['编篡人','',''],['编索','',''],['编紧','',''],['编纂','',''],['编纂委员会','',''],['编练','',''],['编组','',''],['编组站','',''],['编织','',''],['编织品','',''],['编织物','',''],['编结','',''],['编结业','',''],['编缉','',''],['编网','',''],['编者','',''],['编者按','',''],['编者案','',''],['编舞','',''],['编著','',''],['编订','',''],['编订者','',''],['编译','',''],['编译器','',''],['编译家','',''],['编译程序','',''],['编译者','',''],['编辑','',''],['编辑人员','',''],['编辑出版','',''],['编辑器','',''],['编辑室','',''],['编辑家','',''],['编辑工作','',''],['编辑按','',''],['编辑者','',''],['编辑词条','',''],['编辑部','',''],['编进','',''],['编选','',''],['编造','',''],['编造谎言','',''],['编遣','',''],['编钟','',''],['编队','',''],['编集','',''],['缘份','',''],['缘何','',''],['缘分','',''],['缘名失实','',''],['缘情体物','',''],['缘故','',''],['缘文生义','',''],['缘木求鱼','',''],['缘由','',''],['缘簿','',''],['缘薄','',''],['缘薄分浅','',''],['缘说','',''],['缘起','',''],['缘铿命蹇','',''],['缘饰','',''],['缙绅','',''],['缚上','',''],['缚住','',''],['缚带','',''],['缚束','',''],['缚牢','',''],['缚紧','',''],['缚鸡','',''],['缜匝','',''],['缜发','',''],['缜密','',''],['缜润','',''],['缝上','',''],['缝做','',''],['缝制','',''],['缝口','',''],['缝合','',''],['缝合带','',''],['缝合线','',''],['缝好','',''],['缝子','',''],['缝得','',''],['缝成','',''],['缝牢','',''],['缝穷','',''],['缝絍','',''],['缝纫','',''],['缝纫台','',''],['缝纫机','',''],['缝纫箱','',''],['缝纽机','',''],['缝线','',''],['缝缀','',''],['缝编','',''],['缝缝补补','',''],['缝缝连连','',''],['缝衣匠','',''],['缝衣工人','',''],['缝衣针','',''],['缝补','',''],['缝起','',''],['缝边','',''],['缝边者','',''],['缝针','',''],['缝针迹','',''],['缝隙','',''],['缟玛瑙','',''],['缟素','',''],['缠上','',''],['缠丝玛瑙','',''],['缠住','',''],['缠吻','',''],['缠在','',''],['缠头','',''],['缠夹','',''],['缠夹不清','',''],['缠夹二先生','',''],['缠好','',''],['缠悱','',''],['缠手','',''],['缠打','',''],['缠扰','',''],['缠扰不休','',''],['缠斗','',''],['缠着','',''],['缠磨','',''],['缠结','',''],['缠绕','',''],['缠绕器','',''],['缠绕茎','',''],['缠络','',''],['缠绵','',''],['缠绵悱恻','',''],['缠脚','',''],['缠裹','',''],['缠足','',''],['缠身','',''],['缢杀','',''],['缢死','',''],['缢颈','',''],['缣帛','',''],['缤纷','',''],['缥渺','',''],['缥缈','',''],['缧绁','',''],['缨子','',''],['缨帽','',''],['缨络','',''],['缨花','',''],['缩为','',''],['缩写','',''],['缩写式','',''],['缩减','',''],['缩减者','',''],['缩到','',''],['缩力','',''],['缩印','',''],['缩印本','',''],['缩合','',''],['缩回','',''],['缩图','',''],['缩在','',''],['缩地补天','',''],['缩多氨酸','',''],['缩头','',''],['缩头缩脑','',''],['缩头缩脚','',''],['缩孔','',''],['缩小','',''],['缩小模型','',''],['缩尺','',''],['缩尾','',''],['缩屋称贞','',''],['缩影','',''],['缩微','',''],['缩微图书','',''],['缩微工作','',''],['缩微本','',''],['缩性','',''],['缩成','',''],['缩成一团','',''],['缩手','',''],['缩手旁观','',''],['缩手缩脚','',''],['缩排','',''],['缩支','',''],['缩放','',''],['缩放仪','',''],['缩时','',''],['缩时摄影','',''],['缩比','',''],['缩氨酸','',''],['缩水','',''],['缩状','',''],['缩略','',''],['缩略字','',''],['缩略词','',''],['缩略语','',''],['缩着','',''],['缩瞳症','',''],['缩短','',''],['缩砂密','',''],['缩简','',''],['缩紧','',''],['缩约','',''],['缩编','',''],['缩缩','',''],['缩聚','',''],['缩聚反应','',''],['缩肌','',''],['缩胸','',''],['缩衣节口','',''],['缩衣节食','',''],['缩起','',''],['缩进','',''],['缪以千里','',''],['缪司','',''],['缪巧','',''],['缪悠之说','',''],['缪托知己','',''],['缪采虚声','',''],['缫丝','',''],['缬氨酸','',''],['缬草','',''],['缭乱','',''],['缭绕','',''],['缮写','',''],['缮发','',''],['缮清','',''],['缮甲厉兵','',''],['缮甲治兵','',''],['缰绳','',''],['缱绻','',''],['缳首','',''],['缴交','',''],['缴付','',''],['缴入','',''],['缴公','',''],['缴出','',''],['缴卷','',''],['缴卸','',''],['缴售','',''],['缴回','',''],['缴存','',''],['缴属','',''],['缴掉','',''],['缴枪','',''],['缴枪不杀','',''],['缴械','',''],['缴械投降','',''],['缴款','',''],['缴毁','',''],['缴清','',''],['缴满','',''],['缴租','',''],['缴税','',''],['缴纳','',''],['缴给','',''],['缴获','',''],['缴裹儿','',''],['缴费','',''],['缴过','',''],['缴销','',''],['缴齐','',''],['缵不可能的事','',''],['缸体','',''],['缸子','',''],['缸瓦','',''],['缸盆','',''],['缸盖','',''],['缸砖','',''],['缸管','',''],['缸里','',''],['缺一','',''],['缺乏','',''],['缺乏症','',''],['缺乏著','',''],['缺刻','',''],['缺勤','',''],['缺医少药','',''],['缺口','',''],['缺员','',''],['缺嘴','',''],['缺失','',''],['缺少','',''],['缺席','',''],['缺席者','',''],['缺德','',''],['缺德事','',''],['缺德鬼','',''],['缺心少肺','',''],['缺心眼','',''],['缺心眼儿','',''],['缺憾','',''],['缺损','',''],['缺料','',''],['缺斤少两','',''],['缺斤短两','',''],['缺月再圆','',''],['缺欠','',''],['缺氧','',''],['缺氧症','',''],['缺水','',''],['缺油','',''],['缺漏','',''],['缺点','',''],['缺略','',''],['缺疑','',''],['缺省','',''],['缺粮','',''],['缺编','',''],['缺考','',''],['缺血','',''],['缺衣少食','',''],['缺词','',''],['缺课','',''],['缺货','',''],['缺量','',''],['缺钱','',''],['缺门','',''],['缺陷','',''],['缺面','',''],['缺项','',''],['缺额','',''],['缺食无衣','',''],['罂子桐','',''],['罂粟','',''],['罂粟种子','',''],['罂粟科','',''],['罄匮','',''],['罄尽','',''],['罄然','',''],['罄竭','',''],['罄竹难书','',''],['罄笔难书','',''],['罄身','',''],['罄身儿','',''],['罅漏','',''],['罅隙','',''],['罐儿','',''],['罐头','',''],['罐头装','',''],['罐头起子','',''],['罐头食品','',''],['罐子','',''],['罐盖','',''],['罐笼','',''],['罐罐','',''],['罐装','',''],['罐车','',''],['网上','',''],['网上广播','',''],['网中','',''],['网人','',''],['网住','',''],['网儿','',''],['网兜','',''],['网兰','',''],['网关','',''],['网内','',''],['网制','',''],['网区','',''],['网卡','',''],['网友','',''],['网名','',''],['网吧','',''],['网员','',''],['网咖','',''],['网址','',''],['网套','',''],['网子','',''],['网孔','',''],['网屏','',''],['网巾','',''],['网布','',''],['网师园','',''],['网底','',''],['网店','',''],['网开一面','',''],['网开三面','',''],['网志','',''],['网恋','',''],['网捕','',''],['网捞','',''],['网族','',''],['网景','',''],['网杓','',''],['网板','',''],['网架','',''],['网格','',''],['网格线','',''],['网桥','',''],['网段','',''],['网民','',''],['网游','',''],['网漏吞舟','',''],['网点','',''],['网片','',''],['网特','',''],['网状','',''],['网状物','',''],['网状脉','',''],['网球','',''],['网球场','',''],['网球赛','',''],['网瘾','',''],['网皮','',''],['网盘','',''],['网眼','',''],['网禁','',''],['网站','',''],['网管','',''],['网管员','',''],['网管接口','',''],['网管系统','',''],['网箱','',''],['网篮','',''],['网纲','',''],['网纹','',''],['网线','',''],['网络','',''],['网络会所','',''],['网络俚语','',''],['网络化','',''],['网络协议','',''],['网络客','',''],['网络层','',''],['网络层协议','',''],['网络广告','',''],['网络应用','',''],['网络成瘾','',''],['网络打印机','',''],['网络技术','',''],['网络操作系统','',''],['网络日记','',''],['网络欺诈','',''],['网络浏览器','',''],['网络特工','',''],['网络环境','',''],['网络理论','',''],['网络用语','',''],['网络直径','',''],['网络科技','',''],['网络空间','',''],['网络管理','',''],['网络管理员','',''],['网络管理系统','',''],['网络规划人员','',''],['网络设备','',''],['网络设计','',''],['网络语言','',''],['网络语音','',''],['网络资源','',''],['网络迁移','',''],['网络铁路','',''],['网网','',''],['网罗','',''],['网罟座','',''],['网聚','',''],['网膜','',''],['网膜状','',''],['网虫','',''],['网蝽','',''],['网袋','',''],['网语','',''],['网购','',''],['网路','',''],['网路作业系统','',''],['网路平台','',''],['网路应用','',''],['网路服务','',''],['网路架构','',''],['网路特务','',''],['网路环境','',''],['网路节点','',''],['网路节点介面','',''],['网路费','',''],['网路链接层','',''],['网银','',''],['网际','',''],['网际协定','',''],['网际电话','',''],['网际网络','',''],['网际网路','',''],['网际网路协会','',''],['网际色情','',''],['网页','',''],['网页地址','',''],['网页设计','',''],['罔上虐下','',''],['罔知所措','',''],['罕事','',''],['罕到','',''],['罕有','',''],['罕物','',''],['罕用','',''],['罕至','',''],['罕见','',''],['罕觏','',''],['罕譬而喻','',''],['罕闻','',''],['罗一秀','',''],['罗世昌','',''],['罗东','',''],['罗东镇','',''],['罗丹','',''],['罗伦斯','',''],['罗伯斯庇尔','',''],['罗伯特','',''],['罗伯特・伯恩斯','',''],['罗伯特・佛洛斯特','',''],['罗伯特・路易斯・斯蒂文森','',''],['罗伯茨','',''],['罗伯逊','',''],['罗保铭','',''],['罗兰','',''],['罗切斯特','',''],['罗列','',''],['罗刹','',''],['罗勒','',''],['罗卜','',''],['罗口','',''],['罗哩罗嗦','',''],['罗唆','',''],['罗唣','',''],['罗喉','',''],['罗嗦','',''],['罗嘉良','',''],['罗圈','',''],['罗圈儿','',''],['罗圈儿揖','',''],['罗圈架','',''],['罗圈腿','',''],['罗城','',''],['罗城县','',''],['罗塞塔石碑','',''],['罗夫诺','',''],['罗姆人','',''],['罗姆酒','',''],['罗姗','',''],['罗安达','',''],['罗宋汤','',''],['罗家英','',''],['罗宾','',''],['罗宾汉','',''],['罗宾逊','',''],['罗密欧','',''],['罗密欧与朱丽叶','',''],['罗尔定理','',''],['罗尔斯・罗伊斯','',''],['罗巴切夫斯基','',''],['罗布','',''],['罗布林卡','',''],['罗布泊','',''],['罗布麻','',''],['罗庄','',''],['罗式几何','',''],['罗彻斯特','',''],['罗得岛','',''],['罗得斯岛','',''],['罗德岛','',''],['罗志祥','',''],['罗懋登','',''],['罗拉','',''],['罗拜','',''],['罗掘','',''],['罗掘一空','',''],['罗摩衍那','',''],['罗摩诺索夫','',''],['罗摩诺索夫山脊','',''],['罗文','',''],['罗斯','',''],['罗斯托克','',''],['罗斯托夫','',''],['罗斯涅夫','',''],['罗斯福','',''],['罗曼使','',''],['罗曼史','',''],['罗曼司','',''],['罗曼带克','',''],['罗曼蒂克','',''],['罗曼语族','',''],['罗曼诺','',''],['罗望','',''],['罗杰','',''],['罗杰斯','',''],['罗格','',''],['罗氏','',''],['罗氏几何','',''],['罗水','',''],['罗汉','',''],['罗汉拳','',''],['罗汉果','',''],['罗汉病','',''],['罗汉豆','',''],['罗汉鱼','',''],['罗洁爱尔之','',''],['罗浮宫','',''],['罗浮山','',''],['罗湖','',''],['罗琳','',''],['罗皂','',''],['罗盘','',''],['罗盘度','',''],['罗盘座','',''],['罗盛教','',''],['罗素','',''],['罗索','',''],['罗纳','',''],['罗纳尔多','',''],['罗纳河','',''],['罗纹','',''],['罗织','',''],['罗经','',''],['罗绸','',''],['罗缎','',''],['罗缕纪存','',''],['罗网','',''],['罗致','',''],['罗荣桓','',''],['罗莎','',''],['罗讷河','',''],['罗语','',''],['罗说','',''],['罗贯中','',''],['罗里罗嗦','',''],['罗钳吉网','',''],['罗锅','',''],['罗锅儿','',''],['罗锅儿桥','',''],['罗雀','',''],['罗雀掘鼠','',''],['罗霄山','',''],['罗马','',''],['罗马书','',''],['罗马人','',''],['罗马公教','',''],['罗马化','',''],['罗马字','',''],['罗马字母','',''],['罗马帝国','',''],['罗马教廷','',''],['罗马数字','',''],['罗马法','',''],['罗马诺','',''],['罗马里奥','',''],['罚一劝百','',''],['罚不当罪','',''],['罚了不','',''],['罚俸','',''],['罚则','',''],['罚单','',''],['罚款','',''],['罚没','',''],['罚球','',''],['罚站','',''],['罚落','',''],['罚薪','',''],['罚跪','',''],['罚酒','',''],['罚金','',''],['罚钱','',''],['罚锾','',''],['罡风','',''],['罢了','',''],['罢于奔命','',''],['罢休','',''],['罢免','',''],['罢免权','',''],['罢兵','',''],['罢官','',''],['罢工','',''],['罢工者','',''],['罢市','',''],['罢手','',''],['罢教','',''],['罢职','',''],['罢论','',''],['罢课','',''],['罢黜','',''],['罢黜百家','',''],['罩上','',''],['罩以','',''],['罩住','',''],['罩儿','',''],['罩光漆','',''],['罩入','',''],['罩头','',''],['罩子','',''],['罩成','',''],['罩杯','',''],['罩棚','',''],['罩盖','',''],['罩纱','',''],['罩衣','',''],['罩衫','',''],['罩袍','',''],['罩袖','',''],['罩门','',''],['罩面','',''],['罪上加罪','',''],['罪不容诛','',''],['罪与罚','',''],['罪业深重','',''],['罪人','',''],['罪人不孥','',''],['罪以功除','',''],['罪加一等','',''],['罪名','',''],['罪大恶极','',''],['罪孽','',''],['罪孽深重','',''],['罪尤','',''],['罪当万死','',''],['罪性','',''],['罪恶','',''],['罪恶如山','',''],['罪恶昭彰','',''],['罪恶昭著','',''],['罪恶深重','',''],['罪恶滔天','',''],['罪恶行径','',''],['罪愆','',''],['罪戾','',''],['罪有应得','',''],['罪有攸归','',''],['罪案','',''],['罪汉','',''],['罪深','',''],['罪犯','',''],['罪状','',''],['罪疚','',''],['罪种','',''],['罪莫大焉','',''],['罪行','',''],['罪行累累','',''],['罪证','',''],['罪该','',''],['罪该万死','',''],['罪责','',''],['罪责难逃','',''],['罪过','',''],['罪逆深重','',''],['罪错','',''],['罪魁','',''],['罪魁祸首','',''],['置业','',''],['置中','',''],['置之','',''],['置之不理','',''],['置之不问','',''],['置之不顾','',''],['置之度外','',''],['置之死地','',''],['置之死地而后快','',''],['置之死地而后生','',''],['置之脑后','',''],['置之高阁','',''],['置买','',''],['置于','',''],['置于死地而后快','',''],['置信','',''],['置信区间','',''],['置信域','',''],['置信水平','',''],['置信系数','',''],['置信限','',''],['置入','',''],['置办','',''],['置后','',''],['置喙','',''],['置在','',''],['置地','',''],['置备','',''],['置外','',''],['置换','',''],['置换突变','',''],['置换群','',''],['置换者','',''],['置放','',''],['置放者','',''],['置有关法规于不顾','',''],['置死地而后快','',''],['置水之情','',''],['置水之清','',''],['置浮标','',''],['置疑','',''],['置而不问','',''],['置若罔闻','',''],['置装','',''],['置装费','',''],['置评','',''],['置诸高阁','',''],['置身','',''],['置身事外','',''],['置身于','',''],['置辩','',''],['置锥之地','',''],['置顶','',''],['署于','',''],['署假','',''],['署名','',''],['署期','',''],['署理','',''],['署者','',''],['署长','',''],['罴虎','',''],['罹患','',''],['罹灾','',''],['罹病','',''],['罹祸','',''],['罹难','',''],['羁勒','',''],['羁押','',''],['羁旅','',''],['羁留','',''],['羁縻','',''],['羁绊','',''],['羊乳','',''],['羊产','',''],['羊体嵇心','',''],['羊倌','',''],['羊入虎口','',''],['羊卓错','',''],['羊叫声','',''],['羊圈','',''],['羊场','',''],['羊城','',''],['羊头','',''],['羊头狗肉','',''],['羊奶','',''],['羊工','',''],['羊年','',''],['羊怪','',''],['羊拐','',''],['羊排','',''],['羊枣','',''],['羊栈','',''],['羊栏','',''],['羊桃','',''],['羊毛','',''],['羊毛出在羊身上','',''],['羊毛制','',''],['羊毛商','',''],['羊毛毯','',''],['羊毛状','',''],['羊毛疔','',''],['羊毛皮','',''],['羊毛线','',''],['羊毛脂','',''],['羊毛衫','',''],['羊毛袋','',''],['羊毫','',''],['羊水','',''],['羊水穿刺','',''],['羊油','',''],['羊狠狼贪','',''],['羊男','',''],['羊痒疫','',''],['羊痘','',''],['羊痫风','',''],['羊瘙痒病','',''],['羊瘙痒症','',''],['羊癫风','',''],['羊皮','',''],['羊皮帽','',''],['羊皮纸','',''],['羊皮衣','',''],['羊真孔草','',''],['羊绒','',''],['羊续悬鱼','',''],['羊羔','',''],['羊群','',''],['羊羹','',''],['羊肉','',''],['羊肉串','',''],['羊肉馅','',''],['羊肚儿手巾','',''],['羊肚蕈','',''],['羊肠','',''],['羊肠小径','',''],['羊肠小道','',''],['羊肠鸟道','',''],['羊胡子草','',''],['羊脂','',''],['羊腿','',''],['羊膜','',''],['羊膜穿刺术','',''],['羊落虎口','',''],['羊裘垂钓','',''],['羊角','',''],['羊角包','',''],['羊角村','',''],['羊角疯','',''],['羊角芹','',''],['羊角豆','',''],['羊角面包','',''],['羊角风','',''],['羊触藩篱','',''],['羊质虎皮','',''],['羊踏菜园','',''],['羊踯躅','',''],['羊道','',''],['羊革','',''],['羊驼','',''],['羊齿','',''],['羊齿类','',''],['羌人起义','',''],['羌无故实','',''],['羌活','',''],['羌笛','',''],['羌鹫','',''],['美不美','',''],['美不胜收','',''],['美东时间','',''],['美中','',''],['美中不足','',''],['美丽','',''],['美丽动人','',''],['美丽新世界','',''],['美丽的','',''],['美乃滋酱','',''],['美了','',''],['美事','',''],['美人','',''],['美人蕉','',''],['美人计','',''],['美人迟暮','',''],['美人香草','',''],['美人鱼','',''],['美他沙酮','',''],['美以美','',''],['美传','',''],['美体小铺','',''],['美侨','',''],['美俚','',''],['美元','',''],['美兰','',''],['美其','',''],['美其名曰','',''],['美军','',''],['美冠','',''],['美分','',''],['美利奴羊','',''],['美制','',''],['美加','',''],['美化','',''],['美南部','',''],['美发','',''],['美发师','',''],['美口语','',''],['美名','',''],['美吨','',''],['美味','',''],['美味佳肴','',''],['美味可口','',''],['美善','',''],['美因茨','',''],['美国中央情报局','',''],['美国之音','',''],['美国交会','',''],['美国人','',''],['美国人民','',''],['美国众议院','',''],['美国佬','',''],['美国全国广播公司','',''],['美国兵','',''],['美国军人','',''],['美国化','',''],['美国华人','',''],['美国南北战争','',''],['美国参议院','',''],['美国国会','',''],['美国国务院','',''],['美国国家侦察局','',''],['美国国家航天航空局','',''],['美国国家航空航天局','',''],['美国国徽','',''],['美国国际集团','',''],['美国在线','',''],['美国地质局','',''],['美国地质调查局','',''],['美国存托凭证','',''],['美国宇航局','',''],['美国广播公司','',''],['美国总统','',''],['美国政治','',''],['美国最高法院','',''],['美国有线新闻网','',''],['美国海岸警卫队','',''],['美国独立战争','',''],['美国电话电报公司','',''],['美国联准','',''],['美国联邦储备','',''],['美国联邦航空局','',''],['美国能源部','',''],['美国航空','',''],['美国航空公司','',''],['美国证券交易委员会','',''],['美国资讯交换标准码','',''],['美国运通','',''],['美国陆军部','',''],['美圆','',''],['美奖','',''],['美女','',''],['美女破舌','',''],['美女簪花','',''],['美好','',''],['美好生活','',''],['美如','',''],['美如冠玉','',''],['美妙','',''],['美姑河','',''],['美姿','',''],['美学','',''],['美学家','',''],['美宇航局','',''],['美容','',''],['美容业','',''],['美容女','',''],['美容师','',''],['美容店','',''],['美容手术','',''],['美容觉','',''],['美容院','',''],['美尼尔氏病','',''],['美尼尔氏综合症','',''],['美尼尔病','',''],['美展','',''],['美工','',''],['美差','',''],['美差事','',''],['美式','',''],['美式橄榄球','',''],['美式足球','',''],['美德','',''],['美意','',''],['美意延年','',''],['美感','',''],['美才','',''],['美方','',''],['美日','',''],['美景','',''],['美景良辰','',''],['美智子','',''],['美服','',''],['美朝','',''],['美术','',''],['美术史','',''],['美术品','',''],['美术字','',''],['美术家','',''],['美术片','',''],['美术片儿','',''],['美术界','',''],['美术馆','',''],['美林集团','',''],['美栗','',''],['美梦','',''],['美梦成真','',''],['美棉','',''],['美欧','',''],['美歌','',''],['美死','',''],['美气','',''],['美汁源','',''],['美沙酮','',''],['美泉宫','',''],['美洛昔康','',''],['美洲','',''],['美洲兀鹰','',''],['美洲国家','',''],['美洲国家组织','',''],['美洲国家组织宪章','',''],['美洲大陆','',''],['美洲小鸵','',''],['美洲狮','',''],['美洲虎','',''],['美洲豹','',''],['美洲鸵','',''],['美派','',''],['美浓','',''],['美浓纸','',''],['美浓镇','',''],['美溪','',''],['美滋滋','',''],['美满','',''],['美玉','',''],['美玉无瑕','',''],['美玲','',''],['美甲','',''],['美男破老','',''],['美白','',''],['美的','',''],['美目','',''],['美眄','',''],['美眉','',''],['美瞳','',''],['美石','',''],['美神','',''],['美禄','',''],['美称','',''],['美籍','',''],['美籍华人','',''],['美粒果','',''],['美索不达米亚','',''],['美美','',''],['美联储','',''],['美联社','',''],['美育','',''],['美能达','',''],['美色','',''],['美艳','',''],['美苏','',''],['美英','',''],['美蓝','',''],['美衣玉食','',''],['美西','',''],['美西战争','',''],['美西部','',''],['美观','',''],['美观大方','',''],['美言','',''],['美言不信','',''],['美誉','',''],['美诗','',''],['美谈','',''],['美貌','',''],['美质','',''],['美足球','',''],['美轮美奂','',''],['美酒','',''],['美金','',''],['美钞','',''],['美院','',''],['美颜','',''],['美食','',''],['美食主义','',''],['美食学','',''],['美食家','',''],['美食法','',''],['美食甘寝','',''],['美食者','',''],['美餐','',''],['美饰','',''],['美馔','',''],['羔子','',''],['羔皮','',''],['羔羊','',''],['羔羊皮','',''],['羚牛','',''],['羚羊','',''],['羚羊挂角','',''],['羝羊触藩','',''],['羞与为伍','',''],['羞与哙伍','',''],['羞于启齿','',''],['羞人','',''],['羞人答答','',''],['羞以牛后','',''],['羞口难开','',''],['羞容','',''],['羞得','',''],['羞怯','',''],['羞怯成怒','',''],['羞恶','',''],['羞惭','',''],['羞愤','',''],['羞愧','',''],['羞愧难当','',''],['羞明','',''],['羞死','',''],['羞涩','',''],['羞答答','',''],['羞红','',''],['羞羞答答','',''],['羞耻','',''],['羞色','',''],['羞花','',''],['羞花闭目','',''],['羞赧','',''],['羞辱','',''],['羞辱性','',''],['羞辱者','',''],['羞面见人','',''],['羟基','',''],['羟基丁酸','',''],['羟基磷灰石','',''],['羟自由基','',''],['羡慕','',''],['群件','',''],['群众','',''],['群众关系','',''],['群众化','',''],['群众团体','',''],['群众大会','',''],['群众性','',''],['群众文艺','',''],['群众组织','',''],['群众观点','',''],['群众路线','',''],['群众运动','',''],['群体','',''],['群体中','',''],['群体性事件','',''],['群体管理','',''],['群像','',''],['群力','',''],['群口词','',''],['群口铄金','',''],['群婚','',''],['群子弹','',''],['群射','',''],['群居','',''],['群居和一','',''],['群居性','',''],['群居穴处','',''],['群居终日言不及义','',''],['群山','',''],['群岛','',''],['群岛弧','',''],['群峰','',''],['群情','',''],['群情振奋','',''],['群星','',''],['群架','',''],['群栖','',''],['群殴','',''],['群氓','',''],['群猴猴族','',''],['群策','',''],['群策群力','',''],['群系','',''],['群组','',''],['群而不党','',''],['群聚','',''],['群育','',''],['群臣','',''],['群花','',''],['群芳','',''],['群芳争妍','',''],['群英','',''],['群英会','',''],['群英毕集','',''],['群落','',''],['群蚁溃堤','',''],['群袭','',''],['群言','',''],['群言堂','',''],['群论','',''],['群谋','',''],['群贤','',''],['群贤毕至','',''],['群起','',''],['群起而攻之','',''],['群轻折轴','',''],['群雄','',''],['群雄逐鹿','',''],['群集','',''],['群雌粥粥','',''],['群青','',''],['群飞','',''],['群马县','',''],['群魔','',''],['群魔乱舞','',''],['群魔般','',''],['群鸟','',''],['群龙无首','',''],['羧基','',''],['羧基酸','',''],['羧甲司坦','',''],['羧酸','',''],['羯族','',''],['羯羊','',''],['羯胡','',''],['羯鼓','',''],['羯鼓催花','',''],['羰基','',''],['羲皇上人','',''],['羸弱','',''],['羹匙','',''],['羹汤','',''],['羹藜含糗','',''],['羹藜唅糗','',''],['羼杂','',''],['羼水','',''],['羽冠','',''],['羽化','',''],['羽化登仙','',''],['羽化飞天','',''],['羽坛','',''],['羽客','',''],['羽扇','',''],['羽扇纶巾','',''],['羽扇豆','',''],['羽林','',''],['羽檄交驰','',''],['羽檄飞驰','',''],['羽毛','',''],['羽毛丰满','',''],['羽毛未丰','',''],['羽毛状','',''],['羽毛球','',''],['羽毛球场','',''],['羽毛球运动','',''],['羽毛笔','',''],['羽毛缎','',''],['羽毛被','',''],['羽流','',''],['羽涅','',''],['羽状','',''],['羽状复叶','',''],['羽球','',''],['羽田','',''],['羽纱','',''],['羽绒','',''],['羽绒服','',''],['羽绒衫','',''],['羽缎','',''],['羽翮已就','',''],['羽翮飞肉','',''],['羽翼','',''],['羽翼丰满','',''],['羽翼已成','',''],['羽茎','',''],['羽衣','',''],['羽衣甘蓝','',''],['羽裂','',''],['羽蹈烈火','',''],['羽量级','',''],['羽鳃鲐','',''],['翁仲','',''],['翁声','',''],['翁婿','',''],['翁安县','',''],['翁山','',''],['翁山苏姬','',''],['翁牛特','',''],['翅子','',''],['翅展','',''],['翅果','',''],['翅汤','',''],['翅片','',''],['翅状','',''],['翅脉','',''],['翅膀','',''],['翅鞘','',''],['翌年','',''],['翌日','',''],['翌晨','',''],['翎子','',''],['翎毛','',''],['翔凤','',''],['翔回','',''],['翔安','',''],['翔实','',''],['翕动','',''],['翕张','',''],['翕然','',''],['翘二郎腿','',''],['翘企','',''],['翘嘴','',''],['翘尾','',''],['翘尾巴','',''],['翘居群首','',''],['翘拇指','',''],['翘曲','',''],['翘望','',''],['翘材','',''],['翘板','',''],['翘棱','',''],['翘楚','',''],['翘盼','',''],['翘着','',''],['翘硬','',''],['翘翘板','',''],['翘舌音','',''],['翘课','',''],['翘起','',''],['翘足','',''],['翘足引领','',''],['翘足而待','',''],['翘辫','',''],['翘辫子','',''],['翘首','',''],['翘首以待','',''],['翘首企足','',''],['翘首引源','',''],['翘首引领','',''],['翟志刚','',''],['翟理斯','',''],['翠冠玉','',''],['翠岗','',''],['翠峦','',''],['翠巧','',''],['翠微','',''],['翠柏','',''],['翠淆红减','',''],['翠玉','',''],['翠竹','',''],['翠绿','',''],['翠绿色','',''],['翠英','',''],['翠莲','',''],['翠菊','',''],['翠青蛇','',''],['翠鸟','',''],['翡翠','',''],['翩然','',''],['翩然而飞','',''],['翩然而至','',''],['翩翩','',''],['翩翩起舞','',''],['翩若惊鸿','',''],['翩跹','',''],['翰墨','',''],['翰林','',''],['翰林学士','',''],['翰林院','',''],['翱翔','',''],['翳眼','',''],['翻一番','',''],['翻两番','',''],['翻书','',''],['翻了','',''],['翻了一番','',''],['翻云覆雨','',''],['翻作','',''],['翻供','',''],['翻修','',''],['翻倒','',''],['翻入','',''],['翻出','',''],['翻到','',''],['翻动','',''],['翻印','',''],['翻卷','',''],['翻去','',''],['翻唇弄舌','',''],['翻唱','',''],['翻嘴','',''],['翻土','',''],['翻地','',''],['翻墙','',''],['翻天','',''],['翻天复地','',''],['翻天覆地','',''],['翻子拳','',''],['翻寻','',''],['翻山','',''],['翻山越岭','',''],['翻工','',''],['翻建','',''],['翻开','',''],['翻弄','',''],['翻录','',''],['翻悔','',''],['翻成','',''],['翻手为云','',''],['翻手为云覆手变雨','',''],['翻手为云覆手雨','',''],['翻找','',''],['翻把','',''],['翻折','',''],['翻拌','',''],['翻拍','',''],['翻拣','',''],['翻掉','',''],['翻掘','',''],['翻搅','',''],['翻新','',''],['翻新后','',''],['翻旧账','',''],['翻晒','',''],['翻本','',''],['翻来','',''],['翻来复去','',''],['翻来覆去','',''],['翻查','',''],['翻案','',''],['翻检','',''],['翻椅','',''],['翻江倒海','',''],['翻沉','',''],['翻沙覆地','',''],['翻浆','',''],['翻涌','',''],['翻滚','',''],['翻炒','',''],['翻然','',''],['翻然悔悟','',''],['翻然改图','',''],['翻版','',''],['翻版碟','',''],['翻牌','',''],['翻番','',''],['翻白眼','',''],['翻皮','',''],['翻盖','',''],['翻看','',''],['翻着','',''],['翻砂','',''],['翻空出奇','',''],['翻筋斗','',''],['翻箱倒柜','',''],['翻箱倒笼','',''],['翻箱倒箧','',''],['翻篇儿','',''],['翻簧','',''],['翻翻','',''],['翻老账','',''],['翻耕','',''],['翻胃','',''],['翻脸','',''],['翻脸不认人','',''],['翻腾','',''],['翻船','',''],['翻花','',''],['翻茬','',''],['翻蔓儿','',''],['翻覆','',''],['翻覆无常','',''],['翻译','',''],['翻译人员','',''],['翻译员','',''],['翻译学','',''],['翻译家','',''],['翻译机','',''],['翻译理论','',''],['翻译者','',''],['翻起','',''],['翻越','',''],['翻跟头','',''],['翻跟斗','',''],['翻路','',''],['翻跳','',''],['翻身','',''],['翻车','',''],['翻车鱼','',''],['翻转','',''],['翻过','',''],['翻过来','',''],['翻造','',''],['翻造品','',''],['翻遍','',''],['翻阅','',''],['翻页','',''],['翻领','',''],['翻飞','',''],['翻黄','',''],['翻黄倒皂','',''],['翼侧','',''],['翼子板','',''],['翼展','',''],['翼形','',''],['翼手目','',''],['翼手龙','',''],['翼状','',''],['翼状物','',''],['翼翼','',''],['翼翼小心','',''],['翼间架','',''],['翼龙','',''],['耀光','',''],['耀县','',''],['耀州','',''],['耀德','',''],['耀斑','',''],['耀武','',''],['耀武扬威','',''],['耀目','',''],['耀眼','',''],['耀祖','',''],['耀祖荣宗','',''],['耀西','',''],['老一代','',''],['老一套','',''],['老一辈','',''],['老丈','',''],['老三','',''],['老三篇','',''],['老不晓事','',''],['老丑','',''],['老两口儿','',''],['老中','',''],['老中青','',''],['老中青三结合','',''],['老乌恰','',''],['老九','',''],['老乡','',''],['老二','',''],['老于世故','',''],['老五','',''],['老井','',''],['老亲','',''],['老人','',''],['老人学','',''],['老人家','',''],['老人星','',''],['老伯','',''],['老伯伯','',''],['老伴','',''],['老伴儿','',''],['老体','',''],['老佛爷','',''],['老侄','',''],['老例','',''],['老俩口','',''],['老修','',''],['老倭瓜','',''],['老僧','',''],['老僧入定','',''],['老儿','',''],['老兄','',''],['老先生','',''],['老光','',''],['老八板','',''],['老八板儿','',''],['老八路','',''],['老八辈子','',''],['老公','',''],['老公公','',''],['老六','',''],['老兵','',''],['老农','',''],['老几','',''],['老到','',''],['老前辈','',''],['老化','',''],['老化酶','',''],['老区','',''],['老千','',''],['老厚','',''],['老去','',''],['老友','',''],['老叔','',''],['老叟','',''],['老古板','',''],['老古董','',''],['老同志','',''],['老君','',''],['老听','',''],['老吾老','',''],['老命','',''],['老哥','',''],['老坏蛋','',''],['老城','',''],['老塘','',''],['老境','',''],['老境堪忧','',''],['老声','',''],['老处女','',''],['老外','',''],['老大','',''],['老大哥','',''],['老大妈','',''],['老大娘','',''],['老大徒伤悲','',''],['老大无成','',''],['老大爷','',''],['老大自居','',''],['老大难','',''],['老天','',''],['老天拔地','',''],['老天爷','',''],['老太','',''],['老太公','',''],['老太太','',''],['老太婆','',''],['老太爷','',''],['老夫','',''],['老夫子','',''],['老头','',''],['老头乐','',''],['老头儿','',''],['老头子','',''],['老套','',''],['老套子','',''],['老女归宗','',''],['老奴','',''],['老奶奶','',''],['老奸巨滑','',''],['老奸巨猾','',''],['老好人','',''],['老妇','',''],['老妇人','',''],['老妈','',''],['老妈子','',''],['老妖','',''],['老妖似','',''],['老妪','',''],['老妪能解','',''],['老姐','',''],['老姑娘','',''],['老姜','',''],['老姥','',''],['老娘','',''],['老婆','',''],['老婆儿','',''],['老婆婆','',''],['老婆子','',''],['老婆孩子热炕头','',''],['老婆当军','',''],['老婆舌头','',''],['老媪','',''],['老子','',''],['老子婆娑','',''],['老字号','',''],['老宋体','',''],['老实','',''],['老实人','',''],['老实巴交','',''],['老实说','',''],['老客','',''],['老客儿','',''],['老家','',''],['老家儿','',''],['老家贼','',''],['老将','',''],['老小','',''],['老少','',''],['老少咸宜','',''],['老少无欺','',''],['老少皆宜','',''],['老少边穷','',''],['老山','',''],['老山自行车馆','',''],['老巢','',''],['老帅','',''],['老师','',''],['老师傅','',''],['老师宿儒','',''],['老帐','',''],['老干部','',''],['老年','',''],['老年人','',''],['老年学','',''],['老年性痴呆症','',''],['老年期','',''],['老年痴呆','',''],['老年痴呆症','',''],['老年间','',''],['老年黑格尔派','',''],['老幺','',''],['老幼','',''],['老庄','',''],['老庄学派','',''],['老底','',''],['老店','',''],['老式','',''],['老弗大','',''],['老弟','',''],['老张','',''],['老弦','',''],['老弱','',''],['老弱残兵','',''],['老弱病残','',''],['老当','',''],['老当益壮','',''],['老态','',''],['老态龙钟','',''],['老态龙锺','',''],['老总','',''],['老成','',''],['老成之见','',''],['老成持重','',''],['老成练达','',''],['老成见到','',''],['老战友','',''],['老战士','',''],['老手','',''],['老抽','',''],['老拙','',''],['老拳','',''],['老挝人','',''],['老掉牙','',''],['老搭挡','',''],['老搭档','',''],['老教师','',''],['老旦','',''],['老旧','',''],['老早','',''],['老是','',''],['老是往','',''],['老景','',''],['老有所为','',''],['老有所乐','',''],['老有所终','',''],['老朋友','',''],['老本','',''],['老朽','',''],['老李','',''],['老来','',''],['老来俏','',''],['老来少','',''],['老板','',''],['老板娘','',''],['老林','',''],['老枪','',''],['老树','',''],['老样','',''],['老样子','',''],['老根','',''],['老根据地','',''],['老框框','',''],['老死','',''],['老死不相往来','',''],['老死沟壑','',''],['老死牖下','',''],['老残','',''],['老残游记','',''],['老母','',''],['老毛病','',''],['老气','',''],['老气横秋','',''],['老水手','',''],['老汉','',''],['老江湖','',''],['老汤','',''],['老油子','',''],['老油条','',''],['老泪','',''],['老泪纵横','',''],['老派','',''],['老火','',''],['老烟枪','',''],['老烟鬼','',''],['老熊当道','',''],['老父','',''],['老爷','',''],['老爷子','',''],['老爷岭','',''],['老爷爷','',''],['老爷车','',''],['老爸','',''],['老爹','',''],['老牌','',''],['老牛','',''],['老牛吃嫩草','',''],['老牛拉破车','',''],['老牛破车','',''],['老牛舐犊','',''],['老狐狸','',''],['老玉米','',''],['老王','',''],['老王卖瓜','',''],['老生','',''],['老生常谈','',''],['老用户','',''],['老病','',''],['老百姓','',''],['老的','',''],['老皇历','',''],['老相','',''],['老相识','',''],['老眼','',''],['老眼光','',''],['老眼昏花','',''],['老着脸','',''],['老着脸皮','',''],['老祖','',''],['老祖宗','',''],['老神在在','',''],['老窝','',''],['老童','',''],['老等','',''],['老米','',''],['老粗','',''],['老糊涂','',''],['老红军','',''],['老练','',''],['老练兵','',''],['老罴当道','',''],['老美','',''],['老羞','',''],['老羞变怒','',''],['老羞成怒','',''],['老翁','',''],['老老','',''],['老老大大','',''],['老老实实','',''],['老老少少','',''],['老耄','',''],['老者','',''],['老而','',''],['老而不死是为贼','',''],['老而益壮','',''],['老脸','',''],['老腌儿','',''],['老腌瓜','',''],['老舍','',''],['老花','',''],['老花眼','',''],['老花镜','',''],['老茧','',''],['老莱娱亲','',''],['老营','',''],['老著','',''],['老蔫','',''],['老虎','',''],['老虎伍兹','',''],['老虎凳','',''],['老虎头上扑苍蝇','',''],['老虎头上打苍蝇','',''],['老虎机','',''],['老虎灶','',''],['老虎菜','',''],['老虎钳','',''],['老蚌生珠','',''],['老街','',''],['老表','',''],['老衰','',''],['老衰了','',''],['老衲','',''],['老西','',''],['老规矩','',''],['老视眼','',''],['老话','',''],['老说','',''],['老调','',''],['老调重弹','',''],['老谋','',''],['老谋深算','',''],['老谱','',''],['老豆','',''],['老豆腐','',''],['老财','',''],['老账','',''],['老资格','',''],['老趼','',''],['老路','',''],['老身','',''],['老身长子','',''],['老辈','',''],['老辣','',''],['老边','',''],['老迈','',''],['老迈龙钟','',''],['老远','',''],['老道','',''],['老酒','',''],['老醋','',''],['老金','',''],['老锡儿','',''],['老长','',''],['老院','',''],['老雕','',''],['老顽固','',''],['老饕','',''],['老马','',''],['老马为驹','',''],['老马嘶风','',''],['老马恋栈','',''],['老马识途','',''],['老骥','',''],['老骥伏枥','',''],['老骥嘶风','',''],['老骨头','',''],['老高','',''],['老鱼跳波','',''],['老鸟','',''],['老鸡','',''],['老鸡头','',''],['老鸦','',''],['老鸨','',''],['老鸹','',''],['老鹤成轩','',''],['老鹰','',''],['老鹰星云','',''],['老黄','',''],['老黄牛','',''],['老鼠','',''],['老鼠尾巴','',''],['老鼠拖木锨','',''],['老鼠洞','',''],['老鼠见猫','',''],['老鼠过街','',''],['老鼻子','',''],['老龄','',''],['老龄化','',''],['老龟','',''],['考上','',''],['考中','',''],['考人','',''],['考克斯','',''],['考克斯报告','',''],['考入','',''],['考其原因','',''],['考准','',''],['考分','',''],['考到','',''],['考勤','',''],['考勤制度','',''],['考勤簿','',''],['考区','',''],['考卷','',''],['考取','',''],['考古','',''],['考古学','',''],['考古学家','',''],['考古家','',''],['考名则实','',''],['考场','',''],['考完','',''],['考官','',''],['考察','',''],['考察团','',''],['考察报告','',''],['考察船','',''],['考察队','',''],['考得','',''],['考拉','',''],['考据','',''],['考文垂','',''],['考文垂市','',''],['考期','',''],['考查','',''],['考核','',''],['考核制度','',''],['考核成绩','',''],['考波什堡','',''],['考生','',''],['考研','',''],['考种','',''],['考究','',''],['考级','',''],['考绩','',''],['考绩幽明','',''],['考绩黜陟','',''],['考茨基主义','',''],['考虑','',''],['考虑不周','',''],['考虑到','',''],['考虑周到','',''],['考虑过','',''],['考订','',''],['考证','',''],['考评','',''],['考试','',''],['考试制度','',''],['考试卷','',''],['考试卷子','',''],['考试学','',''],['考试者','',''],['考试院','',''],['考语','',''],['考进','',''],['考释','',''],['考量','',''],['考问','',''],['考题','',''],['考验','',''],['耄倪','',''],['耄思','',''],['耄期','',''],['耄耋','',''],['耄耋之年','',''],['耄龄','',''],['者也之乎','',''],['耆儒硕德','',''],['耆儒硕望','',''],['耆儒硕老','',''],['耆年硕德','',''],['耆绅','',''],['耆老','',''],['而不需','',''],['而且','',''],['而于','',''],['而今','',''],['而今而后','',''],['而从','',''],['而做又是另外一回事','',''],['而况','',''],['而别','',''],['而又','',''],['而后','',''],['而处','',''],['而已','',''],['而是','',''],['而止','',''],['而知也无涯','',''],['而立','',''],['而立之年','',''],['而胜于蓝','',''],['而至','',''],['而被','',''],['而言','',''],['而达','',''],['而非','',''],['耍嘴皮','',''],['耍嘴皮子','',''],['耍坛子','',''],['耍奸','',''],['耍子','',''],['耍宝','',''],['耍小聪明','',''],['耍弄','',''],['耍得团团转','',''],['耍心眼','',''],['耍心眼儿','',''],['耍态度','',''],['耍把','',''],['耍无赖','',''],['耍派','',''],['耍滑','',''],['耍滑头','',''],['耍狮子','',''],['耍私情','',''],['耍笑','',''],['耍笔杆','',''],['耍笔杆子','',''],['耍耍','',''],['耍脾气','',''],['耍花招','',''],['耍花腔','',''],['耍蛇','',''],['耍贫嘴','',''],['耍赖','',''],['耍钱','',''],['耍闹','',''],['耐久','',''],['耐久力','',''],['耐久性','',''],['耐人','',''],['耐人寻味','',''],['耐住','',''],['耐光','',''],['耐克','',''],['耐力','',''],['耐劳','',''],['耐压','',''],['耐受','',''],['耐受力','',''],['耐受性','',''],['耐变','',''],['耐寒','',''],['耐心','',''],['耐心帮助','',''],['耐性','',''],['耐战','',''],['耐抗','',''],['耐旱','',''],['耐晒','',''],['耐水','',''],['耐水性','',''],['耐洗','',''],['耐洗涤性','',''],['耐火','',''],['耐火土','',''],['耐火材料','',''],['耐火砖','',''],['耐火黏土','',''],['耐烦','',''],['耐烫','',''],['耐热','',''],['耐热合金','',''],['耐用','',''],['耐用品','',''],['耐用消费品','',''],['耐看','',''],['耐着性子','',''],['耐碱','',''],['耐磨','',''],['耐磨性','',''],['耐穿','',''],['耐腐蚀','',''],['耐航','',''],['耐苦','',''],['耐药性','',''],['耐蚀','',''],['耐酸','',''],['耐震','',''],['耐风','',''],['耐风雨','',''],['耐飞','',''],['耐飞性','',''],['耐饥','',''],['耐高温','',''],['耒耜','',''],['耒耜之勤','',''],['耒耨之利','',''],['耒耨之教','',''],['耕作','',''],['耕作制度','',''],['耕作层','',''],['耕具','',''],['耕农','',''],['耕地','',''],['耕地面积','',''],['耕奴','',''],['耕当问奴','',''],['耕战','',''],['耕机','',''],['耕法','',''],['耕牛','',''],['耕犁','',''],['耕田','',''],['耕畜','',''],['耕种','',''],['耕翻','',''],['耕耘','',''],['耕读','',''],['耗光','',''],['耗减','',''],['耗力','',''],['耗去','',''],['耗子','',''],['耗尽','',''],['耗损','',''],['耗损量','',''],['耗掉','',''],['耗散','',''],['耗散结构','',''],['耗料','',''],['耗时','',''],['耗时耗力','',''],['耗气','',''],['耗水','',''],['耗油','',''],['耗油率','',''],['耗油量','',''],['耗热','',''],['耗用','',''],['耗电','',''],['耗电量','',''],['耗竭','',''],['耗粮','',''],['耗能','',''],['耗费','',''],['耗资','',''],['耗量','',''],['耘锄','',''],['耙地','',''],['耙子','',''],['耙犁','',''],['耠子','',''],['耥耙','',''],['耦合','',''],['耦合器','',''],['耦园','',''],['耦居','',''],['耦联晶体管','',''],['耦语','',''],['耧播','',''],['耧车','',''],['耩子','',''],['耳上','',''],['耳下','',''],['耳下腺','',''],['耳光','',''],['耳刮子','',''],['耳力','',''],['耳听','',''],['耳听为虚','',''],['耳听八方','',''],['耳咽管','',''],['耳喻','',''],['耳坠','',''],['耳坠子','',''],['耳垂','',''],['耳垢','',''],['耳塞','',''],['耳声','',''],['耳壳','',''],['耳套','',''],['耳子','',''],['耳孔','',''],['耳尖','',''],['耳屎','',''],['耳屏','',''],['耳廓狐','',''],['耳性','',''],['耳房','',''],['耳报神','',''],['耳挖','',''],['耳挖勺儿','',''],['耳挖子','',''],['耳掴子','',''],['耳提面命','',''],['耳提面训','',''],['耳旁风','',''],['耳朵','',''],['耳朵底子','',''],['耳朵眼儿','',''],['耳朵软','',''],['耳机','',''],['耳染目濡','',''],['耳根','',''],['耳根清净','',''],['耳沉','',''],['耳洞','',''],['耳源性','',''],['耳满鼻满','',''],['耳濡目染','',''],['耳炎','',''],['耳熟','',''],['耳熟能详','',''],['耳片','',''],['耳状物','',''],['耳环','',''],['耳生','',''],['耳疾','',''],['耳痛','',''],['耳目','',''],['耳目一新','',''],['耳石','',''],['耳科','',''],['耳科学','',''],['耳穴','',''],['耳红面赤','',''],['耳罩','',''],['耳聋','',''],['耳聋眼花','',''],['耳聪目明','',''],['耳背','',''],['耳膜','',''],['耳草属','',''],['耳药水','',''],['耳蜗','',''],['耳蜡','',''],['耳视目听','',''],['耳视目食','',''],['耳语','',''],['耳语般','',''],['耳轮','',''],['耳软','',''],['耳软心活','',''],['耳边','',''],['耳边风','',''],['耳部','',''],['耳郭','',''],['耳针','',''],['耳针疗法','',''],['耳钉','',''],['耳镜','',''],['耳门','',''],['耳闻','',''],['耳闻不如一见','',''],['耳闻不如目见','',''],['耳闻目击','',''],['耳闻目睹','',''],['耳闻目见','',''],['耳顺','',''],['耳顺之年','',''],['耳风','',''],['耳食','',''],['耳食之言','',''],['耳食之谈','',''],['耳饰','',''],['耳鬓厮磨','',''],['耳鸣','',''],['耳麦','',''],['耳鼓','',''],['耳鼻','',''],['耳鼻咽喉','',''],['耳鼻喉','',''],['耳鼻喉科','',''],['耵聍','',''],['耶人','',''],['耶利米','',''],['耶利米书','',''],['耶利米哀歌','',''],['耶和','',''],['耶和华','',''],['耶和华见证人','',''],['耶哥尼雅','',''],['耶弗他','',''],['耶律大石','',''],['耶烈万','',''],['耶稣','',''],['耶稣会','',''],['耶稣会士','',''],['耶稣升天节','',''],['耶稣受难节','',''],['耶稣基督','',''],['耶稣基督后期圣徒教会','',''],['耶稣基督末世圣徒教会','',''],['耶稣教','',''],['耶稣降临节','',''],['耶莱娜・扬科维奇','',''],['耶西','',''],['耶诞','',''],['耶诞节','',''],['耶路','',''],['耶路撒冷','',''],['耶酥','',''],['耶酥会','',''],['耶酥会士','',''],['耶鲁','',''],['耶鲁大学','',''],['耷拉','',''],['耸人听闻','',''],['耸入','',''],['耸入云霄','',''],['耸出','',''],['耸动','',''],['耸壑昂霄','',''],['耸现','',''],['耸立','',''],['耸肩','',''],['耸起','',''],['耻居人下','',''],['耻笑','',''],['耻言人过','',''],['耻辱','',''],['耻骂','',''],['耻骨','',''],['耽于','',''],['耽于酒色','',''],['耽心','',''],['耽惊受怕','',''],['耽搁','',''],['耽溺','',''],['耽误','',''],['耽迷','',''],['耽迷肉欲','',''],['耿介','',''],['耿直','',''],['耿耿','',''],['耿耿于心','',''],['耿耿于怀','',''],['耿饼','',''],['耿马县','',''],['聂卫平','',''],['聂耳','',''],['聂聂','',''],['聆取','',''],['聆听','',''],['聆听会','',''],['聆教','',''],['聆讯','',''],['聊且','',''],['聊了','',''],['聊事','',''],['聊以卒岁','',''],['聊以塞责','',''],['聊以自慰','',''],['聊以解嘲','',''],['聊以解闷','',''],['聊叙','',''],['聊城地区','',''],['聊复尔尔','',''],['聊天','',''],['聊天儿','',''],['聊天室','',''],['聊得','',''],['聊斋','',''],['聊斋志异','',''],['聊生','',''],['聊着','',''],['聊聊','',''],['聊胜于无','',''],['聊表','',''],['聊话','',''],['聊赖','',''],['聋了','',''],['聋人','',''],['聋哑','',''],['聋哑人','',''],['聋哑症','',''],['聋哑者','',''],['聋子','',''],['聋得','',''],['聋盲','',''],['聋聩','',''],['职业','',''],['职业上','',''],['职业中学','',''],['职业倦怠症','',''],['职业化','',''],['职业咨询','',''],['职业培训','',''],['职业学校','',''],['职业工会','',''],['职业性','',''],['职业教育','',''],['职业病','',''],['职业素质','',''],['职业辅导','',''],['职业运动员','',''],['职业道德','',''],['职业阶级','',''],['职业高中','',''],['职业高尔夫球协会','',''],['职代会','',''],['职位','',''],['职位高','',''],['职分','',''],['职别','',''],['职前教育','',''],['职务','',''],['职务上','',''],['职务工资','',''],['职务津贴','',''],['职务考核','',''],['职司','',''],['职员','',''],['职场','',''],['职大','',''],['职守','',''],['职官','',''],['职工','',''],['职工代表','',''],['职工代表大会','',''],['职工收入','',''],['职工福利待遇','',''],['职工队伍','',''],['职工食堂','',''],['职志','',''],['职掌','',''],['职数','',''],['职权','',''],['职权范围','',''],['职校','',''],['职涯','',''],['职称','',''],['职称改革','',''],['职称评定','',''],['职级','',''],['职能','',''],['职能部门','',''],['职衔','',''],['职责','',''],['聒噪','',''],['聒耳','',''],['联产','',''],['联产到劳','',''],['联产到户','',''],['联产到组','',''],['联产承包','',''],['联会','',''],['联体别墅','',''],['联俄','',''],['联保','',''],['联兆','',''],['联共','',''],['联军','',''],['联力','',''],['联办','',''],['联动','',''],['联华','',''],['联句','',''],['联合','',''],['联合会','',''],['联合体','',''],['联合作战','',''],['联合公报','',''],['联合军演','',''],['联合制','',''],['联合包裹服务公司','',''],['联合发表','',''],['联合古大陆','',''],['联合国儿童基金会','',''],['联合国大会','',''],['联合国安全理事会','',''],['联合国宪章','',''],['联合国开发计划署','',''],['联合国教科文组织','',''],['联合国气候变化框架公约','',''],['联合国海洋法公约','',''],['联合国环境规划署','',''],['联合国秘书处','',''],['联合国难民事务高级专员办事处','',''],['联合声明','',''],['联合宣言','',''],['联合式合成词','',''],['联合战线','',''],['联合技术公司','',''],['联合报','',''],['联合收割机','',''],['联合政府','',''],['联合机','',''],['联合核事故协调中心','',''],['联合演习','',''],['联合王国','',''],['联合组织','',''],['联合者','',''],['联合自强','',''],['联合航空公司','',''],['联合舰队','',''],['联合行动','',''],['联合通讯社','',''],['联合采煤机','',''],['联同','',''],['联名','',''],['联在','',''],['联大','',''],['联姻','',''],['联婚','',''],['联宗','',''],['联展','',''],['联展联销','',''],['联席','',''],['联席会议','',''],['联席董事','',''],['联建','',''],['联想','',''],['联想学习','',''],['联想起','',''],['联想集团','',''],['联成','',''],['联成一体','',''],['联成一片','',''],['联户','',''],['联手','',''],['联接','',''],['联播','',''],['联数','',''],['联星','',''],['联机','',''],['联机分析处理','',''],['联机帮助','',''],['联机服务','',''],['联机游戏','',''],['联次','',''],['联欢','',''],['联欢会','',''],['联欢性','',''],['联欢晚会','',''],['联欢节','',''],['联氨','',''],['联电','',''],['联盟','',''],['联盟号','',''],['联社','',''],['联票','',''],['联立方程','',''],['联系','',''],['联系业务','',''],['联系人','',''],['联系实际','',''],['联系方式','',''],['联系点','',''],['联系着','',''],['联系群众','',''],['联组','',''],['联结','',''],['联结主义','',''],['联结器','',''],['联络','',''],['联络员','',''],['联络处','',''],['联络小组','',''],['联络性','',''],['联络站','',''],['联络簿','',''],['联络部','',''],['联绵','',''],['联绵不断','',''],['联绵字','',''],['联缀','',''],['联网','',''],['联网环境','',''],['联署','',''],['联翩','',''],['联考','',''],['联航','',''],['联苯','',''],['联苯基','',''],['联营','',''],['联营企业','',''],['联营公司','',''],['联行','',''],['联袂','',''],['联诵','',''],['联调联试','',''],['联谊','',''],['联谊会','',''],['联贯','',''],['联赛','',''],['联轴器','',''],['联轴节','',''],['联运','',''],['联运票','',''],['联通红筹公司','',''],['联邦','',''],['联邦制','',''],['联邦化','',''],['联邦大楼','',''],['联邦州','',''],['联邦德国','',''],['联邦快递','',''],['联邦政府','',''],['联邦电信交通委员会','',''],['联邦紧急措施署','',''],['联邦调查局','',''],['联邦通信委员会','',''],['联销','',''],['联锁','',''],['联锁店','',''],['联队','',''],['联防','',''],['联防区','',''],['联防队','',''],['联音','',''],['聘为','',''],['聘书','',''],['聘任','',''],['聘任制','',''],['聘召','',''],['聘娶婚','',''],['聘期','',''],['聘用','',''],['聘用制','',''],['聘礼','',''],['聘约','',''],['聘请','',''],['聘选','',''],['聘金','',''],['聘问','',''],['聚丙烯','',''],['聚丙烯纤维','',''],['聚丙烯腈纤维','',''],['聚义','',''],['聚乙烯','',''],['聚乙烯塑料','',''],['聚乙烯醇','',''],['聚乙烯醇缩甲醛纤维','',''],['聚众','',''],['聚众斗殴','',''],['聚众赌博','',''],['聚众闹事','',''],['聚伙','',''],['聚会','',''],['聚伞花序','',''],['聚光','',''],['聚光太阳能','',''],['聚光灯','',''],['聚光镜','',''],['聚友','',''],['聚变','',''],['聚变反应','',''],['聚变武器','',''],['聚合','',''],['聚合体','',''],['聚合作用','',''],['聚合反应','',''],['聚合物','',''],['聚合脢','',''],['聚合资讯订阅','',''],['聚合酶','',''],['聚四氟乙烯','',''],['聚四氟乙烯塑料','',''],['聚在一起','',''],['聚头','',''],['聚宝','',''],['聚宝盆','',''],['聚对苯二甲酸乙二酯纤维','',''],['聚居','',''],['聚居地','',''],['聚性','',''],['聚拢','',''],['聚敛','',''],['聚散','',''],['聚晤','',''],['聚歼','',''],['聚氨酯','',''],['聚氯乙烯','',''],['聚沙之年','',''],['聚沙成塔','',''],['聚灯','',''],['聚点','',''],['聚焦','',''],['聚珍版','',''],['聚甲基丙烯酸甲酯塑料','',''],['聚甲醛','',''],['聚矿作用','',''],['聚碳酸酯','',''],['聚积','',''],['聚米为山','',''],['聚精会神','',''],['聚结','',''],['聚结剂','',''],['聚聚','',''],['聚脂','',''],['聚苯乙烯','',''],['聚苯乙烯塑料','',''],['聚萤映雪','',''],['聚萤积雪','',''],['聚落','',''],['聚蚁成雷','',''],['聚议','',''],['聚谈','',''],['聚财','',''],['聚赌','',''],['聚酯','',''],['聚酯树脂','',''],['聚酯纤维','',''],['聚酰亚胺','',''],['聚酰胺','',''],['聚酰胺纤维','',''],['聚集','',''],['聚餐','',''],['聚饮','',''],['聚首','',''],['聚齐','',''],['聪慧','',''],['聪慧过人','',''],['聪敏','',''],['聪明','',''],['聪明人','',''],['聪明伶俐','',''],['聪明反被聪明误','',''],['聪明才智','',''],['聪明绝顶','',''],['聪明能干','',''],['聪明过头','',''],['聪颖','',''],['聪颖过人','',''],['肃北县','',''],['肃反','',''],['肃反运动','',''],['肃坐','',''],['肃州','',''],['肃慎','',''],['肃敬','',''],['肃杀','',''],['肃清','',''],['肃清反革命分子','',''],['肃然','',''],['肃然起敬','',''],['肃穆','',''],['肃立','',''],['肃静','',''],['肄业','',''],['肄业生','',''],['肄业证书','',''],['肆业','',''],['肆力','',''],['肆意','',''],['肆意妄为','',''],['肆意攻击','',''],['肆扰','',''],['肆无忌惮','',''],['肆虐','',''],['肆行','',''],['肆行无忌','',''],['肆行无惮','',''],['肆言如狂','',''],['肆言无忌','',''],['肆言无惮','',''],['肆言植党','',''],['肆言詈辱','',''],['肇事','',''],['肇事人','',''],['肇事者','',''],['肇事逃逸','',''],['肇俊哲','',''],['肇因','',''],['肇始','',''],['肇庆地区','',''],['肇庆大学','',''],['肇建','',''],['肇祸','',''],['肇端','',''],['肉丁','',''],['肉丝','',''],['肉中刺','',''],['肉中刺眼中钉','',''],['肉中毒','',''],['肉丸','',''],['肉价','',''],['肉体','',''],['肉体上','',''],['肉体化','',''],['肉体性','',''],['肉内','',''],['肉冠','',''],['肉冻','',''],['肉刑','',''],['肉制','',''],['肉制品','',''],['肉包','',''],['肉包子打狗','',''],['肉卷','',''],['肉商','',''],['肉嘟嘟','',''],['肉团','',''],['肉块','',''],['肉垂','',''],['肉头','',''],['肉夹馍','',''],['肉孜节','',''],['肉山酒海','',''],['肉峰','',''],['肉干','',''],['肉店','',''],['肉弹','',''],['肉感','',''],['肉排','',''],['肉搏','',''],['肉搏战','',''],['肉末','',''],['肉条','',''],['肉松','',''],['肉林酒池','',''],['肉果','',''],['肉桂','',''],['肉棒','',''],['肉欲','',''],['肉毒杆菌','',''],['肉毒杆菌毒素','',''],['肉毒梭状芽孢杆菌','',''],['肉毒素','',''],['肉汁','',''],['肉汁汤','',''],['肉汤','',''],['肉汤面','',''],['肉沫','',''],['肉片','',''],['肉牛','',''],['肉状','',''],['肉生痰','',''],['肉用','',''],['肉用鸡','',''],['肉畜','',''],['肉痛','',''],['肉瘤','',''],['肉皮','',''],['肉皮儿','',''],['肉眼','',''],['肉眼凡胎','',''],['肉眼图','',''],['肉眼愚眉','',''],['肉眼观察','',''],['肉碱','',''],['肉票','',''],['肉禽','',''],['肉穗花序','',''],['肉类','',''],['肉粽','',''],['肉糜','',''],['肉红','',''],['肉绽','',''],['肉绽皮开','',''],['肉羹','',''],['肉脯','',''],['肉色','',''],['肉芽','',''],['肉苁蓉','',''],['肉蛋','',''],['肉袒','',''],['肉豆','',''],['肉豆蔻','',''],['肉豆蔻料','',''],['肉质','',''],['肉质根','',''],['肉贩','',''],['肉赘','',''],['肉跳心惊','',''],['肉身','',''],['肉酱','',''],['肉酱面','',''],['肉铺','',''],['肉食','',''],['肉食动物','',''],['肉食品','',''],['肉食性','',''],['肉食者鄙','',''],['肉饼','',''],['肉馅','',''],['肉馅饼','',''],['肉馆','',''],['肉骨','',''],['肉鳍','',''],['肉鸡','',''],['肉麻','',''],['肋条','',''],['肋状','',''],['肋肉','',''],['肋肩累足','',''],['肋膜','',''],['肋膜炎','',''],['肋间','',''],['肋间肌','',''],['肋骨','',''],['肋骨状','',''],['肌体','',''],['肌动蛋白','',''],['肌原纤维','',''],['肌无完肤','',''],['肌炎','',''],['肌理','',''],['肌瘤','',''],['肌纤维','',''],['肌纤蛋白','',''],['肌肉','',''],['肌肉发达','',''],['肌肉松弛剂','',''],['肌肉注射','',''],['肌肉组织','',''],['肌肉萎缩症','',''],['肌肤','',''],['肌腱','',''],['肏你妈','',''],['肏屄','',''],['肏蛋','',''],['肏逼','',''],['肐膊','',''],['肓干','',''],['肖伯纳','',''],['肖像','',''],['肖像权','',''],['肖像画','',''],['肖恩','',''],['肖扬','',''],['肖邦','',''],['肘子','',''],['肘挤','',''],['肘推','',''],['肘状物','',''],['肘窝','',''],['肘腋','',''],['肘腋之忧','',''],['肘腋之患','',''],['肘部','',''],['肚儿','',''],['肚兜','',''],['肚喉科','',''],['肚子','',''],['肚子痛','',''],['肚孤','',''],['肚带','',''],['肚痛','',''],['肚白','',''],['肚皮','',''],['肚皮舞','',''],['肚肠','',''],['肚脐','',''],['肚脐眼','',''],['肚腩','',''],['肚腹','',''],['肚量','',''],['肛交','',''],['肛瘘','',''],['肛道','',''],['肛门','',''],['肛门直肠','',''],['肝儿','',''],['肝功能','',''],['肝吸虫','',''],['肝气','',''],['肝火','',''],['肝炎','',''],['肝片','',''],['肝疾','',''],['肝病','',''],['肝癌','',''],['肝硬化','',''],['肝硬变','',''],['肝糖','',''],['肝肠寸断','',''],['肝肿大','',''],['肝胆','',''],['肝胆楚越','',''],['肝胆涂地','',''],['肝胆照人','',''],['肝胆相照','',''],['肝胆胡越','',''],['肝脏','',''],['肝脑','',''],['肝脑涂地','',''],['肝色','',''],['肝蛭','',''],['肝部','',''],['肝风','',''],['肠仔','',''],['肠伤寒','',''],['肠儿','',''],['肠内','',''],['肠内脏','',''],['肠壁','',''],['肠套叠','',''],['肠子','',''],['肠支','',''],['肠断','',''],['肠梗阻','',''],['肠毒素','',''],['肠液','',''],['肠溃疡','',''],['肠激酶','',''],['肠炎','',''],['肠病毒','',''],['肠痈','',''],['肠癌','',''],['肠管','',''],['肠粉','',''],['肠系膜','',''],['肠线','',''],['肠绒毛','',''],['肠结核','',''],['肠绞痛','',''],['肠肚','',''],['肠肥脑满','',''],['肠胃','',''],['肠胃炎','',''],['肠胃病','',''],['肠胃病学','',''],['肠胃道','',''],['肠菌','',''],['肠虫','',''],['肠蠕动','',''],['肠衣','',''],['肠道','',''],['肠镜','',''],['肠阻塞','',''],['肠骨','',''],['股东','',''],['股东名册','',''],['股东大会','',''],['股东特别大会','',''],['股二头肌','',''],['股价','',''],['股份','',''],['股份公司','',''],['股份制','',''],['股份有限公司','',''],['股份经济','',''],['股分','',''],['股利','',''],['股动脉','',''],['股劲','',''],['股匪','',''],['股员','',''],['股四头肌','',''],['股子','',''],['股室','',''],['股市','',''],['股市低迷','',''],['股息','',''],['股指','',''],['股掌','',''],['股掌之上','',''],['股数','',''],['股本','',''],['股本金比率','',''],['股权','',''],['股栗','',''],['股栗肤粟','',''],['股款','',''],['股民','',''],['股沟','',''],['股疝','',''],['股癣','',''],['股票','',''],['股票交易','',''],['股票交易所','',''],['股票代号','',''],['股票市场','',''],['股票投资','',''],['股票指数','',''],['股绳','',''],['股肉','',''],['股肱','',''],['股资','',''],['股金','',''],['股长','',''],['股集资','',''],['股骨','',''],['肢体','',''],['肢势','',''],['肢窝','',''],['肢节','',''],['肢解','',''],['肤廓','',''],['肤泛','',''],['肤浅','',''],['肤皮','',''],['肤皮潦草','',''],['肤色','',''],['肤觉','',''],['肥儿丸','',''],['肥分','',''],['肥力','',''],['肥厚','',''],['肥圆','',''],['肥墩墩','',''],['肥壮','',''],['肥大','',''],['肥大症','',''],['肥头','',''],['肥头大耳','',''],['肥实','',''],['肥差','',''],['肥效','',''],['肥料','',''],['肥水','',''],['肥水不流外人田','',''],['肥沃','',''],['肥源','',''],['肥煤','',''],['肥猪','',''],['肥田','',''],['肥田粉','',''],['肥田草','',''],['肥瘦','',''],['肥瘦儿','',''],['肥皂','',''],['肥皂剧','',''],['肥皂水','',''],['肥皂沫','',''],['肥皂泡','',''],['肥皂箱','',''],['肥皂般','',''],['肥硕','',''],['肥缺','',''],['肥美','',''],['肥肉','',''],['肥肠','',''],['肥肥','',''],['肥育','',''],['肥胖','',''],['肥胖症','',''],['肥腻','',''],['肥遁鸣高','',''],['肥马虬裘','',''],['肥马轻裘','',''],['肥鲜','',''],['肩上','',''],['肩头','',''],['肩宽','',''],['肩射导弹','',''],['肩带','',''],['肩并肩','',''],['肩扛','',''],['肩担两头脱','',''],['肩挑','',''],['肩摩毂击','',''],['肩摩踵接','',''],['肩窝','',''],['肩章','',''],['肩筐','',''],['肩背相望','',''],['肩胛','',''],['肩胛骨','',''],['肩膀','',''],['肩膊','',''],['肩负','',''],['肩负起','',''],['肩负重任','',''],['肩起','',''],['肩部','',''],['肩骨','',''],['肮脏','',''],['肯于','',''],['肯亚','',''],['肯切','',''],['肯堂肯构','',''],['肯塔基','',''],['肯塔基州','',''],['肯定','',''],['肯定句','',''],['肯定并例句','',''],['肯定性','',''],['肯尼亚人','',''],['肯尼迪','',''],['肯尼迪航天中心','',''],['肯尼迪角','',''],['肯干','',''],['肯德基炸鸡','',''],['肯德拉','',''],['肯普索恩','',''],['肯构肯堂','',''],['肯沃伦','',''],['肯特','',''],['肯綮','',''],['肱三头肌','',''],['肱二头肌','',''],['肱动脉','',''],['肱骨','',''],['育人','',''],['育儿','',''],['育儿室','',''],['育婴','',''],['育婴堂','',''],['育婴室','',''],['育幼院','',''],['育成','',''],['育才','',''],['育林','',''],['育水','',''],['育种','',''],['育秧','',''],['育空','',''],['育空河','',''],['育肥','',''],['育苗','',''],['育雏','',''],['育龄','',''],['育龄期','',''],['肴馔','',''],['肺刺激性毒剂','',''],['肺动脉','',''],['肺叶','',''],['肺吸虫','',''],['肺尘','',''],['肺循环','',''],['肺心病','',''],['肺气肿','',''],['肺水肿','',''],['肺泡','',''],['肺活量','',''],['肺炎','',''],['肺炎克雷伯氏菌','',''],['肺炎双球菌','',''],['肺炎霉浆菌','',''],['肺病','',''],['肺病患者','',''],['肺病热','',''],['肺痨','',''],['肺癌','',''],['肺结核','',''],['肺结核病','',''],['肺脏','',''],['肺脓肿','',''],['肺腑','',''],['肺腑之言','',''],['肺蛭','',''],['肺通气','',''],['肺部','',''],['肺静脉','',''],['肺鱼','',''],['肽单位','',''],['肽基','',''],['肽聚糖','',''],['肽链','',''],['肽键','',''],['肾上','',''],['肾上腺','',''],['肾上腺皮质','',''],['肾上腺素','',''],['肾上腺髓质','',''],['肾亏','',''],['肾功能','',''],['肾囊','',''],['肾小球','',''],['肾炎','',''],['肾病','',''],['肾病综合症','',''],['肾盂','',''],['肾盂炎','',''],['肾结核','',''],['肾结石','',''],['肾脏','',''],['肾虚','',''],['肿伤','',''],['肿块','',''],['肿大','',''],['肿物','',''],['肿痛','',''],['肿瘤','',''],['肿瘤切除术','',''],['肿瘤学','',''],['肿瘤病医生','',''],['肿胀','',''],['肿起','',''],['肿骨鹿','',''],['胀力','',''],['胀大','',''],['胀气','',''],['胀满','',''],['胀破','',''],['胀胀','',''],['胀裂','',''],['胀起','',''],['胁从','',''],['胁从犯','',''],['胁持','',''],['胁肩谄笑','',''],['胁迫','',''],['胃下垂','',''],['胃中','',''],['胃内','',''],['胃口','',''],['胃壁','',''],['胃寒','',''],['胃扩张','',''],['胃毒剂','',''],['胃液','',''],['胃液素','',''],['胃溃疡','',''],['胃灼热','',''],['胃炎','',''],['胃疼','',''],['胃病','',''],['胃痛','',''],['胃癌','',''],['胃绕道','',''],['胃肠','',''],['胃肠炎','',''],['胃脘','',''],['胃腺','',''],['胃舒平','',''],['胃药','',''],['胃蛋白酶','',''],['胃部','',''],['胃酸','',''],['胃镜','',''],['胄子','',''],['胄甲','',''],['胄裔','',''],['胄裔繁衍','',''],['胆儿','',''],['胆力','',''],['胆力过人','',''],['胆囊','',''],['胆囊炎','',''],['胆固醇','',''],['胆壮','',''],['胆大','',''],['胆大包天','',''],['胆大如斗','',''],['胆大妄为','',''],['胆大心细','',''],['胆大无敌','',''],['胆子','',''],['胆寒','',''],['胆小','',''],['胆小如鼠','',''],['胆小怕事','',''],['胆小者','',''],['胆小鬼','',''],['胆怯','',''],['胆惊心寒','',''],['胆惊心战','',''],['胆惊心颤','',''],['胆战','',''],['胆战心寒','',''],['胆战心惊','',''],['胆敢','',''],['胆气','',''],['胆汁','',''],['胆瓶','',''],['胆略','',''],['胆石','',''],['胆石病','',''],['胆石症','',''],['胆石绞痛','',''],['胆矾','',''],['胆破','',''],['胆破心惊','',''],['胆碱','',''],['胆碱酯酶','',''],['胆管','',''],['胆红素','',''],['胆结石','',''],['胆绿素','',''],['胆胀瘟','',''],['胆色素','',''],['胆虚','',''],['胆识','',''],['胆识过人','',''],['胆道','',''],['胆量','',''],['胆颤心寒','',''],['胆颤心惊','',''],['胆魄','',''],['背上','',''],['背不住','',''],['背义忘恩','',''],['背书','',''],['背井','',''],['背井离乡','',''],['背侧','',''],['背信','',''],['背信弃义','',''],['背信忘义','',''],['背债','',''],['背光','',''],['背光式','',''],['背光性','',''],['背兴','',''],['背出','',''],['背包','',''],['背包客','',''],['背包游','',''],['背包袱','',''],['背叛','',''],['背叛者','',''],['背后','',''],['背后议论','',''],['背向','',''],['背囊','',''],['背地','',''],['背地里','',''],['背地风','',''],['背城一战','',''],['背城借一','',''],['背墙','',''],['背头','',''],['背子','',''],['背字','',''],['背对背','',''],['背山','',''],['背山临水','',''],['背山起楼','',''],['背带','',''],['背弃','',''],['背影','',''],['背影儿','',''],['背心','',''],['背心裤','',''],['背恩忘义','',''],['背悔','',''],['背搭子','',''],['背斜','',''],['背斜层','',''],['背日性','',''],['背旮旯儿','',''],['背时','',''],['背景','',''],['背景墙','',''],['背景音乐','',''],['背暗投明','',''],['背板','',''],['背椅','',''],['背榜','',''],['背槽抛粪','',''],['背气','',''],['背水一战','',''],['背水击','',''],['背水阵','',''],['背熟','',''],['背理','',''],['背生芒刺','',''],['背疼','',''],['背痛','',''],['背眼','',''],['背着','',''],['背着手','',''],['背离','',''],['背签','',''],['背篓','',''],['背篮','',''],['背篼','',''],['背紫腰金','',''],['背约','',''],['背脊','',''],['背脊骨','',''],['背若芒刺','',''],['背街','',''],['背袋','',''],['背誓','',''],['背诵','',''],['背谬','',''],['背负','',''],['背起','',''],['背躬','',''],['背过','',''],['背运','',''],['背逆','',''],['背道而驰','',''],['背部','',''],['背阔肌','',''],['背阴','',''],['背集','',''],['背静','',''],['背靠','',''],['背靠背','',''],['背面','',''],['背风','',''],['背饭','',''],['背驰','',''],['背骨','',''],['背鳍','',''],['背黑锅','',''],['胎中','',''],['胎位','',''],['胎便','',''],['胎儿','',''],['胎儿学','',''],['胎具','',''],['胎内','',''],['胎动','',''],['胎压','',''],['胎发','',''],['胎外','',''],['胎教','',''],['胎毒','',''],['胎毛','',''],['胎气','',''],['胎爆','',''],['胎生','',''],['胎生学','',''],['胎痣','',''],['胎盘','',''],['胎粪','',''],['胎膜','',''],['胎衣','',''],['胎记','',''],['胎面','',''],['胖乎乎','',''],['胖人','',''],['胖嘟嘟','',''],['胖墩儿','',''],['胖墩墩','',''],['胖大海','',''],['胖头鱼','',''],['胖子','',''],['胖瘦','',''],['胖的','',''],['胖胖','',''],['胚乳','',''],['胚体','',''],['胚叶','',''],['胚后发育','',''],['胚囊','',''],['胚子','',''],['胚孔','',''],['胚层','',''],['胚根','',''],['胚珠','',''],['胚盘','',''],['胚种','',''],['胚胎','',''],['胚胎发生','',''],['胚胎学','',''],['胚膜','',''],['胚芽','',''],['胚芽米','',''],['胚芽鞘','',''],['胚轴','',''],['胛骨','',''],['胜不骄','',''],['胜不骄败不馁','',''],['胜之','',''],['胜之不武','',''],['胜于','',''],['胜仗','',''],['胜任','',''],['胜任愉快','',''],['胜任能力','',''],['胜似','',''],['胜出','',''],['胜利','',''],['胜利在望','',''],['胜利果实','',''],['胜利者','',''],['胜券','',''],['胜地','',''],['胜天','',''],['胜数','',''],['胜景','',''],['胜智','',''],['胜朝','',''],['胜残去杀','',''],['胜算','',''],['胜者','',''],['胜诉','',''],['胜读十年书','',''],['胜负','',''],['胜负兵家常势','',''],['胜负难测','',''],['胜败','',''],['胜败乃兵家常事','',''],['胜过','',''],['胜过一个诸葛亮','',''],['胜迹','',''],['胜选','',''],['胜造七级浮屠','',''],['胞兄','',''],['胞叔','',''],['胞嘧啶','',''],['胞囊','',''],['胞妹','',''],['胞姐','',''],['胞子','',''],['胞弟','',''],['胞波','',''],['胞浆','',''],['胞状','',''],['胞胎','',''],['胞胚','',''],['胞芽','',''],['胞藻','',''],['胞虫','',''],['胞衣','',''],['胠箧','',''],['胠箧者流','',''],['胡乐','',''],['胡乱','',''],['胡人','',''],['胡佛','',''],['胡作非为','',''],['胡佳','',''],['胡借','',''],['胡克','',''],['胡克定律','',''],['胡匪','',''],['胡司战争','',''],['胡吃','',''],['胡吃海喝','',''],['胡吃海塞','',''],['胡同','',''],['胡吣','',''],['胡吹','',''],['胡吹乱捧','',''],['胡噜','',''],['胡图族','',''],['胡天','',''],['胡天胡帝','',''],['胡夫','',''],['胡姬花','',''],['胡子','',''],['胡子拉碴','',''],['胡子眉毛一把抓','',''],['胡家','',''],['胡弄','',''],['胡志强','',''],['胡志明','',''],['胡志明市','',''],['胡思','',''],['胡思乱想','',''],['胡思乱量','',''],['胡想','',''],['胡慧中','',''],['胡扯','',''],['胡扯八溜','',''],['胡扯淡','',''],['胡抡','',''],['胡搅','',''],['胡搅蛮缠','',''],['胡搞','',''],['胡服','',''],['胡来','',''],['胡杨','',''],['胡枝子','',''],['胡桃','',''],['胡桃木','',''],['胡桃树','',''],['胡桃色','',''],['胡椒','',''],['胡椒子','',''],['胡椒属','',''],['胡椒粉','',''],['胡椒粒','',''],['胡椒薄荷','',''],['胡涂','',''],['胡涂虫','',''],['胡温新政','',''],['胡燕妮','',''],['胡狼','',''],['胡琴','',''],['胡琴儿','',''],['胡瓜','',''],['胡瓜鱼','',''],['胡疵','',''],['胡笙','',''],['胡笳','',''],['胡紫微','',''],['胡紫薇','',''],['胡编乱造','',''],['胡缠','',''],['胡耀邦','',''],['胡芦巴','',''],['胡芫','',''],['胡花','',''],['胡茬','',''],['胡荽','',''],['胡萝卜','',''],['胡萝卜素','',''],['胡蜂','',''],['胡蝶','',''],['胡言','',''],['胡言乱语','',''],['胡言汉语','',''],['胡诌','',''],['胡诌乱傍','',''],['胡诌乱扯','',''],['胡诌乱说','',''],['胡诌乱道','',''],['胡诌八扯','',''],['胡话','',''],['胡说','',''],['胡说乱讲','',''],['胡说乱道','',''],['胡说八道','',''],['胡说白道','',''],['胡豆','',''],['胡适','',''],['胡鄂公','',''],['胡里胡涂','',''],['胡铨','',''],['胡锦涛','',''],['胡闹','',''],['胡须','',''],['胡颓子','',''],['胡风','',''],['胡髭','',''],['胡麻','',''],['胡麻籽','',''],['胥吏','',''],['胧的','',''],['胪列','',''],['胪陈','',''],['胫骨','',''],['胬肉','',''],['胭脂','',''],['胭脂红','',''],['胭脂鱼','',''],['胯下','',''],['胯下之辱','',''],['胯骨','',''],['胰子','',''],['胰岛','',''],['胰岛素','',''],['胰液','',''],['胰淀粉酶','',''],['胰脂酶','',''],['胰脏','',''],['胰脏炎','',''],['胰腺','',''],['胰腺炎','',''],['胰蛋白酶','',''],['胳肢','',''],['胳肢窝','',''],['胳膊','',''],['胳膊肘','',''],['胳膊肘子','',''],['胳膊肘朝外拐','',''],['胳膊腕子','',''],['胳臂','',''],['胳臂箍儿','',''],['胳臂肘儿','',''],['胴体','',''],['胶东','',''],['胶丝','',''],['胶乳','',''],['胶住','',''],['胶体','',''],['胶体化学','',''],['胶体溶液','',''],['胶剂','',''],['胶化体','',''],['胶印','',''],['胶卷','',''],['胶卷匣','',''],['胶原','',''],['胶原纤维','',''],['胶原蛋白','',''],['胶原质','',''],['胶合','',''],['胶合剂','',''],['胶合板','',''],['胶囊','',''],['胶圈','',''],['胶土','',''],['胶块','',''],['胶垫','',''],['胶塞','',''],['胶子','',''],['胶州湾','',''],['胶布','',''],['胶带','',''],['胶底','',''],['胶接','',''],['胶木','',''],['胶条','',''],['胶柱调瑟','',''],['胶柱鼓瑟','',''],['胶氨芹','',''],['胶水','',''],['胶水般','',''],['胶泥','',''],['胶济铁路','',''],['胶漆','',''],['胶片','',''],['胶片佩章','',''],['胶版','',''],['胶版纸','',''],['胶状','',''],['胶状体','',''],['胶状物','',''],['胶皮','',''],['胶盒','',''],['胶着','',''],['胶管','',''],['胶粉','',''],['胶粒','',''],['胶粘','',''],['胶粘剂','',''],['胶纸','',''],['胶结','',''],['胶膜','',''],['胶著','',''],['胶质','',''],['胶轮','',''],['胶轴','',''],['胶辊','',''],['胶靴','',''],['胶鞋','',''],['胶黏剂','',''],['胶黐','',''],['胸中','',''],['胸中宿物','',''],['胸中无数','',''],['胸中有数','',''],['胸侧','',''],['胸像','',''],['胸前','',''],['胸口','',''],['胸噎','',''],['胸围','',''],['胸墙','',''],['胸壁','',''],['胸外心脏按摩','',''],['胸大肌','',''],['胸宽','',''],['胸廓','',''],['胸廓切开术','',''],['胸怀','',''],['胸怀坦荡','',''],['胸怀大局','',''],['胸怀大志','',''],['胸无城府','',''],['胸无大志','',''],['胸无宿物','',''],['胸无点墨','',''],['胸有丘壑','',''],['胸有城府','',''],['胸有成略','',''],['胸有成竹','',''],['胸有成算','',''],['胸有甲兵','',''],['胸椎','',''],['胸槽','',''],['胸次','',''],['胸毛','',''],['胸甲','',''],['胸章','',''],['胸线','',''],['胸罩','',''],['胸肉','',''],['胸肌','',''],['胸胁','',''],['胸脯','',''],['胸腔','',''],['胸腹','',''],['胸腺','',''],['胸腺嘧啶','',''],['胸膛','',''],['胸膜','',''],['胸膜炎','',''],['胸臆','',''],['胸花','',''],['胸衣','',''],['胸襟','',''],['胸透','',''],['胸部','',''],['胸里','',''],['胸针','',''],['胸闷','',''],['胸靶','',''],['胸音','',''],['胸饰','',''],['胸骨','',''],['胸鳍','',''],['胺基酸','',''],['胼手胝足','',''],['胼手胼足','',''],['胼胝','',''],['胼胝体','',''],['能上','',''],['能上能下','',''],['能不','',''],['能不能','',''],['能为','',''],['能了解','',''],['能事','',''],['能交换','',''],['能人','',''],['能以','',''],['能传达','',''],['能传送','',''],['能伸','',''],['能伸能屈','',''],['能使','',''],['能偿债','',''],['能养活','',''],['能再','',''],['能写善算','',''],['能分开','',''],['能分泌','',''],['能力','',''],['能力素质','',''],['能劝告','',''],['能动性','',''],['能吃','',''],['能否','',''],['能吸收','',''],['能够','',''],['能容纳','',''],['能屈能伸','',''],['能工巧匠','',''],['能干','',''],['能弱能强','',''],['能彀','',''],['能征惯战','',''],['能愿动词','',''],['能手','',''],['能掐会算','',''],['能接受','',''],['能文能武','',''],['能歌善舞','',''],['能源','',''],['能源供应','',''],['能源危机','',''],['能源工业','',''],['能源开发','',''],['能源技术','',''],['能源短缺','',''],['能源科学','',''],['能源管理','',''],['能源经济','',''],['能者','',''],['能者为师','',''],['能者多劳','',''],['能耐','',''],['能育性','',''],['能胜任','',''],['能见度','',''],['能视度','',''],['能言取譬','',''],['能言善辩','',''],['能言快语','',''],['能言舌辩','',''],['能诗善文','',''],['能说','',''],['能说会道','',''],['能量','',''],['能量代谢','',''],['能量守恒','',''],['能量守恒定律','',''],['脂性','',''],['脂油','',''],['脂溢性皮炎','',''],['脂环烃','',''],['脂粉','',''],['脂粉气','',''],['脂肪','',''],['脂肪团','',''],['脂肪瘤','',''],['脂肪肝','',''],['脂肪质','',''],['脂肪酶','',''],['脂肪酸','',''],['脂膏','',''],['脂蛋白','',''],['脂质体','',''],['脂酸','',''],['脆弱','',''],['脆快','',''],['脆性','',''],['脆熟','',''],['脆片','',''],['脆生','',''],['脆皮','',''],['脆目','',''],['脆而不坚','',''],['脆耳','',''],['脆脆','',''],['脆谷乐','',''],['脆过','',''],['脆饼','',''],['脆骨','',''],['脉中','',''],['脉内','',''],['脉冲','',''],['脉冲技术','',''],['脉冲星','',''],['脉冲计','',''],['脉冲雷达','',''],['脉动','',''],['脉动星','',''],['脉动电流','',''],['脉压','',''],['脉口','',''],['脉息','',''],['脉搏','',''],['脉搏表','',''],['脉搏计','',''],['脉斑岩','',''],['脉案','',''],['脉横','',''],['脉波','',''],['脉波计','',''],['脉理','',''],['脉石','',''],['脉码','',''],['脉管','',''],['脉管组织','',''],['脉络','',''],['脉络膜','',''],['脉脉','',''],['脉诊','',''],['脉象','',''],['脉跳','',''],['脉轮','',''],['脉轮学说','',''],['脉轮理论','',''],['脉门','',''],['脊丘','',''],['脊令','',''],['脊柱','',''],['脊柱裂','',''],['脊梁','',''],['脊梁骨','',''],['脊椎','',''],['脊椎动物','',''],['脊椎动物门','',''],['脊椎指压治疗医生','',''],['脊椎指压治疗师','',''],['脊椎指压疗法','',''],['脊椎炎','',''],['脊椎骨','',''],['脊檩','',''],['脊神经','',''],['脊索','',''],['脊索动物','',''],['脊索动物门','',''],['脊线','',''],['脊肋','',''],['脊背','',''],['脊骨','',''],['脊髓','',''],['脊髓灰质炎','',''],['脊髓炎','',''],['脊鳍','',''],['脍不厌细','',''],['脍炙人口','',''],['脏乱','',''],['脏乱差','',''],['脏了','',''],['脏兮兮','',''],['脏器','',''],['脏土','',''],['脏字','',''],['脏弹','',''],['脏手','',''],['脏水','',''],['脏污','',''],['脏污着','',''],['脏煤','',''],['脏物','',''],['脏病','',''],['脏脏','',''],['脏腑','',''],['脏话','',''],['脏躁症','',''],['脏钱','',''],['脐屎','',''],['脐带','',''],['脐梗','',''],['脐橙','',''],['脐状','',''],['脐轮','',''],['脐风','',''],['脑上体','',''],['脑下','',''],['脑下垂体','',''],['脑下腺','',''],['脑中','',''],['脑中风','',''],['脑体倒挂','',''],['脑儿','',''],['脑充血','',''],['脑内啡','',''],['脑出血','',''],['脑力','',''],['脑力劳动','',''],['脑力劳动者','',''],['脑力激荡法','',''],['脑勺','',''],['脑勺子','',''],['脑卒中','',''],['脑变','',''],['脑叶','',''],['脑后','',''],['脑回','',''],['脑垂体','',''],['脑壳','',''],['脑子','',''],['脑子生锈','',''],['脑室','',''],['脑岛','',''],['脑干','',''],['脑性痲痹','',''],['脑性麻痹','',''],['脑成像技术','',''],['脑损伤','',''],['脑杓','',''],['脑桥','',''],['脑死亡','',''],['脑残','',''],['脑水肿','',''],['脑汁','',''],['脑沟','',''],['脑波','',''],['脑浆','',''],['脑海','',''],['脑涨','',''],['脑液','',''],['脑溢血','',''],['脑满','',''],['脑满肠肥','',''],['脑炎','',''],['脑状','',''],['脑瓜','',''],['脑瓜儿','',''],['脑瓜子','',''],['脑瓢儿','',''],['脑电图','',''],['脑电图版','',''],['脑电波','',''],['脑病','',''],['脑瘤','',''],['脑瘫','',''],['脑神经','',''],['脑积水','',''],['脑筋','',''],['脑筋好','',''],['脑细胞','',''],['脑肿瘤','',''],['脑胀','',''],['脑脊液','',''],['脑脊髓','',''],['脑膜','',''],['脑膜炎','',''],['脑血栓','',''],['脑血管屏障','',''],['脑血管疾病','',''],['脑袋','',''],['脑袋开花','',''],['脑袋瓜子','',''],['脑贫血','',''],['脑部','',''],['脑量','',''],['脑门','',''],['脑门子','',''],['脑际','',''],['脑震荡','',''],['脑颅','',''],['脑髓','',''],['脓包','',''],['脓口','',''],['脓毒病','',''],['脓水','',''],['脓汁','',''],['脓泡','',''],['脓液','',''],['脓疮','',''],['脓疱','',''],['脓疱病','',''],['脓疹','',''],['脓痰','',''],['脓肿','',''],['脓胸','',''],['脓血症','',''],['脔割','',''],['脖围','',''],['脖子','',''],['脖梗儿','',''],['脖梗子','',''],['脖领','',''],['脖颈','',''],['脖颈儿','',''],['脖颈子','',''],['脚上','',''],['脚下','',''],['脚不沾地','',''],['脚不点地','',''],['脚丫','',''],['脚丫子','',''],['脚位','',''],['脚凳','',''],['脚力','',''],['脚劲','',''],['脚印','',''],['脚后跟','',''],['脚垫','',''],['脚夫','',''],['脚孤拐','',''],['脚尖','',''],['脚带','',''],['脚底','',''],['脚底板','',''],['脚形','',''],['脚心','',''],['脚忙手乱','',''],['脚户','',''],['脚手架','',''],['脚扣','',''],['脚指','',''],['脚指头','',''],['脚指甲','',''],['脚掌','',''],['脚料','',''],['脚本','',''],['脚板','',''],['脚架','',''],['脚标','',''],['脚根','',''],['脚正不怕鞋歪','',''],['脚步','',''],['脚步声','',''],['脚步快','',''],['脚步轻盈','',''],['脚气','',''],['脚气病','',''],['脚注','',''],['脚灯','',''],['脚炉','',''],['脚爪','',''],['脚病','',''],['脚痛','',''],['脚痛医脚','',''],['脚癣','',''],['脚盆','',''],['脚背','',''],['脚脖子','',''],['脚腕','',''],['脚腕子','',''],['脚色','',''],['脚行','',''],['脚误','',''],['脚趾','',''],['脚趾头','',''],['脚趾尖','',''],['脚跟','',''],['脚跟稳','',''],['脚踏','',''],['脚踏两只船','',''],['脚踏两条船','',''],['脚踏实地','',''],['脚踏板','',''],['脚踏车','',''],['脚踝','',''],['脚踩两只船','',''],['脚蹬','',''],['脚蹼','',''],['脚轮','',''],['脚违例','',''],['脚迹','',''],['脚钱','',''],['脚链','',''],['脚镣','',''],['脚镣手铐','',''],['脚镯','',''],['脚门','',''],['脚面','',''],['脚鸭子','',''],['脯子','',''],['脯氨酸','',''],['脱下','',''],['脱不了身','',''],['脱了','',''],['脱了臼','',''],['脱产','',''],['脱产学习','',''],['脱产干部','',''],['脱位','',''],['脱俗','',''],['脱光','',''],['脱兔','',''],['脱党','',''],['脱出','',''],['脱北者','',''],['脱卸','',''],['脱去','',''],['脱发','',''],['脱口','',''],['脱口成章','',''],['脱口秀','',''],['脱口而出','',''],['脱咖啡因','',''],['脱坯','',''],['脱垂','',''],['脱壳','',''],['脱壳机','',''],['脱壳金蝉','',''],['脱孝','',''],['脱尽','',''],['脱岗','',''],['脱帽','',''],['脱序','',''],['脱开','',''],['脱手','',''],['脱换','',''],['脱掉','',''],['脱敏','',''],['脱散','',''],['脱期','',''],['脱机','',''],['脱来','',''],['脱档','',''],['脱模','',''],['脱毛','',''],['脱毛剂','',''],['脱毛用','',''],['脱氢','',''],['脱氢酶','',''],['脱氧','',''],['脱氧剂','',''],['脱氧核糖','',''],['脱氧核糖核酸','',''],['脱氧核苷酸','',''],['脱氧脱糖核酸','',''],['脱氧麻黄碱','',''],['脱水','',''],['脱水器','',''],['脱水机','',''],['脱泡','',''],['脱泥','',''],['脱洒','',''],['脱涩','',''],['脱溶','',''],['脱滑','',''],['脱漏','',''],['脱灰','',''],['脱然','',''],['脱班','',''],['脱略','',''],['脱皮','',''],['脱皮掉肉','',''],['脱盐','',''],['脱盲','',''],['脱硫','',''],['脱碳','',''],['脱离','',''],['脱离危险','',''],['脱离实际','',''],['脱离群众','',''],['脱离者','',''],['脱离苦海','',''],['脱离速度','',''],['脱秀','',''],['脱稿','',''],['脱空','',''],['脱空汉','',''],['脱粒','',''],['脱粒机','',''],['脱粟','',''],['脱线','',''],['脱缰','',''],['脱缰之马','',''],['脱网','',''],['脱罪','',''],['脱羽','',''],['脱者','',''],['脱肛','',''],['脱胎','',''],['脱胎成仙','',''],['脱胎换骨','',''],['脱胎漆器','',''],['脱胶','',''],['脱脂','',''],['脱脂乳','',''],['脱脂棉','',''],['脱脱','',''],['脱臼','',''],['脱色','',''],['脱色剂','',''],['脱节','',''],['脱落','',''],['脱落性','',''],['脱衣','',''],['脱衣服','',''],['脱衣舞','',''],['脱裤','',''],['脱裤子放屁','',''],['脱误','',''],['脱货','',''],['脱货求现','',''],['脱贫','',''],['脱贫致富','',''],['脱身','',''],['脱轨','',''],['脱逃','',''],['脱逃术','',''],['脱钩','',''],['脱销','',''],['脱除','',''],['脱险','',''],['脱靴','',''],['脱靴器','',''],['脱靶','',''],['脱鞋','',''],['脱颖','',''],['脱颖而出','',''],['脱骨成佛','',''],['脱骨换胎','',''],['脲醛','',''],['脸上','',''],['脸书','',''],['脸儿','',''],['脸厚','',''],['脸型','',''],['脸大','',''],['脸子','',''],['脸孔','',''],['脸庞','',''],['脸形','',''],['脸水','',''],['脸白','',''],['脸的','',''],['脸皮','',''],['脸皮厚','',''],['脸盆','',''],['脸盆架','',''],['脸盘','',''],['脸盘儿','',''],['脸盲症','',''],['脸相','',''],['脸红','',''],['脸红筋暴','',''],['脸红筋涨','',''],['脸红脖子粗','',''],['脸罩','',''],['脸膛','',''],['脸膛儿','',''],['脸色','',''],['脸薄','',''],['脸蛋','',''],['脸蛋儿','',''],['脸蛋子','',''],['脸谱','',''],['脸软','',''],['脸部','',''],['脸都绿了','',''],['脸青色','',''],['脸面','',''],['脸颊','',''],['脸额','',''],['脾寒','',''],['脾性','',''],['脾气','',''],['脾气倔','',''],['脾气坏','',''],['脾气大','',''],['脾气好','',''],['脾气暴燥','',''],['脾炎','',''],['脾病','',''],['脾肉之叹','',''],['脾肿大','',''],['脾胃','',''],['脾胃相投','',''],['脾脏','',''],['脾虚','',''],['腆然','',''],['腆着','',''],['腆著','',''],['腆颜','',''],['腈纶','',''],['腊八','',''],['腊八粥','',''],['腊制','',''],['腊味','',''],['腊染法','',''],['腊梅','',''],['腊烛','',''],['腊笔','',''],['腊纸','',''],['腊肉','',''],['腊肠','',''],['腊象','',''],['腊雪','',''],['腊鸭','',''],['腋下','',''],['腋内','',''],['腋毛','',''],['腋生','',''],['腋窝','',''],['腋臭','',''],['腋芽','',''],['腌制','',''],['腌汁','',''],['腌泡','',''],['腌泡汁','',''],['腌浸','',''],['腌渍','',''],['腌渍品','',''],['腌猪','',''],['腌猪肉','',''],['腌肉','',''],['腌臜','',''],['腌菜','',''],['腌蛋','',''],['腌货','',''],['腌货商','',''],['腌鱼','',''],['腌黄瓜','',''],['腐乳','',''],['腐儒','',''],['腐刑','',''],['腐化','',''],['腐化堕落','',''],['腐坏','',''],['腐尸','',''],['腐干','',''],['腐恶','',''],['腐旧','',''],['腐朽','',''],['腐朽思想','',''],['腐植','',''],['腐植质','',''],['腐植酸类肥料','',''],['腐植酸铵','',''],['腐殖土','',''],['腐殖覆盖物','',''],['腐殖质','',''],['腐殖酸','',''],['腐气','',''],['腐烂','',''],['腐烂变质','',''],['腐熟','',''],['腐生','',''],['腐生兰','',''],['腐生物','',''],['腐皮','',''],['腐竹','',''],['腐肉','',''],['腐肥','',''],['腐臭','',''],['腐蚀','',''],['腐蚀剂','',''],['腐蚀性','',''],['腐蚀掉','',''],['腐蚀药','',''],['腐败','',''],['腐败分子','',''],['腐败性','',''],['腐败无能','',''],['腐败现象','',''],['腐败罪','',''],['腑版','',''],['腑脏','',''],['腓利门书','',''],['腓力','',''],['腓尼基','',''],['腓特烈斯塔','',''],['腓立比','',''],['腓立比书','',''],['腓肠肌','',''],['腓骨','',''],['腔壁','',''],['腔子','',''],['腔棘鱼','',''],['腔肠动物','',''],['腔调','',''],['腔隙','',''],['腕关节','',''],['腕力','',''],['腕夺','',''],['腕套','',''],['腕子','',''],['腕带','',''],['腕级','',''],['腕足','',''],['腕足动物','',''],['腕部','',''],['腕镯','',''],['腕隧道症候群','',''],['腕骨','',''],['腕龙','',''],['腘动脉','',''],['腘旁腱肌','',''],['腘窝','',''],['腘窝囊肿','',''],['腘绳肌','',''],['腘肌','',''],['腘静脉','',''],['腠理','',''],['腥味','',''],['腥气','',''],['腥腥','',''],['腥膻','',''],['腥臊','',''],['腥臭','',''],['腥风血雨','',''],['腥黑穗病','',''],['腧穴','',''],['腩炙','',''],['腭裂','',''],['腮帮','',''],['腮帮子','',''],['腮托','',''],['腮红','',''],['腮胡','',''],['腮腺','',''],['腮腺炎','',''],['腮须','',''],['腮颊','',''],['腰下','',''],['腰伤','',''],['腰刀','',''],['腰力','',''],['腰包','',''],['腰围','',''],['腰垫','',''],['腰墙','',''],['腰子','',''],['腰巾','',''],['腰布','',''],['腰带','',''],['腰斩','',''],['腰杆','',''],['腰杆子','',''],['腰板','',''],['腰板儿','',''],['腰果','',''],['腰果鸡丁','',''],['腰椎','',''],['腰椎间盘','',''],['腰椎间盘突出','',''],['腰椎间盘突出症','',''],['腰痛','',''],['腰眼','',''],['腰窝','',''],['腰缠万贯','',''],['腰肉','',''],['腰肌劳损','',''],['腰肢','',''],['腰背','',''],['腰腿','',''],['腰花','',''],['腰身','',''],['腰部','',''],['腰酸','',''],['腰里','',''],['腰金拖紫','',''],['腰金衣紫','',''],['腰锅','',''],['腰间','',''],['腰际','',''],['腰饰','',''],['腰骨','',''],['腰鼓','',''],['腰鼓兄弟','',''],['腰鼓舞','',''],['腱子','',''],['腱弓','',''],['腱炎','',''],['腱鞘','',''],['腱鞘炎','',''],['腹上部','',''],['腹中','',''],['腹侧','',''],['腹吸盘','',''],['腹哀','',''],['腹地','',''],['腹壁','',''],['腹层','',''],['腹带','',''],['腹心','',''],['腹心之患','',''],['腹心之疾','',''],['腹有鳞甲','',''],['腹板','',''],['腹水','',''],['腹水肿','',''],['腹泄','',''],['腹泻','',''],['腹疾','',''],['腹痛','',''],['腹直肌','',''],['腹稿','',''],['腹笥便便','',''],['腹笥甚宽','',''],['腹肌','',''],['腹股沟','',''],['腹胀','',''],['腹背','',''],['腹背之毛','',''],['腹背受敌','',''],['腹背相亲','',''],['腹腔','',''],['腹膜','',''],['腹膜炎','',''],['腹话术','',''],['腹语','',''],['腹语师','',''],['腹语术','',''],['腹诽','',''],['腹诽心谤','',''],['腹足','',''],['腹足类','',''],['腹足纲','',''],['腹部','',''],['腹部绞痛','',''],['腹面','',''],['腹鳍','',''],['腹鸣','',''],['腺体','',''],['腺嘌呤','',''],['腺嘌呤核甘三磷酸','',''],['腺垂体','',''],['腺样','',''],['腺毛','',''],['腺状','',''],['腺病毒','',''],['腺瘤','',''],['腺癌','',''],['腺细胞','',''],['腺苷','',''],['腻了','',''],['腻人','',''],['腻友','',''],['腻味','',''],['腻子','',''],['腻歪','',''],['腻烦','',''],['腻胃','',''],['腻腻','',''],['腻虫','',''],['腼脸','',''],['腼腆','',''],['腽肭','',''],['腽肭兽','',''],['腽肭脐','',''],['腾云','',''],['腾云驾雾','',''],['腾出','',''],['腾地','',''],['腾开','',''],['腾挪','',''],['腾格里沙漠','',''],['腾空','',''],['腾空而起','',''],['腾腾','',''],['腾虎','',''],['腾蛟起凤','',''],['腾让','',''],['腾讯控股有限公司','',''],['腾贵','',''],['腾起','',''],['腾越','',''],['腾跃','',''],['腾达','',''],['腾飞','',''],['腾骧','',''],['腾黄','',''],['腿上','',''],['腿力','',''],['腿号','',''],['腿号箍','',''],['腿后腱','',''],['腿子','',''],['腿带','',''],['腿弯部','',''],['腿样','',''],['腿疼','',''],['腿筋','',''],['腿肚子','',''],['腿脚','',''],['腿腕子','',''],['腿部','',''],['腿骨','',''],['膀大腰圆','',''],['膀子','',''],['膀胱','',''],['膀胱气化','',''],['膀胱炎','',''],['膀胱结石','',''],['膀臂','',''],['膂力','',''],['膈疝','',''],['膈肌','',''],['膈膜','',''],['膈食病','',''],['膏剂','',''],['膏唇拭舌','',''],['膏子','',''],['膏油','',''],['膏火','',''],['膏火自煎','',''],['膏状物','',''],['膏粱','',''],['膏粱子弟','',''],['膏粱文绣','',''],['膏粱锦绣','',''],['膏肓','',''],['膏肓之疾','',''],['膏腴','',''],['膏膏','',''],['膏药','',''],['膏药旗','',''],['膏血','',''],['膑刑','',''],['膘情','',''],['膘肥','',''],['膘肥体壮','',''],['膛内','',''],['膛径','',''],['膛线','',''],['膜孔','',''],['膜拜','',''],['膜炎','',''],['膜片','',''],['膜翅目','',''],['膜质','',''],['膝上','',''],['膝上型','',''],['膝上型电脑','',''],['膝上舞','',''],['膝下','',''],['膝关节','',''],['膝头','',''],['膝状','',''],['膝甲','',''],['膝痒挠背','',''],['膝盖','',''],['膝盖骨','',''],['膝礼','',''],['膝行','',''],['膝行肘步','',''],['膝袒','',''],['膝部','',''],['膨体','',''],['膨体纱','',''],['膨出','',''],['膨大','',''],['膨大海','',''],['膨松','',''],['膨润土','',''],['膨涨','',''],['膨胀','',''],['膨胀性','',''],['膨胀水泥','',''],['膨胀系数','',''],['膨胀计','',''],['膳写者','',''],['膳务员','',''],['膳宿','',''],['膳房','',''],['膳费','',''],['膳食','',''],['膳魔师','',''],['膺任','',''],['膺品','',''],['膺惩','',''],['膺赏','',''],['膺选','',''],['膺造','',''],['膻味','',''],['膻腥','',''],['臀产式分娩','',''],['臀位','',''],['臀位分娩','',''],['臀位取胎术','',''],['臀围','',''],['臀大肌','',''],['臀尖','',''],['臀瓣','',''],['臀疣','',''],['臀肌','',''],['臀部','',''],['臀鳍','',''],['臁疮','',''],['臂力','',''],['臂助','',''],['臂弯','',''],['臂环','',''],['臂章','',''],['臂纱','',''],['臂膀','',''],['臂膊','',''],['臂镯','',''],['臃肿','',''],['臆度','',''],['臆想','',''],['臆想狂','',''],['臆想病','',''],['臆想症','',''],['臆断','',''],['臆测','',''],['臆见','',''],['臆造','',''],['臊子','',''],['臊气','',''],['臊腥','',''],['臌胀','',''],['臣一主二','',''],['臣下','',''],['臣仆','',''],['臣僚','',''],['臣妾','',''],['臣子','',''],['臣属','',''],['臣服','',''],['臣民','',''],['臣臣','',''],['臣虏','',''],['臧否','',''],['臧否人物','',''],['自上','',''],['自上而下','',''],['自下','',''],['自下而上','',''],['自不','',''],['自不待言','',''],['自不必说','',''],['自不量力','',''],['自专','',''],['自东','',''],['自个','',''],['自个儿','',''],['自为','',''],['自为阶级','',''],['自主','',''],['自主创新','',''],['自主权','',''],['自主神经','',''],['自主系统','',''],['自主经营','',''],['自乘','',''],['自习','',''],['自书','',''],['自交作物','',''],['自交系','',''],['自产','',''],['自今','',''],['自从','',''],['自以为','',''],['自以为是','',''],['自以为然','',''],['自以得计','',''],['自会','',''],['自会直','',''],['自传','',''],['自住','',''],['自体','',''],['自体免疫疾病','',''],['自作','',''],['自作主张','',''],['自作多情','',''],['自作聪明','',''],['自作自受','',''],['自供','',''],['自供状','',''],['自便','',''],['自保','',''],['自信','',''],['自信心','',''],['自修','',''],['自做','',''],['自傲','',''],['自养','',''],['自决','',''],['自决权','',''],['自况','',''],['自净作用','',''],['自出','',''],['自出一家','',''],['自出机杼','',''],['自分','',''],['自刎','',''],['自创','',''],['自制','',''],['自制力','',''],['自制炸弹','',''],['自力','',''],['自力更生','',''],['自办','',''],['自动','',''],['自动付款机','',''],['自动伞','',''],['自动免疫','',''],['自动化','',''],['自动化技术','',''],['自动取款机','',''],['自动售货机','',''],['自动地工作','',''],['自动射线摄影','',''],['自动性','',''],['自动恢复','',''],['自动扶梯','',''],['自动挂挡','',''],['自动挡','',''],['自动控制','',''],['自动提款','',''],['自动提款机','',''],['自动播放','',''],['自动机','',''],['自动柜员机','',''],['自动档','',''],['自动梯','',''],['自动检测','',''],['自动检索','',''],['自动楼梯','',''],['自动步枪','',''],['自动步道','',''],['自动气象站','',''],['自动电话','',''],['自动离合','',''],['自动线','',''],['自动自发','',''],['自动装置','',''],['自动车','',''],['自动铅笔','',''],['自动防止辐射程序','',''],['自助','',''],['自助洗衣店','',''],['自助餐','',''],['自励','',''],['自勉','',''],['自卑','',''],['自卑心理','',''],['自卑情绪','',''],['自卑感','',''],['自卖','',''],['自卖自夸','',''],['自卫','',''],['自卫战争','',''],['自卫权','',''],['自卫还击','',''],['自卫队','',''],['自即日起','',''],['自卸车','',''],['自发','',''],['自发势力','',''],['自发对称破缺','',''],['自发性','',''],['自发电位','',''],['自发的唯物主义','',''],['自取','',''],['自取其咎','',''],['自取其辱','',''],['自取灭亡','',''],['自受','',''],['自变数','',''],['自变量','',''],['自叙','',''],['自古','',''],['自古以来','',''],['自叹','',''],['自叹不如','',''],['自各','',''],['自各儿','',''],['自同寒蝉','',''],['自名','',''],['自吹自擂','',''],['自告奋勇','',''],['自命','',''],['自命不凡','',''],['自命清高','',''],['自咎','',''],['自哪','',''],['自唱','',''],['自喜','',''],['自喻','',''],['自嘲','',''],['自圆其说','',''],['自在','',''],['自在不成人','',''],['自在之物','',''],['自在逍遥','',''],['自在阶级','',''],['自填','',''],['自处','',''],['自处理','',''],['自备','',''],['自外','',''],['自大','',''],['自大狂','',''],['自大者','',''],['自失','',''],['自夸','',''],['自奉','',''],['自奉俭约','',''],['自奉甚俭','',''],['自如','',''],['自始','',''],['自始至终','',''],['自娱','',''],['自存','',''],['自学','',''],['自学成才','',''],['自学方法','',''],['自学者','',''],['自定','',''],['自定义','',''],['自家','',''],['自寻','',''],['自寻死路','',''],['自寻烦恼','',''],['自导','',''],['自导引','',''],['自封','',''],['自尊','',''],['自尊心','',''],['自小','',''],['自尽','',''],['自居','',''],['自崖而反','',''],['自差','',''],['自己','',''],['自己人','',''],['自己做','',''],['自己动手','',''],['自己方便','',''],['自带','',''],['自干','',''],['自幼','',''],['自序','',''],['自应','',''],['自底向上','',''],['自度曲','',''],['自建','',''],['自弃','',''],['自强','',''],['自强不息','',''],['自强自立','',''],['自强运动','',''],['自当','',''],['自律','',''],['自律性','',''],['自律性组织','',''],['自得','',''],['自得其乐','',''],['自忖','',''],['自怜','',''],['自怨自艾','',''],['自恃','',''],['自恃清高','',''],['自恋','',''],['自悔','',''],['自惜羽毛','',''],['自惭形秽','',''],['自感','',''],['自感应','',''],['自感系数','',''],['自愧不如','',''],['自愧弗如','',''],['自愿','',''],['自愿互利','',''],['自愿性','',''],['自愿者','',''],['自慰','',''],['自成','',''],['自成一家','',''],['自成体系','',''],['自我','',''],['自我介绍','',''],['自我作故','',''],['自我催眠','',''],['自我发展','',''],['自我安慰','',''],['自我实现','',''],['自我意识','',''],['自我批评','',''],['自我改造','',''],['自我牺牲','',''],['自我的人','',''],['自我表现','',''],['自我解嘲','',''],['自我评价','',''],['自我调节','',''],['自我防卫','',''],['自我陶醉','',''],['自戒','',''],['自戕','',''],['自打','',''],['自扰','',''],['自找','',''],['自找苦吃','',''],['自找麻烦','',''],['自投罗网','',''],['自报','',''],['自报公议','',''],['自报家门','',''],['自拍','',''],['自拍器','',''],['自拍模式','',''],['自拔','',''],['自拔来归','',''],['自招','',''],['自持','',''],['自掏','',''],['自掘','',''],['自掘坟墓','',''],['自控','',''],['自提','',''],['自擂','',''],['自救','',''],['自救不暇','',''],['自料','',''],['自斟自酌','',''],['自新','',''],['自明','',''],['自是','',''],['自暴自弃','',''],['自有','',''],['自有品牌','',''],['自有肺肠','',''],['自本','',''],['自杀','',''],['自杀式','',''],['自杀式汽车炸弹袭击事件','',''],['自杀式炸弹','',''],['自杀式爆炸','',''],['自杀性','',''],['自杀炸弹杀手','',''],['自杀者','',''],['自来','',''],['自来水','',''],['自来水笔','',''],['自来水管','',''],['自来火','',''],['自来红','',''],['自查','',''],['自核','',''],['自检','',''],['自欺','',''],['自欺欺人','',''],['自此','',''],['自毁','',''],['自民党','',''],['自求多福','',''],['自治','',''],['自治体','',''],['自治区','',''],['自治县','',''],['自治州','',''],['自治市','',''],['自治旗','',''],['自治机关','',''],['自治权','',''],['自治领','',''],['自流','',''],['自流井','',''],['自流灌溉','',''],['自淫','',''],['自渎','',''],['自溶','',''],['自溺','',''],['自满','',''],['自激','',''],['自焚','',''],['自然','',''],['自然主义','',''],['自然之友','',''],['自然人','',''],['自然保护区','',''],['自然免疫','',''],['自然分工','',''],['自然力','',''],['自然区','',''],['自然台','',''],['自然史','',''],['自然哲学','',''],['自然地','',''],['自然地理','',''],['自然学','',''],['自然数','',''],['自然数集','',''],['自然村','',''],['自然条件','',''],['自然林','',''],['自然法','',''],['自然灾害','',''],['自然环境','',''],['自然现象','',''],['自然界','',''],['自然疗法','',''],['自然码','',''],['自然神论','',''],['自然科学','',''],['自然科学史','',''],['自然科学基金会','',''],['自然科学的唯物主义','',''],['自然经济','',''],['自然美','',''],['自然而然','',''],['自然色','',''],['自然观','',''],['自然规律','',''],['自然语言','',''],['自然资源','',''],['自然辩证法','',''],['自然选择','',''],['自然铜','',''],['自然风光','',''],['自燃','',''],['自爆','',''],['自爱','',''],['自理','',''],['自甘堕落','',''],['自甘落后','',''],['自生自灭','',''],['自用','',''],['自由','',''],['自由中国','',''],['自由主义','',''],['自由亚洲电台','',''],['自由企业','',''],['自由体操','',''],['自由党','',''],['自由化','',''],['自由古巴','',''],['自由基','',''],['自由基清除剂','',''],['自由女神像','',''],['自由宪章','',''],['自由市','',''],['自由市场','',''],['自由度','',''],['自由式','',''],['自由恋爱','',''],['自由意志','',''],['自由意志主义','',''],['自由放任','',''],['自由散漫','',''],['自由权','',''],['自由民','',''],['自由民主党','',''],['自由泳','',''],['自由活动','',''],['自由派','',''],['自由港','',''],['自由漂移的状态','',''],['自由焓','',''],['自由王国','',''],['自由电子','',''],['自由神像','',''],['自由竞争','',''],['自由素食主义','',''],['自由职业','',''],['自由自在','',''],['自由落体','',''],['自由落体运动','',''],['自由行','',''],['自由行动','',''],['自由诗','',''],['自由贸易','',''],['自由贸易区','',''],['自由软件基金会','',''],['自由选择','',''],['自由选择权','',''],['自由降落','',''],['自画像','',''],['自留','',''],['自留地','',''],['自白','',''],['自白书','',''],['自白者','',''],['自的','',''],['自盗','',''],['自相','',''],['自相关','',''],['自相惊扰','',''],['自相残害','',''],['自相残杀','',''],['自相水火','',''],['自相矛盾','',''],['自相鱼肉','',''],['自省','',''],['自矜','',''],['自知','',''],['自知之明','',''],['自知理亏','',''],['自硬性','',''],['自私','',''],['自私自利','',''],['自称','',''],['自称者','',''],['自稳','',''],['自立','',''],['自立自强','',''],['自立门户','',''],['自筹','',''],['自筹资金','',''],['自繇自在','',''],['自经','',''],['自给','',''],['自给自足','',''],['自绝','',''],['自编','',''],['自编自演','',''],['自缚手脚','',''],['自缢','',''],['自罪','',''],['自耕农','',''],['自肥','',''],['自花','',''],['自花传粉','',''],['自若','',''],['自荐','',''],['自营','',''],['自营商','',''],['自行','',''],['自行其是','',''],['自行安排','',''],['自行火炮','',''],['自行设计','',''],['自行车','',''],['自行车架','',''],['自行车赛','',''],['自行车馆','',''],['自裁','',''],['自装','',''],['自西','',''],['自要','',''],['自视','',''],['自视清高','',''],['自视甚高','',''],['自觉','',''],['自觉性','',''],['自觉的能动性','',''],['自觉自愿','',''],['自觉行秽','',''],['自言自语','',''],['自认','',''],['自讨没趣','',''],['自讨苦吃','',''],['自许','',''],['自设','',''],['自诉','',''],['自诉人','',''],['自诒伊戚','',''],['自诩','',''],['自语','',''],['自诱导','',''],['自说自话','',''],['自请','',''],['自谋','',''],['自谋出路','',''],['自谋职业','',''],['自谦','',''],['自豪','',''],['自豪感','',''],['自负','',''],['自负不凡','',''],['自负盈亏','',''],['自责','',''],['自购','',''],['自费','',''],['自费生','',''],['自费留学','',''],['自贻伊戚','',''],['自赎','',''],['自走','',''],['自足','',''],['自身','',''],['自身利益','',''],['自身建设','',''],['自身难保','',''],['自转','',''],['自转轴','',''],['自轻自贱','',''],['自辱','',''],['自述','',''],['自述文件','',''],['自适应','',''],['自选','',''],['自选动作','',''],['自选商场','',''],['自选市场','',''],['自造词','',''],['自遣','',''],['自郐以下','',''],['自酌','',''],['自酿','',''],['自重','',''],['自量','',''],['自销','',''],['自闭症','',''],['自问','',''],['自雇','',''],['自顶向下','',''],['自顾','',''],['自顾不暇','',''],['自顾自','',''],['自食其力','',''],['自食其果','',''],['自食其言','',''],['自馁','',''],['自首','',''],['自驾汽车出租','',''],['自驾租赁','',''],['自高','',''],['自高自大','',''],['自鸣','',''],['自鸣得意','',''],['自鸣清高','',''],['臭不','',''],['臭不可当','',''],['臭不可闻','',''],['臭乎乎','',''],['臭事','',''],['臭名','',''],['臭名昭彰','',''],['臭名昭著','',''],['臭名远扬','',''],['臭味','',''],['臭味相投','',''],['臭子儿','',''],['臭屁','',''],['臭弹','',''],['臭架子','',''],['臭棋','',''],['臭椿','',''],['臭气','',''],['臭气熏天','',''],['臭氧','',''],['臭氧层','',''],['臭烘烘','',''],['臭熏熏','',''],['臭的','',''],['臭皮囊','',''],['臭美','',''],['臭老九','',''],['臭腺','',''],['臭虫','',''],['臭豆腐','',''],['臭迹','',''],['臭钱','',''],['臭骂','',''],['臭鱼','',''],['臭鼬','',''],['至上','',''],['至为','',''],['至于','',''],['至交','',''],['至交契友','',''],['至亲','',''],['至亲好友','',''],['至亲骨肉','',''],['至今','',''],['至今还','',''],['至公无私','',''],['至关','',''],['至关紧要','',''],['至关重要','',''],['至再至三','',''],['至善','',''],['至善至美','',''],['至圣','',''],['至多','',''],['至好','',''],['至始至终','',''],['至宝','',''],['至尊','',''],['至尊至贵','',''],['至少','',''],['至尾','',''],['至当','',''],['至德','',''],['至意诚心','',''],['至日','',''],['至极','',''],['至此','',''],['至死','',''],['至死不屈','',''],['至死不悟','',''],['至死靡他','',''],['至毒','',''],['至沓来','',''],['至爱','',''],['至理','',''],['至理名言','',''],['至矣尽矣','',''],['至终','',''],['至若','',''],['至诚','',''],['至诚无昧','',''],['至诚高节','',''],['至迟','',''],['至高','',''],['至高无上','',''],['至高统治权','',''],['至高至上','',''],['致上','',''],['致书','',''],['致于','',''],['致仕','',''],['致以','',''],['致伤','',''],['致使','',''],['致信','',''],['致公党','',''],['致冷','',''],['致冷剂','',''],['致函','',''],['致力','',''],['致力于','',''],['致命','',''],['致命伤','',''],['致和','',''],['致哀','',''],['致好','',''],['致密','',''],['致富','',''],['致意','',''],['致敬','',''],['致敬意','',''],['致敬礼','',''],['致欢','',''],['致歉','',''],['致死','',''],['致死剂量','',''],['致死性','',''],['致死性毒剂','',''],['致残','',''],['致用','',''],['致电','',''],['致畸','',''],['致病','',''],['致病菌','',''],['致癌','',''],['致癌物','',''],['致癌物质','',''],['致礼','',''],['致祝词','',''],['致胜','',''],['致良知','',''],['致词','',''],['致谢','',''],['致贺','',''],['致辞','',''],['致远任重','',''],['致邀','',''],['臻于完善','',''],['臻于郅治','',''],['臻沉沧海','',''],['臻至','',''],['臼石','',''],['臼齿','',''],['臾须','',''],['舀出','',''],['舀勺','',''],['舀子','',''],['舀水','',''],['舀汤','',''],['舀起','',''],['舅公','',''],['舅妈','',''],['舅嫂','',''],['舅子','',''],['舅母','',''],['舅父','',''],['舅爷','',''],['舅舅','',''],['舆台','',''],['舆图','',''],['舆情','',''],['舆论','',''],['舆论导向','',''],['舆论工具','',''],['舆论界','',''],['舆论监督','',''],['舆论调查','',''],['舌下','',''],['舌下含服','',''],['舌下片','',''],['舌下神经','',''],['舌下腺','',''],['舌剑唇枪','',''],['舌后','',''],['舌吻','',''],['舌咽神经','',''],['舌头','',''],['舌尖','',''],['舌尖前音','',''],['舌尖后音','',''],['舌尖音','',''],['舌尖颤音','',''],['舌干','',''],['舌战','',''],['舌敝唇焦','',''],['舌敝耳聋','',''],['舌根','',''],['舌根音','',''],['舌炎','',''],['舌片','',''],['舌状片','',''],['舌状花','',''],['舌状部','',''],['舌端','',''],['舌耕','',''],['舌苔','',''],['舌蝇','',''],['舌触','',''],['舌钉','',''],['舌锋','',''],['舌面','',''],['舌面前音','',''],['舌面后音','',''],['舌面音','',''],['舌音','',''],['舌音字','',''],['舌鳎','',''],['舍下','',''],['舍不得','',''],['舍亲','',''],['舍人','',''],['舍位','',''],['舍入','',''],['舍利','',''],['舍利塔','',''],['舍利子','',''],['舍利子塔','',''],['舍去','',''],['舍友','',''],['舍命','',''],['舍命救人','',''],['舍安就危','',''],['舍实求虚','',''],['舍己','',''],['舍己为人','',''],['舍己为公','',''],['舍己从人','',''],['舍己就人','',''],['舍己成人','',''],['舍己救人','',''],['舍己芸人','',''],['舍弃','',''],['舍弟','',''],['舍得','',''],['舍我其谁','',''],['舍我复谁','',''],['舍掉','',''],['舍本','',''],['舍本事末','',''],['舍本逐末','',''],['舍本问末','',''],['舍正从邪','',''],['舍死忘生','',''],['舍生取义','',''],['舍生存义','',''],['舍生忘死','',''],['舍监','',''],['舍短从长','',''],['舍短取长','',''],['舍短录长','',''],['舍短用长','',''],['舍给','',''],['舍身','',''],['舍身为国','',''],['舍身图报','',''],['舍身救人','',''],['舍身求法','',''],['舍车保帅','',''],['舍近','',''],['舍近务远','',''],['舍近即远','',''],['舍近求远','',''],['舍近谋远','',''],['舍间','',''],['舐犊','',''],['舐犊之爱','',''],['舐犊情深','',''],['舐食','',''],['舒卷','',''],['舒同','',''],['舒喘灵','',''],['舒坦','',''],['舒声','',''],['舒展','',''],['舒张','',''],['舒张压','',''],['舒心','',''],['舒怀','',''],['舒散','',''],['舒曼','',''],['舒服','',''],['舒梦兰','',''],['舒泰','',''],['舒淇','',''],['舒畅','',''],['舒筋活血','',''],['舒缓','',''],['舒肤佳','',''],['舒舒服服','',''],['舒适','',''],['舒适音','',''],['舒通','',''],['舒马赫','',''],['舔去','',''],['舔吮','',''],['舔犊之念','',''],['舔犊之爱','',''],['舔犊之私','',''],['舔犊情深','',''],['舔糠及米','',''],['舔阴','',''],['舔食','',''],['舛误','',''],['舜帝陵','',''],['舜日尧天','',''],['舜日尧年','',''],['舞伎','',''],['舞会','',''],['舞会舞','',''],['舞伴','',''],['舞刀','',''],['舞刀跃马','',''],['舞剑','',''],['舞剧','',''],['舞动','',''],['舞厅','',''],['舞厅舞','',''],['舞台','',''],['舞台美术','',''],['舞台艺术','',''],['舞台音乐','',''],['舞场','',''],['舞女','',''],['舞妓','',''],['舞姿','',''],['舞娘','',''],['舞客','',''],['舞师','',''],['舞弄','',''],['舞弊','',''],['舞态','',''],['舞态生风','',''],['舞手','',''],['舞技','',''],['舞抃','',''],['舞文巧法','',''],['舞文巧诋','',''],['舞文弄墨','',''],['舞文弄法','',''],['舞文枉法','',''],['舞景','',''],['舞曲','',''],['舞榭歌台','',''],['舞榭歌楼','',''],['舞步','',''],['舞水端里','',''],['舞池','',''],['舞燕歌莺','',''],['舞爪张牙','',''],['舞牙弄爪','',''],['舞狮','',''],['舞男','',''],['舞着','',''],['舞票','',''],['舞种','',''],['舞者','',''],['舞艺','',''],['舞衫歌扇','',''],['舞蹈','',''],['舞蹈家','',''],['舞蹈术','',''],['舞蹈病','',''],['舞蹈造型','',''],['舞迷','',''],['舞鞋','',''],['舞鸾歌凤','',''],['舞龙','',''],['舟中敌国','',''],['舟子','',''],['舟山群岛','',''],['舟桥','',''],['舟楫','',''],['舟车','',''],['舟车劳顿','',''],['舢板','',''],['舢舨','',''],['航务','',''],['航厦','',''],['航向','',''],['航员','',''],['航图','',''],['航天','',''],['航天中心','',''],['航天员','',''],['航天器','',''],['航天局','',''],['航天工业部','',''],['航天部','',''],['航天飞机','',''],['航宇','',''],['航徽','',''],['航拍','',''],['航政','',''],['航期','',''],['航权','',''],['航材','',''],['航标','',''],['航标灯','',''],['航校','',''],['航模','',''],['航次','',''],['航段','',''],['航母','',''],['航测','',''],['航海','',''],['航海史','',''],['航海图','',''],['航海多项运动','',''],['航海家','',''],['航海年表','',''],['航海术','',''],['航海者','',''],['航海证','',''],['航渡','',''],['航照','',''],['航班','',''],['航班表','',''],['航程','',''],['航空','',''],['航空业','',''],['航空事业','',''],['航空信','',''],['航空公司','',''],['航空兵','',''],['航空器','',''],['航空学','',''],['航空局','',''],['航空手表','',''],['航空摄影','',''],['航空摄影测量','',''],['航空术','',''],['航空植保','',''],['航空模型运动','',''],['航空母舰','',''],['航空母舰战斗群','',''],['航空港','',''],['航空病','',''],['航空站','',''],['航空线','',''],['航空自卫队','',''],['航空航天局','',''],['航空运单','',''],['航空邮件','',''],['航空队','',''],['航站','',''],['航线','',''],['航舰','',''],['航船','',''],['航行','',''],['航行于','',''],['航行率','',''],['航行者','',''],['航路','',''],['航运','',''],['航运史','',''],['航迹','',''],['航速','',''],['航道','',''],['航邮','',''],['般乐','',''],['般桓','',''],['般游','',''],['般若','',''],['般若波罗密','',''],['般若波罗密多心经','',''],['般配','',''],['般雀比拉多','',''],['舰上','',''],['舰只','',''],['舰员','',''],['舰地','',''],['舰塔','',''],['舰宽','',''],['舰岛','',''],['舰旗','',''],['舰日','',''],['舰桥','',''],['舰炮','',''],['舰空导弹','',''],['舰群','',''],['舰船','',''],['舰艇','',''],['舰载','',''],['舰载机','',''],['舰长','',''],['舰队','',''],['舰首','',''],['舰龄','',''],['舱位','',''],['舱口','',''],['舱外活动','',''],['舱室','',''],['舱底','',''],['舱房','',''],['舱盖','',''],['舱身','',''],['舱里','',''],['舱门','',''],['舱面','',''],['舳舻','',''],['舳舻千里','',''],['舳舻相接','',''],['舳舻相继','',''],['舵主','',''],['舵工','',''],['舵手','',''],['舵手室','',''],['舵把','',''],['舵旁','',''],['舵杆','',''],['舵轮','',''],['舶位','',''],['舶来品','',''],['舷侧','',''],['舷材','',''],['舷梯','',''],['舷灯','',''],['舷窗','',''],['舷窗盖','',''],['船上','',''],['船上交货','',''],['船下','',''],['船东','',''],['船中','',''],['船主','',''],['船位','',''],['船体','',''],['船侧','',''],['船内','',''],['船到桥头自然直','',''],['船到桥门','',''],['船到桥门自会直','',''],['船到江心','',''],['船到江心补漏迟','',''],['船到码头','',''],['船务','',''],['船厂','',''],['船友','',''],['船只','',''],['船台','',''],['船吃','',''],['船名','',''],['船员','',''],['船员们','',''],['船坞','',''],['船埠','',''],['船壳','',''],['船外','',''],['船夫','',''],['船头','',''],['船客','',''],['船室','',''],['船家','',''],['船尾','',''],['船尾座','',''],['船山','',''],['船工','',''],['船帆','',''],['船帆座','',''],['船帮','',''],['船床','',''],['船底','',''],['船底座','',''],['船形','',''],['船户','',''],['船支','',''],['船政大臣','',''],['船政学堂','',''],['船政局','',''],['船方','',''],['船期','',''],['船材','',''],['船板','',''],['船桅','',''],['船桨','',''],['船梁','',''],['船梯','',''],['船模','',''],['船歌','',''],['船民','',''],['船浆','',''],['船状','',''],['船票','',''],['船篷','',''],['船籍','',''],['船籍港','',''],['船索','',''],['船级','',''],['船缆','',''],['船老大','',''],['船者','',''],['船腹','',''],['船舰','',''],['船舱','',''],['船舵','',''],['船舶','',''],['船舶人造卫星导航','',''],['船舶奥米加导航','',''],['船舶避碰雷达','',''],['船舷','',''],['船艇','',''],['船艇勤务','',''],['船营','',''],['船蛆','',''],['船货','',''],['船身','',''],['船载','',''],['船边','',''],['船运','',''],['船运业','',''],['船钱','',''],['船长','',''],['船闸','',''],['船队','',''],['船首','',''],['船首舱','',''],['船龄','',''],['舾装','',''],['艄公','',''],['艅艎','',''],['艇甲板','',''],['艇长','',''],['艚子','',''],['艨冲','',''],['艨艟','',''],['良久','',''],['良乡','',''],['良人','',''],['良医','',''],['良友','',''],['良吉','',''],['良善','',''],['良图','',''],['良多','',''],['良好','',''],['良宵','',''],['良宵好景','',''],['良宵美景','',''],['良家','',''],['良家女子','',''],['良导体','',''],['良将','',''],['良工心苦','',''],['良师','',''],['良师益友','',''],['良庆','',''],['良心','',''],['良心未泯','',''],['良心犯','',''],['良性','',''],['良性循环','',''],['良性肿瘤','',''],['良方','',''],['良时美景','',''],['良机','',''],['良材','',''],['良桐','',''],['良民','',''],['良民证','',''],['良渚','',''],['良渚文化','',''],['良港','',''],['良物','',''],['良田','',''],['良癞虾蟆','',''],['良知','',''],['良知良能','',''],['良禽择木','',''],['良禽择木而栖','',''],['良种','',''],['良种繁育','',''],['良策','',''],['良缘','',''],['良苦','',''],['良苦用心','',''],['良药','',''],['良药苦口','',''],['良莠','',''],['良莠不一','',''],['良莠不分','',''],['良莠不齐','',''],['良莠淆杂','',''],['良言','',''],['良质美手','',''],['良辰','',''],['良辰吉日','',''],['良辰媚景','',''],['良辰美景','',''],['良金美玉','',''],['良马','',''],['艰危','',''],['艰困','',''],['艰巨','',''],['艰巨性','',''],['艰涩','',''],['艰深','',''],['艰深晦涩','',''],['艰苦','',''],['艰苦创业','',''],['艰苦卓绝','',''],['艰苦奋斗','',''],['艰苦朴素','',''],['艰贞','',''],['艰辛','',''],['艰险','',''],['艰难','',''],['艰难困苦','',''],['艰难曲折','',''],['艰难竭蹶','',''],['艰难险阻','',''],['色不迷人人自迷','',''],['色令智昏','',''],['色光','',''],['色卡','',''],['色厉内荏','',''],['色厉词严','',''],['色原体','',''],['色友','',''],['色味','',''],['色域','',''],['色基','',''],['色夷','',''],['色子','',''],['色字头上一把刀','',''],['色差','',''],['色布','',''],['色带','',''],['色度','',''],['色度学','',''],['色度计','',''],['色弱','',''],['色当','',''],['色彩','',''],['色彩斑斓','',''],['色彩缤纷','',''],['色彩论','',''],['色性','',''],['色情','',''],['色情业','',''],['色情作品','',''],['色情小说','',''],['色情片','',''],['色情狂','',''],['色拉','',''],['色拉寺','',''],['色拉油','',''],['色拉酱','',''],['色授魂与','',''],['色散','',''],['色斑','',''],['色料','',''],['色条','',''],['色板','',''],['色样','',''],['色欲','',''],['色氨酸','',''],['色泽','',''],['色浅','',''],['色浆','',''],['色淡','',''],['色灯','',''],['色片','',''],['色版','',''],['色狼','',''],['色球','',''],['色盅','',''],['色目','',''],['色目人','',''],['色盲','',''],['色相','',''],['色笔','',''],['色素','',''],['色素体','',''],['色胆','',''],['色胆如天','',''],['色胆迷天','',''],['色胺酸','',''],['色色俱全','',''],['色色迷迷','',''],['色艺两绝','',''],['色艺无双','',''],['色艺绝轮','',''],['色若死灰','',''],['色荒','',''],['色衰','',''],['色衰爱寝','',''],['色衰爱驰','',''],['色觉','',''],['色诱','',''],['色调','',''],['色谱','',''],['色谱仪','',''],['色谱分析','',''],['色边','',''],['色迷','',''],['色酒','',''],['色釉','',''],['色钟','',''],['色键','',''],['色长','',''],['色飞眉舞','',''],['色香味','',''],['色香味俱全','',''],['色鬼','',''],['色魔','',''],['艳丽','',''],['艳丽夺目','',''],['艳冶','',''],['艳史','',''],['艳如桃李','',''],['艳情','',''],['艳曲淫词','',''],['艳福','',''],['艳红色','',''],['艳绝一时','',''],['艳美无敌','',''],['艳羡','',''],['艳舞','',''],['艳色','',''],['艳色绝世','',''],['艳色耀目','',''],['艳诗','',''],['艳遇','',''],['艳阳','',''],['艳阳天','',''],['艺人','',''],['艺伎','',''],['艺匠','',''],['艺名','',''],['艺员','',''],['艺品','',''],['艺圃','',''],['艺场','',''],['艺坛','',''],['艺妓','',''],['艺廊','',''],['艺徒','',''],['艺文志','',''],['艺术','',''],['艺术中心','',''],['艺术交流','',''],['艺术享受','',''],['艺术价值','',''],['艺术体操','',''],['艺术作品','',''],['艺术修养','',''],['艺术创作','',''],['艺术品','',''],['艺术团','',''],['艺术境界','',''],['艺术大师','',''],['艺术学院','',''],['艺术家','',''],['艺术形式','',''],['艺术形象','',''],['艺术性','',''],['艺术感染','',''],['艺术水平','',''],['艺术流派','',''],['艺术片','',''],['艺术界','',''],['艺术节','',''],['艺术表演','',''],['艺术造街','',''],['艺术风格','',''],['艺术馆','',''],['艺林','',''],['艺校','',''],['艺渎','',''],['艺界','',''],['艺美','',''],['艺能','',''],['艺苑','',''],['艺苑奇葩','',''],['艺高','',''],['艺龄','',''],['艾丁湖','',''],['艾伦','',''],['艾伯塔','',''],['艾兹病','',''],['艾冬花','',''],['艾卷','',''],['艾叶','',''],['艾叶油','',''],['艾叶炭','',''],['艾哈迈德','',''],['艾哈迈德阿巴德','',''],['艾哈迈达巴德','',''],['艾哈迈迪内贾德','',''],['艾塔','',''],['艾奇逊','',''],['艾奥瓦','',''],['艾奥瓦州','',''],['艾子','',''],['艾实','',''],['艾尔伯塔','',''],['艾尔米塔什','',''],['艾尔米塔奇','',''],['艾弥尔','',''],['艾德蒙顿','',''],['艾德蕾德','',''],['艾扑西龙','',''],['艾未未','',''],['艾条','',''],['艾条温和灸','',''],['艾条灸','',''],['艾条雀啄灸','',''],['艾格尼丝・史沫特莱','',''],['艾森豪威尔','',''],['艾森豪威尔主义','',''],['艾比湖','',''],['艾滋','',''],['艾滋病','',''],['艾滋病患者','',''],['艾滋病抗体','',''],['艾滋病毒','',''],['艾滋病病毒','',''],['艾灸','',''],['艾炭','',''],['艾炷','',''],['艾炷灸','',''],['艾片','',''],['艾玛纽埃尔','',''],['艾登堡','',''],['艾窝窝','',''],['艾纳香','',''],['艾绒','',''],['艾美奖','',''],['艾艾','',''],['艾草','',''],['艾莉丝','',''],['艾菲尔铁塔','',''],['艾萨克','',''],['艾萨克・牛顿','',''],['艾蒿','',''],['艾赛克斯','',''],['艾迪','',''],['艾迪卡拉','',''],['艾迪生','',''],['艾附暖宫丸','',''],['艾青','',''],['节上生枝','',''],['节下','',''],['节令','',''],['节会','',''],['节余','',''],['节俭','',''],['节俭人','',''],['节俭力行','',''],['节俭躬行','',''],['节候','',''],['节假日','',''],['节减','',''],['节制','',''],['节制生育','',''],['节制资本','',''],['节前','',''],['节后','',''],['节哀','',''],['节哀顺变','',''],['节团','',''],['节外生枝','',''],['节多','',''],['节头','',''],['节奏','',''],['节奏布鲁斯','',''],['节奏性','',''],['节奏感','',''],['节子','',''],['节庆','',''],['节度','',''],['节度使','',''],['节录','',''],['节律','',''],['节拍','',''],['节拍器','',''],['节操','',''],['节支','',''],['节支动物','',''],['节日','',''],['节时','',''],['节期','',''],['节本','',''],['节棍','',''],['节欲','',''],['节气','',''],['节气门','',''],['节水','',''],['节水型','',''],['节油','',''],['节流','',''],['节流踏板','',''],['节流阀','',''],['节点','',''],['节烈','',''],['节煤','',''],['节煤型','',''],['节片','',''],['节理','',''],['节用','',''],['节用厚生','',''],['节用爱人','',''],['节用裕民','',''],['节电','',''],['节略','',''],['节略本','',''],['节疤','',''],['节瘤','',''],['节目','',''],['节目主持人','',''],['节目单','',''],['节省','',''],['节省时间','',''],['节约','',''],['节约者','',''],['节肢','',''],['节肢介体病毒','',''],['节肢动物','',''],['节育','',''],['节能','',''],['节能型','',''],['节能灯','',''],['节能降耗','',''],['节节','',''],['节节下挫','',''],['节节溃退','',''],['节节胜利','',''],['节节败退','',''],['节虫','',''],['节衣缩食','',''],['节足动物','',''],['节距','',''],['节车','',''],['节述','',''],['节选','',''],['节间','',''],['节阀','',''],['节食','',''],['节食缩衣','',''],['节骨眼','',''],['节骨眼儿','',''],['芊眠','',''],['芊绵','',''],['芊芊','',''],['芊萰','',''],['芋圆','',''],['芋头','',''],['芋泥','',''],['芋艿','',''],['芋螺毒素','',''],['芍药','',''],['芍陂','',''],['芎林','',''],['芎林乡','',''],['芎藭','',''],['芒刺','',''],['芒刺在背','',''],['芒剌','',''],['芒寒色正','',''],['芒果','',''],['芒果汁','',''],['芒涸魂汤','',''],['芒然自失','',''],['芒硝','',''],['芒芒苦海','',''],['芗剧','',''],['芗城','',''],['芙蓉','',''],['芙蓉出水','',''],['芙蓉国','',''],['芙蓉花','',''],['芙蕖','',''],['芜俚','',''],['芜劣','',''],['芜杂','',''],['芜秽','',''],['芜累','',''],['芜繁','',''],['芜菁','',''],['芜菁甘蓝','',''],['芜词','',''],['芜鄙','',''],['芜驳','',''],['芝兰','',''],['芝兰之室','',''],['芝兰玉树','',''],['芝加哥','',''],['芝加哥大学','',''],['芝加哥市','',''],['芝士','',''],['芝士蛋糕','',''],['芝宇','',''],['芝焚蕙叹','',''],['芝罘','',''],['芝艾俱尽','',''],['芝麻','',''],['芝麻包','',''],['芝麻官','',''],['芝麻油','',''],['芝麻酱','',''],['芝麻饼','',''],['芟夷','',''],['芟秋','',''],['芟繁就简','',''],['芟荑','',''],['芟除','',''],['芡实','',''],['芡粉','',''],['芤脉','',''],['芥兰','',''],['芥兰牛肉','',''],['芥子','',''],['芥子气','',''],['芥子气伪膜','',''],['芥子气恶病质','',''],['芥子气水疱','',''],['芥末','',''],['芥菜','',''],['芥菜型油菜','',''],['芥菜类蔬菜','',''],['芥菜籽','',''],['芥蒂','',''],['芥蓝','',''],['芥蓝菜','',''],['芦席','',''],['芦木','',''],['芦柑','',''],['芦柴','',''],['芦柴棒','',''],['芦根','',''],['芦沟桥','',''],['芦沟桥事变','',''],['芦洲','',''],['芦洲市','',''],['芦竹','',''],['芦竹乡','',''],['芦笋','',''],['芦笙','',''],['芦笙舞','',''],['芦笛','',''],['芦管','',''],['芦花','',''],['芦花黄雀','',''],['芦苇','',''],['芦苇状','',''],['芦荟','',''],['芦荻','',''],['芨芨草','',''],['芫花','',''],['芫花素','',''],['芫荽','',''],['芫荽叶','',''],['芬兰乌','',''],['芬兰人','',''],['芬兰战争','',''],['芬兰语','',''],['芬园','',''],['芬园乡','',''],['芬芬','',''],['芬芳','',''],['芬香','',''],['芭乐','',''],['芭乐票','',''],['芭提雅','',''],['芭比','',''],['芭芭拉','',''],['芭菲','',''],['芭蕉','',''],['芭蕉扇','',''],['芭蕉芋','',''],['芭蕾','',''],['芭蕾舞','',''],['芭达雅','',''],['芮氏','',''],['芮氏规模','',''],['芯件','',''],['芯子','',''],['芯片','',''],['芯片组','',''],['花上','',''],['花不棱登','',''],['花丛','',''],['花丝','',''],['花了','',''],['花仙子','',''],['花会','',''],['花似','',''],['花俏','',''],['花儿','',''],['花儿匠','',''],['花儿样子','',''],['花儿洞子','',''],['花儿针','',''],['花光','',''],['花农','',''],['花冠','',''],['花分','',''],['花到','',''],['花刺','',''],['花前月下','',''],['花剑','',''],['花匠','',''],['花卉','',''],['花卷','',''],['花厂','',''],['花厅','',''],['花去','',''],['花县','',''],['花台','',''],['花名','',''],['花名册','',''],['花呢','',''],['花哨','',''],['花商','',''],['花团','',''],['花团锦簇','',''],['花园','',''],['花园口','',''],['花园口决堤事件','',''],['花圃','',''],['花圈','',''],['花在','',''],['花地玛堂区','',''],['花坊','',''],['花坛','',''],['花坛乡','',''],['花墙','',''],['花大姐','',''],['花天百日红','',''],['花天酒地','',''],['花头','',''],['花好月圆','',''],['花媳妇儿','',''],['花子','',''],['花子儿','',''],['花季','',''],['花完','',''],['花容','',''],['花容月貌','',''],['花展','',''],['花山','',''],['花岗岩','',''],['花岗石','',''],['花巧','',''],['花市','',''],['花布','',''],['花帐','',''],['花床','',''],['花序','',''],['花店','',''],['花开','',''],['花开了','',''],['花开著','',''],['花式','',''],['花彩','',''],['花径','',''],['花得','',''],['花心','',''],['花心思','',''],['花户','',''],['花房','',''],['花托','',''],['花扦儿','',''],['花把势','',''],['花把式','',''],['花押','',''],['花招','',''],['花括号','',''],['花拳','',''],['花拳绣腿','',''],['花掉','',''],['花插','',''],['花搭着','',''],['花斑','',''],['花斑癣','',''],['花料','',''],['花旗','',''],['花旗参','',''],['花旗国','',''],['花旗银行','',''],['花无百日红','',''],['花旦','',''],['花时间','',''],['花明柳暗','',''],['花晨月夕','',''],['花朝','',''],['花朝月夕','',''],['花朝月夜','',''],['花朝节','',''],['花期','',''],['花木','',''],['花木兰','',''],['花木瓜','',''],['花朵','',''],['花束','',''],['花果','',''],['花果山','',''],['花枝','',''],['花枝招展','',''],['花枪','',''],['花架','',''],['花架子','',''],['花柱','',''],['花柳','',''],['花柳病','',''],['花栗鼠','',''],['花样','',''],['花样游泳','',''],['花样滑冰','',''],['花样翻新','',''],['花梗','',''],['花梨','',''],['花棍舞','',''],['花棒','',''],['花棚','',''],['花椒','',''],['花椰菜','',''],['花榈木','',''],['花残月缺','',''],['花池','',''],['花池子','',''],['花洒','',''],['花海','',''],['花消','',''],['花溪','',''],['花火','',''],['花灯','',''],['花灯戏','',''],['花炮','',''],['花点子','',''],['花烛','',''],['花烛洞房','',''],['花状','',''],['花王','',''],['花环','',''],['花瓣','',''],['花瓶','',''],['花生','',''],['花生油','',''],['花生浆','',''],['花生秀','',''],['花生米','',''],['花生豆儿','',''],['花生酱','',''],['花生饼','',''],['花用','',''],['花甲','',''],['花痴','',''],['花白','',''],['花的','',''],['花盆','',''],['花盒','',''],['花盘','',''],['花眼','',''],['花着','',''],['花石','',''],['花石峡','',''],['花石峡镇','',''],['花种','',''],['花科','',''],['花童','',''],['花筒','',''],['花篮','',''],['花簇','',''],['花簇锦攒','',''],['花簇锦簇','',''],['花籽','',''],['花粉','',''],['花粉热','',''],['花粉症','',''],['花粉管','',''],['花粉篮','',''],['花粉过敏','',''],['花糕','',''],['花絮','',''],['花红','',''],['花红柳绿','',''],['花纱布','',''],['花纹','',''],['花结','',''],['花缎','',''],['花胜','',''],['花脸','',''],['花腔','',''],['花般','',''],['花色','',''],['花色品种','',''],['花色繁多','',''],['花艺','',''],['花花','',''],['花花世界','',''],['花花公子','',''],['花花太岁','',''],['花花搭搭','',''],['花花绿绿','',''],['花花肠子','',''],['花芽','',''],['花苗','',''],['花苞','',''],['花茎','',''],['花茶','',''],['花草','',''],['花草树木','',''],['花药','',''],['花菜','',''],['花萼','',''],['花蒂','',''],['花蕊','',''],['花蕾','',''],['花虫','',''],['花虫类','',''],['花蛋','',''],['花蛤','',''],['花蜜','',''],['花街','',''],['花街柳巷','',''],['花街柳陌','',''],['花衣','',''],['花衫','',''],['花被','',''],['花言','',''],['花言巧语','',''],['花豹','',''],['花貌蓬心','',''],['花费','',''],['花费者','',''],['花车','',''],['花轴','',''],['花轿','',''],['花边','',''],['花边人物','',''],['花边儿','',''],['花边新闻','',''],['花遮柳掩','',''],['花遮柳隐','',''],['花都','',''],['花酒','',''],['花里胡哨','',''],['花钱','',''],['花钱找罪受','',''],['花销','',''],['花键','',''],['花镜','',''],['花门柳户','',''],['花闭月羞','',''],['花障','',''],['花雕','',''],['花露','',''],['花露水','',''],['花青素','',''],['花面狸','',''],['花项','',''],['花须','',''],['花颜月貌','',''],['花饰','',''],['花香','',''],['花香鸟语','',''],['花骨朵','',''],['花魁','',''],['花魔酒病','',''],['花鲢','',''],['花鲫鱼','',''],['花鸟','',''],['花鸟画','',''],['花鸡','',''],['花黄','',''],['花鼓','',''],['花鼓戏','',''],['花鼓舞','',''],['芳兰竟体','',''],['芳华','',''],['芳名','',''],['芳容','',''],['芳心','',''],['芳札','',''],['芳泽','',''],['芳烃','',''],['芳筵','',''],['芳苑','',''],['芳苑乡','',''],['芳草','',''],['芳菲','',''],['芳踪','',''],['芳醇','',''],['芳香','',''],['芳香族','',''],['芳香族化合物','',''],['芳香油','',''],['芳香烃','',''],['芳香环','',''],['芳香疗法','',''],['芳香醋','',''],['芳龄','',''],['芷江','',''],['芷江县','',''],['芸芸','',''],['芸芸众生','',''],['芸苔子','',''],['芸苔属','',''],['芸薹','',''],['芸薹属','',''],['芸豆','',''],['芸阁','',''],['芸香','',''],['芹菜','',''],['芽体','',''],['芽型','',''],['芽孢','',''],['芽接','',''],['芽眼','',''],['芽胞','',''],['芽苗','',''],['芽茶','',''],['芽虫','',''],['芽豆','',''],['苁蓉','',''],['苄基','',''],['苄胺','',''],['苇塘','',''],['苇子','',''],['苇席','',''],['苇箔','',''],['苋科','',''],['苋菜','',''],['苌弘化碧','',''],['苌楚','',''],['苍冥','',''],['苍凉','',''],['苍劲','',''],['苍天','',''],['苍头','',''],['苍惶','',''],['苍术','',''],['苍松','',''],['苍松翠柏','',''],['苍桑','',''],['苍民','',''],['苍海','',''],['苍生','',''],['苍生涂炭','',''],['苍白','',''],['苍白无力','',''],['苍白色','',''],['苍穹','',''],['苍翠','',''],['苍翠繁茂','',''],['苍老','',''],['苍耳','',''],['苍苍','',''],['苍茫','',''],['苍莽','',''],['苍蝇','',''],['苍蝇座','',''],['苍蝇拍','',''],['苍蝇拍子','',''],['苍蝇见血','',''],['苍郁','',''],['苍铅','',''],['苍颜','',''],['苍鹭','',''],['苍鹰','',''],['苍黄','',''],['苍黄翻覆','',''],['苍龙','',''],['苎麻','',''],['苏东坡','',''],['苏中','',''],['苏丹人','',''],['苏仙','',''],['苏伊士','',''],['苏伊士河','',''],['苏伊士运河','',''],['苏俄','',''],['苏克雷','',''],['苏共','',''],['苏共中央','',''],['苏军','',''],['苏剧','',''],['苏北','',''],['苏区','',''],['苏占区','',''],['苏台德地区','',''],['苏合香','',''],['苏哈托','',''],['苏堤','',''],['苏姆盖特','',''],['苏子','',''],['苏家屯','',''],['苏富比','',''],['苏尔','',''],['苏州地区','',''],['苏州大学','',''],['苏州河','',''],['苏州码子','',''],['苏州话','',''],['苏必利尔湖','',''],['苏打','',''],['苏打水','',''],['苏打粉','',''],['苏打饼干','',''],['苏报案','',''],['苏拉威西','',''],['苏方','',''],['苏日','',''],['苏易简','',''],['苏木','',''],['苏杭','',''],['苏枋','',''],['苏枋木','',''],['苏格兰人','',''],['苏格兰场','',''],['苏格兰女王玛丽','',''],['苏格兰帽','',''],['苏格兰折耳猫','',''],['苏格拉底','',''],['苏步青','',''],['苏武','',''],['苏氨酸','',''],['苏洵','',''],['苏海韩潮','',''],['苏澳','',''],['苏澳镇','',''],['苏珊','',''],['苏珊・波伊尔','',''],['苏瓦','',''],['苏白','',''],['苏禄','',''],['苏秦','',''],['苏绣','',''],['苏维埃','',''],['苏维埃俄国','',''],['苏维埃社会主义共和国联盟','',''],['苏美','',''],['苏美尔','',''],['苏联之友社','',''],['苏联人','',''],['苏联共产党','',''],['苏联卢布','',''],['苏联卫国战争','',''],['苏联最高苏维埃','',''],['苏胺酸','',''],['苏莱曼','',''],['苏菜','',''],['苏菲','',''],['苏西洛','',''],['苏贞昌','',''],['苏轼','',''],['苏辙','',''],['苏迪曼杯','',''],['苏醒','',''],['苏醒剂','',''],['苏里南河','',''],['苏金达','',''],['苏铁','',''],['苏门答腊','',''],['苏门答腊岛','',''],['苏门达腊','',''],['苏非主义','',''],['苏黎世','',''],['苏黎世联邦理工学院','',''],['苏黎士','',''],['苑里','',''],['苑里镇','',''],['苒弱','',''],['苒苒','',''],['苓雅','',''],['苓雅区','',''],['苔丝','',''],['苔原','',''],['苔癣','',''],['苔藓','',''],['苔藓植物','',''],['苔衣','',''],['苕子','',''],['苗人','',''],['苗儿','',''],['苗圃','',''],['苗头','',''],['苗子','',''],['苗家','',''],['苗床','',''],['苗期','',''],['苗木','',''],['苗条','',''],['苗种','',''],['苗而不秀','',''],['苗芽','',''],['苗苗','',''],['苗裔','',''],['苗距','',''],['苘麻','',''],['苛刻','',''],['苛吏','',''],['苛察','',''],['苛征','',''],['苛待','',''],['苛性碱','',''],['苛性钠','',''],['苛性钾','',''],['苛捐','',''],['苛捐杂税','',''],['苛政','',''],['苛政猛于虎','',''],['苛敛','',''],['苛斥','',''],['苛杂','',''],['苛求','',''],['苛细','',''],['苛薄','',''],['苛评','',''],['苛评家','',''],['苛责','',''],['苜蓿','',''],['苞片','',''],['苞米','',''],['苞米棒子','',''],['苞粟','',''],['苞苴','',''],['苞苴公行','',''],['苞苴竿牍','',''],['苞苴贿赂','',''],['苞藏祸心','',''],['苞谷','',''],['苟且','',''],['苟且偷安','',''],['苟且偷生','',''],['苟全','',''],['苟合','',''],['苟合取容','',''],['苟同','',''],['苟存','',''],['苟安','',''],['苟安一隅','',''],['苟延残喘','',''],['苟延残息','',''],['苟活','',''],['苟留残喘','',''],['苟简','',''],['苣荬菜','',''],['苤蓝','',''],['若不','',''],['若且','',''],['若且唯若','',''],['若丧考妣','',''],['若为','',''],['若以','',''],['若何','',''],['若你','',''],['若使','',''],['若出一辙','',''],['若即若离','',''],['若合符节','',''],['若在','',''],['若夫','',''],['若将','',''],['若干','',''],['若干个','',''],['若开山脉','',''],['若想','',''],['若按','',''],['若敖鬼馁','',''],['若数家珍','',''],['若无','',''],['若无其事','',''],['若时','',''],['若明若暗','',''],['若昧平生','',''],['若是','',''],['若有','',''],['若有所丧','',''],['若有所亡','',''],['若有所失','',''],['若有所思','',''],['若有若无','',''],['若望','',''],['若望福音','',''],['若果','',''],['若然','',''],['若然不报时晨未到','',''],['若真','',''],['若翰','',''],['若虫','',''],['若要','',''],['若要人不知','',''],['若释重负','',''],['若问','',''],['若隐若显','',''],['若隐若现','',''],['若非','',''],['若饥若渴','',''],['若骛','',''],['苦丁茶','',''],['苦不可言','',''],['苦不唧','',''],['苦不唧儿','',''],['苦不堪言','',''],['苦不聊生','',''],['苦中作乐','',''],['苦主','',''],['苦乐','',''],['苦争恶战','',''],['苦事','',''],['苦于','',''],['苦人','',''],['苦修','',''],['苦僧','',''],['苦况','',''],['苦刑','',''],['苦力','',''],['苦劝','',''],['苦功','',''],['苦劳','',''],['苦卤','',''],['苦参','',''],['苦口','',''],['苦口婆心','',''],['苦口逆耳','',''],['苦味','',''],['苦味酸','',''],['苦命','',''],['苦哈哈','',''],['苦因','',''],['苦境','',''],['苦处','',''],['苦夏','',''],['苦大仇深','',''],['苦头','',''],['苦学','',''],['苦守','',''],['苦害','',''],['苦寒','',''],['苦尽','',''],['苦尽焦思','',''],['苦尽甘来','',''],['苦尽甜来','',''],['苦工','',''],['苦差','',''],['苦差事','',''],['苦干','',''],['苦役','',''],['苦待','',''],['苦心','',''],['苦心孤诣','',''],['苦心极力','',''],['苦心焦思','',''],['苦心竭力','',''],['苦心经营','',''],['苦怔恶战','',''],['苦思','',''],['苦思冥想','',''],['苦思恶想','',''],['苦思苦想','',''],['苦恋','',''],['苦恼','',''],['苦情','',''],['苦想','',''],['苦感','',''],['苦戏','',''],['苦战','',''],['苦挣','',''],['苦斗','',''],['苦杏仁苷','',''],['苦果','',''],['苦根','',''],['苦楚','',''],['苦楝','',''],['苦槠','',''],['苦水','',''],['苦汁','',''],['苦求','',''],['苦活','',''],['苦活儿','',''],['苦海','',''],['苦海无涯','',''],['苦海无边','',''],['苦海茫茫','',''],['苦涩','',''],['苦熬','',''],['苦爱','',''],['苦瓜','',''],['苦瓜脸','',''],['苦甘','',''],['苦痛','',''],['苦的','',''],['苦相','',''],['苦竹','',''],['苦笑','',''],['苦累','',''],['苦练','',''],['苦肉计','',''],['苦胆','',''],['苦脸','',''],['苦艾','',''],['苦艾酒','',''],['苦苓','',''],['苦苣','',''],['苦苦','',''],['苦苦哀求','',''],['苦荬菜','',''],['苦菊','',''],['苦菜花','',''],['苦薄荷','',''],['苦蘵','',''],['苦行','',''],['苦行僧','',''],['苦行赎罪','',''],['苦衷','',''],['苦话','',''],['苦读','',''],['苦谏','',''],['苦趣','',''],['苦辣','',''],['苦迭打','',''],['苦酒','',''],['苦闷','',''],['苦难','',''],['苦难深重','',''],['苦集灭道','',''],['苦雨','',''],['苦雨凄风','',''],['苫布','',''],['苫眼铺眉','',''],['苫背','',''],['苯丙氨酸','',''],['苯丙胺','',''],['苯中毒','',''],['苯乙烯','',''],['苯基','',''],['苯并噻吩','',''],['苯氧基','',''],['苯氨','',''],['苯环','',''],['苯甲基','',''],['苯甲酰氯','',''],['苯甲酸','',''],['苯甲酸钠','',''],['苯甲醛','',''],['苯胺','',''],['苯那辛','',''],['苯酚','',''],['苯酮尿症','',''],['英两','',''],['英亩','',''],['英亩数','',''],['英人','',''],['英仙座','',''],['英仙臂','',''],['英代尔','',''],['英伟达','',''],['英伦','',''],['英俊','',''],['英俚','',''],['英军','',''],['英制','',''],['英制支数','',''],['英勇','',''],['英勇善战','',''],['英勇斗争','',''],['英勇牺牲','',''],['英勇献身','',''],['英华','',''],['英史','',''],['英吉利','',''],['英吉利海峡','',''],['英名','',''],['英吨','',''],['英哩','',''],['英中','',''],['英国人','',''],['英国女王','',''],['英国广播公司','',''],['英国广播电台','',''],['英国式','',''],['英国文化协会','',''],['英国电讯公司','',''],['英国皇家学会','',''],['英国石油','',''],['英国石油公司','',''],['英国管','',''],['英国资产阶级革命','',''],['英声茂实','',''],['英姿','',''],['英姿迈往','',''],['英姿飒爽','',''],['英子','',''],['英宗','',''],['英寸','',''],['英寻','',''],['英尺','',''],['英尺高','',''],['英属','',''],['英属哥伦比亚','',''],['英布战争','',''],['英年','',''],['英年早逝','',''],['英式','',''],['英式橄榄球','',''],['英式足球','',''],['英才','',''],['英担','',''],['英方','',''],['英明','',''],['英明果断','',''],['英杰','',''],['英格兰人','',''],['英格兰银行','',''],['英模','',''],['英模事迹','',''],['英模代表','',''],['英武','',''],['英气','',''],['英汉','',''],['英汉对译','',''],['英汉通','',''],['英法','',''],['英灵','',''],['英烈','',''],['英特','',''],['英特尔','',''],['英特网','',''],['英特耐雄纳尔','',''],['英特迈往','',''],['英王','',''],['英石','',''],['英美','',''],['英联合王国','',''],['英联邦','',''],['英译','',''],['英译本','',''],['英语分词','',''],['英语化','',''],['英语学','',''],['英语教学','',''],['英语热','',''],['英语角','',''],['英豪','',''],['英货币','',''],['英超','',''],['英超赛','',''],['英里','',''],['英镑','',''],['英雄','',''],['英雄主义','',''],['英雄事迹','',''],['英雄人物','',''],['英雄好汉','',''],['英雄式','',''],['英雄形象','',''],['英雄所见略同','',''],['英雄无用武之地','',''],['英雄有用武之地','',''],['英雄模范','',''],['英雄气短','',''],['英雄短气','',''],['英雄辈出','',''],['英雄难过美人关','',''],['英魂','',''],['苴麻','',''],['苷酸','',''],['苹果','',''],['苹果公司','',''],['苹果手机','',''],['苹果核','',''],['苹果汁','',''],['苹果派','',''],['苹果渣','',''],['苹果电脑','',''],['苹果类','',''],['苹果绿','',''],['苹果蠹蛾','',''],['苹果酒','',''],['苹果酱','',''],['苹果饼','',''],['苹果馅饼','',''],['茀星','',''],['茁壮','',''],['茁壮成长','',''],['茁实','',''],['茁长','',''],['茁长素','',''],['茂亲','',''],['茂南','',''],['茂实英声','',''],['茂密','',''],['茂才','',''],['茂林','',''],['茂林乡','',''],['茂汶县','',''],['茂港','',''],['茂物','',''],['茂盛','',''],['茂竹','',''],['范仲淹','',''],['范例','',''],['范公偁','',''],['范围','',''],['范围内','',''],['范围广','',''],['范围是','',''],['范式','',''],['范张鸡黍','',''],['范德格拉夫','',''],['范德格拉夫起电机','',''],['范德瓦耳斯','',''],['范德瓦耳斯力','',''],['范志毅','',''],['范性','',''],['范性材料','',''],['范文','',''],['范斯坦','',''],['范晔','',''],['范本','',''],['范特西','',''],['范玮琪','',''],['范畴','',''],['范畴索引','',''],['范畴论','',''],['范缜','',''],['范蠡','',''],['茄二十八星瓢虫','',''],['茄克','',''],['茄克衫','',''],['茄子','',''],['茄果类蔬菜','',''],['茄科','',''],['茄红素','',''],['茄萣','',''],['茄萣乡','',''],['茅以升','',''],['茅厕','',''],['茅台','',''],['茅台酒','',''],['茅坑','',''],['茅塞','',''],['茅塞顿开','',''],['茅室土阶','',''],['茅屋','',''],['茅屋顶','',''],['茅庐','',''],['茅房','',''],['茅棚','',''],['茅盾','',''],['茅盾文学奖','',''],['茅箭','',''],['茅膏菜','',''],['茅舍','',''],['茅芦三顾','',''],['茅茨土阶','',''],['茅草','',''],['茉莉','',''],['茉莉花','',''],['茉莉花茶','',''],['茉莉菊酯','',''],['茎干','',''],['茎柄','',''],['茏葱','',''],['茑萝','',''],['茕茕','',''],['茕茕孑立','',''],['茕茕孤立','',''],['茗茶','',''],['茗葱','',''],['茜素','',''],['茜紫','',''],['茜草','',''],['茧丝','',''],['茧丝牛毛','',''],['茧儿','',''],['茧子','',''],['茧绸','',''],['茧衣','',''],['茨万吉拉伊','',''],['茨冈人','',''],['茨城','',''],['茨城县','',''],['茨欣瓦利','',''],['茨菰','',''],['茫崖','',''],['茫崖区','',''],['茫崖行政区','',''],['茫崖行政委员会','',''],['茫无头绪','',''],['茫若星河','',''],['茫昧','',''],['茫然','',''],['茫然不解','',''],['茫然失措','',''],['茫然自失','',''],['茫然若失','',''],['茫然若迷','',''],['茫然费解','',''],['茫茫','',''],['茫茫然','',''],['茫茫苦海','',''],['茬口','',''],['茬地','',''],['茬子','',''],['茭白','',''],['茯苓','',''],['茱莉亚','',''],['茱莉娅','',''],['茱莉雅','',''],['茱莉雅・吉拉德','',''],['茱萸','',''],['茳芏','',''],['茴芹','',''],['茴香','',''],['茴香籽','',''],['茵芋','',''],['茵陈蒿','',''],['茶亭','',''],['茶会','',''],['茶余酒后','',''],['茶余饭后','',''],['茶余饭饱','',''],['茶具','',''],['茶农','',''],['茶几','',''],['茶包','',''],['茶匙','',''],['茶博士','',''],['茶卤儿','',''],['茶叙会','',''],['茶叶','',''],['茶叶末儿','',''],['茶叶罐','',''],['茶叶花','',''],['茶叶蛋','',''],['茶味','',''],['茶商','',''],['茶园','',''],['茶场','',''],['茶坊','',''],['茶壶','',''],['茶壶嘴','',''],['茶室','',''],['茶宴','',''],['茶山','',''],['茶巾','',''],['茶市','',''],['茶庄','',''],['茶座','',''],['茶房','',''],['茶托','',''],['茶晶','',''],['茶杯','',''],['茶枯','',''],['茶树','',''],['茶楼','',''],['茶毛虫','',''],['茶水','',''],['茶汤','',''],['茶汤壶','',''],['茶油','',''],['茶炉','',''],['茶炊','',''],['茶点','',''],['茶点时间','',''],['茶盘','',''],['茶砖','',''],['茶碗','',''],['茶碟','',''],['茶碱','',''],['茶礼','',''],['茶社','',''],['茶税','',''],['茶筒','',''],['茶精','',''],['茶经','',''],['茶缸','',''],['茶缸子','',''],['茶罐','',''],['茶色','',''],['茶艺','',''],['茶花','',''],['茶花女','',''],['茶藨子','',''],['茶袋','',''],['茶褐色','',''],['茶话','',''],['茶话会','',''],['茶质','',''],['茶资','',''],['茶道','',''],['茶钱','',''],['茶锈','',''],['茶镜','',''],['茶隼','',''],['茶青','',''],['茶食','',''],['茶饭','',''],['茶饭不思','',''],['茶饭无心','',''],['茶饼','',''],['茶馆','',''],['茶馆儿','',''],['茶香','',''],['茶马互市','',''],['茶马古道','',''],['茸毛','',''],['茸茸','',''],['茹古涵今','',''],['茹志鹃','',''],['茹柔吐刚','',''],['茹毛','',''],['茹毛饮血','',''],['茹泣吐悲','',''],['茹痛','',''],['茹素','',''],['茹苦含辛','',''],['茹荤','',''],['茹荤饮酒','',''],['茹藘','',''],['茹鱼','',''],['茺蔚','',''],['茼蒿','',''],['荀子','',''],['荀彧','',''],['荃湾','',''],['荆天棘地','',''],['荆山','',''],['荆条','',''],['荆棘','',''],['荆棘丛生','',''],['荆棘塞途','',''],['荆棘多','',''],['荆棘载途','',''],['荆棘铜驼','',''],['荆楚网','',''],['荆楚网视','',''],['荆榛满目','',''],['荆江','',''],['荆芥','',''],['荆轲','',''],['荆钗布袄','',''],['荆钗布裙','',''],['荆钗裙布','',''],['荇菜','',''],['草丛','',''],['草乌','',''],['草书','',''],['草书体','',''],['草体','',''],['草偃风从','',''],['草偃风行','',''],['草写','',''],['草函','',''],['草创','',''],['草制','',''],['草刺儿','',''],['草动','',''],['草包','',''],['草原','',''],['草原巨蜥','',''],['草台班子','',''],['草叶','',''],['草图','',''],['草地','',''],['草地般','',''],['草场','',''],['草坪','',''],['草坪扫除机','',''],['草垛','',''],['草垫','',''],['草垫子','',''],['草堂','',''],['草堆','',''],['草大青','',''],['草头','',''],['草头天子','',''],['草字','',''],['草字头儿','',''],['草寇','',''],['草屋','',''],['草履虫','',''],['草屯','',''],['草屯镇','',''],['草山','',''],['草帘','',''],['草席','',''],['草帽','',''],['草帽缏','',''],['草庐','',''],['草庐三顾','',''],['草底','',''],['草底儿','',''],['草房','',''],['草拟','',''],['草料','',''],['草昧','',''],['草晴蛉','',''],['草木','',''],['草木一春','',''],['草木灰','',''],['草木犀','',''],['草木皆兵','',''],['草木鸟兽','',''],['草本','',''],['草本植物','',''],['草果','',''],['草标','',''],['草标儿','',''],['草根','',''],['草根网民','',''],['草案','',''],['草棉','',''],['草棚','',''],['草泥马','',''],['草泽','',''],['草洼','',''],['草测','',''],['草海','',''],['草温表','',''],['草满囹圄','',''],['草灰','',''],['草炭','',''],['草煤','',''],['草爬子','',''],['草状','',''],['草狐','',''],['草率','',''],['草率从事','',''],['草率将事','',''],['草率收兵','',''],['草率行事','',''],['草珊瑚','',''],['草用','',''],['草甸','',''],['草甸子','',''],['草皮','',''],['草石蚕','',''],['草码','',''],['草秆','',''],['草种','',''],['草科','',''],['草稿','',''],['草窝','',''],['草笠','',''],['草签','',''],['草类','',''],['草籽','',''],['草约','',''],['草纸','',''],['草绳','',''],['草绿','',''],['草绿色','',''],['草耙','',''],['草色','',''],['草芥','',''],['草苁蓉','',''],['草茉莉','',''],['草草','',''],['草草了事','',''],['草草收兵','',''],['草草收场','',''],['草荐','',''],['草荒','',''],['草药','',''],['草莓','',''],['草莓族','',''],['草莽','',''],['草菅','',''],['草菅人命','',''],['草菇','',''],['草虫','',''],['草蜻蛉','',''],['草行露宿','',''],['草衣木食','',''],['草裙舞','',''],['草褥','',''],['草豆','',''],['草豆蔻','',''],['草质茎','',''],['草酸','',''],['草酸盐','',''],['草野','',''],['草铺','',''],['草长莺飞','',''],['草间求活','',''],['草靡风行','',''],['草鞋','',''],['草食','',''],['草食动物','',''],['草饼','',''],['草驴','',''],['草鱼','',''],['草鸡','',''],['草鸮','',''],['草黄','',''],['荏弱','',''],['荏苒','',''],['荐举','',''],['荐任','',''],['荐头','',''],['荐头店','',''],['荐引','',''],['荐椎','',''],['荐者','',''],['荐言','',''],['荐贤','',''],['荐骨','',''],['荒丘','',''],['荒乱','',''],['荒信','',''],['荒僻','',''],['荒凉','',''],['荒原','',''],['荒发','',''],['荒唐','',''],['荒唐不经','',''],['荒唐事','',''],['荒唐无稽','',''],['荒唐言行','',''],['荒土','',''],['荒地','',''],['荒坡','',''],['荒子','',''],['荒寒','',''],['荒山','',''],['荒山野岭','',''],['荒岛','',''],['荒年','',''],['荒废','',''],['荒弃','',''],['荒怪不经','',''],['荒数','',''],['荒无','',''],['荒无人烟','',''],['荒旱','',''],['荒时','',''],['荒时暴月','',''],['荒村','',''],['荒歉','',''],['荒沙','',''],['荒淫','',''],['荒淫无耻','',''],['荒滩','',''],['荒漠','',''],['荒漠化','',''],['荒灾','',''],['荒烟蔓草','',''],['荒疏','',''],['荒瘠','',''],['荒芜','',''],['荒草','',''],['荒诞','',''],['荒诞不经','',''],['荒诞主义','',''],['荒诞无稽','',''],['荒诞派','',''],['荒谬','',''],['荒谬无稽','',''],['荒谬绝伦','',''],['荒遐','',''],['荒郊','',''],['荒郊旷野','',''],['荒野','',''],['荔城','',''],['荔枝','',''],['荔枝核','',''],['荔湾','',''],['荚果','',''],['荚膜','',''],['荚膜组织胞浆菌','',''],['荚蓬','',''],['荛花','',''],['荜拨','',''],['荜门圭窦','',''],['荜露蓝缕','',''],['荜露蓝蒌','',''],['荞麦','',''],['荞麦皮','',''],['荟萃','',''],['荠菜','',''],['荡产','',''],['荡产倾家','',''],['荡妇','',''],['荡寇','',''],['荡尽','',''],['荡平','',''],['荡性','',''],['荡来荡去','',''],['荡析离居','',''],['荡检逾闲','',''],['荡气','',''],['荡气回肠','',''],['荡涤','',''],['荡漾','',''],['荡然','',''],['荡然无存','',''],['荡秋千','',''],['荡肥','',''],['荡舟','',''],['荡船','',''],['荡荡','',''],['荡起','',''],['荣任','',''],['荣光','',''],['荣光颂','',''],['荣典','',''],['荣军','',''],['荣华','',''],['荣华富贵','',''],['荣威','',''],['荣宗耀祖','',''],['荣市','',''],['荣幸','',''],['荣归','',''],['荣归主','',''],['荣归故里','',''],['荣成湾','',''],['荣景','',''],['荣格','',''],['荣毅仁','',''],['荣河县','',''],['荣登','',''],['荣登榜首','',''],['荣禄','',''],['荣禄大夫','',''],['荣立','',''],['荣美','',''],['荣耀','',''],['荣膺','',''],['荣获','',''],['荣誉','',''],['荣誉军人','',''],['荣誉博士','',''],['荣誉博士学位','',''],['荣誉奖','',''],['荣誉学位','',''],['荣誉感','',''],['荣誉教授','',''],['荣誉权','',''],['荣誉称号','',''],['荣誉章','',''],['荣辱','',''],['荣辱与共','',''],['荣辱观','',''],['荤油','',''],['荤笑话','',''],['荤粥','',''],['荤素','',''],['荤腥','',''],['荤菜','',''],['荤辛','',''],['荥阳县','',''],['荦荦','',''],['荧光','',''],['荧光增白剂','',''],['荧光学','',''],['荧光屏','',''],['荧光性','',''],['荧光棒','',''],['荧光灯','',''],['荧光笔','',''],['荧光粉','',''],['荧屏','',''],['荧幕','',''],['荧惑','',''],['荧惑星','',''],['荧火','',''],['荧火虫','',''],['荧石','',''],['荧荧','',''],['荨麻','',''],['荨麻疹','',''],['荩臣','',''],['荩草','',''],['荫凉','',''],['荫子封妻','',''],['荫庇','',''],['荫棚','',''],['荫翳','',''],['荫蔽','',''],['荫道','',''],['荭草','',''],['药丸','',''],['药具','',''],['药典','',''],['药农','',''],['药到病除','',''],['药剂','',''],['药剂士','',''],['药剂师','',''],['药剂拌种','',''],['药力','',''],['药包','',''],['药单','',''],['药厂','',''],['药叉','',''],['药名','',''],['药味','',''],['药品','',''],['药商','',''],['药器','',''],['药囊','',''],['药学','',''],['药害','',''],['药局','',''],['药师','',''],['药师佛','',''],['药师如来','',''],['药师经','',''],['药库','',''],['药店','',''],['药店飞龙','',''],['药引子','',''],['药性','',''],['药性气','',''],['药房','',''],['药捻子','',''],['药效','',''],['药料','',''],['药方','',''],['药方儿','',''],['药材','',''],['药械','',''],['药检','',''],['药棉','',''],['药水','',''],['药水儿','',''],['药水瓶','',''],['药浴','',''],['药液','',''],['药渣','',''],['药片','',''],['药物','',''],['药物学','',''],['药物学家','',''],['药物性皮炎','',''],['药理','',''],['药理学','',''],['药瓶','',''],['药用','',''],['药用价值','',''],['药疗','',''],['药疗法','',''],['药疹','',''],['药皂','',''],['药监局','',''],['药盒','',''],['药石','',''],['药石之言','',''],['药种','',''],['药笼中物','',''],['药筒','',''],['药签','',''],['药箱','',''],['药粉','',''],['药罐','',''],['药罐子','',''],['药胰子','',''],['药膏','',''],['药膳','',''],['药苗','',''],['药茶','',''],['药草','',''],['药行','',''],['药衡','',''],['药补','',''],['药补不如食补','',''],['药费','',''],['药酒','',''],['药量','',''],['药铺','',''],['药锭','',''],['药面','',''],['药饵','',''],['荷兰人','',''],['荷兰式拍卖','',''],['荷兰水','',''],['荷兰猪','',''],['荷兰王国','',''],['荷兰皇家航空','',''],['荷兰盾','',''],['荷兰石竹','',''],['荷兰芹','',''],['荷兰语','',''],['荷兰豆','',''],['荷包','',''],['荷包蛋','',''],['荷叶','',''],['荷塘','',''],['荷尔蒙','',''],['荷巴特','',''],['荷枪实弹','',''],['荷泽','',''],['荷泽寺','',''],['荷脑','',''],['荷花','',''],['荷荷','',''],['荷莉・贝瑞','',''],['荷载','',''],['荷重','',''],['荷马','',''],['荸荠','',''],['荼毒','',''],['荼毒生灵','',''],['莅临','',''],['莅临指导','',''],['莅事者','',''],['莅任','',''],['莅会','',''],['莅止','',''],['莆仙戏','',''],['莆田地区','',''],['莉莉','',''],['莎士比亚','',''],['莎拉','',''],['莎拉・佩林','',''],['莎拉・布莱曼','',''],['莎拉波娃','',''],['莎翁','',''],['莎草','',''],['莎莎舞','',''],['莒光','',''],['莒光乡','',''],['莘莘','',''],['莜面','',''],['莜麦','',''],['莜麦菜','',''],['莞尔','',''],['莞熊','',''],['莠草','',''],['莨绸','',''],['莨菪','',''],['莪术','',''],['莪蒿','',''],['莫不','',''],['莫不如此','',''],['莫不是','',''],['莫不然','',''],['莫不逾侈','',''],['莫不闻','',''],['莫为','',''],['莫之能御','',''],['莫予毒也','',''],['莫伊谢耶夫','',''],['莫伯日','',''],['莫克姆湾','',''],['莫入','',''],['莫利森','',''],['莫利达瓦达斡尔族自治旗','',''],['莫卧儿王朝','',''],['莫及','',''],['莫可','',''],['莫可名状','',''],['莫可奈何','',''],['莫可指数','',''],['莫吉托','',''],['莫名','',''],['莫名其妙','',''],['莫哈韦沙漠','',''],['莫塔马湾','',''],['莫大','',''],['莫如','',''],['莫尔兹比港','',''],['莫尔斯','',''],['莫尔斯电码','',''],['莫尼卡・莱温斯基','',''],['莫展一筹','',''],['莫希','',''],['莫忘','',''],['莫怪','',''],['莫扎特','',''],['莫扎里拉','',''],['莫拉莱斯','',''],['莫措手足','',''],['莫撒谎','',''],['莫敌','',''],['莫敢谁何','',''],['莫斯特','',''],['莫斯科','',''],['莫明其妙','',''],['莫札特','',''],['莫杰斯特','',''],['莫此为甚','',''],['莫氏硬度表','',''],['莫测','',''],['莫测高深','',''],['莫理','',''],['莫知与京','',''],['莫知所措','',''],['莫知所谓','',''],['莫管','',''],['莫管他家瓦上霜','',''],['莫罕达斯','',''],['莫罗尼','',''],['莫能','',''],['莫若','',''],['莫衷一是','',''],['莫言','',''],['莫让','',''],['莫讲','',''],['莫说','',''],['莫辨楮叶','',''],['莫过','',''],['莫过于','',''],['莫过如此','',''],['莫逆','',''],['莫逆之交','',''],['莫逆之友','',''],['莫道','',''],['莫邪','',''],['莫霍洛维奇','',''],['莫霍洛维奇不连续面','',''],['莫霍面','',''],['莫非','',''],['莫非是','',''],['莫须','',''],['莫须有','',''],['莫高','',''],['莫高窟','',''],['莰酮','',''],['莱伊尔','',''],['莱佛士','',''],['莱切','',''],['莱卡','',''],['莱因河','',''],['莱塞','',''],['莱姆','',''],['莱姆病','',''],['莱姆酒','',''],['莱山','',''],['莱布尼兹','',''],['莱德杯','',''],['莱斯大学','',''],['莱斯沃斯岛','',''],['莱斯特','',''],['莱斯特郡','',''],['莱旺厄尔','',''],['莱昂纳多','',''],['莱比锡','',''],['莱温斯基','',''],['莱特','',''],['莱茵河','',''],['莱菔','',''],['莱里达','',''],['莱顿','',''],['莱顿大学','',''],['莱齐耶三世','',''],['莲台','',''],['莲子','',''],['莲心','',''],['莲池','',''],['莲湖','',''],['莲花步步生','',''],['莲花落','',''],['莲菜','',''],['莲蓉','',''],['莲蓉包','',''],['莲蓬','',''],['莲蓬头','',''],['莲蓬子儿','',''],['莲藕','',''],['莲都','',''],['莲雾','',''],['莳箩','',''],['莳萝','',''],['莳萝籽','',''],['莴笋','',''],['莴苣','',''],['获准','',''],['获刑','',''],['获利','',''],['获利者','',''],['获利颇巨','',''],['获到','',''],['获取','',''],['获奖','',''],['获奖人','',''],['获奖作品','',''],['获奖者','',''],['获好评','',''],['获得','',''],['获得性','',''],['获得性免疫','',''],['获得者','',''],['获得胜利','',''],['获悉','',''],['获报','',''],['获救','',''],['获暴利者','',''],['获益','',''],['获益匪浅','',''],['获益者','',''],['获知','',''],['获罪','',''],['获胜','',''],['获胜者','',''],['获至','',''],['获致','',''],['获许','',''],['获评','',''],['获购','',''],['获赠','',''],['获赦','',''],['获选','',''],['获释','',''],['获颁','',''],['获鹿','',''],['获鹿镇','',''],['莹莹','',''],['莺俦燕侣','',''],['莺啼燕语','',''],['莺歌','',''],['莺歌燕舞','',''],['莺歌镇','',''],['莺类','',''],['莺鸟','',''],['莼羹鲈脍','',''],['莼菜','',''],['莼鲈之思','',''],['莽原','',''],['莽撞','',''],['莽汉','',''],['莽苍','',''],['莽草','',''],['莽莽','',''],['莿桐','',''],['莿桐乡','',''],['菁华','',''],['菁英','',''],['菁菁','',''],['菅直人','',''],['菊石','',''],['菊科','',''],['菊老荷枯','',''],['菊芋','',''],['菊花','',''],['菊花茶','',''],['菌丝','',''],['菌丝体','',''],['菌伞','',''],['菌体','',''],['菌力','',''],['菌子','',''],['菌托','',''],['菌柄','',''],['菌株','',''],['菌核','',''],['菌液','',''],['菌界','',''],['菌盖','',''],['菌种','',''],['菌类','',''],['菌类植物','',''],['菌肥','',''],['菌胶团','',''],['菌苗','',''],['菌落','',''],['菌陈蒿','',''],['菏兰','',''],['菖蒲','',''],['菘菜','',''],['菘蓝','',''],['菜丝','',''],['菜价','',''],['菜农','',''],['菜刀','',''],['菜单','',''],['菜单条','',''],['菜单项','',''],['菜园','',''],['菜圃','',''],['菜地','',''],['菜场','',''],['菜墩子','',''],['菜子','',''],['菜子油','',''],['菜市','',''],['菜市场','',''],['菜帮','',''],['菜式','',''],['菜心','',''],['菜摊','',''],['菜板','',''],['菜枯','',''],['菜根','',''],['菜梗','',''],['菜汤','',''],['菜油','',''],['菜牛','',''],['菜瓜','',''],['菜田','',''],['菜畦','',''],['菜盆','',''],['菜盒','',''],['菜码儿','',''],['菜票','',''],['菜种','',''],['菜窖','',''],['菜筐','',''],['菜篮','',''],['菜篮子','',''],['菜类','',''],['菜籽','',''],['菜羊','',''],['菜肴','',''],['菜色','',''],['菜花','',''],['菜芽','',''],['菜苔','',''],['菜茹','',''],['菜蓝','',''],['菜蔬','',''],['菜薹','',''],['菜蚜','',''],['菜蛙','',''],['菜谱','',''],['菜豆','',''],['菜贩','',''],['菜锅','',''],['菜青','',''],['菜馆','',''],['菜鸟','',''],['菝葜','',''],['菟丝子','',''],['菠菜','',''],['菠萝','',''],['菠萝蜜','',''],['菡萏','',''],['菥蓂','',''],['菩提','',''],['菩提树','',''],['菩提达摩','',''],['菩提道场','',''],['菩萨','',''],['菩萨低眉','',''],['菩萨心肠','',''],['菰米','',''],['菱形','',''],['菱形窗','',''],['菱花镜','',''],['菱角','',''],['菱铁矿','',''],['菱锌矿','',''],['菱镁矿','',''],['菱镜','',''],['菱面','',''],['菱面体','',''],['菲亚特','',''],['菲仪','',''],['菲佣','',''],['菲利浦','',''],['菲力','',''],['菲力克斯','',''],['菲力牛排','',''],['菲姬','',''],['菲尔兹','',''],['菲尔兹奖','',''],['菲尔普斯','',''],['菲尔特','',''],['菲尼克斯','',''],['菲律宾人','',''],['菲律宾国','',''],['菲律宾大学','',''],['菲律宾语','',''],['菲德尔','',''],['菲才寡学','',''],['菲舍尔','',''],['菲茨杰拉德','',''],['菲菲','',''],['菲薄','',''],['菲衣恶食','',''],['菲酌','',''],['菲食卑宫','',''],['菲食薄衣','',''],['菸斗','',''],['菸硷','',''],['菸碱','',''],['菸碱酸','',''],['菸蒂','',''],['菹醢','',''],['菽水之欢','',''],['菽水承欢','',''],['萃取','',''],['萃萃蝇','',''],['萋斐贝锦','',''],['萋萋','',''],['萋风冷雨','',''],['萋风苦雨','',''],['萌动','',''],['萌发','',''],['萌渚岭','',''],['萌生','',''],['萌芽','',''],['萌芽林','',''],['萍卡菲尔特','',''],['萍水','',''],['萍水相逢','',''],['萍水相遇','',''],['萍水相遭','',''],['萍蓬草','',''],['萍踪','',''],['萍踪梗迹','',''],['萍踪浪影','',''],['萍踪浪迹','',''],['萍飘蓬转','',''],['萎叶','',''],['萎缩','',''],['萎蔫','',''],['萎谢','',''],['萎陷疗法','',''],['萎靡','',''],['萎靡不振','',''],['萎黄病','',''],['萘丸','',''],['萘醌','',''],['萝卜','',''],['萝卜糕','',''],['萝卜花','',''],['萝岗','',''],['萝岗区','',''],['萝艻','',''],['萝芙木','',''],['萝莉','',''],['萝莉控','',''],['萤光','',''],['萤光幕','',''],['萤光素','',''],['萤光绿','',''],['萤光镜','',''],['萤幕','',''],['萤幕保护装置','',''],['萤火','',''],['萤火虫','',''],['萤焰','',''],['萤石','',''],['萤窗雪案','',''],['营业','',''],['营业人员','',''],['营业厅','',''],['营业员','',''],['营业室','',''],['营业所','',''],['营业执照','',''],['营业收入','',''],['营业时候','',''],['营业时间','',''],['营业税','',''],['营业部','',''],['营业额','',''],['营养','',''],['营养不良','',''],['营养卫生','',''],['营养品','',''],['营养学','',''],['营养液','',''],['营养物','',''],['营养物质','',''],['营养素','',''],['营养钵','',''],['营养面积','',''],['营利','',''],['营办','',''],['营区','',''],['营区规划','',''],['营卫','',''],['营号','',''],['营地','',''],['营垒','',''],['营寨','',''],['营屯','',''],['营巢','',''],['营工','',''],['营帐','',''],['营建','',''],['营房','',''],['营房保障','',''],['营收','',''],['营救','',''],['营火','',''],['营火会','',''],['营生','',''],['营田','',''],['营盘','',''],['营盘镇','',''],['营私','',''],['营私作弊','',''],['营私舞弊','',''],['营管','',''],['营谋','',''],['营谋遂顺','',''],['营运','',''],['营运资金','',''],['营造','',''],['营造司','',''],['营造商','',''],['营造尺','',''],['营部','',''],['营销','',''],['营长','',''],['营队','',''],['萦回','',''],['萦怀','',''],['萦纡','',''],['萦绕','',''],['萧一山','',''],['萧万长','',''],['萧乾','',''],['萧伯纳','',''],['萧墙','',''],['萧墙祸起','',''],['萧子显','',''],['萧山','',''],['萧条','',''],['萧梁','',''],['萧森','',''],['萧然','',''],['萧瑟','',''],['萧疏','',''],['萧索','',''],['萧红','',''],['萧萧','',''],['萧行范篆','',''],['萧规曹随','',''],['萧邦','',''],['萧飒','',''],['萨丁尼亚岛','',''],['萨克','',''],['萨克拉门托','',''],['萨克斯','',''],['萨克斯管','',''],['萨克斯风','',''],['萨克森','',''],['萨克森州','',''],['萨克洛夫','',''],['萨克洛夫奖','',''],['萨克管','',''],['萨克逊','',''],['萨兰斯克','',''],['萨其马','',''],['萨博','',''],['萨卡什维利','',''],['萨哈林岛','',''],['萨哈洛夫','',''],['萨哈罗夫','',''],['萨哈罗夫人权奖','',''],['萨哈罗夫奖','',''],['萨哈诺夫','',''],['萨哈诺夫人权奖','',''],['萨噶达娃节','',''],['萨尔','',''],['萨尔图','',''],['萨尔州','',''],['萨尔布吕肯','',''],['萨尔普斯堡','',''],['萨尔浒之战','',''],['萨尔温江','',''],['萨尔瓦多共和国','',''],['萨尔科奇','',''],['萨尔科齐','',''],['萨尔茨堡','',''],['萨巴德罗','',''],['萨德尔','',''],['萨德尔市','',''],['萨拉丁','',''],['萨拉戈萨','',''],['萨拉曼卡','',''],['萨拉森帝国','',''],['萨拉热窝','',''],['萨拉热窝事件','',''],['萨摩','',''],['萨摩亚群岛','',''],['萨摩耶','',''],['萨摩耶犬','',''],['萨摩麟','',''],['萨斯','',''],['萨斯卡通','',''],['萨斯喀彻温','',''],['萨斯病','',''],['萨格勒布','',''],['萨桑王朝','',''],['萨满教','',''],['萨特','',''],['萨珊王朝','',''],['萨瓦河','',''],['萨科齐','',''],['萨米人','',''],['萨莉','',''],['萨菲','',''],['萨蒂','',''],['萨达姆','',''],['萨达姆・侯赛因','',''],['萨达特','',''],['萨迪克','',''],['萨里','',''],['萨里郡','',''],['萨非王朝','',''],['萨马兰奇','',''],['萨默塞特郡','',''],['萱堂','',''],['萱花椿树','',''],['萱草','',''],['萼片','',''],['萼状','',''],['落下','',''],['落乡','',''],['落于','',''],['落于下风','',''],['落井','',''],['落井下石','',''],['落价','',''],['落伍','',''],['落伍者','',''],['落体','',''],['落俗','',''],['落儿','',''],['落入','',''],['落入法网','',''],['落到','',''],['落到实处','',''],['落发','',''],['落叶','',''],['落叶乔木','',''],['落叶剂','',''],['落叶层','',''],['落叶归根','',''],['落叶性','',''],['落叶松','',''],['落叶树','',''],['落叶植物','',''],['落叶知秋','',''],['落后','',''],['落后地区','',''],['落后状况','',''],['落后面貌','',''],['落回','',''],['落在','',''],['落地','',''],['落地灯','',''],['落地窗','',''],['落地签','',''],['落坐','',''],['落埋怨','',''],['落基山','',''],['落墨','',''],['落子','',''],['落实','',''],['落实到人','',''],['落实到户','',''],['落实政策','',''],['落寞','',''],['落尘','',''],['落差','',''],['落幕','',''],['落度','',''],['落座','',''],['落弹','',''],['落得','',''],['落忍','',''],['落成','',''],['落户','',''],['落托','',''],['落扬','',''],['落拓','',''],['落拓不羁','',''],['落日','',''],['落晖','',''],['落月','',''],['落月屋梁','',''],['落枕','',''],['落果','',''],['落架','',''],['落标','',''],['落栈','',''],['落榜','',''],['落槽','',''],['落款','',''],['落水','',''],['落水狗','',''],['落水管','',''],['落汤鸡','',''],['落泊','',''],['落泪','',''],['落漠','',''],['落潮','',''],['落炕','',''],['落点','',''],['落照','',''],['落生','',''],['落石','',''],['落空','',''],['落笔','',''],['落笔审慎','',''],['落第','',''],['落纱','',''],['落网','',''],['落胆','',''],['落脚','',''],['落脚点','',''],['落腮胡','',''],['落腮胡子','',''],['落膘','',''],['落色','',''],['落花','',''],['落花有意流水无情','',''],['落花流水','',''],['落花生','',''],['落草','',''],['落荒','',''],['落荒而逃','',''],['落莫','',''],['落落','',''],['落落大方','',''],['落落寡交','',''],['落落寡合','',''],['落落寡欢','',''],['落落难合','',''],['落葬','',''],['落藉','',''],['落谷','',''],['落败','',''],['落跑','',''],['落选','',''],['落锤','',''],['落难','',''],['落雁沉鱼','',''],['落雨','',''],['落雷','',''],['落霞','',''],['落音','',''],['落马','',''],['落马洲','',''],['落魄','',''],['落魄不羁','',''],['葑菲之采','',''],['著书','',''],['著书立说','',''],['著作','',''],['著作权','',''],['著作等身','',''],['著作者','',''],['著力','',''],['著名','',''],['著名人士','',''],['著墨','',''],['著实','',''],['著录','',''],['著忙','',''],['著急','',''],['著手','',''],['著手成春','',''],['著文','',''],['著有','',''],['著有成效','',''],['著棋','',''],['著气','',''],['著火','',''],['著眉','',''],['著称','',''],['著称于世','',''],['著笔','',''],['著粪佛头','',''],['著者','',''],['著者索引','',''],['著色','',''],['著色液','',''],['著落','',''],['著衣','',''],['著谜','',''],['著走','',''],['著述','',''],['著述等身','',''],['著重','',''],['著陆','',''],['著魔','',''],['葛仙米','',''],['葛优','',''],['葛兰素史克','',''],['葛巾','',''],['葛布','',''],['葛根','',''],['葛法翁','',''],['葛洲坝','',''],['葛瑞格尔','',''],['葛粉','',''],['葛缕子','',''],['葛荣起义','',''],['葛莱美奖','',''],['葛藤','',''],['葡糖','',''],['葡糖胺','',''],['葡萄','',''],['葡萄乾','',''],['葡萄园','',''],['葡萄干','',''],['葡萄干儿','',''],['葡萄弹','',''],['葡萄柚','',''],['葡萄树','',''],['葡萄核','',''],['葡萄汁','',''],['葡萄灰','',''],['葡萄牙人','',''],['葡萄牙文','',''],['葡萄牙语','',''],['葡萄球菌','',''],['葡萄球菌肠毒素','',''],['葡萄糖','',''],['葡萄糖胺','',''],['葡萄紫','',''],['葡萄胎','',''],['葡萄藤','',''],['葡萄酒','',''],['董事','',''],['董事会','',''],['董事长','',''],['董仲舒','',''],['董卓','',''],['董奉','',''],['董建华','',''],['董必武','',''],['董阳孜','',''],['董鸡','',''],['葫芦','',''],['葫芦丝','',''],['葫芦巴','',''],['葫芦科','',''],['葫芦藓','',''],['葫蔓藤','',''],['葬人','',''],['葬仪','',''],['葬仪车','',''],['葬地','',''],['葬埋','',''],['葬式','',''],['葬歌','',''],['葬玉埋香','',''],['葬礼','',''],['葬者','',''],['葬费','',''],['葬身','',''],['葬身鱼腹','',''],['葬送','',''],['葭莩','',''],['葭莩之亲','',''],['葱头','',''],['葱属','',''],['葱岭','',''],['葱白','',''],['葱白儿','',''],['葱绿','',''],['葱翠','',''],['葱花','',''],['葱茏','',''],['葱葱','',''],['葱蒜','',''],['葱蒜类蔬菜','',''],['葱郁','',''],['葱颜顺旨','',''],['葱黄','',''],['葳蕤','',''],['葵扇','',''],['葵涌','',''],['葵科','',''],['葵花','',''],['葵花子','',''],['葵青','',''],['葶苈','',''],['蒂固','',''],['蒂森克虏伯','',''],['蒋介石','',''],['蒋士铨','',''],['蒋家','',''],['蒋桂战争','',''],['蒋纬国','',''],['蒋经国','',''],['蒋雯丽','',''],['蒌叶','',''],['蒌蒿','',''],['蒐寻','',''],['蒐证','',''],['蒐集','',''],['蒙上','',''],['蒙事','',''],['蒙人','',''],['蒙代尔','',''],['蒙住','',''],['蒙冤','',''],['蒙受','',''],['蒙古人','',''],['蒙古人民共和国','',''],['蒙古人种','',''],['蒙古包','',''],['蒙古国','',''],['蒙古地区','',''],['蒙古时代','',''],['蒙古语','',''],['蒙召','',''],['蒙哄','',''],['蒙哥马利','',''],['蒙嘉慧','',''],['蒙在','',''],['蒙在鼓里','',''],['蒙地卡罗','',''],['蒙塾','',''],['蒙大拿','',''],['蒙大拿州','',''],['蒙大纳州','',''],['蒙太奇','',''],['蒙头','',''],['蒙头转向','',''],['蒙娜丽莎','',''],['蒙学','',''],['蒙尘','',''],['蒙山茶','',''],['蒙巴萨','',''],['蒙巴顿','',''],['蒙师','',''],['蒙帕纳斯','',''],['蒙席','',''],['蒙彼利埃','',''],['蒙得维的亚','',''],['蒙恩','',''],['蒙恬','',''],['蒙托罗拉','',''],['蒙损','',''],['蒙文','',''],['蒙族','',''],['蒙日','',''],['蒙昧','',''],['蒙昧主义','',''],['蒙松雨','',''],['蒙求','',''],['蒙汗药','',''],['蒙混','',''],['蒙混过关','',''],['蒙牛','',''],['蒙特利尔','',''],['蒙特卡洛','',''],['蒙特卡洛法','',''],['蒙特卡罗方法','',''],['蒙特塞拉特','',''],['蒙特雷','',''],['蒙皮','',''],['蒙眬','',''],['蒙眼','',''],['蒙着','',''],['蒙罗维亚','',''],['蒙羞','',''],['蒙胧','',''],['蒙茏','',''],['蒙茸','',''],['蒙药','',''],['蒙蒙','',''],['蒙蒙亮','',''],['蒙蒙细雨','',''],['蒙蒙雨','',''],['蒙蒙黑','',''],['蒙蔽','',''],['蒙覆','',''],['蒙难','',''],['蒙面','',''],['蒙馆','',''],['蒙骗','',''],['蒜味','',''],['蒜头','',''],['蒜毫','',''],['蒜泥','',''],['蒜瓣','',''],['蒜瓣儿','',''],['蒜皮','',''],['蒜苔','',''],['蒜苗','',''],['蒜苗炒肉片','',''],['蒜茸','',''],['蒜茸钳','',''],['蒜蓉油菜','',''],['蒜蓉豆角','',''],['蒜薹','',''],['蒜黄','',''],['蒟蒻','',''],['蒭藁增二','',''],['蒲公英','',''],['蒲剑','',''],['蒲剧','',''],['蒲包','',''],['蒲团','',''],['蒲圻','',''],['蒲圻市','',''],['蒲墩儿','',''],['蒲式耳','',''],['蒲扇','',''],['蒲松龄','',''],['蒲柳','',''],['蒲柳之姿','',''],['蒲桃','',''],['蒲棒','',''],['蒲瓜','',''],['蒲甘','',''],['蒲甘王朝','',''],['蒲福风级','',''],['蒲绒','',''],['蒲节','',''],['蒲草','',''],['蒲草箱','',''],['蒲菜','',''],['蒲萄','',''],['蒲葵','',''],['蒲鉾','',''],['蒲陶','',''],['蒲隆地','',''],['蒲鞋','',''],['蒲鞭之政','',''],['蒴果','',''],['蒸化','',''],['蒸去','',''],['蒸发','',''],['蒸发性','',''],['蒸发掉','',''],['蒸发热','',''],['蒸发皿','',''],['蒸发空调','',''],['蒸发计','',''],['蒸发量','',''],['蒸掉','',''],['蒸气','',''],['蒸气浴','',''],['蒸气重整','',''],['蒸汽','',''],['蒸汽似','',''],['蒸汽机','',''],['蒸汽机车','',''],['蒸汽浴','',''],['蒸汽状','',''],['蒸汽疗法','',''],['蒸汽计','',''],['蒸汽锤','',''],['蒸沙成饭','',''],['蒸湘','',''],['蒸溜','',''],['蒸溜器','',''],['蒸溜所','',''],['蒸溜液','',''],['蒸溜者','',''],['蒸烧','',''],['蒸熟','',''],['蒸笼','',''],['蒸粗麦粉','',''],['蒸糕','',''],['蒸肉丸','',''],['蒸腾','',''],['蒸腾作用','',''],['蒸蒸日上','',''],['蒸锅','',''],['蒸食','',''],['蒸饺','',''],['蒸饼','',''],['蒸馏','',''],['蒸馏器','',''],['蒸馏室','',''],['蒸馏水','',''],['蒸馏法','',''],['蒸馏液','',''],['蒸馏物','',''],['蒸馏酒','',''],['蒸鱼','',''],['蒹葭倚玉','',''],['蒺藜','',''],['蒽醌','',''],['蒿子','',''],['蒿子秆儿','',''],['蒿目时艰','',''],['蓁蓁','',''],['蓄养','',''],['蓄力器','',''],['蓄势','',''],['蓄势以待','',''],['蓄势待发','',''],['蓄心','',''],['蓄志','',''],['蓄念','',''],['蓄意','',''],['蓄水','',''],['蓄水池','',''],['蓄洪','',''],['蓄电','',''],['蓄电池','',''],['蓄积','',''],['蓄能','',''],['蓄谋','',''],['蓄谋已久','',''],['蓄财','',''],['蓄财者','',''],['蓄锐养威','',''],['蓄须明志','',''],['蓉树','',''],['蓊菜','',''],['蓊郁','',''],['蓑草','',''],['蓑衣','',''],['蓓蕾','',''],['蓖麻','',''],['蓖麻毒素','',''],['蓖麻油','',''],['蓖麻籽','',''],['蓖麻蚕','',''],['蓝侬','',''],['蓝光','',''],['蓝光光盘','',''],['蓝图','',''],['蓝天','',''],['蓝字','',''],['蓝宝石','',''],['蓝屏死机','',''],['蓝巨星','',''],['蓝布','',''],['蓝晶','',''],['蓝晶晶','',''],['蓝晶石','',''],['蓝本','',''],['蓝桥','',''],['蓝毗尼','',''],['蓝波','',''],['蓝点','',''],['蓝点颏','',''],['蓝点鲅','',''],['蓝牙','',''],['蓝田出玉','',''],['蓝田猿人','',''],['蓝田生玉','',''],['蓝田种玉','',''],['蓝的','',''],['蓝皮','',''],['蓝皮书','',''],['蓝盈盈','',''],['蓝矾','',''],['蓝移','',''],['蓝筹股','',''],['蓝精灵','',''],['蓝细菌','',''],['蓝绿','',''],['蓝绿菌','',''],['蓝绿藻','',''],['蓝缕','',''],['蓝耳病','',''],['蓝肤木','',''],['蓝舌病','',''],['蓝色','',''],['蓝色剂','',''],['蓝色小精灵','',''],['蓝花','',''],['蓝草莓','',''],['蓝莓','',''],['蓝莹莹','',''],['蓝菌','',''],['蓝菌门','',''],['蓝蓝','',''],['蓝藻','',''],['蓝藻门','',''],['蓝调','',''],['蓝铜矿','',''],['蓝闪石','',''],['蓝青','',''],['蓝青官话','',''],['蓝靛','',''],['蓝领','',''],['蓝颜知己','',''],['蓝饰带花','',''],['蓝鲸','',''],['蓝鸟','',''],['蓝黑','',''],['蓟北','',''],['蓟城','',''],['蓟门','',''],['蓟马','',''],['蓦地','',''],['蓦地里','',''],['蓦然','',''],['蓬乱','',''],['蓬勃','',''],['蓬勃发展','',''],['蓬壶','',''],['蓬头历齿','',''],['蓬头垢面','',''],['蓬头跣足','',''],['蓬屋生辉','',''],['蓬布','',''],['蓬心','',''],['蓬户','',''],['蓬户垢牖','',''],['蓬户瓮牖','',''],['蓬散','',''],['蓬松','',''],['蓬江','',''],['蓬生麻中','',''],['蓬筚','',''],['蓬筚增辉','',''],['蓬筚生光','',''],['蓬筚生辉','',''],['蓬茸','',''],['蓬荜','',''],['蓬荜增辉','',''],['蓬荜生光','',''],['蓬荜生辉','',''],['蓬莱仙境','',''],['蓬蒿','',''],['蓬蓬','',''],['蓬蓬勃勃','',''],['蓬车','',''],['蓬门','',''],['蓬门筚户','',''],['蓬门荜户','',''],['蓬闾生辉','',''],['蓬首垢面','',''],['蓼科','',''],['蓼蓝','',''],['蔑称','',''],['蔑视','',''],['蔑语','',''],['蔓延','',''],['蔓延于','',''],['蔓延全国','',''],['蔓生','',''],['蔓生植物','',''],['蔓草','',''],['蔓菁','',''],['蔓藤','',''],['蔓越橘','',''],['蔓越莓','',''],['蔗农','',''],['蔗渣','',''],['蔗糖','',''],['蔗露','',''],['蔚为','',''],['蔚为大观','',''],['蔚兰','',''],['蔚山','',''],['蔚山市','',''],['蔚山广域市','',''],['蔚成','',''],['蔚然','',''],['蔚然成风','',''],['蔚蓝','',''],['蔚起','',''],['蔡东藩','',''],['蔡伦','',''],['蔡依林','',''],['蔡元培','',''],['蔡司公司','',''],['蔡国强','',''],['蔡志忠','',''],['蔡李佛','',''],['蔡甸','',''],['蔡英文','',''],['蔡襄','',''],['蔡锷','',''],['蔫不唧','',''],['蔫儿','',''],['蔫儿坏','',''],['蔫呼呼','',''],['蔫土匪','',''],['蔬果','',''],['蔬果店','',''],['蔬菜','',''],['蔬菜学','',''],['蔬食','',''],['蔬食者','',''],['蔷薇','',''],['蔷薇似','',''],['蔷薇十字团','',''],['蔷薇园','',''],['蔷薇色','',''],['蔷薇花蕾','',''],['蔸距','',''],['蔺相如','',''],['蔻丹','',''],['蔻蔻','',''],['蔼然','',''],['蔼蔼','',''],['蔽之','',''],['蔽体','',''],['蔽塞','',''],['蔽天','',''],['蔽帚千金','',''],['蔽帚自珍','',''],['蔽护','',''],['蔽日','',''],['蔽物','',''],['蔽聪塞明','',''],['蔽芾','',''],['蔽身处','',''],['蕃主','',''],['蕃人','',''],['蕃庑','',''],['蕃茄','',''],['蕃茄色','',''],['蕃薯','',''],['蕃衍','',''],['蕈树','',''],['蕉城','',''],['蕉萃','',''],['蕉藕','',''],['蕉麻','',''],['蕊叶','',''],['蕙兰','',''],['蕙心兰质','',''],['蕙心纨质','',''],['蕙质兰心','',''],['蕞尔','',''],['蕠藘','',''],['蕨类','',''],['蕨类植物','',''],['蕨菜','',''],['蕲求','',''],['蕲艾','',''],['蕲蛇','',''],['蕴于','',''],['蕴含','',''],['蕴和','',''],['蕴奇待价','',''],['蕴涵','',''],['蕴积','',''],['蕴结','',''],['蕴聚','',''],['蕴育','',''],['蕴蓄','',''],['蕴藉','',''],['蕴藏','',''],['蕴藏量','',''],['蕴酿','',''],['蕹菜','',''],['蕺菜','',''],['蕾丝','',''],['蕾丝花边','',''],['蕾丝边','',''],['蕾铃','',''],['薄一波','',''],['薄义','',''],['薄云','',''],['薄产','',''],['薄亲','',''],['薄养厚葬','',''],['薄冰','',''],['薄利','',''],['薄利多销','',''],['薄厚','',''],['薄命','',''],['薄地','',''],['薄壁','',''],['薄壳','',''],['薄尾乞怜','',''],['薄层','',''],['薄布','',''],['薄幸','',''],['薄弱','',''],['薄弱环节','',''],['薄待','',''],['薄情','',''],['薄技','',''],['薄收','',''],['薄明','',''],['薄晓','',''],['薄暗','',''],['薄暮','',''],['薄木板','',''],['薄木片','',''],['薄板','',''],['薄档','',''],['薄棉','',''],['薄棉布','',''],['薄毛呢','',''],['薄油层','',''],['薄海','',''],['薄烤饼','',''],['薄煎饼','',''],['薄熙来','',''],['薄片','',''],['薄片形','',''],['薄片状','',''],['薄版','',''],['薄物细故','',''],['薄瑞光','',''],['薄田','',''],['薄的','',''],['薄皮','',''],['薄礼','',''],['薄祚寒门','',''],['薄纱','',''],['薄纱罗','',''],['薄纸','',''],['薄细','',''],['薄织','',''],['薄绸','',''],['薄而脆','',''],['薄而透明','',''],['薄肉片','',''],['薄胎瓷器','',''],['薄脆','',''],['薄膜','',''],['薄膜电路','',''],['薄舌','',''],['薄荷','',''],['薄荷油','',''],['薄荷脑','',''],['薄荷醇','',''],['薄薄','',''],['薄衣','',''],['薄记员','',''],['薄软','',''],['薄透镜','',''],['薄酒','',''],['薄酬','',''],['薄钢','',''],['薄隔板','',''],['薄雪','',''],['薄雾','',''],['薄面','',''],['薄饼','',''],['薅锄','',''],['薏仁','',''],['薏米','',''],['薏苡','',''],['薏苡之谤','',''],['薏苡明珠','',''],['薛仁贵','',''],['薛城','',''],['薛定谔','',''],['薛定谔方程','',''],['薛宝钗','',''],['薛居正','',''],['薛福成','',''],['薛稷','',''],['薜荔','',''],['薤露','',''],['薪优','',''],['薪优佣厚','',''],['薪俸','',''],['薪尽火传','',''],['薪晌','',''],['薪桂米珠','',''],['薪水','',''],['薪水册','',''],['薪津','',''],['薪炭林','',''],['薪给','',''],['薪资','',''],['薪酬','',''],['薪金','',''],['薪金制','',''],['薪饷','',''],['薮泽','',''],['薯条','',''],['薯片','',''],['薯类','',''],['薯粉','',''],['薯莨','',''],['薯莨绸','',''],['薯蓣','',''],['薯蓣科','',''],['薯饼','',''],['薰上','',''],['薰以','',''],['薰制','',''],['薰莸','',''],['薰莸不同器','',''],['薰衣草','',''],['薰香','',''],['薹草','',''],['薹草属','',''],['藁城县','',''],['藁本','',''],['藁草','',''],['藉以','',''],['藉其','',''],['藉口','',''],['藉故','',''],['藉此','',''],['藉由','',''],['藉着','',''],['藉著','',''],['藉资挹注','',''],['藏之名山','',''],['藏书','',''],['藏书家','',''],['藏书癖','',''],['藏书票','',''],['藏人','',''],['藏传佛教','',''],['藏刀','',''],['藏医','',''],['藏匿','',''],['藏历','',''],['藏品','',''],['藏器待时','',''],['藏在','',''],['藏垢','',''],['藏垢纳污','',''],['藏处','',''],['藏头亢脑','',''],['藏头露尾','',''],['藏奸','',''],['藏好','',''],['藏娇','',''],['藏学','',''],['藏宝','',''],['藏室','',''],['藏富','',''],['藏尸','',''],['藏形匿影','',''],['藏戏','',''],['藏所','',''],['藏拙','',''],['藏掖','',''],['藏文','',''],['藏民','',''],['藏污纳垢','',''],['藏物','',''],['藏独','',''],['藏猫儿','',''],['藏猫猫','',''],['藏獒','',''],['藏着','',''],['藏红花','',''],['藏经','',''],['藏经洞','',''],['藏羚','',''],['藏羚羊','',''],['藏者','',''],['藏胞','',''],['藏茴香果','',''],['藏药','',''],['藏著','',''],['藏蓝','',''],['藏藏掖掖','',''],['藏语','',''],['藏诸名山','',''],['藏象','',''],['藏起','',''],['藏踪','',''],['藏身','',''],['藏身之处','',''],['藏身处','',''],['藏躲','',''],['藏酒','',''],['藏锋敛锷','',''],['藏镜人','',''],['藏间','',''],['藏闷儿','',''],['藏青','',''],['藏青果','',''],['藏青色','',''],['藏香','',''],['藏骨堂','',''],['藏龙卧虎','',''],['藐孤','',''],['藐小','',''],['藐忽','',''],['藐法','',''],['藐藐','',''],['藐视','',''],['藐视一切','',''],['藓苔','',''],['藕丝','',''],['藕合','',''],['藕断丝连','',''],['藕灰','',''],['藕粉','',''],['藕色','',''],['藕节','',''],['藕节儿','',''],['藕花','',''],['藕荷','',''],['藜芦','',''],['藤丛','',''],['藤木','',''],['藤制','',''],['藤器','',''],['藤子','',''],['藤床','',''],['藤本','',''],['藤本植物','',''],['藤杖','',''],['藤条','',''],['藤架','',''],['藤森','',''],['藤椅','',''],['藤泽','',''],['藤牌','',''],['藤球','',''],['藤箧','',''],['藤箱','',''],['藤菜','',''],['藤萝','',''],['藤蔓','',''],['藤野','',''],['藤野先生','',''],['藤鞭','',''],['藤黄','',''],['藩主','',''],['藩台','',''],['藩国','',''],['藩属','',''],['藩库','',''],['藩篱','',''],['藩镇','',''],['藻井','',''],['藻土','',''],['藻类','',''],['藻类学','',''],['藻类植物','',''],['藻饰','',''],['藿香','',''],['藿香正气丸','',''],['蘅塘退士','',''],['蘅芜','',''],['蘑菇','',''],['蘑菇云','',''],['蘑菇汤','',''],['蘖枝','',''],['蘧然','',''],['蘸上','',''],['蘸湿','',''],['蘸火','',''],['蘸破','',''],['蘸笔','',''],['蘸酱','',''],['蘼芜','',''],['虎不拉','',''],['虎丘','',''],['虎伏','',''],['虎体熊腰','',''],['虎兕出柙','',''],['虎入羊群','',''],['虎列拉','',''],['虎劲','',''],['虎势','',''],['虎口','',''],['虎口余生','',''],['虎口拔牙','',''],['虎口逃生','',''],['虎咽狼吞','',''],['虎啸','',''],['虎啸龙吟','',''],['虎头燕颔','',''],['虎头牌','',''],['虎头虎脑','',''],['虎头蛇尾','',''],['虎头蜂','',''],['虎头钳','',''],['虎头鼠尾','',''],['虎威','',''],['虎威狐假','',''],['虎子','',''],['虎字头','',''],['虎将','',''],['虎尾','',''],['虎尾春冰','',''],['虎尾镇','',''],['虎帐','',''],['虎年','',''],['虎彪彪','',''],['虎掷龙拿','',''],['虎斑鹦鹉','',''],['虎斗','',''],['虎斗龙争','',''],['虎步龙行','',''],['虎毒不食儿','',''],['虎爪派','',''],['虎父无犬子','',''],['虎牌','',''],['虎牙','',''],['虎狮兽','',''],['虎狼','',''],['虎略龙韬','',''],['虎疫','',''],['虎皮','',''],['虎皮宣','',''],['虎皮羊质','',''],['虎皮鹦鹉','',''],['虎眼石','',''],['虎穴','',''],['虎穴龙潭','',''],['虎窟龙潭','',''],['虎符','',''],['虎类','',''],['虎耳','',''],['虎耳草','',''],['虎背熊腰','',''],['虎荡羊群','',''],['虎落平川','',''],['虎虎','',''],['虎视','',''],['虎视眈眈','',''],['虎视鹰瞵','',''],['虎贲','',''],['虎起脸','',''],['虎跃龙腾','',''],['虎跳峡','',''],['虎踞','',''],['虎踞龙盘','',''],['虎踞龙蟠','',''],['虎蹲炮','',''],['虎钳','',''],['虎门','',''],['虎门条约','',''],['虎门镇','',''],['虎骨','',''],['虎骨酒','',''],['虎魄','',''],['虎鲸','',''],['虏获','',''],['虐刑','',''],['虐子孤臣','',''],['虐待','',''],['虐待狂','',''],['虐待症','',''],['虐打','',''],['虐政','',''],['虐杀','',''],['虐疾','',''],['虑及','',''],['虔信','',''],['虔信主义','',''],['虔信派','',''],['虔信者','',''],['虔婆','',''],['虔心','',''],['虔敬','',''],['虔诚','',''],['虚与委蛇','',''],['虚义','',''],['虚予委蛇','',''],['虚付','',''],['虚价','',''],['虚伪','',''],['虚伪类真','',''],['虚位','',''],['虚位以待','',''],['虚假','',''],['虚假设','',''],['虚像','',''],['虚减','',''],['虚列','',''],['虚化','',''],['虚发','',''],['虚名','',''],['虚土','',''],['虚增','',''],['虚头','',''],['虚夸','',''],['虚套子','',''],['虚妄','',''],['虚字','',''],['虚学','',''],['虚实','',''],['虚宫格','',''],['虚寒','',''],['虚岁','',''],['虚左以待','',''],['虚己以听','',''],['虚己受人','',''],['虚席','',''],['虚席以待','',''],['虚幻','',''],['虚幻飘渺','',''],['虚应','',''],['虚应故事','',''],['虚度','',''],['虚度光阴','',''],['虚度年华','',''],['虚张','',''],['虚张声势','',''],['虚弱','',''],['虚往实归','',''],['虚心','',''],['虚心使人进步','',''],['虚心好学','',''],['虚怀若谷','',''],['虚悬','',''],['虚情','',''],['虚情假意','',''],['虚惊','',''],['虚报','',''],['虚报冒领','',''],['虚拟','',''],['虚拟世界','',''],['虚拟幻觉','',''],['虚拟机','',''],['虚拟环境','',''],['虚拟现实','',''],['虚拟现实置标语言','',''],['虚拟网络','',''],['虚拟连接','',''],['虚拟通道标志符','',''],['虚拟通道连接','',''],['虚损','',''],['虚掩','',''],['虚提','',''],['虚收','',''],['虚数','',''],['虚文','',''],['虚文浮礼','',''],['虚无','',''],['虚无主义','',''],['虚无假设','',''],['虚无缥渺','',''],['虚无缥缈','',''],['虚无飘渺','',''],['虚星','',''],['虚晃','',''],['虚有其表','',''],['虚构','',''],['虚构小说','',''],['虚框','',''],['虚汗','',''],['虚浮','',''],['虚火','',''],['虚牝','',''],['虚生浪死','',''],['虚电路','',''],['虚症','',''],['虚痨','',''],['虚盈','',''],['虚礼','',''],['虚空','',''],['虚空藏菩萨','',''],['虚粒子','',''],['虚线','',''],['虚缺号','',''],['虚耗','',''],['虚肿','',''],['虚胖','',''],['虚脱','',''],['虚腕','',''],['虚舟飘瓦','',''],['虚荣','',''],['虚荣心','',''],['虚虚实实','',''],['虚言','',''],['虚誉','',''],['虚警','',''],['虚论高议','',''],['虚设','',''],['虚诈','',''],['虚词','',''],['虚话','',''],['虚谈高论','',''],['虚谎','',''],['虚象','',''],['虚转','',''],['虚辞','',''],['虚造','',''],['虚飘飘','',''],['虚饰','',''],['虚骄','',''],['虞世南','',''],['虞侯','',''],['虞喜','',''],['虞应龙','',''],['虞美人','',''],['虞舜','',''],['虫儿','',''],['虫蚁','',''],['虫卵','',''],['虫吃牙','',''],['虫声','',''],['虫媒病毒','',''],['虫媒花','',''],['虫子','',''],['虫子牙','',''],['虫孔','',''],['虫害','',''],['虫情','',''],['虫沙猿鹤','',''],['虫洞','',''],['虫灾','',''],['虫牙','',''],['虫状','',''],['虫病','',''],['虫瘿','',''],['虫白蜡','',''],['虫眼','',''],['虫类','',''],['虫胶','',''],['虫臂鼠肝','',''],['虫草','',''],['虫药','',''],['虫蛀','',''],['虫蜡','',''],['虫豸','',''],['虫鱼','',''],['虫鸟叫声','',''],['虫鸣','',''],['虬须','',''],['虬龙','',''],['虮子','',''],['虰蛵','',''],['虱卵','',''],['虱多不痒','',''],['虱子','',''],['虱目鱼','',''],['虹口','',''],['虹吸','',''],['虹吸现象','',''],['虹吸管','',''],['虹彩','',''],['虹桥','',''],['虹桥机场','',''],['虹膜','',''],['虹鳟','',''],['虺虺','',''],['虺蜥','',''],['虼蚤','',''],['虼螂','',''],['虽之','',''],['虽休勿休','',''],['虽则','',''],['虽对','',''],['虽小','',''],['虽已','',''],['虽是','',''],['虽有','',''],['虽未','',''],['虽死犹生','',''],['虽死犹荣','',''],['虽然','',''],['虽经','',''],['虽能用','',''],['虽覆能复','',''],['虽说','',''],['虾仁','',''],['虾兵蟹将','',''],['虾夷','',''],['虾夷葱','',''],['虾子','',''],['虾干','',''],['虾慌蟹乱','',''],['虾油','',''],['虾片','',''],['虾球','',''],['虾皮','',''],['虾米','',''],['虾虎鱼','',''],['虾虎鱼科','',''],['虾酱','',''],['虾面','',''],['虾须','',''],['虾饺','',''],['蚀刻','',''],['蚀刻师','',''],['蚀刻法','',''],['蚀损','',''],['蚀本','',''],['蚀船虫','',''],['蚁丘','',''],['蚁冢','',''],['蚁斗蜗争','',''],['蚁穴','',''],['蚁窝','',''],['蚁聚蜂屯','',''],['蚁蚕','',''],['蚁酸','',''],['蚁酸盐','',''],['蚁醛','',''],['蚁附','',''],['蚂蚁','',''],['蚂蚁啃骨头','',''],['蚂蚱','',''],['蚂螂','',''],['蚂蟥','',''],['蚂蟥钉','',''],['蚊力负山','',''],['蚊子','',''],['蚊帐','',''],['蚊烟','',''],['蚊类','',''],['蚊虫','',''],['蚊虫叮咬','',''],['蚊蝇','',''],['蚊香','',''],['蚌壳','',''],['蚌山','',''],['蚌蛎','',''],['蚍蜉','',''],['蚍蜉戴盆','',''],['蚍蜉撼大树','',''],['蚍蜉撼树','',''],['蚕丛','',''],['蚕丝','',''],['蚕丝业','',''],['蚕农','',''],['蚕卵','',''],['蚕子','',''],['蚕宝宝','',''],['蚕属','',''],['蚕山','',''],['蚕桑','',''],['蚕沙','',''],['蚕眠','',''],['蚕眠字','',''],['蚕种','',''],['蚕箔','',''],['蚕纸','',''],['蚕茧','',''],['蚕茧纸','',''],['蚕菜','',''],['蚕蔟','',''],['蚕薄','',''],['蚕蚁','',''],['蚕蛹','',''],['蚕蛹油','',''],['蚕蛾','',''],['蚕豆','',''],['蚕豆症','',''],['蚕豆象','',''],['蚕食','',''],['蚕食鲸吞','',''],['蚖虫','',''],['蚜虫','',''],['蚝油','',''],['蚤类','',''],['蚩尤','',''],['蚩蚩群氓','',''],['蚯蚓','',''],['蚰蜒','',''],['蚰蜒草','',''],['蚰蜒路','',''],['蚱虫','',''],['蚱蜢','',''],['蚱蝉','',''],['蚵仔煎','',''],['蚶子','',''],['蚺蛇','',''],['蛀坏','',''],['蛀孔','',''],['蛀心虫','',''],['蛀洞','',''],['蛀牙','',''],['蛀船虫','',''],['蛀虫','',''],['蛀蚀','',''],['蛀食','',''],['蛀齿','',''],['蛆虫','',''],['蛇一般','',''],['蛇口','',''],['蛇咬伤','',''],['蛇夫座','',''],['蛇头','',''],['蛇尾','',''],['蛇岛','',''],['蛇岛蝮','',''],['蛇崇拜','',''],['蛇年','',''],['蛇形','',''],['蛇心佛口','',''],['蛇性','',''],['蛇样','',''],['蛇根草','',''],['蛇毒','',''],['蛇毒素','',''],['蛇皮','',''],['蛇皮果','',''],['蛇神牛鬼','',''],['蛇类','',''],['蛇纹岩','',''],['蛇纹石','',''],['蛇绿岩','',''],['蛇绿混杂','',''],['蛇绿混杂岩','',''],['蛇绿混杂岩带','',''],['蛇胆','',''],['蛇莓','',''],['蛇蒿','',''],['蛇蜕','',''],['蛇蜕皮','',''],['蛇蜥','',''],['蛇蝎','',''],['蛇行','',''],['蛇足','',''],['蛇颈','',''],['蛇麻','',''],['蛇麻草','',''],['蛇鼠横行','',''],['蛊惑','',''],['蛊惑人心','',''],['蛊祝','',''],['蛋制品','',''],['蛋包','',''],['蛋包饭','',''],['蛋卷','',''],['蛋品','',''],['蛋塔','',''],['蛋壳','',''],['蛋奶','',''],['蛋奶酥','',''],['蛋子','',''],['蛋形','',''],['蛋挞','',''],['蛋氨酸','',''],['蛋清','',''],['蛋白','',''],['蛋白尿','',''],['蛋白石','',''],['蛋白素','',''],['蛋白胨','',''],['蛋白质','',''],['蛋白酶','',''],['蛋白银','',''],['蛋类','',''],['蛋粉','',''],['蛋糕','',''],['蛋糕裙','',''],['蛋花','',''],['蛋花汤','',''],['蛋酒','',''],['蛋青','',''],['蛋饼','',''],['蛋鸡','',''],['蛋黄','',''],['蛋黄素','',''],['蛋黄酱','',''],['蛎壳','',''],['蛎鹬','',''],['蛎黄','',''],['蛏子','',''],['蛏干','',''],['蛏田','',''],['蛐蛐儿','',''],['蛐蟮','',''],['蛔虫','',''],['蛔虫病','',''],['蛙人','',''],['蛙泳','',''],['蛙突','',''],['蛙类','',''],['蛙鞋','',''],['蛙鸣','',''],['蛙鼓','',''],['蛛丝','',''],['蛛丝虫迹','',''],['蛛丝马迹','',''],['蛛丝鼠迹','',''],['蛛形','',''],['蛛网','',''],['蛛网似','',''],['蛛网尘封','',''],['蛛网状','',''],['蛛蛛','',''],['蛞蝓','',''],['蛞蝼','',''],['蛟龙','',''],['蛟龙得水','',''],['蛤类','',''],['蛤蚧','',''],['蛤蛎','',''],['蛤蜊','',''],['蛤蟆','',''],['蛤蟆夯','',''],['蛤蟆镜','',''],['蛤蟹','',''],['蛭石','',''],['蛮不讲理','',''],['蛮人','',''],['蛮像','',''],['蛮力','',''],['蛮劲','',''],['蛮化','',''],['蛮地','',''],['蛮夷','',''],['蛮好','',''],['蛮子','',''],['蛮干','',''],['蛮悍','',''],['蛮横','',''],['蛮横无理','',''],['蛮皮','',''],['蛮缠','',''],['蛮荒','',''],['蛮行','',''],['蛮邸','',''],['蛰伏','',''],['蛰居','',''],['蛰眠','',''],['蛰藏','',''],['蛰虫','',''],['蛱蝶','',''],['蛲虫','',''],['蛲虫病','',''],['蛴螬','',''],['蛹幼虫','',''],['蛹期','',''],['蛾子','',''],['蛾摩拉','',''],['蛾眉','',''],['蛾眉皓齿','',''],['蛾眉螓首','',''],['蛾类','',''],['蛾虫','',''],['蜀国','',''],['蜀山','',''],['蜀汉','',''],['蜀犬吠日','',''],['蜀相','',''],['蜀绣','',''],['蜀葵','',''],['蜀道','',''],['蜀锦','',''],['蜀魏','',''],['蜀黍','',''],['蜂乳','',''],['蜂后','',''],['蜂场','',''],['蜂密','',''],['蜂屯蚁聚','',''],['蜂巢','',''],['蜂巢胃','',''],['蜂房','',''],['蜂拥','',''],['蜂拥而上','',''],['蜂拥而来','',''],['蜂拥而至','',''],['蜂毒','',''],['蜂王','',''],['蜂王浆','',''],['蜂王精','',''],['蜂皇','',''],['蜂皇精','',''],['蜂目豺声','',''],['蜂窝','',''],['蜂窝煤','',''],['蜂窝状','',''],['蜂箱','',''],['蜂类','',''],['蜂糕','',''],['蜂群','',''],['蜂聚','',''],['蜂虿有毒','',''],['蜂蜜','',''],['蜂蜜梳子','',''],['蜂蜜酒','',''],['蜂蜡','',''],['蜂螨','',''],['蜂螫','',''],['蜂起','',''],['蜂鸟','',''],['蜂鸣','',''],['蜂鸣器','',''],['蜂鸣声','',''],['蜃景','',''],['蜃楼海市','',''],['蜈支洲岛','',''],['蜈蚣','',''],['蜈蚣草','',''],['蜉蝣','',''],['蜒蚰','',''],['蜕化','',''],['蜕化变质','',''],['蜕变','',''],['蜕壳','',''],['蜕皮','',''],['蜗利蝇名','',''],['蜗名蝇利','',''],['蜗居','',''],['蜗庐','',''],['蜗旋','',''],['蜗杆','',''],['蜗杆副','',''],['蜗牛','',''],['蜗窗','',''],['蜗蜒','',''],['蜗行','',''],['蜗角虚名','',''],['蜗角蝇头','',''],['蜗轮','',''],['蜘蛛','',''],['蜘蛛人','',''],['蜘蛛侠','',''],['蜘蛛抱蛋','',''],['蜘蛛星云','',''],['蜘蛛痣','',''],['蜘蛛类','',''],['蜘蛛网','',''],['蜘蛛般','',''],['蜚声','',''],['蜚声世界','',''],['蜚声海外','',''],['蜚短流长','',''],['蜚英腾茂','',''],['蜚蠊','',''],['蜚蠊科','',''],['蜚言','',''],['蜚语','',''],['蜜丸子','',''],['蜜囊','',''],['蜜月','',''],['蜜月假期','',''],['蜜枣','',''],['蜜柑','',''],['蜜桃','',''],['蜜樱桃','',''],['蜜汁','',''],['蜜洞','',''],['蜜源','',''],['蜜瓜','',''],['蜜糖','',''],['蜜罐','',''],['蜜腺','',''],['蜜般','',''],['蜜色','',''],['蜜蜂','',''],['蜜蜂房','',''],['蜜蜡','',''],['蜜语','',''],['蜜酒','',''],['蜜里调油','',''],['蜜露','',''],['蜜饯','',''],['蜡人','',''],['蜡像','',''],['蜡像馆','',''],['蜡制','',''],['蜡刻','',''],['蜡台','',''],['蜡嘴','',''],['蜡地','',''],['蜡坨','',''],['蜡坨儿','',''],['蜡坨子','',''],['蜡塑术','',''],['蜡扦','',''],['蜡板','',''],['蜡果','',''],['蜡枪','',''],['蜡染','',''],['蜡样','',''],['蜡油','',''],['蜡涂','',''],['蜡渣子','',''],['蜡烛','',''],['蜡烛不点不亮','',''],['蜡烛两头烧','',''],['蜡版','',''],['蜡画','',''],['蜡疗','',''],['蜡笔','',''],['蜡笔夹','',''],['蜡笔小新','',''],['蜡管','',''],['蜡纸','',''],['蜡色','',''],['蜡芯','',''],['蜡花','',''],['蜡虫','',''],['蜡质','',''],['蜡黄','','']];